//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QModelIndex>
#include <QMimeData>
#include <QStringList>
#include <QSize>
#include <QChildEvent>
#include <QTimerEvent>

#include "qabstractitemmodeldirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractItemModel_staticMetaObject =
        &QAbstractItemModel::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QAbstractItemModel_buddy_0_virtual(QObject* cpp_object, const QModelIndex* index, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractItemModel*>(cpp_object)->buddy(*index);
    }

    bool __Qt4Ada_QAbstractItemModel_canFetchMore_0_virtual(QObject* cpp_object, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->canFetchMore(*parent);
    }

    int __Qt4Ada_QAbstractItemModel_columnCount_0_virtual(QObject* cpp_object, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->columnCount(*parent);
    }

    bool __Qt4Ada_QAbstractItemModel_dropMimeData_0_virtual(QObject* cpp_object, QObject* data, Qt::DropAction action, int row, int column, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->dropMimeData(dynamic_cast<QMimeData*>(data), action, row, column, *parent);
    }

    void __Qt4Ada_QAbstractItemModel_fetchMore_0_virtual(QObject* cpp_object, const QModelIndex* parent)
    {
        dynamic_cast<QAbstractItemModel*>(cpp_object)->fetchMore(*parent);
    }

    bool __Qt4Ada_QAbstractItemModel_hasChildren_0_virtual(QObject* cpp_object, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->hasChildren(*parent);
    }

    bool __Qt4Ada_QAbstractItemModel_hasIndex_0_virtual(QObject* cpp_object, int row, int column, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->hasIndex(row, column, *parent);
    }

    void __Qt4Ada_QAbstractItemModel_index_0_virtual(QObject* cpp_object, int row, int column, const QModelIndex* parent, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractItemModel*>(cpp_object)->index(row, column, *parent);
    }

    bool __Qt4Ada_QAbstractItemModel_insertColumns_0_virtual(QObject* cpp_object, int column, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->insertColumns(column, count, *parent);
    }

    bool __Qt4Ada_QAbstractItemModel_insertRows_0_virtual(QObject* cpp_object, int row, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->insertRows(row, count, *parent);
    }

    QObject* __Qt4Ada_QAbstractItemModel_mimeData_0_virtual(QObject* cpp_object, const QModelIndexList* indexes)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemModel*>(cpp_object)->mimeData(*indexes));
    }

    void __Qt4Ada_QAbstractItemModel_mimeTypes_0_virtual(QObject* cpp_object, QStringList* returns)
    {
        *returns = dynamic_cast<QAbstractItemModel*>(cpp_object)->mimeTypes();
    }

    void __Qt4Ada_QAbstractItemModel_parent_1_virtual(QObject* cpp_object, const QModelIndex* child, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractItemModel*>(cpp_object)->parent(*child);
    }

    bool __Qt4Ada_QAbstractItemModel_removeColumns_0_virtual(QObject* cpp_object, int column, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->removeColumns(column, count, *parent);
    }

    bool __Qt4Ada_QAbstractItemModel_removeRows_0_virtual(QObject* cpp_object, int row, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->removeRows(row, count, *parent);
    }

    int __Qt4Ada_QAbstractItemModel_rowCount_0_virtual(QObject* cpp_object, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->rowCount(*parent);
    }

    void __Qt4Ada_QAbstractItemModel_span_0_virtual(QObject* cpp_object, const QModelIndex* index, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractItemModel*>(cpp_object)->span(*index);
    }

    void __Qt4Ada_QAbstractItemModel_revert_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModel*>(cpp_object)->revert();
    }

    bool __Qt4Ada_QAbstractItemModel_submit_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->submit();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QAbstractItemModel_buddy_0_wrapper(QObject* cpp_object, const QModelIndex* index, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::buddy(*index);
    }

    bool __Qt4Ada_QAbstractItemModel_canFetchMore_0_wrapper(QObject* cpp_object, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::canFetchMore(*parent);
    }

    bool __Qt4Ada_QAbstractItemModel_dropMimeData_0_wrapper(QObject* cpp_object, QObject* data, Qt::DropAction action, int row, int column, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::dropMimeData(dynamic_cast<QMimeData*>(data), action, row, column, *parent);
    }

    void __Qt4Ada_QAbstractItemModel_fetchMore_0_wrapper(QObject* cpp_object, const QModelIndex* parent)
    {
        dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::fetchMore(*parent);
    }

    bool __Qt4Ada_QAbstractItemModel_hasChildren_0_wrapper(QObject* cpp_object, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::hasChildren(*parent);
    }

    bool __Qt4Ada_QAbstractItemModel_hasIndex_0_wrapper(QObject* cpp_object, int row, int column, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::hasIndex(row, column, *parent);
    }

    bool __Qt4Ada_QAbstractItemModel_insertColumn_0_wrapper(QObject* cpp_object, int column, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::insertColumn(column, *parent);
    }

    bool __Qt4Ada_QAbstractItemModel_insertColumns_0_wrapper(QObject* cpp_object, int column, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::insertColumns(column, count, *parent);
    }

    bool __Qt4Ada_QAbstractItemModel_insertRow_0_wrapper(QObject* cpp_object, int row, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::insertRow(row, *parent);
    }

    bool __Qt4Ada_QAbstractItemModel_insertRows_0_wrapper(QObject* cpp_object, int row, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::insertRows(row, count, *parent);
    }

    QObject* __Qt4Ada_QAbstractItemModel_mimeData_0_wrapper(QObject* cpp_object, const QModelIndexList* indexes)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::mimeData(*indexes));
    }

    void __Qt4Ada_QAbstractItemModel_mimeTypes_0_wrapper(QObject* cpp_object, QStringList* returns)
    {
        *returns = dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::mimeTypes();
    }

    bool __Qt4Ada_QAbstractItemModel_removeColumn_0_wrapper(QObject* cpp_object, int column, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::removeColumn(column, *parent);
    }

    bool __Qt4Ada_QAbstractItemModel_removeColumns_0_wrapper(QObject* cpp_object, int column, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::removeColumns(column, count, *parent);
    }

    bool __Qt4Ada_QAbstractItemModel_removeRow_0_wrapper(QObject* cpp_object, int row, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::removeRow(row, *parent);
    }

    bool __Qt4Ada_QAbstractItemModel_removeRows_0_wrapper(QObject* cpp_object, int row, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::removeRows(row, count, *parent);
    }

    void __Qt4Ada_QAbstractItemModel_sibling_0_wrapper(QObject* cpp_object, int row, int column, const QModelIndex* idx, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::sibling(row, column, *idx);
    }

    void __Qt4Ada_QAbstractItemModel_span_0_wrapper(QObject* cpp_object, const QModelIndex* index, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::span(*index);
    }

    void __Qt4Ada_QAbstractItemModel_revert_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::revert();
    }

    bool __Qt4Ada_QAbstractItemModel_submit_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_object)->QAbstractItemModel::submit();
    }

    void __Qt4Ada_QAbstractItemModel_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::dataChanged(*topLeft, *bottomRight);
    }

    void __Qt4Ada_QAbstractItemModel_headerDataChanged_0_wrapper(QObject* cpp_object, Qt::Orientation orientation, int first, int last)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::headerDataChanged(orientation, first, last);
    }

    void __Qt4Ada_QAbstractItemModel_layoutAboutToBeChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::layoutAboutToBeChanged();
    }

    void __Qt4Ada_QAbstractItemModel_layoutChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::layoutChanged();
    }

    void __Qt4Ada_QAbstractItemModel_beginInsertColumns_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::beginInsertColumns(*parent, first, last);
    }

    void __Qt4Ada_QAbstractItemModel_beginInsertRows_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::beginInsertRows(*parent, first, last);
    }

    bool __Qt4Ada_QAbstractItemModel_beginMoveColumns_0_wrapper(QObject* cpp_object, const QModelIndex* sourceParent, int sourceFirst, int sourceLast, const QModelIndex* destinationParent, int destinationChild)
    {
        return dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::beginMoveColumns(*sourceParent, sourceFirst, sourceLast, *destinationParent, destinationChild);
    }

    bool __Qt4Ada_QAbstractItemModel_beginMoveRows_0_wrapper(QObject* cpp_object, const QModelIndex* sourceParent, int sourceFirst, int sourceLast, const QModelIndex* destinationParent, int destinationChild)
    {
        return dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::beginMoveRows(*sourceParent, sourceFirst, sourceLast, *destinationParent, destinationChild);
    }

    void __Qt4Ada_QAbstractItemModel_beginRemoveColumns_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::beginRemoveColumns(*parent, first, last);
    }

    void __Qt4Ada_QAbstractItemModel_beginRemoveRows_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::beginRemoveRows(*parent, first, last);
    }

    void __Qt4Ada_QAbstractItemModel_beginResetModel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::beginResetModel();
    }

    void __Qt4Ada_QAbstractItemModel_changePersistentIndex_0_wrapper(QObject* cpp_object, const QModelIndex* from, const QModelIndex* to)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::changePersistentIndex(*from, *to);
    }

    void __Qt4Ada_QAbstractItemModel_endInsertColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::endInsertColumns();
    }

    void __Qt4Ada_QAbstractItemModel_endInsertRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::endInsertRows();
    }

    void __Qt4Ada_QAbstractItemModel_endMoveColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::endMoveColumns();
    }

    void __Qt4Ada_QAbstractItemModel_endMoveRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::endMoveRows();
    }

    void __Qt4Ada_QAbstractItemModel_endRemoveColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::endRemoveColumns();
    }

    void __Qt4Ada_QAbstractItemModel_endRemoveRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::endRemoveRows();
    }

    void __Qt4Ada_QAbstractItemModel_endResetModel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::endResetModel();
    }

    void __Qt4Ada_QAbstractItemModel_reset_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QAbstractItemModel::reset();
    }

    void __Qt4Ada_QAbstractItemModel_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemModel_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QAbstractItemModel_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QAbstractItemModel_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemModelDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractItemModel_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_this)->QAbstractItemModel::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractItemModel_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractItemModel*>(cpp_this)->QAbstractItemModel::qt_metacall(_c, _id, _a);
    }

}

QModelIndex QAbstractItemModelDirector::buddy(const QModelIndex& index) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_buddy_0_dispatch(this->ada_object, &index);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QAbstractItemModelDirector::canFetchMore(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_canFetchMore_0_dispatch(this->ada_object, &parent);
}

int QAbstractItemModelDirector::columnCount(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_columnCount_0_dispatch(this->ada_object, &parent);
}

bool QAbstractItemModelDirector::dropMimeData(QMimeData* data, Qt::DropAction action, int row, int column, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_dropMimeData_0_dispatch(this->ada_object, data, action, row, column, &parent);
}

void QAbstractItemModelDirector::fetchMore(const QModelIndex& parent)
{
    __Qt4Ada_QAbstractItemModel_fetchMore_0_dispatch(this->ada_object, &parent);
}

bool QAbstractItemModelDirector::hasChildren(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_hasChildren_0_dispatch(this->ada_object, &parent);
}

bool QAbstractItemModelDirector::hasIndex(int row, int column, const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_hasIndex_0_dispatch(this->ada_object, row, column, &parent);
}

QModelIndex QAbstractItemModelDirector::index(int row, int column, const QModelIndex& parent) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_index_0_dispatch(this->ada_object, row, column, &parent);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QAbstractItemModelDirector::insertColumns(int column, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_insertColumns_0_dispatch(this->ada_object, column, count, &parent);
}

bool QAbstractItemModelDirector::insertRows(int row, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_insertRows_0_dispatch(this->ada_object, row, count, &parent);
}

QMimeData* QAbstractItemModelDirector::mimeData(const QModelIndexList& indexes) const
{
    return dynamic_cast<QMimeData*>(__Qt4Ada_QAbstractItemModel_mimeData_0_dispatch(this->ada_object, &indexes));
}

QStringList QAbstractItemModelDirector::mimeTypes() const
{
    QStringList *aux = __Qt4Ada_QAbstractItemModel_mimeTypes_0_dispatch(this->ada_object);
    QStringList returns = *aux;
    delete aux;
    return returns;
}

QModelIndex QAbstractItemModelDirector::parent(const QModelIndex& child) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_parent_1_dispatch(this->ada_object, &child);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QAbstractItemModelDirector::removeColumns(int column, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_removeColumns_0_dispatch(this->ada_object, column, count, &parent);
}

bool QAbstractItemModelDirector::removeRows(int row, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_removeRows_0_dispatch(this->ada_object, row, count, &parent);
}

int QAbstractItemModelDirector::rowCount(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_rowCount_0_dispatch(this->ada_object, &parent);
}

QSize QAbstractItemModelDirector::span(const QModelIndex& index) const
{
    QSize *aux = __Qt4Ada_QAbstractItemModel_span_0_dispatch(this->ada_object, &index);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractItemModelDirector::revert()
{
    __Qt4Ada_QAbstractItemModel_revert_0_dispatch(this->ada_object);
}

bool QAbstractItemModelDirector::submit()
{
    return __Qt4Ada_QAbstractItemModel_submit_0_dispatch(this->ada_object);
}

bool QAbstractItemModelDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QAbstractItemModelDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractItemModelDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemModelDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemModelDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractItemModelDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractItemModelDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractItemModelDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
QAbstractItemModelDirector::QAbstractItemModelDirector(void* o, QObject* parent) :
    QAbstractItemModel (parent),
    ada_object (o)
{
}

bool QAbstractItemModelDirector::setData (const QModelIndex & index, const QVariant & value, int role)
{
   return __Qt4Ada_QAbstractItemModel_setData_dispatch (this->ada_object, &index, &value, role);
}

bool QAbstractItemModelDirector::setHeaderData
        (int section, Qt::Orientation orientation, const QVariant & value, int role)
{
   return __Qt4Ada_QAbstractItemModel_setHeaderData_dispatch
             (this->ada_object, section, orientation, &value, role);
}

QVariant QAbstractItemModelDirector::data (const QModelIndex & parent, int role) const
{
   QVariant *tmp = __Qt4Ada_QAbstractItemModel_data_dispatch (this->ada_object, &parent, role);
   QVariant returns = *tmp;
   delete tmp;
   return returns;
}

Qt::ItemFlags QAbstractItemModelDirector::flags (const QModelIndex & index) const
{
   return (Qt::ItemFlags) __Qt4Ada_QAbstractItemModel_flags_dispatch (this->ada_object, &index);
}

QVariant QAbstractItemModelDirector::headerData (int section, Qt::Orientation orientation, int role) const
{
   QVariant *tmp = __Qt4Ada_QAbstractItemModel_headerData_dispatch (this->ada_object, section, orientation, role);
   QVariant returns = *tmp;
   delete tmp;
   return returns;
}

extern "C"
{

   QModelIndex* __Qt4Ada_QAbstractItemModel_createIndex_wrapper (QObject*cpp_this, int row, int col, void* ptr)
   {
      return (new QModelIndex (dynamic_cast<QAbstractItemModelDirector*>(cpp_this)->QAbstractItemModel::createIndex (row, col, ptr)));
   }

   bool __Qt4Ada_QAbstractItemModel_setData_wrapper (QObject*cpp_this,const QModelIndex*index, const QVariant*val, int role)
   {
      return dynamic_cast<QAbstractItemModel*>(cpp_this)->QAbstractItemModel::setData(*index, *val, role);
   }

   bool __Qt4Ada_QAbstractItemModel_setData_virtual (QObject*cpp_this,const QModelIndex*index, const QVariant*val, int role)
   {
      return dynamic_cast<QAbstractItemModel*>(cpp_this)->setData(*index, *val, role);
   }

   bool __Qt4Ada_QAbstractItemModel_setHeaderData_wrapper
           (QObject* cpp_this, int section, int orientation, const QVariant* value, int role)
   {
      return dynamic_cast<QAbstractItemModel*>
                (cpp_this)->QAbstractItemModel::setHeaderData(section,
                                                              static_cast<Qt::Orientation>(orientation),
                                                              *value,
                                                              role);
   }

   bool __Qt4Ada_QAbstractItemModel_setHeaderData_virtual
           (QObject* cpp_this, int section, int orientation, const QVariant* value, int role)
   {
      return dynamic_cast<QAbstractItemModel*>
                (cpp_this)->setHeaderData(section,
                                          static_cast<Qt::Orientation>(orientation),
                                          *value,
                                          role);
   }

   QVariant* __Qt4Ada_QAbstractItemModel_data_virtual
                (QObject*cpp_this, const QModelIndex*index, int role)
   {
      return (new QVariant (dynamic_cast<QAbstractItemModel*>(cpp_this)->data (*index, role)));
   }

   int __Qt4Ada_QAbstractItemModel_flags_virtual (QObject*cpp_this, const QModelIndex*index)
   {
      return dynamic_cast<QAbstractItemModel*>(cpp_this)->flags (*index);
   }

   int __Qt4Ada_QAbstractItemModel_flags_static (QObject*cpp_this, const QModelIndex*index)
   {
      return dynamic_cast<QAbstractItemModel*>(cpp_this)->QAbstractItemModel::flags (*index);
   }

   QVariant* __Qt4Ada_QAbstractItemModel_headerData_virtual
                (QObject*cpp_this,int section, unsigned orientation, int role)
   {
      return (new QVariant (dynamic_cast<QAbstractItemModel*>(cpp_this)->headerData
                                                                          (section,
                                                                           (Qt::Orientation) orientation,
                                                                           role)));
   }

   QVariant* __Qt4Ada_QAbstractItemModel_headerData_static
                (QObject*cpp_this,int section, unsigned orientation, int role)
   {
      return (new QVariant (dynamic_cast<QAbstractItemModel*>(cpp_this)->QAbstractItemModel::headerData
                                                                          (section,
                                                                           (Qt::Orientation) orientation,
                                                                           role)));
   }

    QObject * __Qt4Ada_new_QAbstractItemModelDirector (void* ada_object,QObject*parent)
    {
       return dynamic_cast<QObject*>(new QAbstractItemModelDirector(ada_object, parent));
    }

}
