//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009, 2010 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3716 $ $Date: 2010-02-06 22:13:32 +0300 (Sat, 06 Feb 2010) $
//--------------------------------------------------------------------------//
#include <QByteArray>

extern "C"
{
    extern QByteArray* __QtAda_inititialize_QByteArray(void*);
    extern QByteArray* __QtAda_adjust_QByteArray(void*, const QByteArray*);
    extern void __QtAda_finalize_QByteArray(QByteArray*);

    extern void __QtAda_QByteArray_append_QByteArrayCR(QByteArray*, const QByteArray*);
    extern char __QtAda_QByteArray_at_int_Q(QByteArray*, int);
    extern int __QtAda_QByteArray_capacity_Q(const QByteArray*);
    extern void __QtAda_QByteArray_chop_int(QByteArray*, int);
    extern void __QtAda_QByteArray_clear(QByteArray*);
    extern unsigned __QtAda_QByteArray_contains_QByteArrayCR_Q(const QByteArray*, const QByteArray*);
    extern int __QtAda_QByteArray_count_QByteArrayCR_Q(const QByteArray*, const QByteArray*);
    extern int __QtAda_QByteArray_count_Q(const QByteArray*);
    extern unsigned __QtAda_QByteArray_endsWith_QByteArrayCR_Q(const QByteArray*, const QByteArray*);
    extern int __QtAda_QByteArray_indexOf_QByteArrayCR_int_Q(const QByteArray*, const QByteArray*, int);
    extern void __QtAda_QByteArray_insert_int_QByteArrayCR(QByteArray*, int, const QByteArray*);
    extern unsigned __QtAda_QByteArray_isEmpty_Q(const QByteArray*);
    extern unsigned __QtAda_QByteArray_isNull_Q(const QByteArray*);
    extern int __QtAda_QByteArray_lastIndexOf_QByteArrayCR_int_Q(const QByteArray*, const QByteArray*, int);
    extern void __QtAda_QByteArray_left_int_Q(QByteArray*, const QByteArray*, int);
    extern int __QtAda_QByteArray_length_Q(const QByteArray*);
    extern void __QtAda_QByteArray_mid_int_int_Q(QByteArray*, const QByteArray*, int, int);
    extern void __QtAda_QByteArray_prepend_QByteArrayCR(QByteArray*, const QByteArray*);
    extern void __QtAda_QByteArray_remove_int_int(QByteArray*, int, int);
    extern void __QtAda_QByteArray_repeated_int_Q(QByteArray*, const QByteArray*, int);
    extern void __QtAda_QByteArray_replace_int_int_QByteArrayCR(QByteArray*, int, int, const QByteArray*);
    extern void __QtAda_QByteArray_replace_QByteArrayCR_QByteArrayCR(QByteArray*, const QByteArray*, const QByteArray*);
    extern void __QtAda_QByteArray_reserve_int(QByteArray*, int);
    extern void __QtAda_QByteArray_resize_int(QByteArray*, int);
    extern void __QtAda_QByteArray_right_int_Q(QByteArray*, const QByteArray*, int);
    extern void __QtAda_QByteArray_simplified_Q(QByteArray*, const QByteArray*);
    extern int __QtAda_QByteArray_size_Q(const QByteArray*);
    extern void __QtAda_QByteArray_squeeze(QByteArray*);
    extern unsigned __QtAda_QByteArray_startsWith_QByteArrayCR_Q(const QByteArray*, const QByteArray*);
    extern void __QtAda_QByteArray_toBase64_Q(QByteArray*, const QByteArray*);
    extern void __QtAda_QByteArray_toHex_Q(QByteArray*, const QByteArray*);
    extern void __QtAda_QByteArray_trimmed(QByteArray*);
    extern void __QtAda_QByteArray_truncate_int(QByteArray*, int);
    extern void __QtAda_QByteArray_fromBase64_QByteArrayCR_S(QByteArray*, const QByteArray*);
    extern void __QtAda_QByteArray_fromHex_QByteArrayCR_S(QByteArray*, const QByteArray*);
    extern unsigned __QtAda_QByteArray_eq_QByteArrayCR_Q(const QByteArray*, const QByteArray*);
    extern unsigned __QtAda_QByteArray_lt_QByteArrayCR_Q(const QByteArray*, const QByteArray*);
    extern unsigned __QtAda_QByteArray_gt_QByteArrayCR_Q(const QByteArray*, const QByteArray*);
    extern unsigned __QtAda_QByteArray_le_QByteArrayCR_Q(const QByteArray*, const QByteArray*);
    extern unsigned __QtAda_QByteArray_ge_QByteArrayCR_Q(const QByteArray*, const QByteArray*);

};

