//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QChar>
#include <QString>
#include "qcharwrapper.h"

extern "C"
{

    QChar* __QtAda_inititialize_QChar(void* storage)
    {
        return new (storage) QChar();
    }

    QChar* __QtAda_inititialize_QChar_ushort(void* storage, ushort rc)
    {
        return new (storage) QChar(rc);
    }

    QChar* __QtAda_inititialize_QChar_uint(void* storage, uint rc)
    {
        return new (storage) QChar(rc);
    }

    QChar* __QtAda_inititialize_QChar_SpecialCharacter(void* storage, unsigned sc)
    {
        return new (storage) QChar((QChar::SpecialCharacter)sc);
    }

    QChar* __QtAda_adjust_QChar(void* storage, const QChar* from)
    {
        return new (storage) QChar(*from);
    }

    void __QtAda_finalize_QChar(QChar *item)
    {
        item->~QChar();
    }

    unsigned __QtAda_QChar_category_Q(const QChar* self)
    {
        return (unsigned)self->category();
    }

    unsigned __QtAda_QChar_combiningClass_Q(const QChar* self)
    {
        return (unsigned)self->combiningClass();
    }

    void __QtAda_QChar_decomposition_Q(QString* returns, const QChar* self)
    {
        *returns = self->decomposition();
    }

    unsigned __QtAda_QChar_decompositionTag_Q(const QChar* self)
    {
        return (unsigned)self->decompositionTag();
    }

    unsigned __QtAda_QChar_direction_Q(const QChar* self)
    {
        return (unsigned)self->direction();
    }

    unsigned __QtAda_QChar_hasMirrored_Q(const QChar* self)
    {
        return (unsigned)self->hasMirrored();
    }

    unsigned __QtAda_QChar_isDigit_Q(const QChar* self)
    {
        return (unsigned)self->isDigit();
    }

    unsigned __QtAda_QChar_isHighSurrogate_Q(const QChar* self)
    {
        return (unsigned)self->isHighSurrogate();
    }

    unsigned __QtAda_QChar_isLetter_Q(const QChar* self)
    {
        return (unsigned)self->isLetter();
    }

    unsigned __QtAda_QChar_isLetterOrNumber_Q(const QChar* self)
    {
        return (unsigned)self->isLetterOrNumber();
    }

    unsigned __QtAda_QChar_isLowSurrogate_Q(const QChar* self)
    {
        return (unsigned)self->isLowSurrogate();
    }

    unsigned __QtAda_QChar_isLower_Q(const QChar* self)
    {
        return (unsigned)self->isLower();
    }

    unsigned __QtAda_QChar_isMark_Q(const QChar* self)
    {
        return (unsigned)self->isMark();
    }

    unsigned __QtAda_QChar_isNull_Q(const QChar* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QChar_isNumber_Q(const QChar* self)
    {
        return (unsigned)self->isNumber();
    }

    unsigned __QtAda_QChar_isPrint_Q(const QChar* self)
    {
        return (unsigned)self->isPrint();
    }

    unsigned __QtAda_QChar_isPunct_Q(const QChar* self)
    {
        return (unsigned)self->isPunct();
    }

    unsigned __QtAda_QChar_isSpace_Q(const QChar* self)
    {
        return (unsigned)self->isSpace();
    }

    unsigned __QtAda_QChar_isSymbol_Q(const QChar* self)
    {
        return (unsigned)self->isSymbol();
    }

    unsigned __QtAda_QChar_isTitleCase_Q(const QChar* self)
    {
        return (unsigned)self->isTitleCase();
    }

    unsigned __QtAda_QChar_isUpper_Q(const QChar* self)
    {
        return (unsigned)self->isUpper();
    }

    unsigned __QtAda_QChar_joining_Q(const QChar* self)
    {
        return (unsigned)self->joining();
    }

    void __QtAda_QChar_mirroredChar_Q(QChar* returns, const QChar* self)
    {
        *returns = self->mirroredChar();
    }

    void __QtAda_QChar_toCaseFolded_Q(QChar* returns, const QChar* self)
    {
        *returns = self->toCaseFolded();
    }

    void __QtAda_QChar_toLower_Q(QChar* returns, const QChar* self)
    {
        *returns = self->toLower();
    }

    void __QtAda_QChar_toTitleCase_Q(QChar* returns, const QChar* self)
    {
        *returns = self->toTitleCase();
    }

    void __QtAda_QChar_toUpper_Q(QChar* returns, const QChar* self)
    {
        *returns = self->toUpper();
    }

    ushort __QtAda_QChar_unicode_Q(const QChar* self)
    {
        return self->unicode();
    }

    unsigned __QtAda_QChar_unicodeVersion_Q(const QChar* self)
    {
        return (unsigned)self->unicodeVersion();
    }

    unsigned __QtAda_QChar_category_ushort_S(ushort ucs2)
    {
        return (unsigned)QChar::category(ucs2);
    }

    unsigned __QtAda_QChar_category_uint_S(uint ucs4)
    {
        return (unsigned)QChar::category(ucs4);
    }

    unsigned __QtAda_QChar_combiningClass_ushort_S(ushort ucs2)
    {
        return (unsigned)QChar::combiningClass(ucs2);
    }

    unsigned __QtAda_QChar_combiningClass_uint_S(uint ucs4)
    {
        return (unsigned)QChar::combiningClass(ucs4);
    }

    void __QtAda_QChar_decomposition_uint_S(QString* returns, uint ucs4)
    {
        *returns = QChar::decomposition(ucs4);
    }

    unsigned __QtAda_QChar_decompositionTag_uint_S(uint ucs4)
    {
        return (unsigned)QChar::decompositionTag(ucs4);
    }

    unsigned __QtAda_QChar_direction_ushort_S(ushort ucs2)
    {
        return (unsigned)QChar::direction(ucs2);
    }

    unsigned __QtAda_QChar_direction_uint_S(uint ucs4)
    {
        return (unsigned)QChar::direction(ucs4);
    }

    ushort __QtAda_QChar_highSurrogate_uint_S(uint ucs4)
    {
        return QChar::highSurrogate(ucs4);
    }

    unsigned __QtAda_QChar_joining_ushort_S(ushort ucs2)
    {
        return (unsigned)QChar::joining(ucs2);
    }

    unsigned __QtAda_QChar_joining_uint_S(uint ucs4)
    {
        return (unsigned)QChar::joining(ucs4);
    }

    ushort __QtAda_QChar_lowSurrogate_uint_S(uint ucs4)
    {
        return QChar::lowSurrogate(ucs4);
    }

    ushort __QtAda_QChar_mirroredChar_ushort_S(ushort ucs2)
    {
        return QChar::mirroredChar(ucs2);
    }

    uint __QtAda_QChar_mirroredChar_uint_S(uint ucs4)
    {
        return QChar::mirroredChar(ucs4);
    }

    uint __QtAda_QChar_surrogateToUcs4_ushort_ushort_S(ushort high, ushort low)
    {
        return QChar::surrogateToUcs4(high, low);
    }

    uint __QtAda_QChar_surrogateToUcs4_QChar_QChar_S(QChar* high, QChar* low)
    {
        return QChar::surrogateToUcs4(*high, *low);
    }

    ushort __QtAda_QChar_toCaseFolded_ushort_S(ushort ucs2)
    {
        return QChar::toCaseFolded(ucs2);
    }

    uint __QtAda_QChar_toCaseFolded_uint_S(uint ucs4)
    {
        return QChar::toCaseFolded(ucs4);
    }

    ushort __QtAda_QChar_toLower_ushort_S(ushort ucs2)
    {
        return QChar::toLower(ucs2);
    }

    uint __QtAda_QChar_toLower_uint_S(uint ucs4)
    {
        return QChar::toLower(ucs4);
    }

    ushort __QtAda_QChar_toTitleCase_ushort_S(ushort ucs2)
    {
        return QChar::toTitleCase(ucs2);
    }

    uint __QtAda_QChar_toTitleCase_uint_S(uint ucs4)
    {
        return QChar::toTitleCase(ucs4);
    }

    ushort __QtAda_QChar_toUpper_ushort_S(ushort ucs2)
    {
        return QChar::toUpper(ucs2);
    }

    uint __QtAda_QChar_toUpper_uint_S(uint ucs4)
    {
        return QChar::toUpper(ucs4);
    }

    unsigned __QtAda_QChar_unicodeVersion_ushort_S(ushort ucs2)
    {
        return (unsigned)QChar::unicodeVersion(ucs2);
    }

    unsigned __QtAda_QChar_unicodeVersion_uint_S(uint ucs4)
    {
        return (unsigned)QChar::unicodeVersion(ucs4);
    }

    unsigned __QtAda_eq_QChar_QChar(QChar* c1, QChar* c2)
    {
        return (unsigned)operator==(*c1, *c2);
    }

    unsigned __QtAda_le_QChar_QChar(QChar* c1, QChar* c2)
    {
        return (unsigned)operator<=(*c1, *c2);
    }

    unsigned __QtAda_ge_QChar_QChar(QChar* c1, QChar* c2)
    {
        return (unsigned)operator>=(*c1, *c2);
    }

    unsigned __QtAda_lt_QChar_QChar(QChar* c1, QChar* c2)
    {
        return (unsigned)operator<(*c1, *c2);
    }

    unsigned __QtAda_gt_QChar_QChar(QChar* c1, QChar* c2)
    {
        return (unsigned)operator>(*c1, *c2);
    }

};

