//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QChar>

extern "C"
{
    extern QChar* __QtAda_inititialize_QChar(void*);
    extern QChar* __QtAda_inititialize_QChar_ushort(void*, ushort);
    extern QChar* __QtAda_inititialize_QChar_uint(void*, uint);
    extern QChar* __QtAda_inititialize_QChar_SpecialCharacter(void*, unsigned);
    extern QChar* __QtAda_adjust_QChar(void*, const QChar*);
    extern void __QtAda_finalize_QChar(QChar*);

    extern unsigned __QtAda_QChar_category_Q(const QChar*);
    extern unsigned __QtAda_QChar_combiningClass_Q(const QChar*);
    extern void __QtAda_QChar_decomposition_Q(QString*, const QChar*);
    extern unsigned __QtAda_QChar_decompositionTag_Q(const QChar*);
    extern unsigned __QtAda_QChar_direction_Q(const QChar*);
    extern unsigned __QtAda_QChar_hasMirrored_Q(const QChar*);
    extern unsigned __QtAda_QChar_isDigit_Q(const QChar*);
    extern unsigned __QtAda_QChar_isHighSurrogate_Q(const QChar*);
    extern unsigned __QtAda_QChar_isLetter_Q(const QChar*);
    extern unsigned __QtAda_QChar_isLetterOrNumber_Q(const QChar*);
    extern unsigned __QtAda_QChar_isLowSurrogate_Q(const QChar*);
    extern unsigned __QtAda_QChar_isLower_Q(const QChar*);
    extern unsigned __QtAda_QChar_isMark_Q(const QChar*);
    extern unsigned __QtAda_QChar_isNull_Q(const QChar*);
    extern unsigned __QtAda_QChar_isNumber_Q(const QChar*);
    extern unsigned __QtAda_QChar_isPrint_Q(const QChar*);
    extern unsigned __QtAda_QChar_isPunct_Q(const QChar*);
    extern unsigned __QtAda_QChar_isSpace_Q(const QChar*);
    extern unsigned __QtAda_QChar_isSymbol_Q(const QChar*);
    extern unsigned __QtAda_QChar_isTitleCase_Q(const QChar*);
    extern unsigned __QtAda_QChar_isUpper_Q(const QChar*);
    extern unsigned __QtAda_QChar_joining_Q(const QChar*);
    extern void __QtAda_QChar_mirroredChar_Q(QChar*, const QChar*);
    extern void __QtAda_QChar_toCaseFolded_Q(QChar*, const QChar*);
    extern void __QtAda_QChar_toLower_Q(QChar*, const QChar*);
    extern void __QtAda_QChar_toTitleCase_Q(QChar*, const QChar*);
    extern void __QtAda_QChar_toUpper_Q(QChar*, const QChar*);
    extern ushort __QtAda_QChar_unicode_Q(const QChar*);
    extern unsigned __QtAda_QChar_unicodeVersion_Q(const QChar*);
    extern unsigned __QtAda_QChar_category_ushort_S(ushort);
    extern unsigned __QtAda_QChar_category_uint_S(uint);
    extern unsigned __QtAda_QChar_combiningClass_ushort_S(ushort);
    extern unsigned __QtAda_QChar_combiningClass_uint_S(uint);
    extern void __QtAda_QChar_decomposition_uint_S(QString*, uint);
    extern unsigned __QtAda_QChar_decompositionTag_uint_S(uint);
    extern unsigned __QtAda_QChar_direction_ushort_S(ushort);
    extern unsigned __QtAda_QChar_direction_uint_S(uint);
    extern ushort __QtAda_QChar_highSurrogate_uint_S(uint);
    extern unsigned __QtAda_QChar_joining_ushort_S(ushort);
    extern unsigned __QtAda_QChar_joining_uint_S(uint);
    extern ushort __QtAda_QChar_lowSurrogate_uint_S(uint);
    extern ushort __QtAda_QChar_mirroredChar_ushort_S(ushort);
    extern uint __QtAda_QChar_mirroredChar_uint_S(uint);
    extern uint __QtAda_QChar_surrogateToUcs4_ushort_ushort_S(ushort, ushort);
    extern uint __QtAda_QChar_surrogateToUcs4_QChar_QChar_S(QChar*, QChar*);
    extern ushort __QtAda_QChar_toCaseFolded_ushort_S(ushort);
    extern uint __QtAda_QChar_toCaseFolded_uint_S(uint);
    extern ushort __QtAda_QChar_toLower_ushort_S(ushort);
    extern uint __QtAda_QChar_toLower_uint_S(uint);
    extern ushort __QtAda_QChar_toTitleCase_ushort_S(ushort);
    extern uint __QtAda_QChar_toTitleCase_uint_S(uint);
    extern ushort __QtAda_QChar_toUpper_ushort_S(ushort);
    extern uint __QtAda_QChar_toUpper_uint_S(uint);
    extern unsigned __QtAda_QChar_unicodeVersion_ushort_S(ushort);
    extern unsigned __QtAda_QChar_unicodeVersion_uint_S(uint);
    extern unsigned __QtAda_eq_QChar_QChar(QChar*, QChar*);
    extern unsigned __QtAda_le_QChar_QChar(QChar*, QChar*);
    extern unsigned __QtAda_ge_QChar_QChar(QChar*, QChar*);
    extern unsigned __QtAda_lt_QChar_QChar(QChar*, QChar*);
    extern unsigned __QtAda_gt_QChar_QChar(QChar*, QChar*);

};

