//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QChildEvent>
#include <QTimerEvent>

#include "qcoreapplicationdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QCoreApplication_staticMetaObject =
        &QCoreApplication::staticMetaObject;
}

extern "C"
{

    bool __Qt4Ada_QCoreApplication_notify_0_virtual(QObject* cpp_object, QObject* receiver, QEvent* event)
    {
        return dynamic_cast<QCoreApplication*>(cpp_object)->notify(receiver, event);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QCoreApplication_notify_0_wrapper(QObject* cpp_object, QObject* receiver, QEvent* event)
    {
        return dynamic_cast<QCoreApplication*>(cpp_object)->QCoreApplication::notify(receiver, event);
    }

    bool __Qt4Ada_QCoreApplication_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QCoreApplicationDirector*>(cpp_object)->QCoreApplication::event(e);
    }

    void __Qt4Ada_QCoreApplication_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QCoreApplicationDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QCoreApplication_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QCoreApplicationDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QCoreApplication_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QCoreApplicationDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QCoreApplication_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QCoreApplicationDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QCoreApplication_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QCoreApplication*>(cpp_this)->QCoreApplication::qt_metacast(name);
    }

    int __Qt4Ada_QCoreApplication_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QCoreApplication*>(cpp_this)->QCoreApplication::qt_metacall(_c, _id, _a);
    }

}

bool QCoreApplicationDirector::notify(QObject* receiver, QEvent* event)
{
    return __Qt4Ada_QCoreApplication_notify_0_dispatch(this->ada_object, receiver, event);
}

bool QCoreApplicationDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QCoreApplicationDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QCoreApplicationDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QCoreApplicationDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QCoreApplicationDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QCoreApplicationDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QCoreApplicationDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QCoreApplicationDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QStringList>

bool QCoreApplicationDirector::compressEvent(QEvent*_p1,QObject*_p2,QPostEventList*_p3)
{
    return __Qt4Ada_QCoreApplication_compressEvent_dispatch(this->ada_object,_p1,_p2,_p3);
}

void QCoreApplicationDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QCoreApplicationDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    bool __Qt4Ada_QCoreApplication_compressEvent_wrapper(QObject*cpp_this,QEvent*_p1,QObject*_p2,QPostEventList*_p3)
    {
        return (dynamic_cast<QCoreApplicationDirector*>(cpp_this))->QCoreApplication::compressEvent(_p1,_p2,_p3);
    }

    int __Qt4Ada_QCoreApplication_exec_wrapper()
    {
        return QCoreApplication::exec();
    }

    void __QtAda_QCoreApplication_arguments_S(QStringList* returns)
    {
        *returns = QCoreApplication::arguments();
    }

    void __Qt4Ada_QCoreApplication_applicationDirPath_wrapper(QString* result)
    {
        *result = QCoreApplication::applicationDirPath();
    }

    void __QtAda_delete_QCoreApplication()
    {
        delete QCoreApplication::instance();
    }

    QObject* __QtAda_QCoreApplication_instance_wrapper()
    {
	return static_cast<QObject*>(QCoreApplication::instance());
    }

    void __QtAda_QCoreApplication_setApplicationName_QStringCR(const QString* application)
    {
        QCoreApplication::setApplicationName(*application);
    }

    void __QtAda_QCoreApplication_setApplicationVersion_QStringCR(const QString* version)
    {
        QCoreApplication::setApplicationVersion(*version);
    }

    void __QtAda_QCoreApplication_setOrganizationDomain_QStringCR(const QString* orgDomain)
    {
        QCoreApplication::setOrganizationDomain(*orgDomain);
    }

    void __QtAda_QCoreApplication_setOrganizationName_QStringCR(const QString* orgName)
    {
        QCoreApplication::setOrganizationName(*orgName);
    }

}
