//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QCOREAPPLICATIONDIRECTOR_H__
#define __QCOREAPPLICATIONDIRECTOR_H__

#include <QCoreApplication>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QCoreApplication_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern bool __Qt4Ada_QCoreApplication_notify_0_dispatch(void*, QObject*, QEvent*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern bool __Qt4Ada_QCoreApplication_notify_0_virtual(QObject*, QObject*, QEvent*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QCoreApplication_notify_0_wrapper(QObject*, QObject*, QEvent*);
    extern bool __Qt4Ada_QCoreApplication_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCoreApplication_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCoreApplication_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCoreApplication_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QCoreApplication_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QCoreApplication_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QCoreApplication_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    //  Declarations of exported functions

    extern bool __Qt4Ada_QCoreApplication_compressEvent_dispatch(void*,QEvent*,QObject*,QPostEventList*);

    //  Declarations of wrapper functions for static call

    extern bool __Qt4Ada_QCoreApplication_compressEvent_wrapper(QObject*,QEvent*,QObject*,QPostEventList*);
    extern QObject* __QtAda_QCoreApplication_instance_wrapper();

    extern void __QtAda_QCoreApplication_arguments_S(QStringList*);
    extern int __Qt4Ada_QCoreApplication_exec_wrapper();
    extern void __Qt4Ada_QCoreApplication_applicationDirPath_wrapper(QString*);
    extern void __QtAda_delete_QCoreApplication();
    extern void __QtAda_QCoreApplication_setApplicationName_QStringCR(const QString*);
    extern void __QtAda_QCoreApplication_setApplicationVersion_QStringCR(const QString*);
    extern void __QtAda_QCoreApplication_setOrganizationDomain_QStringCR(const QString*);
    extern void __QtAda_QCoreApplication_setOrganizationName_QStringCR(const QString*);

}

class QCoreApplicationDirector : public QCoreApplication
{
protected:
    void* ada_object;
    QCoreApplicationDirector();

    virtual bool compressEvent(QEvent*,QObject*,QPostEventList*);
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

    friend bool __Qt4Ada_QCoreApplication_compressEvent_wrapper(QObject*,QEvent*,QObject*,QPostEventList*);

    virtual bool notify(QObject*, QEvent*);
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend bool __Qt4Ada_QCoreApplication_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCoreApplication_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCoreApplication_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCoreApplication_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QCoreApplication_sender_0_wrapper(QObject*);
};

#endif // __QCOREAPPLICATIONDIRECTOR_H__
