//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007  Vadim Godunko <vgodunko@gmail.com>                     //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QDateTime>

extern "C"
{
    extern QDateTime* __QtAda_inititialize_QDateTime(void*);
    extern QDateTime* __QtAda_inititialize_QDateTime_QDateCR(void*, const QDate*);
    extern QDateTime* __QtAda_inititialize_QDateTime_QDateCR_QTimeCR_TimeSpec(void*, const QDate*, const QTime*, unsigned);
    extern QDateTime* __QtAda_adjust_QDateTime(void*, const QDateTime*);
    extern void __QtAda_finalize_QDateTime(QDateTime*);

    extern void __QtAda_QDateTime_addDays_int_Q(QDateTime*, const QDateTime*, int);
    extern void __QtAda_QDateTime_addMSecs_qint64_Q(QDateTime*, const QDateTime*, qint64);
    extern void __QtAda_QDateTime_addMonths_int_Q(QDateTime*, const QDateTime*, int);
    extern void __QtAda_QDateTime_addSecs_int_Q(QDateTime*, const QDateTime*, int);
    extern void __QtAda_QDateTime_addYears_int_Q(QDateTime*, const QDateTime*, int);
    extern void __QtAda_QDateTime_date_Q(QDate*, const QDateTime*);
    extern int __QtAda_QDateTime_daysTo_QDateTimeCR_Q(const QDateTime*, const QDateTime*);
    extern unsigned __QtAda_QDateTime_isNull_Q(const QDateTime*);
    extern unsigned __QtAda_QDateTime_isValid_Q(const QDateTime*);
    extern int __QtAda_QDateTime_secsTo_QDateTimeCR_Q(const QDateTime*, const QDateTime*);
    extern void __QtAda_QDateTime_setDate_QDateCR(QDateTime*, const QDate*);
    extern void __QtAda_QDateTime_setTime_QTimeCR(QDateTime*, const QTime*);
    extern void __QtAda_QDateTime_setTimeSpec_TimeSpec(QDateTime*, unsigned);
    extern void __QtAda_QDateTime_time_Q(QTime*, const QDateTime*);
    extern unsigned __QtAda_QDateTime_timeSpec_Q(const QDateTime*);
    extern void __QtAda_QDateTime_toLocalTime_Q(QDateTime*, const QDateTime*);
    extern void __QtAda_QDateTime_toString_QStringCR_Q(QString*, const QDateTime*, const QString*);
    extern void __QtAda_QDateTime_toString_DateFormat_Q(QString*, const QDateTime*, unsigned);
    extern void __QtAda_QDateTime_toTimeSpec_TimeSpec_Q(QDateTime*, const QDateTime*, unsigned);
    extern void __QtAda_QDateTime_toUTC_Q(QDateTime*, const QDateTime*);
    extern void __QtAda_QDateTime_currentDateTime_S(QDateTime*);
    extern void __QtAda_QDateTime_fromString_QStringCR_DateFormat_S(QDateTime*, const QString*, unsigned);
    extern void __QtAda_QDateTime_fromString_QStringCR_QStringCR_S(QDateTime*, const QString*, const QString*);
    extern unsigned __QtAda_QDateTime_eq_QDateTimeCR_Q(const QDateTime*, const QDateTime*);
    extern unsigned __QtAda_QDateTime_lt_QDateTimeCR_Q(const QDateTime*, const QDateTime*);
    extern unsigned __QtAda_QDateTime_le_QDateTimeCR_Q(const QDateTime*, const QDateTime*);
    extern unsigned __QtAda_QDateTime_gt_QDateTimeCR_Q(const QDateTime*, const QDateTime*);
    extern unsigned __QtAda_QDateTime_ge_QDateTimeCR_Q(const QDateTime*, const QDateTime*);

};

