//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include <QStringList>
#include "qdirwrapper.h"

extern "C"
{

    QDir* __QtAda_inititialize_QDir(void* storage)
    {
        return new (storage) QDir();
    }

    QDir* __QtAda_inititialize_QDir_QStringCR(void* storage, const QString* path)
    {
        return new (storage) QDir(*path);
    }

    QDir* __QtAda_adjust_QDir(void* storage, const QDir* from)
    {
        return new (storage) QDir(*from);
    }

    void __QtAda_finalize_QDir(QDir *item)
    {
        item->~QDir();
    }

    void __QtAda_QDir_absoluteFilePath_QStringCR_Q(QString* returns, const QDir* self, const QString* fileName)
    {
        *returns = self->absoluteFilePath(*fileName);
    }

    void __QtAda_QDir_absolutePath_Q(QString* returns, const QDir* self)
    {
        *returns = self->absolutePath();
    }

    void __QtAda_QDir_canonicalPath_Q(QString* returns, const QDir* self)
    {
        *returns = self->canonicalPath();
    }

    unsigned __QtAda_QDir_cd_QStringCR(QDir* self, const QString* dirName)
    {
        return (unsigned)self->cd(*dirName);
    }

    void __QtAda_QDir_cdUp(QDir* self)
    {
        self->cdUp();
    }

    uint __QtAda_QDir_count_Q(const QDir* self)
    {
        return self->count();
    }

    void __QtAda_QDir_dirName_Q(QString* returns, const QDir* self)
    {
        *returns = self->dirName();
    }

    unsigned __QtAda_QDir_exists_QStringCR_Q(const QDir* self, const QString* name)
    {
        return (unsigned)self->exists(*name);
    }

    unsigned __QtAda_QDir_exists_Q(const QDir* self)
    {
        return (unsigned)self->exists();
    }

    void __QtAda_QDir_filePath_QStringCR_Q(QString* returns, const QDir* self, const QString* fileName)
    {
        *returns = self->filePath(*fileName);
    }

    unsigned __QtAda_QDir_isAbsolute_Q(const QDir* self)
    {
        return (unsigned)self->isAbsolute();
    }

    unsigned __QtAda_QDir_isReadable_Q(const QDir* self)
    {
        return (unsigned)self->isReadable();
    }

    unsigned __QtAda_QDir_isRelative_Q(const QDir* self)
    {
        return (unsigned)self->isRelative();
    }

    unsigned __QtAda_QDir_isRoot_Q(const QDir* self)
    {
        return (unsigned)self->isRoot();
    }

    void __QtAda_QDir_makeAbsolute(QDir* self)
    {
        self->makeAbsolute();
    }

    unsigned __QtAda_QDir_mkdir_QStringCR(QDir* self, const QString* dirName)
    {
        return (unsigned)self->mkdir(*dirName);
    }

    unsigned __QtAda_QDir_mkpath_QStringCR(QDir* self, const QString* dirPath)
    {
        return (unsigned)self->mkpath(*dirPath);
    }

    void __QtAda_QDir_nameFilters_Q(QStringList* returns, const QDir* self)
    {
        *returns = self->nameFilters();
    }

    void __QtAda_QDir_path_Q(QString* returns, const QDir* self)
    {
        *returns = self->path();
    }

    void __QtAda_QDir_refresh_Q(const QDir* self)
    {
        self->refresh();
    }

    void __QtAda_QDir_relativeFilePath_QStringCR_Q(QString* returns, const QDir* self, const QString* fileName)
    {
        *returns = self->relativeFilePath(*fileName);
    }

    unsigned __QtAda_QDir_remove_QStringCR(QDir* self, const QString* fileName)
    {
        return (unsigned)self->remove(*fileName);
    }

    unsigned __QtAda_QDir_rename_QStringCR_QStringCR(QDir* self, const QString* oldName, const QString* newName)
    {
        return (unsigned)self->rename(*oldName, *newName);
    }

    unsigned __QtAda_QDir_rmdir_QStringCR(QDir* self, const QString* dirName)
    {
        return (unsigned)self->rmdir(*dirName);
    }

    unsigned __QtAda_QDir_rmpath_QStringCR(QDir* self, const QString* dirPath)
    {
        return (unsigned)self->rmpath(*dirPath);
    }

    void __QtAda_QDir_setFilter_Filter(QDir* self, unsigned filters)
    {
        self->setFilter((QDir::Filter)filters);
    }

    void __QtAda_QDir_setNameFilters_QStringListCR(QDir* self, const QStringList* nameFilters)
    {
        self->setNameFilters(*nameFilters);
    }

    void __QtAda_QDir_setPath_QStringCR(QDir* self, const QString* path)
    {
        self->setPath(*path);
    }

    void __QtAda_QDir_addSearchPath_QStringCR_QStringCR_S(const QString* prefix, const QString* path)
    {
        QDir::addSearchPath(*prefix, *path);
    }

    void __QtAda_QDir_cleanPath_QStringCR_S(QString* returns, const QString* path)
    {
        *returns = QDir::cleanPath(*path);
    }

    void __QtAda_QDir_current_S(QDir* returns)
    {
        *returns = QDir::current();
    }

    void __QtAda_QDir_currentPath_S(QString* returns)
    {
        *returns = QDir::currentPath();
    }

    void __QtAda_QDir_fromNativeSeparators_QStringCR_S(QString* returns, const QString* pathName)
    {
        *returns = QDir::fromNativeSeparators(*pathName);
    }

    void __QtAda_QDir_home_S(QDir* returns)
    {
        *returns = QDir::home();
    }

    void __QtAda_QDir_homePath_S(QString* returns)
    {
        *returns = QDir::homePath();
    }

    unsigned __QtAda_QDir_isAbsolutePath_QStringCR_S(const QString* path)
    {
        return (unsigned)QDir::isAbsolutePath(*path);
    }

    unsigned __QtAda_QDir_isRelativePath_QStringCR_S(const QString* path)
    {
        return (unsigned)QDir::isRelativePath(*path);
    }

    unsigned __QtAda_QDir_match_QStringCR_QStringCR_S(const QString* filter, const QString* fileName)
    {
        return (unsigned)QDir::match(*filter, *fileName);
    }

    unsigned __QtAda_QDir_match_QStringListCR_QStringCR_S(const QStringList* filters, const QString* fileName)
    {
        return (unsigned)QDir::match(*filters, *fileName);
    }

    void __QtAda_QDir_root_S(QDir* returns)
    {
        *returns = QDir::root();
    }

    void __QtAda_QDir_rootPath_S(QString* returns)
    {
        *returns = QDir::rootPath();
    }

    void __QtAda_QDir_searchPaths_QStringCR_S(QStringList* returns, const QString* prefix)
    {
        *returns = QDir::searchPaths(*prefix);
    }

    void __QtAda_QDir_separator_S(QChar* returns)
    {
        *returns = QDir::separator();
    }

    unsigned __QtAda_QDir_setCurrent_QStringCR_S(const QString* path)
    {
        return (unsigned)QDir::setCurrent(*path);
    }

    void __QtAda_QDir_setSearchPaths_QStringCR_QStringListCR_S(const QString* prefix, const QStringList* searchPaths)
    {
        QDir::setSearchPaths(*prefix, *searchPaths);
    }

    void __QtAda_QDir_temp_S(QDir* returns)
    {
        *returns = QDir::temp();
    }

    void __QtAda_QDir_tempPath_S(QString* returns)
    {
        *returns = QDir::tempPath();
    }

    void __QtAda_QDir_toNativeSeparators_QStringCR_S(QString* returns, const QString* pathName)
    {
        *returns = QDir::toNativeSeparators(*pathName);
    }

    unsigned __QtAda_QDir_eq_QDirCR_Q(const QDir* self, const QDir* dir)
    {
        return (unsigned)self->operator==(*dir);
    }

};

