//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QDir>

extern "C"
{
    extern QDir* __QtAda_inititialize_QDir(void*);
    extern QDir* __QtAda_inititialize_QDir_QStringCR(void*, const QString*);
    extern QDir* __QtAda_adjust_QDir(void*, const QDir*);
    extern void __QtAda_finalize_QDir(QDir*);

    extern void __QtAda_QDir_absoluteFilePath_QStringCR_Q(QString*, const QDir*, const QString*);
    extern void __QtAda_QDir_absolutePath_Q(QString*, const QDir*);
    extern void __QtAda_QDir_canonicalPath_Q(QString*, const QDir*);
    extern unsigned __QtAda_QDir_cd_QStringCR(QDir*, const QString*);
    extern void __QtAda_QDir_cdUp(QDir*);
    extern uint __QtAda_QDir_count_Q(const QDir*);
    extern void __QtAda_QDir_dirName_Q(QString*, const QDir*);
    extern unsigned __QtAda_QDir_exists_QStringCR_Q(const QDir*, const QString*);
    extern unsigned __QtAda_QDir_exists_Q(const QDir*);
    extern void __QtAda_QDir_filePath_QStringCR_Q(QString*, const QDir*, const QString*);
    extern unsigned __QtAda_QDir_isAbsolute_Q(const QDir*);
    extern unsigned __QtAda_QDir_isReadable_Q(const QDir*);
    extern unsigned __QtAda_QDir_isRelative_Q(const QDir*);
    extern unsigned __QtAda_QDir_isRoot_Q(const QDir*);
    extern void __QtAda_QDir_makeAbsolute(QDir*);
    extern unsigned __QtAda_QDir_mkdir_QStringCR(QDir*, const QString*);
    extern unsigned __QtAda_QDir_mkpath_QStringCR(QDir*, const QString*);
    extern void __QtAda_QDir_nameFilters_Q(QStringList*, const QDir*);
    extern void __QtAda_QDir_path_Q(QString*, const QDir*);
    extern void __QtAda_QDir_refresh_Q(const QDir*);
    extern void __QtAda_QDir_relativeFilePath_QStringCR_Q(QString*, const QDir*, const QString*);
    extern unsigned __QtAda_QDir_remove_QStringCR(QDir*, const QString*);
    extern unsigned __QtAda_QDir_rename_QStringCR_QStringCR(QDir*, const QString*, const QString*);
    extern unsigned __QtAda_QDir_rmdir_QStringCR(QDir*, const QString*);
    extern unsigned __QtAda_QDir_rmpath_QStringCR(QDir*, const QString*);
    extern void __QtAda_QDir_setFilter_Filter(QDir*, unsigned);
    extern void __QtAda_QDir_setNameFilters_QStringListCR(QDir*, const QStringList*);
    extern void __QtAda_QDir_setPath_QStringCR(QDir*, const QString*);
    extern void __QtAda_QDir_addSearchPath_QStringCR_QStringCR_S(const QString*, const QString*);
    extern void __QtAda_QDir_cleanPath_QStringCR_S(QString*, const QString*);
    extern void __QtAda_QDir_current_S(QDir*);
    extern void __QtAda_QDir_currentPath_S(QString*);
    extern void __QtAda_QDir_fromNativeSeparators_QStringCR_S(QString*, const QString*);
    extern void __QtAda_QDir_home_S(QDir*);
    extern void __QtAda_QDir_homePath_S(QString*);
    extern unsigned __QtAda_QDir_isAbsolutePath_QStringCR_S(const QString*);
    extern unsigned __QtAda_QDir_isRelativePath_QStringCR_S(const QString*);
    extern unsigned __QtAda_QDir_match_QStringCR_QStringCR_S(const QString*, const QString*);
    extern unsigned __QtAda_QDir_match_QStringListCR_QStringCR_S(const QStringList*, const QString*);
    extern void __QtAda_QDir_root_S(QDir*);
    extern void __QtAda_QDir_rootPath_S(QString*);
    extern void __QtAda_QDir_searchPaths_QStringCR_S(QStringList*, const QString*);
    extern void __QtAda_QDir_separator_S(QChar*);
    extern unsigned __QtAda_QDir_setCurrent_QStringCR_S(const QString*);
    extern void __QtAda_QDir_setSearchPaths_QStringCR_QStringListCR_S(const QString*, const QStringList*);
    extern void __QtAda_QDir_temp_S(QDir*);
    extern void __QtAda_QDir_tempPath_S(QString*);
    extern void __QtAda_QDir_toNativeSeparators_QStringCR_S(QString*, const QString*);
    extern unsigned __QtAda_QDir_eq_QDirCR_Q(const QDir*, const QDir*);

};

