//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QFileInfo>

extern "C"
{
    extern QFileInfo* __QtAda_inititialize_QFileInfo(void*);
    extern QFileInfo* __QtAda_inititialize_QFileInfo_QStringCR(void*, const QString*);
    extern QFileInfo* __QtAda_inititialize_QFileInfo_QDirCR_QStringCR(void*, const QDir*, const QString*);
    extern QFileInfo* __QtAda_adjust_QFileInfo(void*, const QFileInfo*);
    extern void __QtAda_finalize_QFileInfo(QFileInfo*);

    extern void __QtAda_QFileInfo_absoluteDir_Q(QDir*, const QFileInfo*);
    extern void __QtAda_QFileInfo_absoluteFilePath_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_absolutePath_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_baseName_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_bundleName_Q(QString*, const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_caching_Q(const QFileInfo*);
    extern void __QtAda_QFileInfo_canonicalFilePath_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_canonicalPath_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_completeBaseName_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_completeSuffix_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_created_Q(QDateTime*, const QFileInfo*);
    extern void __QtAda_QFileInfo_dir_Q(QDir*, const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_exists_Q(const QFileInfo*);
    extern void __QtAda_QFileInfo_fileName_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_filePath_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_group_Q(QString*, const QFileInfo*);
    extern uint __QtAda_QFileInfo_groupId_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isAbsolute_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isBundle_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isDir_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isExecutable_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isFile_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isHidden_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isReadable_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isRelative_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isRoot_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isSymLink_Q(const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_isWritable_Q(const QFileInfo*);
    extern void __QtAda_QFileInfo_lastModified_Q(QDateTime*, const QFileInfo*);
    extern void __QtAda_QFileInfo_lastRead_Q(QDateTime*, const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_makeAbsolute(QFileInfo*);
    extern void __QtAda_QFileInfo_owner_Q(QString*, const QFileInfo*);
    extern uint __QtAda_QFileInfo_ownerId_Q(const QFileInfo*);
    extern void __QtAda_QFileInfo_path_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_refresh(QFileInfo*);
    extern void __QtAda_QFileInfo_setCaching_bool(QFileInfo*, unsigned);
    extern void __QtAda_QFileInfo_setFile_QStringCR(QFileInfo*, const QString*);
    extern void __QtAda_QFileInfo_setFile_QDirCR_QStringCR(QFileInfo*, const QDir*, const QString*);
    extern qint64 __QtAda_QFileInfo_size_Q(const QFileInfo*);
    extern void __QtAda_QFileInfo_suffix_Q(QString*, const QFileInfo*);
    extern void __QtAda_QFileInfo_symLinkTarget_Q(QString*, const QFileInfo*);
    extern unsigned __QtAda_QFileInfo_eq_QFileInfoCR_Q(const QFileInfo*, const QFileInfo*);

};

