//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QByteArray>
#include <QChildEvent>
#include <QTimerEvent>

#include "qiodevicedirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QIODevice_staticMetaObject =
        &QIODevice::staticMetaObject;
}

extern "C"
{

    bool __Qt4Ada_QIODevice_atEnd_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->atEnd();
    }

    qint64 __Qt4Ada_QIODevice_bytesAvailable_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->bytesAvailable();
    }

    qint64 __Qt4Ada_QIODevice_bytesToWrite_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->bytesToWrite();
    }

    bool __Qt4Ada_QIODevice_canReadLine_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->canReadLine();
    }

    void __Qt4Ada_QIODevice_close_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QIODevice*>(cpp_object)->close();
    }

    bool __Qt4Ada_QIODevice_isSequential_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->isSequential();
    }

    qint64 __Qt4Ada_QIODevice_pos_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->pos();
    }

    bool __Qt4Ada_QIODevice_reset_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->reset();
    }

    bool __Qt4Ada_QIODevice_seek_0_virtual(QObject* cpp_object, qint64 pos)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->seek(pos);
    }

    qint64 __Qt4Ada_QIODevice_size_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->size();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QIODevice_atEnd_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::atEnd();
    }

    qint64 __Qt4Ada_QIODevice_bytesAvailable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::bytesAvailable();
    }

    qint64 __Qt4Ada_QIODevice_bytesToWrite_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::bytesToWrite();
    }

    bool __Qt4Ada_QIODevice_canReadLine_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::canReadLine();
    }

    void __Qt4Ada_QIODevice_close_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QIODevice*>(cpp_object)->QIODevice::close();
    }

    void __Qt4Ada_QIODevice_errorString_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QIODevice*>(cpp_object)->QIODevice::errorString();
    }

    bool __Qt4Ada_QIODevice_isOpen_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::isOpen();
    }

    bool __Qt4Ada_QIODevice_isReadable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::isReadable();
    }

    bool __Qt4Ada_QIODevice_isSequential_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::isSequential();
    }

    bool __Qt4Ada_QIODevice_isTextModeEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::isTextModeEnabled();
    }

    bool __Qt4Ada_QIODevice_isWritable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::isWritable();
    }

    void __Qt4Ada_QIODevice_peek_0_wrapper(QObject* cpp_object, qint64 maxlen, QByteArray* returns)
    {
        *returns = dynamic_cast<QIODevice*>(cpp_object)->QIODevice::peek(maxlen);
    }

    qint64 __Qt4Ada_QIODevice_pos_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::pos();
    }

    void __Qt4Ada_QIODevice_read_0_wrapper(QObject* cpp_object, qint64 maxlen, QByteArray* returns)
    {
        *returns = dynamic_cast<QIODevice*>(cpp_object)->QIODevice::read(maxlen);
    }

    void __Qt4Ada_QIODevice_readAll_0_wrapper(QObject* cpp_object, QByteArray* returns)
    {
        *returns = dynamic_cast<QIODevice*>(cpp_object)->QIODevice::readAll();
    }

    void __Qt4Ada_QIODevice_readLine_0_wrapper(QObject* cpp_object, qint64 maxlen, QByteArray* returns)
    {
        *returns = dynamic_cast<QIODevice*>(cpp_object)->QIODevice::readLine(maxlen);
    }

    bool __Qt4Ada_QIODevice_reset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::reset();
    }

    bool __Qt4Ada_QIODevice_seek_0_wrapper(QObject* cpp_object, qint64 pos)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::seek(pos);
    }

    void __Qt4Ada_QIODevice_setTextModeEnabled_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QIODevice*>(cpp_object)->QIODevice::setTextModeEnabled(enabled);
    }

    qint64 __Qt4Ada_QIODevice_size_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::size();
    }

    qint64 __Qt4Ada_QIODevice_write_0_wrapper(QObject* cpp_object, const QByteArray* data)
    {
        return dynamic_cast<QIODevice*>(cpp_object)->QIODevice::write(*data);
    }

    void __Qt4Ada_QIODevice_aboutToClose_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QIODeviceDirector*>(cpp_object)->QIODevice::aboutToClose();
    }

    void __Qt4Ada_QIODevice_bytesWritten_0_wrapper(QObject* cpp_object, qint64 bytes)
    {
        dynamic_cast<QIODeviceDirector*>(cpp_object)->QIODevice::bytesWritten(bytes);
    }

    void __Qt4Ada_QIODevice_readChannelFinished_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QIODeviceDirector*>(cpp_object)->QIODevice::readChannelFinished();
    }

    void __Qt4Ada_QIODevice_readyRead_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QIODeviceDirector*>(cpp_object)->QIODevice::readyRead();
    }

    void __Qt4Ada_QIODevice_setErrorString_0_wrapper(QObject* cpp_object, const QString* errorString)
    {
        dynamic_cast<QIODeviceDirector*>(cpp_object)->QIODevice::setErrorString(*errorString);
    }

    void __Qt4Ada_QIODevice_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QIODeviceDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QIODevice_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QIODeviceDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QIODevice_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QIODeviceDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QIODevice_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QIODeviceDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QIODevice_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QIODevice*>(cpp_this)->QIODevice::qt_metacast(name);
    }

    int __Qt4Ada_QIODevice_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QIODevice*>(cpp_this)->QIODevice::qt_metacall(_c, _id, _a);
    }

}

bool QIODeviceDirector::atEnd() const
{
    return __Qt4Ada_QIODevice_atEnd_0_dispatch(this->ada_object);
}

qint64 QIODeviceDirector::bytesAvailable() const
{
    return __Qt4Ada_QIODevice_bytesAvailable_0_dispatch(this->ada_object);
}

qint64 QIODeviceDirector::bytesToWrite() const
{
    return __Qt4Ada_QIODevice_bytesToWrite_0_dispatch(this->ada_object);
}

bool QIODeviceDirector::canReadLine() const
{
    return __Qt4Ada_QIODevice_canReadLine_0_dispatch(this->ada_object);
}

void QIODeviceDirector::close()
{
    __Qt4Ada_QIODevice_close_0_dispatch(this->ada_object);
}

bool QIODeviceDirector::isSequential() const
{
    return __Qt4Ada_QIODevice_isSequential_0_dispatch(this->ada_object);
}

qint64 QIODeviceDirector::pos() const
{
    return __Qt4Ada_QIODevice_pos_0_dispatch(this->ada_object);
}

bool QIODeviceDirector::reset()
{
    return __Qt4Ada_QIODevice_reset_0_dispatch(this->ada_object);
}

bool QIODeviceDirector::seek(qint64 pos)
{
    return __Qt4Ada_QIODevice_seek_0_dispatch(this->ada_object, pos);
}

qint64 QIODeviceDirector::size() const
{
    return __Qt4Ada_QIODevice_size_0_dispatch(this->ada_object);
}

bool QIODeviceDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QIODeviceDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QIODeviceDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QIODeviceDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QIODeviceDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QIODeviceDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QIODeviceDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QIODeviceDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{

    bool __Qt4Ada_QIODevice_open_virtual(QObject* ptr, unsigned mode)
    {
        return dynamic_cast<QIODevice*>(ptr)->open(QIODevice::OpenMode(mode));
    }

}
