//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QLineF>

extern "C"
{
    extern QLineF* __QtAda_inititialize_QLineF(void*);
    extern QLineF* __QtAda_inititialize_QLineF_QPointFCR_QPointFCR(void*, const QPointF*, const QPointF*);
    extern QLineF* __QtAda_inititialize_QLineF_qreal_qreal_qreal_qreal(void*, double, double, double, double);
    extern QLineF* __QtAda_inititialize_QLineF_QLineCR(void*, const QLine*);
    extern QLineF* __QtAda_adjust_QLineF(void*, const QLineF*);
    extern void __QtAda_finalize_QLineF(QLineF*);

    extern double __QtAda_QLineF_angle_QLineFCR_Q(const QLineF*, const QLineF*);
    extern double __QtAda_QLineF_dx_Q(const QLineF*);
    extern double __QtAda_QLineF_dy_Q(const QLineF*);
    extern unsigned __QtAda_QLineF_isNull_Q(const QLineF*);
    extern double __QtAda_QLineF_length_Q(const QLineF*);
    extern void __QtAda_QLineF_normalVector_Q(QLineF*, const QLineF*);
    extern void __QtAda_QLineF_p1_Q(QPointF*, const QLineF*);
    extern void __QtAda_QLineF_p2_Q(QPointF*, const QLineF*);
    extern void __QtAda_QLineF_pointAt_qreal_Q(QPointF*, const QLineF*, double);
    extern void __QtAda_QLineF_setLength_qreal(QLineF*, double);
    extern void __QtAda_QLineF_toLine_Q(QLine*, const QLineF*);
    extern void __QtAda_QLineF_translate_QPointFCR(QLineF*, const QPointF*);
    extern void __QtAda_QLineF_translate_qreal_qreal(QLineF*, double, double);
    extern void __QtAda_QLineF_unitVector_Q(QLineF*, const QLineF*);
    extern double __QtAda_QLineF_x1_Q(const QLineF*);
    extern double __QtAda_QLineF_x2_Q(const QLineF*);
    extern double __QtAda_QLineF_y1_Q(const QLineF*);
    extern double __QtAda_QLineF_y2_Q(const QLineF*);
    extern unsigned __QtAda_QLineF_eq_QLineFCR_Q(const QLineF*, const QLineF*);

};

