//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QPoint>
#include <QString>
#include "qlinewrapper.h"

extern "C"
{

    QLine* __QtAda_inititialize_QLine(void* storage)
    {
        return new (storage) QLine();
    }

    QLine* __QtAda_inititialize_QLine_QPointCR_QPointCR(void* storage, const QPoint* pt1, const QPoint* pt2)
    {
        return new (storage) QLine(*pt1, *pt2);
    }

    QLine* __QtAda_inititialize_QLine_int_int_int_int(void* storage, int x1, int y1, int x2, int y2)
    {
        return new (storage) QLine(x1, y1, x2, y2);
    }

    QLine* __QtAda_adjust_QLine(void* storage, const QLine* from)
    {
        return new (storage) QLine(*from);
    }

    void __QtAda_finalize_QLine(QLine *item)
    {
        item->~QLine();
    }

    int __QtAda_QLine_dx_Q(const QLine* self)
    {
        return self->dx();
    }

    int __QtAda_QLine_dy_Q(const QLine* self)
    {
        return self->dy();
    }

    unsigned __QtAda_QLine_isNull_Q(const QLine* self)
    {
        return (unsigned)self->isNull();
    }

    void __QtAda_QLine_p1_Q(QPoint* returns, const QLine* self)
    {
        *returns = self->p1();
    }

    void __QtAda_QLine_p2_Q(QPoint* returns, const QLine* self)
    {
        *returns = self->p2();
    }

    void __QtAda_QLine_translate_QPointCR(QLine* self, const QPoint* p)
    {
        self->translate(*p);
    }

    void __QtAda_QLine_translate_int_int(QLine* self, int dx, int dy)
    {
        self->translate(dx, dy);
    }

    int __QtAda_QLine_x1_Q(const QLine* self)
    {
        return self->x1();
    }

    int __QtAda_QLine_x2_Q(const QLine* self)
    {
        return self->x2();
    }

    int __QtAda_QLine_y1_Q(const QLine* self)
    {
        return self->y1();
    }

    int __QtAda_QLine_y2_Q(const QLine* self)
    {
        return self->y2();
    }

    unsigned __QtAda_QLine_eq_QLineCR_Q(const QLine* self, const QLine* d)
    {
        return (unsigned)self->operator==(*d);
    }

};

