//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2976 $ $Date: 2008-12-26 13:13:33 +0300 (Fri, 26 Dec 2008) $
//----------------------------------------------------------------------------
#ifndef __QMETAOBJECTWRAPPER_H__
#define __QMETAOBJECTWRAPPER_H__

#include <QMetaObject>

extern "C" {

    extern void __Qt4Ada_QMetaObject_activate(QObject*sender,const QMetaObject*,int,void **);
    extern void __Qt4Ada_QMetaObject_connectSlotsByName_wrapper (QObject *object);
    extern bool __Qt4Ada_QMetaObject_invokeMethod_wrapper(QObject*,const char*,Qt::ConnectionType,const char*,void*,const char*,void*,const char*,void*,const char*,void*,const char*,void*,const char*,void*,const char*,void*,const char*,void*,const char*,void*,const char*,void*,const char*,void*);

    extern void __QtAda_QMetaObject_changeGuard(QObject**, QObject*);
    extern void __QtAda_QMetaObject_removeGuard(QObject**);
    extern void __QtAda_QMetaObject_addGuard(QObject**);

}

#endif // __QMETAOBJECTWRAPPER_H__
