//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2011 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QMIMEDATADIRECTOR_H__
#define __QMIMEDATADIRECTOR_H__

#include <QMimeData>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QMimeData_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QStringList* __Qt4Ada_QMimeData_formats_0_dispatch(void*);
    extern bool __Qt4Ada_QMimeData_hasFormat_0_dispatch(void*, const QString*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QMimeData_formats_0_virtual(QObject*, QStringList*);
    extern bool __Qt4Ada_QMimeData_hasFormat_0_virtual(QObject*, const QString*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QMimeData_clear_0_wrapper(QObject*);
    extern void __Qt4Ada_QMimeData_colorData_0_wrapper(QObject*, QVariant*);
    extern void __Qt4Ada_QMimeData_data_0_wrapper(QObject*, const QString*, QByteArray*);
    extern void __Qt4Ada_QMimeData_formats_0_wrapper(QObject*, QStringList*);
    extern bool __Qt4Ada_QMimeData_hasColor_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMimeData_hasFormat_0_wrapper(QObject*, const QString*);
    extern bool __Qt4Ada_QMimeData_hasHtml_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMimeData_hasImage_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMimeData_hasText_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMimeData_hasUrls_0_wrapper(QObject*);
    extern void __Qt4Ada_QMimeData_html_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QMimeData_imageData_0_wrapper(QObject*, QVariant*);
    extern void __Qt4Ada_QMimeData_removeFormat_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QMimeData_setColorData_0_wrapper(QObject*, const QVariant*);
    extern void __Qt4Ada_QMimeData_setData_0_wrapper(QObject*, const QString*, const QByteArray*);
    extern void __Qt4Ada_QMimeData_setHtml_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QMimeData_setImageData_0_wrapper(QObject*, const QVariant*);
    extern void __Qt4Ada_QMimeData_setText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QMimeData_text_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QMimeData_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMimeData_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMimeData_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QMimeData_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QMimeData_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QMimeData_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C"
{

    extern QObject* __QtAda_new_QMimeData();

    extern QObject* __Qt4Ada_new_QMimeDataDirector(void*);

}

class QMimeDataDirector : public QMimeData
{
protected:
    void* ada_object;
    QMimeDataDirector(void*);

    friend QObject* __Qt4Ada_new_QMimeDataDirector(void*);

    virtual QStringList formats() const;
    virtual bool hasFormat(const QString&) const;
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QMimeData_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMimeData_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMimeData_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QMimeData_sender_0_wrapper(QObject*);
};

#endif // __QMIMEDATADIRECTOR_H__
