//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QVariant>
#include <QChildEvent>
#include <QTimerEvent>

#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QObject_staticMetaObject =
        &QObject::staticMetaObject;
}

extern "C"
{

    bool __Qt4Ada_QObject_event_0_virtual(QObject* cpp_object, QEvent* e)
    {
        return cpp_object->event(e);
    }

    bool __Qt4Ada_QObject_eventFilter_0_virtual(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return cpp_object->eventFilter(watched, event);
    }

    const QMetaObject* __Qt4Ada_QObject_metaObject_virtual(QObject* cpp_this)
    {
        return cpp_this->metaObject();
    }

    void* __Qt4Ada_QObject_qt_metacast_virtual(QObject* cpp_this, const char* name)
    {
        return cpp_this->qt_metacast(name);
    }

    int __Qt4Ada_QObject_qt_metacall_virtual(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return cpp_this->qt_metacall(_c, _id, _a);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QObject_blockSignals_0_wrapper(QObject* cpp_object, bool b)
    {
        return dynamic_cast<QObject*>(cpp_object)->QObject::blockSignals(b);
    }

    bool __Qt4Ada_QObject_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QObject*>(cpp_object)->QObject::event(e);
    }

    bool __Qt4Ada_QObject_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QObject*>(cpp_object)->QObject::eventFilter(watched, event);
    }

    void __Qt4Ada_QObject_installEventFilter_0_wrapper(QObject* cpp_object, QObject* filterObj)
    {
        dynamic_cast<QObject*>(cpp_object)->QObject::installEventFilter(filterObj);
    }

    bool __Qt4Ada_QObject_isWidgetType_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QObject*>(cpp_object)->QObject::isWidgetType();
    }

    void __Qt4Ada_QObject_objectName_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QObject*>(cpp_object)->QObject::objectName();
    }

    QObject* __Qt4Ada_QObject_parent_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QObject*>(cpp_object)->QObject::parent();
    }

    void __Qt4Ada_QObject_property_0_wrapper(QObject* cpp_object, const char* name, QVariant* returns)
    {
        *returns = dynamic_cast<QObject*>(cpp_object)->QObject::property(name);
    }

    void __Qt4Ada_QObject_removeEventFilter_0_wrapper(QObject* cpp_object, QObject* obj)
    {
        dynamic_cast<QObject*>(cpp_object)->QObject::removeEventFilter(obj);
    }

    void __Qt4Ada_QObject_setObjectName_0_wrapper(QObject* cpp_object, const QString* name)
    {
        dynamic_cast<QObject*>(cpp_object)->QObject::setObjectName(*name);
    }

    void __Qt4Ada_QObject_setParent_0_wrapper(QObject* cpp_object, QObject* parent)
    {
        dynamic_cast<QObject*>(cpp_object)->QObject::setParent(parent);
    }

    void __Qt4Ada_QObject_setProperty_0_wrapper(QObject* cpp_object, const char* name, const QVariant* value)
    {
        dynamic_cast<QObject*>(cpp_object)->QObject::setProperty(name, *value);
    }

    bool __Qt4Ada_QObject_signalsBlocked_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QObject*>(cpp_object)->QObject::signalsBlocked();
    }

    void __Qt4Ada_QObject_deleteLater_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QObject*>(cpp_object)->QObject::deleteLater();
    }

    void __Qt4Ada_QObject_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QObjectDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QObject_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QObjectDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QObject_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QObjectDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QObject_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QObjectDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QObject_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QObject*>(cpp_this)->QObject::qt_metacast(name);
    }

    int __Qt4Ada_QObject_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QObject*>(cpp_this)->QObject::qt_metacall(_c, _id, _a);
    }

}

bool QObjectDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QObjectDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QObjectDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QObjectDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QObjectDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QObjectDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QObjectDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QObjectDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

uint QtAdaQObjectImplUserData::id = QObject::registerUserData();

QtAdaQObjectImplUserData::QtAdaQObjectImplUserData(void* o) :
    ada_object(o)
{
}

QtAdaQObjectImplUserData::~QtAdaQObjectImplUserData()
{
    __QtAda_free_Q_Object_Impl(ada_object);
}

QObjectDirector::QObjectDirector(void* o, QObject*parent) :
    QObject (parent),
    ada_object (o)
{
}

void QObjectDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QObjectDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    void __Qt4Ada_QObject_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QObjectDirector*>(cpp_this))->QObject::connectNotify(_p1);
    }

    void __Qt4Ada_QObject_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QObjectDirector*>(cpp_this))->QObject::disconnectNotify(_p1);
    }

    bool __Qt4Ada_QObject_connect_wrapper (QObject*sender,const char*signal,QObject*receiver,const char*method,Qt::ConnectionType type)
    {
        return QObject::connect(sender,signal,receiver,method,type);
    }

    void __Qt4Ada_QObject_destroyed_wrapper(QObject *cpp_this, QObject *obj)
    {
      emit dynamic_cast <QObjectDirector*> (cpp_this)->destroyed (obj);
    }

    void __Qt4Ada_delete_QObject(QObject *cpp_this)
    {
        delete cpp_this;
    }

    void __QtAda_associate_Q_Object_Impl (QObject* cpp_object, void* ada_object)
    {
        cpp_object->setUserData(QtAdaQObjectImplUserData::id, new QtAdaQObjectImplUserData(ada_object));
    }

    void* __QtAda_get_QObject_LimitedEntity (QObject* cpp_object)
    {
        QObjectUserData* data =
            cpp_object->userData(QtAdaQObjectImplUserData::id);

        if (data)
        {
            return (dynamic_cast<QtAdaQObjectImplUserData*>(data))->ada_object;
        }
        else
        {
            return NULL;
        }
    }

    QObject * __Qt4Ada_new_QObjectDirector (void *ada_object,QObject *parent)
    {
        return dynamic_cast<QObject*>(new QObjectDirector(ada_object, parent));
    }

    int __Qt4Ada_QObject_start_timer_wrapper(QObject* cpp_object, int interval)
    {
        return cpp_object->startTimer(interval);
    }

    void __Qt4Ada_QObject_kill_timer_wrapper(QObject*cpp_object, int id)
    {
        cpp_object->killTimer(id);
    }

    QObject* __Qt4Ada_QObject_findChild_wrapper(QObject* cpp_object, const QString* name)
    {
        return dynamic_cast<QObject*>(cpp_object)->QObject::findChild<QObject*>(*name);
    }

}
