//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QOBJECTDIRECTOR_H__
#define __QOBJECTDIRECTOR_H__

#include <QObject>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QObject_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern bool __Qt4Ada_QObject_event_0_dispatch(void*, QEvent*);
    extern bool __Qt4Ada_QObject_eventFilter_0_dispatch(void*, QObject*, QEvent*);
    extern void __Qt4Ada_QObject_childEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QObject_customEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QObject_timerEvent_0_dispatch(void*, QEvent*);

    extern const QMetaObject* __Qt4Ada_QObject_metaObject_dispatch(void*);
    extern void* __Qt4Ada_QObject_qt_metacast_dispatch(void*, const char*);
    extern int __Qt4Ada_QObject_qt_metacall_dispatch(void*, QMetaObject::Call, int, void**);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern bool __Qt4Ada_QObject_event_0_virtual(QObject*, QEvent*);
    extern bool __Qt4Ada_QObject_eventFilter_0_virtual(QObject*, QObject*, QEvent*);

    extern const QMetaObject* __Qt4Ada_QObject_metaObject_virtual(QObject*);
    extern void* __Qt4Ada_QObject_qt_metacast_virtual(QObject*, const char*);
    extern int __Qt4Ada_QObject_qt_metacall_virtual(QObject*, QMetaObject::Call, int, void**);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QObject_blockSignals_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QObject_event_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QObject_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    extern void __Qt4Ada_QObject_installEventFilter_0_wrapper(QObject*, QObject*);
    extern bool __Qt4Ada_QObject_isWidgetType_0_wrapper(QObject*);
    extern void __Qt4Ada_QObject_objectName_0_wrapper(QObject*, QString*);
    extern QObject* __Qt4Ada_QObject_parent_0_wrapper(QObject*);
    extern void __Qt4Ada_QObject_property_0_wrapper(QObject*, const char*, QVariant*);
    extern void __Qt4Ada_QObject_removeEventFilter_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QObject_setObjectName_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QObject_setParent_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QObject_setProperty_0_wrapper(QObject*, const char*, const QVariant*);
    extern bool __Qt4Ada_QObject_signalsBlocked_0_wrapper(QObject*);
    extern void __Qt4Ada_QObject_deleteLater_0_wrapper(QObject*);
    extern void __Qt4Ada_QObject_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QObject_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QObject_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QObject_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QObject_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QObject_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    //  Declarations of exported functions

    extern void __Qt4Ada_QObject_connectNotify_dispatch(void*, const char*);
    extern void __Qt4Ada_QObject_disconnectNotify_dispatch(void* ,const char*);

    //  Declarations of wrapper functions for static call

    extern void __Qt4Ada_QObject_connectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QObject_disconnectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QObject_destroyed_wrapper(QObject*, QObject*);

    extern bool __Qt4Ada_QObject_connect_wrapper (QObject*,const char*,QObject*,const char*,Qt::ConnectionType);
    extern int __Qt4Ada_QObject_start_timer_wrapper(QObject*, int);
    extern void __Qt4Ada_QObject_kill_timer_wrapper(QObject*, int);
    extern QObject* __Qt4Ada_QObject_findChild_wrapper(QObject*, const QString*);

    //  Auxiliary function

    extern void __Qt4Ada_delete_QObject(QObject *);

    //  Функции ассоциации объектов C++ и Ada.

    extern void __QtAda_associate_Q_Object_Impl(QObject*, void*);
    extern void* __QtAda_get_QObject_LimitedEntity (QObject*);
    extern QObject* __Qt4Ada_new_QObjectDirector (void*,QObject *parent);
    extern void __QtAda_free_Q_Object_Impl(void*);
}

class QtAdaQObjectImplUserData : public QObjectUserData
{
protected:
    QtAdaQObjectImplUserData(void*);
    virtual ~QtAdaQObjectImplUserData();

    void* ada_object;

    static uint id;

    friend void __QtAda_associate_Q_Object_Impl(QObject*, void*);
    friend void* __QtAda_get_QObject_LimitedEntity (QObject*);
};

class QObjectDirector : public QObject
{
protected:
    void* ada_object;
    QObjectDirector(void*, QObject*);

    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

    friend void __Qt4Ada_QObject_connectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QObject_disconnectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QObject_destroyed_wrapper(QObject*, QObject*);
    friend QObject * __Qt4Ada_new_QObjectDirector(void*, QObject*);

    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QObject_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QObject_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QObject_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QObject_sender_0_wrapper(QObject*);
};

#endif // __QOBJECTDIRECTOR_H__
