//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QChildEvent>
#include <QTimerEvent>

#include "qpluginloaderdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QPluginLoader_staticMetaObject =
        &QPluginLoader::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QPluginLoader_errorString_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QPluginLoader*>(cpp_object)->QPluginLoader::errorString();
    }

    void __Qt4Ada_QPluginLoader_fileName_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QPluginLoader*>(cpp_object)->QPluginLoader::fileName();
    }

    QObject* __Qt4Ada_QPluginLoader_instance_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPluginLoader*>(cpp_object)->QPluginLoader::instance();
    }

    bool __Qt4Ada_QPluginLoader_isLoaded_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPluginLoader*>(cpp_object)->QPluginLoader::isLoaded();
    }

    bool __Qt4Ada_QPluginLoader_load_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPluginLoader*>(cpp_object)->QPluginLoader::load();
    }

    void __Qt4Ada_QPluginLoader_setFileName_0_wrapper(QObject* cpp_object, const QString* fileName)
    {
        dynamic_cast<QPluginLoader*>(cpp_object)->QPluginLoader::setFileName(*fileName);
    }

    bool __Qt4Ada_QPluginLoader_unload_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPluginLoader*>(cpp_object)->QPluginLoader::unload();
    }

    void __Qt4Ada_QPluginLoader_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPluginLoaderDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QPluginLoader_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPluginLoaderDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QPluginLoader_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPluginLoaderDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QPluginLoader_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPluginLoaderDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QPluginLoader_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QPluginLoader*>(cpp_this)->QPluginLoader::qt_metacast(name);
    }

    int __Qt4Ada_QPluginLoader_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QPluginLoader*>(cpp_this)->QPluginLoader::qt_metacall(_c, _id, _a);
    }

}

bool QPluginLoaderDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QPluginLoaderDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QPluginLoaderDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QPluginLoaderDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QPluginLoaderDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QPluginLoaderDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QPluginLoaderDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QPluginLoaderDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

void QPluginLoaderDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QPluginLoaderDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    // Constructors

    QObject* __Qt4Ada_new_QPluginLoader (QObject *parent)
    {
        return dynamic_cast<QObject *>(new QPluginLoader (parent));
    }

    QObject* __Qt4Ada_new_QPluginLoader_With_String (const QString* fileName, QObject *parent)
    {
        return dynamic_cast<QObject*>(new QPluginLoader (*fileName, parent));
    }

}
