//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QPoint>
#include <QPointF>
#include <QString>
#include "qpointfwrapper.h"

extern "C"
{

    QPointF* __QtAda_inititialize_QPointF(void* storage)
    {
        return new (storage) QPointF();
    }

    QPointF* __QtAda_inititialize_QPointF_QPointCR(void* storage, const QPoint* p)
    {
        return new (storage) QPointF(*p);
    }

    QPointF* __QtAda_inititialize_QPointF_qreal_qreal(void* storage, double xpos, double ypos)
    {
        return new (storage) QPointF((qreal)xpos, (qreal)ypos);
    }

    QPointF* __QtAda_adjust_QPointF(void* storage, const QPointF* from)
    {
        return new (storage) QPointF(*from);
    }

    void __QtAda_finalize_QPointF(QPointF *item)
    {
        item->~QPointF();
    }

    unsigned __QtAda_QPointF_isNull_Q(const QPointF* self)
    {
        return (unsigned)self->isNull();
    }

    void __QtAda_QPointF_setX_qreal(QPointF* self, double x)
    {
        self->setX((qreal)x);
    }

    void __QtAda_QPointF_setY_qreal(QPointF* self, double y)
    {
        self->setY((qreal)y);
    }

    void __QtAda_QPointF_toPoint_Q(QPoint* returns, const QPointF* self)
    {
        *returns = self->toPoint();
    }

    double __QtAda_QPointF_x_Q(const QPointF* self)
    {
        return (double)self->x();
    }

    double __QtAda_QPointF_y_Q(const QPointF* self)
    {
        return (double)self->y();
    }

    unsigned __QtAda_eq_QPointFCR_QPointFCR(const QPointF* p1, const QPointF* p2)
    {
        return (unsigned)operator==(*p1, *p2);
    }

    void __QtAda_plus_QPointFCR_QPointFCR(QPointF* returns, const QPointF* p1, const QPointF* p2)
    {
        *returns = operator+(*p1, *p2);
    }

    void __QtAda_minus_QPointFCR_QPointFCR(QPointF* returns, const QPointF* p1, const QPointF* p2)
    {
        *returns = operator-(*p1, *p2);
    }

    void __QtAda_multiplication_QPointFCR_qreal(QPointF* returns, const QPointF* p, double s)
    {
        *returns = operator*(*p, (qreal)s);
    }

    void __QtAda_multiplication_qreal_QPointFCR(QPointF* returns, double s, const QPointF* p)
    {
        *returns = operator*((qreal)s, *p);
    }

    void __QtAda_minus_QPointFCR(QPointF* returns, const QPointF* p)
    {
        *returns = operator-(*p);
    }

    void __QtAda_division_QPointFCR_qreal(QPointF* returns, const QPointF* p, double s)
    {
        *returns = operator/(*p, (qreal)s);
    }

};

