//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QPoint>

extern "C"
{
    extern QPoint* __QtAda_inititialize_QPoint(void*);
    extern QPoint* __QtAda_inititialize_QPoint_int_int(void*, int, int);
    extern QPoint* __QtAda_adjust_QPoint(void*, const QPoint*);
    extern void __QtAda_finalize_QPoint(QPoint*);

    extern unsigned __QtAda_QPoint_isNull_Q(const QPoint*);
    extern int __QtAda_QPoint_manhattanLength_Q(const QPoint*);
    extern void __QtAda_QPoint_setX_int(QPoint*, int);
    extern void __QtAda_QPoint_setY_int(QPoint*, int);
    extern int __QtAda_QPoint_x_Q(const QPoint*);
    extern int __QtAda_QPoint_y_Q(const QPoint*);
    extern unsigned __QtAda_eq_QPointCR_QPointCR(const QPoint*, const QPoint*);
    extern void __QtAda_plus_QPointCR_QPointCR(QPoint*, const QPoint*, const QPoint*);
    extern void __QtAda_minus_QPointCR_QPointCR(QPoint*, const QPoint*, const QPoint*);
    extern void __QtAda_multiplication_QPointCR_qreal(QPoint*, const QPoint*, double);
    extern void __QtAda_multiplication_qreal_QPointCR(QPoint*, double, const QPoint*);
    extern void __QtAda_minus_QPointCR(QPoint*, const QPoint*);
    extern void __QtAda_division_QPointCR_qreal(QPoint*, const QPoint*, double);

};

