//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QStringList>
#include <QProcessEnvironment>
#include <QByteArray>
#include <QString>
#include <QChildEvent>
#include <QTimerEvent>

#include "qprocessdirector.h"
#include "qiodevicedirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QProcess_staticMetaObject =
        &QProcess::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QProcess_closeReadChannel_0_wrapper(QObject* cpp_object, QProcess::ProcessChannel channel)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::closeReadChannel(channel);
    }

    void __Qt4Ada_QProcess_closeWriteChannel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::closeWriteChannel();
    }

    void __Qt4Ada_QProcess_environment_0_wrapper(QObject* cpp_object, QStringList* returns)
    {
        *returns = dynamic_cast<QProcess*>(cpp_object)->QProcess::environment();
    }

    QProcess::ProcessError __Qt4Ada_QProcess_error_1_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::error();
    }

    int __Qt4Ada_QProcess_exitCode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::exitCode();
    }

    QProcess::ExitStatus __Qt4Ada_QProcess_exitStatus_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::exitStatus();
    }

    QProcess::ProcessChannelMode __Qt4Ada_QProcess_processChannelMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::processChannelMode();
    }

    void __Qt4Ada_QProcess_processEnvironment_0_wrapper(QObject* cpp_object, QProcessEnvironment* returns)
    {
        *returns = dynamic_cast<QProcess*>(cpp_object)->QProcess::processEnvironment();
    }

    void __Qt4Ada_QProcess_readAllStandardError_0_wrapper(QObject* cpp_object, QByteArray* returns)
    {
        *returns = dynamic_cast<QProcess*>(cpp_object)->QProcess::readAllStandardError();
    }

    void __Qt4Ada_QProcess_readAllStandardOutput_0_wrapper(QObject* cpp_object, QByteArray* returns)
    {
        *returns = dynamic_cast<QProcess*>(cpp_object)->QProcess::readAllStandardOutput();
    }

    QProcess::ProcessChannel __Qt4Ada_QProcess_readChannel_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::readChannel();
    }

    void __Qt4Ada_QProcess_setEnvironment_0_wrapper(QObject* cpp_object, const QStringList* environment)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::setEnvironment(*environment);
    }

    void __Qt4Ada_QProcess_setProcessChannelMode_0_wrapper(QObject* cpp_object, QProcess::ProcessChannelMode mode)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::setProcessChannelMode(mode);
    }

    void __Qt4Ada_QProcess_setProcessEnvironment_0_wrapper(QObject* cpp_object, const QProcessEnvironment* environment)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::setProcessEnvironment(*environment);
    }

    void __Qt4Ada_QProcess_setReadChannel_0_wrapper(QObject* cpp_object, QProcess::ProcessChannel channel)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::setReadChannel(channel);
    }

    void __Qt4Ada_QProcess_setStandardInputFile_0_wrapper(QObject* cpp_object, const QString* fileName)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::setStandardInputFile(*fileName);
    }

    void __Qt4Ada_QProcess_setStandardOutputProcess_0_wrapper(QObject* cpp_object, QObject* destination)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::setStandardOutputProcess(dynamic_cast<QProcess*>(destination));
    }

    void __Qt4Ada_QProcess_setWorkingDirectory_0_wrapper(QObject* cpp_object, const QString* dir)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::setWorkingDirectory(*dir);
    }

    QProcess::ProcessState __Qt4Ada_QProcess_state_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::state();
    }

    bool __Qt4Ada_QProcess_waitForFinished_0_wrapper(QObject* cpp_object, int msecs)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::waitForFinished(msecs);
    }

    bool __Qt4Ada_QProcess_waitForStarted_0_wrapper(QObject* cpp_object, int msecs)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::waitForStarted(msecs);
    }

    void __Qt4Ada_QProcess_workingDirectory_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QProcess*>(cpp_object)->QProcess::workingDirectory();
    }

    void __Qt4Ada_QProcess_kill_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::kill();
    }

    void __Qt4Ada_QProcess_terminate_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::terminate();
    }

    void __Qt4Ada_QProcess_error_0_wrapper(QObject* cpp_object, QProcess::ProcessError error)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QProcess::error(error);
    }

    void __Qt4Ada_QProcess_finished_0_wrapper(QObject* cpp_object, int exitCode, QProcess::ExitStatus exitStatus)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QProcess::finished(exitCode, exitStatus);
    }

    void __Qt4Ada_QProcess_readyReadStandardError_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QProcess::readyReadStandardError();
    }

    void __Qt4Ada_QProcess_readyReadStandardOutput_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QProcess::readyReadStandardOutput();
    }

    void __Qt4Ada_QProcess_started_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QProcess::started();
    }

    void __Qt4Ada_QProcess_stateChanged_0_wrapper(QObject* cpp_object, QProcess::ProcessState state)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QProcess::stateChanged(state);
    }

    void __Qt4Ada_QProcess_setProcessState_0_wrapper(QObject* cpp_object, QProcess::ProcessState state)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QProcess::setProcessState(state);
    }

    void __Qt4Ada_QProcess_setupChildProcess_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QProcess::setupChildProcess();
    }

    bool __Qt4Ada_QProcess_atEnd_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::atEnd();
    }

    bool __Qt4Ada_QProcess_canReadLine_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::canReadLine();
    }

    void __Qt4Ada_QProcess_close_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::close();
    }

    bool __Qt4Ada_QProcess_isSequential_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProcess*>(cpp_object)->QProcess::isSequential();
    }

    void __Qt4Ada_QProcess_aboutToClose_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QIODevice::aboutToClose();
    }

    void __Qt4Ada_QProcess_bytesWritten_0_wrapper(QObject* cpp_object, qint64 bytes)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QIODevice::bytesWritten(bytes);
    }

    void __Qt4Ada_QProcess_readChannelFinished_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QIODevice::readChannelFinished();
    }

    void __Qt4Ada_QProcess_readyRead_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QIODevice::readyRead();
    }

    void __Qt4Ada_QProcess_setErrorString_0_wrapper(QObject* cpp_object, const QString* errorString)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QIODevice::setErrorString(*errorString);
    }

    void __Qt4Ada_QProcess_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QProcess_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QProcess_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProcessDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QProcess_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProcessDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QProcess_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QProcess*>(cpp_this)->QProcess::qt_metacast(name);
    }

    int __Qt4Ada_QProcess_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QProcess*>(cpp_this)->QProcess::qt_metacall(_c, _id, _a);
    }

}

void QProcessDirector::setupChildProcess()
{
    __Qt4Ada_QProcess_setupChildProcess_0_dispatch(this->ada_object);
}

bool QProcessDirector::atEnd() const
{
    return __Qt4Ada_QIODevice_atEnd_0_dispatch(this->ada_object);
}

bool QProcessDirector::canReadLine() const
{
    return __Qt4Ada_QIODevice_canReadLine_0_dispatch(this->ada_object);
}

void QProcessDirector::close()
{
    __Qt4Ada_QIODevice_close_0_dispatch(this->ada_object);
}

bool QProcessDirector::isSequential() const
{
    return __Qt4Ada_QIODevice_isSequential_0_dispatch(this->ada_object);
}

qint64 QProcessDirector::bytesAvailable() const
{
    return __Qt4Ada_QIODevice_bytesAvailable_0_dispatch(this->ada_object);
}

qint64 QProcessDirector::bytesToWrite() const
{
    return __Qt4Ada_QIODevice_bytesToWrite_0_dispatch(this->ada_object);
}

qint64 QProcessDirector::pos() const
{
    return __Qt4Ada_QIODevice_pos_0_dispatch(this->ada_object);
}

bool QProcessDirector::reset()
{
    return __Qt4Ada_QIODevice_reset_0_dispatch(this->ada_object);
}

bool QProcessDirector::seek(qint64 pos)
{
    return __Qt4Ada_QIODevice_seek_0_dispatch(this->ada_object, pos);
}

qint64 QProcessDirector::size() const
{
    return __Qt4Ada_QIODevice_size_0_dispatch(this->ada_object);
}

bool QProcessDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QProcessDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QProcessDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QProcessDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QProcessDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QProcessDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QProcessDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QProcessDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{

    QObject* __Qt4Ada_new_QProcess(QObject* parent)
    {
        return new QProcess(parent);
    }

    bool __Qt4Ada_QProcess_open_wrapper(QObject* self, unsigned mode)
    {
        return dynamic_cast<QProcess*>(self)->QProcess::open(QIODevice::OpenMode(mode));
    }

    void __Qt4Ada_QProcess_setStandardErrorFile_0_wrapper(QObject* cpp_object, const QString* fileName, unsigned mode)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::setStandardErrorFile(*fileName, QIODevice::OpenMode(mode));
    }

    void __Qt4Ada_QProcess_setStandardOutputFile_0_wrapper(QObject* cpp_object, const QString* fileName, unsigned mode)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::setStandardOutputFile(*fileName, QIODevice::OpenMode(mode));
    }

    void __Qt4Ada_QProcess_start_0_wrapper(QObject* cpp_object, const QString* program, const QStringList* arguments, unsigned mode)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::start(*program, *arguments, QIODevice::OpenMode(mode));
    }

    void __Qt4Ada_QProcess_start_1_wrapper(QObject* cpp_object, const QString* program, unsigned mode)
    {
        dynamic_cast<QProcess*>(cpp_object)->QProcess::start(*program, QIODevice::OpenMode(mode));
    }

}
