//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QPROCESSDIRECTOR_H__
#define __QPROCESSDIRECTOR_H__

#include <QProcess>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QProcess_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QProcess_setupChildProcess_0_dispatch(void*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QProcess_closeReadChannel_0_wrapper(QObject*, QProcess::ProcessChannel);
    extern void __Qt4Ada_QProcess_closeWriteChannel_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_environment_0_wrapper(QObject*, QStringList*);
    extern QProcess::ProcessError __Qt4Ada_QProcess_error_1_wrapper(QObject*);
    extern int __Qt4Ada_QProcess_exitCode_0_wrapper(QObject*);
    extern QProcess::ExitStatus __Qt4Ada_QProcess_exitStatus_0_wrapper(QObject*);
    extern QProcess::ProcessChannelMode __Qt4Ada_QProcess_processChannelMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_processEnvironment_0_wrapper(QObject*, QProcessEnvironment*);
    extern void __Qt4Ada_QProcess_readAllStandardError_0_wrapper(QObject*, QByteArray*);
    extern void __Qt4Ada_QProcess_readAllStandardOutput_0_wrapper(QObject*, QByteArray*);
    extern QProcess::ProcessChannel __Qt4Ada_QProcess_readChannel_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_setEnvironment_0_wrapper(QObject*, const QStringList*);
    extern void __Qt4Ada_QProcess_setProcessChannelMode_0_wrapper(QObject*, QProcess::ProcessChannelMode);
    extern void __Qt4Ada_QProcess_setProcessEnvironment_0_wrapper(QObject*, const QProcessEnvironment*);
    extern void __Qt4Ada_QProcess_setReadChannel_0_wrapper(QObject*, QProcess::ProcessChannel);
    extern void __Qt4Ada_QProcess_setStandardInputFile_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QProcess_setStandardOutputProcess_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QProcess_setWorkingDirectory_0_wrapper(QObject*, const QString*);
    extern QProcess::ProcessState __Qt4Ada_QProcess_state_0_wrapper(QObject*);
    extern bool __Qt4Ada_QProcess_waitForFinished_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QProcess_waitForStarted_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QProcess_workingDirectory_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QProcess_kill_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_terminate_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_error_0_wrapper(QObject*, QProcess::ProcessError);
    extern void __Qt4Ada_QProcess_finished_0_wrapper(QObject*, int, QProcess::ExitStatus);
    extern void __Qt4Ada_QProcess_readyReadStandardError_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_readyReadStandardOutput_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_started_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_stateChanged_0_wrapper(QObject*, QProcess::ProcessState);
    extern void __Qt4Ada_QProcess_setProcessState_0_wrapper(QObject*, QProcess::ProcessState);
    extern void __Qt4Ada_QProcess_setupChildProcess_0_wrapper(QObject*);
    extern bool __Qt4Ada_QProcess_atEnd_0_wrapper(QObject*);
    extern bool __Qt4Ada_QProcess_canReadLine_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_close_0_wrapper(QObject*);
    extern bool __Qt4Ada_QProcess_isSequential_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_aboutToClose_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_bytesWritten_0_wrapper(QObject*, qint64);
    extern void __Qt4Ada_QProcess_readChannelFinished_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_readyRead_0_wrapper(QObject*);
    extern void __Qt4Ada_QProcess_setErrorString_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QProcess_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProcess_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProcess_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QProcess_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QProcess_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QProcess_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    //  Wrappers around C++ methods.

    extern QObject* __Qt4Ada_new_QProcess(QObject*);
    extern bool __Qt4Ada_QProcess_open_wrapper(QObject*, unsigned);
    extern void __Qt4Ada_QProcess_setStandardErrorFile_0_wrapper(QObject*, const QString*, unsigned);
    extern void __Qt4Ada_QProcess_setStandardOutputFile_0_wrapper(QObject*, const QString*, unsigned);
    extern void __Qt4Ada_QProcess_start_0_wrapper(QObject*, const QString*, const QStringList*, unsigned);
    extern void __Qt4Ada_QProcess_start_1_wrapper(QObject*, const QString*, unsigned);

}

class QProcessDirector : public QProcess
{
protected:
    void* ada_object;

    virtual void setupChildProcess();
    virtual bool atEnd() const;
    virtual bool canReadLine() const;
    virtual void close();
    virtual bool isSequential() const;
    virtual qint64 bytesAvailable() const;
    virtual qint64 bytesToWrite() const;
    virtual qint64 pos() const;
    virtual bool reset();
    virtual bool seek(qint64);
    virtual qint64 size() const;
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QProcess_error_0_wrapper(QObject*, QProcess::ProcessError);
    friend void __Qt4Ada_QProcess_finished_0_wrapper(QObject*, int, QProcess::ExitStatus);
    friend void __Qt4Ada_QProcess_readyReadStandardError_0_wrapper(QObject*);
    friend void __Qt4Ada_QProcess_readyReadStandardOutput_0_wrapper(QObject*);
    friend void __Qt4Ada_QProcess_started_0_wrapper(QObject*);
    friend void __Qt4Ada_QProcess_stateChanged_0_wrapper(QObject*, QProcess::ProcessState);
    friend void __Qt4Ada_QProcess_setProcessState_0_wrapper(QObject*, QProcess::ProcessState);
    friend void __Qt4Ada_QProcess_setupChildProcess_0_wrapper(QObject*);
    friend void __Qt4Ada_QProcess_aboutToClose_0_wrapper(QObject*);
    friend void __Qt4Ada_QProcess_bytesWritten_0_wrapper(QObject*, qint64);
    friend void __Qt4Ada_QProcess_readChannelFinished_0_wrapper(QObject*);
    friend void __Qt4Ada_QProcess_readyRead_0_wrapper(QObject*);
    friend void __Qt4Ada_QProcess_setErrorString_0_wrapper(QObject*, const QString*);
    friend void __Qt4Ada_QProcess_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProcess_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProcess_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QProcess_sender_0_wrapper(QObject*);
};

#endif // __QPROCESSDIRECTOR_H__
