//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QRect>

extern "C"
{
    extern QRect* __QtAda_inititialize_QRect(void*);
    extern QRect* __QtAda_inititialize_QRect_QPointCR_QPointCR(void*, const QPoint*, const QPoint*);
    extern QRect* __QtAda_inititialize_QRect_QPointCR_QSizeCR(void*, const QPoint*, const QSize*);
    extern QRect* __QtAda_inititialize_QRect_int_int_int_int(void*, int, int, int, int);
    extern QRect* __QtAda_adjust_QRect(void*, const QRect*);
    extern void __QtAda_finalize_QRect(QRect*);
    extern QRect* __Qt4Ada_copy_QRect(const QRect *);

    extern void __QtAda_QRect_adjust_int_int_int_int(QRect*, int, int, int, int);
    extern void __QtAda_QRect_adjusted_int_int_int_int_Q(QRect*, const QRect*, int, int, int, int);
    extern int __QtAda_QRect_bottom_Q(const QRect*);
    extern void __QtAda_QRect_bottomRight_Q(QPoint*, const QRect*);
    extern void __QtAda_QRect_bottomLeft_Q(QPoint*, const QRect*);
    extern void __QtAda_QRect_center_Q(QPoint*, const QRect*);
    extern unsigned __QtAda_QRect_contains_QPointCR_bool_Q(const QRect*, const QPoint*, unsigned);
    extern unsigned __QtAda_QRect_contains_int_int_Q(const QRect*, int, int);
    extern unsigned __QtAda_QRect_contains_int_int_bool_Q(const QRect*, int, int, unsigned);
    extern unsigned __QtAda_QRect_contains_QRectCR_bool_Q(const QRect*, const QRect*, unsigned);
    extern void __QtAda_QRect_getCoords_intP_intP_intP_intP_Q(const QRect*, int*, int*, int*, int*);
    extern void __QtAda_QRect_getRect_intP_intP_intP_intP_Q(const QRect*, int*, int*, int*, int*);
    extern int __QtAda_QRect_height_Q(const QRect*);
    extern void __QtAda_QRect_intersected_QRectCR_Q(QRect*, const QRect*, const QRect*);
    extern unsigned __QtAda_QRect_intersects_QRectCR_Q(const QRect*, const QRect*);
    extern unsigned __QtAda_QRect_isEmpty_Q(const QRect*);
    extern unsigned __QtAda_QRect_isNull_Q(const QRect*);
    extern unsigned __QtAda_QRect_isValid_Q(const QRect*);
    extern int __QtAda_QRect_left_Q(const QRect*);
    extern void __QtAda_QRect_moveBottom_int(QRect*, int);
    extern void __QtAda_QRect_moveBottomLeft_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_moveBottomRight_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_moveCenter_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_moveLeft_int(QRect*, int);
    extern void __QtAda_QRect_moveRight_int(QRect*, int);
    extern void __QtAda_QRect_moveTo_int_int(QRect*, int, int);
    extern void __QtAda_QRect_moveTo_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_moveTop_int(QRect*, int);
    extern void __QtAda_QRect_moveTopLeft_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_moveTopRight_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_normalized_Q(QRect*, const QRect*);
    extern int __QtAda_QRect_right_Q(const QRect*);
    extern void __QtAda_QRect_setBottom_int(QRect*, int);
    extern void __QtAda_QRect_setBottomLeft_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_setBottomRight_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_setCoords_int_int_int_int(QRect*, int, int, int, int);
    extern void __QtAda_QRect_setHeight_int(QRect*, int);
    extern void __QtAda_QRect_setLeft_int(QRect*, int);
    extern void __QtAda_QRect_setRect_int_int_int_int(QRect*, int, int, int, int);
    extern void __QtAda_QRect_setRight_int(QRect*, int);
    extern void __QtAda_QRect_setSize_QSizeCR(QRect*, const QSize*);
    extern void __QtAda_QRect_setTop_int(QRect*, int);
    extern void __QtAda_QRect_setTopLeft_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_setTopRight_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_setWidth_int(QRect*, int);
    extern void __QtAda_QRect_setX_int(QRect*, int);
    extern void __QtAda_QRect_setY_int(QRect*, int);
    extern void __QtAda_QRect_size_Q(QSize*, const QRect*);
    extern int __QtAda_QRect_top_Q(const QRect*);
    extern void __QtAda_QRect_topLeft_Q(QPoint*, const QRect*);
    extern void __QtAda_QRect_topRight_Q(QPoint*, const QRect*);
    extern void __QtAda_QRect_translate_int_int(QRect*, int, int);
    extern void __QtAda_QRect_translate_QPointCR(QRect*, const QPoint*);
    extern void __QtAda_QRect_translated_int_int_Q(QRect*, const QRect*, int, int);
    extern void __QtAda_QRect_translated_QPointCR_Q(QRect*, const QRect*, const QPoint*);
    extern void __QtAda_QRect_united_QRectCR_Q(QRect*, const QRect*, const QRect*);
    extern int __QtAda_QRect_width_Q(const QRect*);
    extern int __QtAda_QRect_x_Q(const QRect*);
    extern int __QtAda_QRect_y_Q(const QRect*);
    extern unsigned __QtAda_eq_QRectCR_QRectCR(const QRect*, const QRect*);

};

