//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include <QStringList>
#include "qregexpwrapper.h"

extern "C"
{

    QRegExp* __QtAda_inititialize_QRegExp(void* storage)
    {
        return new (storage) QRegExp();
    }

    QRegExp* __QtAda_inititialize_QRegExp_QStringCR_CaseSensitivity_PatternSyntax(void* storage, const QString* pattern, unsigned cs, unsigned syntax)
    {
        return new (storage) QRegExp(*pattern, (Qt::CaseSensitivity)cs, (QRegExp::PatternSyntax)syntax);
    }

    QRegExp* __QtAda_adjust_QRegExp(void* storage, const QRegExp* from)
    {
        return new (storage) QRegExp(*from);
    }

    void __QtAda_finalize_QRegExp(QRegExp *item)
    {
        item->~QRegExp();
    }

    void __QtAda_QRegExp_cap_int(QString* returns, QRegExp* self, int nth)
    {
        *returns = self->cap(nth);
    }

    void __QtAda_QRegExp_capturedTexts(QStringList* returns, QRegExp* self)
    {
        *returns = self->capturedTexts();
    }

    unsigned __QtAda_QRegExp_caseSensitivity_Q(const QRegExp* self)
    {
        return (unsigned)self->caseSensitivity();
    }

    void __QtAda_QRegExp_errorString(QString* returns, QRegExp* self)
    {
        *returns = self->errorString();
    }

    unsigned __QtAda_QRegExp_exactMatch_QStringCR_Q(const QRegExp* self, const QString* str)
    {
        return (unsigned)self->exactMatch(*str);
    }

    int __QtAda_QRegExp_indexIn_QStringCR_int_CaretMode_Q(const QRegExp* self, const QString* str, int offset, unsigned caretMode)
    {
        return self->indexIn(*str, offset, (QRegExp::CaretMode)caretMode);
    }

    unsigned __QtAda_QRegExp_isEmpty_Q(const QRegExp* self)
    {
        return (unsigned)self->isEmpty();
    }

    unsigned __QtAda_QRegExp_isMinimal_Q(const QRegExp* self)
    {
        return (unsigned)self->isMinimal();
    }

    unsigned __QtAda_QRegExp_isValid_Q(const QRegExp* self)
    {
        return (unsigned)self->isValid();
    }

    int __QtAda_QRegExp_lastIndexIn_QStringCR_int_CaretMode_Q(const QRegExp* self, const QString* str, int offset, unsigned caretMode)
    {
        return self->lastIndexIn(*str, offset, (QRegExp::CaretMode)caretMode);
    }

    int __QtAda_QRegExp_matchedLength_Q(const QRegExp* self)
    {
        return self->matchedLength();
    }

    int __QtAda_QRegExp_numCaptures_Q(const QRegExp* self)
    {
        return self->numCaptures();
    }

    void __QtAda_QRegExp_pattern_Q(QString* returns, const QRegExp* self)
    {
        *returns = self->pattern();
    }

    unsigned __QtAda_QRegExp_patternSyntax_Q(const QRegExp* self)
    {
        return (unsigned)self->patternSyntax();
    }

    int __QtAda_QRegExp_pos_int(QRegExp* self, int nth)
    {
        return self->pos(nth);
    }

    void __QtAda_QRegExp_setCaseSensitivity_CaseSensitivity(QRegExp* self, unsigned cs)
    {
        self->setCaseSensitivity((Qt::CaseSensitivity)cs);
    }

    void __QtAda_QRegExp_setMinimal_bool(QRegExp* self, unsigned minimal)
    {
        self->setMinimal((bool)minimal);
    }

    void __QtAda_QRegExp_setPattern_QStringCR(QRegExp* self, const QString* pattern)
    {
        self->setPattern(*pattern);
    }

    void __QtAda_QRegExp_setPatternSyntax_PatternSyntaxCR(QRegExp* self, unsigned syntax)
    {
        self->setPatternSyntax((QRegExp::PatternSyntax)syntax);
    }

    void __QtAda_QRegExp_escape_QStringCR_S(QString* returns, const QString* str)
    {
        *returns = QRegExp::escape(*str);
    }

    unsigned __QtAda_QRegExp_eq_QRegExpCR_Q(const QRegExp* self, const QRegExp* rx)
    {
        return (unsigned)self->operator==(*rx);
    }

};

