//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QStringList>
#include <QString>
#include <QVariant>
#include <QChildEvent>
#include <QTimerEvent>

#include "qsettingsdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QSettings_staticMetaObject =
        &QSettings::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QSettings_allKeys_0_wrapper(QObject* cpp_object, QStringList* returns)
    {
        *returns = dynamic_cast<QSettings*>(cpp_object)->QSettings::allKeys();
    }

    void __Qt4Ada_QSettings_applicationName_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QSettings*>(cpp_object)->QSettings::applicationName();
    }

    void __Qt4Ada_QSettings_beginGroup_0_wrapper(QObject* cpp_object, const QString* prefix)
    {
        dynamic_cast<QSettings*>(cpp_object)->QSettings::beginGroup(*prefix);
    }

    int __Qt4Ada_QSettings_beginReadArray_0_wrapper(QObject* cpp_object, const QString* prefix)
    {
        return dynamic_cast<QSettings*>(cpp_object)->QSettings::beginReadArray(*prefix);
    }

    void __Qt4Ada_QSettings_beginWriteArray_0_wrapper(QObject* cpp_object, const QString* prefix, int size)
    {
        dynamic_cast<QSettings*>(cpp_object)->QSettings::beginWriteArray(*prefix, size);
    }

    void __Qt4Ada_QSettings_childGroups_0_wrapper(QObject* cpp_object, QStringList* returns)
    {
        *returns = dynamic_cast<QSettings*>(cpp_object)->QSettings::childGroups();
    }

    void __Qt4Ada_QSettings_childKeys_0_wrapper(QObject* cpp_object, QStringList* returns)
    {
        *returns = dynamic_cast<QSettings*>(cpp_object)->QSettings::childKeys();
    }

    void __Qt4Ada_QSettings_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSettings*>(cpp_object)->QSettings::clear();
    }

    bool __Qt4Ada_QSettings_contains_0_wrapper(QObject* cpp_object, const QString* key)
    {
        return dynamic_cast<QSettings*>(cpp_object)->QSettings::contains(*key);
    }

    void __Qt4Ada_QSettings_endArray_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSettings*>(cpp_object)->QSettings::endArray();
    }

    void __Qt4Ada_QSettings_endGroup_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSettings*>(cpp_object)->QSettings::endGroup();
    }

    bool __Qt4Ada_QSettings_fallbacksEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSettings*>(cpp_object)->QSettings::fallbacksEnabled();
    }

    void __Qt4Ada_QSettings_fileName_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QSettings*>(cpp_object)->QSettings::fileName();
    }

    QSettings::Format __Qt4Ada_QSettings_format_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSettings*>(cpp_object)->QSettings::format();
    }

    void __Qt4Ada_QSettings_group_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QSettings*>(cpp_object)->QSettings::group();
    }

    bool __Qt4Ada_QSettings_isWritable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSettings*>(cpp_object)->QSettings::isWritable();
    }

    void __Qt4Ada_QSettings_organizationName_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QSettings*>(cpp_object)->QSettings::organizationName();
    }

    void __Qt4Ada_QSettings_remove_0_wrapper(QObject* cpp_object, const QString* key)
    {
        dynamic_cast<QSettings*>(cpp_object)->QSettings::remove(*key);
    }

    QSettings::Scope __Qt4Ada_QSettings_scope_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSettings*>(cpp_object)->QSettings::scope();
    }

    void __Qt4Ada_QSettings_setArrayIndex_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QSettings*>(cpp_object)->QSettings::setArrayIndex(index);
    }

    void __Qt4Ada_QSettings_setFallbacksEnabled_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QSettings*>(cpp_object)->QSettings::setFallbacksEnabled(enabled);
    }

    void __Qt4Ada_QSettings_setValue_0_wrapper(QObject* cpp_object, const QString* key, const QVariant* value)
    {
        dynamic_cast<QSettings*>(cpp_object)->QSettings::setValue(*key, *value);
    }

    QSettings::Status __Qt4Ada_QSettings_status_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSettings*>(cpp_object)->QSettings::status();
    }

    void __Qt4Ada_QSettings_sync_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSettings*>(cpp_object)->QSettings::sync();
    }

    void __Qt4Ada_QSettings_value_0_wrapper(QObject* cpp_object, const QString* key, const QVariant* defaultValue, QVariant* returns)
    {
        *returns = dynamic_cast<QSettings*>(cpp_object)->QSettings::value(*key, *defaultValue);
    }

    bool __Qt4Ada_QSettings_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QSettingsDirector*>(cpp_object)->QSettings::event(e);
    }

    void __Qt4Ada_QSettings_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSettingsDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QSettings_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSettingsDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QSettings_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSettingsDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QSettings_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSettingsDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QSettings_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QSettings*>(cpp_this)->QSettings::qt_metacast(name);
    }

    int __Qt4Ada_QSettings_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QSettings*>(cpp_this)->QSettings::qt_metacall(_c, _id, _a);
    }

}

bool QSettingsDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QSettingsDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QSettingsDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QSettingsDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QSettingsDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QSettingsDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QSettingsDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QSettingsDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{

    QSettings::Format __Qt4Ada_QSettings_defaultFormat_wrapper()
    {
        return QSettings::defaultFormat();
    }

    QObject* __QtAda_new_QSettings_QStringCR_QStringCR_QObjectP(const QString* organization, const QString* application, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QSettings(*organization, *application, parent));
    }

    QObject* __QtAda_new_QSettings_QSettingsScope_QStringCR_QStringCR_QObjectP(QSettings::Scope scope, const QString* organization, const QString* application, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QSettings(scope, *organization, *application, parent));
    }

    QObject* __QtAda_new_QSettings_QSettingsFormat_QSettingsScope_QStringCR_QStringCR_QObjectP(QSettings::Format format, QSettings::Scope scope, const QString* organization, const QString* application, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QSettings(format, scope, *organization, *application, parent));
    }

    QObject* __QtAda_new_QSettings_QStringCR_QSettingsFormat_QObjectP(const QString* fileName, QSettings::Format format, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QSettings(*fileName, format, parent));
    }

    QObject* __QtAda_new_QSettings_QObjectP(QObject* parent)
    {
        return dynamic_cast<QObject*>(new QSettings(parent));
    }


}
