//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QSETTINGSDIRECTOR_H__
#define __QSETTINGSDIRECTOR_H__

#include <QSettings>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QSettings_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QSettings_allKeys_0_wrapper(QObject*, QStringList*);
    extern void __Qt4Ada_QSettings_applicationName_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QSettings_beginGroup_0_wrapper(QObject*, const QString*);
    extern int __Qt4Ada_QSettings_beginReadArray_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QSettings_beginWriteArray_0_wrapper(QObject*, const QString*, int);
    extern void __Qt4Ada_QSettings_childGroups_0_wrapper(QObject*, QStringList*);
    extern void __Qt4Ada_QSettings_childKeys_0_wrapper(QObject*, QStringList*);
    extern void __Qt4Ada_QSettings_clear_0_wrapper(QObject*);
    extern bool __Qt4Ada_QSettings_contains_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QSettings_endArray_0_wrapper(QObject*);
    extern void __Qt4Ada_QSettings_endGroup_0_wrapper(QObject*);
    extern bool __Qt4Ada_QSettings_fallbacksEnabled_0_wrapper(QObject*);
    extern void __Qt4Ada_QSettings_fileName_0_wrapper(QObject*, QString*);
    extern QSettings::Format __Qt4Ada_QSettings_format_0_wrapper(QObject*);
    extern void __Qt4Ada_QSettings_group_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QSettings_isWritable_0_wrapper(QObject*);
    extern void __Qt4Ada_QSettings_organizationName_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QSettings_remove_0_wrapper(QObject*, const QString*);
    extern QSettings::Scope __Qt4Ada_QSettings_scope_0_wrapper(QObject*);
    extern void __Qt4Ada_QSettings_setArrayIndex_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSettings_setFallbacksEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QSettings_setValue_0_wrapper(QObject*, const QString*, const QVariant*);
    extern QSettings::Status __Qt4Ada_QSettings_status_0_wrapper(QObject*);
    extern void __Qt4Ada_QSettings_sync_0_wrapper(QObject*);
    extern void __Qt4Ada_QSettings_value_0_wrapper(QObject*, const QString*, const QVariant*, QVariant*);
    extern bool __Qt4Ada_QSettings_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSettings_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSettings_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSettings_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QSettings_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QSettings_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QSettings_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C"
{

    extern QSettings::Format __Qt4Ada_QSettings_defaultFormat_wrapper();

    extern QObject* __QtAda_new_QSettings_QStringCR_QStringCR_QObjectP(const QString*, const QString*, QObject*);
    extern QObject* __QtAda_new_QSettings_QSettingsScope_QStringCR_QStringCR_QObjectP(QSettings::Scope, const QString*, const QString*, QObject*);
    extern QObject* __QtAda_new_QSettings_QSettingsFormat_QSettingsScope_QStringCR_QStringCR_QObjectP(QSettings::Format, QSettings::Scope, const QString*, const QString*, QObject*);
    extern QObject* __QtAda_new_QSettings_QStringCR_QSettingsFormat_QObjectP(const QString*, QSettings::Format, QObject*);
    extern QObject* __QtAda_new_QSettings_QObjectP(QObject*);

}

class QSettingsDirector : public QSettings
{
protected:
    void* ada_object;

    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend bool __Qt4Ada_QSettings_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSettings_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSettings_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSettings_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QSettings_sender_0_wrapper(QObject*);
};

#endif // __QSETTINGSDIRECTOR_H__
