//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QSizeF>

extern "C"
{
    extern QSizeF* __QtAda_inititialize_QSizeF(void*);
    extern QSizeF* __QtAda_inititialize_QSizeF_QSizeCR(void*, const QSize*);
    extern QSizeF* __QtAda_inititialize_QSizeF_qreal_qreal(void*, double, double);
    extern QSizeF* __QtAda_adjust_QSizeF(void*, const QSizeF*);
    extern void __QtAda_finalize_QSizeF(QSizeF*);
    extern QSizeF* __Qt4Ada_copy_QSizeF(const QSizeF*);

    extern void __QtAda_QSizeF_boundedTo_QSizeFCR_Q(QSizeF*, const QSizeF*, const QSizeF*);
    extern void __QtAda_QSizeF_expandedTo_QSizeFCR_Q(QSizeF*, const QSizeF*, const QSizeF*);
    extern double __QtAda_QSizeF_height_Q(const QSizeF*);
    extern unsigned __QtAda_QSizeF_isEmpty_Q(const QSizeF*);
    extern unsigned __QtAda_QSizeF_isNull_Q(const QSizeF*);
    extern unsigned __QtAda_QSizeF_isValid_Q(const QSizeF*);
    extern void __QtAda_QSizeF_scale_qreal_qreal_AspectRatioMode(QSizeF*, double, double, unsigned);
    extern void __QtAda_QSizeF_scale_QSizeFCR_AspectRatioMode(QSizeF*, const QSizeF*, unsigned);
    extern void __QtAda_QSizeF_setHeight_qreal(QSizeF*, double);
    extern void __QtAda_QSizeF_setWidth_qreal(QSizeF*, double);
    extern void __QtAda_QSizeF_toSize_Q(QSize*, const QSizeF*);
    extern void __QtAda_QSizeF_transpose(QSizeF*);
    extern double __QtAda_QSizeF_width_Q(const QSizeF*);
    extern unsigned __QtAda_eq_QSizeFCR_QSizeFCR(const QSizeF*, const QSizeF*);
    extern void __QtAda_plus_QSizeFCR_QSizeFCR(QSizeF*, const QSizeF*, const QSizeF*);
    extern void __QtAda_minus_QSizeFCR_QSizeFCR(QSizeF*, const QSizeF*, const QSizeF*);
    extern void __QtAda_multiplication_QSizeFCR_qreal(QSizeF*, const QSizeF*, double);
    extern void __QtAda_multiplication_qreal_QSizeFCR(QSizeF*, double, const QSizeF*);
    extern void __QtAda_division_QSizeFCR_qreal(QSizeF*, const QSizeF*, double);

};

