//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QSize>
#include <QString>
#include "qsizewrapper.h"
#include <new>

extern "C"
{

    QSize* __QtAda_inititialize_QSize(void* storage)
    {
        return new (storage) QSize();
    }

    QSize* __QtAda_inititialize_QSize_int_int(void* storage, int w, int h)
    {
        return new (storage) QSize(w, h);
    }

    QSize* __QtAda_adjust_QSize(void* storage, const QSize* from)
    {
        return new (storage) QSize(*from);
    }

    void __QtAda_finalize_QSize(QSize *item)
    {
        item->~QSize();
    }

    QSize* __Qt4Ada_copy_QSize (const QSize* cpp_object)
    {
        return new QSize (*cpp_object);
    }

    void __QtAda_QSize_boundedTo_QSizeCR_Q(QSize* returns, const QSize* self, const QSize* otherSize)
    {
        *returns = self->boundedTo(*otherSize);
    }

    void __QtAda_QSize_expandedTo_QSizeCR_Q(QSize* returns, const QSize* self, const QSize* otherSize)
    {
        *returns = self->expandedTo(*otherSize);
    }

    int __QtAda_QSize_height_Q(const QSize* self)
    {
        return self->height();
    }

    unsigned __QtAda_QSize_isEmpty_Q(const QSize* self)
    {
        return (unsigned)self->isEmpty();
    }

    unsigned __QtAda_QSize_isNull_Q(const QSize* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QSize_isValid_Q(const QSize* self)
    {
        return (unsigned)self->isValid();
    }

    void __QtAda_QSize_scale_int_int_AspectRatioMode(QSize* self, int w, int h, unsigned mode)
    {
        self->scale(w, h, (Qt::AspectRatioMode)mode);
    }

    void __QtAda_QSize_scale_QSizeCR_AspectRatioMode(QSize* self, const QSize* s, unsigned mode)
    {
        self->scale(*s, (Qt::AspectRatioMode)mode);
    }

    void __QtAda_QSize_setHeight_int(QSize* self, int h)
    {
        self->setHeight(h);
    }

    void __QtAda_QSize_setWidth_int(QSize* self, int w)
    {
        self->setWidth(w);
    }

    void __QtAda_QSize_transpose(QSize* self)
    {
        self->transpose();
    }

    int __QtAda_QSize_width_Q(const QSize* self)
    {
        return self->width();
    }

    unsigned __QtAda_eq_QSizeCR_QSizeCR(const QSize* s1, const QSize* s2)
    {
        return (unsigned)operator==(*s1, *s2);
    }

    void __QtAda_plus_QSizeCR_QSizeCR(QSize* returns, const QSize* s1, const QSize* s2)
    {
        *returns = operator+(*s1, *s2);
    }

    void __QtAda_minus_QSizeCR_QSizeCR(QSize* returns, const QSize* s1, const QSize* s2)
    {
        *returns = operator-(*s1, *s2);
    }

    void __QtAda_multiplication_QSizeCR_qreal(QSize* returns, const QSize* s, double factor)
    {
        *returns = operator*(*s, (qreal)factor);
    }

    void __QtAda_multiplication_qreal_QSizeCR(QSize* returns, double factor, const QSize* s)
    {
        *returns = operator*((qreal)factor, *s);
    }

    void __QtAda_division_QSizeCR_qreal(QSize* returns, const QSize* s, double factor)
    {
        *returns = operator/(*s, (qreal)factor);
    }

};

