------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Child_Events;
with Qt4.Events;
with Qt4.Timer_Events;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Abstract_Table_Models.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QAbstractTableModel_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QAbstractTableModel_qt_metacast_wrapper");

   procedure index_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Returns : not null access Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, index_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_index_0_wrapper");

   procedure parent_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Child : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Returns : not null access Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, parent_1_wrapper,
                     "__Qt4Ada_QAbstractTableModel_parent_1_wrapper");

   procedure dataChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Top_Left : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Bottom_Right : not null access constant Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, dataChanged_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_dataChanged_0_wrapper");

   procedure headerDataChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Orientation : Qt4.Orientation;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);
   pragma Import (C, headerDataChanged_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_headerDataChanged_0_wrapper");

   procedure layoutAboutToBeChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, layoutAboutToBeChanged_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_layoutAboutToBeChanged_0_wrapper");

   procedure layoutChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, layoutChanged_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_layoutChanged_0_wrapper");

   procedure beginInsertColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);
   pragma Import (C, beginInsertColumns_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_beginInsertColumns_0_wrapper");

   procedure beginInsertRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);
   pragma Import (C, beginInsertRows_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_beginInsertRows_0_wrapper");

   function beginMoveColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Source_Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Destination_Child : Qt4.Q_Integer)
       return Qt4.bool;
   pragma Import (C, beginMoveColumns_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_beginMoveColumns_0_wrapper");

   function beginMoveRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Source_Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Destination_Child : Qt4.Q_Integer)
       return Qt4.bool;
   pragma Import (C, beginMoveRows_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_beginMoveRows_0_wrapper");

   procedure beginRemoveColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);
   pragma Import (C, beginRemoveColumns_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_beginRemoveColumns_0_wrapper");

   procedure beginRemoveRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);
   pragma Import (C, beginRemoveRows_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_beginRemoveRows_0_wrapper");

   procedure beginResetModel_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, beginResetModel_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_beginResetModel_0_wrapper");

   procedure changePersistentIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     From : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     To : not null access constant Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, changePersistentIndex_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_changePersistentIndex_0_wrapper");

   procedure endInsertColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endInsertColumns_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_endInsertColumns_0_wrapper");

   procedure endInsertRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endInsertRows_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_endInsertRows_0_wrapper");

   procedure endMoveColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endMoveColumns_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_endMoveColumns_0_wrapper");

   procedure endMoveRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endMoveRows_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_endMoveRows_0_wrapper");

   procedure endRemoveColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endRemoveColumns_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_endRemoveColumns_0_wrapper");

   procedure endRemoveRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endRemoveRows_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_endRemoveRows_0_wrapper");

   procedure endResetModel_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endResetModel_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_endResetModel_0_wrapper");

   procedure reset_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, reset_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_reset_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_customEvent_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_timerEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QAbstractTableModel_sender_0_wrapper");

   ------------------
   -- Constructors --
   ------------------

   package body Constructors is

      function new_QAbstractTableModelDirector
       (Object : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
        Parent : access Qt_Ada.Internals.Objects.QObject)
          return not null Qt_Ada.Internals.Objects.QObject_Access;
      pragma Import (C,
                     new_QAbstractTableModelDirector,
                     "__Qt4Ada_new_QAbstractTableModelDirector");
      pragma Warnings (Off, new_QAbstractTableModelDirector);

      ----------------
      -- Initialize --
      ----------------

      procedure Initialize
       (Self   : not null access Q_Abstract_Table_Model_Director'Class;
        Parent : access Qt4.Objects.Q_Object'Class := null)
      is
         Director : constant not null Qt_Ada.Internals.Objects.QObject_Access
           := new_QAbstractTableModelDirector
               (Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self),
                Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
                 (Parent));

      begin
         Qt_Ada.Internals.Objects.Initialize (Self, Director);
      end Initialize;

   end Constructors;

   pragma Style_Checks ("N");

   -----------
   -- Index --
   -----------

   overriding
   function Index
    (Self : not null access constant Q_Abstract_Table_Model_Director;
     Row : Qt4.Q_Integer;
     Column : Qt4.Q_Integer;
     Parent : Qt4.Model_Indices.Q_Model_Index
       := Qt4.Model_Indices.Create)
       return Qt4.Model_Indices.Q_Model_Index
   is
      Returns : Qt4.Model_Indices.Q_Model_Index;

   begin
      index_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Row,
        Column,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent),
        Qt4.Model_Indices.Internals.QModelIndex_View (Returns));

      return Returns;
   end Index;

   ------------
   -- Parent --
   ------------

   overriding
   function Parent
    (Self : not null access constant Q_Abstract_Table_Model_Director;
     Child : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
   is
      Returns : Qt4.Model_Indices.Q_Model_Index;

   begin
      parent_1_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Child),
        Qt4.Model_Indices.Internals.QModelIndex_View (Returns));

      return Returns;
   end Parent;

   -----------------------
   -- Emit_Data_Changed --
   -----------------------

   overriding
   procedure Emit_Data_Changed
    (Self : not null access Q_Abstract_Table_Model_Director;
     Top_Left : Qt4.Model_Indices.Q_Model_Index;
     Bottom_Right : Qt4.Model_Indices.Q_Model_Index)
   is
   begin
      dataChanged_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Top_Left),
        Qt4.Model_Indices.Internals.QModelIndex_View (Bottom_Right));
   end Emit_Data_Changed;

   ------------------------------
   -- Emit_Header_Data_Changed --
   ------------------------------

   overriding
   procedure Emit_Header_Data_Changed
    (Self : not null access Q_Abstract_Table_Model_Director;
     Orientation : Qt4.Orientation;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer)
   is
   begin
      headerDataChanged_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Orientation,
        First,
        Last);
   end Emit_Header_Data_Changed;

   -------------------------------------
   -- Emit_Layout_About_To_Be_Changed --
   -------------------------------------

   overriding
   procedure Emit_Layout_About_To_Be_Changed
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      layoutAboutToBeChanged_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end Emit_Layout_About_To_Be_Changed;

   -------------------------
   -- Emit_Layout_Changed --
   -------------------------

   overriding
   procedure Emit_Layout_Changed
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      layoutChanged_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end Emit_Layout_Changed;

   --------------------------
   -- Begin_Insert_Columns --
   --------------------------

   overriding
   procedure Begin_Insert_Columns
    (Self : not null access Q_Abstract_Table_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer)
   is
   begin
      beginInsertColumns_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent),
        First,
        Last);
   end Begin_Insert_Columns;

   -----------------------
   -- Begin_Insert_Rows --
   -----------------------

   overriding
   procedure Begin_Insert_Rows
    (Self : not null access Q_Abstract_Table_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer)
   is
   begin
      beginInsertRows_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent),
        First,
        Last);
   end Begin_Insert_Rows;

   ------------------------
   -- Begin_Move_Columns --
   ------------------------

   overriding
   function Begin_Move_Columns
    (Self : not null access Q_Abstract_Table_Model_Director;
     Source_Parent : Qt4.Model_Indices.Q_Model_Index;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : Qt4.Model_Indices.Q_Model_Index;
     Destination_Child : Qt4.Q_Integer)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (beginMoveColumns_0_wrapper
           (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
            Qt4.Model_Indices.Internals.QModelIndex_View (Source_Parent),
            Source_First,
            Source_Last,
            Qt4.Model_Indices.Internals.QModelIndex_View (Destination_Parent),
            Destination_Child));
   end Begin_Move_Columns;

   ---------------------
   -- Begin_Move_Rows --
   ---------------------

   overriding
   function Begin_Move_Rows
    (Self : not null access Q_Abstract_Table_Model_Director;
     Source_Parent : Qt4.Model_Indices.Q_Model_Index;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : Qt4.Model_Indices.Q_Model_Index;
     Destination_Child : Qt4.Q_Integer)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (beginMoveRows_0_wrapper
           (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
            Qt4.Model_Indices.Internals.QModelIndex_View (Source_Parent),
            Source_First,
            Source_Last,
            Qt4.Model_Indices.Internals.QModelIndex_View (Destination_Parent),
            Destination_Child));
   end Begin_Move_Rows;

   --------------------------
   -- Begin_Remove_Columns --
   --------------------------

   overriding
   procedure Begin_Remove_Columns
    (Self : not null access Q_Abstract_Table_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer)
   is
   begin
      beginRemoveColumns_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent),
        First,
        Last);
   end Begin_Remove_Columns;

   -----------------------
   -- Begin_Remove_Rows --
   -----------------------

   overriding
   procedure Begin_Remove_Rows
    (Self : not null access Q_Abstract_Table_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer)
   is
   begin
      beginRemoveRows_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent),
        First,
        Last);
   end Begin_Remove_Rows;

   -----------------------
   -- Begin_Reset_Model --
   -----------------------

   overriding
   procedure Begin_Reset_Model
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      beginResetModel_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end Begin_Reset_Model;

   -----------------------------
   -- Change_Persistent_Index --
   -----------------------------

   overriding
   procedure Change_Persistent_Index
    (Self : not null access Q_Abstract_Table_Model_Director;
     From : Qt4.Model_Indices.Q_Model_Index;
     To : Qt4.Model_Indices.Q_Model_Index)
   is
   begin
      changePersistentIndex_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (From),
        Qt4.Model_Indices.Internals.QModelIndex_View (To));
   end Change_Persistent_Index;

   ------------------------
   -- End_Insert_Columns --
   ------------------------

   overriding
   procedure End_Insert_Columns
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      endInsertColumns_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end End_Insert_Columns;

   ---------------------
   -- End_Insert_Rows --
   ---------------------

   overriding
   procedure End_Insert_Rows
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      endInsertRows_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end End_Insert_Rows;

   ----------------------
   -- End_Move_Columns --
   ----------------------

   overriding
   procedure End_Move_Columns
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      endMoveColumns_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end End_Move_Columns;

   -------------------
   -- End_Move_Rows --
   -------------------

   overriding
   procedure End_Move_Rows
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      endMoveRows_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end End_Move_Rows;

   ------------------------
   -- End_Remove_Columns --
   ------------------------

   overriding
   procedure End_Remove_Columns
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      endRemoveColumns_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end End_Remove_Columns;

   ---------------------
   -- End_Remove_Rows --
   ---------------------

   overriding
   procedure End_Remove_Rows
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      endRemoveRows_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end End_Remove_Rows;

   ---------------------
   -- End_Reset_Model --
   ---------------------

   overriding
   procedure End_Reset_Model
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      endResetModel_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end End_Reset_Model;

   -----------
   -- Reset --
   -----------

   overriding
   procedure Reset
    (Self : not null access Q_Abstract_Table_Model_Director)
   is
   begin
      reset_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View);
   end Reset;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_Abstract_Table_Model_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_Abstract_Table_Model_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_Abstract_Table_Model_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_Abstract_Table_Model_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_Abstract_Table_Model_Director'Class (Self.all).QObject_View));
   end Sender;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QAbstractTableModel", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.Abstract_Table_Models.Directors;
