------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Events;
with Qt4.Objects;
with Qt4.String_Lists;
with Qt4.Strings;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Core_Applications is

   type Q_Core_Application is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Core_Application_Access is
     access all Q_Core_Application'Class;
   for Q_Core_Application_Access'Storage_Size use 0;

   type Q_Core_Application_Pointer is tagged;

   not overriding
   function Notify
    (Self : not null access Q_Core_Application;
     Receiver : not null access Qt4.Objects.Q_Object'Class;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
         is abstract;

   function Application_Dir_Path return Qt4.Strings.Q_String;

   function Exec return Qt4.Q_Integer;
   pragma Import (C, Exec, "__Qt4Ada_QCoreApplication_exec_wrapper");

   function Arguments return Qt4.String_Lists.Q_String_List;

   function Instance return not null access Q_Core_Application'Class;

   procedure Set_Application_Name (Application : Qt4.Strings.Q_String);

   procedure Set_Application_Version (Version : Qt4.Strings.Q_String);

   procedure Set_Organization_Domain (Org_Domain : Qt4.Strings.Q_String);

   procedure Set_Organization_Name (Org_Name : Qt4.Strings.Q_String);

   package Q_Core_Application_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Core_Application, Q_Core_Application_Access);

   type Q_Core_Application_Pointer is
     new Q_Core_Application_Pointers.Q_Pointer with null record;

private

   procedure Dummy;

end Qt4.Core_Applications;
