------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2011 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);

package body Qt_Ada.Internals.Objects.Mime_Data_Proxies is

   procedure formats_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.String_Lists.Internals.QStringList);
      pragma Import (C, formats_0_virtual,
                     "__Qt4Ada_QMimeData_formats_0_virtual");

   function hasFormat_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mime_Type : not null access constant Qt4.Strings.Internals.QString)
       return Qt4.bool;
      pragma Import (C, hasFormat_0_virtual,
                     "__Qt4Ada_QMimeData_hasFormat_0_virtual");

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;

   pragma Style_Checks ("N");

   -------------
   -- Formats --
   -------------

   function Formats
    (Self : not null access constant Q_Mime_Data_Proxy)
       return Qt4.String_Lists.Q_String_List
   is
      Returns : Qt4.String_Lists.Q_String_List;

   begin
      formats_0_virtual
       (Q_Mime_Data_Proxy'Class (Self.all).QObject_View,
        Qt4.String_Lists.Internals.QStringList_View (Returns));

      return Returns;
   end Formats;

   ----------------
   -- Has_Format --
   ----------------

   function Has_Format
    (Self : not null access constant Q_Mime_Data_Proxy;
     Mime_Type : Qt4.Strings.Q_String)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasFormat_0_virtual
           (Q_Mime_Data_Proxy'Class (Self.all).QObject_View,
            Qt4.Strings.Internals.QString_View (Mime_Type)));
   end Has_Format;

   type Q_Mime_Data_Proxy_Access is
     access all Q_Mime_Data_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access
   is
      Self : constant not null Q_Mime_Data_Proxy_Access
        := new Q_Mime_Data_Proxy;

   begin
      Qt_Ada.Internals.Objects.Initialize (Self, Object);

      return Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Object_Registry.Register_Proxy
    ("QMimeData", Create'Access);
end Qt_Ada.Internals.Objects.Mime_Data_Proxies;
