//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 3134 $ $Date: 2009-02-23 10:44:53 +0300 (Mon, 23 Feb 2009) $
//----------------------------------------------------------------------------
#ifndef __QTADACOREAPPLICATION_H__
#define __QTADACOREAPPLICATION_H__

#include <QCoreApplication>

class QtAdaCoreApplication;

extern "C"
{

    extern int __QtAdaCoreApplication_ada_notify(QtAdaCoreApplication*, QObject*, QEvent*);
    extern int __QtAdaCoreApplication_cpp_notify(QtAdaCoreApplication*, QObject*, QEvent*);
    extern void __QtAda_new_QtAdaCoreApplication();

}

class QtAdaCoreApplication : public QCoreApplication
{
    QtAdaCoreApplication(int&, char**);

    virtual bool notify(QObject*, QEvent*);

    friend void __QtAda_new_QtAdaCoreApplication();
};

#endif // __QTADACOREAPPLICATION_H__
