//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QTimerEvent>
#include <QChildEvent>

#include "qtimerdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QTimer_staticMetaObject =
        &QTimer::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QTimer_isActive_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTimer*>(cpp_object)->QTimer::isActive();
    }

    bool __Qt4Ada_QTimer_isSingleShot_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTimer*>(cpp_object)->QTimer::isSingleShot();
    }

    void __Qt4Ada_QTimer_setSingleShot_0_wrapper(QObject* cpp_object, bool singleShot)
    {
        dynamic_cast<QTimer*>(cpp_object)->QTimer::setSingleShot(singleShot);
    }

    int __Qt4Ada_QTimer_timerId_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTimer*>(cpp_object)->QTimer::timerId();
    }

    void __Qt4Ada_QTimer_start_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTimer*>(cpp_object)->QTimer::start();
    }

    void __Qt4Ada_QTimer_stop_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTimer*>(cpp_object)->QTimer::stop();
    }

    void __Qt4Ada_QTimer_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimerDirector*>(cpp_object)->QTimer::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QTimer_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimerDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QTimer_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimerDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QTimer_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTimerDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QTimer_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QTimer*>(cpp_this)->QTimer::qt_metacast(name);
    }

    int __Qt4Ada_QTimer_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QTimer*>(cpp_this)->QTimer::qt_metacall(_c, _id, _a);
    }

}

void QTimerDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

bool QTimerDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QTimerDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QTimerDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QTimerDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QTimerDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QTimerDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QTimerDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{
    QObject *__Qt4Ada_new_QTimer (QObject* parent)
    {
        return dynamic_cast<QObject *>(new QTimer (parent));
    }

    void __Qt4Ada_QTimer_start_sec_wrapper(QObject* cpp_object, int msec)
    {
        dynamic_cast<QTimer*>(cpp_object)->QTimer::start(msec);
    }
}
