//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include <QTime>
#include "qtimewrapper.h"

extern "C"
{

    QTime* __QtAda_inititialize_QTime(void* storage)
    {
        return new (storage) QTime();
    }

    QTime* __QtAda_inititialize_QTime_int_int_int_int(void* storage, int h, int m, int s, int ms)
    {
        return new (storage) QTime(h, m, s, ms);
    }

    QTime* __QtAda_adjust_QTime(void* storage, const QTime* from)
    {
        return new (storage) QTime(*from);
    }

    void __QtAda_finalize_QTime(QTime *item)
    {
        item->~QTime();
    }

    void __QtAda_QTime_addMSecs_int_Q(QTime* returns, const QTime* self, int ms)
    {
        *returns = self->addMSecs(ms);
    }

    void __QtAda_QTime_addSecs_int_Q(QTime* returns, const QTime* self, int secs)
    {
        *returns = self->addSecs(secs);
    }

    int __QtAda_QTime_elapsed_Q(const QTime* self)
    {
        return self->elapsed();
    }

    int __QtAda_QTime_hour_Q(const QTime* self)
    {
        return self->hour();
    }

    unsigned __QtAda_QTime_isNull_Q(const QTime* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QTime_isValid_Q(const QTime* self)
    {
        return (unsigned)self->isValid();
    }

    int __QtAda_QTime_minute_Q(const QTime* self)
    {
        return self->minute();
    }

    int __QtAda_QTime_msec_Q(const QTime* self)
    {
        return self->msec();
    }

    int __QtAda_QTime_msecsTo_QTimeCR_Q(const QTime* self, const QTime* t)
    {
        return self->msecsTo(*t);
    }

    int __QtAda_QTime_second_Q(const QTime* self)
    {
        return self->second();
    }

    int __QtAda_QTime_secsTo_QTimeCR_Q(const QTime* self, const QTime* t)
    {
        return self->secsTo(*t);
    }

    void __QtAda_QTime_start(QTime* self)
    {
        self->start();
    }

    void __QtAda_QTime_toString_QStringCR_Q(QString* returns, const QTime* self, const QString* format)
    {
        *returns = self->toString(*format);
    }

    void __QtAda_QTime_toString_DateFormat_Q(QString* returns, const QTime* self, unsigned f)
    {
        *returns = self->toString((Qt::DateFormat)f);
    }

    void __QtAda_QTime_currentTime_S(QTime* returns)
    {
        *returns = QTime::currentTime();
    }

    void __QtAda_QTime_fromString_QStringCR_DateFormat_S(QTime* returns, const QString* s, unsigned f)
    {
        *returns = QTime::fromString(*s, (Qt::DateFormat)f);
    }

    void __QtAda_QTime_fromString_QStringCR_QStringCR_S(QTime* returns, const QString* s, const QString* format)
    {
        *returns = QTime::fromString(*s, *format);
    }

    unsigned __QtAda_QTime_isValid_int_int_int_int_S(int h, int m, int s, int ms)
    {
        return (unsigned)QTime::isValid(h, m, s, ms);
    }

    unsigned __QtAda_QTime_eq_QTimeCR_Q(const QTime* self, const QTime* other)
    {
        return (unsigned)self->operator==(*other);
    }

    unsigned __QtAda_QTime_lt_QTimeCR_Q(const QTime* self, const QTime* other)
    {
        return (unsigned)self->operator<(*other);
    }

    unsigned __QtAda_QTime_le_QTimeCR_Q(const QTime* self, const QTime* other)
    {
        return (unsigned)self->operator<=(*other);
    }

    unsigned __QtAda_QTime_gt_QTimeCR_Q(const QTime* self, const QTime* other)
    {
        return (unsigned)self->operator>(*other);
    }

    unsigned __QtAda_QTime_ge_QTimeCR_Q(const QTime* self, const QTime* other)
    {
        return (unsigned)self->operator>=(*other);
    }

};

