//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QUrl>

extern "C"
{
    extern QUrl* __QtAda_inititialize_QUrl(void*);
    extern QUrl* __QtAda_inititialize_QUrl_QStringCR(void*, const QString*);
    extern QUrl* __QtAda_inititialize_QUrl_QStringCR_ParsingMode(void*, const QString*, unsigned);
    extern QUrl* __QtAda_adjust_QUrl(void*, const QUrl*);
    extern void __QtAda_finalize_QUrl(QUrl*);

    extern void __QtAda_QUrl_addEncodedQueryItem_QByteArrayCR_QByteArrayCR(QUrl*, const QByteArray*, const QByteArray*);
    extern void __QtAda_QUrl_addQueryItem_QStringCR_QStringCR(QUrl*, const QString*, const QString*);
    extern void __QtAda_QUrl_allQueryItemValues_QStringCR_Q(QStringList*, const QUrl*, const QString*);
    extern void __QtAda_QUrl_authority_Q(QString*, const QUrl*);
    extern void __QtAda_QUrl_clear(QUrl*);
    extern void __QtAda_QUrl_encodedFragment_Q(QByteArray*, const QUrl*);
    extern void __QtAda_QUrl_encodedHost_Q(QByteArray*, const QUrl*);
    extern void __QtAda_QUrl_encodedPassword_Q(QByteArray*, const QUrl*);
    extern void __QtAda_QUrl_encodedPath_Q(QByteArray*, const QUrl*);
    extern void __QtAda_QUrl_encodedQuery_Q(QByteArray*, const QUrl*);
    extern void __QtAda_QUrl_encodedQueryItemValue_QByteArrayCR_Q(QByteArray*, const QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_encodedUserName_Q(QByteArray*, const QUrl*);
    extern void __QtAda_QUrl_errorString_Q(QString*, const QUrl*);
    extern void __QtAda_QUrl_fragment_Q(QString*, const QUrl*);
    extern unsigned __QtAda_QUrl_hasEncodedQueryItem_QByteArrayCR_Q(const QUrl*, const QByteArray*);
    extern unsigned __QtAda_QUrl_hasFragment_Q(const QUrl*);
    extern unsigned __QtAda_QUrl_hasQuery_Q(const QUrl*);
    extern unsigned __QtAda_QUrl_hasQueryItem_QStringCR_Q(const QUrl*, const QString*);
    extern void __QtAda_QUrl_host_Q(QString*, const QUrl*);
    extern unsigned __QtAda_QUrl_isEmpty_Q(const QUrl*);
    extern unsigned __QtAda_QUrl_isParentOf_QUrlCR_Q(const QUrl*, const QUrl*);
    extern unsigned __QtAda_QUrl_isRelative_Q(const QUrl*);
    extern unsigned __QtAda_QUrl_isValid_Q(const QUrl*);
    extern void __QtAda_QUrl_password_Q(QString*, const QUrl*);
    extern void __QtAda_QUrl_path_Q(QString*, const QUrl*);
    extern int __QtAda_QUrl_port_Q(const QUrl*);
    extern int __QtAda_QUrl_port_int_Q(const QUrl*, int);
    extern void __QtAda_QUrl_queryItemValue_QStringCR_Q(QString*, const QUrl*, const QString*);
    extern void __QtAda_QUrl_removeAllEncodedQueryItems_QByteArrayCR(QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_removeAllQueryItems_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_removeEncodedQueryItem_QByteArrayCR(QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_removeQueryItem_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_resolved_QUrlCR_Q(QUrl*, const QUrl*, const QUrl*);
    extern void __QtAda_QUrl_scheme_Q(QString*, const QUrl*);
    extern void __QtAda_QUrl_setAuthority_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_setEncodedFragment_QByteArrayCR(QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_setEncodedHost_QByteArrayCR(QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_setEncodedPassword_QByteArrayCR(QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_setEncodedPath_QByteArrayCR(QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_setEncodedQuery_QByteArrayCR(QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_setEncodedUrl_QByteArrayCR(QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_setEncodedUrl_QByteArrayCR_ParsingMode(QUrl*, const QByteArray*, unsigned);
    extern void __QtAda_QUrl_setEncodedUserName_QByteArrayCR(QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_setFragment_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_setHost_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_setPassword_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_setPath_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_setPort_int(QUrl*, int);
    extern void __QtAda_QUrl_setScheme_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_setUrl_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_setUrl_QStringCR_ParsingMode(QUrl*, const QString*, unsigned);
    extern void __QtAda_QUrl_setUserInfo_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_setUserName_QStringCR(QUrl*, const QString*);
    extern void __QtAda_QUrl_toLocalFile_Q(QString*, const QUrl*);
    extern void __QtAda_QUrl_userInfo_Q(QString*, const QUrl*);
    extern void __QtAda_QUrl_userName_Q(QString*, const QUrl*);
    extern unsigned __QtAda_QUrl_eq_QUrlCR_Q(const QUrl*, const QUrl*);
    extern void __QtAda_QUrl_fromAce_QByteArrayCR_S(QString*, const QByteArray*);
    extern void __QtAda_QUrl_fromEncoded_QByteArrayCR_S(QUrl*, const QByteArray*);
    extern void __QtAda_QUrl_fromEncoded_QByteArrayCR_ParsingMode_S(QUrl*, const QByteArray*, unsigned);
    extern void __QtAda_QUrl_fromLocalFile_QStringCR_S(QUrl*, const QString*);
    extern void __QtAda_QUrl_fromPercentEncoding_QByteArrayCR_S(QString*, const QByteArray*);
    extern void __QtAda_QUrl_idnWhitelist_S(QStringList*);
    extern void __QtAda_QUrl_setIdnWhitelist_QStringListCR_S(const QStringList*);
    extern void __QtAda_QUrl_toAce_QStringCR_S(QByteArray*, const QString*);
    extern void __QtAda_QUrl_toPercentEncoding_QStringCR_QByteArrayCR_QByteArrayCR_S(QByteArray*, const QString*, const QByteArray*, const QByteArray*);

};

