//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QChar>
#include <QDate>
#include <QDateTime>
#include <QLine>
#include <QLineF>
#include <QPoint>
#include <QPointF>
#include <QRect>
#include <QRectF>
#include <QRegExp>
#include <QSize>
#include <QSizeF>
#include <QString>
#include <QTime>
#include "qvariantwrapper.h"

extern "C"
{

    QVariant* __Qt4Ada_copy_QVariant(const QVariant* cpp_object)
    {
        return new QVariant(*cpp_object);
    }

    void __Qt4Ada_assing_QVariant(QVariant* s1, const QVariant* s2)
    {
        *s1 = *s2;
    }

    QVariant* __QtAda_inititialize_QVariant(void* storage)
    {
        return new (storage) QVariant();
    }

    QVariant* __QtAda_inititialize_QVariant_Type(void* storage, unsigned type)
    {
        return new (storage) QVariant((QVariant::Type)type);
    }

    QVariant* __QtAda_inititialize_QVariant_unsigned_voidCP(void* storage, unsigned type, const void* copy)
    {
        return new (storage) QVariant((int)type, copy);
    }

    QVariant* __QtAda_inititialize_QVariant_int(void* storage, int i)
    {
        return new (storage) QVariant(i);
    }

    QVariant* __QtAda_inititialize_QVariant_bool(void* storage, unsigned b)
    {
        return new (storage) QVariant((bool)b);
    }

    QVariant* __QtAda_inititialize_QVariant_double(void* storage, double d)
    {
        return new (storage) QVariant(d);
    }

    QVariant* __QtAda_inititialize_QVariant_QStringCR(void* storage, const QString* string)
    {
        return new (storage) QVariant(*string);
    }

    QVariant* __QtAda_inititialize_QVariant_QCharCR(void* storage, const QChar* qchar)
    {
        return new (storage) QVariant(*qchar);
    }

    QVariant* __QtAda_inititialize_QVariant_QDateCR(void* storage, const QDate* date)
    {
        return new (storage) QVariant(*date);
    }

    QVariant* __QtAda_inititialize_QVariant_QTimeCR(void* storage, const QTime* time)
    {
        return new (storage) QVariant(*time);
    }

    QVariant* __QtAda_inititialize_QVariant_QDateTimeCR(void* storage, const QDateTime* datetime)
    {
        return new (storage) QVariant(*datetime);
    }

    QVariant* __QtAda_inititialize_QVariant_QSizeCR(void* storage, const QSize* size)
    {
        return new (storage) QVariant(*size);
    }

    QVariant* __QtAda_inititialize_QVariant_QSizeFCR(void* storage, const QSizeF* size)
    {
        return new (storage) QVariant(*size);
    }

    QVariant* __QtAda_inititialize_QVariant_QPointCR(void* storage, const QPoint* pt)
    {
        return new (storage) QVariant(*pt);
    }

    QVariant* __QtAda_inititialize_QVariant_QPointFCR(void* storage, const QPointF* pt)
    {
        return new (storage) QVariant(*pt);
    }

    QVariant* __QtAda_inititialize_QVariant_QLineCR(void* storage, const QLine* line)
    {
        return new (storage) QVariant(*line);
    }

    QVariant* __QtAda_inititialize_QVariant_QLineFCR(void* storage, const QLineF* line)
    {
        return new (storage) QVariant(*line);
    }

    QVariant* __QtAda_inititialize_QVariant_QRectCR(void* storage, const QRect* rect)
    {
        return new (storage) QVariant(*rect);
    }

    QVariant* __QtAda_inititialize_QVariant_QRectFCR(void* storage, const QRectF* rect)
    {
        return new (storage) QVariant(*rect);
    }

    QVariant* __QtAda_inititialize_QVariant_QRegExpCR(void* storage, const QRegExp* regExp)
    {
        return new (storage) QVariant(*regExp);
    }

    QVariant* __QtAda_inititialize_QVariant_GlobalColor(void* storage, unsigned color)
    {
        return new (storage) QVariant((Qt::GlobalColor)color);
    }

    QVariant* __QtAda_adjust_QVariant(void* storage, const QVariant* from)
    {
        return new (storage) QVariant(*from);
    }

    void __QtAda_finalize_QVariant(QVariant *item)
    {
        item->~QVariant();
    }

    unsigned __QtAda_QVariant_canConvert_Type_Q(const QVariant* self, unsigned t)
    {
        return (unsigned)self->canConvert((QVariant::Type)t);
    }

    void __QtAda_QVariant_clear(QVariant* self)
    {
        self->clear();
    }

    unsigned __QtAda_QVariant_isNull_Q(const QVariant* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QVariant_isValid_Q(const QVariant* self)
    {
        return (unsigned)self->isValid();
    }

    unsigned __QtAda_QVariant_toBool_Q(const QVariant* self)
    {
        return (unsigned)self->toBool();
    }

    double __QtAda_QVariant_toDouble_bool_Q(const QVariant* self, unsigned *ok)
    {
        bool aux;
	double result = (double)self->toDouble(&aux);
        *ok = (unsigned)aux;
	return result;
    }

    int __QtAda_QVariant_toInt_bool_Q(const QVariant* self, unsigned *ok)
    {
        bool aux;
	int result = (int)self->toInt(&aux);
        *ok = (unsigned)aux;
	return result;
    }

    void __QtAda_QVariant_toChar_Q(QChar* returns, const QVariant* self)
    {
        *returns = self->toChar();
    }

    void __QtAda_QVariant_toDate_Q(QDate* returns, const QVariant* self)
    {
        *returns = self->toDate();
    }

    void __QtAda_QVariant_toTime_Q(QTime* returns, const QVariant* self)
    {
        *returns = self->toTime();
    }

    void __QtAda_QVariant_toDateTime_Q(QDateTime* returns, const QVariant* self)
    {
        *returns = self->toDateTime();
    }

    void __QtAda_QVariant_toLine_Q(QLine* returns, const QVariant* self)
    {
        *returns = self->toLine();
    }

    void __QtAda_QVariant_toLineF_Q(QLineF* returns, const QVariant* self)
    {
        *returns = self->toLineF();
    }

    void __QtAda_QVariant_toPoint_Q(QPoint* returns, const QVariant* self)
    {
        *returns = self->toPoint();
    }

    void __QtAda_QVariant_toPointF_Q(QPointF* returns, const QVariant* self)
    {
        *returns = self->toPointF();
    }

    void __QtAda_QVariant_toRect_Q(QRect* returns, const QVariant* self)
    {
        *returns = self->toRect();
    }

    void __QtAda_QVariant_toRectF_Q(QRectF* returns, const QVariant* self)
    {
        *returns = self->toRectF();
    }

    void __QtAda_QVariant_toSize_Q(QSize* returns, const QVariant* self)
    {
        *returns = self->toSize();
    }

    void __QtAda_QVariant_toSizeF_Q(QSizeF* returns, const QVariant* self)
    {
        *returns = self->toSizeF();
    }

    void __QtAda_QVariant_toString_Q(QString* returns, const QVariant* self)
    {
        *returns = self->toString();
    }

    void __QtAda_QVariant_toRegExp_Q(QRegExp* returns, const QVariant* self)
    {
        *returns = self->toRegExp();
    }

    unsigned __QtAda_QVariant_type(QVariant* self)
    {
        return (unsigned)self->type();
    }

    unsigned __QtAda_QVariant_userType(QVariant* self)
    {
        return (unsigned)self->userType();
    }

    unsigned __QtAda_QVariant_eq_QVariantCR_Q(const QVariant* self, const QVariant* v)
    {
        return (unsigned)self->operator==(*v);
    }

    const void* __QtAda_QVariant_constData_Q(const QVariant* self)
    {
        return self->constData();
    }

    void __QtAda_registerMetaType_QVariant()
    {
        qRegisterMetaType<QVariant>("QVariant");
    }

};

