//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007  Vadim Godunko <vgodunko@gmail.com>                     //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QVariant>

extern "C"
{
    extern QVariant* __Qt4Ada_copy_QVariant(const QVariant*);
    extern void      __Qt4Ada_assing_QVariant (QVariant*, const QVariant*);

    extern QVariant* __QtAda_inititialize_QVariant(void*);
    extern QVariant* __QtAda_inititialize_QVariant_Type(void*, unsigned);
    extern QVariant* __QtAda_inititialize_QVariant_unsigned_voidCP(void*, unsigned, const void*);
    extern QVariant* __QtAda_inititialize_QVariant_int(void*, int);
    extern QVariant* __QtAda_inititialize_QVariant_bool(void*, unsigned);
    extern QVariant* __QtAda_inititialize_QVariant_double(void*, double);
    extern QVariant* __QtAda_inititialize_QVariant_QStringCR(void*, const QString*);
    extern QVariant* __QtAda_inititialize_QVariant_QCharCR(void*, const QChar*);
    extern QVariant* __QtAda_inititialize_QVariant_QDateCR(void*, const QDate*);
    extern QVariant* __QtAda_inititialize_QVariant_QTimeCR(void*, const QTime*);
    extern QVariant* __QtAda_inititialize_QVariant_QDateTimeCR(void*, const QDateTime*);
    extern QVariant* __QtAda_inititialize_QVariant_QSizeCR(void*, const QSize*);
    extern QVariant* __QtAda_inititialize_QVariant_QSizeFCR(void*, const QSizeF*);
    extern QVariant* __QtAda_inititialize_QVariant_QPointCR(void*, const QPoint*);
    extern QVariant* __QtAda_inititialize_QVariant_QPointFCR(void*, const QPointF*);
    extern QVariant* __QtAda_inititialize_QVariant_QLineCR(void*, const QLine*);
    extern QVariant* __QtAda_inititialize_QVariant_QLineFCR(void*, const QLineF*);
    extern QVariant* __QtAda_inititialize_QVariant_QRectCR(void*, const QRect*);
    extern QVariant* __QtAda_inititialize_QVariant_QRectFCR(void*, const QRectF*);
    extern QVariant* __QtAda_inititialize_QVariant_QRegExpCR(void*, const QRegExp*);
    extern QVariant* __QtAda_inititialize_QVariant_GlobalColor(void*, unsigned);
    extern QVariant* __QtAda_adjust_QVariant(void*, const QVariant*);
    extern void __QtAda_finalize_QVariant(QVariant*);

    extern unsigned __QtAda_QVariant_canConvert_Type_Q(const QVariant*, unsigned);
    extern void __QtAda_QVariant_clear(QVariant*);
    extern unsigned __QtAda_QVariant_isNull_Q(const QVariant*);
    extern unsigned __QtAda_QVariant_isValid_Q(const QVariant*);
    extern unsigned __QtAda_QVariant_toBool_Q(const QVariant*);
    extern double __QtAda_QVariant_toDouble_bool_Q(const QVariant* self, unsigned *ok);
    extern int __QtAda_QVariant_toInt_bool_Q(const QVariant* self, unsigned *ok);
    extern void __QtAda_QVariant_toChar_Q(QChar*, const QVariant*);
    extern void __QtAda_QVariant_toDate_Q(QDate*, const QVariant*);
    extern void __QtAda_QVariant_toTime_Q(QTime*, const QVariant*);
    extern void __QtAda_QVariant_toDateTime_Q(QDateTime*, const QVariant*);
    extern void __QtAda_QVariant_toLine_Q(QLine*, const QVariant*);
    extern void __QtAda_QVariant_toLineF_Q(QLineF*, const QVariant*);
    extern void __QtAda_QVariant_toPoint_Q(QPoint*, const QVariant*);
    extern void __QtAda_QVariant_toPointF_Q(QPointF*, const QVariant*);
    extern void __QtAda_QVariant_toRect_Q(QRect*, const QVariant*);
    extern void __QtAda_QVariant_toRectF_Q(QRectF*, const QVariant*);
    extern void __QtAda_QVariant_toSize_Q(QSize*, const QVariant*);
    extern void __QtAda_QVariant_toSizeF_Q(QSizeF*, const QVariant*);
    extern void __QtAda_QVariant_toString_Q(QString*, const QVariant*);
    extern void __QtAda_QVariant_toRegExp_Q(QRegExp*, const QVariant*);
    extern unsigned __QtAda_QVariant_type(QVariant*);
    extern unsigned __QtAda_QVariant_userType(QVariant*);
    extern unsigned __QtAda_QVariant_eq_QVariantCR_Q(const QVariant*, const QVariant*);
    extern const void* __QtAda_QVariant_constData_Q(const QVariant*);

    extern void __QtAda_registerMetaType_QVariant();

};

