//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2012 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QIcon>
#include <QSize>
#include <QString>
#include <QFocusEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QTimerEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>

#include "qabstractbuttondirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractButton_staticMetaObject =
        &QAbstractButton::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QAbstractButton_autoExclusive_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::autoExclusive();
    }

    bool __Qt4Ada_QAbstractButton_autoRepeat_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::autoRepeat();
    }

    void __Qt4Ada_QAbstractButton_icon_0_wrapper(QObject* cpp_object, QIcon* returns)
    {
        *returns = dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::icon();
    }

    void __Qt4Ada_QAbstractButton_iconSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::iconSize();
    }

    bool __Qt4Ada_QAbstractButton_isCheckable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::isCheckable();
    }

    bool __Qt4Ada_QAbstractButton_isChecked_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::isChecked();
    }

    bool __Qt4Ada_QAbstractButton_isDown_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::isDown();
    }

    void __Qt4Ada_QAbstractButton_setAutoExclusive_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::setAutoExclusive(enabled);
    }

    void __Qt4Ada_QAbstractButton_setAutoRepeat_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::setAutoRepeat(enabled);
    }

    void __Qt4Ada_QAbstractButton_setCheckable_0_wrapper(QObject* cpp_object, bool checkable)
    {
        dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::setCheckable(checkable);
    }

    void __Qt4Ada_QAbstractButton_setDown_0_wrapper(QObject* cpp_object, bool pressed)
    {
        dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::setDown(pressed);
    }

    void __Qt4Ada_QAbstractButton_setIcon_0_wrapper(QObject* cpp_object, const QIcon* icon)
    {
        dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::setIcon(*icon);
    }

    void __Qt4Ada_QAbstractButton_setText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::setText(*text);
    }

    void __Qt4Ada_QAbstractButton_text_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::text();
    }

    void __Qt4Ada_QAbstractButton_click_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::click();
    }

    void __Qt4Ada_QAbstractButton_setChecked_0_wrapper(QObject* cpp_object, bool checked)
    {
        dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::setChecked(checked);
    }

    void __Qt4Ada_QAbstractButton_setIconSize_0_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::setIconSize(*size);
    }

    void __Qt4Ada_QAbstractButton_toggle_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractButton*>(cpp_object)->QAbstractButton::toggle();
    }

    void __Qt4Ada_QAbstractButton_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::changeEvent(event);
    }

    void __Qt4Ada_QAbstractButton_checkStateSet_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::checkStateSet();
    }

    bool __Qt4Ada_QAbstractButton_hitButton_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        return dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::hitButton(*pos);
    }

    bool __Qt4Ada_QAbstractButton_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::event(e);
    }

    void __Qt4Ada_QAbstractButton_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_nextCheckState_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::nextCheckState();
    }

    void __Qt4Ada_QAbstractButton_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QAbstractButton::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QAbstractButton_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QAbstractButton_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QAbstractButton_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QAbstractButton_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QAbstractButton_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QAbstractButton_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QAbstractButton_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QAbstractButton_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QAbstractButton_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractButton_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QAbstractButton_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractButtonDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractButton_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractButton*>(cpp_this)->QAbstractButton::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractButton_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractButton*>(cpp_this)->QAbstractButton::qt_metacall(_c, _id, _a);
    }

}

void QAbstractButtonDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::checkStateSet()
{
    __Qt4Ada_QAbstractButton_checkStateSet_0_dispatch(this->ada_object);
}

bool QAbstractButtonDirector::hitButton(const QPoint& pos) const
{
    return __Qt4Ada_QAbstractButton_hitButton_0_dispatch(this->ada_object, &pos);
}

bool QAbstractButtonDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QAbstractButtonDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::nextCheckState()
{
    __Qt4Ada_QAbstractButton_nextCheckState_0_dispatch(this->ada_object);
}

void QAbstractButtonDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

int QAbstractButtonDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QAbstractButtonDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QAbstractButtonDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QAbstractButtonDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractButtonDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QAbstractButtonDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractButtonDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QAbstractButtonDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QAbstractButtonDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QAbstractButtonDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractButtonDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractButtonDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractButtonDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractButtonDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractButtonDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QPaintEngine*QAbstractButtonDirector::paintEngine()
{
    return __Qt4Ada_QPaintDevice_paintEngine_dispatch(this->ada_object);
}

void QAbstractButtonDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QAbstractButtonDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    bool __Qt4Ada_QAbstractButton_eventFilter_wrapper(QObject*cpp_this,QObject*_p1,QEvent*_p2)
    {
        return (dynamic_cast<QAbstractButton*>(cpp_this))->QAbstractButton::eventFilter(_p1,_p2);
    }

    void __Qt4Ada_QAbstractButton_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QAbstractButtonDirector*>(cpp_this))->QAbstractButton::connectNotify(_p1);
    }

    void __Qt4Ada_QAbstractButton_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QAbstractButtonDirector*>(cpp_this))->QAbstractButton::disconnectNotify(_p1);
    }

}
