//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2012 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QABSTRACTBUTTONDIRECTOR_H__
#define __QABSTRACTBUTTONDIRECTOR_H__

#include <QAbstractButton>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QAbstractButton_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QAbstractButton_checkStateSet_0_dispatch(void*);
    extern bool __Qt4Ada_QAbstractButton_hitButton_0_dispatch(void*, const QPoint*);
    extern void __Qt4Ada_QAbstractButton_nextCheckState_0_dispatch(void*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QAbstractButton_autoExclusive_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractButton_autoRepeat_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractButton_icon_0_wrapper(QObject*, QIcon*);
    extern void __Qt4Ada_QAbstractButton_iconSize_0_wrapper(QObject*, QSize*);
    extern bool __Qt4Ada_QAbstractButton_isCheckable_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractButton_isChecked_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractButton_isDown_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractButton_setAutoExclusive_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractButton_setAutoRepeat_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractButton_setCheckable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractButton_setDown_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractButton_setIcon_0_wrapper(QObject*, const QIcon*);
    extern void __Qt4Ada_QAbstractButton_setText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QAbstractButton_text_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QAbstractButton_click_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractButton_setChecked_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractButton_setIconSize_0_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QAbstractButton_toggle_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractButton_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_checkStateSet_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractButton_hitButton_0_wrapper(QObject*, const QPoint*);
    extern bool __Qt4Ada_QAbstractButton_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_nextCheckState_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractButton_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QAbstractButton_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractButton_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractButton_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QAbstractButton_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractButton_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractButton_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QAbstractButton_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QAbstractButton_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractButton_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QAbstractButton_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QAbstractButton_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QAbstractButton_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    //  Declarations of wrapper functions for static call

    extern void __Qt4Ada_QAbstractButton_connectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QAbstractButton_disconnectNotify_wrapper(QObject*,const char*);

}

class QAbstractButtonDirector : public QAbstractButton
{
protected:
    void* ada_object;
    QAbstractButtonDirector();

    virtual QPaintEngine*paintEngine();
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

    friend void __Qt4Ada_QAbstractButton_connectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QAbstractButton_disconnectNotify_wrapper(QObject*,const char*);

    virtual void changeEvent(QEvent*);
    virtual void checkStateSet();
    virtual bool hitButton(const QPoint&) const;
    virtual bool event(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void nextCheckState();
    virtual void paintEvent(QPaintEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QAbstractButton_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_checkStateSet_0_wrapper(QObject*);
    friend bool __Qt4Ada_QAbstractButton_hitButton_0_wrapper(QObject*, const QPoint*);
    friend bool __Qt4Ada_QAbstractButton_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_nextCheckState_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractButton_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QAbstractButton_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractButton_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QAbstractButton_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QAbstractButton_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractButton_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractButton_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QAbstractButton_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QAbstractButton_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractButton_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QAbstractButton_sender_0_wrapper(QObject*);
};

#endif // __QABSTRACTBUTTONDIRECTOR_H__
