//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QStyleOptionViewItem>
#include <QAbstractItemModel>
#include <QSize>
#include <QChildEvent>
#include <QTimerEvent>

#include "qabstractitemdelegatedirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractItemDelegate_staticMetaObject =
        &QAbstractItemDelegate::staticMetaObject;
}

extern "C"
{

    QObject* __Qt4Ada_QAbstractItemDelegate_createEditor_0_virtual(QObject* cpp_object, QObject* parent, const QStyleOption* option, const QModelIndex* index)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemDelegate*>(cpp_object)->createEditor(dynamic_cast<QWidget*>(parent), static_cast<const QStyleOptionViewItem&>(*option), *index));
    }

    bool __Qt4Ada_QAbstractItemDelegate_editorEvent_0_virtual(QObject* cpp_object, QEvent* event, QObject* model, const QStyleOption* option, const QModelIndex* index)
    {
        return dynamic_cast<QAbstractItemDelegate*>(cpp_object)->editorEvent(event, dynamic_cast<QAbstractItemModel*>(model), static_cast<const QStyleOptionViewItem&>(*option), *index);
    }

    void __Qt4Ada_QAbstractItemDelegate_setEditorData_0_virtual(QObject* cpp_object, QObject* editor, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemDelegate*>(cpp_object)->setEditorData(dynamic_cast<QWidget*>(editor), *index);
    }

    void __Qt4Ada_QAbstractItemDelegate_setModelData_0_virtual(QObject* cpp_object, QObject* editor, QObject* model, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemDelegate*>(cpp_object)->setModelData(dynamic_cast<QWidget*>(editor), dynamic_cast<QAbstractItemModel*>(model), *index);
    }

    void __Qt4Ada_QAbstractItemDelegate_sizeHint_0_virtual(QObject* cpp_object, const QStyleOption* option, const QModelIndex* index, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractItemDelegate*>(cpp_object)->sizeHint(static_cast<const QStyleOptionViewItem&>(*option), *index);
    }

    void __Qt4Ada_QAbstractItemDelegate_updateEditorGeometry_0_virtual(QObject* cpp_object, QObject* editor, const QStyleOption* option, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemDelegate*>(cpp_object)->updateEditorGeometry(dynamic_cast<QWidget*>(editor), static_cast<const QStyleOptionViewItem&>(*option), *index);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    QObject* __Qt4Ada_QAbstractItemDelegate_createEditor_0_wrapper(QObject* cpp_object, QObject* parent, const QStyleOption* option, const QModelIndex* index)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemDelegate*>(cpp_object)->QAbstractItemDelegate::createEditor(dynamic_cast<QWidget*>(parent), static_cast<const QStyleOptionViewItem&>(*option), *index));
    }

    bool __Qt4Ada_QAbstractItemDelegate_editorEvent_0_wrapper(QObject* cpp_object, QEvent* event, QObject* model, const QStyleOption* option, const QModelIndex* index)
    {
        return dynamic_cast<QAbstractItemDelegate*>(cpp_object)->QAbstractItemDelegate::editorEvent(event, dynamic_cast<QAbstractItemModel*>(model), static_cast<const QStyleOptionViewItem&>(*option), *index);
    }

    void __Qt4Ada_QAbstractItemDelegate_setEditorData_0_wrapper(QObject* cpp_object, QObject* editor, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemDelegate*>(cpp_object)->QAbstractItemDelegate::setEditorData(dynamic_cast<QWidget*>(editor), *index);
    }

    void __Qt4Ada_QAbstractItemDelegate_setModelData_0_wrapper(QObject* cpp_object, QObject* editor, QObject* model, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemDelegate*>(cpp_object)->QAbstractItemDelegate::setModelData(dynamic_cast<QWidget*>(editor), dynamic_cast<QAbstractItemModel*>(model), *index);
    }

    void __Qt4Ada_QAbstractItemDelegate_updateEditorGeometry_0_wrapper(QObject* cpp_object, QObject* editor, const QStyleOption* option, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemDelegate*>(cpp_object)->QAbstractItemDelegate::updateEditorGeometry(dynamic_cast<QWidget*>(editor), static_cast<const QStyleOptionViewItem&>(*option), *index);
    }

    void __Qt4Ada_QAbstractItemDelegate_commitData_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QAbstractItemDelegateDirector*>(cpp_object)->QAbstractItemDelegate::commitData(dynamic_cast<QWidget*>(editor));
    }

    void __Qt4Ada_QAbstractItemDelegate_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemDelegateDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemDelegate_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemDelegateDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QAbstractItemDelegate_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemDelegateDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QAbstractItemDelegate_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemDelegateDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractItemDelegate_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractItemDelegate*>(cpp_this)->QAbstractItemDelegate::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractItemDelegate_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractItemDelegate*>(cpp_this)->QAbstractItemDelegate::qt_metacall(_c, _id, _a);
    }

}

QWidget* QAbstractItemDelegateDirector::createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
    return dynamic_cast<QWidget*>(__Qt4Ada_QAbstractItemDelegate_createEditor_0_dispatch(this->ada_object, parent, &option, &index));
}

bool QAbstractItemDelegateDirector::editorEvent(QEvent* event, QAbstractItemModel* model, const QStyleOptionViewItem& option, const QModelIndex& index)
{
    return __Qt4Ada_QAbstractItemDelegate_editorEvent_0_dispatch(this->ada_object, event, model, &option, &index);
}

void QAbstractItemDelegateDirector::setEditorData(QWidget* editor, const QModelIndex& index) const
{
    __Qt4Ada_QAbstractItemDelegate_setEditorData_0_dispatch(this->ada_object, editor, &index);
}

void QAbstractItemDelegateDirector::setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const
{
    __Qt4Ada_QAbstractItemDelegate_setModelData_0_dispatch(this->ada_object, editor, model, &index);
}

QSize QAbstractItemDelegateDirector::sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const
{
    QSize *aux = __Qt4Ada_QAbstractItemDelegate_sizeHint_0_dispatch(this->ada_object, &option, &index);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractItemDelegateDirector::updateEditorGeometry(QWidget* editor, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
    __Qt4Ada_QAbstractItemDelegate_updateEditorGeometry_0_dispatch(this->ada_object, editor, &option, &index);
}

bool QAbstractItemDelegateDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QAbstractItemDelegateDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractItemDelegateDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemDelegateDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemDelegateDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractItemDelegateDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractItemDelegateDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractItemDelegateDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QAbstractItemDelegateDirector::QAbstractItemDelegateDirector(void* o, QObject* parent) :
    QAbstractItemDelegate(parent),
    ada_object (o)
{
}

void QAbstractItemDelegateDirector::paint ( QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index ) const
{
   __Qt4Ada_QAbstractItemDelegate_paint_dispatch
             (this->ada_object,
              painter,
              static_cast<const QStyleOption*>(&option),
              &index);
}

extern "C"
{
    QObject* __Qt4Ada_new_QAbstractItemDelegateDirector(void* ada_object, QObject* parent)
    {
        return new QAbstractItemDelegateDirector(ada_object, parent);
    }

   void __Qt4Ada_QAbstractItemDelegate_paint_virtual (QObject*cpp_object,
                                                      QPainter*painter,
                                                      const QStyleOption*option,
                                                      const QModelIndex*index)
   {
       dynamic_cast <QAbstractItemDelegate*> (cpp_object) -> paint
         (painter, *(static_cast<const QStyleOptionViewItem*>(option)),*index);
   }
}
