//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSize>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QKeyEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QVariant>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QPaintEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qabstractprintdialogdirector.h"
#include "qdialogdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractPrintDialog_staticMetaObject =
        &QAbstractPrintDialog::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    int __Qt4Ada_QAbstractPrintDialog_fromPage_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractPrintDialog*>(cpp_object)->QAbstractPrintDialog::fromPage();
    }

    int __Qt4Ada_QAbstractPrintDialog_maxPage_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractPrintDialog*>(cpp_object)->QAbstractPrintDialog::maxPage();
    }

    int __Qt4Ada_QAbstractPrintDialog_minPage_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractPrintDialog*>(cpp_object)->QAbstractPrintDialog::minPage();
    }

    QAbstractPrintDialog::PrintRange __Qt4Ada_QAbstractPrintDialog_printRange_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractPrintDialog*>(cpp_object)->QAbstractPrintDialog::printRange();
    }

    void __Qt4Ada_QAbstractPrintDialog_setFromTo_0_wrapper(QObject* cpp_object, int fromPage, int toPage)
    {
        dynamic_cast<QAbstractPrintDialog*>(cpp_object)->QAbstractPrintDialog::setFromTo(fromPage, toPage);
    }

    void __Qt4Ada_QAbstractPrintDialog_setMinMax_0_wrapper(QObject* cpp_object, int min, int max)
    {
        dynamic_cast<QAbstractPrintDialog*>(cpp_object)->QAbstractPrintDialog::setMinMax(min, max);
    }

    void __Qt4Ada_QAbstractPrintDialog_setPrintRange_0_wrapper(QObject* cpp_object, QAbstractPrintDialog::PrintRange rng)
    {
        dynamic_cast<QAbstractPrintDialog*>(cpp_object)->QAbstractPrintDialog::setPrintRange(rng);
    }

    int __Qt4Ada_QAbstractPrintDialog_toPage_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractPrintDialog*>(cpp_object)->QAbstractPrintDialog::toPage();
    }

    void __Qt4Ada_QAbstractPrintDialog_accepted_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QDialog::accepted();
    }

    void __Qt4Ada_QAbstractPrintDialog_finished_0_wrapper(QObject* cpp_object, int result)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QDialog::finished(result);
    }

    void __Qt4Ada_QAbstractPrintDialog_rejected_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QDialog::rejected();
    }

    void __Qt4Ada_QAbstractPrintDialog_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QDialog::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QDialog::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    bool __Qt4Ada_QAbstractPrintDialog_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QDialog::eventFilter(watched, event);
    }

    void __Qt4Ada_QAbstractPrintDialog_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QDialog::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QDialog::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QDialog::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QAbstractPrintDialog_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QAbstractPrintDialog_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QAbstractPrintDialog_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::event(e);
    }

    void __Qt4Ada_QAbstractPrintDialog_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QAbstractPrintDialog_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QAbstractPrintDialog_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QAbstractPrintDialog_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QAbstractPrintDialog_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QAbstractPrintDialog_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QAbstractPrintDialog_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QAbstractPrintDialog_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QAbstractPrintDialog_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QAbstractPrintDialog_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractPrintDialog_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QAbstractPrintDialog_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QAbstractPrintDialog_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractPrintDialogDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractPrintDialog_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractPrintDialog*>(cpp_this)->QAbstractPrintDialog::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractPrintDialog_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractPrintDialog*>(cpp_this)->QAbstractPrintDialog::qt_metacall(_c, _id, _a);
    }

}

void QAbstractPrintDialogDirector::accept()
{
    __Qt4Ada_QDialog_accept_0_dispatch(this->ada_object);
}

void QAbstractPrintDialogDirector::done(int result)
{
    __Qt4Ada_QDialog_done_0_dispatch(this->ada_object, result);
}

void QAbstractPrintDialogDirector::reject()
{
    __Qt4Ada_QDialog_reject_0_dispatch(this->ada_object);
}

QSize QAbstractPrintDialogDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractPrintDialogDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

QSize QAbstractPrintDialogDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractPrintDialogDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractPrintDialogDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractPrintDialogDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

int QAbstractPrintDialogDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QAbstractPrintDialogDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QAbstractPrintDialogDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractPrintDialogDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QAbstractPrintDialogDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractPrintDialogDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QAbstractPrintDialogDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QAbstractPrintDialogDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

void QAbstractPrintDialogDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QAbstractPrintDialogDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractPrintDialogDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractPrintDialogDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractPrintDialogDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
