//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QScrollBar>
#include <QSize>
#include <QResizeEvent>
#include <QPaintEvent>
#include <QMouseEvent>
#include <QWheelEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QKeyEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractScrollArea_staticMetaObject =
        &QAbstractScrollArea::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    QObject* __Qt4Ada_QAbstractScrollArea_cornerWidget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::cornerWidget());
    }

    QObject* __Qt4Ada_QAbstractScrollArea_horizontalScrollBar_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::horizontalScrollBar());
    }

    void __Qt4Ada_QAbstractScrollArea_maximumViewportSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::maximumViewportSize();
    }

    void __Qt4Ada_QAbstractScrollArea_setCornerWidget_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::setCornerWidget(dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QAbstractScrollArea_setHorizontalScrollBar_0_wrapper(QObject* cpp_object, QObject* scrollbar)
    {
        dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::setHorizontalScrollBar(dynamic_cast<QScrollBar*>(scrollbar));
    }

    void __Qt4Ada_QAbstractScrollArea_setVerticalScrollBar_0_wrapper(QObject* cpp_object, QObject* scrollbar)
    {
        dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::setVerticalScrollBar(dynamic_cast<QScrollBar*>(scrollbar));
    }

    void __Qt4Ada_QAbstractScrollArea_setViewport_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::setViewport(dynamic_cast<QWidget*>(widget));
    }

    QObject* __Qt4Ada_QAbstractScrollArea_viewport_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::viewport());
    }

    QObject* __Qt4Ada_QAbstractScrollArea_verticalScrollBar_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::verticalScrollBar());
    }

    void __Qt4Ada_QAbstractScrollArea_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::minimumSizeHint();
    }

    void __Qt4Ada_QAbstractScrollArea_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractScrollArea*>(cpp_object)->QAbstractScrollArea::sizeHint();
    }

    void __Qt4Ada_QAbstractScrollArea_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::scrollContentsBy(dx, dy);
    }

    void __Qt4Ada_QAbstractScrollArea_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    bool __Qt4Ada_QAbstractScrollArea_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::viewportEvent(event);
    }

    bool __Qt4Ada_QAbstractScrollArea_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::event(e);
    }

    void __Qt4Ada_QAbstractScrollArea_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QAbstractScrollArea_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QAbstractScrollArea_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QAbstractScrollArea_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QAbstractScrollArea_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QAbstractScrollArea_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QAbstractScrollArea_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QAbstractScrollArea_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QAbstractScrollArea_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QAbstractScrollArea_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QAbstractScrollArea_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QAbstractScrollArea_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QAbstractScrollArea_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractScrollArea_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QAbstractScrollArea_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QAbstractScrollArea_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractScrollAreaDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractScrollArea_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractScrollArea*>(cpp_this)->QAbstractScrollArea::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractScrollArea_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractScrollArea*>(cpp_this)->QAbstractScrollArea::qt_metacall(_c, _id, _a);
    }

}

QSize QAbstractScrollAreaDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QAbstractScrollAreaDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractScrollAreaDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

bool QAbstractScrollAreaDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractScrollAreaDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QAbstractScrollAreaDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QAbstractScrollAreaDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QAbstractScrollAreaDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QAbstractScrollAreaDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QAbstractScrollAreaDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractScrollAreaDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QAbstractScrollAreaDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QAbstractScrollAreaDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QAbstractScrollAreaDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractScrollAreaDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QAbstractScrollAreaDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractScrollAreaDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractScrollAreaDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractScrollAreaDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

#include <QStyle>

#include "qpaintdevicedirector.h"

QPaintEngine*QAbstractScrollAreaDirector::paintEngine()
{
    return __Qt4Ada_QPaintDevice_paintEngine_dispatch(this->ada_object);
}

void QAbstractScrollAreaDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QAbstractScrollAreaDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    void __Qt4Ada_QAbstractScrollArea_setVisible_wrapper(QObject*cpp_this,bool _p1)
    {
    (dynamic_cast<QAbstractScrollArea*>(cpp_this))->QAbstractScrollArea::setVisible(_p1);
    }

    QPaintEngine*__Qt4Ada_QAbstractScrollArea_paintEngine_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QAbstractScrollArea*>(cpp_this))->QAbstractScrollArea::paintEngine();
    }

    void __Qt4Ada_QAbstractScrollArea_styleChange_wrapper(QObject*cpp_this,QObject&_p1)
    {
    (dynamic_cast<QAbstractScrollAreaDirector*>(cpp_this))->QAbstractScrollArea::styleChange(dynamic_cast<QStyle&>(_p1));
    }

    void __Qt4Ada_QAbstractScrollArea_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QAbstractScrollAreaDirector*>(cpp_this))->QAbstractScrollArea::connectNotify(_p1);
    }

    void __Qt4Ada_QAbstractScrollArea_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QAbstractScrollAreaDirector*>(cpp_this))->QAbstractScrollArea::disconnectNotify(_p1);
    }

}
