//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QABSTRACTSLIDERDIRECTOR_H__
#define __QABSTRACTSLIDERDIRECTOR_H__

#include <QAbstractSlider>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QAbstractSlider_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QAbstractSlider_hasTracking_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractSlider_invertedAppearance_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractSlider_invertedControls_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractSlider_isSliderDown_0_wrapper(QObject*);
    extern int __Qt4Ada_QAbstractSlider_maximum_0_wrapper(QObject*);
    extern int __Qt4Ada_QAbstractSlider_minimum_0_wrapper(QObject*);
    extern int __Qt4Ada_QAbstractSlider_pageStep_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSlider_setInvertedAppearance_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractSlider_setInvertedControls_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractSlider_setMaximum_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractSlider_setMinimum_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractSlider_setPageStep_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractSlider_setRange_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QAbstractSlider_setSingleStep_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractSlider_setSliderDown_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractSlider_setSliderPosition_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractSlider_setTracking_0_wrapper(QObject*, bool);
    extern int __Qt4Ada_QAbstractSlider_singleStep_0_wrapper(QObject*);
    extern int __Qt4Ada_QAbstractSlider_sliderPosition_0_wrapper(QObject*);
    extern int __Qt4Ada_QAbstractSlider_value_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSlider_setValue_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractSlider_rangeChanged_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QAbstractSlider_sliderMoved_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractSlider_sliderPressed_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSlider_sliderReleased_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSlider_valueChanged_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractSlider_changeEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractSlider_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QAbstractSlider_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractSlider_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractSlider_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractSlider_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractSlider_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSlider_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSlider_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QAbstractSlider_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QAbstractSlider_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSlider_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QAbstractSlider_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QAbstractSlider_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QAbstractSlider_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

class QAbstractSliderDirector : public QAbstractSlider
{
protected:
    void* ada_object;
    QAbstractSliderDirector();

    virtual void changeEvent(QEvent*);
    virtual bool event(QEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QAbstractSlider_rangeChanged_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QAbstractSlider_sliderMoved_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QAbstractSlider_sliderPressed_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractSlider_sliderReleased_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractSlider_valueChanged_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QAbstractSlider_changeEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractSlider_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QAbstractSlider_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractSlider_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QAbstractSlider_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QAbstractSlider_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractSlider_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractSlider_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractSlider_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QAbstractSlider_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QAbstractSlider_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSlider_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QAbstractSlider_sender_0_wrapper(QObject*);
};

#endif // __QABSTRACTSLIDERDIRECTOR_H__
