//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QSize>
#include <QLineEdit>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTimerEvent>
#include <QWheelEvent>
#include <QVariant>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qabstractspinboxdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractSpinBox_staticMetaObject =
        &QAbstractSpinBox::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QAbstractSpinBox_fixup_0_virtual(QObject* cpp_object, QString* input)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->fixup(*input);
    }

    void __Qt4Ada_QAbstractSpinBox_stepBy_0_virtual(QObject* cpp_object, int steps)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->stepBy(steps);
    }

    QValidator::State __Qt4Ada_QAbstractSpinBox_validate_0_virtual(QObject* cpp_object, QString* input, int pos)
    {
        return dynamic_cast<QAbstractSpinBox*>(cpp_object)->validate(*input, pos);
    }

    void __Qt4Ada_QAbstractSpinBox_clear_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->clear();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QAbstractSpinBox_fixup_0_wrapper(QObject* cpp_object, QString* input)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::fixup(*input);
    }

    bool __Qt4Ada_QAbstractSpinBox_hasAcceptableInput_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::hasAcceptableInput();
    }

    bool __Qt4Ada_QAbstractSpinBox_hasFrame_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::hasFrame();
    }

    void __Qt4Ada_QAbstractSpinBox_interpretText_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::interpretText();
    }

    bool __Qt4Ada_QAbstractSpinBox_isAccelerated_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::isAccelerated();
    }

    bool __Qt4Ada_QAbstractSpinBox_isReadOnly_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::isReadOnly();
    }

    void __Qt4Ada_QAbstractSpinBox_setAccelerated_0_wrapper(QObject* cpp_object, bool on)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::setAccelerated(on);
    }

    void __Qt4Ada_QAbstractSpinBox_setFrame_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::setFrame(enabled);
    }

    void __Qt4Ada_QAbstractSpinBox_setReadOnly_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::setReadOnly(enabled);
    }

    void __Qt4Ada_QAbstractSpinBox_setSpecialValueText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::setSpecialValueText(*text);
    }

    void __Qt4Ada_QAbstractSpinBox_setWrapping_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::setWrapping(enabled);
    }

    void __Qt4Ada_QAbstractSpinBox_specialValueText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::specialValueText();
    }

    void __Qt4Ada_QAbstractSpinBox_stepBy_0_wrapper(QObject* cpp_object, int steps)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::stepBy(steps);
    }

    void __Qt4Ada_QAbstractSpinBox_text_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::text();
    }

    QValidator::State __Qt4Ada_QAbstractSpinBox_validate_0_wrapper(QObject* cpp_object, QString* input, int pos)
    {
        return dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::validate(*input, pos);
    }

    bool __Qt4Ada_QAbstractSpinBox_wrapping_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::wrapping();
    }

    void __Qt4Ada_QAbstractSpinBox_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::minimumSizeHint();
    }

    void __Qt4Ada_QAbstractSpinBox_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::sizeHint();
    }

    void __Qt4Ada_QAbstractSpinBox_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::clear();
    }

    void __Qt4Ada_QAbstractSpinBox_selectAll_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::selectAll();
    }

    void __Qt4Ada_QAbstractSpinBox_stepDown_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::stepDown();
    }

    void __Qt4Ada_QAbstractSpinBox_stepUp_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSpinBox*>(cpp_object)->QAbstractSpinBox::stepUp();
    }

    QObject* __Qt4Ada_QAbstractSpinBox_lineEdit_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::lineEdit());
    }

    void __Qt4Ada_QAbstractSpinBox_setLineEdit_0_wrapper(QObject* cpp_object, QObject* edit)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::setLineEdit(dynamic_cast<QLineEdit*>(edit));
    }

    void __Qt4Ada_QAbstractSpinBox_editingFinished_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::editingFinished();
    }

    bool __Qt4Ada_QAbstractSpinBox_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::event(e);
    }

    void __Qt4Ada_QAbstractSpinBox_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::changeEvent(event);
    }

    void __Qt4Ada_QAbstractSpinBox_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QAbstractSpinBox_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QAbstractSpinBox_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QAbstractSpinBox_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QAbstractSpinBox_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QAbstractSpinBox_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QAbstractSpinBox_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QAbstractSpinBox_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QAbstractSpinBox_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QAbstractSpinBox_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractSpinBox_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QAbstractSpinBox_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSpinBoxDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractSpinBox_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractSpinBox*>(cpp_this)->QAbstractSpinBox::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractSpinBox_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractSpinBox*>(cpp_this)->QAbstractSpinBox::qt_metacall(_c, _id, _a);
    }

}

void QAbstractSpinBoxDirector::fixup(QString& input) const
{
    __Qt4Ada_QAbstractSpinBox_fixup_0_dispatch(this->ada_object, &input);
}

void QAbstractSpinBoxDirector::stepBy(int steps)
{
    __Qt4Ada_QAbstractSpinBox_stepBy_0_dispatch(this->ada_object, steps);
}

QValidator::State QAbstractSpinBoxDirector::validate(QString& input, int pos) const
{
    return __Qt4Ada_QAbstractSpinBox_validate_0_dispatch(this->ada_object, &input, pos);
}

QSize QAbstractSpinBoxDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QAbstractSpinBoxDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractSpinBoxDirector::clear()
{
    __Qt4Ada_QAbstractSpinBox_clear_0_dispatch(this->ada_object);
}

bool QAbstractSpinBoxDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QAbstractSpinBoxDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QAbstractSpinBoxDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QAbstractSpinBoxDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QAbstractSpinBoxDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QAbstractSpinBoxDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractSpinBoxDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QAbstractSpinBoxDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QAbstractSpinBoxDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QAbstractSpinBoxDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractSpinBoxDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSpinBoxDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractSpinBoxDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractSpinBoxDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractSpinBoxDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QAbstractSpinBox::StepEnabled QAbstractSpinBoxDirector::stepEnabled()
{
    return __Qt4Ada_QAbstractSpinBox_stepEnabled_dispatch(this->ada_object);
}

QPaintEngine*QAbstractSpinBoxDirector::paintEngine()
{
    return __Qt4Ada_QPaintDevice_paintEngine_dispatch(this->ada_object);
}

void QAbstractSpinBoxDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QAbstractSpinBoxDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    QPaintEngine*__Qt4Ada_QAbstractSpinBox_paintEngine_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QAbstractSpinBox*>(cpp_this))->QAbstractSpinBox::paintEngine();
    }

    QAbstractSpinBox::StepEnabled __Qt4Ada_QAbstractSpinBox_stepEnabled_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QAbstractSpinBoxDirector*>(cpp_this))->QAbstractSpinBox::stepEnabled();
    }

    void __Qt4Ada_QAbstractSpinBox_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QAbstractSpinBoxDirector*>(cpp_this))->QAbstractSpinBox::connectNotify(_p1);
    }

    void __Qt4Ada_QAbstractSpinBox_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QAbstractSpinBoxDirector*>(cpp_this))->QAbstractSpinBox::disconnectNotify(_p1);
    }

}
