//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QVariant>
#include <QFont>
#include <QIcon>
#include <QString>
#include <QWidget>
#include <QKeySequence>
#include <QChildEvent>
#include <QTimerEvent>

#include "qactiondirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAction_staticMetaObject =
        &QAction::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QAction_activate_0_wrapper(QObject* cpp_object, QAction::ActionEvent event)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::activate(event);
    }

    bool __Qt4Ada_QAction_autoRepeat_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAction*>(cpp_object)->QAction::autoRepeat();
    }

    void __Qt4Ada_QAction_data_0_wrapper(QObject* cpp_object, QVariant* returns)
    {
        *returns = dynamic_cast<QAction*>(cpp_object)->QAction::data();
    }

    void __Qt4Ada_QAction_font_0_wrapper(QObject* cpp_object, QFont* returns)
    {
        *returns = dynamic_cast<QAction*>(cpp_object)->QAction::font();
    }

    void __Qt4Ada_QAction_icon_0_wrapper(QObject* cpp_object, QIcon* returns)
    {
        *returns = dynamic_cast<QAction*>(cpp_object)->QAction::icon();
    }

    void __Qt4Ada_QAction_iconText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QAction*>(cpp_object)->QAction::iconText();
    }

    bool __Qt4Ada_QAction_isCheckable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAction*>(cpp_object)->QAction::isCheckable();
    }

    bool __Qt4Ada_QAction_isChecked_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAction*>(cpp_object)->QAction::isChecked();
    }

    bool __Qt4Ada_QAction_isEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAction*>(cpp_object)->QAction::isEnabled();
    }

    bool __Qt4Ada_QAction_isSeparator_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAction*>(cpp_object)->QAction::isSeparator();
    }

    bool __Qt4Ada_QAction_isVisible_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAction*>(cpp_object)->QAction::isVisible();
    }

    QAction::MenuRole __Qt4Ada_QAction_menuRole_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAction*>(cpp_object)->QAction::menuRole();
    }

    QObject* __Qt4Ada_QAction_parentWidget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAction*>(cpp_object)->QAction::parentWidget());
    }

    void __Qt4Ada_QAction_setAutoRepeat_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setAutoRepeat(enable);
    }

    void __Qt4Ada_QAction_setCheckable_0_wrapper(QObject* cpp_object, bool checkable)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setCheckable(checkable);
    }

    void __Qt4Ada_QAction_setData_0_wrapper(QObject* cpp_object, const QVariant* data)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setData(*data);
    }

    void __Qt4Ada_QAction_setFont_0_wrapper(QObject* cpp_object, const QFont* font)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setFont(*font);
    }

    void __Qt4Ada_QAction_setIcon_0_wrapper(QObject* cpp_object, const QIcon* icon)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setIcon(*icon);
    }

    void __Qt4Ada_QAction_setIconText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setIconText(*text);
    }

    void __Qt4Ada_QAction_setMenuRole_0_wrapper(QObject* cpp_object, QAction::MenuRole menuRole)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setMenuRole(menuRole);
    }

    void __Qt4Ada_QAction_setSeparator_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setSeparator(b);
    }

    void __Qt4Ada_QAction_setShortcut_0_wrapper(QObject* cpp_object, const QKeySequence* shortcut)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setShortcut(*shortcut);
    }

    void __Qt4Ada_QAction_setStatusTip_0_wrapper(QObject* cpp_object, const QString* statusTip)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setStatusTip(*statusTip);
    }

    void __Qt4Ada_QAction_setText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setText(*text);
    }

    void __Qt4Ada_QAction_setToolTip_0_wrapper(QObject* cpp_object, const QString* tip)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setToolTip(*tip);
    }

    void __Qt4Ada_QAction_setWhatsThis_0_wrapper(QObject* cpp_object, const QString* what)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setWhatsThis(*what);
    }

    void __Qt4Ada_QAction_shortcut_0_wrapper(QObject* cpp_object, QKeySequence* returns)
    {
        *returns = dynamic_cast<QAction*>(cpp_object)->QAction::shortcut();
    }

    void __Qt4Ada_QAction_statusTip_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QAction*>(cpp_object)->QAction::statusTip();
    }

    void __Qt4Ada_QAction_text_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QAction*>(cpp_object)->QAction::text();
    }

    void __Qt4Ada_QAction_toolTip_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QAction*>(cpp_object)->QAction::toolTip();
    }

    void __Qt4Ada_QAction_whatsThis_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QAction*>(cpp_object)->QAction::whatsThis();
    }

    void __Qt4Ada_QAction_hover_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::hover();
    }

    void __Qt4Ada_QAction_setChecked_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setChecked(b);
    }

    void __Qt4Ada_QAction_setDisabled_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setDisabled(b);
    }

    void __Qt4Ada_QAction_setEnabled_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setEnabled(b);
    }

    void __Qt4Ada_QAction_setVisible_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::setVisible(b);
    }

    void __Qt4Ada_QAction_toggle_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::toggle();
    }

    void __Qt4Ada_QAction_trigger_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAction*>(cpp_object)->QAction::trigger();
    }

    void __Qt4Ada_QAction_changed_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QActionDirector*>(cpp_object)->QAction::changed();
    }

    void __Qt4Ada_QAction_hovered_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QActionDirector*>(cpp_object)->QAction::hovered();
    }

    void __Qt4Ada_QAction_toggled_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QActionDirector*>(cpp_object)->QAction::toggled(b);
    }

    void __Qt4Ada_QAction_triggered_0_wrapper(QObject* cpp_object, bool checked)
    {
        dynamic_cast<QActionDirector*>(cpp_object)->QAction::triggered(checked);
    }

    bool __Qt4Ada_QAction_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QActionDirector*>(cpp_object)->QAction::event(e);
    }

    void __Qt4Ada_QAction_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QActionDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAction_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QActionDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QAction_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QActionDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QAction_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QActionDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAction_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAction*>(cpp_this)->QAction::qt_metacast(name);
    }

    int __Qt4Ada_QAction_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAction*>(cpp_this)->QAction::qt_metacall(_c, _id, _a);
    }

}

bool QActionDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QActionDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QActionDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QActionDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QActionDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QActionDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QActionDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QActionDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

// Constructors
extern "C" {
   QObject * __Qt4Ada_new_QAction (QObject * parent)
   {
      return dynamic_cast<QObject*>(new QAction (parent));
   }

   QObject * __Qt4Ada_new_QAction_with_String (QString * text, QObject *parent)
   {
      return dynamic_cast<QObject*>(new QAction (*text, parent));
   }

   QObject * __Qt4Ada_new_QAction_with_Icon (QIcon*icon,QString *text, QObject *parent)
   {
      return dynamic_cast<QObject*>(new QAction (*icon, *text, parent));
   }
}
