//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QACTIONDIRECTOR_H__
#define __QACTIONDIRECTOR_H__

#include <QAction>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QAction_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QAction_activate_0_wrapper(QObject*, QAction::ActionEvent);
    extern bool __Qt4Ada_QAction_autoRepeat_0_wrapper(QObject*);
    extern void __Qt4Ada_QAction_data_0_wrapper(QObject*, QVariant*);
    extern void __Qt4Ada_QAction_font_0_wrapper(QObject*, QFont*);
    extern void __Qt4Ada_QAction_icon_0_wrapper(QObject*, QIcon*);
    extern void __Qt4Ada_QAction_iconText_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QAction_isCheckable_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAction_isChecked_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAction_isEnabled_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAction_isSeparator_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAction_isVisible_0_wrapper(QObject*);
    extern QAction::MenuRole __Qt4Ada_QAction_menuRole_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QAction_parentWidget_0_wrapper(QObject*);
    extern void __Qt4Ada_QAction_setAutoRepeat_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAction_setCheckable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAction_setData_0_wrapper(QObject*, const QVariant*);
    extern void __Qt4Ada_QAction_setFont_0_wrapper(QObject*, const QFont*);
    extern void __Qt4Ada_QAction_setIcon_0_wrapper(QObject*, const QIcon*);
    extern void __Qt4Ada_QAction_setIconText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QAction_setMenuRole_0_wrapper(QObject*, QAction::MenuRole);
    extern void __Qt4Ada_QAction_setSeparator_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAction_setShortcut_0_wrapper(QObject*, const QKeySequence*);
    extern void __Qt4Ada_QAction_setStatusTip_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QAction_setText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QAction_setToolTip_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QAction_setWhatsThis_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QAction_shortcut_0_wrapper(QObject*, QKeySequence*);
    extern void __Qt4Ada_QAction_statusTip_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QAction_text_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QAction_toolTip_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QAction_whatsThis_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QAction_hover_0_wrapper(QObject*);
    extern void __Qt4Ada_QAction_setChecked_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAction_setDisabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAction_setEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAction_setVisible_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAction_toggle_0_wrapper(QObject*);
    extern void __Qt4Ada_QAction_trigger_0_wrapper(QObject*);
    extern void __Qt4Ada_QAction_changed_0_wrapper(QObject*);
    extern void __Qt4Ada_QAction_hovered_0_wrapper(QObject*);
    extern void __Qt4Ada_QAction_toggled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAction_triggered_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QAction_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAction_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAction_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAction_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QAction_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QAction_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QAction_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

// Constructors
extern "C" {
   QObject * __Qt4Ada_new_QAction (QObject *);
   QObject * __Qt4Ada_new_QAction_with_String (QString *, QObject *);
   QObject * __Qt4Ada_new_QAction_with_Icon (QIcon*,QString *, QObject *);
}

class QActionDirector : public QAction
{
protected:
    void* ada_object;
    QActionDirector();

    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QAction_changed_0_wrapper(QObject*);
    friend void __Qt4Ada_QAction_hovered_0_wrapper(QObject*);
    friend void __Qt4Ada_QAction_toggled_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QAction_triggered_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QAction_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAction_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAction_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAction_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QAction_sender_0_wrapper(QObject*);
};

#endif // __QACTIONDIRECTOR_H__
