//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QBitmap>
#include <QString>
#include "qbitmapwrapper.h"

extern "C"
{

    QPixmap* __QtAda_inititialize_QBitmap(void* storage)
    {
        return new (storage) QBitmap();
    }

    QPixmap* __QtAda_inititialize_QBitmap_QPixmapCR(void* storage, const QPixmap* pixmap)
    {
        return new (storage) QBitmap(*pixmap);
    }

    QPixmap* __QtAda_inititialize_QBitmap_int_int(void* storage, int width, int height)
    {
        return new (storage) QBitmap(width, height);
    }

    QPixmap* __QtAda_inititialize_QBitmap_QSizeCR(void* storage, const QSize* size)
    {
        return new (storage) QBitmap(*size);
    }

    QPixmap* __QtAda_adjust_QBitmap(void* storage, const QPixmap* from)
    {
        return new (storage) QBitmap(*static_cast<const QBitmap*>(from));
    }

    void __QtAda_finalize_QBitmap(QPixmap *item)
    {
        static_cast<const QBitmap*>(item)->~QBitmap();
    }

    void __QtAda_QBitmap_clear(QPixmap* self)
    {
        static_cast<QBitmap*>(self)->clear();
    }

    void __QtAda_QBitmap_transformed_QTransformCR_Q(QPixmap* returns, const QPixmap* self, const QTransform* matrix)
    {
        *static_cast<QBitmap*>(returns) = static_cast<const QBitmap*>(self)->transformed(*matrix);
    }

    void __QtAda_QBitmap_transformed_QMatrixCR_Q(QPixmap* returns, const QPixmap* self, const QMatrix* matrix)
    {
        *static_cast<QBitmap*>(returns) = static_cast<const QBitmap*>(self)->transformed(*matrix);
    }

};

