//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QLayout>
#include <QWidget>
#include <QSize>
#include <QChildEvent>
#include <QTimerEvent>

#include "qboxlayoutdirector.h"
#include "qlayoutdirector.h"
#include "qobjectdirector.h"
#include "qlayoutitemdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QBoxLayout_staticMetaObject =
        &QBoxLayout::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QBoxLayout_addLayout_0_wrapper(QObject* cpp_object, QObject* layout, int stretch)
    {
        dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::addLayout(dynamic_cast<QLayout*>(layout), stretch);
    }

    void __Qt4Ada_QBoxLayout_addSpacing_0_wrapper(QObject* cpp_object, int size)
    {
        dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::addSpacing(size);
    }

    void __Qt4Ada_QBoxLayout_addStretch_0_wrapper(QObject* cpp_object, int stretch)
    {
        dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::addStretch(stretch);
    }

    void __Qt4Ada_QBoxLayout_addStrut_0_wrapper(QObject* cpp_object, int size)
    {
        dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::addStrut(size);
    }

    void __Qt4Ada_QBoxLayout_insertLayout_0_wrapper(QObject* cpp_object, int index, QObject* layout, int stretch)
    {
        dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::insertLayout(index, dynamic_cast<QLayout*>(layout), stretch);
    }

    void __Qt4Ada_QBoxLayout_insertSpacing_0_wrapper(QObject* cpp_object, int index, int size)
    {
        dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::insertSpacing(index, size);
    }

    void __Qt4Ada_QBoxLayout_insertStretch_0_wrapper(QObject* cpp_object, int index, int stretch)
    {
        dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::insertStretch(index, stretch);
    }

    bool __Qt4Ada_QBoxLayout_setStretchFactor_1_wrapper(QObject* cpp_object, QObject* w, int stretch)
    {
        return dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::setStretchFactor(dynamic_cast<QWidget*>(w), stretch);
    }

    bool __Qt4Ada_QBoxLayout_setStretchFactor_0_wrapper(QObject* cpp_object, QObject* l, int stretch)
    {
        return dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::setStretchFactor(dynamic_cast<QLayout*>(l), stretch);
    }

    void __Qt4Ada_QBoxLayout_addItem_0_wrapper(QObject* cpp_object, QLayoutItem* item)
    {
        dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::addItem(item);
    }

    int __Qt4Ada_QBoxLayout_count_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::count();
    }

    bool __Qt4Ada_QBoxLayout_hasHeightForWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::hasHeightForWidth();
    }

    int __Qt4Ada_QBoxLayout_heightForWidth_0_wrapper(QObject* cpp_object, int w)
    {
        return dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::heightForWidth(w);
    }

    void __Qt4Ada_QBoxLayout_invalidate_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::invalidate();
    }

    void __Qt4Ada_QBoxLayout_maximumSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::maximumSize();
    }

    int __Qt4Ada_QBoxLayout_minimumHeightForWidth_0_wrapper(QObject* cpp_object, int w)
    {
        return dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::minimumHeightForWidth(w);
    }

    void __Qt4Ada_QBoxLayout_minimumSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::minimumSize();
    }

    void __Qt4Ada_QBoxLayout_setGeometry_0_wrapper(QObject* cpp_object, const QRect* r)
    {
        dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::setGeometry(*r);
    }

    void __Qt4Ada_QBoxLayout_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QBoxLayout*>(cpp_object)->QBoxLayout::sizeHint();
    }

    void __Qt4Ada_QBoxLayout_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QBoxLayoutDirector*>(cpp_object)->QLayout::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QBoxLayout_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QBoxLayoutDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QBoxLayout_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QBoxLayoutDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QBoxLayout_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QBoxLayoutDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QBoxLayout_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QBoxLayout*>(cpp_this)->QBoxLayout::qt_metacast(name);
    }

    int __Qt4Ada_QBoxLayout_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QBoxLayout*>(cpp_this)->QBoxLayout::qt_metacall(_c, _id, _a);
    }

}

void QBoxLayoutDirector::addItem(QLayoutItem* item)
{
    __Qt4Ada_QLayout_addItem_0_dispatch(this->ada_object, item);
}

int QBoxLayoutDirector::count() const
{
    return __Qt4Ada_QLayout_count_0_dispatch(this->ada_object);
}

bool QBoxLayoutDirector::hasHeightForWidth() const
{
    return __Qt4Ada_QLayoutItem_hasHeightForWidth_0_dispatch(this->ada_object);
}

int QBoxLayoutDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QLayoutItem_heightForWidth_0_dispatch(this->ada_object, w);
}

void QBoxLayoutDirector::invalidate()
{
    __Qt4Ada_QLayoutItem_invalidate_0_dispatch(this->ada_object);
}

QSize QBoxLayoutDirector::maximumSize() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_maximumSize_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

int QBoxLayoutDirector::minimumHeightForWidth(int w) const
{
    return __Qt4Ada_QLayoutItem_minimumHeightForWidth_0_dispatch(this->ada_object, w);
}

QSize QBoxLayoutDirector::minimumSize() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_minimumSize_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QBoxLayoutDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

int QBoxLayoutDirector::indexOf(QWidget* widget) const
{
    return __Qt4Ada_QLayout_indexOf_0_dispatch(this->ada_object, widget);
}

bool QBoxLayoutDirector::isEmpty() const
{
    return __Qt4Ada_QLayoutItem_isEmpty_0_dispatch(this->ada_object);
}

void QBoxLayoutDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

bool QBoxLayoutDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QBoxLayoutDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QBoxLayoutDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QBoxLayoutDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

QLayout* QBoxLayoutDirector::layout()
{
    return dynamic_cast<QLayout*>(__Qt4Ada_QLayoutItem_layout_0_dispatch(this->ada_object));
}

QWidget* QBoxLayoutDirector::widget()
{
    return dynamic_cast<QWidget*>(__Qt4Ada_QLayoutItem_widget_0_dispatch(this->ada_object));
}

const QMetaObject* QBoxLayoutDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QBoxLayoutDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QBoxLayoutDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QWidget>

// Qt::Orientations QBoxLayoutDirector::expandingDirections()
// {
//     return __Qt4Ada_QLayoutItem_expandingDirections_dispatch(this->ada_object);
// }
//
// QLayoutItem*QBoxLayoutDirector::itemAt(int _p1)
// {
//     return __Qt4Ada_QLayout_itemAt_dispatch(this->ada_object,_p1);
// }
//
// QLayoutItem*QBoxLayoutDirector::takeAt(int _p1)
// {
//     return __Qt4Ada_QLayout_takeAt_dispatch(this->ada_object,_p1);
// }
//
// void QBoxLayoutDirector::connectNotify(const char*_p1)
// {
//     __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
// }
//
// void QBoxLayoutDirector::disconnectNotify(const char*_p1)
// {
//     __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
// }
//
// QSpacerItem*QBoxLayoutDirector::spacerItem()
// {
//     return dynamic_cast<QSpacerItem*>(__Qt4Ada_QLayoutItem_spacerItem_dispatch(this->ada_object));
// }

extern "C" {

//     Qt::Orientations __Qt4Ada_QBoxLayout_expandingDirections_wrapper(QObject*cpp_this)
//     {
//         return (dynamic_cast<QBoxLayout*>(cpp_this))->QBoxLayout::expandingDirections();
//     }
//
//     QLayoutItem*__Qt4Ada_QBoxLayout_itemAt_wrapper(QObject*cpp_this,int _p1)
//     {
//         return (dynamic_cast<QBoxLayout*>(cpp_this))->QBoxLayout::itemAt(_p1);
//     }
//
//     QLayoutItem*__Qt4Ada_QBoxLayout_takeAt_wrapper(QObject*cpp_this,int _p1)
//     {
//         return (dynamic_cast<QBoxLayout*>(cpp_this))->QBoxLayout::takeAt(_p1);
//     }
//
//     void __Qt4Ada_QBoxLayout_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
//     {
//     (dynamic_cast<QBoxLayoutDirector*>(cpp_this))->QBoxLayout::connectNotify(_p1);
//     }
//
//     void __Qt4Ada_QBoxLayout_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
//     {
//     (dynamic_cast<QBoxLayoutDirector*>(cpp_this))->QBoxLayout::disconnectNotify(_p1);
//     }

    QObject* __Qt4Ada_new_QBoxLayout (QBoxLayout::Direction dir,
                                      QObject*              parent)
    {
        return dynamic_cast<QObject*>(new QBoxLayout(dir,
                                      dynamic_cast<QWidget*>(parent)));
    }

    void __Qt4Ada_QBoxLayout_addStretch_wrapper(QObject* cpp_this, int stretch)
    {
        (dynamic_cast<QBoxLayout*>(cpp_this))->QBoxLayout::addStretch(stretch);
    }

    void __Qt4Ada_QBoxLayout_addWidget_wrapper(QObject* cpp_this,
                                               QObject* widget,
                                               int      stretch,
                                               unsigned alignment)
    {
        (dynamic_cast<QBoxLayout*>(cpp_this))->
                  QBoxLayout::addWidget(dynamic_cast<QWidget*>(widget),
                                        stretch, Qt::Alignment(alignment));
    }

    void __Qt4Ada_QBoxLayout_addLayout_wrapper(QObject* cpp_this,
                                               QObject* widget,
                                               int      stretch)
    {
        (dynamic_cast<QBoxLayout*>(cpp_this))->
                  QBoxLayout::addLayout(dynamic_cast<QLayout*>(widget),
                                        stretch);
    }

}
