//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QBrush>

extern "C"
{
    extern QBrush* __QtAda_inititialize_QBrush(void*);
    extern QBrush* __QtAda_inititialize_QBrush_BrushStyle(void*, unsigned);
    extern QBrush* __QtAda_inititialize_QBrush_QColorCR_BrushStyle(void*, const QColor*, unsigned);
    extern QBrush* __QtAda_inititialize_QBrush_GlobalColor_BrushStyle(void*, unsigned, unsigned);
    extern QBrush* __QtAda_inititialize_QBrush_QColorCR_QPixmapCR(void*, const QColor*, const QPixmap*);
    extern QBrush* __QtAda_inititialize_QBrush_GlobalColor_QPixmapCR(void*, unsigned, const QPixmap*);
    extern QBrush* __QtAda_inititialize_QBrush_QPixmapCR(void*, const QPixmap*);
    extern QBrush* __QtAda_inititialize_QBrush_QGradientCR(void*, const QGradient*);
    extern QBrush* __QtAda_adjust_QBrush(void*, const QBrush*);
    extern void __QtAda_finalize_QBrush(QBrush*);

    extern void __QtAda_QBrush_color_Q(QColor*, const QBrush*);
    extern unsigned __QtAda_QBrush_isDetached_Q(const QBrush*);
    extern unsigned __QtAda_QBrush_isOpaque_Q(const QBrush*);
    extern void __QtAda_QBrush_matrix_Q(QMatrix*, const QBrush*);
    extern void __QtAda_QBrush_setColor_QColorCR(QBrush*, const QColor*);
    extern void __QtAda_QBrush_setColor_GlobalColor(QBrush*, unsigned);
    extern void __QtAda_QBrush_setMatrix_QMatrixCR(QBrush*, const QMatrix*);
    extern void __QtAda_QBrush_setStyle_BrushStyle(QBrush*, unsigned);
    extern void __QtAda_QBrush_setTexture_QPixmapCR(QBrush*, const QPixmap*);
    extern void __QtAda_QBrush_setTransform_QTransformCR(QBrush*, const QTransform*);
    extern unsigned __QtAda_QBrush_style_Q(const QBrush*);
    extern void __QtAda_QBrush_texture_Q(QPixmap*, const QBrush*);
    extern void __QtAda_QBrush_transform_Q(QTransform*, const QBrush*);
    extern unsigned __QtAda_QBrush_eq_QBrushCR_Q(const QBrush*, const QBrush*);

};

