//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QCHECKBOXDIRECTOR_H__
#define __QCHECKBOXDIRECTOR_H__

#include <QCheckBox>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QCheckBox_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern Qt::CheckState __Qt4Ada_QCheckBox_checkState_0_wrapper(QObject*);
    extern bool __Qt4Ada_QCheckBox_isTristate_0_wrapper(QObject*);
    extern void __Qt4Ada_QCheckBox_setCheckState_0_wrapper(QObject*, Qt::CheckState);
    extern void __Qt4Ada_QCheckBox_setTristate_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QCheckBox_stateChanged_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QCheckBox_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QCheckBox_checkStateSet_0_wrapper(QObject*);
    extern bool __Qt4Ada_QCheckBox_hitButton_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QCheckBox_nextCheckState_0_wrapper(QObject*);
    extern bool __Qt4Ada_QCheckBox_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QCheckBox_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QCheckBox_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QCheckBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QCheckBox_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QCheckBox_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QCheckBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QCheckBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QCheckBox_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCheckBox_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QCheckBox_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QCheckBox_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QCheckBox_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

//  Constructors
extern "C"
{

   extern QObject* __Qt4Ada_new_QCheckBox (QObject*);
   extern QObject* __Qt4Ada_new_QCheckBox_with_QString (QString*,QObject*);

}

class QCheckBoxDirector : public QCheckBox
{
protected:
    void* ada_object;
    QCheckBoxDirector();

    virtual QSize sizeHint() const;
    virtual void checkStateSet();
    virtual bool hitButton(const QPoint&) const;
    virtual void nextCheckState();
    virtual bool event(QEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void changeEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QCheckBox_stateChanged_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QCheckBox_checkStateSet_0_wrapper(QObject*);
    friend bool __Qt4Ada_QCheckBox_hitButton_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QCheckBox_nextCheckState_0_wrapper(QObject*);
    friend bool __Qt4Ada_QCheckBox_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QCheckBox_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QCheckBox_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QCheckBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QCheckBox_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QCheckBox_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QCheckBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QCheckBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QCheckBox_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCheckBox_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QCheckBox_sender_0_wrapper(QObject*);
};

#endif // __QCHECKBOXDIRECTOR_H__
