//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QAbstractItemModel>
#include <QString>
#include <QModelIndex>
#include <QAbstractItemView>
#include <QWidget>
#include <QChildEvent>
#include <QTimerEvent>

#include "qcompleterdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QCompleter_staticMetaObject =
        &QCompleter::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QCompleter_pathFromIndex_0_virtual(QObject* cpp_object, const QModelIndex* index, QString* returns)
    {
        *returns = dynamic_cast<QCompleter*>(cpp_object)->pathFromIndex(*index);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    int __Qt4Ada_QCompleter_completionColumn_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QCompleter*>(cpp_object)->QCompleter::completionColumn();
    }

    int __Qt4Ada_QCompleter_completionCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QCompleter*>(cpp_object)->QCompleter::completionCount();
    }

    QObject* __Qt4Ada_QCompleter_completionModel_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QCompleter*>(cpp_object)->QCompleter::completionModel());
    }

    void __Qt4Ada_QCompleter_completionPrefix_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QCompleter*>(cpp_object)->QCompleter::completionPrefix();
    }

    int __Qt4Ada_QCompleter_completionRole_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QCompleter*>(cpp_object)->QCompleter::completionRole();
    }

    void __Qt4Ada_QCompleter_currentCompletion_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QCompleter*>(cpp_object)->QCompleter::currentCompletion();
    }

    void __Qt4Ada_QCompleter_currentIndex_0_wrapper(QObject* cpp_object, QModelIndex* returns)
    {
        *returns = dynamic_cast<QCompleter*>(cpp_object)->QCompleter::currentIndex();
    }

    int __Qt4Ada_QCompleter_currentRow_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QCompleter*>(cpp_object)->QCompleter::currentRow();
    }

    QObject* __Qt4Ada_QCompleter_model_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QCompleter*>(cpp_object)->QCompleter::model());
    }

    void __Qt4Ada_QCompleter_pathFromIndex_0_wrapper(QObject* cpp_object, const QModelIndex* index, QString* returns)
    {
        *returns = dynamic_cast<QCompleter*>(cpp_object)->QCompleter::pathFromIndex(*index);
    }

    QObject* __Qt4Ada_QCompleter_popup_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QCompleter*>(cpp_object)->QCompleter::popup());
    }

    void __Qt4Ada_QCompleter_setCompletionColumn_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QCompleter*>(cpp_object)->QCompleter::setCompletionColumn(column);
    }

    void __Qt4Ada_QCompleter_setCompletionRole_0_wrapper(QObject* cpp_object, int role)
    {
        dynamic_cast<QCompleter*>(cpp_object)->QCompleter::setCompletionRole(role);
    }

    bool __Qt4Ada_QCompleter_setCurrentRow_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QCompleter*>(cpp_object)->QCompleter::setCurrentRow(row);
    }

    void __Qt4Ada_QCompleter_setModel_0_wrapper(QObject* cpp_object, QObject* c)
    {
        dynamic_cast<QCompleter*>(cpp_object)->QCompleter::setModel(dynamic_cast<QAbstractItemModel*>(c));
    }

    void __Qt4Ada_QCompleter_setPopup_0_wrapper(QObject* cpp_object, QObject* popup)
    {
        dynamic_cast<QCompleter*>(cpp_object)->QCompleter::setPopup(dynamic_cast<QAbstractItemView*>(popup));
    }

    void __Qt4Ada_QCompleter_setWidget_0_wrapper(QObject* cpp_object, QObject* popup)
    {
        dynamic_cast<QCompleter*>(cpp_object)->QCompleter::setWidget(dynamic_cast<QWidget*>(popup));
    }

    QObject* __Qt4Ada_QCompleter_widget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QCompleter*>(cpp_object)->QCompleter::widget());
    }

    void __Qt4Ada_QCompleter_complete_0_wrapper(QObject* cpp_object, const QRect* rect)
    {
        dynamic_cast<QCompleter*>(cpp_object)->QCompleter::complete(*rect);
    }

    void __Qt4Ada_QCompleter_setCompletionPrefix_0_wrapper(QObject* cpp_object, const QString* prefix)
    {
        dynamic_cast<QCompleter*>(cpp_object)->QCompleter::setCompletionPrefix(*prefix);
    }

    void __Qt4Ada_QCompleter_activated_1_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QCompleterDirector*>(cpp_object)->QCompleter::activated(*text);
    }

    void __Qt4Ada_QCompleter_activated_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QCompleterDirector*>(cpp_object)->QCompleter::activated(*index);
    }

    void __Qt4Ada_QCompleter_highlighted_1_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QCompleterDirector*>(cpp_object)->QCompleter::highlighted(*text);
    }

    void __Qt4Ada_QCompleter_highlighted_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QCompleterDirector*>(cpp_object)->QCompleter::highlighted(*index);
    }

    bool __Qt4Ada_QCompleter_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QCompleterDirector*>(cpp_object)->QCompleter::event(e);
    }

    bool __Qt4Ada_QCompleter_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QCompleterDirector*>(cpp_object)->QCompleter::eventFilter(watched, event);
    }

    void __Qt4Ada_QCompleter_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QCompleterDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QCompleter_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QCompleterDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QCompleter_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QCompleterDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QCompleter_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QCompleterDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QCompleter_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QCompleter*>(cpp_this)->QCompleter::qt_metacast(name);
    }

    int __Qt4Ada_QCompleter_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QCompleter*>(cpp_this)->QCompleter::qt_metacall(_c, _id, _a);
    }

}

QString QCompleterDirector::pathFromIndex(const QModelIndex& index) const
{
    QString *aux = __Qt4Ada_QCompleter_pathFromIndex_0_dispatch(this->ada_object, &index);
    QString returns = *aux;
    delete aux;
    return returns;
}

bool QCompleterDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QCompleterDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QCompleterDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QCompleterDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QCompleterDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QCompleterDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QCompleterDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QCompleterDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
