//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QCOMPLETERDIRECTOR_H__
#define __QCOMPLETERDIRECTOR_H__

#include <QCompleter>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QCompleter_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QString* __Qt4Ada_QCompleter_pathFromIndex_0_dispatch(void*, const QModelIndex*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QCompleter_pathFromIndex_0_virtual(QObject*, const QModelIndex*, QString*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern int __Qt4Ada_QCompleter_completionColumn_0_wrapper(QObject*);
    extern int __Qt4Ada_QCompleter_completionCount_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QCompleter_completionModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QCompleter_completionPrefix_0_wrapper(QObject*, QString*);
    extern int __Qt4Ada_QCompleter_completionRole_0_wrapper(QObject*);
    extern void __Qt4Ada_QCompleter_currentCompletion_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QCompleter_currentIndex_0_wrapper(QObject*, QModelIndex*);
    extern int __Qt4Ada_QCompleter_currentRow_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QCompleter_model_0_wrapper(QObject*);
    extern void __Qt4Ada_QCompleter_pathFromIndex_0_wrapper(QObject*, const QModelIndex*, QString*);
    extern QObject* __Qt4Ada_QCompleter_popup_0_wrapper(QObject*);
    extern void __Qt4Ada_QCompleter_setCompletionColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QCompleter_setCompletionRole_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QCompleter_setCurrentRow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QCompleter_setModel_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QCompleter_setPopup_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QCompleter_setWidget_0_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QCompleter_widget_0_wrapper(QObject*);
    extern void __Qt4Ada_QCompleter_complete_0_wrapper(QObject*, const QRect*);
    extern void __Qt4Ada_QCompleter_setCompletionPrefix_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QCompleter_activated_1_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QCompleter_activated_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QCompleter_highlighted_1_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QCompleter_highlighted_0_wrapper(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QCompleter_event_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QCompleter_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    extern void __Qt4Ada_QCompleter_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCompleter_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QCompleter_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QCompleter_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QCompleter_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QCompleter_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

class QCompleterDirector : public QCompleter
{
protected:
    void* ada_object;
    QCompleterDirector();

    virtual QString pathFromIndex(const QModelIndex&) const;
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QCompleter_activated_1_wrapper(QObject*, const QString*);
    friend void __Qt4Ada_QCompleter_activated_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QCompleter_highlighted_1_wrapper(QObject*, const QString*);
    friend void __Qt4Ada_QCompleter_highlighted_0_wrapper(QObject*, const QModelIndex*);
    friend bool __Qt4Ada_QCompleter_event_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QCompleter_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    friend void __Qt4Ada_QCompleter_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCompleter_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QCompleter_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QCompleter_sender_0_wrapper(QObject*);
};

#endif // __QCOMPLETERDIRECTOR_H__
