//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QDIALOGBUTTONBOXDIRECTOR_H__
#define __QDIALOGBUTTONBOXDIRECTOR_H__

#include <QDialogButtonBox>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QDialogButtonBox_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QDialogButtonBox_addButton_2_wrapper(QObject*, QObject*, QDialogButtonBox::ButtonRole);
    extern QObject* __Qt4Ada_QDialogButtonBox_addButton_1_wrapper(QObject*, const QString*, QDialogButtonBox::ButtonRole);
    extern QObject* __Qt4Ada_QDialogButtonBox_addButton_0_wrapper(QObject*, QDialogButtonBox::StandardButton);
    extern QObject* __Qt4Ada_QDialogButtonBox_button_0_wrapper(QObject*, QDialogButtonBox::StandardButton);
    extern QDialogButtonBox::ButtonRole __Qt4Ada_QDialogButtonBox_buttonRole_0_wrapper(QObject*, QObject*);
    extern bool __Qt4Ada_QDialogButtonBox_centerButtons_0_wrapper(QObject*);
    extern void __Qt4Ada_QDialogButtonBox_clear_0_wrapper(QObject*);
    extern Qt::Orientation __Qt4Ada_QDialogButtonBox_orientation_0_wrapper(QObject*);
    extern void __Qt4Ada_QDialogButtonBox_removeButton_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QDialogButtonBox_setCenterButtons_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QDialogButtonBox_setOrientation_0_wrapper(QObject*, Qt::Orientation);
    extern QDialogButtonBox::StandardButton __Qt4Ada_QDialogButtonBox_standardButton_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QDialogButtonBox_accepted_0_wrapper(QObject*);
    extern void __Qt4Ada_QDialogButtonBox_clicked_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QDialogButtonBox_helpRequested_0_wrapper(QObject*);
    extern void __Qt4Ada_QDialogButtonBox_rejected_0_wrapper(QObject*);
    extern bool __Qt4Ada_QDialogButtonBox_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QDialogButtonBox_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QDialogButtonBox_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QDialogButtonBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QDialogButtonBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QDialogButtonBox_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QDialogButtonBox_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QDialogButtonBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QDialogButtonBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QDialogButtonBox_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDialogButtonBox_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QDialogButtonBox_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QDialogButtonBox_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QDialogButtonBox_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject* __Qt4Ada_new_QDialogButtonBox(unsigned, QObject*);
    extern QObject* __Qt4Ada_new_QDialogButtonBoxDirector(void*, unsigned, QObject*);

}

class QDialogButtonBoxDirector : public QDialogButtonBox
{
protected:
    void* ada_object;
    QDialogButtonBoxDirector(void*, Qt::Orientation, QObject*);

    friend QObject* __Qt4Ada_new_QDialogButtonBoxDirector(void*, unsigned, QObject*);

    virtual bool event(QEvent*);
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QDialogButtonBox_accepted_0_wrapper(QObject*);
    friend void __Qt4Ada_QDialogButtonBox_clicked_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QDialogButtonBox_helpRequested_0_wrapper(QObject*);
    friend void __Qt4Ada_QDialogButtonBox_rejected_0_wrapper(QObject*);
    friend bool __Qt4Ada_QDialogButtonBox_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QDialogButtonBox_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QDialogButtonBox_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QDialogButtonBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QDialogButtonBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QDialogButtonBox_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QDialogButtonBox_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QDialogButtonBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QDialogButtonBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QDialogButtonBox_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDialogButtonBox_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QDialogButtonBox_sender_0_wrapper(QObject*);
};

#endif // __QDIALOGBUTTONBOXDIRECTOR_H__
