//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSize>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QKeyEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QVariant>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QPaintEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qdialogdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QDialog_staticMetaObject =
        &QDialog::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QDialog_accept_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QDialog*>(cpp_object)->accept();
    }

    void __Qt4Ada_QDialog_done_0_virtual(QObject* cpp_object, int result)
    {
        dynamic_cast<QDialog*>(cpp_object)->done(result);
    }

    void __Qt4Ada_QDialog_reject_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QDialog*>(cpp_object)->reject();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QDialog_isSizeGripEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialog*>(cpp_object)->QDialog::isSizeGripEnabled();
    }

    int __Qt4Ada_QDialog_result_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialog*>(cpp_object)->QDialog::result();
    }

    void __Qt4Ada_QDialog_setModal_0_wrapper(QObject* cpp_object, bool modal)
    {
        dynamic_cast<QDialog*>(cpp_object)->QDialog::setModal(modal);
    }

    void __Qt4Ada_QDialog_setResult_0_wrapper(QObject* cpp_object, int result)
    {
        dynamic_cast<QDialog*>(cpp_object)->QDialog::setResult(result);
    }

    void __Qt4Ada_QDialog_setSizeGripEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QDialog*>(cpp_object)->QDialog::setSizeGripEnabled(enable);
    }

    void __Qt4Ada_QDialog_accept_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDialog*>(cpp_object)->QDialog::accept();
    }

    void __Qt4Ada_QDialog_done_0_wrapper(QObject* cpp_object, int result)
    {
        dynamic_cast<QDialog*>(cpp_object)->QDialog::done(result);
    }

    int __Qt4Ada_QDialog_exec_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialog*>(cpp_object)->QDialog::exec();
    }

    void __Qt4Ada_QDialog_reject_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDialog*>(cpp_object)->QDialog::reject();
    }

    void __Qt4Ada_QDialog_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QDialog*>(cpp_object)->QDialog::minimumSizeHint();
    }

    void __Qt4Ada_QDialog_setVisible_0_wrapper(QObject* cpp_object, bool visible)
    {
        dynamic_cast<QDialog*>(cpp_object)->QDialog::setVisible(visible);
    }

    void __Qt4Ada_QDialog_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QDialog*>(cpp_object)->QDialog::sizeHint();
    }

    void __Qt4Ada_QDialog_accepted_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QDialog::accepted();
    }

    void __Qt4Ada_QDialog_finished_0_wrapper(QObject* cpp_object, int result)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QDialog::finished(result);
    }

    void __Qt4Ada_QDialog_rejected_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QDialog::rejected();
    }

    void __Qt4Ada_QDialog_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QDialog::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QDialog_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QDialog::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    bool __Qt4Ada_QDialog_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QDialogDirector*>(cpp_object)->QDialog::eventFilter(watched, event);
    }

    void __Qt4Ada_QDialog_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QDialog::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QDialog_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QDialog::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QDialog_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QDialog::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QDialog_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QDialog_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QDialog_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QDialog_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QDialog_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QDialog_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QDialog_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QDialog_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QDialog_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::event(e);
    }

    void __Qt4Ada_QDialog_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QDialog_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QDialog_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QDialog_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QDialog_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QDialog_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QDialog_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QDialog_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QDialog_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QDialog_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDialog_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDialog_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDialog_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDialog_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QDialog_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QDialog_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QDialog_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QDialog_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QDialog_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QDialogDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QDialog_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QDialog_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QDialog_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QDialog_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialogDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QDialog_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QDialog*>(cpp_this)->QDialog::qt_metacast(name);
    }

    int __Qt4Ada_QDialog_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QDialog*>(cpp_this)->QDialog::qt_metacall(_c, _id, _a);
    }

}

void QDialogDirector::accept()
{
    __Qt4Ada_QDialog_accept_0_dispatch(this->ada_object);
}

void QDialogDirector::done(int result)
{
    __Qt4Ada_QDialog_done_0_dispatch(this->ada_object, result);
}

void QDialogDirector::reject()
{
    __Qt4Ada_QDialog_reject_0_dispatch(this->ada_object);
}

QSize QDialogDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QDialogDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

QSize QDialogDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QDialogDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

bool QDialogDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QDialogDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

int QDialogDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QDialogDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QDialogDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QDialogDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QDialogDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QDialogDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QDialogDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QDialogDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

void QDialogDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QDialogDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QDialogDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QDialogDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QDialogDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QDialogDirector::QDialogDirector(void* o, QWidget*parent,Qt::WindowFlags flags) :
    QDialog (parent, flags),
    ada_object (o)
{
}

extern "C" {

    QObject * __Qt4Ada_new_QDialog (QObject * parent, unsigned f)
    {
       return dynamic_cast<QObject *>
          (new QDialog (dynamic_cast<QWidget*> (parent),
                        static_cast<Qt::WindowFlags> (f)));
    }

    QObject* __Qt4Ada_new_QDialogDirector(void* ada_object, QWidget* parent, unsigned f)
    {
        return dynamic_cast<QObject*>
                (new QDialogDirector(ada_object, parent, static_cast<Qt::WindowType>(f)));
    }

}
