//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QDOCKWIDGETDIRECTOR_H__
#define __QDOCKWIDGETDIRECTOR_H__

#include <QDockWidget>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QDockWidget_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QDockWidget_isFloating_0_wrapper(QObject*);
    extern void __Qt4Ada_QDockWidget_setFloating_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QDockWidget_setTitleBarWidget_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QDockWidget_setWidget_0_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QDockWidget_titleBarWidget_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QDockWidget_toggleViewAction_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QDockWidget_widget_0_wrapper(QObject*);
    extern void __Qt4Ada_QDockWidget_topLevelChanged_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QDockWidget_visibilityChanged_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QDockWidget_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_closeEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QDockWidget_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QDockWidget_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QDockWidget_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QDockWidget_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QDockWidget_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QDockWidget_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QDockWidget_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QDockWidget_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QDockWidget_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QDockWidget_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDockWidget_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QDockWidget_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QDockWidget_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QDockWidget_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

//  Constructors
extern "C"
{

   extern QObject* __Qt4Ada_new_QDockWidget_with_QString (QString*,QObject*,unsigned f);
   extern QObject* __Qt4Ada_new_QDockWidget (QObject*,unsigned f);

   extern QObject* __Qt4Ada_new_QDockWidgetDirector_1(void*, QObject*, unsigned);
   extern QObject* __Qt4Ada_new_QDockWidgetDirector_2(void*, QString*, QObject*, unsigned);

}

extern "C"
{
   extern void __Qt4Ada_QDockWidget_setAllowedAreas_wrapper (QObject*, unsigned);
   extern void __Qt4Ada_QDockWidget_setFeatures_wrapper (QObject*, unsigned features );
}

class QDockWidgetDirector : public QDockWidget
{
protected:
    void* ada_object;
    QDockWidgetDirector(void*, QWidget*, Qt::WindowFlags);
    QDockWidgetDirector(void*, const QString&, QWidget*, Qt::WindowFlags);

    friend QObject* __Qt4Ada_new_QDockWidgetDirector_1(void*, QObject*, unsigned);
    friend QObject* __Qt4Ada_new_QDockWidgetDirector_2(void*, QString*, QObject*, unsigned);

    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual bool event(QEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QDockWidget_topLevelChanged_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QDockWidget_visibilityChanged_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QDockWidget_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_closeEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QDockWidget_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QDockWidget_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QDockWidget_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QDockWidget_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QDockWidget_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QDockWidget_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QDockWidget_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QDockWidget_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QDockWidget_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QDockWidget_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDockWidget_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QDockWidget_sender_0_wrapper(QObject*);
};

#endif // __QDOCKWIDGETDIRECTOR_H__
