//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QSize>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTimerEvent>
#include <QWheelEvent>
#include <QVariant>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qdoublespinboxdirector.h"
#include "qabstractspinboxdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QDoubleSpinBox_staticMetaObject =
        &QDoubleSpinBox::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QDoubleSpinBox_textFromValue_0_virtual(QObject* cpp_object, double val, QString* returns)
    {
        *returns = dynamic_cast<QDoubleSpinBox*>(cpp_object)->textFromValue(val);
    }

    double __Qt4Ada_QDoubleSpinBox_valueFromText_0_virtual(QObject* cpp_object, const QString* text)
    {
        return dynamic_cast<QDoubleSpinBox*>(cpp_object)->valueFromText(*text);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QDoubleSpinBox_cleanText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::cleanText();
    }

    int __Qt4Ada_QDoubleSpinBox_decimals_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::decimals();
    }

    double __Qt4Ada_QDoubleSpinBox_maximum_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::maximum();
    }

    double __Qt4Ada_QDoubleSpinBox_minimum_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::minimum();
    }

    void __Qt4Ada_QDoubleSpinBox_prefix_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::prefix();
    }

    void __Qt4Ada_QDoubleSpinBox_setDecimals_0_wrapper(QObject* cpp_object, int prec)
    {
        dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::setDecimals(prec);
    }

    void __Qt4Ada_QDoubleSpinBox_setMaximum_0_wrapper(QObject* cpp_object, double max)
    {
        dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::setMaximum(max);
    }

    void __Qt4Ada_QDoubleSpinBox_setMinimum_0_wrapper(QObject* cpp_object, double min)
    {
        dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::setMinimum(min);
    }

    void __Qt4Ada_QDoubleSpinBox_setPrefix_0_wrapper(QObject* cpp_object, const QString* prefix)
    {
        dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::setPrefix(*prefix);
    }

    void __Qt4Ada_QDoubleSpinBox_setRange_0_wrapper(QObject* cpp_object, double min, double max)
    {
        dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::setRange(min, max);
    }

    void __Qt4Ada_QDoubleSpinBox_setSingleStep_0_wrapper(QObject* cpp_object, double val)
    {
        dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::setSingleStep(val);
    }

    void __Qt4Ada_QDoubleSpinBox_setSuffix_0_wrapper(QObject* cpp_object, const QString* suffix)
    {
        dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::setSuffix(*suffix);
    }

    double __Qt4Ada_QDoubleSpinBox_singleStep_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::singleStep();
    }

    void __Qt4Ada_QDoubleSpinBox_suffix_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::suffix();
    }

    void __Qt4Ada_QDoubleSpinBox_textFromValue_0_wrapper(QObject* cpp_object, double val, QString* returns)
    {
        *returns = dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::textFromValue(val);
    }

    double __Qt4Ada_QDoubleSpinBox_value_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::value();
    }

    double __Qt4Ada_QDoubleSpinBox_valueFromText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        return dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::valueFromText(*text);
    }

    void __Qt4Ada_QDoubleSpinBox_setValue_0_wrapper(QObject* cpp_object, double val)
    {
        dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::setValue(val);
    }

    void __Qt4Ada_QDoubleSpinBox_fixup_0_wrapper(QObject* cpp_object, QString* input)
    {
        dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::fixup(*input);
    }

    QValidator::State __Qt4Ada_QDoubleSpinBox_validate_0_wrapper(QObject* cpp_object, QString* input, int pos)
    {
        return dynamic_cast<QDoubleSpinBox*>(cpp_object)->QDoubleSpinBox::validate(*input, pos);
    }

    void __Qt4Ada_QDoubleSpinBox_valueChanged_1_wrapper(QObject* cpp_object, double d)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QDoubleSpinBox::valueChanged(d);
    }

    void __Qt4Ada_QDoubleSpinBox_valueChanged_0_wrapper(QObject* cpp_object, QString* text)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QDoubleSpinBox::valueChanged(*text);
    }

    QObject* __Qt4Ada_QDoubleSpinBox_lineEdit_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::lineEdit());
    }

    void __Qt4Ada_QDoubleSpinBox_setLineEdit_0_wrapper(QObject* cpp_object, QObject* edit)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::setLineEdit(dynamic_cast<QLineEdit*>(edit));
    }

    void __Qt4Ada_QDoubleSpinBox_editingFinished_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::editingFinished();
    }

    bool __Qt4Ada_QDoubleSpinBox_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::event(e);
    }

    void __Qt4Ada_QDoubleSpinBox_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::changeEvent(event);
    }

    void __Qt4Ada_QDoubleSpinBox_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QDoubleSpinBox_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QDoubleSpinBox_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QDoubleSpinBox_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QDoubleSpinBox_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QDoubleSpinBox_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QDoubleSpinBox_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QDoubleSpinBox_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QDoubleSpinBox_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QDoubleSpinBox_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QDoubleSpinBox_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QDoubleSpinBox_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleSpinBoxDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QDoubleSpinBox_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QDoubleSpinBox*>(cpp_this)->QDoubleSpinBox::qt_metacast(name);
    }

    int __Qt4Ada_QDoubleSpinBox_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QDoubleSpinBox*>(cpp_this)->QDoubleSpinBox::qt_metacall(_c, _id, _a);
    }

}

QString QDoubleSpinBoxDirector::textFromValue(double val) const
{
    QString *aux = __Qt4Ada_QDoubleSpinBox_textFromValue_0_dispatch(this->ada_object, val);
    QString returns = *aux;
    delete aux;
    return returns;
}

double QDoubleSpinBoxDirector::valueFromText(const QString& text) const
{
    return __Qt4Ada_QDoubleSpinBox_valueFromText_0_dispatch(this->ada_object, &text);
}

void QDoubleSpinBoxDirector::fixup(QString& input) const
{
    __Qt4Ada_QAbstractSpinBox_fixup_0_dispatch(this->ada_object, &input);
}

QValidator::State QDoubleSpinBoxDirector::validate(QString& input, int pos) const
{
    return __Qt4Ada_QAbstractSpinBox_validate_0_dispatch(this->ada_object, &input, pos);
}

void QDoubleSpinBoxDirector::stepBy(int steps)
{
    __Qt4Ada_QAbstractSpinBox_stepBy_0_dispatch(this->ada_object, steps);
}

QSize QDoubleSpinBoxDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QDoubleSpinBoxDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QDoubleSpinBoxDirector::clear()
{
    __Qt4Ada_QAbstractSpinBox_clear_0_dispatch(this->ada_object);
}

bool QDoubleSpinBoxDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QDoubleSpinBoxDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QDoubleSpinBoxDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QDoubleSpinBoxDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QDoubleSpinBoxDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QDoubleSpinBoxDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QDoubleSpinBoxDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QDoubleSpinBoxDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QDoubleSpinBoxDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QDoubleSpinBoxDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QDoubleSpinBoxDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QDoubleSpinBoxDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QDoubleSpinBoxDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QDoubleSpinBoxDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QDoubleSpinBoxDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
