//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QDOUBLESPINBOXDIRECTOR_H__
#define __QDOUBLESPINBOXDIRECTOR_H__

#include <QDoubleSpinBox>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QDoubleSpinBox_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QString* __Qt4Ada_QDoubleSpinBox_textFromValue_0_dispatch(void*, double);
    extern double __Qt4Ada_QDoubleSpinBox_valueFromText_0_dispatch(void*, const QString*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QDoubleSpinBox_textFromValue_0_virtual(QObject*, double, QString*);
    extern double __Qt4Ada_QDoubleSpinBox_valueFromText_0_virtual(QObject*, const QString*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QDoubleSpinBox_cleanText_0_wrapper(QObject*, QString*);
    extern int __Qt4Ada_QDoubleSpinBox_decimals_0_wrapper(QObject*);
    extern double __Qt4Ada_QDoubleSpinBox_maximum_0_wrapper(QObject*);
    extern double __Qt4Ada_QDoubleSpinBox_minimum_0_wrapper(QObject*);
    extern void __Qt4Ada_QDoubleSpinBox_prefix_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QDoubleSpinBox_setDecimals_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QDoubleSpinBox_setMaximum_0_wrapper(QObject*, double);
    extern void __Qt4Ada_QDoubleSpinBox_setMinimum_0_wrapper(QObject*, double);
    extern void __Qt4Ada_QDoubleSpinBox_setPrefix_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QDoubleSpinBox_setRange_0_wrapper(QObject*, double, double);
    extern void __Qt4Ada_QDoubleSpinBox_setSingleStep_0_wrapper(QObject*, double);
    extern void __Qt4Ada_QDoubleSpinBox_setSuffix_0_wrapper(QObject*, const QString*);
    extern double __Qt4Ada_QDoubleSpinBox_singleStep_0_wrapper(QObject*);
    extern void __Qt4Ada_QDoubleSpinBox_suffix_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QDoubleSpinBox_textFromValue_0_wrapper(QObject*, double, QString*);
    extern double __Qt4Ada_QDoubleSpinBox_value_0_wrapper(QObject*);
    extern double __Qt4Ada_QDoubleSpinBox_valueFromText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QDoubleSpinBox_setValue_0_wrapper(QObject*, double);
    extern void __Qt4Ada_QDoubleSpinBox_fixup_0_wrapper(QObject*, QString*);
    extern QValidator::State __Qt4Ada_QDoubleSpinBox_validate_0_wrapper(QObject*, QString*, int);
    extern void __Qt4Ada_QDoubleSpinBox_valueChanged_1_wrapper(QObject*, double);
    extern void __Qt4Ada_QDoubleSpinBox_valueChanged_0_wrapper(QObject*, QString*);
    extern QObject* __Qt4Ada_QDoubleSpinBox_lineEdit_0_wrapper(QObject*);
    extern void __Qt4Ada_QDoubleSpinBox_setLineEdit_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QDoubleSpinBox_editingFinished_0_wrapper(QObject*);
    extern bool __Qt4Ada_QDoubleSpinBox_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QDoubleSpinBox_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QDoubleSpinBox_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QDoubleSpinBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QDoubleSpinBox_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QDoubleSpinBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QDoubleSpinBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QDoubleSpinBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QDoubleSpinBox_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDoubleSpinBox_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QDoubleSpinBox_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QDoubleSpinBox_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QDoubleSpinBox_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
#include <QLineEdit>  //  Эта директива должна генерироваться автоматически!

class QDoubleSpinBoxDirector : public QDoubleSpinBox
{
protected:
    void* ada_object;
    QDoubleSpinBoxDirector();

    virtual QString textFromValue(double) const;
    virtual double valueFromText(const QString&) const;
    virtual void fixup(QString&) const;
    virtual QValidator::State validate(QString&, int) const;
    virtual void stepBy(int);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void clear();
    virtual bool event(QEvent*);
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QDoubleSpinBox_valueChanged_1_wrapper(QObject*, double);
    friend void __Qt4Ada_QDoubleSpinBox_valueChanged_0_wrapper(QObject*, QString*);
    friend QObject* __Qt4Ada_QDoubleSpinBox_lineEdit_0_wrapper(QObject*);
    friend void __Qt4Ada_QDoubleSpinBox_setLineEdit_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QDoubleSpinBox_editingFinished_0_wrapper(QObject*);
    friend bool __Qt4Ada_QDoubleSpinBox_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QDoubleSpinBox_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QDoubleSpinBox_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QDoubleSpinBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QDoubleSpinBox_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QDoubleSpinBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QDoubleSpinBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QDoubleSpinBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QDoubleSpinBox_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDoubleSpinBox_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QDoubleSpinBox_sender_0_wrapper(QObject*);
};

#endif // __QDOUBLESPINBOXDIRECTOR_H__
