//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QChildEvent>
#include <QTimerEvent>

#include "qdoublevalidatordirector.h"
#include "qvalidatordirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QDoubleValidator_staticMetaObject =
        &QDoubleValidator::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QDoubleValidator_setRange_0_virtual(QObject* cpp_object, double bottom, double top, int decimals)
    {
        dynamic_cast<QDoubleValidator*>(cpp_object)->setRange(bottom, top, decimals);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    double __Qt4Ada_QDoubleValidator_bottom_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleValidator*>(cpp_object)->QDoubleValidator::bottom();
    }

    int __Qt4Ada_QDoubleValidator_decimals_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleValidator*>(cpp_object)->QDoubleValidator::decimals();
    }

    void __Qt4Ada_QDoubleValidator_setBottom_0_wrapper(QObject* cpp_object, double bottom)
    {
        dynamic_cast<QDoubleValidator*>(cpp_object)->QDoubleValidator::setBottom(bottom);
    }

    void __Qt4Ada_QDoubleValidator_setDecimals_0_wrapper(QObject* cpp_object, int decimals)
    {
        dynamic_cast<QDoubleValidator*>(cpp_object)->QDoubleValidator::setDecimals(decimals);
    }

    void __Qt4Ada_QDoubleValidator_setRange_0_wrapper(QObject* cpp_object, double bottom, double top, int decimals)
    {
        dynamic_cast<QDoubleValidator*>(cpp_object)->QDoubleValidator::setRange(bottom, top, decimals);
    }

    void __Qt4Ada_QDoubleValidator_setTop_0_wrapper(QObject* cpp_object, double top)
    {
        dynamic_cast<QDoubleValidator*>(cpp_object)->QDoubleValidator::setTop(top);
    }

    double __Qt4Ada_QDoubleValidator_top_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleValidator*>(cpp_object)->QDoubleValidator::top();
    }

    void __Qt4Ada_QDoubleValidator_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleValidatorDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QDoubleValidator_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleValidatorDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QDoubleValidator_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDoubleValidatorDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QDoubleValidator_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDoubleValidatorDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QDoubleValidator_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QDoubleValidator*>(cpp_this)->QDoubleValidator::qt_metacast(name);
    }

    int __Qt4Ada_QDoubleValidator_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QDoubleValidator*>(cpp_this)->QDoubleValidator::qt_metacall(_c, _id, _a);
    }

}

void QDoubleValidatorDirector::setRange(double bottom, double top, int decimals)
{
    __Qt4Ada_QDoubleValidator_setRange_0_dispatch(this->ada_object, bottom, top, decimals);
}

void QDoubleValidatorDirector::fixup(QString& input) const
{
    __Qt4Ada_QValidator_fixup_0_dispatch(this->ada_object, &input);
}

bool QDoubleValidatorDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QDoubleValidatorDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QDoubleValidatorDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QDoubleValidatorDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QDoubleValidatorDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QDoubleValidatorDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QDoubleValidatorDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QDoubleValidatorDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{

    QValidator::State __Qt4Ada_QDoubleValidator_validate_wrapper(QObject* cpp_this, QString* input, int* pos)
    {
        return dynamic_cast<QDoubleValidator*>(cpp_this)->QDoubleValidator::validate(*input, *pos);
    }

}
