//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2733 $ $Date: 2008-05-14 08:54:18 +0400 (Wed, 14 May 2008) $
//----------------------------------------------------------------------------
#include "qdropeventwrapper.h"
#include <QWidget>

extern "C" {
    //  Declarations of wrapper functions for static call

    void __Qt4Ada_QDropEvent_acceptProposedAction_wrapper (QEvent*cpp_this)
    {
      dynamic_cast <QDropEvent*> (cpp_this) -> acceptProposedAction() ;
    }
    unsigned __Qt4Ada_QDropEvent_dropAction_wrapper (QEvent*cpp_this)
    {
      return ((unsigned)dynamic_cast <QDropEvent*> (cpp_this) -> dropAction());
    }
    unsigned __Qt4Ada_QDropEvent_keyboardModifiers_wrapper (QEvent*cpp_this)
    {
      return ((unsigned)dynamic_cast <QDropEvent*> (cpp_this) -> keyboardModifiers());
    }
//     QMimeData* __Qt4Ada_QDropEvent_mimdeData_wrapper (QEvent*);

    unsigned __Qt4Ada_QDropEvent_mouseButtons_wrapper (QEvent*cpp_this)
    {
      return ((unsigned)dynamic_cast <QDropEvent*> (cpp_this) -> mouseButtons());
    }

    QPoint * __Qt4Ada_QDropEvent_pos_wrapper (QEvent*cpp_this)
    {
       QPoint p =  dynamic_cast <QDropEvent*> (cpp_this) ->  pos();
       return (new QPoint (p.x(), p.y()));
    }

    unsigned __Qt4Ada_QDropEvent_possibleActions_wrapper (QEvent*cpp_this)
    {
      return ((unsigned)dynamic_cast <QDropEvent*> (cpp_this) -> possibleActions());
     }
    unsigned __Qt4Ada_QDropEvent_proposedAction_wrapper (QEvent*cpp_this)
    {
      return ((unsigned)dynamic_cast <QDropEvent*> (cpp_this) -> proposedAction());
    }
    void __Qt4Ada_QDropEvent_setDropAction_wrapper (QEvent*cpp_this,unsigned action)
    {
      dynamic_cast <QDropEvent*> (cpp_this) -> setDropAction((Qt::DropAction)action );
    }

    QObject* __Qt4Ada_QDropEvent_source_wrapper (QEvent*cpp_this)
    {
      return static_cast <QObject*> (dynamic_cast <QDropEvent*> (cpp_this) -> source());
    }
}
