//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include "qfontinfowrapper.h"

extern "C"
{

    QFontInfo* __QtAda_inititialize_QFontInfo_QFontCR(void* storage, const QFont* font)
    {
        return new (storage) QFontInfo(*font);
    }

    QFontInfo* __QtAda_adjust_QFontInfo(void* storage, const QFontInfo* from)
    {
        return new (storage) QFontInfo(*from);
    }

    void __QtAda_finalize_QFontInfo(QFontInfo *item)
    {
        item->~QFontInfo();
    }

    unsigned __QtAda_QFontInfo_bold_Q(const QFontInfo* self)
    {
        return (unsigned)self->bold();
    }

    unsigned __QtAda_QFontInfo_exactMatch_Q(const QFontInfo* self)
    {
        return (unsigned)self->exactMatch();
    }

    void __QtAda_QFontInfo_family_Q(QString* returns, const QFontInfo* self)
    {
        *returns = self->family();
    }

    unsigned __QtAda_QFontInfo_fixedPitch_Q(const QFontInfo* self)
    {
        return (unsigned)self->fixedPitch();
    }

    unsigned __QtAda_QFontInfo_italic_Q(const QFontInfo* self)
    {
        return (unsigned)self->italic();
    }

    int __QtAda_QFontInfo_pixelSize_Q(const QFontInfo* self)
    {
        return self->pixelSize();
    }

    int __QtAda_QFontInfo_pointSize_Q(const QFontInfo* self)
    {
        return self->pointSize();
    }

    double __QtAda_QFontInfo_pointSizeF_Q(const QFontInfo* self)
    {
        return (double)self->pointSizeF();
    }

    unsigned __QtAda_QFontInfo_rawMode_Q(const QFontInfo* self)
    {
        return (unsigned)self->rawMode();
    }

    unsigned __QtAda_QFontInfo_style_Q(const QFontInfo* self)
    {
        return (unsigned)self->style();
    }

    unsigned __QtAda_QFontInfo_styleHint_Q(const QFontInfo* self)
    {
        return (unsigned)self->styleHint();
    }

    int __QtAda_QFontInfo_weight_Q(const QFontInfo* self)
    {
        return self->weight();
    }

    unsigned __QtAda_QFontInfo_overline_Q(const QFontInfo* self)
    {
        return (unsigned)self->overline();
    }

    unsigned __QtAda_QFontInfo_strikeOut_Q(const QFontInfo* self)
    {
        return (unsigned)self->strikeOut();
    }

    unsigned __QtAda_QFontInfo_underline_Q(const QFontInfo* self)
    {
        return (unsigned)self->underline();
    }

};
