//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QFont>
#include <QString>
#include <QStringList>
#include "qfontwrapper.h"

extern "C"
{

    QFont* __QtAda_inititialize_QFont(void* storage)
    {
        return new (storage) QFont();
    }

    QFont* __QtAda_inititialize_QFont_QStringCR_int_Weight_bool(void* storage, const QString* family, int pointSize, int weight, unsigned italic)
    {
        return new (storage) QFont(*family, pointSize, (QFont::Weight)weight, (bool)italic);
    }

    QFont* __QtAda_adjust_QFont(void* storage, const QFont* from)
    {
        return new (storage) QFont(*from);
    }

    void __QtAda_finalize_QFont(QFont *item)
    {
        item->~QFont();
    }

    unsigned __QtAda_QFont_bold_Q(const QFont* self)
    {
        return (unsigned)self->bold();
    }

    void __QtAda_QFont_defaultFamily_Q(QString* returns, const QFont* self)
    {
        *returns = self->defaultFamily();
    }

    unsigned __QtAda_QFont_exactMatch_Q(const QFont* self)
    {
        return (unsigned)self->exactMatch();
    }

    void __QtAda_QFont_family_Q(QString* returns, const QFont* self)
    {
        *returns = self->family();
    }

    unsigned __QtAda_QFont_fixedPitch_Q(const QFont* self)
    {
        return (unsigned)self->fixedPitch();
    }

    unsigned __QtAda_QFont_fromString_QStringCR(QFont* self, const QString* descrip)
    {
        return (unsigned)self->fromString(*descrip);
    }

    unsigned __QtAda_QFont_isCopyOf_QFontCR_Q(const QFont* self, const QFont* f)
    {
        return (unsigned)self->isCopyOf(*f);
    }

    unsigned __QtAda_QFont_italic_Q(const QFont* self)
    {
        return (unsigned)self->italic();
    }

    unsigned __QtAda_QFont_kerning_Q(const QFont* self)
    {
        return (unsigned)self->kerning();
    }

    void __QtAda_QFont_key_Q(QString* returns, const QFont* self)
    {
        *returns = self->key();
    }

    void __QtAda_QFont_lastResortFamily_Q(QString* returns, const QFont* self)
    {
        *returns = self->lastResortFamily();
    }

    void __QtAda_QFont_lastResortFont_Q(QString* returns, const QFont* self)
    {
        *returns = self->lastResortFont();
    }

    unsigned __QtAda_QFont_overline_Q(const QFont* self)
    {
        return (unsigned)self->overline();
    }

    int __QtAda_QFont_pixelSize_Q(const QFont* self)
    {
        return self->pixelSize();
    }

    int __QtAda_QFont_pointSize_Q(const QFont* self)
    {
        return self->pointSize();
    }

    double __QtAda_QFont_pointSizeF_Q(const QFont* self)
    {
        return (double)self->pointSizeF();
    }

    unsigned __QtAda_QFont_rawMode_Q(const QFont* self)
    {
        return (unsigned)self->rawMode();
    }

    void __QtAda_QFont_rawName_Q(QString* returns, const QFont* self)
    {
        *returns = self->rawName();
    }

    void __QtAda_QFont_resolve_QFontCR_Q(QFont* returns, const QFont* self, const QFont* f)
    {
        *returns = self->resolve(*f);
    }

    void __QtAda_QFont_setBold_bool(QFont* self, unsigned enable)
    {
        self->setBold((bool)enable);
    }

    void __QtAda_QFont_setFamily_QStringCR(QFont* self, const QString* family)
    {
        self->setFamily(*family);
    }

    void __QtAda_QFont_setFixedPitch_bool(QFont* self, unsigned enable)
    {
        self->setFixedPitch((bool)enable);
    }

    void __QtAda_QFont_setItalic_bool(QFont* self, unsigned enable)
    {
        self->setItalic((bool)enable);
    }

    void __QtAda_QFont_setKerning_bool(QFont* self, unsigned enable)
    {
        self->setKerning((bool)enable);
    }

    void __QtAda_QFont_setOverline_bool(QFont* self, unsigned enable)
    {
        self->setOverline((bool)enable);
    }

    void __QtAda_QFont_setPixelSize_int(QFont* self, int size)
    {
        self->setPixelSize(size);
    }

    void __QtAda_QFont_setPointSize_int(QFont* self, int size)
    {
        self->setPointSize(size);
    }

    void __QtAda_QFont_setPointSizeF_qreal(QFont* self, double size)
    {
        self->setPointSizeF((qreal)size);
    }

    void __QtAda_QFont_setRawMode_bool(QFont* self, unsigned enable)
    {
        self->setRawMode((bool)enable);
    }

    void __QtAda_QFont_setRawName_QStringCR(QFont* self, const QString* name)
    {
        self->setRawName(*name);
    }

    void __QtAda_QFont_setStretch_Stretch(QFont* self, unsigned factor)
    {
        self->setStretch((QFont::Stretch)factor);
    }

    void __QtAda_QFont_setStrikeOut_bool(QFont* self, unsigned enable)
    {
        self->setStrikeOut((bool)enable);
    }

    void __QtAda_QFont_setStyle_Style(QFont* self, unsigned style)
    {
        self->setStyle((QFont::Style)style);
    }

    void __QtAda_QFont_setUnderline_bool(QFont* self, unsigned enable)
    {
        self->setUnderline((bool)enable);
    }

    void __QtAda_QFont_setWeight_Weight(QFont* self, int weight)
    {
        self->setWeight((QFont::Weight)weight);
    }

    unsigned __QtAda_QFont_stretch_Q(const QFont* self)
    {
        return (unsigned)self->stretch();
    }

    unsigned __QtAda_QFont_strikeOut_Q(const QFont* self)
    {
        return (unsigned)self->strikeOut();
    }

    unsigned __QtAda_QFont_style_Q(const QFont* self)
    {
        return (unsigned)self->style();
    }

    unsigned __QtAda_QFont_styleHint_Q(const QFont* self)
    {
        return (unsigned)self->styleHint();
    }

    void __QtAda_QFont_toString_Q(QString* returns, const QFont* self)
    {
        *returns = self->toString();
    }

    unsigned __QtAda_QFont_underline_Q(const QFont* self)
    {
        return (unsigned)self->underline();
    }

    int __QtAda_QFont_weight_Q(const QFont* self)
    {
        return (int)self->weight();
    }

    unsigned __QtAda_QFont_eq_QFontCR_Q(const QFont* self, const QFont* f)
    {
        return (unsigned)self->operator==(*f);
    }

    unsigned __QtAda_QFont_lt_QFontCR_Q(const QFont* self, const QFont* f)
    {
        return (unsigned)self->operator<(*f);
    }

    void __QtAda_QFont_insertSubstitution_QStringCR_QStringCR_S(const QString* familyName, const QString* substituteName)
    {
        QFont::insertSubstitution(*familyName, *substituteName);
    }

    void __QtAda_QFont_insertSubstitutions_QStringCR_QStringListCR_S(const QString* familyName, const QStringList* substituteNames)
    {
        QFont::insertSubstitutions(*familyName, *substituteNames);
    }

    void __QtAda_QFont_removeSubstitution_QStringCR_S(const QString* familyName)
    {
        QFont::removeSubstitution(*familyName);
    }

    void __QtAda_QFont_substitute_QStringCR_S(QString* returns, const QString* familyName)
    {
        *returns = QFont::substitute(*familyName);
    }

    void __QtAda_QFont_substitutes_QStringCR_S(QStringList* returns, const QString* familyName)
    {
        *returns = QFont::substitutes(*familyName);
    }

    void __QtAda_QFont_substitutions_S(QStringList* returns)
    {
        *returns = QFont::substitutions();
    }

};

