//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009, 2010 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QGRAPHICSITEMDIRECTOR_H__
#define __QGRAPHICSITEMDIRECTOR_H__

#include <QGraphicsItem>

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QGraphicsItem_advance_0_dispatch(void*, int);
    extern QRectF* __Qt4Ada_QGraphicsItem_boundingRect_0_dispatch(void*);
    extern bool __Qt4Ada_QGraphicsItem_collidesWithItem_0_dispatch(void*, const QGraphicsItem*, Qt::ItemSelectionMode);
    extern bool __Qt4Ada_QGraphicsItem_collidesWithPath_0_dispatch(void*, const QPainterPath*, Qt::ItemSelectionMode);
    extern bool __Qt4Ada_QGraphicsItem_contains_0_dispatch(void*, const QPointF*);
    extern bool __Qt4Ada_QGraphicsItem_isObscuredBy_0_dispatch(void*, const QGraphicsItem*);
    extern QPainterPath* __Qt4Ada_QGraphicsItem_opaqueArea_0_dispatch(void*);
    extern QPainterPath* __Qt4Ada_QGraphicsItem_shape_0_dispatch(void*);
    extern void __Qt4Ada_QGraphicsItem_contextMenuEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_dragEnterEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_dragLeaveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_dragMoveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_dropEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_focusInEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_focusOutEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_hoverEnterEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_hoverMoveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_inputMethodEvent_0_dispatch(void*, QEvent*);
    extern QVariant* __Qt4Ada_QGraphicsItem_inputMethodQuery_0_dispatch(void*, Qt::InputMethodQuery);
    extern QVariant* __Qt4Ada_QGraphicsItem_itemChange_0_dispatch(void*, QGraphicsItem::GraphicsItemChange, const QVariant*);
    extern void __Qt4Ada_QGraphicsItem_keyPressEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_keyReleaseEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_mouseMoveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_mousePressEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_dispatch(void*, QEvent*);
    extern bool __Qt4Ada_QGraphicsItem_sceneEvent_0_dispatch(void*, QEvent*);
    extern bool __Qt4Ada_QGraphicsItem_sceneEventFilter_0_dispatch(void*, QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_wheelEvent_0_dispatch(void*, QEvent*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QGraphicsItem_advance_0_virtual(QGraphicsItem*, int);
    extern void __Qt4Ada_QGraphicsItem_boundingRect_0_virtual(QGraphicsItem*, QRectF*);
    extern bool __Qt4Ada_QGraphicsItem_collidesWithItem_0_virtual(QGraphicsItem*, const QGraphicsItem*, Qt::ItemSelectionMode);
    extern bool __Qt4Ada_QGraphicsItem_collidesWithPath_0_virtual(QGraphicsItem*, const QPainterPath*, Qt::ItemSelectionMode);
    extern bool __Qt4Ada_QGraphicsItem_contains_0_virtual(QGraphicsItem*, const QPointF*);
    extern bool __Qt4Ada_QGraphicsItem_isObscuredBy_0_virtual(QGraphicsItem*, const QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_opaqueArea_0_virtual(QGraphicsItem*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsItem_shape_0_virtual(QGraphicsItem*, QPainterPath*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QGraphicsItem_acceptDrops_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_acceptHoverEvents_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_acceptTouchEvents_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_advance_0_wrapper(QGraphicsItem*, int);
    extern void __Qt4Ada_QGraphicsItem_boundingRegion_0_wrapper(QGraphicsItem*, const QTransform*, QRegion*);
    extern qreal __Qt4Ada_QGraphicsItem_boundingRegionGranularity_0_wrapper(QGraphicsItem*);
    extern QGraphicsItem::CacheMode __Qt4Ada_QGraphicsItem_cacheMode_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_childrenBoundingRect_0_wrapper(QGraphicsItem*, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_clearFocus_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_clipPath_0_wrapper(QGraphicsItem*, QPainterPath*);
    extern bool __Qt4Ada_QGraphicsItem_collidesWithItem_0_wrapper(QGraphicsItem*, const QGraphicsItem*, Qt::ItemSelectionMode);
    extern bool __Qt4Ada_QGraphicsItem_collidesWithPath_0_wrapper(QGraphicsItem*, const QPainterPath*, Qt::ItemSelectionMode);
    extern QGraphicsItem* __Qt4Ada_QGraphicsItem_commonAncestorItem_0_wrapper(QGraphicsItem*, QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_contains_0_wrapper(QGraphicsItem*, const QPointF*);
    extern void __Qt4Ada_QGraphicsItem_cursor_0_wrapper(QGraphicsItem*, QCursor*);
    extern void __Qt4Ada_QGraphicsItem_data_0_wrapper(QGraphicsItem*, int, QVariant*);
    extern void __Qt4Ada_QGraphicsItem_deviceTransform_0_wrapper(QGraphicsItem*, const QTransform*, QTransform*);
    extern qreal __Qt4Ada_QGraphicsItem_effectiveOpacity_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_ensureVisible_1_wrapper(QGraphicsItem*, const QRectF*, int, int);
    extern void __Qt4Ada_QGraphicsItem_ensureVisible_0_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal, int, int);
    extern bool __Qt4Ada_QGraphicsItem_filtersChildEvents_0_wrapper(QGraphicsItem*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsItem_focusItem_0_wrapper(QGraphicsItem*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsItem_focusProxy_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_grabKeyboard_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_grabMouse_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_handlesChildEvents_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_hasCursor_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_hasFocus_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_hide_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_installSceneEventFilter_0_wrapper(QGraphicsItem*, QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isActive_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isAncestorOf_0_wrapper(QGraphicsItem*, const QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isClipped_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isEnabled_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isObscured_2_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isObscured_1_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal);
    extern bool __Qt4Ada_QGraphicsItem_isObscured_0_wrapper(QGraphicsItem*, const QRectF*);
    extern bool __Qt4Ada_QGraphicsItem_isObscuredBy_0_wrapper(QGraphicsItem*, const QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isPanel_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isSelected_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isUnderMouse_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isVisible_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isVisibleTo_0_wrapper(QGraphicsItem*, const QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isWidget_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_isWindow_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_mapFromItem_5_wrapper(QGraphicsItem*, const QGraphicsItem*, const QPointF*, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromItem_4_wrapper(QGraphicsItem*, const QGraphicsItem*, const QRectF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromItem_3_wrapper(QGraphicsItem*, const QGraphicsItem*, const QPolygonF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromItem_2_wrapper(QGraphicsItem*, const QGraphicsItem*, const QPainterPath*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsItem_mapFromItem_1_wrapper(QGraphicsItem*, const QGraphicsItem*, qreal, qreal, qreal, qreal, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromItem_0_wrapper(QGraphicsItem*, const QGraphicsItem*, qreal, qreal, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromParent_5_wrapper(QGraphicsItem*, const QPointF*, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromParent_4_wrapper(QGraphicsItem*, const QRectF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromParent_3_wrapper(QGraphicsItem*, const QPolygonF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromParent_2_wrapper(QGraphicsItem*, const QPainterPath*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsItem_mapFromParent_1_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromParent_0_wrapper(QGraphicsItem*, qreal, qreal, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromScene_5_wrapper(QGraphicsItem*, const QPointF*, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromScene_4_wrapper(QGraphicsItem*, const QRectF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromScene_3_wrapper(QGraphicsItem*, const QPolygonF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromScene_2_wrapper(QGraphicsItem*, const QPainterPath*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsItem_mapFromScene_1_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapFromScene_0_wrapper(QGraphicsItem*, qreal, qreal, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectFromItem_1_wrapper(QGraphicsItem*, const QGraphicsItem*, const QRectF*, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectFromItem_0_wrapper(QGraphicsItem*, const QGraphicsItem*, qreal, qreal, qreal, qreal, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectFromParent_1_wrapper(QGraphicsItem*, const QRectF*, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectFromParent_0_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectFromScene_1_wrapper(QGraphicsItem*, const QRectF*, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectFromScene_0_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectToItem_1_wrapper(QGraphicsItem*, const QGraphicsItem*, const QRectF*, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectToItem_0_wrapper(QGraphicsItem*, const QGraphicsItem*, qreal, qreal, qreal, qreal, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectToParent_1_wrapper(QGraphicsItem*, const QRectF*, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectToParent_0_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectToScene_1_wrapper(QGraphicsItem*, const QRectF*, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapRectToScene_0_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_mapToItem_5_wrapper(QGraphicsItem*, const QGraphicsItem*, const QPointF*, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapToItem_4_wrapper(QGraphicsItem*, const QGraphicsItem*, const QRectF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapToItem_3_wrapper(QGraphicsItem*, const QGraphicsItem*, const QPolygonF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapToItem_2_wrapper(QGraphicsItem*, const QGraphicsItem*, const QPainterPath*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsItem_mapToItem_1_wrapper(QGraphicsItem*, const QGraphicsItem*, qreal, qreal, qreal, qreal, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapToItem_0_wrapper(QGraphicsItem*, const QGraphicsItem*, qreal, qreal, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapToParent_5_wrapper(QGraphicsItem*, const QPointF*, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapToParent_4_wrapper(QGraphicsItem*, const QRectF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapToParent_3_wrapper(QGraphicsItem*, const QPolygonF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapToParent_2_wrapper(QGraphicsItem*, const QPainterPath*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsItem_mapToParent_1_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapToParent_0_wrapper(QGraphicsItem*, qreal, qreal, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapToScene_5_wrapper(QGraphicsItem*, const QPointF*, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_mapToScene_4_wrapper(QGraphicsItem*, const QRectF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapToScene_3_wrapper(QGraphicsItem*, const QPolygonF*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapToScene_2_wrapper(QGraphicsItem*, const QPainterPath*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsItem_mapToScene_1_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal, QPolygonF*);
    extern void __Qt4Ada_QGraphicsItem_mapToScene_0_wrapper(QGraphicsItem*, qreal, qreal, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_matrix_0_wrapper(QGraphicsItem*, QMatrix*);
    extern void __Qt4Ada_QGraphicsItem_moveBy_0_wrapper(QGraphicsItem*, qreal, qreal);
    extern qreal __Qt4Ada_QGraphicsItem_opacity_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_opaqueArea_0_wrapper(QGraphicsItem*, QPainterPath*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsItem_panel_0_wrapper(QGraphicsItem*);
    extern QGraphicsItem::PanelModality __Qt4Ada_QGraphicsItem_panelModality_0_wrapper(QGraphicsItem*);
    extern QObject* __Qt4Ada_QGraphicsItem_parentObject_0_wrapper(QGraphicsItem*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsItem_parentItem_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_pos_0_wrapper(QGraphicsItem*, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_removeSceneEventFilter_0_wrapper(QGraphicsItem*, QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_resetMatrix_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_resetTransform_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_rotate_0_wrapper(QGraphicsItem*, qreal);
    extern qreal __Qt4Ada_QGraphicsItem_rotation_0_wrapper(QGraphicsItem*);
    extern qreal __Qt4Ada_QGraphicsItem_scale_1_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_scale_0_wrapper(QGraphicsItem*, qreal, qreal);
    extern QObject* __Qt4Ada_QGraphicsItem_scene_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_sceneBoundingRect_0_wrapper(QGraphicsItem*, QRectF*);
    extern void __Qt4Ada_QGraphicsItem_sceneMatrix_0_wrapper(QGraphicsItem*, QMatrix*);
    extern void __Qt4Ada_QGraphicsItem_scenePos_0_wrapper(QGraphicsItem*, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_sceneTransform_0_wrapper(QGraphicsItem*, QTransform*);
    extern void __Qt4Ada_QGraphicsItem_scroll_0_wrapper(QGraphicsItem*, qreal, qreal, const QRectF*);
    extern void __Qt4Ada_QGraphicsItem_setAcceptDrops_0_wrapper(QGraphicsItem*, bool);
    extern void __Qt4Ada_QGraphicsItem_setAcceptHoverEvents_0_wrapper(QGraphicsItem*, bool);
    extern void __Qt4Ada_QGraphicsItem_setAcceptTouchEvents_0_wrapper(QGraphicsItem*, bool);
    extern void __Qt4Ada_QGraphicsItem_setActive_0_wrapper(QGraphicsItem*, bool);
    extern void __Qt4Ada_QGraphicsItem_setBoundingRegionGranularity_0_wrapper(QGraphicsItem*, qreal);
    extern void __Qt4Ada_QGraphicsItem_setCacheMode_0_wrapper(QGraphicsItem*, QGraphicsItem::CacheMode, const QSize*);
    extern void __Qt4Ada_QGraphicsItem_setCursor_0_wrapper(QGraphicsItem*, const QCursor*);
    extern void __Qt4Ada_QGraphicsItem_setData_0_wrapper(QGraphicsItem*, int, const QVariant*);
    extern void __Qt4Ada_QGraphicsItem_setEnabled_0_wrapper(QGraphicsItem*, bool);
    extern void __Qt4Ada_QGraphicsItem_setFiltersChildEvents_0_wrapper(QGraphicsItem*, bool);
    extern void __Qt4Ada_QGraphicsItem_setFlag_0_wrapper(QGraphicsItem*, QGraphicsItem::GraphicsItemFlag, bool);
    extern void __Qt4Ada_QGraphicsItem_setFocusProxy_0_wrapper(QGraphicsItem*, QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_setHandlesChildEvents_0_wrapper(QGraphicsItem*, bool);
    extern void __Qt4Ada_QGraphicsItem_setMatrix_0_wrapper(QGraphicsItem*, const QMatrix*, bool);
    extern void __Qt4Ada_QGraphicsItem_setOpacity_0_wrapper(QGraphicsItem*, qreal);
    extern void __Qt4Ada_QGraphicsItem_setPanelModality_0_wrapper(QGraphicsItem*, QGraphicsItem::PanelModality);
    extern void __Qt4Ada_QGraphicsItem_setParentItem_0_wrapper(QGraphicsItem*, QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_setPos_1_wrapper(QGraphicsItem*, const QPointF*);
    extern void __Qt4Ada_QGraphicsItem_setPos_0_wrapper(QGraphicsItem*, qreal, qreal);
    extern void __Qt4Ada_QGraphicsItem_setRotation_0_wrapper(QGraphicsItem*, qreal);
    extern void __Qt4Ada_QGraphicsItem_setScale_0_wrapper(QGraphicsItem*, qreal);
    extern void __Qt4Ada_QGraphicsItem_setSelected_0_wrapper(QGraphicsItem*, bool);
    extern void __Qt4Ada_QGraphicsItem_setToolTip_0_wrapper(QGraphicsItem*, const QString*);
    extern void __Qt4Ada_QGraphicsItem_setTransform_0_wrapper(QGraphicsItem*, const QTransform*, bool);
    extern void __Qt4Ada_QGraphicsItem_setTransformOriginPoint_1_wrapper(QGraphicsItem*, const QPointF*);
    extern void __Qt4Ada_QGraphicsItem_setTransformOriginPoint_0_wrapper(QGraphicsItem*, qreal, qreal);
    extern void __Qt4Ada_QGraphicsItem_setVisible_0_wrapper(QGraphicsItem*, bool);
    extern void __Qt4Ada_QGraphicsItem_setX_0_wrapper(QGraphicsItem*, qreal);
    extern void __Qt4Ada_QGraphicsItem_setY_0_wrapper(QGraphicsItem*, qreal);
    extern void __Qt4Ada_QGraphicsItem_setZValue_0_wrapper(QGraphicsItem*, qreal);
    extern void __Qt4Ada_QGraphicsItem_shape_0_wrapper(QGraphicsItem*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsItem_shear_0_wrapper(QGraphicsItem*, qreal, qreal);
    extern void __Qt4Ada_QGraphicsItem_show_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_stackBefore_0_wrapper(QGraphicsItem*, QGraphicsItem*);
    extern QObject* __Qt4Ada_QGraphicsItem_toGraphicsObject_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_toolTip_0_wrapper(QGraphicsItem*, QString*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsItem_topLevelItem_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_transform_0_wrapper(QGraphicsItem*, QTransform*);
    extern void __Qt4Ada_QGraphicsItem_transformOriginPoint_0_wrapper(QGraphicsItem*, QPointF*);
    extern void __Qt4Ada_QGraphicsItem_translate_0_wrapper(QGraphicsItem*, qreal, qreal);
    extern void __Qt4Ada_QGraphicsItem_ungrabKeyboard_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_ungrabMouse_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_unsetCursor_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_update_1_wrapper(QGraphicsItem*, const QRectF*);
    extern void __Qt4Ada_QGraphicsItem_update_0_wrapper(QGraphicsItem*, qreal, qreal, qreal, qreal);
    extern qreal __Qt4Ada_QGraphicsItem_x_0_wrapper(QGraphicsItem*);
    extern qreal __Qt4Ada_QGraphicsItem_y_0_wrapper(QGraphicsItem*);
    extern qreal __Qt4Ada_QGraphicsItem_zValue_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsItem_contextMenuEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_dragEnterEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_dragLeaveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_dragMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_dropEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_focusInEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_focusOutEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_hoverEnterEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_hoverMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_inputMethodEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_inputMethodQuery_0_wrapper(QGraphicsItem*, Qt::InputMethodQuery, QVariant*);
    extern void __Qt4Ada_QGraphicsItem_itemChange_0_wrapper(QGraphicsItem*, QGraphicsItem::GraphicsItemChange, const QVariant*, QVariant*);
    extern void __Qt4Ada_QGraphicsItem_keyPressEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_keyReleaseEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_mouseMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_mousePressEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_prepareGeometryChange_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsItem_sceneEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern bool __Qt4Ada_QGraphicsItem_sceneEventFilter_0_wrapper(QGraphicsItem*, QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsItem_wheelEvent_0_wrapper(QGraphicsItem*, QEvent*);
}
#include <QGraphicsScene>
#include <QPainter>
#include <QPainterPath>
#include <QStyleOptionGraphicsItem>

//  Functions for dispatching call of Ada subprograms.

extern "C"
{

    extern int __Qt4Ada_QGraphicsItem_type_dispatch(void*);
    extern void __Qt4Ada_QGraphicsItem_paint_dispatch(void*, QPainter*, const QStyleOption*, QObject*);
    extern void __Qt4Ada_QGraphicsItem_paint_virtual(QGraphicsItem*, QPainter*, const QStyleOption*, QObject*);
    extern void __QtAda_free_Q_Graphics_Item_Impl(void*);

}

extern "C" {

    int __Qt4Ada_QGraphicsItem_type_wrapper(QGraphicsItem*);
    int __Qt4Ada_QGraphicsItem_type_virtual(QGraphicsItem*);

    void __Qt4Ada_QGraphicsItem_setAcceptedMouseButtons_wrapper(QGraphicsItem*, unsigned);

}

extern "C" {

    extern void __QtAda_associate_Q_Graphics_Item_Impl(QGraphicsItem*, void*);
    extern void* __Qt4Ada_get_QGraphicsItem_LimitedEntity(QGraphicsItem*);
    extern void __Qt4Ada_delete_QGraphicsItem(QGraphicsItem*);
    extern QGraphicsItem* __Qt4Ada_new_QGraphicsItemDirector(void*,
                                                             QGraphicsItem*,
                                                             QGraphicsScene*);
}

class Qt4AdaQGraphicsItemUserData {

    friend void __Qt4Ada_associate_Q_Graphics_Item_Impl(QGraphicsItem*, void*);
    friend void* __Qt4Ada_get_QGraphicsItem_LimitedEntity(QGraphicsItem*);

public:
    Qt4AdaQGraphicsItemUserData();
    Qt4AdaQGraphicsItemUserData(void*, bool);
    Qt4AdaQGraphicsItemUserData(const Qt4AdaQGraphicsItemUserData &);
    Qt4AdaQGraphicsItemUserData & operator=
        (const Qt4AdaQGraphicsItemUserData & copy);
    virtual ~Qt4AdaQGraphicsItemUserData();

private:

    struct Qt4AdaQGraphicsItemUserDataPrivate
           { uint  count;
             bool  isQObject;
             void* ada_object; } *data;
};

Q_DECLARE_METATYPE(Qt4AdaQGraphicsItemUserData);

class QGraphicsItemDirector : public QGraphicsItem
{
protected:
    void* ada_object;
    QGraphicsItemDirector(void*, QGraphicsItem*, QGraphicsScene*);

    virtual void paint(QPainter * painter,
                       const QStyleOptionGraphicsItem * option,
                       QWidget * widget = 0);
//    virtual int type() const;
//  XXX Temporary commented out. May be useful sometimes.

    friend QGraphicsItem* __Qt4Ada_new_QGraphicsItemDirector(void*, QGraphicsItem*, QGraphicsScene*);

    virtual void advance(int);
    virtual QRectF boundingRect() const;
    virtual bool collidesWithItem(const QGraphicsItem*, Qt::ItemSelectionMode) const;
    virtual bool collidesWithPath(const QPainterPath&, Qt::ItemSelectionMode) const;
    virtual bool contains(const QPointF&) const;
    virtual bool isObscuredBy(const QGraphicsItem*) const;
    virtual QPainterPath opaqueArea() const;
    virtual QPainterPath shape() const;
    virtual void contextMenuEvent(QGraphicsSceneContextMenuEvent*);
    virtual void dragEnterEvent(QGraphicsSceneDragDropEvent*);
    virtual void dragLeaveEvent(QGraphicsSceneDragDropEvent*);
    virtual void dragMoveEvent(QGraphicsSceneDragDropEvent*);
    virtual void dropEvent(QGraphicsSceneDragDropEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hoverEnterEvent(QGraphicsSceneHoverEvent*);
    virtual void hoverMoveEvent(QGraphicsSceneHoverEvent*);
    virtual void hoverLeaveEvent(QGraphicsSceneHoverEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QVariant itemChange(QGraphicsItem::GraphicsItemChange, const QVariant&);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QGraphicsSceneMouseEvent*);
    virtual void mouseMoveEvent(QGraphicsSceneMouseEvent*);
    virtual void mousePressEvent(QGraphicsSceneMouseEvent*);
    virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent*);
    virtual bool sceneEvent(QEvent*);
    virtual bool sceneEventFilter(QGraphicsItem*, QEvent*);
    virtual void wheelEvent(QGraphicsSceneWheelEvent*);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QGraphicsItem_contextMenuEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_dragEnterEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_dragLeaveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_dragMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_dropEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_focusInEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_focusOutEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_hoverEnterEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_hoverMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_inputMethodEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_inputMethodQuery_0_wrapper(QGraphicsItem*, Qt::InputMethodQuery, QVariant*);
    friend void __Qt4Ada_QGraphicsItem_itemChange_0_wrapper(QGraphicsItem*, QGraphicsItem::GraphicsItemChange, const QVariant*, QVariant*);
    friend void __Qt4Ada_QGraphicsItem_keyPressEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_keyReleaseEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_mouseMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_mousePressEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_prepareGeometryChange_0_wrapper(QGraphicsItem*);
    friend bool __Qt4Ada_QGraphicsItem_sceneEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend bool __Qt4Ada_QGraphicsItem_sceneEventFilter_0_wrapper(QGraphicsItem*, QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsItem_wheelEvent_0_wrapper(QGraphicsItem*, QEvent*);
};

#endif // __QGRAPHICSITEMDIRECTOR_H__
