//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QChildEvent>
#include <QTimerEvent>
#include <QRectF>
#include <QPainterPath>
#include <QGraphicsSceneContextMenuEvent>
#include <QGraphicsSceneDragDropEvent>
#include <QFocusEvent>
#include <QGraphicsSceneHoverEvent>
#include <QInputMethodEvent>
#include <QVariant>
#include <QKeyEvent>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsSceneWheelEvent>

#include "qgraphicsobjectdirector.h"
#include "qobjectdirector.h"
#include "qgraphicsitemdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QGraphicsObject_staticMetaObject =
        &QGraphicsObject::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QGraphicsObject_enabledChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsObject::enabledChanged();
    }

    void __Qt4Ada_QGraphicsObject_opacityChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsObject::opacityChanged();
    }

    void __Qt4Ada_QGraphicsObject_parentChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsObject::parentChanged();
    }

    void __Qt4Ada_QGraphicsObject_rotationChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsObject::rotationChanged();
    }

    void __Qt4Ada_QGraphicsObject_scaleChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsObject::scaleChanged();
    }

    void __Qt4Ada_QGraphicsObject_visibleChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsObject::visibleChanged();
    }

    void __Qt4Ada_QGraphicsObject_xChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsObject::xChanged();
    }

    void __Qt4Ada_QGraphicsObject_yChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsObject::yChanged();
    }

    void __Qt4Ada_QGraphicsObject_zChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsObject::zChanged();
    }

    void __Qt4Ada_QGraphicsObject_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QGraphicsObject_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QGraphicsObject_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QObject::sender();
    }

    void __Qt4Ada_QGraphicsObject_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::contextMenuEvent(dynamic_cast<QGraphicsSceneContextMenuEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::dragEnterEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::dragLeaveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::dragMoveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::dropEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_hoverEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::hoverEnterEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_hoverMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::hoverMoveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_hoverLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::hoverLeaveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_inputMethodQuery_0_wrapper(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::inputMethodQuery(query);
    }

    void __Qt4Ada_QGraphicsObject_itemChange_0_wrapper(QObject* cpp_object, QGraphicsItem::GraphicsItemChange change, const QVariant* value, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::itemChange(change, *value);
    }

    void __Qt4Ada_QGraphicsObject_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::mouseDoubleClickEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::mouseMoveEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::mousePressEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::mouseReleaseEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsObject_prepareGeometryChange_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::prepareGeometryChange();
    }

    bool __Qt4Ada_QGraphicsObject_sceneEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::sceneEvent(event);
    }

    bool __Qt4Ada_QGraphicsObject_sceneEventFilter_0_wrapper(QObject* cpp_object, QGraphicsItem* watched, QEvent* event)
    {
        return dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::sceneEventFilter(watched, event);
    }

    void __Qt4Ada_QGraphicsObject_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsObjectDirector*>(cpp_object)->QGraphicsItem::wheelEvent(dynamic_cast<QGraphicsSceneWheelEvent*>(event));
    }

    void* __Qt4Ada_QGraphicsObject_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QGraphicsObject*>(cpp_this)->QGraphicsObject::qt_metacast(name);
    }

    int __Qt4Ada_QGraphicsObject_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QGraphicsObject*>(cpp_this)->QGraphicsObject::qt_metacall(_c, _id, _a);
    }

}

bool QGraphicsObjectDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QGraphicsObjectDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGraphicsObjectDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::advance(int phase)
{
    __Qt4Ada_QGraphicsItem_advance_0_dispatch(this->ada_object, phase);
}

QRectF QGraphicsObjectDirector::boundingRect() const
{
    QRectF *aux = __Qt4Ada_QGraphicsItem_boundingRect_0_dispatch(this->ada_object);
    QRectF returns = *aux;
    delete aux;
    return returns;
}

bool QGraphicsObjectDirector::collidesWithItem(const QGraphicsItem* other, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithItem_0_dispatch(this->ada_object, other, mode);
}

bool QGraphicsObjectDirector::collidesWithPath(const QPainterPath& path, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithPath_0_dispatch(this->ada_object, &path, mode);
}

bool QGraphicsObjectDirector::contains(const QPointF& point) const
{
    return __Qt4Ada_QGraphicsItem_contains_0_dispatch(this->ada_object, &point);
}

bool QGraphicsObjectDirector::isObscuredBy(const QGraphicsItem* item) const
{
    return __Qt4Ada_QGraphicsItem_isObscuredBy_0_dispatch(this->ada_object, item);
}

QPainterPath QGraphicsObjectDirector::opaqueArea() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_opaqueArea_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

QPainterPath QGraphicsObjectDirector::shape() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_shape_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsObjectDirector::contextMenuEvent(QGraphicsSceneContextMenuEvent* event)
{
    __Qt4Ada_QGraphicsItem_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::dragEnterEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::dragLeaveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::dragMoveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::dropEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dropEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusInEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::hoverEnterEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::hoverMoveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::hoverLeaveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QGraphicsItem_inputMethodEvent_0_dispatch(this->ada_object, event);
}

QVariant QGraphicsObjectDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QVariant QGraphicsObjectDirector::itemChange(QGraphicsItem::GraphicsItemChange change, const QVariant& value)
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_itemChange_0_dispatch(this->ada_object, change, &value);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsObjectDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsObjectDirector::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsObjectDirector::sceneEvent(QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsObjectDirector::sceneEventFilter(QGraphicsItem* watched, QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGraphicsObjectDirector::wheelEvent(QGraphicsSceneWheelEvent* event)
{
    __Qt4Ada_QGraphicsItem_wheelEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QGraphicsObjectDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QGraphicsObjectDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QGraphicsObjectDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{

    QGraphicsItem* __QtAda_dynamic_cast_QGraphicsItem_from_QObject(QObject* object)
    {
        return dynamic_cast<QGraphicsItem*>(object);
    }

}
