//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QPolygonF>
#include <QRectF>
#include <QPainterPath>
#include <QGraphicsSceneContextMenuEvent>
#include <QGraphicsSceneDragDropEvent>
#include <QFocusEvent>
#include <QGraphicsSceneHoverEvent>
#include <QInputMethodEvent>
#include <QVariant>
#include <QKeyEvent>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsSceneWheelEvent>

#include "qgraphicspolygonitemdirector.h"
#include "qabstractgraphicsshapeitemdirector.h"
#include "qgraphicsitemdirector.h"

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    Qt::FillRule __Qt4Ada_QGraphicsPolygonItem_fillRule_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsPolygonItem*>(cpp_object)->QGraphicsPolygonItem::fillRule();
    }

    void __Qt4Ada_QGraphicsPolygonItem_polygon_0_wrapper(QGraphicsItem* cpp_object, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsPolygonItem*>(cpp_object)->QGraphicsPolygonItem::polygon();
    }

    void __Qt4Ada_QGraphicsPolygonItem_setFillRule_0_wrapper(QGraphicsItem* cpp_object, Qt::FillRule rule)
    {
        dynamic_cast<QGraphicsPolygonItem*>(cpp_object)->QGraphicsPolygonItem::setFillRule(rule);
    }

    void __Qt4Ada_QGraphicsPolygonItem_setPolygon_0_wrapper(QGraphicsItem* cpp_object, const QPolygonF* polygon)
    {
        dynamic_cast<QGraphicsPolygonItem*>(cpp_object)->QGraphicsPolygonItem::setPolygon(*polygon);
    }

    void __Qt4Ada_QGraphicsPolygonItem_boundingRect_0_wrapper(QGraphicsItem* cpp_object, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsPolygonItem*>(cpp_object)->QGraphicsPolygonItem::boundingRect();
    }

    bool __Qt4Ada_QGraphicsPolygonItem_contains_0_wrapper(QGraphicsItem* cpp_object, const QPointF* point)
    {
        return dynamic_cast<QGraphicsPolygonItem*>(cpp_object)->QGraphicsPolygonItem::contains(*point);
    }

    bool __Qt4Ada_QGraphicsPolygonItem_isObscuredBy_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item)
    {
        return dynamic_cast<QGraphicsPolygonItem*>(cpp_object)->QGraphicsPolygonItem::isObscuredBy(item);
    }

    void __Qt4Ada_QGraphicsPolygonItem_opaqueArea_0_wrapper(QGraphicsItem* cpp_object, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsPolygonItem*>(cpp_object)->QGraphicsPolygonItem::opaqueArea();
    }

    void __Qt4Ada_QGraphicsPolygonItem_shape_0_wrapper(QGraphicsItem* cpp_object, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsPolygonItem*>(cpp_object)->QGraphicsPolygonItem::shape();
    }

    void __Qt4Ada_QGraphicsPolygonItem_contextMenuEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::contextMenuEvent(dynamic_cast<QGraphicsSceneContextMenuEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_dragEnterEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::dragEnterEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_dragLeaveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::dragLeaveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_dragMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::dragMoveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_dropEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::dropEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_focusInEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_focusOutEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_hoverEnterEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::hoverEnterEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_hoverMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::hoverMoveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_hoverLeaveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::hoverLeaveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_inputMethodEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_inputMethodQuery_0_wrapper(QGraphicsItem* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::inputMethodQuery(query);
    }

    void __Qt4Ada_QGraphicsPolygonItem_itemChange_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem::GraphicsItemChange change, const QVariant* value, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::itemChange(change, *value);
    }

    void __Qt4Ada_QGraphicsPolygonItem_keyPressEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_keyReleaseEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_mouseDoubleClickEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::mouseDoubleClickEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_mouseMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::mouseMoveEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_mousePressEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::mousePressEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_mouseReleaseEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::mouseReleaseEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsPolygonItem_prepareGeometryChange_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::prepareGeometryChange();
    }

    bool __Qt4Ada_QGraphicsPolygonItem_sceneEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        return dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::sceneEvent(event);
    }

    bool __Qt4Ada_QGraphicsPolygonItem_sceneEventFilter_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem* watched, QEvent* event)
    {
        return dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::sceneEventFilter(watched, event);
    }

    void __Qt4Ada_QGraphicsPolygonItem_wheelEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsPolygonItemDirector*>(cpp_object)->QGraphicsItem::wheelEvent(dynamic_cast<QGraphicsSceneWheelEvent*>(event));
    }

}

QRectF QGraphicsPolygonItemDirector::boundingRect() const
{
    QRectF *aux = __Qt4Ada_QGraphicsItem_boundingRect_0_dispatch(this->ada_object);
    QRectF returns = *aux;
    delete aux;
    return returns;
}

bool QGraphicsPolygonItemDirector::contains(const QPointF& point) const
{
    return __Qt4Ada_QGraphicsItem_contains_0_dispatch(this->ada_object, &point);
}

bool QGraphicsPolygonItemDirector::isObscuredBy(const QGraphicsItem* item) const
{
    return __Qt4Ada_QGraphicsItem_isObscuredBy_0_dispatch(this->ada_object, item);
}

QPainterPath QGraphicsPolygonItemDirector::opaqueArea() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_opaqueArea_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

QPainterPath QGraphicsPolygonItemDirector::shape() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_shape_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsPolygonItemDirector::advance(int phase)
{
    __Qt4Ada_QGraphicsItem_advance_0_dispatch(this->ada_object, phase);
}

bool QGraphicsPolygonItemDirector::collidesWithItem(const QGraphicsItem* other, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithItem_0_dispatch(this->ada_object, other, mode);
}

bool QGraphicsPolygonItemDirector::collidesWithPath(const QPainterPath& path, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithPath_0_dispatch(this->ada_object, &path, mode);
}

void QGraphicsPolygonItemDirector::contextMenuEvent(QGraphicsSceneContextMenuEvent* event)
{
    __Qt4Ada_QGraphicsItem_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::dragEnterEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::dragLeaveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::dragMoveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::dropEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dropEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusInEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::hoverEnterEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::hoverMoveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::hoverLeaveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QGraphicsItem_inputMethodEvent_0_dispatch(this->ada_object, event);
}

QVariant QGraphicsPolygonItemDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QVariant QGraphicsPolygonItemDirector::itemChange(QGraphicsItem::GraphicsItemChange change, const QVariant& value)
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_itemChange_0_dispatch(this->ada_object, change, &value);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsPolygonItemDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsPolygonItemDirector::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsPolygonItemDirector::sceneEvent(QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsPolygonItemDirector::sceneEventFilter(QGraphicsItem* watched, QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGraphicsPolygonItemDirector::wheelEvent(QGraphicsSceneWheelEvent* event)
{
    __Qt4Ada_QGraphicsItem_wheelEvent_0_dispatch(this->ada_object, event);
}

extern "C" {

    void __Qt4Ada_QGraphicsPolygonItem_paint_wrapper (QGraphicsItem*                  cpp_object,
                                                      QPainter*                       painter,
                                                      const QStyleOptionGraphicsItem* option,
                                                      QWidget*                        widget)
   {
         dynamic_cast<QGraphicsPolygonItem*>(cpp_object)->paint(painter, option, widget);
   }

}
