//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QGRAPHICSPOLYGONITEMDIRECTOR_H__
#define __QGRAPHICSPOLYGONITEMDIRECTOR_H__

#include <QGraphicsPolygonItem>

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern Qt::FillRule __Qt4Ada_QGraphicsPolygonItem_fillRule_0_wrapper(QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsPolygonItem_polygon_0_wrapper(QGraphicsItem*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsPolygonItem_setFillRule_0_wrapper(QGraphicsItem*, Qt::FillRule);
    extern void __Qt4Ada_QGraphicsPolygonItem_setPolygon_0_wrapper(QGraphicsItem*, const QPolygonF*);
    extern void __Qt4Ada_QGraphicsPolygonItem_boundingRect_0_wrapper(QGraphicsItem*, QRectF*);
    extern bool __Qt4Ada_QGraphicsPolygonItem_contains_0_wrapper(QGraphicsItem*, const QPointF*);
    extern bool __Qt4Ada_QGraphicsPolygonItem_isObscuredBy_0_wrapper(QGraphicsItem*, const QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsPolygonItem_opaqueArea_0_wrapper(QGraphicsItem*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsPolygonItem_shape_0_wrapper(QGraphicsItem*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsPolygonItem_contextMenuEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_dragEnterEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_dragLeaveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_dragMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_dropEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_focusInEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_focusOutEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_hoverEnterEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_hoverMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_hoverLeaveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_inputMethodEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_inputMethodQuery_0_wrapper(QGraphicsItem*, Qt::InputMethodQuery, QVariant*);
    extern void __Qt4Ada_QGraphicsPolygonItem_itemChange_0_wrapper(QGraphicsItem*, QGraphicsItem::GraphicsItemChange, const QVariant*, QVariant*);
    extern void __Qt4Ada_QGraphicsPolygonItem_keyPressEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_keyReleaseEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_mouseDoubleClickEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_mouseMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_mousePressEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_mouseReleaseEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_prepareGeometryChange_0_wrapper(QGraphicsItem*);
    extern bool __Qt4Ada_QGraphicsPolygonItem_sceneEvent_0_wrapper(QGraphicsItem*, QEvent*);
    extern bool __Qt4Ada_QGraphicsPolygonItem_sceneEventFilter_0_wrapper(QGraphicsItem*, QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsPolygonItem_wheelEvent_0_wrapper(QGraphicsItem*, QEvent*);
}
#include <QStyleOptionGraphicsItem>
#include <QWidget>

extern "C" {

    void __Qt4Ada_QGraphicsPolygonItem_paint_wrapper (QGraphicsItem*,
                                                      QPainter*,
                                                      const QStyleOptionGraphicsItem*,
                                                      QWidget*);

}

class QGraphicsPolygonItemDirector : public QGraphicsPolygonItem
{
protected:
    void* ada_object;
    QGraphicsPolygonItemDirector();

    virtual QRectF boundingRect() const;
    virtual bool contains(const QPointF&) const;
    virtual bool isObscuredBy(const QGraphicsItem*) const;
    virtual QPainterPath opaqueArea() const;
    virtual QPainterPath shape() const;
    virtual void advance(int);
    virtual bool collidesWithItem(const QGraphicsItem*, Qt::ItemSelectionMode) const;
    virtual bool collidesWithPath(const QPainterPath&, Qt::ItemSelectionMode) const;
    virtual void contextMenuEvent(QGraphicsSceneContextMenuEvent*);
    virtual void dragEnterEvent(QGraphicsSceneDragDropEvent*);
    virtual void dragLeaveEvent(QGraphicsSceneDragDropEvent*);
    virtual void dragMoveEvent(QGraphicsSceneDragDropEvent*);
    virtual void dropEvent(QGraphicsSceneDragDropEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hoverEnterEvent(QGraphicsSceneHoverEvent*);
    virtual void hoverMoveEvent(QGraphicsSceneHoverEvent*);
    virtual void hoverLeaveEvent(QGraphicsSceneHoverEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QVariant itemChange(QGraphicsItem::GraphicsItemChange, const QVariant&);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QGraphicsSceneMouseEvent*);
    virtual void mouseMoveEvent(QGraphicsSceneMouseEvent*);
    virtual void mousePressEvent(QGraphicsSceneMouseEvent*);
    virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent*);
    virtual bool sceneEvent(QEvent*);
    virtual bool sceneEventFilter(QGraphicsItem*, QEvent*);
    virtual void wheelEvent(QGraphicsSceneWheelEvent*);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QGraphicsPolygonItem_contextMenuEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_dragEnterEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_dragLeaveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_dragMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_dropEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_focusInEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_focusOutEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_hoverEnterEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_hoverMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_hoverLeaveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_inputMethodEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_inputMethodQuery_0_wrapper(QGraphicsItem*, Qt::InputMethodQuery, QVariant*);
    friend void __Qt4Ada_QGraphicsPolygonItem_itemChange_0_wrapper(QGraphicsItem*, QGraphicsItem::GraphicsItemChange, const QVariant*, QVariant*);
    friend void __Qt4Ada_QGraphicsPolygonItem_keyPressEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_keyReleaseEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_mouseDoubleClickEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_mouseMoveEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_mousePressEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_mouseReleaseEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_prepareGeometryChange_0_wrapper(QGraphicsItem*);
    friend bool __Qt4Ada_QGraphicsPolygonItem_sceneEvent_0_wrapper(QGraphicsItem*, QEvent*);
    friend bool __Qt4Ada_QGraphicsPolygonItem_sceneEventFilter_0_wrapper(QGraphicsItem*, QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsPolygonItem_wheelEvent_0_wrapper(QGraphicsItem*, QEvent*);
};

#endif // __QGRAPHICSPOLYGONITEMDIRECTOR_H__
