//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QGRAPHICSSCENEDIRECTOR_H__
#define __QGRAPHICSSCENEDIRECTOR_H__

#include <QGraphicsScene>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QGraphicsScene_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QVariant* __Qt4Ada_QGraphicsScene_inputMethodQuery_0_dispatch(void*, Qt::InputMethodQuery);
    extern void __Qt4Ada_QGraphicsScene_contextMenuEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_dragEnterEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_dragMoveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_dragLeaveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_dropEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_focusInEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_focusOutEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_helpEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_keyPressEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_keyReleaseEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_mousePressEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_mouseMoveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_mouseReleaseEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_mouseDoubleClickEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_wheelEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_inputMethodEvent_0_dispatch(void*, QEvent*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QGraphicsScene_inputMethodQuery_0_virtual(QObject*, Qt::InputMethodQuery, QVariant*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern QGraphicsItem* __Qt4Ada_QGraphicsScene_addEllipse_0_wrapper(QObject*, const QRectF*, const QPen*, const QBrush*);
    extern void __Qt4Ada_QGraphicsScene_addItem_0_wrapper(QObject*, QGraphicsItem*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsScene_addLine_0_wrapper(QObject*, const QLineF*, const QPen*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsScene_addPath_0_wrapper(QObject*, const QPainterPath*, const QPen*, const QBrush*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsScene_addPolygon_0_wrapper(QObject*, const QPolygonF*, const QPen*, const QBrush*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsScene_addRect_0_wrapper(QObject*, const QRectF*, const QPen*, const QBrush*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsScene_addSimpleText_0_wrapper(QObject*, const QString*, const QFont*);
    extern QObject* __Qt4Ada_QGraphicsScene_addText_0_wrapper(QObject*, const QString*, const QFont*);
    extern void __Qt4Ada_QGraphicsScene_backgroundBrush_0_wrapper(QObject*, QBrush*);
    extern void __Qt4Ada_QGraphicsScene_clearFocus_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsScene_clearSelection_0_wrapper(QObject*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsScene_focusItem_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsScene_foregroundBrush_0_wrapper(QObject*, QBrush*);
    extern bool __Qt4Ada_QGraphicsScene_hasFocus_0_wrapper(QObject*);
    extern qreal __Qt4Ada_QGraphicsScene_height_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsScene_inputMethodQuery_0_wrapper(QObject*, Qt::InputMethodQuery, QVariant*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsScene_itemAt_1_wrapper(QObject*, const QPointF*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsScene_itemAt_0_wrapper(QObject*, qreal, qreal);
    extern QGraphicsScene::ItemIndexMethod __Qt4Ada_QGraphicsScene_itemIndexMethod_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsScene_itemsBoundingRect_0_wrapper(QObject*, QRectF*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsScene_mouseGrabberItem_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsScene_removeItem_0_wrapper(QObject*, QGraphicsItem*);
    extern void __Qt4Ada_QGraphicsScene_sceneRect_0_wrapper(QObject*, QRectF*);
    extern void __Qt4Ada_QGraphicsScene_setBackgroundBrush_0_wrapper(QObject*, const QBrush*);
    extern void __Qt4Ada_QGraphicsScene_setForegroundBrush_0_wrapper(QObject*, const QBrush*);
    extern void __Qt4Ada_QGraphicsScene_setItemIndexMethod_0_wrapper(QObject*, QGraphicsScene::ItemIndexMethod);
    extern void __Qt4Ada_QGraphicsScene_setSceneRect_1_wrapper(QObject*, const QRectF*);
    extern void __Qt4Ada_QGraphicsScene_setSceneRect_0_wrapper(QObject*, qreal, qreal, qreal, qreal);
    extern void __Qt4Ada_QGraphicsScene_setSelectionArea_0_wrapper(QObject*, const QPainterPath*);
    extern qreal __Qt4Ada_QGraphicsScene_width_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsScene_advance_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsScene_update_0_wrapper(QObject*, const QRectF*);
    extern bool __Qt4Ada_QGraphicsScene_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_helpEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsScene_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QGraphicsScene_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QGraphicsScene_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QGraphicsScene_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

#include <QGraphicsItem>
#include <QLine>
#include <QList>
#include <QPen>
#include <QRectF>
#include <QStyleOption>

extern "C" {

    extern QObject * __Qt4Ada_new_QGraphicsScene (QObject *parent);
    extern QObject * __Qt4Ada_new_QGraphicsScene_With_RectF (QRectF*,QObject*);
    extern QObject * __Qt4Ada_new_QGraphicsScene_From_Points
               (qreal x, qreal y, qreal width, qreal height, QObject * parent);

    extern QObject* __Qt4Ada_new_QGraphicsSceneDirector(void*, QObject*);

    //  Declarations of wrapper functions for static call

    extern void __Qt4Ada_QGraphicsScene_drawBackground_wrapper(QObject*,QPainter*,const QRectF&);
    extern void __Qt4Ada_QGraphicsScene_drawForeground_wrapper(QObject*,QPainter*,const QRectF&);
    extern void __Qt4Ada_QGraphicsScene_drawItems_wrapper
               (QObject*,QPainter*,int ,QGraphicsItem*,const QStyleOption ,QObject*);
    extern void __Qt4Ada_QGraphicsScene_items_wrapper(QObject*, QList<QGraphicsItem*>*);

}

class QGraphicsSceneDirector : public QGraphicsScene
{
protected:
    void* ada_object;
    QGraphicsSceneDirector(void*, QObject*);

    virtual void drawBackground(QPainter*,const QRectF&);
    virtual void drawForeground(QPainter*,const QRectF&);
    virtual void drawItems(QPainter*,int ,QGraphicsItem*,const QStyleOptionGraphicsItem ,QWidget*);
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

    friend void __Qt4Ada_QGraphicsScene_drawBackground_wrapper(QObject*,QPainter*,const QRectF&);
    friend void __Qt4Ada_QGraphicsScene_drawForeground_wrapper(QObject*,QPainter*,const QRectF&);
    friend void __Qt4Ada_QGraphicsScene_drawItems_wrapper(QObject*,QPainter*,int ,QGraphicsItem*,const QStyleOption ,QObject*);
    friend QObject* __Qt4Ada_new_QGraphicsSceneDirector(void*, QObject*);

    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual bool event(QEvent*);
    virtual void contextMenuEvent(QGraphicsSceneContextMenuEvent*);
    virtual void dragEnterEvent(QGraphicsSceneDragDropEvent*);
    virtual void dragMoveEvent(QGraphicsSceneDragDropEvent*);
    virtual void dragLeaveEvent(QGraphicsSceneDragDropEvent*);
    virtual void dropEvent(QGraphicsSceneDragDropEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void helpEvent(QGraphicsSceneHelpEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mousePressEvent(QGraphicsSceneMouseEvent*);
    virtual void mouseMoveEvent(QGraphicsSceneMouseEvent*);
    virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent*);
    virtual void mouseDoubleClickEvent(QGraphicsSceneMouseEvent*);
    virtual void wheelEvent(QGraphicsSceneWheelEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend bool __Qt4Ada_QGraphicsScene_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_helpEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsScene_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QGraphicsScene_sender_0_wrapper(QObject*);
};

#endif // __QGRAPHICSSCENEDIRECTOR_H__
