//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QGRAPHICSVIEWDIRECTOR_H__
#define __QGRAPHICSVIEWDIRECTOR_H__

#include <QGraphicsView>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QGraphicsView_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QGraphicsView_backgroundBrush_0_wrapper(QObject*, QBrush*);
    extern void __Qt4Ada_QGraphicsView_centerOn_2_wrapper(QObject*, const QPointF*);
    extern void __Qt4Ada_QGraphicsView_centerOn_1_wrapper(QObject*, qreal, qreal);
    extern void __Qt4Ada_QGraphicsView_centerOn_0_wrapper(QObject*, const QGraphicsItem*);
    extern QGraphicsView::DragMode __Qt4Ada_QGraphicsView_dragMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsView_ensureVisible_2_wrapper(QObject*, const QRectF*, int, int);
    extern void __Qt4Ada_QGraphicsView_ensureVisible_1_wrapper(QObject*, qreal, qreal, qreal, qreal, int, int);
    extern void __Qt4Ada_QGraphicsView_ensureVisible_0_wrapper(QObject*, const QGraphicsItem*, int, int);
    extern void __Qt4Ada_QGraphicsView_fitInView_2_wrapper(QObject*, const QRectF*, Qt::AspectRatioMode);
    extern void __Qt4Ada_QGraphicsView_fitInView_1_wrapper(QObject*, qreal, qreal, qreal, qreal, Qt::AspectRatioMode);
    extern void __Qt4Ada_QGraphicsView_fitInView_0_wrapper(QObject*, const QGraphicsItem*, Qt::AspectRatioMode);
    extern void __Qt4Ada_QGraphicsView_foregroundBrush_0_wrapper(QObject*, QBrush*);
    extern bool __Qt4Ada_QGraphicsView_isInteractive_0_wrapper(QObject*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsView_itemAt_1_wrapper(QObject*, const QPoint*);
    extern QGraphicsItem* __Qt4Ada_QGraphicsView_itemAt_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QGraphicsView_mapFromScene_5_wrapper(QObject*, const QPointF*, QPoint*);
    extern void __Qt4Ada_QGraphicsView_mapFromScene_4_wrapper(QObject*, const QRectF*, QPolygon*);
    extern void __Qt4Ada_QGraphicsView_mapFromScene_3_wrapper(QObject*, const QPolygonF*, QPolygon*);
    extern void __Qt4Ada_QGraphicsView_mapFromScene_2_wrapper(QObject*, const QPainterPath*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsView_mapFromScene_1_wrapper(QObject*, qreal, qreal, QPoint*);
    extern void __Qt4Ada_QGraphicsView_mapFromScene_0_wrapper(QObject*, qreal, qreal, qreal, qreal, QPolygon*);
    extern void __Qt4Ada_QGraphicsView_mapToScene_5_wrapper(QObject*, const QPoint*, QPointF*);
    extern void __Qt4Ada_QGraphicsView_mapToScene_4_wrapper(QObject*, const QRect*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsView_mapToScene_3_wrapper(QObject*, const QPolygon*, QPolygonF*);
    extern void __Qt4Ada_QGraphicsView_mapToScene_2_wrapper(QObject*, const QPainterPath*, QPainterPath*);
    extern void __Qt4Ada_QGraphicsView_mapToScene_1_wrapper(QObject*, int, int, QPointF*);
    extern void __Qt4Ada_QGraphicsView_mapToScene_0_wrapper(QObject*, int, int, int, int, QPolygonF*);
    extern void __Qt4Ada_QGraphicsView_matrix_0_wrapper(QObject*, QMatrix*);
    extern void __Qt4Ada_QGraphicsView_resetCachedContent_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsView_resetMatrix_0_wrapper(QObject*);
    extern QGraphicsView::ViewportAnchor __Qt4Ada_QGraphicsView_resizeAnchor_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsView_rotate_0_wrapper(QObject*, qreal);
    extern void __Qt4Ada_QGraphicsView_scale_0_wrapper(QObject*, qreal, qreal);
    extern QObject* __Qt4Ada_QGraphicsView_scene_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsView_sceneRect_0_wrapper(QObject*, QRectF*);
    extern void __Qt4Ada_QGraphicsView_setBackgroundBrush_0_wrapper(QObject*, const QBrush*);
    extern void __Qt4Ada_QGraphicsView_setDragMode_0_wrapper(QObject*, QGraphicsView::DragMode);
    extern void __Qt4Ada_QGraphicsView_setForegroundBrush_0_wrapper(QObject*, const QBrush*);
    extern void __Qt4Ada_QGraphicsView_setInteractive_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QGraphicsView_setMatrix_0_wrapper(QObject*, const QMatrix*, bool);
    extern void __Qt4Ada_QGraphicsView_setResizeAnchor_0_wrapper(QObject*, QGraphicsView::ViewportAnchor);
    extern void __Qt4Ada_QGraphicsView_setScene_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QGraphicsView_setSceneRect_1_wrapper(QObject*, const QRectF*);
    extern void __Qt4Ada_QGraphicsView_setSceneRect_0_wrapper(QObject*, qreal, qreal, qreal, qreal);
    extern void __Qt4Ada_QGraphicsView_setTransformationAnchor_0_wrapper(QObject*, QGraphicsView::ViewportAnchor);
    extern void __Qt4Ada_QGraphicsView_setViewportUpdateMode_0_wrapper(QObject*, QGraphicsView::ViewportUpdateMode);
    extern void __Qt4Ada_QGraphicsView_shear_0_wrapper(QObject*, qreal, qreal);
    extern QGraphicsView::ViewportAnchor __Qt4Ada_QGraphicsView_transformationAnchor_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsView_translate_0_wrapper(QObject*, qreal, qreal);
    extern QGraphicsView::ViewportUpdateMode __Qt4Ada_QGraphicsView_viewportUpdateMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsView_updateSceneRect_0_wrapper(QObject*, const QRectF*);
    extern void __Qt4Ada_QGraphicsView_inputMethodQuery_0_wrapper(QObject*, Qt::InputMethodQuery, QVariant*);
    extern void __Qt4Ada_QGraphicsView_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QGraphicsView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_dropEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QGraphicsView_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QGraphicsView_showEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QGraphicsView_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QGraphicsView_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QGraphicsView_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QGraphicsView_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QGraphicsView_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QGraphicsView_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsView_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsView_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QGraphicsView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QGraphicsView_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsView_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QGraphicsView_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QGraphicsView_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QGraphicsView_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
#include <QStyleOption>

extern "C" {

    extern QObject* __Qt4Ada_new_QGraphicsView (QObject* parent);
    extern QObject* __Qt4Ada_new_QGraphicsView_With_Scene (QObject* scene, QObject* parent);

    extern QObject* __Qt4Ada_new_QGraphicsViewDirector(void* ,QObject*);

    //  Declarations of wrapper functions for static call

    extern void __Qt4Ada_QGraphicsView_drawBackground_wrapper(QObject*,QPainter*,const QRectF&);
    extern void __Qt4Ada_QGraphicsView_drawBackground_virtual(QObject*,QPainter*,const QRectF&);
    extern void __Qt4Ada_QGraphicsView_drawBackground_dispatch(void*, QPainter*, const QRectF&);
    extern void __Qt4Ada_QGraphicsView_drawForeground_wrapper(QObject*,QPainter*,const QRectF&);
    extern void __Qt4Ada_QGraphicsView_drawItems_wrapper(QObject*,QPainter*,int ,QGraphicsItem*,const QStyleOption );
    extern QPaintEngine*__Qt4Ada_QGraphicsView_paintEngine_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsView_connectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QGraphicsView_disconnectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QGraphicsView_setCacheMode_wrapper(QObject*,unsigned);
    extern void __Qt4Ada_QGraphicsView_setRenderHint_wrapper (QObject*, unsigned, bool);

}

class QGraphicsViewDirector : public QGraphicsView
{
protected:
    void* ada_object;
    QGraphicsViewDirector(void*, QWidget*);

    virtual QPaintEngine*paintEngine();
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);
    virtual void drawBackground(QPainter*, const QRectF&);

    friend void __Qt4Ada_QGraphicsView_drawBackground_wrapper(QObject*,QPainter*,const QRectF&);
    friend void __Qt4Ada_QGraphicsView_drawBackground_virtual(QObject*,QPainter*,const QRectF&);
    friend void __Qt4Ada_QGraphicsView_drawForeground_wrapper(QObject*,QPainter*,const QRectF&);
    friend void __Qt4Ada_QGraphicsView_drawItems_wrapper(QObject*,QPainter*,int ,QGraphicsItem*,const QStyleOption );
    friend void __Qt4Ada_QGraphicsView_connectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QGraphicsView_disconnectNotify_wrapper(QObject*,const char*);
    friend QObject* __Qt4Ada_new_QGraphicsViewDirector(void* ,QObject*);

    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual bool event(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void scrollContentsBy(int, int);
    virtual void showEvent(QShowEvent*);
    virtual bool viewportEvent(QEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void hideEvent(QHideEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QGraphicsView_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QGraphicsView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_dropEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QGraphicsView_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QGraphicsView_showEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QGraphicsView_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend void __Qt4Ada_QGraphicsView_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QGraphicsView_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QGraphicsView_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QGraphicsView_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QGraphicsView_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsView_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsView_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QGraphicsView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QGraphicsView_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsView_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QGraphicsView_sender_0_wrapper(QObject*);
};

#endif // __QGRAPHICSVIEWDIRECTOR_H__
