//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QSize>
#include <QChildEvent>
#include <QFocusEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QTimerEvent>

#include "qgroupboxdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QGroupBox_staticMetaObject =
        &QGroupBox::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QGroupBox_isCheckable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGroupBox*>(cpp_object)->QGroupBox::isCheckable();
    }

    bool __Qt4Ada_QGroupBox_isChecked_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGroupBox*>(cpp_object)->QGroupBox::isChecked();
    }

    bool __Qt4Ada_QGroupBox_isFlat_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGroupBox*>(cpp_object)->QGroupBox::isFlat();
    }

    void __Qt4Ada_QGroupBox_setCheckable_0_wrapper(QObject* cpp_object, bool checkable)
    {
        dynamic_cast<QGroupBox*>(cpp_object)->QGroupBox::setCheckable(checkable);
    }

    void __Qt4Ada_QGroupBox_setFlat_0_wrapper(QObject* cpp_object, bool flat)
    {
        dynamic_cast<QGroupBox*>(cpp_object)->QGroupBox::setFlat(flat);
    }

    void __Qt4Ada_QGroupBox_setTitle_0_wrapper(QObject* cpp_object, const QString* title)
    {
        dynamic_cast<QGroupBox*>(cpp_object)->QGroupBox::setTitle(*title);
    }

    void __Qt4Ada_QGroupBox_title_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QGroupBox*>(cpp_object)->QGroupBox::title();
    }

    void __Qt4Ada_QGroupBox_setChecked_0_wrapper(QObject* cpp_object, bool checked)
    {
        dynamic_cast<QGroupBox*>(cpp_object)->QGroupBox::setChecked(checked);
    }

    void __Qt4Ada_QGroupBox_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QGroupBox*>(cpp_object)->QGroupBox::minimumSizeHint();
    }

    void __Qt4Ada_QGroupBox_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QGroupBox::changeEvent(event);
    }

    void __Qt4Ada_QGroupBox_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QGroupBox::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    bool __Qt4Ada_QGroupBox_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QGroupBoxDirector*>(cpp_object)->QGroupBox::event(e);
    }

    void __Qt4Ada_QGroupBox_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QGroupBox::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QGroupBox::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QGroupBox::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QGroupBox::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QGroupBox::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QGroupBox::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QGroupBox_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QGroupBox_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QGroupBox_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QGroupBox_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QGroupBox_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QGroupBox_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QGroupBox_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QGroupBox_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QGroupBox_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QGroupBox_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QGroupBoxDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QGroupBox_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QGroupBox_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGroupBoxDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QGroupBox_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGroupBoxDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QGroupBox_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QGroupBox*>(cpp_this)->QGroupBox::qt_metacast(name);
    }

    int __Qt4Ada_QGroupBox_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QGroupBox*>(cpp_this)->QGroupBox::qt_metacall(_c, _id, _a);
    }

}

QSize QGroupBoxDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QGroupBoxDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

bool QGroupBoxDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QGroupBoxDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

int QGroupBoxDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QGroupBoxDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QGroupBoxDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QGroupBoxDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QGroupBoxDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QGroupBoxDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QGroupBoxDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QGroupBoxDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QGroupBoxDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGroupBoxDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QGroupBoxDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QGroupBoxDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QGroupBoxDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QGroupBoxDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C" {

    QObject* __Qt4Ada_new_QGroupBox_wrapper (QObject*parent)
    {
        return dynamic_cast<QObject *>(new QGroupBox (dynamic_cast <QWidget*> (parent)));
    }

    QObject* __Qt4Ada_new_QGroupBox_with_string_wrapper (QString*title, QObject*parent = 0)
    {
        return dynamic_cast<QObject *>(new QGroupBox (*title ,dynamic_cast <QWidget*> (parent)));
    }

}
