//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QHBOXLAYOUTDIRECTOR_H__
#define __QHBOXLAYOUTDIRECTOR_H__

#include <QHBoxLayout>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QHBoxLayout_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QHBoxLayout_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHBoxLayout_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHBoxLayout_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QHBoxLayout_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QHBoxLayout_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QHBoxLayout_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject* __Qt4Ada_new_QHBoxLayout();
    extern QObject* __Qt4Ada_new_QHBoxLayout_QWidgetP(QObject*);

    //  Declarations of wrapper functions for static call

    extern Qt::Orientations __Qt4Ada_QHBoxLayout_expandingDirections_wrapper(QObject*);
    extern QLayoutItem*__Qt4Ada_QHBoxLayout_itemAt_wrapper(QObject*,int );
    extern QLayoutItem*__Qt4Ada_QHBoxLayout_takeAt_wrapper(QObject*,int );
    extern void __Qt4Ada_QHBoxLayout_setGeometry_wrapper(QObject*,const QRect&);
    extern QRect __Qt4Ada_QHBoxLayout_geometry_wrapper(QObject*);
    extern int __Qt4Ada_QHBoxLayout_indexOf_wrapper(QObject*,QObject*);
    extern QObject*__Qt4Ada_QHBoxLayout_layout_wrapper(QObject*);
    extern void __Qt4Ada_QHBoxLayout_connectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QHBoxLayout_disconnectNotify_wrapper(QObject*,const char*);

}

class QHBoxLayoutDirector : public QHBoxLayout
{
protected:
    void* ada_object;
    QHBoxLayoutDirector();

    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

    friend void __Qt4Ada_QHBoxLayout_connectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QHBoxLayout_disconnectNotify_wrapper(QObject*,const char*);

    virtual void addItem(QLayoutItem*);
    virtual int count() const;
    virtual bool hasHeightForWidth() const;
    virtual int heightForWidth(int) const;
    virtual void invalidate();
    virtual QSize maximumSize() const;
    virtual int minimumHeightForWidth(int) const;
    virtual QSize minimumSize() const;
    virtual QSize sizeHint() const;
    virtual int indexOf(QWidget*) const;
    virtual bool isEmpty() const;
    virtual void childEvent(QChildEvent*);
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual QLayout* layout();
    virtual QWidget* widget();

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QHBoxLayout_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHBoxLayout_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHBoxLayout_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QHBoxLayout_sender_0_wrapper(QObject*);
};

#endif // __QHBOXLAYOUTDIRECTOR_H__
