//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QByteArray>
#include <QSize>
#include <QAbstractItemModel>
#include <QModelIndex>
#include <QPaintEvent>
#include <QMouseEvent>
#include <QRect>
#include <QRegion>
#include <QItemSelectionModel>
#include <QVariant>
#include <QWidget>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QResizeEvent>
#include <QTimerEvent>
#include <QWheelEvent>
#include <QContextMenuEvent>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qheaderviewdirector.h"
#include "qabstractitemviewdirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QHeaderView_staticMetaObject =
        &QHeaderView::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QHeaderView_cascadingSectionResizes_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::cascadingSectionResizes();
    }

    int __Qt4Ada_QHeaderView_count_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::count();
    }

    Qt::Alignment __Qt4Ada_QHeaderView_defaultAlignment_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::defaultAlignment();
    }

    int __Qt4Ada_QHeaderView_defaultSectionSize_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::defaultSectionSize();
    }

    int __Qt4Ada_QHeaderView_hiddenSectionCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::hiddenSectionCount();
    }

    void __Qt4Ada_QHeaderView_hideSection_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::hideSection(logicalIndex);
    }

    bool __Qt4Ada_QHeaderView_highlightSections_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::highlightSections();
    }

    bool __Qt4Ada_QHeaderView_isClickable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::isClickable();
    }

    bool __Qt4Ada_QHeaderView_isMovable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::isMovable();
    }

    bool __Qt4Ada_QHeaderView_isSectionHidden_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::isSectionHidden(logicalIndex);
    }

    bool __Qt4Ada_QHeaderView_isSortIndicatorShown_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::isSortIndicatorShown();
    }

    int __Qt4Ada_QHeaderView_length_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::length();
    }

    int __Qt4Ada_QHeaderView_logicalIndex_0_wrapper(QObject* cpp_object, int visualIndex)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::logicalIndex(visualIndex);
    }

    int __Qt4Ada_QHeaderView_logicalIndexAt_2_wrapper(QObject* cpp_object, int position)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::logicalIndexAt(position);
    }

    int __Qt4Ada_QHeaderView_logicalIndexAt_1_wrapper(QObject* cpp_object, int x, int y)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::logicalIndexAt(x, y);
    }

    int __Qt4Ada_QHeaderView_logicalIndexAt_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::logicalIndexAt(*pos);
    }

    int __Qt4Ada_QHeaderView_minimumSectionSize_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::minimumSectionSize();
    }

    void __Qt4Ada_QHeaderView_moveSection_0_wrapper(QObject* cpp_object, int from, int to)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::moveSection(from, to);
    }

    int __Qt4Ada_QHeaderView_offset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::offset();
    }

    Qt::Orientation __Qt4Ada_QHeaderView_orientation_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::orientation();
    }

    QHeaderView::ResizeMode __Qt4Ada_QHeaderView_resizeMode_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::resizeMode(logicalIndex);
    }

    void __Qt4Ada_QHeaderView_resizeSection_0_wrapper(QObject* cpp_object, int logicalIndex, int size)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::resizeSection(logicalIndex, size);
    }

    void __Qt4Ada_QHeaderView_resizeSections_0_wrapper(QObject* cpp_object, QHeaderView::ResizeMode mode)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::resizeSections(mode);
    }

    bool __Qt4Ada_QHeaderView_restoreState_0_wrapper(QObject* cpp_object, const QByteArray* state)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::restoreState(*state);
    }

    void __Qt4Ada_QHeaderView_saveState_0_wrapper(QObject* cpp_object, QByteArray* returns)
    {
        *returns = dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::saveState();
    }

    int __Qt4Ada_QHeaderView_sectionPosition_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::sectionPosition(logicalIndex);
    }

    int __Qt4Ada_QHeaderView_sectionSize_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::sectionSize(logicalIndex);
    }

    int __Qt4Ada_QHeaderView_sectionSizeHint_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::sectionSizeHint(logicalIndex);
    }

    int __Qt4Ada_QHeaderView_sectionViewportPosition_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::sectionViewportPosition(logicalIndex);
    }

    bool __Qt4Ada_QHeaderView_sectionsHidden_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::sectionsHidden();
    }

    bool __Qt4Ada_QHeaderView_sectionsMoved_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::sectionsMoved();
    }

    void __Qt4Ada_QHeaderView_setCascadingSectionResizes_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setCascadingSectionResizes(enable);
    }

    void __Qt4Ada_QHeaderView_setClickable_0_wrapper(QObject* cpp_object, bool clickable)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setClickable(clickable);
    }

    void __Qt4Ada_QHeaderView_setDefaultAlignment_0_wrapper(QObject* cpp_object, Qt::Alignment alignment)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setDefaultAlignment(alignment);
    }

    void __Qt4Ada_QHeaderView_setDefaultSectionSize_0_wrapper(QObject* cpp_object, int size)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setDefaultSectionSize(size);
    }

    void __Qt4Ada_QHeaderView_setHighlightSections_0_wrapper(QObject* cpp_object, bool clickable)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setHighlightSections(clickable);
    }

    void __Qt4Ada_QHeaderView_setMinimumSectionSize_0_wrapper(QObject* cpp_object, int size)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setMinimumSectionSize(size);
    }

    void __Qt4Ada_QHeaderView_setMovable_0_wrapper(QObject* cpp_object, bool movable)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setMovable(movable);
    }

    void __Qt4Ada_QHeaderView_setResizeMode_1_wrapper(QObject* cpp_object, QHeaderView::ResizeMode mode)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setResizeMode(mode);
    }

    void __Qt4Ada_QHeaderView_setResizeMode_0_wrapper(QObject* cpp_object, int logicalIndex, QHeaderView::ResizeMode mode)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setResizeMode(logicalIndex, mode);
    }

    void __Qt4Ada_QHeaderView_setSectionHidden_0_wrapper(QObject* cpp_object, int logicalIndex, bool hide)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setSectionHidden(logicalIndex, hide);
    }

    void __Qt4Ada_QHeaderView_setSortIndicator_0_wrapper(QObject* cpp_object, int logicalIndex, Qt::SortOrder order)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setSortIndicator(logicalIndex, order);
    }

    void __Qt4Ada_QHeaderView_setSortIndicatorShown_0_wrapper(QObject* cpp_object, bool show)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setSortIndicatorShown(show);
    }

    void __Qt4Ada_QHeaderView_setStretchLastSection_0_wrapper(QObject* cpp_object, bool stretch)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setStretchLastSection(stretch);
    }

    void __Qt4Ada_QHeaderView_showSection_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::showSection(logicalIndex);
    }

    Qt::SortOrder __Qt4Ada_QHeaderView_sortIndicatorOrder_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::sortIndicatorOrder();
    }

    int __Qt4Ada_QHeaderView_sortIndicatorSection_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::sortIndicatorSection();
    }

    bool __Qt4Ada_QHeaderView_stretchLastSection_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::stretchLastSection();
    }

    int __Qt4Ada_QHeaderView_stretchSectionCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::stretchSectionCount();
    }

    void __Qt4Ada_QHeaderView_swapSections_0_wrapper(QObject* cpp_object, int first, int second)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::swapSections(first, second);
    }

    int __Qt4Ada_QHeaderView_visualIndex_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::visualIndex(logicalIndex);
    }

    int __Qt4Ada_QHeaderView_visualIndexAt_0_wrapper(QObject* cpp_object, int position)
    {
        return dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::visualIndexAt(position);
    }

    void __Qt4Ada_QHeaderView_headerDataChanged_0_wrapper(QObject* cpp_object, Qt::Orientation orientation, int logicalFirst, int logicalLast)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::headerDataChanged(orientation, logicalFirst, logicalLast);
    }

    void __Qt4Ada_QHeaderView_setOffset_0_wrapper(QObject* cpp_object, int offset)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setOffset(offset);
    }

    void __Qt4Ada_QHeaderView_setOffsetToLastSection_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setOffsetToLastSection();
    }

    void __Qt4Ada_QHeaderView_setOffsetToSectionPosition_0_wrapper(QObject* cpp_object, int visualIndex)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setOffsetToSectionPosition(visualIndex);
    }

    void __Qt4Ada_QHeaderView_geometriesChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::geometriesChanged();
    }

    void __Qt4Ada_QHeaderView_sectionAutoResize_0_wrapper(QObject* cpp_object, int logicalIndex, QHeaderView::ResizeMode mode)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sectionAutoResize(logicalIndex, mode);
    }

    void __Qt4Ada_QHeaderView_sectionClicked_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sectionClicked(logicalIndex);
    }

    void __Qt4Ada_QHeaderView_sectionCountChanged_0_wrapper(QObject* cpp_object, int oldCount, int newCount)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sectionCountChanged(oldCount, newCount);
    }

    void __Qt4Ada_QHeaderView_sectionDoubleClicked_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sectionDoubleClicked(logicalIndex);
    }

    void __Qt4Ada_QHeaderView_sectionEntered_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sectionEntered(logicalIndex);
    }

    void __Qt4Ada_QHeaderView_sectionHandleDoubleClicked_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sectionHandleDoubleClicked(logicalIndex);
    }

    void __Qt4Ada_QHeaderView_sectionMoved_0_wrapper(QObject* cpp_object, int logicalIndex, int oldVisualIndex, int newVisualIndex)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sectionMoved(logicalIndex, oldVisualIndex, newVisualIndex);
    }

    void __Qt4Ada_QHeaderView_sectionPressed_0_wrapper(QObject* cpp_object, int logicalIndex)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sectionPressed(logicalIndex);
    }

    void __Qt4Ada_QHeaderView_sectionResized_0_wrapper(QObject* cpp_object, int logicalIndex, int oldSize, int newSize)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sectionResized(logicalIndex, oldSize, newSize);
    }

    void __Qt4Ada_QHeaderView_sortIndicatorChanged_0_wrapper(QObject* cpp_object, int logicalIndex, Qt::SortOrder order)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sortIndicatorChanged(logicalIndex, order);
    }

    void __Qt4Ada_QHeaderView_sectionSizeFromContents_0_wrapper(QObject* cpp_object, int logicalIndex, QSize* returns)
    {
        *returns = dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::sectionSizeFromContents(logicalIndex);
    }

    void __Qt4Ada_QHeaderView_reset_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::reset();
    }

    void __Qt4Ada_QHeaderView_setModel_0_wrapper(QObject* cpp_object, QObject* model)
    {
        dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::setModel(dynamic_cast<QAbstractItemModel*>(model));
    }

    void __Qt4Ada_QHeaderView_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QHeaderView*>(cpp_object)->QHeaderView::sizeHint();
    }

    void __Qt4Ada_QHeaderView_currentChanged_0_wrapper(QObject* cpp_object, const QModelIndex* current, const QModelIndex* previous)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::currentChanged(*current, *previous);
    }

    void __Qt4Ada_QHeaderView_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::dataChanged(*topLeft, *bottomRight);
    }

    bool __Qt4Ada_QHeaderView_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::event(e);
    }

    int __Qt4Ada_QHeaderView_horizontalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::horizontalOffset();
    }

    void __Qt4Ada_QHeaderView_indexAt_0_wrapper(QObject* cpp_object, const QPoint* point, QModelIndex* returns)
    {
        *returns = dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::indexAt(*point);
    }

    bool __Qt4Ada_QHeaderView_isIndexHidden_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        return dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::isIndexHidden(*index);
    }

    void __Qt4Ada_QHeaderView_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_rowsInserted_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::rowsInserted(*parent, start, stop);
    }

    void __Qt4Ada_QHeaderView_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::scrollContentsBy(dx, dy);
    }

    void __Qt4Ada_QHeaderView_scrollTo_0_wrapper(QObject* cpp_object, const QModelIndex* index, QAbstractItemView::ScrollHint hint)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::scrollTo(*index, hint);
    }

    int __Qt4Ada_QHeaderView_verticalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::verticalOffset();
    }

    bool __Qt4Ada_QHeaderView_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::viewportEvent(event);
    }

    void __Qt4Ada_QHeaderView_visualRect_0_wrapper(QObject* cpp_object, const QModelIndex* index, QRect* returns)
    {
        *returns = dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::visualRect(*index);
    }

    void __Qt4Ada_QHeaderView_visualRegionForSelection_0_wrapper(QObject* cpp_object, const QItemSelection* selection, QRegion* returns)
    {
        *returns = dynamic_cast<QHeaderViewDirector*>(cpp_object)->QHeaderView::visualRegionForSelection(*selection);
    }

    void __Qt4Ada_QHeaderView_activated_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::activated(*index);
    }

    void __Qt4Ada_QHeaderView_clicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::clicked(*index);
    }

    void __Qt4Ada_QHeaderView_doubleClicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::doubleClicked(*index);
    }

    void __Qt4Ada_QHeaderView_entered_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::entered(*index);
    }

    void __Qt4Ada_QHeaderView_pressed_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::pressed(*index);
    }

    void __Qt4Ada_QHeaderView_viewportEntered_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::viewportEntered();
    }

    void __Qt4Ada_QHeaderView_dirtyRegionOffset_0_wrapper(QObject* cpp_object, QPoint* returns)
    {
        *returns = dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::dirtyRegionOffset();
    }

    void __Qt4Ada_QHeaderView_executeDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::executeDelayedItemsLayout();
    }

    void __Qt4Ada_QHeaderView_scheduleDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::scheduleDelayedItemsLayout();
    }

    void __Qt4Ada_QHeaderView_scrollDirtyRegion_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::scrollDirtyRegion(dx, dy);
    }

    void __Qt4Ada_QHeaderView_setDirtyRegion_0_wrapper(QObject* cpp_object, const QRegion* region)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::setDirtyRegion(*region);
    }

    void __Qt4Ada_QHeaderView_commitData_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::commitData(dynamic_cast<QWidget*>(editor));
    }

    void __Qt4Ada_QHeaderView_editorDestroyed_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::editorDestroyed(editor);
    }

    void __Qt4Ada_QHeaderView_rowsAboutToBeRemoved_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::rowsAboutToBeRemoved(*parent, start, stop);
    }

    void __Qt4Ada_QHeaderView_selectionChanged_0_wrapper(QObject* cpp_object, const QItemSelection* selected, const QItemSelection* deselected)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::selectionChanged(*selected, *deselected);
    }

    void __Qt4Ada_QHeaderView_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QHeaderView_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::focusNextPrevChild(next);
    }

    void __Qt4Ada_QHeaderView_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractItemView::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QHeaderView_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QHeaderView_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractScrollArea::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QAbstractScrollArea::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QHeaderView_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QHeaderView_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QHeaderView_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QHeaderView_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QHeaderView_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QHeaderView_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QHeaderView_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QHeaderView_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QHeaderViewDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QHeaderView_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QHeaderView_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QHeaderViewDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QHeaderView_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QHeaderViewDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QHeaderView_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QHeaderView*>(cpp_this)->QHeaderView::qt_metacast(name);
    }

    int __Qt4Ada_QHeaderView_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QHeaderView*>(cpp_this)->QHeaderView::qt_metacall(_c, _id, _a);
    }

}

QSize QHeaderViewDirector::sectionSizeFromContents(int logicalIndex) const
{
    QSize *aux = __Qt4Ada_QHeaderView_sectionSizeFromContents_0_dispatch(this->ada_object, logicalIndex);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QHeaderViewDirector::reset()
{
    __Qt4Ada_QAbstractItemView_reset_0_dispatch(this->ada_object);
}

void QHeaderViewDirector::setModel(QAbstractItemModel* model)
{
    __Qt4Ada_QAbstractItemView_setModel_0_dispatch(this->ada_object, model);
}

QSize QHeaderViewDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QHeaderViewDirector::currentChanged(const QModelIndex& current, const QModelIndex& previous)
{
    __Qt4Ada_QAbstractItemView_currentChanged_0_dispatch(this->ada_object, &current, &previous);
}

void QHeaderViewDirector::dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight)
{
    __Qt4Ada_QAbstractItemView_dataChanged_0_dispatch(this->ada_object, &topLeft, &bottomRight);
}

bool QHeaderViewDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

int QHeaderViewDirector::horizontalOffset() const
{
    return __Qt4Ada_QAbstractItemView_horizontalOffset_0_dispatch(this->ada_object);
}

QModelIndex QHeaderViewDirector::indexAt(const QPoint& point) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemView_indexAt_0_dispatch(this->ada_object, &point);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QHeaderViewDirector::isIndexHidden(const QModelIndex& index) const
{
    return __Qt4Ada_QAbstractItemView_isIndexHidden_0_dispatch(this->ada_object, &index);
}

void QHeaderViewDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::rowsInserted(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsInserted_0_dispatch(this->ada_object, &parent, start, stop);
}

void QHeaderViewDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

void QHeaderViewDirector::scrollTo(const QModelIndex& index, QAbstractItemView::ScrollHint hint)
{
    __Qt4Ada_QAbstractItemView_scrollTo_0_dispatch(this->ada_object, &index, hint);
}

int QHeaderViewDirector::verticalOffset() const
{
    return __Qt4Ada_QAbstractItemView_verticalOffset_0_dispatch(this->ada_object);
}

bool QHeaderViewDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

QRect QHeaderViewDirector::visualRect(const QModelIndex& index) const
{
    QRect *aux = __Qt4Ada_QAbstractItemView_visualRect_0_dispatch(this->ada_object, &index);
    QRect returns = *aux;
    delete aux;
    return returns;
}

QRegion QHeaderViewDirector::visualRegionForSelection(const QItemSelection& selection) const
{
    QRegion *aux = __Qt4Ada_QAbstractItemView_visualRegionForSelection_0_dispatch(this->ada_object, &selection);
    QRegion returns = *aux;
    delete aux;
    return returns;
}

void QHeaderViewDirector::keyboardSearch(const QString& search)
{
    __Qt4Ada_QAbstractItemView_keyboardSearch_0_dispatch(this->ada_object, &search);
}

void QHeaderViewDirector::setSelectionModel(QItemSelectionModel* selectionModel)
{
    __Qt4Ada_QAbstractItemView_setSelectionModel_0_dispatch(this->ada_object, selectionModel);
}

int QHeaderViewDirector::sizeHintForColumn(int column) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_dispatch(this->ada_object, column);
}

int QHeaderViewDirector::sizeHintForRow(int row) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForRow_0_dispatch(this->ada_object, row);
}

void QHeaderViewDirector::selectAll()
{
    __Qt4Ada_QAbstractItemView_selectAll_0_dispatch(this->ada_object);
}

void QHeaderViewDirector::setRootIndex(const QModelIndex& index)
{
    __Qt4Ada_QAbstractItemView_setRootIndex_0_dispatch(this->ada_object, &index);
}

QVariant QHeaderViewDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QHeaderViewDirector::commitData(QWidget* editor)
{
    __Qt4Ada_QAbstractItemView_commitData_0_dispatch(this->ada_object, editor);
}

void QHeaderViewDirector::editorDestroyed(QObject* editor)
{
    __Qt4Ada_QAbstractItemView_editorDestroyed_0_dispatch(this->ada_object, editor);
}

void QHeaderViewDirector::rowsAboutToBeRemoved(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_dispatch(this->ada_object, &parent, start, stop);
}

void QHeaderViewDirector::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected)
{
    __Qt4Ada_QAbstractItemView_selectionChanged_0_dispatch(this->ada_object, &selected, &deselected);
}

void QHeaderViewDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QHeaderViewDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QHeaderViewDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

QSize QHeaderViewDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QHeaderViewDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QHeaderViewDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QHeaderViewDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QHeaderViewDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QHeaderViewDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QHeaderViewDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QHeaderViewDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QHeaderViewDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QHeaderViewDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QHeaderViewDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QHeaderViewDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C" {

    void __Qt4Ada_QHeaderView_moveCursor_wrapper (QObject*cpp_object, unsigned action, unsigned modifiers,QModelIndex*index)
   {
      *index = dynamic_cast<QHeaderViewDirector*>(cpp_object)->moveCursor((QHeaderViewDirector::CursorAction)action, (Qt::KeyboardModifiers)modifiers);
   }

    void __Qt4Ada_QHeaderView_setSelection_wrapper(QObject* cpp_object, QRect* rect, unsigned flags)
    {
       dynamic_cast<QHeaderViewDirector*>(cpp_object)->setSelection(*rect, (QItemSelectionModel::SelectionFlags)flags);
    }

}
