//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3732 $ $Date: 2010-04-30 14:49:36 +0400 (Fri, 30 Apr 2010) $
//--------------------------------------------------------------------------//
#include <QImageReader>

extern "C"
{
    extern QImageReader* __QtAda_inititialize_QImageReader(void*);
    extern QImageReader* __QtAda_inititialize_QImageReader_QStringCR_QByteArrayCR(void*, const QString*, const QByteArray*);
    extern void __QtAda_finalize_QImageReader(QImageReader*);

    extern unsigned __QtAda_QImageReader_autoDetectImageFormat_Q(const QImageReader*);
    extern void __QtAda_QImageReader_backgroundColor_Q(QColor*, const QImageReader*);
    extern unsigned __QtAda_QImageReader_canRead_Q(const QImageReader*);
    extern void __QtAda_QImageReader_clipRect_Q(QRect*, const QImageReader*);
    extern int __QtAda_QImageReader_currentImageNumber_Q(const QImageReader*);
    extern void __QtAda_QImageReader_currentImageRect_Q(QRect*, const QImageReader*);
    extern unsigned __QtAda_QImageReader_decideFormatFromContent_Q(const QImageReader*);
    extern unsigned __QtAda_QImageReader_error_Q(const QImageReader*);
    extern void __QtAda_QImageReader_errorString_Q(QString*, const QImageReader*);
    extern void __QtAda_QImageReader_fileName_Q(QString*, const QImageReader*);
    extern void __QtAda_QImageReader_format_Q(QByteArray*, const QImageReader*);
    extern int __QtAda_QImageReader_imageCount_Q(const QImageReader*);
    extern unsigned __QtAda_QImageReader_imageFormat_Q(const QImageReader*);
    extern unsigned __QtAda_QImageReader_jumpToImage_int(QImageReader*, int);
    extern unsigned __QtAda_QImageReader_jumpToNextImage(QImageReader*);
    extern int __QtAda_QImageReader_loopCount_Q(const QImageReader*);
    extern int __QtAda_QImageReader_nextImageDelay_Q(const QImageReader*);
    extern int __QtAda_QImageReader_quality_Q(const QImageReader*);
    extern void __QtAda_QImageReader_read(QImage*, QImageReader*);
    extern unsigned __QtAda_QImageReader_read_QImageP(QImageReader*, QImage*);
    extern void __QtAda_QImageReader_scaledClipRect_Q(QRect*, const QImageReader*);
    extern void __QtAda_QImageReader_scaledSize_Q(QSize*, const QImageReader*);
    extern void __QtAda_QImageReader_setAutoDetectImageFormat_bool(QImageReader*, unsigned);
    extern void __QtAda_QImageReader_setBackgroundColor_QColorCR(QImageReader*, const QColor*);
    extern void __QtAda_QImageReader_setClipRect_QRectCR(QImageReader*, const QRect*);
    extern void __QtAda_QImageReader_setDecideFormatFromContent_bool(QImageReader*, unsigned);
    extern void __QtAda_QImageReader_setFileName_QStringCR(QImageReader*, const QString*);
    extern void __QtAda_QImageReader_setFormat_QByteArrayCR(QImageReader*, const QByteArray*);
    extern void __QtAda_QImageReader_setQuality_int(QImageReader*, int);
    extern void __QtAda_QImageReader_setScaledClipRect_QRectCR(QImageReader*, const QRect*);
    extern void __QtAda_QImageReader_setScaledSize_QSizeCR(QImageReader*, const QSize*);
    extern void __QtAda_QImageReader_size_Q(QSize*, const QImageReader*);
    extern unsigned __QtAda_QImageReader_supportsAnimation_Q(const QImageReader*);
    extern unsigned __QtAda_QImageReader_supportsOption_ImageOption_Q(const QImageReader*, unsigned);
    extern void __QtAda_QImageReader_text_QStringCR_Q(QString*, const QImageReader*, const QString*);
    extern void __QtAda_QImageReader_textKeys_Q(QStringList*, const QImageReader*);
    extern void __QtAda_QImageReader_imageFormat_QStringCR_S(QByteArray*, const QString*);
    extern void __QtAda_QImageReader_supportedImageFormats_S(QList<QByteArray>*);

};

