//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3731 $ $Date: 2010-04-30 13:21:13 +0400 (Fri, 30 Apr 2010) $
//--------------------------------------------------------------------------//
#include <QImageWriter>

extern "C"
{
    extern QImageWriter* __QtAda_inititialize_QImageWriter(void*);
    extern QImageWriter* __QtAda_inititialize_QImageWriter_QStringCR_QByteArrayCR(void*, const QString*, const QByteArray*);
    extern void __QtAda_finalize_QImageWriter(QImageWriter*);

    extern unsigned __QtAda_QImageWriter_canWrite_Q(const QImageWriter*);
    extern int __QtAda_QImageWriter_compression_Q(const QImageWriter*);
    extern unsigned __QtAda_QImageWriter_error_Q(const QImageWriter*);
    extern void __QtAda_QImageWriter_errorString_Q(QString*, const QImageWriter*);
    extern void __QtAda_QImageWriter_fileName_Q(QString*, const QImageWriter*);
    extern void __QtAda_QImageWriter_format_Q(QByteArray*, const QImageWriter*);
    extern float __QtAda_QImageWriter_gamma_Q(const QImageWriter*);
    extern int __QtAda_QImageWriter_quality_Q(const QImageWriter*);
    extern void __QtAda_QImageWriter_setCompression_int(QImageWriter*, int);
    extern void __QtAda_QImageWriter_setFileName_QStringCR(QImageWriter*, const QString*);
    extern void __QtAda_QImageWriter_setFormat_QByteArrayCR(QImageWriter*, const QByteArray*);
    extern void __QtAda_QImageWriter_setGamma_float(QImageWriter*, float);
    extern void __QtAda_QImageWriter_setQuality_int(QImageWriter*, int);
    extern void __QtAda_QImageWriter_setText_QStringCR_QStringCR(QImageWriter*, const QString*, const QString*);
    extern unsigned __QtAda_QImageWriter_supportsOption_ImageOption_Q(const QImageWriter*, unsigned);
    extern unsigned __QtAda_QImageWriter_write_QImageCR(QImageWriter*, const QImage*);
    extern void __QtAda_QImageWriter_supportedImageFormats_S(QList<QByteArray>*);

};

