//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QITEMDELEGATEDIRECTOR_H__
#define __QITEMDELEGATEDIRECTOR_H__

#include <QItemDelegate>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QItemDelegate_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QItemDelegate_hasClipping_0_wrapper(QObject*);
    extern void __Qt4Ada_QItemDelegate_setClipping_0_wrapper(QObject*, bool);
    extern QObject* __Qt4Ada_QItemDelegate_createEditor_0_wrapper(QObject*, QObject*, const QStyleOption*, const QModelIndex*);
    extern void __Qt4Ada_QItemDelegate_setEditorData_0_wrapper(QObject*, QObject*, const QModelIndex*);
    extern void __Qt4Ada_QItemDelegate_setModelData_0_wrapper(QObject*, QObject*, QObject*, const QModelIndex*);
    extern void __Qt4Ada_QItemDelegate_sizeHint_0_wrapper(QObject*, const QStyleOption*, const QModelIndex*, QSize*);
    extern void __Qt4Ada_QItemDelegate_updateEditorGeometry_0_wrapper(QObject*, QObject*, const QStyleOption*, const QModelIndex*);
    extern void __Qt4Ada_QItemDelegate_commitData_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QItemDelegate_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QItemDelegate_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QItemDelegate_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QItemDelegate_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QItemDelegate_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QItemDelegate_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C"
{
    //  constructors

    extern QObject* __Qt4Ada_new_QItemDelegateDirector(void*, QObject*);

    extern void __Qt4Ada_QItemDelegate_paint_wrapper(QObject*, QPainter*, const QStyleOptionViewItem*, const QModelIndex*);

}

class QItemDelegateDirector : public QItemDelegate
{
protected:
    void* ada_object;
    QItemDelegateDirector(void*, QObject*);

    virtual void paint(QPainter*, const QStyleOptionViewItem&, const QModelIndex&) const;

    friend QObject* __Qt4Ada_new_QItemDelegateDirector(void*, QObject*);

    virtual QWidget* createEditor(QWidget*, const QStyleOptionViewItem&, const QModelIndex&) const;
    virtual void setEditorData(QWidget*, const QModelIndex&) const;
    virtual void setModelData(QWidget*, QAbstractItemModel*, const QModelIndex&) const;
    virtual QSize sizeHint(const QStyleOptionViewItem&, const QModelIndex&) const;
    virtual void updateEditorGeometry(QWidget*, const QStyleOptionViewItem&, const QModelIndex&) const;
    virtual bool editorEvent(QEvent*, QAbstractItemModel*, const QStyleOptionViewItem&, const QModelIndex&);
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QItemDelegate_commitData_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QItemDelegate_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QItemDelegate_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QItemDelegate_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QItemDelegate_sender_0_wrapper(QObject*);
};

#endif // __QITEMDELEGATEDIRECTOR_H__
