//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QModelIndex>
#include <QAbstractItemModel>
#include <QChildEvent>
#include <QTimerEvent>

#include "qitemselectionmodeldirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QItemSelectionModel_staticMetaObject =
        &QItemSelectionModel::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QItemSelectionModel_clear_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QItemSelectionModel*>(cpp_object)->clear();
    }

    void __Qt4Ada_QItemSelectionModel_reset_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QItemSelectionModel*>(cpp_object)->reset();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QItemSelectionModel_columnIntersectsSelection_0_wrapper(QObject* cpp_object, int column, const QModelIndex* parent)
    {
        return dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::columnIntersectsSelection(column, *parent);
    }

    void __Qt4Ada_QItemSelectionModel_currentIndex_0_wrapper(QObject* cpp_object, QModelIndex* returns)
    {
        *returns = dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::currentIndex();
    }

    bool __Qt4Ada_QItemSelectionModel_hasSelection_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::hasSelection();
    }

    bool __Qt4Ada_QItemSelectionModel_isColumnSelected_0_wrapper(QObject* cpp_object, int column, const QModelIndex* parent)
    {
        return dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::isColumnSelected(column, *parent);
    }

    bool __Qt4Ada_QItemSelectionModel_isRowSelected_0_wrapper(QObject* cpp_object, int row, const QModelIndex* parent)
    {
        return dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::isRowSelected(row, *parent);
    }

    bool __Qt4Ada_QItemSelectionModel_isSelected_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        return dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::isSelected(*index);
    }

    const QObject* __Qt4Ada_QItemSelectionModel_model_0_wrapper(QObject* cpp_object)
    {
        return static_cast<const QObject*>(dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::model());
    }

    bool __Qt4Ada_QItemSelectionModel_rowIntersectsSelection_0_wrapper(QObject* cpp_object, int row, const QModelIndex* parent)
    {
        return dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::rowIntersectsSelection(row, *parent);
    }

    void __Qt4Ada_QItemSelectionModel_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::clear();
    }

    void __Qt4Ada_QItemSelectionModel_clearSelection_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::clearSelection();
    }

    void __Qt4Ada_QItemSelectionModel_reset_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QItemSelectionModel*>(cpp_object)->QItemSelectionModel::reset();
    }

    void __Qt4Ada_QItemSelectionModel_currentChanged_0_wrapper(QObject* cpp_object, const QModelIndex* current, const QModelIndex* previous)
    {
        dynamic_cast<QItemSelectionModelDirector*>(cpp_object)->QItemSelectionModel::currentChanged(*current, *previous);
    }

    void __Qt4Ada_QItemSelectionModel_currentColumnChanged_0_wrapper(QObject* cpp_object, const QModelIndex* current, const QModelIndex* previous)
    {
        dynamic_cast<QItemSelectionModelDirector*>(cpp_object)->QItemSelectionModel::currentColumnChanged(*current, *previous);
    }

    void __Qt4Ada_QItemSelectionModel_currentRowChanged_0_wrapper(QObject* cpp_object, const QModelIndex* current, const QModelIndex* previous)
    {
        dynamic_cast<QItemSelectionModelDirector*>(cpp_object)->QItemSelectionModel::currentRowChanged(*current, *previous);
    }

    void __Qt4Ada_QItemSelectionModel_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QItemSelectionModelDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QItemSelectionModel_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QItemSelectionModelDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QItemSelectionModel_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QItemSelectionModelDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QItemSelectionModel_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QItemSelectionModelDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QItemSelectionModel_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QItemSelectionModel*>(cpp_this)->QItemSelectionModel::qt_metacast(name);
    }

    int __Qt4Ada_QItemSelectionModel_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QItemSelectionModel*>(cpp_this)->QItemSelectionModel::qt_metacall(_c, _id, _a);
    }

}

void QItemSelectionModelDirector::clear()
{
    __Qt4Ada_QItemSelectionModel_clear_0_dispatch(this->ada_object);
}

void QItemSelectionModelDirector::reset()
{
    __Qt4Ada_QItemSelectionModel_reset_0_dispatch(this->ada_object);
}

bool QItemSelectionModelDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QItemSelectionModelDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QItemSelectionModelDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QItemSelectionModelDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QItemSelectionModelDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QItemSelectionModelDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QItemSelectionModelDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QItemSelectionModelDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

void QItemSelectionModelDirector::select (const QItemSelection & selection, QItemSelectionModel::SelectionFlags command)
{
   __Qt4Ada_QItemSelectionModel_select_dispatch (this->ada_object, &selection,(unsigned)command);
}

void QItemSelectionModelDirector::select(const QModelIndex& index, QItemSelectionModel::SelectionFlags command)
{
   __Qt4Ada_QItemSelectionModel_select_QModelIndexCR_dispatch(this->ada_object, &index, (unsigned)command);
}

extern "C" {

    QItemSelectionModel* __Qt4Ada_new_QItemSelectionModel (QObject* model, QObject* parent)
    {
       return new QItemSelectionModel(dynamic_cast<QAbstractItemModel*>(model), parent);
    }

    void __Qt4Ada_QItemSelectionModel_select_virtual (QObject*cpp_object,QItemSelection*selection,unsigned command)
    {
        dynamic_cast<QItemSelectionModel*> (cpp_object) -> select (*selection, (QItemSelectionModel::SelectionFlags) command);
    }

    void __Qt4Ada_QItemSelectionModel_select_QModelIndexCR_virtual (QObject* self, QModelIndex* index, unsigned command)
    {
        dynamic_cast<QItemSelectionModel*>(self)->select(*index, (QItemSelectionModel::SelectionFlags)command);
    }

    void __Qt4Ada_QItemSelectionModel_select_wrapper (QObject*cpp_object,QItemSelection*selection,unsigned command)
    {
        dynamic_cast<QItemSelectionModel*> (cpp_object) ->QItemSelectionModel::select (*selection, (QItemSelectionModel::SelectionFlags) command);
    }

    void __Qt4Ada_QItemSelectionModel_select_QModelIndexCR_wrapper(QObject* self, QModelIndex* index, unsigned command)
    {
        dynamic_cast<QItemSelectionModel*>(self)->QItemSelectionModel::select(*index, (QItemSelectionModel::SelectionFlags)command);
    }

    void __QtAda_QItemSelectionModel_setCurrentIndex_wrapper(QObject* self, QModelIndex* index, unsigned command)
    {
        dynamic_cast<QItemSelectionModel*>(self)->QItemSelectionModel::setCurrentIndex(*index, (QItemSelectionModel::SelectionFlags)command);
    }

}
