//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QLAYOUTDIRECTOR_H__
#define __QLAYOUTDIRECTOR_H__

#include <QLayout>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QLayout_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QLayout_addItem_0_dispatch(void*, QLayoutItem*);
    extern int __Qt4Ada_QLayout_count_0_dispatch(void*);
    extern int __Qt4Ada_QLayout_indexOf_0_dispatch(void*, QObject*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QLayout_addItem_0_virtual(QObject*, QLayoutItem*);
    extern int __Qt4Ada_QLayout_count_0_virtual(QObject*);
    extern int __Qt4Ada_QLayout_indexOf_0_virtual(QObject*, QObject*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QLayout_activate_0_wrapper(QObject*);
    extern void __Qt4Ada_QLayout_addWidget_0_wrapper(QObject*, QObject*);
    extern int __Qt4Ada_QLayout_indexOf_0_wrapper(QObject*, QObject*);
    extern bool __Qt4Ada_QLayout_isEnabled_0_wrapper(QObject*);
    extern int __Qt4Ada_QLayout_margin_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QLayout_menuBar_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QLayout_parentWidget_0_wrapper(QObject*);
    extern void __Qt4Ada_QLayout_removeItem_0_wrapper(QObject*, QLayoutItem*);
    extern void __Qt4Ada_QLayout_removeWidget_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QLayout_setContentsMargins_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QLayout_setEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QLayout_setMargin_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QLayout_setMenuBar_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QLayout_setSpacing_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QLayout_spacing_0_wrapper(QObject*);
    extern void __Qt4Ada_QLayout_update_0_wrapper(QObject*);
    extern bool __Qt4Ada_QLayout_isEmpty_0_wrapper(QObject*);
    extern void __Qt4Ada_QLayout_minimumSize_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QLayout_maximumSize_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QLayout_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLayout_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLayout_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QLayout_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QLayout_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QLayout_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern Qt::Orientations __Qt4Ada_QLayout_expandingDirections_dispatch(void *);
    //  Declarations of wrapper functions for virtual call

    extern Qt::Orientations __Qt4Ada_QLayout_expandingDirections_virtual(QObject*);

    //  Declarations of wrapper functions for static call

    extern Qt::Orientations __Qt4Ada_QLayout_expandingDirections_wrapper(QObject*);

}

class QLayoutDirector : public QLayout
{
protected:
    void* ada_object;
    QLayoutDirector();

    virtual Qt::Orientations expandingDirections();
//     virtual void connectNotify(const char*);
//     virtual void disconnectNotify(const char*);

    virtual void addItem(QLayoutItem*);
    virtual int count() const;
    virtual int indexOf(QWidget*) const;
    virtual bool isEmpty() const;
    virtual QSize minimumSize() const;
    virtual QSize maximumSize() const;
    virtual void childEvent(QChildEvent*);
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual bool hasHeightForWidth() const;
    virtual int heightForWidth(int) const;
    virtual void invalidate();
    virtual QLayout* layout();
    virtual int minimumHeightForWidth(int) const;
    virtual QSize sizeHint() const;
    virtual QWidget* widget();

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QLayout_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLayout_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLayout_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QLayout_sender_0_wrapper(QObject*);
};

#endif // __QLAYOUTDIRECTOR_H__
