//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QLINEEDITDIRECTOR_H__
#define __QLINEEDITDIRECTOR_H__

#include <QLineEdit>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QLineEdit_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QLineEdit_backspace_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QLineEdit_createStandardContextMenu_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QLineEdit_completer_0_wrapper(QObject*);
    extern int __Qt4Ada_QLineEdit_cursorPosition_0_wrapper(QObject*);
    extern int __Qt4Ada_QLineEdit_cursorPositionAt_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QLineEdit_cursorBackward_0_wrapper(QObject*, bool, int);
    extern void __Qt4Ada_QLineEdit_cursorForward_0_wrapper(QObject*, bool, int);
    extern void __Qt4Ada_QLineEdit_cursorWordBackward_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QLineEdit_cursorWordForward_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QLineEdit_del_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_deselect_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_displayText_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QLineEdit_dragEnabled_0_wrapper(QObject*);
    extern QLineEdit::EchoMode __Qt4Ada_QLineEdit_echoMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_end_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QLineEdit_hasAcceptableInput_0_wrapper(QObject*);
    extern bool __Qt4Ada_QLineEdit_hasFrame_0_wrapper(QObject*);
    extern bool __Qt4Ada_QLineEdit_hasSelectedText_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_home_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QLineEdit_inputMask_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QLineEdit_insert_0_wrapper(QObject*, const QString*);
    extern bool __Qt4Ada_QLineEdit_isModified_0_wrapper(QObject*);
    extern bool __Qt4Ada_QLineEdit_isReadOnly_0_wrapper(QObject*);
    extern bool __Qt4Ada_QLineEdit_isRedoAvailable_0_wrapper(QObject*);
    extern bool __Qt4Ada_QLineEdit_isUndoAvailable_0_wrapper(QObject*);
    extern int __Qt4Ada_QLineEdit_maxLength_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_selectedText_0_wrapper(QObject*, QString*);
    extern int __Qt4Ada_QLineEdit_selectionStart_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_setCompleter_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QLineEdit_setCursorPosition_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QLineEdit_setDragEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QLineEdit_setEchoMode_0_wrapper(QObject*, QLineEdit::EchoMode);
    extern void __Qt4Ada_QLineEdit_setFrame_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QLineEdit_setInputMask_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QLineEdit_setMaxLength_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QLineEdit_setModified_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QLineEdit_setReadOnly_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QLineEdit_setSelection_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QLineEdit_setValidator_0_wrapper(QObject*, const QObject*);
    extern void __Qt4Ada_QLineEdit_text_0_wrapper(QObject*, QString*);
    extern const QObject* __Qt4Ada_QLineEdit_validator_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_clear_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_copy_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_cut_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_paste_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_redo_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_selectAll_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_setText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QLineEdit_undo_0_wrapper(QObject*);
    extern bool __Qt4Ada_QLineEdit_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_inputMethodQuery_0_wrapper(QObject*, Qt::InputMethodQuery, QVariant*);
    extern void __Qt4Ada_QLineEdit_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QLineEdit_minimumSizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QLineEdit_cursorPositionChanged_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QLineEdit_editingFinished_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_returnPressed_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_selectionChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_textChanged_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QLineEdit_textEdited_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QLineEdit_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QLineEdit_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QLineEdit_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QLineEdit_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QLineEdit_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QLineEdit_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QLineEdit_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLineEdit_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QLineEdit_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QLineEdit_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QLineEdit_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject * __Qt4Ada_new_QLineEdit (QObject * parent);
    extern QObject * __Qt4Ada_new_QLineEdit_With_String (QString*text, QObject * parent);

    //  Declarations of wrapper functions for static call

    extern QPaintEngine*__Qt4Ada_QLineEdit_paintEngine_wrapper(QObject*);
    extern void __Qt4Ada_QLineEdit_connectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QLineEdit_disconnectNotify_wrapper(QObject*,const char*);

    extern void __Qt4Ada_QLineEdit_setAlignment_wrapper (QObject*, unsigned);
}

class QLineEditDirector : public QLineEdit
{
protected:
    void* ada_object;
    QLineEditDirector();

    virtual QPaintEngine*paintEngine();
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

    friend void __Qt4Ada_QLineEdit_connectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QLineEdit_disconnectNotify_wrapper(QObject*,const char*);

    virtual bool event(QEvent*);
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize sizeHint() const;
    virtual QSize minimumSizeHint() const;
    virtual void changeEvent(QEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual int heightForWidth(int) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void hideEvent(QHideEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QLineEdit_cursorPositionChanged_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QLineEdit_editingFinished_0_wrapper(QObject*);
    friend void __Qt4Ada_QLineEdit_returnPressed_0_wrapper(QObject*);
    friend void __Qt4Ada_QLineEdit_selectionChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QLineEdit_textChanged_0_wrapper(QObject*, const QString*);
    friend void __Qt4Ada_QLineEdit_textEdited_0_wrapper(QObject*, const QString*);
    friend void __Qt4Ada_QLineEdit_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QLineEdit_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QLineEdit_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QLineEdit_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QLineEdit_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QLineEdit_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QLineEdit_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QLineEdit_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QLineEdit_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLineEdit_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QLineEdit_sender_0_wrapper(QObject*);
};

#endif // __QLINEEDITDIRECTOR_H__
