//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QModelIndex>
#include <QRect>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QTimerEvent>
#include <QRegion>
#include <QAbstractItemModel>
#include <QItemSelectionModel>
#include <QVariant>
#include <QWidget>
#include <QDragEnterEvent>
#include <QFocusEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QSize>
#include <QWheelEvent>
#include <QContextMenuEvent>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qlistwidgetdirector.h"
#include "qlistviewdirector.h"
#include "qabstractitemviewdirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QListWidget_staticMetaObject =
        &QListWidget::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QListWidget_addItem_0_wrapper(QObject* cpp_object, const QString* label)
    {
        dynamic_cast<QListWidget*>(cpp_object)->QListWidget::addItem(*label);
    }

    int __Qt4Ada_QListWidget_count_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListWidget*>(cpp_object)->QListWidget::count();
    }

    int __Qt4Ada_QListWidget_currentRow_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListWidget*>(cpp_object)->QListWidget::currentRow();
    }

    void __Qt4Ada_QListWidget_insertItem_0_wrapper(QObject* cpp_object, int row, const QString* label)
    {
        dynamic_cast<QListWidget*>(cpp_object)->QListWidget::insertItem(row, *label);
    }

    bool __Qt4Ada_QListWidget_isSortingEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListWidget*>(cpp_object)->QListWidget::isSortingEnabled();
    }

    void __Qt4Ada_QListWidget_setCurrentRow_0_wrapper(QObject* cpp_object, int row)
    {
        dynamic_cast<QListWidget*>(cpp_object)->QListWidget::setCurrentRow(row);
    }

    void __Qt4Ada_QListWidget_setSortingEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QListWidget*>(cpp_object)->QListWidget::setSortingEnabled(enable);
    }

    void __Qt4Ada_QListWidget_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListWidget*>(cpp_object)->QListWidget::clear();
    }

    void __Qt4Ada_QListWidget_currentRowChanged_0_wrapper(QObject* cpp_object, int currentRow)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListWidget::currentRowChanged(currentRow);
    }

    void __Qt4Ada_QListWidget_currentTextChanged_0_wrapper(QObject* cpp_object, const QString* currentText)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListWidget::currentTextChanged(*currentText);
    }

    void __Qt4Ada_QListWidget_itemSelectionChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListWidget::itemSelectionChanged();
    }

    bool __Qt4Ada_QListWidget_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QListWidgetDirector*>(cpp_object)->QListWidget::event(e);
    }

    void __Qt4Ada_QListWidget_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QListWidget_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QListWidget_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    int __Qt4Ada_QListWidget_horizontalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::horizontalOffset();
    }

    bool __Qt4Ada_QListWidget_isIndexHidden_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        return dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::isIndexHidden(*index);
    }

    void __Qt4Ada_QListWidget_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QListWidget_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QListWidget_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QListWidget_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QListWidget_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::scrollContentsBy(dx, dy);
    }

    void __Qt4Ada_QListWidget_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    int __Qt4Ada_QListWidget_verticalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::verticalOffset();
    }

    void __Qt4Ada_QListWidget_visualRegionForSelection_0_wrapper(QObject* cpp_object, const QItemSelection* selection, QRegion* returns)
    {
        *returns = dynamic_cast<QListWidgetDirector*>(cpp_object)->QListView::visualRegionForSelection(*selection);
    }

    void __Qt4Ada_QListWidget_activated_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::activated(*index);
    }

    void __Qt4Ada_QListWidget_clicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::clicked(*index);
    }

    void __Qt4Ada_QListWidget_doubleClicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::doubleClicked(*index);
    }

    void __Qt4Ada_QListWidget_entered_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::entered(*index);
    }

    void __Qt4Ada_QListWidget_pressed_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::pressed(*index);
    }

    void __Qt4Ada_QListWidget_viewportEntered_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::viewportEntered();
    }

    void __Qt4Ada_QListWidget_dirtyRegionOffset_0_wrapper(QObject* cpp_object, QPoint* returns)
    {
        *returns = dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::dirtyRegionOffset();
    }

    void __Qt4Ada_QListWidget_executeDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::executeDelayedItemsLayout();
    }

    void __Qt4Ada_QListWidget_scheduleDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::scheduleDelayedItemsLayout();
    }

    void __Qt4Ada_QListWidget_scrollDirtyRegion_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::scrollDirtyRegion(dx, dy);
    }

    void __Qt4Ada_QListWidget_setDirtyRegion_0_wrapper(QObject* cpp_object, const QRegion* region)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::setDirtyRegion(*region);
    }

    void __Qt4Ada_QListWidget_commitData_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::commitData(dynamic_cast<QWidget*>(editor));
    }

    void __Qt4Ada_QListWidget_currentChanged_0_wrapper(QObject* cpp_object, const QModelIndex* current, const QModelIndex* previous)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::currentChanged(*current, *previous);
    }

    void __Qt4Ada_QListWidget_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::dataChanged(*topLeft, *bottomRight);
    }

    void __Qt4Ada_QListWidget_editorDestroyed_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::editorDestroyed(editor);
    }

    void __Qt4Ada_QListWidget_rowsAboutToBeRemoved_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::rowsAboutToBeRemoved(*parent, start, stop);
    }

    void __Qt4Ada_QListWidget_rowsInserted_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::rowsInserted(*parent, start, stop);
    }

    void __Qt4Ada_QListWidget_selectionChanged_0_wrapper(QObject* cpp_object, const QItemSelection* selected, const QItemSelection* deselected)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::selectionChanged(*selected, *deselected);
    }

    void __Qt4Ada_QListWidget_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QListWidget_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QListWidget_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::focusNextPrevChild(next);
    }

    void __Qt4Ada_QListWidget_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QListWidget_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QListWidget_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QListWidget_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QListWidget_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    bool __Qt4Ada_QListWidget_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractItemView::viewportEvent(event);
    }

    void __Qt4Ada_QListWidget_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QListWidget_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QListWidget_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractScrollArea::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QListWidget_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QAbstractScrollArea::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QListWidget_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QListWidget_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QListWidget_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QListWidget_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QListWidget_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QListWidget_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QListWidget_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QListWidget_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QListWidget_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QListWidget_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QListWidget_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QListWidget_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QListWidget_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QListWidget_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QListWidget_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QListWidgetDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QListWidget_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QListWidget_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListWidgetDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QListWidget_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListWidgetDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QListWidget_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QListWidget*>(cpp_this)->QListWidget::qt_metacast(name);
    }

    int __Qt4Ada_QListWidget_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QListWidget*>(cpp_this)->QListWidget::qt_metacall(_c, _id, _a);
    }

}

bool QListWidgetDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

QModelIndex QListWidgetDirector::indexAt(const QPoint& point) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemView_indexAt_0_dispatch(this->ada_object, &point);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

void QListWidgetDirector::scrollTo(const QModelIndex& index, QAbstractItemView::ScrollHint hint)
{
    __Qt4Ada_QAbstractItemView_scrollTo_0_dispatch(this->ada_object, &index, hint);
}

QRect QListWidgetDirector::visualRect(const QModelIndex& index) const
{
    QRect *aux = __Qt4Ada_QAbstractItemView_visualRect_0_dispatch(this->ada_object, &index);
    QRect returns = *aux;
    delete aux;
    return returns;
}

void QListWidgetDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

int QListWidgetDirector::horizontalOffset() const
{
    return __Qt4Ada_QAbstractItemView_horizontalOffset_0_dispatch(this->ada_object);
}

bool QListWidgetDirector::isIndexHidden(const QModelIndex& index) const
{
    return __Qt4Ada_QAbstractItemView_isIndexHidden_0_dispatch(this->ada_object, &index);
}

void QListWidgetDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

void QListWidgetDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

int QListWidgetDirector::verticalOffset() const
{
    return __Qt4Ada_QAbstractItemView_verticalOffset_0_dispatch(this->ada_object);
}

QRegion QListWidgetDirector::visualRegionForSelection(const QItemSelection& selection) const
{
    QRegion *aux = __Qt4Ada_QAbstractItemView_visualRegionForSelection_0_dispatch(this->ada_object, &selection);
    QRegion returns = *aux;
    delete aux;
    return returns;
}

void QListWidgetDirector::keyboardSearch(const QString& search)
{
    __Qt4Ada_QAbstractItemView_keyboardSearch_0_dispatch(this->ada_object, &search);
}

void QListWidgetDirector::setModel(QAbstractItemModel* model)
{
    __Qt4Ada_QAbstractItemView_setModel_0_dispatch(this->ada_object, model);
}

void QListWidgetDirector::setSelectionModel(QItemSelectionModel* selectionModel)
{
    __Qt4Ada_QAbstractItemView_setSelectionModel_0_dispatch(this->ada_object, selectionModel);
}

int QListWidgetDirector::sizeHintForColumn(int column) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_dispatch(this->ada_object, column);
}

int QListWidgetDirector::sizeHintForRow(int row) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForRow_0_dispatch(this->ada_object, row);
}

void QListWidgetDirector::reset()
{
    __Qt4Ada_QAbstractItemView_reset_0_dispatch(this->ada_object);
}

void QListWidgetDirector::selectAll()
{
    __Qt4Ada_QAbstractItemView_selectAll_0_dispatch(this->ada_object);
}

void QListWidgetDirector::setRootIndex(const QModelIndex& index)
{
    __Qt4Ada_QAbstractItemView_setRootIndex_0_dispatch(this->ada_object, &index);
}

QVariant QListWidgetDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QListWidgetDirector::commitData(QWidget* editor)
{
    __Qt4Ada_QAbstractItemView_commitData_0_dispatch(this->ada_object, editor);
}

void QListWidgetDirector::currentChanged(const QModelIndex& current, const QModelIndex& previous)
{
    __Qt4Ada_QAbstractItemView_currentChanged_0_dispatch(this->ada_object, &current, &previous);
}

void QListWidgetDirector::dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight)
{
    __Qt4Ada_QAbstractItemView_dataChanged_0_dispatch(this->ada_object, &topLeft, &bottomRight);
}

void QListWidgetDirector::editorDestroyed(QObject* editor)
{
    __Qt4Ada_QAbstractItemView_editorDestroyed_0_dispatch(this->ada_object, editor);
}

void QListWidgetDirector::rowsAboutToBeRemoved(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_dispatch(this->ada_object, &parent, start, stop);
}

void QListWidgetDirector::rowsInserted(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsInserted_0_dispatch(this->ada_object, &parent, start, stop);
}

void QListWidgetDirector::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected)
{
    __Qt4Ada_QAbstractItemView_selectionChanged_0_dispatch(this->ada_object, &selected, &deselected);
}

void QListWidgetDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QListWidgetDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QListWidgetDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

bool QListWidgetDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

QSize QListWidgetDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QListWidgetDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QListWidgetDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QListWidgetDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QListWidgetDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QListWidgetDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QListWidgetDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QListWidgetDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QListWidgetDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QListWidgetDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QListWidgetDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QListWidgetDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QListWidgetDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{
   QObject * __Qt4Ada_new_QListWidget (QObject * parent)
   {
      return static_cast<QObject *>(new QListWidget (dynamic_cast <QWidget*> (parent)));
   }

   void __Qt4Ada_QListWidget_addItems_wrapper (QObject*cpp_object, QStringList*labels)
   {
        dynamic_cast<QListWidget*>(cpp_object)->addItems (*labels);
   }
}
