//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QToolBar>
#include <QWidget>
#include <QSize>
#include <QMenuBar>
#include <QByteArray>
#include <QStatusBar>
#include <QContextMenuEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qmainwindowdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QMainWindow_staticMetaObject =
        &QMainWindow::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QMainWindow_addToolBar_1_wrapper(QObject* cpp_object, QObject* toolbar)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::addToolBar(dynamic_cast<QToolBar*>(toolbar));
    }

    QObject* __Qt4Ada_QMainWindow_addToolBar_0_wrapper(QObject* cpp_object, const QString* title)
    {
        return static_cast<QObject*>(dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::addToolBar(*title));
    }

    QObject* __Qt4Ada_QMainWindow_centralWidget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::centralWidget());
    }

    void __Qt4Ada_QMainWindow_iconSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::iconSize();
    }

    void __Qt4Ada_QMainWindow_insertToolBar_0_wrapper(QObject* cpp_object, QObject* before, QObject* toolbar)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::insertToolBar(dynamic_cast<QToolBar*>(before), dynamic_cast<QToolBar*>(toolbar));
    }

    void __Qt4Ada_QMainWindow_insertToolBarBreak_0_wrapper(QObject* cpp_object, QObject* before)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::insertToolBarBreak(dynamic_cast<QToolBar*>(before));
    }

    bool __Qt4Ada_QMainWindow_isAnimated_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::isAnimated();
    }

    bool __Qt4Ada_QMainWindow_isDockNestingEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::isDockNestingEnabled();
    }

    QObject* __Qt4Ada_QMainWindow_menuBar_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::menuBar());
    }

    QObject* __Qt4Ada_QMainWindow_menuWidget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::menuWidget());
    }

    void __Qt4Ada_QMainWindow_removeToolBar_0_wrapper(QObject* cpp_object, QObject* toolbar)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::removeToolBar(dynamic_cast<QToolBar*>(toolbar));
    }

    bool __Qt4Ada_QMainWindow_restoreState_0_wrapper(QObject* cpp_object, const QByteArray* state, int version)
    {
        return dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::restoreState(*state, version);
    }

    void __Qt4Ada_QMainWindow_saveState_0_wrapper(QObject* cpp_object, int version, QByteArray* returns)
    {
        *returns = dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::saveState(version);
    }

    void __Qt4Ada_QMainWindow_setCentralWidget_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::setCentralWidget(dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QMainWindow_setIconSize_0_wrapper(QObject* cpp_object, const QSize* iconSize)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::setIconSize(*iconSize);
    }

    void __Qt4Ada_QMainWindow_setMenuBar_0_wrapper(QObject* cpp_object, QObject* menubar)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::setMenuBar(dynamic_cast<QMenuBar*>(menubar));
    }

    void __Qt4Ada_QMainWindow_setMenuWidget_0_wrapper(QObject* cpp_object, QObject* menubar)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::setMenuWidget(dynamic_cast<QWidget*>(menubar));
    }

    void __Qt4Ada_QMainWindow_setStatusBar_0_wrapper(QObject* cpp_object, QObject* statusbar)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::setStatusBar(dynamic_cast<QStatusBar*>(statusbar));
    }

    QObject* __Qt4Ada_QMainWindow_statusBar_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::statusBar());
    }

    void __Qt4Ada_QMainWindow_setAnimated_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::setAnimated(enabled);
    }

    void __Qt4Ada_QMainWindow_setDockNestingEnabled_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::setDockNestingEnabled(enabled);
    }

    void __Qt4Ada_QMainWindow_iconSizeChanged_0_wrapper(QObject* cpp_object, const QSize* iconSize)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QMainWindow::iconSizeChanged(*iconSize);
    }

    void __Qt4Ada_QMainWindow_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QMainWindow::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    bool __Qt4Ada_QMainWindow_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QMainWindowDirector*>(cpp_object)->QMainWindow::event(e);
    }

    void __Qt4Ada_QMainWindow_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QMainWindow_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QMainWindow_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QMainWindow_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QMainWindow_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QMainWindow_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QMainWindow_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QMainWindow_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QMainWindow_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QMainWindow_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QMainWindow_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QMainWindow_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QMainWindowDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QMainWindow_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QMainWindow_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QMainWindow_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMainWindowDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QMainWindow_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMainWindowDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QMainWindow_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QMainWindow*>(cpp_this)->QMainWindow::qt_metacast(name);
    }

    int __Qt4Ada_QMainWindow_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QMainWindow*>(cpp_this)->QMainWindow::qt_metacall(_c, _id, _a);
    }

}

void QMainWindowDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

bool QMainWindowDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

int QMainWindowDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QMainWindowDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QMainWindowDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QMainWindowDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QMainWindowDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QMainWindowDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QMainWindowDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QMainWindowDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QMainWindowDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QMainWindowDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QMainWindowDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QMainWindowDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QMainWindowDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QMainWindowDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QMainWindowDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QDockWidget>

QMainWindowDirector::QMainWindowDirector(void* o, QWidget* parent, Qt::WindowFlags flags) :
    QMainWindow (parent, flags),
    ada_object (o)
{
}

extern "C" {

    QObject* __Qt4Ada_new_QMainWindow (QObject* parent, unsigned flags)
    {
        return dynamic_cast<QObject *>
                  (new QMainWindow(dynamic_cast<QWidget*>(parent),
                                   static_cast<Qt::WindowFlags>(flags)));
    }

    QObject* __Qt4Ada_new_QMainWindowDirector (void* ada_object, QObject* parent, unsigned flags)
    {
        return dynamic_cast<QObject*>
                 (new QMainWindowDirector
                   (ada_object,dynamic_cast<QWidget*>(parent), (Qt::WindowFlags) flags));
    }

}

   void __Qt4Ada_QMainWindow_addDockWidget_0_wrapper (QObject*cpp_object,
                                                      unsigned area,
                                                      QObject* dockWidget)
   {

       dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::addDockWidget
                                               ((Qt::DockWidgetArea)area,
                                                dynamic_cast<QDockWidget*>(dockWidget));

   }

   void __Qt4Ada_QMainWindow_addDockWidget_1_wrapper (QObject*cpp_object,
                                                      unsigned area,
                                                      QObject* dockWidget,
                                                      unsigned orientation)
   {

       dynamic_cast<QMainWindow*>(cpp_object)->QMainWindow::addDockWidget
                                               ((Qt::DockWidgetArea)area,
                                                dynamic_cast<QDockWidget*>(dockWidget),
                                                (Qt::Orientation)orientation);

   }
