//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QMAINWINDOWDIRECTOR_H__
#define __QMAINWINDOWDIRECTOR_H__

#include <QMainWindow>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QMainWindow_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QMainWindow_addToolBar_1_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QMainWindow_addToolBar_0_wrapper(QObject*, const QString*);
    extern QObject* __Qt4Ada_QMainWindow_centralWidget_0_wrapper(QObject*);
    extern void __Qt4Ada_QMainWindow_iconSize_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QMainWindow_insertToolBar_0_wrapper(QObject*, QObject*, QObject*);
    extern void __Qt4Ada_QMainWindow_insertToolBarBreak_0_wrapper(QObject*, QObject*);
    extern bool __Qt4Ada_QMainWindow_isAnimated_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMainWindow_isDockNestingEnabled_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QMainWindow_menuBar_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QMainWindow_menuWidget_0_wrapper(QObject*);
    extern void __Qt4Ada_QMainWindow_removeToolBar_0_wrapper(QObject*, QObject*);
    extern bool __Qt4Ada_QMainWindow_restoreState_0_wrapper(QObject*, const QByteArray*, int);
    extern void __Qt4Ada_QMainWindow_saveState_0_wrapper(QObject*, int, QByteArray*);
    extern void __Qt4Ada_QMainWindow_setCentralWidget_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMainWindow_setIconSize_0_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QMainWindow_setMenuBar_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMainWindow_setMenuWidget_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMainWindow_setStatusBar_0_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QMainWindow_statusBar_0_wrapper(QObject*);
    extern void __Qt4Ada_QMainWindow_setAnimated_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QMainWindow_setDockNestingEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QMainWindow_iconSizeChanged_0_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QMainWindow_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMainWindow_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QMainWindow_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMainWindow_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMainWindow_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QMainWindow_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMainWindow_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QMainWindow_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QMainWindow_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QMainWindow_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QMainWindow_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMainWindow_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QMainWindow_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QMainWindow_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QMainWindow_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
extern "C" {

    // Constructors

    extern QObject * __Qt4Ada_new_QMainWindow (QObject*, unsigned);
    extern QObject* __Qt4Ada_new_QMainWindowDirector(void*, QObject*, unsigned);

}

extern "C"
{
   extern void __Qt4Ada_QMainWindow_addDockWidget_0_wrapper (QObject*,
                                                             unsigned,
                                                             QObject*);

   extern void __Qt4Ada_QMainWindow_addDockWidget_1_wrapper (QObject*,
                                                             unsigned,
                                                             QObject*,
                                                             unsigned);
}

class QMainWindowDirector : public QMainWindow
{
protected:
    void* ada_object;
    QMainWindowDirector(void*, QWidget*, Qt::WindowFlags);

    friend QObject* __Qt4Ada_new_QMainWindowDirector(void*, QObject*, unsigned);

    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual bool event(QEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QMainWindow_iconSizeChanged_0_wrapper(QObject*, const QSize*);
    friend void __Qt4Ada_QMainWindow_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMainWindow_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QMainWindow_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMainWindow_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QMainWindow_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QMainWindow_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMainWindow_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QMainWindow_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QMainWindow_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QMainWindow_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QMainWindow_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMainWindow_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QMainWindow_sender_0_wrapper(QObject*);
};

#endif // __QMAINWINDOWDIRECTOR_H__
