//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QMatrix>

extern "C"
{
    extern QMatrix* __QtAda_inititialize_QMatrix(void*);
    extern QMatrix* __QtAda_inititialize_QMatrix_qreal_qreal_qreal_qreal_qreal_qreal(void*, double, double, double, double, double, double);
    extern QMatrix* __QtAda_adjust_QMatrix(void*, const QMatrix*);
    extern void __QtAda_finalize_QMatrix(QMatrix*);

    extern double __QtAda_QMatrix_m11_Q(const QMatrix*);
    extern double __QtAda_QMatrix_m12_Q(const QMatrix*);
    extern double __QtAda_QMatrix_m21_Q(const QMatrix*);
    extern double __QtAda_QMatrix_m22_Q(const QMatrix*);
    extern double __QtAda_QMatrix_det_Q(const QMatrix*);
    extern double __QtAda_QMatrix_dx_Q(const QMatrix*);
    extern double __QtAda_QMatrix_dy_Q(const QMatrix*);
    extern void __QtAda_QMatrix_inverted_Q(QMatrix*, const QMatrix*);
    extern unsigned __QtAda_QMatrix_isIdentity_Q(const QMatrix*);
    extern unsigned __QtAda_QMatrix_isInvertible_Q(const QMatrix*);
    extern void __QtAda_QMatrix_map_qreal_qreal_qrealP_qrealP_Q(const QMatrix*, double, double, double*, double*);
    extern void __QtAda_QMatrix_map_int_int_intP_intP_Q(const QMatrix*, int, int, int*, int*);
    extern void __QtAda_QMatrix_map_QPointCR_Q(QPoint*, const QMatrix*, const QPoint*);
    extern void __QtAda_QMatrix_map_QPointFCR_Q(QPointF*, const QMatrix*, const QPointF*);
    extern void __QtAda_QMatrix_map_QLineCR_Q(QLine*, const QMatrix*, const QLine*);
    extern void __QtAda_QMatrix_map_QLineFCR_Q(QLineF*, const QMatrix*, const QLineF*);
    extern void __QtAda_QMatrix_map_QPolygonCR_Q(QPolygon*, const QMatrix*, const QPolygon*);
    extern void __QtAda_QMatrix_map_QPolygonFCR_Q(QPolygonF*, const QMatrix*, const QPolygonF*);
    extern void __QtAda_QMatrix_map_QRegionCR_Q(QRegion*, const QMatrix*, const QRegion*);
    extern void __QtAda_QMatrix_map_QPainterPathCR_Q(QPainterPath*, const QMatrix*, const QPainterPath*);
    extern void __QtAda_QMatrix_mapRect_QRectCR_Q(QRect*, const QMatrix*, const QRect*);
    extern void __QtAda_QMatrix_mapRect_QRectFCR_Q(QRectF*, const QMatrix*, const QRectF*);
    extern void __QtAda_QMatrix_mapToPolygon_QRectCR_Q(QPolygon*, const QMatrix*, const QRect*);
    extern void __QtAda_QMatrix_reset(QMatrix*);
    extern void __QtAda_QMatrix_rotate_qreal(QMatrix*, double);
    extern void __QtAda_QMatrix_scale_qreal_qreal(QMatrix*, double, double);
    extern void __QtAda_QMatrix_setMatrix_qreal_qreal_qreal_qreal_qreal_qreal(QMatrix*, double, double, double, double, double, double);
    extern void __QtAda_QMatrix_shear_qreal_qreal(QMatrix*, double, double);
    extern void __QtAda_QMatrix_translate_qreal_qreal(QMatrix*, double, double);
    extern unsigned __QtAda_QMatrix_eq_QMatrixCR_Q(const QMatrix*, const QMatrix*);
    extern void __QtAda_QMatrix_multiplication_QMatrixCR_Q(QMatrix*, const QMatrix*, const QMatrix*);
    extern void __QtAda_multiplication_QPointCR_QMatrixCR(QPoint*, const QPoint*, const QMatrix*);
    extern void __QtAda_multiplication_QPointFCR_QMatrixCR(QPointF*, const QPointF*, const QMatrix*);
    extern void __QtAda_multiplication_QLineCR_QMatrixCR(QLine*, const QLine*, const QMatrix*);
    extern void __QtAda_multiplication_QLineFCR_QMatrixCR(QLineF*, const QLineF*, const QMatrix*);
    extern void __QtAda_multiplication_QPolygonCR_QMatrixCR(QPolygon*, const QPolygon*, const QMatrix*);
    extern void __QtAda_multiplication_QPolygonFCR_QMatrixCR(QPolygonF*, const QPolygonF*, const QMatrix*);
    extern void __QtAda_multiplication_QRegionCR_QMatrixCR(QRegion*, const QRegion*, const QMatrix*);
    extern void __QtAda_multiplication_QPainterPathCR_QMatrixCR(QPainterPath*, const QPainterPath*, const QMatrix*);

};

