//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QMDIAREADIRECTOR_H__
#define __QMDIAREADIRECTOR_H__

#include <QMdiArea>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QMdiArea_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern QObject* __Qt4Ada_QMdiArea_activeSubWindow_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiArea_background_0_wrapper(QObject*, QBrush*);
    extern QObject* __Qt4Ada_QMdiArea_currentSubWindow_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiArea_removeSubWindow_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMdiArea_setBackground_0_wrapper(QObject*, const QBrush*);
    extern void __Qt4Ada_QMdiArea_activateNextSubWindow_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiArea_activatePreviousSubWindow_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiArea_cascadeSubWindows_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiArea_closeActiveSubWindow_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiArea_closeAllSubWindows_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiArea_setActiveSubWindow_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMdiArea_tileSubWindows_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiArea_subWindowActivated_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMdiArea_minimumSizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QMdiArea_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QMdiArea_childEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMdiArea_event_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMdiArea_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QMdiArea_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMdiArea_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_timerEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMdiArea_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QMdiArea_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QMdiArea_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMdiArea_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMdiArea_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QMdiArea_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMdiArea_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiArea_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiArea_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiArea_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QMdiArea_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QMdiArea_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QMdiArea_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QMdiArea_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QMdiArea_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
// Constructors

extern "C"
{
    extern QObject* __Qt4Ada_new_QMdiArea (QObject*);
    extern QObject* __Qt4Ada_QMdiArea_addSubWindow_0_wrapper (QObject*, QObject*, int);
}

class QMdiAreaDirector : public QMdiArea
{
protected:
    void* ada_object;
    QMdiAreaDirector();

    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void childEvent(QChildEvent*);
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void scrollContentsBy(int, int);
    virtual void showEvent(QShowEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual bool viewportEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QMdiArea_subWindowActivated_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QMdiArea_childEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMdiArea_event_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMdiArea_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QMdiArea_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QMdiArea_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_timerEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMdiArea_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend void __Qt4Ada_QMdiArea_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QMdiArea_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMdiArea_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QMdiArea_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QMdiArea_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMdiArea_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QMdiArea_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiArea_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QMdiArea_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QMdiArea_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QMdiArea_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QMdiArea_sender_0_wrapper(QObject*);
};

#endif // __QMDIAREADIRECTOR_H__
