//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QMDISUBWINDOWDIRECTOR_H__
#define __QMDISUBWINDOWDIRECTOR_H__

#include <QMdiSubWindow>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QMdiSubWindow_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QMdiSubWindow_isShaded_0_wrapper(QObject*);
    extern int __Qt4Ada_QMdiSubWindow_keyboardPageStep_0_wrapper(QObject*);
    extern int __Qt4Ada_QMdiSubWindow_keyboardSingleStep_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiSubWindow_setKeyboardPageStep_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QMdiSubWindow_setKeyboardSingleStep_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QMdiSubWindow_setSystemMenu_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMdiSubWindow_setWidget_0_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QMdiSubWindow_systemMenu_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QMdiSubWindow_widget_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiSubWindow_showShaded_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiSubWindow_showSystemMenu_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiSubWindow_aboutToActivate_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiSubWindow_minimumSizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QMdiSubWindow_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QMdiSubWindow_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMdiSubWindow_event_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMdiSubWindow_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QMdiSubWindow_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMdiSubWindow_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMdiSubWindow_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QMdiSubWindow_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiSubWindow_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QMdiSubWindow_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMdiSubWindow_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QMdiSubWindow_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QMdiSubWindow_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QMdiSubWindow_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QMdiSubWindow_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QMdiSubWindow_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject* __Qt4Ada_new_QMdiSubWindow(QObject*, unsigned);
    extern QObject* __Qt4Ada_new_QMdiSubWindowDirector(void*, QObject*, unsigned);

}

class QMdiSubWindowDirector : public QMdiSubWindow
{
protected:
    void* ada_object;
    QMdiSubWindowDirector(void*, QWidget*, Qt::WindowFlags);

    friend QObject* __Qt4Ada_new_QMdiSubWindowDirector(void*, QObject*, unsigned);

    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void changeEvent(QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QMdiSubWindow_aboutToActivate_0_wrapper(QObject*);
    friend void __Qt4Ada_QMdiSubWindow_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMdiSubWindow_event_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMdiSubWindow_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QMdiSubWindow_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMdiSubWindow_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QMdiSubWindow_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QMdiSubWindow_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QMdiSubWindow_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QMdiSubWindow_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMdiSubWindow_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QMdiSubWindow_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QMdiSubWindow_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QMdiSubWindow_sender_0_wrapper(QObject*);
};

#endif // __QMDISUBWINDOWDIRECTOR_H__
