//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QAction>
#include <QRect>
#include <QIcon>
#include <QString>
#include <QSize>
#include <QActionEvent>
#include <QHideEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QTimerEvent>
#include <QWheelEvent>
#include <QVariant>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qmenudirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QMenu_staticMetaObject =
        &QMenu::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    QObject* __Qt4Ada_QMenu_actionAt_0_wrapper(QObject* cpp_object, const QPoint* pt)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::actionAt(*pt));
    }

    void __Qt4Ada_QMenu_actionGeometry_0_wrapper(QObject* cpp_object, QObject* act, QRect* returns)
    {
        *returns = dynamic_cast<QMenu*>(cpp_object)->QMenu::actionGeometry(dynamic_cast<QAction*>(act));
    }

    QObject* __Qt4Ada_QMenu_addAction_2_wrapper(QObject* cpp_object, const QString* text)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::addAction(*text));
    }

    QObject* __Qt4Ada_QMenu_addAction_1_wrapper(QObject* cpp_object, const QIcon* icon, const QString* text)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::addAction(*icon, *text));
    }

    QObject* __Qt4Ada_QMenu_addMenu_2_wrapper(QObject* cpp_object, QObject* menu)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::addMenu(dynamic_cast<QMenu*>(menu)));
    }

    QObject* __Qt4Ada_QMenu_addMenu_1_wrapper(QObject* cpp_object, const QString* text)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::addMenu(*text));
    }

    QObject* __Qt4Ada_QMenu_addMenu_0_wrapper(QObject* cpp_object, const QIcon* icon, const QString* text)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::addMenu(*icon, *text));
    }

    QObject* __Qt4Ada_QMenu_addSeparator_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::addSeparator());
    }

    void __Qt4Ada_QMenu_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMenu*>(cpp_object)->QMenu::clear();
    }

    QObject* __Qt4Ada_QMenu_defaultAction_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::defaultAction());
    }

    QObject* __Qt4Ada_QMenu_exec_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::exec());
    }

    void __Qt4Ada_QMenu_hideTearOffMenu_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMenu*>(cpp_object)->QMenu::hideTearOffMenu();
    }

    void __Qt4Ada_QMenu_icon_0_wrapper(QObject* cpp_object, QIcon* returns)
    {
        *returns = dynamic_cast<QMenu*>(cpp_object)->QMenu::icon();
    }

    QObject* __Qt4Ada_QMenu_insertMenu_0_wrapper(QObject* cpp_object, QObject* before, QObject* menu)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::insertMenu(dynamic_cast<QAction*>(before), dynamic_cast<QMenu*>(menu)));
    }

    QObject* __Qt4Ada_QMenu_insertSeparator_0_wrapper(QObject* cpp_object, QObject* before)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::insertSeparator(dynamic_cast<QAction*>(before)));
    }

    bool __Qt4Ada_QMenu_isEmpty_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMenu*>(cpp_object)->QMenu::isEmpty();
    }

    bool __Qt4Ada_QMenu_isTearOffEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMenu*>(cpp_object)->QMenu::isTearOffEnabled();
    }

    bool __Qt4Ada_QMenu_isTearOffMenuVisible_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMenu*>(cpp_object)->QMenu::isTearOffMenuVisible();
    }

    QObject* __Qt4Ada_QMenu_menuAction_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMenu*>(cpp_object)->QMenu::menuAction());
    }

    bool __Qt4Ada_QMenu_separatorsCollapsible_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMenu*>(cpp_object)->QMenu::separatorsCollapsible();
    }

    void __Qt4Ada_QMenu_setActiveAction_0_wrapper(QObject* cpp_object, QObject* act)
    {
        dynamic_cast<QMenu*>(cpp_object)->QMenu::setActiveAction(dynamic_cast<QAction*>(act));
    }

    void __Qt4Ada_QMenu_setDefaultAction_0_wrapper(QObject* cpp_object, QObject* act)
    {
        dynamic_cast<QMenu*>(cpp_object)->QMenu::setDefaultAction(dynamic_cast<QAction*>(act));
    }

    void __Qt4Ada_QMenu_setIcon_0_wrapper(QObject* cpp_object, const QIcon* icon)
    {
        dynamic_cast<QMenu*>(cpp_object)->QMenu::setIcon(*icon);
    }

    void __Qt4Ada_QMenu_setSeparatorsCollapsible_0_wrapper(QObject* cpp_object, bool collapse)
    {
        dynamic_cast<QMenu*>(cpp_object)->QMenu::setSeparatorsCollapsible(collapse);
    }

    void __Qt4Ada_QMenu_setTearOffEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QMenu*>(cpp_object)->QMenu::setTearOffEnabled(enable);
    }

    void __Qt4Ada_QMenu_setTitle_0_wrapper(QObject* cpp_object, const QString* title)
    {
        dynamic_cast<QMenu*>(cpp_object)->QMenu::setTitle(*title);
    }

    void __Qt4Ada_QMenu_title_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QMenu*>(cpp_object)->QMenu::title();
    }

    void __Qt4Ada_QMenu_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QMenu*>(cpp_object)->QMenu::sizeHint();
    }

    int __Qt4Ada_QMenu_columnCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::columnCount();
    }

    void __Qt4Ada_QMenu_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QMenu_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::changeEvent(event);
    }

    void __Qt4Ada_QMenu_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QMenu_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::enterEvent(event);
    }

    bool __Qt4Ada_QMenu_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::event(e);
    }

    bool __Qt4Ada_QMenu_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::focusNextPrevChild(next);
    }

    void __Qt4Ada_QMenu_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QMenu_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::leaveEvent(event);
    }

    void __Qt4Ada_QMenu_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMenu_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMenu_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMenu_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QMenu_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QMenu_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QMenu::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QMenu_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QMenu_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QMenu_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QMenu_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QMenu_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QMenu_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QMenu_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QMenu_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QMenu_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    void __Qt4Ada_QMenu_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QMenu_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QMenu_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QMenu_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QMenu_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMenu_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QMenu_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QMenu_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QMenu_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QMenu_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QMenu_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QMenuDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QMenu_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QMenu_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMenuDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QMenu_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMenuDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QMenu_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QMenu*>(cpp_this)->QMenu::qt_metacast(name);
    }

    int __Qt4Ada_QMenu_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QMenu*>(cpp_this)->QMenu::qt_metacall(_c, _id, _a);
    }

}

QSize QMenuDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QMenuDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QMenuDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QMenuDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QMenuDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QMenuDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QMenuDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QMenuDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QMenuDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QMenuDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QMenuDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QMenuDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QMenuDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QMenuDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QMenuDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QMenuDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QMenuDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
extern "C" {

    QObject* __Qt4Ada_new_QMenu (QObject* parent)
    {
        return dynamic_cast<QObject *>
                  (new QMenu(dynamic_cast<QWidget*>(parent)));
    }

    QObject * __Qt4Ada_new_QMenu_QString (QString* text, QObject* parent)
    {
        return dynamic_cast<QObject *>
                  (new QMenu(*text, dynamic_cast<QWidget*> (parent)));
    }

}
