//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QMENUDIRECTOR_H__
#define __QMENUDIRECTOR_H__

#include <QMenu>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QMenu_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern QObject* __Qt4Ada_QMenu_actionAt_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QMenu_actionGeometry_0_wrapper(QObject*, QObject*, QRect*);
    extern QObject* __Qt4Ada_QMenu_addAction_2_wrapper(QObject*, const QString*);
    extern QObject* __Qt4Ada_QMenu_addAction_1_wrapper(QObject*, const QIcon*, const QString*);
    extern QObject* __Qt4Ada_QMenu_addMenu_2_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QMenu_addMenu_1_wrapper(QObject*, const QString*);
    extern QObject* __Qt4Ada_QMenu_addMenu_0_wrapper(QObject*, const QIcon*, const QString*);
    extern QObject* __Qt4Ada_QMenu_addSeparator_0_wrapper(QObject*);
    extern void __Qt4Ada_QMenu_clear_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QMenu_defaultAction_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QMenu_exec_0_wrapper(QObject*);
    extern void __Qt4Ada_QMenu_hideTearOffMenu_0_wrapper(QObject*);
    extern void __Qt4Ada_QMenu_icon_0_wrapper(QObject*, QIcon*);
    extern QObject* __Qt4Ada_QMenu_insertMenu_0_wrapper(QObject*, QObject*, QObject*);
    extern QObject* __Qt4Ada_QMenu_insertSeparator_0_wrapper(QObject*, QObject*);
    extern bool __Qt4Ada_QMenu_isEmpty_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMenu_isTearOffEnabled_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMenu_isTearOffMenuVisible_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QMenu_menuAction_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMenu_separatorsCollapsible_0_wrapper(QObject*);
    extern void __Qt4Ada_QMenu_setActiveAction_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMenu_setDefaultAction_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMenu_setIcon_0_wrapper(QObject*, const QIcon*);
    extern void __Qt4Ada_QMenu_setSeparatorsCollapsible_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QMenu_setTearOffEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QMenu_setTitle_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QMenu_title_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QMenu_sizeHint_0_wrapper(QObject*, QSize*);
    extern int __Qt4Ada_QMenu_columnCount_0_wrapper(QObject*);
    extern void __Qt4Ada_QMenu_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMenu_event_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMenu_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QMenu_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QMenu_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMenu_focusNextChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QMenu_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMenu_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QMenu_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QMenu_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QMenu_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QMenu_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMenu_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QMenu_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QMenu_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QMenu_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
extern "C" {

    // Constructors

    extern QObject * __Qt4Ada_new_QMenu (QObject*);
    extern QObject * __Qt4Ada_new_QMenu_QString (QString*, QObject*);

}

class QMenuDirector : public QMenu
{
protected:
    void* ada_object;
    QMenuDirector();

    virtual QSize sizeHint() const;
    virtual void actionEvent(QActionEvent*);
    virtual void changeEvent(QEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool event(QEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual void setVisible(bool);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend int __Qt4Ada_QMenu_columnCount_0_wrapper(QObject*);
    friend void __Qt4Ada_QMenu_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMenu_event_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMenu_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QMenu_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QMenu_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMenu_focusNextChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QMenu_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMenu_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QMenu_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QMenu_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QMenu_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QMenu_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMenu_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QMenu_sender_0_wrapper(QObject*);
};

#endif // __QMENUDIRECTOR_H__
