//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QPainterPath>

extern "C"
{
    extern QPainterPath* __QtAda_inititialize_QPainterPath(void*);
    extern QPainterPath* __QtAda_inititialize_QPainterPath_QPointFCR(void*, const QPointF*);
    extern QPainterPath* __QtAda_adjust_QPainterPath(void*, const QPainterPath*);
    extern void __QtAda_finalize_QPainterPath(QPainterPath*);

    extern void __QtAda_QPainterPath_addEllipse_QRectFCR(QPainterPath*, const QRectF*);
    extern void __QtAda_QPainterPath_addEllipse_qreal_qreal_qreal_qreal(QPainterPath*, double, double, double, double);
    extern void __QtAda_QPainterPath_addEllipse_QPointFCR_qreal_qreal(QPainterPath*, const QPointF*, double, double);
    extern void __QtAda_QPainterPath_addPath_QPainterPathCR(QPainterPath*, const QPainterPath*);
    extern void __QtAda_QPainterPath_addPolygon_QPolygonFCR(QPainterPath*, const QPolygonF*);
    extern void __QtAda_QPainterPath_addRect_QRectFCR(QPainterPath*, const QRectF*);
    extern void __QtAda_QPainterPath_addRect_qreal_qreal_qreal_qreal(QPainterPath*, double, double, double, double);
    extern void __QtAda_QPainterPath_addRegion_QRegionCR(QPainterPath*, const QRegion*);
    extern void __QtAda_QPainterPath_addRoundedRect_QRectFCR_qreal_qreal_SizeMode(QPainterPath*, const QRectF*, double, double, unsigned);
    extern void __QtAda_QPainterPath_addRoundedRect_qreal_qreal_qreal_qreal_qreal_qreal_SizeMode(QPainterPath*, double, double, double, double, double, double, unsigned);
    extern void __QtAda_QPainterPath_addText_QPointFCR_QFontCR_QStringCR(QPainterPath*, const QPointF*, const QFont*, const QString*);
    extern void __QtAda_QPainterPath_addText_qreal_qreal_QFontCR_QStringCR(QPainterPath*, double, double, const QFont*, const QString*);
    extern double __QtAda_QPainterPath_angleAtPercent_qreal_Q(const QPainterPath*, double);
    extern void __QtAda_QPainterPath_arcMoveTo_QRectFCR_qreal(QPainterPath*, const QRectF*, double);
    extern void __QtAda_QPainterPath_arcMoveTo_qreal_qreal_qreal_qreal_qreal(QPainterPath*, double, double, double, double, double);
    extern void __QtAda_QPainterPath_arcTo_QRectFCR_qreal_qreal(QPainterPath*, const QRectF*, double, double);
    extern void __QtAda_QPainterPath_arcTo_qreal_qreal_qreal_qreal_qreal_qreal(QPainterPath*, double, double, double, double, double, double);
    extern void __QtAda_QPainterPath_boundingRect_Q(QRectF*, const QPainterPath*);
    extern void __QtAda_QPainterPath_closeSubpath(QPainterPath*);
    extern void __QtAda_QPainterPath_connectPath_QPainterPathCR(QPainterPath*, const QPainterPath*);
    extern unsigned __QtAda_QPainterPath_contains_QPointFCR_Q(const QPainterPath*, const QPointF*);
    extern unsigned __QtAda_QPainterPath_contains_QRectFCR_Q(const QPainterPath*, const QRectF*);
    extern unsigned __QtAda_QPainterPath_contains_QPainterPathCR_Q(const QPainterPath*, const QPainterPath*);
    extern void __QtAda_QPainterPath_controlPointRect_Q(QRectF*, const QPainterPath*);
    extern void __QtAda_QPainterPath_cubicTo_QPointFCR_QPointFCR_QPointFCR(QPainterPath*, const QPointF*, const QPointF*, const QPointF*);
    extern void __QtAda_QPainterPath_cubicTo_qreal_qreal_qreal_qreal_qreal_qreal(QPainterPath*, double, double, double, double, double, double);
    extern void __QtAda_QPainterPath_currentPosition_Q(QPointF*, const QPainterPath*);
    extern int __QtAda_QPainterPath_elementCount_Q(const QPainterPath*);
    extern unsigned __QtAda_QPainterPath_fillRule_Q(const QPainterPath*);
    extern void __QtAda_QPainterPath_intersected_QPainterPathCR_Q(QPainterPath*, const QPainterPath*, const QPainterPath*);
    extern unsigned __QtAda_QPainterPath_intersects_QRectFCR_Q(const QPainterPath*, const QRectF*);
    extern unsigned __QtAda_QPainterPath_intersects_QPainterPathCR_Q(const QPainterPath*, const QPainterPath*);
    extern unsigned __QtAda_QPainterPath_isEmpty_Q(const QPainterPath*);
    extern double __QtAda_QPainterPath_length_Q(const QPainterPath*);
    extern void __QtAda_QPainterPath_lineTo_QPointFCR(QPainterPath*, const QPointF*);
    extern void __QtAda_QPainterPath_lineTo_qreal_qreal(QPainterPath*, double, double);
    extern void __QtAda_QPainterPath_moveTo_QPointFCR(QPainterPath*, const QPointF*);
    extern void __QtAda_QPainterPath_moveTo_qreal_qreal(QPainterPath*, double, double);
    extern double __QtAda_QPainterPath_percentAtLength_qreal_Q(const QPainterPath*, double);
    extern void __QtAda_QPainterPath_pointAtPercent_qreal_Q(QPointF*, const QPainterPath*, double);
    extern void __QtAda_QPainterPath_quadTo_QPointFCR_QPointFCR(QPainterPath*, const QPointF*, const QPointF*);
    extern void __QtAda_QPainterPath_quadTo_qreal_qreal_qreal_qreal(QPainterPath*, double, double, double, double);
    extern void __QtAda_QPainterPath_setElementPositionAt_int_qreal_qreal(QPainterPath*, int, double, double);
    extern void __QtAda_QPainterPath_setFillRule_FillRule(QPainterPath*, unsigned);
    extern void __QtAda_QPainterPath_simplified_Q(QPainterPath*, const QPainterPath*);
    extern double __QtAda_QPainterPath_slopeAtPercent_qreal_Q(const QPainterPath*, double);
    extern void __QtAda_QPainterPath_subtracted_QPainterPathCR_Q(QPainterPath*, const QPainterPath*, const QPainterPath*);
    extern void __QtAda_QPainterPath_toFillPolygon_QTransformCR_Q(QPolygonF*, const QPainterPath*, const QTransform*);
    extern void __QtAda_QPainterPath_toFillPolygon_QMatrixCR_Q(QPolygonF*, const QPainterPath*, const QMatrix*);
    extern void __QtAda_QPainterPath_toReversed_Q(QPainterPath*, const QPainterPath*);
    extern void __QtAda_QPainterPath_united_QPainterPathCR_Q(QPainterPath*, const QPainterPath*, const QPainterPath*);
    extern unsigned __QtAda_QPainterPath_eq_QPainterPathCR_Q(const QPainterPath*, const QPainterPath*);

    extern QPainterPath* __Qt4Ada_copy_QPainterPath(const QPainterPath*);

};

