//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QPixmap>

extern "C"
{
    extern QPixmap* __QtAda_inititialize_QPixmap(void*);
    extern QPixmap* __QtAda_inititialize_QPixmap_int_int(void*, int, int);
    extern QPixmap* __QtAda_initialize_QPixmap_QStringCR_charP_QtImageConversionFlags(void*, QString*, char*, unsigned);
    extern QPixmap* __QtAda_inititialize_QPixmap_QSizeCR(void*, const QSize*);
    extern QPixmap* __QtAda_adjust_QPixmap(void*, const QPixmap*);
    extern void __QtAda_finalize_QPixmap(QPixmap*);

    extern void __QtAda_QPixmap_alphaChannel_Q(QPixmap*, const QPixmap*);
    extern void __QtAda_QPixmap_copy_QRectCR_Q(QPixmap*, const QPixmap*, const QRect*);
    extern void __QtAda_QPixmap_copy_int_int_int_int_Q(QPixmap*, const QPixmap*, int, int, int, int);
    extern void __QtAda_QPixmap_createHeuristicMask_bool_Q(QPixmap*, const QPixmap*, unsigned);
    extern void __QtAda_QPixmap_createMaskFromColor_QColorCR_MaskMode_Q(QPixmap*, const QPixmap*, const QColor*, unsigned);
    extern void __QtAda_QPixmap_createMaskFromColor_QColorCR_Q(QPixmap*, const QPixmap*, const QColor*);
    extern int __QtAda_QPixmap_depth_Q(const QPixmap*);
    extern void __QtAda_QPixmap_detach(QPixmap*);
    extern void __QtAda_QPixmap_fill_QColorCR(QPixmap*, const QColor*);
    extern unsigned __QtAda_QPixmap_hasAlpha_Q(const QPixmap*);
    extern unsigned __QtAda_QPixmap_hasAlphaChannel_Q(const QPixmap*);
    extern int __QtAda_QPixmap_height_Q(const QPixmap*);
    extern unsigned __QtAda_QPixmap_isNull_Q(const QPixmap*);
    extern unsigned __QtAda_QPixmap_isQBitmap_Q(const QPixmap*);
    extern void __QtAda_QPixmap_mask_Q(QPixmap*, const QPixmap*);
    extern void __QtAda_QPixmap_rect_Q(QRect*, const QPixmap*);
    extern void __QtAda_QPixmap_scaled_QSizeCR_AspectRatioMode_TransformationMode_Q(QPixmap*, const QPixmap*, const QSize*, unsigned, unsigned);
    extern void __QtAda_QPixmap_scaled_int_int_AspectRatioMode_TransformationMode_Q(QPixmap*, const QPixmap*, int, int, unsigned, unsigned);
    extern void __QtAda_QPixmap_scaledToHeight_int_TransformationMode_Q(QPixmap*, const QPixmap*, int, unsigned);
    extern void __QtAda_QPixmap_scaledToWidth_int_TransformationMode_Q(QPixmap*, const QPixmap*, int, unsigned);
    extern void __QtAda_QPixmap_setAlphaChannel_QPixmapCR(QPixmap*, const QPixmap*);
    extern void __QtAda_QPixmap_setMask_QBitmapCR(QPixmap*, const QPixmap*);
    extern void __QtAda_QPixmap_size_Q(QSize*, const QPixmap*);
    extern void __QtAda_QPixmap_transformed_QTransformCR_TransformationMode_Q(QPixmap*, const QPixmap*, const QTransform*, unsigned);
    extern void __QtAda_QPixmap_transformed_QMatrixCR_TransformationMode_Q(QPixmap*, const QPixmap*, const QMatrix*, unsigned);
    extern int __QtAda_QPixmap_width_Q(const QPixmap*);
    extern int __QtAda_QPixmap_defaultDepth_S();
    extern void __QtAda_QPixmap_trueMatrix_QTransformCR_int_int_S(QTransform*, const QTransform*, int, int);
    extern void __QtAda_QPixmap_trueMatrix_QMatrixCR_int_int_S(QMatrix*, const QMatrix*, int, int);

    extern QPaintDevice* __QtAda_QPixmap_QPaintDevice_View(QPixmap*);

};

