//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QRectF>
#include <QSizeF>
#include <QTextFrame>
#include <QChildEvent>
#include <QTimerEvent>

#include "qplaintextdocumentlayoutdirector.h"
#include "qabstracttextdocumentlayoutdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QPlainTextDocumentLayout_staticMetaObject =
        &QPlainTextDocumentLayout::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    int __Qt4Ada_QPlainTextDocumentLayout_cursorWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextDocumentLayout*>(cpp_object)->QPlainTextDocumentLayout::cursorWidth();
    }

    void __Qt4Ada_QPlainTextDocumentLayout_ensureBlockLayout_0_wrapper(QObject* cpp_object, const QTextBlock* block)
    {
        dynamic_cast<QPlainTextDocumentLayout*>(cpp_object)->QPlainTextDocumentLayout::ensureBlockLayout(*block);
    }

    void __Qt4Ada_QPlainTextDocumentLayout_requestUpdate_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextDocumentLayout*>(cpp_object)->QPlainTextDocumentLayout::requestUpdate();
    }

    void __Qt4Ada_QPlainTextDocumentLayout_setCursorWidth_0_wrapper(QObject* cpp_object, int width)
    {
        dynamic_cast<QPlainTextDocumentLayout*>(cpp_object)->QPlainTextDocumentLayout::setCursorWidth(width);
    }

    void __Qt4Ada_QPlainTextDocumentLayout_documentSizeChanged_0_wrapper(QObject* cpp_object, const QSizeF* newSize)
    {
        dynamic_cast<QPlainTextDocumentLayoutDirector*>(cpp_object)->QAbstractTextDocumentLayout::documentSizeChanged(*newSize);
    }

    void __Qt4Ada_QPlainTextDocumentLayout_pageCountChanged_0_wrapper(QObject* cpp_object, int newPages)
    {
        dynamic_cast<QPlainTextDocumentLayoutDirector*>(cpp_object)->QAbstractTextDocumentLayout::pageCountChanged(newPages);
    }

    void __Qt4Ada_QPlainTextDocumentLayout_update_0_wrapper(QObject* cpp_object, const QRectF* rect)
    {
        dynamic_cast<QPlainTextDocumentLayoutDirector*>(cpp_object)->QAbstractTextDocumentLayout::update(*rect);
    }

    void __Qt4Ada_QPlainTextDocumentLayout_updateBlock_0_wrapper(QObject* cpp_object, const QTextBlock* block)
    {
        dynamic_cast<QPlainTextDocumentLayoutDirector*>(cpp_object)->QAbstractTextDocumentLayout::updateBlock(*block);
    }

    void __Qt4Ada_QPlainTextDocumentLayout_format_0_wrapper(QObject* cpp_object, int position, QTextFormat* returns)
    {
        *static_cast<QTextCharFormat*>(returns) = dynamic_cast<QPlainTextDocumentLayoutDirector*>(cpp_object)->QAbstractTextDocumentLayout::format(position);
    }

    void __Qt4Ada_QPlainTextDocumentLayout_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextDocumentLayoutDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QPlainTextDocumentLayout_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextDocumentLayoutDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QPlainTextDocumentLayout_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextDocumentLayoutDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QPlainTextDocumentLayout_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextDocumentLayoutDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QPlainTextDocumentLayout_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QPlainTextDocumentLayout*>(cpp_this)->QPlainTextDocumentLayout::qt_metacast(name);
    }

    int __Qt4Ada_QPlainTextDocumentLayout_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QPlainTextDocumentLayout*>(cpp_this)->QPlainTextDocumentLayout::qt_metacall(_c, _id, _a);
    }

}

QRectF QPlainTextDocumentLayoutDirector::blockBoundingRect(const QTextBlock& block) const
{
    QRectF *aux = __Qt4Ada_QAbstractTextDocumentLayout_blockBoundingRect_0_dispatch(this->ada_object, &block);
    QRectF returns = *aux;
    delete aux;
    return returns;
}

QSizeF QPlainTextDocumentLayoutDirector::documentSize() const
{
    QSizeF *aux = __Qt4Ada_QAbstractTextDocumentLayout_documentSize_0_dispatch(this->ada_object);
    QSizeF returns = *aux;
    delete aux;
    return returns;
}

QRectF QPlainTextDocumentLayoutDirector::frameBoundingRect(QTextFrame* frame) const
{
    QRectF *aux = __Qt4Ada_QAbstractTextDocumentLayout_frameBoundingRect_0_dispatch(this->ada_object, frame);
    QRectF returns = *aux;
    delete aux;
    return returns;
}

int QPlainTextDocumentLayoutDirector::hitTest(const QPointF& point, Qt::HitTestAccuracy accuracy) const
{
    return __Qt4Ada_QAbstractTextDocumentLayout_hitTest_0_dispatch(this->ada_object, &point, accuracy);
}

int QPlainTextDocumentLayoutDirector::pageCount() const
{
    return __Qt4Ada_QAbstractTextDocumentLayout_pageCount_0_dispatch(this->ada_object);
}

void QPlainTextDocumentLayoutDirector::documentChanged(int from, int charsRemoved, int charsAdded)
{
    __Qt4Ada_QAbstractTextDocumentLayout_documentChanged_0_dispatch(this->ada_object, from, charsRemoved, charsAdded);
}

bool QPlainTextDocumentLayoutDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QPlainTextDocumentLayoutDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QPlainTextDocumentLayoutDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextDocumentLayoutDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextDocumentLayoutDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QPlainTextDocumentLayoutDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QPlainTextDocumentLayoutDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QPlainTextDocumentLayoutDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
