//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QChildEvent>
#include <QTimerEvent>

#include "qplastiquestyledirector.h"
#include "qwindowsstyledirector.h"
#include "qcommonstyledirector.h"
#include "qstyledirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QPlastiqueStyle_staticMetaObject =
        &QPlastiqueStyle::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QPlastiqueStyle_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlastiqueStyleDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QPlastiqueStyle_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlastiqueStyleDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QPlastiqueStyle_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlastiqueStyleDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QPlastiqueStyle_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlastiqueStyleDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QPlastiqueStyle_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QPlastiqueStyle*>(cpp_this)->QPlastiqueStyle::qt_metacast(name);
    }

    int __Qt4Ada_QPlastiqueStyle_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QPlastiqueStyle*>(cpp_this)->QPlastiqueStyle::qt_metacall(_c, _id, _a);
    }

}

bool QPlastiqueStyleDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QPlastiqueStyleDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QPlastiqueStyleDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QPlastiqueStyleDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QPlastiqueStyleDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QPlastiqueStyleDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QPlastiqueStyleDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QPlastiqueStyleDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
