//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QPoint>
#include <QPolygon>
#include <QRect>
#include <QString>
#include "qpolygonwrapper.h"

extern "C"
{

    QPolygon* __QtAda_inititialize_QPolygon(void* storage)
    {
        return new (storage) QPolygon();
    }

    QPolygon* __QtAda_inititialize_QPolygon_int(void* storage, int size)
    {
        return new (storage) QPolygon(size);
    }

    QPolygon* __QtAda_inititialize_QPolygon_QRectCR_bool(void* storage, const QRect* r, unsigned closed)
    {
        return new (storage) QPolygon(*r, (bool)closed);
    }

    QPolygon* __QtAda_adjust_QPolygon(void* storage, const QPolygon* from)
    {
        return new (storage) QPolygon(*from);
    }

    void __QtAda_finalize_QPolygon(QPolygon *item)
    {
        item->~QPolygon();
    }

    void __QtAda_QPolygon_boundingRect_Q(QRect* returns, const QPolygon* self)
    {
        *returns = self->boundingRect();
    }

    unsigned __QtAda_QPolygon_containsPoint_QPointCR_FillRule_Q(const QPolygon* self, const QPoint* pt, unsigned fillRule)
    {
        return (unsigned)self->containsPoint(*pt, (Qt::FillRule)fillRule);
    }

    void __QtAda_QPolygon_intersected_QPolygonCR_Q(QPolygon* returns, const QPolygon* self, const QPolygon* r)
    {
        *returns = self->intersected(*r);
    }

    void __QtAda_QPolygon_point_int_intP_intP_Q(const QPolygon* self, int i, int* x, int* y)
    {
        self->point(i, x, y);
    }

    void __QtAda_QPolygon_point_int_Q(QPoint* returns, const QPolygon* self, int i)
    {
        *returns = self->point(i);
    }

    void __QtAda_QPolygon_putPoints_int_int_QPolygonCR_int(QPolygon* self, int index, int nPoints, const QPolygon* from, int fromIndex)
    {
        self->putPoints(index, nPoints, *from, fromIndex);
    }

    void __QtAda_QPolygon_setPoint_int_int_int(QPolygon* self, int index, int x, int y)
    {
        self->setPoint(index, x, y);
    }

    void __QtAda_QPolygon_setPoint_int_QPointCR(QPolygon* self, int index, const QPoint* p)
    {
        self->setPoint(index, *p);
    }

    void __QtAda_QPolygon_subtracted_QPolygonCR_Q(QPolygon* returns, const QPolygon* self, const QPolygon* r)
    {
        *returns = self->subtracted(*r);
    }

    void __QtAda_QPolygon_translate_int_int(QPolygon* self, int dx, int dy)
    {
        self->translate(dx, dy);
    }

    void __QtAda_QPolygon_translate_QPointCR(QPolygon* self, const QPoint* offset)
    {
        self->translate(*offset);
    }

    void __QtAda_QPolygon_united_QPolygonCR_Q(QPolygon* returns, const QPolygon* self, const QPolygon* r)
    {
        *returns = self->united(*r);
    }

};

