//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QRect>
#include <QSizeF>
#include <QString>
#include "qprinterwrapper.h"

extern "C"
{

    QPrinter* __QtAda_inititialize_QPrinter(void* storage)
    {
        return new (storage) QPrinter();
    }

    QPrinter* __QtAda_inititialize_QPrinter_PrinterMode(void* storage, unsigned mode)
    {
        return new (storage) QPrinter((QPrinter::PrinterMode)mode);
    }

    void __QtAda_finalize_QPrinter(QPrinter *item)
    {
        item->~QPrinter();
    }

    unsigned __QtAda_QPrinter_abort(QPrinter* self)
    {
        return (unsigned)self->abort();
    }

    unsigned __QtAda_QPrinter_collateCopies_Q(const QPrinter* self)
    {
        return (unsigned)self->collateCopies();
    }

    unsigned __QtAda_QPrinter_colorMode_Q(const QPrinter* self)
    {
        return (unsigned)self->colorMode();
    }

    void __QtAda_QPrinter_creator_Q(QString* returns, const QPrinter* self)
    {
        *returns = self->creator();
    }

    void __QtAda_QPrinter_docName_Q(QString* returns, const QPrinter* self)
    {
        *returns = self->docName();
    }

    unsigned __QtAda_QPrinter_doubleSidedPrinting_Q(const QPrinter* self)
    {
        return (unsigned)self->doubleSidedPrinting();
    }

    unsigned __QtAda_QPrinter_fontEmbeddingEnabled_Q(const QPrinter* self)
    {
        return (unsigned)self->fontEmbeddingEnabled();
    }

    int __QtAda_QPrinter_fromPage_Q(const QPrinter* self)
    {
        return self->fromPage();
    }

    unsigned __QtAda_QPrinter_fullPage_Q(const QPrinter* self)
    {
        return (unsigned)self->fullPage();
    }

    unsigned __QtAda_QPrinter_newPage(QPrinter* self)
    {
        return (unsigned)self->newPage();
    }

    int __QtAda_QPrinter_numCopies_Q(const QPrinter* self)
    {
        return self->numCopies();
    }

    unsigned __QtAda_QPrinter_orientation_Q(const QPrinter* self)
    {
        return (unsigned)self->orientation();
    }

    void __QtAda_QPrinter_outputFileName_Q(QString* returns, const QPrinter* self)
    {
        *returns = self->outputFileName();
    }

    unsigned __QtAda_QPrinter_outputFormat_Q(const QPrinter* self)
    {
        return (unsigned)self->outputFormat();
    }

    unsigned __QtAda_QPrinter_pageOrder_Q(const QPrinter* self)
    {
        return (unsigned)self->pageOrder();
    }

    void __QtAda_QPrinter_pageRect_Q(QRect* returns, const QPrinter* self)
    {
        *returns = self->pageRect();
    }

    unsigned __QtAda_QPrinter_pageSize_Q(const QPrinter* self)
    {
        return (unsigned)self->pageSize();
    }

    void __QtAda_QPrinter_paperRect_Q(QRect* returns, const QPrinter* self)
    {
        *returns = self->paperRect();
    }

    unsigned __QtAda_QPrinter_paperSize_Q(const QPrinter* self)
    {
        return (unsigned)self->paperSize();
    }

    void __QtAda_QPrinter_paperSize_Unit_Q(QSizeF* returns, const QPrinter* self, unsigned unit)
    {
        *returns = self->paperSize((QPrinter::Unit)unit);
    }

    unsigned __QtAda_QPrinter_paperSource_Q(const QPrinter* self)
    {
        return (unsigned)self->paperSource();
    }

    void __QtAda_QPrinter_printProgram_Q(QString* returns, const QPrinter* self)
    {
        *returns = self->printProgram();
    }

    unsigned __QtAda_QPrinter_printRange_Q(const QPrinter* self)
    {
        return (unsigned)self->printRange();
    }

    void __QtAda_QPrinter_printerName_Q(QString* returns, const QPrinter* self)
    {
        *returns = self->printerName();
    }

    unsigned __QtAda_QPrinter_printerState_Q(const QPrinter* self)
    {
        return (unsigned)self->printerState();
    }

    int __QtAda_QPrinter_resolution_Q(const QPrinter* self)
    {
        return self->resolution();
    }

    void __QtAda_QPrinter_setCollateCopies_bool(QPrinter* self, unsigned collate)
    {
        self->setCollateCopies((bool)collate);
    }

    void __QtAda_QPrinter_setColorMode_ColorMode(QPrinter* self, unsigned mode)
    {
        self->setColorMode((QPrinter::ColorMode)mode);
    }

    void __QtAda_QPrinter_setCreator_QStringCR(QPrinter* self, const QString* creator)
    {
        self->setCreator(*creator);
    }

    void __QtAda_QPrinter_setDocName_QStringCR(QPrinter* self, const QString* name)
    {
        self->setDocName(*name);
    }

    void __QtAda_QPrinter_setDoubleSidedPrinting_bool(QPrinter* self, unsigned enable)
    {
        self->setDoubleSidedPrinting((bool)enable);
    }

    void __QtAda_QPrinter_setFontEmbeddingEnabled_bool(QPrinter* self, unsigned enable)
    {
        self->setFontEmbeddingEnabled((bool)enable);
    }

    void __QtAda_QPrinter_setFromTo_int_int(QPrinter* self, int fromPage, int toPage)
    {
        self->setFromTo(fromPage, toPage);
    }

    void __QtAda_QPrinter_setFullPage_bool(QPrinter* self, unsigned fp)
    {
        self->setFullPage((bool)fp);
    }

    void __QtAda_QPrinter_setNumCopies_int(QPrinter* self, int numCopies)
    {
        self->setNumCopies(numCopies);
    }

    void __QtAda_QPrinter_setOrientation_Orientation(QPrinter* self, unsigned orientation)
    {
        self->setOrientation((QPrinter::Orientation)orientation);
    }

    void __QtAda_QPrinter_setOutputFileName_QStringCR(QPrinter* self, const QString* fileName)
    {
        self->setOutputFileName(*fileName);
    }

    void __QtAda_QPrinter_setOutputFormat_OutputFormat(QPrinter* self, unsigned format)
    {
        self->setOutputFormat((QPrinter::OutputFormat)format);
    }

    void __QtAda_QPrinter_setPageMargins_qreal_qreal_qreal_qreal_Unit(QPrinter* self, double left, double top, double right, double bottom, unsigned unit)
    {
        self->setPageMargins((qreal)left, (qreal)top, (qreal)right, (qreal)bottom, (QPrinter::Unit)unit);
    }

    void __QtAda_QPrinter_setPageOrder_PageOrder(QPrinter* self, unsigned order)
    {
        self->setPageOrder((QPrinter::PageOrder)order);
    }

    void __QtAda_QPrinter_setPageSize_PageSize(QPrinter* self, unsigned size)
    {
        self->setPageSize((QPrinter::PageSize)size);
    }

    void __QtAda_QPrinter_setPaperSize_PaperSize(QPrinter* self, unsigned newPaperSize)
    {
        self->setPaperSize((QPrinter::PaperSize)newPaperSize);
    }

    void __QtAda_QPrinter_setPaperSize_QSizeFCR_Unit(QPrinter* self, const QSizeF* paperSize, unsigned unit)
    {
        self->setPaperSize(*paperSize, (QPrinter::Unit)unit);
    }

    void __QtAda_QPrinter_setPaperSource_PaperSource(QPrinter* self, unsigned source)
    {
        self->setPaperSource((QPrinter::PaperSource)source);
    }

    void __QtAda_QPrinter_setPrintProgram_QStringCR(QPrinter* self, const QString* program)
    {
        self->setPrintProgram(*program);
    }

    void __QtAda_QPrinter_setPrintRange_PrintRange(QPrinter* self, unsigned range)
    {
        self->setPrintRange((QPrinter::PrintRange)range);
    }

    void __QtAda_QPrinter_setPrinterName_QStringCR(QPrinter* self, const QString* name)
    {
        self->setPrinterName(*name);
    }

    void __QtAda_QPrinter_setResolution_int(QPrinter* self, int resolution)
    {
        self->setResolution(resolution);
    }

    int __QtAda_QPrinter_toPage_Q(const QPrinter* self)
    {
        return self->toPage();
    }

    QPaintDevice* __QtAda_QPrinter_QPaintDevice_View(QPrinter* self)
    {
        return static_cast<QPaintDevice*>(self);
    }

};

