//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QPROGRESSBARDIRECTOR_H__
#define __QPROGRESSBARDIRECTOR_H__

#include <QProgressBar>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QProgressBar_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QString* __Qt4Ada_QProgressBar_text_0_dispatch(void*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QProgressBar_text_0_virtual(QObject*, QString*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QProgressBar_format_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QProgressBar_invertedAppearance_0_wrapper(QObject*);
    extern bool __Qt4Ada_QProgressBar_isTextVisible_0_wrapper(QObject*);
    extern int __Qt4Ada_QProgressBar_maximum_0_wrapper(QObject*);
    extern int __Qt4Ada_QProgressBar_minimum_0_wrapper(QObject*);
    extern Qt::Orientation __Qt4Ada_QProgressBar_orientation_0_wrapper(QObject*);
    extern void __Qt4Ada_QProgressBar_setAlignment_0_wrapper(QObject*, Qt::Alignment);
    extern void __Qt4Ada_QProgressBar_setFormat_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QProgressBar_setInvertedAppearance_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QProgressBar_setTextDirection_0_wrapper(QObject*, QProgressBar::Direction);
    extern void __Qt4Ada_QProgressBar_setTextVisible_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QProgressBar_text_0_wrapper(QObject*, QString*);
    extern QProgressBar::Direction __Qt4Ada_QProgressBar_textDirection_0_wrapper(QObject*);
    extern int __Qt4Ada_QProgressBar_value_0_wrapper(QObject*);
    extern void __Qt4Ada_QProgressBar_reset_0_wrapper(QObject*);
    extern void __Qt4Ada_QProgressBar_setMaximum_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QProgressBar_setMinimum_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QProgressBar_setOrientation_0_wrapper(QObject*, Qt::Orientation);
    extern void __Qt4Ada_QProgressBar_setRange_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QProgressBar_setValue_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QProgressBar_valueChanged_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QProgressBar_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QProgressBar_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QProgressBar_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QProgressBar_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QProgressBar_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QProgressBar_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QProgressBar_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QProgressBar_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QProgressBar_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QProgressBar_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QProgressBar_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QProgressBar_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QProgressBar_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QProgressBar_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
extern "C" {
    
    //  Constructor
    extern QObject * __Qt4Ada_new_QProgressBar (QObject * parent);

}

class QProgressBarDirector : public QProgressBar
{
protected:
    void* ada_object;
    QProgressBarDirector();

    virtual QString text() const;
    virtual bool event(QEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QProgressBar_valueChanged_0_wrapper(QObject*, int);
    friend bool __Qt4Ada_QProgressBar_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QProgressBar_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QProgressBar_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QProgressBar_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QProgressBar_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QProgressBar_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QProgressBar_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QProgressBar_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QProgressBar_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QProgressBar_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QProgressBar_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QProgressBar_sender_0_wrapper(QObject*);
};

#endif // __QPROGRESSBARDIRECTOR_H__
