//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSize>
#include <QPaintEvent>
#include <QKeyEvent>
#include <QFocusEvent>
#include <QMouseEvent>
#include <QTimerEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>

#include "qpushbuttondirector.h"
#include "qabstractbuttondirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QPushButton_staticMetaObject =
        &QPushButton::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QPushButton_autoDefault_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPushButton*>(cpp_object)->QPushButton::autoDefault();
    }

    bool __Qt4Ada_QPushButton_isDefault_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPushButton*>(cpp_object)->QPushButton::isDefault();
    }

    bool __Qt4Ada_QPushButton_isFlat_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPushButton*>(cpp_object)->QPushButton::isFlat();
    }

    void __Qt4Ada_QPushButton_setAutoDefault_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QPushButton*>(cpp_object)->QPushButton::setAutoDefault(enable);
    }

    void __Qt4Ada_QPushButton_setDefault_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QPushButton*>(cpp_object)->QPushButton::setDefault(enable);
    }

    void __Qt4Ada_QPushButton_setFlat_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QPushButton*>(cpp_object)->QPushButton::setFlat(enable);
    }

    void __Qt4Ada_QPushButton_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QPushButton*>(cpp_object)->QPushButton::sizeHint();
    }

    void __Qt4Ada_QPushButton_showMenu_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPushButton*>(cpp_object)->QPushButton::showMenu();
    }

    bool __Qt4Ada_QPushButton_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QPushButtonDirector*>(cpp_object)->QPushButton::event(e);
    }

    void __Qt4Ada_QPushButton_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QPushButton::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QPushButton_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QPushButton::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QPushButton_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QPushButton::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QPushButton_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QPushButton::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QPushButton_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QAbstractButton::changeEvent(event);
    }

    void __Qt4Ada_QPushButton_checkStateSet_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QAbstractButton::checkStateSet();
    }

    bool __Qt4Ada_QPushButton_hitButton_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        return dynamic_cast<QPushButtonDirector*>(cpp_object)->QAbstractButton::hitButton(*pos);
    }

    void __Qt4Ada_QPushButton_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QAbstractButton::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QPushButton_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QAbstractButton::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QPushButton_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QAbstractButton::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QPushButton_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QAbstractButton::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QPushButton_nextCheckState_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QAbstractButton::nextCheckState();
    }

    void __Qt4Ada_QPushButton_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QAbstractButton::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QPushButton_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QPushButton_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QPushButton_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QPushButton_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QPushButton_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QPushButton_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QPushButton_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QPushButton_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QPushButton_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QPushButton_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QPushButton_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QPushButton_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QPushButton_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QPushButton_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QPushButton_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QPushButton_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QPushButton_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QPushButton_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QPushButton_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QPushButton_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QPushButton_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QPushButton_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QPushButton_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QPushButtonDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QPushButton_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QPushButton_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPushButtonDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QPushButton_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPushButtonDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QPushButton_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QPushButton*>(cpp_this)->QPushButton::qt_metacast(name);
    }

    int __Qt4Ada_QPushButton_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QPushButton*>(cpp_this)->QPushButton::qt_metacall(_c, _id, _a);
    }

}

QSize QPushButtonDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QPushButtonDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QPushButtonDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::checkStateSet()
{
    __Qt4Ada_QAbstractButton_checkStateSet_0_dispatch(this->ada_object);
}

bool QPushButtonDirector::hitButton(const QPoint& pos) const
{
    return __Qt4Ada_QAbstractButton_hitButton_0_dispatch(this->ada_object, &pos);
}

void QPushButtonDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::nextCheckState()
{
    __Qt4Ada_QAbstractButton_nextCheckState_0_dispatch(this->ada_object);
}

void QPushButtonDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

int QPushButtonDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QPushButtonDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QPushButtonDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QPushButtonDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QPushButtonDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QPushButtonDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QPushButtonDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QPushButtonDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QPushButtonDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QPushButtonDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QPushButtonDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QPushButtonDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QPushButtonDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QPushButtonDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QPaintEngine*QPushButtonDirector::paintEngine()
{
    return __Qt4Ada_QPaintDevice_paintEngine_dispatch(this->ada_object);
}

void QPushButtonDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QPushButtonDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    QObject * __Qt4Ada_new_QPushButton (QObject *parent)
    {
        return dynamic_cast<QObject *>(new QPushButton (dynamic_cast <QWidget*> (parent)));
    }

    QObject * __Qt4Ada_new_QPushButton_With_String (QString*text, QObject*parent)
    {
        return dynamic_cast<QObject *>(new QPushButton (*text, dynamic_cast <QWidget*> (parent)));
    }

    QPaintEngine*__Qt4Ada_QPushButton_paintEngine_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QPushButton*>(cpp_this))->QPushButton::paintEngine();
    }

    void __Qt4Ada_QPushButton_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QPushButtonDirector*>(cpp_this))->QPushButton::connectNotify(_p1);
    }

    void __Qt4Ada_QPushButton_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QPushButtonDirector*>(cpp_this))->QPushButton::disconnectNotify(_p1);
    }

}
