//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3637 $ $Date: 2009-11-27 10:46:41 +0300 (Fri, 27 Nov 2009) $
//--------------------------------------------------------------------------//
#include "qrgbwrapper.h"

extern "C"
{

    unsigned __QtAda_qAlpha(QRgb rgba)
    {
        return qAlpha(rgba);
    }

    unsigned __QtAda_qBlue(QRgb rgb)
    {
        return qBlue(rgb);
    }

    unsigned __QtAda_qGray_int_int_int(unsigned r, unsigned g, unsigned b)
    {
        return qGray(r, g, b);
    }

    unsigned __QtAda_qGray_QRgb(QRgb rgb)
    {
        return qGray(rgb);
    }

    unsigned __QtAda_qGreen(QRgb rgb)
    {
        return qGreen(rgb);
    }

    unsigned __QtAda_qRed(QRgb rgb)
    {
        return qRed(rgb);
    }

    QRgb __QtAda_qRgb(unsigned r, unsigned g, unsigned b)
    {
        return qRgb(r, g, b);
    }

    QRgb __QtAda_qRgba(unsigned r, unsigned g, unsigned b, unsigned a)
    {
        return qRgba(r, g, b, a);
    }

};
