//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QSize>
#include <QResizeEvent>
#include <QPaintEvent>
#include <QMouseEvent>
#include <QWheelEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QKeyEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qscrollareadirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QScrollArea_staticMetaObject =
        &QScrollArea::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    Qt::Alignment __Qt4Ada_QScrollArea_alignment_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::alignment();
    }

    void __Qt4Ada_QScrollArea_ensureVisible_0_wrapper(QObject* cpp_object, int x, int y, int xmargin, int ymargin)
    {
        dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::ensureVisible(x, y, xmargin, ymargin);
    }

    void __Qt4Ada_QScrollArea_ensureWidgetVisible_0_wrapper(QObject* cpp_object, QObject* childWidget, int xmargin, int ymargin)
    {
        dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::ensureWidgetVisible(dynamic_cast<QWidget*>(childWidget), xmargin, ymargin);
    }

    void __Qt4Ada_QScrollArea_setAlignment_0_wrapper(QObject* cpp_object, Qt::Alignment alignment)
    {
        dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::setAlignment(alignment);
    }

    void __Qt4Ada_QScrollArea_setWidget_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::setWidget(dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QScrollArea_setWidgetResizable_0_wrapper(QObject* cpp_object, bool resizable)
    {
        dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::setWidgetResizable(resizable);
    }

    QObject* __Qt4Ada_QScrollArea_takeWidget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::takeWidget());
    }

    QObject* __Qt4Ada_QScrollArea_widget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::widget());
    }

    bool __Qt4Ada_QScrollArea_widgetResizable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::widgetResizable();
    }

    void __Qt4Ada_QScrollArea_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::sizeHint();
    }

    bool __Qt4Ada_QScrollArea_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QScrollArea*>(cpp_object)->QScrollArea::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QScrollArea_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QScrollAreaDirector*>(cpp_object)->QScrollArea::event(e);
    }

    bool __Qt4Ada_QScrollArea_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QScrollAreaDirector*>(cpp_object)->QScrollArea::eventFilter(watched, event);
    }

    void __Qt4Ada_QScrollArea_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QScrollArea::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QScrollArea::scrollContentsBy(dx, dy);
    }

    void __Qt4Ada_QScrollArea_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QScrollArea_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    bool __Qt4Ada_QScrollArea_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::viewportEvent(event);
    }

    void __Qt4Ada_QScrollArea_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QAbstractScrollArea::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QScrollArea_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QScrollArea_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QScrollArea_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QScrollArea_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    void __Qt4Ada_QScrollArea_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QScrollArea_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QScrollArea_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QScrollArea_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QScrollArea_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QScrollArea_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QScrollAreaDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QScrollArea_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QScrollArea_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QScrollArea_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QScrollAreaDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QScrollArea_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QScrollAreaDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QScrollArea_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QScrollArea*>(cpp_this)->QScrollArea::qt_metacast(name);
    }

    int __Qt4Ada_QScrollArea_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QScrollArea*>(cpp_this)->QScrollArea::qt_metacall(_c, _id, _a);
    }

}

QSize QScrollAreaDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QScrollAreaDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

bool QScrollAreaDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QScrollAreaDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QScrollAreaDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

QSize QScrollAreaDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QScrollAreaDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QScrollAreaDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QScrollAreaDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QScrollAreaDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QScrollAreaDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QScrollAreaDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

void QScrollAreaDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QScrollAreaDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QScrollAreaDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QScrollAreaDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QScrollAreaDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C" {

    QObject* __Qt4Ada_new_QScrollArea (QObject* parent)
    {
        return dynamic_cast<QObject*>(new QScrollArea (dynamic_cast<QWidget*>(parent)));
    }

}
