//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QSPINBOXDIRECTOR_H__
#define __QSPINBOXDIRECTOR_H__

#include <QSpinBox>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QSpinBox_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QString* __Qt4Ada_QSpinBox_textFromValue_0_dispatch(void*, int);
    extern int __Qt4Ada_QSpinBox_valueFromText_0_dispatch(void*, const QString*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QSpinBox_cleanText_0_wrapper(QObject*, QString*);
    extern int __Qt4Ada_QSpinBox_maximum_0_wrapper(QObject*);
    extern int __Qt4Ada_QSpinBox_minimum_0_wrapper(QObject*);
    extern void __Qt4Ada_QSpinBox_prefix_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QSpinBox_setMaximum_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSpinBox_setMinimum_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSpinBox_setPrefix_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QSpinBox_setRange_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QSpinBox_setSingleStep_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSpinBox_setSuffix_0_wrapper(QObject*, const QString*);
    extern int __Qt4Ada_QSpinBox_singleStep_0_wrapper(QObject*);
    extern void __Qt4Ada_QSpinBox_suffix_0_wrapper(QObject*, QString*);
    extern int __Qt4Ada_QSpinBox_value_0_wrapper(QObject*);
    extern void __Qt4Ada_QSpinBox_setValue_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSpinBox_valueChanged_1_wrapper(QObject*, int);
    extern void __Qt4Ada_QSpinBox_valueChanged_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QSpinBox_textFromValue_0_wrapper(QObject*, int, QString*);
    extern int __Qt4Ada_QSpinBox_valueFromText_0_wrapper(QObject*, const QString*);
    extern bool __Qt4Ada_QSpinBox_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_fixup_0_wrapper(QObject*, QString*);
    extern QValidator::State __Qt4Ada_QSpinBox_validate_0_wrapper(QObject*, QString*, int);
    extern QObject* __Qt4Ada_QSpinBox_lineEdit_0_wrapper(QObject*);
    extern void __Qt4Ada_QSpinBox_setLineEdit_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QSpinBox_editingFinished_0_wrapper(QObject*);
    extern void __Qt4Ada_QSpinBox_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QSpinBox_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QSpinBox_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QSpinBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QSpinBox_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QSpinBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QSpinBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QSpinBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QSpinBox_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSpinBox_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QSpinBox_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QSpinBox_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QSpinBox_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
#include <QLineEdit>  //  Эта директива должна генерироваться автоматически!

extern "C" {

    extern QObject* __Qt4Ada_new_QSpinBox (QObject*);

}

class QSpinBoxDirector : public QSpinBox
{
protected:
    void* ada_object;
    QSpinBoxDirector();

    virtual QString textFromValue(int) const;
    virtual int valueFromText(const QString&) const;
    virtual bool event(QEvent*);
    virtual void fixup(QString&) const;
    virtual QValidator::State validate(QString&, int) const;
    virtual void stepBy(int);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void clear();
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QSpinBox_valueChanged_1_wrapper(QObject*, int);
    friend void __Qt4Ada_QSpinBox_valueChanged_0_wrapper(QObject*, const QString*);
    friend void __Qt4Ada_QSpinBox_textFromValue_0_wrapper(QObject*, int, QString*);
    friend int __Qt4Ada_QSpinBox_valueFromText_0_wrapper(QObject*, const QString*);
    friend bool __Qt4Ada_QSpinBox_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_fixup_0_wrapper(QObject*, QString*);
    friend QValidator::State __Qt4Ada_QSpinBox_validate_0_wrapper(QObject*, QString*, int);
    friend QObject* __Qt4Ada_QSpinBox_lineEdit_0_wrapper(QObject*);
    friend void __Qt4Ada_QSpinBox_setLineEdit_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QSpinBox_editingFinished_0_wrapper(QObject*);
    friend void __Qt4Ada_QSpinBox_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QSpinBox_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QSpinBox_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QSpinBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QSpinBox_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QSpinBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QSpinBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QSpinBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QSpinBox_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSpinBox_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QSpinBox_sender_0_wrapper(QObject*);
};

#endif // __QSPINBOXDIRECTOR_H__
