//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2012 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QSplitterHandle>
#include <QByteArray>
#include <QSize>
#include <QChildEvent>
#include <QResizeEvent>
#include <QPaintEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QTimerEvent>

#include "qsplitterdirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QSplitter_staticMetaObject =
        &QSplitter::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QSplitter_addWidget_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QSplitter*>(cpp_object)->QSplitter::addWidget(dynamic_cast<QWidget*>(widget));
    }

    bool __Qt4Ada_QSplitter_childrenCollapsible_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitter*>(cpp_object)->QSplitter::childrenCollapsible();
    }

    int __Qt4Ada_QSplitter_count_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitter*>(cpp_object)->QSplitter::count();
    }

    QObject* __Qt4Ada_QSplitter_handle_0_wrapper(QObject* cpp_object, int index)
    {
        return static_cast<QObject*>(dynamic_cast<QSplitter*>(cpp_object)->QSplitter::handle(index));
    }

    int __Qt4Ada_QSplitter_handleWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitter*>(cpp_object)->QSplitter::handleWidth();
    }

    int __Qt4Ada_QSplitter_indexOf_0_wrapper(QObject* cpp_object, QObject* w)
    {
        return dynamic_cast<QSplitter*>(cpp_object)->QSplitter::indexOf(dynamic_cast<QWidget*>(w));
    }

    void __Qt4Ada_QSplitter_insertWidget_0_wrapper(QObject* cpp_object, int index, QObject* widget)
    {
        dynamic_cast<QSplitter*>(cpp_object)->QSplitter::insertWidget(index, dynamic_cast<QWidget*>(widget));
    }

    bool __Qt4Ada_QSplitter_isCollapsible_0_wrapper(QObject* cpp_object, int index)
    {
        return dynamic_cast<QSplitter*>(cpp_object)->QSplitter::isCollapsible(index);
    }

    bool __Qt4Ada_QSplitter_opaqueResize_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitter*>(cpp_object)->QSplitter::opaqueResize();
    }

    void __Qt4Ada_QSplitter_refresh_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSplitter*>(cpp_object)->QSplitter::refresh();
    }

    void __Qt4Ada_QSplitter_restoreState_0_wrapper(QObject* cpp_object, const QByteArray* state)
    {
        dynamic_cast<QSplitter*>(cpp_object)->QSplitter::restoreState(*state);
    }

    void __Qt4Ada_QSplitter_saveState_0_wrapper(QObject* cpp_object, QByteArray* returns)
    {
        *returns = dynamic_cast<QSplitter*>(cpp_object)->QSplitter::saveState();
    }

    void __Qt4Ada_QSplitter_setChildrenCollapsible_0_wrapper(QObject* cpp_object, bool collapse)
    {
        dynamic_cast<QSplitter*>(cpp_object)->QSplitter::setChildrenCollapsible(collapse);
    }

    void __Qt4Ada_QSplitter_setCollapsible_0_wrapper(QObject* cpp_object, int index, bool collapse)
    {
        dynamic_cast<QSplitter*>(cpp_object)->QSplitter::setCollapsible(index, collapse);
    }

    void __Qt4Ada_QSplitter_setHandleWidth_0_wrapper(QObject* cpp_object, int width)
    {
        dynamic_cast<QSplitter*>(cpp_object)->QSplitter::setHandleWidth(width);
    }

    void __Qt4Ada_QSplitter_setStretchFactor_0_wrapper(QObject* cpp_object, int index, int stretch)
    {
        dynamic_cast<QSplitter*>(cpp_object)->QSplitter::setStretchFactor(index, stretch);
    }

    QObject* __Qt4Ada_QSplitter_widget_0_wrapper(QObject* cpp_object, int index)
    {
        return static_cast<QObject*>(dynamic_cast<QSplitter*>(cpp_object)->QSplitter::widget(index));
    }

    void __Qt4Ada_QSplitter_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QSplitter*>(cpp_object)->QSplitter::sizeHint();
    }

    void __Qt4Ada_QSplitter_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QSplitter*>(cpp_object)->QSplitter::minimumSizeHint();
    }

    void __Qt4Ada_QSplitter_splitterMoved_0_wrapper(QObject* cpp_object, int pos, int index)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QSplitter::splitterMoved(pos, index);
    }

    int __Qt4Ada_QSplitter_closestLegalPosition_0_wrapper(QObject* cpp_object, int pos, int index)
    {
        return dynamic_cast<QSplitterDirector*>(cpp_object)->QSplitter::closestLegalPosition(pos, index);
    }

    void __Qt4Ada_QSplitter_moveSplitter_0_wrapper(QObject* cpp_object, int pos, int index)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QSplitter::moveSplitter(pos, index);
    }

    void __Qt4Ada_QSplitter_setRubberBand_0_wrapper(QObject* cpp_object, int position)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QSplitter::setRubberBand(position);
    }

    void __Qt4Ada_QSplitter_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QSplitter::changeEvent(event);
    }

    void __Qt4Ada_QSplitter_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QSplitter::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    bool __Qt4Ada_QSplitter_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QSplitterDirector*>(cpp_object)->QSplitter::event(e);
    }

    void __Qt4Ada_QSplitter_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QSplitter::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QSplitter_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QFrame::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QSplitter_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QSplitter_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QSplitter_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QSplitter_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QSplitter_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QSplitter_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QSplitter_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QSplitter_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QSplitter_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QSplitter_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QSplitter_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QSplitter_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QSplitter_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QSplitter_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QSplitter_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QSplitter_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QSplitter_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QSplitter_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QSplitter_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QSplitter_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSplitter_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSplitter_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSplitter_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSplitter_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QSplitter_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QSplitter_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QSplitter_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QSplitter_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QSplitter_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QSplitterDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QSplitter_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QSplitter_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QSplitter_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitterDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QSplitter_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QSplitter*>(cpp_this)->QSplitter::qt_metacast(name);
    }

    int __Qt4Ada_QSplitter_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QSplitter*>(cpp_this)->QSplitter::qt_metacall(_c, _id, _a);
    }

}

QSize QSplitterDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QSplitterDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QSplitterDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

bool QSplitterDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QSplitterDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

int QSplitterDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QSplitterDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QSplitterDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QSplitterDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QSplitterDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QSplitterDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QSplitterDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QSplitterDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QSplitterDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QSplitterDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QSplitterDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QSplitterDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QSplitterDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C" {

    QSplitter* __Qt4Ada_new_QSplitter (QObject* parent)
    {
        return new QSplitter(dynamic_cast<QWidget*>(parent));
    }

    QSplitter* __Qt4Ada_new_QSplitter_Orientation (int orientation, QObject* parent)
    {
        return new QSplitter(static_cast<Qt::Orientation>(orientation),
                             dynamic_cast<QWidget*>(parent));
    }

}
