//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSplitter>
#include <QSize>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMoveEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qsplitterhandledirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QSplitterHandle_staticMetaObject =
        &QSplitterHandle::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QSplitterHandle_opaqueResize_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitterHandle*>(cpp_object)->QSplitterHandle::opaqueResize();
    }

    QObject* __Qt4Ada_QSplitterHandle_splitter_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QSplitterHandle*>(cpp_object)->QSplitterHandle::splitter());
    }

    void __Qt4Ada_QSplitterHandle_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QSplitterHandle*>(cpp_object)->QSplitterHandle::sizeHint();
    }

    int __Qt4Ada_QSplitterHandle_closestLegalPosition_0_wrapper(QObject* cpp_object, int p)
    {
        return dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QSplitterHandle::closestLegalPosition(p);
    }

    void __Qt4Ada_QSplitterHandle_moveSplitter_0_wrapper(QObject* cpp_object, int p)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QSplitterHandle::moveSplitter(p);
    }

    bool __Qt4Ada_QSplitterHandle_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QSplitterHandle::event(e);
    }

    void __Qt4Ada_QSplitterHandle_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QSplitterHandle::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QSplitterHandle::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QSplitterHandle::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QSplitterHandle::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QSplitterHandle_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QSplitterHandle_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QSplitterHandle_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QSplitterHandle_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QSplitterHandle_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QSplitterHandle_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QSplitterHandle_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QSplitterHandle_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QSplitterHandle_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QSplitterHandle_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QSplitterHandle_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QSplitterHandle_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QSplitterHandle_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QSplitterHandle_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QSplitterHandle_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSplitterHandleDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QSplitterHandle_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QSplitterHandle*>(cpp_this)->QSplitterHandle::qt_metacast(name);
    }

    int __Qt4Ada_QSplitterHandle_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QSplitterHandle*>(cpp_this)->QSplitterHandle::qt_metacall(_c, _id, _a);
    }

}

QSize QSplitterHandleDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QSplitterHandleDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QSplitterHandleDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

int QSplitterHandleDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QSplitterHandleDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QSplitterHandleDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QSplitterHandleDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QSplitterHandleDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QSplitterHandleDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QSplitterHandleDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QSplitterHandleDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QSplitterHandleDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QSplitterHandleDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QSplitterHandleDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QSplitterHandleDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QSplitterHandleDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QSplitterHandleDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
