//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QString>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QVariant>
#include <QSize>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qstatusbardirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QStatusBar_staticMetaObject =
        &QStatusBar::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QStatusBar_addPermanentWidget_0_wrapper(QObject* cpp_object, QObject* widget, int stretch)
    {
        dynamic_cast<QStatusBar*>(cpp_object)->QStatusBar::addPermanentWidget(dynamic_cast<QWidget*>(widget), stretch);
    }

    void __Qt4Ada_QStatusBar_addWidget_0_wrapper(QObject* cpp_object, QObject* widget, int stretch)
    {
        dynamic_cast<QStatusBar*>(cpp_object)->QStatusBar::addWidget(dynamic_cast<QWidget*>(widget), stretch);
    }

    void __Qt4Ada_QStatusBar_currentMessage_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QStatusBar*>(cpp_object)->QStatusBar::currentMessage();
    }

    void __Qt4Ada_QStatusBar_insertPermanentWidget_0_wrapper(QObject* cpp_object, int index, QObject* widget, int stretch)
    {
        dynamic_cast<QStatusBar*>(cpp_object)->QStatusBar::insertPermanentWidget(index, dynamic_cast<QWidget*>(widget), stretch);
    }

    void __Qt4Ada_QStatusBar_insertWidget_0_wrapper(QObject* cpp_object, int index, QObject* widget, int stretch)
    {
        dynamic_cast<QStatusBar*>(cpp_object)->QStatusBar::insertWidget(index, dynamic_cast<QWidget*>(widget), stretch);
    }

    bool __Qt4Ada_QStatusBar_isSizeGripEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QStatusBar*>(cpp_object)->QStatusBar::isSizeGripEnabled();
    }

    void __Qt4Ada_QStatusBar_removeWidget_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QStatusBar*>(cpp_object)->QStatusBar::removeWidget(dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QStatusBar_setSizeGripEnabled_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QStatusBar*>(cpp_object)->QStatusBar::setSizeGripEnabled(enabled);
    }

    void __Qt4Ada_QStatusBar_clearMessage_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStatusBar*>(cpp_object)->QStatusBar::clearMessage();
    }

    void __Qt4Ada_QStatusBar_messageChanged_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QStatusBar::messageChanged(*text);
    }

    void __Qt4Ada_QStatusBar_hideOrShow_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QStatusBar::hideOrShow();
    }

    void __Qt4Ada_QStatusBar_reformat_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QStatusBar::reformat();
    }

    bool __Qt4Ada_QStatusBar_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QStatusBarDirector*>(cpp_object)->QStatusBar::event(e);
    }

    void __Qt4Ada_QStatusBar_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QStatusBar::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QStatusBar::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QStatusBar_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QStatusBar_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QStatusBar_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QStatusBar_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QStatusBar_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QStatusBar_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QStatusBar_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QStatusBar_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QStatusBar_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QStatusBar_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QStatusBar_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QStatusBarDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QStatusBar_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QStatusBar_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QStatusBar_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStatusBarDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QStatusBar_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QStatusBarDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QStatusBar_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QStatusBar*>(cpp_this)->QStatusBar::qt_metacast(name);
    }

    int __Qt4Ada_QStatusBar_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QStatusBar*>(cpp_this)->QStatusBar::qt_metacall(_c, _id, _a);
    }

}

bool QStatusBarDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QStatusBarDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

int QStatusBarDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QStatusBarDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QStatusBarDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QStatusBarDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QStatusBarDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QStatusBarDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QStatusBarDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QStatusBarDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QStatusBarDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QStatusBarDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QStatusBarDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QStatusBarDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QStatusBarDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QStatusBarDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QStatusBarDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C" {

    void __Qt4Ada_QStatusBar_showMessage_wrapper
             (QObject* const cpp_this, QString* const message, int timeout)
    {
        dynamic_cast<QStatusBar*>(cpp_this)->QStatusBar::showMessage(*message, timeout);
    }

}
