//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2884 $ $Date: 2008-10-02 16:45:42 +0400 (Thu, 02 Oct 2008) $
//----------------------------------------------------------------------------
#ifndef __QSTYLEOPTIONWRAPPER_H__
#define __QSTYLEOPTIONWRAPPER_H__

#include <QStyleOption>

extern "C"
{
    // Constructors

    extern QStyleOption* __Qt4Ada_new_QStyleOption ();

    extern QStyleOption* __Qt4Ada_copy_QStyleOption(const QStyleOption*);
    extern void __Qt4Ada_delete_QStyleOption(QStyleOption*);

    extern int __Qt4Ada_QStyleOption_type_wrapper (QStyleOption*);
    extern int __Qt4Ada_QStyleOption_version_wrapper (QStyleOption*);
    extern unsigned __Qt4Ada_QStyleOption_state_wrapper (QStyleOption*);
    extern void __Qt4Ada_QStyleOption_setRect_wrapper (QStyleOption*, QRect*);
    extern void __Qt4Ada_QStyleOption_rect_wrapper (QStyleOption*, QRect*);

   // Static Public Members
}

#endif // __QStyleOptionWRAPPER_H__
