//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QSYNTAXHIGHLIGHTERDIRECTOR_H__
#define __QSYNTAXHIGHLIGHTERDIRECTOR_H__

#include <QSyntaxHighlighter>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QSyntaxHighlighter_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QSyntaxHighlighter_highlightBlock_0_dispatch(void*, const QString*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern QObject* __Qt4Ada_QSyntaxHighlighter_document_0_wrapper(QObject*);
    extern void __Qt4Ada_QSyntaxHighlighter_setDocument_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QSyntaxHighlighter_rehighlight_0_wrapper(QObject*);
    extern int __Qt4Ada_QSyntaxHighlighter_currentBlockState_0_wrapper(QObject*);
    extern int __Qt4Ada_QSyntaxHighlighter_previousBlockState_0_wrapper(QObject*);
    extern void __Qt4Ada_QSyntaxHighlighter_setCurrentBlockState_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSyntaxHighlighter_setFormat_2_wrapper(QObject*, int, int, const QColor*);
    extern void __Qt4Ada_QSyntaxHighlighter_setFormat_1_wrapper(QObject*, int, int, const QFont*);
    extern void __Qt4Ada_QSyntaxHighlighter_setFormat_0_wrapper(QObject*, int, int, const QTextFormat*);
    extern void __Qt4Ada_QSyntaxHighlighter_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSyntaxHighlighter_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSyntaxHighlighter_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QSyntaxHighlighter_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QSyntaxHighlighter_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QSyntaxHighlighter_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
#include <QTextEdit>

extern "C"
{
    //  constructors

    extern QObject* __Qt4Ada_new_QSyntaxHighlighterDirector_QObjectP(void*, QObject*);
    extern QObject* __Qt4Ada_new_QSyntaxHighlighterDirector_QTextDocumentP(void*, QObject*);
    extern QObject* __Qt4Ada_new_QSyntaxHighlighterDirector_QTextEditP(void*, QObject*);

}

class QSyntaxHighlighterDirector : public QSyntaxHighlighter
{
protected:
    void* ada_object;
    QSyntaxHighlighterDirector(void*, QObject*);
    QSyntaxHighlighterDirector(void*, QTextDocument*);
    QSyntaxHighlighterDirector(void*, QTextEdit*);

    friend QObject* __Qt4Ada_new_QSyntaxHighlighterDirector_QObjectP(void*, QObject*);
    friend QObject* __Qt4Ada_new_QSyntaxHighlighterDirector_QTextDocumentP(void*, QObject*);
    friend QObject* __Qt4Ada_new_QSyntaxHighlighterDirector_QTextEditP(void*, QObject*);

    virtual void highlightBlock(const QString&);
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend int __Qt4Ada_QSyntaxHighlighter_currentBlockState_0_wrapper(QObject*);
    friend int __Qt4Ada_QSyntaxHighlighter_previousBlockState_0_wrapper(QObject*);
    friend void __Qt4Ada_QSyntaxHighlighter_setCurrentBlockState_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QSyntaxHighlighter_setFormat_2_wrapper(QObject*, int, int, const QColor*);
    friend void __Qt4Ada_QSyntaxHighlighter_setFormat_1_wrapper(QObject*, int, int, const QFont*);
    friend void __Qt4Ada_QSyntaxHighlighter_setFormat_0_wrapper(QObject*, int, int, const QTextFormat*);
    friend void __Qt4Ada_QSyntaxHighlighter_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSyntaxHighlighter_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSyntaxHighlighter_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QSyntaxHighlighter_sender_0_wrapper(QObject*);
};

#endif // __QSYNTAXHIGHLIGHTERDIRECTOR_H__
