------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Events;
limited with Qt4.Focus_Events;
with Qt4.Graphics_Items.Directors;
limited with Qt4.Graphics_Scene_Context_Menu_Events;
limited with Qt4.Graphics_Scene_Drag_Drop_Events;
limited with Qt4.Graphics_Scene_Hover_Events;
limited with Qt4.Graphics_Scene_Mouse_Events;
limited with Qt4.Graphics_Scene_Wheel_Events;
limited with Qt4.Input_Method_Events;
limited with Qt4.Key_Events;
with Qt4.Painter_Paths;
with Qt4.Variants;

package Qt4.Abstract_Graphics_Shape_Items.Directors is

   type Q_Abstract_Graphics_Shape_Item_Director is
     abstract new Qt4.Graphics_Items.Directors.Q_Graphics_Item_Director
       and Q_Abstract_Graphics_Shape_Item with null record;

   overriding
   function Is_Obscured_By
    (Self : not null access constant Q_Abstract_Graphics_Shape_Item_Director;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class)
       return Standard.Boolean;

   overriding
   function Opaque_Area
    (Self : not null access constant Q_Abstract_Graphics_Shape_Item_Director)
       return Qt4.Painter_Paths.Q_Painter_Path;

   overriding
   procedure Context_Menu_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Context_Menu_Events.Q_Graphics_Scene_Context_Menu_Event'Class);

   overriding
   procedure Drag_Enter_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   overriding
   procedure Drag_Leave_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   overriding
   procedure Drag_Move_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   overriding
   procedure Drop_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   overriding
   procedure Focus_In_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class);

   overriding
   procedure Focus_Out_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class);

   overriding
   procedure Hover_Enter_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class);

   overriding
   procedure Hover_Move_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class);

   overriding
   procedure Hover_Leave_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class);

   overriding
   procedure Input_Method_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Input_Method_Events.Q_Input_Method_Event'Class);

   overriding
   function Input_Method_Query
    (Self : not null access constant Q_Abstract_Graphics_Shape_Item_Director;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant;

   overriding
   function Item_Change
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Change : Qt4.Graphics_Items.Graphics_Item_Graphics_Item_Change;
     Value : Qt4.Variants.Q_Variant)
       return Qt4.Variants.Q_Variant;

   overriding
   procedure Key_Press_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class);

   overriding
   procedure Key_Release_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class);

   overriding
   procedure Mouse_Double_Click_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   overriding
   procedure Mouse_Move_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   overriding
   procedure Mouse_Press_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   overriding
   procedure Mouse_Release_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   overriding
   procedure Prepare_Geometry_Change
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director);

   overriding
   function Scene_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean;

   overriding
   function Scene_Event_Filter
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Watched : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean;

   overriding
   procedure Wheel_Event
    (Self : not null access Q_Abstract_Graphics_Shape_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Wheel_Events.Q_Graphics_Scene_Wheel_Event'Class);

end Qt4.Abstract_Graphics_Shape_Items.Directors;
