------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Models;
with Qt4.Child_Events;
with Qt4.Events;
with Qt4.Style_Options;
with Qt4.Timer_Events;
with Qt4.Widgets;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Events.Registry;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Abstract_Item_Delegates.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QAbstractItemDelegate_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QAbstractItemDelegate_qt_metacast_wrapper");

   function createEditor_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Parent : not null access Qt_Ada.Internals.Objects.QObject;
     Option : not null access Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Export (C, createEditor_0_dispatch,
                     "__Qt4Ada_QAbstractItemDelegate_createEditor_0_dispatch");
   pragma Warnings (Off, createEditor_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   function createEditor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access Qt_Ada.Internals.Objects.QObject;
     Option : not null access constant Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, createEditor_0_wrapper,
                     "__Qt4Ada_QAbstractItemDelegate_createEditor_0_wrapper");

   function editorEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent;
     Model : not null access Qt_Ada.Internals.Objects.QObject;
     Option : not null access Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool;
   pragma Export (C, editorEvent_0_dispatch,
                     "__Qt4Ada_QAbstractItemDelegate_editorEvent_0_dispatch");
   pragma Warnings (Off, editorEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   function editorEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent;
     Model : not null access Qt_Ada.Internals.Objects.QObject;
     Option : not null access constant Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access constant Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool;
   pragma Import (C, editorEvent_0_wrapper,
                     "__Qt4Ada_QAbstractItemDelegate_editorEvent_0_wrapper");

   procedure setEditorData_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Editor : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex);
   pragma Export (C, setEditorData_0_dispatch,
                     "__Qt4Ada_QAbstractItemDelegate_setEditorData_0_dispatch");
   pragma Warnings (Off, setEditorData_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure setEditorData_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Editor : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access constant Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, setEditorData_0_wrapper,
                     "__Qt4Ada_QAbstractItemDelegate_setEditorData_0_wrapper");

   procedure setModelData_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Editor : not null access Qt_Ada.Internals.Objects.QObject;
     Model : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex);
   pragma Export (C, setModelData_0_dispatch,
                     "__Qt4Ada_QAbstractItemDelegate_setModelData_0_dispatch");
   pragma Warnings (Off, setModelData_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure setModelData_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Editor : not null access Qt_Ada.Internals.Objects.QObject;
     Model : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access constant Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, setModelData_0_wrapper,
                     "__Qt4Ada_QAbstractItemDelegate_setModelData_0_wrapper");

   function sizeHint_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Option : not null access Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return not null access Qt4.Sizes.Internals.QSize;
   pragma Export (C, sizeHint_0_dispatch,
                     "__Qt4Ada_QAbstractItemDelegate_sizeHint_0_dispatch");
   pragma Warnings (Off, sizeHint_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure updateEditorGeometry_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Editor : not null access Qt_Ada.Internals.Objects.QObject;
     Option : not null access Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex);
   pragma Export (C, updateEditorGeometry_0_dispatch,
                     "__Qt4Ada_QAbstractItemDelegate_updateEditorGeometry_0_dispatch");
   pragma Warnings (Off, updateEditorGeometry_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure updateEditorGeometry_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Editor : not null access Qt_Ada.Internals.Objects.QObject;
     Option : not null access constant Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access constant Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, updateEditorGeometry_0_wrapper,
                     "__Qt4Ada_QAbstractItemDelegate_updateEditorGeometry_0_wrapper");

   procedure commitData_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Editor : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, commitData_0_wrapper,
                     "__Qt4Ada_QAbstractItemDelegate_commitData_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QAbstractItemDelegate_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QAbstractItemDelegate_customEvent_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QAbstractItemDelegate_timerEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QAbstractItemDelegate_sender_0_wrapper");

   procedure paint_dispatch
    (Self    : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Painter : not null Qt4.Painters.Internals.QPainter_Access;
     Option  : not null access Qt4.Style_Options.Thin.QStyleOption;
     Index   : Qt4.Model_Indices.Internals.QModelIndex_Access);
   pragma Export
    (C, paint_dispatch, "__Qt4Ada_QAbstractItemDelegate_paint_dispatch");
   pragma Warnings (Off, paint_dispatch);

   --------------------
   -- paint_dispatch --
   --------------------

   procedure paint_dispatch
    (Self    : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Painter : not null Qt4.Painters.Internals.QPainter_Access;
     Option  : not null access Qt4.Style_Options.Thin.QStyleOption;
     Index   : Qt4.Model_Indices.Internals.QModelIndex_Access)
   is
   begin
      Q_Abstract_Item_Delegate_Director'Class (Self.all).Paint
       (Qt4.Painters.Internals.Create_Wrapper (Painter),
        Qt4.Style_Option_View_Items.Q_Style_Option_View_Item
         (Qt4.Style_Options.Internals.Create_Wrapper (Option)),
        Qt4.Model_Indices.Internals.Create_Wrapper (Index));
   end paint_dispatch;

   ------------------
   -- Constructors --
   ------------------

   package body Constructors is

      function new_QAbstractItemDelegateDirector
       (Object : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
        Parent : access Qt_Ada.Internals.Objects.QObject)
          return not null Qt_Ada.Internals.Objects.QObject_Access;
      pragma Import
       (C, new_QAbstractItemDelegateDirector,
        "__Qt4Ada_new_QAbstractItemDelegateDirector");
      pragma Warnings (Off, new_QAbstractItemDelegateDirector);

      ----------------
      -- Initialize --
      ----------------

      procedure Initialize
       (Self   : not null access Q_Abstract_Item_Delegate_Director'Class;
        Parent : access Qt4.Objects.Q_Object'Class := null)
      is
         Director : constant not null Qt_Ada.Internals.Objects.QObject_Access
           := new_QAbstractItemDelegateDirector
               (Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self),
                Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
                 (Parent));

      begin
         Qt_Ada.Internals.Objects.Initialize (Self, Director);
      end Initialize;

   end Constructors;

   pragma Style_Checks ("N");

   -----------------------------
   -- createEditor_0_dispatch --
   -----------------------------

   function createEditor_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Parent : not null access Qt_Ada.Internals.Objects.QObject;
     Option : not null access Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return not null access Qt_Ada.Internals.Objects.QObject
   is
   begin
      return
        Q_Abstract_Item_Delegate_Director'Class (Self.all).Create_Editor
         (Qt4.Widgets.Q_Widget'Class (Qt_Ada.Internals.Object_Registry.To_Q_Object (Parent).all)'Access,
          Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class (Qt4.Style_Options.Internals.Create_Wrapper (Option)),
          Qt4.Model_Indices.Internals.Create_Wrapper (Qt4.Model_Indices.Internals.QModelIndex_Access (Index))).QObject_View;
   end createEditor_0_dispatch;

   -------------------
   -- Create_Editor --
   -------------------

   overriding
   function Create_Editor
    (Self : not null access constant Q_Abstract_Item_Delegate_Director;
     Parent : not null access Qt4.Widgets.Q_Widget'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return not null access Qt4.Widgets.Q_Widget'Class
   is
   begin
      return
        Qt4.Widgets.Q_Widget'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (createEditor_0_wrapper
             (Q_Abstract_Item_Delegate_Director'Class (Self.all).QObject_View,
              Parent.QObject_View,
              Qt4.Style_Options.Internals.QStyleOption_View (Option),
              Qt4.Model_Indices.Internals.QModelIndex_View (Index))).all)'Access;
   end Create_Editor;

   ----------------------------
   -- editorEvent_0_dispatch --
   ----------------------------

   function editorEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent;
     Model : not null access Qt_Ada.Internals.Objects.QObject;
     Option : not null access Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return Qt4.bool
   is
   begin
      return
        Qt4.To_bool
         (Q_Abstract_Item_Delegate_Director'Class (Self.all).Editor_Event
           (Qt4.Events.Q_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access,
            Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class (Qt_Ada.Internals.Object_Registry.To_Q_Object (Model).all)'Access,
            Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class (Qt4.Style_Options.Internals.Create_Wrapper (Option)),
            Qt4.Model_Indices.Internals.Create_Wrapper (Qt4.Model_Indices.Internals.QModelIndex_Access (Index))));
   end editorEvent_0_dispatch;

   ------------------
   -- Editor_Event --
   ------------------

   overriding
   function Editor_Event
    (Self : not null access Q_Abstract_Item_Delegate_Director;
     Event : not null access Qt4.Events.Q_Event'Class;
     Model : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (editorEvent_0_wrapper
           (Q_Abstract_Item_Delegate_Director'Class (Self.all).QObject_View,
            Event.QEvent_View,
            Model.QObject_View,
            Qt4.Style_Options.Internals.QStyleOption_View (Option),
            Qt4.Model_Indices.Internals.QModelIndex_View (Index)));
   end Editor_Event;

   ------------------------------
   -- setEditorData_0_dispatch --
   ------------------------------

   procedure setEditorData_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Editor : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
   is
   begin
      Q_Abstract_Item_Delegate_Director'Class (Self.all).Set_Editor_Data
       (Qt4.Widgets.Q_Widget'Class (Qt_Ada.Internals.Object_Registry.To_Q_Object (Editor).all)'Access,
        Qt4.Model_Indices.Internals.Create_Wrapper (Qt4.Model_Indices.Internals.QModelIndex_Access (Index)));
   end setEditorData_0_dispatch;

   ---------------------
   -- Set_Editor_Data --
   ---------------------

   overriding
   procedure Set_Editor_Data
    (Self : not null access constant Q_Abstract_Item_Delegate_Director;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
   is
   begin
      setEditorData_0_wrapper
       (Q_Abstract_Item_Delegate_Director'Class (Self.all).QObject_View,
        Editor.QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Index));
   end Set_Editor_Data;

   -----------------------------
   -- setModelData_0_dispatch --
   -----------------------------

   procedure setModelData_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Editor : not null access Qt_Ada.Internals.Objects.QObject;
     Model : not null access Qt_Ada.Internals.Objects.QObject;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
   is
   begin
      Q_Abstract_Item_Delegate_Director'Class (Self.all).Set_Model_Data
       (Qt4.Widgets.Q_Widget'Class (Qt_Ada.Internals.Object_Registry.To_Q_Object (Editor).all)'Access,
        Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class (Qt_Ada.Internals.Object_Registry.To_Q_Object (Model).all)'Access,
        Qt4.Model_Indices.Internals.Create_Wrapper (Qt4.Model_Indices.Internals.QModelIndex_Access (Index)));
   end setModelData_0_dispatch;

   --------------------
   -- Set_Model_Data --
   --------------------

   overriding
   procedure Set_Model_Data
    (Self : not null access constant Q_Abstract_Item_Delegate_Director;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Model : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
   is
   begin
      setModelData_0_wrapper
       (Q_Abstract_Item_Delegate_Director'Class (Self.all).QObject_View,
        Editor.QObject_View,
        Model.QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Index));
   end Set_Model_Data;

   -------------------------
   -- sizeHint_0_dispatch --
   -------------------------

   function sizeHint_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Option : not null access Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return not null access Qt4.Sizes.Internals.QSize
   is
   begin
      return
        Qt4.Sizes.Thin.copy_QSize
         (Qt4.Sizes.Internals.QSize_View
           (Q_Abstract_Item_Delegate_Director'Class (Self.all).Size_Hint
             (Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class (Qt4.Style_Options.Internals.Create_Wrapper (Option)),
              Qt4.Model_Indices.Internals.Create_Wrapper (Qt4.Model_Indices.Internals.QModelIndex_Access (Index)))));
   end sizeHint_0_dispatch;

   -------------------------------------
   -- updateEditorGeometry_0_dispatch --
   -------------------------------------

   procedure updateEditorGeometry_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Editor : not null access Qt_Ada.Internals.Objects.QObject;
     Option : not null access Qt4.Style_Options.Thin.QStyleOption;
     Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
   is
   begin
      Q_Abstract_Item_Delegate_Director'Class (Self.all).Update_Editor_Geometry
       (Qt4.Widgets.Q_Widget'Class (Qt_Ada.Internals.Object_Registry.To_Q_Object (Editor).all)'Access,
        Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class (Qt4.Style_Options.Internals.Create_Wrapper (Option)),
        Qt4.Model_Indices.Internals.Create_Wrapper (Qt4.Model_Indices.Internals.QModelIndex_Access (Index)));
   end updateEditorGeometry_0_dispatch;

   ----------------------------
   -- Update_Editor_Geometry --
   ----------------------------

   overriding
   procedure Update_Editor_Geometry
    (Self : not null access constant Q_Abstract_Item_Delegate_Director;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
   is
   begin
      updateEditorGeometry_0_wrapper
       (Q_Abstract_Item_Delegate_Director'Class (Self.all).QObject_View,
        Editor.QObject_View,
        Qt4.Style_Options.Internals.QStyleOption_View (Option),
        Qt4.Model_Indices.Internals.QModelIndex_View (Index));
   end Update_Editor_Geometry;

   ----------------------
   -- Emit_Commit_Data --
   ----------------------

   not overriding
   procedure Emit_Commit_Data
    (Self : not null access Q_Abstract_Item_Delegate_Director;
     Editor : not null access Qt4.Widgets.Q_Widget'Class)
   is
   begin
      commitData_0_wrapper
       (Q_Abstract_Item_Delegate_Director'Class (Self.all).QObject_View,
        Editor.QObject_View);
   end Emit_Commit_Data;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_Abstract_Item_Delegate_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_Abstract_Item_Delegate_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_Abstract_Item_Delegate_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_Abstract_Item_Delegate_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_Abstract_Item_Delegate_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_Abstract_Item_Delegate_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_Abstract_Item_Delegate_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_Abstract_Item_Delegate_Director'Class (Self.all).QObject_View));
   end Sender;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QAbstractItemDelegate", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.Abstract_Item_Delegates.Directors;
