------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Abstract_Item_Models;
limited with Qt4.Events;
with Qt4.Model_Indices;
with Qt4.Objects;
with Qt4.Painters;
with Qt4.Sizes;
with Qt4.Style_Option_View_Items;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Abstract_Item_Delegates is

   type Q_Abstract_Item_Delegate is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Abstract_Item_Delegate_Access is
     access all Q_Abstract_Item_Delegate'Class;
   for Q_Abstract_Item_Delegate_Access'Storage_Size use 0;

   type Q_Abstract_Item_Delegate_Pointer is tagged;

   not overriding
   function Create_Editor
    (Self : not null access constant Q_Abstract_Item_Delegate;
     Parent : not null access Qt4.Widgets.Q_Widget'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return not null access Qt4.Widgets.Q_Widget'Class
         is abstract;

   not overriding
   function Editor_Event
    (Self : not null access Q_Abstract_Item_Delegate;
     Event : not null access Qt4.Events.Q_Event'Class;
     Model : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean
         is abstract;

   not overriding
   procedure Set_Editor_Data
    (Self : not null access constant Q_Abstract_Item_Delegate;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       is abstract;

   not overriding
   procedure Set_Model_Data
    (Self : not null access constant Q_Abstract_Item_Delegate;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Model : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       is abstract;

   not overriding
   function Size_Hint
    (Self : not null access constant Q_Abstract_Item_Delegate;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Sizes.Q_Size
         is abstract;

   not overriding
   procedure Update_Editor_Geometry
    (Self : not null access constant Q_Abstract_Item_Delegate;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       is abstract;

   not overriding
   procedure Paint
    (Self    : not null access Q_Abstract_Item_Delegate;
     Painter : Qt4.Painters.Q_Painter;
     Option  : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item;
     Index   : Qt4.Model_Indices.Q_Model_Index)
       is abstract;

   package Q_Abstract_Item_Delegate_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Abstract_Item_Delegate, Q_Abstract_Item_Delegate_Access);

   type Q_Abstract_Item_Delegate_Pointer is
     new Q_Abstract_Item_Delegate_Pointers.Q_Pointer with null record;

private

   procedure Dummy;

end Qt4.Abstract_Item_Delegates;
