------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Dialogs;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Abstract_Print_Dialogs is

   type Abstract_Print_Dialog_Print_Range is
    (All_Pages,
     Selection,
     Page_Range);
   pragma Convention (C, Abstract_Print_Dialog_Print_Range);

   type Q_Abstract_Print_Dialog is limited interface
     and Qt4.Dialogs.Q_Dialog;

   type Q_Abstract_Print_Dialog_Access is
     access all Q_Abstract_Print_Dialog'Class;
   for Q_Abstract_Print_Dialog_Access'Storage_Size use 0;

   type Q_Abstract_Print_Dialog_Pointer is tagged;

   function From_Page
    (Self : not null access constant Q_Abstract_Print_Dialog'Class)
       return Qt4.Q_Integer;

   function Max_Page
    (Self : not null access constant Q_Abstract_Print_Dialog'Class)
       return Qt4.Q_Integer;

   function Min_Page
    (Self : not null access constant Q_Abstract_Print_Dialog'Class)
       return Qt4.Q_Integer;

   function Print_Range
    (Self : not null access constant Q_Abstract_Print_Dialog'Class)
       return Qt4.Abstract_Print_Dialogs.Abstract_Print_Dialog_Print_Range;

   procedure Set_From_To
    (Self : not null access Q_Abstract_Print_Dialog'Class;
     From_Page : Qt4.Q_Integer;
     To_Page : Qt4.Q_Integer);

   procedure Set_Min_Max
    (Self : not null access Q_Abstract_Print_Dialog'Class;
     Min : Qt4.Q_Integer;
     Max : Qt4.Q_Integer);

   procedure Set_Print_Range
    (Self : not null access Q_Abstract_Print_Dialog'Class;
     Rng : Qt4.Abstract_Print_Dialogs.Abstract_Print_Dialog_Print_Range);

   function To_Page
    (Self : not null access constant Q_Abstract_Print_Dialog'Class)
       return Qt4.Q_Integer;

   package Q_Abstract_Print_Dialog_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Abstract_Print_Dialog, Q_Abstract_Print_Dialog_Access);

   type Q_Abstract_Print_Dialog_Pointer is
     new Q_Abstract_Print_Dialog_Pointers.Q_Pointer with null record;

end Qt4.Abstract_Print_Dialogs;
