------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Child_Events;
with Qt4.Events;
with Qt4.Timer_Events;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Abstract_Item_Model_Utilities;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Abstract_Proxy_Models.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QAbstractProxyModel_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QAbstractProxyModel_qt_metacast_wrapper");

   function mapFromSource_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Source_Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return not null access Qt4.Model_Indices.Internals.QModelIndex;
   pragma Export (C, mapFromSource_0_dispatch,
                     "__Qt4Ada_QAbstractProxyModel_mapFromSource_0_dispatch");
   pragma Warnings (Off, mapFromSource_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   function mapSelectionFromSource_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Source_Selection : not null access Qt4.Item_Selections.Thin.QItemSelection)
       return not null access Qt4.Item_Selections.Thin.QItemSelection;
   pragma Export (C, mapSelectionFromSource_0_dispatch,
                     "__Qt4Ada_QAbstractProxyModel_mapSelectionFromSource_0_dispatch");
   pragma Warnings (Off, mapSelectionFromSource_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure mapSelectionFromSource_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Source_Selection : not null access constant Qt4.Item_Selections.Thin.QItemSelection;
     Returns : out Qt4.Item_Selections.Thin.QItemSelection);
   pragma Import (C, mapSelectionFromSource_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_mapSelectionFromSource_0_wrapper");

   function mapSelectionToSource_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Proxy_Selection : not null access Qt4.Item_Selections.Thin.QItemSelection)
       return not null access Qt4.Item_Selections.Thin.QItemSelection;
   pragma Export (C, mapSelectionToSource_0_dispatch,
                     "__Qt4Ada_QAbstractProxyModel_mapSelectionToSource_0_dispatch");
   pragma Warnings (Off, mapSelectionToSource_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure mapSelectionToSource_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Proxy_Selection : not null access constant Qt4.Item_Selections.Thin.QItemSelection;
     Returns : out Qt4.Item_Selections.Thin.QItemSelection);
   pragma Import (C, mapSelectionToSource_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_mapSelectionToSource_0_wrapper");

   function mapToSource_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Proxy_Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return not null access Qt4.Model_Indices.Internals.QModelIndex;
   pragma Export (C, mapToSource_0_dispatch,
                     "__Qt4Ada_QAbstractProxyModel_mapToSource_0_dispatch");
   pragma Warnings (Off, mapToSource_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure setSourceModel_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Source_Model : access Qt_Ada.Internals.Objects.QObject);
   pragma Export (C, setSourceModel_0_dispatch,
                     "__Qt4Ada_QAbstractProxyModel_setSourceModel_0_dispatch");
   pragma Warnings (Off, setSourceModel_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure setSourceModel_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Source_Model : access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setSourceModel_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_setSourceModel_0_wrapper");

   procedure dataChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Top_Left : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Bottom_Right : not null access constant Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, dataChanged_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_dataChanged_0_wrapper");

   procedure headerDataChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Orientation : Qt4.Orientation;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);
   pragma Import (C, headerDataChanged_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_headerDataChanged_0_wrapper");

   procedure layoutAboutToBeChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, layoutAboutToBeChanged_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_layoutAboutToBeChanged_0_wrapper");

   procedure layoutChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, layoutChanged_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_layoutChanged_0_wrapper");

   procedure beginInsertColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);
   pragma Import (C, beginInsertColumns_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_beginInsertColumns_0_wrapper");

   procedure beginInsertRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);
   pragma Import (C, beginInsertRows_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_beginInsertRows_0_wrapper");

   function beginMoveColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Source_Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Destination_Child : Qt4.Q_Integer)
       return Qt4.bool;
   pragma Import (C, beginMoveColumns_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_beginMoveColumns_0_wrapper");

   function beginMoveRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Source_Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Destination_Child : Qt4.Q_Integer)
       return Qt4.bool;
   pragma Import (C, beginMoveRows_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_beginMoveRows_0_wrapper");

   procedure beginRemoveColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);
   pragma Import (C, beginRemoveColumns_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_beginRemoveColumns_0_wrapper");

   procedure beginRemoveRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Parent : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);
   pragma Import (C, beginRemoveRows_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_beginRemoveRows_0_wrapper");

   procedure beginResetModel_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, beginResetModel_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_beginResetModel_0_wrapper");

   procedure changePersistentIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     From : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     To : not null access constant Qt4.Model_Indices.Internals.QModelIndex);
   pragma Import (C, changePersistentIndex_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_changePersistentIndex_0_wrapper");

   procedure endInsertColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endInsertColumns_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_endInsertColumns_0_wrapper");

   procedure endInsertRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endInsertRows_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_endInsertRows_0_wrapper");

   procedure endMoveColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endMoveColumns_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_endMoveColumns_0_wrapper");

   procedure endMoveRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endMoveRows_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_endMoveRows_0_wrapper");

   procedure endRemoveColumns_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endRemoveColumns_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_endRemoveColumns_0_wrapper");

   procedure endRemoveRows_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endRemoveRows_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_endRemoveRows_0_wrapper");

   procedure endResetModel_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, endResetModel_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_endResetModel_0_wrapper");

   procedure reset_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, reset_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_reset_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_customEvent_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_timerEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QAbstractProxyModel_sender_0_wrapper");

   pragma Style_Checks ("N");

   ------------------------------
   -- mapFromSource_0_dispatch --
   ------------------------------

   function mapFromSource_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Source_Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return not null access Qt4.Model_Indices.Internals.QModelIndex
   is
   begin
      return
        Qt4.Model_Indices.Thin.copy_QModelIndex
         (Qt4.Model_Indices.Internals.QModelIndex_View
           (Q_Abstract_Proxy_Model_Director'Class (Self.all).Map_From_Source
             (Qt4.Model_Indices.Internals.Create_Wrapper (Qt4.Model_Indices.Internals.QModelIndex_Access (Source_Index)))));
   end mapFromSource_0_dispatch;

   ---------------------------------------
   -- mapSelectionFromSource_0_dispatch --
   ---------------------------------------

   function mapSelectionFromSource_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Source_Selection : not null access Qt4.Item_Selections.Thin.QItemSelection)
       return not null access Qt4.Item_Selections.Thin.QItemSelection
   is
   begin
      return
        Qt4.Item_Selections.Thin.copy_QItemSelection
         (Qt4.Item_Selections.Internals.QItemSelection_View
           (Q_Abstract_Proxy_Model_Director'Class (Self.all).Map_Selection_From_Source
             (Qt4.Item_Selections.Internals.To_Q_Item_Selection (Source_Selection))));
   end mapSelectionFromSource_0_dispatch;

   -------------------------------
   -- Map_Selection_From_Source --
   -------------------------------

   overriding
   function Map_Selection_From_Source
    (Self : not null access constant Q_Abstract_Proxy_Model_Director;
     Source_Selection : Qt4.Item_Selections.Q_Item_Selection)
       return Qt4.Item_Selections.Q_Item_Selection
   is
      Returns : Qt4.Item_Selections.Q_Item_Selection;

   begin
      mapSelectionFromSource_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Qt4.Item_Selections.Internals.QItemSelection_View (Source_Selection),
        Qt4.Item_Selections.Internals.QItemSelection_View (Returns).all);

      return Returns;
   end Map_Selection_From_Source;

   -------------------------------------
   -- mapSelectionToSource_0_dispatch --
   -------------------------------------

   function mapSelectionToSource_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Proxy_Selection : not null access Qt4.Item_Selections.Thin.QItemSelection)
       return not null access Qt4.Item_Selections.Thin.QItemSelection
   is
   begin
      return
        Qt4.Item_Selections.Thin.copy_QItemSelection
         (Qt4.Item_Selections.Internals.QItemSelection_View
           (Q_Abstract_Proxy_Model_Director'Class (Self.all).Map_Selection_To_Source
             (Qt4.Item_Selections.Internals.To_Q_Item_Selection (Proxy_Selection))));
   end mapSelectionToSource_0_dispatch;

   -----------------------------
   -- Map_Selection_To_Source --
   -----------------------------

   overriding
   function Map_Selection_To_Source
    (Self : not null access constant Q_Abstract_Proxy_Model_Director;
     Proxy_Selection : Qt4.Item_Selections.Q_Item_Selection)
       return Qt4.Item_Selections.Q_Item_Selection
   is
      Returns : Qt4.Item_Selections.Q_Item_Selection;

   begin
      mapSelectionToSource_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Qt4.Item_Selections.Internals.QItemSelection_View (Proxy_Selection),
        Qt4.Item_Selections.Internals.QItemSelection_View (Returns).all);

      return Returns;
   end Map_Selection_To_Source;

   ----------------------------
   -- mapToSource_0_dispatch --
   ----------------------------

   function mapToSource_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Proxy_Index : not null access Qt4.Model_Indices.Internals.QModelIndex)
       return not null access Qt4.Model_Indices.Internals.QModelIndex
   is
   begin
      return
        Qt4.Model_Indices.Thin.copy_QModelIndex
         (Qt4.Model_Indices.Internals.QModelIndex_View
           (Q_Abstract_Proxy_Model_Director'Class (Self.all).Map_To_Source
             (Qt4.Model_Indices.Internals.Create_Wrapper (Qt4.Model_Indices.Internals.QModelIndex_Access (Proxy_Index)))));
   end mapToSource_0_dispatch;

   -------------------------------
   -- setSourceModel_0_dispatch --
   -------------------------------

   procedure setSourceModel_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Source_Model : access Qt_Ada.Internals.Objects.QObject)
   is
   begin
      Q_Abstract_Proxy_Model_Director'Class (Self.all).Set_Source_Model
       (Qt_Ada.Internals.Objects.Abstract_Item_Model_Utilities.Corresponding_Q_Abstract_Item_Model (Source_Model));
   end setSourceModel_0_dispatch;

   ----------------------
   -- Set_Source_Model --
   ----------------------

   overriding
   procedure Set_Source_Model
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Source_Model : access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class)
   is
   begin
      setSourceModel_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject (Source_Model));
   end Set_Source_Model;

   -----------------------
   -- Emit_Data_Changed --
   -----------------------

   overriding
   procedure Emit_Data_Changed
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Top_Left : Qt4.Model_Indices.Q_Model_Index;
     Bottom_Right : Qt4.Model_Indices.Q_Model_Index)
   is
   begin
      dataChanged_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Top_Left),
        Qt4.Model_Indices.Internals.QModelIndex_View (Bottom_Right));
   end Emit_Data_Changed;

   ------------------------------
   -- Emit_Header_Data_Changed --
   ------------------------------

   overriding
   procedure Emit_Header_Data_Changed
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Orientation : Qt4.Orientation;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer)
   is
   begin
      headerDataChanged_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Orientation,
        First,
        Last);
   end Emit_Header_Data_Changed;

   -------------------------------------
   -- Emit_Layout_About_To_Be_Changed --
   -------------------------------------

   overriding
   procedure Emit_Layout_About_To_Be_Changed
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      layoutAboutToBeChanged_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end Emit_Layout_About_To_Be_Changed;

   -------------------------
   -- Emit_Layout_Changed --
   -------------------------

   overriding
   procedure Emit_Layout_Changed
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      layoutChanged_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end Emit_Layout_Changed;

   --------------------------
   -- Begin_Insert_Columns --
   --------------------------

   overriding
   procedure Begin_Insert_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer)
   is
   begin
      beginInsertColumns_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent),
        First,
        Last);
   end Begin_Insert_Columns;

   -----------------------
   -- Begin_Insert_Rows --
   -----------------------

   overriding
   procedure Begin_Insert_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer)
   is
   begin
      beginInsertRows_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent),
        First,
        Last);
   end Begin_Insert_Rows;

   ------------------------
   -- Begin_Move_Columns --
   ------------------------

   overriding
   function Begin_Move_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Source_Parent : Qt4.Model_Indices.Q_Model_Index;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : Qt4.Model_Indices.Q_Model_Index;
     Destination_Child : Qt4.Q_Integer)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (beginMoveColumns_0_wrapper
           (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
            Qt4.Model_Indices.Internals.QModelIndex_View (Source_Parent),
            Source_First,
            Source_Last,
            Qt4.Model_Indices.Internals.QModelIndex_View (Destination_Parent),
            Destination_Child));
   end Begin_Move_Columns;

   ---------------------
   -- Begin_Move_Rows --
   ---------------------

   overriding
   function Begin_Move_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Source_Parent : Qt4.Model_Indices.Q_Model_Index;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : Qt4.Model_Indices.Q_Model_Index;
     Destination_Child : Qt4.Q_Integer)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (beginMoveRows_0_wrapper
           (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
            Qt4.Model_Indices.Internals.QModelIndex_View (Source_Parent),
            Source_First,
            Source_Last,
            Qt4.Model_Indices.Internals.QModelIndex_View (Destination_Parent),
            Destination_Child));
   end Begin_Move_Rows;

   --------------------------
   -- Begin_Remove_Columns --
   --------------------------

   overriding
   procedure Begin_Remove_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer)
   is
   begin
      beginRemoveColumns_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent),
        First,
        Last);
   end Begin_Remove_Columns;

   -----------------------
   -- Begin_Remove_Rows --
   -----------------------

   overriding
   procedure Begin_Remove_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer)
   is
   begin
      beginRemoveRows_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Parent),
        First,
        Last);
   end Begin_Remove_Rows;

   -----------------------
   -- Begin_Reset_Model --
   -----------------------

   overriding
   procedure Begin_Reset_Model
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      beginResetModel_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end Begin_Reset_Model;

   -----------------------------
   -- Change_Persistent_Index --
   -----------------------------

   overriding
   procedure Change_Persistent_Index
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     From : Qt4.Model_Indices.Q_Model_Index;
     To : Qt4.Model_Indices.Q_Model_Index)
   is
   begin
      changePersistentIndex_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (From),
        Qt4.Model_Indices.Internals.QModelIndex_View (To));
   end Change_Persistent_Index;

   ------------------------
   -- End_Insert_Columns --
   ------------------------

   overriding
   procedure End_Insert_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      endInsertColumns_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end End_Insert_Columns;

   ---------------------
   -- End_Insert_Rows --
   ---------------------

   overriding
   procedure End_Insert_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      endInsertRows_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end End_Insert_Rows;

   ----------------------
   -- End_Move_Columns --
   ----------------------

   overriding
   procedure End_Move_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      endMoveColumns_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end End_Move_Columns;

   -------------------
   -- End_Move_Rows --
   -------------------

   overriding
   procedure End_Move_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      endMoveRows_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end End_Move_Rows;

   ------------------------
   -- End_Remove_Columns --
   ------------------------

   overriding
   procedure End_Remove_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      endRemoveColumns_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end End_Remove_Columns;

   ---------------------
   -- End_Remove_Rows --
   ---------------------

   overriding
   procedure End_Remove_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      endRemoveRows_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end End_Remove_Rows;

   ---------------------
   -- End_Reset_Model --
   ---------------------

   overriding
   procedure End_Reset_Model
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      endResetModel_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end End_Reset_Model;

   -----------
   -- Reset --
   -----------

   overriding
   procedure Reset
    (Self : not null access Q_Abstract_Proxy_Model_Director)
   is
   begin
      reset_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View);
   end Reset;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_Abstract_Proxy_Model_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_Abstract_Proxy_Model_Director'Class (Self.all).QObject_View));
   end Sender;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QAbstractProxyModel", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.Abstract_Proxy_Models.Directors;
