------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Models.Directors;
limited with Qt4.Child_Events;
limited with Qt4.Events;
with Qt4.Meta_Objects;
limited with Qt4.Objects;
limited with Qt4.Timer_Events;

package Qt4.Abstract_Proxy_Models.Directors is

   type Q_Abstract_Proxy_Model_Director is
     abstract new Qt4.Abstract_Item_Models.Directors.Q_Abstract_Item_Model_Director
       and Q_Abstract_Proxy_Model with null record;

   overriding
   function Map_From_Source
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Source_Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
         is abstract;

   overriding
   function Map_Selection_From_Source
    (Self : not null access constant Q_Abstract_Proxy_Model_Director;
     Source_Selection : Qt4.Item_Selections.Q_Item_Selection)
       return Qt4.Item_Selections.Q_Item_Selection;

   overriding
   function Map_Selection_To_Source
    (Self : not null access constant Q_Abstract_Proxy_Model_Director;
     Proxy_Selection : Qt4.Item_Selections.Q_Item_Selection)
       return Qt4.Item_Selections.Q_Item_Selection;

   overriding
   function Map_To_Source
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Proxy_Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
         is abstract;

   overriding
   procedure Set_Source_Model
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Source_Model : access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class);

   overriding
   procedure Emit_Data_Changed
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Top_Left : Qt4.Model_Indices.Q_Model_Index;
     Bottom_Right : Qt4.Model_Indices.Q_Model_Index);

   overriding
   procedure Emit_Header_Data_Changed
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Orientation : Qt4.Orientation;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   overriding
   procedure Emit_Layout_About_To_Be_Changed
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure Emit_Layout_Changed
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure Begin_Insert_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   overriding
   procedure Begin_Insert_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   overriding
   function Begin_Move_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Source_Parent : Qt4.Model_Indices.Q_Model_Index;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : Qt4.Model_Indices.Q_Model_Index;
     Destination_Child : Qt4.Q_Integer)
       return Standard.Boolean;

   overriding
   function Begin_Move_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Source_Parent : Qt4.Model_Indices.Q_Model_Index;
     Source_First : Qt4.Q_Integer;
     Source_Last : Qt4.Q_Integer;
     Destination_Parent : Qt4.Model_Indices.Q_Model_Index;
     Destination_Child : Qt4.Q_Integer)
       return Standard.Boolean;

   overriding
   procedure Begin_Remove_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   overriding
   procedure Begin_Remove_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Parent : Qt4.Model_Indices.Q_Model_Index;
     First : Qt4.Q_Integer;
     Last : Qt4.Q_Integer);

   overriding
   procedure Begin_Reset_Model
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure Change_Persistent_Index
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     From : Qt4.Model_Indices.Q_Model_Index;
     To : Qt4.Model_Indices.Q_Model_Index);

   overriding
   procedure End_Insert_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure End_Insert_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure End_Move_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure End_Move_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure End_Remove_Columns
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure End_Remove_Rows
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure End_Reset_Model
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure Reset
    (Self : not null access Q_Abstract_Proxy_Model_Director);

   overriding
   procedure Child_Event
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_Abstract_Proxy_Model_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Abstract_Proxy_Model_Director)
       return access Qt4.Objects.Q_Object'Class;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QAbstractProxyModel_staticMetaObject");

end Qt4.Abstract_Proxy_Models.Directors;
