------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Models;
with Qt4.Item_Selections;
with Qt4.Model_Indices;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Abstract_Proxy_Models is

   type Q_Abstract_Proxy_Model is limited interface
     and Qt4.Abstract_Item_Models.Q_Abstract_Item_Model;

   type Q_Abstract_Proxy_Model_Access is
     access all Q_Abstract_Proxy_Model'Class;
   for Q_Abstract_Proxy_Model_Access'Storage_Size use 0;

   type Q_Abstract_Proxy_Model_Pointer is tagged;

   not overriding
   function Map_From_Source
    (Self : not null access Q_Abstract_Proxy_Model;
     Source_Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
         is abstract;

   not overriding
   function Map_Selection_From_Source
    (Self : not null access constant Q_Abstract_Proxy_Model;
     Source_Selection : Qt4.Item_Selections.Q_Item_Selection)
       return Qt4.Item_Selections.Q_Item_Selection
         is abstract;

   not overriding
   function Map_Selection_To_Source
    (Self : not null access constant Q_Abstract_Proxy_Model;
     Proxy_Selection : Qt4.Item_Selections.Q_Item_Selection)
       return Qt4.Item_Selections.Q_Item_Selection
         is abstract;

   not overriding
   function Map_To_Source
    (Self : not null access Q_Abstract_Proxy_Model;
     Proxy_Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Model_Indices.Q_Model_Index
         is abstract;

   not overriding
   procedure Set_Source_Model
    (Self : not null access Q_Abstract_Proxy_Model;
     Source_Model : access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class)
       is abstract;

   function Source_Model
    (Self : not null access constant Q_Abstract_Proxy_Model'Class)
       return access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;

   package Q_Abstract_Proxy_Model_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Abstract_Proxy_Model, Q_Abstract_Proxy_Model_Access);

   type Q_Abstract_Proxy_Model_Pointer is
     new Q_Abstract_Proxy_Model_Pointers.Q_Pointer with null record;

end Qt4.Abstract_Proxy_Models;
