------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Colors;
with Qt4.Dialogs;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Color_Dialogs is

   type Q_Color_Dialog is limited interface
     and Qt4.Dialogs.Q_Dialog;

   type Q_Color_Dialog_Access is
     access all Q_Color_Dialog'Class;
   for Q_Color_Dialog_Access'Storage_Size use 0;

   type Q_Color_Dialog_Pointer is tagged;

   function Current_Color
    (Self : not null access constant Q_Color_Dialog'Class)
       return Qt4.Colors.Q_Color;

   procedure Open
    (Self : not null access Q_Color_Dialog'Class);

   function Selected_Color
    (Self : not null access constant Q_Color_Dialog'Class)
       return Qt4.Colors.Q_Color;

   procedure Set_Current_Color
    (Self : not null access Q_Color_Dialog'Class;
     Color : Qt4.Colors.Q_Color);

   function Get_Color
    (Initial : Qt4.Colors.Q_Color'Class := Qt4.Colors.Create (Qt4.White);
     Parent  : access Qt4.Widgets.Q_Widget'Class := null)
       return Qt4.Colors.Q_Color;

   package Q_Color_Dialog_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Color_Dialog, Q_Color_Dialog_Access);

   type Q_Color_Dialog_Pointer is
     new Q_Color_Dialog_Pointers.Q_Pointer with null record;

end Qt4.Color_Dialogs;
