------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009, 2010 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Graphics_Items.Directors;
with Qt4.Graphics_Objects;
with Qt_Ada.Internals.Graphics_Item_Registry;
with Qt_Ada.Internals.Graphics_Items.Graphics_Item_Utilities;
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects.Graphics_Object_Utilities;
with Qt_Ada.Internals.Objects.Graphics_Scene_Utilities;

with Qt_Ada.Internals.Graphics_Items.Graphics_Item_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Graphics_Items.Graphics_Item_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Graphics_Items is

   function acceptDrops_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, acceptDrops_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_acceptDrops_0_wrapper");

   function acceptHoverEvents_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, acceptHoverEvents_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_acceptHoverEvents_0_wrapper");

   function acceptTouchEvents_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, acceptTouchEvents_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_acceptTouchEvents_0_wrapper");

   procedure boundingRegion_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item_To_Device_Transform : not null access constant Qt4.Transforms.Internals.QTransform;
     Returns : not null access Qt4.Regions.Internals.QRegion);
   pragma Import (C, boundingRegion_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_boundingRegion_0_wrapper");

   function boundingRegionGranularity_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Q_Real;
   pragma Import (C, boundingRegionGranularity_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_boundingRegionGranularity_0_wrapper");

   function cacheMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Graphics_Items.Graphics_Item_Cache_Mode;
   pragma Import (C, cacheMode_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_cacheMode_0_wrapper");

   procedure childrenBoundingRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, childrenBoundingRect_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_childrenBoundingRect_0_wrapper");

   procedure clearFocus_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, clearFocus_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_clearFocus_0_wrapper");

   procedure clipPath_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, clipPath_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_clipPath_0_wrapper");

   function commonAncestorItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Other : access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
   pragma Import (C, commonAncestorItem_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_commonAncestorItem_0_wrapper");

   procedure cursor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Cursors.Internals.QCursor);
   pragma Import (C, cursor_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_cursor_0_wrapper");

   procedure data_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Key : Qt4.Q_Integer;
     Returns : not null access Qt4.Variants.Internals.QVariant);
   pragma Import (C, data_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_data_0_wrapper");

   procedure deviceTransform_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Viewport_Transform : not null access constant Qt4.Transforms.Internals.QTransform;
     Returns : not null access Qt4.Transforms.Internals.QTransform);
   pragma Import (C, deviceTransform_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_deviceTransform_0_wrapper");

   function effectiveOpacity_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Q_Real;
   pragma Import (C, effectiveOpacity_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_effectiveOpacity_0_wrapper");

   procedure ensureVisible_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Xmargin : Qt4.Q_Integer;
     Ymargin : Qt4.Q_Integer);
   pragma Import (C, ensureVisible_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_ensureVisible_1_wrapper");

   procedure ensureVisible_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Xmargin : Qt4.Q_Integer;
     Ymargin : Qt4.Q_Integer);
   pragma Import (C, ensureVisible_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_ensureVisible_0_wrapper");

   function filtersChildEvents_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, filtersChildEvents_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_filtersChildEvents_0_wrapper");

   function focusItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
   pragma Import (C, focusItem_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_focusItem_0_wrapper");

   function focusProxy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
   pragma Import (C, focusProxy_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_focusProxy_0_wrapper");

   procedure grabKeyboard_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, grabKeyboard_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_grabKeyboard_0_wrapper");

   procedure grabMouse_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, grabMouse_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_grabMouse_0_wrapper");

   function handlesChildEvents_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, handlesChildEvents_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_handlesChildEvents_0_wrapper");

   function hasCursor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, hasCursor_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_hasCursor_0_wrapper");

   function hasFocus_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, hasFocus_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_hasFocus_0_wrapper");

   procedure hide_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, hide_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_hide_0_wrapper");

   procedure installSceneEventFilter_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Filter_Item : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, installSceneEventFilter_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_installSceneEventFilter_0_wrapper");

   function isActive_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isActive_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isActive_0_wrapper");

   function isAncestorOf_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Child : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isAncestorOf_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isAncestorOf_0_wrapper");

   function isClipped_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isClipped_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isClipped_0_wrapper");

   function isEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isEnabled_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isEnabled_0_wrapper");

   function isObscured_2_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isObscured_2_wrapper,
                     "__Qt4Ada_QGraphicsItem_isObscured_2_wrapper");

   function isObscured_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.bool;
   pragma Import (C, isObscured_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_isObscured_1_wrapper");

   function isObscured_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF)
       return Qt4.bool;
   pragma Import (C, isObscured_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isObscured_0_wrapper");

   function isPanel_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isPanel_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isPanel_0_wrapper");

   function isSelected_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isSelected_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isSelected_0_wrapper");

   function isUnderMouse_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isUnderMouse_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isUnderMouse_0_wrapper");

   function isVisible_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isVisible_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isVisible_0_wrapper");

   function isVisibleTo_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Parent : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isVisibleTo_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isVisibleTo_0_wrapper");

   function isWidget_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isWidget_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isWidget_0_wrapper");

   function isWindow_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isWindow_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isWindow_0_wrapper");

   procedure mapFromItem_5_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Point : not null access constant Qt4.Point_Fs.Internals.QPointF;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapFromItem_5_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromItem_5_wrapper");

   procedure mapFromItem_4_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapFromItem_4_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromItem_4_wrapper");

   procedure mapFromItem_3_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Polygon : not null access constant Qt4.Polygon_Fs.Internals.QPolygonF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapFromItem_3_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromItem_3_wrapper");

   procedure mapFromItem_2_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Path : not null access constant Qt4.Painter_Paths.Internals.QPainterPath;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, mapFromItem_2_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromItem_2_wrapper");

   procedure mapFromItem_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapFromItem_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromItem_1_wrapper");

   procedure mapFromItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapFromItem_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromItem_0_wrapper");

   procedure mapFromParent_5_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Point : not null access constant Qt4.Point_Fs.Internals.QPointF;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapFromParent_5_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromParent_5_wrapper");

   procedure mapFromParent_4_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapFromParent_4_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromParent_4_wrapper");

   procedure mapFromParent_3_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Polygon : not null access constant Qt4.Polygon_Fs.Internals.QPolygonF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapFromParent_3_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromParent_3_wrapper");

   procedure mapFromParent_2_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Path : not null access constant Qt4.Painter_Paths.Internals.QPainterPath;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, mapFromParent_2_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromParent_2_wrapper");

   procedure mapFromParent_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapFromParent_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromParent_1_wrapper");

   procedure mapFromParent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapFromParent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromParent_0_wrapper");

   procedure mapFromScene_5_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Point : not null access constant Qt4.Point_Fs.Internals.QPointF;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapFromScene_5_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromScene_5_wrapper");

   procedure mapFromScene_4_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapFromScene_4_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromScene_4_wrapper");

   procedure mapFromScene_3_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Polygon : not null access constant Qt4.Polygon_Fs.Internals.QPolygonF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapFromScene_3_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromScene_3_wrapper");

   procedure mapFromScene_2_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Path : not null access constant Qt4.Painter_Paths.Internals.QPainterPath;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, mapFromScene_2_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromScene_2_wrapper");

   procedure mapFromScene_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapFromScene_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromScene_1_wrapper");

   procedure mapFromScene_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapFromScene_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapFromScene_0_wrapper");

   procedure mapRectFromItem_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectFromItem_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectFromItem_1_wrapper");

   procedure mapRectFromItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectFromItem_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectFromItem_0_wrapper");

   procedure mapRectFromParent_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectFromParent_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectFromParent_1_wrapper");

   procedure mapRectFromParent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectFromParent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectFromParent_0_wrapper");

   procedure mapRectFromScene_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectFromScene_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectFromScene_1_wrapper");

   procedure mapRectFromScene_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectFromScene_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectFromScene_0_wrapper");

   procedure mapRectToItem_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectToItem_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectToItem_1_wrapper");

   procedure mapRectToItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectToItem_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectToItem_0_wrapper");

   procedure mapRectToParent_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectToParent_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectToParent_1_wrapper");

   procedure mapRectToParent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectToParent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectToParent_0_wrapper");

   procedure mapRectToScene_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectToScene_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectToScene_1_wrapper");

   procedure mapRectToScene_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, mapRectToScene_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapRectToScene_0_wrapper");

   procedure mapToItem_5_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Point : not null access constant Qt4.Point_Fs.Internals.QPointF;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapToItem_5_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToItem_5_wrapper");

   procedure mapToItem_4_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToItem_4_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToItem_4_wrapper");

   procedure mapToItem_3_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Polygon : not null access constant Qt4.Polygon_Fs.Internals.QPolygonF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToItem_3_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToItem_3_wrapper");

   procedure mapToItem_2_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Path : not null access constant Qt4.Painter_Paths.Internals.QPainterPath;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, mapToItem_2_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToItem_2_wrapper");

   procedure mapToItem_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToItem_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToItem_1_wrapper");

   procedure mapToItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapToItem_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToItem_0_wrapper");

   procedure mapToParent_5_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Point : not null access constant Qt4.Point_Fs.Internals.QPointF;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapToParent_5_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToParent_5_wrapper");

   procedure mapToParent_4_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToParent_4_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToParent_4_wrapper");

   procedure mapToParent_3_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Polygon : not null access constant Qt4.Polygon_Fs.Internals.QPolygonF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToParent_3_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToParent_3_wrapper");

   procedure mapToParent_2_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Path : not null access constant Qt4.Painter_Paths.Internals.QPainterPath;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, mapToParent_2_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToParent_2_wrapper");

   procedure mapToParent_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToParent_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToParent_1_wrapper");

   procedure mapToParent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapToParent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToParent_0_wrapper");

   procedure mapToScene_5_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Point : not null access constant Qt4.Point_Fs.Internals.QPointF;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapToScene_5_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToScene_5_wrapper");

   procedure mapToScene_4_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToScene_4_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToScene_4_wrapper");

   procedure mapToScene_3_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Polygon : not null access constant Qt4.Polygon_Fs.Internals.QPolygonF;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToScene_3_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToScene_3_wrapper");

   procedure mapToScene_2_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Path : not null access constant Qt4.Painter_Paths.Internals.QPainterPath;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, mapToScene_2_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToScene_2_wrapper");

   procedure mapToScene_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, mapToScene_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToScene_1_wrapper");

   procedure mapToScene_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, mapToScene_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mapToScene_0_wrapper");

   procedure matrix_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Matrices.Internals.QMatrix);
   pragma Import (C, matrix_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_matrix_0_wrapper");

   procedure moveBy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real);
   pragma Import (C, moveBy_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_moveBy_0_wrapper");

   function opacity_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Q_Real;
   pragma Import (C, opacity_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_opacity_0_wrapper");

   function panel_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
   pragma Import (C, panel_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_panel_0_wrapper");

   function panelModality_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Graphics_Items.Graphics_Item_Panel_Modality;
   pragma Import (C, panelModality_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_panelModality_0_wrapper");

   function parentObject_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, parentObject_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_parentObject_0_wrapper");

   function parentItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
   pragma Import (C, parentItem_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_parentItem_0_wrapper");

   procedure pos_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, pos_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_pos_0_wrapper");

   procedure removeSceneEventFilter_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Filter_Item : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, removeSceneEventFilter_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_removeSceneEventFilter_0_wrapper");

   procedure resetMatrix_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, resetMatrix_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_resetMatrix_0_wrapper");

   procedure resetTransform_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, resetTransform_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_resetTransform_0_wrapper");

   procedure rotate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Angle : Qt4.Q_Real);
   pragma Import (C, rotate_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_rotate_0_wrapper");

   function rotation_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Q_Real;
   pragma Import (C, rotation_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_rotation_0_wrapper");

   function scale_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Q_Real;
   pragma Import (C, scale_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_scale_1_wrapper");

   procedure scale_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Sx : Qt4.Q_Real;
     Sy : Qt4.Q_Real);
   pragma Import (C, scale_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_scale_0_wrapper");

   function scene_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, scene_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_scene_0_wrapper");

   procedure sceneBoundingRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, sceneBoundingRect_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_sceneBoundingRect_0_wrapper");

   procedure sceneMatrix_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Matrices.Internals.QMatrix);
   pragma Import (C, sceneMatrix_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_sceneMatrix_0_wrapper");

   procedure scenePos_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, scenePos_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_scenePos_0_wrapper");

   procedure sceneTransform_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Transforms.Internals.QTransform);
   pragma Import (C, sceneTransform_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_sceneTransform_0_wrapper");

   procedure scroll_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, scroll_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_scroll_0_wrapper");

   procedure setAcceptDrops_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     On : Qt4.bool);
   pragma Import (C, setAcceptDrops_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setAcceptDrops_0_wrapper");

   procedure setAcceptHoverEvents_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Enabled : Qt4.bool);
   pragma Import (C, setAcceptHoverEvents_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setAcceptHoverEvents_0_wrapper");

   procedure setAcceptTouchEvents_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Enabled : Qt4.bool);
   pragma Import (C, setAcceptTouchEvents_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setAcceptTouchEvents_0_wrapper");

   procedure setActive_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Active : Qt4.bool);
   pragma Import (C, setActive_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setActive_0_wrapper");

   procedure setBoundingRegionGranularity_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Granularity : Qt4.Q_Real);
   pragma Import (C, setBoundingRegionGranularity_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setBoundingRegionGranularity_0_wrapper");

   procedure setCacheMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Mode : Qt4.Graphics_Items.Graphics_Item_Cache_Mode;
     Cache_Size : not null access constant Qt4.Sizes.Internals.QSize);
   pragma Import (C, setCacheMode_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setCacheMode_0_wrapper");

   procedure setCursor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Cursor : not null access constant Qt4.Cursors.Internals.QCursor);
   pragma Import (C, setCursor_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setCursor_0_wrapper");

   procedure setData_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Key : Qt4.Q_Integer;
     Value : not null access constant Qt4.Variants.Internals.QVariant);
   pragma Import (C, setData_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setData_0_wrapper");

   procedure setEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Enabled : Qt4.bool);
   pragma Import (C, setEnabled_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setEnabled_0_wrapper");

   procedure setFiltersChildEvents_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Enabled : Qt4.bool);
   pragma Import (C, setFiltersChildEvents_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setFiltersChildEvents_0_wrapper");

   procedure setFlag_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Flag : Qt4.Graphics_Items.Graphics_Item_Graphics_Item_Flag;
     Enabled : Qt4.bool);
   pragma Import (C, setFlag_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setFlag_0_wrapper");

   procedure setFocusProxy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, setFocusProxy_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setFocusProxy_0_wrapper");

   procedure setHandlesChildEvents_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Enabled : Qt4.bool);
   pragma Import (C, setHandlesChildEvents_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setHandlesChildEvents_0_wrapper");

   procedure setMatrix_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Matrix : not null access constant Qt4.Matrices.Internals.QMatrix;
     Combine : Qt4.bool);
   pragma Import (C, setMatrix_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setMatrix_0_wrapper");

   procedure setOpacity_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Opacity : Qt4.Q_Real);
   pragma Import (C, setOpacity_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setOpacity_0_wrapper");

   procedure setPanelModality_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Panel_Modality : Qt4.Graphics_Items.Graphics_Item_Panel_Modality);
   pragma Import (C, setPanelModality_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setPanelModality_0_wrapper");

   procedure setParentItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Parent : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, setParentItem_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setParentItem_0_wrapper");

   procedure setPos_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Pos : not null access constant Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, setPos_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_setPos_1_wrapper");

   procedure setPos_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real);
   pragma Import (C, setPos_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setPos_0_wrapper");

   procedure setRotation_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Angle : Qt4.Q_Real);
   pragma Import (C, setRotation_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setRotation_0_wrapper");

   procedure setScale_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Factor : Qt4.Q_Real);
   pragma Import (C, setScale_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setScale_0_wrapper");

   procedure setSelected_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Selected : Qt4.bool);
   pragma Import (C, setSelected_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setSelected_0_wrapper");

   procedure setToolTip_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Tool_Tip : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setToolTip_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setToolTip_0_wrapper");

   procedure setTransform_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Matrix : not null access constant Qt4.Transforms.Internals.QTransform;
     Combine : Qt4.bool);
   pragma Import (C, setTransform_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setTransform_0_wrapper");

   procedure setTransformOriginPoint_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Origin : not null access constant Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, setTransformOriginPoint_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_setTransformOriginPoint_1_wrapper");

   procedure setTransformOriginPoint_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real);
   pragma Import (C, setTransformOriginPoint_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setTransformOriginPoint_0_wrapper");

   procedure setVisible_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Visible : Qt4.bool);
   pragma Import (C, setVisible_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setVisible_0_wrapper");

   procedure setX_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real);
   pragma Import (C, setX_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setX_0_wrapper");

   procedure setY_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Y : Qt4.Q_Real);
   pragma Import (C, setY_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setY_0_wrapper");

   procedure setZValue_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Z : Qt4.Q_Real);
   pragma Import (C, setZValue_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_setZValue_0_wrapper");

   procedure shear_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Sh : Qt4.Q_Real;
     Sv : Qt4.Q_Real);
   pragma Import (C, shear_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_shear_0_wrapper");

   procedure show_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, show_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_show_0_wrapper");

   procedure stackBefore_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Sibling : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, stackBefore_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_stackBefore_0_wrapper");

   function toGraphicsObject_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, toGraphicsObject_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_toGraphicsObject_0_wrapper");

   procedure toolTip_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, toolTip_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_toolTip_0_wrapper");

   function topLevelItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
   pragma Import (C, topLevelItem_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_topLevelItem_0_wrapper");

   procedure transform_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Transforms.Internals.QTransform);
   pragma Import (C, transform_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_transform_0_wrapper");

   procedure transformOriginPoint_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, transformOriginPoint_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_transformOriginPoint_0_wrapper");

   procedure translate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real);
   pragma Import (C, translate_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_translate_0_wrapper");

   procedure ungrabKeyboard_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, ungrabKeyboard_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_ungrabKeyboard_0_wrapper");

   procedure ungrabMouse_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, ungrabMouse_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_ungrabMouse_0_wrapper");

   procedure unsetCursor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, unsetCursor_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_unsetCursor_0_wrapper");

   procedure update_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, update_1_wrapper,
                     "__Qt4Ada_QGraphicsItem_update_1_wrapper");

   procedure update_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Width : Qt4.Q_Real;
     Height : Qt4.Q_Real);
   pragma Import (C, update_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_update_0_wrapper");

   function x_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Q_Real;
   pragma Import (C, x_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_x_0_wrapper");

   function y_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Q_Real;
   pragma Import (C, y_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_y_0_wrapper");

   function zValue_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Q_Real;
   pragma Import (C, zValue_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_zValue_0_wrapper");

   --------------------------------
   -- Set_Accepted_Mouse_Buttons --
   --------------------------------

   procedure setAcceptedMouseButtons_wrapper
    (Self    : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Buttons : Qt4.Mouse_Buttons);
   pragma Import (C,
                  setAcceptedMouseButtons_wrapper,
                  "__Qt4Ada_QGraphicsItem_setAcceptedMouseButtons_wrapper");

   procedure Set_Accepted_Mouse_Buttons
    (Self    : not null access Q_Graphics_Item'Class;
     Buttons : Qt4.Mouse_Buttons) is
   begin
      setAcceptedMouseButtons_wrapper (Self.QGraphicsItem_View, Buttons);
   end Set_Accepted_Mouse_Buttons;

   pragma Style_Checks ("N");

   ------------------
   -- Accept_Drops --
   ------------------

   function Accept_Drops
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (acceptDrops_0_wrapper
           (Self.QGraphicsItem_View));
   end Accept_Drops;

   -------------------------
   -- Accept_Hover_Events --
   -------------------------

   function Accept_Hover_Events
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (acceptHoverEvents_0_wrapper
           (Self.QGraphicsItem_View));
   end Accept_Hover_Events;

   -------------------------
   -- Accept_Touch_Events --
   -------------------------

   function Accept_Touch_Events
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (acceptTouchEvents_0_wrapper
           (Self.QGraphicsItem_View));
   end Accept_Touch_Events;

   ---------------------
   -- Bounding_Region --
   ---------------------

   function Bounding_Region
    (Self : not null access constant Q_Graphics_Item'Class;
     Item_To_Device_Transform : Qt4.Transforms.Q_Transform)
       return Qt4.Regions.Q_Region
   is
      Returns : Qt4.Regions.Q_Region;

   begin
      boundingRegion_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Transforms.Internals.QTransform_View (Item_To_Device_Transform),
        Qt4.Regions.Internals.QRegion_View (Returns));

      return Returns;
   end Bounding_Region;

   ---------------------------------
   -- Bounding_Region_Granularity --
   ---------------------------------

   function Bounding_Region_Granularity
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Q_Real
   is
   begin
      return
        boundingRegionGranularity_0_wrapper
         (Self.QGraphicsItem_View);
   end Bounding_Region_Granularity;

   ----------------
   -- Cache_Mode --
   ----------------

   function Cache_Mode
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Graphics_Items.Graphics_Item_Cache_Mode
   is
   begin
      return
        cacheMode_0_wrapper
         (Self.QGraphicsItem_View);
   end Cache_Mode;

   ----------------------------
   -- Children_Bounding_Rect --
   ----------------------------

   function Children_Bounding_Rect
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      childrenBoundingRect_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Children_Bounding_Rect;

   -----------------
   -- Clear_Focus --
   -----------------

   procedure Clear_Focus
    (Self : not null access Q_Graphics_Item'Class)
   is
   begin
      clearFocus_0_wrapper
       (Self.QGraphicsItem_View);
   end Clear_Focus;

   ---------------
   -- Clip_Path --
   ---------------

   function Clip_Path
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      clipPath_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Clip_Path;

   --------------------------
   -- Common_Ancestor_Item --
   --------------------------

   function Common_Ancestor_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Other : access Qt4.Graphics_Items.Q_Graphics_Item'Class)
       return access Qt4.Graphics_Items.Q_Graphics_Item'Class
   is
   begin
      return
        Qt_Ada.Internals.Graphics_Items.Graphics_Item_Utilities.Corresponding_Q_Graphics_Item
         (commonAncestorItem_0_wrapper
           (Self.QGraphicsItem_View,
            Qt_Ada.Internals.Graphics_Items.Graphics_Item_Utilities.Corresponding_QGraphicsItem (Other)));
   end Common_Ancestor_Item;

   ------------
   -- Cursor --
   ------------

   function Cursor
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Cursors.Q_Cursor
   is
      Returns : Qt4.Cursors.Q_Cursor;

   begin
      cursor_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Cursors.Internals.QCursor_View (Returns));

      return Returns;
   end Cursor;

   ----------
   -- Data --
   ----------

   function Data
    (Self : not null access constant Q_Graphics_Item'Class;
     Key : Qt4.Q_Integer)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      data_0_wrapper
       (Self.QGraphicsItem_View,
        Key,
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Data;

   ----------------------
   -- Device_Transform --
   ----------------------

   function Device_Transform
    (Self : not null access constant Q_Graphics_Item'Class;
     Viewport_Transform : Qt4.Transforms.Q_Transform)
       return Qt4.Transforms.Q_Transform
   is
      Returns : Qt4.Transforms.Q_Transform;

   begin
      deviceTransform_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Transforms.Internals.QTransform_View (Viewport_Transform),
        Qt4.Transforms.Internals.QTransform_View (Returns));

      return Returns;
   end Device_Transform;

   -----------------------
   -- Effective_Opacity --
   -----------------------

   function Effective_Opacity
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Q_Real
   is
   begin
      return
        effectiveOpacity_0_wrapper
         (Self.QGraphicsItem_View);
   end Effective_Opacity;

   --------------------
   -- Ensure_Visible --
   --------------------

   procedure Ensure_Visible
    (Self : not null access Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F
       := Qt4.Rect_Fs.Create;
     Xmargin : Qt4.Q_Integer
       :=  50;
     Ymargin : Qt4.Q_Integer
       :=  50)
   is
   begin
      ensureVisible_1_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Xmargin,
        Ymargin);
   end Ensure_Visible;

   --------------------
   -- Ensure_Visible --
   --------------------

   procedure Ensure_Visible
    (Self : not null access Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real;
     Xmargin : Qt4.Q_Integer
       :=  50;
     Ymargin : Qt4.Q_Integer
       :=  50)
   is
   begin
      ensureVisible_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Xmargin,
        Ymargin);
   end Ensure_Visible;

   --------------------------
   -- Filters_Child_Events --
   --------------------------

   function Filters_Child_Events
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (filtersChildEvents_0_wrapper
           (Self.QGraphicsItem_View));
   end Filters_Child_Events;

   ----------------
   -- Focus_Item --
   ----------------

   function Focus_Item
    (Self : not null access constant Q_Graphics_Item'Class)
       return access Qt4.Graphics_Items.Q_Graphics_Item'Class
   is
   begin
      return
        Qt_Ada.Internals.Graphics_Items.Graphics_Item_Utilities.Corresponding_Q_Graphics_Item
         (focusItem_0_wrapper
           (Self.QGraphicsItem_View));
   end Focus_Item;

   -----------------
   -- Focus_Proxy --
   -----------------

   function Focus_Proxy
    (Self : not null access constant Q_Graphics_Item'Class)
       return access Qt4.Graphics_Items.Q_Graphics_Item'Class
   is
   begin
      return
        Qt_Ada.Internals.Graphics_Items.Graphics_Item_Utilities.Corresponding_Q_Graphics_Item
         (focusProxy_0_wrapper
           (Self.QGraphicsItem_View));
   end Focus_Proxy;

   -------------------
   -- Grab_Keyboard --
   -------------------

   procedure Grab_Keyboard
    (Self : not null access Q_Graphics_Item'Class)
   is
   begin
      grabKeyboard_0_wrapper
       (Self.QGraphicsItem_View);
   end Grab_Keyboard;

   ----------------
   -- Grab_Mouse --
   ----------------

   procedure Grab_Mouse
    (Self : not null access Q_Graphics_Item'Class)
   is
   begin
      grabMouse_0_wrapper
       (Self.QGraphicsItem_View);
   end Grab_Mouse;

   --------------------------
   -- Handles_Child_Events --
   --------------------------

   function Handles_Child_Events
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (handlesChildEvents_0_wrapper
           (Self.QGraphicsItem_View));
   end Handles_Child_Events;

   ----------------
   -- Has_Cursor --
   ----------------

   function Has_Cursor
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasCursor_0_wrapper
           (Self.QGraphicsItem_View));
   end Has_Cursor;

   ---------------
   -- Has_Focus --
   ---------------

   function Has_Focus
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasFocus_0_wrapper
           (Self.QGraphicsItem_View));
   end Has_Focus;

   ----------
   -- Hide --
   ----------

   procedure Hide
    (Self : not null access Q_Graphics_Item'Class)
   is
   begin
      hide_0_wrapper
       (Self.QGraphicsItem_View);
   end Hide;

   --------------------------------
   -- Install_Scene_Event_Filter --
   --------------------------------

   procedure Install_Scene_Event_Filter
    (Self : not null access Q_Graphics_Item'Class;
     Filter_Item : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class)
   is
   begin
      installSceneEventFilter_0_wrapper
       (Self.QGraphicsItem_View,
        Filter_Item.QGraphicsItem_View);
   end Install_Scene_Event_Filter;

   ---------------
   -- Is_Active --
   ---------------

   function Is_Active
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isActive_0_wrapper
           (Self.QGraphicsItem_View));
   end Is_Active;

   --------------------
   -- Is_Ancestor_Of --
   --------------------

   function Is_Ancestor_Of
    (Self : not null access constant Q_Graphics_Item'Class;
     Child : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isAncestorOf_0_wrapper
           (Self.QGraphicsItem_View,
            Child.QGraphicsItem_View));
   end Is_Ancestor_Of;

   ----------------
   -- Is_Clipped --
   ----------------

   function Is_Clipped
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isClipped_0_wrapper
           (Self.QGraphicsItem_View));
   end Is_Clipped;

   ----------------
   -- Is_Enabled --
   ----------------

   function Is_Enabled
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isEnabled_0_wrapper
           (Self.QGraphicsItem_View));
   end Is_Enabled;

   -----------------
   -- Is_Obscured --
   -----------------

   function Is_Obscured
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isObscured_2_wrapper
           (Self.QGraphicsItem_View));
   end Is_Obscured;

   -----------------
   -- Is_Obscured --
   -----------------

   function Is_Obscured
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isObscured_1_wrapper
           (Self.QGraphicsItem_View,
            X,
            Y,
            W,
            H));
   end Is_Obscured;

   -----------------
   -- Is_Obscured --
   -----------------

   function Is_Obscured
    (Self : not null access constant Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isObscured_0_wrapper
           (Self.QGraphicsItem_View,
            Qt4.Rect_Fs.Internals.QRectF_View (Rect)));
   end Is_Obscured;

   --------------
   -- Is_Panel --
   --------------

   function Is_Panel
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isPanel_0_wrapper
           (Self.QGraphicsItem_View));
   end Is_Panel;

   -----------------
   -- Is_Selected --
   -----------------

   function Is_Selected
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isSelected_0_wrapper
           (Self.QGraphicsItem_View));
   end Is_Selected;

   --------------------
   -- Is_Under_Mouse --
   --------------------

   function Is_Under_Mouse
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isUnderMouse_0_wrapper
           (Self.QGraphicsItem_View));
   end Is_Under_Mouse;

   ----------------
   -- Is_Visible --
   ----------------

   function Is_Visible
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isVisible_0_wrapper
           (Self.QGraphicsItem_View));
   end Is_Visible;

   -------------------
   -- Is_Visible_To --
   -------------------

   function Is_Visible_To
    (Self : not null access constant Q_Graphics_Item'Class;
     Parent : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isVisibleTo_0_wrapper
           (Self.QGraphicsItem_View,
            Parent.QGraphicsItem_View));
   end Is_Visible_To;

   ---------------
   -- Is_Widget --
   ---------------

   function Is_Widget
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isWidget_0_wrapper
           (Self.QGraphicsItem_View));
   end Is_Widget;

   ---------------
   -- Is_Window --
   ---------------

   function Is_Window
    (Self : not null access constant Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isWindow_0_wrapper
           (Self.QGraphicsItem_View));
   end Is_Window;

   -------------------
   -- Map_From_Item --
   -------------------

   function Map_From_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapFromItem_5_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Point),
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_From_Item;

   -------------------
   -- Map_From_Item --
   -------------------

   function Map_From_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapFromItem_4_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_From_Item;

   -------------------
   -- Map_From_Item --
   -------------------

   function Map_From_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Polygon : Qt4.Polygon_Fs.Q_Polygon_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapFromItem_3_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Polygon),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_From_Item;

   -------------------
   -- Map_From_Item --
   -------------------

   function Map_From_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      mapFromItem_2_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Path),
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Map_From_Item;

   -------------------
   -- Map_From_Item --
   -------------------

   function Map_From_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapFromItem_1_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_From_Item;

   -------------------
   -- Map_From_Item --
   -------------------

   function Map_From_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapFromItem_0_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        X,
        Y,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_From_Item;

   ---------------------
   -- Map_From_Parent --
   ---------------------

   function Map_From_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapFromParent_5_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Point),
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_From_Parent;

   ---------------------
   -- Map_From_Parent --
   ---------------------

   function Map_From_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapFromParent_4_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_From_Parent;

   ---------------------
   -- Map_From_Parent --
   ---------------------

   function Map_From_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     Polygon : Qt4.Polygon_Fs.Q_Polygon_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapFromParent_3_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Polygon),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_From_Parent;

   ---------------------
   -- Map_From_Parent --
   ---------------------

   function Map_From_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      mapFromParent_2_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Path),
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Map_From_Parent;

   ---------------------
   -- Map_From_Parent --
   ---------------------

   function Map_From_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapFromParent_1_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_From_Parent;

   ---------------------
   -- Map_From_Parent --
   ---------------------

   function Map_From_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapFromParent_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_From_Parent;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapFromScene_5_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Point),
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_From_Scene;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapFromScene_4_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_From_Scene;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     Polygon : Qt4.Polygon_Fs.Q_Polygon_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapFromScene_3_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Polygon),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_From_Scene;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      mapFromScene_2_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Path),
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Map_From_Scene;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapFromScene_1_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_From_Scene;

   --------------------
   -- Map_From_Scene --
   --------------------

   function Map_From_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapFromScene_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_From_Scene;

   ------------------------
   -- Map_Rect_From_Item --
   ------------------------

   function Map_Rect_From_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectFromItem_1_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_From_Item;

   ------------------------
   -- Map_Rect_From_Item --
   ------------------------

   function Map_Rect_From_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectFromItem_0_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_From_Item;

   --------------------------
   -- Map_Rect_From_Parent --
   --------------------------

   function Map_Rect_From_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectFromParent_1_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_From_Parent;

   --------------------------
   -- Map_Rect_From_Parent --
   --------------------------

   function Map_Rect_From_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectFromParent_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_From_Parent;

   -------------------------
   -- Map_Rect_From_Scene --
   -------------------------

   function Map_Rect_From_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectFromScene_1_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_From_Scene;

   -------------------------
   -- Map_Rect_From_Scene --
   -------------------------

   function Map_Rect_From_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectFromScene_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_From_Scene;

   ----------------------
   -- Map_Rect_To_Item --
   ----------------------

   function Map_Rect_To_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectToItem_1_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_To_Item;

   ----------------------
   -- Map_Rect_To_Item --
   ----------------------

   function Map_Rect_To_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectToItem_0_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_To_Item;

   ------------------------
   -- Map_Rect_To_Parent --
   ------------------------

   function Map_Rect_To_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectToParent_1_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_To_Parent;

   ------------------------
   -- Map_Rect_To_Parent --
   ------------------------

   function Map_Rect_To_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectToParent_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_To_Parent;

   -----------------------
   -- Map_Rect_To_Scene --
   -----------------------

   function Map_Rect_To_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectToScene_1_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_To_Scene;

   -----------------------
   -- Map_Rect_To_Scene --
   -----------------------

   function Map_Rect_To_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      mapRectToScene_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Map_Rect_To_Scene;

   -----------------
   -- Map_To_Item --
   -----------------

   function Map_To_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapToItem_5_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Point),
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_To_Item;

   -----------------
   -- Map_To_Item --
   -----------------

   function Map_To_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToItem_4_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Item;

   -----------------
   -- Map_To_Item --
   -----------------

   function Map_To_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Polygon : Qt4.Polygon_Fs.Q_Polygon_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToItem_3_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Polygon),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Item;

   -----------------
   -- Map_To_Item --
   -----------------

   function Map_To_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      mapToItem_2_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Path),
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Map_To_Item;

   -----------------
   -- Map_To_Item --
   -----------------

   function Map_To_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToItem_1_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Item;

   -----------------
   -- Map_To_Item --
   -----------------

   function Map_To_Item
    (Self : not null access constant Q_Graphics_Item'Class;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapToItem_0_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View,
        X,
        Y,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_To_Item;

   -------------------
   -- Map_To_Parent --
   -------------------

   function Map_To_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapToParent_5_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Point),
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_To_Parent;

   -------------------
   -- Map_To_Parent --
   -------------------

   function Map_To_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToParent_4_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Parent;

   -------------------
   -- Map_To_Parent --
   -------------------

   function Map_To_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     Polygon : Qt4.Polygon_Fs.Q_Polygon_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToParent_3_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Polygon),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Parent;

   -------------------
   -- Map_To_Parent --
   -------------------

   function Map_To_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      mapToParent_2_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Path),
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Map_To_Parent;

   -------------------
   -- Map_To_Parent --
   -------------------

   function Map_To_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToParent_1_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Parent;

   -------------------
   -- Map_To_Parent --
   -------------------

   function Map_To_Parent
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapToParent_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_To_Parent;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapToScene_5_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Point),
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToScene_4_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     Polygon : Qt4.Polygon_Fs.Q_Polygon_F)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToScene_3_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Polygon),
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      mapToScene_2_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Path),
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      mapToScene_1_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        W,
        H,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------------
   -- Map_To_Scene --
   ------------------

   function Map_To_Scene
    (Self : not null access constant Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      mapToScene_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Map_To_Scene;

   ------------
   -- Matrix --
   ------------

   function Matrix
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Matrices.Q_Matrix
   is
      Returns : Qt4.Matrices.Q_Matrix;

   begin
      matrix_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Matrices.Internals.QMatrix_View (Returns));

      return Returns;
   end Matrix;

   -------------
   -- Move_By --
   -------------

   procedure Move_By
    (Self : not null access Q_Graphics_Item'Class;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real)
   is
   begin
      moveBy_0_wrapper
       (Self.QGraphicsItem_View,
        Dx,
        Dy);
   end Move_By;

   -------------
   -- Opacity --
   -------------

   function Opacity
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Q_Real
   is
   begin
      return
        opacity_0_wrapper
         (Self.QGraphicsItem_View);
   end Opacity;

   -----------
   -- Panel --
   -----------

   function Panel
    (Self : not null access constant Q_Graphics_Item'Class)
       return access Qt4.Graphics_Items.Q_Graphics_Item'Class
   is
   begin
      return
        Qt_Ada.Internals.Graphics_Items.Graphics_Item_Utilities.Corresponding_Q_Graphics_Item
         (panel_0_wrapper
           (Self.QGraphicsItem_View));
   end Panel;

   --------------------
   -- Panel_Modality --
   --------------------

   function Panel_Modality
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Graphics_Items.Graphics_Item_Panel_Modality
   is
   begin
      return
        panelModality_0_wrapper
         (Self.QGraphicsItem_View);
   end Panel_Modality;

   -------------------
   -- Parent_Object --
   -------------------

   function Parent_Object
    (Self : not null access constant Q_Graphics_Item'Class)
       return not null access Qt4.Graphics_Objects.Q_Graphics_Object'Class
   is
   begin
      return
        Qt4.Graphics_Objects.Q_Graphics_Object'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (parentObject_0_wrapper
             (Self.QGraphicsItem_View)).all)'Access;
   end Parent_Object;

   -----------------
   -- Parent_Item --
   -----------------

   function Parent_Item
    (Self : not null access constant Q_Graphics_Item'Class)
       return not null access Qt4.Graphics_Items.Q_Graphics_Item'Class
   is
   begin
      return
        Qt4.Graphics_Items.Q_Graphics_Item'Class
         (Qt_Ada.Internals.Graphics_Item_Registry.To_Q_Graphics_Item
           (parentItem_0_wrapper
             (Self.QGraphicsItem_View)).all)'Access;
   end Parent_Item;

   ---------
   -- Pos --
   ---------

   function Pos
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      pos_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Pos;

   -------------------------------
   -- Remove_Scene_Event_Filter --
   -------------------------------

   procedure Remove_Scene_Event_Filter
    (Self : not null access Q_Graphics_Item'Class;
     Filter_Item : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class)
   is
   begin
      removeSceneEventFilter_0_wrapper
       (Self.QGraphicsItem_View,
        Filter_Item.QGraphicsItem_View);
   end Remove_Scene_Event_Filter;

   ------------------
   -- Reset_Matrix --
   ------------------

   procedure Reset_Matrix
    (Self : not null access Q_Graphics_Item'Class)
   is
   begin
      resetMatrix_0_wrapper
       (Self.QGraphicsItem_View);
   end Reset_Matrix;

   ---------------------
   -- Reset_Transform --
   ---------------------

   procedure Reset_Transform
    (Self : not null access Q_Graphics_Item'Class)
   is
   begin
      resetTransform_0_wrapper
       (Self.QGraphicsItem_View);
   end Reset_Transform;

   ------------
   -- Rotate --
   ------------

   procedure Rotate
    (Self : not null access Q_Graphics_Item'Class;
     Angle : Qt4.Q_Real)
   is
   begin
      rotate_0_wrapper
       (Self.QGraphicsItem_View,
        Angle);
   end Rotate;

   --------------
   -- Rotation --
   --------------

   function Rotation
    (Self : not null access Q_Graphics_Item'Class)
       return Qt4.Q_Real
   is
   begin
      return
        rotation_0_wrapper
         (Self.QGraphicsItem_View);
   end Rotation;

   -----------
   -- Scale --
   -----------

   function Scale
    (Self : not null access Q_Graphics_Item'Class)
       return Qt4.Q_Real
   is
   begin
      return
        scale_1_wrapper
         (Self.QGraphicsItem_View);
   end Scale;

   -----------
   -- Scale --
   -----------

   procedure Scale
    (Self : not null access Q_Graphics_Item'Class;
     Sx : Qt4.Q_Real;
     Sy : Qt4.Q_Real)
   is
   begin
      scale_0_wrapper
       (Self.QGraphicsItem_View,
        Sx,
        Sy);
   end Scale;

   -----------
   -- Scene --
   -----------

   function Scene
    (Self : not null access constant Q_Graphics_Item'Class)
       return access Qt4.Graphics_Scenes.Q_Graphics_Scene'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Graphics_Scene_Utilities.Corresponding_Q_Graphics_Scene
         (scene_0_wrapper
           (Self.QGraphicsItem_View));
   end Scene;

   -------------------------
   -- Scene_Bounding_Rect --
   -------------------------

   function Scene_Bounding_Rect
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      sceneBoundingRect_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Scene_Bounding_Rect;

   ------------------
   -- Scene_Matrix --
   ------------------

   function Scene_Matrix
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Matrices.Q_Matrix
   is
      Returns : Qt4.Matrices.Q_Matrix;

   begin
      sceneMatrix_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Matrices.Internals.QMatrix_View (Returns));

      return Returns;
   end Scene_Matrix;

   ---------------
   -- Scene_Pos --
   ---------------

   function Scene_Pos
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      scenePos_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Scene_Pos;

   ---------------------
   -- Scene_Transform --
   ---------------------

   function Scene_Transform
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Transforms.Q_Transform
   is
      Returns : Qt4.Transforms.Q_Transform;

   begin
      sceneTransform_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Transforms.Internals.QTransform_View (Returns));

      return Returns;
   end Scene_Transform;

   ------------
   -- Scroll --
   ------------

   procedure Scroll
    (Self : not null access Q_Graphics_Item'Class;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real;
     Rect : Qt4.Rect_Fs.Q_Rect_F
       := Qt4.Rect_Fs.Create)
   is
   begin
      scroll_0_wrapper
       (Self.QGraphicsItem_View,
        Dx,
        Dy,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect));
   end Scroll;

   ----------------------
   -- Set_Accept_Drops --
   ----------------------

   procedure Set_Accept_Drops
    (Self : not null access Q_Graphics_Item'Class;
     On : Standard.Boolean)
   is
   begin
      setAcceptDrops_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.To_bool (On));
   end Set_Accept_Drops;

   -----------------------------
   -- Set_Accept_Hover_Events --
   -----------------------------

   procedure Set_Accept_Hover_Events
    (Self : not null access Q_Graphics_Item'Class;
     Enabled : Standard.Boolean)
   is
   begin
      setAcceptHoverEvents_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.To_bool (Enabled));
   end Set_Accept_Hover_Events;

   -----------------------------
   -- Set_Accept_Touch_Events --
   -----------------------------

   procedure Set_Accept_Touch_Events
    (Self : not null access Q_Graphics_Item'Class;
     Enabled : Standard.Boolean)
   is
   begin
      setAcceptTouchEvents_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.To_bool (Enabled));
   end Set_Accept_Touch_Events;

   ----------------
   -- Set_Active --
   ----------------

   procedure Set_Active
    (Self : not null access Q_Graphics_Item'Class;
     Active : Standard.Boolean)
   is
   begin
      setActive_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.To_bool (Active));
   end Set_Active;

   -------------------------------------
   -- Set_Bounding_Region_Granularity --
   -------------------------------------

   procedure Set_Bounding_Region_Granularity
    (Self : not null access Q_Graphics_Item'Class;
     Granularity : Qt4.Q_Real)
   is
   begin
      setBoundingRegionGranularity_0_wrapper
       (Self.QGraphicsItem_View,
        Granularity);
   end Set_Bounding_Region_Granularity;

   --------------------
   -- Set_Cache_Mode --
   --------------------

   procedure Set_Cache_Mode
    (Self : not null access Q_Graphics_Item'Class;
     Mode : Qt4.Graphics_Items.Graphics_Item_Cache_Mode;
     Cache_Size : Qt4.Sizes.Q_Size
       := Qt4.Sizes.Create)
   is
   begin
      setCacheMode_0_wrapper
       (Self.QGraphicsItem_View,
        Mode,
        Qt4.Sizes.Internals.QSize_View (Cache_Size));
   end Set_Cache_Mode;

   ----------------
   -- Set_Cursor --
   ----------------

   procedure Set_Cursor
    (Self : not null access Q_Graphics_Item'Class;
     Cursor : Qt4.Cursors.Q_Cursor)
   is
   begin
      setCursor_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Cursors.Internals.QCursor_View (Cursor));
   end Set_Cursor;

   --------------
   -- Set_Data --
   --------------

   procedure Set_Data
    (Self : not null access Q_Graphics_Item'Class;
     Key : Qt4.Q_Integer;
     Value : Qt4.Variants.Q_Variant)
   is
   begin
      setData_0_wrapper
       (Self.QGraphicsItem_View,
        Key,
        Qt4.Variants.Internals.QVariant_View (Value));
   end Set_Data;

   -----------------
   -- Set_Enabled --
   -----------------

   procedure Set_Enabled
    (Self : not null access Q_Graphics_Item'Class;
     Enabled : Standard.Boolean)
   is
   begin
      setEnabled_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.To_bool (Enabled));
   end Set_Enabled;

   ------------------------------
   -- Set_Filters_Child_Events --
   ------------------------------

   procedure Set_Filters_Child_Events
    (Self : not null access Q_Graphics_Item'Class;
     Enabled : Standard.Boolean)
   is
   begin
      setFiltersChildEvents_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.To_bool (Enabled));
   end Set_Filters_Child_Events;

   --------------
   -- Set_Flag --
   --------------

   procedure Set_Flag
    (Self : not null access Q_Graphics_Item'Class;
     Flag : Qt4.Graphics_Items.Graphics_Item_Graphics_Item_Flag;
     Enabled : Standard.Boolean
       := True)
   is
   begin
      setFlag_0_wrapper
       (Self.QGraphicsItem_View,
        Flag,
        Qt4.To_bool (Enabled));
   end Set_Flag;

   ---------------------
   -- Set_Focus_Proxy --
   ---------------------

   procedure Set_Focus_Proxy
    (Self : not null access Q_Graphics_Item'Class;
     Item : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class)
   is
   begin
      setFocusProxy_0_wrapper
       (Self.QGraphicsItem_View,
        Item.QGraphicsItem_View);
   end Set_Focus_Proxy;

   ------------------------------
   -- Set_Handles_Child_Events --
   ------------------------------

   procedure Set_Handles_Child_Events
    (Self : not null access Q_Graphics_Item'Class;
     Enabled : Standard.Boolean)
   is
   begin
      setHandlesChildEvents_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.To_bool (Enabled));
   end Set_Handles_Child_Events;

   ----------------
   -- Set_Matrix --
   ----------------

   procedure Set_Matrix
    (Self : not null access Q_Graphics_Item'Class;
     Matrix : Qt4.Matrices.Q_Matrix;
     Combine : Standard.Boolean
       := False)
   is
   begin
      setMatrix_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Matrices.Internals.QMatrix_View (Matrix),
        Qt4.To_bool (Combine));
   end Set_Matrix;

   -----------------
   -- Set_Opacity --
   -----------------

   procedure Set_Opacity
    (Self : not null access Q_Graphics_Item'Class;
     Opacity : Qt4.Q_Real)
   is
   begin
      setOpacity_0_wrapper
       (Self.QGraphicsItem_View,
        Opacity);
   end Set_Opacity;

   ------------------------
   -- Set_Panel_Modality --
   ------------------------

   procedure Set_Panel_Modality
    (Self : not null access Q_Graphics_Item'Class;
     Panel_Modality : Qt4.Graphics_Items.Graphics_Item_Panel_Modality)
   is
   begin
      setPanelModality_0_wrapper
       (Self.QGraphicsItem_View,
        Panel_Modality);
   end Set_Panel_Modality;

   ---------------------
   -- Set_Parent_Item --
   ---------------------

   procedure Set_Parent_Item
    (Self : not null access Q_Graphics_Item'Class;
     Parent : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class)
   is
   begin
      setParentItem_0_wrapper
       (Self.QGraphicsItem_View,
        Parent.QGraphicsItem_View);
   end Set_Parent_Item;

   -------------
   -- Set_Pos --
   -------------

   procedure Set_Pos
    (Self : not null access Q_Graphics_Item'Class;
     Pos : Qt4.Point_Fs.Q_Point_F)
   is
   begin
      setPos_1_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Pos));
   end Set_Pos;

   -------------
   -- Set_Pos --
   -------------

   procedure Set_Pos
    (Self : not null access Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
   is
   begin
      setPos_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y);
   end Set_Pos;

   ------------------
   -- Set_Rotation --
   ------------------

   procedure Set_Rotation
    (Self : not null access Q_Graphics_Item'Class;
     Angle : Qt4.Q_Real)
   is
   begin
      setRotation_0_wrapper
       (Self.QGraphicsItem_View,
        Angle);
   end Set_Rotation;

   ---------------
   -- Set_Scale --
   ---------------

   procedure Set_Scale
    (Self : not null access Q_Graphics_Item'Class;
     Factor : Qt4.Q_Real)
   is
   begin
      setScale_0_wrapper
       (Self.QGraphicsItem_View,
        Factor);
   end Set_Scale;

   ------------------
   -- Set_Selected --
   ------------------

   procedure Set_Selected
    (Self : not null access Q_Graphics_Item'Class;
     Selected : Standard.Boolean)
   is
   begin
      setSelected_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.To_bool (Selected));
   end Set_Selected;

   ------------------
   -- Set_Tool_Tip --
   ------------------

   procedure Set_Tool_Tip
    (Self : not null access Q_Graphics_Item'Class;
     Tool_Tip : Qt4.Strings.Q_String)
   is
   begin
      setToolTip_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Strings.Internals.QString_View (Tool_Tip));
   end Set_Tool_Tip;

   -------------------
   -- Set_Transform --
   -------------------

   procedure Set_Transform
    (Self : not null access Q_Graphics_Item'Class;
     Matrix : Qt4.Transforms.Q_Transform;
     Combine : Standard.Boolean
       := False)
   is
   begin
      setTransform_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Transforms.Internals.QTransform_View (Matrix),
        Qt4.To_bool (Combine));
   end Set_Transform;

   --------------------------------
   -- Set_Transform_Origin_Point --
   --------------------------------

   procedure Set_Transform_Origin_Point
    (Self : not null access Q_Graphics_Item'Class;
     Origin : Qt4.Point_Fs.Q_Point_F)
   is
   begin
      setTransformOriginPoint_1_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Origin));
   end Set_Transform_Origin_Point;

   --------------------------------
   -- Set_Transform_Origin_Point --
   --------------------------------

   procedure Set_Transform_Origin_Point
    (Self : not null access Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real)
   is
   begin
      setTransformOriginPoint_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y);
   end Set_Transform_Origin_Point;

   -----------------
   -- Set_Visible --
   -----------------

   procedure Set_Visible
    (Self : not null access Q_Graphics_Item'Class;
     Visible : Standard.Boolean)
   is
   begin
      setVisible_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.To_bool (Visible));
   end Set_Visible;

   -----------
   -- Set_X --
   -----------

   procedure Set_X
    (Self : not null access Q_Graphics_Item'Class;
     X : Qt4.Q_Real)
   is
   begin
      setX_0_wrapper
       (Self.QGraphicsItem_View,
        X);
   end Set_X;

   -----------
   -- Set_Y --
   -----------

   procedure Set_Y
    (Self : not null access Q_Graphics_Item'Class;
     Y : Qt4.Q_Real)
   is
   begin
      setY_0_wrapper
       (Self.QGraphicsItem_View,
        Y);
   end Set_Y;

   -----------------
   -- Set_Z_Value --
   -----------------

   procedure Set_Z_Value
    (Self : not null access Q_Graphics_Item'Class;
     Z : Qt4.Q_Real)
   is
   begin
      setZValue_0_wrapper
       (Self.QGraphicsItem_View,
        Z);
   end Set_Z_Value;

   -----------
   -- Shear --
   -----------

   procedure Shear
    (Self : not null access Q_Graphics_Item'Class;
     Sh : Qt4.Q_Real;
     Sv : Qt4.Q_Real)
   is
   begin
      shear_0_wrapper
       (Self.QGraphicsItem_View,
        Sh,
        Sv);
   end Shear;

   ----------
   -- Show --
   ----------

   procedure Show
    (Self : not null access Q_Graphics_Item'Class)
   is
   begin
      show_0_wrapper
       (Self.QGraphicsItem_View);
   end Show;

   ------------------
   -- Stack_Before --
   ------------------

   procedure Stack_Before
    (Self : not null access Q_Graphics_Item'Class;
     Sibling : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class)
   is
   begin
      stackBefore_0_wrapper
       (Self.QGraphicsItem_View,
        Sibling.QGraphicsItem_View);
   end Stack_Before;

   ------------------------
   -- To_Graphics_Object --
   ------------------------

   function To_Graphics_Object
    (Self : not null access Q_Graphics_Item'Class)
       return access Qt4.Graphics_Objects.Q_Graphics_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Graphics_Object_Utilities.Corresponding_Q_Graphics_Object
         (toGraphicsObject_0_wrapper
           (Self.QGraphicsItem_View));
   end To_Graphics_Object;

   --------------
   -- Tool_Tip --
   --------------

   function Tool_Tip
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      toolTip_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Tool_Tip;

   --------------------
   -- Top_Level_Item --
   --------------------

   function Top_Level_Item
    (Self : not null access constant Q_Graphics_Item'Class)
       return not null access Qt4.Graphics_Items.Q_Graphics_Item'Class
   is
   begin
      return
        Qt4.Graphics_Items.Q_Graphics_Item'Class
         (Qt_Ada.Internals.Graphics_Item_Registry.To_Q_Graphics_Item
           (topLevelItem_0_wrapper
             (Self.QGraphicsItem_View)).all)'Access;
   end Top_Level_Item;

   ---------------
   -- Transform --
   ---------------

   function Transform
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Transforms.Q_Transform
   is
      Returns : Qt4.Transforms.Q_Transform;

   begin
      transform_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Transforms.Internals.QTransform_View (Returns));

      return Returns;
   end Transform;

   ----------------------------
   -- Transform_Origin_Point --
   ----------------------------

   function Transform_Origin_Point
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      transformOriginPoint_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Transform_Origin_Point;

   ---------------
   -- Translate --
   ---------------

   procedure Translate
    (Self : not null access Q_Graphics_Item'Class;
     Dx : Qt4.Q_Real;
     Dy : Qt4.Q_Real)
   is
   begin
      translate_0_wrapper
       (Self.QGraphicsItem_View,
        Dx,
        Dy);
   end Translate;

   ---------------------
   -- Ungrab_Keyboard --
   ---------------------

   procedure Ungrab_Keyboard
    (Self : not null access Q_Graphics_Item'Class)
   is
   begin
      ungrabKeyboard_0_wrapper
       (Self.QGraphicsItem_View);
   end Ungrab_Keyboard;

   ------------------
   -- Ungrab_Mouse --
   ------------------

   procedure Ungrab_Mouse
    (Self : not null access Q_Graphics_Item'Class)
   is
   begin
      ungrabMouse_0_wrapper
       (Self.QGraphicsItem_View);
   end Ungrab_Mouse;

   ------------------
   -- Unset_Cursor --
   ------------------

   procedure Unset_Cursor
    (Self : not null access Q_Graphics_Item'Class)
   is
   begin
      unsetCursor_0_wrapper
       (Self.QGraphicsItem_View);
   end Unset_Cursor;

   ------------
   -- Update --
   ------------

   procedure Update
    (Self : not null access Q_Graphics_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F
       := Qt4.Rect_Fs.Create)
   is
   begin
      update_1_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect));
   end Update;

   ------------
   -- Update --
   ------------

   procedure Update
    (Self : not null access Q_Graphics_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     Width : Qt4.Q_Real;
     Height : Qt4.Q_Real)
   is
   begin
      update_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        Width,
        Height);
   end Update;

   -------
   -- X --
   -------

   function X
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Q_Real
   is
   begin
      return
        x_0_wrapper
         (Self.QGraphicsItem_View);
   end X;

   -------
   -- Y --
   -------

   function Y
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Q_Real
   is
   begin
      return
        y_0_wrapper
         (Self.QGraphicsItem_View);
   end Y;

   -------------
   -- Z_Value --
   -------------

   function Z_Value
    (Self : not null access constant Q_Graphics_Item'Class)
       return Qt4.Q_Real
   is
   begin
      return
        zValue_0_wrapper
         (Self.QGraphicsItem_View);
   end Z_Value;

end Qt4.Graphics_Items;
