------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Graphics_Items;
with Qt4.Objects;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Graphics_Objects is

   type Q_Graphics_Object is limited interface
     and Qt4.Objects.Q_Object
     and Qt4.Graphics_Items.Q_Graphics_Item;

   type Q_Graphics_Object_Access is
     access all Q_Graphics_Object'Class;
   for Q_Graphics_Object_Access'Storage_Size use 0;

   type Q_Graphics_Object_Pointer is tagged;

   package Q_Graphics_Object_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Graphics_Object, Q_Graphics_Object_Access);

   type Q_Graphics_Object_Pointer is
     new Q_Graphics_Object_Pointers.Q_Pointer with null record;

private

   procedure Dummy;

end Qt4.Graphics_Objects;
