------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009, 2010 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Graphics_Items;

with Qt_Ada.Internals.Graphics_Items.Graphics_Path_Item_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Graphics_Items.Graphics_Path_Item_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Graphics_Path_Items is

   procedure path_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, path_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_path_0_wrapper");

   procedure setPath_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Path : not null access constant Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, setPath_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_setPath_0_wrapper");

   pragma Style_Checks ("N");

   ----------
   -- Path --
   ----------

   function Path
    (Self : not null access constant Q_Graphics_Path_Item'Class)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      path_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Path;

   --------------
   -- Set_Path --
   --------------

   procedure Set_Path
    (Self : not null access Q_Graphics_Path_Item'Class;
     Path : Qt4.Painter_Paths.Q_Painter_Path)
   is
   begin
      setPath_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Path));
   end Set_Path;

end Qt4.Graphics_Path_Items;
