------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Delegates.Directors;
limited with Qt4.Abstract_Item_Models;
limited with Qt4.Child_Events;
limited with Qt4.Events;
with Qt4.Meta_Objects;
with Qt4.Model_Indices;
limited with Qt4.Objects;
with Qt4.Painters;
with Qt4.Sizes;
with Qt4.Style_Option_View_Items;
limited with Qt4.Timer_Events;
limited with Qt4.Widgets;

package Qt4.Item_Delegates.Directors is

   type Q_Item_Delegate_Director is
     new Qt4.Abstract_Item_Delegates.Directors.Q_Abstract_Item_Delegate_Director
       and Q_Item_Delegate with null record;

   overriding
   function Create_Editor
    (Self : not null access constant Q_Item_Delegate_Director;
     Parent : not null access Qt4.Widgets.Q_Widget'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return not null access Qt4.Widgets.Q_Widget'Class;

   overriding
   procedure Set_Editor_Data
    (Self : not null access constant Q_Item_Delegate_Director;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Index : Qt4.Model_Indices.Q_Model_Index);

   overriding
   procedure Set_Model_Data
    (Self : not null access constant Q_Item_Delegate_Director;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Model : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;
     Index : Qt4.Model_Indices.Q_Model_Index);

   overriding
   function Size_Hint
    (Self : not null access constant Q_Item_Delegate_Director;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Sizes.Q_Size;

   overriding
   procedure Update_Editor_Geometry
    (Self : not null access constant Q_Item_Delegate_Director;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index);

   overriding
   procedure Emit_Commit_Data
    (Self : not null access Q_Item_Delegate_Director;
     Editor : not null access Qt4.Widgets.Q_Widget'Class);

   overriding
   procedure Child_Event
    (Self : not null access Q_Item_Delegate_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Item_Delegate_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_Item_Delegate_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Item_Delegate_Director)
       return access Qt4.Objects.Q_Object'Class;

   overriding
   procedure Paint
    (Self    : not null access Q_Item_Delegate_Director;
     Painter : Qt4.Painters.Q_Painter;
     Option  : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item;
     Index   : Qt4.Model_Indices.Q_Model_Index);

   package Constructors is

      procedure Initialize
       (Self   : not null access Q_Item_Delegate_Director'Class;
        Parent : access Qt4.Objects.Q_Object'Class := null);

   end Constructors;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QItemDelegate_staticMetaObject");

end Qt4.Item_Delegates.Directors;
