------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Child_Events;
limited with Qt4.Events;
with Qt4.Layout_Items.Impl;
with Qt4.Meta_Objects;
with Qt4.Objects.Directors;
with Qt4.Sizes;
limited with Qt4.Timer_Events;

package Qt4.Layouts.Directors is

   type Q_Layout_Director is
     abstract new Qt4.Objects.Directors.Q_Object_Director
       and Q_Layout
       and Qt4.Layout_Items.Impl.Q_Layout_Item_Impl_Base with null record;

   overriding
   procedure Add_Item
    (Self : not null access Q_Layout_Director;
     Item : not null access Qt4.Layout_Items.Q_Layout_Item'Class)
       is abstract;

   overriding
   function Count
    (Self : not null access constant Q_Layout_Director)
       return Qt4.Q_Integer
         is abstract;

   overriding
   function Index_Of
    (Self : not null access constant Q_Layout_Director;
     Widget : not null access Qt4.Widgets.Q_Widget'Class)
       return Qt4.Q_Integer;

   overriding
   function Is_Empty
    (Self : not null access constant Q_Layout_Director)
       return Standard.Boolean;

   overriding
   function Minimum_Size
    (Self : not null access constant Q_Layout_Director)
       return Qt4.Sizes.Q_Size;

   overriding
   function Maximum_Size
    (Self : not null access constant Q_Layout_Director)
       return Qt4.Sizes.Q_Size;

   overriding
   procedure Child_Event
    (Self : not null access Q_Layout_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Layout_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_Layout_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Layout_Director)
       return access Qt4.Objects.Q_Object'Class;

   overriding
   function Has_Height_For_Width
    (Self : not null access constant Q_Layout_Director)
       return Standard.Boolean;

   overriding
   function Height_For_Width
    (Self : not null access constant Q_Layout_Director;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   overriding
   procedure Invalidate
    (Self : not null access Q_Layout_Director);

   overriding
   function Layout
    (Self : not null access Q_Layout_Director)
       return not null access Qt4.Layouts.Q_Layout'Class;

   overriding
   function Minimum_Height_For_Width
    (Self : not null access constant Q_Layout_Director;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   overriding
   function Size_Hint
    (Self : not null access constant Q_Layout_Director)
       return Qt4.Sizes.Q_Size
         is abstract;

   overriding
   function Widget
    (Self : not null access Q_Layout_Director)
       return not null access Qt4.Widgets.Q_Widget'Class;

   overriding
   function Expanding_Directions
    (Self : not null access constant Q_Layout_Director)
       return Qt4.Orientations;

   overriding
   function QLayoutItem_View
    (Self : not null access constant Q_Layout_Director)
       return not null access Qt4.Layout_Items.Impl.Thin.QLayoutItem;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QLayout_staticMetaObject");

end Qt4.Layouts.Directors;
