------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Menus;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Mdi_Sub_Windows is

   type Q_Mdi_Sub_Window is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Mdi_Sub_Window_Access is
     access all Q_Mdi_Sub_Window'Class;
   for Q_Mdi_Sub_Window_Access'Storage_Size use 0;

   type Q_Mdi_Sub_Window_Pointer is tagged;

   function Is_Shaded
    (Self : not null access constant Q_Mdi_Sub_Window'Class)
       return Standard.Boolean;

   function Keyboard_Page_Step
    (Self : not null access constant Q_Mdi_Sub_Window'Class)
       return Qt4.Q_Integer;

   function Keyboard_Single_Step
    (Self : not null access constant Q_Mdi_Sub_Window'Class)
       return Qt4.Q_Integer;

   procedure Set_Keyboard_Page_Step
    (Self : not null access Q_Mdi_Sub_Window'Class;
     Step : Qt4.Q_Integer);

   procedure Set_Keyboard_Single_Step
    (Self : not null access Q_Mdi_Sub_Window'Class;
     Step : Qt4.Q_Integer);

   procedure Set_System_Menu
    (Self : not null access Q_Mdi_Sub_Window'Class;
     System_Menu : not null access Qt4.Menus.Q_Menu'Class);

   procedure Set_Widget
    (Self : not null access Q_Mdi_Sub_Window'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   function System_Menu
    (Self : not null access constant Q_Mdi_Sub_Window'Class)
       return not null access Qt4.Menus.Q_Menu'Class;

   function Widget
    (Self : not null access constant Q_Mdi_Sub_Window'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   procedure Show_Shaded
    (Self : not null access Q_Mdi_Sub_Window'Class);

   procedure Show_System_Menu
    (Self : not null access Q_Mdi_Sub_Window'Class);

   package Q_Mdi_Sub_Window_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Mdi_Sub_Window, Q_Mdi_Sub_Window_Access);

   type Q_Mdi_Sub_Window_Pointer is
     new Q_Mdi_Sub_Window_Pointers.Q_Pointer with null record;

end Qt4.Mdi_Sub_Windows;
