------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Text_Document_Layouts;
with Qt4.Text_Blocks;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Plain_Text_Document_Layouts is

   type Q_Plain_Text_Document_Layout is limited interface
     and Qt4.Abstract_Text_Document_Layouts.Q_Abstract_Text_Document_Layout;

   type Q_Plain_Text_Document_Layout_Access is
     access all Q_Plain_Text_Document_Layout'Class;
   for Q_Plain_Text_Document_Layout_Access'Storage_Size use 0;

   type Q_Plain_Text_Document_Layout_Pointer is tagged;

   function Cursor_Width
    (Self : not null access constant Q_Plain_Text_Document_Layout'Class)
       return Qt4.Q_Integer;

   procedure Ensure_Block_Layout
    (Self : not null access constant Q_Plain_Text_Document_Layout'Class;
     Block : Qt4.Text_Blocks.Q_Text_Block);

   procedure Request_Update
    (Self : not null access Q_Plain_Text_Document_Layout'Class);

   procedure Set_Cursor_Width
    (Self : not null access Q_Plain_Text_Document_Layout'Class;
     Width : Qt4.Q_Integer);

   package Q_Plain_Text_Document_Layout_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Plain_Text_Document_Layout, Q_Plain_Text_Document_Layout_Access);

   type Q_Plain_Text_Document_Layout_Pointer is
     new Q_Plain_Text_Document_Layout_Pointers.Q_Pointer with null record;

end Qt4.Plain_Text_Document_Layouts;
