------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Action_Events;
with Qt4.Child_Events;
with Qt4.Close_Events;
with Qt4.Context_Menu_Events;
with Qt4.Drag_Enter_Events;
with Qt4.Drag_Leave_Events;
with Qt4.Drag_Move_Events;
with Qt4.Drop_Events;
with Qt4.Events;
with Qt4.Focus_Events;
with Qt4.Hide_Events;
with Qt4.Input_Method_Events;
with Qt4.Key_Events;
with Qt4.Mouse_Events;
with Qt4.Move_Events;
with Qt4.Paint_Events;
with Qt4.Resize_Events;
with Qt4.Show_Events;
with Qt4.Tablet_Events;
with Qt4.Timer_Events;
with Qt4.Wheel_Events;
with Qt4.Widgets;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Plain_Text_Edits.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QPlainTextEdit_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QPlainTextEdit_qt_metacast_wrapper");

   procedure blockCountChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     New_Block_Count : Qt4.Q_Integer);
   pragma Import (C, blockCountChanged_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_blockCountChanged_0_wrapper");

   procedure copyAvailable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     B : Qt4.bool);
   pragma Import (C, copyAvailable_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_copyAvailable_0_wrapper");

   procedure cursorPositionChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, cursorPositionChanged_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_cursorPositionChanged_0_wrapper");

   procedure modificationChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     B : Qt4.bool);
   pragma Import (C, modificationChanged_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_modificationChanged_0_wrapper");

   procedure redoAvailable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     B : Qt4.bool);
   pragma Import (C, redoAvailable_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_redoAvailable_0_wrapper");

   procedure selectionChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, selectionChanged_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_selectionChanged_0_wrapper");

   procedure textChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, textChanged_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_textChanged_0_wrapper");

   procedure undoAvailable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     B : Qt4.bool);
   pragma Import (C, undoAvailable_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_undoAvailable_0_wrapper");

   procedure updateRequest_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Rect : not null access constant Qt4.Rects.Internals.QRect;
     Dy : Qt4.Q_Integer);
   pragma Import (C, updateRequest_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_updateRequest_0_wrapper");

   procedure firstVisibleBlock_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : out Qt4.Text_Blocks.Thin.QTextBlock);
   pragma Import (C, firstVisibleBlock_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_firstVisibleBlock_0_wrapper");

   procedure contentOffset_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Point_Fs.Internals.QPointF);
   pragma Import (C, contentOffset_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_contentOffset_0_wrapper");

   procedure blockBoundingRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Block : not null access constant Qt4.Text_Blocks.Thin.QTextBlock;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, blockBoundingRect_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_blockBoundingRect_0_wrapper");

   procedure blockBoundingGeometry_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Block : not null access constant Qt4.Text_Blocks.Thin.QTextBlock;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, blockBoundingGeometry_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_blockBoundingGeometry_0_wrapper");

   function event_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     E : not null access Qt_Ada.Internals.Events.QEvent)
       return Qt4.bool;
   pragma Import (C, event_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_event_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_timerEvent_0_wrapper");

   procedure keyPressEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, keyPressEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_keyPressEvent_0_wrapper");

   procedure keyReleaseEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, keyReleaseEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_keyReleaseEvent_0_wrapper");

   procedure resizeEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, resizeEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_resizeEvent_0_wrapper");

   procedure paintEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, paintEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_paintEvent_0_wrapper");

   procedure mouseDoubleClickEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseDoubleClickEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_mouseDoubleClickEvent_0_wrapper");

   procedure mouseMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseMoveEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_mouseMoveEvent_0_wrapper");

   procedure mousePressEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mousePressEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_mousePressEvent_0_wrapper");

   procedure mouseReleaseEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseReleaseEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_mouseReleaseEvent_0_wrapper");

   function focusNextPrevChild_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Next : Qt4.bool)
       return Qt4.bool;
   pragma Import (C, focusNextPrevChild_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_focusNextPrevChild_0_wrapper");

   procedure contextMenuEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, contextMenuEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_contextMenuEvent_0_wrapper");

   procedure dragEnterEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragEnterEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_dragEnterEvent_0_wrapper");

   procedure dragLeaveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragLeaveEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_dragLeaveEvent_0_wrapper");

   procedure dragMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragMoveEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_dragMoveEvent_0_wrapper");

   procedure dropEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dropEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_dropEvent_0_wrapper");

   procedure focusInEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, focusInEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_focusInEvent_0_wrapper");

   procedure focusOutEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, focusOutEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_focusOutEvent_0_wrapper");

   procedure showEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, showEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_showEvent_0_wrapper");

   procedure changeEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, changeEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_changeEvent_0_wrapper");

   procedure wheelEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, wheelEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_wheelEvent_0_wrapper");

   procedure inputMethodEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, inputMethodEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_inputMethodEvent_0_wrapper");

   procedure inputMethodQuery_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Query : Qt4.Input_Method_Query;
     Returns : not null access Qt4.Variants.Internals.QVariant);
   pragma Import (C, inputMethodQuery_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_inputMethodQuery_0_wrapper");

   procedure scrollContentsBy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Dx : Qt4.Q_Integer;
     Dy : Qt4.Q_Integer);
   pragma Import (C, scrollContentsBy_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_scrollContentsBy_0_wrapper");

   procedure setupViewport_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Viewport : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setupViewport_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setupViewport_0_wrapper");

   procedure setViewportMargins_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Left : Qt4.Q_Integer;
     Top : Qt4.Q_Integer;
     Right : Qt4.Q_Integer;
     Bottom : Qt4.Q_Integer);
   pragma Import (C, setViewportMargins_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_setViewportMargins_0_wrapper");

   function viewportEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
       return Qt4.bool;
   pragma Import (C, viewportEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_viewportEvent_0_wrapper");

   procedure customContextMenuRequested_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint);
   pragma Import (C, customContextMenuRequested_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_customContextMenuRequested_0_wrapper");

   procedure actionEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, actionEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_actionEvent_0_wrapper");

   procedure closeEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, closeEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_closeEvent_0_wrapper");

   procedure enterEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, enterEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_enterEvent_0_wrapper");

   function focusNextChild_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, focusNextChild_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_focusNextChild_0_wrapper");

   function focusPreviousChild_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, focusPreviousChild_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_focusPreviousChild_0_wrapper");

   procedure hideEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, hideEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_hideEvent_0_wrapper");

   procedure leaveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, leaveEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_leaveEvent_0_wrapper");

   procedure moveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, moveEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_moveEvent_0_wrapper");

   procedure resetInputContext_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, resetInputContext_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_resetInputContext_0_wrapper");

   procedure tabletEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, tabletEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_tabletEvent_0_wrapper");

   function metric_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Metric : Qt4.Paint_Devices.Paint_Device_Metric)
       return Qt4.Q_Integer;
   pragma Import (C, metric_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_metric_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_customEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QPlainTextEdit_sender_0_wrapper");

   pragma Style_Checks ("N");

   ------------------------------
   -- Emit_Block_Count_Changed --
   ------------------------------

   not overriding
   procedure Emit_Block_Count_Changed
    (Self : not null access Q_Plain_Text_Edit_Director;
     New_Block_Count : Qt4.Q_Integer)
   is
   begin
      blockCountChanged_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        New_Block_Count);
   end Emit_Block_Count_Changed;

   -------------------------
   -- Emit_Copy_Available --
   -------------------------

   not overriding
   procedure Emit_Copy_Available
    (Self : not null access Q_Plain_Text_Edit_Director;
     B : Standard.Boolean)
   is
   begin
      copyAvailable_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Qt4.To_bool (B));
   end Emit_Copy_Available;

   ----------------------------------
   -- Emit_Cursor_Position_Changed --
   ----------------------------------

   not overriding
   procedure Emit_Cursor_Position_Changed
    (Self : not null access Q_Plain_Text_Edit_Director)
   is
   begin
      cursorPositionChanged_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View);
   end Emit_Cursor_Position_Changed;

   -------------------------------
   -- Emit_Modification_Changed --
   -------------------------------

   not overriding
   procedure Emit_Modification_Changed
    (Self : not null access Q_Plain_Text_Edit_Director;
     B : Standard.Boolean)
   is
   begin
      modificationChanged_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Qt4.To_bool (B));
   end Emit_Modification_Changed;

   -------------------------
   -- Emit_Redo_Available --
   -------------------------

   not overriding
   procedure Emit_Redo_Available
    (Self : not null access Q_Plain_Text_Edit_Director;
     B : Standard.Boolean)
   is
   begin
      redoAvailable_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Qt4.To_bool (B));
   end Emit_Redo_Available;

   ----------------------------
   -- Emit_Selection_Changed --
   ----------------------------

   not overriding
   procedure Emit_Selection_Changed
    (Self : not null access Q_Plain_Text_Edit_Director)
   is
   begin
      selectionChanged_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View);
   end Emit_Selection_Changed;

   -----------------------
   -- Emit_Text_Changed --
   -----------------------

   not overriding
   procedure Emit_Text_Changed
    (Self : not null access Q_Plain_Text_Edit_Director)
   is
   begin
      textChanged_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View);
   end Emit_Text_Changed;

   -------------------------
   -- Emit_Undo_Available --
   -------------------------

   not overriding
   procedure Emit_Undo_Available
    (Self : not null access Q_Plain_Text_Edit_Director;
     B : Standard.Boolean)
   is
   begin
      undoAvailable_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Qt4.To_bool (B));
   end Emit_Undo_Available;

   -------------------------
   -- Emit_Update_Request --
   -------------------------

   not overriding
   procedure Emit_Update_Request
    (Self : not null access Q_Plain_Text_Edit_Director;
     Rect : Qt4.Rects.Q_Rect;
     Dy : Qt4.Q_Integer)
   is
   begin
      updateRequest_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Qt4.Rects.Internals.QRect_View (Rect),
        Dy);
   end Emit_Update_Request;

   -------------------------
   -- First_Visible_Block --
   -------------------------

   not overriding
   function First_Visible_Block
    (Self : not null access constant Q_Plain_Text_Edit_Director)
       return Qt4.Text_Blocks.Q_Text_Block
   is
      Returns : Qt4.Text_Blocks.Q_Text_Block;

   begin
      firstVisibleBlock_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Qt4.Text_Blocks.Internals.QTextBlock_View (Returns).all);

      return Returns;
   end First_Visible_Block;

   --------------------
   -- Content_Offset --
   --------------------

   not overriding
   function Content_Offset
    (Self : not null access constant Q_Plain_Text_Edit_Director)
       return Qt4.Point_Fs.Q_Point_F
   is
      Returns : Qt4.Point_Fs.Q_Point_F;

   begin
      contentOffset_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Qt4.Point_Fs.Internals.QPointF_View (Returns));

      return Returns;
   end Content_Offset;

   -------------------------
   -- Block_Bounding_Rect --
   -------------------------

   not overriding
   function Block_Bounding_Rect
    (Self : not null access constant Q_Plain_Text_Edit_Director;
     Block : Qt4.Text_Blocks.Q_Text_Block)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      blockBoundingRect_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Qt4.Text_Blocks.Internals.QTextBlock_View (Block),
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Block_Bounding_Rect;

   -----------------------------
   -- Block_Bounding_Geometry --
   -----------------------------

   not overriding
   function Block_Bounding_Geometry
    (Self : not null access constant Q_Plain_Text_Edit_Director;
     Block : Qt4.Text_Blocks.Q_Text_Block)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      blockBoundingGeometry_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Qt4.Text_Blocks.Internals.QTextBlock_View (Block),
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Block_Bounding_Geometry;

   -----------
   -- Event --
   -----------

   overriding
   function Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     E : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (event_0_wrapper
           (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
            E.QEvent_View));
   end Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ---------------------
   -- Key_Press_Event --
   ---------------------

   overriding
   procedure Key_Press_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class)
   is
   begin
      keyPressEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Key_Press_Event;

   -----------------------
   -- Key_Release_Event --
   -----------------------

   overriding
   procedure Key_Release_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class)
   is
   begin
      keyReleaseEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Key_Release_Event;

   ------------------
   -- Resize_Event --
   ------------------

   overriding
   procedure Resize_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Resize_Events.Q_Resize_Event'Class)
   is
   begin
      resizeEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Resize_Event;

   -----------------
   -- Paint_Event --
   -----------------

   overriding
   procedure Paint_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Paint_Events.Q_Paint_Event'Class)
   is
   begin
      paintEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Paint_Event;

   ------------------------------
   -- Mouse_Double_Click_Event --
   ------------------------------

   overriding
   procedure Mouse_Double_Click_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class)
   is
   begin
      mouseDoubleClickEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Double_Click_Event;

   ----------------------
   -- Mouse_Move_Event --
   ----------------------

   overriding
   procedure Mouse_Move_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class)
   is
   begin
      mouseMoveEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Move_Event;

   -----------------------
   -- Mouse_Press_Event --
   -----------------------

   overriding
   procedure Mouse_Press_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class)
   is
   begin
      mousePressEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Press_Event;

   -------------------------
   -- Mouse_Release_Event --
   -------------------------

   overriding
   procedure Mouse_Release_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class)
   is
   begin
      mouseReleaseEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Release_Event;

   ---------------------------
   -- Focus_Next_Prev_Child --
   ---------------------------

   overriding
   function Focus_Next_Prev_Child
    (Self : not null access Q_Plain_Text_Edit_Director;
     Next : Standard.Boolean)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (focusNextPrevChild_0_wrapper
           (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
            Qt4.To_bool (Next)));
   end Focus_Next_Prev_Child;

   ------------------------
   -- Context_Menu_Event --
   ------------------------

   overriding
   procedure Context_Menu_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Context_Menu_Events.Q_Context_Menu_Event'Class)
   is
   begin
      contextMenuEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Context_Menu_Event;

   ----------------------
   -- Drag_Enter_Event --
   ----------------------

   overriding
   procedure Drag_Enter_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Drag_Enter_Events.Q_Drag_Enter_Event'Class)
   is
   begin
      dragEnterEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drag_Enter_Event;

   ----------------------
   -- Drag_Leave_Event --
   ----------------------

   overriding
   procedure Drag_Leave_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Drag_Leave_Events.Q_Drag_Leave_Event'Class)
   is
   begin
      dragLeaveEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drag_Leave_Event;

   ---------------------
   -- Drag_Move_Event --
   ---------------------

   overriding
   procedure Drag_Move_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Drag_Move_Events.Q_Drag_Move_Event'Class)
   is
   begin
      dragMoveEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drag_Move_Event;

   ----------------
   -- Drop_Event --
   ----------------

   overriding
   procedure Drop_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Drop_Events.Q_Drop_Event'Class)
   is
   begin
      dropEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drop_Event;

   --------------------
   -- Focus_In_Event --
   --------------------

   overriding
   procedure Focus_In_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class)
   is
   begin
      focusInEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Focus_In_Event;

   ---------------------
   -- Focus_Out_Event --
   ---------------------

   overriding
   procedure Focus_Out_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class)
   is
   begin
      focusOutEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Focus_Out_Event;

   ----------------
   -- Show_Event --
   ----------------

   overriding
   procedure Show_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Show_Events.Q_Show_Event'Class)
   is
   begin
      showEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Show_Event;

   ------------------
   -- Change_Event --
   ------------------

   overriding
   procedure Change_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      changeEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Change_Event;

   -----------------
   -- Wheel_Event --
   -----------------

   overriding
   procedure Wheel_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Wheel_Events.Q_Wheel_Event'Class)
   is
   begin
      wheelEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Wheel_Event;

   ------------------------
   -- Input_Method_Event --
   ------------------------

   overriding
   procedure Input_Method_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Input_Method_Events.Q_Input_Method_Event'Class)
   is
   begin
      inputMethodEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Input_Method_Event;

   ------------------------
   -- Input_Method_Query --
   ------------------------

   overriding
   function Input_Method_Query
    (Self : not null access constant Q_Plain_Text_Edit_Director;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      inputMethodQuery_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Query,
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Input_Method_Query;

   ------------------------
   -- Scroll_Contents_By --
   ------------------------

   overriding
   procedure Scroll_Contents_By
    (Self : not null access Q_Plain_Text_Edit_Director;
     Dx : Qt4.Q_Integer;
     Dy : Qt4.Q_Integer)
   is
   begin
      scrollContentsBy_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Dx,
        Dy);
   end Scroll_Contents_By;

   --------------------
   -- Setup_Viewport --
   --------------------

   overriding
   procedure Setup_Viewport
    (Self : not null access Q_Plain_Text_Edit_Director;
     Viewport : not null access Qt4.Widgets.Q_Widget'Class)
   is
   begin
      setupViewport_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Viewport.QObject_View);
   end Setup_Viewport;

   --------------------------
   -- Set_Viewport_Margins --
   --------------------------

   overriding
   procedure Set_Viewport_Margins
    (Self : not null access Q_Plain_Text_Edit_Director;
     Left : Qt4.Q_Integer;
     Top : Qt4.Q_Integer;
     Right : Qt4.Q_Integer;
     Bottom : Qt4.Q_Integer)
   is
   begin
      setViewportMargins_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Left,
        Top,
        Right,
        Bottom);
   end Set_Viewport_Margins;

   --------------------
   -- Viewport_Event --
   --------------------

   overriding
   function Viewport_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (viewportEvent_0_wrapper
           (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
            Event.QEvent_View));
   end Viewport_Event;

   ----------------------------------------
   -- Emit_Custom_Context_Menu_Requested --
   ----------------------------------------

   overriding
   procedure Emit_Custom_Context_Menu_Requested
    (Self : not null access Q_Plain_Text_Edit_Director;
     Pos : Qt4.Points.Q_Point)
   is
   begin
      customContextMenuRequested_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos));
   end Emit_Custom_Context_Menu_Requested;

   ------------------
   -- Action_Event --
   ------------------

   overriding
   procedure Action_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Action_Events.Q_Action_Event'Class)
   is
   begin
      actionEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Action_Event;

   -----------------
   -- Close_Event --
   -----------------

   overriding
   procedure Close_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Close_Events.Q_Close_Event'Class)
   is
   begin
      closeEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Close_Event;

   -----------------
   -- Enter_Event --
   -----------------

   overriding
   procedure Enter_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      enterEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Enter_Event;

   ----------------------
   -- Focus_Next_Child --
   ----------------------

   overriding
   function Focus_Next_Child
    (Self : not null access Q_Plain_Text_Edit_Director)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (focusNextChild_0_wrapper
           (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View));
   end Focus_Next_Child;

   --------------------------
   -- Focus_Previous_Child --
   --------------------------

   overriding
   function Focus_Previous_Child
    (Self : not null access Q_Plain_Text_Edit_Director)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (focusPreviousChild_0_wrapper
           (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View));
   end Focus_Previous_Child;

   ----------------
   -- Hide_Event --
   ----------------

   overriding
   procedure Hide_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Hide_Events.Q_Hide_Event'Class)
   is
   begin
      hideEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Hide_Event;

   -----------------
   -- Leave_Event --
   -----------------

   overriding
   procedure Leave_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      leaveEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Leave_Event;

   ----------------
   -- Move_Event --
   ----------------

   overriding
   procedure Move_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Move_Events.Q_Move_Event'Class)
   is
   begin
      moveEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Move_Event;

   -------------------------
   -- Reset_Input_Context --
   -------------------------

   overriding
   procedure Reset_Input_Context
    (Self : not null access Q_Plain_Text_Edit_Director)
   is
   begin
      resetInputContext_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View);
   end Reset_Input_Context;

   ------------------
   -- Tablet_Event --
   ------------------

   overriding
   procedure Tablet_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Tablet_Events.Q_Tablet_Event'Class)
   is
   begin
      tabletEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Tablet_Event;

   ------------
   -- Metric --
   ------------

   overriding
   function Metric
    (Self : not null access constant Q_Plain_Text_Edit_Director;
     Metric : Qt4.Paint_Devices.Paint_Device_Metric)
       return Qt4.Q_Integer
   is
   begin
      return
        metric_0_wrapper
         (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
          Metric);
   end Metric;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_Plain_Text_Edit_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_Plain_Text_Edit_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_Plain_Text_Edit_Director'Class (Self.all).QObject_View));
   end Sender;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QPlainTextEdit", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.Plain_Text_Edits.Directors;
