------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Points;
with Qt4.Rects;
with Qt4.Sizes;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Rubber_Bands is

   type Rubber_Band_Shape is
    (Line,
     Rectangle);
   pragma Convention (C, Rubber_Band_Shape);

   type Q_Rubber_Band is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Rubber_Band_Access is
     access all Q_Rubber_Band'Class;
   for Q_Rubber_Band_Access'Storage_Size use 0;

   type Q_Rubber_Band_Pointer is tagged;

   procedure Move
    (Self : not null access Q_Rubber_Band'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer);

   procedure Move
    (Self : not null access Q_Rubber_Band'Class;
     Pos : Qt4.Points.Q_Point);

   procedure Resize
    (Self : not null access Q_Rubber_Band'Class;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);

   procedure Resize
    (Self : not null access Q_Rubber_Band'Class;
     S : Qt4.Sizes.Q_Size);

   procedure Set_Geometry
    (Self : not null access Q_Rubber_Band'Class;
     X : Qt4.Q_Integer;
     Y : Qt4.Q_Integer;
     W : Qt4.Q_Integer;
     H : Qt4.Q_Integer);

   procedure Set_Geometry
    (Self : not null access Q_Rubber_Band'Class;
     R : Qt4.Rects.Q_Rect);

   function Shape
    (Self : not null access constant Q_Rubber_Band'Class)
       return Qt4.Rubber_Bands.Rubber_Band_Shape;

   package Q_Rubber_Band_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Rubber_Band, Q_Rubber_Band_Access);

   type Q_Rubber_Band_Pointer is
     new Q_Rubber_Band_Pointers.Q_Pointer with null record;

end Qt4.Rubber_Bands;
