------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3243 $ $Date: 2009-04-11 07:39:16 +0400 (Sat, 11 Apr 2009) $
------------------------------------------------------------------------------

package Qt4.Splash_Screens.Constructors is

   function Create
    (Pixmap : Qt4.Pixmaps.Q_Pixmap'Class := Qt4.Pixmaps.Create;
     Flags  : Qt4.Window_Flags           := +Qt4.Widget)
       return not null Qt4.Splash_Screens.Q_Splash_Screen_Access;
   --  Returns new QSplashScreen object.

   function Create
    (Parent : not null access Qt4.Widgets.Q_Widget'Class;
     Pixmap : Qt4.Pixmaps.Q_Pixmap'Class := Qt4.Pixmaps.Create;
     Flags  : Qt4.Window_Flags           := +Qt4.Widget)
       return not null Qt4.Splash_Screens.Q_Splash_Screen_Access;
   --  Returns new QSplashScreen object.

end Qt4.Splash_Screens.Constructors;
