------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Splitters;
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Splitter_Handle_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Splitter_Handle_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Splitter_Handles is

   function opaqueResize_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, opaqueResize_0_wrapper,
                     "__Qt4Ada_QSplitterHandle_opaqueResize_0_wrapper");

   function splitter_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, splitter_0_wrapper,
                     "__Qt4Ada_QSplitterHandle_splitter_0_wrapper");

   pragma Style_Checks ("N");

   -------------------
   -- Opaque_Resize --
   -------------------

   function Opaque_Resize
    (Self : not null access constant Q_Splitter_Handle'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (opaqueResize_0_wrapper
           (Self.QObject_View));
   end Opaque_Resize;

   --------------
   -- Splitter --
   --------------

   function Splitter
    (Self : not null access constant Q_Splitter_Handle'Class)
       return not null access Qt4.Splitters.Q_Splitter'Class
   is
   begin
      return
        Qt4.Splitters.Q_Splitter'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (splitter_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Splitter;

end Qt4.Splitter_Handles;
