------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Strings;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Status_Bars is

   type Q_Status_Bar is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Status_Bar_Access is
     access all Q_Status_Bar'Class;
   for Q_Status_Bar_Access'Storage_Size use 0;

   type Q_Status_Bar_Pointer is tagged;

   procedure Add_Permanent_Widget
    (Self : not null access Q_Status_Bar'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class;
     Stretch : Qt4.Q_Integer
       :=  0);

   procedure Add_Widget
    (Self : not null access Q_Status_Bar'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class;
     Stretch : Qt4.Q_Integer
       :=  0);

   function Current_Message
    (Self : not null access constant Q_Status_Bar'Class)
       return Qt4.Strings.Q_String;

   procedure Insert_Permanent_Widget
    (Self : not null access Q_Status_Bar'Class;
     Index : Qt4.Q_Integer;
     Widget : not null access Qt4.Widgets.Q_Widget'Class;
     Stretch : Qt4.Q_Integer
       :=  0);

   procedure Insert_Widget
    (Self : not null access Q_Status_Bar'Class;
     Index : Qt4.Q_Integer;
     Widget : not null access Qt4.Widgets.Q_Widget'Class;
     Stretch : Qt4.Q_Integer
       :=  0);

   function Is_Size_Grip_Enabled
    (Self : not null access constant Q_Status_Bar'Class)
       return Standard.Boolean;

   procedure Remove_Widget
    (Self : not null access Q_Status_Bar'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Size_Grip_Enabled
    (Self : not null access Q_Status_Bar'Class;
     Enabled : Standard.Boolean);

   procedure Clear_Message
    (Self : not null access Q_Status_Bar'Class);

   procedure Show_Message
    (Self    : not null access Q_Status_Bar'Class;
     Message : Qt4.Strings.Q_String;
     Timeout : Duration := 0.0);

   package Q_Status_Bar_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Status_Bar, Q_Status_Bar_Access);

   type Q_Status_Bar_Pointer is
     new Q_Status_Bar_Pointers.Q_Pointer with null record;

end Qt4.Status_Bars;
