------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Objects;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Styles is

   type Q_Style is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Style_Access is
     access all Q_Style'Class;
   for Q_Style_Access'Storage_Size use 0;

   type Q_Style_Pointer is tagged;

   type State_Flag is
    (
--  State_Default,
     State_None,
     State_Enabled,
     State_Raised,
     State_Sunken,
     State_Off,
     State_No_Change,
     State_On,
     State_Down_Arrow,
     State_Horizontal,
     State_Has_Focus,
     State_Top,
     State_Bottom,
     State_Focus_At_Border,
     State_Auto_Raise,
     State_Mouse_Over,
     State_Up_Arrow,
     State_Selected,
     State_Active,
     State_Open,
     State_Children,
     State_Item,
     State_Sibling,
     State_Editing,
     State_Keyboard_Focus_Change,
     State_Has_Edit_Focus,
     State_ReadOnly);
   pragma Convention (C, State_Flag);
   for State_Flag'Size use Interfaces.C.int'Size;
   for State_Flag use
    (
--  State_Default               => 16#00000000#,
     State_None                  => 16#00000000#,
     State_Enabled               => 16#00000001#,
     State_Raised                => 16#00000002#,
     State_Sunken                => 16#00000004#,
     State_Off                   => 16#00000008#,
     State_No_Change             => 16#00000010#,
     State_On                    => 16#00000020#,
     State_Down_Arrow            => 16#00000040#,
     State_Horizontal            => 16#00000080#,
     State_Has_Focus             => 16#00000100#,
     State_Top                   => 16#00000200#,
     State_Bottom                => 16#00000400#,
     State_Focus_At_Border       => 16#00000800#,
     State_Auto_Raise            => 16#00001000#,
     State_Mouse_Over            => 16#00002000#,
     State_Up_Arrow              => 16#00004000#,
     State_Selected              => 16#00008000#,
     State_Active                => 16#00010000#,
     State_Open                  => 16#00040000#,
     State_Children              => 16#00080000#,
     State_Item                  => 16#00100000#,
     State_Sibling               => 16#00200000#,
     State_Editing               => 16#00400000#,
     State_Keyboard_Focus_Change => 16#00800000#,
     State_Has_Edit_Focus        => 16#01000000#,
     State_ReadOnly              => 16#02000000#);

   package State_Flag_Flags is
     new Qt4_Generic_Flags (State_Flag);

   type State is new State_Flag_Flags.Flags;

   package Q_Style_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Style, Q_Style_Access);

   type Q_Style_Pointer is
     new Q_Style_Pointers.Q_Pointer with null record;

private

   procedure Dummy;

end Qt4.Styles;
