------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Pixmaps;
with Qt4.Strings;
with Qt4.Widgets;
with Qt4.Wizards;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Wizard_Pages is

   type Q_Wizard_Page is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Wizard_Page_Access is
     access all Q_Wizard_Page'Class;
   for Q_Wizard_Page_Access'Storage_Size use 0;

   type Q_Wizard_Page_Pointer is tagged;

   function Button_Text
    (Self : not null access constant Q_Wizard_Page'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Button)
       return Qt4.Strings.Q_String;

   not overriding
   procedure Cleanup_Page
    (Self : not null access Q_Wizard_Page)
       is abstract;

   not overriding
   procedure Initialize_Page
    (Self : not null access Q_Wizard_Page)
       is abstract;

   function Is_Commit_Page
    (Self : not null access constant Q_Wizard_Page'Class)
       return Standard.Boolean;

   not overriding
   function Is_Complete
    (Self : not null access constant Q_Wizard_Page)
       return Standard.Boolean
         is abstract;

   function Is_Final_Page
    (Self : not null access constant Q_Wizard_Page'Class)
       return Standard.Boolean;

   not overriding
   function Next_Id
    (Self : not null access constant Q_Wizard_Page)
       return Qt4.Q_Integer
         is abstract;

   function Pixmap
    (Self : not null access constant Q_Wizard_Page'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Pixmap)
       return Qt4.Pixmaps.Q_Pixmap;

   procedure Set_Button_Text
    (Self : not null access Q_Wizard_Page'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Button;
     Text : Qt4.Strings.Q_String);

   procedure Set_Commit_Page
    (Self : not null access Q_Wizard_Page'Class;
     Commit_Page : Standard.Boolean);

   procedure Set_Final_Page
    (Self : not null access Q_Wizard_Page'Class;
     Final_Page : Standard.Boolean);

   procedure Set_Pixmap
    (Self : not null access Q_Wizard_Page'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Pixmap;
     Pixmap : Qt4.Pixmaps.Q_Pixmap);

   procedure Set_Sub_Title
    (Self : not null access Q_Wizard_Page'Class;
     Sub_Title : Qt4.Strings.Q_String);

   procedure Set_Title
    (Self : not null access Q_Wizard_Page'Class;
     Title : Qt4.Strings.Q_String);

   function Sub_Title
    (Self : not null access constant Q_Wizard_Page'Class)
       return Qt4.Strings.Q_String;

   function Title
    (Self : not null access constant Q_Wizard_Page'Class)
       return Qt4.Strings.Q_String;

   not overriding
   function Validate_Page
    (Self : not null access Q_Wizard_Page)
       return Standard.Boolean
         is abstract;

   package Q_Wizard_Page_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Wizard_Page, Q_Wizard_Page_Access);

   type Q_Wizard_Page_Pointer is
     new Q_Wizard_Page_Pointers.Q_Pointer with null record;

end Qt4.Wizard_Pages;
