------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.X11_Embed_Containers is

   type X11_Embed_Container_Error is
    (Unknown,
     Internal,
     Invalid_Window_ID);
   pragma Convention (C, X11_Embed_Container_Error);

   type Q_X11_Embed_Container is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_X11_Embed_Container_Access is
     access all Q_X11_Embed_Container'Class;
   for Q_X11_Embed_Container_Access'Storage_Size use 0;

   type Q_X11_Embed_Container_Pointer is tagged;

   function Client_Win_Id
    (Self : not null access constant Q_X11_Embed_Container'Class)
       return Qt4.W_Id;

   procedure Discard_Client
    (Self : not null access Q_X11_Embed_Container'Class);

   procedure Embed_Client
    (Self : not null access Q_X11_Embed_Container'Class;
     Id : Qt4.W_Id);

   function Error
    (Self : not null access constant Q_X11_Embed_Container'Class)
       return Qt4.X11_Embed_Containers.X11_Embed_Container_Error;

   package Q_X11_Embed_Container_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_X11_Embed_Container, Q_X11_Embed_Container_Access);

   type Q_X11_Embed_Container_Pointer is
     new Q_X11_Embed_Container_Pointers.Q_Pointer with null record;

end Qt4.X11_Embed_Containers;
