------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.X11_Embed_Widget_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.X11_Embed_Widget_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.X11_Embed_Widgets is

   function containerWinId_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.W_Id;
   pragma Import (C, containerWinId_0_wrapper,
                     "__Qt4Ada_QX11EmbedWidget_containerWinId_0_wrapper");

   procedure embedInto_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Id : Qt4.W_Id);
   pragma Import (C, embedInto_0_wrapper,
                     "__Qt4Ada_QX11EmbedWidget_embedInto_0_wrapper");

   function error_1_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.X11_Embed_Widgets.X11_Embed_Widget_Error;
   pragma Import (C, error_1_wrapper,
                     "__Qt4Ada_QX11EmbedWidget_error_1_wrapper");

   pragma Style_Checks ("N");

   ----------------------
   -- Container_Win_Id --
   ----------------------

   function Container_Win_Id
    (Self : not null access constant Q_X11_Embed_Widget'Class)
       return Qt4.W_Id
   is
   begin
      return
        containerWinId_0_wrapper
         (Self.QObject_View);
   end Container_Win_Id;

   ----------------
   -- Embed_Into --
   ----------------

   procedure Embed_Into
    (Self : not null access Q_X11_Embed_Widget'Class;
     Id : Qt4.W_Id)
   is
   begin
      embedInto_0_wrapper
       (Self.QObject_View,
        Id);
   end Embed_Into;

   -----------
   -- Error --
   -----------

   function Error
    (Self : not null access constant Q_X11_Embed_Widget'Class)
       return Qt4.X11_Embed_Widgets.X11_Embed_Widget_Error
   is
   begin
      return
        error_1_wrapper
         (Self.QObject_View);
   end Error;

end Qt4.X11_Embed_Widgets;
