------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Graphics_Items;
with Qt_Ada.Internals.Graphics_Item_Registry;
pragma Elaborate (Qt_Ada.Internals.Graphics_Item_Registry);

package body Qt_Ada.Internals.Graphics_Items.Graphics_Polygon_Item_Proxies is

   function Create
    (Object : not null Qt_Ada.Internals.Graphics_Items.QGraphicsItem_Access)
       return not null Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base_Access;

   pragma Style_Checks ("N");

   type Q_Graphics_Polygon_Item_Proxy_Access is
     access all Q_Graphics_Polygon_Item_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Graphics_Items.QGraphicsItem_Access)
       return not null Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base_Access
   is
      Self : constant not null Q_Graphics_Polygon_Item_Proxy_Access
        := new Q_Graphics_Polygon_Item_Proxy;

   begin
      Qt_Ada.Internals.Graphics_Items.Initialize (Self, Object);

      return Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Graphics_Item_Registry.Register_QGraphicsItem_Subclass
    (Qt4.Graphics_Items.Graphics_Polygon_Item, Create'Access);
end Qt_Ada.Internals.Graphics_Items.Graphics_Polygon_Item_Proxies;
