------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Delegates;
with Qt4.Abstract_Item_Models;
with Qt4.Events;
with Qt4.Model_Indices;
with Qt4.Painters;
with Qt4.Sizes;
with Qt4.Style_Option_View_Items;
with Qt4.Widgets;
with Qt_Ada.Internals.Objects.Object_Proxies;

package Qt_Ada.Internals.Objects.Abstract_Item_Delegate_Proxies is

   pragma Elaborate_Body;

   type Q_Abstract_Item_Delegate_Proxy is
     new Qt_Ada.Internals.Objects.Object_Proxies.Q_Object_Proxy
       and Qt4.Abstract_Item_Delegates.Q_Abstract_Item_Delegate with null record;

   function Create_Editor
    (Self : not null access constant Q_Abstract_Item_Delegate_Proxy;
     Parent : not null access Qt4.Widgets.Q_Widget'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Editor_Event
    (Self : not null access Q_Abstract_Item_Delegate_Proxy;
     Event : not null access Qt4.Events.Q_Event'Class;
     Model : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Standard.Boolean;

   procedure Set_Editor_Data
    (Self : not null access constant Q_Abstract_Item_Delegate_Proxy;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Index : Qt4.Model_Indices.Q_Model_Index);

   procedure Set_Model_Data
    (Self : not null access constant Q_Abstract_Item_Delegate_Proxy;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Model : not null access Qt4.Abstract_Item_Models.Q_Abstract_Item_Model'Class;
     Index : Qt4.Model_Indices.Q_Model_Index);

   function Size_Hint
    (Self : not null access constant Q_Abstract_Item_Delegate_Proxy;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index)
       return Qt4.Sizes.Q_Size;

   procedure Update_Editor_Geometry
    (Self : not null access constant Q_Abstract_Item_Delegate_Proxy;
     Editor : not null access Qt4.Widgets.Q_Widget'Class;
     Option : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item'Class;
     Index : Qt4.Model_Indices.Q_Model_Index);

   overriding
   procedure Paint
    (Self    : not null access Q_Abstract_Item_Delegate_Proxy;
     Painter : Qt4.Painters.Q_Painter;
     Option  : Qt4.Style_Option_View_Items.Q_Style_Option_View_Item;
     Index   : Qt4.Model_Indices.Q_Model_Index);

end Qt_Ada.Internals.Objects.Abstract_Item_Delegate_Proxies;
