------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Applications;
with Qt4.Session_Managers;
with Qt_Ada.Internals.Objects.Core_Application_Proxies;

package Qt_Ada.Internals.Objects.Application_Proxies is

   pragma Elaborate_Body;

   type Q_Application_Proxy is
     new Qt_Ada.Internals.Objects.Core_Application_Proxies.Q_Core_Application_Proxy
       and Qt4.Applications.Q_Application with null record;

   overriding
   procedure Commit_Data
    (Self    : not null access Q_Application_Proxy;
     Manager : not null access Qt4.Session_Managers.Q_Session_Manager'Class);

   overriding
   procedure Save_State
    (Self    : not null access Q_Application_Proxy;
     Manager : not null access Qt4.Session_Managers.Q_Session_Manager'Class);

--   overriding
--   function Compress_Event
--    (Self          : not null access Q_Application_Impl;
--     Event         : not null access Qt4.Events.Q_Event'Class;
--     Receiver      : not null access Qt4.Objects.Q_Object'Class;
--     Posted_Events : not null access Qt4.Post_Event_Lists.Q_Post_Event_List)
--       return Boolean;

end Qt_Ada.Internals.Objects.Application_Proxies;
