------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Item_Selection_Models;
with Qt4.Item_Selections;
with Qt4.Model_Indices;
with Qt_Ada.Internals.Objects.Object_Proxies;

package Qt_Ada.Internals.Objects.Item_Selection_Model_Proxies is

   pragma Elaborate_Body;

   type Q_Item_Selection_Model_Proxy is
     new Qt_Ada.Internals.Objects.Object_Proxies.Q_Object_Proxy
       and Qt4.Item_Selection_Models.Q_Item_Selection_Model with null record;

   procedure Clear
    (Self : not null access Q_Item_Selection_Model_Proxy);

   procedure Reset
    (Self : not null access Q_Item_Selection_Model_Proxy);

   overriding
   procedure Select_Item
    (Self    : not null access Q_Item_Selection_Model_Proxy;
     Index   : Qt4.Model_Indices.Q_Model_Index;
     Command : Qt4.Item_Selection_Models.Selection_Flags);

   overriding
   procedure Select_Item
    (Self      : not null access Q_Item_Selection_Model_Proxy;
     Selection : Qt4.Item_Selections.Q_Item_Selection;
     Command   : Qt4.Item_Selection_Models.Selection_Flags);

end Qt_Ada.Internals.Objects.Item_Selection_Model_Proxies;
