------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);

package body Qt_Ada.Internals.Objects.Validator_Proxies is

   procedure fixup_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Input : not null access Qt4.Strings.Internals.QString);
      pragma Import (C, fixup_0_virtual,
                     "__Qt4Ada_QValidator_fixup_0_virtual");

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;

   function validate_virtual
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Input : not null access Qt4.Strings.Internals.QString;
     Pos   : not null access Qt4.Q_Integer)
       return Qt4.Validators.Validator_State;
   pragma Import (C, validate_virtual, "__Qt4Ada_QValidator_validate_virtual");

   --------------
   -- Validate --
   --------------

   overriding
   function Validate
    (Self  : not null access constant Q_Validator_Proxy;
     Input : not null access Qt4.Strings.Q_String;
     Pos   : not null access Qt4.Q_Integer)
       return Qt4.Validators.Validator_State
   is
   begin
      return
        validate_virtual
         (Self.QObject_View,
          Qt4.Strings.Internals.QString_View (Input.all),
          Pos);
   end Validate;

   pragma Style_Checks ("N");

   -----------
   -- Fixup --
   -----------

   procedure Fixup
    (Self : not null access constant Q_Validator_Proxy;
     Input : Qt4.Strings.Q_String)
   is
   begin
      fixup_0_virtual
       (Q_Validator_Proxy'Class (Self.all).QObject_View,
        Qt4.Strings.Internals.QString_View (Input));
   end Fixup;

   type Q_Validator_Proxy_Access is
     access all Q_Validator_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access
   is
      Self : constant not null Q_Validator_Proxy_Access
        := new Q_Validator_Proxy;

   begin
      Qt_Ada.Internals.Objects.Initialize (Self, Object);

      return Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Object_Registry.Register_Proxy
    ("QValidator", Create'Access);
end Qt_Ada.Internals.Objects.Validator_Proxies;
