//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSize>
#include <QVariant>
#include <QIcon>
#include <QRect>
#include <QString>
#include <QColor>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qtabbardirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QTabBar_staticMetaObject =
        &QTabBar::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    int __Qt4Ada_QTabBar_addTab_1_wrapper(QObject* cpp_object, const QString* text)
    {
        return dynamic_cast<QTabBar*>(cpp_object)->QTabBar::addTab(*text);
    }

    int __Qt4Ada_QTabBar_addTab_0_wrapper(QObject* cpp_object, const QIcon* icon, const QString* text)
    {
        return dynamic_cast<QTabBar*>(cpp_object)->QTabBar::addTab(*icon, *text);
    }

    int __Qt4Ada_QTabBar_count_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabBar*>(cpp_object)->QTabBar::count();
    }

    int __Qt4Ada_QTabBar_currentIndex_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabBar*>(cpp_object)->QTabBar::currentIndex();
    }

    bool __Qt4Ada_QTabBar_drawBase_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabBar*>(cpp_object)->QTabBar::drawBase();
    }

    void __Qt4Ada_QTabBar_iconSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QTabBar*>(cpp_object)->QTabBar::iconSize();
    }

    int __Qt4Ada_QTabBar_insertTab_1_wrapper(QObject* cpp_object, int index, const QString* text)
    {
        return dynamic_cast<QTabBar*>(cpp_object)->QTabBar::insertTab(index, *text);
    }

    int __Qt4Ada_QTabBar_insertTab_0_wrapper(QObject* cpp_object, int index, const QIcon* icon, const QString* text)
    {
        return dynamic_cast<QTabBar*>(cpp_object)->QTabBar::insertTab(index, *icon, *text);
    }

    bool __Qt4Ada_QTabBar_isTabEnabled_0_wrapper(QObject* cpp_object, int index)
    {
        return dynamic_cast<QTabBar*>(cpp_object)->QTabBar::isTabEnabled(index);
    }

    void __Qt4Ada_QTabBar_removeTab_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::removeTab(index);
    }

    void __Qt4Ada_QTabBar_setDrawBase_0_wrapper(QObject* cpp_object, bool drawTheBase)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setDrawBase(drawTheBase);
    }

    void __Qt4Ada_QTabBar_setIconSize_0_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setIconSize(*size);
    }

    void __Qt4Ada_QTabBar_setShape_0_wrapper(QObject* cpp_object, QTabBar::Shape shape)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setShape(shape);
    }

    void __Qt4Ada_QTabBar_setTabData_0_wrapper(QObject* cpp_object, int index, const QVariant* data)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setTabData(index, *data);
    }

    void __Qt4Ada_QTabBar_setTabEnabled_0_wrapper(QObject* cpp_object, int index, bool enabled)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setTabEnabled(index, enabled);
    }

    void __Qt4Ada_QTabBar_setTabIcon_0_wrapper(QObject* cpp_object, int index, const QIcon* icon)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setTabIcon(index, *icon);
    }

    void __Qt4Ada_QTabBar_setTabText_0_wrapper(QObject* cpp_object, int index, const QString* text)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setTabText(index, *text);
    }

    void __Qt4Ada_QTabBar_setTabTextColor_0_wrapper(QObject* cpp_object, int index, const QColor* color)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setTabTextColor(index, *color);
    }

    void __Qt4Ada_QTabBar_setTabToolTip_0_wrapper(QObject* cpp_object, int index, const QString* tip)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setTabToolTip(index, *tip);
    }

    void __Qt4Ada_QTabBar_setTabWhatsThis_0_wrapper(QObject* cpp_object, int index, const QString* text)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setTabWhatsThis(index, *text);
    }

    void __Qt4Ada_QTabBar_setUsesScrollButtons_0_wrapper(QObject* cpp_object, bool useButtons)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setUsesScrollButtons(useButtons);
    }

    QTabBar::Shape __Qt4Ada_QTabBar_shape_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabBar*>(cpp_object)->QTabBar::shape();
    }

    void __Qt4Ada_QTabBar_tabData_0_wrapper(QObject* cpp_object, int index, QVariant* returns)
    {
        *returns = dynamic_cast<QTabBar*>(cpp_object)->QTabBar::tabData(index);
    }

    void __Qt4Ada_QTabBar_tabIcon_0_wrapper(QObject* cpp_object, int index, QIcon* returns)
    {
        *returns = dynamic_cast<QTabBar*>(cpp_object)->QTabBar::tabIcon(index);
    }

    void __Qt4Ada_QTabBar_tabRect_0_wrapper(QObject* cpp_object, int index, QRect* returns)
    {
        *returns = dynamic_cast<QTabBar*>(cpp_object)->QTabBar::tabRect(index);
    }

    void __Qt4Ada_QTabBar_tabText_0_wrapper(QObject* cpp_object, int index, QString* returns)
    {
        *returns = dynamic_cast<QTabBar*>(cpp_object)->QTabBar::tabText(index);
    }

    void __Qt4Ada_QTabBar_tabTextColor_0_wrapper(QObject* cpp_object, int index, QColor* returns)
    {
        *returns = dynamic_cast<QTabBar*>(cpp_object)->QTabBar::tabTextColor(index);
    }

    void __Qt4Ada_QTabBar_tabToolTip_0_wrapper(QObject* cpp_object, int index, QString* returns)
    {
        *returns = dynamic_cast<QTabBar*>(cpp_object)->QTabBar::tabToolTip(index);
    }

    void __Qt4Ada_QTabBar_tabWhatsThis_0_wrapper(QObject* cpp_object, int index, QString* returns)
    {
        *returns = dynamic_cast<QTabBar*>(cpp_object)->QTabBar::tabWhatsThis(index);
    }

    bool __Qt4Ada_QTabBar_usesScrollButtons_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabBar*>(cpp_object)->QTabBar::usesScrollButtons();
    }

    void __Qt4Ada_QTabBar_setCurrentIndex_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QTabBar*>(cpp_object)->QTabBar::setCurrentIndex(index);
    }

    void __Qt4Ada_QTabBar_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QTabBar*>(cpp_object)->QTabBar::sizeHint();
    }

    void __Qt4Ada_QTabBar_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QTabBar*>(cpp_object)->QTabBar::minimumSizeHint();
    }

    void __Qt4Ada_QTabBar_currentChanged_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::currentChanged(index);
    }

    void __Qt4Ada_QTabBar_tabInserted_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::tabInserted(index);
    }

    void __Qt4Ada_QTabBar_tabLayoutChange_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::tabLayoutChange();
    }

    void __Qt4Ada_QTabBar_tabRemoved_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::tabRemoved(index);
    }

    void __Qt4Ada_QTabBar_tabSizeHint_0_wrapper(QObject* cpp_object, int index, QSize* returns)
    {
        *returns = dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::tabSizeHint(index);
    }

    void __Qt4Ada_QTabBar_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::changeEvent(event);
    }

    bool __Qt4Ada_QTabBar_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::event(e);
    }

    void __Qt4Ada_QTabBar_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTabBar_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTabBar_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTabBar_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTabBar_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QTabBar_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QTabBar_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QTabBar::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QTabBar_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QTabBar_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QTabBar_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QTabBar_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QTabBar_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QTabBar_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QTabBar_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QTabBar_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QTabBar_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QTabBar_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QTabBar_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QTabBar_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QTabBar_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QTabBar_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QTabBar_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QTabBar_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QTabBar_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTabBar_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QTabBar_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTabBar_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QTabBar_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QTabBar_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QTabBar_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QTabBar_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QTabBarDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QTabBar_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QTabBar_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QTabBar_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabBarDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QTabBar_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabBarDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QTabBar_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QTabBar*>(cpp_this)->QTabBar::qt_metacast(name);
    }

    int __Qt4Ada_QTabBar_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QTabBar*>(cpp_this)->QTabBar::qt_metacall(_c, _id, _a);
    }

}

QSize QTabBarDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QTabBarDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QTabBarDirector::tabInserted(int index)
{
    __Qt4Ada_QTabBar_tabInserted_0_dispatch(this->ada_object, index);
}

void QTabBarDirector::tabLayoutChange()
{
    __Qt4Ada_QTabBar_tabLayoutChange_0_dispatch(this->ada_object);
}

void QTabBarDirector::tabRemoved(int index)
{
    __Qt4Ada_QTabBar_tabRemoved_0_dispatch(this->ada_object, index);
}

QSize QTabBarDirector::tabSizeHint(int index) const
{
    QSize *aux = __Qt4Ada_QTabBar_tabSizeHint_0_dispatch(this->ada_object, index);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QTabBarDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

bool QTabBarDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QTabBarDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

int QTabBarDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QTabBarDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QTabBarDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QTabBarDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QTabBarDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QTabBarDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QTabBarDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QTabBarDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QTabBarDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QTabBarDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QTabBarDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QTabBarDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QTabBarDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
