//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QSize>
#include <QIcon>
#include <QString>
#include <QTabBar>
#include <QKeyEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qtabwidgetdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QTabWidget_staticMetaObject =
        &QTabWidget::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    int __Qt4Ada_QTabWidget_addTab_1_wrapper(QObject* cpp_object, QObject* widget, const QString* label)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::addTab(dynamic_cast<QWidget*>(widget), *label);
    }

    int __Qt4Ada_QTabWidget_addTab_0_wrapper(QObject* cpp_object, QObject* widget, const QIcon* icon, const QString* label)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::addTab(dynamic_cast<QWidget*>(widget), *icon, *label);
    }

    void __Qt4Ada_QTabWidget_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::clear();
    }

    int __Qt4Ada_QTabWidget_count_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::count();
    }

    int __Qt4Ada_QTabWidget_currentIndex_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::currentIndex();
    }

    QObject* __Qt4Ada_QTabWidget_currentWidget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::currentWidget());
    }

    void __Qt4Ada_QTabWidget_iconSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::iconSize();
    }

    int __Qt4Ada_QTabWidget_indexOf_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::indexOf(dynamic_cast<QWidget*>(widget));
    }

    int __Qt4Ada_QTabWidget_insertTab_1_wrapper(QObject* cpp_object, int index, QObject* widget, const QString* label)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::insertTab(index, dynamic_cast<QWidget*>(widget), *label);
    }

    int __Qt4Ada_QTabWidget_insertTab_0_wrapper(QObject* cpp_object, int index, QObject* widget, const QIcon* icon, const QString* label)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::insertTab(index, dynamic_cast<QWidget*>(widget), *icon, *label);
    }

    bool __Qt4Ada_QTabWidget_isTabEnabled_0_wrapper(QObject* cpp_object, int index)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::isTabEnabled(index);
    }

    void __Qt4Ada_QTabWidget_removeTab_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::removeTab(index);
    }

    void __Qt4Ada_QTabWidget_setIconSize_0_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setIconSize(*size);
    }

    void __Qt4Ada_QTabWidget_setTabEnabled_0_wrapper(QObject* cpp_object, int index, bool enabled)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setTabEnabled(index, enabled);
    }

    void __Qt4Ada_QTabWidget_setTabIcon_0_wrapper(QObject* cpp_object, int index, const QIcon* icon)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setTabIcon(index, *icon);
    }

    void __Qt4Ada_QTabWidget_setTabPosition_0_wrapper(QObject* cpp_object, QTabWidget::TabPosition position)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setTabPosition(position);
    }

    void __Qt4Ada_QTabWidget_setTabShape_0_wrapper(QObject* cpp_object, QTabWidget::TabShape s)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setTabShape(s);
    }

    void __Qt4Ada_QTabWidget_setTabText_0_wrapper(QObject* cpp_object, int index, const QString* label)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setTabText(index, *label);
    }

    void __Qt4Ada_QTabWidget_setTabToolTip_0_wrapper(QObject* cpp_object, int index, const QString* tip)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setTabToolTip(index, *tip);
    }

    void __Qt4Ada_QTabWidget_setTabWhatsThis_0_wrapper(QObject* cpp_object, int index, const QString* text)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setTabWhatsThis(index, *text);
    }

    void __Qt4Ada_QTabWidget_setUsesScrollButtons_0_wrapper(QObject* cpp_object, bool useButtons)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setUsesScrollButtons(useButtons);
    }

    void __Qt4Ada_QTabWidget_tabIcon_0_wrapper(QObject* cpp_object, int index, QIcon* returns)
    {
        *returns = dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::tabIcon(index);
    }

    QTabWidget::TabPosition __Qt4Ada_QTabWidget_tabPosition_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::tabPosition();
    }

    QTabWidget::TabShape __Qt4Ada_QTabWidget_tabShape_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::tabShape();
    }

    void __Qt4Ada_QTabWidget_tabText_0_wrapper(QObject* cpp_object, int index, QString* returns)
    {
        *returns = dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::tabText(index);
    }

    void __Qt4Ada_QTabWidget_tabToolTip_0_wrapper(QObject* cpp_object, int index, QString* returns)
    {
        *returns = dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::tabToolTip(index);
    }

    void __Qt4Ada_QTabWidget_tabWhatsThis_0_wrapper(QObject* cpp_object, int index, QString* returns)
    {
        *returns = dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::tabWhatsThis(index);
    }

    bool __Qt4Ada_QTabWidget_usesScrollButtons_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::usesScrollButtons();
    }

    QObject* __Qt4Ada_QTabWidget_widget_0_wrapper(QObject* cpp_object, int index)
    {
        return static_cast<QObject*>(dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::widget(index));
    }

    void __Qt4Ada_QTabWidget_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::minimumSizeHint();
    }

    void __Qt4Ada_QTabWidget_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::sizeHint();
    }

    void __Qt4Ada_QTabWidget_setCurrentIndex_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setCurrentIndex(index);
    }

    void __Qt4Ada_QTabWidget_setCurrentWidget_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QTabWidget*>(cpp_object)->QTabWidget::setCurrentWidget(dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QTabWidget_currentChanged_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::currentChanged(index);
    }

    void __Qt4Ada_QTabWidget_setTabBar_0_wrapper(QObject* cpp_object, QObject* tb)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::setTabBar(dynamic_cast<QTabBar*>(tb));
    }

    QObject* __Qt4Ada_QTabWidget_tabBar_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::tabBar());
    }

    void __Qt4Ada_QTabWidget_tabInserted_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::tabInserted(index);
    }

    void __Qt4Ada_QTabWidget_tabRemoved_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::tabRemoved(index);
    }

    void __Qt4Ada_QTabWidget_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::changeEvent(event);
    }

    bool __Qt4Ada_QTabWidget_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::event(e);
    }

    void __Qt4Ada_QTabWidget_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QTabWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QTabWidget_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QTabWidget_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QTabWidget_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QTabWidget_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QTabWidget_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QTabWidget_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QTabWidget_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QTabWidget_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QTabWidget_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QTabWidget_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QTabWidgetDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QTabWidget_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QTabWidget_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QTabWidget_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTabWidgetDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QTabWidget_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTabWidgetDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QTabWidget_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QTabWidget*>(cpp_this)->QTabWidget::qt_metacast(name);
    }

    int __Qt4Ada_QTabWidget_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QTabWidget*>(cpp_this)->QTabWidget::qt_metacall(_c, _id, _a);
    }

}

QSize QTabWidgetDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QTabWidgetDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QTabWidgetDirector::tabInserted(int index)
{
    __Qt4Ada_QTabWidget_tabInserted_0_dispatch(this->ada_object, index);
}

void QTabWidgetDirector::tabRemoved(int index)
{
    __Qt4Ada_QTabWidget_tabRemoved_0_dispatch(this->ada_object, index);
}

void QTabWidgetDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

bool QTabWidgetDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QTabWidgetDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

int QTabWidgetDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QTabWidgetDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QTabWidgetDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QTabWidgetDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QTabWidgetDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QTabWidgetDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QTabWidgetDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QTabWidgetDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QTabWidgetDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QTabWidgetDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QTabWidgetDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QTabWidgetDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QTabWidgetDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C" {

    QObject* __Qt4Ada_new_QTabWidget(QObject* parent)
    {
        return dynamic_cast<QObject *>(new QTabWidget(dynamic_cast<QWidget*>(parent)));
    }

}
