//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QTABWIDGETDIRECTOR_H__
#define __QTABWIDGETDIRECTOR_H__

#include <QTabWidget>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QTabWidget_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QTabWidget_tabInserted_0_dispatch(void*, int);
    extern void __Qt4Ada_QTabWidget_tabRemoved_0_dispatch(void*, int);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern int __Qt4Ada_QTabWidget_addTab_1_wrapper(QObject*, QObject*, const QString*);
    extern int __Qt4Ada_QTabWidget_addTab_0_wrapper(QObject*, QObject*, const QIcon*, const QString*);
    extern void __Qt4Ada_QTabWidget_clear_0_wrapper(QObject*);
    extern int __Qt4Ada_QTabWidget_count_0_wrapper(QObject*);
    extern int __Qt4Ada_QTabWidget_currentIndex_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QTabWidget_currentWidget_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabWidget_iconSize_0_wrapper(QObject*, QSize*);
    extern int __Qt4Ada_QTabWidget_indexOf_0_wrapper(QObject*, QObject*);
    extern int __Qt4Ada_QTabWidget_insertTab_1_wrapper(QObject*, int, QObject*, const QString*);
    extern int __Qt4Ada_QTabWidget_insertTab_0_wrapper(QObject*, int, QObject*, const QIcon*, const QString*);
    extern bool __Qt4Ada_QTabWidget_isTabEnabled_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabWidget_removeTab_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabWidget_setIconSize_0_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QTabWidget_setTabEnabled_0_wrapper(QObject*, int, bool);
    extern void __Qt4Ada_QTabWidget_setTabIcon_0_wrapper(QObject*, int, const QIcon*);
    extern void __Qt4Ada_QTabWidget_setTabPosition_0_wrapper(QObject*, QTabWidget::TabPosition);
    extern void __Qt4Ada_QTabWidget_setTabShape_0_wrapper(QObject*, QTabWidget::TabShape);
    extern void __Qt4Ada_QTabWidget_setTabText_0_wrapper(QObject*, int, const QString*);
    extern void __Qt4Ada_QTabWidget_setTabToolTip_0_wrapper(QObject*, int, const QString*);
    extern void __Qt4Ada_QTabWidget_setTabWhatsThis_0_wrapper(QObject*, int, const QString*);
    extern void __Qt4Ada_QTabWidget_setUsesScrollButtons_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTabWidget_tabIcon_0_wrapper(QObject*, int, QIcon*);
    extern QTabWidget::TabPosition __Qt4Ada_QTabWidget_tabPosition_0_wrapper(QObject*);
    extern QTabWidget::TabShape __Qt4Ada_QTabWidget_tabShape_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabWidget_tabText_0_wrapper(QObject*, int, QString*);
    extern void __Qt4Ada_QTabWidget_tabToolTip_0_wrapper(QObject*, int, QString*);
    extern void __Qt4Ada_QTabWidget_tabWhatsThis_0_wrapper(QObject*, int, QString*);
    extern bool __Qt4Ada_QTabWidget_usesScrollButtons_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QTabWidget_widget_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabWidget_minimumSizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QTabWidget_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QTabWidget_setCurrentIndex_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabWidget_setCurrentWidget_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTabWidget_currentChanged_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabWidget_setTabBar_0_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QTabWidget_tabBar_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabWidget_tabInserted_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabWidget_tabRemoved_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabWidget_changeEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTabWidget_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QTabWidget_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTabWidget_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTabWidget_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTabWidget_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTabWidget_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabWidget_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabWidget_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QTabWidget_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QTabWidget_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabWidget_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QTabWidget_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QTabWidget_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QTabWidget_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject* __Qt4Ada_new_QTabWidget(QObject*);

}

class QTabWidgetDirector : public QTabWidget
{
protected:
    void* ada_object;
    QTabWidgetDirector();

    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void tabInserted(int);
    virtual void tabRemoved(int);
    virtual void changeEvent(QEvent*);
    virtual bool event(QEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QTabWidget_currentChanged_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QTabWidget_setTabBar_0_wrapper(QObject*, QObject*);
    friend QObject* __Qt4Ada_QTabWidget_tabBar_0_wrapper(QObject*);
    friend void __Qt4Ada_QTabWidget_tabInserted_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QTabWidget_tabRemoved_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QTabWidget_changeEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTabWidget_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QTabWidget_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTabWidget_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QTabWidget_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTabWidget_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTabWidget_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QTabWidget_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QTabWidget_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QTabWidget_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QTabWidget_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabWidget_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QTabWidget_sender_0_wrapper(QObject*);
};

#endif // __QTABWIDGETDIRECTOR_H__
