//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QColor>
#include <QFont>
#include <QPen>
#include <QString>
#include <QStringList>
#include "qtextcharformatwrapper.h"

extern "C"
{

    QTextFormat* __QtAda_inititialize_QTextCharFormat(void* storage)
    {
        return new (storage) QTextCharFormat();
    }

    QTextFormat* __QtAda_adjust_QTextCharFormat(void* storage, const QTextFormat* from)
    {
        return new (storage) QTextCharFormat(*static_cast<const QTextCharFormat*>(from));
    }

    void __QtAda_finalize_QTextCharFormat(QTextFormat *item)
    {
        static_cast<const QTextCharFormat*>(item)->~QTextCharFormat();
    }

    void __QtAda_QTextCharFormat_anchorHref_Q(QString* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextCharFormat*>(self)->anchorHref();
    }

    void __QtAda_QTextCharFormat_anchorNames_Q(QStringList* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextCharFormat*>(self)->anchorNames();
    }

    void __QtAda_QTextCharFormat_font_Q(QFont* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextCharFormat*>(self)->font();
    }

    unsigned __QtAda_QTextCharFormat_fontCapitalization_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextCharFormat*>(self)->fontCapitalization();
    }

    void __QtAda_QTextCharFormat_fontFamily_Q(QString* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextCharFormat*>(self)->fontFamily();
    }

    unsigned __QtAda_QTextCharFormat_fontFixedPitch_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextCharFormat*>(self)->fontFixedPitch();
    }

    unsigned __QtAda_QTextCharFormat_fontItalic_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextCharFormat*>(self)->fontItalic();
    }

    double __QtAda_QTextCharFormat_fontLetterSpacing_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextCharFormat*>(self)->fontLetterSpacing();
    }

    unsigned __QtAda_QTextCharFormat_fontOverline_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextCharFormat*>(self)->fontOverline();
    }

    double __QtAda_QTextCharFormat_fontPointSize_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextCharFormat*>(self)->fontPointSize();
    }

    unsigned __QtAda_QTextCharFormat_fontStrikeOut_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextCharFormat*>(self)->fontStrikeOut();
    }

    unsigned __QtAda_QTextCharFormat_fontUnderline_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextCharFormat*>(self)->fontUnderline();
    }

    int __QtAda_QTextCharFormat_fontWeight_Q(const QTextFormat* self)
    {
        return static_cast<const QTextCharFormat*>(self)->fontWeight();
    }

    double __QtAda_QTextCharFormat_fontWordSpacing_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextCharFormat*>(self)->fontWordSpacing();
    }

    unsigned __QtAda_QTextCharFormat_isAnchor_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextCharFormat*>(self)->isAnchor();
    }

    unsigned __QtAda_QTextCharFormat_isValid_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextCharFormat*>(self)->isValid();
    }

    void __QtAda_QTextCharFormat_setAnchor_bool(QTextFormat* self, unsigned anchor)
    {
        static_cast<QTextCharFormat*>(self)->setAnchor((bool)anchor);
    }

    void __QtAda_QTextCharFormat_setAnchorHref_QStringCR(QTextFormat* self, const QString* anchor)
    {
        static_cast<QTextCharFormat*>(self)->setAnchorHref(*anchor);
    }

    void __QtAda_QTextCharFormat_setAnchorNames_QStringListCR(QTextFormat* self, const QStringList* names)
    {
        static_cast<QTextCharFormat*>(self)->setAnchorNames(*names);
    }

    void __QtAda_QTextCharFormat_setFont_QFontCR(QTextFormat* self, const QFont* font)
    {
        static_cast<QTextCharFormat*>(self)->setFont(*font);
    }

    void __QtAda_QTextCharFormat_setFontCapitalization_Capitalization(QTextFormat* self, unsigned capitalization)
    {
        static_cast<QTextCharFormat*>(self)->setFontCapitalization((QFont::Capitalization)capitalization);
    }

    void __QtAda_QTextCharFormat_setFontFamily_QStringCR(QTextFormat* self, const QString* anchor)
    {
        static_cast<QTextCharFormat*>(self)->setFontFamily(*anchor);
    }

    void __QtAda_QTextCharFormat_setFontFixedPitch_bool(QTextFormat* self, unsigned fixedPitch)
    {
        static_cast<QTextCharFormat*>(self)->setFontFixedPitch((bool)fixedPitch);
    }

    void __QtAda_QTextCharFormat_setFontItalic_bool(QTextFormat* self, unsigned italic)
    {
        static_cast<QTextCharFormat*>(self)->setFontItalic((bool)italic);
    }

    void __QtAda_QTextCharFormat_setFontLetterSpacing_qreal(QTextFormat* self, double spacing)
    {
        static_cast<QTextCharFormat*>(self)->setFontLetterSpacing((qreal)spacing);
    }

    void __QtAda_QTextCharFormat_setFontOverline_bool(QTextFormat* self, unsigned overline)
    {
        static_cast<QTextCharFormat*>(self)->setFontOverline((bool)overline);
    }

    void __QtAda_QTextCharFormat_setFontPointSize_qreal(QTextFormat* self, double size)
    {
        static_cast<QTextCharFormat*>(self)->setFontPointSize((qreal)size);
    }

    void __QtAda_QTextCharFormat_setFontStrikeOut_bool(QTextFormat* self, unsigned strikeOut)
    {
        static_cast<QTextCharFormat*>(self)->setFontStrikeOut((bool)strikeOut);
    }

    void __QtAda_QTextCharFormat_setFontUnderline_bool(QTextFormat* self, unsigned underline)
    {
        static_cast<QTextCharFormat*>(self)->setFontUnderline((bool)underline);
    }

    void __QtAda_QTextCharFormat_setFontWeight_int(QTextFormat* self, int weight)
    {
        static_cast<QTextCharFormat*>(self)->setFontWeight(weight);
    }

    void __QtAda_QTextCharFormat_setFontWordSpacing_qreal(QTextFormat* self, double spacing)
    {
        static_cast<QTextCharFormat*>(self)->setFontWordSpacing((qreal)spacing);
    }

    void __QtAda_QTextCharFormat_setTextOutline_QPenCR(QTextFormat* self, const QPen* pen)
    {
        static_cast<QTextCharFormat*>(self)->setTextOutline(*pen);
    }

    void __QtAda_QTextCharFormat_setToolTip_QStringCR(QTextFormat* self, const QString* tip)
    {
        static_cast<QTextCharFormat*>(self)->setToolTip(*tip);
    }

    void __QtAda_QTextCharFormat_setUnderlineColor_QColorCR(QTextFormat* self, const QColor* color)
    {
        static_cast<QTextCharFormat*>(self)->setUnderlineColor(*color);
    }

    void __QtAda_QTextCharFormat_setUnderlineStyle_UnderlineStyle(QTextFormat* self, unsigned style)
    {
        static_cast<QTextCharFormat*>(self)->setUnderlineStyle((QTextCharFormat::UnderlineStyle)style);
    }

    void __QtAda_QTextCharFormat_setVerticalAlignment_VerticalAlignment(QTextFormat* self, unsigned alignment)
    {
        static_cast<QTextCharFormat*>(self)->setVerticalAlignment((QTextCharFormat::VerticalAlignment)alignment);
    }

    void __QtAda_QTextCharFormat_textOutline_Q(QPen* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextCharFormat*>(self)->textOutline();
    }

    void __QtAda_QTextCharFormat_toolTip_Q(QString* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextCharFormat*>(self)->toolTip();
    }

    void __QtAda_QTextCharFormat_underlineColor_Q(QColor* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextCharFormat*>(self)->underlineColor();
    }

    unsigned __QtAda_QTextCharFormat_underlineStyle_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextCharFormat*>(self)->underlineStyle();
    }

    unsigned __QtAda_QTextCharFormat_verticalAlignment_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextCharFormat*>(self)->verticalAlignment();
    }

};

