//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QTextCharFormat>

extern "C"
{
    extern QTextFormat* __QtAda_inititialize_QTextCharFormat(void*);
    extern QTextFormat* __QtAda_adjust_QTextCharFormat(void*, const QTextFormat*);
    extern void __QtAda_finalize_QTextCharFormat(QTextFormat*);

    extern void __QtAda_QTextCharFormat_anchorHref_Q(QString*, const QTextFormat*);
    extern void __QtAda_QTextCharFormat_anchorNames_Q(QStringList*, const QTextFormat*);
    extern void __QtAda_QTextCharFormat_font_Q(QFont*, const QTextFormat*);
    extern unsigned __QtAda_QTextCharFormat_fontCapitalization_Q(const QTextFormat*);
    extern void __QtAda_QTextCharFormat_fontFamily_Q(QString*, const QTextFormat*);
    extern unsigned __QtAda_QTextCharFormat_fontFixedPitch_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextCharFormat_fontItalic_Q(const QTextFormat*);
    extern double __QtAda_QTextCharFormat_fontLetterSpacing_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextCharFormat_fontOverline_Q(const QTextFormat*);
    extern double __QtAda_QTextCharFormat_fontPointSize_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextCharFormat_fontStrikeOut_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextCharFormat_fontUnderline_Q(const QTextFormat*);
    extern int __QtAda_QTextCharFormat_fontWeight_Q(const QTextFormat*);
    extern double __QtAda_QTextCharFormat_fontWordSpacing_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextCharFormat_isAnchor_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextCharFormat_isValid_Q(const QTextFormat*);
    extern void __QtAda_QTextCharFormat_setAnchor_bool(QTextFormat*, unsigned);
    extern void __QtAda_QTextCharFormat_setAnchorHref_QStringCR(QTextFormat*, const QString*);
    extern void __QtAda_QTextCharFormat_setAnchorNames_QStringListCR(QTextFormat*, const QStringList*);
    extern void __QtAda_QTextCharFormat_setFont_QFontCR(QTextFormat*, const QFont*);
    extern void __QtAda_QTextCharFormat_setFontCapitalization_Capitalization(QTextFormat*, unsigned);
    extern void __QtAda_QTextCharFormat_setFontFamily_QStringCR(QTextFormat*, const QString*);
    extern void __QtAda_QTextCharFormat_setFontFixedPitch_bool(QTextFormat*, unsigned);
    extern void __QtAda_QTextCharFormat_setFontItalic_bool(QTextFormat*, unsigned);
    extern void __QtAda_QTextCharFormat_setFontLetterSpacing_qreal(QTextFormat*, double);
    extern void __QtAda_QTextCharFormat_setFontOverline_bool(QTextFormat*, unsigned);
    extern void __QtAda_QTextCharFormat_setFontPointSize_qreal(QTextFormat*, double);
    extern void __QtAda_QTextCharFormat_setFontStrikeOut_bool(QTextFormat*, unsigned);
    extern void __QtAda_QTextCharFormat_setFontUnderline_bool(QTextFormat*, unsigned);
    extern void __QtAda_QTextCharFormat_setFontWeight_int(QTextFormat*, int);
    extern void __QtAda_QTextCharFormat_setFontWordSpacing_qreal(QTextFormat*, double);
    extern void __QtAda_QTextCharFormat_setTextOutline_QPenCR(QTextFormat*, const QPen*);
    extern void __QtAda_QTextCharFormat_setToolTip_QStringCR(QTextFormat*, const QString*);
    extern void __QtAda_QTextCharFormat_setUnderlineColor_QColorCR(QTextFormat*, const QColor*);
    extern void __QtAda_QTextCharFormat_setUnderlineStyle_UnderlineStyle(QTextFormat*, unsigned);
    extern void __QtAda_QTextCharFormat_setVerticalAlignment_VerticalAlignment(QTextFormat*, unsigned);
    extern void __QtAda_QTextCharFormat_textOutline_Q(QPen*, const QTextFormat*);
    extern void __QtAda_QTextCharFormat_toolTip_Q(QString*, const QTextFormat*);
    extern void __QtAda_QTextCharFormat_underlineColor_Q(QColor*, const QTextFormat*);
    extern unsigned __QtAda_QTextCharFormat_underlineStyle_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextCharFormat_verticalAlignment_Q(const QTextFormat*);

};

