//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QTextBlock>
#include <QChar>
#include <QFont>
#include <QString>
#include <QTextObject>
#include <QChildEvent>
#include <QTimerEvent>

#include "qtextdocumentdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QTextDocument_staticMetaObject =
        &QTextDocument::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QTextDocument_clear_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->clear();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QTextDocument_adjustSize_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::adjustSize();
    }

    void __Qt4Ada_QTextDocument_begin_0_wrapper(QObject* cpp_object, QTextBlock* returns)
    {
        *returns = dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::begin();
    }

    int __Qt4Ada_QTextDocument_blockCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::blockCount();
    }

    void __Qt4Ada_QTextDocument_characterAt_0_wrapper(QObject* cpp_object, int pos, QChar* returns)
    {
        *returns = dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::characterAt(pos);
    }

    void __Qt4Ada_QTextDocument_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::clear();
    }

    void __Qt4Ada_QTextDocument_defaultFont_0_wrapper(QObject* cpp_object, QFont* returns)
    {
        *returns = dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::defaultFont();
    }

    void __Qt4Ada_QTextDocument_defaultStyleSheet_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::defaultStyleSheet();
    }

    void __Qt4Ada_QTextDocument_end_0_wrapper(QObject* cpp_object, QTextBlock* returns)
    {
        *returns = dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::end();
    }

    void __Qt4Ada_QTextDocument_findBlock_0_wrapper(QObject* cpp_object, int pos, QTextBlock* returns)
    {
        *returns = dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::findBlock(pos);
    }

    bool __Qt4Ada_QTextDocument_isEmpty_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::isEmpty();
    }

    bool __Qt4Ada_QTextDocument_isModified_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::isModified();
    }

    bool __Qt4Ada_QTextDocument_isRedoAvailable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::isRedoAvailable();
    }

    bool __Qt4Ada_QTextDocument_isUndoAvailable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::isUndoAvailable();
    }

    bool __Qt4Ada_QTextDocument_isUndoRedoEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::isUndoRedoEnabled();
    }

    void __Qt4Ada_QTextDocument_markContentsDirty_0_wrapper(QObject* cpp_object, int from, int length)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::markContentsDirty(from, length);
    }

    int __Qt4Ada_QTextDocument_maximumBlockCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::maximumBlockCount();
    }

    QObject* __Qt4Ada_QTextDocument_object_0_wrapper(QObject* cpp_object, int objectIndex)
    {
        return static_cast<QObject*>(dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::object(objectIndex));
    }

    int __Qt4Ada_QTextDocument_pageCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::pageCount();
    }

    void __Qt4Ada_QTextDocument_setDefaultFont_0_wrapper(QObject* cpp_object, const QFont* font)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::setDefaultFont(*font);
    }

    void __Qt4Ada_QTextDocument_setDefaultStyleSheet_0_wrapper(QObject* cpp_object, const QString* sheet)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::setDefaultStyleSheet(*sheet);
    }

    void __Qt4Ada_QTextDocument_setHtml_0_wrapper(QObject* cpp_object, const QString* html)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::setHtml(*html);
    }

    void __Qt4Ada_QTextDocument_setMaximumBlockCount_0_wrapper(QObject* cpp_object, int maximum)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::setMaximumBlockCount(maximum);
    }

    void __Qt4Ada_QTextDocument_setPlainText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::setPlainText(*text);
    }

    void __Qt4Ada_QTextDocument_setUndoRedoEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::setUndoRedoEnabled(enable);
    }

    void __Qt4Ada_QTextDocument_setUseDesignMetrics_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::setUseDesignMetrics(b);
    }

    void __Qt4Ada_QTextDocument_toHtml_0_wrapper(QObject* cpp_object, const QByteArray* encoding, QString* returns)
    {
        *returns = dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::toHtml(*encoding);
    }

    void __Qt4Ada_QTextDocument_toPlainText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::toPlainText();
    }

    bool __Qt4Ada_QTextDocument_useDesignMetrics_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::useDesignMetrics();
    }

    void __Qt4Ada_QTextDocument_redo_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::redo();
    }

    void __Qt4Ada_QTextDocument_setModified_0_wrapper(QObject* cpp_object, bool m)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::setModified(m);
    }

    void __Qt4Ada_QTextDocument_undo_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextDocument*>(cpp_object)->QTextDocument::undo();
    }

    void __Qt4Ada_QTextDocument_contentsChange_0_wrapper(QObject* cpp_object, int from, int charsRemoves, int charsAdded)
    {
        dynamic_cast<QTextDocumentDirector*>(cpp_object)->QTextDocument::contentsChange(from, charsRemoves, charsAdded);
    }

    void __Qt4Ada_QTextDocument_contentsChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextDocumentDirector*>(cpp_object)->QTextDocument::contentsChanged();
    }

    void __Qt4Ada_QTextDocument_modificationChanged_0_wrapper(QObject* cpp_object, bool m)
    {
        dynamic_cast<QTextDocumentDirector*>(cpp_object)->QTextDocument::modificationChanged(m);
    }

    void __Qt4Ada_QTextDocument_redoAvailable_0_wrapper(QObject* cpp_object, bool available)
    {
        dynamic_cast<QTextDocumentDirector*>(cpp_object)->QTextDocument::redoAvailable(available);
    }

    void __Qt4Ada_QTextDocument_undoAvailable_0_wrapper(QObject* cpp_object, bool available)
    {
        dynamic_cast<QTextDocumentDirector*>(cpp_object)->QTextDocument::undoAvailable(available);
    }

    void __Qt4Ada_QTextDocument_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextDocumentDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QTextDocument_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextDocumentDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QTextDocument_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextDocumentDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QTextDocument_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextDocumentDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QTextDocument_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QTextDocument*>(cpp_this)->QTextDocument::qt_metacast(name);
    }

    int __Qt4Ada_QTextDocument_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QTextDocument*>(cpp_this)->QTextDocument::qt_metacall(_c, _id, _a);
    }

}

void QTextDocumentDirector::clear()
{
    __Qt4Ada_QTextDocument_clear_0_dispatch(this->ada_object);
}

bool QTextDocumentDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QTextDocumentDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QTextDocumentDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QTextDocumentDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QTextDocumentDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QTextDocumentDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QTextDocumentDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QTextDocumentDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QTextCursor>

extern "C"
{
    void __Qt4Ada_QTextDocument_find_1_wrapper (QObject*       cpp_object,
                                                const QString* sub_string,
                                                int            position,
                                                unsigned       options,
                                                QTextCursor*   returns)
    {
        *returns =
          dynamic_cast<QTextDocument*>(cpp_object)->find(*sub_string,
                                            position,
                                            static_cast<QTextDocument::FindFlags>(options));
    }

    void __Qt4Ada_QTextDocument_print_wrapper (QObject* self, QPrinter* printer)
    {
        dynamic_cast<QTextDocument*>(self)->QTextDocument::print(printer);
    }
}
