//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QTEXTDOCUMENTDIRECTOR_H__
#define __QTEXTDOCUMENTDIRECTOR_H__

#include <QTextDocument>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QTextDocument_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QTextDocument_clear_0_dispatch(void*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QTextDocument_clear_0_virtual(QObject*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QTextDocument_adjustSize_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextDocument_begin_0_wrapper(QObject*, QTextBlock*);
    extern int __Qt4Ada_QTextDocument_blockCount_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextDocument_characterAt_0_wrapper(QObject*, int, QChar*);
    extern void __Qt4Ada_QTextDocument_clear_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextDocument_defaultFont_0_wrapper(QObject*, QFont*);
    extern void __Qt4Ada_QTextDocument_defaultStyleSheet_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QTextDocument_end_0_wrapper(QObject*, QTextBlock*);
    extern void __Qt4Ada_QTextDocument_findBlock_0_wrapper(QObject*, int, QTextBlock*);
    extern bool __Qt4Ada_QTextDocument_isEmpty_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTextDocument_isModified_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTextDocument_isRedoAvailable_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTextDocument_isUndoAvailable_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTextDocument_isUndoRedoEnabled_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextDocument_markContentsDirty_0_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QTextDocument_maximumBlockCount_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QTextDocument_object_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTextDocument_pageCount_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextDocument_setDefaultFont_0_wrapper(QObject*, const QFont*);
    extern void __Qt4Ada_QTextDocument_setDefaultStyleSheet_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextDocument_setHtml_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextDocument_setMaximumBlockCount_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTextDocument_setPlainText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextDocument_setUndoRedoEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextDocument_setUseDesignMetrics_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextDocument_toHtml_0_wrapper(QObject*, const QByteArray*, QString*);
    extern void __Qt4Ada_QTextDocument_toPlainText_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QTextDocument_useDesignMetrics_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextDocument_redo_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextDocument_setModified_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextDocument_undo_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextDocument_contentsChange_0_wrapper(QObject*, int, int, int);
    extern void __Qt4Ada_QTextDocument_contentsChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextDocument_modificationChanged_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextDocument_redoAvailable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextDocument_undoAvailable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextDocument_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextDocument_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextDocument_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QTextDocument_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QTextDocument_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QTextDocument_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

   extern "C"
   {
        extern void __Qt4Ada_QTextDocument_find_1_wrapper (QObject*, const QString *, int, unsigned, QTextCursor*);
        extern void __Qt4Ada_QTextDocument_print_wrapper (QObject*, QPrinter*);
   }

class QTextDocumentDirector : public QTextDocument
{
protected:
    void* ada_object;
    QTextDocumentDirector();

    virtual void clear();
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QTextDocument_contentsChange_0_wrapper(QObject*, int, int, int);
    friend void __Qt4Ada_QTextDocument_contentsChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QTextDocument_modificationChanged_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTextDocument_redoAvailable_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTextDocument_undoAvailable_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTextDocument_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextDocument_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextDocument_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QTextDocument_sender_0_wrapper(QObject*);
};

#endif // __QTEXTDOCUMENTDIRECTOR_H__
