//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QTextDocument>
#include <QTextCursor>
#include <QString>
#include <QColor>
#include <QFont>
#include <QTextCharFormat>
#include <QMenu>
#include <QRect>
#include <QContextMenuEvent>
#include <QTimerEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QResizeEvent>
#include <QPaintEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QShowEvent>
#include <QWheelEvent>
#include <QInputMethodEvent>
#include <QSize>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qtexteditdirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QTextEdit_staticMetaObject =
        &QTextEdit::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QTextEdit_setDocument_0_wrapper(QObject* cpp_object, QObject* document)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setDocument(dynamic_cast<QTextDocument*>(document));
    }

    QObject* __Qt4Ada_QTextEdit_document_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::document());
    }

    void __Qt4Ada_QTextEdit_setTextCursor_0_wrapper(QObject* cpp_object, const QTextCursor* cursor)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setTextCursor(*cursor);
    }

    void __Qt4Ada_QTextEdit_textCursor_0_wrapper(QObject* cpp_object, QTextCursor* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::textCursor();
    }

    bool __Qt4Ada_QTextEdit_isReadOnly_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::isReadOnly();
    }

    void __Qt4Ada_QTextEdit_setReadOnly_0_wrapper(QObject* cpp_object, bool ro)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setReadOnly(ro);
    }

    qreal __Qt4Ada_QTextEdit_fontPointSize_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::fontPointSize();
    }

    void __Qt4Ada_QTextEdit_fontFamily_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::fontFamily();
    }

    int __Qt4Ada_QTextEdit_fontWeight_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::fontWeight();
    }

    bool __Qt4Ada_QTextEdit_fontUnderline_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::fontUnderline();
    }

    bool __Qt4Ada_QTextEdit_fontItalic_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::fontItalic();
    }

    void __Qt4Ada_QTextEdit_textColor_0_wrapper(QObject* cpp_object, QColor* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::textColor();
    }

    void __Qt4Ada_QTextEdit_currentFont_0_wrapper(QObject* cpp_object, QFont* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::currentFont();
    }

    void __Qt4Ada_QTextEdit_mergeCurrentCharFormat_0_wrapper(QObject* cpp_object, const QTextFormat* modifier)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::mergeCurrentCharFormat(static_cast<const QTextCharFormat&>(*modifier));
    }

    void __Qt4Ada_QTextEdit_setCurrentCharFormat_0_wrapper(QObject* cpp_object, const QTextFormat* format)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setCurrentCharFormat(static_cast<const QTextCharFormat&>(*format));
    }

    bool __Qt4Ada_QTextEdit_tabChangesFocus_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::tabChangesFocus();
    }

    void __Qt4Ada_QTextEdit_setTabChangesFocus_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setTabChangesFocus(b);
    }

    void __Qt4Ada_QTextEdit_setDocumentTitle_0_wrapper(QObject* cpp_object, const QString* title)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setDocumentTitle(*title);
    }

    void __Qt4Ada_QTextEdit_documentTitle_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::documentTitle();
    }

    bool __Qt4Ada_QTextEdit_isUndoRedoEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::isUndoRedoEnabled();
    }

    void __Qt4Ada_QTextEdit_setUndoRedoEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setUndoRedoEnabled(enable);
    }

    QTextEdit::LineWrapMode __Qt4Ada_QTextEdit_lineWrapMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::lineWrapMode();
    }

    void __Qt4Ada_QTextEdit_setLineWrapMode_0_wrapper(QObject* cpp_object, QTextEdit::LineWrapMode mode)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setLineWrapMode(mode);
    }

    int __Qt4Ada_QTextEdit_lineWrapColumnOrWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::lineWrapColumnOrWidth();
    }

    void __Qt4Ada_QTextEdit_setLineWrapColumnOrWidth_0_wrapper(QObject* cpp_object, int w)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setLineWrapColumnOrWidth(w);
    }

    void __Qt4Ada_QTextEdit_toPlainText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::toPlainText();
    }

    void __Qt4Ada_QTextEdit_toHtml_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::toHtml();
    }

    void __Qt4Ada_QTextEdit_ensureCursorVisible_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::ensureCursorVisible();
    }

    QObject* __Qt4Ada_QTextEdit_createStandardContextMenu_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::createStandardContextMenu());
    }

    void __Qt4Ada_QTextEdit_cursorForPosition_0_wrapper(QObject* cpp_object, const QPoint* pos, QTextCursor* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::cursorForPosition(*pos);
    }

    void __Qt4Ada_QTextEdit_cursorRect_1_wrapper(QObject* cpp_object, const QTextCursor* cursor, QRect* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::cursorRect(*cursor);
    }

    void __Qt4Ada_QTextEdit_cursorRect_0_wrapper(QObject* cpp_object, QRect* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::cursorRect();
    }

    void __Qt4Ada_QTextEdit_anchorAt_0_wrapper(QObject* cpp_object, const QPoint* pos, QString* returns)
    {
        *returns = dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::anchorAt(*pos);
    }

    bool __Qt4Ada_QTextEdit_overwriteMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::overwriteMode();
    }

    void __Qt4Ada_QTextEdit_setOverwriteMode_0_wrapper(QObject* cpp_object, bool overwrite)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setOverwriteMode(overwrite);
    }

    int __Qt4Ada_QTextEdit_tabStopWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::tabStopWidth();
    }

    void __Qt4Ada_QTextEdit_setTabStopWidth_0_wrapper(QObject* cpp_object, int width)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setTabStopWidth(width);
    }

    int __Qt4Ada_QTextEdit_cursorWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::cursorWidth();
    }

    void __Qt4Ada_QTextEdit_setCursorWidth_0_wrapper(QObject* cpp_object, int width)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setCursorWidth(width);
    }

    bool __Qt4Ada_QTextEdit_acceptRichText_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::acceptRichText();
    }

    void __Qt4Ada_QTextEdit_setAcceptRichText_0_wrapper(QObject* cpp_object, bool acc)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setAcceptRichText(acc);
    }

    bool __Qt4Ada_QTextEdit_canPaste_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::canPaste();
    }

    void __Qt4Ada_QTextEdit_setFontPointSize_0_wrapper(QObject* cpp_object, qreal s)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setFontPointSize(s);
    }

    void __Qt4Ada_QTextEdit_setFontFamily_0_wrapper(QObject* cpp_object, const QString* fontFamily)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setFontFamily(*fontFamily);
    }

    void __Qt4Ada_QTextEdit_setFontWeight_0_wrapper(QObject* cpp_object, int weight)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setFontWeight(weight);
    }

    void __Qt4Ada_QTextEdit_setFontUnderline_0_wrapper(QObject* cpp_object, bool underline)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setFontUnderline(underline);
    }

    void __Qt4Ada_QTextEdit_setFontItalic_0_wrapper(QObject* cpp_object, bool italic)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setFontItalic(italic);
    }

    void __Qt4Ada_QTextEdit_setTextColor_0_wrapper(QObject* cpp_object, const QColor* c)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setTextColor(*c);
    }

    void __Qt4Ada_QTextEdit_setCurrentFont_0_wrapper(QObject* cpp_object, const QFont* f)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setCurrentFont(*f);
    }

    void __Qt4Ada_QTextEdit_setPlainText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setPlainText(*text);
    }

    void __Qt4Ada_QTextEdit_setHtml_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setHtml(*text);
    }

    void __Qt4Ada_QTextEdit_setText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::setText(*text);
    }

    void __Qt4Ada_QTextEdit_cut_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::cut();
    }

    void __Qt4Ada_QTextEdit_copy_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::copy();
    }

    void __Qt4Ada_QTextEdit_paste_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::paste();
    }

    void __Qt4Ada_QTextEdit_undo_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::undo();
    }

    void __Qt4Ada_QTextEdit_redo_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::redo();
    }

    void __Qt4Ada_QTextEdit_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::clear();
    }

    void __Qt4Ada_QTextEdit_selectAll_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::selectAll();
    }

    void __Qt4Ada_QTextEdit_insertPlainText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::insertPlainText(*text);
    }

    void __Qt4Ada_QTextEdit_insertHtml_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::insertHtml(*text);
    }

    void __Qt4Ada_QTextEdit_append_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::append(*text);
    }

    void __Qt4Ada_QTextEdit_scrollToAnchor_0_wrapper(QObject* cpp_object, const QString* name)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::scrollToAnchor(*name);
    }

    void __Qt4Ada_QTextEdit_zoomIn_0_wrapper(QObject* cpp_object, int rng)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::zoomIn(rng);
    }

    void __Qt4Ada_QTextEdit_zoomOut_0_wrapper(QObject* cpp_object, int rng)
    {
        dynamic_cast<QTextEdit*>(cpp_object)->QTextEdit::zoomOut(rng);
    }

    void __Qt4Ada_QTextEdit_copyAvailable_0_wrapper(QObject* cpp_object, bool yes)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::copyAvailable(yes);
    }

    void __Qt4Ada_QTextEdit_currentCharFormatChanged_0_wrapper(QObject* cpp_object, const QTextFormat* f)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::currentCharFormatChanged(static_cast<const QTextCharFormat&>(*f));
    }

    void __Qt4Ada_QTextEdit_cursorPositionChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::cursorPositionChanged();
    }

    void __Qt4Ada_QTextEdit_redoAvailable_0_wrapper(QObject* cpp_object, bool available)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::redoAvailable(available);
    }

    void __Qt4Ada_QTextEdit_selectionChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::selectionChanged();
    }

    void __Qt4Ada_QTextEdit_textChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::textChanged();
    }

    void __Qt4Ada_QTextEdit_undoAvailable_0_wrapper(QObject* cpp_object, bool available)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::undoAvailable(available);
    }

    void __Qt4Ada_QTextEdit_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    bool __Qt4Ada_QTextEdit_event_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::event(event);
    }

    void __Qt4Ada_QTextEdit_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::changeEvent(event);
    }

    void __Qt4Ada_QTextEdit_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::scrollContentsBy(dx, dy);
    }

    bool __Qt4Ada_QTextEdit_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QTextEditDirector*>(cpp_object)->QTextEdit::focusNextPrevChild(next);
    }

    void __Qt4Ada_QTextEdit_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QTextEdit_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    bool __Qt4Ada_QTextEdit_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QTextEditDirector*>(cpp_object)->QAbstractScrollArea::viewportEvent(event);
    }

    void __Qt4Ada_QTextEdit_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QTextEdit_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QTextEdit_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QTextEdit_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QTextEdit_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QTextEdit_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QTextEdit_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QTextEdit_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QTextEditDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QTextEdit_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QTextEdit_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTextEditDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QTextEdit_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTextEditDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QTextEdit_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QTextEdit*>(cpp_this)->QTextEdit::qt_metacast(name);
    }

    int __Qt4Ada_QTextEdit_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QTextEdit*>(cpp_this)->QTextEdit::qt_metacall(_c, _id, _a);
    }

}

void QTextEditDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

bool QTextEditDirector::event(QEvent* event)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

bool QTextEditDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

QSize QTextEditDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QTextEditDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QTextEditDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

int QTextEditDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QTextEditDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QTextEditDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QTextEditDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QTextEditDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QTextEditDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QTextEditDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QTextEditDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QTextEditDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QTextEditDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QTextEditDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
 // Constructors

extern "C"
{
   QObject* __Qt4Ada_new_QTextEdit (QObject*parent)
   {
        return dynamic_cast<QObject*>(new QTextEdit (dynamic_cast<QWidget*>(parent)));
   }

   QObject* __Qt4Ada_new_QTextEdit_with_String (QString*text,QObject*parent)
   {
        return dynamic_cast<QObject*>(new QTextEdit (*text, dynamic_cast<QWidget*>(parent)));
   }
}
