//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QTEXTEDITDIRECTOR_H__
#define __QTEXTEDITDIRECTOR_H__

#include <QTextEdit>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QTextEdit_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QTextEdit_setDocument_0_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QTextEdit_document_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setTextCursor_0_wrapper(QObject*, const QTextCursor*);
    extern void __Qt4Ada_QTextEdit_textCursor_0_wrapper(QObject*, QTextCursor*);
    extern bool __Qt4Ada_QTextEdit_isReadOnly_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setReadOnly_0_wrapper(QObject*, bool);
    extern qreal __Qt4Ada_QTextEdit_fontPointSize_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_fontFamily_0_wrapper(QObject*, QString*);
    extern int __Qt4Ada_QTextEdit_fontWeight_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTextEdit_fontUnderline_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTextEdit_fontItalic_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_textColor_0_wrapper(QObject*, QColor*);
    extern void __Qt4Ada_QTextEdit_currentFont_0_wrapper(QObject*, QFont*);
    extern void __Qt4Ada_QTextEdit_mergeCurrentCharFormat_0_wrapper(QObject*, const QTextFormat*);
    extern void __Qt4Ada_QTextEdit_setCurrentCharFormat_0_wrapper(QObject*, const QTextFormat*);
    extern bool __Qt4Ada_QTextEdit_tabChangesFocus_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setTabChangesFocus_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextEdit_setDocumentTitle_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextEdit_documentTitle_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QTextEdit_isUndoRedoEnabled_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setUndoRedoEnabled_0_wrapper(QObject*, bool);
    extern QTextEdit::LineWrapMode __Qt4Ada_QTextEdit_lineWrapMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setLineWrapMode_0_wrapper(QObject*, QTextEdit::LineWrapMode);
    extern int __Qt4Ada_QTextEdit_lineWrapColumnOrWidth_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setLineWrapColumnOrWidth_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTextEdit_toPlainText_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QTextEdit_toHtml_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QTextEdit_ensureCursorVisible_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QTextEdit_createStandardContextMenu_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_cursorForPosition_0_wrapper(QObject*, const QPoint*, QTextCursor*);
    extern void __Qt4Ada_QTextEdit_cursorRect_1_wrapper(QObject*, const QTextCursor*, QRect*);
    extern void __Qt4Ada_QTextEdit_cursorRect_0_wrapper(QObject*, QRect*);
    extern void __Qt4Ada_QTextEdit_anchorAt_0_wrapper(QObject*, const QPoint*, QString*);
    extern bool __Qt4Ada_QTextEdit_overwriteMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setOverwriteMode_0_wrapper(QObject*, bool);
    extern int __Qt4Ada_QTextEdit_tabStopWidth_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setTabStopWidth_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTextEdit_cursorWidth_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setCursorWidth_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QTextEdit_acceptRichText_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setAcceptRichText_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QTextEdit_canPaste_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_setFontPointSize_0_wrapper(QObject*, qreal);
    extern void __Qt4Ada_QTextEdit_setFontFamily_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextEdit_setFontWeight_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTextEdit_setFontUnderline_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextEdit_setFontItalic_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextEdit_setTextColor_0_wrapper(QObject*, const QColor*);
    extern void __Qt4Ada_QTextEdit_setCurrentFont_0_wrapper(QObject*, const QFont*);
    extern void __Qt4Ada_QTextEdit_setPlainText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextEdit_setHtml_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextEdit_setText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextEdit_cut_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_copy_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_paste_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_undo_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_redo_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_clear_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_selectAll_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_insertPlainText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextEdit_insertHtml_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextEdit_append_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextEdit_scrollToAnchor_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QTextEdit_zoomIn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTextEdit_zoomOut_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTextEdit_copyAvailable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextEdit_currentCharFormatChanged_0_wrapper(QObject*, const QTextFormat*);
    extern void __Qt4Ada_QTextEdit_cursorPositionChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_redoAvailable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextEdit_selectionChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_textChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_undoAvailable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextEdit_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTextEdit_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern bool __Qt4Ada_QTextEdit_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTextEdit_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTextEdit_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern bool __Qt4Ada_QTextEdit_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QTextEdit_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTextEdit_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTextEdit_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QTextEdit_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QTextEdit_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QTextEdit_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTextEdit_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QTextEdit_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QTextEdit_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QTextEdit_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
 // Constructors

extern "C"
{
   extern QObject* __Qt4Ada_new_QTextEdit (QObject*);
   extern QObject* __Qt4Ada_new_QTextEdit_with_String (QString*,QObject*);
}

class QTextEditDirector : public QTextEdit
{
protected:
    void* ada_object;
    QTextEditDirector();

    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual bool event(QEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void changeEvent(QEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void scrollContentsBy(int, int);
    virtual bool focusNextPrevChild(bool);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual bool viewportEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QTextEdit_copyAvailable_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTextEdit_currentCharFormatChanged_0_wrapper(QObject*, const QTextFormat*);
    friend void __Qt4Ada_QTextEdit_cursorPositionChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QTextEdit_redoAvailable_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTextEdit_selectionChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QTextEdit_textChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QTextEdit_undoAvailable_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTextEdit_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTextEdit_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend bool __Qt4Ada_QTextEdit_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTextEdit_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QTextEdit_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend bool __Qt4Ada_QTextEdit_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QTextEdit_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTextEdit_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QTextEdit_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QTextEdit_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QTextEdit_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QTextEdit_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QTextEdit_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTextEdit_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QTextEdit_sender_0_wrapper(QObject*);
};

#endif // __QTEXTEDITDIRECTOR_H__
