//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QBrush>
#include <QString>
#include <QTextLength>
#include "qtextframeformatwrapper.h"

extern "C"
{

    QTextFormat* __QtAda_inititialize_QTextFrameFormat(void* storage)
    {
        return new (storage) QTextFrameFormat();
    }

    QTextFormat* __QtAda_adjust_QTextFrameFormat(void* storage, const QTextFormat* from)
    {
        return new (storage) QTextFrameFormat(*static_cast<const QTextFrameFormat*>(from));
    }

    void __QtAda_finalize_QTextFrameFormat(QTextFormat *item)
    {
        static_cast<const QTextFrameFormat*>(item)->~QTextFrameFormat();
    }

    double __QtAda_QTextFrameFormat_border_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextFrameFormat*>(self)->border();
    }

    void __QtAda_QTextFrameFormat_borderBrush_Q(QBrush* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextFrameFormat*>(self)->borderBrush();
    }

    unsigned __QtAda_QTextFrameFormat_borderStyle_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextFrameFormat*>(self)->borderStyle();
    }

    double __QtAda_QTextFrameFormat_bottomMargin_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextFrameFormat*>(self)->bottomMargin();
    }

    void __QtAda_QTextFrameFormat_height_Q(QTextLength* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextFrameFormat*>(self)->height();
    }

    unsigned __QtAda_QTextFrameFormat_isValid_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextFrameFormat*>(self)->isValid();
    }

    double __QtAda_QTextFrameFormat_leftMargin_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextFrameFormat*>(self)->leftMargin();
    }

    double __QtAda_QTextFrameFormat_margin_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextFrameFormat*>(self)->margin();
    }

    double __QtAda_QTextFrameFormat_padding_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextFrameFormat*>(self)->padding();
    }

    unsigned __QtAda_QTextFrameFormat_position_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextFrameFormat*>(self)->position();
    }

    double __QtAda_QTextFrameFormat_rightMargin_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextFrameFormat*>(self)->rightMargin();
    }

    void __QtAda_QTextFrameFormat_setBorder_qreal(QTextFormat* self, double width)
    {
        static_cast<QTextFrameFormat*>(self)->setBorder((qreal)width);
    }

    void __QtAda_QTextFrameFormat_setBorderBrush_QBrushCR(QTextFormat* self, const QBrush* brush)
    {
        static_cast<QTextFrameFormat*>(self)->setBorderBrush(*brush);
    }

    void __QtAda_QTextFrameFormat_setBorderStyle_BorderStyle(QTextFormat* self, unsigned style)
    {
        static_cast<QTextFrameFormat*>(self)->setBorderStyle((QTextFrameFormat::BorderStyle)style);
    }

    void __QtAda_QTextFrameFormat_setBottomMargin_qreal(QTextFormat* self, double margin)
    {
        static_cast<QTextFrameFormat*>(self)->setBottomMargin((qreal)margin);
    }

    void __QtAda_QTextFrameFormat_setHeight_QTextLengthCR(QTextFormat* self, const QTextLength* height)
    {
        static_cast<QTextFrameFormat*>(self)->setHeight(*height);
    }

    void __QtAda_QTextFrameFormat_setHeight_qreal(QTextFormat* self, double height)
    {
        static_cast<QTextFrameFormat*>(self)->setHeight((qreal)height);
    }

    void __QtAda_QTextFrameFormat_setLeftMargin_qreal(QTextFormat* self, double margin)
    {
        static_cast<QTextFrameFormat*>(self)->setLeftMargin((qreal)margin);
    }

    void __QtAda_QTextFrameFormat_setMargin_qreal(QTextFormat* self, double margin)
    {
        static_cast<QTextFrameFormat*>(self)->setMargin((qreal)margin);
    }

    void __QtAda_QTextFrameFormat_setPadding_qreal(QTextFormat* self, double padding)
    {
        static_cast<QTextFrameFormat*>(self)->setPadding((qreal)padding);
    }

    void __QtAda_QTextFrameFormat_setPosition_Position(QTextFormat* self, unsigned f)
    {
        static_cast<QTextFrameFormat*>(self)->setPosition((QTextFrameFormat::Position)f);
    }

    void __QtAda_QTextFrameFormat_setRightMargin_qreal(QTextFormat* self, double margin)
    {
        static_cast<QTextFrameFormat*>(self)->setRightMargin((qreal)margin);
    }

    void __QtAda_QTextFrameFormat_setTopMargin_qreal(QTextFormat* self, double margin)
    {
        static_cast<QTextFrameFormat*>(self)->setTopMargin((qreal)margin);
    }

    void __QtAda_QTextFrameFormat_setWidth_QTextLengthCR(QTextFormat* self, const QTextLength* width)
    {
        static_cast<QTextFrameFormat*>(self)->setWidth(*width);
    }

    void __QtAda_QTextFrameFormat_setWidth_qreal(QTextFormat* self, double width)
    {
        static_cast<QTextFrameFormat*>(self)->setWidth((qreal)width);
    }

    double __QtAda_QTextFrameFormat_topMargin_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextFrameFormat*>(self)->topMargin();
    }

    void __QtAda_QTextFrameFormat_width_Q(QTextLength* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextFrameFormat*>(self)->width();
    }

};

