//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include "qtextlistformatwrapper.h"

extern "C"
{

    QTextFormat* __QtAda_inititialize_QTextListFormat(void* storage)
    {
        return new (storage) QTextListFormat();
    }

    QTextFormat* __QtAda_adjust_QTextListFormat(void* storage, const QTextFormat* from)
    {
        return new (storage) QTextListFormat(*static_cast<const QTextListFormat*>(from));
    }

    void __QtAda_finalize_QTextListFormat(QTextFormat *item)
    {
        static_cast<const QTextListFormat*>(item)->~QTextListFormat();
    }

    unsigned __QtAda_QTextListFormat_indent_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextListFormat*>(self)->indent();
    }

    unsigned __QtAda_QTextListFormat_isValid_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextListFormat*>(self)->isValid();
    }

    void __QtAda_QTextListFormat_setIndent_int(QTextFormat* self, int indent)
    {
        static_cast<QTextListFormat*>(self)->setIndent(indent);
    }

    void __QtAda_QTextListFormat_setStyle_Style(QTextFormat* self, int style)
    {
        static_cast<QTextListFormat*>(self)->setStyle((QTextListFormat::Style)style);
    }

    int __QtAda_QTextListFormat_style_Q(const QTextFormat* self)
    {
        return (int)static_cast<const QTextListFormat*>(self)->style();
    }

};

