//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include "qtexttablecellformatwrapper.h"

extern "C"
{

    QTextFormat* __QtAda_inititialize_QTextTableCellFormat(void* storage)
    {
        return new (storage) QTextTableCellFormat();
    }

    QTextFormat* __QtAda_adjust_QTextTableCellFormat(void* storage, const QTextFormat* from)
    {
        return new (storage) QTextTableCellFormat(*static_cast<const QTextTableCellFormat*>(from));
    }

    void __QtAda_finalize_QTextTableCellFormat(QTextFormat *item)
    {
        static_cast<const QTextTableCellFormat*>(item)->~QTextTableCellFormat();
    }

    double __QtAda_QTextTableCellFormat_bottomPadding_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextTableCellFormat*>(self)->bottomPadding();
    }

    unsigned __QtAda_QTextTableCellFormat_isValid_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextTableCellFormat*>(self)->isValid();
    }

    double __QtAda_QTextTableCellFormat_leftPadding_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextTableCellFormat*>(self)->leftPadding();
    }

    double __QtAda_QTextTableCellFormat_rightPadding_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextTableCellFormat*>(self)->rightPadding();
    }

    void __QtAda_QTextTableCellFormat_setBottomPadding_qreal(QTextFormat* self, double padding)
    {
        static_cast<QTextTableCellFormat*>(self)->setBottomPadding((qreal)padding);
    }

    void __QtAda_QTextTableCellFormat_setLeftPadding_qreal(QTextFormat* self, double padding)
    {
        static_cast<QTextTableCellFormat*>(self)->setLeftPadding((qreal)padding);
    }

    void __QtAda_QTextTableCellFormat_setPadding_qreal(QTextFormat* self, double padding)
    {
        static_cast<QTextTableCellFormat*>(self)->setPadding((qreal)padding);
    }

    void __QtAda_QTextTableCellFormat_setRightPadding_qreal(QTextFormat* self, double padding)
    {
        static_cast<QTextTableCellFormat*>(self)->setRightPadding((qreal)padding);
    }

    void __QtAda_QTextTableCellFormat_setTopPadding_qreal(QTextFormat* self, double padding)
    {
        static_cast<QTextTableCellFormat*>(self)->setTopPadding((qreal)padding);
    }

    double __QtAda_QTextTableCellFormat_topPadding_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextTableCellFormat*>(self)->topPadding();
    }

};

