//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSize>
#include <QWidget>
#include <QChildEvent>
#include <QTimerEvent>
#include <QLayout>

#include "qvboxlayoutdirector.h"
#include "qboxlayoutdirector.h"
#include "qlayoutdirector.h"
#include "qobjectdirector.h"
#include "qlayoutitemdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QVBoxLayout_staticMetaObject =
        &QVBoxLayout::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QVBoxLayout_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QVBoxLayoutDirector*>(cpp_object)->QLayout::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QVBoxLayout_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QVBoxLayoutDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QVBoxLayout_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QVBoxLayoutDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QVBoxLayout_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QVBoxLayoutDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QVBoxLayout_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QVBoxLayout*>(cpp_this)->QVBoxLayout::qt_metacast(name);
    }

    int __Qt4Ada_QVBoxLayout_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QVBoxLayout*>(cpp_this)->QVBoxLayout::qt_metacall(_c, _id, _a);
    }

}

void QVBoxLayoutDirector::addItem(QLayoutItem* item)
{
    __Qt4Ada_QLayout_addItem_0_dispatch(this->ada_object, item);
}

int QVBoxLayoutDirector::count() const
{
    return __Qt4Ada_QLayout_count_0_dispatch(this->ada_object);
}

bool QVBoxLayoutDirector::hasHeightForWidth() const
{
    return __Qt4Ada_QLayoutItem_hasHeightForWidth_0_dispatch(this->ada_object);
}

int QVBoxLayoutDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QLayoutItem_heightForWidth_0_dispatch(this->ada_object, w);
}

void QVBoxLayoutDirector::invalidate()
{
    __Qt4Ada_QLayoutItem_invalidate_0_dispatch(this->ada_object);
}

QSize QVBoxLayoutDirector::maximumSize() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_maximumSize_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

int QVBoxLayoutDirector::minimumHeightForWidth(int w) const
{
    return __Qt4Ada_QLayoutItem_minimumHeightForWidth_0_dispatch(this->ada_object, w);
}

QSize QVBoxLayoutDirector::minimumSize() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_minimumSize_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QVBoxLayoutDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

int QVBoxLayoutDirector::indexOf(QWidget* widget) const
{
    return __Qt4Ada_QLayout_indexOf_0_dispatch(this->ada_object, widget);
}

bool QVBoxLayoutDirector::isEmpty() const
{
    return __Qt4Ada_QLayoutItem_isEmpty_0_dispatch(this->ada_object);
}

void QVBoxLayoutDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

bool QVBoxLayoutDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QVBoxLayoutDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QVBoxLayoutDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QVBoxLayoutDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

QLayout* QVBoxLayoutDirector::layout()
{
    return dynamic_cast<QLayout*>(__Qt4Ada_QLayoutItem_layout_0_dispatch(this->ada_object));
}

QWidget* QVBoxLayoutDirector::widget()
{
    return dynamic_cast<QWidget*>(__Qt4Ada_QLayoutItem_widget_0_dispatch(this->ada_object));
}

const QMetaObject* QVBoxLayoutDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QVBoxLayoutDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QVBoxLayoutDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QWidget>

void QVBoxLayoutDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QVBoxLayoutDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    QObject* __Qt4Ada_new_QVBoxLayout()
    {
        return dynamic_cast<QObject*> (new QVBoxLayout);
    }

    QObject* __Qt4Ada_new_QVBoxLayout_QWidgetP(QObject* parent)
    {
        return dynamic_cast<QObject*>(new QVBoxLayout(dynamic_cast<QWidget*>(parent)));
    }

    void __Qt4Ada_QVBoxLayout_addItem_wrapper(QObject*cpp_this,QLayoutItem*_p1)
    {
    (dynamic_cast<QVBoxLayout*>(cpp_this))->QVBoxLayout::addItem(_p1);
    }

    Qt::Orientations __Qt4Ada_QVBoxLayout_expandingDirections_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QVBoxLayout*>(cpp_this))->QVBoxLayout::expandingDirections();
    }

    QLayoutItem*__Qt4Ada_QVBoxLayout_itemAt_wrapper(QObject*cpp_this,int _p1)
    {
        return (dynamic_cast<QVBoxLayout*>(cpp_this))->QVBoxLayout::itemAt(_p1);
    }

    QLayoutItem*__Qt4Ada_QVBoxLayout_takeAt_wrapper(QObject*cpp_this,int _p1)
    {
        return (dynamic_cast<QVBoxLayout*>(cpp_this))->QVBoxLayout::takeAt(_p1);
    }

    void __Qt4Ada_QVBoxLayout_setGeometry_wrapper(QObject*cpp_this,const QRect&_p1)
    {
    (dynamic_cast<QVBoxLayout*>(cpp_this))->QVBoxLayout::setGeometry(_p1);
    }

    QRect __Qt4Ada_QVBoxLayout_geometry_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QVBoxLayout*>(cpp_this))->QVBoxLayout::geometry();
    }

    int __Qt4Ada_QVBoxLayout_indexOf_wrapper(QObject*cpp_this,QObject*_p1)
    {
        return (dynamic_cast<QVBoxLayout*>(cpp_this))->QVBoxLayout::indexOf(dynamic_cast<QWidget*>(_p1));
    }

    void __Qt4Ada_QVBoxLayout_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QVBoxLayoutDirector*>(cpp_this))->QVBoxLayout::connectNotify(_p1);
    }

    void __Qt4Ada_QVBoxLayout_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QVBoxLayoutDirector*>(cpp_this))->QVBoxLayout::disconnectNotify(_p1);
    }

}
