//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QWIDGETDIRECTOR_H__
#define __QWIDGETDIRECTOR_H__

#include <QWidget>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QWidget_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern int __Qt4Ada_QWidget_heightForWidth_0_dispatch(void*, int);
    extern QVariant* __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(void*, Qt::InputMethodQuery);
    extern QSize* __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(void*);
    extern QSize* __Qt4Ada_QWidget_sizeHint_0_dispatch(void*);
    extern void __Qt4Ada_QWidget_setVisible_0_dispatch(void*, bool);
    extern void __Qt4Ada_QWidget_actionEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_changeEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_closeEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_dropEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_enterEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_focusInEvent_0_dispatch(void*, QEvent*);
    extern bool __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(void*, bool);
    extern void __Qt4Ada_QWidget_focusOutEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_hideEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_keyPressEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_leaveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_mousePressEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_moveEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_paintEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_resizeEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_showEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_tabletEvent_0_dispatch(void*, QEvent*);
    extern void __Qt4Ada_QWidget_wheelEvent_0_dispatch(void*, QEvent*);
    extern int __Qt4Ada_QWidget_metric_0_dispatch(void*, QPaintDevice::PaintDeviceMetric);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern int __Qt4Ada_QWidget_heightForWidth_0_virtual(QObject*, int);
    extern void __Qt4Ada_QWidget_inputMethodQuery_0_virtual(QObject*, Qt::InputMethodQuery, QVariant*);
    extern void __Qt4Ada_QWidget_minimumSizeHint_0_virtual(QObject*, QSize*);
    extern void __Qt4Ada_QWidget_sizeHint_0_virtual(QObject*, QSize*);
    extern void __Qt4Ada_QWidget_setVisible_0_virtual(QObject*, bool);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QWidget_acceptDrops_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_accessibleDescription_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QWidget_accessibleName_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QWidget_activateWindow_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_addAction_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QWidget_adjustSize_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_autoFillBackground_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_baseSize_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QWidget_childAt_1_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QWidget_childAt_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QWidget_childrenRect_0_wrapper(QObject*, QRect*);
    extern void __Qt4Ada_QWidget_childrenRegion_0_wrapper(QObject*, QRegion*);
    extern void __Qt4Ada_QWidget_clearFocus_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_clearMask_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_contentsRect_0_wrapper(QObject*, QRect*);
    extern Qt::ContextMenuPolicy __Qt4Ada_QWidget_contextMenuPolicy_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_cursor_0_wrapper(QObject*, QCursor*);
    extern WId __Qt4Ada_QWidget_effectiveWinId_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_ensurePolished_0_wrapper(QObject*);
    extern Qt::FocusPolicy __Qt4Ada_QWidget_focusPolicy_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QWidget_focusProxy_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QWidget_focusWidget_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_font_0_wrapper(QObject*, QFont*);
    extern QFontInfo* __Qt4Ada_QWidget_fontInfo_0_wrapper(QObject*, void*);
    extern QFontMetrics* __Qt4Ada_QWidget_fontMetrics_0_wrapper(QObject*, void*);
    extern void __Qt4Ada_QWidget_frameGeometry_0_wrapper(QObject*, QRect*);
    extern void __Qt4Ada_QWidget_frameSize_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QWidget_grabKeyboard_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_grabMouse_1_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_grabMouse_0_wrapper(QObject*, const QCursor*);
    extern bool __Qt4Ada_QWidget_hasFocus_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_hasMouseTracking_0_wrapper(QObject*);
    extern int __Qt4Ada_QWidget_height_0_wrapper(QObject*);
    extern int __Qt4Ada_QWidget_heightForWidth_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWidget_inputMethodQuery_0_wrapper(QObject*, Qt::InputMethodQuery, QVariant*);
    extern void __Qt4Ada_QWidget_insertAction_0_wrapper(QObject*, QObject*, QObject*);
    extern bool __Qt4Ada_QWidget_isActiveWindow_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_isAncestorOf_0_wrapper(QObject*, const QObject*);
    extern bool __Qt4Ada_QWidget_isEnabled_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_isEnabledTo_0_wrapper(QObject*, QObject*);
    extern bool __Qt4Ada_QWidget_isFullScreen_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_isHidden_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_isMaximized_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_isMinimized_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_isModal_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_isVisible_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_isVisibleTo_0_wrapper(QObject*, QObject*);
    extern bool __Qt4Ada_QWidget_isWindow_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_isWindowModified_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QWidget_layout_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_mapFrom_0_wrapper(QObject*, QObject*, const QPoint*, QPoint*);
    extern void __Qt4Ada_QWidget_mapFromGlobal_0_wrapper(QObject*, const QPoint*, QPoint*);
    extern void __Qt4Ada_QWidget_mapFromParent_0_wrapper(QObject*, const QPoint*, QPoint*);
    extern void __Qt4Ada_QWidget_mapTo_0_wrapper(QObject*, QObject*, const QPoint*, QPoint*);
    extern void __Qt4Ada_QWidget_mapToGlobal_0_wrapper(QObject*, const QPoint*, QPoint*);
    extern void __Qt4Ada_QWidget_mapToParent_0_wrapper(QObject*, const QPoint*, QPoint*);
    extern void __Qt4Ada_QWidget_mask_0_wrapper(QObject*, QRegion*);
    extern int __Qt4Ada_QWidget_maximumHeight_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_maximumSize_0_wrapper(QObject*, QSize*);
    extern int __Qt4Ada_QWidget_maximumWidth_0_wrapper(QObject*);
    extern int __Qt4Ada_QWidget_minimumHeight_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_minimumSize_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QWidget_minimumSizeHint_0_wrapper(QObject*, QSize*);
    extern int __Qt4Ada_QWidget_minimumWidth_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_move_1_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QWidget_move_0_wrapper(QObject*, int, int);
    extern QObject* __Qt4Ada_QWidget_nextInFocusChain_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_normalGeometry_0_wrapper(QObject*, QRect*);
    extern void __Qt4Ada_QWidget_palette_0_wrapper(QObject*, QPalette*);
    extern QObject* __Qt4Ada_QWidget_parentWidget_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_pos_0_wrapper(QObject*, QPoint*);
    extern void __Qt4Ada_QWidget_rect_0_wrapper(QObject*, QRect*);
    extern void __Qt4Ada_QWidget_releaseKeyboard_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_releaseMouse_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_removeAction_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QWidget_repaint_3_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QWidget_repaint_2_wrapper(QObject*, const QRect*);
    extern void __Qt4Ada_QWidget_repaint_1_wrapper(QObject*, const QRegion*);
    extern void __Qt4Ada_QWidget_resize_1_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QWidget_resize_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QWidget_restoreGeometry_0_wrapper(QObject*, const QByteArray*);
    extern void __Qt4Ada_QWidget_saveGeometry_0_wrapper(QObject*, QByteArray*);
    extern void __Qt4Ada_QWidget_scroll_1_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QWidget_scroll_0_wrapper(QObject*, int, int, const QRect*);
    extern void __Qt4Ada_QWidget_setAcceptDrops_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWidget_setAccessibleDescription_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWidget_setAccessibleName_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWidget_setAttribute_0_wrapper(QObject*, Qt::WidgetAttribute, bool);
    extern void __Qt4Ada_QWidget_setAutoFillBackground_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWidget_setBaseSize_1_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QWidget_setBaseSize_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QWidget_setContentsMargins_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QWidget_setContextMenuPolicy_0_wrapper(QObject*, Qt::ContextMenuPolicy);
    extern void __Qt4Ada_QWidget_setCursor_0_wrapper(QObject*, const QCursor*);
    extern void __Qt4Ada_QWidget_setFixedHeight_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWidget_setFixedSize_1_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QWidget_setFixedSize_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QWidget_setFixedWidth_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWidget_setFocus_1_wrapper(QObject*, Qt::FocusReason);
    extern void __Qt4Ada_QWidget_setFocusPolicy_0_wrapper(QObject*, Qt::FocusPolicy);
    extern void __Qt4Ada_QWidget_setFocusProxy_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QWidget_setFont_0_wrapper(QObject*, const QFont*);
    extern void __Qt4Ada_QWidget_setGeometry_1_wrapper(QObject*, const QRect*);
    extern void __Qt4Ada_QWidget_setGeometry_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QWidget_setLayout_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QWidget_setMask_0_wrapper(QObject*, const QRegion*);
    extern void __Qt4Ada_QWidget_setMaximumHeight_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWidget_setMaximumSize_1_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QWidget_setMaximumSize_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QWidget_setMaximumWidth_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWidget_setMinimumHeight_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWidget_setMinimumSize_1_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QWidget_setMinimumSize_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QWidget_setMinimumWidth_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWidget_setMouseTracking_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWidget_setPalette_0_wrapper(QObject*, const QPalette*);
    extern void __Qt4Ada_QWidget_setParent_1_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QWidget_setSizeIncrement_1_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QWidget_setSizeIncrement_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QWidget_setStatusTip_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWidget_setStyle_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QWidget_setToolTip_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWidget_setUpdatesEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWidget_setWhatsThis_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWidget_setWindowIcon_0_wrapper(QObject*, const QIcon*);
    extern void __Qt4Ada_QWidget_setWindowIconText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWidget_setWindowRole_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWidget_size_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QWidget_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QWidget_sizeIncrement_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QWidget_sizePolicy_0_wrapper(QObject*, QSizePolicy*);
    extern void __Qt4Ada_QWidget_stackUnder_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QWidget_statusTip_0_wrapper(QObject*, QString*);
    extern QObject* __Qt4Ada_QWidget_style_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_styleSheet_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QWidget_testAttribute_0_wrapper(QObject*, Qt::WidgetAttribute);
    extern void __Qt4Ada_QWidget_toolTip_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QWidget_underMouse_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_unsetCursor_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_unsetLayoutDirection_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_update_3_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QWidget_update_2_wrapper(QObject*, const QRect*);
    extern void __Qt4Ada_QWidget_update_1_wrapper(QObject*, const QRegion*);
    extern void __Qt4Ada_QWidget_updateGeometry_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_updatesEnabled_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_visibleRegion_0_wrapper(QObject*, QRegion*);
    extern void __Qt4Ada_QWidget_whatsThis_0_wrapper(QObject*, QString*);
    extern int __Qt4Ada_QWidget_width_0_wrapper(QObject*);
    extern WId __Qt4Ada_QWidget_winId_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QWidget_window_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_windowIcon_0_wrapper(QObject*, QIcon*);
    extern void __Qt4Ada_QWidget_windowIconText_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QWidget_windowRole_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QWidget_windowTitle_0_wrapper(QObject*, QString*);
    extern int __Qt4Ada_QWidget_x_0_wrapper(QObject*);
    extern int __Qt4Ada_QWidget_y_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_close_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_hide_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_lower_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_raise_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_repaint_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_setDisabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWidget_setEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWidget_setFocus_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_setHidden_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWidget_setStyleSheet_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWidget_setVisible_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWidget_setWindowModified_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWidget_setWindowTitle_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWidget_show_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_showFullScreen_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_showMaximized_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_showMinimized_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_showNormal_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_update_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QWidget_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QWidget_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QWidget_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWidget_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWidget_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QWidget_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QWidget_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QWidget_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QWidget_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWidget_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QWidget_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QWidget_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QWidget_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QPaintDevice* __QtAda_QWidget_QPaintDevice_View(QObject*);

    //  Declarations of wrapper functions for static call

    extern QPaintEngine*__Qt4Ada_QWidget_paintEngine_wrapper(QObject*);

    extern QObject* __Qt4Ada_new_QWidget(QObject*, unsigned);
    extern QObject* __Qt4Ada_new_QWidgetDirector(void*, QObject*, unsigned);
    extern void __Qt4Ada_QWidget_setSizePolicy_wrapper (QObject*     cpp_this,
                                                        QSizePolicy* value);
    extern void __Qt4Ada_QWidget_setTabOrder_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QWidget_setWindowFlags_wrapper (QObject* cpp_ths, int flags);

    extern QWidget* __QtAda_dynamic_cast_QWidget_from_QObject(QObject*);
    extern QObject* __QtAda_dynamic_cast_QObject_from_QWidget(QWidget*);

}

class QWidgetDirector : public QWidget
{
protected:
    void* ada_object;
    QWidgetDirector(void*, QWidget*, Qt::WindowFlags);

//     virtual QPaintEngine*paintEngine();
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);
    friend QObject* __Qt4Ada_new_QWidgetDirector(void*, QObject*, unsigned);

    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool event(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QWidget_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QWidget_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QWidget_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QWidget_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QWidget_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QWidget_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QWidget_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QWidget_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QWidget_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QWidget_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QWidget_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWidget_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QWidget_sender_0_wrapper(QObject*);
};

#endif // __QWIDGETDIRECTOR_H__
