//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QWIZARDPAGEDIRECTOR_H__
#define __QWIZARDPAGEDIRECTOR_H__

#include <QWizardPage>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QWizardPage_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QWizardPage_cleanupPage_0_dispatch(void*);
    extern void __Qt4Ada_QWizardPage_initializePage_0_dispatch(void*);
    extern bool __Qt4Ada_QWizardPage_isComplete_0_dispatch(void*);
    extern int __Qt4Ada_QWizardPage_nextId_0_dispatch(void*);
    extern bool __Qt4Ada_QWizardPage_validatePage_0_dispatch(void*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QWizardPage_cleanupPage_0_virtual(QObject*);
    extern void __Qt4Ada_QWizardPage_initializePage_0_virtual(QObject*);
    extern bool __Qt4Ada_QWizardPage_isComplete_0_virtual(QObject*);
    extern int __Qt4Ada_QWizardPage_nextId_0_virtual(QObject*);
    extern bool __Qt4Ada_QWizardPage_validatePage_0_virtual(QObject*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QWizardPage_buttonText_0_wrapper(QObject*, QWizard::WizardButton, QString*);
    extern void __Qt4Ada_QWizardPage_cleanupPage_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizardPage_initializePage_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWizardPage_isCommitPage_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWizardPage_isComplete_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWizardPage_isFinalPage_0_wrapper(QObject*);
    extern int __Qt4Ada_QWizardPage_nextId_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizardPage_pixmap_0_wrapper(QObject*, QWizard::WizardPixmap, QPixmap*);
    extern void __Qt4Ada_QWizardPage_setButtonText_0_wrapper(QObject*, QWizard::WizardButton, const QString*);
    extern void __Qt4Ada_QWizardPage_setCommitPage_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWizardPage_setFinalPage_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWizardPage_setPixmap_0_wrapper(QObject*, QWizard::WizardPixmap, const QPixmap*);
    extern void __Qt4Ada_QWizardPage_setSubTitle_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWizardPage_setTitle_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QWizardPage_subTitle_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QWizardPage_title_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QWizardPage_validatePage_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizardPage_completeChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizardPage_field_0_wrapper(QObject*, const QString*, QVariant*);
    extern void __Qt4Ada_QWizardPage_setField_0_wrapper(QObject*, const QString*, const QVariant*);
    extern QObject* __Qt4Ada_QWizardPage_wizard_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizardPage_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QWizardPage_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QWizardPage_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QWizardPage_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWizardPage_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWizardPage_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QWizardPage_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizardPage_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizardPage_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QWizardPage_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QWizardPage_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizardPage_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QWizardPage_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QWizardPage_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QWizardPage_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject* __Qt4Ada_new_QWizardPage(QObject*);
    extern QObject* __Qt4Ada_new_QWizardPageDirector(void*, QObject*);

}

class QWizardPageDirector : public QWizardPage
{
protected:
    void* ada_object;
public:
    QWizardPageDirector(void*, QWidget*);

    virtual void cleanupPage();
    virtual void initializePage();
    virtual bool isComplete() const;
    virtual int nextId() const;
    virtual bool validatePage();
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool event(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QWizardPage_completeChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QWizardPage_field_0_wrapper(QObject*, const QString*, QVariant*);
    friend void __Qt4Ada_QWizardPage_setField_0_wrapper(QObject*, const QString*, const QVariant*);
    friend QObject* __Qt4Ada_QWizardPage_wizard_0_wrapper(QObject*);
    friend void __Qt4Ada_QWizardPage_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QWizardPage_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QWizardPage_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QWizardPage_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QWizardPage_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QWizardPage_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QWizardPage_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QWizardPage_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QWizardPage_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QWizardPage_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QWizardPage_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizardPage_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QWizardPage_sender_0_wrapper(QObject*);
};

#endif // __QWIZARDPAGEDIRECTOR_H__
