//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QX11EMBEDCONTAINERDIRECTOR_H__
#define __QX11EMBEDCONTAINERDIRECTOR_H__

#include <QX11EmbedContainer>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QX11EmbedContainer_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern WId __Qt4Ada_QX11EmbedContainer_clientWinId_0_wrapper(QObject*);
    extern void __Qt4Ada_QX11EmbedContainer_discardClient_0_wrapper(QObject*);
    extern void __Qt4Ada_QX11EmbedContainer_embedClient_0_wrapper(QObject*, WId);
    extern QX11EmbedContainer::Error __Qt4Ada_QX11EmbedContainer_error_1_wrapper(QObject*);
    extern void __Qt4Ada_QX11EmbedContainer_clientClosed_0_wrapper(QObject*);
    extern void __Qt4Ada_QX11EmbedContainer_clientIsEmbedded_0_wrapper(QObject*);
    extern void __Qt4Ada_QX11EmbedContainer_error_0_wrapper(QObject*, QX11EmbedContainer::Error);
    extern void __Qt4Ada_QX11EmbedContainer_minimumSizeHint_0_wrapper(QObject*, QSize*);
    extern bool __Qt4Ada_QX11EmbedContainer_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_showEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QX11EmbedContainer_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QX11EmbedContainer_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QX11EmbedContainer_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QX11EmbedContainer_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QX11EmbedContainer_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QX11EmbedContainer_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QX11EmbedContainer_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QX11EmbedContainer_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QX11EmbedContainer_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QX11EmbedContainer_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QX11EmbedContainer_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QX11EmbedContainer_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QX11EmbedContainer_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QX11EmbedContainer_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject* __Qt4Ada_new_QX11EmbedContainer(QObject* parent);
    extern QObject* __Qt4Ada_new_QX11EmbedContainerDirector(void*, QObject*);

}

class QX11EmbedContainerDirector : public QX11EmbedContainer
{
protected:
    void* ada_object;
protected:
    QX11EmbedContainerDirector(void*, QWidget*);

    friend QObject* __Qt4Ada_new_QX11EmbedContainerDirector(void*, QObject*);

    virtual QSize minimumSizeHint() const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual bool event(QEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize sizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QX11EmbedContainer_clientClosed_0_wrapper(QObject*);
    friend void __Qt4Ada_QX11EmbedContainer_clientIsEmbedded_0_wrapper(QObject*);
    friend void __Qt4Ada_QX11EmbedContainer_error_0_wrapper(QObject*, QX11EmbedContainer::Error);
    friend bool __Qt4Ada_QX11EmbedContainer_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_showEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QX11EmbedContainer_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QX11EmbedContainer_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QX11EmbedContainer_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QX11EmbedContainer_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QX11EmbedContainer_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QX11EmbedContainer_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QX11EmbedContainer_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QX11EmbedContainer_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QX11EmbedContainer_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QX11EmbedContainer_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QX11EmbedContainer_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QX11EmbedContainer_sender_0_wrapper(QObject*);
};

#endif // __QX11EMBEDCONTAINERDIRECTOR_H__
