//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSize>
#include <QResizeEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QPaintEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qx11embedwidgetdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QX11EmbedWidget_staticMetaObject =
        &QX11EmbedWidget::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    WId __Qt4Ada_QX11EmbedWidget_containerWinId_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QX11EmbedWidget*>(cpp_object)->QX11EmbedWidget::containerWinId();
    }

    void __Qt4Ada_QX11EmbedWidget_embedInto_0_wrapper(QObject* cpp_object, WId id)
    {
        dynamic_cast<QX11EmbedWidget*>(cpp_object)->QX11EmbedWidget::embedInto(id);
    }

    QX11EmbedWidget::Error __Qt4Ada_QX11EmbedWidget_error_1_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QX11EmbedWidget*>(cpp_object)->QX11EmbedWidget::error();
    }

    void __Qt4Ada_QX11EmbedWidget_error_0_wrapper(QObject* cpp_object, QX11EmbedWidget::Error error)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QX11EmbedWidget::error(error);
    }

    void __Qt4Ada_QX11EmbedWidget_containerClosed_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QX11EmbedWidget::containerClosed();
    }

    void __Qt4Ada_QX11EmbedWidget_embedded_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QX11EmbedWidget::embedded();
    }

    void __Qt4Ada_QX11EmbedWidget_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QX11EmbedWidget*>(cpp_object)->QX11EmbedWidget::minimumSizeHint();
    }

    bool __Qt4Ada_QX11EmbedWidget_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QX11EmbedWidget::event(e);
    }

    bool __Qt4Ada_QX11EmbedWidget_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QX11EmbedWidget::eventFilter(watched, event);
    }

    void __Qt4Ada_QX11EmbedWidget_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QX11EmbedWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QX11EmbedWidget_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QX11EmbedWidget_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QX11EmbedWidget_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QX11EmbedWidget_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QX11EmbedWidget_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QX11EmbedWidget_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QX11EmbedWidget_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QX11EmbedWidget_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QX11EmbedWidget_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QX11EmbedWidget_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QX11EmbedWidget_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QX11EmbedWidget_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QX11EmbedWidget_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QX11EmbedWidget_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QX11EmbedWidget_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QX11EmbedWidgetDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QX11EmbedWidget_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QX11EmbedWidget*>(cpp_this)->QX11EmbedWidget::qt_metacast(name);
    }

    int __Qt4Ada_QX11EmbedWidget_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QX11EmbedWidget*>(cpp_this)->QX11EmbedWidget::qt_metacall(_c, _id, _a);
    }

}

QSize QX11EmbedWidgetDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QX11EmbedWidgetDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QX11EmbedWidgetDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QX11EmbedWidgetDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

int QX11EmbedWidgetDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QX11EmbedWidgetDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QX11EmbedWidgetDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QX11EmbedWidgetDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QX11EmbedWidgetDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QX11EmbedWidgetDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QX11EmbedWidgetDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QX11EmbedWidgetDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

void QX11EmbedWidgetDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QX11EmbedWidgetDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QX11EmbedWidgetDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QX11EmbedWidgetDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QX11EmbedWidgetDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C" {

    QObject* __Qt4Ada_new_QX11EmbedWidget(QObject* parent)
    {
        return dynamic_cast<QObject*>(new QX11EmbedWidget(dynamic_cast<QWidget*>(parent)));
    }

}
