//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QGLWIDGETDIRECTOR_H__
#define __QGLWIDGETDIRECTOR_H__

#include <QGLWidget>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QGLWidget_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QGLWidget_updateGL_0_dispatch(void*);
    extern void __Qt4Ada_QGLWidget_updateOverlayGL_0_dispatch(void*);
    extern bool __Qt4Ada_QGLWidget_autoBufferSwap_0_dispatch(void*);
    extern void __Qt4Ada_QGLWidget_glDraw_0_dispatch(void*);
    extern void __Qt4Ada_QGLWidget_glInit_0_dispatch(void*);
    extern void __Qt4Ada_QGLWidget_initializeGL_0_dispatch(void*);
    extern void __Qt4Ada_QGLWidget_initializeOverlayGL_0_dispatch(void*);
    extern void __Qt4Ada_QGLWidget_paintGL_0_dispatch(void*);
    extern void __Qt4Ada_QGLWidget_paintOverlayGL_0_dispatch(void*);
    extern void __Qt4Ada_QGLWidget_resizeGL_0_dispatch(void*, int, int);
    extern void __Qt4Ada_QGLWidget_resizeOverlayGL_0_dispatch(void*, int, int);
    extern void __Qt4Ada_QGLWidget_setAutoBufferSwap_0_dispatch(void*, bool);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QGLWidget_updateGL_0_virtual(QObject*);
    extern void __Qt4Ada_QGLWidget_updateOverlayGL_0_virtual(QObject*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QGLWidget_qglClearColor_0_wrapper(QObject*, const QColor*);
    extern void __Qt4Ada_QGLWidget_qglColor_0_wrapper(QObject*, const QColor*);
    extern void __Qt4Ada_QGLWidget_updateGL_0_wrapper(QObject*);
    extern void __Qt4Ada_QGLWidget_updateOverlayGL_0_wrapper(QObject*);
    extern bool __Qt4Ada_QGLWidget_autoBufferSwap_0_wrapper(QObject*);
    extern void __Qt4Ada_QGLWidget_glDraw_0_wrapper(QObject*);
    extern void __Qt4Ada_QGLWidget_glInit_0_wrapper(QObject*);
    extern void __Qt4Ada_QGLWidget_initializeGL_0_wrapper(QObject*);
    extern void __Qt4Ada_QGLWidget_initializeOverlayGL_0_wrapper(QObject*);
    extern void __Qt4Ada_QGLWidget_paintGL_0_wrapper(QObject*);
    extern void __Qt4Ada_QGLWidget_paintOverlayGL_0_wrapper(QObject*);
    extern void __Qt4Ada_QGLWidget_resizeGL_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QGLWidget_resizeOverlayGL_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QGLWidget_setAutoBufferSwap_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QGLWidget_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QGLWidget_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QGLWidget_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QGLWidget_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QGLWidget_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QGLWidget_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QGLWidget_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QGLWidget_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QGLWidget_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QGLWidget_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGLWidget_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QGLWidget_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QGLWidget_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QGLWidget_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C"
{

    extern QObject* __Qt4Ada_new_QGLWidgetDirector(void*, QObject*, QObject*, unsigned);

}

class QGLWidgetDirector : public QGLWidget
{
protected:
    void* ada_object;
    QGLWidgetDirector(void*, QWidget*, QGLWidget*, Qt::WindowFlags);

    friend QObject* __Qt4Ada_new_QGLWidgetDirector(void*, QObject*, QObject*, unsigned);

    virtual void updateGL();
    virtual void updateOverlayGL();
    virtual bool autoBufferSwap() const;
    virtual void glDraw();
    virtual void glInit();
    virtual void initializeGL();
    virtual void initializeOverlayGL();
    virtual void paintGL();
    virtual void paintOverlayGL();
    virtual void resizeGL(int, int);
    virtual void resizeOverlayGL(int, int);
    virtual void setAutoBufferSwap(bool);
    virtual bool event(QEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend bool __Qt4Ada_QGLWidget_autoBufferSwap_0_wrapper(QObject*);
    friend void __Qt4Ada_QGLWidget_glDraw_0_wrapper(QObject*);
    friend void __Qt4Ada_QGLWidget_glInit_0_wrapper(QObject*);
    friend void __Qt4Ada_QGLWidget_initializeGL_0_wrapper(QObject*);
    friend void __Qt4Ada_QGLWidget_initializeOverlayGL_0_wrapper(QObject*);
    friend void __Qt4Ada_QGLWidget_paintGL_0_wrapper(QObject*);
    friend void __Qt4Ada_QGLWidget_paintOverlayGL_0_wrapper(QObject*);
    friend void __Qt4Ada_QGLWidget_resizeGL_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QGLWidget_resizeOverlayGL_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QGLWidget_setAutoBufferSwap_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QGLWidget_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QGLWidget_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QGLWidget_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QGLWidget_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QGLWidget_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QGLWidget_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QGLWidget_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QGLWidget_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QGLWidget_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QGLWidget_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGLWidget_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QGLWidget_sender_0_wrapper(QObject*);
};

#endif // __QGLWIDGETDIRECTOR_H__
