------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Action_Events;
with Qt4.Child_Events;
with Qt4.Close_Events;
with Qt4.Context_Menu_Events;
with Qt4.Drag_Enter_Events;
with Qt4.Drag_Leave_Events;
with Qt4.Drag_Move_Events;
with Qt4.Drop_Events;
with Qt4.Events;
with Qt4.Focus_Events;
with Qt4.Hide_Events;
with Qt4.Input_Method_Events;
with Qt4.Key_Events;
with Qt4.Mouse_Events;
with Qt4.Move_Events;
with Qt4.Paint_Events;
with Qt4.Resize_Events;
with Qt4.Show_Events;
with Qt4.Tablet_Events;
with Qt4.Timer_Events;
with Qt4.Wheel_Events;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.GL_Widgets.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QGLWidget_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QGLWidget_qt_metacast_wrapper");

   procedure updateGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access);
   pragma Export (C, updateGL_0_dispatch,
                     "__Qt4Ada_QGLWidget_updateGL_0_dispatch");
   pragma Warnings (Off, updateGL_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure updateGL_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, updateGL_0_wrapper,
                     "__Qt4Ada_QGLWidget_updateGL_0_wrapper");

   procedure updateOverlayGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access);
   pragma Export (C, updateOverlayGL_0_dispatch,
                     "__Qt4Ada_QGLWidget_updateOverlayGL_0_dispatch");
   pragma Warnings (Off, updateOverlayGL_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure updateOverlayGL_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, updateOverlayGL_0_wrapper,
                     "__Qt4Ada_QGLWidget_updateOverlayGL_0_wrapper");

   function autoBufferSwap_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
       return Qt4.bool;
   pragma Export (C, autoBufferSwap_0_dispatch,
                     "__Qt4Ada_QGLWidget_autoBufferSwap_0_dispatch");
   pragma Warnings (Off, autoBufferSwap_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   function autoBufferSwap_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, autoBufferSwap_0_wrapper,
                     "__Qt4Ada_QGLWidget_autoBufferSwap_0_wrapper");

   procedure glDraw_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access);
   pragma Export (C, glDraw_0_dispatch,
                     "__Qt4Ada_QGLWidget_glDraw_0_dispatch");
   pragma Warnings (Off, glDraw_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure glDraw_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, glDraw_0_wrapper,
                     "__Qt4Ada_QGLWidget_glDraw_0_wrapper");

   procedure glInit_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access);
   pragma Export (C, glInit_0_dispatch,
                     "__Qt4Ada_QGLWidget_glInit_0_dispatch");
   pragma Warnings (Off, glInit_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure glInit_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, glInit_0_wrapper,
                     "__Qt4Ada_QGLWidget_glInit_0_wrapper");

   procedure initializeGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access);
   pragma Export (C, initializeGL_0_dispatch,
                     "__Qt4Ada_QGLWidget_initializeGL_0_dispatch");
   pragma Warnings (Off, initializeGL_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure initializeGL_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, initializeGL_0_wrapper,
                     "__Qt4Ada_QGLWidget_initializeGL_0_wrapper");

   procedure initializeOverlayGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access);
   pragma Export (C, initializeOverlayGL_0_dispatch,
                     "__Qt4Ada_QGLWidget_initializeOverlayGL_0_dispatch");
   pragma Warnings (Off, initializeOverlayGL_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure initializeOverlayGL_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, initializeOverlayGL_0_wrapper,
                     "__Qt4Ada_QGLWidget_initializeOverlayGL_0_wrapper");

   procedure paintGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access);
   pragma Export (C, paintGL_0_dispatch,
                     "__Qt4Ada_QGLWidget_paintGL_0_dispatch");
   pragma Warnings (Off, paintGL_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure paintGL_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, paintGL_0_wrapper,
                     "__Qt4Ada_QGLWidget_paintGL_0_wrapper");

   procedure paintOverlayGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access);
   pragma Export (C, paintOverlayGL_0_dispatch,
                     "__Qt4Ada_QGLWidget_paintOverlayGL_0_dispatch");
   pragma Warnings (Off, paintOverlayGL_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure paintOverlayGL_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, paintOverlayGL_0_wrapper,
                     "__Qt4Ada_QGLWidget_paintOverlayGL_0_wrapper");

   procedure resizeGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Width : Qt4.Q_Integer;
     Height : Qt4.Q_Integer);
   pragma Export (C, resizeGL_0_dispatch,
                     "__Qt4Ada_QGLWidget_resizeGL_0_dispatch");
   pragma Warnings (Off, resizeGL_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure resizeGL_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Width : Qt4.Q_Integer;
     Height : Qt4.Q_Integer);
   pragma Import (C, resizeGL_0_wrapper,
                     "__Qt4Ada_QGLWidget_resizeGL_0_wrapper");

   procedure resizeOverlayGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Width : Qt4.Q_Integer;
     Height : Qt4.Q_Integer);
   pragma Export (C, resizeOverlayGL_0_dispatch,
                     "__Qt4Ada_QGLWidget_resizeOverlayGL_0_dispatch");
   pragma Warnings (Off, resizeOverlayGL_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure resizeOverlayGL_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Width : Qt4.Q_Integer;
     Height : Qt4.Q_Integer);
   pragma Import (C, resizeOverlayGL_0_wrapper,
                     "__Qt4Ada_QGLWidget_resizeOverlayGL_0_wrapper");

   procedure setAutoBufferSwap_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     On : Qt4.bool);
   pragma Export (C, setAutoBufferSwap_0_dispatch,
                     "__Qt4Ada_QGLWidget_setAutoBufferSwap_0_dispatch");
   pragma Warnings (Off, setAutoBufferSwap_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure setAutoBufferSwap_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     On : Qt4.bool);
   pragma Import (C, setAutoBufferSwap_0_wrapper,
                     "__Qt4Ada_QGLWidget_setAutoBufferSwap_0_wrapper");

   function event_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     E : not null access Qt_Ada.Internals.Events.QEvent)
       return Qt4.bool;
   pragma Import (C, event_0_wrapper,
                     "__Qt4Ada_QGLWidget_event_0_wrapper");

   procedure paintEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, paintEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_paintEvent_0_wrapper");

   procedure resizeEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, resizeEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_resizeEvent_0_wrapper");

   procedure customContextMenuRequested_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint);
   pragma Import (C, customContextMenuRequested_0_wrapper,
                     "__Qt4Ada_QGLWidget_customContextMenuRequested_0_wrapper");

   procedure actionEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, actionEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_actionEvent_0_wrapper");

   procedure changeEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, changeEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_changeEvent_0_wrapper");

   procedure closeEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, closeEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_closeEvent_0_wrapper");

   procedure contextMenuEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, contextMenuEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_contextMenuEvent_0_wrapper");

   procedure dragEnterEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragEnterEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_dragEnterEvent_0_wrapper");

   procedure dragLeaveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragLeaveEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_dragLeaveEvent_0_wrapper");

   procedure dragMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragMoveEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_dragMoveEvent_0_wrapper");

   procedure dropEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dropEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_dropEvent_0_wrapper");

   procedure enterEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, enterEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_enterEvent_0_wrapper");

   procedure focusInEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, focusInEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_focusInEvent_0_wrapper");

   function focusNextChild_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, focusNextChild_0_wrapper,
                     "__Qt4Ada_QGLWidget_focusNextChild_0_wrapper");

   function focusNextPrevChild_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Next : Qt4.bool)
       return Qt4.bool;
   pragma Import (C, focusNextPrevChild_0_wrapper,
                     "__Qt4Ada_QGLWidget_focusNextPrevChild_0_wrapper");

   procedure focusOutEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, focusOutEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_focusOutEvent_0_wrapper");

   function focusPreviousChild_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, focusPreviousChild_0_wrapper,
                     "__Qt4Ada_QGLWidget_focusPreviousChild_0_wrapper");

   procedure hideEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, hideEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_hideEvent_0_wrapper");

   procedure inputMethodEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, inputMethodEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_inputMethodEvent_0_wrapper");

   procedure keyPressEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, keyPressEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_keyPressEvent_0_wrapper");

   procedure keyReleaseEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, keyReleaseEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_keyReleaseEvent_0_wrapper");

   procedure leaveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, leaveEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_leaveEvent_0_wrapper");

   procedure mouseDoubleClickEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseDoubleClickEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_mouseDoubleClickEvent_0_wrapper");

   procedure mouseMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseMoveEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_mouseMoveEvent_0_wrapper");

   procedure mousePressEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mousePressEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_mousePressEvent_0_wrapper");

   procedure mouseReleaseEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseReleaseEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_mouseReleaseEvent_0_wrapper");

   procedure moveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, moveEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_moveEvent_0_wrapper");

   procedure resetInputContext_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, resetInputContext_0_wrapper,
                     "__Qt4Ada_QGLWidget_resetInputContext_0_wrapper");

   procedure showEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, showEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_showEvent_0_wrapper");

   procedure tabletEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, tabletEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_tabletEvent_0_wrapper");

   procedure wheelEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, wheelEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_wheelEvent_0_wrapper");

   function metric_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Metric : Qt4.Paint_Devices.Paint_Device_Metric)
       return Qt4.Q_Integer;
   pragma Import (C, metric_0_wrapper,
                     "__Qt4Ada_QGLWidget_metric_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_customEvent_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QGLWidget_timerEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QGLWidget_sender_0_wrapper");

   ------------------
   -- Constructors --
   ------------------

   package body Constructors is

      function new_QGLWidgetDirector
       (Object       : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
        Parent       : access Qt_Ada.Internals.Objects.QObject;
        Share_Widget : access Qt_Ada.Internals.Objects.QObject;
        Flags        : Qt4.Window_Flags)
          return not null Qt_Ada.Internals.Objects.QObject_Access;
      pragma Import
       (C, new_QGLWidgetDirector, "__Qt4Ada_new_QGLWidgetDirector");
      pragma Warnings (Off, new_QGLWidgetDirector);

      ----------------
      -- Initialize --
      ----------------

      procedure Initialize
       (Self         : not null access Q_GL_Widget_Director'Class;
        Parent       : access Qt4.Widgets.Q_Widget'Class := null;
        Share_Widget : access Qt4.GL_Widgets.Q_GL_Widget'Class := null;
        Flags        : Qt4.Window_Flags := +Qt4.Widget)
      is
         Director : constant not null Qt_Ada.Internals.Objects.QObject_Access
           := new_QGLWidgetDirector
               (Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self),
                Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
                 (Parent),
                Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
                 (Share_Widget),
                Flags);

      begin
         Qt_Ada.Internals.Objects.Initialize (Self, Director);
      end Initialize;

   end Constructors;

   pragma Style_Checks ("N");

   -------------------------
   -- updateGL_0_dispatch --
   -------------------------

   procedure updateGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Update_GL;
   end updateGL_0_dispatch;

   ---------------
   -- Update_GL --
   ---------------

   overriding
   procedure Update_GL
    (Self : not null access Q_GL_Widget_Director)
   is
   begin
      updateGL_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View);
   end Update_GL;

   --------------------------------
   -- updateOverlayGL_0_dispatch --
   --------------------------------

   procedure updateOverlayGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Update_Overlay_GL;
   end updateOverlayGL_0_dispatch;

   -----------------------
   -- Update_Overlay_GL --
   -----------------------

   overriding
   procedure Update_Overlay_GL
    (Self : not null access Q_GL_Widget_Director)
   is
   begin
      updateOverlayGL_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View);
   end Update_Overlay_GL;

   -------------------------------
   -- autoBufferSwap_0_dispatch --
   -------------------------------

   function autoBufferSwap_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
       return Qt4.bool
   is
   begin
      return
        Qt4.To_bool
         (Q_GL_Widget_Director'Class (Self.all).Auto_Buffer_Swap);
   end autoBufferSwap_0_dispatch;

   ----------------------
   -- Auto_Buffer_Swap --
   ----------------------

   not overriding
   function Auto_Buffer_Swap
    (Self : not null access constant Q_GL_Widget_Director)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (autoBufferSwap_0_wrapper
           (Q_GL_Widget_Director'Class (Self.all).QObject_View));
   end Auto_Buffer_Swap;

   -----------------------
   -- glDraw_0_dispatch --
   -----------------------

   procedure glDraw_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Gl_Draw;
   end glDraw_0_dispatch;

   -------------
   -- Gl_Draw --
   -------------

   not overriding
   procedure Gl_Draw
    (Self : not null access Q_GL_Widget_Director)
   is
   begin
      glDraw_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View);
   end Gl_Draw;

   -----------------------
   -- glInit_0_dispatch --
   -----------------------

   procedure glInit_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Gl_Init;
   end glInit_0_dispatch;

   -------------
   -- Gl_Init --
   -------------

   not overriding
   procedure Gl_Init
    (Self : not null access Q_GL_Widget_Director)
   is
   begin
      glInit_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View);
   end Gl_Init;

   -----------------------------
   -- initializeGL_0_dispatch --
   -----------------------------

   procedure initializeGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Initialize_GL;
   end initializeGL_0_dispatch;

   -------------------
   -- Initialize_GL --
   -------------------

   not overriding
   procedure Initialize_GL
    (Self : not null access Q_GL_Widget_Director)
   is
   begin
      initializeGL_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View);
   end Initialize_GL;

   ------------------------------------
   -- initializeOverlayGL_0_dispatch --
   ------------------------------------

   procedure initializeOverlayGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Initialize_Overlay_GL;
   end initializeOverlayGL_0_dispatch;

   ---------------------------
   -- Initialize_Overlay_GL --
   ---------------------------

   not overriding
   procedure Initialize_Overlay_GL
    (Self : not null access Q_GL_Widget_Director)
   is
   begin
      initializeOverlayGL_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View);
   end Initialize_Overlay_GL;

   ------------------------
   -- paintGL_0_dispatch --
   ------------------------

   procedure paintGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Paint_GL;
   end paintGL_0_dispatch;

   --------------
   -- Paint_GL --
   --------------

   not overriding
   procedure Paint_GL
    (Self : not null access Q_GL_Widget_Director)
   is
   begin
      paintGL_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View);
   end Paint_GL;

   -------------------------------
   -- paintOverlayGL_0_dispatch --
   -------------------------------

   procedure paintOverlayGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Paint_Overlay_GL;
   end paintOverlayGL_0_dispatch;

   ----------------------
   -- Paint_Overlay_GL --
   ----------------------

   not overriding
   procedure Paint_Overlay_GL
    (Self : not null access Q_GL_Widget_Director)
   is
   begin
      paintOverlayGL_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View);
   end Paint_Overlay_GL;

   -------------------------
   -- resizeGL_0_dispatch --
   -------------------------

   procedure resizeGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Width : Qt4.Q_Integer;
     Height : Qt4.Q_Integer)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Resize_GL
       (Width,
        Height);
   end resizeGL_0_dispatch;

   ---------------
   -- Resize_GL --
   ---------------

   not overriding
   procedure Resize_GL
    (Self : not null access Q_GL_Widget_Director;
     Width : Qt4.Q_Integer;
     Height : Qt4.Q_Integer)
   is
   begin
      resizeGL_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Width,
        Height);
   end Resize_GL;

   --------------------------------
   -- resizeOverlayGL_0_dispatch --
   --------------------------------

   procedure resizeOverlayGL_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Width : Qt4.Q_Integer;
     Height : Qt4.Q_Integer)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Resize_Overlay_GL
       (Width,
        Height);
   end resizeOverlayGL_0_dispatch;

   -----------------------
   -- Resize_Overlay_GL --
   -----------------------

   not overriding
   procedure Resize_Overlay_GL
    (Self : not null access Q_GL_Widget_Director;
     Width : Qt4.Q_Integer;
     Height : Qt4.Q_Integer)
   is
   begin
      resizeOverlayGL_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Width,
        Height);
   end Resize_Overlay_GL;

   ----------------------------------
   -- setAutoBufferSwap_0_dispatch --
   ----------------------------------

   procedure setAutoBufferSwap_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     On : Qt4.bool)
   is
   begin
      Q_GL_Widget_Director'Class (Self.all).Set_Auto_Buffer_Swap
       (Qt4.To_Boolean (On));
   end setAutoBufferSwap_0_dispatch;

   --------------------------
   -- Set_Auto_Buffer_Swap --
   --------------------------

   not overriding
   procedure Set_Auto_Buffer_Swap
    (Self : not null access Q_GL_Widget_Director;
     On : Standard.Boolean)
   is
   begin
      setAutoBufferSwap_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Qt4.To_bool (On));
   end Set_Auto_Buffer_Swap;

   -----------
   -- Event --
   -----------

   overriding
   function Event
    (Self : not null access Q_GL_Widget_Director;
     E : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (event_0_wrapper
           (Q_GL_Widget_Director'Class (Self.all).QObject_View,
            E.QEvent_View));
   end Event;

   -----------------
   -- Paint_Event --
   -----------------

   overriding
   procedure Paint_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Paint_Events.Q_Paint_Event'Class)
   is
   begin
      paintEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Paint_Event;

   ------------------
   -- Resize_Event --
   ------------------

   overriding
   procedure Resize_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Resize_Events.Q_Resize_Event'Class)
   is
   begin
      resizeEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Resize_Event;

   ----------------------------------------
   -- Emit_Custom_Context_Menu_Requested --
   ----------------------------------------

   overriding
   procedure Emit_Custom_Context_Menu_Requested
    (Self : not null access Q_GL_Widget_Director;
     Pos : Qt4.Points.Q_Point)
   is
   begin
      customContextMenuRequested_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Qt4.Points.Internals.QPoint_View (Pos));
   end Emit_Custom_Context_Menu_Requested;

   ------------------
   -- Action_Event --
   ------------------

   overriding
   procedure Action_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Action_Events.Q_Action_Event'Class)
   is
   begin
      actionEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Action_Event;

   ------------------
   -- Change_Event --
   ------------------

   overriding
   procedure Change_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      changeEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Change_Event;

   -----------------
   -- Close_Event --
   -----------------

   overriding
   procedure Close_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Close_Events.Q_Close_Event'Class)
   is
   begin
      closeEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Close_Event;

   ------------------------
   -- Context_Menu_Event --
   ------------------------

   overriding
   procedure Context_Menu_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Context_Menu_Events.Q_Context_Menu_Event'Class)
   is
   begin
      contextMenuEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Context_Menu_Event;

   ----------------------
   -- Drag_Enter_Event --
   ----------------------

   overriding
   procedure Drag_Enter_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Drag_Enter_Events.Q_Drag_Enter_Event'Class)
   is
   begin
      dragEnterEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drag_Enter_Event;

   ----------------------
   -- Drag_Leave_Event --
   ----------------------

   overriding
   procedure Drag_Leave_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Drag_Leave_Events.Q_Drag_Leave_Event'Class)
   is
   begin
      dragLeaveEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drag_Leave_Event;

   ---------------------
   -- Drag_Move_Event --
   ---------------------

   overriding
   procedure Drag_Move_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Drag_Move_Events.Q_Drag_Move_Event'Class)
   is
   begin
      dragMoveEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drag_Move_Event;

   ----------------
   -- Drop_Event --
   ----------------

   overriding
   procedure Drop_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Drop_Events.Q_Drop_Event'Class)
   is
   begin
      dropEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drop_Event;

   -----------------
   -- Enter_Event --
   -----------------

   overriding
   procedure Enter_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      enterEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Enter_Event;

   --------------------
   -- Focus_In_Event --
   --------------------

   overriding
   procedure Focus_In_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class)
   is
   begin
      focusInEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Focus_In_Event;

   ----------------------
   -- Focus_Next_Child --
   ----------------------

   overriding
   function Focus_Next_Child
    (Self : not null access Q_GL_Widget_Director)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (focusNextChild_0_wrapper
           (Q_GL_Widget_Director'Class (Self.all).QObject_View));
   end Focus_Next_Child;

   ---------------------------
   -- Focus_Next_Prev_Child --
   ---------------------------

   overriding
   function Focus_Next_Prev_Child
    (Self : not null access Q_GL_Widget_Director;
     Next : Standard.Boolean)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (focusNextPrevChild_0_wrapper
           (Q_GL_Widget_Director'Class (Self.all).QObject_View,
            Qt4.To_bool (Next)));
   end Focus_Next_Prev_Child;

   ---------------------
   -- Focus_Out_Event --
   ---------------------

   overriding
   procedure Focus_Out_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class)
   is
   begin
      focusOutEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Focus_Out_Event;

   --------------------------
   -- Focus_Previous_Child --
   --------------------------

   overriding
   function Focus_Previous_Child
    (Self : not null access Q_GL_Widget_Director)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (focusPreviousChild_0_wrapper
           (Q_GL_Widget_Director'Class (Self.all).QObject_View));
   end Focus_Previous_Child;

   ----------------
   -- Hide_Event --
   ----------------

   overriding
   procedure Hide_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Hide_Events.Q_Hide_Event'Class)
   is
   begin
      hideEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Hide_Event;

   ------------------------
   -- Input_Method_Event --
   ------------------------

   overriding
   procedure Input_Method_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Input_Method_Events.Q_Input_Method_Event'Class)
   is
   begin
      inputMethodEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Input_Method_Event;

   ---------------------
   -- Key_Press_Event --
   ---------------------

   overriding
   procedure Key_Press_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class)
   is
   begin
      keyPressEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Key_Press_Event;

   -----------------------
   -- Key_Release_Event --
   -----------------------

   overriding
   procedure Key_Release_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class)
   is
   begin
      keyReleaseEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Key_Release_Event;

   -----------------
   -- Leave_Event --
   -----------------

   overriding
   procedure Leave_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      leaveEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Leave_Event;

   ------------------------------
   -- Mouse_Double_Click_Event --
   ------------------------------

   overriding
   procedure Mouse_Double_Click_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class)
   is
   begin
      mouseDoubleClickEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Double_Click_Event;

   ----------------------
   -- Mouse_Move_Event --
   ----------------------

   overriding
   procedure Mouse_Move_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class)
   is
   begin
      mouseMoveEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Move_Event;

   -----------------------
   -- Mouse_Press_Event --
   -----------------------

   overriding
   procedure Mouse_Press_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class)
   is
   begin
      mousePressEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Press_Event;

   -------------------------
   -- Mouse_Release_Event --
   -------------------------

   overriding
   procedure Mouse_Release_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Mouse_Events.Q_Mouse_Event'Class)
   is
   begin
      mouseReleaseEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Release_Event;

   ----------------
   -- Move_Event --
   ----------------

   overriding
   procedure Move_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Move_Events.Q_Move_Event'Class)
   is
   begin
      moveEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Move_Event;

   -------------------------
   -- Reset_Input_Context --
   -------------------------

   overriding
   procedure Reset_Input_Context
    (Self : not null access Q_GL_Widget_Director)
   is
   begin
      resetInputContext_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View);
   end Reset_Input_Context;

   ----------------
   -- Show_Event --
   ----------------

   overriding
   procedure Show_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Show_Events.Q_Show_Event'Class)
   is
   begin
      showEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Show_Event;

   ------------------
   -- Tablet_Event --
   ------------------

   overriding
   procedure Tablet_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Tablet_Events.Q_Tablet_Event'Class)
   is
   begin
      tabletEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Tablet_Event;

   -----------------
   -- Wheel_Event --
   -----------------

   overriding
   procedure Wheel_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Wheel_Events.Q_Wheel_Event'Class)
   is
   begin
      wheelEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Wheel_Event;

   ------------
   -- Metric --
   ------------

   overriding
   function Metric
    (Self : not null access constant Q_GL_Widget_Director;
     Metric : Qt4.Paint_Devices.Paint_Device_Metric)
       return Qt4.Q_Integer
   is
   begin
      return
        metric_0_wrapper
         (Q_GL_Widget_Director'Class (Self.all).QObject_View,
          Metric);
   end Metric;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_GL_Widget_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_GL_Widget_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_GL_Widget_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_GL_Widget_Director'Class (Self.all).QObject_View));
   end Sender;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QGLWidget", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.GL_Widgets.Directors;
