//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QSqlDatabase>
#include <QSqlError>
#include <QSqlIndex>
#include <QSqlQuery>
#include <QSqlRecord>
#include <QString>
#include <QStringList>
#include "qsqldatabasewrapper.h"

extern "C"
{

    QSqlDatabase* __QtAda_inititialize_QSqlDatabase(void* storage)
    {
        return new (storage) QSqlDatabase();
    }

    QSqlDatabase* __QtAda_adjust_QSqlDatabase(void* storage, const QSqlDatabase* from)
    {
        return new (storage) QSqlDatabase(*from);
    }

    void __QtAda_finalize_QSqlDatabase(QSqlDatabase *item)
    {
        item->~QSqlDatabase();
    }

    void __QtAda_QSqlDatabase_close(QSqlDatabase* self)
    {
        self->close();
    }

    unsigned __QtAda_QSqlDatabase_commit(QSqlDatabase* self)
    {
        return (unsigned)self->commit();
    }

    void __QtAda_QSqlDatabase_connectOptions_Q(QString* returns, const QSqlDatabase* self)
    {
        *returns = self->connectOptions();
    }

    void __QtAda_QSqlDatabase_connectionName_Q(QString* returns, const QSqlDatabase* self)
    {
        *returns = self->connectionName();
    }

    void __QtAda_QSqlDatabase_databaseName_Q(QString* returns, const QSqlDatabase* self)
    {
        *returns = self->databaseName();
    }

    void __QtAda_QSqlDatabase_driverName_Q(QString* returns, const QSqlDatabase* self)
    {
        *returns = self->driverName();
    }

    void __QtAda_QSqlDatabase_exec_QStringCR_Q(QSqlQuery* returns, const QSqlDatabase* self, const QString* query)
    {
        *returns = self->exec(*query);
    }

    void __QtAda_QSqlDatabase_hostName_Q(QString* returns, const QSqlDatabase* self)
    {
        *returns = self->hostName();
    }

    unsigned __QtAda_QSqlDatabase_isOpen_Q(const QSqlDatabase* self)
    {
        return (unsigned)self->isOpen();
    }

    unsigned __QtAda_QSqlDatabase_isOpenError_Q(const QSqlDatabase* self)
    {
        return (unsigned)self->isOpenError();
    }

    unsigned __QtAda_QSqlDatabase_isValid_Q(const QSqlDatabase* self)
    {
        return (unsigned)self->isValid();
    }

    void __QtAda_QSqlDatabase_lastError_Q(QSqlError* returns, const QSqlDatabase* self)
    {
        *returns = self->lastError();
    }

    unsigned __QtAda_QSqlDatabase_open(QSqlDatabase* self)
    {
        return (unsigned)self->open();
    }

    unsigned __QtAda_QSqlDatabase_open_QStringCR_QStringCR(QSqlDatabase* self, const QString* user, const QString* password)
    {
        return (unsigned)self->open(*user, *password);
    }

    void __QtAda_QSqlDatabase_password_Q(QString* returns, const QSqlDatabase* self)
    {
        *returns = self->password();
    }

    int __QtAda_QSqlDatabase_port_Q(const QSqlDatabase* self)
    {
        return self->port();
    }

    void __QtAda_QSqlDatabase_primaryIndex_QStringCR_Q(QSqlRecord* returns, const QSqlDatabase* self, const QString* tablename)
    {
        *static_cast<QSqlIndex*>(returns) = self->primaryIndex(*tablename);
    }

    void __QtAda_QSqlDatabase_record_QStringCR_Q(QSqlRecord* returns, const QSqlDatabase* self, const QString* tablename)
    {
        *returns = self->record(*tablename);
    }

    unsigned __QtAda_QSqlDatabase_rollback(QSqlDatabase* self)
    {
        return (unsigned)self->rollback();
    }

    void __QtAda_QSqlDatabase_setConnectOptions_QStringCR(QSqlDatabase* self, const QString* options)
    {
        self->setConnectOptions(*options);
    }

    void __QtAda_QSqlDatabase_setDatabaseName_QStringCR(QSqlDatabase* self, const QString* name)
    {
        self->setDatabaseName(*name);
    }

    void __QtAda_QSqlDatabase_setHostName_QStringCR(QSqlDatabase* self, const QString* host)
    {
        self->setHostName(*host);
    }

    void __QtAda_QSqlDatabase_setPassword_QStringCR(QSqlDatabase* self, const QString* password)
    {
        self->setPassword(*password);
    }

    void __QtAda_QSqlDatabase_setPort_int(QSqlDatabase* self, int port)
    {
        self->setPort(port);
    }

    void __QtAda_QSqlDatabase_setUserName_QStringCR(QSqlDatabase* self, const QString* name)
    {
        self->setUserName(*name);
    }

    void __QtAda_QSqlDatabase_tables_TableType_Q(QStringList* returns, const QSqlDatabase* self, unsigned the_type)
    {
        *returns = self->tables((QSql::TableType)the_type);
    }

    unsigned __QtAda_QSqlDatabase_transaction(QSqlDatabase* self)
    {
        return (unsigned)self->transaction();
    }

    void __QtAda_QSqlDatabase_userName_Q(QString* returns, const QSqlDatabase* self)
    {
        *returns = self->userName();
    }

    void __QtAda_QSqlDatabase_defaultConnection_S(QString* returns)
    {
        *returns = QLatin1String(QSqlDatabase::defaultConnection);
    }

    void __QtAda_QSqlDatabase_addDatabase_QStringCR_QStringCR_S(QSqlDatabase* returns, const QString* the_type, const QString* connectionName)
    {
        *returns = QSqlDatabase::addDatabase(*the_type, *connectionName);
    }

    void __QtAda_QSqlDatabase_cloneDatabase_QSqlDatabaseCR_QStringCR_S(const QSqlDatabase* other, const QString* connectionName)
    {
        QSqlDatabase::cloneDatabase(*other, *connectionName);
    }

    void __QtAda_QSqlDatabase_connectionNames_S(QStringList* returns)
    {
        *returns = QSqlDatabase::connectionNames();
    }

    unsigned __QtAda_QSqlDatabase_contains_QStringCR_S(const QString* connectionName)
    {
        return (unsigned)QSqlDatabase::contains(*connectionName);
    }

    void __QtAda_QSqlDatabase_database_QStringCR_bool_S(QSqlDatabase* returns, const QString* connectionName, unsigned open)
    {
        *returns = QSqlDatabase::database(*connectionName, (bool)open);
    }

    void __QtAda_QSqlDatabase_drivers_S(QStringList* returns)
    {
        *returns = QSqlDatabase::drivers();
    }

    unsigned __QtAda_QSqlDatabase_isDriverAvailable_QStringCR_S(const QString* name)
    {
        return (unsigned)QSqlDatabase::isDriverAvailable(*name);
    }

    void __QtAda_QSqlDatabase_removeDatabase_QStringCR_S(const QString* connectionName)
    {
        QSqlDatabase::removeDatabase(*connectionName);
    }

};

