//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QSqlDatabase>

extern "C"
{
    extern QSqlDatabase* __QtAda_inititialize_QSqlDatabase(void*);
    extern QSqlDatabase* __QtAda_adjust_QSqlDatabase(void*, const QSqlDatabase*);
    extern void __QtAda_finalize_QSqlDatabase(QSqlDatabase*);

    extern void __QtAda_QSqlDatabase_close(QSqlDatabase*);
    extern unsigned __QtAda_QSqlDatabase_commit(QSqlDatabase*);
    extern void __QtAda_QSqlDatabase_connectOptions_Q(QString*, const QSqlDatabase*);
    extern void __QtAda_QSqlDatabase_connectionName_Q(QString*, const QSqlDatabase*);
    extern void __QtAda_QSqlDatabase_databaseName_Q(QString*, const QSqlDatabase*);
    extern void __QtAda_QSqlDatabase_driverName_Q(QString*, const QSqlDatabase*);
    extern void __QtAda_QSqlDatabase_exec_QStringCR_Q(QSqlQuery*, const QSqlDatabase*, const QString*);
    extern void __QtAda_QSqlDatabase_hostName_Q(QString*, const QSqlDatabase*);
    extern unsigned __QtAda_QSqlDatabase_isOpen_Q(const QSqlDatabase*);
    extern unsigned __QtAda_QSqlDatabase_isOpenError_Q(const QSqlDatabase*);
    extern unsigned __QtAda_QSqlDatabase_isValid_Q(const QSqlDatabase*);
    extern void __QtAda_QSqlDatabase_lastError_Q(QSqlError*, const QSqlDatabase*);
    extern unsigned __QtAda_QSqlDatabase_open(QSqlDatabase*);
    extern unsigned __QtAda_QSqlDatabase_open_QStringCR_QStringCR(QSqlDatabase*, const QString*, const QString*);
    extern void __QtAda_QSqlDatabase_password_Q(QString*, const QSqlDatabase*);
    extern int __QtAda_QSqlDatabase_port_Q(const QSqlDatabase*);
    extern void __QtAda_QSqlDatabase_primaryIndex_QStringCR_Q(QSqlRecord*, const QSqlDatabase*, const QString*);
    extern void __QtAda_QSqlDatabase_record_QStringCR_Q(QSqlRecord*, const QSqlDatabase*, const QString*);
    extern unsigned __QtAda_QSqlDatabase_rollback(QSqlDatabase*);
    extern void __QtAda_QSqlDatabase_setConnectOptions_QStringCR(QSqlDatabase*, const QString*);
    extern void __QtAda_QSqlDatabase_setDatabaseName_QStringCR(QSqlDatabase*, const QString*);
    extern void __QtAda_QSqlDatabase_setHostName_QStringCR(QSqlDatabase*, const QString*);
    extern void __QtAda_QSqlDatabase_setPassword_QStringCR(QSqlDatabase*, const QString*);
    extern void __QtAda_QSqlDatabase_setPort_int(QSqlDatabase*, int);
    extern void __QtAda_QSqlDatabase_setUserName_QStringCR(QSqlDatabase*, const QString*);
    extern void __QtAda_QSqlDatabase_tables_TableType_Q(QStringList*, const QSqlDatabase*, unsigned);
    extern unsigned __QtAda_QSqlDatabase_transaction(QSqlDatabase*);
    extern void __QtAda_QSqlDatabase_userName_Q(QString*, const QSqlDatabase*);
    extern void __QtAda_QSqlDatabase_defaultConnection_S(QString*);
    extern void __QtAda_QSqlDatabase_addDatabase_QStringCR_QStringCR_S(QSqlDatabase*, const QString*, const QString*);
    extern void __QtAda_QSqlDatabase_cloneDatabase_QSqlDatabaseCR_QStringCR_S(const QSqlDatabase*, const QString*);
    extern void __QtAda_QSqlDatabase_connectionNames_S(QStringList*);
    extern unsigned __QtAda_QSqlDatabase_contains_QStringCR_S(const QString*);
    extern void __QtAda_QSqlDatabase_database_QStringCR_bool_S(QSqlDatabase*, const QString*, unsigned);
    extern void __QtAda_QSqlDatabase_drivers_S(QStringList*);
    extern unsigned __QtAda_QSqlDatabase_isDriverAvailable_QStringCR_S(const QString*);
    extern void __QtAda_QSqlDatabase_removeDatabase_QStringCR_S(const QString*);

};

