//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include "qsqlerrorwrapper.h"

extern "C"
{

    QSqlError* __QtAda_inititialize_QSqlError(void* storage)
    {
        return new (storage) QSqlError();
    }

    QSqlError* __QtAda_inititialize_QSqlError_QStringCR_QStringCR_ErrorType_int(void* storage, const QString* driverText, const QString* databaseText, unsigned the_type, int number)
    {
        return new (storage) QSqlError(*driverText, *databaseText, (QSqlError::ErrorType)the_type, number);
    }

    QSqlError* __QtAda_adjust_QSqlError(void* storage, const QSqlError* from)
    {
        return new (storage) QSqlError(*from);
    }

    void __QtAda_finalize_QSqlError(QSqlError *item)
    {
        item->~QSqlError();
    }

    void __QtAda_QSqlError_databaseText_Q(QString* returns, const QSqlError* self)
    {
        *returns = self->databaseText();
    }

    void __QtAda_QSqlError_driverText_Q(QString* returns, const QSqlError* self)
    {
        *returns = self->driverText();
    }

    unsigned __QtAda_QSqlError_isValid_Q(const QSqlError* self)
    {
        return (unsigned)self->isValid();
    }

    int __QtAda_QSqlError_number_Q(const QSqlError* self)
    {
        return self->number();
    }

    void __QtAda_QSqlError_setDatabaseText_QStringCR(QSqlError* self, const QString* databaseText)
    {
        self->setDatabaseText(*databaseText);
    }

    void __QtAda_QSqlError_setDriverText_QStringCR(QSqlError* self, const QString* driverText)
    {
        self->setDriverText(*driverText);
    }

    void __QtAda_QSqlError_setNumber_int(QSqlError* self, int number)
    {
        self->setNumber(number);
    }

    void __QtAda_QSqlError_setType_ErrorType(QSqlError* self, unsigned the_type)
    {
        self->setType((QSqlError::ErrorType)the_type);
    }

    void __QtAda_QSqlError_text_Q(QString* returns, const QSqlError* self)
    {
        *returns = self->text();
    }

    unsigned __QtAda_QSqlError_type_Q(const QSqlError* self)
    {
        return (unsigned)self->type();
    }

};

