//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QSQLQUERYMODELDIRECTOR_H__
#define __QSQLQUERYMODELDIRECTOR_H__

#include <QSqlQueryModel>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QSqlQueryModel_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QSqlQueryModel_clear_0_dispatch(void*);
    extern QVariant* __Qt4Ada_QSqlQueryModel_data_0_dispatch(void*, const QModelIndex*, int);
    extern QVariant* __Qt4Ada_QSqlQueryModel_headerData_0_dispatch(void*, int, Qt::Orientation, int);
    extern bool __Qt4Ada_QSqlQueryModel_setHeaderData_0_dispatch(void*, int, Qt::Orientation, const QVariant*, int);
    extern void __Qt4Ada_QSqlQueryModel_queryChange_0_dispatch(void*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QSqlQueryModel_clear_0_virtual(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_data_0_virtual(QObject*, const QModelIndex*, int, QVariant*);
    extern void __Qt4Ada_QSqlQueryModel_headerData_0_virtual(QObject*, int, Qt::Orientation, int, QVariant*);
    extern bool __Qt4Ada_QSqlQueryModel_setHeaderData_0_virtual(QObject*, int, Qt::Orientation, const QVariant*, int);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QSqlQueryModel_canFetchMore_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QSqlQueryModel_clear_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_data_0_wrapper(QObject*, const QModelIndex*, int, QVariant*);
    extern void __Qt4Ada_QSqlQueryModel_fetchMore_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QSqlQueryModel_headerData_0_wrapper(QObject*, int, Qt::Orientation, int, QVariant*);
    extern bool __Qt4Ada_QSqlQueryModel_insertColumns_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern void __Qt4Ada_QSqlQueryModel_lastError_0_wrapper(QObject*, QSqlError*);
    extern void __Qt4Ada_QSqlQueryModel_query_0_wrapper(QObject*, QSqlQuery*);
    extern void __Qt4Ada_QSqlQueryModel_record_1_wrapper(QObject*, QSqlRecord*);
    extern void __Qt4Ada_QSqlQueryModel_record_0_wrapper(QObject*, int, QSqlRecord*);
    extern bool __Qt4Ada_QSqlQueryModel_removeColumns_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern int __Qt4Ada_QSqlQueryModel_rowCount_0_wrapper(QObject*, const QModelIndex*);
    extern int __Qt4Ada_QSqlQueryModel_columnCount_0_wrapper(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QSqlQueryModel_setHeaderData_0_wrapper(QObject*, int, Qt::Orientation, const QVariant*, int);
    extern void __Qt4Ada_QSqlQueryModel_setQuery_0_wrapper(QObject*, const QSqlQuery*);
    extern void __Qt4Ada_QSqlQueryModel_indexInQuery_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    extern void __Qt4Ada_QSqlQueryModel_queryChange_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QSqlQueryModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    extern void __Qt4Ada_QSqlQueryModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_layoutChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSqlQueryModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern bool __Qt4Ada_QSqlQueryModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern bool __Qt4Ada_QSqlQueryModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern void __Qt4Ada_QSqlQueryModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSqlQueryModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSqlQueryModel_beginResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QSqlQueryModel_endInsertColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_endInsertRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_endMoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_endMoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_endRemoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_endRemoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_endResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_reset_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlQueryModel_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSqlQueryModel_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSqlQueryModel_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QSqlQueryModel_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QSqlQueryModel_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QSqlQueryModel_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QVariant* __Qt4Ada_QSqlQueryModel_data_virtual(QObject*, const QModelIndex*, int);

}

class QSqlQueryModelDirector : public QSqlQueryModel
{
protected:
    void* ada_object;
    QSqlQueryModelDirector();

    virtual bool canFetchMore(const QModelIndex&) const;
    virtual void clear();
    virtual QVariant data(const QModelIndex&, int) const;
    virtual void fetchMore(const QModelIndex&);
    virtual QVariant headerData(int, Qt::Orientation, int) const;
    virtual bool insertColumns(int, int, const QModelIndex&);
    virtual bool removeColumns(int, int, const QModelIndex&);
    virtual int rowCount(const QModelIndex&) const;
    virtual int columnCount(const QModelIndex&) const;
    virtual bool setHeaderData(int, Qt::Orientation, const QVariant&, int);
    virtual void queryChange();
    virtual QModelIndex index(int, int, const QModelIndex&) const;
    virtual QModelIndex parent(const QModelIndex&) const;
    virtual QModelIndex buddy(const QModelIndex&) const;
    virtual bool dropMimeData(QMimeData*, Qt::DropAction, int, int, const QModelIndex&);
    virtual bool hasChildren(const QModelIndex&) const;
    virtual bool hasIndex(int, int, const QModelIndex&) const;
    virtual bool insertRows(int, int, const QModelIndex&);
    virtual QMimeData* mimeData(const QModelIndexList&) const;
    virtual QStringList mimeTypes() const;
    virtual bool removeRows(int, int, const QModelIndex&);
    virtual QSize span(const QModelIndex&) const;
    virtual void revert();
    virtual bool submit();
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QSqlQueryModel_indexInQuery_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    friend void __Qt4Ada_QSqlQueryModel_queryChange_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QSqlQueryModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    friend void __Qt4Ada_QSqlQueryModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_layoutChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSqlQueryModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend bool __Qt4Ada_QSqlQueryModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend bool __Qt4Ada_QSqlQueryModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend void __Qt4Ada_QSqlQueryModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSqlQueryModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSqlQueryModel_beginResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QSqlQueryModel_endInsertColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_endInsertRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_endMoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_endMoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_endRemoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_endRemoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_endResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_reset_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlQueryModel_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSqlQueryModel_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSqlQueryModel_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QSqlQueryModel_sender_0_wrapper(QObject*);
};

#endif // __QSQLQUERYMODELDIRECTOR_H__
