//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QSqlQuery>

extern "C"
{
    extern QSqlQuery* __QtAda_inititialize_QSqlQuery(void*);
    extern QSqlQuery* __QtAda_inititialize_QSqlQuery_QStringCR_QSqlDatabaseCR(void*, const QString*, const QSqlDatabase*);
    extern QSqlQuery* __QtAda_inititialize_QSqlQuery_QSqlDatabaseCR(void*, const QSqlDatabase*);
    extern QSqlQuery* __QtAda_adjust_QSqlQuery(void*, const QSqlQuery*);
    extern void __QtAda_finalize_QSqlQuery(QSqlQuery*);

    extern void __QtAda_QSqlQuery_addBindValue_QVariantCR_ParamTypeFlag(QSqlQuery*, const QVariant*, unsigned);
    extern int __QtAda_QSqlQuery_at_Q(const QSqlQuery*);
    extern void __QtAda_QSqlQuery_bindValue_QStringCR_QVariantCR_ParamTypeFlag(QSqlQuery*, const QString*, const QVariant*, unsigned);
    extern void __QtAda_QSqlQuery_bindValue_int_QVariantCR_ParamTypeFlag(QSqlQuery*, int, const QVariant*, unsigned);
    extern void __QtAda_QSqlQuery_boundValue_QStringCR_Q(QVariant*, const QSqlQuery*, const QString*);
    extern void __QtAda_QSqlQuery_boundValue_int_Q(QVariant*, const QSqlQuery*, int);
    extern void __QtAda_QSqlQuery_clear(QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_exec_QStringCR(QSqlQuery*, const QString*);
    extern unsigned __QtAda_QSqlQuery_exec(QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_execBatch_BatchExecutionMode(QSqlQuery*, unsigned);
    extern void __QtAda_QSqlQuery_executedQuery_Q(QString*, const QSqlQuery*);
    extern void __QtAda_QSqlQuery_finish(QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_first(QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_isActive_Q(const QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_isForwardOnly_Q(const QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_isNull_int_Q(const QSqlQuery*, int);
    extern unsigned __QtAda_QSqlQuery_isSelect_Q(const QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_isValid_Q(const QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_last(QSqlQuery*);
    extern void __QtAda_QSqlQuery_lastError_Q(QSqlError*, const QSqlQuery*);
    extern void __QtAda_QSqlQuery_lastInsertId_Q(QVariant*, const QSqlQuery*);
    extern void __QtAda_QSqlQuery_lastQuery_Q(QString*, const QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_next(QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_nextResult(QSqlQuery*);
    extern int __QtAda_QSqlQuery_numRowsAffected_Q(const QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_numericalPrecisionPolicy_Q(const QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_prepare_QStringCR(QSqlQuery*, const QString*);
    extern unsigned __QtAda_QSqlQuery_previous(QSqlQuery*);
    extern void __QtAda_QSqlQuery_record_Q(QSqlRecord*, const QSqlQuery*);
    extern unsigned __QtAda_QSqlQuery_seek_int_bool(QSqlQuery*, int, unsigned);
    extern void __QtAda_QSqlQuery_setForwardOnly_bool(QSqlQuery*, unsigned);
    extern void __QtAda_QSqlQuery_setNumericalPrecisionPolicy_NumericalPrecisionPolicy(QSqlQuery*, unsigned);
    extern int __QtAda_QSqlQuery_size(QSqlQuery*);
    extern void __QtAda_QSqlQuery_value_int(QVariant*, QSqlQuery*, int);

};

