//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSqlRelation>
#include <QString>
#include <QVariant>
#include <QModelIndex>
#include <QMimeData>
#include <QStringList>
#include <QSize>
#include <QChildEvent>
#include <QTimerEvent>

#include "qsqlrelationaltablemodeldirector.h"
#include "qsqltablemodeldirector.h"
#include "qsqlquerymodeldirector.h"
#include "qabstracttablemodeldirector.h"
#include "qabstractitemmodeldirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QSqlRelationalTableModel_staticMetaObject =
        &QSqlRelationalTableModel::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QSqlRelationalTableModel_setRelation_0_virtual(QObject* cpp_object, int column, const QSqlRelation* relation)
    {
        dynamic_cast<QSqlRelationalTableModel*>(cpp_object)->setRelation(column, *relation);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QSqlRelationalTableModel_relation_0_wrapper(QObject* cpp_object, int column, QSqlRelation* returns)
    {
        *returns = dynamic_cast<QSqlRelationalTableModel*>(cpp_object)->QSqlRelationalTableModel::relation(column);
    }

    void __Qt4Ada_QSqlRelationalTableModel_setRelation_0_wrapper(QObject* cpp_object, int column, const QSqlRelation* relation)
    {
        dynamic_cast<QSqlRelationalTableModel*>(cpp_object)->QSqlRelationalTableModel::setRelation(column, *relation);
    }

    void __Qt4Ada_QSqlRelationalTableModel_selectStatement_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QSqlRelationalTableModel::selectStatement();
    }

    void __Qt4Ada_QSqlRelationalTableModel_orderByClause_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QSqlRelationalTableModel::orderByClause();
    }

    void __Qt4Ada_QSqlRelationalTableModel_beforeDelete_0_wrapper(QObject* cpp_object, int row)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QSqlTableModel::beforeDelete(row);
    }

    bool __Qt4Ada_QSqlRelationalTableModel_deleteRowFromTable_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QSqlTableModel::deleteRowFromTable(row);
    }

    void __Qt4Ada_QSqlRelationalTableModel_indexInQuery_0_wrapper(QObject* cpp_object, const QModelIndex* item, QModelIndex* returns)
    {
        *returns = dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QSqlTableModel::indexInQuery(*item);
    }

    void __Qt4Ada_QSqlRelationalTableModel_queryChange_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QSqlQueryModel::queryChange();
    }

    void __Qt4Ada_QSqlRelationalTableModel_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::dataChanged(*topLeft, *bottomRight);
    }

    void __Qt4Ada_QSqlRelationalTableModel_headerDataChanged_0_wrapper(QObject* cpp_object, Qt::Orientation orientation, int first, int last)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::headerDataChanged(orientation, first, last);
    }

    void __Qt4Ada_QSqlRelationalTableModel_layoutAboutToBeChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::layoutAboutToBeChanged();
    }

    void __Qt4Ada_QSqlRelationalTableModel_layoutChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::layoutChanged();
    }

    void __Qt4Ada_QSqlRelationalTableModel_beginInsertColumns_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::beginInsertColumns(*parent, first, last);
    }

    void __Qt4Ada_QSqlRelationalTableModel_beginInsertRows_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::beginInsertRows(*parent, first, last);
    }

    bool __Qt4Ada_QSqlRelationalTableModel_beginMoveColumns_0_wrapper(QObject* cpp_object, const QModelIndex* sourceParent, int sourceFirst, int sourceLast, const QModelIndex* destinationParent, int destinationChild)
    {
        return dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::beginMoveColumns(*sourceParent, sourceFirst, sourceLast, *destinationParent, destinationChild);
    }

    bool __Qt4Ada_QSqlRelationalTableModel_beginMoveRows_0_wrapper(QObject* cpp_object, const QModelIndex* sourceParent, int sourceFirst, int sourceLast, const QModelIndex* destinationParent, int destinationChild)
    {
        return dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::beginMoveRows(*sourceParent, sourceFirst, sourceLast, *destinationParent, destinationChild);
    }

    void __Qt4Ada_QSqlRelationalTableModel_beginRemoveColumns_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::beginRemoveColumns(*parent, first, last);
    }

    void __Qt4Ada_QSqlRelationalTableModel_beginRemoveRows_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::beginRemoveRows(*parent, first, last);
    }

    void __Qt4Ada_QSqlRelationalTableModel_beginResetModel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::beginResetModel();
    }

    void __Qt4Ada_QSqlRelationalTableModel_changePersistentIndex_0_wrapper(QObject* cpp_object, const QModelIndex* from, const QModelIndex* to)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::changePersistentIndex(*from, *to);
    }

    void __Qt4Ada_QSqlRelationalTableModel_endInsertColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::endInsertColumns();
    }

    void __Qt4Ada_QSqlRelationalTableModel_endInsertRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::endInsertRows();
    }

    void __Qt4Ada_QSqlRelationalTableModel_endMoveColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::endMoveColumns();
    }

    void __Qt4Ada_QSqlRelationalTableModel_endMoveRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::endMoveRows();
    }

    void __Qt4Ada_QSqlRelationalTableModel_endRemoveColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::endRemoveColumns();
    }

    void __Qt4Ada_QSqlRelationalTableModel_endRemoveRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::endRemoveRows();
    }

    void __Qt4Ada_QSqlRelationalTableModel_endResetModel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::endResetModel();
    }

    void __Qt4Ada_QSqlRelationalTableModel_reset_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QAbstractItemModel::reset();
    }

    void __Qt4Ada_QSqlRelationalTableModel_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QSqlRelationalTableModel_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QSqlRelationalTableModel_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QSqlRelationalTableModel_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSqlRelationalTableModelDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QSqlRelationalTableModel_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QSqlRelationalTableModel*>(cpp_this)->QSqlRelationalTableModel::qt_metacast(name);
    }

    int __Qt4Ada_QSqlRelationalTableModel_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QSqlRelationalTableModel*>(cpp_this)->QSqlRelationalTableModel::qt_metacall(_c, _id, _a);
    }

}

void QSqlRelationalTableModelDirector::setRelation(int column, const QSqlRelation& relation)
{
    __Qt4Ada_QSqlRelationalTableModel_setRelation_0_dispatch(this->ada_object, column, &relation);
}

QString QSqlRelationalTableModelDirector::selectStatement() const
{
    QString *aux = __Qt4Ada_QSqlTableModel_selectStatement_0_dispatch(this->ada_object);
    QString returns = *aux;
    delete aux;
    return returns;
}

QString QSqlRelationalTableModelDirector::orderByClause() const
{
    QString *aux = __Qt4Ada_QSqlTableModel_orderByClause_0_dispatch(this->ada_object);
    QString returns = *aux;
    delete aux;
    return returns;
}

bool QSqlRelationalTableModelDirector::insertRows(int row, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_insertRows_0_dispatch(this->ada_object, row, count, &parent);
}

bool QSqlRelationalTableModelDirector::removeColumns(int column, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_removeColumns_0_dispatch(this->ada_object, column, count, &parent);
}

bool QSqlRelationalTableModelDirector::removeRows(int row, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_removeRows_0_dispatch(this->ada_object, row, count, &parent);
}

void QSqlRelationalTableModelDirector::revertRow(int row)
{
    __Qt4Ada_QSqlTableModel_revertRow_0_dispatch(this->ada_object, row);
}

bool QSqlRelationalTableModelDirector::select()
{
    return __Qt4Ada_QSqlTableModel_select_0_dispatch(this->ada_object);
}

void QSqlRelationalTableModelDirector::setEditStrategy(QSqlTableModel::EditStrategy strategy)
{
    __Qt4Ada_QSqlTableModel_setEditStrategy_0_dispatch(this->ada_object, strategy);
}

void QSqlRelationalTableModelDirector::setFilter(const QString& filter)
{
    __Qt4Ada_QSqlTableModel_setFilter_0_dispatch(this->ada_object, &filter);
}

void QSqlRelationalTableModelDirector::setSort(int column, Qt::SortOrder order)
{
    __Qt4Ada_QSqlTableModel_setSort_0_dispatch(this->ada_object, column, order);
}

void QSqlRelationalTableModelDirector::setTable(const QString& tableName)
{
    __Qt4Ada_QSqlTableModel_setTable_0_dispatch(this->ada_object, &tableName);
}

void QSqlRelationalTableModelDirector::sort(int column, Qt::SortOrder order)
{
    __Qt4Ada_QSqlTableModel_sort_0_dispatch(this->ada_object, column, order);
}

void QSqlRelationalTableModelDirector::revert()
{
    __Qt4Ada_QAbstractItemModel_revert_0_dispatch(this->ada_object);
}

bool QSqlRelationalTableModelDirector::submit()
{
    return __Qt4Ada_QAbstractItemModel_submit_0_dispatch(this->ada_object);
}

bool QSqlRelationalTableModelDirector::deleteRowFromTable(int row)
{
    return __Qt4Ada_QSqlTableModel_deleteRowFromTable_0_dispatch(this->ada_object, row);
}

bool QSqlRelationalTableModelDirector::canFetchMore(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_canFetchMore_0_dispatch(this->ada_object, &parent);
}

void QSqlRelationalTableModelDirector::clear()
{
    __Qt4Ada_QSqlQueryModel_clear_0_dispatch(this->ada_object);
}

QVariant QSqlRelationalTableModelDirector::data(const QModelIndex& item, int role) const
{
    QVariant *aux = __Qt4Ada_QSqlQueryModel_data_0_dispatch(this->ada_object, &item, role);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QSqlRelationalTableModelDirector::fetchMore(const QModelIndex& parent)
{
    __Qt4Ada_QAbstractItemModel_fetchMore_0_dispatch(this->ada_object, &parent);
}

QVariant QSqlRelationalTableModelDirector::headerData(int section, Qt::Orientation orientation, int role) const
{
    QVariant *aux = __Qt4Ada_QSqlQueryModel_headerData_0_dispatch(this->ada_object, section, orientation, role);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

bool QSqlRelationalTableModelDirector::insertColumns(int column, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_insertColumns_0_dispatch(this->ada_object, column, count, &parent);
}

int QSqlRelationalTableModelDirector::rowCount(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_rowCount_0_dispatch(this->ada_object, &parent);
}

int QSqlRelationalTableModelDirector::columnCount(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_columnCount_0_dispatch(this->ada_object, &parent);
}

bool QSqlRelationalTableModelDirector::setHeaderData(int section, Qt::Orientation orientation, const QVariant& value, int role)
{
    return __Qt4Ada_QSqlQueryModel_setHeaderData_0_dispatch(this->ada_object, section, orientation, &value, role);
}

void QSqlRelationalTableModelDirector::queryChange()
{
    __Qt4Ada_QSqlQueryModel_queryChange_0_dispatch(this->ada_object);
}

QModelIndex QSqlRelationalTableModelDirector::index(int row, int column, const QModelIndex& parent) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_index_0_dispatch(this->ada_object, row, column, &parent);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

QModelIndex QSqlRelationalTableModelDirector::parent(const QModelIndex& child) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_parent_1_dispatch(this->ada_object, &child);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

QModelIndex QSqlRelationalTableModelDirector::buddy(const QModelIndex& index) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_buddy_0_dispatch(this->ada_object, &index);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QSqlRelationalTableModelDirector::dropMimeData(QMimeData* data, Qt::DropAction action, int row, int column, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_dropMimeData_0_dispatch(this->ada_object, data, action, row, column, &parent);
}

bool QSqlRelationalTableModelDirector::hasChildren(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_hasChildren_0_dispatch(this->ada_object, &parent);
}

bool QSqlRelationalTableModelDirector::hasIndex(int row, int column, const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_hasIndex_0_dispatch(this->ada_object, row, column, &parent);
}

QMimeData* QSqlRelationalTableModelDirector::mimeData(const QModelIndexList& indexes) const
{
    return dynamic_cast<QMimeData*>(__Qt4Ada_QAbstractItemModel_mimeData_0_dispatch(this->ada_object, &indexes));
}

QStringList QSqlRelationalTableModelDirector::mimeTypes() const
{
    QStringList *aux = __Qt4Ada_QAbstractItemModel_mimeTypes_0_dispatch(this->ada_object);
    QStringList returns = *aux;
    delete aux;
    return returns;
}

QSize QSqlRelationalTableModelDirector::span(const QModelIndex& index) const
{
    QSize *aux = __Qt4Ada_QAbstractItemModel_span_0_dispatch(this->ada_object, &index);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QSqlRelationalTableModelDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QSqlRelationalTableModelDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QSqlRelationalTableModelDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QSqlRelationalTableModelDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QSqlRelationalTableModelDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QSqlRelationalTableModelDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QSqlRelationalTableModelDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QSqlRelationalTableModelDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
extern "C" {

    QObject* __Qt4Ada_new_QSqlRelationalTableModel (QObject* parent, QSqlDatabase* db)
    {
        return dynamic_cast<QObject *>(new QSqlRelationalTableModel (parent, *db));
    }
}
