//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QSQLRELATIONALTABLEMODELDIRECTOR_H__
#define __QSQLRELATIONALTABLEMODELDIRECTOR_H__

#include <QSqlRelationalTableModel>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QSqlRelationalTableModel_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QSqlRelationalTableModel_setRelation_0_dispatch(void*, int, const QSqlRelation*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QSqlRelationalTableModel_setRelation_0_virtual(QObject*, int, const QSqlRelation*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QSqlRelationalTableModel_relation_0_wrapper(QObject*, int, QSqlRelation*);
    extern void __Qt4Ada_QSqlRelationalTableModel_setRelation_0_wrapper(QObject*, int, const QSqlRelation*);
    extern void __Qt4Ada_QSqlRelationalTableModel_selectStatement_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QSqlRelationalTableModel_orderByClause_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QSqlRelationalTableModel_beforeDelete_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QSqlRelationalTableModel_deleteRowFromTable_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSqlRelationalTableModel_indexInQuery_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    extern void __Qt4Ada_QSqlRelationalTableModel_queryChange_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QSqlRelationalTableModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    extern void __Qt4Ada_QSqlRelationalTableModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_layoutChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSqlRelationalTableModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern bool __Qt4Ada_QSqlRelationalTableModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern bool __Qt4Ada_QSqlRelationalTableModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern void __Qt4Ada_QSqlRelationalTableModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSqlRelationalTableModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSqlRelationalTableModel_beginResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QSqlRelationalTableModel_endInsertColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_endInsertRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_endMoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_endMoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_endRemoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_endRemoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_endResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_reset_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlRelationalTableModel_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSqlRelationalTableModel_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSqlRelationalTableModel_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QSqlRelationalTableModel_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QSqlRelationalTableModel_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QSqlRelationalTableModel_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
extern "C" {
    
    //  Constructor

    extern QObject* __Qt4Ada_new_QSqlRelationalTableModel (QObject*, QSqlDatabase*);
}

class QSqlRelationalTableModelDirector : public QSqlRelationalTableModel
{
protected:
    void* ada_object;
    QSqlRelationalTableModelDirector();

    virtual void setRelation(int, const QSqlRelation&);
    virtual QString selectStatement() const;
    virtual QString orderByClause() const;
    virtual bool insertRows(int, int, const QModelIndex&);
    virtual bool removeColumns(int, int, const QModelIndex&);
    virtual bool removeRows(int, int, const QModelIndex&);
    virtual void revertRow(int);
    virtual bool select();
    virtual void setEditStrategy(QSqlTableModel::EditStrategy);
    virtual void setFilter(const QString&);
    virtual void setSort(int, Qt::SortOrder);
    virtual void setTable(const QString&);
    virtual void sort(int, Qt::SortOrder);
    virtual void revert();
    virtual bool submit();
    virtual bool deleteRowFromTable(int);
    virtual bool canFetchMore(const QModelIndex&) const;
    virtual void clear();
    virtual QVariant data(const QModelIndex&, int) const;
    virtual void fetchMore(const QModelIndex&);
    virtual QVariant headerData(int, Qt::Orientation, int) const;
    virtual bool insertColumns(int, int, const QModelIndex&);
    virtual int rowCount(const QModelIndex&) const;
    virtual int columnCount(const QModelIndex&) const;
    virtual bool setHeaderData(int, Qt::Orientation, const QVariant&, int);
    virtual void queryChange();
    virtual QModelIndex index(int, int, const QModelIndex&) const;
    virtual QModelIndex parent(const QModelIndex&) const;
    virtual QModelIndex buddy(const QModelIndex&) const;
    virtual bool dropMimeData(QMimeData*, Qt::DropAction, int, int, const QModelIndex&);
    virtual bool hasChildren(const QModelIndex&) const;
    virtual bool hasIndex(int, int, const QModelIndex&) const;
    virtual QMimeData* mimeData(const QModelIndexList&) const;
    virtual QStringList mimeTypes() const;
    virtual QSize span(const QModelIndex&) const;
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QSqlRelationalTableModel_selectStatement_0_wrapper(QObject*, QString*);
    friend void __Qt4Ada_QSqlRelationalTableModel_orderByClause_0_wrapper(QObject*, QString*);
    friend void __Qt4Ada_QSqlRelationalTableModel_beforeDelete_0_wrapper(QObject*, int);
    friend bool __Qt4Ada_QSqlRelationalTableModel_deleteRowFromTable_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QSqlRelationalTableModel_indexInQuery_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    friend void __Qt4Ada_QSqlRelationalTableModel_queryChange_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QSqlRelationalTableModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    friend void __Qt4Ada_QSqlRelationalTableModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_layoutChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSqlRelationalTableModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend bool __Qt4Ada_QSqlRelationalTableModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend bool __Qt4Ada_QSqlRelationalTableModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend void __Qt4Ada_QSqlRelationalTableModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSqlRelationalTableModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSqlRelationalTableModel_beginResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QSqlRelationalTableModel_endInsertColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_endInsertRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_endMoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_endMoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_endRemoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_endRemoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_endResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_reset_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlRelationalTableModel_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSqlRelationalTableModel_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSqlRelationalTableModel_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QSqlRelationalTableModel_sender_0_wrapper(QObject*);
};

#endif // __QSQLRELATIONALTABLEMODELDIRECTOR_H__
