------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);

package body Qt_Ada.Internals.Objects.Sql_Query_Model_Proxies is

   procedure clear_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
      pragma Import (C, clear_0_virtual,
                     "__Qt4Ada_QSqlQueryModel_clear_0_virtual");

   procedure data_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Item : not null access constant Qt4.Model_Indices.Internals.QModelIndex;
     Role : Qt4.Q_Integer;
     Returns : not null access Qt4.Variants.Internals.QVariant);
      pragma Import (C, data_0_virtual,
                     "__Qt4Ada_QSqlQueryModel_data_0_virtual");

   procedure headerData_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Section : Qt4.Q_Integer;
     Orientation : Qt4.Orientation;
     Role : Qt4.Q_Integer;
     Returns : not null access Qt4.Variants.Internals.QVariant);
      pragma Import (C, headerData_0_virtual,
                     "__Qt4Ada_QSqlQueryModel_headerData_0_virtual");

   function setHeaderData_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Section : Qt4.Q_Integer;
     Orientation : Qt4.Orientation;
     Value : not null access constant Qt4.Variants.Internals.QVariant;
     Role : Qt4.Q_Integer)
       return Qt4.bool;
      pragma Import (C, setHeaderData_0_virtual,
                     "__Qt4Ada_QSqlQueryModel_setHeaderData_0_virtual");

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;

   pragma Style_Checks ("N");

   -----------
   -- Clear --
   -----------

   procedure Clear
    (Self : not null access Q_Sql_Query_Model_Proxy)
   is
   begin
      clear_0_virtual
       (Q_Sql_Query_Model_Proxy'Class (Self.all).QObject_View);
   end Clear;

   ----------
   -- Data --
   ----------

   function Data
    (Self : not null access constant Q_Sql_Query_Model_Proxy;
     Item : Qt4.Model_Indices.Q_Model_Index;
     Role : Qt4.Q_Integer)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      data_0_virtual
       (Q_Sql_Query_Model_Proxy'Class (Self.all).QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Item),
        Role,
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Data;

   -----------------
   -- Header_Data --
   -----------------

   function Header_Data
    (Self : not null access constant Q_Sql_Query_Model_Proxy;
     Section : Qt4.Q_Integer;
     Orientation : Qt4.Orientation;
     Role : Qt4.Q_Integer)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      headerData_0_virtual
       (Q_Sql_Query_Model_Proxy'Class (Self.all).QObject_View,
        Section,
        Orientation,
        Role,
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Header_Data;

   ---------------------
   -- Set_Header_Data --
   ---------------------

   function Set_Header_Data
    (Self : not null access Q_Sql_Query_Model_Proxy;
     Section : Qt4.Q_Integer;
     Orientation : Qt4.Orientation;
     Value : Qt4.Variants.Q_Variant;
     Role : Qt4.Q_Integer)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (setHeaderData_0_virtual
           (Q_Sql_Query_Model_Proxy'Class (Self.all).QObject_View,
            Section,
            Orientation,
            Qt4.Variants.Internals.QVariant_View (Value),
            Role));
   end Set_Header_Data;

   type Q_Sql_Query_Model_Proxy_Access is
     access all Q_Sql_Query_Model_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access
   is
      Self : constant not null Q_Sql_Query_Model_Proxy_Access
        := new Q_Sql_Query_Model_Proxy;

   begin
      Qt_Ada.Internals.Objects.Initialize (Self, Object);

      return Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Object_Registry.Register_Proxy
    ("QSqlQueryModel", Create'Access);
end Qt_Ada.Internals.Objects.Sql_Query_Model_Proxies;
