------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Sql_Table_Models;
with Qt4.Strings;
with Qt_Ada.Internals.Objects.Sql_Query_Model_Proxies;

package Qt_Ada.Internals.Objects.Sql_Table_Model_Proxies is

   pragma Elaborate_Body;

   type Q_Sql_Table_Model_Proxy is
     new Qt_Ada.Internals.Objects.Sql_Query_Model_Proxies.Q_Sql_Query_Model_Proxy
       and Qt4.Sql_Table_Models.Q_Sql_Table_Model with null record;

   procedure Revert_Row
    (Self : not null access Q_Sql_Table_Model_Proxy;
     Row : Qt4.Q_Integer);

   function Select_Query
    (Self : not null access Q_Sql_Table_Model_Proxy)
       return Standard.Boolean;

   procedure Set_Edit_Strategy
    (Self : not null access Q_Sql_Table_Model_Proxy;
     Strategy : Qt4.Sql_Table_Models.Sql_Table_Model_Edit_Strategy);

   procedure Set_Filter
    (Self : not null access Q_Sql_Table_Model_Proxy;
     Filter : Qt4.Strings.Q_String);

   procedure Set_Sort
    (Self : not null access Q_Sql_Table_Model_Proxy;
     Column : Qt4.Q_Integer;
     Order : Qt4.Sort_Order);

   procedure Set_Table
    (Self : not null access Q_Sql_Table_Model_Proxy;
     Table_Name : Qt4.Strings.Q_String);

   procedure Sort
    (Self : not null access Q_Sql_Table_Model_Proxy;
     Column : Qt4.Q_Integer;
     Order : Qt4.Sort_Order);

end Qt_Ada.Internals.Objects.Sql_Table_Model_Proxies;
