//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QUILOADERDIRECTOR_H__
#define __QUILOADERDIRECTOR_H__

#include <QUiLoader>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QUiLoader_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QObject* __Qt4Ada_QUiLoader_createAction_0_dispatch(void*, QObject*, const QString*);
    extern QObject* __Qt4Ada_QUiLoader_createLayout_0_dispatch(void*, const QString*, QObject*, const QString*);
    extern QObject* __Qt4Ada_QUiLoader_createWidget_0_dispatch(void*, const QString*, QObject*, const QString*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern QObject* __Qt4Ada_QUiLoader_createAction_0_virtual(QObject*, QObject*, const QString*);
    extern QObject* __Qt4Ada_QUiLoader_createLayout_0_virtual(QObject*, const QString*, QObject*, const QString*);
    extern QObject* __Qt4Ada_QUiLoader_createWidget_0_virtual(QObject*, const QString*, QObject*, const QString*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QUiLoader_addPluginPath_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QUiLoader_clearPluginPaths_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QUiLoader_createAction_0_wrapper(QObject*, QObject*, const QString*);
    extern QObject* __Qt4Ada_QUiLoader_createLayout_0_wrapper(QObject*, const QString*, QObject*, const QString*);
    extern QObject* __Qt4Ada_QUiLoader_createWidget_0_wrapper(QObject*, const QString*, QObject*, const QString*);
    extern QObject* __Qt4Ada_QUiLoader_load_0_wrapper(QObject*, QObject*, QObject*);
    extern void __Qt4Ada_QUiLoader_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QUiLoader_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QUiLoader_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QUiLoader_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QUiLoader_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QUiLoader_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

   QObject* __Qt4Ada_new_QUiLoader(QObject*);

}

class QUiLoaderDirector : public QUiLoader
{
protected:
    void* ada_object;
    QUiLoaderDirector();

    virtual QAction* createAction(QObject*, const QString&);
    virtual QLayout* createLayout(const QString&, QObject*, const QString&);
    virtual QWidget* createWidget(const QString&, QWidget*, const QString&);
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QUiLoader_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QUiLoader_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QUiLoader_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QUiLoader_sender_0_wrapper(QObject*);
};

#endif // __QUILOADERDIRECTOR_H__
