------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Web_View_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Web_View_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Web_Views is

   procedure icon_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Icons.Internals.QIcon);
   pragma Import (C, icon_0_wrapper,
                     "__Qt4Ada_QWebView_icon_0_wrapper");

   procedure load_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Url : not null access constant Qt4.Urls.Internals.QUrl);
   pragma Import (C, load_0_wrapper,
                     "__Qt4Ada_QWebView_load_0_wrapper");

   procedure setUrl_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Url : not null access constant Qt4.Urls.Internals.QUrl);
   pragma Import (C, setUrl_0_wrapper,
                     "__Qt4Ada_QWebView_setUrl_0_wrapper");

   pragma Style_Checks ("N");

   ----------
   -- Icon --
   ----------

   function Icon
    (Self : not null access constant Q_Web_View'Class)
       return Qt4.Icons.Q_Icon
   is
      Returns : Qt4.Icons.Q_Icon;

   begin
      icon_0_wrapper
       (Self.QObject_View,
        Qt4.Icons.Internals.QIcon_View (Returns));

      return Returns;
   end Icon;

   ----------
   -- Load --
   ----------

   procedure Load
    (Self : not null access Q_Web_View'Class;
     Url : Qt4.Urls.Q_Url)
   is
   begin
      load_0_wrapper
       (Self.QObject_View,
        Qt4.Urls.Internals.QUrl_View (Url));
   end Load;

   -------------
   -- Set_Url --
   -------------

   procedure Set_Url
    (Self : not null access Q_Web_View'Class;
     Url : Qt4.Urls.Q_Url)
   is
   begin
      setUrl_0_wrapper
       (Self.QObject_View,
        Qt4.Urls.Internals.QUrl_View (Url));
   end Set_Url;

end Qt4.Web_Views;
