------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Icons;
with Qt4.Urls;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Web_Views is

   type Q_Web_View is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Web_View_Access is
     access all Q_Web_View'Class;
   for Q_Web_View_Access'Storage_Size use 0;

   type Q_Web_View_Pointer is tagged;

   function Icon
    (Self : not null access constant Q_Web_View'Class)
       return Qt4.Icons.Q_Icon;

   procedure Load
    (Self : not null access Q_Web_View'Class;
     Url : Qt4.Urls.Q_Url);

   procedure Set_Url
    (Self : not null access Q_Web_View'Class;
     Url : Qt4.Urls.Q_Url);

   package Q_Web_View_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Web_View, Q_Web_View_Access);

   type Q_Web_View_Pointer is
     new Q_Web_View_Pointers.Q_Pointer with null record;

end Qt4.Web_Views;
