//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QDomDocument>
#include <QIODevice>

extern "C"
{
    extern QDomNode* __QtAda_inititialize_QDomDocument(void*);
    extern QDomNode* __QtAda_inititialize_QDomDocument_QStringCR(void*, const QString*);
    extern QDomNode* __QtAda_inititialize_QDomDocument_QDomDocumentTypeCR(void*, const QDomNode*);
    extern QDomNode* __QtAda_adjust_QDomDocument(void*, const QDomNode*);
    extern void __QtAda_finalize_QDomDocument(QDomNode*);

    extern void __QtAda_QDomDocument_createAttribute_QStringCR(QDomNode*, QDomNode*, const QString*);
    extern void __QtAda_QDomDocument_createAttributeNS_QStringCR_QStringCR(QDomNode*, QDomNode*, const QString*, const QString*);
    extern void __QtAda_QDomDocument_createCDATASection_QStringCR(QDomNode*, QDomNode*, const QString*);
    extern void __QtAda_QDomDocument_createComment_QStringCR(QDomNode*, QDomNode*, const QString*);
    extern void __QtAda_QDomDocument_createDocumentFragment(QDomNode*, QDomNode*);
    extern void __QtAda_QDomDocument_createElement_QStringCR(QDomNode*, QDomNode*, const QString*);
    extern void __QtAda_QDomDocument_createElementNS_QStringCR_QStringCR(QDomNode*, QDomNode*, const QString*, const QString*);
    extern void __QtAda_QDomDocument_createEntityReference_QStringCR(QDomNode*, QDomNode*, const QString*);
    extern void __QtAda_QDomDocument_createProcessingInstruction_QStringCR_QStringCR(QDomNode*, QDomNode*, const QString*, const QString*);
    extern void __QtAda_QDomDocument_createTextNode_QStringCR(QDomNode*, QDomNode*, const QString*);
    extern void __QtAda_QDomDocument_doctype_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomDocument_documentElement_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomDocument_elementById_QStringCR(QDomNode*, QDomNode*, const QString*);
    extern void __QtAda_QDomDocument_elementsByTagName_QStringCR_Q(QDomNodeList*, const QDomNode*, const QString*);
    extern void __QtAda_QDomDocument_elementsByTagNameNS_QStringCR_QStringCR(QDomNodeList*, QDomNode*, const QString*, const QString*);
    extern void __QtAda_QDomDocument_implementation_Q(QDomImplementation*, const QDomNode*);
    extern void __QtAda_QDomDocument_importNode_QDomNodeCR_bool(QDomNode*, QDomNode*, const QDomNode*, unsigned);
    extern unsigned __QtAda_QDomDocument_nodeType_Q(const QDomNode*);
    extern unsigned __QtAda_QDomDocument_setContent_QStringCR_bool(QDomNode*, const QString*, unsigned);
    extern unsigned __QtAda_QDomDocument_setContent_QIODeviceP_QStringP_intP_intP(QDomNode*, QObject*, QString*, int*, int*);
    extern void __QtAda_QDomDocument_toString_int_Q(QString*, const QDomNode*, int);

};

