//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QDomNode>
#include <QString>
#include "qdomnamednodemapwrapper.h"

extern "C"
{

    QDomNamedNodeMap* __QtAda_inititialize_QDomNamedNodeMap(void* storage)
    {
        return new (storage) QDomNamedNodeMap();
    }

    QDomNamedNodeMap* __QtAda_adjust_QDomNamedNodeMap(void* storage, const QDomNamedNodeMap* from)
    {
        return new (storage) QDomNamedNodeMap(*from);
    }

    void __QtAda_finalize_QDomNamedNodeMap(QDomNamedNodeMap *item)
    {
        item->~QDomNamedNodeMap();
    }

    unsigned __QtAda_QDomNamedNodeMap_contains_QStringCR_Q(const QDomNamedNodeMap* self, const QString* name)
    {
        return (unsigned)self->contains(*name);
    }

    int __QtAda_QDomNamedNodeMap_count_Q(const QDomNamedNodeMap* self)
    {
        return self->count();
    }

    unsigned __QtAda_QDomNamedNodeMap_isEmpty_Q(const QDomNamedNodeMap* self)
    {
        return (unsigned)self->isEmpty();
    }

    void __QtAda_QDomNamedNodeMap_item_int_Q(QDomNode* returns, const QDomNamedNodeMap* self, int index)
    {
        *returns = self->item(index);
    }

    uint __QtAda_QDomNamedNodeMap_length_Q(const QDomNamedNodeMap* self)
    {
        return self->length();
    }

    void __QtAda_QDomNamedNodeMap_namedItem_QStringCR_Q(QDomNode* returns, const QDomNamedNodeMap* self, const QString* name)
    {
        *returns = self->namedItem(*name);
    }

    void __QtAda_QDomNamedNodeMap_namedItemNS_QStringCR_QStringCR_Q(QDomNode* returns, const QDomNamedNodeMap* self, const QString* nsURI, const QString* localName)
    {
        *returns = self->namedItemNS(*nsURI, *localName);
    }

    void __QtAda_QDomNamedNodeMap_removeNamedItem_QStringCR(QDomNamedNodeMap* self, const QString* name)
    {
        self->removeNamedItem(*name);
    }

    void __QtAda_QDomNamedNodeMap_removeNamedItemNS_QStringCR_QStringCR(QDomNamedNodeMap* self, const QString* nsURI, const QString* localName)
    {
        self->removeNamedItemNS(*nsURI, *localName);
    }

    void __QtAda_QDomNamedNodeMap_setNamedItem_QDomNodeCR(QDomNamedNodeMap* self, const QDomNode* newNode)
    {
        self->setNamedItem(*newNode);
    }

    void __QtAda_QDomNamedNodeMap_setNamedItemNS_QDomNodeCR(QDomNamedNodeMap* self, const QDomNode* newNode)
    {
        self->setNamedItemNS(*newNode);
    }

    int __QtAda_QDomNamedNodeMap_size_Q(const QDomNamedNodeMap* self)
    {
        return self->size();
    }

    unsigned __QtAda_QDomNamedNodeMap_eq_QDomNamedNodeMapCR_Q(const QDomNamedNodeMap* self, const QDomNamedNodeMap* n)
    {
        return (unsigned)self->operator==(*n);
    }

};

