//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QDomNode>
#include <QString>
#include "qdomnodelistwrapper.h"

extern "C"
{

    QDomNodeList* __QtAda_inititialize_QDomNodeList(void* storage)
    {
        return new (storage) QDomNodeList();
    }

    QDomNodeList* __QtAda_adjust_QDomNodeList(void* storage, const QDomNodeList* from)
    {
        return new (storage) QDomNodeList(*from);
    }

    void __QtAda_finalize_QDomNodeList(QDomNodeList *item)
    {
        item->~QDomNodeList();
    }

    void __QtAda_QDomNodeList_at_int_Q(QDomNode* returns, const QDomNodeList* self, int index)
    {
        *returns = self->at(index);
    }

    int __QtAda_QDomNodeList_count_Q(const QDomNodeList* self)
    {
        return self->count();
    }

    unsigned __QtAda_QDomNodeList_isEmpty_Q(const QDomNodeList* self)
    {
        return (unsigned)self->isEmpty();
    }

    void __QtAda_QDomNodeList_item_int_Q(QDomNode* returns, const QDomNodeList* self, int index)
    {
        *returns = self->item(index);
    }

    uint __QtAda_QDomNodeList_length_Q(const QDomNodeList* self)
    {
        return self->length();
    }

    int __QtAda_QDomNodeList_size_Q(const QDomNodeList* self)
    {
        return self->size();
    }

    unsigned __QtAda_QDomNodeList_eq_QDomNodeListCR_Q(const QDomNodeList* self, const QDomNodeList* n)
    {
        return (unsigned)self->operator==(*n);
    }

};

