//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QDomAttr>
#include <QDomCDATASection>
#include <QDomCharacterData>
#include <QDomComment>
#include <QDomDocument>
#include <QDomDocumentFragment>
#include <QDomDocumentType>
#include <QDomElement>
#include <QDomEntity>
#include <QDomEntityReference>
#include <QDomNamedNodeMap>
#include <QDomNode>
#include <QDomNodeList>
#include <QDomNotation>
#include <QDomProcessingInstruction>
#include <QDomText>
#include <QString>
#include "qdomnodewrapper.h"

extern "C"
{

    QDomNode* __QtAda_inititialize_QDomNode(void* storage)
    {
        return new (storage) QDomNode();
    }

    QDomNode* __QtAda_adjust_QDomNode(void* storage, const QDomNode* from)
    {
        return new (storage) QDomNode(*from);
    }

    void __QtAda_finalize_QDomNode(QDomNode *item)
    {
        item->~QDomNode();
    }

    void __QtAda_QDomNode_appendChild_QDomNodeCR(QDomNode* self, const QDomNode* newChild)
    {
        self->appendChild(*newChild);
    }

    void __QtAda_QDomNode_attributes_Q(QDomNamedNodeMap* returns, const QDomNode* self)
    {
        *returns = self->attributes();
    }

    void __QtAda_QDomNode_childNodes_Q(QDomNodeList* returns, const QDomNode* self)
    {
        *returns = self->childNodes();
    }

    void __QtAda_QDomNode_clear(QDomNode* self)
    {
        self->clear();
    }

    void __QtAda_QDomNode_cloneNode_bool_Q(QDomNode* returns, const QDomNode* self, unsigned deep)
    {
        *returns = self->cloneNode((bool)deep);
    }

    int __QtAda_QDomNode_columnNumber_Q(const QDomNode* self)
    {
        return self->columnNumber();
    }

    void __QtAda_QDomNode_firstChild_Q(QDomNode* returns, const QDomNode* self)
    {
        *returns = self->firstChild();
    }

    void __QtAda_QDomNode_firstChildElement_QStringCR_Q(QDomNode* returns, const QDomNode* self, const QString* tagName)
    {
        *static_cast<QDomElement*>(returns) = self->firstChildElement(*tagName);
    }

    unsigned __QtAda_QDomNode_hasAttributes_Q(const QDomNode* self)
    {
        return (unsigned)self->hasAttributes();
    }

    unsigned __QtAda_QDomNode_hasChildNodes_Q(const QDomNode* self)
    {
        return (unsigned)self->hasChildNodes();
    }

    void __QtAda_QDomNode_insertAfter_QDomNodeCR_QDomNodeCR(QDomNode* self, const QDomNode* newChild, const QDomNode* refChild)
    {
        self->insertAfter(*newChild, *refChild);
    }

    void __QtAda_QDomNode_insertBefore_QDomNodeCR_QDomNodeCR(QDomNode* self, const QDomNode* newChild, const QDomNode* refChild)
    {
        self->insertBefore(*newChild, *refChild);
    }

    unsigned __QtAda_QDomNode_isAttr_Q(const QDomNode* self)
    {
        return (unsigned)self->isAttr();
    }

    unsigned __QtAda_QDomNode_isCDATASection_Q(const QDomNode* self)
    {
        return (unsigned)self->isCDATASection();
    }

    unsigned __QtAda_QDomNode_isCharacterData_Q(const QDomNode* self)
    {
        return (unsigned)self->isCharacterData();
    }

    unsigned __QtAda_QDomNode_isComment_Q(const QDomNode* self)
    {
        return (unsigned)self->isComment();
    }

    unsigned __QtAda_QDomNode_isDocument_Q(const QDomNode* self)
    {
        return (unsigned)self->isDocument();
    }

    unsigned __QtAda_QDomNode_isDocumentFragment_Q(const QDomNode* self)
    {
        return (unsigned)self->isDocumentFragment();
    }

    unsigned __QtAda_QDomNode_isDocumentType_Q(const QDomNode* self)
    {
        return (unsigned)self->isDocumentType();
    }

    unsigned __QtAda_QDomNode_isElement_Q(const QDomNode* self)
    {
        return (unsigned)self->isElement();
    }

    unsigned __QtAda_QDomNode_isEntity_Q(const QDomNode* self)
    {
        return (unsigned)self->isEntity();
    }

    unsigned __QtAda_QDomNode_isEntityReference_Q(const QDomNode* self)
    {
        return (unsigned)self->isEntityReference();
    }

    unsigned __QtAda_QDomNode_isNotation_Q(const QDomNode* self)
    {
        return (unsigned)self->isNotation();
    }

    unsigned __QtAda_QDomNode_isNull_Q(const QDomNode* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QDomNode_isProcessingInstruction_Q(const QDomNode* self)
    {
        return (unsigned)self->isProcessingInstruction();
    }

    unsigned __QtAda_QDomNode_isSupported_QStringCR_QStringCR_Q(const QDomNode* self, const QString* feature, const QString* version)
    {
        return (unsigned)self->isSupported(*feature, *version);
    }

    unsigned __QtAda_QDomNode_isText_Q(const QDomNode* self)
    {
        return (unsigned)self->isText();
    }

    void __QtAda_QDomNode_lastChild_Q(QDomNode* returns, const QDomNode* self)
    {
        *returns = self->lastChild();
    }

    void __QtAda_QDomNode_lastChildElement_QStringCR_Q(QDomNode* returns, const QDomNode* self, const QString* tagName)
    {
        *static_cast<QDomElement*>(returns) = self->lastChildElement(*tagName);
    }

    int __QtAda_QDomNode_lineNumber_Q(const QDomNode* self)
    {
        return self->lineNumber();
    }

    void __QtAda_QDomNode_localName_Q(QString* returns, const QDomNode* self)
    {
        *returns = self->localName();
    }

    void __QtAda_QDomNode_namedItem_QStringCR_Q(QDomNode* returns, const QDomNode* self, const QString* name)
    {
        *returns = self->namedItem(*name);
    }

    void __QtAda_QDomNode_namespaceURI_Q(QString* returns, const QDomNode* self)
    {
        *returns = self->namespaceURI();
    }

    void __QtAda_QDomNode_nextSibling_Q(QDomNode* returns, const QDomNode* self)
    {
        *returns = self->nextSibling();
    }

    void __QtAda_QDomNode_nextSiblingElement_QStringCR_Q(QDomNode* returns, const QDomNode* self, const QString* tagName)
    {
        *static_cast<QDomElement*>(returns) = self->nextSiblingElement(*tagName);
    }

    void __QtAda_QDomNode_nodeName_Q(QString* returns, const QDomNode* self)
    {
        *returns = self->nodeName();
    }

    unsigned __QtAda_QDomNode_nodeType_Q(const QDomNode* self)
    {
        return (unsigned)self->nodeType();
    }

    void __QtAda_QDomNode_nodeValue_Q(QString* returns, const QDomNode* self)
    {
        *returns = self->nodeValue();
    }

    void __QtAda_QDomNode_normalize(QDomNode* self)
    {
        self->normalize();
    }

    void __QtAda_QDomNode_ownerDocument_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomDocument*>(returns) = self->ownerDocument();
    }

    void __QtAda_QDomNode_parentNode_Q(QDomNode* returns, const QDomNode* self)
    {
        *returns = self->parentNode();
    }

    void __QtAda_QDomNode_prefix_Q(QString* returns, const QDomNode* self)
    {
        *returns = self->prefix();
    }

    void __QtAda_QDomNode_previousSibling_Q(QDomNode* returns, const QDomNode* self)
    {
        *returns = self->previousSibling();
    }

    void __QtAda_QDomNode_previousSiblingElement_QStringCR_Q(QDomNode* returns, const QDomNode* self, const QString* tagName)
    {
        *static_cast<QDomElement*>(returns) = self->previousSiblingElement(*tagName);
    }

    void __QtAda_QDomNode_removeChild_QDomNodeCR(QDomNode* self, const QDomNode* oldChild)
    {
        self->removeChild(*oldChild);
    }

    void __QtAda_QDomNode_replaceChild_QDomNodeCR_QDomNodeCR(QDomNode* self, const QDomNode* newChild, const QDomNode* oldChild)
    {
        self->replaceChild(*newChild, *oldChild);
    }

    void __QtAda_QDomNode_setNodeValue_QStringCR(QDomNode* self, const QString* v)
    {
        self->setNodeValue(*v);
    }

    void __QtAda_QDomNode_setPrefix_QStringCR(QDomNode* self, const QString* pre)
    {
        self->setPrefix(*pre);
    }

    void __QtAda_QDomNode_toAttr_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomAttr*>(returns) = self->toAttr();
    }

    void __QtAda_QDomNode_toCDATASection_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomCDATASection*>(returns) = self->toCDATASection();
    }

    void __QtAda_QDomNode_toCharacterData_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomCharacterData*>(returns) = self->toCharacterData();
    }

    void __QtAda_QDomNode_toComment_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomComment*>(returns) = self->toComment();
    }

    void __QtAda_QDomNode_toDocument_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomDocument*>(returns) = self->toDocument();
    }

    void __QtAda_QDomNode_toDocumentFragment_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomDocumentFragment*>(returns) = self->toDocumentFragment();
    }

    void __QtAda_QDomNode_toDocumentType_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomDocumentType*>(returns) = self->toDocumentType();
    }

    void __QtAda_QDomNode_toElement_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomElement*>(returns) = self->toElement();
    }

    void __QtAda_QDomNode_toEntity_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomEntity*>(returns) = self->toEntity();
    }

    void __QtAda_QDomNode_toEntityReference_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomEntityReference*>(returns) = self->toEntityReference();
    }

    void __QtAda_QDomNode_toNotation_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomNotation*>(returns) = self->toNotation();
    }

    void __QtAda_QDomNode_toProcessingInstruction_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomProcessingInstruction*>(returns) = self->toProcessingInstruction();
    }

    void __QtAda_QDomNode_toText_Q(QDomNode* returns, const QDomNode* self)
    {
        *static_cast<QDomText*>(returns) = self->toText();
    }

    unsigned __QtAda_QDomNode_eq_QDomNodeCR_Q(const QDomNode* self, const QDomNode* n)
    {
        return (unsigned)self->operator==(*n);
    }

};

