------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3234 $ $Date: 2009-04-09 23:05:06 +0400 (Thu, 09 Apr 2009) $
------------------------------------------------------------------------------
with Qt_Ada.Application;
with Qt4.Widgets;

with Game_Boards;

procedure Main is
begin
   Qt_Ada.Application.Initialize;

   declare
      Board : constant not null access Qt4.Widgets.Q_Widget'Class
        := Game_Boards.Constructors.Create;

   begin
      Board.Set_Geometry (100, 100, 500, 355);
      Board.Show;
      Qt_Ada.Application.Execute;
   end;
end Main;
