//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QABSTRACTITEMMODELDIRECTOR_H__
#define __QABSTRACTITEMMODELDIRECTOR_H__

#include <QAbstractItemModel>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QAbstractItemModel_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QModelIndex* __Qt4Ada_QAbstractItemModel_buddy_0_dispatch(void*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_canFetchMore_0_dispatch(void*, const QModelIndex*);
    extern int __Qt4Ada_QAbstractItemModel_columnCount_0_dispatch(void*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_dropMimeData_0_dispatch(void*, QObject*, Qt::DropAction, int, int, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemModel_fetchMore_0_dispatch(void*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_hasChildren_0_dispatch(void*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_hasIndex_0_dispatch(void*, int, int, const QModelIndex*);
    extern QModelIndex* __Qt4Ada_QAbstractItemModel_index_0_dispatch(void*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_insertColumns_0_dispatch(void*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_insertRows_0_dispatch(void*, int, int, const QModelIndex*);
    extern QObject* __Qt4Ada_QAbstractItemModel_mimeData_0_dispatch(void*, const QModelIndexList*);
    extern QStringList* __Qt4Ada_QAbstractItemModel_mimeTypes_0_dispatch(void*);
    extern QModelIndex* __Qt4Ada_QAbstractItemModel_parent_1_dispatch(void*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_removeColumns_0_dispatch(void*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_removeRows_0_dispatch(void*, int, int, const QModelIndex*);
    extern int __Qt4Ada_QAbstractItemModel_rowCount_0_dispatch(void*, const QModelIndex*);
    extern QSize* __Qt4Ada_QAbstractItemModel_span_0_dispatch(void*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemModel_revert_0_dispatch(void*);
    extern bool __Qt4Ada_QAbstractItemModel_submit_0_dispatch(void*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QAbstractItemModel_buddy_0_virtual(QObject*, const QModelIndex*, QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_canFetchMore_0_virtual(QObject*, const QModelIndex*);
    extern int __Qt4Ada_QAbstractItemModel_columnCount_0_virtual(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_dropMimeData_0_virtual(QObject*, QObject*, Qt::DropAction, int, int, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemModel_fetchMore_0_virtual(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_hasChildren_0_virtual(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_hasIndex_0_virtual(QObject*, int, int, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemModel_index_0_virtual(QObject*, int, int, const QModelIndex*, QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_insertColumns_0_virtual(QObject*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_insertRows_0_virtual(QObject*, int, int, const QModelIndex*);
    extern QObject* __Qt4Ada_QAbstractItemModel_mimeData_0_virtual(QObject*, const QModelIndexList*);
    extern void __Qt4Ada_QAbstractItemModel_mimeTypes_0_virtual(QObject*, QStringList*);
    extern void __Qt4Ada_QAbstractItemModel_parent_1_virtual(QObject*, const QModelIndex*, QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_removeColumns_0_virtual(QObject*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_removeRows_0_virtual(QObject*, int, int, const QModelIndex*);
    extern int __Qt4Ada_QAbstractItemModel_rowCount_0_virtual(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemModel_span_0_virtual(QObject*, const QModelIndex*, QSize*);
    extern void __Qt4Ada_QAbstractItemModel_revert_0_virtual(QObject*);
    extern bool __Qt4Ada_QAbstractItemModel_submit_0_virtual(QObject*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QAbstractItemModel_buddy_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_canFetchMore_0_wrapper(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_dropMimeData_0_wrapper(QObject*, QObject*, Qt::DropAction, int, int, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemModel_fetchMore_0_wrapper(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_hasChildren_0_wrapper(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_hasIndex_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_insertColumn_0_wrapper(QObject*, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_insertColumns_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_insertRow_0_wrapper(QObject*, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_insertRows_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern QObject* __Qt4Ada_QAbstractItemModel_mimeData_0_wrapper(QObject*, const QModelIndexList*);
    extern void __Qt4Ada_QAbstractItemModel_mimeTypes_0_wrapper(QObject*, QStringList*);
    extern bool __Qt4Ada_QAbstractItemModel_removeColumn_0_wrapper(QObject*, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_removeColumns_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_removeRow_0_wrapper(QObject*, int, const QModelIndex*);
    extern bool __Qt4Ada_QAbstractItemModel_removeRows_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemModel_sibling_0_wrapper(QObject*, int, int, const QModelIndex*, QModelIndex*);
    extern void __Qt4Ada_QAbstractItemModel_span_0_wrapper(QObject*, const QModelIndex*, QSize*);
    extern void __Qt4Ada_QAbstractItemModel_revert_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractItemModel_submit_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    extern void __Qt4Ada_QAbstractItemModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_layoutChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QAbstractItemModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern bool __Qt4Ada_QAbstractItemModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern bool __Qt4Ada_QAbstractItemModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern void __Qt4Ada_QAbstractItemModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QAbstractItemModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QAbstractItemModel_beginResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemModel_endInsertColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_endInsertRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_endMoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_endMoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_endRemoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_endRemoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_endResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_reset_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemModel_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemModel_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemModel_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QAbstractItemModel_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QAbstractItemModel_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QAbstractItemModel_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C"
{
   extern QObject* __Qt4Ada_new_QAbstractItemModelDirector (void*, QObject*);
   extern QVariant* __Qt4Ada_QAbstractItemModel_data_dispatch (void*, const QModelIndex*, int);
   extern unsigned __Qt4Ada_QAbstractItemModel_flags_dispatch (void*, const QModelIndex*);
   extern QVariant* __Qt4Ada_QAbstractItemModel_headerData_dispatch (void*,int, Qt::Orientation, int);
   extern bool __Qt4Ada_QAbstractItemModel_setData_dispatch (void*, const QModelIndex*, const QVariant*, int);
   extern bool __Qt4Ada_QAbstractItemModel_setHeaderData_dispatch (void*, int, int, const QVariant*, int);

   extern QVariant*     __Qt4Ada_QAbstractItemModel_data_virtual (QObject*, const QModelIndex*, int);
   extern int __Qt4Ada_QAbstractItemModel_flags_virtual (QObject*, const QModelIndex*);
   extern int __Qt4Ada_QAbstractItemModel_flags_static (QObject*, const QModelIndex*);
   extern QVariant*     __Qt4Ada_QAbstractItemModel_headerData_virtual (QObject*,int, unsigned, int);
   extern QVariant*     __Qt4Ada_QAbstractItemModel_headerData_static (QObject*,int, unsigned, int);
   extern bool          __Qt4Ada_QAbstractItemModel_setData_virtual
                           (QObject*,const QModelIndex*, const QVariant*, int);
   extern bool          __Qt4Ada_QAbstractItemModel_setHeaderData_virtual
                           (QObject*, int, int, const QVariant*, int);

   extern QModelIndex*  __Qt4Ada_QAbstractItemModel_createIndex_wrapper (QObject*, int, int, void*);

   extern bool          __Qt4Ada_QAbstractItemModel_setData_wrapper
                           (QObject*,const QModelIndex*, const QVariant*, int);

}

class QAbstractItemModelDirector : public QAbstractItemModel
{
protected:
    void* ada_object;
public:
    QAbstractItemModelDirector(void*, QObject*);

    virtual QVariant      data (const QModelIndex&, int) const;
    virtual Qt::ItemFlags flags (const QModelIndex & index) const;
    virtual QVariant      headerData (int, Qt::Orientation , int) const;
    virtual bool          setData
                             (const QModelIndex & index, const QVariant & value, int role = Qt::EditRole);
    virtual bool          setHeaderData
                             (int section, Qt::Orientation orientation, const QVariant & value, int role);

    friend QModelIndex* __Qt4Ada_QAbstractItemModel_createIndex_wrapper (QObject*, int, int, void*);

    virtual QModelIndex buddy(const QModelIndex&) const;
    virtual bool canFetchMore(const QModelIndex&) const;
    virtual int columnCount(const QModelIndex&) const;
    virtual bool dropMimeData(QMimeData*, Qt::DropAction, int, int, const QModelIndex&);
    virtual void fetchMore(const QModelIndex&);
    virtual bool hasChildren(const QModelIndex&) const;
    virtual bool hasIndex(int, int, const QModelIndex&) const;
    virtual QModelIndex index(int, int, const QModelIndex&) const;
    virtual bool insertColumns(int, int, const QModelIndex&);
    virtual bool insertRows(int, int, const QModelIndex&);
    virtual QMimeData* mimeData(const QModelIndexList&) const;
    virtual QStringList mimeTypes() const;
    virtual QModelIndex parent(const QModelIndex&) const;
    virtual bool removeColumns(int, int, const QModelIndex&);
    virtual bool removeRows(int, int, const QModelIndex&);
    virtual int rowCount(const QModelIndex&) const;
    virtual QSize span(const QModelIndex&) const;
    virtual void revert();
    virtual bool submit();
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QAbstractItemModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractItemModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    friend void __Qt4Ada_QAbstractItemModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_layoutChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QAbstractItemModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend bool __Qt4Ada_QAbstractItemModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend bool __Qt4Ada_QAbstractItemModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend void __Qt4Ada_QAbstractItemModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QAbstractItemModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QAbstractItemModel_beginResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractItemModel_endInsertColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_endInsertRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_endMoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_endMoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_endRemoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_endRemoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_endResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_reset_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemModel_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemModel_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemModel_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QAbstractItemModel_sender_0_wrapper(QObject*);
};

#endif // __QABSTRACTITEMMODELDIRECTOR_H__
