//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QModelIndex>
#include <QMimeData>
#include <QStringList>
#include <QSize>
#include <QChildEvent>
#include <QTimerEvent>

#include "qabstractlistmodeldirector.h"
#include "qabstractitemmodeldirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractListModel_staticMetaObject =
        &QAbstractListModel::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QAbstractListModel_index_0_wrapper(QObject* cpp_object, int row, int column, const QModelIndex* parent, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractListModel*>(cpp_object)->QAbstractListModel::index(row, column, *parent);
    }

    extern QModelIndex _ZNK18QAbstractListModel6parentERK11QModelIndex(const QAbstractListModel*,const QModelIndex&);

    void __Qt4Ada_QAbstractListModel_parent_1_wrapper(QObject* cpp_object, const QModelIndex* child, QModelIndex* returns)
    {
        *returns = _ZNK18QAbstractListModel6parentERK11QModelIndex(dynamic_cast<const QAbstractListModelDirector*>(cpp_object), *child);
    }

    extern int _ZNK18QAbstractListModel11columnCountERK11QModelIndex(const QAbstractListModel*,const QModelIndex&);

    int __Qt4Ada_QAbstractListModel_columnCount_0_wrapper(QObject* cpp_object, const QModelIndex* parent)
    {
        return _ZNK18QAbstractListModel11columnCountERK11QModelIndex(dynamic_cast<const QAbstractListModelDirector*>(cpp_object), *parent);
    }

    extern bool _ZNK18QAbstractListModel11hasChildrenERK11QModelIndex(const QAbstractListModel*,const QModelIndex&);

    bool __Qt4Ada_QAbstractListModel_hasChildren_0_wrapper(QObject* cpp_object, const QModelIndex* parent)
    {
        return _ZNK18QAbstractListModel11hasChildrenERK11QModelIndex(dynamic_cast<const QAbstractListModelDirector*>(cpp_object), *parent);
    }

    void __Qt4Ada_QAbstractListModel_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::dataChanged(*topLeft, *bottomRight);
    }

    void __Qt4Ada_QAbstractListModel_headerDataChanged_0_wrapper(QObject* cpp_object, Qt::Orientation orientation, int first, int last)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::headerDataChanged(orientation, first, last);
    }

    void __Qt4Ada_QAbstractListModel_layoutAboutToBeChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::layoutAboutToBeChanged();
    }

    void __Qt4Ada_QAbstractListModel_layoutChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::layoutChanged();
    }

    void __Qt4Ada_QAbstractListModel_beginInsertColumns_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::beginInsertColumns(*parent, first, last);
    }

    void __Qt4Ada_QAbstractListModel_beginInsertRows_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::beginInsertRows(*parent, first, last);
    }

    bool __Qt4Ada_QAbstractListModel_beginMoveColumns_0_wrapper(QObject* cpp_object, const QModelIndex* sourceParent, int sourceFirst, int sourceLast, const QModelIndex* destinationParent, int destinationChild)
    {
        return dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::beginMoveColumns(*sourceParent, sourceFirst, sourceLast, *destinationParent, destinationChild);
    }

    bool __Qt4Ada_QAbstractListModel_beginMoveRows_0_wrapper(QObject* cpp_object, const QModelIndex* sourceParent, int sourceFirst, int sourceLast, const QModelIndex* destinationParent, int destinationChild)
    {
        return dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::beginMoveRows(*sourceParent, sourceFirst, sourceLast, *destinationParent, destinationChild);
    }

    void __Qt4Ada_QAbstractListModel_beginRemoveColumns_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::beginRemoveColumns(*parent, first, last);
    }

    void __Qt4Ada_QAbstractListModel_beginRemoveRows_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::beginRemoveRows(*parent, first, last);
    }

    void __Qt4Ada_QAbstractListModel_beginResetModel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::beginResetModel();
    }

    void __Qt4Ada_QAbstractListModel_changePersistentIndex_0_wrapper(QObject* cpp_object, const QModelIndex* from, const QModelIndex* to)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::changePersistentIndex(*from, *to);
    }

    void __Qt4Ada_QAbstractListModel_endInsertColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::endInsertColumns();
    }

    void __Qt4Ada_QAbstractListModel_endInsertRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::endInsertRows();
    }

    void __Qt4Ada_QAbstractListModel_endMoveColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::endMoveColumns();
    }

    void __Qt4Ada_QAbstractListModel_endMoveRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::endMoveRows();
    }

    void __Qt4Ada_QAbstractListModel_endRemoveColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::endRemoveColumns();
    }

    void __Qt4Ada_QAbstractListModel_endRemoveRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::endRemoveRows();
    }

    void __Qt4Ada_QAbstractListModel_endResetModel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::endResetModel();
    }

    void __Qt4Ada_QAbstractListModel_reset_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QAbstractItemModel::reset();
    }

    void __Qt4Ada_QAbstractListModel_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractListModel_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QAbstractListModel_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QAbstractListModel_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractListModelDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractListModel_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractListModel*>(cpp_this)->QAbstractListModel::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractListModel_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractListModel*>(cpp_this)->QAbstractListModel::qt_metacall(_c, _id, _a);
    }

}

QModelIndex QAbstractListModelDirector::index(int row, int column, const QModelIndex& parent) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_index_0_dispatch(this->ada_object, row, column, &parent);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

QModelIndex QAbstractListModelDirector::parent(const QModelIndex& child) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_parent_1_dispatch(this->ada_object, &child);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

int QAbstractListModelDirector::columnCount(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_columnCount_0_dispatch(this->ada_object, &parent);
}

bool QAbstractListModelDirector::hasChildren(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_hasChildren_0_dispatch(this->ada_object, &parent);
}

QModelIndex QAbstractListModelDirector::buddy(const QModelIndex& index) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_buddy_0_dispatch(this->ada_object, &index);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QAbstractListModelDirector::canFetchMore(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_canFetchMore_0_dispatch(this->ada_object, &parent);
}

bool QAbstractListModelDirector::dropMimeData(QMimeData* data, Qt::DropAction action, int row, int column, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_dropMimeData_0_dispatch(this->ada_object, data, action, row, column, &parent);
}

void QAbstractListModelDirector::fetchMore(const QModelIndex& parent)
{
    __Qt4Ada_QAbstractItemModel_fetchMore_0_dispatch(this->ada_object, &parent);
}

bool QAbstractListModelDirector::hasIndex(int row, int column, const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_hasIndex_0_dispatch(this->ada_object, row, column, &parent);
}

bool QAbstractListModelDirector::insertColumns(int column, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_insertColumns_0_dispatch(this->ada_object, column, count, &parent);
}

bool QAbstractListModelDirector::insertRows(int row, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_insertRows_0_dispatch(this->ada_object, row, count, &parent);
}

QMimeData* QAbstractListModelDirector::mimeData(const QModelIndexList& indexes) const
{
    return dynamic_cast<QMimeData*>(__Qt4Ada_QAbstractItemModel_mimeData_0_dispatch(this->ada_object, &indexes));
}

QStringList QAbstractListModelDirector::mimeTypes() const
{
    QStringList *aux = __Qt4Ada_QAbstractItemModel_mimeTypes_0_dispatch(this->ada_object);
    QStringList returns = *aux;
    delete aux;
    return returns;
}

bool QAbstractListModelDirector::removeColumns(int column, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_removeColumns_0_dispatch(this->ada_object, column, count, &parent);
}

bool QAbstractListModelDirector::removeRows(int row, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_removeRows_0_dispatch(this->ada_object, row, count, &parent);
}

int QAbstractListModelDirector::rowCount(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_rowCount_0_dispatch(this->ada_object, &parent);
}

QSize QAbstractListModelDirector::span(const QModelIndex& index) const
{
    QSize *aux = __Qt4Ada_QAbstractItemModel_span_0_dispatch(this->ada_object, &index);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractListModelDirector::revert()
{
    __Qt4Ada_QAbstractItemModel_revert_0_dispatch(this->ada_object);
}

bool QAbstractListModelDirector::submit()
{
    return __Qt4Ada_QAbstractItemModel_submit_0_dispatch(this->ada_object);
}

bool QAbstractListModelDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QAbstractListModelDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractListModelDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractListModelDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QAbstractListModelDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractListModelDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractListModelDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractListModelDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QAbstractListModelDirector::QAbstractListModelDirector(void* o, QObject* parent) :
    QAbstractListModel (parent),
    ada_object (o)
{
}

bool QAbstractListModelDirector::setData(const QModelIndex& index, const QVariant& value, int role)
{
    return __Qt4Ada_QAbstractItemModel_setData_dispatch(this->ada_object, &index, &value, role);
}

bool QAbstractListModelDirector::setHeaderData(int section, Qt::Orientation orientation, const QVariant& value, int role)
{
   return __Qt4Ada_QAbstractItemModel_setHeaderData_dispatch
             (this->ada_object, section, orientation, &value, role);
}

QVariant QAbstractListModelDirector::data(const QModelIndex &parent, int role) const
{
   QVariant *tmp = __Qt4Ada_QAbstractItemModel_data_dispatch(this->ada_object, &parent, role);
   QVariant returns = *tmp;
   delete tmp;
   return returns;
}

Qt::ItemFlags QAbstractListModelDirector::flags (const QModelIndex & index) const
{
    return (Qt::ItemFlags) __Qt4Ada_QAbstractItemModel_flags_dispatch (this->ada_object, &index);
}

QVariant QAbstractListModelDirector::headerData(int section, Qt::Orientation orientation, int role) const
{
    QVariant* tmp = __Qt4Ada_QAbstractItemModel_headerData_dispatch(this->ada_object, section, orientation, role);
    QVariant returns = *tmp;
    delete tmp;
    return returns;
}

extern "C"
{

    QObject *__Qt4Ada_new_QAbstractListModelDirector(void* ada_object, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QAbstractListModelDirector(ada_object, parent));
    }

}
