//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QDate>
#include <QString>
#include "qdatewrapper.h"

extern "C"
{

    QDate* __QtAda_inititialize_QDate(void* storage)
    {
        return new (storage) QDate();
    }

    QDate* __QtAda_inititialize_QDate_int_int_int(void* storage, int y, int m, int d)
    {
        return new (storage) QDate(y, m, d);
    }

    QDate* __QtAda_adjust_QDate(void* storage, const QDate* from)
    {
        return new (storage) QDate(*from);
    }

    void __QtAda_finalize_QDate(QDate *item)
    {
        item->~QDate();
    }

    void __QtAda_QDate_addDays_int_Q(QDate* returns, const QDate* self, int days)
    {
        *returns = self->addDays(days);
    }

    void __QtAda_QDate_addMonths_int_Q(QDate* returns, const QDate* self, int months)
    {
        *returns = self->addMonths(months);
    }

    void __QtAda_QDate_addYears_int_Q(QDate* returns, const QDate* self, int years)
    {
        *returns = self->addYears(years);
    }

    int __QtAda_QDate_day_Q(const QDate* self)
    {
        return self->day();
    }

    unsigned __QtAda_QDate_dayOfWeek_Q(const QDate* self)
    {
        return (unsigned)self->dayOfWeek();
    }

    int __QtAda_QDate_dayOfYear_Q(const QDate* self)
    {
        return self->dayOfYear();
    }

    int __QtAda_QDate_daysInMonth_Q(const QDate* self)
    {
        return self->daysInMonth();
    }

    int __QtAda_QDate_daysInYear_Q(const QDate* self)
    {
        return self->daysInYear();
    }

    int __QtAda_QDate_daysTo_QDateCR_Q(const QDate* self, const QDate* d)
    {
        return self->daysTo(*d);
    }

    unsigned __QtAda_QDate_isNull_Q(const QDate* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QDate_isValid_Q(const QDate* self)
    {
        return (unsigned)self->isValid();
    }

    int __QtAda_QDate_month_Q(const QDate* self)
    {
        return self->month();
    }

    int __QtAda_QDate_toJulianDay_Q(const QDate* self)
    {
        return self->toJulianDay();
    }

    void __QtAda_QDate_toString_QStringCR_Q(QString* returns, const QDate* self, const QString* format)
    {
        *returns = self->toString(*format);
    }

    void __QtAda_QDate_toString_DateFormat_Q(QString* returns, const QDate* self, unsigned f)
    {
        *returns = self->toString((Qt::DateFormat)f);
    }

    int __QtAda_QDate_year_Q(const QDate* self)
    {
        return self->year();
    }

    void __QtAda_QDate_currentDate_S(QDate* returns)
    {
        *returns = QDate::currentDate();
    }

    void __QtAda_QDate_fromJulianDay_int_S(QDate* returns, int jd)
    {
        *returns = QDate::fromJulianDay(jd);
    }

    void __QtAda_QDate_fromString_QStringCR_DateFormat_S(QDate* returns, const QString* s, unsigned f)
    {
        *returns = QDate::fromString(*s, (Qt::DateFormat)f);
    }

    void __QtAda_QDate_fromString_QStringCR_QStringCR_S(QDate* returns, const QString* s, const QString* format)
    {
        *returns = QDate::fromString(*s, *format);
    }

    unsigned __QtAda_QDate_isLeapYear_int_S(int year)
    {
        return (unsigned)QDate::isLeapYear(year);
    }

    unsigned __QtAda_QDate_isValid_int_int_int_S(int y, int m, int d)
    {
        return (unsigned)QDate::isValid(y, m, d);
    }

    void __QtAda_QDate_longDayName_DayOfWeek_S(QString* returns, unsigned weekday)
    {
        *returns = QDate::longDayName((Qt::DayOfWeek)weekday);
    }

    void __QtAda_QDate_longMonthName_int_S(QString* returns, int month)
    {
        *returns = QDate::longMonthName(month);
    }

    void __QtAda_QDate_shortDayName_DayOfWeek_S(QString* returns, unsigned weekday)
    {
        *returns = QDate::shortDayName((Qt::DayOfWeek)weekday);
    }

    void __QtAda_QDate_shortMonthName_int_S(QString* returns, int month)
    {
        *returns = QDate::shortMonthName(month);
    }

    unsigned __QtAda_QDate_eq_QDateCR_Q(const QDate* self, const QDate* other)
    {
        return (unsigned)self->operator==(*other);
    }

    unsigned __QtAda_QDate_lt_QDateCR_Q(const QDate* self, const QDate* other)
    {
        return (unsigned)self->operator<(*other);
    }

    unsigned __QtAda_QDate_le_QDateCR_Q(const QDate* self, const QDate* other)
    {
        return (unsigned)self->operator<=(*other);
    }

    unsigned __QtAda_QDate_gt_QDateCR_Q(const QDate* self, const QDate* other)
    {
        return (unsigned)self->operator>(*other);
    }

    unsigned __QtAda_QDate_ge_QDateCR_Q(const QDate* self, const QDate* other)
    {
        return (unsigned)self->operator>=(*other);
    }

};

