//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007  Vadim Godunko <vgodunko@gmail.com>                     //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QDate>

extern "C"
{
    extern QDate* __QtAda_inititialize_QDate(void*);
    extern QDate* __QtAda_inititialize_QDate_int_int_int(void*, int, int, int);
    extern QDate* __QtAda_adjust_QDate(void*, const QDate*);
    extern void __QtAda_finalize_QDate(QDate*);

    extern void __QtAda_QDate_addDays_int_Q(QDate*, const QDate*, int);
    extern void __QtAda_QDate_addMonths_int_Q(QDate*, const QDate*, int);
    extern void __QtAda_QDate_addYears_int_Q(QDate*, const QDate*, int);
    extern int __QtAda_QDate_day_Q(const QDate*);
    extern unsigned __QtAda_QDate_dayOfWeek_Q(const QDate*);
    extern int __QtAda_QDate_dayOfYear_Q(const QDate*);
    extern int __QtAda_QDate_daysInMonth_Q(const QDate*);
    extern int __QtAda_QDate_daysInYear_Q(const QDate*);
    extern int __QtAda_QDate_daysTo_QDateCR_Q(const QDate*, const QDate*);
    extern unsigned __QtAda_QDate_isNull_Q(const QDate*);
    extern unsigned __QtAda_QDate_isValid_Q(const QDate*);
    extern int __QtAda_QDate_month_Q(const QDate*);
    extern int __QtAda_QDate_toJulianDay_Q(const QDate*);
    extern void __QtAda_QDate_toString_QStringCR_Q(QString*, const QDate*, const QString*);
    extern void __QtAda_QDate_toString_DateFormat_Q(QString*, const QDate*, unsigned);
    extern int __QtAda_QDate_year_Q(const QDate*);
    extern void __QtAda_QDate_currentDate_S(QDate*);
    extern void __QtAda_QDate_fromJulianDay_int_S(QDate*, int);
    extern void __QtAda_QDate_fromString_QStringCR_DateFormat_S(QDate*, const QString*, unsigned);
    extern void __QtAda_QDate_fromString_QStringCR_QStringCR_S(QDate*, const QString*, const QString*);
    extern unsigned __QtAda_QDate_isLeapYear_int_S(int);
    extern unsigned __QtAda_QDate_isValid_int_int_int_S(int, int, int);
    extern void __QtAda_QDate_longDayName_DayOfWeek_S(QString*, unsigned);
    extern void __QtAda_QDate_longMonthName_int_S(QString*, int);
    extern void __QtAda_QDate_shortDayName_DayOfWeek_S(QString*, unsigned);
    extern void __QtAda_QDate_shortMonthName_int_S(QString*, int);
    extern unsigned __QtAda_QDate_eq_QDateCR_Q(const QDate*, const QDate*);
    extern unsigned __QtAda_QDate_lt_QDateCR_Q(const QDate*, const QDate*);
    extern unsigned __QtAda_QDate_le_QDateCR_Q(const QDate*, const QDate*);
    extern unsigned __QtAda_QDate_gt_QDateCR_Q(const QDate*, const QDate*);
    extern unsigned __QtAda_QDate_ge_QDateCR_Q(const QDate*, const QDate*);

};

