//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QChildEvent>
#include <QTimerEvent>

#include "qfiledirector.h"
#include "qiodevicedirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QFile_staticMetaObject =
        &QFile::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QFile_copy_0_wrapper(QObject* cpp_object, const QString* newName)
    {
        return dynamic_cast<QFile*>(cpp_object)->QFile::copy(*newName);
    }

    bool __Qt4Ada_QFile_exists_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFile*>(cpp_object)->QFile::exists();
    }

    void __Qt4Ada_QFile_fileName_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QFile*>(cpp_object)->QFile::fileName();
    }

    bool __Qt4Ada_QFile_flush_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFile*>(cpp_object)->QFile::flush();
    }

    int __Qt4Ada_QFile_handle_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFile*>(cpp_object)->QFile::handle();
    }

    bool __Qt4Ada_QFile_link_0_wrapper(QObject* cpp_object, const QString* linkName)
    {
        return dynamic_cast<QFile*>(cpp_object)->QFile::link(*linkName);
    }

    bool __Qt4Ada_QFile_remove_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFile*>(cpp_object)->QFile::remove();
    }

    bool __Qt4Ada_QFile_rename_0_wrapper(QObject* cpp_object, const QString* newName)
    {
        return dynamic_cast<QFile*>(cpp_object)->QFile::rename(*newName);
    }

    void __Qt4Ada_QFile_setFileName_0_wrapper(QObject* cpp_object, const QString* name)
    {
        dynamic_cast<QFile*>(cpp_object)->QFile::setFileName(*name);
    }

    void __Qt4Ada_QFile_symLinkTarget_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QFile*>(cpp_object)->QFile::symLinkTarget();
    }

    void __Qt4Ada_QFile_unsetError_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QFile*>(cpp_object)->QFile::unsetError();
    }

    bool __Qt4Ada_QFile_atEnd_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFile*>(cpp_object)->QFile::atEnd();
    }

    void __Qt4Ada_QFile_close_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QFile*>(cpp_object)->QFile::close();
    }

    bool __Qt4Ada_QFile_isSequential_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFile*>(cpp_object)->QFile::isSequential();
    }

    void __Qt4Ada_QFile_aboutToClose_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QFileDirector*>(cpp_object)->QIODevice::aboutToClose();
    }

    void __Qt4Ada_QFile_bytesWritten_0_wrapper(QObject* cpp_object, qint64 bytes)
    {
        dynamic_cast<QFileDirector*>(cpp_object)->QIODevice::bytesWritten(bytes);
    }

    void __Qt4Ada_QFile_readChannelFinished_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QFileDirector*>(cpp_object)->QIODevice::readChannelFinished();
    }

    void __Qt4Ada_QFile_readyRead_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QFileDirector*>(cpp_object)->QIODevice::readyRead();
    }

    void __Qt4Ada_QFile_setErrorString_0_wrapper(QObject* cpp_object, const QString* errorString)
    {
        dynamic_cast<QFileDirector*>(cpp_object)->QIODevice::setErrorString(*errorString);
    }

    void __Qt4Ada_QFile_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QFile_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QFile_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QFile_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFileDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QFile_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QFile*>(cpp_this)->QFile::qt_metacast(name);
    }

    int __Qt4Ada_QFile_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QFile*>(cpp_this)->QFile::qt_metacall(_c, _id, _a);
    }

}

bool QFileDirector::atEnd() const
{
    return __Qt4Ada_QIODevice_atEnd_0_dispatch(this->ada_object);
}

void QFileDirector::close()
{
    __Qt4Ada_QIODevice_close_0_dispatch(this->ada_object);
}

bool QFileDirector::isSequential() const
{
    return __Qt4Ada_QIODevice_isSequential_0_dispatch(this->ada_object);
}

qint64 QFileDirector::bytesAvailable() const
{
    return __Qt4Ada_QIODevice_bytesAvailable_0_dispatch(this->ada_object);
}

qint64 QFileDirector::bytesToWrite() const
{
    return __Qt4Ada_QIODevice_bytesToWrite_0_dispatch(this->ada_object);
}

bool QFileDirector::canReadLine() const
{
    return __Qt4Ada_QIODevice_canReadLine_0_dispatch(this->ada_object);
}

qint64 QFileDirector::pos() const
{
    return __Qt4Ada_QIODevice_pos_0_dispatch(this->ada_object);
}

bool QFileDirector::reset()
{
    return __Qt4Ada_QIODevice_reset_0_dispatch(this->ada_object);
}

bool QFileDirector::seek(qint64 pos)
{
    return __Qt4Ada_QIODevice_seek_0_dispatch(this->ada_object, pos);
}

qint64 QFileDirector::size() const
{
    return __Qt4Ada_QIODevice_size_0_dispatch(this->ada_object);
}

bool QFileDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QFileDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QFileDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QFileDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QFileDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QFileDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QFileDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QFileDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{

    QObject* __Qt4Ada_new_QFile (const QString* const name)
    {
        return new QFile (*name);
    }

    bool __Qt4Ada_QFile_open_wrapper (QObject* ptr, unsigned mode)
    {
        return dynamic_cast<QFile*>(ptr)->QFile::open(QIODevice::OpenMode(mode));
    }

}
