//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QDateTime>
#include <QDir>
#include <QString>
#include "qfileinfowrapper.h"

extern "C"
{

    QFileInfo* __QtAda_inititialize_QFileInfo(void* storage)
    {
        return new (storage) QFileInfo();
    }

    QFileInfo* __QtAda_inititialize_QFileInfo_QStringCR(void* storage, const QString* file)
    {
        return new (storage) QFileInfo(*file);
    }

    QFileInfo* __QtAda_inititialize_QFileInfo_QDirCR_QStringCR(void* storage, const QDir* dir, const QString* file)
    {
        return new (storage) QFileInfo(*dir, *file);
    }

    QFileInfo* __QtAda_adjust_QFileInfo(void* storage, const QFileInfo* from)
    {
        return new (storage) QFileInfo(*from);
    }

    void __QtAda_finalize_QFileInfo(QFileInfo *item)
    {
        item->~QFileInfo();
    }

    void __QtAda_QFileInfo_absoluteDir_Q(QDir* returns, const QFileInfo* self)
    {
        *returns = self->absoluteDir();
    }

    void __QtAda_QFileInfo_absoluteFilePath_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->absoluteFilePath();
    }

    void __QtAda_QFileInfo_absolutePath_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->absolutePath();
    }

    void __QtAda_QFileInfo_baseName_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->baseName();
    }

    void __QtAda_QFileInfo_bundleName_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->bundleName();
    }

    unsigned __QtAda_QFileInfo_caching_Q(const QFileInfo* self)
    {
        return (unsigned)self->caching();
    }

    void __QtAda_QFileInfo_canonicalFilePath_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->canonicalFilePath();
    }

    void __QtAda_QFileInfo_canonicalPath_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->canonicalPath();
    }

    void __QtAda_QFileInfo_completeBaseName_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->completeBaseName();
    }

    void __QtAda_QFileInfo_completeSuffix_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->completeSuffix();
    }

    void __QtAda_QFileInfo_created_Q(QDateTime* returns, const QFileInfo* self)
    {
        *returns = self->created();
    }

    void __QtAda_QFileInfo_dir_Q(QDir* returns, const QFileInfo* self)
    {
        *returns = self->dir();
    }

    unsigned __QtAda_QFileInfo_exists_Q(const QFileInfo* self)
    {
        return (unsigned)self->exists();
    }

    void __QtAda_QFileInfo_fileName_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->fileName();
    }

    void __QtAda_QFileInfo_filePath_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->filePath();
    }

    void __QtAda_QFileInfo_group_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->group();
    }

    uint __QtAda_QFileInfo_groupId_Q(const QFileInfo* self)
    {
        return self->groupId();
    }

    unsigned __QtAda_QFileInfo_isAbsolute_Q(const QFileInfo* self)
    {
        return (unsigned)self->isAbsolute();
    }

    unsigned __QtAda_QFileInfo_isBundle_Q(const QFileInfo* self)
    {
        return (unsigned)self->isBundle();
    }

    unsigned __QtAda_QFileInfo_isDir_Q(const QFileInfo* self)
    {
        return (unsigned)self->isDir();
    }

    unsigned __QtAda_QFileInfo_isExecutable_Q(const QFileInfo* self)
    {
        return (unsigned)self->isExecutable();
    }

    unsigned __QtAda_QFileInfo_isFile_Q(const QFileInfo* self)
    {
        return (unsigned)self->isFile();
    }

    unsigned __QtAda_QFileInfo_isHidden_Q(const QFileInfo* self)
    {
        return (unsigned)self->isHidden();
    }

    unsigned __QtAda_QFileInfo_isReadable_Q(const QFileInfo* self)
    {
        return (unsigned)self->isReadable();
    }

    unsigned __QtAda_QFileInfo_isRelative_Q(const QFileInfo* self)
    {
        return (unsigned)self->isRelative();
    }

    unsigned __QtAda_QFileInfo_isRoot_Q(const QFileInfo* self)
    {
        return (unsigned)self->isRoot();
    }

    unsigned __QtAda_QFileInfo_isSymLink_Q(const QFileInfo* self)
    {
        return (unsigned)self->isSymLink();
    }

    unsigned __QtAda_QFileInfo_isWritable_Q(const QFileInfo* self)
    {
        return (unsigned)self->isWritable();
    }

    void __QtAda_QFileInfo_lastModified_Q(QDateTime* returns, const QFileInfo* self)
    {
        *returns = self->lastModified();
    }

    void __QtAda_QFileInfo_lastRead_Q(QDateTime* returns, const QFileInfo* self)
    {
        *returns = self->lastRead();
    }

    unsigned __QtAda_QFileInfo_makeAbsolute(QFileInfo* self)
    {
        return (unsigned)self->makeAbsolute();
    }

    void __QtAda_QFileInfo_owner_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->owner();
    }

    uint __QtAda_QFileInfo_ownerId_Q(const QFileInfo* self)
    {
        return self->ownerId();
    }

    void __QtAda_QFileInfo_path_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->path();
    }

    void __QtAda_QFileInfo_refresh(QFileInfo* self)
    {
        self->refresh();
    }

    void __QtAda_QFileInfo_setCaching_bool(QFileInfo* self, unsigned enable)
    {
        self->setCaching((bool)enable);
    }

    void __QtAda_QFileInfo_setFile_QStringCR(QFileInfo* self, const QString* file)
    {
        self->setFile(*file);
    }

    void __QtAda_QFileInfo_setFile_QDirCR_QStringCR(QFileInfo* self, const QDir* dir, const QString* file)
    {
        self->setFile(*dir, *file);
    }

    qint64 __QtAda_QFileInfo_size_Q(const QFileInfo* self)
    {
        return self->size();
    }

    void __QtAda_QFileInfo_suffix_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->suffix();
    }

    void __QtAda_QFileInfo_symLinkTarget_Q(QString* returns, const QFileInfo* self)
    {
        *returns = self->symLinkTarget();
    }

    unsigned __QtAda_QFileInfo_eq_QFileInfoCR_Q(const QFileInfo* self, const QFileInfo* fileinfo)
    {
        return (unsigned)self->operator==(*fileinfo);
    }

};

