//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QIODEVICEDIRECTOR_H__
#define __QIODEVICEDIRECTOR_H__

#include <QIODevice>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QIODevice_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern bool __Qt4Ada_QIODevice_atEnd_0_dispatch(void*);
    extern qint64 __Qt4Ada_QIODevice_bytesAvailable_0_dispatch(void*);
    extern qint64 __Qt4Ada_QIODevice_bytesToWrite_0_dispatch(void*);
    extern bool __Qt4Ada_QIODevice_canReadLine_0_dispatch(void*);
    extern void __Qt4Ada_QIODevice_close_0_dispatch(void*);
    extern bool __Qt4Ada_QIODevice_isSequential_0_dispatch(void*);
    extern qint64 __Qt4Ada_QIODevice_pos_0_dispatch(void*);
    extern bool __Qt4Ada_QIODevice_reset_0_dispatch(void*);
    extern bool __Qt4Ada_QIODevice_seek_0_dispatch(void*, qint64);
    extern qint64 __Qt4Ada_QIODevice_size_0_dispatch(void*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern bool __Qt4Ada_QIODevice_atEnd_0_virtual(QObject*);
    extern qint64 __Qt4Ada_QIODevice_bytesAvailable_0_virtual(QObject*);
    extern qint64 __Qt4Ada_QIODevice_bytesToWrite_0_virtual(QObject*);
    extern bool __Qt4Ada_QIODevice_canReadLine_0_virtual(QObject*);
    extern void __Qt4Ada_QIODevice_close_0_virtual(QObject*);
    extern bool __Qt4Ada_QIODevice_isSequential_0_virtual(QObject*);
    extern qint64 __Qt4Ada_QIODevice_pos_0_virtual(QObject*);
    extern bool __Qt4Ada_QIODevice_reset_0_virtual(QObject*);
    extern bool __Qt4Ada_QIODevice_seek_0_virtual(QObject*, qint64);
    extern qint64 __Qt4Ada_QIODevice_size_0_virtual(QObject*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QIODevice_atEnd_0_wrapper(QObject*);
    extern qint64 __Qt4Ada_QIODevice_bytesAvailable_0_wrapper(QObject*);
    extern qint64 __Qt4Ada_QIODevice_bytesToWrite_0_wrapper(QObject*);
    extern bool __Qt4Ada_QIODevice_canReadLine_0_wrapper(QObject*);
    extern void __Qt4Ada_QIODevice_close_0_wrapper(QObject*);
    extern void __Qt4Ada_QIODevice_errorString_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QIODevice_isOpen_0_wrapper(QObject*);
    extern bool __Qt4Ada_QIODevice_isReadable_0_wrapper(QObject*);
    extern bool __Qt4Ada_QIODevice_isSequential_0_wrapper(QObject*);
    extern bool __Qt4Ada_QIODevice_isTextModeEnabled_0_wrapper(QObject*);
    extern bool __Qt4Ada_QIODevice_isWritable_0_wrapper(QObject*);
    extern void __Qt4Ada_QIODevice_peek_0_wrapper(QObject*, qint64, QByteArray*);
    extern qint64 __Qt4Ada_QIODevice_pos_0_wrapper(QObject*);
    extern void __Qt4Ada_QIODevice_read_0_wrapper(QObject*, qint64, QByteArray*);
    extern void __Qt4Ada_QIODevice_readAll_0_wrapper(QObject*, QByteArray*);
    extern void __Qt4Ada_QIODevice_readLine_0_wrapper(QObject*, qint64, QByteArray*);
    extern bool __Qt4Ada_QIODevice_reset_0_wrapper(QObject*);
    extern bool __Qt4Ada_QIODevice_seek_0_wrapper(QObject*, qint64);
    extern void __Qt4Ada_QIODevice_setTextModeEnabled_0_wrapper(QObject*, bool);
    extern qint64 __Qt4Ada_QIODevice_size_0_wrapper(QObject*);
    extern qint64 __Qt4Ada_QIODevice_write_0_wrapper(QObject*, const QByteArray*);
    extern void __Qt4Ada_QIODevice_aboutToClose_0_wrapper(QObject*);
    extern void __Qt4Ada_QIODevice_bytesWritten_0_wrapper(QObject*, qint64);
    extern void __Qt4Ada_QIODevice_readChannelFinished_0_wrapper(QObject*);
    extern void __Qt4Ada_QIODevice_readyRead_0_wrapper(QObject*);
    extern void __Qt4Ada_QIODevice_setErrorString_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QIODevice_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QIODevice_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QIODevice_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QIODevice_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QIODevice_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QIODevice_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

   bool __Qt4Ada_QIODevice_open_virtual(QObject*, unsigned);

}

class QIODeviceDirector : public QIODevice
{
protected:
    void* ada_object;
    QIODeviceDirector();

    virtual bool atEnd() const;
    virtual qint64 bytesAvailable() const;
    virtual qint64 bytesToWrite() const;
    virtual bool canReadLine() const;
    virtual void close();
    virtual bool isSequential() const;
    virtual qint64 pos() const;
    virtual bool reset();
    virtual bool seek(qint64);
    virtual qint64 size() const;
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QIODevice_aboutToClose_0_wrapper(QObject*);
    friend void __Qt4Ada_QIODevice_bytesWritten_0_wrapper(QObject*, qint64);
    friend void __Qt4Ada_QIODevice_readChannelFinished_0_wrapper(QObject*);
    friend void __Qt4Ada_QIODevice_readyRead_0_wrapper(QObject*);
    friend void __Qt4Ada_QIODevice_setErrorString_0_wrapper(QObject*, const QString*);
    friend void __Qt4Ada_QIODevice_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QIODevice_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QIODevice_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QIODevice_sender_0_wrapper(QObject*);
};

#endif // __QIODEVICEDIRECTOR_H__
