//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QLine>
#include <QLineF>
#include <QPointF>
#include <QString>
#include "qlinefwrapper.h"

extern "C"
{

    QLineF* __QtAda_inititialize_QLineF(void* storage)
    {
        return new (storage) QLineF();
    }

    QLineF* __QtAda_inititialize_QLineF_QPointFCR_QPointFCR(void* storage, const QPointF* pt1, const QPointF* pt2)
    {
        return new (storage) QLineF(*pt1, *pt2);
    }

    QLineF* __QtAda_inititialize_QLineF_qreal_qreal_qreal_qreal(void* storage, double x1, double y1, double x2, double y2)
    {
        return new (storage) QLineF((qreal)x1, (qreal)y1, (qreal)x2, (qreal)y2);
    }

    QLineF* __QtAda_inititialize_QLineF_QLineCR(void* storage, const QLine* line)
    {
        return new (storage) QLineF(*line);
    }

    QLineF* __QtAda_adjust_QLineF(void* storage, const QLineF* from)
    {
        return new (storage) QLineF(*from);
    }

    void __QtAda_finalize_QLineF(QLineF *item)
    {
        item->~QLineF();
    }

    double __QtAda_QLineF_angle_QLineFCR_Q(const QLineF* self, const QLineF* l)
    {
        return (double)self->angle(*l);
    }

    double __QtAda_QLineF_dx_Q(const QLineF* self)
    {
        return (double)self->dx();
    }

    double __QtAda_QLineF_dy_Q(const QLineF* self)
    {
        return (double)self->dy();
    }

    unsigned __QtAda_QLineF_isNull_Q(const QLineF* self)
    {
        return (unsigned)self->isNull();
    }

    double __QtAda_QLineF_length_Q(const QLineF* self)
    {
        return (double)self->length();
    }

    void __QtAda_QLineF_normalVector_Q(QLineF* returns, const QLineF* self)
    {
        *returns = self->normalVector();
    }

    void __QtAda_QLineF_p1_Q(QPointF* returns, const QLineF* self)
    {
        *returns = self->p1();
    }

    void __QtAda_QLineF_p2_Q(QPointF* returns, const QLineF* self)
    {
        *returns = self->p2();
    }

    void __QtAda_QLineF_pointAt_qreal_Q(QPointF* returns, const QLineF* self, double t)
    {
        *returns = self->pointAt((qreal)t);
    }

    void __QtAda_QLineF_setLength_qreal(QLineF* self, double len)
    {
        self->setLength((qreal)len);
    }

    void __QtAda_QLineF_toLine_Q(QLine* returns, const QLineF* self)
    {
        *returns = self->toLine();
    }

    void __QtAda_QLineF_translate_QPointFCR(QLineF* self, const QPointF* p)
    {
        self->translate(*p);
    }

    void __QtAda_QLineF_translate_qreal_qreal(QLineF* self, double dx, double dy)
    {
        self->translate((qreal)dx, (qreal)dy);
    }

    void __QtAda_QLineF_unitVector_Q(QLineF* returns, const QLineF* self)
    {
        *returns = self->unitVector();
    }

    double __QtAda_QLineF_x1_Q(const QLineF* self)
    {
        return (double)self->x1();
    }

    double __QtAda_QLineF_x2_Q(const QLineF* self)
    {
        return (double)self->x2();
    }

    double __QtAda_QLineF_y1_Q(const QLineF* self)
    {
        return (double)self->y1();
    }

    double __QtAda_QLineF_y2_Q(const QLineF* self)
    {
        return (double)self->y2();
    }

    unsigned __QtAda_QLineF_eq_QLineFCR_Q(const QLineF* self, const QLineF* d)
    {
        return (unsigned)self->operator==(*d);
    }

};

