//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009  Vadim Godunko <vgodunko@gmail.com>                     //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3040 $ $Date: 2009-01-04 17:07:19 +0300 (Sun, 04 Jan 2009) $
//--------------------------------------------------------------------------//
#include <QList>
#include <QObject>

extern "C"
{

    extern QList<QObject*>* __QtAda_initialize_QListOfQObject(void*);
    extern QList<QObject*>* __QtAda_adjust_QListOfQObject(void*, const QList<QObject*>*);
    extern void __QtAda_finalize_QListOfQObject(QList<QObject*>*);
    extern int __QtAda_QListOfQObject_size(QList<QObject*>*);
    extern QObject* __QtAda_QListOfQObject_value_int(QList<QObject*>*, int);

}
