//----------------------------------------------------------------------------
//                                                                          --
//                An Ada2005 binding to the Qt C++ framework                --
//                                                                          --
//----------------------------------------------------------------------------
//                                                                          --
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
//                                                                          --
// QtAda is free software;  you can  redistribute it and/or modify it under --
// terms of the  GNU General Public License as published  by the Free Soft- --
// ware  Foundation;  either version 2,  or (at your option) any later ver- --
// sion. QtAda is distributed in the hope that it will be useful, but WITH- --
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
// for  more details.  You should have  received  a copy of the GNU General --
// Public License distributed with QtAda;  see file COPYING.  If not, write --
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
// Boston, MA 02110-1301, USA.                                              --
//                                                                          --
// As a special exception,  if other files  instantiate  generics from this --
// unit, or you link  this unit with other files  to produce an executable, --
// this  unit  does not  by itself cause  the resulting  executable  to  be --
// covered  by the  GNU  General  Public  License.  This exception does not --
// however invalidate  any other reasons why  the executable file  might be --
// covered by the  GNU Public License.                                      --
//                                                                          --
//----------------------------------------------------------------------------
//  $Revision: 2976 $ $Date: 2008-12-26 13:13:33 +0300 (Fri, 26 Dec 2008) $
//----------------------------------------------------------------------------
#include "qmetaobjectwrapper.h"

extern "C" {

    extern void __Qt4Ada_QMetaObject_activate_wrapper(QObject*sender,const QMetaObject*metaobject,int local_signal_index,void **argv)
    {
        QMetaObject::activate(sender,metaobject,local_signal_index,argv);
    }

    void __Qt4Ada_QMetaObject_connectSlotsByName_wrapper (QObject *object)
    {
       QMetaObject::connectSlotsByName (object);
    }

    bool __Qt4Ada_QMetaObject_invokeMethod_wrapper(
        QObject*object,
        const char*method,
        Qt::ConnectionType type,
        const char*retName, void*retData,
        const char*val0name, void*val0data,
        const char*val1name, void*val1data,
        const char*val2name, void*val2data,
        const char*val3name, void*val3data,
        const char*val4name, void*val4data,
        const char*val5name, void*val5data,
        const char*val6name, void*val6data,
        const char*val7name, void*val7data,
        const char*val8name, void*val8data,
        const char*val9name, void*val9data)
    {
        return QMetaObject::invokeMethod(
            object,
            method,
            type,
            QGenericReturnArgument(retName,retData),
            QGenericArgument(val0name,val0data),
            QGenericArgument(val1name,val1data),
            QGenericArgument(val2name,val2data),
            QGenericArgument(val3name,val3data),
            QGenericArgument(val4name,val4data),
            QGenericArgument(val5name,val5data),
            QGenericArgument(val6name,val6data),
            QGenericArgument(val7name,val7data),
            QGenericArgument(val8name,val8data),
            QGenericArgument(val9name,val9data));
    }

    void __QtAda_QMetaObject_changeGuard(QObject** ptr, QObject* o)
    {
        QMetaObject::changeGuard(ptr, o);
    }

    void __QtAda_QMetaObject_removeGuard(QObject** ptr)
    {
        QMetaObject::removeGuard(ptr);
    }

    void __QtAda_QMetaObject_addGuard(QObject** ptr)
    {
        QMetaObject::addGuard(ptr);
    }

}
