//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2011 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QVariant>
#include <QByteArray>
#include <QStringList>
#include <QString>
#include <QChildEvent>
#include <QTimerEvent>

#include "qmimedatadirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QMimeData_staticMetaObject =
        &QMimeData::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QMimeData_formats_0_virtual(QObject* cpp_object, QStringList* returns)
    {
        *returns = dynamic_cast<QMimeData*>(cpp_object)->formats();
    }

    bool __Qt4Ada_QMimeData_hasFormat_0_virtual(QObject* cpp_object, const QString* mimeType)
    {
        return dynamic_cast<QMimeData*>(cpp_object)->hasFormat(*mimeType);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QMimeData_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMimeData*>(cpp_object)->QMimeData::clear();
    }

    void __Qt4Ada_QMimeData_colorData_0_wrapper(QObject* cpp_object, QVariant* returns)
    {
        *returns = dynamic_cast<QMimeData*>(cpp_object)->QMimeData::colorData();
    }

    void __Qt4Ada_QMimeData_data_0_wrapper(QObject* cpp_object, const QString* mimeType, QByteArray* returns)
    {
        *returns = dynamic_cast<QMimeData*>(cpp_object)->QMimeData::data(*mimeType);
    }

    void __Qt4Ada_QMimeData_formats_0_wrapper(QObject* cpp_object, QStringList* returns)
    {
        *returns = dynamic_cast<QMimeData*>(cpp_object)->QMimeData::formats();
    }

    bool __Qt4Ada_QMimeData_hasColor_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMimeData*>(cpp_object)->QMimeData::hasColor();
    }

    bool __Qt4Ada_QMimeData_hasFormat_0_wrapper(QObject* cpp_object, const QString* mimeType)
    {
        return dynamic_cast<QMimeData*>(cpp_object)->QMimeData::hasFormat(*mimeType);
    }

    bool __Qt4Ada_QMimeData_hasHtml_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMimeData*>(cpp_object)->QMimeData::hasHtml();
    }

    bool __Qt4Ada_QMimeData_hasImage_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMimeData*>(cpp_object)->QMimeData::hasImage();
    }

    bool __Qt4Ada_QMimeData_hasText_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMimeData*>(cpp_object)->QMimeData::hasText();
    }

    bool __Qt4Ada_QMimeData_hasUrls_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMimeData*>(cpp_object)->QMimeData::hasUrls();
    }

    void __Qt4Ada_QMimeData_html_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QMimeData*>(cpp_object)->QMimeData::html();
    }

    void __Qt4Ada_QMimeData_imageData_0_wrapper(QObject* cpp_object, QVariant* returns)
    {
        *returns = dynamic_cast<QMimeData*>(cpp_object)->QMimeData::imageData();
    }

    void __Qt4Ada_QMimeData_removeFormat_0_wrapper(QObject* cpp_object, const QString* mimeType)
    {
        dynamic_cast<QMimeData*>(cpp_object)->QMimeData::removeFormat(*mimeType);
    }

    void __Qt4Ada_QMimeData_setColorData_0_wrapper(QObject* cpp_object, const QVariant* color)
    {
        dynamic_cast<QMimeData*>(cpp_object)->QMimeData::setColorData(*color);
    }

    void __Qt4Ada_QMimeData_setData_0_wrapper(QObject* cpp_object, const QString* mimeType, const QByteArray* data)
    {
        dynamic_cast<QMimeData*>(cpp_object)->QMimeData::setData(*mimeType, *data);
    }

    void __Qt4Ada_QMimeData_setHtml_0_wrapper(QObject* cpp_object, const QString* html)
    {
        dynamic_cast<QMimeData*>(cpp_object)->QMimeData::setHtml(*html);
    }

    void __Qt4Ada_QMimeData_setImageData_0_wrapper(QObject* cpp_object, const QVariant* image)
    {
        dynamic_cast<QMimeData*>(cpp_object)->QMimeData::setImageData(*image);
    }

    void __Qt4Ada_QMimeData_setText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QMimeData*>(cpp_object)->QMimeData::setText(*text);
    }

    void __Qt4Ada_QMimeData_text_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QMimeData*>(cpp_object)->QMimeData::text();
    }

    void __Qt4Ada_QMimeData_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMimeDataDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QMimeData_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMimeDataDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QMimeData_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMimeDataDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QMimeData_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMimeDataDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QMimeData_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QMimeData*>(cpp_this)->QMimeData::qt_metacast(name);
    }

    int __Qt4Ada_QMimeData_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QMimeData*>(cpp_this)->QMimeData::qt_metacall(_c, _id, _a);
    }

}

QStringList QMimeDataDirector::formats() const
{
    QStringList *aux = __Qt4Ada_QMimeData_formats_0_dispatch(this->ada_object);
    QStringList returns = *aux;
    delete aux;
    return returns;
}

bool QMimeDataDirector::hasFormat(const QString& mimeType) const
{
    return __Qt4Ada_QMimeData_hasFormat_0_dispatch(this->ada_object, &mimeType);
}

bool QMimeDataDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QMimeDataDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QMimeDataDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QMimeDataDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QMimeDataDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QMimeDataDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QMimeDataDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QMimeDataDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QMimeDataDirector::QMimeDataDirector(void* o) :
    ada_object(o)
{
}

extern "C"
{

    QObject* __QtAda_new_QMimeData()
    {
        return dynamic_cast<QObject*>(new QMimeData);
    }

    QObject* __Qt4Ada_new_QMimeDataDirector(void* ada_object)
    {
       return dynamic_cast<QObject*>(new QMimeDataDirector(ada_object));
    }

}
