//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QModelIndex>
#include <QString>
#include <QVariant>
#include "qmodelindexwrapper.h"

extern "C"
{

    QModelIndex* __QtAda_inititialize_QModelIndex(void* storage)
    {
        return new (storage) QModelIndex();
    }

    QModelIndex* __QtAda_adjust_QModelIndex(void* storage, const QModelIndex* from)
    {
        return new (storage) QModelIndex(*from);
    }

    void __QtAda_finalize_QModelIndex(QModelIndex *item)
    {
        item->~QModelIndex();
    }

    void __QtAda_QModelIndex_child_int_int_Q(QModelIndex* returns, const QModelIndex* self, int row, int column)
    {
        *returns = self->child(row, column);
    }

    int __QtAda_QModelIndex_column_Q(const QModelIndex* self)
    {
        return self->column();
    }

    void __QtAda_QModelIndex_data_ItemDataRole_Q(QVariant* returns, const QModelIndex* self, unsigned role)
    {
        *returns = self->data((Qt::ItemDataRole)role);
    }

    unsigned __QtAda_QModelIndex_flags_Q(const QModelIndex* self)
    {
        return (unsigned)self->flags();
    }

    unsigned __QtAda_QModelIndex_isValid_Q(const QModelIndex* self)
    {
        return (unsigned)self->isValid();
    }

    void __QtAda_QModelIndex_parent_Q(QModelIndex* returns, const QModelIndex* self)
    {
        *returns = self->parent();
    }

    int __QtAda_QModelIndex_row_Q(const QModelIndex* self)
    {
        return self->row();
    }

    void __QtAda_QModelIndex_sibling_int_int_Q(QModelIndex* returns, const QModelIndex* self, int row, int column)
    {
        *returns = self->sibling(row, column);
    }

    unsigned __QtAda_QModelIndex_lt_QModelIndexCR_Q(const QModelIndex* self, const QModelIndex* other)
    {
        return (unsigned)self->operator<(*other);
    }

    unsigned __QtAda_QModelIndex_eq_QModelIndexCR_Q(const QModelIndex* self, const QModelIndex* other)
    {
        return (unsigned)self->operator==(*other);
    }

    QModelIndex* __Qt4Ada_copy_QModelIndex (const QModelIndex* cpp_object)
    {
        return new QModelIndex (*cpp_object);
    }

    void * __Qt4Ada_QModelIndex_internalPointer_wrapper (const QModelIndex*cpp_object)
    {
       return cpp_object->internalPointer ();
    }

    const QObject* __Qt4Ada_QModelIndex_model_wrapper(const QModelIndex* cpp_object)
    {
        return static_cast<const QObject*>(cpp_object->QModelIndex::model());
    }

};

