//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QPointF>

extern "C"
{
    extern QPointF* __QtAda_inititialize_QPointF(void*);
    extern QPointF* __QtAda_inititialize_QPointF_QPointCR(void*, const QPoint*);
    extern QPointF* __QtAda_inititialize_QPointF_qreal_qreal(void*, double, double);
    extern QPointF* __QtAda_adjust_QPointF(void*, const QPointF*);
    extern void __QtAda_finalize_QPointF(QPointF*);

    extern unsigned __QtAda_QPointF_isNull_Q(const QPointF*);
    extern void __QtAda_QPointF_setX_qreal(QPointF*, double);
    extern void __QtAda_QPointF_setY_qreal(QPointF*, double);
    extern void __QtAda_QPointF_toPoint_Q(QPoint*, const QPointF*);
    extern double __QtAda_QPointF_x_Q(const QPointF*);
    extern double __QtAda_QPointF_y_Q(const QPointF*);
    extern unsigned __QtAda_eq_QPointFCR_QPointFCR(const QPointF*, const QPointF*);
    extern void __QtAda_plus_QPointFCR_QPointFCR(QPointF*, const QPointF*, const QPointF*);
    extern void __QtAda_minus_QPointFCR_QPointFCR(QPointF*, const QPointF*, const QPointF*);
    extern void __QtAda_multiplication_QPointFCR_qreal(QPointF*, const QPointF*, double);
    extern void __QtAda_multiplication_qreal_QPointFCR(QPointF*, double, const QPointF*);
    extern void __QtAda_minus_QPointFCR(QPointF*, const QPointF*);
    extern void __QtAda_division_QPointFCR_qreal(QPointF*, const QPointF*, double);

};

