//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QRectF>

extern "C"
{
    extern QRectF* __QtAda_inititialize_QRectF(void*);
    extern QRectF* __QtAda_inititialize_QRectF_QPointFCR_QSizeFCR(void*, const QPointF*, const QSizeF*);
    extern QRectF* __QtAda_inititialize_QRectF_QPointFCR_QPointFCR(void*, const QPointF*, const QPointF*);
    extern QRectF* __QtAda_inititialize_QRectF_qreal_qreal_qreal_qreal(void*, double, double, double, double);
    extern QRectF* __QtAda_inititialize_QRectF_QRectCR(void*, const QRect*);
    extern QRectF* __QtAda_adjust_QRectF(void*, const QRectF*);
    extern void __QtAda_finalize_QRectF(QRectF*);
    extern QRectF* __Qt4Ada_copy_QRectF(const QRectF*);

    extern void __QtAda_QRectF_adjust_qreal_qreal_qreal_qreal(QRectF*, double, double, double, double);
    extern void __QtAda_QRectF_adjusted_qreal_qreal_qreal_qreal_Q(QRectF*, const QRectF*, double, double, double, double);
    extern double __QtAda_QRectF_bottom_Q(const QRectF*);
    extern void __QtAda_QRectF_bottomLeft_Q(QPointF*, const QRectF*);
    extern void __QtAda_QRectF_bottomRight_Q(QPointF*, const QRectF*);
    extern void __QtAda_QRectF_center_Q(QPointF*, const QRectF*);
    extern unsigned __QtAda_QRectF_contains_QPointFCR_Q(const QRectF*, const QPointF*);
    extern unsigned __QtAda_QRectF_contains_qreal_qreal_Q(const QRectF*, double, double);
    extern unsigned __QtAda_QRectF_contains_QRectFCR_Q(const QRectF*, const QRectF*);
    extern void __QtAda_QRectF_getCoords_qrealP_qrealP_qrealP_qrealP_Q(const QRectF*, double*, double*, double*, double*);
    extern void __QtAda_QRectF_getRect_qrealP_qrealP_qrealP_qrealP_Q(const QRectF*, double*, double*, double*, double*);
    extern double __QtAda_QRectF_height_Q(const QRectF*);
    extern void __QtAda_QRectF_intersected_QRectFCR_Q(QRectF*, const QRectF*, const QRectF*);
    extern unsigned __QtAda_QRectF_intersects_QRectFCR_Q(const QRectF*, const QRectF*);
    extern unsigned __QtAda_QRectF_isEmpty_Q(const QRectF*);
    extern unsigned __QtAda_QRectF_isNull_Q(const QRectF*);
    extern unsigned __QtAda_QRectF_isValid_Q(const QRectF*);
    extern double __QtAda_QRectF_left_Q(const QRectF*);
    extern void __QtAda_QRectF_moveBottom_qreal(QRectF*, double);
    extern void __QtAda_QRectF_moveBottomLeft_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_moveBottomRight_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_moveCenter_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_moveLeft_qreal(QRectF*, double);
    extern void __QtAda_QRectF_moveRight_qreal(QRectF*, double);
    extern void __QtAda_QRectF_moveTo_qreal_qreal(QRectF*, double, double);
    extern void __QtAda_QRectF_moveTo_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_moveTop_qreal(QRectF*, double);
    extern void __QtAda_QRectF_moveTopLeft_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_moveTopRight_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_normalized_Q(QRectF*, const QRectF*);
    extern double __QtAda_QRectF_right_Q(const QRectF*);
    extern void __QtAda_QRectF_setBottom_qreal(QRectF*, double);
    extern void __QtAda_QRectF_setBottomLeft_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_setBottomRight_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_setCoords_qreal_qreal_qreal_qreal(QRectF*, double, double, double, double);
    extern void __QtAda_QRectF_setHeight_qreal(QRectF*, double);
    extern void __QtAda_QRectF_setLeft_qreal(QRectF*, double);
    extern void __QtAda_QRectF_setRect_qreal_qreal_qreal_qreal(QRectF*, double, double, double, double);
    extern void __QtAda_QRectF_setRight_qreal(QRectF*, double);
    extern void __QtAda_QRectF_setSize_QSizeFCR(QRectF*, const QSizeF*);
    extern void __QtAda_QRectF_setTop_qreal(QRectF*, double);
    extern void __QtAda_QRectF_setTopLeft_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_setTopRight_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_setWidth_qreal(QRectF*, double);
    extern void __QtAda_QRectF_setX_qreal(QRectF*, double);
    extern void __QtAda_QRectF_setY_qreal(QRectF*, double);
    extern void __QtAda_QRectF_size_Q(QSizeF*, const QRectF*);
    extern void __QtAda_QRectF_toAlignedRect_Q(QRect*, const QRectF*);
    extern void __QtAda_QRectF_toRect_Q(QRect*, const QRectF*);
    extern double __QtAda_QRectF_top_Q(const QRectF*);
    extern void __QtAda_QRectF_topLeft_Q(QPointF*, const QRectF*);
    extern void __QtAda_QRectF_topRight_Q(QPointF*, const QRectF*);
    extern void __QtAda_QRectF_translate_qreal_qreal(QRectF*, double, double);
    extern void __QtAda_QRectF_translate_QPointFCR(QRectF*, const QPointF*);
    extern void __QtAda_QRectF_translated_qreal_qreal_Q(QRectF*, const QRectF*, double, double);
    extern void __QtAda_QRectF_translated_QPointFCR_Q(QRectF*, const QRectF*, const QPointF*);
    extern void __QtAda_QRectF_united_QRectFCR_Q(QRectF*, const QRectF*, const QRectF*);
    extern double __QtAda_QRectF_width_Q(const QRectF*);
    extern double __QtAda_QRectF_x_Q(const QRectF*);
    extern double __QtAda_QRectF_y_Q(const QRectF*);
    extern unsigned __QtAda_eq_QRectFCR_QRectFCR(const QRectF*, const QRectF*);

};

