//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QChildEvent>
#include <QTimerEvent>

#include "qsignalmapperdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QSignalMapper_staticMetaObject =
        &QSignalMapper::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QSignalMapper_setMapping_2_wrapper(QObject* cpp_object, QObject* sender, int id)
    {
        dynamic_cast<QSignalMapper*>(cpp_object)->QSignalMapper::setMapping(sender, id);
    }

    void __Qt4Ada_QSignalMapper_setMapping_1_wrapper(QObject* cpp_object, QObject* sender, const QString* text)
    {
        dynamic_cast<QSignalMapper*>(cpp_object)->QSignalMapper::setMapping(sender, *text);
    }

    void __Qt4Ada_QSignalMapper_setMapping_0_wrapper(QObject* cpp_object, QObject* sender, QObject* object)
    {
        dynamic_cast<QSignalMapper*>(cpp_object)->QSignalMapper::setMapping(sender, object);
    }

    void __Qt4Ada_QSignalMapper_removeMappings_0_wrapper(QObject* cpp_object, QObject* sender)
    {
        dynamic_cast<QSignalMapper*>(cpp_object)->QSignalMapper::removeMappings(sender);
    }

    QObject* __Qt4Ada_QSignalMapper_mapping_2_wrapper(QObject* cpp_object, int id)
    {
        return dynamic_cast<QSignalMapper*>(cpp_object)->QSignalMapper::mapping(id);
    }

    QObject* __Qt4Ada_QSignalMapper_mapping_1_wrapper(QObject* cpp_object, const QString* text)
    {
        return dynamic_cast<QSignalMapper*>(cpp_object)->QSignalMapper::mapping(*text);
    }

    QObject* __Qt4Ada_QSignalMapper_mapping_0_wrapper(QObject* cpp_object, QObject* object)
    {
        return dynamic_cast<QSignalMapper*>(cpp_object)->QSignalMapper::mapping(object);
    }

    void __Qt4Ada_QSignalMapper_map_1_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSignalMapper*>(cpp_object)->QSignalMapper::map();
    }

    void __Qt4Ada_QSignalMapper_map_0_wrapper(QObject* cpp_object, QObject* sender)
    {
        dynamic_cast<QSignalMapper*>(cpp_object)->QSignalMapper::map(sender);
    }

    void __Qt4Ada_QSignalMapper_mapped_2_wrapper(QObject* cpp_object, int id)
    {
        dynamic_cast<QSignalMapperDirector*>(cpp_object)->QSignalMapper::mapped(id);
    }

    void __Qt4Ada_QSignalMapper_mapped_1_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QSignalMapperDirector*>(cpp_object)->QSignalMapper::mapped(*text);
    }

    void __Qt4Ada_QSignalMapper_mapped_0_wrapper(QObject* cpp_object, QObject* object)
    {
        dynamic_cast<QSignalMapperDirector*>(cpp_object)->QSignalMapper::mapped(object);
    }

    void __Qt4Ada_QSignalMapper_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSignalMapperDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QSignalMapper_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSignalMapperDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QSignalMapper_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSignalMapperDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QSignalMapper_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSignalMapperDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QSignalMapper_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QSignalMapper*>(cpp_this)->QSignalMapper::qt_metacast(name);
    }

    int __Qt4Ada_QSignalMapper_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QSignalMapper*>(cpp_this)->QSignalMapper::qt_metacall(_c, _id, _a);
    }

}

bool QSignalMapperDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QSignalMapperDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QSignalMapperDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QSignalMapperDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QSignalMapperDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QSignalMapperDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QSignalMapperDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QSignalMapperDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{

    QObject *__Qt4Ada_new_QSignalMapper (QObject *parent)
    {
        return dynamic_cast<QObject *>(new QSignalMapper (dynamic_cast <QObject*> (parent)));
    }

}
