//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//  $Revision: 3848 $ $Date: 2011-06-28 08:49:18 +0400 (Tue, 28 Jun 2011) $
//--------------------------------------------------------------------------//
#include <QStringList>

extern "C"
{
    extern QStringList* __Qt4Ada_copy_QStringList (const QStringList*);
    extern QStringList* __QtAda_inititialize_QStringList(void*);
    extern QStringList* __QtAda_inititialize_QStringList_QStringCR(void*, const QString*);
    extern QStringList* __QtAda_adjust_QStringList(void*, const QStringList*);
    extern void __QtAda_finalize_QStringList(QStringList*);

    extern void __QtAda_QStringList_append_QStringCR(QStringList*, const QString*);
    extern void __QtAda_QStringList_value_int_Q(QString*, const QStringList*, int);
    extern int __QtAda_QStringList_size_Q(const QStringList*);
    extern void __QtAda_QStringList_filter_QStringCR_CaseSensitivity_Q(QStringList*, const QStringList*, const QString*, unsigned);
    extern void __QtAda_QStringList_filter_QRegExpCR_Q(QStringList*, const QStringList*, const QRegExp*);
    extern int __QtAda_QStringList_indexOf_QRegExpCR_int_Q(const QStringList*, const QRegExp*, int);
    extern void __QtAda_QStringList_join_QStringCR_Q(QString*, const QStringList*, const QString*);
    extern int __QtAda_QStringList_lastIndexOf_QRegExpCR_int_Q(const QStringList*, const QRegExp*, int);
    extern void __QtAda_QStringList_replaceInStrings_QStringCR_QStringCR_CaseSensitivity(QStringList*, const QString*, const QString*, unsigned);
    extern void __QtAda_QStringList_replaceInStrings_QRegExpCR_QStringCR(QStringList*, const QRegExp*, const QString*);
    extern void __QtAda_QStringList_removeFirst(QStringList*);
    extern void __QtAda_QStringList_removeLast(QStringList*);
    extern void __QtAda_QStringList_sort(QStringList*);
    extern unsigned __QtAda_QStringList_eq_QStringListCR_Q(const QStringList*, const QStringList*);

};

