------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Child_Events;
limited with Qt4.Timer_Events;

package Qt4.Objects.Directors is

   type Q_Object_Director is
     abstract new Qt_Ada.Internals.Objects.Q_Object_Impl_Base
       and Q_Object with null record;

   overriding
   function Event
    (Self : not null access Q_Object_Director;
     E : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean;

   overriding
   function Event_Filter
    (Self : not null access Q_Object_Director;
     Watched : not null access Qt4.Objects.Q_Object'Class;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean;

   not overriding
   procedure Child_Event
    (Self : not null access Q_Object_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   not overriding
   procedure Custom_Event
    (Self : not null access Q_Object_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   not overriding
   procedure Timer_Event
    (Self : not null access Q_Object_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   not overriding
   function Sender
    (Self : not null access constant Q_Object_Director)
       return access Qt4.Objects.Q_Object'Class;

   not overriding
   procedure Emit_Destroyed
    (Self : not null access Q_Object_Director;
     Obj  : access Qt4.Objects.Q_Object'Class := null);

   --  Subprograms with protected C++ visibility.

   not overriding
   procedure Connect_Notify (Self   : not null access Q_Object_Director;
                             Signal : String);

   not overriding
   procedure Disconnect_Notify (Self   : not null access Q_Object_Director;
                                Signal : String);

   package Constructors is

      procedure Initialize
       (Self   : not null access Q_Object_Director'Class;
        Parent : access Q_Object'Class := null);
      --  Creates C++ director and associate it with the specified object.

   end Constructors;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QObject_staticMetaObject");

end Qt4.Objects.Directors;
