------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3791 $ $Date: 2010-10-28 19:45:44 +0400 (Thu, 28 Oct 2010) $
------------------------------------------------------------------------------

package body Qt_Ada.Internals.Events is

   ----------------
   -- Initialize --
   ----------------

   procedure Initialize
    (Self   : not null access Q_Event_Base'Class;
     Object : not null QEvent_Access) is
   begin
      Self.Object := Object;
   end Initialize;

   -----------------
   -- QEvent_View --
   -----------------

   not overriding function QEvent_View
    (Self : not null access constant Q_Event_Base)
       return not null QEvent_Access is
   begin
      return Self.Object;
   end QEvent_View;

end Qt_Ada.Internals.Events;
