------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2011 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3848 $ $Date: 2011-06-28 08:49:18 +0400 (Tue, 28 Jun 2011) $
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;

package body Qt_Ada.Internals.Objects.Mime_Data_Utilities is

--   function dynamic_cast_QWidget (Item : access QObject)
--     return System.Address;
--   pragma Import
--    (C, dynamic_cast_QWidget, "__QtAda_dynamic_cast_QWidget_from_QObject");
--
--   function dynamic_cast_QObject (Item : System.Address)
--     return QObject_Access;
--   pragma Import
--    (C, dynamic_cast_QObject, "__QtAda_dynamic_cast_QObject_from_QWidget");

   -------------------------------
   -- Corresponding_Q_Mime_Data --
   -------------------------------

   function Corresponding_Q_Mime_Data
    (Item : access Qt_Ada.Internals.Objects.QObject)
       return access Qt4.Mime_Datas.Q_Mime_Data'Class is
   begin
      if Item = null then
         return null;
      end if;

      return
        Qt4.Mime_Datas.Q_Mime_Data'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object (Item).all)'Access;
   end Corresponding_Q_Mime_Data;

--   ----------------
--   -- To_Address --
--   ----------------
--
--   function To_Address (Item : access constant Qt4.Widgets.Q_Widget'Class)
--     return System.Address
--   is
--   begin
--      return dynamic_cast_QWidget (Item.QObject_View);
--   end To_Address;
--
--   ----------------
--   -- To_Pointer --
--   ----------------
--
--   function To_Pointer (Item : System.Address)
--     return Qt4.Widgets.Q_Widget_Access
--   is
--   begin
--      return
--        Qt4.Widgets.Q_Widget_Access
--         (Corresponding_Q_Widget (dynamic_cast_QObject (Item)));
--   end To_Pointer;

end Qt_Ada.Internals.Objects.Mime_Data_Utilities;
