//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007  Vadim Godunko <vgodunko@gmail.com>                     //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QTime>

extern "C"
{
    extern QTime* __QtAda_inititialize_QTime(void*);
    extern QTime* __QtAda_inititialize_QTime_int_int_int_int(void*, int, int, int, int);
    extern QTime* __QtAda_adjust_QTime(void*, const QTime*);
    extern void __QtAda_finalize_QTime(QTime*);

    extern void __QtAda_QTime_addMSecs_int_Q(QTime*, const QTime*, int);
    extern void __QtAda_QTime_addSecs_int_Q(QTime*, const QTime*, int);
    extern int __QtAda_QTime_elapsed_Q(const QTime*);
    extern int __QtAda_QTime_hour_Q(const QTime*);
    extern unsigned __QtAda_QTime_isNull_Q(const QTime*);
    extern unsigned __QtAda_QTime_isValid_Q(const QTime*);
    extern int __QtAda_QTime_minute_Q(const QTime*);
    extern int __QtAda_QTime_msec_Q(const QTime*);
    extern int __QtAda_QTime_msecsTo_QTimeCR_Q(const QTime*, const QTime*);
    extern int __QtAda_QTime_second_Q(const QTime*);
    extern int __QtAda_QTime_secsTo_QTimeCR_Q(const QTime*, const QTime*);
    extern void __QtAda_QTime_start(QTime*);
    extern void __QtAda_QTime_toString_QStringCR_Q(QString*, const QTime*, const QString*);
    extern void __QtAda_QTime_toString_DateFormat_Q(QString*, const QTime*, unsigned);
    extern void __QtAda_QTime_currentTime_S(QTime*);
    extern void __QtAda_QTime_fromString_QStringCR_DateFormat_S(QTime*, const QString*, unsigned);
    extern void __QtAda_QTime_fromString_QStringCR_QStringCR_S(QTime*, const QString*, const QString*);
    extern unsigned __QtAda_QTime_isValid_int_int_int_int_S(int, int, int, int);
    extern unsigned __QtAda_QTime_eq_QTimeCR_Q(const QTime*, const QTime*);
    extern unsigned __QtAda_QTime_lt_QTimeCR_Q(const QTime*, const QTime*);
    extern unsigned __QtAda_QTime_le_QTimeCR_Q(const QTime*, const QTime*);
    extern unsigned __QtAda_QTime_gt_QTimeCR_Q(const QTime*, const QTime*);
    extern unsigned __QtAda_QTime_ge_QTimeCR_Q(const QTime*, const QTime*);

};

