//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QBrush>
#include <QPen>
#include <QPainterPath>
#include <QRectF>
#include <QGraphicsSceneContextMenuEvent>
#include <QGraphicsSceneDragDropEvent>
#include <QFocusEvent>
#include <QGraphicsSceneHoverEvent>
#include <QInputMethodEvent>
#include <QVariant>
#include <QKeyEvent>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsSceneWheelEvent>

#include "qabstractgraphicsshapeitemdirector.h"
#include "qgraphicsitemdirector.h"

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QAbstractGraphicsShapeItem_brush_0_wrapper(QGraphicsItem* cpp_object, QBrush* returns)
    {
        *returns = dynamic_cast<QAbstractGraphicsShapeItem*>(cpp_object)->QAbstractGraphicsShapeItem::brush();
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_pen_0_wrapper(QGraphicsItem* cpp_object, QPen* returns)
    {
        *returns = dynamic_cast<QAbstractGraphicsShapeItem*>(cpp_object)->QAbstractGraphicsShapeItem::pen();
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_setBrush_0_wrapper(QGraphicsItem* cpp_object, const QBrush* brush)
    {
        dynamic_cast<QAbstractGraphicsShapeItem*>(cpp_object)->QAbstractGraphicsShapeItem::setBrush(*brush);
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_setPen_0_wrapper(QGraphicsItem* cpp_object, const QPen* pen)
    {
        dynamic_cast<QAbstractGraphicsShapeItem*>(cpp_object)->QAbstractGraphicsShapeItem::setPen(*pen);
    }

    bool __Qt4Ada_QAbstractGraphicsShapeItem_isObscuredBy_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item)
    {
        return dynamic_cast<QAbstractGraphicsShapeItem*>(cpp_object)->QAbstractGraphicsShapeItem::isObscuredBy(item);
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_opaqueArea_0_wrapper(QGraphicsItem* cpp_object, QPainterPath* returns)
    {
        *returns = dynamic_cast<QAbstractGraphicsShapeItem*>(cpp_object)->QAbstractGraphicsShapeItem::opaqueArea();
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_contextMenuEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::contextMenuEvent(dynamic_cast<QGraphicsSceneContextMenuEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_dragEnterEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::dragEnterEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_dragLeaveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::dragLeaveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_dragMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::dragMoveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_dropEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::dropEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_focusInEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_focusOutEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_hoverEnterEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::hoverEnterEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_hoverMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::hoverMoveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_hoverLeaveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::hoverLeaveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_inputMethodEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_inputMethodQuery_0_wrapper(QGraphicsItem* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::inputMethodQuery(query);
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_itemChange_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem::GraphicsItemChange change, const QVariant* value, QVariant* returns)
    {
        *returns = dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::itemChange(change, *value);
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_keyPressEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_keyReleaseEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_mouseDoubleClickEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::mouseDoubleClickEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_mouseMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::mouseMoveEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_mousePressEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::mousePressEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_mouseReleaseEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::mouseReleaseEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_prepareGeometryChange_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::prepareGeometryChange();
    }

    bool __Qt4Ada_QAbstractGraphicsShapeItem_sceneEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        return dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::sceneEvent(event);
    }

    bool __Qt4Ada_QAbstractGraphicsShapeItem_sceneEventFilter_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem* watched, QEvent* event)
    {
        return dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::sceneEventFilter(watched, event);
    }

    void __Qt4Ada_QAbstractGraphicsShapeItem_wheelEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractGraphicsShapeItemDirector*>(cpp_object)->QGraphicsItem::wheelEvent(dynamic_cast<QGraphicsSceneWheelEvent*>(event));
    }

}

bool QAbstractGraphicsShapeItemDirector::isObscuredBy(const QGraphicsItem* item) const
{
    return __Qt4Ada_QGraphicsItem_isObscuredBy_0_dispatch(this->ada_object, item);
}

QPainterPath QAbstractGraphicsShapeItemDirector::opaqueArea() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_opaqueArea_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

void QAbstractGraphicsShapeItemDirector::advance(int phase)
{
    __Qt4Ada_QGraphicsItem_advance_0_dispatch(this->ada_object, phase);
}

QRectF QAbstractGraphicsShapeItemDirector::boundingRect() const
{
    QRectF *aux = __Qt4Ada_QGraphicsItem_boundingRect_0_dispatch(this->ada_object);
    QRectF returns = *aux;
    delete aux;
    return returns;
}

bool QAbstractGraphicsShapeItemDirector::collidesWithItem(const QGraphicsItem* other, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithItem_0_dispatch(this->ada_object, other, mode);
}

bool QAbstractGraphicsShapeItemDirector::collidesWithPath(const QPainterPath& path, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithPath_0_dispatch(this->ada_object, &path, mode);
}

bool QAbstractGraphicsShapeItemDirector::contains(const QPointF& point) const
{
    return __Qt4Ada_QGraphicsItem_contains_0_dispatch(this->ada_object, &point);
}

QPainterPath QAbstractGraphicsShapeItemDirector::shape() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_shape_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

void QAbstractGraphicsShapeItemDirector::contextMenuEvent(QGraphicsSceneContextMenuEvent* event)
{
    __Qt4Ada_QGraphicsItem_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::dragEnterEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::dragLeaveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::dragMoveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::dropEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dropEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusInEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::hoverEnterEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverEnterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::hoverMoveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::hoverLeaveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QGraphicsItem_inputMethodEvent_0_dispatch(this->ada_object, event);
}

QVariant QAbstractGraphicsShapeItemDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QVariant QAbstractGraphicsShapeItemDirector::itemChange(QGraphicsItem::GraphicsItemChange change, const QVariant& value)
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_itemChange_0_dispatch(this->ada_object, change, &value);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QAbstractGraphicsShapeItemDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractGraphicsShapeItemDirector::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractGraphicsShapeItemDirector::sceneEvent(QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractGraphicsShapeItemDirector::sceneEventFilter(QGraphicsItem* watched, QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractGraphicsShapeItemDirector::wheelEvent(QGraphicsSceneWheelEvent* event)
{
    __Qt4Ada_QGraphicsItem_wheelEvent_0_dispatch(this->ada_object, event);
}
