//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QModelIndex>
#include <QSize>
#include <QWidget>
#include <QAbstractItemDelegate>
#include <QAbstractItemModel>
#include <QItemSelectionModel>
#include <QRect>
#include <QVariant>
#include <QPoint>
#include <QRegion>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QResizeEvent>
#include <QTimerEvent>
#include <QPaintEvent>
#include <QWheelEvent>
#include <QContextMenuEvent>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qabstractitemviewdirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractItemView_staticMetaObject =
        &QAbstractItemView::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QAbstractItemView_indexAt_0_virtual(QObject* cpp_object, const QPoint* point, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractItemView*>(cpp_object)->indexAt(*point);
    }

    void __Qt4Ada_QAbstractItemView_keyboardSearch_0_virtual(QObject* cpp_object, const QString* search)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->keyboardSearch(*search);
    }

    void __Qt4Ada_QAbstractItemView_scrollTo_0_virtual(QObject* cpp_object, const QModelIndex* index, QAbstractItemView::ScrollHint hint)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->scrollTo(*index, hint);
    }

    void __Qt4Ada_QAbstractItemView_setModel_0_virtual(QObject* cpp_object, QObject* model)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->setModel(dynamic_cast<QAbstractItemModel*>(model));
    }

    void __Qt4Ada_QAbstractItemView_setSelectionModel_0_virtual(QObject* cpp_object, QObject* selectionModel)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->setSelectionModel(dynamic_cast<QItemSelectionModel*>(selectionModel));
    }

    int __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_virtual(QObject* cpp_object, int column)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->sizeHintForColumn(column);
    }

    int __Qt4Ada_QAbstractItemView_sizeHintForRow_0_virtual(QObject* cpp_object, int row)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->sizeHintForRow(row);
    }

    void __Qt4Ada_QAbstractItemView_visualRect_0_virtual(QObject* cpp_object, const QModelIndex* index, QRect* returns)
    {
        *returns = dynamic_cast<QAbstractItemView*>(cpp_object)->visualRect(*index);
    }

    void __Qt4Ada_QAbstractItemView_reset_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->reset();
    }

    void __Qt4Ada_QAbstractItemView_selectAll_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->selectAll();
    }

    void __Qt4Ada_QAbstractItemView_setRootIndex_0_virtual(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->setRootIndex(*index);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QAbstractItemView_alternatingRowColors_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::alternatingRowColors();
    }

    void __Qt4Ada_QAbstractItemView_closePersistentEditor_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::closePersistentEditor(*index);
    }

    void __Qt4Ada_QAbstractItemView_currentIndex_0_wrapper(QObject* cpp_object, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::currentIndex();
    }

    QAbstractItemView::DragDropMode __Qt4Ada_QAbstractItemView_dragDropMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::dragDropMode();
    }

    bool __Qt4Ada_QAbstractItemView_dragDropOverwriteMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::dragDropOverwriteMode();
    }

    bool __Qt4Ada_QAbstractItemView_dragEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::dragEnabled();
    }

    bool __Qt4Ada_QAbstractItemView_hasAutoScroll_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::hasAutoScroll();
    }

    QAbstractItemView::ScrollMode __Qt4Ada_QAbstractItemView_horizontalScrollMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::horizontalScrollMode();
    }

    void __Qt4Ada_QAbstractItemView_iconSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::iconSize();
    }

    QObject* __Qt4Ada_QAbstractItemView_indexWidget_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::indexWidget(*index));
    }

    QObject* __Qt4Ada_QAbstractItemView_itemDelegate_1_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::itemDelegate());
    }

    QObject* __Qt4Ada_QAbstractItemView_itemDelegate_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::itemDelegate(*index));
    }

    QObject* __Qt4Ada_QAbstractItemView_itemDelegateForColumn_0_wrapper(QObject* cpp_object, int column)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::itemDelegateForColumn(column));
    }

    QObject* __Qt4Ada_QAbstractItemView_itemDelegateForRow_0_wrapper(QObject* cpp_object, int row)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::itemDelegateForRow(row));
    }

    void __Qt4Ada_QAbstractItemView_keyboardSearch_0_wrapper(QObject* cpp_object, const QString* search)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::keyboardSearch(*search);
    }

    QObject* __Qt4Ada_QAbstractItemView_model_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::model());
    }

    void __Qt4Ada_QAbstractItemView_openPersistentEditor_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::openPersistentEditor(*index);
    }

    void __Qt4Ada_QAbstractItemView_rootIndex_0_wrapper(QObject* cpp_object, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::rootIndex();
    }

    QAbstractItemView::SelectionBehavior __Qt4Ada_QAbstractItemView_selectionBehavior_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::selectionBehavior();
    }

    QAbstractItemView::SelectionMode __Qt4Ada_QAbstractItemView_selectionMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::selectionMode();
    }

    QObject* __Qt4Ada_QAbstractItemView_selectionModel_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::selectionModel());
    }

    void __Qt4Ada_QAbstractItemView_setAlternatingRowColors_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setAlternatingRowColors(enable);
    }

    void __Qt4Ada_QAbstractItemView_setAutoScroll_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setAutoScroll(enable);
    }

    void __Qt4Ada_QAbstractItemView_setDragDropMode_0_wrapper(QObject* cpp_object, QAbstractItemView::DragDropMode behavior)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setDragDropMode(behavior);
    }

    void __Qt4Ada_QAbstractItemView_setDragDropOverwriteMode_0_wrapper(QObject* cpp_object, bool overwrite)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setDragDropOverwriteMode(overwrite);
    }

    void __Qt4Ada_QAbstractItemView_setDragEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setDragEnabled(enable);
    }

    void __Qt4Ada_QAbstractItemView_setDropIndicatorShown_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setDropIndicatorShown(enable);
    }

    void __Qt4Ada_QAbstractItemView_setHorizontalScrollMode_0_wrapper(QObject* cpp_object, QAbstractItemView::ScrollMode mode)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setHorizontalScrollMode(mode);
    }

    void __Qt4Ada_QAbstractItemView_setIconSize_0_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setIconSize(*size);
    }

    void __Qt4Ada_QAbstractItemView_setIndexWidget_0_wrapper(QObject* cpp_object, const QModelIndex* index, QObject* widget)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setIndexWidget(*index, dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QAbstractItemView_setItemDelegate_0_wrapper(QObject* cpp_object, QObject* delegate)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setItemDelegate(dynamic_cast<QAbstractItemDelegate*>(delegate));
    }

    void __Qt4Ada_QAbstractItemView_setItemDelegateForColumn_0_wrapper(QObject* cpp_object, int column, QObject* delegate)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setItemDelegateForColumn(column, dynamic_cast<QAbstractItemDelegate*>(delegate));
    }

    void __Qt4Ada_QAbstractItemView_setItemDelegateForRow_0_wrapper(QObject* cpp_object, int row, QObject* delegate)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setItemDelegateForRow(row, dynamic_cast<QAbstractItemDelegate*>(delegate));
    }

    void __Qt4Ada_QAbstractItemView_setModel_0_wrapper(QObject* cpp_object, QObject* model)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setModel(dynamic_cast<QAbstractItemModel*>(model));
    }

    void __Qt4Ada_QAbstractItemView_setSelectionBehavior_0_wrapper(QObject* cpp_object, QAbstractItemView::SelectionBehavior behavior)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setSelectionBehavior(behavior);
    }

    void __Qt4Ada_QAbstractItemView_setSelectionMode_0_wrapper(QObject* cpp_object, QAbstractItemView::SelectionMode mode)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setSelectionMode(mode);
    }

    void __Qt4Ada_QAbstractItemView_setSelectionModel_0_wrapper(QObject* cpp_object, QObject* selectionModel)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setSelectionModel(dynamic_cast<QItemSelectionModel*>(selectionModel));
    }

    void __Qt4Ada_QAbstractItemView_setTabKeyNavigation_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setTabKeyNavigation(enable);
    }

    void __Qt4Ada_QAbstractItemView_setVerticalScrollMode_0_wrapper(QObject* cpp_object, QAbstractItemView::ScrollMode mode)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setVerticalScrollMode(mode);
    }

    bool __Qt4Ada_QAbstractItemView_showDropIndicator_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::showDropIndicator();
    }

    int __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::sizeHintForColumn(column);
    }

    void __Qt4Ada_QAbstractItemView_sizeHintForIndex_0_wrapper(QObject* cpp_object, const QModelIndex* index, QSize* returns)
    {
        *returns = dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::sizeHintForIndex(*index);
    }

    int __Qt4Ada_QAbstractItemView_sizeHintForRow_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::sizeHintForRow(row);
    }

    bool __Qt4Ada_QAbstractItemView_tabKeyNavigation_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::tabKeyNavigation();
    }

    QAbstractItemView::ScrollMode __Qt4Ada_QAbstractItemView_verticalScrollMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::verticalScrollMode();
    }

    void __Qt4Ada_QAbstractItemView_clearSelection_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::clearSelection();
    }

    void __Qt4Ada_QAbstractItemView_edit_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::edit(*index);
    }

    void __Qt4Ada_QAbstractItemView_reset_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::reset();
    }

    void __Qt4Ada_QAbstractItemView_scrollToBottom_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::scrollToBottom();
    }

    void __Qt4Ada_QAbstractItemView_scrollToTop_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::scrollToTop();
    }

    void __Qt4Ada_QAbstractItemView_selectAll_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::selectAll();
    }

    void __Qt4Ada_QAbstractItemView_setCurrentIndex_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setCurrentIndex(*index);
    }

    void __Qt4Ada_QAbstractItemView_setRootIndex_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::setRootIndex(*index);
    }

    void __Qt4Ada_QAbstractItemView_inputMethodQuery_0_wrapper(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QAbstractItemView*>(cpp_object)->QAbstractItemView::inputMethodQuery(query);
    }

    void __Qt4Ada_QAbstractItemView_activated_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::activated(*index);
    }

    void __Qt4Ada_QAbstractItemView_clicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::clicked(*index);
    }

    void __Qt4Ada_QAbstractItemView_doubleClicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::doubleClicked(*index);
    }

    void __Qt4Ada_QAbstractItemView_entered_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::entered(*index);
    }

    void __Qt4Ada_QAbstractItemView_pressed_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::pressed(*index);
    }

    void __Qt4Ada_QAbstractItemView_viewportEntered_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::viewportEntered();
    }

    void __Qt4Ada_QAbstractItemView_dirtyRegionOffset_0_wrapper(QObject* cpp_object, QPoint* returns)
    {
        *returns = dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::dirtyRegionOffset();
    }

    void __Qt4Ada_QAbstractItemView_executeDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::executeDelayedItemsLayout();
    }

    void __Qt4Ada_QAbstractItemView_scheduleDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::scheduleDelayedItemsLayout();
    }

    void __Qt4Ada_QAbstractItemView_scrollDirtyRegion_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::scrollDirtyRegion(dx, dy);
    }

    void __Qt4Ada_QAbstractItemView_setDirtyRegion_0_wrapper(QObject* cpp_object, const QRegion* region)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::setDirtyRegion(*region);
    }

    void __Qt4Ada_QAbstractItemView_commitData_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::commitData(dynamic_cast<QWidget*>(editor));
    }

    void __Qt4Ada_QAbstractItemView_currentChanged_0_wrapper(QObject* cpp_object, const QModelIndex* current, const QModelIndex* previous)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::currentChanged(*current, *previous);
    }

    void __Qt4Ada_QAbstractItemView_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::dataChanged(*topLeft, *bottomRight);
    }

    void __Qt4Ada_QAbstractItemView_editorDestroyed_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::editorDestroyed(editor);
    }

    void __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::rowsAboutToBeRemoved(*parent, start, stop);
    }

    void __Qt4Ada_QAbstractItemView_rowsInserted_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::rowsInserted(*parent, start, stop);
    }

    void __Qt4Ada_QAbstractItemView_selectionChanged_0_wrapper(QObject* cpp_object, const QItemSelection* selected, const QItemSelection* deselected)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::selectionChanged(*selected, *deselected);
    }

    void __Qt4Ada_QAbstractItemView_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    bool __Qt4Ada_QAbstractItemView_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::event(e);
    }

    void __Qt4Ada_QAbstractItemView_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QAbstractItemView_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::focusNextPrevChild(next);
    }

    void __Qt4Ada_QAbstractItemView_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    bool __Qt4Ada_QAbstractItemView_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractItemView::viewportEvent(event);
    }

    void __Qt4Ada_QAbstractItemView_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QAbstractItemView_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractScrollArea::scrollContentsBy(dx, dy);
    }

    void __Qt4Ada_QAbstractItemView_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QAbstractItemView_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractScrollArea::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractScrollArea::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QAbstractScrollArea::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QAbstractItemView_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QAbstractItemView_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QAbstractItemView_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QAbstractItemView_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QAbstractItemView_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QAbstractItemView_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QAbstractItemView_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QAbstractItemView_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QAbstractItemView_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractItemView_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QAbstractItemView_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractItemViewDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractItemView_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_this)->QAbstractItemView::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractItemView_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractItemView*>(cpp_this)->QAbstractItemView::qt_metacall(_c, _id, _a);
    }

}

QModelIndex QAbstractItemViewDirector::indexAt(const QPoint& point) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemView_indexAt_0_dispatch(this->ada_object, &point);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

void QAbstractItemViewDirector::keyboardSearch(const QString& search)
{
    __Qt4Ada_QAbstractItemView_keyboardSearch_0_dispatch(this->ada_object, &search);
}

void QAbstractItemViewDirector::scrollTo(const QModelIndex& index, QAbstractItemView::ScrollHint hint)
{
    __Qt4Ada_QAbstractItemView_scrollTo_0_dispatch(this->ada_object, &index, hint);
}

void QAbstractItemViewDirector::setModel(QAbstractItemModel* model)
{
    __Qt4Ada_QAbstractItemView_setModel_0_dispatch(this->ada_object, model);
}

void QAbstractItemViewDirector::setSelectionModel(QItemSelectionModel* selectionModel)
{
    __Qt4Ada_QAbstractItemView_setSelectionModel_0_dispatch(this->ada_object, selectionModel);
}

int QAbstractItemViewDirector::sizeHintForColumn(int column) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_dispatch(this->ada_object, column);
}

int QAbstractItemViewDirector::sizeHintForRow(int row) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForRow_0_dispatch(this->ada_object, row);
}

QRect QAbstractItemViewDirector::visualRect(const QModelIndex& index) const
{
    QRect *aux = __Qt4Ada_QAbstractItemView_visualRect_0_dispatch(this->ada_object, &index);
    QRect returns = *aux;
    delete aux;
    return returns;
}

void QAbstractItemViewDirector::reset()
{
    __Qt4Ada_QAbstractItemView_reset_0_dispatch(this->ada_object);
}

void QAbstractItemViewDirector::selectAll()
{
    __Qt4Ada_QAbstractItemView_selectAll_0_dispatch(this->ada_object);
}

void QAbstractItemViewDirector::setRootIndex(const QModelIndex& index)
{
    __Qt4Ada_QAbstractItemView_setRootIndex_0_dispatch(this->ada_object, &index);
}

QVariant QAbstractItemViewDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

int QAbstractItemViewDirector::horizontalOffset() const
{
    return __Qt4Ada_QAbstractItemView_horizontalOffset_0_dispatch(this->ada_object);
}

bool QAbstractItemViewDirector::isIndexHidden(const QModelIndex& index) const
{
    return __Qt4Ada_QAbstractItemView_isIndexHidden_0_dispatch(this->ada_object, &index);
}

int QAbstractItemViewDirector::verticalOffset() const
{
    return __Qt4Ada_QAbstractItemView_verticalOffset_0_dispatch(this->ada_object);
}

QRegion QAbstractItemViewDirector::visualRegionForSelection(const QItemSelection& selection) const
{
    QRegion *aux = __Qt4Ada_QAbstractItemView_visualRegionForSelection_0_dispatch(this->ada_object, &selection);
    QRegion returns = *aux;
    delete aux;
    return returns;
}

void QAbstractItemViewDirector::commitData(QWidget* editor)
{
    __Qt4Ada_QAbstractItemView_commitData_0_dispatch(this->ada_object, editor);
}

void QAbstractItemViewDirector::currentChanged(const QModelIndex& current, const QModelIndex& previous)
{
    __Qt4Ada_QAbstractItemView_currentChanged_0_dispatch(this->ada_object, &current, &previous);
}

void QAbstractItemViewDirector::dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight)
{
    __Qt4Ada_QAbstractItemView_dataChanged_0_dispatch(this->ada_object, &topLeft, &bottomRight);
}

void QAbstractItemViewDirector::editorDestroyed(QObject* editor)
{
    __Qt4Ada_QAbstractItemView_editorDestroyed_0_dispatch(this->ada_object, editor);
}

void QAbstractItemViewDirector::rowsAboutToBeRemoved(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_dispatch(this->ada_object, &parent, start, stop);
}

void QAbstractItemViewDirector::rowsInserted(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsInserted_0_dispatch(this->ada_object, &parent, start, stop);
}

void QAbstractItemViewDirector::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected)
{
    __Qt4Ada_QAbstractItemView_selectionChanged_0_dispatch(this->ada_object, &selected, &deselected);
}

void QAbstractItemViewDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractItemViewDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QAbstractItemViewDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractItemViewDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QAbstractItemViewDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractItemViewDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

QSize QAbstractItemViewDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QAbstractItemViewDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractItemViewDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

void QAbstractItemViewDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QAbstractItemViewDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QAbstractItemViewDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QAbstractItemViewDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QAbstractItemViewDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QAbstractItemViewDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractItemViewDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractItemViewDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractItemViewDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractItemViewDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractItemViewDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QAbstractItemViewDirector::QAbstractItemViewDirector(void* o, QObject*parent) :
    QAbstractItemView (dynamic_cast<QWidget*>(parent)),
    ada_object (o)
{
}

QModelIndex QAbstractItemViewDirector::moveCursor (CursorAction cursorAction, Qt::KeyboardModifiers modifiers )
{
   QModelIndex *aux = __Qt4Ada_QAbstractItemView_moveCursor_dispatch (this->ada_object, cursorAction, modifiers);
   QModelIndex result = *aux;
   delete aux;
   return result;
}

void QAbstractItemViewDirector::setSelection ( const QRect & rect, QItemSelectionModel::SelectionFlags flags )
{
    __Qt4Ada_QAbstractItemView_setSelection_dispatch (this->ada_object, &rect, flags);
}

QStyleOptionViewItem QAbstractItemViewDirector::viewOptions () const
{
    QStyleOption aux = *(__Qt4Ada_QAbstractItemView_viewOptions_dispatch (this->ada_object));

     return *(qstyleoption_cast<QStyleOptionViewItem*>
               (__Qt4Ada_QAbstractItemView_viewOptions_dispatch (this->ada_object)));
}

bool QAbstractItemViewDirector::edit(const QModelIndex &index, EditTrigger trigger, QEvent *event)
{
    return __Qt4Ada_QAbstractItemView_edit_with_trigger_dispatch
            (this->ada_object, &index, (unsigned) trigger, event);
}

extern "C"
{

    void __Qt4Ada_QAbstractItemView_moveCursor_virtual (QObject*cpp_object, int cursorAction, unsigned modifiers , QModelIndex*returns)
    {
      *returns = dynamic_cast<QAbstractItemViewDirector*> (cpp_object) -> moveCursor ((QAbstractItemView::CursorAction) cursorAction, (Qt::KeyboardModifiers) modifiers);
    }

    void __Qt4Ada_QAbstractItemView_setSelection_virtual (QObject*cpp_object, const QRect*rect, unsigned flags)
    {
      dynamic_cast<QAbstractItemViewDirector*>(cpp_object) -> setSelection (*rect, (QItemSelectionModel::SelectionFlags) flags);
    }

    void __Qt4Ada_QAbstractItemView_viewOptions_wrapper (QObject*cpp_object, QStyleOption*returns)
    {

      QStyleOptionViewItem aux = dynamic_cast<QAbstractItemViewDirector*>
               (cpp_object) -> QAbstractItemView::viewOptions ();

      *returns  = *(qstyleoption_cast<QStyleOption*> (&aux));
    }

    bool __Qt4Ada_QAbstractItemView_edit_with_trigger_wrapper (QObject*cpp_object,
                                                               QModelIndex*index,
                                                               unsigned trigger,
                                                               QEvent* event)
    {
       return dynamic_cast<QAbstractItemViewDirector*>
         (cpp_object) -> QAbstractItemView::edit (*index,
                                                  (QAbstractItemView::EditTrigger) trigger,
                                                  event);
    }

    QObject* __Qt4Ada_new_QAbstractItemViewDirector (void* ada_object, QObject* parent)
    {
       return dynamic_cast<QObject*>(new QAbstractItemViewDirector(ada_object, parent));
    }

}
