//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QABSTRACTITEMVIEWDIRECTOR_H__
#define __QABSTRACTITEMVIEWDIRECTOR_H__

#include <QAbstractItemView>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QAbstractItemView_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QModelIndex* __Qt4Ada_QAbstractItemView_indexAt_0_dispatch(void*, const QPoint*);
    extern void __Qt4Ada_QAbstractItemView_keyboardSearch_0_dispatch(void*, const QString*);
    extern void __Qt4Ada_QAbstractItemView_scrollTo_0_dispatch(void*, const QModelIndex*, QAbstractItemView::ScrollHint);
    extern void __Qt4Ada_QAbstractItemView_setModel_0_dispatch(void*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_setSelectionModel_0_dispatch(void*, QObject*);
    extern int __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_dispatch(void*, int);
    extern int __Qt4Ada_QAbstractItemView_sizeHintForRow_0_dispatch(void*, int);
    extern QRect* __Qt4Ada_QAbstractItemView_visualRect_0_dispatch(void*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_reset_0_dispatch(void*);
    extern void __Qt4Ada_QAbstractItemView_selectAll_0_dispatch(void*);
    extern void __Qt4Ada_QAbstractItemView_setRootIndex_0_dispatch(void*, const QModelIndex*);
    extern int __Qt4Ada_QAbstractItemView_horizontalOffset_0_dispatch(void*);
    extern bool __Qt4Ada_QAbstractItemView_isIndexHidden_0_dispatch(void*, const QModelIndex*);
    extern int __Qt4Ada_QAbstractItemView_verticalOffset_0_dispatch(void*);
    extern QRegion* __Qt4Ada_QAbstractItemView_visualRegionForSelection_0_dispatch(void*, const QItemSelection*);
    extern void __Qt4Ada_QAbstractItemView_commitData_0_dispatch(void*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_currentChanged_0_dispatch(void*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_dataChanged_0_dispatch(void*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_editorDestroyed_0_dispatch(void*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_dispatch(void*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QAbstractItemView_rowsInserted_0_dispatch(void*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QAbstractItemView_selectionChanged_0_dispatch(void*, const QItemSelection*, const QItemSelection*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QAbstractItemView_indexAt_0_virtual(QObject*, const QPoint*, QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_keyboardSearch_0_virtual(QObject*, const QString*);
    extern void __Qt4Ada_QAbstractItemView_scrollTo_0_virtual(QObject*, const QModelIndex*, QAbstractItemView::ScrollHint);
    extern void __Qt4Ada_QAbstractItemView_setModel_0_virtual(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_setSelectionModel_0_virtual(QObject*, QObject*);
    extern int __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_virtual(QObject*, int);
    extern int __Qt4Ada_QAbstractItemView_sizeHintForRow_0_virtual(QObject*, int);
    extern void __Qt4Ada_QAbstractItemView_visualRect_0_virtual(QObject*, const QModelIndex*, QRect*);
    extern void __Qt4Ada_QAbstractItemView_reset_0_virtual(QObject*);
    extern void __Qt4Ada_QAbstractItemView_selectAll_0_virtual(QObject*);
    extern void __Qt4Ada_QAbstractItemView_setRootIndex_0_virtual(QObject*, const QModelIndex*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QAbstractItemView_alternatingRowColors_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_closePersistentEditor_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_currentIndex_0_wrapper(QObject*, QModelIndex*);
    extern QAbstractItemView::DragDropMode __Qt4Ada_QAbstractItemView_dragDropMode_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractItemView_dragDropOverwriteMode_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractItemView_dragEnabled_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractItemView_hasAutoScroll_0_wrapper(QObject*);
    extern QAbstractItemView::ScrollMode __Qt4Ada_QAbstractItemView_horizontalScrollMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_iconSize_0_wrapper(QObject*, QSize*);
    extern QObject* __Qt4Ada_QAbstractItemView_indexWidget_0_wrapper(QObject*, const QModelIndex*);
    extern QObject* __Qt4Ada_QAbstractItemView_itemDelegate_1_wrapper(QObject*);
    extern QObject* __Qt4Ada_QAbstractItemView_itemDelegate_0_wrapper(QObject*, const QModelIndex*);
    extern QObject* __Qt4Ada_QAbstractItemView_itemDelegateForColumn_0_wrapper(QObject*, int);
    extern QObject* __Qt4Ada_QAbstractItemView_itemDelegateForRow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractItemView_keyboardSearch_0_wrapper(QObject*, const QString*);
    extern QObject* __Qt4Ada_QAbstractItemView_model_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_openPersistentEditor_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_rootIndex_0_wrapper(QObject*, QModelIndex*);
    extern QAbstractItemView::SelectionBehavior __Qt4Ada_QAbstractItemView_selectionBehavior_0_wrapper(QObject*);
    extern QAbstractItemView::SelectionMode __Qt4Ada_QAbstractItemView_selectionMode_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QAbstractItemView_selectionModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_setAlternatingRowColors_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractItemView_setAutoScroll_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractItemView_setDragDropMode_0_wrapper(QObject*, QAbstractItemView::DragDropMode);
    extern void __Qt4Ada_QAbstractItemView_setDragDropOverwriteMode_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractItemView_setDragEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractItemView_setDropIndicatorShown_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractItemView_setHorizontalScrollMode_0_wrapper(QObject*, QAbstractItemView::ScrollMode);
    extern void __Qt4Ada_QAbstractItemView_setIconSize_0_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QAbstractItemView_setIndexWidget_0_wrapper(QObject*, const QModelIndex*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_setItemDelegate_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_setItemDelegateForColumn_0_wrapper(QObject*, int, QObject*);
    extern void __Qt4Ada_QAbstractItemView_setItemDelegateForRow_0_wrapper(QObject*, int, QObject*);
    extern void __Qt4Ada_QAbstractItemView_setModel_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_setSelectionBehavior_0_wrapper(QObject*, QAbstractItemView::SelectionBehavior);
    extern void __Qt4Ada_QAbstractItemView_setSelectionMode_0_wrapper(QObject*, QAbstractItemView::SelectionMode);
    extern void __Qt4Ada_QAbstractItemView_setSelectionModel_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_setTabKeyNavigation_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractItemView_setVerticalScrollMode_0_wrapper(QObject*, QAbstractItemView::ScrollMode);
    extern bool __Qt4Ada_QAbstractItemView_showDropIndicator_0_wrapper(QObject*);
    extern int __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractItemView_sizeHintForIndex_0_wrapper(QObject*, const QModelIndex*, QSize*);
    extern int __Qt4Ada_QAbstractItemView_sizeHintForRow_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QAbstractItemView_tabKeyNavigation_0_wrapper(QObject*);
    extern QAbstractItemView::ScrollMode __Qt4Ada_QAbstractItemView_verticalScrollMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_clearSelection_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_edit_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_reset_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_scrollToBottom_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_scrollToTop_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_selectAll_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_setCurrentIndex_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_setRootIndex_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_inputMethodQuery_0_wrapper(QObject*, Qt::InputMethodQuery, QVariant*);
    extern void __Qt4Ada_QAbstractItemView_activated_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_clicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_entered_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_pressed_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_viewportEntered_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    extern void __Qt4Ada_QAbstractItemView_executeDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QAbstractItemView_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    extern void __Qt4Ada_QAbstractItemView_commitData_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_editorDestroyed_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QAbstractItemView_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QAbstractItemView_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    extern void __Qt4Ada_QAbstractItemView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_dropEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractItemView_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractItemView_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractItemView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_timerEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractItemView_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractItemView_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QAbstractItemView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QAbstractItemView_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QAbstractItemView_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractItemView_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractItemView_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractItemView_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QAbstractItemView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QAbstractItemView_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractItemView_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QAbstractItemView_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QAbstractItemView_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QAbstractItemView_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
#include <QRegion>

extern "C"
{

    //  dispatchs

    extern QModelIndex* __Qt4Ada_QAbstractItemView_moveCursor_dispatch (void*, int, unsigned);
    extern void __Qt4Ada_QAbstractItemView_setSelection_dispatch (void*, const QRect*, unsigned);
    extern QStyleOption* __Qt4Ada_QAbstractItemView_viewOptions_dispatch (void*);

    extern bool __Qt4Ada_QAbstractItemView_edit_with_trigger_dispatch (void*, const QModelIndex*, unsigned, QEvent*);

    //  virtual

    extern void __Qt4Ada_QAbstractItemView_moveCursor_virtual (QObject*, int, unsigned, QModelIndex*);
    extern void __Qt4Ada_QAbstractItemView_setSelection_virtual (QObject*, const QRect*, unsigned);

   //  wrappers

    void __Qt4Ada_QAbstractItemView_viewOptions_wrapper (QObject*cpp_object, QStyleOption*returns);
    extern bool __Qt4Ada_QAbstractItemView_edit_with_trigger_wrapper (QObject*,QModelIndex*,unsigned,QEvent*);

    //  constructors

    extern QObject* __Qt4Ada_new_QAbstractItemViewDirector (void*, QObject*);

}

class QAbstractItemViewDirector : public QAbstractItemView
{
protected:
    void* ada_object;
    QAbstractItemViewDirector(void*, QObject*);

    virtual QModelIndex moveCursor (CursorAction cursorAction, Qt::KeyboardModifiers modifiers );
    virtual void setSelection ( const QRect & rect, QItemSelectionModel::SelectionFlags flags );
    virtual QStyleOptionViewItem viewOptions () const;
    virtual bool edit(const QModelIndex &index, QAbstractItemView::EditTrigger trigger, QEvent *event);

    friend QObject* __Qt4Ada_new_QAbstractItemViewDirector (void*, QObject*);

    friend void __Qt4Ada_QAbstractItemView_moveCursor_virtual (QObject*, int, unsigned, QModelIndex*);
    friend void __Qt4Ada_QAbstractItemView_setSelection_virtual (QObject*, const QRect*, unsigned);
    friend void __Qt4Ada_QAbstractItemView_viewOptions_wrapper (QObject*,QStyleOption*);
    friend bool __Qt4Ada_QAbstractItemView_edit_with_trigger_wrapper (QObject*,QModelIndex*,unsigned,QEvent*);

    virtual QModelIndex indexAt(const QPoint&) const;
    virtual void keyboardSearch(const QString&);
    virtual void scrollTo(const QModelIndex&, QAbstractItemView::ScrollHint);
    virtual void setModel(QAbstractItemModel*);
    virtual void setSelectionModel(QItemSelectionModel*);
    virtual int sizeHintForColumn(int) const;
    virtual int sizeHintForRow(int) const;
    virtual QRect visualRect(const QModelIndex&) const;
    virtual void reset();
    virtual void selectAll();
    virtual void setRootIndex(const QModelIndex&);
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual int horizontalOffset() const;
    virtual bool isIndexHidden(const QModelIndex&) const;
    virtual int verticalOffset() const;
    virtual QRegion visualRegionForSelection(const QItemSelection&) const;
    virtual void commitData(QWidget*);
    virtual void currentChanged(const QModelIndex&, const QModelIndex&);
    virtual void dataChanged(const QModelIndex&, const QModelIndex&);
    virtual void editorDestroyed(QObject*);
    virtual void rowsAboutToBeRemoved(const QModelIndex&, int, int);
    virtual void rowsInserted(const QModelIndex&, int, int);
    virtual void selectionChanged(const QItemSelection&, const QItemSelection&);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual bool event(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual bool viewportEvent(QEvent*);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void scrollContentsBy(int, int);
    virtual void paintEvent(QPaintEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QAbstractItemView_activated_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractItemView_clicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractItemView_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractItemView_entered_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractItemView_pressed_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractItemView_viewportEntered_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemView_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    friend void __Qt4Ada_QAbstractItemView_executeDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemView_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemView_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QAbstractItemView_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    friend void __Qt4Ada_QAbstractItemView_commitData_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QAbstractItemView_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractItemView_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractItemView_editorDestroyed_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QAbstractItemView_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QAbstractItemView_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    friend void __Qt4Ada_QAbstractItemView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_dropEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractItemView_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractItemView_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QAbstractItemView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_timerEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractItemView_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QAbstractItemView_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QAbstractItemView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend void __Qt4Ada_QAbstractItemView_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QAbstractItemView_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractItemView_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QAbstractItemView_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemView_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractItemView_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QAbstractItemView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QAbstractItemView_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractItemView_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QAbstractItemView_sender_0_wrapper(QObject*);
};

#endif // __QABSTRACTITEMVIEWDIRECTOR_H__
