//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QModelIndex>
#include <QItemSelection>
#include <QAbstractItemModel>
#include <QMimeData>
#include <QStringList>
#include <QSize>
#include <QChildEvent>
#include <QTimerEvent>

#include "qabstractproxymodeldirector.h"
#include "qabstractitemmodeldirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractProxyModel_staticMetaObject =
        &QAbstractProxyModel::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QAbstractProxyModel_mapFromSource_0_virtual(QObject* cpp_object, const QModelIndex* sourceIndex, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractProxyModel*>(cpp_object)->mapFromSource(*sourceIndex);
    }

    void __Qt4Ada_QAbstractProxyModel_mapSelectionFromSource_0_virtual(QObject* cpp_object, const QItemSelection* sourceSelection, QItemSelection* returns)
    {
        *returns = dynamic_cast<QAbstractProxyModel*>(cpp_object)->mapSelectionFromSource(*sourceSelection);
    }

    void __Qt4Ada_QAbstractProxyModel_mapSelectionToSource_0_virtual(QObject* cpp_object, const QItemSelection* proxySelection, QItemSelection* returns)
    {
        *returns = dynamic_cast<QAbstractProxyModel*>(cpp_object)->mapSelectionToSource(*proxySelection);
    }

    void __Qt4Ada_QAbstractProxyModel_mapToSource_0_virtual(QObject* cpp_object, const QModelIndex* proxyIndex, QModelIndex* returns)
    {
        *returns = dynamic_cast<QAbstractProxyModel*>(cpp_object)->mapToSource(*proxyIndex);
    }

    void __Qt4Ada_QAbstractProxyModel_setSourceModel_0_virtual(QObject* cpp_object, QObject* sourceModel)
    {
        dynamic_cast<QAbstractProxyModel*>(cpp_object)->setSourceModel(dynamic_cast<QAbstractItemModel*>(sourceModel));
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QAbstractProxyModel_mapSelectionFromSource_0_wrapper(QObject* cpp_object, const QItemSelection* sourceSelection, QItemSelection* returns)
    {
        *returns = dynamic_cast<QAbstractProxyModel*>(cpp_object)->QAbstractProxyModel::mapSelectionFromSource(*sourceSelection);
    }

    void __Qt4Ada_QAbstractProxyModel_mapSelectionToSource_0_wrapper(QObject* cpp_object, const QItemSelection* proxySelection, QItemSelection* returns)
    {
        *returns = dynamic_cast<QAbstractProxyModel*>(cpp_object)->QAbstractProxyModel::mapSelectionToSource(*proxySelection);
    }

    void __Qt4Ada_QAbstractProxyModel_setSourceModel_0_wrapper(QObject* cpp_object, QObject* sourceModel)
    {
        dynamic_cast<QAbstractProxyModel*>(cpp_object)->QAbstractProxyModel::setSourceModel(dynamic_cast<QAbstractItemModel*>(sourceModel));
    }

    QObject* __Qt4Ada_QAbstractProxyModel_sourceModel_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractProxyModel*>(cpp_object)->QAbstractProxyModel::sourceModel());
    }

    void __Qt4Ada_QAbstractProxyModel_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::dataChanged(*topLeft, *bottomRight);
    }

    void __Qt4Ada_QAbstractProxyModel_headerDataChanged_0_wrapper(QObject* cpp_object, Qt::Orientation orientation, int first, int last)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::headerDataChanged(orientation, first, last);
    }

    void __Qt4Ada_QAbstractProxyModel_layoutAboutToBeChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::layoutAboutToBeChanged();
    }

    void __Qt4Ada_QAbstractProxyModel_layoutChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::layoutChanged();
    }

    void __Qt4Ada_QAbstractProxyModel_beginInsertColumns_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::beginInsertColumns(*parent, first, last);
    }

    void __Qt4Ada_QAbstractProxyModel_beginInsertRows_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::beginInsertRows(*parent, first, last);
    }

    bool __Qt4Ada_QAbstractProxyModel_beginMoveColumns_0_wrapper(QObject* cpp_object, const QModelIndex* sourceParent, int sourceFirst, int sourceLast, const QModelIndex* destinationParent, int destinationChild)
    {
        return dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::beginMoveColumns(*sourceParent, sourceFirst, sourceLast, *destinationParent, destinationChild);
    }

    bool __Qt4Ada_QAbstractProxyModel_beginMoveRows_0_wrapper(QObject* cpp_object, const QModelIndex* sourceParent, int sourceFirst, int sourceLast, const QModelIndex* destinationParent, int destinationChild)
    {
        return dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::beginMoveRows(*sourceParent, sourceFirst, sourceLast, *destinationParent, destinationChild);
    }

    void __Qt4Ada_QAbstractProxyModel_beginRemoveColumns_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::beginRemoveColumns(*parent, first, last);
    }

    void __Qt4Ada_QAbstractProxyModel_beginRemoveRows_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::beginRemoveRows(*parent, first, last);
    }

    void __Qt4Ada_QAbstractProxyModel_beginResetModel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::beginResetModel();
    }

    void __Qt4Ada_QAbstractProxyModel_changePersistentIndex_0_wrapper(QObject* cpp_object, const QModelIndex* from, const QModelIndex* to)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::changePersistentIndex(*from, *to);
    }

    void __Qt4Ada_QAbstractProxyModel_endInsertColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::endInsertColumns();
    }

    void __Qt4Ada_QAbstractProxyModel_endInsertRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::endInsertRows();
    }

    void __Qt4Ada_QAbstractProxyModel_endMoveColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::endMoveColumns();
    }

    void __Qt4Ada_QAbstractProxyModel_endMoveRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::endMoveRows();
    }

    void __Qt4Ada_QAbstractProxyModel_endRemoveColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::endRemoveColumns();
    }

    void __Qt4Ada_QAbstractProxyModel_endRemoveRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::endRemoveRows();
    }

    void __Qt4Ada_QAbstractProxyModel_endResetModel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::endResetModel();
    }

    void __Qt4Ada_QAbstractProxyModel_reset_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QAbstractItemModel::reset();
    }

    void __Qt4Ada_QAbstractProxyModel_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractProxyModel_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QAbstractProxyModel_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QAbstractProxyModel_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractProxyModelDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractProxyModel_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractProxyModel*>(cpp_this)->QAbstractProxyModel::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractProxyModel_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractProxyModel*>(cpp_this)->QAbstractProxyModel::qt_metacall(_c, _id, _a);
    }

}

QModelIndex QAbstractProxyModelDirector::mapFromSource(const QModelIndex& sourceIndex)
{
    QModelIndex *aux = __Qt4Ada_QAbstractProxyModel_mapFromSource_0_dispatch(this->ada_object, &sourceIndex);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

QItemSelection QAbstractProxyModelDirector::mapSelectionFromSource(const QItemSelection& sourceSelection) const
{
    QItemSelection *aux = __Qt4Ada_QAbstractProxyModel_mapSelectionFromSource_0_dispatch(this->ada_object, &sourceSelection);
    QItemSelection returns = *aux;
    delete aux;
    return returns;
}

QItemSelection QAbstractProxyModelDirector::mapSelectionToSource(const QItemSelection& proxySelection) const
{
    QItemSelection *aux = __Qt4Ada_QAbstractProxyModel_mapSelectionToSource_0_dispatch(this->ada_object, &proxySelection);
    QItemSelection returns = *aux;
    delete aux;
    return returns;
}

QModelIndex QAbstractProxyModelDirector::mapToSource(const QModelIndex& proxyIndex)
{
    QModelIndex *aux = __Qt4Ada_QAbstractProxyModel_mapToSource_0_dispatch(this->ada_object, &proxyIndex);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

void QAbstractProxyModelDirector::setSourceModel(QAbstractItemModel* sourceModel)
{
    __Qt4Ada_QAbstractProxyModel_setSourceModel_0_dispatch(this->ada_object, sourceModel);
}

QModelIndex QAbstractProxyModelDirector::buddy(const QModelIndex& index) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_buddy_0_dispatch(this->ada_object, &index);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QAbstractProxyModelDirector::canFetchMore(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_canFetchMore_0_dispatch(this->ada_object, &parent);
}

int QAbstractProxyModelDirector::columnCount(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_columnCount_0_dispatch(this->ada_object, &parent);
}

bool QAbstractProxyModelDirector::dropMimeData(QMimeData* data, Qt::DropAction action, int row, int column, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_dropMimeData_0_dispatch(this->ada_object, data, action, row, column, &parent);
}

void QAbstractProxyModelDirector::fetchMore(const QModelIndex& parent)
{
    __Qt4Ada_QAbstractItemModel_fetchMore_0_dispatch(this->ada_object, &parent);
}

bool QAbstractProxyModelDirector::hasChildren(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_hasChildren_0_dispatch(this->ada_object, &parent);
}

bool QAbstractProxyModelDirector::hasIndex(int row, int column, const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_hasIndex_0_dispatch(this->ada_object, row, column, &parent);
}

QModelIndex QAbstractProxyModelDirector::index(int row, int column, const QModelIndex& parent) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_index_0_dispatch(this->ada_object, row, column, &parent);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QAbstractProxyModelDirector::insertColumns(int column, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_insertColumns_0_dispatch(this->ada_object, column, count, &parent);
}

bool QAbstractProxyModelDirector::insertRows(int row, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_insertRows_0_dispatch(this->ada_object, row, count, &parent);
}

QMimeData* QAbstractProxyModelDirector::mimeData(const QModelIndexList& indexes) const
{
    return dynamic_cast<QMimeData*>(__Qt4Ada_QAbstractItemModel_mimeData_0_dispatch(this->ada_object, &indexes));
}

QStringList QAbstractProxyModelDirector::mimeTypes() const
{
    QStringList *aux = __Qt4Ada_QAbstractItemModel_mimeTypes_0_dispatch(this->ada_object);
    QStringList returns = *aux;
    delete aux;
    return returns;
}

QModelIndex QAbstractProxyModelDirector::parent(const QModelIndex& child) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_parent_1_dispatch(this->ada_object, &child);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QAbstractProxyModelDirector::removeColumns(int column, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_removeColumns_0_dispatch(this->ada_object, column, count, &parent);
}

bool QAbstractProxyModelDirector::removeRows(int row, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_removeRows_0_dispatch(this->ada_object, row, count, &parent);
}

int QAbstractProxyModelDirector::rowCount(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_rowCount_0_dispatch(this->ada_object, &parent);
}

QSize QAbstractProxyModelDirector::span(const QModelIndex& index) const
{
    QSize *aux = __Qt4Ada_QAbstractItemModel_span_0_dispatch(this->ada_object, &index);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractProxyModelDirector::revert()
{
    __Qt4Ada_QAbstractItemModel_revert_0_dispatch(this->ada_object);
}

bool QAbstractProxyModelDirector::submit()
{
    return __Qt4Ada_QAbstractItemModel_submit_0_dispatch(this->ada_object);
}

bool QAbstractProxyModelDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QAbstractProxyModelDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractProxyModelDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractProxyModelDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QAbstractProxyModelDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractProxyModelDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractProxyModelDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractProxyModelDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
