//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QABSTRACTPROXYMODELDIRECTOR_H__
#define __QABSTRACTPROXYMODELDIRECTOR_H__

#include <QAbstractProxyModel>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QAbstractProxyModel_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QModelIndex* __Qt4Ada_QAbstractProxyModel_mapFromSource_0_dispatch(void*, const QModelIndex*);
    extern QItemSelection* __Qt4Ada_QAbstractProxyModel_mapSelectionFromSource_0_dispatch(void*, const QItemSelection*);
    extern QItemSelection* __Qt4Ada_QAbstractProxyModel_mapSelectionToSource_0_dispatch(void*, const QItemSelection*);
    extern QModelIndex* __Qt4Ada_QAbstractProxyModel_mapToSource_0_dispatch(void*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractProxyModel_setSourceModel_0_dispatch(void*, QObject*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QAbstractProxyModel_mapFromSource_0_virtual(QObject*, const QModelIndex*, QModelIndex*);
    extern void __Qt4Ada_QAbstractProxyModel_mapSelectionFromSource_0_virtual(QObject*, const QItemSelection*, QItemSelection*);
    extern void __Qt4Ada_QAbstractProxyModel_mapSelectionToSource_0_virtual(QObject*, const QItemSelection*, QItemSelection*);
    extern void __Qt4Ada_QAbstractProxyModel_mapToSource_0_virtual(QObject*, const QModelIndex*, QModelIndex*);
    extern void __Qt4Ada_QAbstractProxyModel_setSourceModel_0_virtual(QObject*, QObject*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QAbstractProxyModel_mapSelectionFromSource_0_wrapper(QObject*, const QItemSelection*, QItemSelection*);
    extern void __Qt4Ada_QAbstractProxyModel_mapSelectionToSource_0_wrapper(QObject*, const QItemSelection*, QItemSelection*);
    extern void __Qt4Ada_QAbstractProxyModel_setSourceModel_0_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QAbstractProxyModel_sourceModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractProxyModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    extern void __Qt4Ada_QAbstractProxyModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_layoutChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QAbstractProxyModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern bool __Qt4Ada_QAbstractProxyModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern bool __Qt4Ada_QAbstractProxyModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern void __Qt4Ada_QAbstractProxyModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QAbstractProxyModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QAbstractProxyModel_beginResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QAbstractProxyModel_endInsertColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_endInsertRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_endMoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_endMoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_endRemoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_endRemoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_endResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_reset_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractProxyModel_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractProxyModel_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractProxyModel_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QAbstractProxyModel_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QAbstractProxyModel_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QAbstractProxyModel_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

class QAbstractProxyModelDirector : public QAbstractProxyModel
{
protected:
    void* ada_object;
    QAbstractProxyModelDirector();

    virtual QModelIndex mapFromSource(const QModelIndex&);
    virtual QItemSelection mapSelectionFromSource(const QItemSelection&) const;
    virtual QItemSelection mapSelectionToSource(const QItemSelection&) const;
    virtual QModelIndex mapToSource(const QModelIndex&);
    virtual void setSourceModel(QAbstractItemModel*);
    virtual QModelIndex buddy(const QModelIndex&) const;
    virtual bool canFetchMore(const QModelIndex&) const;
    virtual int columnCount(const QModelIndex&) const;
    virtual bool dropMimeData(QMimeData*, Qt::DropAction, int, int, const QModelIndex&);
    virtual void fetchMore(const QModelIndex&);
    virtual bool hasChildren(const QModelIndex&) const;
    virtual bool hasIndex(int, int, const QModelIndex&) const;
    virtual QModelIndex index(int, int, const QModelIndex&) const;
    virtual bool insertColumns(int, int, const QModelIndex&);
    virtual bool insertRows(int, int, const QModelIndex&);
    virtual QMimeData* mimeData(const QModelIndexList&) const;
    virtual QStringList mimeTypes() const;
    virtual QModelIndex parent(const QModelIndex&) const;
    virtual bool removeColumns(int, int, const QModelIndex&);
    virtual bool removeRows(int, int, const QModelIndex&);
    virtual int rowCount(const QModelIndex&) const;
    virtual QSize span(const QModelIndex&) const;
    virtual void revert();
    virtual bool submit();
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QAbstractProxyModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractProxyModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    friend void __Qt4Ada_QAbstractProxyModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_layoutChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QAbstractProxyModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend bool __Qt4Ada_QAbstractProxyModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend bool __Qt4Ada_QAbstractProxyModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend void __Qt4Ada_QAbstractProxyModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QAbstractProxyModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QAbstractProxyModel_beginResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QAbstractProxyModel_endInsertColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_endInsertRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_endMoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_endMoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_endRemoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_endRemoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_endResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_reset_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractProxyModel_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractProxyModel_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractProxyModel_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QAbstractProxyModel_sender_0_wrapper(QObject*);
};

#endif // __QABSTRACTPROXYMODELDIRECTOR_H__
