//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QABSTRACTSCROLLAREADIRECTOR_H__
#define __QABSTRACTSCROLLAREADIRECTOR_H__

#include <QAbstractScrollArea>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QAbstractScrollArea_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(void*, int, int);
    extern bool __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(void*, QEvent*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern QObject* __Qt4Ada_QAbstractScrollArea_cornerWidget_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QAbstractScrollArea_horizontalScrollBar_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractScrollArea_maximumViewportSize_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QAbstractScrollArea_setCornerWidget_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractScrollArea_setHorizontalScrollBar_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractScrollArea_setVerticalScrollBar_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractScrollArea_setViewport_0_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QAbstractScrollArea_viewport_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QAbstractScrollArea_verticalScrollBar_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractScrollArea_minimumSizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QAbstractScrollArea_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QAbstractScrollArea_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QAbstractScrollArea_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern bool __Qt4Ada_QAbstractScrollArea_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractScrollArea_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QAbstractScrollArea_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractScrollArea_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractScrollArea_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractScrollArea_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractScrollArea_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractScrollArea_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractScrollArea_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QAbstractScrollArea_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QAbstractScrollArea_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractScrollArea_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QAbstractScrollArea_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QAbstractScrollArea_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QAbstractScrollArea_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    //  Declarations of wrapper functions for static call

    extern QPaintEngine*__Qt4Ada_QAbstractScrollArea_paintEngine_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractScrollArea_styleChange_wrapper(QObject*,QObject&);
    extern void __Qt4Ada_QAbstractScrollArea_connectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QAbstractScrollArea_disconnectNotify_wrapper(QObject*,const char*);

}

class QAbstractScrollAreaDirector : public QAbstractScrollArea
{
protected:
    void* ada_object;
    QAbstractScrollAreaDirector();

    virtual QPaintEngine*paintEngine();
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

    friend void __Qt4Ada_QAbstractScrollArea_styleChange_wrapper(QObject*,QObject&);
    friend void __Qt4Ada_QAbstractScrollArea_connectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QAbstractScrollArea_disconnectNotify_wrapper(QObject*,const char*);

    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void scrollContentsBy(int, int);
    virtual bool viewportEvent(QEvent*);
    virtual bool event(QEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QAbstractScrollArea_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QAbstractScrollArea_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend bool __Qt4Ada_QAbstractScrollArea_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractScrollArea_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QAbstractScrollArea_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractScrollArea_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QAbstractScrollArea_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QAbstractScrollArea_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractScrollArea_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractScrollArea_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractScrollArea_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QAbstractScrollArea_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QAbstractScrollArea_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractScrollArea_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QAbstractScrollArea_sender_0_wrapper(QObject*);
};

#endif // __QABSTRACTSCROLLAREADIRECTOR_H__
