//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QKeyEvent>
#include <QTimerEvent>
#include <QWheelEvent>
#include <QVariant>
#include <QSize>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qabstractsliderdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractSlider_staticMetaObject =
        &QAbstractSlider::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QAbstractSlider_hasTracking_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::hasTracking();
    }

    bool __Qt4Ada_QAbstractSlider_invertedAppearance_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::invertedAppearance();
    }

    bool __Qt4Ada_QAbstractSlider_invertedControls_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::invertedControls();
    }

    bool __Qt4Ada_QAbstractSlider_isSliderDown_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::isSliderDown();
    }

    int __Qt4Ada_QAbstractSlider_maximum_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::maximum();
    }

    int __Qt4Ada_QAbstractSlider_minimum_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::minimum();
    }

    int __Qt4Ada_QAbstractSlider_pageStep_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::pageStep();
    }

    void __Qt4Ada_QAbstractSlider_setInvertedAppearance_0_wrapper(QObject* cpp_object, bool value)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setInvertedAppearance(value);
    }

    void __Qt4Ada_QAbstractSlider_setInvertedControls_0_wrapper(QObject* cpp_object, bool value)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setInvertedControls(value);
    }

    void __Qt4Ada_QAbstractSlider_setMaximum_0_wrapper(QObject* cpp_object, int value)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setMaximum(value);
    }

    void __Qt4Ada_QAbstractSlider_setMinimum_0_wrapper(QObject* cpp_object, int value)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setMinimum(value);
    }

    void __Qt4Ada_QAbstractSlider_setPageStep_0_wrapper(QObject* cpp_object, int value)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setPageStep(value);
    }

    void __Qt4Ada_QAbstractSlider_setRange_0_wrapper(QObject* cpp_object, int min, int max)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setRange(min, max);
    }

    void __Qt4Ada_QAbstractSlider_setSingleStep_0_wrapper(QObject* cpp_object, int value)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setSingleStep(value);
    }

    void __Qt4Ada_QAbstractSlider_setSliderDown_0_wrapper(QObject* cpp_object, bool value)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setSliderDown(value);
    }

    void __Qt4Ada_QAbstractSlider_setSliderPosition_0_wrapper(QObject* cpp_object, int value)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setSliderPosition(value);
    }

    void __Qt4Ada_QAbstractSlider_setTracking_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setTracking(enable);
    }

    int __Qt4Ada_QAbstractSlider_singleStep_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::singleStep();
    }

    int __Qt4Ada_QAbstractSlider_sliderPosition_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::sliderPosition();
    }

    int __Qt4Ada_QAbstractSlider_value_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::value();
    }

    void __Qt4Ada_QAbstractSlider_setValue_0_wrapper(QObject* cpp_object, int value)
    {
        dynamic_cast<QAbstractSlider*>(cpp_object)->QAbstractSlider::setValue(value);
    }

    void __Qt4Ada_QAbstractSlider_rangeChanged_0_wrapper(QObject* cpp_object, int min, int max)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QAbstractSlider::rangeChanged(min, max);
    }

    void __Qt4Ada_QAbstractSlider_sliderMoved_0_wrapper(QObject* cpp_object, int position)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QAbstractSlider::sliderMoved(position);
    }

    void __Qt4Ada_QAbstractSlider_sliderPressed_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QAbstractSlider::sliderPressed();
    }

    void __Qt4Ada_QAbstractSlider_sliderReleased_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QAbstractSlider::sliderReleased();
    }

    void __Qt4Ada_QAbstractSlider_valueChanged_0_wrapper(QObject* cpp_object, int value)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QAbstractSlider::valueChanged(value);
    }

    void __Qt4Ada_QAbstractSlider_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QAbstractSlider::changeEvent(event);
    }

    bool __Qt4Ada_QAbstractSlider_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QAbstractSlider::event(e);
    }

    void __Qt4Ada_QAbstractSlider_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QAbstractSlider::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QAbstractSlider::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QAbstractSlider::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QAbstractSlider_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QAbstractSlider_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QAbstractSlider_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QAbstractSlider_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QAbstractSlider_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QAbstractSlider_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QAbstractSlider_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QAbstractSlider_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QAbstractSlider_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QAbstractSlider_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QAbstractSlider_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractSlider_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QAbstractSlider_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractSliderDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractSlider_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_this)->QAbstractSlider::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractSlider_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractSlider*>(cpp_this)->QAbstractSlider::qt_metacall(_c, _id, _a);
    }

}

void QAbstractSliderDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractSliderDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QAbstractSliderDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QAbstractSliderDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QAbstractSliderDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QAbstractSliderDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QAbstractSliderDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QAbstractSliderDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QAbstractSliderDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QAbstractSliderDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QAbstractSliderDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QAbstractSliderDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QAbstractSliderDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractSliderDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractSliderDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractSliderDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractSliderDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractSliderDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
