//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QABSTRACTSPINBOXDIRECTOR_H__
#define __QABSTRACTSPINBOXDIRECTOR_H__

#include <QAbstractSpinBox>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QAbstractSpinBox_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QAbstractSpinBox_fixup_0_dispatch(void*, QString*);
    extern void __Qt4Ada_QAbstractSpinBox_stepBy_0_dispatch(void*, int);
    extern QValidator::State __Qt4Ada_QAbstractSpinBox_validate_0_dispatch(void*, QString*, int);
    extern void __Qt4Ada_QAbstractSpinBox_clear_0_dispatch(void*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QAbstractSpinBox_fixup_0_virtual(QObject*, QString*);
    extern void __Qt4Ada_QAbstractSpinBox_stepBy_0_virtual(QObject*, int);
    extern QValidator::State __Qt4Ada_QAbstractSpinBox_validate_0_virtual(QObject*, QString*, int);
    extern void __Qt4Ada_QAbstractSpinBox_clear_0_virtual(QObject*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QAbstractSpinBox_fixup_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QAbstractSpinBox_hasAcceptableInput_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractSpinBox_hasFrame_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_interpretText_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractSpinBox_isAccelerated_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractSpinBox_isReadOnly_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_setAccelerated_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractSpinBox_setFrame_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractSpinBox_setReadOnly_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractSpinBox_setSpecialValueText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QAbstractSpinBox_setWrapping_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QAbstractSpinBox_specialValueText_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QAbstractSpinBox_stepBy_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QAbstractSpinBox_text_0_wrapper(QObject*, QString*);
    extern QValidator::State __Qt4Ada_QAbstractSpinBox_validate_0_wrapper(QObject*, QString*, int);
    extern bool __Qt4Ada_QAbstractSpinBox_wrapping_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_minimumSizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QAbstractSpinBox_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QAbstractSpinBox_clear_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_selectAll_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_stepDown_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_stepUp_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QAbstractSpinBox_lineEdit_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_setLineEdit_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_editingFinished_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractSpinBox_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QAbstractSpinBox_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QAbstractSpinBox_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QAbstractSpinBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QAbstractSpinBox_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QAbstractSpinBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QAbstractSpinBox_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QAbstractSpinBox_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QAbstractSpinBox_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QAbstractSpinBox_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QAbstractSpinBox_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    //  Declarations of exported functions

    extern QAbstractSpinBox::StepEnabled __Qt4Ada_QAbstractSpinBox_stepEnabled_dispatch(void *);

    //  Declarations of wrapper functions for static call

    extern QAbstractSpinBox::StepEnabled __Qt4Ada_QAbstractSpinBox_stepEnabled_wrapper(QObject*);
    extern QPaintEngine*__Qt4Ada_QAbstractSpinBox_paintEngine_wrapper(QObject*);
    extern void __Qt4Ada_QAbstractSpinBox_connectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QAbstractSpinBox_disconnectNotify_wrapper(QObject*,const char*);

}

class QAbstractSpinBoxDirector : public QAbstractSpinBox
{
protected:
    void* ada_object;
    QAbstractSpinBoxDirector();

    virtual QAbstractSpinBox::StepEnabled stepEnabled();
    virtual QPaintEngine*paintEngine();
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

    friend QAbstractSpinBox::StepEnabled __Qt4Ada_QAbstractSpinBox_stepEnabled_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractSpinBox_connectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QAbstractSpinBox_disconnectNotify_wrapper(QObject*,const char*);

    virtual void fixup(QString&) const;
    virtual void stepBy(int);
    virtual QValidator::State validate(QString&, int) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void clear();
    virtual bool event(QEvent*);
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend QObject* __Qt4Ada_QAbstractSpinBox_lineEdit_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractSpinBox_setLineEdit_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QAbstractSpinBox_editingFinished_0_wrapper(QObject*);
    friend bool __Qt4Ada_QAbstractSpinBox_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QAbstractSpinBox_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QAbstractSpinBox_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QAbstractSpinBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QAbstractSpinBox_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractSpinBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QAbstractSpinBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QAbstractSpinBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QAbstractSpinBox_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QAbstractSpinBox_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QAbstractSpinBox_sender_0_wrapper(QObject*);
};

#endif // __QABSTRACTSPINBOXDIRECTOR_H__
