//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QRectF>
#include <QTextDocument>
#include <QSizeF>
#include <QTextFrame>
#include <QTextCharFormat>
#include <QChildEvent>
#include <QTimerEvent>

#include "qabstracttextdocumentlayoutdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QAbstractTextDocumentLayout_staticMetaObject =
        &QAbstractTextDocumentLayout::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QAbstractTextDocumentLayout_blockBoundingRect_0_virtual(QObject* cpp_object, const QTextBlock* block, QRectF* returns)
    {
        *returns = dynamic_cast<QAbstractTextDocumentLayout*>(cpp_object)->blockBoundingRect(*block);
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_documentSize_0_virtual(QObject* cpp_object, QSizeF* returns)
    {
        *returns = dynamic_cast<QAbstractTextDocumentLayout*>(cpp_object)->documentSize();
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_frameBoundingRect_0_virtual(QObject* cpp_object, QObject* frame, QRectF* returns)
    {
        *returns = dynamic_cast<QAbstractTextDocumentLayout*>(cpp_object)->frameBoundingRect(dynamic_cast<QTextFrame*>(frame));
    }

    int __Qt4Ada_QAbstractTextDocumentLayout_hitTest_0_virtual(QObject* cpp_object, const QPointF* point, Qt::HitTestAccuracy accuracy)
    {
        return dynamic_cast<QAbstractTextDocumentLayout*>(cpp_object)->hitTest(*point, accuracy);
    }

    int __Qt4Ada_QAbstractTextDocumentLayout_pageCount_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractTextDocumentLayout*>(cpp_object)->pageCount();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QAbstractTextDocumentLayout_anchorAt_0_wrapper(QObject* cpp_object, const QPointF* pos, QString* returns)
    {
        *returns = dynamic_cast<QAbstractTextDocumentLayout*>(cpp_object)->QAbstractTextDocumentLayout::anchorAt(*pos);
    }

    QObject* __Qt4Ada_QAbstractTextDocumentLayout_document_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QAbstractTextDocumentLayout*>(cpp_object)->QAbstractTextDocumentLayout::document());
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_registerHandler_0_wrapper(QObject* cpp_object, int objectType, QObject* component)
    {
        dynamic_cast<QAbstractTextDocumentLayout*>(cpp_object)->QAbstractTextDocumentLayout::registerHandler(objectType, component);
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_documentSizeChanged_0_wrapper(QObject* cpp_object, const QSizeF* newSize)
    {
        dynamic_cast<QAbstractTextDocumentLayoutDirector*>(cpp_object)->QAbstractTextDocumentLayout::documentSizeChanged(*newSize);
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_pageCountChanged_0_wrapper(QObject* cpp_object, int newPages)
    {
        dynamic_cast<QAbstractTextDocumentLayoutDirector*>(cpp_object)->QAbstractTextDocumentLayout::pageCountChanged(newPages);
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_update_0_wrapper(QObject* cpp_object, const QRectF* rect)
    {
        dynamic_cast<QAbstractTextDocumentLayoutDirector*>(cpp_object)->QAbstractTextDocumentLayout::update(*rect);
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_updateBlock_0_wrapper(QObject* cpp_object, const QTextBlock* block)
    {
        dynamic_cast<QAbstractTextDocumentLayoutDirector*>(cpp_object)->QAbstractTextDocumentLayout::updateBlock(*block);
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_format_0_wrapper(QObject* cpp_object, int position, QTextFormat* returns)
    {
        *static_cast<QTextCharFormat*>(returns) = dynamic_cast<QAbstractTextDocumentLayoutDirector*>(cpp_object)->QAbstractTextDocumentLayout::format(position);
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractTextDocumentLayoutDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractTextDocumentLayoutDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QAbstractTextDocumentLayout_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QAbstractTextDocumentLayoutDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QAbstractTextDocumentLayout_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QAbstractTextDocumentLayoutDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QAbstractTextDocumentLayout_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QAbstractTextDocumentLayout*>(cpp_this)->QAbstractTextDocumentLayout::qt_metacast(name);
    }

    int __Qt4Ada_QAbstractTextDocumentLayout_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QAbstractTextDocumentLayout*>(cpp_this)->QAbstractTextDocumentLayout::qt_metacall(_c, _id, _a);
    }

}

QRectF QAbstractTextDocumentLayoutDirector::blockBoundingRect(const QTextBlock& block) const
{
    QRectF *aux = __Qt4Ada_QAbstractTextDocumentLayout_blockBoundingRect_0_dispatch(this->ada_object, &block);
    QRectF returns = *aux;
    delete aux;
    return returns;
}

QSizeF QAbstractTextDocumentLayoutDirector::documentSize() const
{
    QSizeF *aux = __Qt4Ada_QAbstractTextDocumentLayout_documentSize_0_dispatch(this->ada_object);
    QSizeF returns = *aux;
    delete aux;
    return returns;
}

QRectF QAbstractTextDocumentLayoutDirector::frameBoundingRect(QTextFrame* frame) const
{
    QRectF *aux = __Qt4Ada_QAbstractTextDocumentLayout_frameBoundingRect_0_dispatch(this->ada_object, frame);
    QRectF returns = *aux;
    delete aux;
    return returns;
}

int QAbstractTextDocumentLayoutDirector::hitTest(const QPointF& point, Qt::HitTestAccuracy accuracy) const
{
    return __Qt4Ada_QAbstractTextDocumentLayout_hitTest_0_dispatch(this->ada_object, &point, accuracy);
}

int QAbstractTextDocumentLayoutDirector::pageCount() const
{
    return __Qt4Ada_QAbstractTextDocumentLayout_pageCount_0_dispatch(this->ada_object);
}

void QAbstractTextDocumentLayoutDirector::documentChanged(int from, int charsRemoved, int charsAdded)
{
    __Qt4Ada_QAbstractTextDocumentLayout_documentChanged_0_dispatch(this->ada_object, from, charsRemoved, charsAdded);
}

bool QAbstractTextDocumentLayoutDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QAbstractTextDocumentLayoutDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QAbstractTextDocumentLayoutDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QAbstractTextDocumentLayoutDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QAbstractTextDocumentLayoutDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QAbstractTextDocumentLayoutDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QAbstractTextDocumentLayoutDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QAbstractTextDocumentLayoutDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
