//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QChildEvent>
#include <QTimerEvent>

#include "qapplicationdirector.h"
#include "qcoreapplicationdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QApplication_staticMetaObject =
        &QApplication::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QApplication_isSessionRestored_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QApplication*>(cpp_object)->QApplication::isSessionRestored();
    }

    void __Qt4Ada_QApplication_sessionId_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QApplication*>(cpp_object)->QApplication::sessionId();
    }

    void __Qt4Ada_QApplication_sessionKey_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QApplication*>(cpp_object)->QApplication::sessionKey();
    }

    void __Qt4Ada_QApplication_styleSheet_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QApplication*>(cpp_object)->QApplication::styleSheet();
    }

    void __Qt4Ada_QApplication_aboutQt_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QApplication*>(cpp_object)->QApplication::aboutQt();
    }

    void __Qt4Ada_QApplication_closeAllWindows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QApplication*>(cpp_object)->QApplication::closeAllWindows();
    }

    void __Qt4Ada_QApplication_setStyleSheet_0_wrapper(QObject* cpp_object, const QString* sheet)
    {
        dynamic_cast<QApplication*>(cpp_object)->QApplication::setStyleSheet(*sheet);
    }

    bool __Qt4Ada_QApplication_notify_0_wrapper(QObject* cpp_object, QObject* receiver, QEvent* event)
    {
        return dynamic_cast<QApplication*>(cpp_object)->QApplication::notify(receiver, event);
    }

    bool __Qt4Ada_QApplication_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QApplicationDirector*>(cpp_object)->QApplication::event(e);
    }

    void __Qt4Ada_QApplication_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QApplicationDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QApplication_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QApplicationDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QApplication_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QApplicationDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QApplication_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QApplicationDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QApplication_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QApplication*>(cpp_this)->QApplication::qt_metacast(name);
    }

    int __Qt4Ada_QApplication_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QApplication*>(cpp_this)->QApplication::qt_metacall(_c, _id, _a);
    }

}

bool QApplicationDirector::notify(QObject* receiver, QEvent* event)
{
    return __Qt4Ada_QCoreApplication_notify_0_dispatch(this->ada_object, receiver, event);
}

bool QApplicationDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QApplicationDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QApplicationDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QApplicationDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QApplicationDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QApplicationDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QApplicationDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QApplicationDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QStyle>
#include <QSessionManager>

#include "qobjectdirector.h"
#include "qcoreapplicationdirector.h"
#include "qapplicationdirector.h"

void QApplicationDirector::commitData(QSessionManager&_p1)
{
    __Qt4Ada_QApplication_commitData_dispatch(this->ada_object,&_p1);
}

void QApplicationDirector::saveState(QSessionManager&_p1)
{
    __Qt4Ada_QApplication_saveState_dispatch(this->ada_object,&_p1);
}

bool QApplicationDirector::compressEvent(QEvent*_p1,QObject*_p2,QPostEventList*_p3)
{
    return __Qt4Ada_QCoreApplication_compressEvent_dispatch(this->ada_object,_p1,_p2,_p3);
}

void QApplicationDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QApplicationDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    int __Qt4Ada_QApplication_exec_wrapper()
    {
        return QApplication::exec();
    }

    void __Qt4Ada_QApplication_commitData_virtual(QObject*cpp_this,QObject&_p1)
    {
    (dynamic_cast<QApplication*>(cpp_this))->commitData(dynamic_cast<QSessionManager&>(_p1));
    }

    void __Qt4Ada_QApplication_saveState_virtual(QObject*cpp_this,QObject&_p1)
    {
    (dynamic_cast<QApplication*>(cpp_this))->saveState(dynamic_cast<QSessionManager&>(_p1));
    }

    void __Qt4Ada_QApplication_commitData_wrapper(QObject*cpp_this,QObject&_p1)
    {
    (dynamic_cast<QApplication*>(cpp_this))->QApplication::commitData(dynamic_cast<QSessionManager&>(_p1));
    }

    void __Qt4Ada_QApplication_saveState_wrapper(QObject*cpp_this,QObject&_p1)
    {
    (dynamic_cast<QApplication*>(cpp_this))->QApplication::saveState(dynamic_cast<QSessionManager&>(_p1));
    }

    bool __Qt4Ada_QApplication_compressEvent_wrapper(QObject*cpp_this,QEvent*_p1,QObject*_p2,QPostEventList*_p3)
    {
        return (dynamic_cast<QApplicationDirector*>(cpp_this))->QApplication::compressEvent(_p1,_p2,_p3);
    }

    void __Qt4Ada_QApplication_setOverrideCursor_wrapper(const QCursor* cursor)
    {
        QApplication::setOverrideCursor (*cursor);
    }

    void __Qt4Ada_QApplication_restoreOverrideCursor_wrapper()
    {
        QApplication::restoreOverrideCursor();
    }

    void __QtAda_QApplication_setStyle_QStyleP_wrapper(QObject* style)
    {
        QApplication::setStyle(dynamic_cast<QStyle*>(style));
    }

    QObject* __QtAda_QApplication_setStyle_QStringCR_wrapper(const QString* style)
    {
        return dynamic_cast<QObject*>(QApplication::setStyle(*style));
    }

    QObject* __QtAda_QApplication_style_wrapper()
    {
        return dynamic_cast<QObject*>(QApplication::style());
    }

}
