//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QCompleter>
#include <QString>
#include <QSize>
#include <QAbstractItemDelegate>
#include <QIcon>
#include <QLineEdit>
#include <QAbstractItemModel>
#include <QModelIndex>
#include <QValidator>
#include <QAbstractItemView>
#include <QContextMenuEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QVariant>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QWheelEvent>
#include <QActionEvent>
#include <QCloseEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qcomboboxdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QComboBox_staticMetaObject =
        &QComboBox::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QComboBox_hidePopup_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QComboBox*>(cpp_object)->hidePopup();
    }

    void __Qt4Ada_QComboBox_showPopup_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QComboBox*>(cpp_object)->showPopup();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QComboBox_addItem_1_wrapper(QObject* cpp_object, const QString* text, const QVariant* userData)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::addItem(*text, *userData);
    }

    void __Qt4Ada_QComboBox_addItem_0_wrapper(QObject* cpp_object, const QIcon* icon, const QString* text, const QVariant* userData)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::addItem(*icon, *text, *userData);
    }

    void __Qt4Ada_QComboBox_addItems_0_wrapper(QObject* cpp_object, const QStringList* texts)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::addItems(*texts);
    }

    QObject* __Qt4Ada_QComboBox_completer_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QComboBox*>(cpp_object)->QComboBox::completer());
    }

    int __Qt4Ada_QComboBox_count_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBox*>(cpp_object)->QComboBox::count();
    }

    int __Qt4Ada_QComboBox_currentIndex_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBox*>(cpp_object)->QComboBox::currentIndex();
    }

    void __Qt4Ada_QComboBox_currentText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QComboBox*>(cpp_object)->QComboBox::currentText();
    }

    bool __Qt4Ada_QComboBox_duplicatesEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBox*>(cpp_object)->QComboBox::duplicatesEnabled();
    }

    bool __Qt4Ada_QComboBox_hasFrame_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBox*>(cpp_object)->QComboBox::hasFrame();
    }

    void __Qt4Ada_QComboBox_hidePopup_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::hidePopup();
    }

    void __Qt4Ada_QComboBox_iconSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QComboBox*>(cpp_object)->QComboBox::iconSize();
    }

    void __Qt4Ada_QComboBox_insertItem_1_wrapper(QObject* cpp_object, int index, const QString* text, const QVariant* userData)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::insertItem(index, *text, *userData);
    }

    void __Qt4Ada_QComboBox_insertItem_0_wrapper(QObject* cpp_object, int index, const QIcon* icon, const QString* text, const QVariant* userData)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::insertItem(index, *icon, *text, *userData);
    }

    bool __Qt4Ada_QComboBox_isEditable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBox*>(cpp_object)->QComboBox::isEditable();
    }

    QObject* __Qt4Ada_QComboBox_itemDelegate_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QComboBox*>(cpp_object)->QComboBox::itemDelegate());
    }

    void __Qt4Ada_QComboBox_itemIcon_0_wrapper(QObject* cpp_object, int index, QIcon* returns)
    {
        *returns = dynamic_cast<QComboBox*>(cpp_object)->QComboBox::itemIcon(index);
    }

    void __Qt4Ada_QComboBox_itemText_0_wrapper(QObject* cpp_object, int index, QString* returns)
    {
        *returns = dynamic_cast<QComboBox*>(cpp_object)->QComboBox::itemText(index);
    }

    QObject* __Qt4Ada_QComboBox_lineEdit_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QComboBox*>(cpp_object)->QComboBox::lineEdit());
    }

    int __Qt4Ada_QComboBox_maxCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBox*>(cpp_object)->QComboBox::maxCount();
    }

    int __Qt4Ada_QComboBox_maxVisibleItems_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBox*>(cpp_object)->QComboBox::maxVisibleItems();
    }

    int __Qt4Ada_QComboBox_minimumContentsLength_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBox*>(cpp_object)->QComboBox::minimumContentsLength();
    }

    QObject* __Qt4Ada_QComboBox_model_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QComboBox*>(cpp_object)->QComboBox::model());
    }

    int __Qt4Ada_QComboBox_modelColumn_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBox*>(cpp_object)->QComboBox::modelColumn();
    }

    void __Qt4Ada_QComboBox_removeItem_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::removeItem(index);
    }

    void __Qt4Ada_QComboBox_rootModelIndex_0_wrapper(QObject* cpp_object, QModelIndex* returns)
    {
        *returns = dynamic_cast<QComboBox*>(cpp_object)->QComboBox::rootModelIndex();
    }

    void __Qt4Ada_QComboBox_setCompleter_0_wrapper(QObject* cpp_object, QObject* c)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setCompleter(dynamic_cast<QCompleter*>(c));
    }

    void __Qt4Ada_QComboBox_setDuplicatesEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setDuplicatesEnabled(enable);
    }

    void __Qt4Ada_QComboBox_setEditable_0_wrapper(QObject* cpp_object, bool editable)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setEditable(editable);
    }

    void __Qt4Ada_QComboBox_setFrame_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setFrame(enable);
    }

    void __Qt4Ada_QComboBox_setItemDelegate_0_wrapper(QObject* cpp_object, QObject* delegate)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setItemDelegate(dynamic_cast<QAbstractItemDelegate*>(delegate));
    }

    void __Qt4Ada_QComboBox_setIconSize_0_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setIconSize(*size);
    }

    void __Qt4Ada_QComboBox_setItemIcon_0_wrapper(QObject* cpp_object, int index, const QIcon* icon)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setItemIcon(index, *icon);
    }

    void __Qt4Ada_QComboBox_setItemText_0_wrapper(QObject* cpp_object, int index, const QString* text)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setItemText(index, *text);
    }

    void __Qt4Ada_QComboBox_setLineEdit_0_wrapper(QObject* cpp_object, QObject* edit)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setLineEdit(dynamic_cast<QLineEdit*>(edit));
    }

    void __Qt4Ada_QComboBox_setMaxCount_0_wrapper(QObject* cpp_object, int max)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setMaxCount(max);
    }

    void __Qt4Ada_QComboBox_setMaxVisibleItems_0_wrapper(QObject* cpp_object, int maxItems)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setMaxVisibleItems(maxItems);
    }

    void __Qt4Ada_QComboBox_setMinimumContentsLength_0_wrapper(QObject* cpp_object, int characters)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setMinimumContentsLength(characters);
    }

    void __Qt4Ada_QComboBox_setModel_0_wrapper(QObject* cpp_object, QObject* model)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setModel(dynamic_cast<QAbstractItemModel*>(model));
    }

    void __Qt4Ada_QComboBox_setModelColumn_0_wrapper(QObject* cpp_object, int visibleColumn)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setModelColumn(visibleColumn);
    }

    void __Qt4Ada_QComboBox_setRootModelIndex_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setRootModelIndex(*index);
    }

    void __Qt4Ada_QComboBox_setValidator_0_wrapper(QObject* cpp_object, const QObject* v)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setValidator(dynamic_cast<const QValidator*>(v));
    }

    void __Qt4Ada_QComboBox_setView_0_wrapper(QObject* cpp_object, QObject* itemView)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setView(dynamic_cast<QAbstractItemView*>(itemView));
    }

    void __Qt4Ada_QComboBox_showPopup_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::showPopup();
    }

    const QObject* __Qt4Ada_QComboBox_validator_0_wrapper(QObject* cpp_object)
    {
        return static_cast<const QObject*>(dynamic_cast<QComboBox*>(cpp_object)->QComboBox::validator());
    }

    QObject* __Qt4Ada_QComboBox_view_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QComboBox*>(cpp_object)->QComboBox::view());
    }

    void __Qt4Ada_QComboBox_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QComboBox*>(cpp_object)->QComboBox::minimumSizeHint();
    }

    void __Qt4Ada_QComboBox_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QComboBox*>(cpp_object)->QComboBox::sizeHint();
    }

    bool __Qt4Ada_QComboBox_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QComboBox*>(cpp_object)->QComboBox::event(e);
    }

    void __Qt4Ada_QComboBox_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::clear();
    }

    void __Qt4Ada_QComboBox_clearEditText_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::clearEditText();
    }

    void __Qt4Ada_QComboBox_setCurrentIndex_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setCurrentIndex(index);
    }

    void __Qt4Ada_QComboBox_setEditText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QComboBox*>(cpp_object)->QComboBox::setEditText(*text);
    }

    void __Qt4Ada_QComboBox_activated_1_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::activated(index);
    }

    void __Qt4Ada_QComboBox_activated_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::activated(*text);
    }

    void __Qt4Ada_QComboBox_currentIndexChanged_1_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::currentIndexChanged(index);
    }

    void __Qt4Ada_QComboBox_currentIndexChanged_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::currentIndexChanged(*text);
    }

    void __Qt4Ada_QComboBox_editTextChanged_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::editTextChanged(*text);
    }

    void __Qt4Ada_QComboBox_highlighted_1_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::highlighted(index);
    }

    void __Qt4Ada_QComboBox_highlighted_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::highlighted(*text);
    }

    void __Qt4Ada_QComboBox_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::changeEvent(event);
    }

    void __Qt4Ada_QComboBox_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QComboBox_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QComboBox_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QComboBox_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QComboBox_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QComboBox_inputMethodQuery_0_wrapper(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::inputMethodQuery(query);
    }

    void __Qt4Ada_QComboBox_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QComboBox_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QComboBox_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QComboBox_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QComboBox_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QComboBox_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QComboBox_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QComboBox_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QComboBox::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QComboBox_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QComboBox_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QComboBox_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QComboBox_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QComboBox_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QComboBox_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QComboBox_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QComboBox_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QComboBox_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QComboBox_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QComboBox_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QComboBox_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QComboBox_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QComboBox_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QComboBox_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QComboBox_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QComboBox_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QComboBox_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QComboBoxDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QComboBox_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QComboBox_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QComboBox_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QComboBoxDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QComboBox_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QComboBoxDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QComboBox_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QComboBox*>(cpp_this)->QComboBox::qt_metacast(name);
    }

    int __Qt4Ada_QComboBox_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QComboBox*>(cpp_this)->QComboBox::qt_metacall(_c, _id, _a);
    }

}

void QComboBoxDirector::hidePopup()
{
    __Qt4Ada_QComboBox_hidePopup_0_dispatch(this->ada_object);
}

void QComboBoxDirector::showPopup()
{
    __Qt4Ada_QComboBox_showPopup_0_dispatch(this->ada_object);
}

QSize QComboBoxDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QComboBoxDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QComboBoxDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QComboBoxDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

QVariant QComboBoxDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QComboBoxDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QComboBoxDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QComboBoxDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QComboBoxDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QComboBoxDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QComboBoxDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QComboBoxDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QComboBoxDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QComboBoxDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QComboBoxDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QComboBoxDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QComboBoxDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QComboBoxDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QPaintEngine*QComboBoxDirector::paintEngine()
{
    return __Qt4Ada_QPaintDevice_paintEngine_dispatch(this->ada_object);
}

void QComboBoxDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QComboBoxDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    QObject * __Qt4Ada_new_QComboBox (QObject * parent)
    {
       return dynamic_cast<QObject *>(new QComboBox (dynamic_cast <QWidget*> (parent)));
    }

    QPaintEngine*__Qt4Ada_QComboBox_paintEngine_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QComboBox*>(cpp_this))->QComboBox::paintEngine();
    }

    bool __Qt4Ada_QComboBox_eventFilter_wrapper(QObject*cpp_this,QObject*_p1,QEvent*_p2)
    {
        return (dynamic_cast<QComboBox*>(cpp_this))->QComboBox::eventFilter(_p1,_p2);
    }

    void __Qt4Ada_QComboBox_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QComboBoxDirector*>(cpp_this))->QComboBox::connectNotify(_p1);
    }

    void __Qt4Ada_QComboBox_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QComboBoxDirector*>(cpp_this))->QComboBox::disconnectNotify(_p1);
    }

    int __Qt4Ada_QComboBox_findText_wrapper(QObject* cpp_object, const QString* text, unsigned flags)
    {
	return dynamic_cast<QComboBox*>(cpp_object)->findText (*text, static_cast<Qt::MatchFlags>(flags));
    }
}
