//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QDate>
#include <QDateTime>
#include <QString>
#include <QTime>
#include <QSize>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTimerEvent>
#include <QWheelEvent>
#include <QVariant>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qdatetimeeditdirector.h"
#include "qabstractspinboxdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QDateTimeEdit_staticMetaObject =
        &QDateTimeEdit::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QDateTimeEdit_calendarPopup_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::calendarPopup();
    }

    void __Qt4Ada_QDateTimeEdit_clearMaximumDate_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::clearMaximumDate();
    }

    void __Qt4Ada_QDateTimeEdit_clearMaximumDateTime_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::clearMaximumDateTime();
    }

    void __Qt4Ada_QDateTimeEdit_clearMaximumTime_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::clearMaximumTime();
    }

    void __Qt4Ada_QDateTimeEdit_clearMinimumDate_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::clearMinimumDate();
    }

    void __Qt4Ada_QDateTimeEdit_clearMinimumDateTime_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::clearMinimumDateTime();
    }

    void __Qt4Ada_QDateTimeEdit_clearMinimumTime_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::clearMinimumTime();
    }

    int __Qt4Ada_QDateTimeEdit_currentSectionIndex_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::currentSectionIndex();
    }

    void __Qt4Ada_QDateTimeEdit_date_0_wrapper(QObject* cpp_object, QDate* returns)
    {
        *returns = dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::date();
    }

    void __Qt4Ada_QDateTimeEdit_dateTime_0_wrapper(QObject* cpp_object, QDateTime* returns)
    {
        *returns = dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::dateTime();
    }

    void __Qt4Ada_QDateTimeEdit_displayFormat_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::displayFormat();
    }

    void __Qt4Ada_QDateTimeEdit_maximumDate_0_wrapper(QObject* cpp_object, QDate* returns)
    {
        *returns = dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::maximumDate();
    }

    void __Qt4Ada_QDateTimeEdit_maximumDateTime_0_wrapper(QObject* cpp_object, QDateTime* returns)
    {
        *returns = dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::maximumDateTime();
    }

    void __Qt4Ada_QDateTimeEdit_maximumTime_0_wrapper(QObject* cpp_object, QTime* returns)
    {
        *returns = dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::maximumTime();
    }

    void __Qt4Ada_QDateTimeEdit_minimumDate_0_wrapper(QObject* cpp_object, QDate* returns)
    {
        *returns = dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::minimumDate();
    }

    void __Qt4Ada_QDateTimeEdit_minimumDateTime_0_wrapper(QObject* cpp_object, QDateTime* returns)
    {
        *returns = dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::minimumDateTime();
    }

    void __Qt4Ada_QDateTimeEdit_minimumTime_0_wrapper(QObject* cpp_object, QTime* returns)
    {
        *returns = dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::minimumTime();
    }

    int __Qt4Ada_QDateTimeEdit_sectionCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::sectionCount();
    }

    void __Qt4Ada_QDateTimeEdit_setCalendarPopup_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setCalendarPopup(enable);
    }

    void __Qt4Ada_QDateTimeEdit_setCurrentSectionIndex_0_wrapper(QObject* cpp_object, int index)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setCurrentSectionIndex(index);
    }

    void __Qt4Ada_QDateTimeEdit_setDateRange_0_wrapper(QObject* cpp_object, const QDate* mix, const QDate* max)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setDateRange(*mix, *max);
    }

    void __Qt4Ada_QDateTimeEdit_setDateTimeRange_0_wrapper(QObject* cpp_object, const QDateTime* mix, const QDateTime* max)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setDateTimeRange(*mix, *max);
    }

    void __Qt4Ada_QDateTimeEdit_setDisplayFormat_0_wrapper(QObject* cpp_object, const QString* format)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setDisplayFormat(*format);
    }

    void __Qt4Ada_QDateTimeEdit_setMaximumDate_0_wrapper(QObject* cpp_object, const QDate* max)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setMaximumDate(*max);
    }

    void __Qt4Ada_QDateTimeEdit_setMaximumDateTime_0_wrapper(QObject* cpp_object, const QDateTime* max)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setMaximumDateTime(*max);
    }

    void __Qt4Ada_QDateTimeEdit_setMaximumTime_0_wrapper(QObject* cpp_object, const QTime* max)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setMaximumTime(*max);
    }

    void __Qt4Ada_QDateTimeEdit_setMinimumDate_0_wrapper(QObject* cpp_object, const QDate* min)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setMinimumDate(*min);
    }

    void __Qt4Ada_QDateTimeEdit_setMinimumDateTime_0_wrapper(QObject* cpp_object, const QDateTime* min)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setMinimumDateTime(*min);
    }

    void __Qt4Ada_QDateTimeEdit_setMinimumTime_0_wrapper(QObject* cpp_object, const QTime* min)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setMinimumTime(*min);
    }

    void __Qt4Ada_QDateTimeEdit_setTimeRange_0_wrapper(QObject* cpp_object, const QTime* mix, const QTime* max)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setTimeRange(*mix, *max);
    }

    void __Qt4Ada_QDateTimeEdit_setTimeSpec_0_wrapper(QObject* cpp_object, Qt::TimeSpec spec)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setTimeSpec(spec);
    }

    void __Qt4Ada_QDateTimeEdit_time_0_wrapper(QObject* cpp_object, QTime* returns)
    {
        *returns = dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::time();
    }

    Qt::TimeSpec __Qt4Ada_QDateTimeEdit_timeSpec_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::timeSpec();
    }

    void __Qt4Ada_QDateTimeEdit_setDate_0_wrapper(QObject* cpp_object, const QDate* date)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setDate(*date);
    }

    void __Qt4Ada_QDateTimeEdit_setDateTime_0_wrapper(QObject* cpp_object, const QDateTime* dateTime)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setDateTime(*dateTime);
    }

    void __Qt4Ada_QDateTimeEdit_setTime_0_wrapper(QObject* cpp_object, const QTime* time)
    {
        dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::setTime(*time);
    }

    void __Qt4Ada_QDateTimeEdit_dateChanged_0_wrapper(QObject* cpp_object, const QDate* date)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QDateTimeEdit::dateChanged(*date);
    }

    void __Qt4Ada_QDateTimeEdit_dateTimeChanged_0_wrapper(QObject* cpp_object, const QDateTime* dateTime)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QDateTimeEdit::dateTimeChanged(*dateTime);
    }

    void __Qt4Ada_QDateTimeEdit_timeChanged_0_wrapper(QObject* cpp_object, const QTime* time)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QDateTimeEdit::timeChanged(*time);
    }

    bool __Qt4Ada_QDateTimeEdit_event_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QDateTimeEdit*>(cpp_object)->QDateTimeEdit::event(event);
    }

    QObject* __Qt4Ada_QDateTimeEdit_lineEdit_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::lineEdit());
    }

    void __Qt4Ada_QDateTimeEdit_setLineEdit_0_wrapper(QObject* cpp_object, QObject* edit)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::setLineEdit(dynamic_cast<QLineEdit*>(edit));
    }

    void __Qt4Ada_QDateTimeEdit_editingFinished_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::editingFinished();
    }

    void __Qt4Ada_QDateTimeEdit_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::changeEvent(event);
    }

    void __Qt4Ada_QDateTimeEdit_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QAbstractSpinBox::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QDateTimeEdit_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QDateTimeEdit_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QDateTimeEdit_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QDateTimeEdit_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QDateTimeEdit_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QDateTimeEdit_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QDateTimeEdit_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QDateTimeEdit_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QDateTimeEdit_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QDateTimeEdit_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QDateTimeEdit_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDateTimeEditDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QDateTimeEdit_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QDateTimeEdit*>(cpp_this)->QDateTimeEdit::qt_metacast(name);
    }

    int __Qt4Ada_QDateTimeEdit_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QDateTimeEdit*>(cpp_this)->QDateTimeEdit::qt_metacall(_c, _id, _a);
    }

}

bool QDateTimeEditDirector::event(QEvent* event)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::fixup(QString& input) const
{
    __Qt4Ada_QAbstractSpinBox_fixup_0_dispatch(this->ada_object, &input);
}

void QDateTimeEditDirector::stepBy(int steps)
{
    __Qt4Ada_QAbstractSpinBox_stepBy_0_dispatch(this->ada_object, steps);
}

QValidator::State QDateTimeEditDirector::validate(QString& input, int pos) const
{
    return __Qt4Ada_QAbstractSpinBox_validate_0_dispatch(this->ada_object, &input, pos);
}

QSize QDateTimeEditDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QDateTimeEditDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QDateTimeEditDirector::clear()
{
    __Qt4Ada_QAbstractSpinBox_clear_0_dispatch(this->ada_object);
}

void QDateTimeEditDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QDateTimeEditDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QDateTimeEditDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QDateTimeEditDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QDateTimeEditDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QDateTimeEditDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QDateTimeEditDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QDateTimeEditDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QDateTimeEditDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QDateTimeEditDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QDateTimeEditDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QDateTimeEditDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QDateTimeEditDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QDateTimeEditDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
