//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QDATETIMEEDITDIRECTOR_H__
#define __QDATETIMEEDITDIRECTOR_H__

#include <QDateTimeEdit>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QDateTimeEdit_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QDateTimeEdit_calendarPopup_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_clearMaximumDate_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_clearMaximumDateTime_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_clearMaximumTime_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_clearMinimumDate_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_clearMinimumDateTime_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_clearMinimumTime_0_wrapper(QObject*);
    extern int __Qt4Ada_QDateTimeEdit_currentSectionIndex_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_date_0_wrapper(QObject*, QDate*);
    extern void __Qt4Ada_QDateTimeEdit_dateTime_0_wrapper(QObject*, QDateTime*);
    extern void __Qt4Ada_QDateTimeEdit_displayFormat_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QDateTimeEdit_maximumDate_0_wrapper(QObject*, QDate*);
    extern void __Qt4Ada_QDateTimeEdit_maximumDateTime_0_wrapper(QObject*, QDateTime*);
    extern void __Qt4Ada_QDateTimeEdit_maximumTime_0_wrapper(QObject*, QTime*);
    extern void __Qt4Ada_QDateTimeEdit_minimumDate_0_wrapper(QObject*, QDate*);
    extern void __Qt4Ada_QDateTimeEdit_minimumDateTime_0_wrapper(QObject*, QDateTime*);
    extern void __Qt4Ada_QDateTimeEdit_minimumTime_0_wrapper(QObject*, QTime*);
    extern int __Qt4Ada_QDateTimeEdit_sectionCount_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_setCalendarPopup_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QDateTimeEdit_setCurrentSectionIndex_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QDateTimeEdit_setDateRange_0_wrapper(QObject*, const QDate*, const QDate*);
    extern void __Qt4Ada_QDateTimeEdit_setDateTimeRange_0_wrapper(QObject*, const QDateTime*, const QDateTime*);
    extern void __Qt4Ada_QDateTimeEdit_setDisplayFormat_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QDateTimeEdit_setMaximumDate_0_wrapper(QObject*, const QDate*);
    extern void __Qt4Ada_QDateTimeEdit_setMaximumDateTime_0_wrapper(QObject*, const QDateTime*);
    extern void __Qt4Ada_QDateTimeEdit_setMaximumTime_0_wrapper(QObject*, const QTime*);
    extern void __Qt4Ada_QDateTimeEdit_setMinimumDate_0_wrapper(QObject*, const QDate*);
    extern void __Qt4Ada_QDateTimeEdit_setMinimumDateTime_0_wrapper(QObject*, const QDateTime*);
    extern void __Qt4Ada_QDateTimeEdit_setMinimumTime_0_wrapper(QObject*, const QTime*);
    extern void __Qt4Ada_QDateTimeEdit_setTimeRange_0_wrapper(QObject*, const QTime*, const QTime*);
    extern void __Qt4Ada_QDateTimeEdit_setTimeSpec_0_wrapper(QObject*, Qt::TimeSpec);
    extern void __Qt4Ada_QDateTimeEdit_time_0_wrapper(QObject*, QTime*);
    extern Qt::TimeSpec __Qt4Ada_QDateTimeEdit_timeSpec_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_setDate_0_wrapper(QObject*, const QDate*);
    extern void __Qt4Ada_QDateTimeEdit_setDateTime_0_wrapper(QObject*, const QDateTime*);
    extern void __Qt4Ada_QDateTimeEdit_setTime_0_wrapper(QObject*, const QTime*);
    extern void __Qt4Ada_QDateTimeEdit_dateChanged_0_wrapper(QObject*, const QDate*);
    extern void __Qt4Ada_QDateTimeEdit_dateTimeChanged_0_wrapper(QObject*, const QDateTime*);
    extern void __Qt4Ada_QDateTimeEdit_timeChanged_0_wrapper(QObject*, const QTime*);
    extern bool __Qt4Ada_QDateTimeEdit_event_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QDateTimeEdit_lineEdit_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_setLineEdit_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QDateTimeEdit_editingFinished_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QDateTimeEdit_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QDateTimeEdit_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QDateTimeEdit_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QDateTimeEdit_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QDateTimeEdit_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QDateTimeEdit_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QDateTimeEdit_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QDateTimeEdit_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QDateTimeEdit_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QDateTimeEdit_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QDateTimeEdit_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
#include <QLineEdit>

class QDateTimeEditDirector : public QDateTimeEdit
{
protected:
    void* ada_object;
   QDateTimeEditDirector();

    virtual bool event(QEvent*);
    virtual void fixup(QString&) const;
    virtual void stepBy(int);
    virtual QValidator::State validate(QString&, int) const;
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void clear();
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QDateTimeEdit_dateChanged_0_wrapper(QObject*, const QDate*);
    friend void __Qt4Ada_QDateTimeEdit_dateTimeChanged_0_wrapper(QObject*, const QDateTime*);
    friend void __Qt4Ada_QDateTimeEdit_timeChanged_0_wrapper(QObject*, const QTime*);
    friend QObject* __Qt4Ada_QDateTimeEdit_lineEdit_0_wrapper(QObject*);
    friend void __Qt4Ada_QDateTimeEdit_setLineEdit_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QDateTimeEdit_editingFinished_0_wrapper(QObject*);
    friend void __Qt4Ada_QDateTimeEdit_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QDateTimeEdit_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QDateTimeEdit_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QDateTimeEdit_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend bool __Qt4Ada_QDateTimeEdit_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QDateTimeEdit_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QDateTimeEdit_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QDateTimeEdit_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QDateTimeEdit_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QDateTimeEdit_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QDateTimeEdit_sender_0_wrapper(QObject*);
};

#endif // __QDATETIMEEDITDIRECTOR_H__
