//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QAbstractButton>
#include <QPushButton>
#include <QVariant>
#include <QSize>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qdialogbuttonboxdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QDialogButtonBox_staticMetaObject =
        &QDialogButtonBox::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QDialogButtonBox_addButton_2_wrapper(QObject* cpp_object, QObject* button, QDialogButtonBox::ButtonRole role)
    {
        dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::addButton(dynamic_cast<QAbstractButton*>(button), role);
    }

    QObject* __Qt4Ada_QDialogButtonBox_addButton_1_wrapper(QObject* cpp_object, const QString* text, QDialogButtonBox::ButtonRole role)
    {
        return static_cast<QObject*>(dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::addButton(*text, role));
    }

    QObject* __Qt4Ada_QDialogButtonBox_addButton_0_wrapper(QObject* cpp_object, QDialogButtonBox::StandardButton button)
    {
        return static_cast<QObject*>(dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::addButton(button));
    }

    QObject* __Qt4Ada_QDialogButtonBox_button_0_wrapper(QObject* cpp_object, QDialogButtonBox::StandardButton which)
    {
        return static_cast<QObject*>(dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::button(which));
    }

    QDialogButtonBox::ButtonRole __Qt4Ada_QDialogButtonBox_buttonRole_0_wrapper(QObject* cpp_object, QObject* button)
    {
        return dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::buttonRole(dynamic_cast<QAbstractButton*>(button));
    }

    bool __Qt4Ada_QDialogButtonBox_centerButtons_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::centerButtons();
    }

    void __Qt4Ada_QDialogButtonBox_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::clear();
    }

    Qt::Orientation __Qt4Ada_QDialogButtonBox_orientation_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::orientation();
    }

    void __Qt4Ada_QDialogButtonBox_removeButton_0_wrapper(QObject* cpp_object, QObject* button)
    {
        dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::removeButton(dynamic_cast<QAbstractButton*>(button));
    }

    void __Qt4Ada_QDialogButtonBox_setCenterButtons_0_wrapper(QObject* cpp_object, bool center)
    {
        dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::setCenterButtons(center);
    }

    void __Qt4Ada_QDialogButtonBox_setOrientation_0_wrapper(QObject* cpp_object, Qt::Orientation orientation)
    {
        dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::setOrientation(orientation);
    }

    QDialogButtonBox::StandardButton __Qt4Ada_QDialogButtonBox_standardButton_0_wrapper(QObject* cpp_object, QObject* button)
    {
        return dynamic_cast<QDialogButtonBox*>(cpp_object)->QDialogButtonBox::standardButton(dynamic_cast<QAbstractButton*>(button));
    }

    void __Qt4Ada_QDialogButtonBox_accepted_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QDialogButtonBox::accepted();
    }

    void __Qt4Ada_QDialogButtonBox_clicked_0_wrapper(QObject* cpp_object, QObject* button)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QDialogButtonBox::clicked(dynamic_cast<QAbstractButton*>(button));
    }

    void __Qt4Ada_QDialogButtonBox_helpRequested_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QDialogButtonBox::helpRequested();
    }

    void __Qt4Ada_QDialogButtonBox_rejected_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QDialogButtonBox::rejected();
    }

    bool __Qt4Ada_QDialogButtonBox_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QDialogButtonBox::event(e);
    }

    void __Qt4Ada_QDialogButtonBox_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QDialogButtonBox::changeEvent(event);
    }

    void __Qt4Ada_QDialogButtonBox_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QDialogButtonBox_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QDialogButtonBox_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QDialogButtonBox_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QDialogButtonBox_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QDialogButtonBox_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QDialogButtonBox_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QDialogButtonBox_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QDialogButtonBox_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QDialogButtonBox_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QDialogButtonBox_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QDialogButtonBox_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QDialogButtonBox_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QDialogButtonBox_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QDialogButtonBox_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDialogButtonBoxDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QDialogButtonBox_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QDialogButtonBox*>(cpp_this)->QDialogButtonBox::qt_metacast(name);
    }

    int __Qt4Ada_QDialogButtonBox_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QDialogButtonBox*>(cpp_this)->QDialogButtonBox::qt_metacall(_c, _id, _a);
    }

}

bool QDialogButtonBoxDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QDialogButtonBoxDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QDialogButtonBoxDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QDialogButtonBoxDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QDialogButtonBoxDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QDialogButtonBoxDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QDialogButtonBoxDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QDialogButtonBoxDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QDialogButtonBoxDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QDialogButtonBoxDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QDialogButtonBoxDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QDialogButtonBoxDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QDialogButtonBoxDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QDialogButtonBoxDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QDialogButtonBoxDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QDialogButtonBoxDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QDialogButtonBoxDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QDialogButtonBoxDirector::QDialogButtonBoxDirector(void* o, Qt::Orientation orientation, QObject* parent) :
    QDialogButtonBox(orientation, dynamic_cast<QWidget*>(parent)),
    ada_object(o)
{
}

extern "C" {

    QObject* __Qt4Ada_new_QDialogButtonBox(unsigned orientation, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QDialogButtonBox(static_cast<Qt::Orientation>(orientation), dynamic_cast<QWidget*>(parent)));
    }

    QObject* __Qt4Ada_new_QDialogButtonBoxDirector(void* ada_object, unsigned orientation, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QDialogButtonBoxDirector(ada_object, static_cast<Qt::Orientation>(orientation), dynamic_cast<QWidget*>(parent)));
    }

}
