//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QAction>
#include <QCloseEvent>
#include <QPaintEvent>
#include <QVariant>
#include <QSize>
#include <QActionEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qdockwidgetdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QDockWidget_staticMetaObject =
        &QDockWidget::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QDockWidget_isFloating_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDockWidget*>(cpp_object)->QDockWidget::isFloating();
    }

    void __Qt4Ada_QDockWidget_setFloating_0_wrapper(QObject* cpp_object, bool floating)
    {
        dynamic_cast<QDockWidget*>(cpp_object)->QDockWidget::setFloating(floating);
    }

    void __Qt4Ada_QDockWidget_setTitleBarWidget_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QDockWidget*>(cpp_object)->QDockWidget::setTitleBarWidget(dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QDockWidget_setWidget_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QDockWidget*>(cpp_object)->QDockWidget::setWidget(dynamic_cast<QWidget*>(widget));
    }

    QObject* __Qt4Ada_QDockWidget_titleBarWidget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QDockWidget*>(cpp_object)->QDockWidget::titleBarWidget());
    }

    QObject* __Qt4Ada_QDockWidget_toggleViewAction_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QDockWidget*>(cpp_object)->QDockWidget::toggleViewAction());
    }

    QObject* __Qt4Ada_QDockWidget_widget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QDockWidget*>(cpp_object)->QDockWidget::widget());
    }

    void __Qt4Ada_QDockWidget_topLevelChanged_0_wrapper(QObject* cpp_object, bool topLevel)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QDockWidget::topLevelChanged(topLevel);
    }

    void __Qt4Ada_QDockWidget_visibilityChanged_0_wrapper(QObject* cpp_object, bool visible)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QDockWidget::visibilityChanged(visible);
    }

    void __Qt4Ada_QDockWidget_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QDockWidget::changeEvent(event);
    }

    void __Qt4Ada_QDockWidget_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QDockWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    bool __Qt4Ada_QDockWidget_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QDockWidgetDirector*>(cpp_object)->QDockWidget::event(e);
    }

    void __Qt4Ada_QDockWidget_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QDockWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QDockWidget_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QDockWidget_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QDockWidget_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QDockWidget_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QDockWidget_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QDockWidget_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QDockWidget_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QDockWidget_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QDockWidget_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QDockWidget_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QDockWidgetDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QDockWidget_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QDockWidget_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QDockWidget_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QDockWidgetDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QDockWidget_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QDockWidgetDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QDockWidget_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QDockWidget*>(cpp_this)->QDockWidget::qt_metacast(name);
    }

    int __Qt4Ada_QDockWidget_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QDockWidget*>(cpp_this)->QDockWidget::qt_metacall(_c, _id, _a);
    }

}

void QDockWidgetDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

bool QDockWidgetDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QDockWidgetDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

int QDockWidgetDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QDockWidgetDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QDockWidgetDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QDockWidgetDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QDockWidgetDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QDockWidgetDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QDockWidgetDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QDockWidgetDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QDockWidgetDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QDockWidgetDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QDockWidgetDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QDockWidgetDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QDockWidgetDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QDockWidgetDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QDockWidgetDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QDockWidgetDirector::QDockWidgetDirector(void* o, QWidget* parent, Qt::WindowFlags flags) :
    QDockWidget(parent, flags),
    ada_object(o)
{
}

QDockWidgetDirector::QDockWidgetDirector(void* o, const QString& title, QWidget* parent, Qt::WindowFlags flags) :
    QDockWidget(title, parent, flags),
    ada_object(o)
{
}

extern "C" {

   QObject* __Qt4Ada_new_QDockWidget_with_QString (QString*title,QObject*parent,unsigned f)
   {
      return dynamic_cast<QObject*>(new QDockWidget (*title,
                                                     dynamic_cast<QWidget*>(parent),
                                                     (Qt::WindowFlags)f));
   }

   QObject* __Qt4Ada_new_QDockWidget (QObject*parent, unsigned f)
   {
      return dynamic_cast<QObject*>(new QDockWidget
(dynamic_cast<QWidget*>(parent),(Qt::WindowFlags)f));

   }

   QObject* __Qt4Ada_new_QDockWidgetDirector_1(void* ada_object, QObject* parent, unsigned flags)
    {
        return dynamic_cast<QObject*>
                 (new QDockWidgetDirector
                   (ada_object, dynamic_cast<QWidget*>(parent), (Qt::WindowFlags) flags));
    }

   QObject* __Qt4Ada_new_QDockWidgetDirector_2(void* ada_object, QString* title, QObject* parent, unsigned flags)
    {
        return dynamic_cast<QObject*>
                 (new QDockWidgetDirector
                   (ada_object, *title, dynamic_cast<QWidget*>(parent), (Qt::WindowFlags) flags));
    }

   void __Qt4Ada_QDockWidget_setAllowedAreas_wrapper (QObject*cpp_object, unsigned areas)
   {
      dynamic_cast<QDockWidget*>(cpp_object)->setAllowedAreas ((Qt::DockWidgetAreas)areas);
   }

   void __Qt4Ada_QDockWidget_setFeatures_wrapper (QObject*cpp_object, unsigned features)
   {
      dynamic_cast<QDockWidget*>(cpp_object)->setFeatures ((QDockWidget::DockWidgetFeatures)features);
   }

}
