//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QSize>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QKeyEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QVariant>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QPaintEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qfiledialogdirector.h"
#include "qdialogdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QFileDialog_staticMetaObject =
        &QFileDialog::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QFileDialog_confirmOverwrite_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::confirmOverwrite();
    }

    void __Qt4Ada_QFileDialog_defaultSuffix_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::defaultSuffix();
    }

    QFileDialog::FileMode __Qt4Ada_QFileDialog_fileMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::fileMode();
    }

    bool __Qt4Ada_QFileDialog_isReadOnly_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::isReadOnly();
    }

    bool __Qt4Ada_QFileDialog_resolveSymlinks_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::resolveSymlinks();
    }

    void __Qt4Ada_QFileDialog_selectFile_0_wrapper(QObject* cpp_object, const QString* filename)
    {
        dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::selectFile(*filename);
    }

    void __Qt4Ada_QFileDialog_selectFilter_0_wrapper(QObject* cpp_object, const QString* filter)
    {
        dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::selectFilter(*filter);
    }

    void __Qt4Ada_QFileDialog_selectedFilter_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::selectedFilter();
    }

    void __Qt4Ada_QFileDialog_setConfirmOverwrite_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::setConfirmOverwrite(enabled);
    }

    void __Qt4Ada_QFileDialog_setDefaultSuffix_0_wrapper(QObject* cpp_object, const QString* suffix)
    {
        dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::setDefaultSuffix(*suffix);
    }

    void __Qt4Ada_QFileDialog_setDirectory_0_wrapper(QObject* cpp_object, const QString* directory)
    {
        dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::setDirectory(*directory);
    }

    void __Qt4Ada_QFileDialog_setFileMode_0_wrapper(QObject* cpp_object, QFileDialog::FileMode mode)
    {
        dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::setFileMode(mode);
    }

    void __Qt4Ada_QFileDialog_setFilter_0_wrapper(QObject* cpp_object, const QString* filter)
    {
        dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::setFilter(*filter);
    }

    void __Qt4Ada_QFileDialog_setReadOnly_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::setReadOnly(enabled);
    }

    void __Qt4Ada_QFileDialog_setResolveSymlinks_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QFileDialog*>(cpp_object)->QFileDialog::setResolveSymlinks(enabled);
    }

    void __Qt4Ada_QFileDialog_currentChanged_0_wrapper(QObject* cpp_object, const QString* path)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QFileDialog::currentChanged(*path);
    }

    void __Qt4Ada_QFileDialog_accept_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QFileDialog::accept();
    }

    void __Qt4Ada_QFileDialog_done_0_wrapper(QObject* cpp_object, int result)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QFileDialog::done(result);
    }

    void __Qt4Ada_QFileDialog_accepted_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QDialog::accepted();
    }

    void __Qt4Ada_QFileDialog_finished_0_wrapper(QObject* cpp_object, int result)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QDialog::finished(result);
    }

    void __Qt4Ada_QFileDialog_rejected_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QDialog::rejected();
    }

    void __Qt4Ada_QFileDialog_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QDialog::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QDialog::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    bool __Qt4Ada_QFileDialog_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QFileDialogDirector*>(cpp_object)->QDialog::eventFilter(watched, event);
    }

    void __Qt4Ada_QFileDialog_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QDialog::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QDialog::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QDialog::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QFileDialog_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QFileDialog_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QFileDialog_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::event(e);
    }

    void __Qt4Ada_QFileDialog_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QFileDialog_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QFileDialog_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QFileDialog_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QFileDialog_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QFileDialog_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QFileDialog_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QFileDialog_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QFileDialog_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QFileDialogDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QFileDialog_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QFileDialog_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QFileDialog_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QFileDialogDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QFileDialog_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QFileDialogDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QFileDialog_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QFileDialog*>(cpp_this)->QFileDialog::qt_metacast(name);
    }

    int __Qt4Ada_QFileDialog_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QFileDialog*>(cpp_this)->QFileDialog::qt_metacall(_c, _id, _a);
    }

}

void QFileDialogDirector::accept()
{
    __Qt4Ada_QDialog_accept_0_dispatch(this->ada_object);
}

void QFileDialogDirector::done(int result)
{
    __Qt4Ada_QDialog_done_0_dispatch(this->ada_object, result);
}

void QFileDialogDirector::reject()
{
    __Qt4Ada_QDialog_reject_0_dispatch(this->ada_object);
}

QSize QFileDialogDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QFileDialogDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

QSize QFileDialogDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QFileDialogDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

bool QFileDialogDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QFileDialogDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

int QFileDialogDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QFileDialogDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QFileDialogDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QFileDialogDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QFileDialogDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QFileDialogDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QFileDialogDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QFileDialogDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

void QFileDialogDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QFileDialogDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QFileDialogDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QFileDialogDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QFileDialogDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C" {

    QObject* __QtAda_new_QFileDialog_QWidgetP_QtWindowFlags(QObject* parent, unsigned flags)
    {
        return new QFileDialog(dynamic_cast<QWidget*>(parent), (Qt::WindowFlags)flags);
    }

    QObject* __QtAda_new_QFileDialog_QWidgetP_QStringCR_QStringCR_QStringCR(QObject* parent, QString* caption, QString* directory, QString* filter)
    {
        return new QFileDialog(dynamic_cast<QWidget*>(parent), *caption, *directory, *filter);
    }

    void __QtAda_QFileDialog_selectedFiles_Q_wrapper(QObject* self, QStringList* returns)
    {
        *returns = dynamic_cast<QFileDialog*>(self)->QFileDialog::selectedFiles();
    }

    void __QtAda_QFileDialog_getExistingDirectory_wrapper(QObject* parent, QString* caption, QString* dir, unsigned options, QString* returns)
    {
        *returns = QFileDialog::getExistingDirectory(dynamic_cast<QFileDialog*>(parent), *caption, *dir, (QFileDialog::Options)options);
    }

    void __Qt4Ada_QMainWindow_getOpenFileName_wrapper (QObject* parent,
                                                       const QString* const caption,
                                                       const QString* const dir,
                                                       const QString* const filter,
                                                       QString* selectedFilter,
                                                       unsigned options,
                                                       QString* const out_str)
    {
        *out_str = QFileDialog::getOpenFileName(dynamic_cast <QWidget*>(parent),
                                                *caption,
                                                *dir,
                                                *filter,
                                                selectedFilter,
                                                (QFileDialog::Options) options);
    }

    void __Qt4Ada_QMainWindow_getSaveFileName_wrapper (QObject* parent,
                                                       const QString* const caption,
                                                       const QString* const dir,
                                                       const QString* const filter,
                                                       QString* selectedFilter,
                                                       unsigned options,
                                                       QString* const out_str)
    {
        *out_str = QFileDialog::getSaveFileName(dynamic_cast <QWidget*>(parent),
                                                *caption,
                                                *dir,
                                                *filter,
                                                selectedFilter,
                                                (QFileDialog::Options) options);
    }


}
