//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QRect>
#include <QString>
#include "qfontmetricswrapper.h"

extern "C"
{

    QFontMetrics* __QtAda_inititialize_QFontMetrics_QFontCR(void* storage, const QFont* font)
    {
        return new (storage) QFontMetrics(*font);
    }

    QFontMetrics* __QtAda_adjust_QFontMetrics(void* storage, const QFontMetrics* from)
    {
        return new (storage) QFontMetrics(*from);
    }

    void __QtAda_finalize_QFontMetrics(QFontMetrics *item)
    {
        item->~QFontMetrics();
    }

    int __QtAda_QFontMetrics_ascent_Q(const QFontMetrics* self)
    {
        return self->ascent();
    }

    int __QtAda_QFontMetrics_averageCharWidth_Q(const QFontMetrics* self)
    {
        return self->averageCharWidth();
    }

    void __QtAda_QFontMetrics_boundingRect_QChar_Q(QRect* returns, const QFontMetrics* self, QChar* ch)
    {
        *returns = self->boundingRect(*ch);
    }

    void __QtAda_QFontMetrics_boundingRect_QStringCR_Q(QRect* returns, const QFontMetrics* self, const QString* text)
    {
        *returns = self->boundingRect(*text);
    }

    int __QtAda_QFontMetrics_charWidth_QStringCR_int_Q(const QFontMetrics* self, const QString* str, int pos)
    {
        return self->charWidth(*str, pos);
    }

    int __QtAda_QFontMetrics_descent_Q(const QFontMetrics* self)
    {
        return self->descent();
    }

    int __QtAda_QFontMetrics_height_Q(const QFontMetrics* self)
    {
        return self->height();
    }

    unsigned __QtAda_QFontMetrics_inFont_QChar_Q(const QFontMetrics* self, QChar* ch)
    {
        return (unsigned)self->inFont(*ch);
    }

    int __QtAda_QFontMetrics_leading_Q(const QFontMetrics* self)
    {
        return self->leading();
    }

    int __QtAda_QFontMetrics_leftBearing_QChar_Q(const QFontMetrics* self, QChar* ch)
    {
        return self->leftBearing(*ch);
    }

    int __QtAda_QFontMetrics_lineSpacing_Q(const QFontMetrics* self)
    {
        return self->lineSpacing();
    }

    int __QtAda_QFontMetrics_lineWidth_Q(const QFontMetrics* self)
    {
        return self->lineWidth();
    }

    int __QtAda_QFontMetrics_maxWidth_Q(const QFontMetrics* self)
    {
        return self->maxWidth();
    }

    int __QtAda_QFontMetrics_minLeftBearing_Q(const QFontMetrics* self)
    {
        return self->minLeftBearing();
    }

    int __QtAda_QFontMetrics_minRightBearing_Q(const QFontMetrics* self)
    {
        return self->minRightBearing();
    }

    int __QtAda_QFontMetrics_overlinePos_Q(const QFontMetrics* self)
    {
        return self->overlinePos();
    }

    int __QtAda_QFontMetrics_rightBearing_QChar_Q(const QFontMetrics* self, QChar* ch)
    {
        return self->rightBearing(*ch);
    }

    int __QtAda_QFontMetrics_strikeOutPos_Q(const QFontMetrics* self)
    {
        return self->strikeOutPos();
    }

    void __QtAda_QFontMetrics_tightBoundingRect_QStringCR_Q(QRect* returns, const QFontMetrics* self, const QString* str)
    {
        *returns = self->tightBoundingRect(*str);
    }

    int __QtAda_QFontMetrics_underlinePos_Q(const QFontMetrics* self)
    {
        return self->underlinePos();
    }

    int __QtAda_QFontMetrics_width_QStringCR_int_Q(const QFontMetrics* self, const QString* text, int len)
    {
        return self->width(*text, len);
    }

    int __QtAda_QFontMetrics_width_QChar_Q(const QFontMetrics* self, QChar* ch)
    {
        return self->width(*ch);
    }

    int __QtAda_QFontMetrics_xHeight_Q(const QFontMetrics* self)
    {
        return self->xHeight();
    }

    unsigned __QtAda_QFontMetrics_eq_QFontMetricsCR_Q(const QFontMetrics* self, const QFontMetrics* other)
    {
        return (unsigned)self->operator==(*other);
    }

};

