//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QFont>

extern "C"
{
    extern QFont* __QtAda_inititialize_QFont(void*);
    extern QFont* __QtAda_inititialize_QFont_QStringCR_int_Weight_bool(void*, const QString*, int, int, unsigned);
    extern QFont* __QtAda_adjust_QFont(void*, const QFont*);
    extern void __QtAda_finalize_QFont(QFont*);

    extern unsigned __QtAda_QFont_bold_Q(const QFont*);
    extern void __QtAda_QFont_defaultFamily_Q(QString*, const QFont*);
    extern unsigned __QtAda_QFont_exactMatch_Q(const QFont*);
    extern void __QtAda_QFont_family_Q(QString*, const QFont*);
    extern unsigned __QtAda_QFont_fixedPitch_Q(const QFont*);
    extern unsigned __QtAda_QFont_fromString_QStringCR(QFont*, const QString*);
    extern unsigned __QtAda_QFont_isCopyOf_QFontCR_Q(const QFont*, const QFont*);
    extern unsigned __QtAda_QFont_italic_Q(const QFont*);
    extern unsigned __QtAda_QFont_kerning_Q(const QFont*);
    extern void __QtAda_QFont_key_Q(QString*, const QFont*);
    extern void __QtAda_QFont_lastResortFamily_Q(QString*, const QFont*);
    extern void __QtAda_QFont_lastResortFont_Q(QString*, const QFont*);
    extern unsigned __QtAda_QFont_overline_Q(const QFont*);
    extern int __QtAda_QFont_pixelSize_Q(const QFont*);
    extern int __QtAda_QFont_pointSize_Q(const QFont*);
    extern double __QtAda_QFont_pointSizeF_Q(const QFont*);
    extern unsigned __QtAda_QFont_rawMode_Q(const QFont*);
    extern void __QtAda_QFont_rawName_Q(QString*, const QFont*);
    extern void __QtAda_QFont_resolve_QFontCR_Q(QFont*, const QFont*, const QFont*);
    extern void __QtAda_QFont_setBold_bool(QFont*, unsigned);
    extern void __QtAda_QFont_setFamily_QStringCR(QFont*, const QString*);
    extern void __QtAda_QFont_setFixedPitch_bool(QFont*, unsigned);
    extern void __QtAda_QFont_setItalic_bool(QFont*, unsigned);
    extern void __QtAda_QFont_setKerning_bool(QFont*, unsigned);
    extern void __QtAda_QFont_setOverline_bool(QFont*, unsigned);
    extern void __QtAda_QFont_setPixelSize_int(QFont*, int);
    extern void __QtAda_QFont_setPointSize_int(QFont*, int);
    extern void __QtAda_QFont_setPointSizeF_qreal(QFont*, double);
    extern void __QtAda_QFont_setRawMode_bool(QFont*, unsigned);
    extern void __QtAda_QFont_setRawName_QStringCR(QFont*, const QString*);
    extern void __QtAda_QFont_setStretch_Stretch(QFont*, unsigned);
    extern void __QtAda_QFont_setStrikeOut_bool(QFont*, unsigned);
    extern void __QtAda_QFont_setStyle_Style(QFont*, unsigned);
    extern void __QtAda_QFont_setUnderline_bool(QFont*, unsigned);
    extern void __QtAda_QFont_setWeight_Weight(QFont*, int);
    extern unsigned __QtAda_QFont_stretch_Q(const QFont*);
    extern unsigned __QtAda_QFont_strikeOut_Q(const QFont*);
    extern unsigned __QtAda_QFont_style_Q(const QFont*);
    extern unsigned __QtAda_QFont_styleHint_Q(const QFont*);
    extern void __QtAda_QFont_toString_Q(QString*, const QFont*);
    extern unsigned __QtAda_QFont_underline_Q(const QFont*);
    extern int __QtAda_QFont_weight_Q(const QFont*);
    extern unsigned __QtAda_QFont_eq_QFontCR_Q(const QFont*, const QFont*);
    extern unsigned __QtAda_QFont_lt_QFontCR_Q(const QFont*, const QFont*);
    extern void __QtAda_QFont_insertSubstitution_QStringCR_QStringCR_S(const QString*, const QString*);
    extern void __QtAda_QFont_insertSubstitutions_QStringCR_QStringListCR_S(const QString*, const QStringList*);
    extern void __QtAda_QFont_removeSubstitution_QStringCR_S(const QString*);
    extern void __QtAda_QFont_substitute_QStringCR_S(QString*, const QString*);
    extern void __QtAda_QFont_substitutes_QStringCR_S(QStringList*, const QString*);
    extern void __QtAda_QFont_substitutions_S(QStringList*);

};

