//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QFRAMEDIRECTOR_H__
#define __QFRAMEDIRECTOR_H__

#include <QFrame>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QFrame_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QFrame_frameRect_0_wrapper(QObject*, QRect*);
    extern int __Qt4Ada_QFrame_frameShadow_0_wrapper(QObject*);
    extern int __Qt4Ada_QFrame_frameShape_0_wrapper(QObject*);
    extern int __Qt4Ada_QFrame_frameWidth_0_wrapper(QObject*);
    extern int __Qt4Ada_QFrame_lineWidth_0_wrapper(QObject*);
    extern int __Qt4Ada_QFrame_midLineWidth_0_wrapper(QObject*);
    extern void __Qt4Ada_QFrame_setFrameRect_0_wrapper(QObject*, const QRect*);
    extern void __Qt4Ada_QFrame_setFrameShadow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QFrame_setFrameShape_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QFrame_setLineWidth_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QFrame_setMidLineWidth_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QFrame_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QFrame_changeEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QFrame_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QFrame_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QFrame_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QFrame_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QFrame_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QFrame_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QFrame_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QFrame_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QFrame_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QFrame_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QFrame_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QFrame_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QFrame_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QFrame_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    // Constructors

    extern QObject* __Qt4Ada_new_QFrame(QObject*, unsigned);
    extern QObject* __Qt4Ada_new_QFrameDirector(void*, QObject*, unsigned);

    //  Declarations of wrapper functions for static call

    extern bool __Qt4Ada_QFrame_focusNextPrevChild_wrapper(QObject*,bool );
    extern void __Qt4Ada_QFrame_connectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QFrame_disconnectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QFrame_setFrameStyle_wrapper(QObject*, int);

}

class QFrameDirector : public QFrame
{
protected:
    void* ada_object;
    QFrameDirector(void*, QWidget*, Qt::WindowFlags);

    virtual QPaintEngine*paintEngine();
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

    friend QObject* __Qt4Ada_new_QFrameDirector(void*, QObject*, unsigned);
    friend void __Qt4Ada_QFrame_connectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QFrame_disconnectNotify_wrapper(QObject*,const char*);

    virtual QSize sizeHint() const;
    virtual void changeEvent(QEvent*);
    virtual bool event(QEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QFrame_changeEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QFrame_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QFrame_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QFrame_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QFrame_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QFrame_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QFrame_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QFrame_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QFrame_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QFrame_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QFrame_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QFrame_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QFrame_sender_0_wrapper(QObject*);
};

#endif // __QFRAMEDIRECTOR_H__
