//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009, 2010 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QRectF>
#include <QRegion>
#include <QPainterPath>
#include <QCursor>
#include <QVariant>
#include <QTransform>
#include <QPointF>
#include <QPolygonF>
#include <QMatrix>
#include <QGraphicsObject>
#include <QGraphicsScene>
#include <QString>
#include <QGraphicsSceneContextMenuEvent>
#include <QGraphicsSceneDragDropEvent>
#include <QFocusEvent>
#include <QGraphicsSceneHoverEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsSceneWheelEvent>

#include "qgraphicsitemdirector.h"

extern "C"
{

    void __Qt4Ada_QGraphicsItem_advance_0_virtual(QGraphicsItem* cpp_object, int phase)
    {
        cpp_object->advance(phase);
    }

    void __Qt4Ada_QGraphicsItem_boundingRect_0_virtual(QGraphicsItem* cpp_object, QRectF* returns)
    {
        *returns = cpp_object->boundingRect();
    }

    bool __Qt4Ada_QGraphicsItem_collidesWithItem_0_virtual(QGraphicsItem* cpp_object, const QGraphicsItem* other, Qt::ItemSelectionMode mode)
    {
        return cpp_object->collidesWithItem(other, mode);
    }

    bool __Qt4Ada_QGraphicsItem_collidesWithPath_0_virtual(QGraphicsItem* cpp_object, const QPainterPath* path, Qt::ItemSelectionMode mode)
    {
        return cpp_object->collidesWithPath(*path, mode);
    }

    bool __Qt4Ada_QGraphicsItem_contains_0_virtual(QGraphicsItem* cpp_object, const QPointF* point)
    {
        return cpp_object->contains(*point);
    }

    bool __Qt4Ada_QGraphicsItem_isObscuredBy_0_virtual(QGraphicsItem* cpp_object, const QGraphicsItem* item)
    {
        return cpp_object->isObscuredBy(item);
    }

    void __Qt4Ada_QGraphicsItem_opaqueArea_0_virtual(QGraphicsItem* cpp_object, QPainterPath* returns)
    {
        *returns = cpp_object->opaqueArea();
    }

    void __Qt4Ada_QGraphicsItem_shape_0_virtual(QGraphicsItem* cpp_object, QPainterPath* returns)
    {
        *returns = cpp_object->shape();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QGraphicsItem_acceptDrops_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::acceptDrops();
    }

    bool __Qt4Ada_QGraphicsItem_acceptHoverEvents_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::acceptHoverEvents();
    }

    bool __Qt4Ada_QGraphicsItem_acceptTouchEvents_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::acceptTouchEvents();
    }

    void __Qt4Ada_QGraphicsItem_advance_0_wrapper(QGraphicsItem* cpp_object, int phase)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::advance(phase);
    }

    void __Qt4Ada_QGraphicsItem_boundingRegion_0_wrapper(QGraphicsItem* cpp_object, const QTransform* itemToDeviceTransform, QRegion* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::boundingRegion(*itemToDeviceTransform);
    }

    qreal __Qt4Ada_QGraphicsItem_boundingRegionGranularity_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::boundingRegionGranularity();
    }

    QGraphicsItem::CacheMode __Qt4Ada_QGraphicsItem_cacheMode_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::cacheMode();
    }

    void __Qt4Ada_QGraphicsItem_childrenBoundingRect_0_wrapper(QGraphicsItem* cpp_object, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::childrenBoundingRect();
    }

    void __Qt4Ada_QGraphicsItem_clearFocus_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::clearFocus();
    }

    void __Qt4Ada_QGraphicsItem_clipPath_0_wrapper(QGraphicsItem* cpp_object, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::clipPath();
    }

    bool __Qt4Ada_QGraphicsItem_collidesWithItem_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* other, Qt::ItemSelectionMode mode)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::collidesWithItem(other, mode);
    }

    bool __Qt4Ada_QGraphicsItem_collidesWithPath_0_wrapper(QGraphicsItem* cpp_object, const QPainterPath* path, Qt::ItemSelectionMode mode)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::collidesWithPath(*path, mode);
    }

    QGraphicsItem* __Qt4Ada_QGraphicsItem_commonAncestorItem_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem* other)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::commonAncestorItem(other);
    }

    bool __Qt4Ada_QGraphicsItem_contains_0_wrapper(QGraphicsItem* cpp_object, const QPointF* point)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::contains(*point);
    }

    void __Qt4Ada_QGraphicsItem_cursor_0_wrapper(QGraphicsItem* cpp_object, QCursor* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::cursor();
    }

    void __Qt4Ada_QGraphicsItem_data_0_wrapper(QGraphicsItem* cpp_object, int key, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::data(key);
    }

    void __Qt4Ada_QGraphicsItem_deviceTransform_0_wrapper(QGraphicsItem* cpp_object, const QTransform* viewportTransform, QTransform* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::deviceTransform(*viewportTransform);
    }

    qreal __Qt4Ada_QGraphicsItem_effectiveOpacity_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::effectiveOpacity();
    }

    void __Qt4Ada_QGraphicsItem_ensureVisible_1_wrapper(QGraphicsItem* cpp_object, const QRectF* rect, int xmargin, int ymargin)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::ensureVisible(*rect, xmargin, ymargin);
    }

    void __Qt4Ada_QGraphicsItem_ensureVisible_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal w, qreal h, int xmargin, int ymargin)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::ensureVisible(x, y, w, h, xmargin, ymargin);
    }

    bool __Qt4Ada_QGraphicsItem_filtersChildEvents_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::filtersChildEvents();
    }

    QGraphicsItem* __Qt4Ada_QGraphicsItem_focusItem_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::focusItem();
    }

    QGraphicsItem* __Qt4Ada_QGraphicsItem_focusProxy_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::focusProxy();
    }

    void __Qt4Ada_QGraphicsItem_grabKeyboard_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::grabKeyboard();
    }

    void __Qt4Ada_QGraphicsItem_grabMouse_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::grabMouse();
    }

    bool __Qt4Ada_QGraphicsItem_handlesChildEvents_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::handlesChildEvents();
    }

    bool __Qt4Ada_QGraphicsItem_hasCursor_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::hasCursor();
    }

    bool __Qt4Ada_QGraphicsItem_hasFocus_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::hasFocus();
    }

    void __Qt4Ada_QGraphicsItem_hide_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::hide();
    }

    void __Qt4Ada_QGraphicsItem_installSceneEventFilter_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem* filterItem)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::installSceneEventFilter(filterItem);
    }

    bool __Qt4Ada_QGraphicsItem_isActive_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isActive();
    }

    bool __Qt4Ada_QGraphicsItem_isAncestorOf_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* child)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isAncestorOf(child);
    }

    bool __Qt4Ada_QGraphicsItem_isClipped_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isClipped();
    }

    bool __Qt4Ada_QGraphicsItem_isEnabled_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isEnabled();
    }

    bool __Qt4Ada_QGraphicsItem_isObscured_2_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isObscured();
    }

    bool __Qt4Ada_QGraphicsItem_isObscured_1_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal w, qreal h)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isObscured(x, y, w, h);
    }

    bool __Qt4Ada_QGraphicsItem_isObscured_0_wrapper(QGraphicsItem* cpp_object, const QRectF* rect)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isObscured(*rect);
    }

    bool __Qt4Ada_QGraphicsItem_isObscuredBy_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isObscuredBy(item);
    }

    bool __Qt4Ada_QGraphicsItem_isPanel_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isPanel();
    }

    bool __Qt4Ada_QGraphicsItem_isSelected_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isSelected();
    }

    bool __Qt4Ada_QGraphicsItem_isUnderMouse_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isUnderMouse();
    }

    bool __Qt4Ada_QGraphicsItem_isVisible_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isVisible();
    }

    bool __Qt4Ada_QGraphicsItem_isVisibleTo_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* parent)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isVisibleTo(parent);
    }

    bool __Qt4Ada_QGraphicsItem_isWidget_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isWidget();
    }

    bool __Qt4Ada_QGraphicsItem_isWindow_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::isWindow();
    }

    void __Qt4Ada_QGraphicsItem_mapFromItem_5_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, const QPointF* point, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromItem(item, *point);
    }

    void __Qt4Ada_QGraphicsItem_mapFromItem_4_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, const QRectF* rect, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromItem(item, *rect);
    }

    void __Qt4Ada_QGraphicsItem_mapFromItem_3_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, const QPolygonF* polygon, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromItem(item, *polygon);
    }

    void __Qt4Ada_QGraphicsItem_mapFromItem_2_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, const QPainterPath* path, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromItem(item, *path);
    }

    void __Qt4Ada_QGraphicsItem_mapFromItem_1_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, qreal x, qreal y, qreal w, qreal h, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromItem(item, x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapFromItem_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, qreal x, qreal y, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromItem(item, x, y);
    }

    void __Qt4Ada_QGraphicsItem_mapFromParent_5_wrapper(QGraphicsItem* cpp_object, const QPointF* point, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromParent(*point);
    }

    void __Qt4Ada_QGraphicsItem_mapFromParent_4_wrapper(QGraphicsItem* cpp_object, const QRectF* rect, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromParent(*rect);
    }

    void __Qt4Ada_QGraphicsItem_mapFromParent_3_wrapper(QGraphicsItem* cpp_object, const QPolygonF* polygon, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromParent(*polygon);
    }

    void __Qt4Ada_QGraphicsItem_mapFromParent_2_wrapper(QGraphicsItem* cpp_object, const QPainterPath* path, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromParent(*path);
    }

    void __Qt4Ada_QGraphicsItem_mapFromParent_1_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal w, qreal h, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromParent(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapFromParent_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromParent(x, y);
    }

    void __Qt4Ada_QGraphicsItem_mapFromScene_5_wrapper(QGraphicsItem* cpp_object, const QPointF* point, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromScene(*point);
    }

    void __Qt4Ada_QGraphicsItem_mapFromScene_4_wrapper(QGraphicsItem* cpp_object, const QRectF* rect, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromScene(*rect);
    }

    void __Qt4Ada_QGraphicsItem_mapFromScene_3_wrapper(QGraphicsItem* cpp_object, const QPolygonF* polygon, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromScene(*polygon);
    }

    void __Qt4Ada_QGraphicsItem_mapFromScene_2_wrapper(QGraphicsItem* cpp_object, const QPainterPath* path, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromScene(*path);
    }

    void __Qt4Ada_QGraphicsItem_mapFromScene_1_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal w, qreal h, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromScene(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapFromScene_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapFromScene(x, y);
    }

    void __Qt4Ada_QGraphicsItem_mapRectFromItem_1_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, const QRectF* rect, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectFromItem(item, *rect);
    }

    void __Qt4Ada_QGraphicsItem_mapRectFromItem_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, qreal x, qreal y, qreal w, qreal h, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectFromItem(item, x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapRectFromParent_1_wrapper(QGraphicsItem* cpp_object, const QRectF* rect, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectFromParent(*rect);
    }

    void __Qt4Ada_QGraphicsItem_mapRectFromParent_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal w, qreal h, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectFromParent(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapRectFromScene_1_wrapper(QGraphicsItem* cpp_object, const QRectF* rect, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectFromScene(*rect);
    }

    void __Qt4Ada_QGraphicsItem_mapRectFromScene_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal w, qreal h, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectFromScene(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapRectToItem_1_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, const QRectF* rect, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectToItem(item, *rect);
    }

    void __Qt4Ada_QGraphicsItem_mapRectToItem_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, qreal x, qreal y, qreal w, qreal h, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectToItem(item, x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapRectToParent_1_wrapper(QGraphicsItem* cpp_object, const QRectF* rect, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectToParent(*rect);
    }

    void __Qt4Ada_QGraphicsItem_mapRectToParent_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal w, qreal h, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectToParent(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapRectToScene_1_wrapper(QGraphicsItem* cpp_object, const QRectF* rect, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectToScene(*rect);
    }

    void __Qt4Ada_QGraphicsItem_mapRectToScene_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal w, qreal h, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapRectToScene(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapToItem_5_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, const QPointF* point, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToItem(item, *point);
    }

    void __Qt4Ada_QGraphicsItem_mapToItem_4_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, const QRectF* rect, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToItem(item, *rect);
    }

    void __Qt4Ada_QGraphicsItem_mapToItem_3_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, const QPolygonF* polygon, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToItem(item, *polygon);
    }

    void __Qt4Ada_QGraphicsItem_mapToItem_2_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, const QPainterPath* path, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToItem(item, *path);
    }

    void __Qt4Ada_QGraphicsItem_mapToItem_1_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, qreal x, qreal y, qreal w, qreal h, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToItem(item, x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapToItem_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item, qreal x, qreal y, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToItem(item, x, y);
    }

    void __Qt4Ada_QGraphicsItem_mapToParent_5_wrapper(QGraphicsItem* cpp_object, const QPointF* point, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToParent(*point);
    }

    void __Qt4Ada_QGraphicsItem_mapToParent_4_wrapper(QGraphicsItem* cpp_object, const QRectF* rect, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToParent(*rect);
    }

    void __Qt4Ada_QGraphicsItem_mapToParent_3_wrapper(QGraphicsItem* cpp_object, const QPolygonF* polygon, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToParent(*polygon);
    }

    void __Qt4Ada_QGraphicsItem_mapToParent_2_wrapper(QGraphicsItem* cpp_object, const QPainterPath* path, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToParent(*path);
    }

    void __Qt4Ada_QGraphicsItem_mapToParent_1_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal w, qreal h, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToParent(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapToParent_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToParent(x, y);
    }

    void __Qt4Ada_QGraphicsItem_mapToScene_5_wrapper(QGraphicsItem* cpp_object, const QPointF* point, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToScene(*point);
    }

    void __Qt4Ada_QGraphicsItem_mapToScene_4_wrapper(QGraphicsItem* cpp_object, const QRectF* rect, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToScene(*rect);
    }

    void __Qt4Ada_QGraphicsItem_mapToScene_3_wrapper(QGraphicsItem* cpp_object, const QPolygonF* polygon, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToScene(*polygon);
    }

    void __Qt4Ada_QGraphicsItem_mapToScene_2_wrapper(QGraphicsItem* cpp_object, const QPainterPath* path, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToScene(*path);
    }

    void __Qt4Ada_QGraphicsItem_mapToScene_1_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal w, qreal h, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToScene(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsItem_mapToScene_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::mapToScene(x, y);
    }

    void __Qt4Ada_QGraphicsItem_matrix_0_wrapper(QGraphicsItem* cpp_object, QMatrix* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::matrix();
    }

    void __Qt4Ada_QGraphicsItem_moveBy_0_wrapper(QGraphicsItem* cpp_object, qreal dx, qreal dy)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::moveBy(dx, dy);
    }

    qreal __Qt4Ada_QGraphicsItem_opacity_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::opacity();
    }

    void __Qt4Ada_QGraphicsItem_opaqueArea_0_wrapper(QGraphicsItem* cpp_object, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::opaqueArea();
    }

    QGraphicsItem* __Qt4Ada_QGraphicsItem_panel_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::panel();
    }

    QGraphicsItem::PanelModality __Qt4Ada_QGraphicsItem_panelModality_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::panelModality();
    }

    QObject* __Qt4Ada_QGraphicsItem_parentObject_0_wrapper(QGraphicsItem* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::parentObject());
    }

    QGraphicsItem* __Qt4Ada_QGraphicsItem_parentItem_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::parentItem();
    }

    void __Qt4Ada_QGraphicsItem_pos_0_wrapper(QGraphicsItem* cpp_object, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::pos();
    }

    void __Qt4Ada_QGraphicsItem_removeSceneEventFilter_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem* filterItem)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::removeSceneEventFilter(filterItem);
    }

    void __Qt4Ada_QGraphicsItem_resetMatrix_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::resetMatrix();
    }

    void __Qt4Ada_QGraphicsItem_resetTransform_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::resetTransform();
    }

    void __Qt4Ada_QGraphicsItem_rotate_0_wrapper(QGraphicsItem* cpp_object, qreal angle)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::rotate(angle);
    }

    qreal __Qt4Ada_QGraphicsItem_rotation_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::rotation();
    }

    qreal __Qt4Ada_QGraphicsItem_scale_1_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::scale();
    }

    void __Qt4Ada_QGraphicsItem_scale_0_wrapper(QGraphicsItem* cpp_object, qreal sx, qreal sy)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::scale(sx, sy);
    }

    QObject* __Qt4Ada_QGraphicsItem_scene_0_wrapper(QGraphicsItem* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::scene());
    }

    void __Qt4Ada_QGraphicsItem_sceneBoundingRect_0_wrapper(QGraphicsItem* cpp_object, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::sceneBoundingRect();
    }

    void __Qt4Ada_QGraphicsItem_sceneMatrix_0_wrapper(QGraphicsItem* cpp_object, QMatrix* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::sceneMatrix();
    }

    void __Qt4Ada_QGraphicsItem_scenePos_0_wrapper(QGraphicsItem* cpp_object, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::scenePos();
    }

    void __Qt4Ada_QGraphicsItem_sceneTransform_0_wrapper(QGraphicsItem* cpp_object, QTransform* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::sceneTransform();
    }

    void __Qt4Ada_QGraphicsItem_scroll_0_wrapper(QGraphicsItem* cpp_object, qreal dx, qreal dy, const QRectF* rect)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::scroll(dx, dy, *rect);
    }

    void __Qt4Ada_QGraphicsItem_setAcceptDrops_0_wrapper(QGraphicsItem* cpp_object, bool on)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setAcceptDrops(on);
    }

    void __Qt4Ada_QGraphicsItem_setAcceptHoverEvents_0_wrapper(QGraphicsItem* cpp_object, bool enabled)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setAcceptHoverEvents(enabled);
    }

    void __Qt4Ada_QGraphicsItem_setAcceptTouchEvents_0_wrapper(QGraphicsItem* cpp_object, bool enabled)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setAcceptTouchEvents(enabled);
    }

    void __Qt4Ada_QGraphicsItem_setActive_0_wrapper(QGraphicsItem* cpp_object, bool active)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setActive(active);
    }

    void __Qt4Ada_QGraphicsItem_setBoundingRegionGranularity_0_wrapper(QGraphicsItem* cpp_object, qreal granularity)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setBoundingRegionGranularity(granularity);
    }

    void __Qt4Ada_QGraphicsItem_setCacheMode_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem::CacheMode mode, const QSize* cacheSize)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setCacheMode(mode, *cacheSize);
    }

    void __Qt4Ada_QGraphicsItem_setCursor_0_wrapper(QGraphicsItem* cpp_object, const QCursor* cursor)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setCursor(*cursor);
    }

    void __Qt4Ada_QGraphicsItem_setData_0_wrapper(QGraphicsItem* cpp_object, int key, const QVariant* value)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setData(key, *value);
    }

    void __Qt4Ada_QGraphicsItem_setEnabled_0_wrapper(QGraphicsItem* cpp_object, bool enabled)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setEnabled(enabled);
    }

    void __Qt4Ada_QGraphicsItem_setFiltersChildEvents_0_wrapper(QGraphicsItem* cpp_object, bool enabled)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setFiltersChildEvents(enabled);
    }

    void __Qt4Ada_QGraphicsItem_setFlag_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem::GraphicsItemFlag flag, bool enabled)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setFlag(flag, enabled);
    }

    void __Qt4Ada_QGraphicsItem_setFocusProxy_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem* item)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setFocusProxy(item);
    }

    void __Qt4Ada_QGraphicsItem_setHandlesChildEvents_0_wrapper(QGraphicsItem* cpp_object, bool enabled)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setHandlesChildEvents(enabled);
    }

    void __Qt4Ada_QGraphicsItem_setMatrix_0_wrapper(QGraphicsItem* cpp_object, const QMatrix* matrix, bool combine)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setMatrix(*matrix, combine);
    }

    void __Qt4Ada_QGraphicsItem_setOpacity_0_wrapper(QGraphicsItem* cpp_object, qreal opacity)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setOpacity(opacity);
    }

    void __Qt4Ada_QGraphicsItem_setPanelModality_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem::PanelModality panelModality)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setPanelModality(panelModality);
    }

    void __Qt4Ada_QGraphicsItem_setParentItem_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem* parent)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setParentItem(parent);
    }

    void __Qt4Ada_QGraphicsItem_setPos_1_wrapper(QGraphicsItem* cpp_object, const QPointF* pos)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setPos(*pos);
    }

    void __Qt4Ada_QGraphicsItem_setPos_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setPos(x, y);
    }

    void __Qt4Ada_QGraphicsItem_setRotation_0_wrapper(QGraphicsItem* cpp_object, qreal angle)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setRotation(angle);
    }

    void __Qt4Ada_QGraphicsItem_setScale_0_wrapper(QGraphicsItem* cpp_object, qreal factor)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setScale(factor);
    }

    void __Qt4Ada_QGraphicsItem_setSelected_0_wrapper(QGraphicsItem* cpp_object, bool selected)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setSelected(selected);
    }

    void __Qt4Ada_QGraphicsItem_setToolTip_0_wrapper(QGraphicsItem* cpp_object, const QString* toolTip)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setToolTip(*toolTip);
    }

    void __Qt4Ada_QGraphicsItem_setTransform_0_wrapper(QGraphicsItem* cpp_object, const QTransform* matrix, bool combine)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setTransform(*matrix, combine);
    }

    void __Qt4Ada_QGraphicsItem_setTransformOriginPoint_1_wrapper(QGraphicsItem* cpp_object, const QPointF* origin)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setTransformOriginPoint(*origin);
    }

    void __Qt4Ada_QGraphicsItem_setTransformOriginPoint_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setTransformOriginPoint(x, y);
    }

    void __Qt4Ada_QGraphicsItem_setVisible_0_wrapper(QGraphicsItem* cpp_object, bool visible)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setVisible(visible);
    }

    void __Qt4Ada_QGraphicsItem_setX_0_wrapper(QGraphicsItem* cpp_object, qreal x)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setX(x);
    }

    void __Qt4Ada_QGraphicsItem_setY_0_wrapper(QGraphicsItem* cpp_object, qreal y)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setY(y);
    }

    void __Qt4Ada_QGraphicsItem_setZValue_0_wrapper(QGraphicsItem* cpp_object, qreal z)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::setZValue(z);
    }

    void __Qt4Ada_QGraphicsItem_shape_0_wrapper(QGraphicsItem* cpp_object, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::shape();
    }

    void __Qt4Ada_QGraphicsItem_shear_0_wrapper(QGraphicsItem* cpp_object, qreal sh, qreal sv)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::shear(sh, sv);
    }

    void __Qt4Ada_QGraphicsItem_show_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::show();
    }

    void __Qt4Ada_QGraphicsItem_stackBefore_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem* sibling)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::stackBefore(sibling);
    }

    QObject* __Qt4Ada_QGraphicsItem_toGraphicsObject_0_wrapper(QGraphicsItem* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::toGraphicsObject());
    }

    void __Qt4Ada_QGraphicsItem_toolTip_0_wrapper(QGraphicsItem* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::toolTip();
    }

    QGraphicsItem* __Qt4Ada_QGraphicsItem_topLevelItem_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::topLevelItem();
    }

    void __Qt4Ada_QGraphicsItem_transform_0_wrapper(QGraphicsItem* cpp_object, QTransform* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::transform();
    }

    void __Qt4Ada_QGraphicsItem_transformOriginPoint_0_wrapper(QGraphicsItem* cpp_object, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::transformOriginPoint();
    }

    void __Qt4Ada_QGraphicsItem_translate_0_wrapper(QGraphicsItem* cpp_object, qreal dx, qreal dy)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::translate(dx, dy);
    }

    void __Qt4Ada_QGraphicsItem_ungrabKeyboard_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::ungrabKeyboard();
    }

    void __Qt4Ada_QGraphicsItem_ungrabMouse_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::ungrabMouse();
    }

    void __Qt4Ada_QGraphicsItem_unsetCursor_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::unsetCursor();
    }

    void __Qt4Ada_QGraphicsItem_update_1_wrapper(QGraphicsItem* cpp_object, const QRectF* rect)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::update(*rect);
    }

    void __Qt4Ada_QGraphicsItem_update_0_wrapper(QGraphicsItem* cpp_object, qreal x, qreal y, qreal width, qreal height)
    {
        dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::update(x, y, width, height);
    }

    qreal __Qt4Ada_QGraphicsItem_x_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::x();
    }

    qreal __Qt4Ada_QGraphicsItem_y_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::y();
    }

    qreal __Qt4Ada_QGraphicsItem_zValue_0_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::zValue();
    }

    void __Qt4Ada_QGraphicsItem_contextMenuEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::contextMenuEvent(dynamic_cast<QGraphicsSceneContextMenuEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_dragEnterEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::dragEnterEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_dragLeaveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::dragLeaveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_dragMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::dragMoveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_dropEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::dropEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_focusInEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_focusOutEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_hoverEnterEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::hoverEnterEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_hoverMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::hoverMoveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::hoverLeaveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_inputMethodEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_inputMethodQuery_0_wrapper(QGraphicsItem* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::inputMethodQuery(query);
    }

    void __Qt4Ada_QGraphicsItem_itemChange_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem::GraphicsItemChange change, const QVariant* value, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::itemChange(change, *value);
    }

    void __Qt4Ada_QGraphicsItem_keyPressEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_keyReleaseEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::mouseDoubleClickEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_mouseMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::mouseMoveEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_mousePressEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::mousePressEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::mouseReleaseEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsItem_prepareGeometryChange_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::prepareGeometryChange();
    }

    bool __Qt4Ada_QGraphicsItem_sceneEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        return dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::sceneEvent(event);
    }

    bool __Qt4Ada_QGraphicsItem_sceneEventFilter_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem* watched, QEvent* event)
    {
        return dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::sceneEventFilter(watched, event);
    }

    void __Qt4Ada_QGraphicsItem_wheelEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsItemDirector*>(cpp_object)->QGraphicsItem::wheelEvent(dynamic_cast<QGraphicsSceneWheelEvent*>(event));
    }

}

void QGraphicsItemDirector::advance(int phase)
{
    __Qt4Ada_QGraphicsItem_advance_0_dispatch(this->ada_object, phase);
}

QRectF QGraphicsItemDirector::boundingRect() const
{
    QRectF *aux = __Qt4Ada_QGraphicsItem_boundingRect_0_dispatch(this->ada_object);
    QRectF returns = *aux;
    delete aux;
    return returns;
}

bool QGraphicsItemDirector::collidesWithItem(const QGraphicsItem* other, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithItem_0_dispatch(this->ada_object, other, mode);
}

bool QGraphicsItemDirector::collidesWithPath(const QPainterPath& path, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithPath_0_dispatch(this->ada_object, &path, mode);
}

bool QGraphicsItemDirector::contains(const QPointF& point) const
{
    return __Qt4Ada_QGraphicsItem_contains_0_dispatch(this->ada_object, &point);
}

bool QGraphicsItemDirector::isObscuredBy(const QGraphicsItem* item) const
{
    return __Qt4Ada_QGraphicsItem_isObscuredBy_0_dispatch(this->ada_object, item);
}

QPainterPath QGraphicsItemDirector::opaqueArea() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_opaqueArea_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

QPainterPath QGraphicsItemDirector::shape() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_shape_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsItemDirector::contextMenuEvent(QGraphicsSceneContextMenuEvent* event)
{
    __Qt4Ada_QGraphicsItem_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::dragEnterEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::dragLeaveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::dragMoveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::dropEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dropEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusInEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::hoverEnterEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::hoverMoveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::hoverLeaveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QGraphicsItem_inputMethodEvent_0_dispatch(this->ada_object, event);
}

QVariant QGraphicsItemDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QVariant QGraphicsItemDirector::itemChange(QGraphicsItem::GraphicsItemChange change, const QVariant& value)
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_itemChange_0_dispatch(this->ada_object, change, &value);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsItemDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsItemDirector::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsItemDirector::sceneEvent(QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsItemDirector::sceneEventFilter(QGraphicsItem* watched, QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGraphicsItemDirector::wheelEvent(QGraphicsSceneWheelEvent* event)
{
    __Qt4Ada_QGraphicsItem_wheelEvent_0_dispatch(this->ada_object, event);
}
#include <iostream>

//int QGraphicsItemDirector::type() const
//{
//   return __Qt4Ada_QGraphicsItem_type_dispatch(this->ada_object);
//}

void QGraphicsItemDirector::paint(QPainter *                       painter,
                                  const QStyleOptionGraphicsItem * option,
                                  QWidget *                        widget)
{
   //  XXX Обнаружено, что в Qt 4.2.2 тип option почему-то указан некорректно.
   //  Для обхода ошибки используется прямая принудительная установка типа.

   if (option->type != QStyleOption::SO_GraphicsItem)
   {
//       std::cout << "Fix wrong (" << option->type
//           << ") QStyleOptionGraphicsItem type (force "
//	   << QStyleOption::SO_GraphicsItem << ")" << std::endl;

       const_cast<QStyleOptionGraphicsItem*>(option)->type =
         QStyleOption::SO_GraphicsItem;
   }

   __Qt4Ada_QGraphicsItem_paint_dispatch(this->ada_object, painter, qstyleoption_cast<const QStyleOption*> (option), dynamic_cast<QObject*> (widget));
}

Qt4AdaQGraphicsItemUserData::Qt4AdaQGraphicsItemUserData()
{
    data = new Qt4AdaQGraphicsItemUserDataPrivate;
    data->ada_object = NULL;
    data->count = 0;
}

Qt4AdaQGraphicsItemUserData::Qt4AdaQGraphicsItemUserData(void* o, bool isQObject)
{
    data = new Qt4AdaQGraphicsItemUserDataPrivate;
    data->ada_object = o;
    data->isQObject = isQObject;
    data->count = 1;
}

Qt4AdaQGraphicsItemUserData::Qt4AdaQGraphicsItemUserData (const Qt4AdaQGraphicsItemUserData & copy)
{
    data = copy.data;
    data->count++;
}

Qt4AdaQGraphicsItemUserData & Qt4AdaQGraphicsItemUserData::operator=
    (const Qt4AdaQGraphicsItemUserData & copy)
{
    data = copy.data;
    data->count++;
    return *this;
}

Qt4AdaQGraphicsItemUserData::~Qt4AdaQGraphicsItemUserData()
{
    if(data->count > 0)
    {
        data->count--;

        if(data->count == 0)
        {
            if (!data->isQObject)
            {
		//  When a class is a subclass from both QObject and
		//  QGraphicsItem the object is destroyed as part of QObject
		//  destruction.

                __QtAda_free_Q_Graphics_Item_Impl(data->ada_object);
            }

            delete data;
        }
    }
}

QGraphicsItemDirector::QGraphicsItemDirector(void* o, QGraphicsItem* parent, QGraphicsScene* scene) :
    QGraphicsItem(parent, scene),
    ada_object(o)
{
}

extern "C" {

    void __Qt4Ada_delete_QGraphicsItem(QGraphicsItem *cpp_this)
    {
        delete cpp_this;
    }

    void __QtAda_associate_Q_Graphics_Item_Impl
        (QGraphicsItem* cpp_object, void* ada_object)
    {
        Qt4AdaQGraphicsItemUserData ud =
            Qt4AdaQGraphicsItemUserData(ada_object,
                                        cpp_object->toGraphicsObject() != 0);
        QVariant note;
        note.setValue(ud);
        cpp_object->setData(0, note);
    }

    void* __Qt4Ada_get_QGraphicsItem_LimitedEntity(QGraphicsItem* cpp_object)
    {
        QVariant var = cpp_object->data(0);
        Qt4AdaQGraphicsItemUserData ud = var.value<Qt4AdaQGraphicsItemUserData>();

        if(ud.data->count > 0)
        {
            return ud.data->ada_object;
        }
        else
        {
            return NULL;
        }
    }

//  static int metaTypeId = qRegisterMetaType<QGraphicsItemDirector>("QGraphicsItemDirector");

    QGraphicsItem* __Qt4Ada_new_QGraphicsItemDirector(void* ada_object, QGraphicsItem* parent, QGraphicsScene* scene)
    {
        return dynamic_cast<QGraphicsItem*>(new QGraphicsItemDirector(ada_object, parent, scene));
    }

    int __Qt4Ada_QGraphicsItem_type_wrapper(QGraphicsItem* cpp_object)
    {
        return dynamic_cast<QGraphicsItem*>(cpp_object)->QGraphicsItem::type();
    }

    int __Qt4Ada_QGraphicsItem_type_virtual(QGraphicsItem* cpp_object)
    {
        return cpp_object->type();
    }

    void __Qt4Ada_QGraphicsItem_setAcceptedMouseButtons_wrapper(QGraphicsItem* cpp_object,
                                                                unsigned       buttons)
    {
        dynamic_cast<QGraphicsItem*>
           (cpp_object)->QGraphicsItem::setAcceptedMouseButtons(static_cast<Qt::MouseButtons>(buttons));
    }

    void __Qt4Ada_QGraphicsItem_paint_virtual(QGraphicsItem* self, QPainter* painter, const QStyleOption* option, QObject* widget)
    {
        self->paint(painter, qstyleoption_cast<const QStyleOptionGraphicsItem*>(option), dynamic_cast<QWidget*>(widget));
    }

}
