//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QGRAPHICSOBJECTDIRECTOR_H__
#define __QGRAPHICSOBJECTDIRECTOR_H__

#include <QGraphicsObject>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QGraphicsObject_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QGraphicsObject_enabledChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsObject_opacityChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsObject_parentChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsObject_rotationChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsObject_scaleChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsObject_visibleChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsObject_xChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsObject_yChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsObject_zChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsObject_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QGraphicsObject_sender_0_wrapper(QObject*);
    extern void __Qt4Ada_QGraphicsObject_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_hoverEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_hoverMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_hoverLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_inputMethodQuery_0_wrapper(QObject*, Qt::InputMethodQuery, QVariant*);
    extern void __Qt4Ada_QGraphicsObject_itemChange_0_wrapper(QObject*, QGraphicsItem::GraphicsItemChange, const QVariant*, QVariant*);
    extern void __Qt4Ada_QGraphicsObject_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_prepareGeometryChange_0_wrapper(QObject*);
    extern bool __Qt4Ada_QGraphicsObject_sceneEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QGraphicsObject_sceneEventFilter_0_wrapper(QObject*, QGraphicsItem*, QEvent*);
    extern void __Qt4Ada_QGraphicsObject_wheelEvent_0_wrapper(QObject*, QEvent*);

    extern void* __Qt4Ada_QGraphicsObject_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QGraphicsObject_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

class QGraphicsObjectDirector : public QGraphicsObject
{
protected:
    void* ada_object;

    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void advance(int);
    virtual QRectF boundingRect() const;
    virtual bool collidesWithItem(const QGraphicsItem*, Qt::ItemSelectionMode) const;
    virtual bool collidesWithPath(const QPainterPath&, Qt::ItemSelectionMode) const;
    virtual bool contains(const QPointF&) const;
    virtual bool isObscuredBy(const QGraphicsItem*) const;
    virtual QPainterPath opaqueArea() const;
    virtual QPainterPath shape() const;
    virtual void contextMenuEvent(QGraphicsSceneContextMenuEvent*);
    virtual void dragEnterEvent(QGraphicsSceneDragDropEvent*);
    virtual void dragLeaveEvent(QGraphicsSceneDragDropEvent*);
    virtual void dragMoveEvent(QGraphicsSceneDragDropEvent*);
    virtual void dropEvent(QGraphicsSceneDragDropEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hoverEnterEvent(QGraphicsSceneHoverEvent*);
    virtual void hoverMoveEvent(QGraphicsSceneHoverEvent*);
    virtual void hoverLeaveEvent(QGraphicsSceneHoverEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QVariant itemChange(QGraphicsItem::GraphicsItemChange, const QVariant&);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QGraphicsSceneMouseEvent*);
    virtual void mouseMoveEvent(QGraphicsSceneMouseEvent*);
    virtual void mousePressEvent(QGraphicsSceneMouseEvent*);
    virtual void mouseReleaseEvent(QGraphicsSceneMouseEvent*);
    virtual bool sceneEvent(QEvent*);
    virtual bool sceneEventFilter(QGraphicsItem*, QEvent*);
    virtual void wheelEvent(QGraphicsSceneWheelEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QGraphicsObject_enabledChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsObject_opacityChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsObject_parentChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsObject_rotationChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsObject_scaleChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsObject_visibleChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsObject_xChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsObject_yChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsObject_zChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsObject_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QGraphicsObject_sender_0_wrapper(QObject*);
    friend void __Qt4Ada_QGraphicsObject_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_hoverEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_hoverMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_hoverLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_inputMethodQuery_0_wrapper(QObject*, Qt::InputMethodQuery, QVariant*);
    friend void __Qt4Ada_QGraphicsObject_itemChange_0_wrapper(QObject*, QGraphicsItem::GraphicsItemChange, const QVariant*, QVariant*);
    friend void __Qt4Ada_QGraphicsObject_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_prepareGeometryChange_0_wrapper(QObject*);
    friend bool __Qt4Ada_QGraphicsObject_sceneEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QGraphicsObject_sceneEventFilter_0_wrapper(QObject*, QGraphicsItem*, QEvent*);
    friend void __Qt4Ada_QGraphicsObject_wheelEvent_0_wrapper(QObject*, QEvent*);
};

#endif // __QGRAPHICSOBJECTDIRECTOR_H__
