//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QGraphicsEllipseItem>
#include <QGraphicsLineItem>
#include <QGraphicsPathItem>
#include <QGraphicsPolygonItem>
#include <QGraphicsRectItem>
#include <QGraphicsSimpleTextItem>
#include <QGraphicsTextItem>
#include <QBrush>
#include <QVariant>
#include <QRectF>
#include <QGraphicsSceneContextMenuEvent>
#include <QGraphicsSceneDragDropEvent>
#include <QFocusEvent>
#include <QGraphicsSceneHelpEvent>
#include <QKeyEvent>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsSceneWheelEvent>
#include <QInputMethodEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qgraphicsscenedirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QGraphicsScene_staticMetaObject =
        &QGraphicsScene::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QGraphicsScene_inputMethodQuery_0_virtual(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsScene*>(cpp_object)->inputMethodQuery(query);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    QGraphicsItem* __Qt4Ada_QGraphicsScene_addEllipse_0_wrapper(QObject* cpp_object, const QRectF* rect, const QPen* pen, const QBrush* brush)
    {
        return static_cast<QGraphicsItem*>(dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::addEllipse(*rect, *pen, *brush));
    }

    void __Qt4Ada_QGraphicsScene_addItem_0_wrapper(QObject* cpp_object, QGraphicsItem* item)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::addItem(item);
    }

    QGraphicsItem* __Qt4Ada_QGraphicsScene_addLine_0_wrapper(QObject* cpp_object, const QLineF* line, const QPen* pen)
    {
        return static_cast<QGraphicsItem*>(dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::addLine(*line, *pen));
    }

    QGraphicsItem* __Qt4Ada_QGraphicsScene_addPath_0_wrapper(QObject* cpp_object, const QPainterPath* path, const QPen* pen, const QBrush* brush)
    {
        return static_cast<QGraphicsItem*>(dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::addPath(*path, *pen, *brush));
    }

    QGraphicsItem* __Qt4Ada_QGraphicsScene_addPolygon_0_wrapper(QObject* cpp_object, const QPolygonF* path, const QPen* pen, const QBrush* brush)
    {
        return static_cast<QGraphicsItem*>(dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::addPolygon(*path, *pen, *brush));
    }

    QGraphicsItem* __Qt4Ada_QGraphicsScene_addRect_0_wrapper(QObject* cpp_object, const QRectF* path, const QPen* pen, const QBrush* brush)
    {
        return static_cast<QGraphicsItem*>(dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::addRect(*path, *pen, *brush));
    }

    QGraphicsItem* __Qt4Ada_QGraphicsScene_addSimpleText_0_wrapper(QObject* cpp_object, const QString* text, const QFont* font)
    {
        return static_cast<QGraphicsItem*>(dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::addSimpleText(*text, *font));
    }

    QObject* __Qt4Ada_QGraphicsScene_addText_0_wrapper(QObject* cpp_object, const QString* text, const QFont* font)
    {
        return static_cast<QObject*>(dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::addText(*text, *font));
    }

    void __Qt4Ada_QGraphicsScene_backgroundBrush_0_wrapper(QObject* cpp_object, QBrush* returns)
    {
        *returns = dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::backgroundBrush();
    }

    void __Qt4Ada_QGraphicsScene_clearFocus_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::clearFocus();
    }

    void __Qt4Ada_QGraphicsScene_clearSelection_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::clearSelection();
    }

    QGraphicsItem* __Qt4Ada_QGraphicsScene_focusItem_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::focusItem();
    }

    void __Qt4Ada_QGraphicsScene_foregroundBrush_0_wrapper(QObject* cpp_object, QBrush* returns)
    {
        *returns = dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::foregroundBrush();
    }

    bool __Qt4Ada_QGraphicsScene_hasFocus_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::hasFocus();
    }

    qreal __Qt4Ada_QGraphicsScene_height_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::height();
    }

    void __Qt4Ada_QGraphicsScene_inputMethodQuery_0_wrapper(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::inputMethodQuery(query);
    }

    QGraphicsItem* __Qt4Ada_QGraphicsScene_itemAt_1_wrapper(QObject* cpp_object, const QPointF* pos)
    {
        return dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::itemAt(*pos);
    }

    QGraphicsItem* __Qt4Ada_QGraphicsScene_itemAt_0_wrapper(QObject* cpp_object, qreal x, qreal y)
    {
        return dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::itemAt(x, y);
    }

    QGraphicsScene::ItemIndexMethod __Qt4Ada_QGraphicsScene_itemIndexMethod_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::itemIndexMethod();
    }

    void __Qt4Ada_QGraphicsScene_itemsBoundingRect_0_wrapper(QObject* cpp_object, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::itemsBoundingRect();
    }

    QGraphicsItem* __Qt4Ada_QGraphicsScene_mouseGrabberItem_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::mouseGrabberItem();
    }

    void __Qt4Ada_QGraphicsScene_removeItem_0_wrapper(QObject* cpp_object, QGraphicsItem* item)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::removeItem(item);
    }

    void __Qt4Ada_QGraphicsScene_sceneRect_0_wrapper(QObject* cpp_object, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::sceneRect();
    }

    void __Qt4Ada_QGraphicsScene_setBackgroundBrush_0_wrapper(QObject* cpp_object, const QBrush* brush)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::setBackgroundBrush(*brush);
    }

    void __Qt4Ada_QGraphicsScene_setForegroundBrush_0_wrapper(QObject* cpp_object, const QBrush* brush)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::setForegroundBrush(*brush);
    }

    void __Qt4Ada_QGraphicsScene_setItemIndexMethod_0_wrapper(QObject* cpp_object, QGraphicsScene::ItemIndexMethod method)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::setItemIndexMethod(method);
    }

    void __Qt4Ada_QGraphicsScene_setSceneRect_1_wrapper(QObject* cpp_object, const QRectF* rect)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::setSceneRect(*rect);
    }

    void __Qt4Ada_QGraphicsScene_setSceneRect_0_wrapper(QObject* cpp_object, qreal x, qreal y, qreal w, qreal h)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::setSceneRect(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsScene_setSelectionArea_0_wrapper(QObject* cpp_object, const QPainterPath* path)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::setSelectionArea(*path);
    }

    qreal __Qt4Ada_QGraphicsScene_width_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::width();
    }

    void __Qt4Ada_QGraphicsScene_advance_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::advance();
    }

    void __Qt4Ada_QGraphicsScene_update_0_wrapper(QObject* cpp_object, const QRectF* rect)
    {
        dynamic_cast<QGraphicsScene*>(cpp_object)->QGraphicsScene::update(*rect);
    }

    bool __Qt4Ada_QGraphicsScene_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::event(e);
    }

    void __Qt4Ada_QGraphicsScene_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::contextMenuEvent(dynamic_cast<QGraphicsSceneContextMenuEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::dragEnterEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::dragMoveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::dragLeaveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::dropEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_helpEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::helpEvent(dynamic_cast<QGraphicsSceneHelpEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::mousePressEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::mouseMoveEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::mouseReleaseEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::mouseDoubleClickEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::wheelEvent(dynamic_cast<QGraphicsSceneWheelEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QGraphicsScene::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QGraphicsScene_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QGraphicsScene_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QGraphicsScene_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsSceneDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QGraphicsScene_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QGraphicsScene*>(cpp_this)->QGraphicsScene::qt_metacast(name);
    }

    int __Qt4Ada_QGraphicsScene_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QGraphicsScene*>(cpp_this)->QGraphicsScene::qt_metacall(_c, _id, _a);
    }

}

QVariant QGraphicsSceneDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QGraphicsScene_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

bool QGraphicsSceneDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QGraphicsSceneDirector::contextMenuEvent(QGraphicsSceneContextMenuEvent* event)
{
    __Qt4Ada_QGraphicsScene_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::dragEnterEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsScene_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::dragMoveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsScene_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::dragLeaveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsScene_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::dropEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsScene_dropEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsScene_focusInEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsScene_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::helpEvent(QGraphicsSceneHelpEvent* event)
{
    __Qt4Ada_QGraphicsScene_helpEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsScene_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsScene_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsScene_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsScene_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsScene_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsScene_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::wheelEvent(QGraphicsSceneWheelEvent* event)
{
    __Qt4Ada_QGraphicsScene_wheelEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QGraphicsScene_inputMethodEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsSceneDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGraphicsSceneDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSceneDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QGraphicsSceneDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QGraphicsSceneDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QGraphicsSceneDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include "qobjectdirector.h"
#include "qgraphicsscenedirector.h"
#include <QRectF>

QGraphicsSceneDirector::QGraphicsSceneDirector(void* o, QObject* parent) :
    QGraphicsScene(parent),
    ada_object(o)
{
}

void QGraphicsSceneDirector::drawBackground(QPainter*_p1,const QRectF&_p2)
{
//     __Qt4Ada_QGraphicsScene_drawBackground_dispatch(this->ada_object,_p1,_p2);
}

void QGraphicsSceneDirector::drawForeground(QPainter*_p1,const QRectF&_p2)
{
//     __Qt4Ada_QGraphicsScene_drawForeground_dispatch(this->ada_object,_p1,_p2);
}

void QGraphicsSceneDirector::drawItems(QPainter*_p1,int _p2,QGraphicsItem*_p3,const QStyleOptionGraphicsItem _p4,QWidget*_p5)
{
//     __Qt4Ada_QGraphicsScene_drawItems_dispatch(this->ada_object,_p1,_p2,_p3,_p4,_p5);
}

void QGraphicsSceneDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QGraphicsSceneDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    extern QObject * __Qt4Ada_new_QGraphicsScene (QObject *parent)
    {
         return dynamic_cast<QObject *> (new QGraphicsScene (parent));
    }

    extern QObject * __Qt4Ada_new_QGraphicsScene_With_RectF (QRectF* r,QObject *parent)
    {
        return dynamic_cast<QObject *> (new QGraphicsScene (*r, parent));
    }
    extern QObject * __Qt4Ada_new_QGraphicsScene_From_Points (qreal x, qreal y, qreal width, qreal height, QObject * parent)
    {
        return dynamic_cast<QObject *> (new QGraphicsScene (x,y,width,height,parent));
    }

    QObject* __Qt4Ada_new_QGraphicsSceneDirector(void* ada_object,QObject *parent)
    {
        return dynamic_cast<QObject*>(new QGraphicsSceneDirector(ada_object, parent));
    }

    void __Qt4Ada_QGraphicsScene_drawBackground_wrapper(QObject*cpp_this,QPainter*_p1,const QRectF&_p2)
    {
    (dynamic_cast<QGraphicsSceneDirector*>(cpp_this))->QGraphicsScene::drawBackground(_p1,_p2);
    }

    void __Qt4Ada_QGraphicsScene_drawForeground_wrapper(QObject*cpp_this,QPainter*_p1,const QRectF&_p2)
    {
    (dynamic_cast<QGraphicsSceneDirector*>(cpp_this))->QGraphicsScene::drawForeground(_p1,_p2);
    }

   void __Qt4Ada_QGraphicsScene_items_wrapper(QObject*cpp_this, QList<QGraphicsItem*>* returns)
   {
      *returns = (dynamic_cast<QGraphicsScene*>(cpp_this))->QGraphicsScene::items();
   }

//     void __Qt4Ada_QGraphicsScene_drawItems_wrapper(QObject*cpp_this,QPainter*_p1,int _p2,QGraphicsItem*_p3,const QStyleOption _p4,QObject*_p5)
//     {
//     (dynamic_cast<QGraphicsSceneDirector*>(cpp_this))->QGraphicsScene::drawItems(_p1,_p2,_p3,dynamic_cast<const QStyleOptionGraphicsItem >(_p4),dynamic_cast<QWidget*>(_p5));
//     }

}
