//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QFont>
#include <QString>
#include <QRectF>
#include <QPainterPath>
#include <QGraphicsSceneContextMenuEvent>
#include <QGraphicsSceneDragDropEvent>
#include <QFocusEvent>
#include <QGraphicsSceneHoverEvent>
#include <QInputMethodEvent>
#include <QVariant>
#include <QKeyEvent>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsSceneWheelEvent>

#include "qgraphicssimpletextitemdirector.h"
#include "qabstractgraphicsshapeitemdirector.h"
#include "qgraphicsitemdirector.h"

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QGraphicsSimpleTextItem_font_0_wrapper(QGraphicsItem* cpp_object, QFont* returns)
    {
        *returns = dynamic_cast<QGraphicsSimpleTextItem*>(cpp_object)->QGraphicsSimpleTextItem::font();
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_setFont_0_wrapper(QGraphicsItem* cpp_object, const QFont* font)
    {
        dynamic_cast<QGraphicsSimpleTextItem*>(cpp_object)->QGraphicsSimpleTextItem::setFont(*font);
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_setText_0_wrapper(QGraphicsItem* cpp_object, const QString* text)
    {
        dynamic_cast<QGraphicsSimpleTextItem*>(cpp_object)->QGraphicsSimpleTextItem::setText(*text);
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_text_0_wrapper(QGraphicsItem* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QGraphicsSimpleTextItem*>(cpp_object)->QGraphicsSimpleTextItem::text();
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_boundingRect_0_wrapper(QGraphicsItem* cpp_object, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsSimpleTextItem*>(cpp_object)->QGraphicsSimpleTextItem::boundingRect();
    }

    bool __Qt4Ada_QGraphicsSimpleTextItem_contains_0_wrapper(QGraphicsItem* cpp_object, const QPointF* point)
    {
        return dynamic_cast<QGraphicsSimpleTextItem*>(cpp_object)->QGraphicsSimpleTextItem::contains(*point);
    }

    bool __Qt4Ada_QGraphicsSimpleTextItem_isObscuredBy_0_wrapper(QGraphicsItem* cpp_object, const QGraphicsItem* item)
    {
        return dynamic_cast<QGraphicsSimpleTextItem*>(cpp_object)->QGraphicsSimpleTextItem::isObscuredBy(item);
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_opaqueArea_0_wrapper(QGraphicsItem* cpp_object, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsSimpleTextItem*>(cpp_object)->QGraphicsSimpleTextItem::opaqueArea();
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_shape_0_wrapper(QGraphicsItem* cpp_object, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsSimpleTextItem*>(cpp_object)->QGraphicsSimpleTextItem::shape();
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_contextMenuEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::contextMenuEvent(dynamic_cast<QGraphicsSceneContextMenuEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_dragEnterEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::dragEnterEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_dragLeaveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::dragLeaveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_dragMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::dragMoveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_dropEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::dropEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_focusInEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_focusOutEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_hoverEnterEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::hoverEnterEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_hoverMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::hoverMoveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_hoverLeaveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::hoverLeaveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_inputMethodEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_inputMethodQuery_0_wrapper(QGraphicsItem* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::inputMethodQuery(query);
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_itemChange_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem::GraphicsItemChange change, const QVariant* value, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::itemChange(change, *value);
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_keyPressEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_keyReleaseEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_mouseDoubleClickEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::mouseDoubleClickEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_mouseMoveEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::mouseMoveEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_mousePressEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::mousePressEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_mouseReleaseEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::mouseReleaseEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_prepareGeometryChange_0_wrapper(QGraphicsItem* cpp_object)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::prepareGeometryChange();
    }

    bool __Qt4Ada_QGraphicsSimpleTextItem_sceneEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        return dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::sceneEvent(event);
    }

    bool __Qt4Ada_QGraphicsSimpleTextItem_sceneEventFilter_0_wrapper(QGraphicsItem* cpp_object, QGraphicsItem* watched, QEvent* event)
    {
        return dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::sceneEventFilter(watched, event);
    }

    void __Qt4Ada_QGraphicsSimpleTextItem_wheelEvent_0_wrapper(QGraphicsItem* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsSimpleTextItemDirector*>(cpp_object)->QGraphicsItem::wheelEvent(dynamic_cast<QGraphicsSceneWheelEvent*>(event));
    }

}

QRectF QGraphicsSimpleTextItemDirector::boundingRect() const
{
    QRectF *aux = __Qt4Ada_QGraphicsItem_boundingRect_0_dispatch(this->ada_object);
    QRectF returns = *aux;
    delete aux;
    return returns;
}

bool QGraphicsSimpleTextItemDirector::contains(const QPointF& point) const
{
    return __Qt4Ada_QGraphicsItem_contains_0_dispatch(this->ada_object, &point);
}

bool QGraphicsSimpleTextItemDirector::isObscuredBy(const QGraphicsItem* item) const
{
    return __Qt4Ada_QGraphicsItem_isObscuredBy_0_dispatch(this->ada_object, item);
}

QPainterPath QGraphicsSimpleTextItemDirector::opaqueArea() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_opaqueArea_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

QPainterPath QGraphicsSimpleTextItemDirector::shape() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_shape_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsSimpleTextItemDirector::advance(int phase)
{
    __Qt4Ada_QGraphicsItem_advance_0_dispatch(this->ada_object, phase);
}

bool QGraphicsSimpleTextItemDirector::collidesWithItem(const QGraphicsItem* other, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithItem_0_dispatch(this->ada_object, other, mode);
}

bool QGraphicsSimpleTextItemDirector::collidesWithPath(const QPainterPath& path, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithPath_0_dispatch(this->ada_object, &path, mode);
}

void QGraphicsSimpleTextItemDirector::contextMenuEvent(QGraphicsSceneContextMenuEvent* event)
{
    __Qt4Ada_QGraphicsItem_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::dragEnterEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::dragLeaveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::dragMoveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::dropEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dropEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusInEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::hoverEnterEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::hoverMoveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::hoverLeaveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QGraphicsItem_inputMethodEvent_0_dispatch(this->ada_object, event);
}

QVariant QGraphicsSimpleTextItemDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QVariant QGraphicsSimpleTextItemDirector::itemChange(QGraphicsItem::GraphicsItemChange change, const QVariant& value)
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_itemChange_0_dispatch(this->ada_object, change, &value);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsSimpleTextItemDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsSimpleTextItemDirector::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsSimpleTextItemDirector::sceneEvent(QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsSimpleTextItemDirector::sceneEventFilter(QGraphicsItem* watched, QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGraphicsSimpleTextItemDirector::wheelEvent(QGraphicsSceneWheelEvent* event)
{
    __Qt4Ada_QGraphicsItem_wheelEvent_0_dispatch(this->ada_object, event);
}

extern "C" {

    void __Qt4Ada_QGraphicsSimpleTextItem_paint_wrapper(QGraphicsItem* cpp_object, QPainter* painter, const QStyleOptionGraphicsItem* option, QObject* widget)
   {
         dynamic_cast<QGraphicsSimpleTextItem*>(cpp_object)->paint(painter, option, dynamic_cast<QWidget*>(widget));
   }

}
