//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QColor>
#include <QTextDocument>
#include <QFont>
#include <QTextCursor>
#include <QString>
#include <QRectF>
#include <QPainterPath>
#include <QGraphicsSceneContextMenuEvent>
#include <QGraphicsSceneDragDropEvent>
#include <QFocusEvent>
#include <QGraphicsSceneHoverEvent>
#include <QInputMethodEvent>
#include <QVariant>
#include <QKeyEvent>
#include <QGraphicsSceneMouseEvent>
#include <QChildEvent>
#include <QTimerEvent>
#include <QGraphicsSceneWheelEvent>

#include "qgraphicstextitemdirector.h"
#include "qgraphicsobjectdirector.h"
#include "qobjectdirector.h"
#include "qgraphicsitemdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QGraphicsTextItem_staticMetaObject =
        &QGraphicsTextItem::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QGraphicsTextItem_adjustSize_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::adjustSize();
    }

    void __Qt4Ada_QGraphicsTextItem_defaultTextColor_0_wrapper(QObject* cpp_object, QColor* returns)
    {
        *returns = dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::defaultTextColor();
    }

    QObject* __Qt4Ada_QGraphicsTextItem_document_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::document());
    }

    void __Qt4Ada_QGraphicsTextItem_font_0_wrapper(QObject* cpp_object, QFont* returns)
    {
        *returns = dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::font();
    }

    bool __Qt4Ada_QGraphicsTextItem_openExternalLinks_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::openExternalLinks();
    }

    void __Qt4Ada_QGraphicsTextItem_setDefaultTextColor_0_wrapper(QObject* cpp_object, const QColor* col)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::setDefaultTextColor(*col);
    }

    void __Qt4Ada_QGraphicsTextItem_setDocument_0_wrapper(QObject* cpp_object, QObject* document)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::setDocument(dynamic_cast<QTextDocument*>(document));
    }

    void __Qt4Ada_QGraphicsTextItem_setFont_0_wrapper(QObject* cpp_object, const QFont* font)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::setFont(*font);
    }

    void __Qt4Ada_QGraphicsTextItem_setHtml_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::setHtml(*text);
    }

    void __Qt4Ada_QGraphicsTextItem_setOpenExternalLinks_0_wrapper(QObject* cpp_object, bool open)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::setOpenExternalLinks(open);
    }

    void __Qt4Ada_QGraphicsTextItem_setPlainText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::setPlainText(*text);
    }

    void __Qt4Ada_QGraphicsTextItem_setTabChangesFocus_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::setTabChangesFocus(b);
    }

    void __Qt4Ada_QGraphicsTextItem_setTextCursor_0_wrapper(QObject* cpp_object, const QTextCursor* cursor)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::setTextCursor(*cursor);
    }

    void __Qt4Ada_QGraphicsTextItem_setTextWidth_0_wrapper(QObject* cpp_object, qreal width)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::setTextWidth(width);
    }

    bool __Qt4Ada_QGraphicsTextItem_tabChangesFocus_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::tabChangesFocus();
    }

    void __Qt4Ada_QGraphicsTextItem_textCursor_0_wrapper(QObject* cpp_object, QTextCursor* returns)
    {
        *returns = dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::textCursor();
    }

    qreal __Qt4Ada_QGraphicsTextItem_textWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::textWidth();
    }

    void __Qt4Ada_QGraphicsTextItem_toHtml_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::toHtml();
    }

    void __Qt4Ada_QGraphicsTextItem_toPlainText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::toPlainText();
    }

    void __Qt4Ada_QGraphicsTextItem_boundingRect_0_wrapper(QObject* cpp_object, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::boundingRect();
    }

    bool __Qt4Ada_QGraphicsTextItem_contains_0_wrapper(QObject* cpp_object, const QPointF* point)
    {
        return dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::contains(*point);
    }

    bool __Qt4Ada_QGraphicsTextItem_isObscuredBy_0_wrapper(QObject* cpp_object, const QGraphicsItem* item)
    {
        return dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::isObscuredBy(item);
    }

    void __Qt4Ada_QGraphicsTextItem_opaqueArea_0_wrapper(QObject* cpp_object, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::opaqueArea();
    }

    void __Qt4Ada_QGraphicsTextItem_shape_0_wrapper(QObject* cpp_object, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::shape();
    }

    void __Qt4Ada_QGraphicsTextItem_linkActivated_0_wrapper(QObject* cpp_object, const QString* link)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::linkActivated(*link);
    }

    void __Qt4Ada_QGraphicsTextItem_linkHovered_0_wrapper(QObject* cpp_object, const QString* link)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::linkHovered(*link);
    }

    void __Qt4Ada_QGraphicsTextItem_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::contextMenuEvent(dynamic_cast<QGraphicsSceneContextMenuEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::dragEnterEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::dragLeaveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::dragMoveEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::dropEvent(dynamic_cast<QGraphicsSceneDragDropEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_hoverEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::hoverEnterEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_hoverMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::hoverMoveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_hoverLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::hoverLeaveEvent(dynamic_cast<QGraphicsSceneHoverEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_inputMethodQuery_0_wrapper(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::inputMethodQuery(query);
    }

    void __Qt4Ada_QGraphicsTextItem_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::mouseDoubleClickEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::mouseMoveEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::mousePressEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::mouseReleaseEvent(dynamic_cast<QGraphicsSceneMouseEvent*>(event));
    }

    bool __Qt4Ada_QGraphicsTextItem_sceneEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsTextItem::sceneEvent(event);
    }

    void __Qt4Ada_QGraphicsTextItem_enabledChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsObject::enabledChanged();
    }

    void __Qt4Ada_QGraphicsTextItem_opacityChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsObject::opacityChanged();
    }

    void __Qt4Ada_QGraphicsTextItem_parentChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsObject::parentChanged();
    }

    void __Qt4Ada_QGraphicsTextItem_rotationChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsObject::rotationChanged();
    }

    void __Qt4Ada_QGraphicsTextItem_scaleChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsObject::scaleChanged();
    }

    void __Qt4Ada_QGraphicsTextItem_visibleChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsObject::visibleChanged();
    }

    void __Qt4Ada_QGraphicsTextItem_xChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsObject::xChanged();
    }

    void __Qt4Ada_QGraphicsTextItem_yChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsObject::yChanged();
    }

    void __Qt4Ada_QGraphicsTextItem_zChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsObject::zChanged();
    }

    void __Qt4Ada_QGraphicsTextItem_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QGraphicsTextItem_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QGraphicsTextItem_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QGraphicsTextItem_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QObject::sender();
    }

    void __Qt4Ada_QGraphicsTextItem_itemChange_0_wrapper(QObject* cpp_object, QGraphicsItem::GraphicsItemChange change, const QVariant* value, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsItem::itemChange(change, *value);
    }

    void __Qt4Ada_QGraphicsTextItem_prepareGeometryChange_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsItem::prepareGeometryChange();
    }

    bool __Qt4Ada_QGraphicsTextItem_sceneEventFilter_0_wrapper(QObject* cpp_object, QGraphicsItem* watched, QEvent* event)
    {
        return dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsItem::sceneEventFilter(watched, event);
    }

    void __Qt4Ada_QGraphicsTextItem_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsTextItemDirector*>(cpp_object)->QGraphicsItem::wheelEvent(dynamic_cast<QGraphicsSceneWheelEvent*>(event));
    }

    void* __Qt4Ada_QGraphicsTextItem_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QGraphicsTextItem*>(cpp_this)->QGraphicsTextItem::qt_metacast(name);
    }

    int __Qt4Ada_QGraphicsTextItem_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QGraphicsTextItem*>(cpp_this)->QGraphicsTextItem::qt_metacall(_c, _id, _a);
    }

}

QRectF QGraphicsTextItemDirector::boundingRect() const
{
    QRectF *aux = __Qt4Ada_QGraphicsItem_boundingRect_0_dispatch(this->ada_object);
    QRectF returns = *aux;
    delete aux;
    return returns;
}

bool QGraphicsTextItemDirector::contains(const QPointF& point) const
{
    return __Qt4Ada_QGraphicsItem_contains_0_dispatch(this->ada_object, &point);
}

bool QGraphicsTextItemDirector::isObscuredBy(const QGraphicsItem* item) const
{
    return __Qt4Ada_QGraphicsItem_isObscuredBy_0_dispatch(this->ada_object, item);
}

QPainterPath QGraphicsTextItemDirector::opaqueArea() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_opaqueArea_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

QPainterPath QGraphicsTextItemDirector::shape() const
{
    QPainterPath *aux = __Qt4Ada_QGraphicsItem_shape_0_dispatch(this->ada_object);
    QPainterPath returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsTextItemDirector::contextMenuEvent(QGraphicsSceneContextMenuEvent* event)
{
    __Qt4Ada_QGraphicsItem_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::dragEnterEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::dragLeaveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::dragMoveEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::dropEvent(QGraphicsSceneDragDropEvent* event)
{
    __Qt4Ada_QGraphicsItem_dropEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusInEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QGraphicsItem_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::hoverEnterEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::hoverMoveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::hoverLeaveEvent(QGraphicsSceneHoverEvent* event)
{
    __Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QGraphicsItem_inputMethodEvent_0_dispatch(this->ada_object, event);
}

QVariant QGraphicsTextItemDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsTextItemDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QGraphicsItem_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::mouseDoubleClickEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::mouseMoveEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::mousePressEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::mouseReleaseEvent(QGraphicsSceneMouseEvent* event)
{
    __Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsTextItemDirector::sceneEvent(QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsTextItemDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QGraphicsTextItemDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGraphicsTextItemDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsTextItemDirector::advance(int phase)
{
    __Qt4Ada_QGraphicsItem_advance_0_dispatch(this->ada_object, phase);
}

bool QGraphicsTextItemDirector::collidesWithItem(const QGraphicsItem* other, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithItem_0_dispatch(this->ada_object, other, mode);
}

bool QGraphicsTextItemDirector::collidesWithPath(const QPainterPath& path, Qt::ItemSelectionMode mode) const
{
    return __Qt4Ada_QGraphicsItem_collidesWithPath_0_dispatch(this->ada_object, &path, mode);
}

QVariant QGraphicsTextItemDirector::itemChange(QGraphicsItem::GraphicsItemChange change, const QVariant& value)
{
    QVariant *aux = __Qt4Ada_QGraphicsItem_itemChange_0_dispatch(this->ada_object, change, &value);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

bool QGraphicsTextItemDirector::sceneEventFilter(QGraphicsItem* watched, QEvent* event)
{
    return __Qt4Ada_QGraphicsItem_sceneEventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGraphicsTextItemDirector::wheelEvent(QGraphicsSceneWheelEvent* event)
{
    __Qt4Ada_QGraphicsItem_wheelEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QGraphicsTextItemDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QGraphicsTextItemDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QGraphicsTextItemDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C" {

    void __Qt4Ada_QGraphicsTextItem_paint_wrapper(QGraphicsItem* cpp_object, QPainter* painter, const QStyleOptionGraphicsItem* option, QObject* widget)
    {
        dynamic_cast<QGraphicsTextItem*>(cpp_object)->QGraphicsTextItem::paint(painter, option, dynamic_cast<QWidget*>(widget));
    }

}
