//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QBrush>
#include <QPoint>
#include <QPolygon>
#include <QPainterPath>
#include <QPointF>
#include <QPolygonF>
#include <QMatrix>
#include <QGraphicsScene>
#include <QRectF>
#include <QVariant>
#include <QWidget>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QWheelEvent>
#include <QSize>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qgraphicsviewdirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QGraphicsView_staticMetaObject =
        &QGraphicsView::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QGraphicsView_backgroundBrush_0_wrapper(QObject* cpp_object, QBrush* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::backgroundBrush();
    }

    void __Qt4Ada_QGraphicsView_centerOn_2_wrapper(QObject* cpp_object, const QPointF* pos)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::centerOn(*pos);
    }

    void __Qt4Ada_QGraphicsView_centerOn_1_wrapper(QObject* cpp_object, qreal x, qreal y)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::centerOn(x, y);
    }

    void __Qt4Ada_QGraphicsView_centerOn_0_wrapper(QObject* cpp_object, const QGraphicsItem* item)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::centerOn(item);
    }

    QGraphicsView::DragMode __Qt4Ada_QGraphicsView_dragMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::dragMode();
    }

    void __Qt4Ada_QGraphicsView_ensureVisible_2_wrapper(QObject* cpp_object, const QRectF* rect, int xmargin, int ymargin)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::ensureVisible(*rect, xmargin, ymargin);
    }

    void __Qt4Ada_QGraphicsView_ensureVisible_1_wrapper(QObject* cpp_object, qreal x, qreal y, qreal w, qreal h, int xmargin, int ymargin)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::ensureVisible(x, y, w, h, xmargin, ymargin);
    }

    void __Qt4Ada_QGraphicsView_ensureVisible_0_wrapper(QObject* cpp_object, const QGraphicsItem* item, int xmargin, int ymargin)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::ensureVisible(item, xmargin, ymargin);
    }

    void __Qt4Ada_QGraphicsView_fitInView_2_wrapper(QObject* cpp_object, const QRectF* rect, Qt::AspectRatioMode aspectRadioMode)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::fitInView(*rect, aspectRadioMode);
    }

    void __Qt4Ada_QGraphicsView_fitInView_1_wrapper(QObject* cpp_object, qreal x, qreal y, qreal w, qreal h, Qt::AspectRatioMode aspectRadioMode)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::fitInView(x, y, w, h, aspectRadioMode);
    }

    void __Qt4Ada_QGraphicsView_fitInView_0_wrapper(QObject* cpp_object, const QGraphicsItem* item, Qt::AspectRatioMode aspectRadioMode)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::fitInView(item, aspectRadioMode);
    }

    void __Qt4Ada_QGraphicsView_foregroundBrush_0_wrapper(QObject* cpp_object, QBrush* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::foregroundBrush();
    }

    bool __Qt4Ada_QGraphicsView_isInteractive_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::isInteractive();
    }

    QGraphicsItem* __Qt4Ada_QGraphicsView_itemAt_1_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        return dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::itemAt(*pos);
    }

    QGraphicsItem* __Qt4Ada_QGraphicsView_itemAt_0_wrapper(QObject* cpp_object, int x, int y)
    {
        return dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::itemAt(x, y);
    }

    void __Qt4Ada_QGraphicsView_mapFromScene_5_wrapper(QObject* cpp_object, const QPointF* point, QPoint* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapFromScene(*point);
    }

    void __Qt4Ada_QGraphicsView_mapFromScene_4_wrapper(QObject* cpp_object, const QRectF* rect, QPolygon* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapFromScene(*rect);
    }

    void __Qt4Ada_QGraphicsView_mapFromScene_3_wrapper(QObject* cpp_object, const QPolygonF* polygon, QPolygon* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapFromScene(*polygon);
    }

    void __Qt4Ada_QGraphicsView_mapFromScene_2_wrapper(QObject* cpp_object, const QPainterPath* path, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapFromScene(*path);
    }

    void __Qt4Ada_QGraphicsView_mapFromScene_1_wrapper(QObject* cpp_object, qreal x, qreal y, QPoint* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapFromScene(x, y);
    }

    void __Qt4Ada_QGraphicsView_mapFromScene_0_wrapper(QObject* cpp_object, qreal x, qreal y, qreal w, qreal h, QPolygon* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapFromScene(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsView_mapToScene_5_wrapper(QObject* cpp_object, const QPoint* point, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapToScene(*point);
    }

    void __Qt4Ada_QGraphicsView_mapToScene_4_wrapper(QObject* cpp_object, const QRect* rect, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapToScene(*rect);
    }

    void __Qt4Ada_QGraphicsView_mapToScene_3_wrapper(QObject* cpp_object, const QPolygon* polygon, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapToScene(*polygon);
    }

    void __Qt4Ada_QGraphicsView_mapToScene_2_wrapper(QObject* cpp_object, const QPainterPath* path, QPainterPath* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapToScene(*path);
    }

    void __Qt4Ada_QGraphicsView_mapToScene_1_wrapper(QObject* cpp_object, int x, int y, QPointF* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapToScene(x, y);
    }

    void __Qt4Ada_QGraphicsView_mapToScene_0_wrapper(QObject* cpp_object, int x, int y, int w, int h, QPolygonF* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::mapToScene(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsView_matrix_0_wrapper(QObject* cpp_object, QMatrix* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::matrix();
    }

    void __Qt4Ada_QGraphicsView_resetCachedContent_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::resetCachedContent();
    }

    void __Qt4Ada_QGraphicsView_resetMatrix_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::resetMatrix();
    }

    QGraphicsView::ViewportAnchor __Qt4Ada_QGraphicsView_resizeAnchor_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::resizeAnchor();
    }

    void __Qt4Ada_QGraphicsView_rotate_0_wrapper(QObject* cpp_object, qreal angle)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::rotate(angle);
    }

    void __Qt4Ada_QGraphicsView_scale_0_wrapper(QObject* cpp_object, qreal sx, qreal sy)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::scale(sx, sy);
    }

    QObject* __Qt4Ada_QGraphicsView_scene_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::scene());
    }

    void __Qt4Ada_QGraphicsView_sceneRect_0_wrapper(QObject* cpp_object, QRectF* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::sceneRect();
    }

    void __Qt4Ada_QGraphicsView_setBackgroundBrush_0_wrapper(QObject* cpp_object, const QBrush* brush)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setBackgroundBrush(*brush);
    }

    void __Qt4Ada_QGraphicsView_setDragMode_0_wrapper(QObject* cpp_object, QGraphicsView::DragMode mode)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setDragMode(mode);
    }

    void __Qt4Ada_QGraphicsView_setForegroundBrush_0_wrapper(QObject* cpp_object, const QBrush* brush)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setForegroundBrush(*brush);
    }

    void __Qt4Ada_QGraphicsView_setInteractive_0_wrapper(QObject* cpp_object, bool allowed)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setInteractive(allowed);
    }

    void __Qt4Ada_QGraphicsView_setMatrix_0_wrapper(QObject* cpp_object, const QMatrix* matrix, bool combine)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setMatrix(*matrix, combine);
    }

    void __Qt4Ada_QGraphicsView_setResizeAnchor_0_wrapper(QObject* cpp_object, QGraphicsView::ViewportAnchor anchor)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setResizeAnchor(anchor);
    }

    void __Qt4Ada_QGraphicsView_setScene_0_wrapper(QObject* cpp_object, QObject* scene)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setScene(dynamic_cast<QGraphicsScene*>(scene));
    }

    void __Qt4Ada_QGraphicsView_setSceneRect_1_wrapper(QObject* cpp_object, const QRectF* rect)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setSceneRect(*rect);
    }

    void __Qt4Ada_QGraphicsView_setSceneRect_0_wrapper(QObject* cpp_object, qreal x, qreal y, qreal w, qreal h)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setSceneRect(x, y, w, h);
    }

    void __Qt4Ada_QGraphicsView_setTransformationAnchor_0_wrapper(QObject* cpp_object, QGraphicsView::ViewportAnchor anchor)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setTransformationAnchor(anchor);
    }

    void __Qt4Ada_QGraphicsView_setViewportUpdateMode_0_wrapper(QObject* cpp_object, QGraphicsView::ViewportUpdateMode mode)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::setViewportUpdateMode(mode);
    }

    void __Qt4Ada_QGraphicsView_shear_0_wrapper(QObject* cpp_object, qreal sh, qreal sv)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::shear(sh, sv);
    }

    QGraphicsView::ViewportAnchor __Qt4Ada_QGraphicsView_transformationAnchor_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::transformationAnchor();
    }

    void __Qt4Ada_QGraphicsView_translate_0_wrapper(QObject* cpp_object, qreal dx, qreal dy)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::translate(dx, dy);
    }

    QGraphicsView::ViewportUpdateMode __Qt4Ada_QGraphicsView_viewportUpdateMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::viewportUpdateMode();
    }

    void __Qt4Ada_QGraphicsView_updateSceneRect_0_wrapper(QObject* cpp_object, const QRectF* rect)
    {
        dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::updateSceneRect(*rect);
    }

    void __Qt4Ada_QGraphicsView_inputMethodQuery_0_wrapper(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QGraphicsView*>(cpp_object)->QGraphicsView::inputMethodQuery(query);
    }

    void __Qt4Ada_QGraphicsView_setupViewport_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::setupViewport(dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QGraphicsView_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    bool __Qt4Ada_QGraphicsView_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::event(e);
    }

    void __Qt4Ada_QGraphicsView_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::scrollContentsBy(dx, dy);
    }

    void __Qt4Ada_QGraphicsView_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    bool __Qt4Ada_QGraphicsView_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::viewportEvent(event);
    }

    void __Qt4Ada_QGraphicsView_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QGraphicsView::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QGraphicsView_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QGraphicsView_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QGraphicsView_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QGraphicsView_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QGraphicsView_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QGraphicsView_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QGraphicsView_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QGraphicsView_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QGraphicsView_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QGraphicsView_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QGraphicsView_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QGraphicsView_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QGraphicsView_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QGraphicsView_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGraphicsViewDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QGraphicsView_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QGraphicsView*>(cpp_this)->QGraphicsView::qt_metacast(name);
    }

    int __Qt4Ada_QGraphicsView_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QGraphicsView*>(cpp_this)->QGraphicsView::qt_metacall(_c, _id, _a);
    }

}

QVariant QGraphicsViewDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsViewDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsViewDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QGraphicsViewDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

void QGraphicsViewDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsViewDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

QSize QGraphicsViewDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QGraphicsViewDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QGraphicsViewDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QGraphicsViewDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QGraphicsViewDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QGraphicsViewDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QGraphicsViewDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QGraphicsViewDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QGraphicsViewDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QGraphicsViewDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGraphicsViewDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QGraphicsViewDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QGraphicsViewDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QGraphicsViewDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QGraphicsViewDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QGraphicsScene>

QGraphicsViewDirector::QGraphicsViewDirector(void* o, QWidget* parent) :
    QGraphicsView(parent),
    ada_object (o)
{
}

QPaintEngine*QGraphicsViewDirector::paintEngine()
{
    return __Qt4Ada_QPaintDevice_paintEngine_dispatch(this->ada_object);
}

void QGraphicsViewDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QGraphicsViewDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

void QGraphicsViewDirector::drawBackground(QPainter*_p1,const QRectF&_p2)
{
    __Qt4Ada_QGraphicsView_drawBackground_dispatch(this->ada_object,_p1,_p2);
}

extern "C" {

    extern QObject * __Qt4Ada_new_QGraphicsView (QObject * parent)
    {
         return dynamic_cast<QObject*> (new QGraphicsView (dynamic_cast <QWidget*> (parent)));
    }
    extern QObject * __Qt4Ada_new_QGraphicsView_With_Scene ( QObject * scene, QObject * parent)
    {
         return dynamic_cast<QObject*> (new QGraphicsView (dynamic_cast <QGraphicsScene*> (scene), dynamic_cast <QWidget*> (parent)));
    }

    QPaintEngine*__Qt4Ada_QGraphicsView_paintEngine_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QGraphicsView*>(cpp_this))->QGraphicsView::paintEngine();
    }

    void __Qt4Ada_QGraphicsView_drawBackground_wrapper(QObject*cpp_this,QPainter*_p1,const QRectF&_p2)
    {
    (dynamic_cast<QGraphicsViewDirector*>(cpp_this))->QGraphicsView::drawBackground(_p1,_p2);
    }

    void __Qt4Ada_QGraphicsView_drawBackground_virtual(QObject*cpp_this,QPainter*_p1,const QRectF&_p2)
    {
    (dynamic_cast<QGraphicsViewDirector*>(cpp_this))->drawBackground(_p1,_p2);
    }

    void __Qt4Ada_QGraphicsView_drawForeground_wrapper(QObject*cpp_this,QPainter*_p1,const QRectF&_p2)
    {
    (dynamic_cast<QGraphicsViewDirector*>(cpp_this))->QGraphicsView::drawForeground(_p1,_p2);
    }

    void __Qt4Ada_QGraphicsView_drawItems_wrapper(QObject*cpp_this,QPainter*_p1,int _p2,QGraphicsItem*_p3,const QStyleOption _p4)
    {
//     (dynamic_cast<QGraphicsViewDirector*>(cpp_this))->QGraphicsView::drawItems(_p1,_p2,_p3,dynamic_cast<const QStyleOptionGraphicsItem >(_p4));
    }

    void __Qt4Ada_QGraphicsView_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QGraphicsViewDirector*>(cpp_this))->QGraphicsView::connectNotify(_p1);
    }

    void __Qt4Ada_QGraphicsView_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QGraphicsViewDirector*>(cpp_this))->QGraphicsView::disconnectNotify(_p1);
    }

    QObject* __Qt4Ada_new_QGraphicsViewDirector(void* ada_object, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QGraphicsViewDirector(ada_object,dynamic_cast<QWidget*>(parent)));
    }

    void __Qt4Ada_QGraphicsView_setCacheMode_wrapper(QObject*cpp_this, unsigned mode)
    {
        dynamic_cast<QGraphicsView*>(cpp_this)->setCacheMode(static_cast<QGraphicsView::CacheMode>(mode));
    }

    void __Qt4Ada_QGraphicsView_setRenderHint_wrapper (QObject*cpp_this, unsigned hint, bool enabled)
    {
       dynamic_cast<QGraphicsView*>(cpp_this)->setRenderHint((QPainter::RenderHint)hint, enabled);
    }

}
