//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QRect>
#include <QSize>
#include <QWidget>
#include <QChildEvent>
#include <QTimerEvent>
#include <QLayout>

#include "qgridlayoutdirector.h"
#include "qlayoutdirector.h"
#include "qobjectdirector.h"
#include "qlayoutitemdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QGridLayout_staticMetaObject =
        &QGridLayout::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QGridLayout_cellRect_0_wrapper(QObject* cpp_object, int row, int column, QRect* returns)
    {
        *returns = dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::cellRect(row, column);
    }

    int __Qt4Ada_QGridLayout_columnCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::columnCount();
    }

    int __Qt4Ada_QGridLayout_columnMinimumWidth_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::columnMinimumWidth(column);
    }

    int __Qt4Ada_QGridLayout_columnStretch_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::columnStretch(column);
    }

    int __Qt4Ada_QGridLayout_rowCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::rowCount();
    }

    int __Qt4Ada_QGridLayout_rowMinimumHeight_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::rowMinimumHeight(row);
    }

    int __Qt4Ada_QGridLayout_rowStretch_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::rowStretch(row);
    }

    void __Qt4Ada_QGridLayout_setColumnMinimumWidth_0_wrapper(QObject* cpp_object, int column, int minSize)
    {
        dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::setColumnMinimumWidth(column, minSize);
    }

    void __Qt4Ada_QGridLayout_setColumnStretch_0_wrapper(QObject* cpp_object, int column, int stretch)
    {
        dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::setColumnStretch(column, stretch);
    }

    void __Qt4Ada_QGridLayout_setRowMinimumHeight_0_wrapper(QObject* cpp_object, int row, int minSize)
    {
        dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::setRowMinimumHeight(row, minSize);
    }

    void __Qt4Ada_QGridLayout_setRowStretch_0_wrapper(QObject* cpp_object, int row, int stretch)
    {
        dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::setRowStretch(row, stretch);
    }

    void __Qt4Ada_QGridLayout_addItem_0_wrapper(QObject* cpp_object, QLayoutItem* item)
    {
        dynamic_cast<QGridLayoutDirector*>(cpp_object)->QGridLayout::addItem(item);
    }

    int __Qt4Ada_QGridLayout_count_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::count();
    }

    bool __Qt4Ada_QGridLayout_hasHeightForWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::hasHeightForWidth();
    }

    int __Qt4Ada_QGridLayout_heightForWidth_0_wrapper(QObject* cpp_object, int w)
    {
        return dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::heightForWidth(w);
    }

    void __Qt4Ada_QGridLayout_invalidate_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::invalidate();
    }

    void __Qt4Ada_QGridLayout_maximumSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::maximumSize();
    }

    int __Qt4Ada_QGridLayout_minimumHeightForWidth_0_wrapper(QObject* cpp_object, int w)
    {
        return dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::minimumHeightForWidth(w);
    }

    void __Qt4Ada_QGridLayout_minimumSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::minimumSize();
    }

    void __Qt4Ada_QGridLayout_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QGridLayout*>(cpp_object)->QGridLayout::sizeHint();
    }

    void __Qt4Ada_QGridLayout_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGridLayoutDirector*>(cpp_object)->QLayout::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QGridLayout_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGridLayoutDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QGridLayout_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGridLayoutDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QGridLayout_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGridLayoutDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QGridLayout_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QGridLayout*>(cpp_this)->QGridLayout::qt_metacast(name);
    }

    int __Qt4Ada_QGridLayout_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QGridLayout*>(cpp_this)->QGridLayout::qt_metacall(_c, _id, _a);
    }

}

void QGridLayoutDirector::addItem(QLayoutItem* item)
{
    __Qt4Ada_QLayout_addItem_0_dispatch(this->ada_object, item);
}

int QGridLayoutDirector::count() const
{
    return __Qt4Ada_QLayout_count_0_dispatch(this->ada_object);
}

bool QGridLayoutDirector::hasHeightForWidth() const
{
    return __Qt4Ada_QLayoutItem_hasHeightForWidth_0_dispatch(this->ada_object);
}

int QGridLayoutDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QLayoutItem_heightForWidth_0_dispatch(this->ada_object, w);
}

void QGridLayoutDirector::invalidate()
{
    __Qt4Ada_QLayoutItem_invalidate_0_dispatch(this->ada_object);
}

QSize QGridLayoutDirector::maximumSize() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_maximumSize_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

int QGridLayoutDirector::minimumHeightForWidth(int w) const
{
    return __Qt4Ada_QLayoutItem_minimumHeightForWidth_0_dispatch(this->ada_object, w);
}

QSize QGridLayoutDirector::minimumSize() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_minimumSize_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QGridLayoutDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

int QGridLayoutDirector::indexOf(QWidget* widget) const
{
    return __Qt4Ada_QLayout_indexOf_0_dispatch(this->ada_object, widget);
}

bool QGridLayoutDirector::isEmpty() const
{
    return __Qt4Ada_QLayoutItem_isEmpty_0_dispatch(this->ada_object);
}

void QGridLayoutDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

bool QGridLayoutDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QGridLayoutDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGridLayoutDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QGridLayoutDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

QLayout* QGridLayoutDirector::layout()
{
    return dynamic_cast<QLayout*>(__Qt4Ada_QLayoutItem_layout_0_dispatch(this->ada_object));
}

QWidget* QGridLayoutDirector::widget()
{
    return dynamic_cast<QWidget*>(__Qt4Ada_QLayoutItem_widget_0_dispatch(this->ada_object));
}

const QMetaObject* QGridLayoutDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QGridLayoutDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QGridLayoutDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QWidget>

void QGridLayoutDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QGridLayoutDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    QObject* __Qt4Ada_new_QGridLayout ()
    {
        return dynamic_cast<QObject*>(new QGridLayout ());
    }

    QObject* __Qt4Ada_new_QGridLayout_QWidgetP (QObject *parent)
    {
        return dynamic_cast<QObject*>(new QGridLayout(dynamic_cast<QWidget*>(parent)));
    }

    Qt::Orientations __Qt4Ada_QGridLayout_expandingDirections_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QGridLayout*>(cpp_this))->QGridLayout::expandingDirections();
    }

    void __Qt4Ada_QGridLayout_setGeometry_wrapper(QObject*cpp_this,const QRect&_p1)
    {
    (dynamic_cast<QGridLayout*>(cpp_this))->QGridLayout::setGeometry(_p1);
    }

    QRect __Qt4Ada_QGridLayout_geometry_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QGridLayout*>(cpp_this))->QGridLayout::geometry();
    }

    int __Qt4Ada_QGridLayout_indexOf_wrapper(QObject*cpp_this,QObject*_p1)
    {
        return (dynamic_cast<QGridLayout*>(cpp_this))->QGridLayout::indexOf(dynamic_cast<QWidget*>(_p1));
    }

    void __Qt4Ada_QGridLayout_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QGridLayoutDirector*>(cpp_this))->QGridLayout::connectNotify(_p1);
    }

    void __Qt4Ada_QGridLayout_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QGridLayoutDirector*>(cpp_this))->QGridLayout::disconnectNotify(_p1);
    }

    void __Qt4Ada_QGridLayout_addLayout_wrapper(QObject* cpp_this,
                                                QObject* layout,
                                                int      row,
                                                int      column,
                                                unsigned alignment)
    {
        (dynamic_cast<QGridLayout*>(cpp_this))->
                  QGridLayout::addLayout(dynamic_cast<QLayout*>(layout),
                                         row,
                                         column,
                                         Qt::Alignment(alignment));
    }

    void __Qt4Ada_QGridLayout_addWidget_wrapper(QObject* cpp_this,
                                                QObject* widget,
                                                int      row,
                                                int      column,
                                                unsigned alignment)
    {
        (dynamic_cast<QGridLayout*>(cpp_this))->
                  QGridLayout::addWidget(dynamic_cast<QWidget*>(widget),
                                         row,
                                         column,
                                         Qt::Alignment(alignment));
    }

    void __Qt4Ada_QGridLayout_setColumnStretch_wrapper
                (QObject* cpp_this, int column, int stretch)
    {
        (dynamic_cast<QGridLayout*>(cpp_this))->
                 QGridLayout::setColumnStretch (column, stretch);
    }

    void __Qt4Ada_QGridLayout_addWidget_with_multiply_rows_columns_wrapper (QObject*cpp_this,
                                                                            QObject*widget,
                                                                            int fromRow,
                                                                            int fromColumn,
                                                                            int rowSpan,
                                                                            int columnSpan,
                                                                            unsigned alignment)
    {
         (dynamic_cast<QGridLayout*>(cpp_this))-> QGridLayout::addWidget(dynamic_cast<QWidget*>(widget),
                                                                         fromRow,
                                                                         fromColumn,
                                                                         rowSpan,
                                                                         columnSpan,
                                                                         Qt::Alignment(alignment));
    }
}
