//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QHEADERVIEWDIRECTOR_H__
#define __QHEADERVIEWDIRECTOR_H__

#include <QHeaderView>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QHeaderView_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern QSize* __Qt4Ada_QHeaderView_sectionSizeFromContents_0_dispatch(void*, int);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QHeaderView_cascadingSectionResizes_0_wrapper(QObject*);
    extern int __Qt4Ada_QHeaderView_count_0_wrapper(QObject*);
    extern Qt::Alignment __Qt4Ada_QHeaderView_defaultAlignment_0_wrapper(QObject*);
    extern int __Qt4Ada_QHeaderView_defaultSectionSize_0_wrapper(QObject*);
    extern int __Qt4Ada_QHeaderView_hiddenSectionCount_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_hideSection_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QHeaderView_highlightSections_0_wrapper(QObject*);
    extern bool __Qt4Ada_QHeaderView_isClickable_0_wrapper(QObject*);
    extern bool __Qt4Ada_QHeaderView_isMovable_0_wrapper(QObject*);
    extern bool __Qt4Ada_QHeaderView_isSectionHidden_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QHeaderView_isSortIndicatorShown_0_wrapper(QObject*);
    extern int __Qt4Ada_QHeaderView_length_0_wrapper(QObject*);
    extern int __Qt4Ada_QHeaderView_logicalIndex_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QHeaderView_logicalIndexAt_2_wrapper(QObject*, int);
    extern int __Qt4Ada_QHeaderView_logicalIndexAt_1_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QHeaderView_logicalIndexAt_0_wrapper(QObject*, const QPoint*);
    extern int __Qt4Ada_QHeaderView_minimumSectionSize_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_moveSection_0_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QHeaderView_offset_0_wrapper(QObject*);
    extern Qt::Orientation __Qt4Ada_QHeaderView_orientation_0_wrapper(QObject*);
    extern QHeaderView::ResizeMode __Qt4Ada_QHeaderView_resizeMode_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_resizeSection_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QHeaderView_resizeSections_0_wrapper(QObject*, QHeaderView::ResizeMode);
    extern bool __Qt4Ada_QHeaderView_restoreState_0_wrapper(QObject*, const QByteArray*);
    extern void __Qt4Ada_QHeaderView_saveState_0_wrapper(QObject*, QByteArray*);
    extern int __Qt4Ada_QHeaderView_sectionPosition_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QHeaderView_sectionSize_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QHeaderView_sectionSizeHint_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QHeaderView_sectionViewportPosition_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QHeaderView_sectionsHidden_0_wrapper(QObject*);
    extern bool __Qt4Ada_QHeaderView_sectionsMoved_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_setCascadingSectionResizes_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QHeaderView_setClickable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QHeaderView_setDefaultAlignment_0_wrapper(QObject*, Qt::Alignment);
    extern void __Qt4Ada_QHeaderView_setDefaultSectionSize_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_setHighlightSections_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QHeaderView_setMinimumSectionSize_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_setMovable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QHeaderView_setResizeMode_1_wrapper(QObject*, QHeaderView::ResizeMode);
    extern void __Qt4Ada_QHeaderView_setResizeMode_0_wrapper(QObject*, int, QHeaderView::ResizeMode);
    extern void __Qt4Ada_QHeaderView_setSectionHidden_0_wrapper(QObject*, int, bool);
    extern void __Qt4Ada_QHeaderView_setSortIndicator_0_wrapper(QObject*, int, Qt::SortOrder);
    extern void __Qt4Ada_QHeaderView_setSortIndicatorShown_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QHeaderView_setStretchLastSection_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QHeaderView_showSection_0_wrapper(QObject*, int);
    extern Qt::SortOrder __Qt4Ada_QHeaderView_sortIndicatorOrder_0_wrapper(QObject*);
    extern int __Qt4Ada_QHeaderView_sortIndicatorSection_0_wrapper(QObject*);
    extern bool __Qt4Ada_QHeaderView_stretchLastSection_0_wrapper(QObject*);
    extern int __Qt4Ada_QHeaderView_stretchSectionCount_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_swapSections_0_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QHeaderView_visualIndex_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QHeaderView_visualIndexAt_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    extern void __Qt4Ada_QHeaderView_setOffset_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_setOffsetToLastSection_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_setOffsetToSectionPosition_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_geometriesChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_sectionAutoResize_0_wrapper(QObject*, int, QHeaderView::ResizeMode);
    extern void __Qt4Ada_QHeaderView_sectionClicked_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_sectionCountChanged_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QHeaderView_sectionDoubleClicked_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_sectionEntered_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_sectionHandleDoubleClicked_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_sectionMoved_0_wrapper(QObject*, int, int, int);
    extern void __Qt4Ada_QHeaderView_sectionPressed_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QHeaderView_sectionResized_0_wrapper(QObject*, int, int, int);
    extern void __Qt4Ada_QHeaderView_sortIndicatorChanged_0_wrapper(QObject*, int, Qt::SortOrder);
    extern void __Qt4Ada_QHeaderView_sectionSizeFromContents_0_wrapper(QObject*, int, QSize*);
    extern void __Qt4Ada_QHeaderView_reset_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_setModel_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QHeaderView_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QHeaderView_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QHeaderView_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern bool __Qt4Ada_QHeaderView_event_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QHeaderView_horizontalOffset_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_indexAt_0_wrapper(QObject*, const QPoint*, QModelIndex*);
    extern bool __Qt4Ada_QHeaderView_isIndexHidden_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QHeaderView_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QHeaderView_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QHeaderView_scrollTo_0_wrapper(QObject*, const QModelIndex*, QAbstractItemView::ScrollHint);
    extern int __Qt4Ada_QHeaderView_verticalOffset_0_wrapper(QObject*);
    extern bool __Qt4Ada_QHeaderView_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_visualRect_0_wrapper(QObject*, const QModelIndex*, QRect*);
    extern void __Qt4Ada_QHeaderView_visualRegionForSelection_0_wrapper(QObject*, const QItemSelection*, QRegion*);
    extern void __Qt4Ada_QHeaderView_activated_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QHeaderView_clicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QHeaderView_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QHeaderView_entered_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QHeaderView_pressed_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QHeaderView_viewportEntered_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    extern void __Qt4Ada_QHeaderView_executeDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QHeaderView_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    extern void __Qt4Ada_QHeaderView_commitData_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QHeaderView_editorDestroyed_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QHeaderView_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QHeaderView_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    extern void __Qt4Ada_QHeaderView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QHeaderView_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QHeaderView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QHeaderView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QHeaderView_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QHeaderView_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QHeaderView_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QHeaderView_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QHeaderView_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QHeaderView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QHeaderView_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QHeaderView_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QHeaderView_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QHeaderView_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QHeaderView_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
extern "C" {

   extern void __Qt4Ada_QHeaderView_moveCursor_wrapper (QObject*, unsigned, unsigned,QModelIndex*);
   extern void __Qt4Ada_QHeaderView_setSelection_wrapper (QObject*, QRect*, unsigned);

}

class QHeaderViewDirector : public QHeaderView
{
protected:
    void* ada_object;
    QHeaderViewDirector();

    friend void __Qt4Ada_QHeaderView_moveCursor_wrapper(QObject*, unsigned, unsigned,QModelIndex*);
    friend void __Qt4Ada_QHeaderView_setSelection_wrapper(QObject*, QRect*, unsigned);

    virtual QSize sectionSizeFromContents(int) const;
    virtual void reset();
    virtual void setModel(QAbstractItemModel*);
    virtual QSize sizeHint() const;
    virtual void currentChanged(const QModelIndex&, const QModelIndex&);
    virtual void dataChanged(const QModelIndex&, const QModelIndex&);
    virtual bool event(QEvent*);
    virtual int horizontalOffset() const;
    virtual QModelIndex indexAt(const QPoint&) const;
    virtual bool isIndexHidden(const QModelIndex&) const;
    virtual void paintEvent(QPaintEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void rowsInserted(const QModelIndex&, int, int);
    virtual void scrollContentsBy(int, int);
    virtual void scrollTo(const QModelIndex&, QAbstractItemView::ScrollHint);
    virtual int verticalOffset() const;
    virtual bool viewportEvent(QEvent*);
    virtual QRect visualRect(const QModelIndex&) const;
    virtual QRegion visualRegionForSelection(const QItemSelection&) const;
    virtual void keyboardSearch(const QString&);
    virtual void setSelectionModel(QItemSelectionModel*);
    virtual int sizeHintForColumn(int) const;
    virtual int sizeHintForRow(int) const;
    virtual void selectAll();
    virtual void setRootIndex(const QModelIndex&);
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void commitData(QWidget*);
    virtual void editorDestroyed(QObject*);
    virtual void rowsAboutToBeRemoved(const QModelIndex&, int, int);
    virtual void selectionChanged(const QItemSelection&, const QItemSelection&);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual QSize minimumSizeHint() const;
    virtual void wheelEvent(QWheelEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QHeaderView_geometriesChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QHeaderView_sectionAutoResize_0_wrapper(QObject*, int, QHeaderView::ResizeMode);
    friend void __Qt4Ada_QHeaderView_sectionClicked_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QHeaderView_sectionCountChanged_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QHeaderView_sectionDoubleClicked_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QHeaderView_sectionEntered_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QHeaderView_sectionHandleDoubleClicked_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QHeaderView_sectionMoved_0_wrapper(QObject*, int, int, int);
    friend void __Qt4Ada_QHeaderView_sectionPressed_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QHeaderView_sectionResized_0_wrapper(QObject*, int, int, int);
    friend void __Qt4Ada_QHeaderView_sortIndicatorChanged_0_wrapper(QObject*, int, Qt::SortOrder);
    friend void __Qt4Ada_QHeaderView_sectionSizeFromContents_0_wrapper(QObject*, int, QSize*);
    friend void __Qt4Ada_QHeaderView_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QHeaderView_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend bool __Qt4Ada_QHeaderView_event_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QHeaderView_horizontalOffset_0_wrapper(QObject*);
    friend void __Qt4Ada_QHeaderView_indexAt_0_wrapper(QObject*, const QPoint*, QModelIndex*);
    friend bool __Qt4Ada_QHeaderView_isIndexHidden_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QHeaderView_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QHeaderView_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QHeaderView_scrollTo_0_wrapper(QObject*, const QModelIndex*, QAbstractItemView::ScrollHint);
    friend int __Qt4Ada_QHeaderView_verticalOffset_0_wrapper(QObject*);
    friend bool __Qt4Ada_QHeaderView_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_visualRect_0_wrapper(QObject*, const QModelIndex*, QRect*);
    friend void __Qt4Ada_QHeaderView_visualRegionForSelection_0_wrapper(QObject*, const QItemSelection*, QRegion*);
    friend void __Qt4Ada_QHeaderView_activated_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QHeaderView_clicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QHeaderView_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QHeaderView_entered_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QHeaderView_pressed_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QHeaderView_viewportEntered_0_wrapper(QObject*);
    friend void __Qt4Ada_QHeaderView_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    friend void __Qt4Ada_QHeaderView_executeDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QHeaderView_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QHeaderView_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QHeaderView_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    friend void __Qt4Ada_QHeaderView_commitData_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QHeaderView_editorDestroyed_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QHeaderView_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QHeaderView_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    friend void __Qt4Ada_QHeaderView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QHeaderView_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QHeaderView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QHeaderView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend void __Qt4Ada_QHeaderView_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QHeaderView_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QHeaderView_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QHeaderView_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QHeaderView_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QHeaderView_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QHeaderView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QHeaderView_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QHeaderView_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QHeaderView_sender_0_wrapper(QObject*);
};

#endif // __QHEADERVIEWDIRECTOR_H__
