//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QPixmap>
#include <QSize>
#include <QString>
#include <QVariant>
#include "qiconwrapper.h"

extern "C"
{

    QIcon* __QtAda_inititialize_QIcon(void* storage)
    {
        return new (storage) QIcon();
    }

    QIcon* __QtAda_inititialize_QIcon_QPixmapCR(void* storage, const QPixmap* pixmap)
    {
        return new (storage) QIcon(*pixmap);
    }

    QIcon* __QtAda_inititialize_QIcon_QStringCR(void* storage, const QString* fileName)
    {
        return new (storage) QIcon(*fileName);
    }

    QIcon* __QtAda_adjust_QIcon(void* storage, const QIcon* from)
    {
        return new (storage) QIcon(*from);
    }

    void __QtAda_finalize_QIcon(QIcon *item)
    {
        item->~QIcon();
    }

    void __QtAda_QIcon_actualSize_QSizeCR_Mode_State_Q(QSize* returns, const QIcon* self, const QSize* size, unsigned mode, unsigned state)
    {
        *returns = self->actualSize(*size, (QIcon::Mode)mode, (QIcon::State)state);
    }

    void __QtAda_QIcon_addFile_QStringCR_QSizeCR_Mode_State(QIcon* self, const QString* fileName, const QSize* size, unsigned mode, unsigned state)
    {
        self->addFile(*fileName, *size, (QIcon::Mode)mode, (QIcon::State)state);
    }

    void __QtAda_QIcon_addPixmap_QPixmapCR_Mode_State(QIcon* self, const QPixmap* pixmap, unsigned mode, unsigned state)
    {
        self->addPixmap(*pixmap, (QIcon::Mode)mode, (QIcon::State)state);
    }

    unsigned __QtAda_QIcon_isNull_Q(const QIcon* self)
    {
        return (unsigned)self->isNull();
    }

    void __QtAda_QIcon_pixmap_QSizeCR_Mode_State_Q(QPixmap* returns, const QIcon* self, const QSize* size, unsigned mode, unsigned state)
    {
        *returns = self->pixmap(*size, (QIcon::Mode)mode, (QIcon::State)state);
    }

    void __QtAda_QIcon_pixmap_int_int_Mode_State_Q(QPixmap* returns, const QIcon* self, int w, int h, unsigned mode, unsigned state)
    {
        *returns = self->pixmap(w, h, (QIcon::Mode)mode, (QIcon::State)state);
    }

    void __QtAda_QIcon_pixmap_int_Mode_State_Q(QPixmap* returns, const QIcon* self, int extent, unsigned mode, unsigned state)
    {
        *returns = self->pixmap(extent, (QIcon::Mode)mode, (QIcon::State)state);
    }

    void __QtAda_QIcon_operator_QVariant(QVariant* returns, const QIcon* self)
    {
        *returns = QVariant(*self);
    }

    void __QtAda_QVariant_value_QIcon(QIcon* returns, const QVariant* self)
    {
        *returns = self->value<QIcon>();
    }

};
