//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QKeySequence>

extern "C"
{
    extern QKeySequence* __QtAda_inititialize_QKeySequence(void*);
    extern QKeySequence* __QtAda_inititialize_QKeySequence_QStringCR(void*, const QString*);
    extern QKeySequence* __QtAda_inititialize_QKeySequence_int_int_int_int(void*, int, int, int, int);
    extern QKeySequence* __QtAda_inititialize_QKeySequence_StandardKey(void*, unsigned);
    extern QKeySequence* __QtAda_adjust_QKeySequence(void*, const QKeySequence*);
    extern void __QtAda_finalize_QKeySequence(QKeySequence*);

    extern uint __QtAda_QKeySequence_count_Q(const QKeySequence*);
    extern unsigned __QtAda_QKeySequence_isEmpty_Q(const QKeySequence*);
    extern unsigned __QtAda_QKeySequence_matches_QKeySequenceCR_Q(const QKeySequence*, const QKeySequence*);
    extern void __QtAda_QKeySequence_toString_SequenceFormat_Q(QString*, const QKeySequence*, unsigned);
    extern unsigned __QtAda_QKeySequence_lt_QKeySequenceCR_Q(const QKeySequence*, const QKeySequence*);
    extern unsigned __QtAda_QKeySequence_le_QKeySequenceCR_Q(const QKeySequence*, const QKeySequence*);
    extern unsigned __QtAda_QKeySequence_eq_QKeySequenceCR_Q(const QKeySequence*, const QKeySequence*);
    extern unsigned __QtAda_QKeySequence_gt_QKeySequenceCR_Q(const QKeySequence*, const QKeySequence*);
    extern unsigned __QtAda_QKeySequence_ge_QKeySequenceCR_Q(const QKeySequence*, const QKeySequence*);
    extern void __QtAda_QKeySequence_fromString_QStringCR_SequenceFormat_S(QKeySequence*, const QString*, unsigned);
    extern void __QtAda_QKeySequence_keyBindings_StandardKey_S(QList<QKeySequence>*, unsigned);
    extern void __QtAda_QKeySequence_mnemonic_QStringCR_S(QKeySequence*, const QString*);

};

