//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QString>
#include <QSize>
#include <QContextMenuEvent>
#include <QFocusEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qlabeldirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QLabel_staticMetaObject =
        &QLabel::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    QObject* __Qt4Ada_QLabel_buddy_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QLabel*>(cpp_object)->QLabel::buddy());
    }

    bool __Qt4Ada_QLabel_hasScaledContents_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLabel*>(cpp_object)->QLabel::hasScaledContents();
    }

    int __Qt4Ada_QLabel_indent_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLabel*>(cpp_object)->QLabel::indent();
    }

    int __Qt4Ada_QLabel_margin_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLabel*>(cpp_object)->QLabel::margin();
    }

    bool __Qt4Ada_QLabel_openExternalLinks_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLabel*>(cpp_object)->QLabel::openExternalLinks();
    }

    void __Qt4Ada_QLabel_setBuddy_0_wrapper(QObject* cpp_object, QObject* buddy)
    {
        dynamic_cast<QLabel*>(cpp_object)->QLabel::setBuddy(dynamic_cast<QWidget*>(buddy));
    }

    void __Qt4Ada_QLabel_setIndent_0_wrapper(QObject* cpp_object, int indent)
    {
        dynamic_cast<QLabel*>(cpp_object)->QLabel::setIndent(indent);
    }

    void __Qt4Ada_QLabel_setMargin_0_wrapper(QObject* cpp_object, int margin)
    {
        dynamic_cast<QLabel*>(cpp_object)->QLabel::setMargin(margin);
    }

    void __Qt4Ada_QLabel_setOpenExternalLinks_0_wrapper(QObject* cpp_object, bool open)
    {
        dynamic_cast<QLabel*>(cpp_object)->QLabel::setOpenExternalLinks(open);
    }

    void __Qt4Ada_QLabel_setPixmap_0_wrapper(QObject* cpp_object, const QPixmap* pixmap)
    {
        dynamic_cast<QLabel*>(cpp_object)->QLabel::setPixmap(*pixmap);
    }

    void __Qt4Ada_QLabel_setScaledContents_0_wrapper(QObject* cpp_object, bool scaled)
    {
        dynamic_cast<QLabel*>(cpp_object)->QLabel::setScaledContents(scaled);
    }

    void __Qt4Ada_QLabel_setWordWrap_0_wrapper(QObject* cpp_object, bool on)
    {
        dynamic_cast<QLabel*>(cpp_object)->QLabel::setWordWrap(on);
    }

    void __Qt4Ada_QLabel_text_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QLabel*>(cpp_object)->QLabel::text();
    }

    bool __Qt4Ada_QLabel_wordWrap_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLabel*>(cpp_object)->QLabel::wordWrap();
    }

    void __Qt4Ada_QLabel_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLabel*>(cpp_object)->QLabel::clear();
    }

    void __Qt4Ada_QLabel_setNum_0_wrapper(QObject* cpp_object, int num)
    {
        dynamic_cast<QLabel*>(cpp_object)->QLabel::setNum(num);
    }

    void __Qt4Ada_QLabel_setText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QLabel*>(cpp_object)->QLabel::setText(*text);
    }

    void __Qt4Ada_QLabel_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QLabel*>(cpp_object)->QLabel::sizeHint();
    }

    void __Qt4Ada_QLabel_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QLabel*>(cpp_object)->QLabel::minimumSizeHint();
    }

    void __Qt4Ada_QLabel_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::changeEvent(event);
    }

    void __Qt4Ada_QLabel_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    bool __Qt4Ada_QLabel_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::event(e);
    }

    void __Qt4Ada_QLabel_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QLabel_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::focusNextPrevChild(next);
    }

    void __Qt4Ada_QLabel_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QLabel_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QLabel_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLabel_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLabel_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLabel_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QLabel::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QLabel_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QLabel_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QLabel_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QLabel_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QLabel_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QLabel_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QLabel_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QLabel_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QLabel_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QLabel_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QLabel_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QLabel_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QLabel_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QLabel_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QLabel_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLabel_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QLabel_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QLabel_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QLabel_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QLabel_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QLabel_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QLabel_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QLabelDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QLabel_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QLabel_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QLabel_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLabelDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QLabel_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLabelDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QLabel_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QLabel*>(cpp_this)->QLabel::qt_metacast(name);
    }

    int __Qt4Ada_QLabel_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QLabel*>(cpp_this)->QLabel::qt_metacall(_c, _id, _a);
    }

}

QSize QLabelDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QLabelDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QLabelDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

bool QLabelDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QLabelDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QLabelDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QLabelDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

int QLabelDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QLabelDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QLabelDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QLabelDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QLabelDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QLabelDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QLabelDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QLabelDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QLabelDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QLabelDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QLabelDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QEvent>

QPaintEngine*QLabelDirector::paintEngine()
{
    return __Qt4Ada_QPaintDevice_paintEngine_dispatch(this->ada_object);
}

void QLabelDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QLabelDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    QObject*__Qt4Ada_new_QLabel (QObject*parent, unsigned f)
    {
      return dynamic_cast<QObject *>(new QLabel (dynamic_cast <QWidget*> (parent), (Qt::WindowFlags)f));
    }

    QObject*__Qt4Ada_new_QLabel_With_String (QString*text, QObject*parent, unsigned f)
    {
      return dynamic_cast<QObject *>(new QLabel (*text,dynamic_cast <QWidget*> (parent),(Qt::WindowFlags)f));
    }

    QPaintEngine*__Qt4Ada_QLabel_paintEngine_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QLabel*>(cpp_this))->QLabel::paintEngine();
    }

    void __Qt4Ada_QLabel_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QLabelDirector*>(cpp_this))->QLabel::connectNotify(_p1);
    }

    void __Qt4Ada_QLabel_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QLabelDirector*>(cpp_this))->QLabel::disconnectNotify(_p1);
    }

    void __Qt4Ada_QLabel_setText_wrapper (QObject* cpp_this, QString* text)
    {
        (dynamic_cast<QLabel*>(cpp_this))->setText(*text);
    }

    void __Qt4Ada_QLabel_setAlignment_wrapper (QObject* cpp_this, unsigned value)
    {
        (dynamic_cast<QLabel*>(cpp_this))->setAlignment((Qt::Alignment)value);
    }

    void __Qt4Ada_QLabel_setTextInteractionFlags_wrapper (QObject* cpp_this, unsigned value)
    {
        (dynamic_cast<QLabel*>(cpp_this))->setTextInteractionFlags((Qt::TextInteractionFlags)value);
    }

}
