//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QSize>
#include <QChildEvent>
#include <QTimerEvent>

#include "qlayoutdirector.h"
#include "qobjectdirector.h"
#include "qlayoutitemdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QLayout_staticMetaObject =
        &QLayout::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QLayout_addItem_0_virtual(QObject* cpp_object, QLayoutItem* item)
    {
        dynamic_cast<QLayout*>(cpp_object)->addItem(item);
    }

    int __Qt4Ada_QLayout_count_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QLayout*>(cpp_object)->count();
    }

    int __Qt4Ada_QLayout_indexOf_0_virtual(QObject* cpp_object, QObject* widget)
    {
        return dynamic_cast<QLayout*>(cpp_object)->indexOf(dynamic_cast<QWidget*>(widget));
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QLayout_activate_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLayout*>(cpp_object)->QLayout::activate();
    }

    void __Qt4Ada_QLayout_addWidget_0_wrapper(QObject* cpp_object, QObject* w)
    {
        dynamic_cast<QLayout*>(cpp_object)->QLayout::addWidget(dynamic_cast<QWidget*>(w));
    }

    int __Qt4Ada_QLayout_indexOf_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        return dynamic_cast<QLayout*>(cpp_object)->QLayout::indexOf(dynamic_cast<QWidget*>(widget));
    }

    bool __Qt4Ada_QLayout_isEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLayout*>(cpp_object)->QLayout::isEnabled();
    }

    int __Qt4Ada_QLayout_margin_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLayout*>(cpp_object)->QLayout::margin();
    }

    QObject* __Qt4Ada_QLayout_menuBar_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QLayout*>(cpp_object)->QLayout::menuBar());
    }

    QObject* __Qt4Ada_QLayout_parentWidget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QLayout*>(cpp_object)->QLayout::parentWidget());
    }

    void __Qt4Ada_QLayout_removeItem_0_wrapper(QObject* cpp_object, QLayoutItem* item)
    {
        dynamic_cast<QLayout*>(cpp_object)->QLayout::removeItem(item);
    }

    void __Qt4Ada_QLayout_removeWidget_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QLayout*>(cpp_object)->QLayout::removeWidget(dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QLayout_setContentsMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QLayout*>(cpp_object)->QLayout::setContentsMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QLayout_setEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QLayout*>(cpp_object)->QLayout::setEnabled(enable);
    }

    void __Qt4Ada_QLayout_setMargin_0_wrapper(QObject* cpp_object, int margin)
    {
        dynamic_cast<QLayout*>(cpp_object)->QLayout::setMargin(margin);
    }

    void __Qt4Ada_QLayout_setMenuBar_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QLayout*>(cpp_object)->QLayout::setMenuBar(dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QLayout_setSpacing_0_wrapper(QObject* cpp_object, int margin)
    {
        dynamic_cast<QLayout*>(cpp_object)->QLayout::setSpacing(margin);
    }

    int __Qt4Ada_QLayout_spacing_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLayout*>(cpp_object)->QLayout::spacing();
    }

    void __Qt4Ada_QLayout_update_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLayout*>(cpp_object)->QLayout::update();
    }

    bool __Qt4Ada_QLayout_isEmpty_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLayout*>(cpp_object)->QLayout::isEmpty();
    }

    void __Qt4Ada_QLayout_minimumSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QLayout*>(cpp_object)->QLayout::minimumSize();
    }

    void __Qt4Ada_QLayout_maximumSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QLayout*>(cpp_object)->QLayout::maximumSize();
    }

    void __Qt4Ada_QLayout_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLayoutDirector*>(cpp_object)->QLayout::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QLayout_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLayoutDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QLayout_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLayoutDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QLayout_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLayoutDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QLayout_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QLayout*>(cpp_this)->QLayout::qt_metacast(name);
    }

    int __Qt4Ada_QLayout_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QLayout*>(cpp_this)->QLayout::qt_metacall(_c, _id, _a);
    }

}

void QLayoutDirector::addItem(QLayoutItem* item)
{
    __Qt4Ada_QLayout_addItem_0_dispatch(this->ada_object, item);
}

int QLayoutDirector::count() const
{
    return __Qt4Ada_QLayout_count_0_dispatch(this->ada_object);
}

int QLayoutDirector::indexOf(QWidget* widget) const
{
    return __Qt4Ada_QLayout_indexOf_0_dispatch(this->ada_object, widget);
}

bool QLayoutDirector::isEmpty() const
{
    return __Qt4Ada_QLayoutItem_isEmpty_0_dispatch(this->ada_object);
}

QSize QLayoutDirector::minimumSize() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_minimumSize_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QLayoutDirector::maximumSize() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_maximumSize_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QLayoutDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

bool QLayoutDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QLayoutDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QLayoutDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QLayoutDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

bool QLayoutDirector::hasHeightForWidth() const
{
    return __Qt4Ada_QLayoutItem_hasHeightForWidth_0_dispatch(this->ada_object);
}

int QLayoutDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QLayoutItem_heightForWidth_0_dispatch(this->ada_object, w);
}

void QLayoutDirector::invalidate()
{
    __Qt4Ada_QLayoutItem_invalidate_0_dispatch(this->ada_object);
}

QLayout* QLayoutDirector::layout()
{
    return dynamic_cast<QLayout*>(__Qt4Ada_QLayoutItem_layout_0_dispatch(this->ada_object));
}

int QLayoutDirector::minimumHeightForWidth(int w) const
{
    return __Qt4Ada_QLayoutItem_minimumHeightForWidth_0_dispatch(this->ada_object, w);
}

QSize QLayoutDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QLayoutItem_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QWidget* QLayoutDirector::widget()
{
    return dynamic_cast<QWidget*>(__Qt4Ada_QLayoutItem_widget_0_dispatch(this->ada_object));
}

const QMetaObject* QLayoutDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QLayoutDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QLayoutDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

Qt::Orientations QLayoutDirector::expandingDirections()
{
    return __Qt4Ada_QLayout_expandingDirections_dispatch(this->ada_object);
}

extern "C" {

    Qt::Orientations __Qt4Ada_QLayout_expandingDirections_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QLayout*>(cpp_this))->QLayout::expandingDirections();
    }

    Qt::Orientations __Qt4Ada_QLayout_expandingDirections_virtual(QObject*cpp_this)
    {
        return (dynamic_cast<QLayout*>(cpp_this))->expandingDirections();
    }

}
