//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSize>
#include <QPaintEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qlcdnumberdirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QLCDNumber_staticMetaObject =
        &QLCDNumber::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QLCDNumber_checkOverflow_1_wrapper(QObject* cpp_object, int num)
    {
        return dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::checkOverflow(num);
    }

    bool __Qt4Ada_QLCDNumber_checkOverflow_0_wrapper(QObject* cpp_object, double num)
    {
        return dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::checkOverflow(num);
    }

    int __Qt4Ada_QLCDNumber_intValue_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::intValue();
    }

    QLCDNumber::Mode __Qt4Ada_QLCDNumber_mode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::mode();
    }

    int __Qt4Ada_QLCDNumber_numDigits_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::numDigits();
    }

    QLCDNumber::SegmentStyle __Qt4Ada_QLCDNumber_segmentStyle_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::segmentStyle();
    }

    void __Qt4Ada_QLCDNumber_setMode_0_wrapper(QObject* cpp_object, QLCDNumber::Mode mode)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::setMode(mode);
    }

    void __Qt4Ada_QLCDNumber_setNumDigits_0_wrapper(QObject* cpp_object, int nDigits)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::setNumDigits(nDigits);
    }

    void __Qt4Ada_QLCDNumber_setSegmentStyle_0_wrapper(QObject* cpp_object, QLCDNumber::SegmentStyle style)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::setSegmentStyle(style);
    }

    bool __Qt4Ada_QLCDNumber_smallDecimalPoint_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::smallDecimalPoint();
    }

    double __Qt4Ada_QLCDNumber_value_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::value();
    }

    void __Qt4Ada_QLCDNumber_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::sizeHint();
    }

    void __Qt4Ada_QLCDNumber_display_2_wrapper(QObject* cpp_object, const QString* str)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::display(*str);
    }

    void __Qt4Ada_QLCDNumber_display_1_wrapper(QObject* cpp_object, int num)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::display(num);
    }

    void __Qt4Ada_QLCDNumber_display_0_wrapper(QObject* cpp_object, double num)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::display(num);
    }

    void __Qt4Ada_QLCDNumber_setBinMode_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::setBinMode();
    }

    void __Qt4Ada_QLCDNumber_setDecMode_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::setDecMode();
    }

    void __Qt4Ada_QLCDNumber_setHexMode_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::setHexMode();
    }

    void __Qt4Ada_QLCDNumber_setOctMode_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::setOctMode();
    }

    void __Qt4Ada_QLCDNumber_setSmallDecimalPoint_0_wrapper(QObject* cpp_object, bool e)
    {
        dynamic_cast<QLCDNumber*>(cpp_object)->QLCDNumber::setSmallDecimalPoint(e);
    }

    void __Qt4Ada_QLCDNumber_overflow_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QLCDNumber::overflow();
    }

    bool __Qt4Ada_QLCDNumber_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QLCDNumberDirector*>(cpp_object)->QLCDNumber::event(e);
    }

    void __Qt4Ada_QLCDNumber_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QLCDNumber::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QLCDNumber_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QLCDNumber_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QLCDNumber_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QLCDNumber_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QLCDNumber_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QLCDNumber_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QLCDNumber_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QLCDNumber_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QLCDNumber_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QLCDNumber_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QLCDNumber_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QLCDNumberDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QLCDNumber_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QLCDNumber_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QLCDNumber_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLCDNumberDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QLCDNumber_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLCDNumberDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QLCDNumber_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QLCDNumber*>(cpp_this)->QLCDNumber::qt_metacast(name);
    }

    int __Qt4Ada_QLCDNumber_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QLCDNumber*>(cpp_this)->QLCDNumber::qt_metacall(_c, _id, _a);
    }

}

QSize QLCDNumberDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QLCDNumberDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QLCDNumberDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QLCDNumberDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QLCDNumberDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QLCDNumberDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QLCDNumberDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QLCDNumberDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QLCDNumberDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QLCDNumberDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QLCDNumberDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QLCDNumberDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QLCDNumberDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QLCDNumberDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QLCDNumberDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QLCDNumberDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QLCDNumberDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QLCDNumberDirector::QLCDNumberDirector(void* self, QWidget* parent) :
    QLCDNumber (parent),
    ada_object (self)
{
}

QLCDNumberDirector::QLCDNumberDirector(void* self, uint numDigits, QWidget* parent) :
    QLCDNumber (numDigits, parent),
    ada_object (self)
{
}

QPaintEngine*QLCDNumberDirector::paintEngine()
{
    return __Qt4Ada_QPaintDevice_paintEngine_dispatch(this->ada_object);
}

void QLCDNumberDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QLCDNumberDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    QObject* __Qt4Ada_new_QLCDNumber (uint numDigits, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QLCDNumber (numDigits, dynamic_cast <QWidget*> (parent)));
    }

    QObject* __QtAda_new_QLCDNumberDirector_unsigned_QWidgetP(void* self, uint numDigits, QObject* parent)
    {
        return static_cast<QObject*>(new QLCDNumberDirector(self, numDigits, dynamic_cast<QWidget*>(parent)));
    }

    QObject* __QtAda_new_QLCDNumberDirector_QWidgetP(void* self, QObject* parent)
    {
        return static_cast<QObject*>(new QLCDNumberDirector(self, dynamic_cast<QWidget*>(parent)));
    }

    QPaintEngine*__Qt4Ada_QLCDNumber_paintEngine_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QLCDNumber*>(cpp_this))->QLCDNumber::paintEngine();
    }

    void __Qt4Ada_QLCDNumber_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QLCDNumberDirector*>(cpp_this))->QLCDNumber::connectNotify(_p1);
    }

    void __Qt4Ada_QLCDNumber_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QLCDNumberDirector*>(cpp_this))->QLCDNumber::disconnectNotify(_p1);
    }

    void __Qt4Ada_QLCDNumber_setSegmentStyle_wrapper (QObject* cpp_this, QLCDNumber::SegmentStyle style)
    {
       dynamic_cast <QLCDNumber*>(cpp_this)->setSegmentStyle (style);
    }

}
