//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QLCDNUMBERDIRECTOR_H__
#define __QLCDNUMBERDIRECTOR_H__

#include <QLCDNumber>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QLCDNumber_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QLCDNumber_checkOverflow_1_wrapper(QObject*, int);
    extern bool __Qt4Ada_QLCDNumber_checkOverflow_0_wrapper(QObject*, double);
    extern int __Qt4Ada_QLCDNumber_intValue_0_wrapper(QObject*);
    extern QLCDNumber::Mode __Qt4Ada_QLCDNumber_mode_0_wrapper(QObject*);
    extern int __Qt4Ada_QLCDNumber_numDigits_0_wrapper(QObject*);
    extern QLCDNumber::SegmentStyle __Qt4Ada_QLCDNumber_segmentStyle_0_wrapper(QObject*);
    extern void __Qt4Ada_QLCDNumber_setMode_0_wrapper(QObject*, QLCDNumber::Mode);
    extern void __Qt4Ada_QLCDNumber_setNumDigits_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QLCDNumber_setSegmentStyle_0_wrapper(QObject*, QLCDNumber::SegmentStyle);
    extern bool __Qt4Ada_QLCDNumber_smallDecimalPoint_0_wrapper(QObject*);
    extern double __Qt4Ada_QLCDNumber_value_0_wrapper(QObject*);
    extern void __Qt4Ada_QLCDNumber_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QLCDNumber_display_2_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QLCDNumber_display_1_wrapper(QObject*, int);
    extern void __Qt4Ada_QLCDNumber_display_0_wrapper(QObject*, double);
    extern void __Qt4Ada_QLCDNumber_setBinMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QLCDNumber_setDecMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QLCDNumber_setHexMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QLCDNumber_setOctMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QLCDNumber_setSmallDecimalPoint_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QLCDNumber_overflow_0_wrapper(QObject*);
    extern bool __Qt4Ada_QLCDNumber_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QLCDNumber_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QLCDNumber_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QLCDNumber_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QLCDNumber_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QLCDNumber_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QLCDNumber_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QLCDNumber_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QLCDNumber_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QLCDNumber_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QLCDNumber_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QLCDNumber_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QLCDNumber_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QLCDNumber_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject* __Qt4Ada_new_QLCDNumber (uint numDigits, QObject* parent);
    extern QObject* __QtAda_new_QLCDNumberDirector_unsigned_QWidgetP(void*, uint, QObject*);
    extern QObject* __QtAda_new_QLCDNumberDirector_QWidgetP(void*, QObject*);

    //  Declarations of wrapper functions for static call

    extern QPaintEngine*__Qt4Ada_QLCDNumber_paintEngine_wrapper(QObject*);
    extern void __Qt4Ada_QLCDNumber_connectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QLCDNumber_disconnectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QLCDNumber_setSegmentStyle_wrapper
                    (QObject*, QLCDNumber::SegmentStyle);
}

class QLCDNumberDirector : public QLCDNumber
{
protected:
    void* ada_object;
    QLCDNumberDirector(void*, QWidget*);
    QLCDNumberDirector(void*, uint, QWidget*);

    virtual QPaintEngine*paintEngine();
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

    friend void __Qt4Ada_QLCDNumber_connectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QLCDNumber_disconnectNotify_wrapper(QObject*,const char*);
    friend QObject* __QtAda_new_QLCDNumberDirector_unsigned_QWidgetP(void*, uint, QObject*);
    friend QObject* __QtAda_new_QLCDNumberDirector_QWidgetP(void*, QObject*);

    virtual QSize sizeHint() const;
    virtual bool event(QEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual QSize minimumSizeHint() const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QLCDNumber_overflow_0_wrapper(QObject*);
    friend bool __Qt4Ada_QLCDNumber_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QLCDNumber_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QLCDNumber_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QLCDNumber_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QLCDNumber_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QLCDNumber_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QLCDNumber_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QLCDNumber_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QLCDNumber_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QLCDNumber_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QLCDNumber_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QLCDNumber_sender_0_wrapper(QObject*);
};

#endif // __QLCDNUMBERDIRECTOR_H__
