//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QMenu>
#include <QCompleter>
#include <QString>
#include <QValidator>
#include <QVariant>
#include <QSize>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qlineeditdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QLineEdit_staticMetaObject =
        &QLineEdit::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QLineEdit_backspace_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::backspace();
    }

    QObject* __Qt4Ada_QLineEdit_createStandardContextMenu_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::createStandardContextMenu());
    }

    QObject* __Qt4Ada_QLineEdit_completer_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::completer());
    }

    int __Qt4Ada_QLineEdit_cursorPosition_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::cursorPosition();
    }

    int __Qt4Ada_QLineEdit_cursorPositionAt_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::cursorPositionAt(*pos);
    }

    void __Qt4Ada_QLineEdit_cursorBackward_0_wrapper(QObject* cpp_object, bool mark, int steps)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::cursorBackward(mark, steps);
    }

    void __Qt4Ada_QLineEdit_cursorForward_0_wrapper(QObject* cpp_object, bool mark, int steps)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::cursorForward(mark, steps);
    }

    void __Qt4Ada_QLineEdit_cursorWordBackward_0_wrapper(QObject* cpp_object, bool mark)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::cursorWordBackward(mark);
    }

    void __Qt4Ada_QLineEdit_cursorWordForward_0_wrapper(QObject* cpp_object, bool mark)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::cursorWordForward(mark);
    }

    void __Qt4Ada_QLineEdit_del_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::del();
    }

    void __Qt4Ada_QLineEdit_deselect_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::deselect();
    }

    void __Qt4Ada_QLineEdit_displayText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::displayText();
    }

    bool __Qt4Ada_QLineEdit_dragEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::dragEnabled();
    }

    QLineEdit::EchoMode __Qt4Ada_QLineEdit_echoMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::echoMode();
    }

    void __Qt4Ada_QLineEdit_end_0_wrapper(QObject* cpp_object, bool mark)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::end(mark);
    }

    bool __Qt4Ada_QLineEdit_hasAcceptableInput_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::hasAcceptableInput();
    }

    bool __Qt4Ada_QLineEdit_hasFrame_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::hasFrame();
    }

    bool __Qt4Ada_QLineEdit_hasSelectedText_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::hasSelectedText();
    }

    void __Qt4Ada_QLineEdit_home_0_wrapper(QObject* cpp_object, bool mark)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::home(mark);
    }

    void __Qt4Ada_QLineEdit_inputMask_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::inputMask();
    }

    void __Qt4Ada_QLineEdit_insert_0_wrapper(QObject* cpp_object, const QString* newText)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::insert(*newText);
    }

    bool __Qt4Ada_QLineEdit_isModified_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::isModified();
    }

    bool __Qt4Ada_QLineEdit_isReadOnly_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::isReadOnly();
    }

    bool __Qt4Ada_QLineEdit_isRedoAvailable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::isRedoAvailable();
    }

    bool __Qt4Ada_QLineEdit_isUndoAvailable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::isUndoAvailable();
    }

    int __Qt4Ada_QLineEdit_maxLength_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::maxLength();
    }

    void __Qt4Ada_QLineEdit_selectedText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::selectedText();
    }

    int __Qt4Ada_QLineEdit_selectionStart_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::selectionStart();
    }

    void __Qt4Ada_QLineEdit_setCompleter_0_wrapper(QObject* cpp_object, QObject* c)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setCompleter(dynamic_cast<QCompleter*>(c));
    }

    void __Qt4Ada_QLineEdit_setCursorPosition_0_wrapper(QObject* cpp_object, int pos)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setCursorPosition(pos);
    }

    void __Qt4Ada_QLineEdit_setDragEnabled_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setDragEnabled(b);
    }

    void __Qt4Ada_QLineEdit_setEchoMode_0_wrapper(QObject* cpp_object, QLineEdit::EchoMode mode)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setEchoMode(mode);
    }

    void __Qt4Ada_QLineEdit_setFrame_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setFrame(b);
    }

    void __Qt4Ada_QLineEdit_setInputMask_0_wrapper(QObject* cpp_object, const QString* inputMask)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setInputMask(*inputMask);
    }

    void __Qt4Ada_QLineEdit_setMaxLength_0_wrapper(QObject* cpp_object, int length)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setMaxLength(length);
    }

    void __Qt4Ada_QLineEdit_setModified_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setModified(b);
    }

    void __Qt4Ada_QLineEdit_setReadOnly_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setReadOnly(b);
    }

    void __Qt4Ada_QLineEdit_setSelection_0_wrapper(QObject* cpp_object, int start, int length)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setSelection(start, length);
    }

    void __Qt4Ada_QLineEdit_setValidator_0_wrapper(QObject* cpp_object, const QObject* v)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setValidator(dynamic_cast<const QValidator*>(v));
    }

    void __Qt4Ada_QLineEdit_text_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::text();
    }

    const QObject* __Qt4Ada_QLineEdit_validator_0_wrapper(QObject* cpp_object)
    {
        return static_cast<const QObject*>(dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::validator());
    }

    void __Qt4Ada_QLineEdit_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::clear();
    }

    void __Qt4Ada_QLineEdit_copy_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::copy();
    }

    void __Qt4Ada_QLineEdit_cut_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::cut();
    }

    void __Qt4Ada_QLineEdit_paste_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::paste();
    }

    void __Qt4Ada_QLineEdit_redo_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::redo();
    }

    void __Qt4Ada_QLineEdit_selectAll_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::selectAll();
    }

    void __Qt4Ada_QLineEdit_setText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::setText(*text);
    }

    void __Qt4Ada_QLineEdit_undo_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::undo();
    }

    bool __Qt4Ada_QLineEdit_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::event(e);
    }

    void __Qt4Ada_QLineEdit_inputMethodQuery_0_wrapper(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::inputMethodQuery(query);
    }

    void __Qt4Ada_QLineEdit_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::sizeHint();
    }

    void __Qt4Ada_QLineEdit_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QLineEdit*>(cpp_object)->QLineEdit::minimumSizeHint();
    }

    void __Qt4Ada_QLineEdit_cursorPositionChanged_0_wrapper(QObject* cpp_object, int old, int n)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::cursorPositionChanged(old, n);
    }

    void __Qt4Ada_QLineEdit_editingFinished_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::editingFinished();
    }

    void __Qt4Ada_QLineEdit_returnPressed_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::returnPressed();
    }

    void __Qt4Ada_QLineEdit_selectionChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::selectionChanged();
    }

    void __Qt4Ada_QLineEdit_textChanged_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::textChanged(*text);
    }

    void __Qt4Ada_QLineEdit_textEdited_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::textEdited(*text);
    }

    void __Qt4Ada_QLineEdit_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::changeEvent(event);
    }

    void __Qt4Ada_QLineEdit_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QLineEdit::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QLineEdit_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QLineEdit_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QLineEdit_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QLineEdit_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QLineEdit_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QLineEdit_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QLineEdit_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QLineEdit_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QLineEditDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QLineEdit_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QLineEdit_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QLineEdit_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QLineEditDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QLineEdit_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QLineEditDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QLineEdit_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QLineEdit*>(cpp_this)->QLineEdit::qt_metacast(name);
    }

    int __Qt4Ada_QLineEdit_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QLineEdit*>(cpp_this)->QLineEdit::qt_metacall(_c, _id, _a);
    }

}

bool QLineEditDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

QVariant QLineEditDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QLineEditDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QLineEditDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QLineEditDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

int QLineEditDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QLineEditDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QLineEditDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QLineEditDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QLineEditDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QLineEditDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QLineEditDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QLineEditDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QLineEditDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QLineEditDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QLineEditDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QLineEditDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QStyle>

QPaintEngine*QLineEditDirector::paintEngine()
{
    return __Qt4Ada_QPaintDevice_paintEngine_dispatch(this->ada_object);
}

void QLineEditDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QLineEditDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    QObject * __Qt4Ada_new_QLineEdit (QObject * parent)
    {
      return static_cast<QObject *>(new QLineEdit (dynamic_cast <QWidget*> (parent)));
    }

    QObject * __Qt4Ada_new_QLineEdit_With_String (QString*text, QObject * parent)
    {
      return static_cast<QObject *>(new QLineEdit (*text,dynamic_cast <QWidget*> (parent)));
    }

    QPaintEngine*__Qt4Ada_QLineEdit_paintEngine_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QLineEdit*>(cpp_this))->QLineEdit::paintEngine();
    }

    void __Qt4Ada_QLineEdit_connectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QLineEditDirector*>(cpp_this))->QLineEdit::connectNotify(_p1);
    }

    void __Qt4Ada_QLineEdit_disconnectNotify_wrapper(QObject*cpp_this,const char*_p1)
    {
    (dynamic_cast<QLineEditDirector*>(cpp_this))->QLineEdit::disconnectNotify(_p1);
    }

    void __Qt4Ada_QLineEdit_setAlignment_wrapper (QObject*cpp_this, unsigned f)
    {
         (dynamic_cast<QLineEdit*>(cpp_this))->QLineEdit::setAlignment(Qt::Alignment(f));
    }

}
