//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSize>
#include <QModelIndex>
#include <QRect>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QTimerEvent>
#include <QRegion>
#include <QAbstractItemModel>
#include <QItemSelectionModel>
#include <QVariant>
#include <QWidget>
#include <QDragEnterEvent>
#include <QFocusEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QWheelEvent>
#include <QContextMenuEvent>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qlistviewdirector.h"
#include "qabstractitemviewdirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QListView_staticMetaObject =
        &QListView::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    int __Qt4Ada_QListView_batchSize_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListView*>(cpp_object)->QListView::batchSize();
    }

    void __Qt4Ada_QListView_clearPropertyFlags_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListView*>(cpp_object)->QListView::clearPropertyFlags();
    }

    void __Qt4Ada_QListView_gridSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QListView*>(cpp_object)->QListView::gridSize();
    }

    bool __Qt4Ada_QListView_isRowHidden_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QListView*>(cpp_object)->QListView::isRowHidden(row);
    }

    bool __Qt4Ada_QListView_isWrapping_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListView*>(cpp_object)->QListView::isWrapping();
    }

    int __Qt4Ada_QListView_modelColumn_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListView*>(cpp_object)->QListView::modelColumn();
    }

    void __Qt4Ada_QListView_setBatchSize_0_wrapper(QObject* cpp_object, int batchSize)
    {
        dynamic_cast<QListView*>(cpp_object)->QListView::setBatchSize(batchSize);
    }

    void __Qt4Ada_QListView_setGridSize_0_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QListView*>(cpp_object)->QListView::setGridSize(*size);
    }

    void __Qt4Ada_QListView_setModelColumn_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QListView*>(cpp_object)->QListView::setModelColumn(column);
    }

    void __Qt4Ada_QListView_setRowHidden_0_wrapper(QObject* cpp_object, int row, bool hide)
    {
        dynamic_cast<QListView*>(cpp_object)->QListView::setRowHidden(row, hide);
    }

    void __Qt4Ada_QListView_setSpacing_0_wrapper(QObject* cpp_object, int space)
    {
        dynamic_cast<QListView*>(cpp_object)->QListView::setSpacing(space);
    }

    void __Qt4Ada_QListView_setUniformItemSizes_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QListView*>(cpp_object)->QListView::setUniformItemSizes(enable);
    }

    void __Qt4Ada_QListView_setWordWrap_0_wrapper(QObject* cpp_object, bool on)
    {
        dynamic_cast<QListView*>(cpp_object)->QListView::setWordWrap(on);
    }

    void __Qt4Ada_QListView_setWrapping_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QListView*>(cpp_object)->QListView::setWrapping(enable);
    }

    int __Qt4Ada_QListView_spacing_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListView*>(cpp_object)->QListView::spacing();
    }

    bool __Qt4Ada_QListView_uniformItemSizes_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListView*>(cpp_object)->QListView::uniformItemSizes();
    }

    bool __Qt4Ada_QListView_wordWrap_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListView*>(cpp_object)->QListView::wordWrap();
    }

    void __Qt4Ada_QListView_indexAt_0_wrapper(QObject* cpp_object, const QPoint* point, QModelIndex* returns)
    {
        *returns = dynamic_cast<QListView*>(cpp_object)->QListView::indexAt(*point);
    }

    void __Qt4Ada_QListView_scrollTo_0_wrapper(QObject* cpp_object, const QModelIndex* index, QAbstractItemView::ScrollHint hint)
    {
        dynamic_cast<QListView*>(cpp_object)->QListView::scrollTo(*index, hint);
    }

    void __Qt4Ada_QListView_visualRect_0_wrapper(QObject* cpp_object, const QModelIndex* index, QRect* returns)
    {
        *returns = dynamic_cast<QListView*>(cpp_object)->QListView::visualRect(*index);
    }

    void __Qt4Ada_QListView_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QListView::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QListView_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QListView::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QListView_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QListView::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    bool __Qt4Ada_QListView_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QListViewDirector*>(cpp_object)->QListView::event(e);
    }

    int __Qt4Ada_QListView_horizontalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListViewDirector*>(cpp_object)->QListView::horizontalOffset();
    }

    bool __Qt4Ada_QListView_isIndexHidden_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        return dynamic_cast<QListViewDirector*>(cpp_object)->QListView::isIndexHidden(*index);
    }

    void __Qt4Ada_QListView_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QListView::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QListView_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QListView::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QListView_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QListView::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QListView_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QListView::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QListView_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QListView::scrollContentsBy(dx, dy);
    }

    void __Qt4Ada_QListView_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QListView::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    int __Qt4Ada_QListView_verticalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListViewDirector*>(cpp_object)->QListView::verticalOffset();
    }

    void __Qt4Ada_QListView_visualRegionForSelection_0_wrapper(QObject* cpp_object, const QItemSelection* selection, QRegion* returns)
    {
        *returns = dynamic_cast<QListViewDirector*>(cpp_object)->QListView::visualRegionForSelection(*selection);
    }

    void __Qt4Ada_QListView_activated_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::activated(*index);
    }

    void __Qt4Ada_QListView_clicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::clicked(*index);
    }

    void __Qt4Ada_QListView_doubleClicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::doubleClicked(*index);
    }

    void __Qt4Ada_QListView_entered_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::entered(*index);
    }

    void __Qt4Ada_QListView_pressed_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::pressed(*index);
    }

    void __Qt4Ada_QListView_viewportEntered_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::viewportEntered();
    }

    void __Qt4Ada_QListView_dirtyRegionOffset_0_wrapper(QObject* cpp_object, QPoint* returns)
    {
        *returns = dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::dirtyRegionOffset();
    }

    void __Qt4Ada_QListView_executeDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::executeDelayedItemsLayout();
    }

    void __Qt4Ada_QListView_scheduleDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::scheduleDelayedItemsLayout();
    }

    void __Qt4Ada_QListView_scrollDirtyRegion_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::scrollDirtyRegion(dx, dy);
    }

    void __Qt4Ada_QListView_setDirtyRegion_0_wrapper(QObject* cpp_object, const QRegion* region)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::setDirtyRegion(*region);
    }

    void __Qt4Ada_QListView_commitData_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::commitData(dynamic_cast<QWidget*>(editor));
    }

    void __Qt4Ada_QListView_currentChanged_0_wrapper(QObject* cpp_object, const QModelIndex* current, const QModelIndex* previous)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::currentChanged(*current, *previous);
    }

    void __Qt4Ada_QListView_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::dataChanged(*topLeft, *bottomRight);
    }

    void __Qt4Ada_QListView_editorDestroyed_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::editorDestroyed(editor);
    }

    void __Qt4Ada_QListView_rowsAboutToBeRemoved_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::rowsAboutToBeRemoved(*parent, start, stop);
    }

    void __Qt4Ada_QListView_rowsInserted_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::rowsInserted(*parent, start, stop);
    }

    void __Qt4Ada_QListView_selectionChanged_0_wrapper(QObject* cpp_object, const QItemSelection* selected, const QItemSelection* deselected)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::selectionChanged(*selected, *deselected);
    }

    void __Qt4Ada_QListView_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QListView_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QListView_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::focusNextPrevChild(next);
    }

    void __Qt4Ada_QListView_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QListView_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QListView_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QListView_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QListView_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    bool __Qt4Ada_QListView_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractItemView::viewportEvent(event);
    }

    void __Qt4Ada_QListView_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QListView_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QListView_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractScrollArea::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QListView_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QAbstractScrollArea::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QListView_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QListView_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QListView_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QListView_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QListView_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QListView_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QListView_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QListView_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QListView_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QListView_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QListView_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QListView_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QListView_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QListView_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QListView_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QListViewDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QListView_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QListView_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QListViewDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QListView_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QListViewDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QListView_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QListView*>(cpp_this)->QListView::qt_metacast(name);
    }

    int __Qt4Ada_QListView_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QListView*>(cpp_this)->QListView::qt_metacall(_c, _id, _a);
    }

}

QModelIndex QListViewDirector::indexAt(const QPoint& point) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemView_indexAt_0_dispatch(this->ada_object, &point);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

void QListViewDirector::scrollTo(const QModelIndex& index, QAbstractItemView::ScrollHint hint)
{
    __Qt4Ada_QAbstractItemView_scrollTo_0_dispatch(this->ada_object, &index, hint);
}

QRect QListViewDirector::visualRect(const QModelIndex& index) const
{
    QRect *aux = __Qt4Ada_QAbstractItemView_visualRect_0_dispatch(this->ada_object, &index);
    QRect returns = *aux;
    delete aux;
    return returns;
}

void QListViewDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

bool QListViewDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

int QListViewDirector::horizontalOffset() const
{
    return __Qt4Ada_QAbstractItemView_horizontalOffset_0_dispatch(this->ada_object);
}

bool QListViewDirector::isIndexHidden(const QModelIndex& index) const
{
    return __Qt4Ada_QAbstractItemView_isIndexHidden_0_dispatch(this->ada_object, &index);
}

void QListViewDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

void QListViewDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

int QListViewDirector::verticalOffset() const
{
    return __Qt4Ada_QAbstractItemView_verticalOffset_0_dispatch(this->ada_object);
}

QRegion QListViewDirector::visualRegionForSelection(const QItemSelection& selection) const
{
    QRegion *aux = __Qt4Ada_QAbstractItemView_visualRegionForSelection_0_dispatch(this->ada_object, &selection);
    QRegion returns = *aux;
    delete aux;
    return returns;
}

void QListViewDirector::keyboardSearch(const QString& search)
{
    __Qt4Ada_QAbstractItemView_keyboardSearch_0_dispatch(this->ada_object, &search);
}

void QListViewDirector::setModel(QAbstractItemModel* model)
{
    __Qt4Ada_QAbstractItemView_setModel_0_dispatch(this->ada_object, model);
}

void QListViewDirector::setSelectionModel(QItemSelectionModel* selectionModel)
{
    __Qt4Ada_QAbstractItemView_setSelectionModel_0_dispatch(this->ada_object, selectionModel);
}

int QListViewDirector::sizeHintForColumn(int column) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_dispatch(this->ada_object, column);
}

int QListViewDirector::sizeHintForRow(int row) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForRow_0_dispatch(this->ada_object, row);
}

void QListViewDirector::reset()
{
    __Qt4Ada_QAbstractItemView_reset_0_dispatch(this->ada_object);
}

void QListViewDirector::selectAll()
{
    __Qt4Ada_QAbstractItemView_selectAll_0_dispatch(this->ada_object);
}

void QListViewDirector::setRootIndex(const QModelIndex& index)
{
    __Qt4Ada_QAbstractItemView_setRootIndex_0_dispatch(this->ada_object, &index);
}

QVariant QListViewDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QListViewDirector::commitData(QWidget* editor)
{
    __Qt4Ada_QAbstractItemView_commitData_0_dispatch(this->ada_object, editor);
}

void QListViewDirector::currentChanged(const QModelIndex& current, const QModelIndex& previous)
{
    __Qt4Ada_QAbstractItemView_currentChanged_0_dispatch(this->ada_object, &current, &previous);
}

void QListViewDirector::dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight)
{
    __Qt4Ada_QAbstractItemView_dataChanged_0_dispatch(this->ada_object, &topLeft, &bottomRight);
}

void QListViewDirector::editorDestroyed(QObject* editor)
{
    __Qt4Ada_QAbstractItemView_editorDestroyed_0_dispatch(this->ada_object, editor);
}

void QListViewDirector::rowsAboutToBeRemoved(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_dispatch(this->ada_object, &parent, start, stop);
}

void QListViewDirector::rowsInserted(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsInserted_0_dispatch(this->ada_object, &parent, start, stop);
}

void QListViewDirector::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected)
{
    __Qt4Ada_QAbstractItemView_selectionChanged_0_dispatch(this->ada_object, &selected, &deselected);
}

void QListViewDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QListViewDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QListViewDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

bool QListViewDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

QSize QListViewDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QListViewDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QListViewDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QListViewDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QListViewDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QListViewDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QListViewDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QListViewDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QListViewDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QListViewDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QListViewDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QListViewDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QListViewDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QListViewDirector::QListViewDirector(void* o, QWidget* parent) :
    QListView (parent),
    ada_object (o)
{
}

extern "C" {

    QObject* __Qt4Ada_new_QListView (QObject* parent)
    {
        return static_cast<QObject*>(new QListView(dynamic_cast<QWidget*>(parent)));
    }

    QObject* __Qt4Ada_new_QListViewDirector(void* ada_object, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QListViewDirector(ada_object, dynamic_cast<QWidget*>(parent)));
    }

    void __Qt4Ada_QListView_moveCursor_wrapper (QObject*cpp_object, unsigned action, unsigned modifiers,QModelIndex*index)
    {
        *index = dynamic_cast <QListViewDirector*>(cpp_object) -> moveCursor ((QListViewDirector::CursorAction) action, (Qt::KeyboardModifiers) modifiers);
    }

    void __Qt4Ada_QListView_setSelection_wrapper (QObject*cpp_object, QRect*rect, unsigned flags)
    {
       dynamic_cast<QListViewDirector*>(cpp_object) -> setSelection (*rect,  (QItemSelectionModel::SelectionFlags)flags);
    }

}
