//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QLISTVIEWDIRECTOR_H__
#define __QLISTVIEWDIRECTOR_H__

#include <QListView>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QListView_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern int __Qt4Ada_QListView_batchSize_0_wrapper(QObject*);
    extern void __Qt4Ada_QListView_clearPropertyFlags_0_wrapper(QObject*);
    extern void __Qt4Ada_QListView_gridSize_0_wrapper(QObject*, QSize*);
    extern bool __Qt4Ada_QListView_isRowHidden_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QListView_isWrapping_0_wrapper(QObject*);
    extern int __Qt4Ada_QListView_modelColumn_0_wrapper(QObject*);
    extern void __Qt4Ada_QListView_setBatchSize_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QListView_setGridSize_0_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QListView_setModelColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QListView_setRowHidden_0_wrapper(QObject*, int, bool);
    extern void __Qt4Ada_QListView_setSpacing_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QListView_setUniformItemSizes_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QListView_setWordWrap_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QListView_setWrapping_0_wrapper(QObject*, bool);
    extern int __Qt4Ada_QListView_spacing_0_wrapper(QObject*);
    extern bool __Qt4Ada_QListView_uniformItemSizes_0_wrapper(QObject*);
    extern bool __Qt4Ada_QListView_wordWrap_0_wrapper(QObject*);
    extern void __Qt4Ada_QListView_indexAt_0_wrapper(QObject*, const QPoint*, QModelIndex*);
    extern void __Qt4Ada_QListView_scrollTo_0_wrapper(QObject*, const QModelIndex*, QAbstractItemView::ScrollHint);
    extern void __Qt4Ada_QListView_visualRect_0_wrapper(QObject*, const QModelIndex*, QRect*);
    extern void __Qt4Ada_QListView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_dropEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QListView_event_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QListView_horizontalOffset_0_wrapper(QObject*);
    extern bool __Qt4Ada_QListView_isIndexHidden_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QListView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QListView_timerEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QListView_verticalOffset_0_wrapper(QObject*);
    extern void __Qt4Ada_QListView_visualRegionForSelection_0_wrapper(QObject*, const QItemSelection*, QRegion*);
    extern void __Qt4Ada_QListView_activated_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QListView_clicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QListView_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QListView_entered_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QListView_pressed_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QListView_viewportEntered_0_wrapper(QObject*);
    extern void __Qt4Ada_QListView_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    extern void __Qt4Ada_QListView_executeDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QListView_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QListView_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QListView_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    extern void __Qt4Ada_QListView_commitData_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QListView_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QListView_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QListView_editorDestroyed_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QListView_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QListView_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QListView_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    extern void __Qt4Ada_QListView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QListView_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QListView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QListView_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QListView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QListView_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QListView_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QListView_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QListView_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QListView_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QListView_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QListView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QListView_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QListView_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QListView_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QListView_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QListView_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject* __Qt4Ada_new_QListView(QObject*);
    extern QObject* __Qt4Ada_new_QListViewDirector(void*, QObject*);

    extern void __Qt4Ada_QListView_moveCursor_wrapper(QObject*, unsigned, unsigned,QModelIndex*);
    extern void __Qt4Ada_QListView_setSelection_wrapper(QObject*, QRect*, unsigned);

}

class QListViewDirector : public QListView
{
protected:
    void* ada_object;
    QListViewDirector(void*, QWidget*);

    friend void __Qt4Ada_QListView_moveCursor_wrapper (QObject*, unsigned, unsigned,QModelIndex*);
    friend void __Qt4Ada_QListView_setSelection_wrapper (QObject*, QRect*, unsigned);
    friend QObject* __Qt4Ada_new_QListViewDirector(void*, QObject*);

    virtual QModelIndex indexAt(const QPoint&) const;
    virtual void scrollTo(const QModelIndex&, QAbstractItemView::ScrollHint);
    virtual QRect visualRect(const QModelIndex&) const;
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual bool event(QEvent*);
    virtual int horizontalOffset() const;
    virtual bool isIndexHidden(const QModelIndex&) const;
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void scrollContentsBy(int, int);
    virtual void timerEvent(QTimerEvent*);
    virtual int verticalOffset() const;
    virtual QRegion visualRegionForSelection(const QItemSelection&) const;
    virtual void keyboardSearch(const QString&);
    virtual void setModel(QAbstractItemModel*);
    virtual void setSelectionModel(QItemSelectionModel*);
    virtual int sizeHintForColumn(int) const;
    virtual int sizeHintForRow(int) const;
    virtual void reset();
    virtual void selectAll();
    virtual void setRootIndex(const QModelIndex&);
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void commitData(QWidget*);
    virtual void currentChanged(const QModelIndex&, const QModelIndex&);
    virtual void dataChanged(const QModelIndex&, const QModelIndex&);
    virtual void editorDestroyed(QObject*);
    virtual void rowsAboutToBeRemoved(const QModelIndex&, int, int);
    virtual void rowsInserted(const QModelIndex&, int, int);
    virtual void selectionChanged(const QItemSelection&, const QItemSelection&);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual bool viewportEvent(QEvent*);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void wheelEvent(QWheelEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QListView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_dropEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QListView_event_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QListView_horizontalOffset_0_wrapper(QObject*);
    friend bool __Qt4Ada_QListView_isIndexHidden_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QListView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QListView_timerEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QListView_verticalOffset_0_wrapper(QObject*);
    friend void __Qt4Ada_QListView_visualRegionForSelection_0_wrapper(QObject*, const QItemSelection*, QRegion*);
    friend void __Qt4Ada_QListView_activated_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QListView_clicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QListView_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QListView_entered_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QListView_pressed_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QListView_viewportEntered_0_wrapper(QObject*);
    friend void __Qt4Ada_QListView_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    friend void __Qt4Ada_QListView_executeDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QListView_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QListView_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QListView_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    friend void __Qt4Ada_QListView_commitData_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QListView_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QListView_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QListView_editorDestroyed_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QListView_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QListView_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QListView_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    friend void __Qt4Ada_QListView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QListView_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QListView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QListView_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QListView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend void __Qt4Ada_QListView_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QListView_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QListView_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QListView_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QListView_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QListView_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QListView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QListView_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QListView_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QListView_sender_0_wrapper(QObject*);
};

#endif // __QLISTVIEWDIRECTOR_H__
