//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QMdiSubWindow>
#include <QBrush>
#include <QWidget>
#include <QSize>
#include <QChildEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTimerEvent>
#include <QMouseEvent>
#include <QWheelEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QKeyEvent>
#include <QVariant>
#include <QActionEvent>
#include <QCloseEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QTabletEvent>

#include "qmdiareadirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QMdiArea_staticMetaObject =
        &QMdiArea::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    QObject* __Qt4Ada_QMdiArea_activeSubWindow_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::activeSubWindow());
    }

    void __Qt4Ada_QMdiArea_background_0_wrapper(QObject* cpp_object, QBrush* returns)
    {
        *returns = dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::background();
    }

    QObject* __Qt4Ada_QMdiArea_currentSubWindow_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::currentSubWindow());
    }

    void __Qt4Ada_QMdiArea_removeSubWindow_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::removeSubWindow(dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QMdiArea_setBackground_0_wrapper(QObject* cpp_object, const QBrush* background)
    {
        dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::setBackground(*background);
    }

    void __Qt4Ada_QMdiArea_activateNextSubWindow_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::activateNextSubWindow();
    }

    void __Qt4Ada_QMdiArea_activatePreviousSubWindow_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::activatePreviousSubWindow();
    }

    void __Qt4Ada_QMdiArea_cascadeSubWindows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::cascadeSubWindows();
    }

    void __Qt4Ada_QMdiArea_closeActiveSubWindow_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::closeActiveSubWindow();
    }

    void __Qt4Ada_QMdiArea_closeAllSubWindows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::closeAllSubWindows();
    }

    void __Qt4Ada_QMdiArea_setActiveSubWindow_0_wrapper(QObject* cpp_object, QObject* window)
    {
        dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::setActiveSubWindow(dynamic_cast<QMdiSubWindow*>(window));
    }

    void __Qt4Ada_QMdiArea_tileSubWindows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::tileSubWindows();
    }

    void __Qt4Ada_QMdiArea_subWindowActivated_0_wrapper(QObject* cpp_object, QObject* window)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::subWindowActivated(dynamic_cast<QMdiSubWindow*>(window));
    }

    void __Qt4Ada_QMdiArea_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::minimumSizeHint();
    }

    void __Qt4Ada_QMdiArea_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QMdiArea*>(cpp_object)->QMdiArea::sizeHint();
    }

    void __Qt4Ada_QMdiArea_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    bool __Qt4Ada_QMdiArea_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::event(e);
    }

    bool __Qt4Ada_QMdiArea_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::eventFilter(watched, event);
    }

    void __Qt4Ada_QMdiArea_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::scrollContentsBy(dx, dy);
    }

    void __Qt4Ada_QMdiArea_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QMdiArea_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    bool __Qt4Ada_QMdiArea_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QMdiAreaDirector*>(cpp_object)->QMdiArea::viewportEvent(event);
    }

    void __Qt4Ada_QMdiArea_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QMdiArea_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QAbstractScrollArea::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QMdiArea_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QMdiArea_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QMdiArea_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QMdiArea_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QMdiArea_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QMdiArea_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QMdiArea_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QMdiArea_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QMdiArea_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QMdiArea_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QMdiArea_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QMdiArea_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QMdiAreaDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QMdiArea_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiAreaDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QMdiArea_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMdiAreaDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QMdiArea_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QMdiArea*>(cpp_this)->QMdiArea::qt_metacast(name);
    }

    int __Qt4Ada_QMdiArea_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QMdiArea*>(cpp_this)->QMdiArea::qt_metacall(_c, _id, _a);
    }

}

QSize QMdiAreaDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QMdiAreaDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QMdiAreaDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

bool QMdiAreaDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QMdiAreaDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QMdiAreaDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

void QMdiAreaDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

bool QMdiAreaDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QMdiAreaDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QMdiAreaDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QMdiAreaDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QMdiAreaDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QMdiAreaDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QMdiAreaDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QMdiAreaDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QMdiAreaDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

void QMdiAreaDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QMdiAreaDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QMdiAreaDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QMdiAreaDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
// Constructors

extern "C"
{

    QObject* __Qt4Ada_new_QMdiArea (QObject* parent)
    {
        return dynamic_cast<QObject*>(new QMdiArea(dynamic_cast<QWidget*>(parent)));
    }

    QObject* __Qt4Ada_QMdiArea_addSubWindow_0_wrapper (QObject* self, QObject* widget, int flags)
    {
        return static_cast<QObject*>(dynamic_cast<QMdiArea*>(self)->addSubWindow(dynamic_cast<QWidget*>(widget), Qt::WindowFlags(flags)));
    }

}
