//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QMenu>
#include <QWidget>
#include <QSize>
#include <QChildEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QKeyEvent>
#include <QMoveEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTimerEvent>
#include <QVariant>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QInputMethodEvent>
#include <QTabletEvent>
#include <QWheelEvent>

#include "qmdisubwindowdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QMdiSubWindow_staticMetaObject =
        &QMdiSubWindow::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QMdiSubWindow_isShaded_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::isShaded();
    }

    int __Qt4Ada_QMdiSubWindow_keyboardPageStep_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::keyboardPageStep();
    }

    int __Qt4Ada_QMdiSubWindow_keyboardSingleStep_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::keyboardSingleStep();
    }

    void __Qt4Ada_QMdiSubWindow_setKeyboardPageStep_0_wrapper(QObject* cpp_object, int step)
    {
        dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::setKeyboardPageStep(step);
    }

    void __Qt4Ada_QMdiSubWindow_setKeyboardSingleStep_0_wrapper(QObject* cpp_object, int step)
    {
        dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::setKeyboardSingleStep(step);
    }

    void __Qt4Ada_QMdiSubWindow_setSystemMenu_0_wrapper(QObject* cpp_object, QObject* systemMenu)
    {
        dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::setSystemMenu(dynamic_cast<QMenu*>(systemMenu));
    }

    void __Qt4Ada_QMdiSubWindow_setWidget_0_wrapper(QObject* cpp_object, QObject* widget)
    {
        dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::setWidget(dynamic_cast<QWidget*>(widget));
    }

    QObject* __Qt4Ada_QMdiSubWindow_systemMenu_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::systemMenu());
    }

    QObject* __Qt4Ada_QMdiSubWindow_widget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::widget());
    }

    void __Qt4Ada_QMdiSubWindow_showShaded_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::showShaded();
    }

    void __Qt4Ada_QMdiSubWindow_showSystemMenu_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::showSystemMenu();
    }

    void __Qt4Ada_QMdiSubWindow_aboutToActivate_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::aboutToActivate();
    }

    void __Qt4Ada_QMdiSubWindow_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::minimumSizeHint();
    }

    void __Qt4Ada_QMdiSubWindow_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QMdiSubWindow*>(cpp_object)->QMdiSubWindow::sizeHint();
    }

    void __Qt4Ada_QMdiSubWindow_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::changeEvent(event);
    }

    void __Qt4Ada_QMdiSubWindow_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    bool __Qt4Ada_QMdiSubWindow_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::event(e);
    }

    bool __Qt4Ada_QMdiSubWindow_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::eventFilter(watched, event);
    }

    void __Qt4Ada_QMdiSubWindow_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::leaveEvent(event);
    }

    void __Qt4Ada_QMdiSubWindow_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QMdiSubWindow::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QMdiSubWindow_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QMdiSubWindow_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QMdiSubWindow_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QMdiSubWindow_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QMdiSubWindow_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QMdiSubWindow_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QMdiSubWindow_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QMdiSubWindow_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QMdiSubWindow_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QMdiSubWindow_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMdiSubWindowDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QMdiSubWindow_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QMdiSubWindow*>(cpp_this)->QMdiSubWindow::qt_metacast(name);
    }

    int __Qt4Ada_QMdiSubWindow_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QMdiSubWindow*>(cpp_this)->QMdiSubWindow::qt_metacall(_c, _id, _a);
    }

}

QSize QMdiSubWindowDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QMdiSubWindowDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QMdiSubWindowDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

bool QMdiSubWindowDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QMdiSubWindowDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QMdiSubWindowDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

int QMdiSubWindowDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QMdiSubWindowDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QMdiSubWindowDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QMdiSubWindowDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QMdiSubWindowDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QMdiSubWindowDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QMdiSubWindowDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QMdiSubWindowDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

void QMdiSubWindowDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QMdiSubWindowDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QMdiSubWindowDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QMdiSubWindowDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
QMdiSubWindowDirector::QMdiSubWindowDirector(void* o, QWidget* parent, Qt::WindowFlags flags) :
    QMdiSubWindow(parent, flags),
    ada_object(o)
{
}

extern "C" {

    QObject* __Qt4Ada_new_QMdiSubWindow(QObject* parent, unsigned f)
    {
        return dynamic_cast<QObject*>
          (new QMdiSubWindow (dynamic_cast<QWidget*>(parent),
                        static_cast<Qt::WindowFlags>(f)));
    }

    QObject* __Qt4Ada_new_QMdiSubWindowDirector(void* o, QObject* parent, unsigned f)
    {
        return dynamic_cast<QObject*>(new QMdiSubWindowDirector(o, dynamic_cast<QWidget*>(parent), (Qt::WindowFlags)f));
    }

}
