//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QAbstractButton>
#include <QPushButton>
#include <QString>
#include <QSize>
#include <QCloseEvent>
#include <QKeyEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QContextMenuEvent>
#include <QVariant>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QPaintEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qmessageboxdirector.h"
#include "qdialogdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QMessageBox_staticMetaObject =
        &QMessageBox::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QMessageBox_addButton_1_wrapper(QObject* cpp_object, QObject* button, QMessageBox::ButtonRole role)
    {
        dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::addButton(dynamic_cast<QAbstractButton*>(button), role);
    }

    QObject* __Qt4Ada_QMessageBox_addButton_0_wrapper(QObject* cpp_object, const QString* text, QMessageBox::ButtonRole role)
    {
        return static_cast<QObject*>(dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::addButton(*text, role));
    }

    QObject* __Qt4Ada_QMessageBox_clickedButton_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::clickedButton());
    }

    QObject* __Qt4Ada_QMessageBox_defaultButton_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::defaultButton());
    }

    void __Qt4Ada_QMessageBox_detailedText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::detailedText();
    }

    QObject* __Qt4Ada_QMessageBox_escapeButton_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::escapeButton());
    }

    QMessageBox::Icon __Qt4Ada_QMessageBox_icon_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::icon();
    }

    void __Qt4Ada_QMessageBox_informativeText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::informativeText();
    }

    void __Qt4Ada_QMessageBox_removeButton_0_wrapper(QObject* cpp_object, QObject* button)
    {
        dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::removeButton(dynamic_cast<QAbstractButton*>(button));
    }

    void __Qt4Ada_QMessageBox_setDefaultButton_0_wrapper(QObject* cpp_object, QObject* button)
    {
        dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::setDefaultButton(dynamic_cast<QPushButton*>(button));
    }

    void __Qt4Ada_QMessageBox_setDetailedText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::setDetailedText(*text);
    }

    void __Qt4Ada_QMessageBox_setEscapeButton_0_wrapper(QObject* cpp_object, QObject* button)
    {
        dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::setEscapeButton(dynamic_cast<QAbstractButton*>(button));
    }

    void __Qt4Ada_QMessageBox_setIcon_0_wrapper(QObject* cpp_object, QMessageBox::Icon icon)
    {
        dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::setIcon(icon);
    }

    void __Qt4Ada_QMessageBox_setInformativeText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::setInformativeText(*text);
    }

    void __Qt4Ada_QMessageBox_setText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::setText(*text);
    }

    void __Qt4Ada_QMessageBox_setWindowTitle_0_wrapper(QObject* cpp_object, const QString* title)
    {
        dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::setWindowTitle(*title);
    }

    void __Qt4Ada_QMessageBox_text_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::text();
    }

    void __Qt4Ada_QMessageBox_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QMessageBox*>(cpp_object)->QMessageBox::sizeHint();
    }

    void __Qt4Ada_QMessageBox_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QMessageBox::changeEvent(event);
    }

    void __Qt4Ada_QMessageBox_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QMessageBox::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    bool __Qt4Ada_QMessageBox_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QMessageBoxDirector*>(cpp_object)->QMessageBox::event(e);
    }

    void __Qt4Ada_QMessageBox_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QMessageBox::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QMessageBox::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QMessageBox::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_accepted_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QDialog::accepted();
    }

    void __Qt4Ada_QMessageBox_finished_0_wrapper(QObject* cpp_object, int result)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QDialog::finished(result);
    }

    void __Qt4Ada_QMessageBox_rejected_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QDialog::rejected();
    }

    void __Qt4Ada_QMessageBox_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QDialog::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    bool __Qt4Ada_QMessageBox_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QMessageBoxDirector*>(cpp_object)->QDialog::eventFilter(watched, event);
    }

    void __Qt4Ada_QMessageBox_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QMessageBox_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QMessageBox_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QMessageBox_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QMessageBox_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QMessageBox_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QMessageBox_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QMessageBox_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QMessageBox_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QMessageBox_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QMessageBox_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QMessageBoxDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QMessageBox_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QMessageBox_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QMessageBox_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QMessageBoxDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QMessageBox_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QMessageBoxDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QMessageBox_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QMessageBox*>(cpp_this)->QMessageBox::qt_metacast(name);
    }

    int __Qt4Ada_QMessageBox_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QMessageBox*>(cpp_this)->QMessageBox::qt_metacall(_c, _id, _a);
    }

}

QSize QMessageBoxDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QMessageBoxDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

bool QMessageBoxDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QMessageBoxDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::accept()
{
    __Qt4Ada_QDialog_accept_0_dispatch(this->ada_object);
}

void QMessageBoxDirector::done(int result)
{
    __Qt4Ada_QDialog_done_0_dispatch(this->ada_object, result);
}

void QMessageBoxDirector::reject()
{
    __Qt4Ada_QDialog_reject_0_dispatch(this->ada_object);
}

QSize QMessageBoxDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QMessageBoxDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QMessageBoxDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

bool QMessageBoxDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

int QMessageBoxDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QMessageBoxDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QMessageBoxDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QMessageBoxDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QMessageBoxDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QMessageBoxDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

void QMessageBoxDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QMessageBoxDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QMessageBoxDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QMessageBoxDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QMessageBoxDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
extern "C"
{

   void __Qt4Ada_QMessage_Box_about_wrapper (QObject*parent, const QString*title, const QString*text)
   {
       QMessageBox::about (dynamic_cast<QWidget*>(parent),
                          *title,
                          *text);
   }
   void __Qt4Ada_QMessage_Box_aboutQt_wrapper (QObject*parent, const QString*title)
   {
       QMessageBox::aboutQt (dynamic_cast<QWidget*>(parent),*title);
   }

   extern unsigned __Qt4Ada_QMessage_Box_critical_wrapper (QObject* parent,
                                                           const QString* title,
                                                           const QString*text,
                                                           unsigned buttons,
                                                           unsigned default_button)
   {
      return
       (unsigned)QMessageBox::critical (dynamic_cast<QWidget*>(parent),
                                        *title,
                                        *text,
                                        (QMessageBox::StandardButtons)buttons,
                                        (QMessageBox::StandardButton)default_button);
   }

   extern unsigned __Qt4Ada_QMessage_Box_information_wrapper(QObject* parent,
                                                           const QString* title,
                                                           const QString*text,
                                                           unsigned buttons,
                                                           unsigned default_button)
   {
      return
       (unsigned)QMessageBox::information (dynamic_cast<QWidget*>(parent),
                                           *title,
                                           *text,
                                           (QMessageBox::StandardButtons)buttons,
                                           (QMessageBox::StandardButton)default_button);
   }

   extern unsigned __Qt4Ada_QMessage_Box_question_wrapper(QObject* parent,
                                                           const QString* title,
                                                           const QString*text,
                                                           unsigned buttons,
                                                           unsigned default_button)
   {
      return
       (unsigned)QMessageBox::question (dynamic_cast<QWidget*>(parent),
                                        *title,
                                        *text,
                                        (QMessageBox::StandardButtons)buttons,
                                        (QMessageBox::StandardButton)default_button);
   }

   extern unsigned __Qt4Ada_QMessage_Box_warning_wrapper(QObject* parent,
                                                           const QString* title,
                                                           const QString*text,
                                                           unsigned buttons,
                                                           unsigned default_button)
   {
      return
       (unsigned)QMessageBox::warning (dynamic_cast<QWidget*>(parent),
                                       *title,
                                       *text,
                                       (QMessageBox::StandardButtons)buttons,
                                       (QMessageBox::StandardButton)default_button);
   }
}
