//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QMESSAGEBOXDIRECTOR_H__
#define __QMESSAGEBOXDIRECTOR_H__

#include <QMessageBox>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QMessageBox_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QMessageBox_addButton_1_wrapper(QObject*, QObject*, QMessageBox::ButtonRole);
    extern QObject* __Qt4Ada_QMessageBox_addButton_0_wrapper(QObject*, const QString*, QMessageBox::ButtonRole);
    extern QObject* __Qt4Ada_QMessageBox_clickedButton_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QMessageBox_defaultButton_0_wrapper(QObject*);
    extern void __Qt4Ada_QMessageBox_detailedText_0_wrapper(QObject*, QString*);
    extern QObject* __Qt4Ada_QMessageBox_escapeButton_0_wrapper(QObject*);
    extern QMessageBox::Icon __Qt4Ada_QMessageBox_icon_0_wrapper(QObject*);
    extern void __Qt4Ada_QMessageBox_informativeText_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QMessageBox_removeButton_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMessageBox_setDefaultButton_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMessageBox_setDetailedText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QMessageBox_setEscapeButton_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QMessageBox_setIcon_0_wrapper(QObject*, QMessageBox::Icon);
    extern void __Qt4Ada_QMessageBox_setInformativeText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QMessageBox_setText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QMessageBox_setWindowTitle_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QMessageBox_text_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QMessageBox_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QMessageBox_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_closeEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMessageBox_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_accepted_0_wrapper(QObject*);
    extern void __Qt4Ada_QMessageBox_finished_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QMessageBox_rejected_0_wrapper(QObject*);
    extern void __Qt4Ada_QMessageBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMessageBox_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QMessageBox_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMessageBox_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QMessageBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QMessageBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QMessageBox_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QMessageBox_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QMessageBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QMessageBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QMessageBox_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QMessageBox_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QMessageBox_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QMessageBox_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QMessageBox_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

// Static public members
extern "C"
{
   extern void __Qt4Ada_QMessage_Box_about_wrapper (QObject*, const QString*, const QString*);
   extern void __Qt4Ada_QMessage_Box_aboutQt_wrapper (QObject*, const QString*);

   extern unsigned __Qt4Ada_QMessage_Box_critical_wrapper (QObject*,
                                                           const QString*,
                                                           const QString*,
                                                           unsigned,
                                                           unsigned);
   extern unsigned __Qt4Ada_QMessage_Box_information_wrapper (QObject*,
                                                              const QString*,
                                                              const QString*,
                                                              unsigned,
                                                              unsigned);
   extern unsigned __Qt4Ada_QMessage_Box_question_wrapper (QObject*,
                                                           const QString*,
                                                           const QString*,
                                                           unsigned,
                                                           unsigned);
   extern unsigned __Qt4Ada_QMessage_Box_warning_wrapper (QObject*,
                                                          const QString*,
                                                          const QString*,
                                                          unsigned,
                                                          unsigned);
}

class QMessageBoxDirector : public QMessageBox
{
protected:
    void* ada_object;
    QMessageBoxDirector();

    virtual QSize sizeHint() const;
    virtual void changeEvent(QEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual bool event(QEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void accept();
    virtual void done(int);
    virtual void reject();
    virtual QSize minimumSizeHint() const;
    virtual void setVisible(bool);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void actionEvent(QActionEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QMessageBox_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_closeEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMessageBox_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_accepted_0_wrapper(QObject*);
    friend void __Qt4Ada_QMessageBox_finished_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QMessageBox_rejected_0_wrapper(QObject*);
    friend void __Qt4Ada_QMessageBox_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMessageBox_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QMessageBox_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMessageBox_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QMessageBox_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QMessageBox_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QMessageBox_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QMessageBox_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QMessageBox_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QMessageBox_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QMessageBox_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QMessageBox_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QMessageBox_sender_0_wrapper(QObject*);
};

#endif // __QMESSAGEBOXDIRECTOR_H__
