//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QPen>

extern "C"
{
    extern QPen* __QtAda_inititialize_QPen(void*);
    extern QPen* __QtAda_inititialize_QPen_PenStyle(void*, unsigned);
    extern QPen* __QtAda_inititialize_QPen_QColorCR(void*, const QColor*);
    extern QPen* __QtAda_inititialize_QPen_QBrushCR_qreal_PenStyle_PenCapStyle_PenJoinStyle(void*, const QBrush*, double, unsigned, unsigned, unsigned);
    extern QPen* __QtAda_adjust_QPen(void*, const QPen*);
    extern void __QtAda_finalize_QPen(QPen*);

    extern void __QtAda_QPen_brush_Q(QBrush*, const QPen*);
    extern unsigned __QtAda_QPen_capStyle_Q(const QPen*);
    extern void __QtAda_QPen_color_Q(QColor*, const QPen*);
    extern double __QtAda_QPen_dashOffset_Q(const QPen*);
    extern unsigned __QtAda_QPen_isCosmetic_Q(const QPen*);
    extern unsigned __QtAda_QPen_isSolid_Q(const QPen*);
    extern unsigned __QtAda_QPen_joinStyle_Q(const QPen*);
    extern double __QtAda_QPen_miterLimit_Q(const QPen*);
    extern void __QtAda_QPen_setBrush_QBrushCR(QPen*, const QBrush*);
    extern void __QtAda_QPen_setCapStyle_PenCapStyle(QPen*, unsigned);
    extern void __QtAda_QPen_setColor_QColorCR(QPen*, const QColor*);
    extern void __QtAda_QPen_setCosmetic_bool(QPen*, unsigned);
    extern void __QtAda_QPen_setDashOffset_qreal(QPen*, double);
    extern void __QtAda_QPen_setJoinStyle_PenJoinStyle(QPen*, unsigned);
    extern void __QtAda_QPen_setMiterLimit_qreal(QPen*, double);
    extern void __QtAda_QPen_setStyle_PenStyle(QPen*, unsigned);
    extern void __QtAda_QPen_setWidth_int(QPen*, int);
    extern void __QtAda_QPen_setWidthF_qreal(QPen*, double);
    extern unsigned __QtAda_QPen_style_Q(const QPen*);
    extern int __QtAda_QPen_width_Q(const QPen*);
    extern double __QtAda_QPen_widthF_Q(const QPen*);
    extern unsigned __QtAda_QPen_eq_QPenCR_Q(const QPen*, const QPen*);

};

