//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QPLAINTEXTDOCUMENTLAYOUTDIRECTOR_H__
#define __QPLAINTEXTDOCUMENTLAYOUTDIRECTOR_H__

#include <QPlainTextDocumentLayout>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QPlainTextDocumentLayout_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern int __Qt4Ada_QPlainTextDocumentLayout_cursorWidth_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextDocumentLayout_ensureBlockLayout_0_wrapper(QObject*, const QTextBlock*);
    extern void __Qt4Ada_QPlainTextDocumentLayout_requestUpdate_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextDocumentLayout_setCursorWidth_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QPlainTextDocumentLayout_documentSizeChanged_0_wrapper(QObject*, const QSizeF*);
    extern void __Qt4Ada_QPlainTextDocumentLayout_pageCountChanged_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QPlainTextDocumentLayout_update_0_wrapper(QObject*, const QRectF*);
    extern void __Qt4Ada_QPlainTextDocumentLayout_updateBlock_0_wrapper(QObject*, const QTextBlock*);
    extern void __Qt4Ada_QPlainTextDocumentLayout_format_0_wrapper(QObject*, int, QTextFormat*);
    extern void __Qt4Ada_QPlainTextDocumentLayout_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextDocumentLayout_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextDocumentLayout_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QPlainTextDocumentLayout_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QPlainTextDocumentLayout_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QPlainTextDocumentLayout_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

class QPlainTextDocumentLayoutDirector : public QPlainTextDocumentLayout
{
protected:
    void* ada_object;

    virtual QRectF blockBoundingRect(const QTextBlock&) const;
    virtual QSizeF documentSize() const;
    virtual QRectF frameBoundingRect(QTextFrame*) const;
    virtual int hitTest(const QPointF&, Qt::HitTestAccuracy) const;
    virtual int pageCount() const;
    virtual void documentChanged(int, int, int);
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QPlainTextDocumentLayout_documentSizeChanged_0_wrapper(QObject*, const QSizeF*);
    friend void __Qt4Ada_QPlainTextDocumentLayout_pageCountChanged_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QPlainTextDocumentLayout_update_0_wrapper(QObject*, const QRectF*);
    friend void __Qt4Ada_QPlainTextDocumentLayout_updateBlock_0_wrapper(QObject*, const QTextBlock*);
    friend void __Qt4Ada_QPlainTextDocumentLayout_format_0_wrapper(QObject*, int, QTextFormat*);
    friend void __Qt4Ada_QPlainTextDocumentLayout_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextDocumentLayout_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextDocumentLayout_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QPlainTextDocumentLayout_sender_0_wrapper(QObject*);
};

#endif // __QPLAINTEXTDOCUMENTLAYOUTDIRECTOR_H__
