//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QMenu>
#include <QTextCharFormat>
#include <QTextCursor>
#include <QRect>
#include <QTextDocument>
#include <QString>
#include <QTextBlock>
#include <QPointF>
#include <QRectF>
#include <QTimerEvent>
#include <QKeyEvent>
#include <QResizeEvent>
#include <QPaintEvent>
#include <QMouseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QShowEvent>
#include <QWheelEvent>
#include <QInputMethodEvent>
#include <QVariant>
#include <QSize>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qplaintexteditdirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QPlainTextEdit_staticMetaObject =
        &QPlainTextEdit::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QPlainTextEdit_backgroundVisible_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::backgroundVisible();
    }

    bool __Qt4Ada_QPlainTextEdit_blockCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::blockCount();
    }

    bool __Qt4Ada_QPlainTextEdit_canPaste_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::canPaste();
    }

    bool __Qt4Ada_QPlainTextEdit_centerOnScroll_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::centerOnScroll();
    }

    QObject* __Qt4Ada_QPlainTextEdit_createStandardContextMenu_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::createStandardContextMenu());
    }

    void __Qt4Ada_QPlainTextEdit_currentCharFormat_0_wrapper(QObject* cpp_object, QTextFormat* returns)
    {
        *static_cast<QTextCharFormat*>(returns) = dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::currentCharFormat();
    }

    void __Qt4Ada_QPlainTextEdit_cursorForPosition_0_wrapper(QObject* cpp_object, const QPoint* pos, QTextCursor* returns)
    {
        *returns = dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::cursorForPosition(*pos);
    }

    void __Qt4Ada_QPlainTextEdit_cursorRect_1_wrapper(QObject* cpp_object, const QTextCursor* cursor, QRect* returns)
    {
        *returns = dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::cursorRect(*cursor);
    }

    void __Qt4Ada_QPlainTextEdit_cursorRect_0_wrapper(QObject* cpp_object, QRect* returns)
    {
        *returns = dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::cursorRect();
    }

    int __Qt4Ada_QPlainTextEdit_cursorWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::cursorWidth();
    }

    QObject* __Qt4Ada_QPlainTextEdit_document_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::document());
    }

    void __Qt4Ada_QPlainTextEdit_documentTitle_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::documentTitle();
    }

    void __Qt4Ada_QPlainTextEdit_ensureCursorVisible_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::ensureCursorVisible();
    }

    bool __Qt4Ada_QPlainTextEdit_isReadOnly_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::isReadOnly();
    }

    bool __Qt4Ada_QPlainTextEdit_isUndoRedoEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::isUndoRedoEnabled();
    }

    QPlainTextEdit::LineWrapMode __Qt4Ada_QPlainTextEdit_lineWrapMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::lineWrapMode();
    }

    int __Qt4Ada_QPlainTextEdit_maximumBlockCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::maximumBlockCount();
    }

    void __Qt4Ada_QPlainTextEdit_mergeCurrentCharFormat_0_wrapper(QObject* cpp_object, const QTextFormat* modifier)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::mergeCurrentCharFormat(static_cast<const QTextCharFormat&>(*modifier));
    }

    bool __Qt4Ada_QPlainTextEdit_overwriteMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::overwriteMode();
    }

    void __Qt4Ada_QPlainTextEdit_setBackgroundVisible_0_wrapper(QObject* cpp_object, bool visible)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setBackgroundVisible(visible);
    }

    void __Qt4Ada_QPlainTextEdit_setCenterOnScroll_0_wrapper(QObject* cpp_object, bool enabled)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setCenterOnScroll(enabled);
    }

    void __Qt4Ada_QPlainTextEdit_setCurrentCharFormat_0_wrapper(QObject* cpp_object, const QTextFormat* modifier)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setCurrentCharFormat(static_cast<const QTextCharFormat&>(*modifier));
    }

    void __Qt4Ada_QPlainTextEdit_setCursorWidth_0_wrapper(QObject* cpp_object, int width)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setCursorWidth(width);
    }

    void __Qt4Ada_QPlainTextEdit_setDocument_0_wrapper(QObject* cpp_object, QObject* document)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setDocument(dynamic_cast<QTextDocument*>(document));
    }

    void __Qt4Ada_QPlainTextEdit_setDocumentTitle_0_wrapper(QObject* cpp_object, const QString* title)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setDocumentTitle(*title);
    }

    void __Qt4Ada_QPlainTextEdit_setLineWrapMode_0_wrapper(QObject* cpp_object, QPlainTextEdit::LineWrapMode mode)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setLineWrapMode(mode);
    }

    void __Qt4Ada_QPlainTextEdit_setMaximumBlockCount_0_wrapper(QObject* cpp_object, int maximum)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setMaximumBlockCount(maximum);
    }

    void __Qt4Ada_QPlainTextEdit_setOverwriteMode_0_wrapper(QObject* cpp_object, bool overwrite)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setOverwriteMode(overwrite);
    }

    void __Qt4Ada_QPlainTextEdit_setReadOnly_0_wrapper(QObject* cpp_object, bool ro)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setReadOnly(ro);
    }

    void __Qt4Ada_QPlainTextEdit_setTabChangesFocus_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setTabChangesFocus(b);
    }

    void __Qt4Ada_QPlainTextEdit_setTabStopWidth_0_wrapper(QObject* cpp_object, int width)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setTabStopWidth(width);
    }

    void __Qt4Ada_QPlainTextEdit_setTextCursor_0_wrapper(QObject* cpp_object, const QTextCursor* cursor)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setTextCursor(*cursor);
    }

    void __Qt4Ada_QPlainTextEdit_setUndoRedoEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setUndoRedoEnabled(enable);
    }

    bool __Qt4Ada_QPlainTextEdit_tabChangesFocus_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::tabChangesFocus();
    }

    int __Qt4Ada_QPlainTextEdit_tabStopWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::tabStopWidth();
    }

    void __Qt4Ada_QPlainTextEdit_textCursor_0_wrapper(QObject* cpp_object, QTextCursor* returns)
    {
        *returns = dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::textCursor();
    }

    void __Qt4Ada_QPlainTextEdit_toPlainText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::toPlainText();
    }

    QTextOption::WrapMode __Qt4Ada_QPlainTextEdit_wordWrapMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::wordWrapMode();
    }

    void __Qt4Ada_QPlainTextEdit_appendHtml_0_wrapper(QObject* cpp_object, const QString* html)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::appendHtml(*html);
    }

    void __Qt4Ada_QPlainTextEdit_appendPlainText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::appendPlainText(*text);
    }

    void __Qt4Ada_QPlainTextEdit_centerCursor_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::centerCursor();
    }

    void __Qt4Ada_QPlainTextEdit_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::clear();
    }

    void __Qt4Ada_QPlainTextEdit_copy_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::copy();
    }

    void __Qt4Ada_QPlainTextEdit_cut_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::cut();
    }

    void __Qt4Ada_QPlainTextEdit_insertPlainText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::insertPlainText(*text);
    }

    void __Qt4Ada_QPlainTextEdit_paste_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::paste();
    }

    void __Qt4Ada_QPlainTextEdit_redo_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::redo();
    }

    void __Qt4Ada_QPlainTextEdit_selectAll_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::selectAll();
    }

    void __Qt4Ada_QPlainTextEdit_setPlainText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::setPlainText(*text);
    }

    void __Qt4Ada_QPlainTextEdit_undo_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEdit*>(cpp_object)->QPlainTextEdit::undo();
    }

    void __Qt4Ada_QPlainTextEdit_blockCountChanged_0_wrapper(QObject* cpp_object, int newBlockCount)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::blockCountChanged(newBlockCount);
    }

    void __Qt4Ada_QPlainTextEdit_copyAvailable_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::copyAvailable(b);
    }

    void __Qt4Ada_QPlainTextEdit_cursorPositionChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::cursorPositionChanged();
    }

    void __Qt4Ada_QPlainTextEdit_modificationChanged_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::modificationChanged(b);
    }

    void __Qt4Ada_QPlainTextEdit_redoAvailable_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::redoAvailable(b);
    }

    void __Qt4Ada_QPlainTextEdit_selectionChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::selectionChanged();
    }

    void __Qt4Ada_QPlainTextEdit_textChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::textChanged();
    }

    void __Qt4Ada_QPlainTextEdit_undoAvailable_0_wrapper(QObject* cpp_object, bool b)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::undoAvailable(b);
    }

    void __Qt4Ada_QPlainTextEdit_updateRequest_0_wrapper(QObject* cpp_object, const QRect* rect, int dy)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::updateRequest(*rect, dy);
    }

    void __Qt4Ada_QPlainTextEdit_firstVisibleBlock_0_wrapper(QObject* cpp_object, QTextBlock* returns)
    {
        *returns = dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::firstVisibleBlock();
    }

    void __Qt4Ada_QPlainTextEdit_contentOffset_0_wrapper(QObject* cpp_object, QPointF* returns)
    {
        *returns = dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::contentOffset();
    }

    void __Qt4Ada_QPlainTextEdit_blockBoundingRect_0_wrapper(QObject* cpp_object, const QTextBlock* block, QRectF* returns)
    {
        *returns = dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::blockBoundingRect(*block);
    }

    void __Qt4Ada_QPlainTextEdit_blockBoundingGeometry_0_wrapper(QObject* cpp_object, const QTextBlock* block, QRectF* returns)
    {
        *returns = dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::blockBoundingGeometry(*block);
    }

    bool __Qt4Ada_QPlainTextEdit_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::event(e);
    }

    void __Qt4Ada_QPlainTextEdit_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    bool __Qt4Ada_QPlainTextEdit_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::focusNextPrevChild(next);
    }

    void __Qt4Ada_QPlainTextEdit_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::changeEvent(event);
    }

    void __Qt4Ada_QPlainTextEdit_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_inputMethodQuery_0_wrapper(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::inputMethodQuery(query);
    }

    void __Qt4Ada_QPlainTextEdit_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QPlainTextEdit::scrollContentsBy(dx, dy);
    }

    void __Qt4Ada_QPlainTextEdit_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QPlainTextEdit_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    bool __Qt4Ada_QPlainTextEdit_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QAbstractScrollArea::viewportEvent(event);
    }

    void __Qt4Ada_QPlainTextEdit_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QPlainTextEdit_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QPlainTextEdit_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QPlainTextEdit_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QPlainTextEdit_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QPlainTextEdit_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QPlainTextEdit_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QPlainTextEdit_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QPlainTextEdit_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QPlainTextEdit_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QPlainTextEdit_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QPlainTextEditDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QPlainTextEdit_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_this)->QPlainTextEdit::qt_metacast(name);
    }

    int __Qt4Ada_QPlainTextEdit_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QPlainTextEdit*>(cpp_this)->QPlainTextEdit::qt_metacall(_c, _id, _a);
    }

}

bool QPlainTextEditDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QPlainTextEditDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

bool QPlainTextEditDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QPlainTextEditDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

QVariant QPlainTextEditDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QPlainTextEditDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

QSize QPlainTextEditDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QPlainTextEditDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QPlainTextEditDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

int QPlainTextEditDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QPlainTextEditDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QPlainTextEditDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QPlainTextEditDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QPlainTextEditDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QPlainTextEditDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QPlainTextEditDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QPlainTextEditDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QPlainTextEditDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QPlainTextEditDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
 // Constructors

extern "C"
{

    QObject* __Qt4Ada_new_QPlainTextEdit(QObject* parent)
    {
        return dynamic_cast<QObject*>(new QPlainTextEdit(dynamic_cast<QWidget*>(parent)));
    }

    QObject* __Qt4Ada_new_QPlainTextEdit_with_String(QString* text, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QPlainTextEdit(*text, dynamic_cast<QWidget*>(parent)));
    }

    void __QtAda_QPlainTextEdit_QTextCursorMoveOperation_QTextCursorMoveMode(QObject* self, unsigned operation, unsigned mode)
    {
        dynamic_cast<QPlainTextEdit*>(self)->moveCursor((QTextCursor::MoveOperation)operation, (QTextCursor::MoveMode)mode);
    }

}
