//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QPLAINTEXTEDITDIRECTOR_H__
#define __QPLAINTEXTEDITDIRECTOR_H__

#include <QPlainTextEdit>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QPlainTextEdit_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QPlainTextEdit_backgroundVisible_0_wrapper(QObject*);
    extern bool __Qt4Ada_QPlainTextEdit_blockCount_0_wrapper(QObject*);
    extern bool __Qt4Ada_QPlainTextEdit_canPaste_0_wrapper(QObject*);
    extern bool __Qt4Ada_QPlainTextEdit_centerOnScroll_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QPlainTextEdit_createStandardContextMenu_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_currentCharFormat_0_wrapper(QObject*, QTextFormat*);
    extern void __Qt4Ada_QPlainTextEdit_cursorForPosition_0_wrapper(QObject*, const QPoint*, QTextCursor*);
    extern void __Qt4Ada_QPlainTextEdit_cursorRect_1_wrapper(QObject*, const QTextCursor*, QRect*);
    extern void __Qt4Ada_QPlainTextEdit_cursorRect_0_wrapper(QObject*, QRect*);
    extern int __Qt4Ada_QPlainTextEdit_cursorWidth_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QPlainTextEdit_document_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_documentTitle_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QPlainTextEdit_ensureCursorVisible_0_wrapper(QObject*);
    extern bool __Qt4Ada_QPlainTextEdit_isReadOnly_0_wrapper(QObject*);
    extern bool __Qt4Ada_QPlainTextEdit_isUndoRedoEnabled_0_wrapper(QObject*);
    extern QPlainTextEdit::LineWrapMode __Qt4Ada_QPlainTextEdit_lineWrapMode_0_wrapper(QObject*);
    extern int __Qt4Ada_QPlainTextEdit_maximumBlockCount_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_mergeCurrentCharFormat_0_wrapper(QObject*, const QTextFormat*);
    extern bool __Qt4Ada_QPlainTextEdit_overwriteMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_setBackgroundVisible_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QPlainTextEdit_setCenterOnScroll_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QPlainTextEdit_setCurrentCharFormat_0_wrapper(QObject*, const QTextFormat*);
    extern void __Qt4Ada_QPlainTextEdit_setCursorWidth_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QPlainTextEdit_setDocument_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QPlainTextEdit_setDocumentTitle_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QPlainTextEdit_setLineWrapMode_0_wrapper(QObject*, QPlainTextEdit::LineWrapMode);
    extern void __Qt4Ada_QPlainTextEdit_setMaximumBlockCount_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QPlainTextEdit_setOverwriteMode_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QPlainTextEdit_setReadOnly_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QPlainTextEdit_setTabChangesFocus_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QPlainTextEdit_setTabStopWidth_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QPlainTextEdit_setTextCursor_0_wrapper(QObject*, const QTextCursor*);
    extern void __Qt4Ada_QPlainTextEdit_setUndoRedoEnabled_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QPlainTextEdit_tabChangesFocus_0_wrapper(QObject*);
    extern int __Qt4Ada_QPlainTextEdit_tabStopWidth_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_textCursor_0_wrapper(QObject*, QTextCursor*);
    extern void __Qt4Ada_QPlainTextEdit_toPlainText_0_wrapper(QObject*, QString*);
    extern QTextOption::WrapMode __Qt4Ada_QPlainTextEdit_wordWrapMode_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_appendHtml_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QPlainTextEdit_appendPlainText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QPlainTextEdit_centerCursor_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_clear_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_copy_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_cut_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_insertPlainText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QPlainTextEdit_paste_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_redo_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_selectAll_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_setPlainText_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QPlainTextEdit_undo_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_blockCountChanged_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QPlainTextEdit_copyAvailable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QPlainTextEdit_cursorPositionChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_modificationChanged_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QPlainTextEdit_redoAvailable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QPlainTextEdit_selectionChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_textChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_undoAvailable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QPlainTextEdit_updateRequest_0_wrapper(QObject*, const QRect*, int);
    extern void __Qt4Ada_QPlainTextEdit_firstVisibleBlock_0_wrapper(QObject*, QTextBlock*);
    extern void __Qt4Ada_QPlainTextEdit_contentOffset_0_wrapper(QObject*, QPointF*);
    extern void __Qt4Ada_QPlainTextEdit_blockBoundingRect_0_wrapper(QObject*, const QTextBlock*, QRectF*);
    extern void __Qt4Ada_QPlainTextEdit_blockBoundingGeometry_0_wrapper(QObject*, const QTextBlock*, QRectF*);
    extern bool __Qt4Ada_QPlainTextEdit_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QPlainTextEdit_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QPlainTextEdit_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_inputMethodQuery_0_wrapper(QObject*, Qt::InputMethodQuery, QVariant*);
    extern void __Qt4Ada_QPlainTextEdit_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QPlainTextEdit_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QPlainTextEdit_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern bool __Qt4Ada_QPlainTextEdit_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QPlainTextEdit_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QPlainTextEdit_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QPlainTextEdit_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QPlainTextEdit_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QPlainTextEdit_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QPlainTextEdit_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QPlainTextEdit_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QPlainTextEdit_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QPlainTextEdit_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QPlainTextEdit_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
 // Constructors

extern "C"
{
    extern QObject* __Qt4Ada_new_QPlainTextEdit (QObject*);
    extern QObject* __Qt4Ada_new_QPlainTextEdit_with_String (QString*,QObject*);
    extern void __QtAda_QPlainTextEdit_QTextCursorMoveOperation_QTextCursorMoveMode (QObject*, unsigned, unsigned);
}

class QPlainTextEditDirector : public QPlainTextEdit
{
protected:
    void* ada_object;

    virtual bool event(QEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void changeEvent(QEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void scrollContentsBy(int, int);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual bool viewportEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QPlainTextEdit_blockCountChanged_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QPlainTextEdit_copyAvailable_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QPlainTextEdit_cursorPositionChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QPlainTextEdit_modificationChanged_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QPlainTextEdit_redoAvailable_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QPlainTextEdit_selectionChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QPlainTextEdit_textChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QPlainTextEdit_undoAvailable_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QPlainTextEdit_updateRequest_0_wrapper(QObject*, const QRect*, int);
    friend void __Qt4Ada_QPlainTextEdit_firstVisibleBlock_0_wrapper(QObject*, QTextBlock*);
    friend void __Qt4Ada_QPlainTextEdit_contentOffset_0_wrapper(QObject*, QPointF*);
    friend void __Qt4Ada_QPlainTextEdit_blockBoundingRect_0_wrapper(QObject*, const QTextBlock*, QRectF*);
    friend void __Qt4Ada_QPlainTextEdit_blockBoundingGeometry_0_wrapper(QObject*, const QTextBlock*, QRectF*);
    friend bool __Qt4Ada_QPlainTextEdit_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QPlainTextEdit_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QPlainTextEdit_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_inputMethodQuery_0_wrapper(QObject*, Qt::InputMethodQuery, QVariant*);
    friend void __Qt4Ada_QPlainTextEdit_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QPlainTextEdit_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QPlainTextEdit_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend bool __Qt4Ada_QPlainTextEdit_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QPlainTextEdit_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QPlainTextEdit_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QPlainTextEdit_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QPlainTextEdit_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QPlainTextEdit_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QPlainTextEdit_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QPlainTextEdit_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QPlainTextEdit_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QPlainTextEdit_sender_0_wrapper(QObject*);
};

#endif // __QPLAINTEXTEDITDIRECTOR_H__
