//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QPolygon>
#include <QPolygonF>
#include <QRectF>
#include <QString>
#include "qpolygonfwrapper.h"

extern "C"
{

    QPolygonF* __QtAda_inititialize_QPolygonF(void* storage)
    {
        return new (storage) QPolygonF();
    }

    QPolygonF* __QtAda_inititialize_QPolygonF_int(void* storage, int size)
    {
        return new (storage) QPolygonF(size);
    }

    QPolygonF* __QtAda_inititialize_QPolygonF_QRectFCR(void* storage, const QRectF* r)
    {
        return new (storage) QPolygonF(*r);
    }

    QPolygonF* __QtAda_inititialize_QPolygonF_QPolygonCR(void* storage, const QPolygon* a)
    {
        return new (storage) QPolygonF(*a);
    }

    QPolygonF* __QtAda_adjust_QPolygonF(void* storage, const QPolygonF* from)
    {
        return new (storage) QPolygonF(*from);
    }

    void __QtAda_finalize_QPolygonF(QPolygonF *item)
    {
        item->~QPolygonF();
    }

    void __QtAda_QPolygonF_boundingRect_Q(QRectF* returns, const QPolygonF* self)
    {
        *returns = self->boundingRect();
    }

    unsigned __QtAda_QPolygonF_containsPoint_QPointFCR_FillRule_Q(const QPolygonF* self, const QPointF* pt, unsigned fillRule)
    {
        return (unsigned)self->containsPoint(*pt, (Qt::FillRule)fillRule);
    }

    void __QtAda_QPolygonF_intersected_QPolygonFCR_Q(QPolygonF* returns, const QPolygonF* self, const QPolygonF* r)
    {
        *returns = self->intersected(*r);
    }

    unsigned __QtAda_QPolygonF_isClosed_Q(const QPolygonF* self)
    {
        return (unsigned)self->isClosed();
    }

    void __QtAda_QPolygonF_subtracted_QPolygonFCR_Q(QPolygonF* returns, const QPolygonF* self, const QPolygonF* r)
    {
        *returns = self->subtracted(*r);
    }

    void __QtAda_QPolygonF_toPolygon_Q(QPolygon* returns, const QPolygonF* self)
    {
        *returns = self->toPolygon();
    }

    void __QtAda_QPolygonF_translate_QPointFCR(QPolygonF* self, const QPointF* offset)
    {
        self->translate(*offset);
    }

    void __QtAda_QPolygonF_translate_qreal_qreal(QPolygonF* self, double dx, double dy)
    {
        self->translate((qreal)dx, (qreal)dy);
    }

    void __QtAda_QPolygonF_united_QPolygonFCR_Q(QPolygonF* returns, const QPolygonF* self, const QPolygonF* r)
    {
        *returns = self->united(*r);
    }

    void __QtAda_QPolygonF_append_QPointFCR(QPolygonF* self, const QPointF* t)
    {
        self->append(*t);
    }

};

