//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QPrinter>

extern "C"
{
    extern QPrinter* __QtAda_inititialize_QPrinter(void*);
    extern QPrinter* __QtAda_inititialize_QPrinter_PrinterMode(void*, unsigned);
    extern void __QtAda_finalize_QPrinter(QPrinter*);

    extern unsigned __QtAda_QPrinter_abort(QPrinter*);
    extern unsigned __QtAda_QPrinter_collateCopies_Q(const QPrinter*);
    extern unsigned __QtAda_QPrinter_colorMode_Q(const QPrinter*);
    extern void __QtAda_QPrinter_creator_Q(QString*, const QPrinter*);
    extern void __QtAda_QPrinter_docName_Q(QString*, const QPrinter*);
    extern unsigned __QtAda_QPrinter_doubleSidedPrinting_Q(const QPrinter*);
    extern unsigned __QtAda_QPrinter_fontEmbeddingEnabled_Q(const QPrinter*);
    extern int __QtAda_QPrinter_fromPage_Q(const QPrinter*);
    extern unsigned __QtAda_QPrinter_fullPage_Q(const QPrinter*);
    extern unsigned __QtAda_QPrinter_newPage(QPrinter*);
    extern int __QtAda_QPrinter_numCopies_Q(const QPrinter*);
    extern unsigned __QtAda_QPrinter_orientation_Q(const QPrinter*);
    extern void __QtAda_QPrinter_outputFileName_Q(QString*, const QPrinter*);
    extern unsigned __QtAda_QPrinter_outputFormat_Q(const QPrinter*);
    extern unsigned __QtAda_QPrinter_pageOrder_Q(const QPrinter*);
    extern void __QtAda_QPrinter_pageRect_Q(QRect*, const QPrinter*);
    extern unsigned __QtAda_QPrinter_pageSize_Q(const QPrinter*);
    extern void __QtAda_QPrinter_paperRect_Q(QRect*, const QPrinter*);
    extern unsigned __QtAda_QPrinter_paperSize_Q(const QPrinter*);
    extern void __QtAda_QPrinter_paperSize_Unit_Q(QSizeF*, const QPrinter*, unsigned);
    extern unsigned __QtAda_QPrinter_paperSource_Q(const QPrinter*);
    extern void __QtAda_QPrinter_printProgram_Q(QString*, const QPrinter*);
    extern unsigned __QtAda_QPrinter_printRange_Q(const QPrinter*);
    extern void __QtAda_QPrinter_printerName_Q(QString*, const QPrinter*);
    extern unsigned __QtAda_QPrinter_printerState_Q(const QPrinter*);
    extern int __QtAda_QPrinter_resolution_Q(const QPrinter*);
    extern void __QtAda_QPrinter_setCollateCopies_bool(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setColorMode_ColorMode(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setCreator_QStringCR(QPrinter*, const QString*);
    extern void __QtAda_QPrinter_setDocName_QStringCR(QPrinter*, const QString*);
    extern void __QtAda_QPrinter_setDoubleSidedPrinting_bool(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setFontEmbeddingEnabled_bool(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setFromTo_int_int(QPrinter*, int, int);
    extern void __QtAda_QPrinter_setFullPage_bool(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setNumCopies_int(QPrinter*, int);
    extern void __QtAda_QPrinter_setOrientation_Orientation(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setOutputFileName_QStringCR(QPrinter*, const QString*);
    extern void __QtAda_QPrinter_setOutputFormat_OutputFormat(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setPageMargins_qreal_qreal_qreal_qreal_Unit(QPrinter*, double, double, double, double, unsigned);
    extern void __QtAda_QPrinter_setPageOrder_PageOrder(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setPageSize_PageSize(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setPaperSize_PaperSize(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setPaperSize_QSizeFCR_Unit(QPrinter*, const QSizeF*, unsigned);
    extern void __QtAda_QPrinter_setPaperSource_PaperSource(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setPrintProgram_QStringCR(QPrinter*, const QString*);
    extern void __QtAda_QPrinter_setPrintRange_PrintRange(QPrinter*, unsigned);
    extern void __QtAda_QPrinter_setPrinterName_QStringCR(QPrinter*, const QString*);
    extern void __QtAda_QPrinter_setResolution_int(QPrinter*, int);
    extern int __QtAda_QPrinter_toPage_Q(const QPrinter*);

    extern QPaintDevice* __QtAda_QPrinter_QPaintDevice_View(QPrinter*);

};

