//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QPaintEvent>
#include <QVariant>
#include <QSize>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qprogressbardirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QProgressBar_staticMetaObject =
        &QProgressBar::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QProgressBar_text_0_virtual(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QProgressBar*>(cpp_object)->text();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QProgressBar_format_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::format();
    }

    bool __Qt4Ada_QProgressBar_invertedAppearance_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::invertedAppearance();
    }

    bool __Qt4Ada_QProgressBar_isTextVisible_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::isTextVisible();
    }

    int __Qt4Ada_QProgressBar_maximum_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::maximum();
    }

    int __Qt4Ada_QProgressBar_minimum_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::minimum();
    }

    Qt::Orientation __Qt4Ada_QProgressBar_orientation_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::orientation();
    }

    void __Qt4Ada_QProgressBar_setAlignment_0_wrapper(QObject* cpp_object, Qt::Alignment alignment)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::setAlignment(alignment);
    }

    void __Qt4Ada_QProgressBar_setFormat_0_wrapper(QObject* cpp_object, const QString* format)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::setFormat(*format);
    }

    void __Qt4Ada_QProgressBar_setInvertedAppearance_0_wrapper(QObject* cpp_object, bool invert)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::setInvertedAppearance(invert);
    }

    void __Qt4Ada_QProgressBar_setTextDirection_0_wrapper(QObject* cpp_object, QProgressBar::Direction textDirection)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::setTextDirection(textDirection);
    }

    void __Qt4Ada_QProgressBar_setTextVisible_0_wrapper(QObject* cpp_object, bool visible)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::setTextVisible(visible);
    }

    void __Qt4Ada_QProgressBar_text_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::text();
    }

    QProgressBar::Direction __Qt4Ada_QProgressBar_textDirection_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::textDirection();
    }

    int __Qt4Ada_QProgressBar_value_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::value();
    }

    void __Qt4Ada_QProgressBar_reset_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::reset();
    }

    void __Qt4Ada_QProgressBar_setMaximum_0_wrapper(QObject* cpp_object, int maximum)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::setMaximum(maximum);
    }

    void __Qt4Ada_QProgressBar_setMinimum_0_wrapper(QObject* cpp_object, int minimum)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::setMinimum(minimum);
    }

    void __Qt4Ada_QProgressBar_setOrientation_0_wrapper(QObject* cpp_object, Qt::Orientation orientation)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::setOrientation(orientation);
    }

    void __Qt4Ada_QProgressBar_setRange_0_wrapper(QObject* cpp_object, int minimum, int maximum)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::setRange(minimum, maximum);
    }

    void __Qt4Ada_QProgressBar_setValue_0_wrapper(QObject* cpp_object, int value)
    {
        dynamic_cast<QProgressBar*>(cpp_object)->QProgressBar::setValue(value);
    }

    void __Qt4Ada_QProgressBar_valueChanged_0_wrapper(QObject* cpp_object, int value)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QProgressBar::valueChanged(value);
    }

    bool __Qt4Ada_QProgressBar_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QProgressBarDirector*>(cpp_object)->QProgressBar::event(e);
    }

    void __Qt4Ada_QProgressBar_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QProgressBar::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QProgressBar_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QProgressBar_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QProgressBar_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QProgressBar_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QProgressBar_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QProgressBar_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QProgressBar_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QProgressBar_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QProgressBar_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QProgressBar_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QProgressBar_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QProgressBarDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QProgressBar_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QProgressBar_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QProgressBar_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QProgressBarDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QProgressBar_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QProgressBarDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QProgressBar_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QProgressBar*>(cpp_this)->QProgressBar::qt_metacast(name);
    }

    int __Qt4Ada_QProgressBar_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QProgressBar*>(cpp_this)->QProgressBar::qt_metacall(_c, _id, _a);
    }

}

QString QProgressBarDirector::text() const
{
    QString *aux = __Qt4Ada_QProgressBar_text_0_dispatch(this->ada_object);
    QString returns = *aux;
    delete aux;
    return returns;
}

bool QProgressBarDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QProgressBarDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

int QProgressBarDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QProgressBarDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QProgressBarDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QProgressBarDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QProgressBarDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QProgressBarDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QProgressBarDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QProgressBarDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QProgressBarDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QProgressBarDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QProgressBarDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QProgressBarDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QProgressBarDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QProgressBarDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QProgressBarDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
extern "C" {

    QObject * __Qt4Ada_new_QProgressBar (QObject * parent)
    {
       return dynamic_cast<QObject *>(new QProgressBar (dynamic_cast <QWidget*> (parent)));
    }

}
