//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QRegExp>
#include <QChildEvent>
#include <QTimerEvent>

#include "qregexpvalidatordirector.h"
#include "qvalidatordirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QRegExpValidator_staticMetaObject =
        &QRegExpValidator::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QRegExpValidator_regExp_0_wrapper(QObject* cpp_object, QRegExp* returns)
    {
        *returns = dynamic_cast<QRegExpValidator*>(cpp_object)->QRegExpValidator::regExp();
    }

    void __Qt4Ada_QRegExpValidator_setRegExp_0_wrapper(QObject* cpp_object, const QRegExp* rx)
    {
        dynamic_cast<QRegExpValidator*>(cpp_object)->QRegExpValidator::setRegExp(*rx);
    }

    void __Qt4Ada_QRegExpValidator_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QRegExpValidatorDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QRegExpValidator_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QRegExpValidatorDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QRegExpValidator_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QRegExpValidatorDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QRegExpValidator_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QRegExpValidatorDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QRegExpValidator_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QRegExpValidator*>(cpp_this)->QRegExpValidator::qt_metacast(name);
    }

    int __Qt4Ada_QRegExpValidator_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QRegExpValidator*>(cpp_this)->QRegExpValidator::qt_metacall(_c, _id, _a);
    }

}

void QRegExpValidatorDirector::fixup(QString& input) const
{
    __Qt4Ada_QValidator_fixup_0_dispatch(this->ada_object, &input);
}

bool QRegExpValidatorDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QRegExpValidatorDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QRegExpValidatorDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QRegExpValidatorDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QRegExpValidatorDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QRegExpValidatorDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QRegExpValidatorDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QRegExpValidatorDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
 // Constructors

extern "C"
{
    QObject* __Qt4Ada_new_QRegExpValidator (QObject*parent)
    {
        return dynamic_cast<QObject*>(new QRegExpValidator (parent));
    }

    QObject* __Qt4Ada_new_QRegExpValidator_With_RegExp (QRegExp *rx, QObject*parent)
    {
        return dynamic_cast<QObject*>(new QRegExpValidator (*rx, parent));
    }

    QValidator::State __Qt4Ada_QRegExpValidator_validate_wrapper(QObject* cpp_this, QString* input, int* pos)
    {
        return dynamic_cast<QRegExpValidator*>(cpp_this)->QRegExpValidator::validate(*input, *pos);
    }

}
