//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QRect>
#include <QRegion>
#include <QString>
#include "qregionwrapper.h"

extern "C"
{

    QRegion* __QtAda_inititialize_QRegion(void* storage)
    {
        return new (storage) QRegion();
    }

    QRegion* __QtAda_inititialize_QRegion_int_int_int_RegionType(void* storage, int x, int y, int h, unsigned t)
    {
        return new (storage) QRegion(x, y, h, (QRegion::RegionType)t);
    }

    QRegion* __QtAda_inititialize_QRegion_QPolygonCR_FillRule(void* storage, const QPolygon* pa, unsigned fillRule)
    {
        return new (storage) QRegion(*pa, (Qt::FillRule)fillRule);
    }

    QRegion* __QtAda_inititialize_QRegion_QRectR_RegionType(void* storage, QRect* r, unsigned t)
    {
        return new (storage) QRegion(*r, (QRegion::RegionType)t);
    }

    QRegion* __QtAda_adjust_QRegion(void* storage, const QRegion* from)
    {
        return new (storage) QRegion(*from);
    }

    void __QtAda_finalize_QRegion(QRegion *item)
    {
        item->~QRegion();
    }

    QRegion* __Qt4Ada_copy_QRegion (const QRegion* cpp_object)
    {
        return new QRegion (*cpp_object);
    }

    void __QtAda_QRegion_boundingRect_Q(QRect* returns, const QRegion* self)
    {
        *returns = self->boundingRect();
    }

    unsigned __QtAda_QRegion_contains_QPointCR_Q(const QRegion* self, const QPoint* p)
    {
        return (unsigned)self->contains(*p);
    }

    unsigned __QtAda_QRegion_contains_QRectCR_Q(const QRegion* self, const QRect* r)
    {
        return (unsigned)self->contains(*r);
    }

    void __QtAda_QRegion_intersected_QRegionCR_Q(QRegion* returns, const QRegion* self, const QRegion* r)
    {
        *returns = self->intersected(*r);
    }

    unsigned __QtAda_QRegion_intersects_QRegionCR_Q(const QRegion* self, const QRegion* r)
    {
        return (unsigned)self->intersects(*r);
    }

    unsigned __QtAda_QRegion_intersects_QRectCR_Q(const QRegion* self, const QRect* r)
    {
        return (unsigned)self->intersects(*r);
    }

    unsigned __QtAda_QRegion_isEmpty_Q(const QRegion* self)
    {
        return (unsigned)self->isEmpty();
    }

    void __QtAda_QRegion_subtracted_QRegionCR_Q(QRegion* returns, const QRegion* self, const QRegion* r)
    {
        *returns = self->subtracted(*r);
    }

    void __QtAda_QRegion_translate_int_int(QRegion* self, int dx, int dy)
    {
        self->translate(dx, dy);
    }

    void __QtAda_QRegion_translate_QPointCR(QRegion* self, const QPoint* p)
    {
        self->translate(*p);
    }

    void __QtAda_QRegion_translated_int_int_Q(QRegion* returns, const QRegion* self, int dx, int dy)
    {
        *returns = self->translated(dx, dy);
    }

    void __QtAda_QRegion_translated_QPointCR_Q(QRegion* returns, const QRegion* self, const QPoint* p)
    {
        *returns = self->translated(*p);
    }

    void __QtAda_QRegion_united_QRegionCR_Q(QRegion* returns, const QRegion* self, const QRegion* r)
    {
        *returns = self->united(*r);
    }

    void __QtAda_QRegion_xored_QRegionCR_Q(QRegion* returns, const QRegion* self, const QRegion* r)
    {
        *returns = self->xored(*r);
    }

    unsigned __QtAda_QRegion_eq_QRegionCR_Q(const QRegion* self, const QRegion* r)
    {
        return (unsigned)self->operator==(*r);
    }

};

