//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QRegion>

extern "C"
{
    extern QRegion* __QtAda_inititialize_QRegion(void*);
    extern QRegion* __QtAda_inititialize_QRegion_int_int_int_RegionType(void*, int, int, int, unsigned);
    extern QRegion* __QtAda_inititialize_QRegion_QPolygonCR_FillRule(void*, const QPolygon*, unsigned);
    extern QRegion* __QtAda_inititialize_QRegion_QRectR_RegionType(void*, QRect*, unsigned);
    extern QRegion* __QtAda_adjust_QRegion(void*, const QRegion*);
    extern void __QtAda_finalize_QRegion(QRegion*);
    extern QRegion* __Qt4Ada_copy_QRegion(const QRegion*);

    extern void __QtAda_QRegion_boundingRect_Q(QRect*, const QRegion*);
    extern unsigned __QtAda_QRegion_contains_QPointCR_Q(const QRegion*, const QPoint*);
    extern unsigned __QtAda_QRegion_contains_QRectCR_Q(const QRegion*, const QRect*);
    extern void __QtAda_QRegion_intersected_QRegionCR_Q(QRegion*, const QRegion*, const QRegion*);
    extern unsigned __QtAda_QRegion_intersects_QRegionCR_Q(const QRegion*, const QRegion*);
    extern unsigned __QtAda_QRegion_intersects_QRectCR_Q(const QRegion*, const QRect*);
    extern unsigned __QtAda_QRegion_isEmpty_Q(const QRegion*);
    extern void __QtAda_QRegion_subtracted_QRegionCR_Q(QRegion*, const QRegion*, const QRegion*);
    extern void __QtAda_QRegion_translate_int_int(QRegion*, int, int);
    extern void __QtAda_QRegion_translate_QPointCR(QRegion*, const QPoint*);
    extern void __QtAda_QRegion_translated_int_int_Q(QRegion*, const QRegion*, int, int);
    extern void __QtAda_QRegion_translated_QPointCR_Q(QRegion*, const QRegion*, const QPoint*);
    extern void __QtAda_QRegion_united_QRegionCR_Q(QRegion*, const QRegion*, const QRegion*);
    extern void __QtAda_QRegion_xored_QRegionCR_Q(QRegion*, const QRegion*, const QRegion*);
    extern unsigned __QtAda_QRegion_eq_QRegionCR_Q(const QRegion*, const QRegion*);

};

