//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QSLIDERDIRECTOR_H__
#define __QSLIDERDIRECTOR_H__

#include <QSlider>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QSlider_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QSlider_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_minimumSizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QSlider_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QSlider_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_rangeChanged_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QSlider_sliderMoved_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSlider_sliderPressed_0_wrapper(QObject*);
    extern void __Qt4Ada_QSlider_sliderReleased_0_wrapper(QObject*);
    extern void __Qt4Ada_QSlider_valueChanged_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSlider_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_timerEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QSlider_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QSlider_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QSlider_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QSlider_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QSlider_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QSlider_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QSlider_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QSlider_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QSlider_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSlider_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QSlider_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QSlider_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QSlider_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    //  Constructors

    extern QObject * __Qt4Ada_new_QSlider (QObject *parent);
    extern QObject * __Qt4Ada_new_QSlider_With_Orientation (Qt::Orientation orientation, QObject *parent);

    //  Declarations of wrapper functions for static call

    extern QPaintEngine*__Qt4Ada_QSlider_paintEngine_wrapper(QObject*);
    extern void __Qt4Ada_QSlider_connectNotify_wrapper(QObject*,const char*);
    extern void __Qt4Ada_QSlider_disconnectNotify_wrapper(QObject*,const char*);

}

class QSliderDirector : public QSlider
{
protected:
    void* ada_object;
    QSliderDirector();

//     virtual void sliderChange(QAbstractSlider::SliderChange );
    virtual QPaintEngine*paintEngine();
    virtual void connectNotify(const char*);
    virtual void disconnectNotify(const char*);

//     friend void __Qt4Ada_QSlider_sliderChange_wrapper(QObject*,QAbstractSlider::SliderChange );
    friend void __Qt4Ada_QSlider_enabledChange_wrapper(QObject*,bool );
    friend void __Qt4Ada_QSlider_connectNotify_wrapper(QObject*,const char*);
    friend void __Qt4Ada_QSlider_disconnectNotify_wrapper(QObject*,const char*);

    virtual bool event(QEvent*);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void changeEvent(QEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void timerEvent(QTimerEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QSlider_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_rangeChanged_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QSlider_sliderMoved_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QSlider_sliderPressed_0_wrapper(QObject*);
    friend void __Qt4Ada_QSlider_sliderReleased_0_wrapper(QObject*);
    friend void __Qt4Ada_QSlider_valueChanged_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QSlider_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_timerEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QSlider_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QSlider_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QSlider_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QSlider_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QSlider_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QSlider_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QSlider_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QSlider_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QSlider_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSlider_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QSlider_sender_0_wrapper(QObject*);
};

#endif // __QSLIDERDIRECTOR_H__
