//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QSORTFILTERPROXYMODELDIRECTOR_H__
#define __QSORTFILTERPROXYMODELDIRECTOR_H__

#include <QSortFilterProxyModel>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QSortFilterProxyModel_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern bool __Qt4Ada_QSortFilterProxyModel_filterAcceptsColumn_0_dispatch(void*, int, const QModelIndex*);
    extern bool __Qt4Ada_QSortFilterProxyModel_filterAcceptsRow_0_dispatch(void*, int, const QModelIndex*);
    extern bool __Qt4Ada_QSortFilterProxyModel_lessThan_0_dispatch(void*, const QModelIndex*, const QModelIndex*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QSortFilterProxyModel_dynamicSortFilter_0_wrapper(QObject*);
    extern Qt::CaseSensitivity __Qt4Ada_QSortFilterProxyModel_filterCaseSensitivity_0_wrapper(QObject*);
    extern int __Qt4Ada_QSortFilterProxyModel_filterKeyColumn_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_filterRegExp_0_wrapper(QObject*, QRegExp*);
    extern int __Qt4Ada_QSortFilterProxyModel_filterRole_0_wrapper(QObject*);
    extern bool __Qt4Ada_QSortFilterProxyModel_isSortLocaleAware_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_mapFromSource_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_mapToSource_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_setDynamicSortFilter_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QSortFilterProxyModel_setFilterCaseSensitivity_0_wrapper(QObject*, Qt::CaseSensitivity);
    extern void __Qt4Ada_QSortFilterProxyModel_setFilterKeyColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSortFilterProxyModel_setFilterRegExp_1_wrapper(QObject*, const QRegExp*);
    extern void __Qt4Ada_QSortFilterProxyModel_setFilterRole_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSortFilterProxyModel_setSortCaseSensitivity_0_wrapper(QObject*, Qt::CaseSensitivity);
    extern void __Qt4Ada_QSortFilterProxyModel_setSortLocaleAware_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QSortFilterProxyModel_setSortRole_0_wrapper(QObject*, int);
    extern Qt::CaseSensitivity __Qt4Ada_QSortFilterProxyModel_sortCaseSensitivity_0_wrapper(QObject*);
    extern int __Qt4Ada_QSortFilterProxyModel_sortRole_0_wrapper(QObject*);
    extern int __Qt4Ada_QSortFilterProxyModel_columnCount_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_index_0_wrapper(QObject*, int, int, const QModelIndex*, QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_parent_1_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    extern int __Qt4Ada_QSortFilterProxyModel_rowCount_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_invalidate_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_setFilterFixedString_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QSortFilterProxyModel_setFilterRegExp_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QSortFilterProxyModel_setFilterWildcard_0_wrapper(QObject*, const QString*);
    extern bool __Qt4Ada_QSortFilterProxyModel_filterAcceptsColumn_0_wrapper(QObject*, int, const QModelIndex*);
    extern bool __Qt4Ada_QSortFilterProxyModel_filterAcceptsRow_0_wrapper(QObject*, int, const QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_invalidateFilter_0_wrapper(QObject*);
    extern bool __Qt4Ada_QSortFilterProxyModel_lessThan_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_setSourceModel_0_wrapper(QObject*, QObject*);
    extern bool __Qt4Ada_QSortFilterProxyModel_canFetchMore_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_fetchMore_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    extern void __Qt4Ada_QSortFilterProxyModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_layoutChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSortFilterProxyModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern bool __Qt4Ada_QSortFilterProxyModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern bool __Qt4Ada_QSortFilterProxyModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern void __Qt4Ada_QSortFilterProxyModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSortFilterProxyModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSortFilterProxyModel_beginResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QSortFilterProxyModel_endInsertColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_endInsertRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_endMoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_endMoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_endRemoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_endRemoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_endResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_reset_0_wrapper(QObject*);
    extern void __Qt4Ada_QSortFilterProxyModel_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSortFilterProxyModel_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSortFilterProxyModel_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QSortFilterProxyModel_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QSortFilterProxyModel_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QSortFilterProxyModel_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
extern "C" {

    extern QObject* __Qt4Ada_new_QSortFilterProxyModel(QObject*);
    extern QObject* __Qt4Ada_new_QSortFilterProxyModelDirector(void*, QObject*);

    extern QVariant* __Qt4Ada_QSortFilterProxyModel_data_virtual(QObject*, const QModelIndex*, int);

}

class QSortFilterProxyModelDirector : public QSortFilterProxyModel
{
protected:
    void* ada_object;
    QSortFilterProxyModelDirector(void*, QObject*);

    friend QObject* __Qt4Ada_new_QSortFilterProxyModelDirector(void*, QObject*);

    virtual QModelIndex mapFromSource(const QModelIndex&);
    virtual QModelIndex mapToSource(const QModelIndex&);
    virtual int columnCount(const QModelIndex&) const;
    virtual QModelIndex index(int, int, const QModelIndex&) const;
    virtual QModelIndex parent(const QModelIndex&) const;
    virtual int rowCount(const QModelIndex&) const;
    virtual bool filterAcceptsColumn(int, const QModelIndex&) const;
    virtual bool filterAcceptsRow(int, const QModelIndex&) const;
    virtual bool lessThan(const QModelIndex&, const QModelIndex&) const;
    virtual void setSourceModel(QAbstractItemModel*);
    virtual bool canFetchMore(const QModelIndex&) const;
    virtual void fetchMore(const QModelIndex&);
    virtual QItemSelection mapSelectionFromSource(const QItemSelection&) const;
    virtual QItemSelection mapSelectionToSource(const QItemSelection&) const;
    virtual QModelIndex buddy(const QModelIndex&) const;
    virtual bool dropMimeData(QMimeData*, Qt::DropAction, int, int, const QModelIndex&);
    virtual bool hasChildren(const QModelIndex&) const;
    virtual bool hasIndex(int, int, const QModelIndex&) const;
    virtual bool insertColumns(int, int, const QModelIndex&);
    virtual bool insertRows(int, int, const QModelIndex&);
    virtual QMimeData* mimeData(const QModelIndexList&) const;
    virtual QStringList mimeTypes() const;
    virtual bool removeColumns(int, int, const QModelIndex&);
    virtual bool removeRows(int, int, const QModelIndex&);
    virtual QSize span(const QModelIndex&) const;
    virtual void revert();
    virtual bool submit();
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend bool __Qt4Ada_QSortFilterProxyModel_filterAcceptsColumn_0_wrapper(QObject*, int, const QModelIndex*);
    friend bool __Qt4Ada_QSortFilterProxyModel_filterAcceptsRow_0_wrapper(QObject*, int, const QModelIndex*);
    friend void __Qt4Ada_QSortFilterProxyModel_invalidateFilter_0_wrapper(QObject*);
    friend bool __Qt4Ada_QSortFilterProxyModel_lessThan_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QSortFilterProxyModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QSortFilterProxyModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    friend void __Qt4Ada_QSortFilterProxyModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_layoutChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSortFilterProxyModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend bool __Qt4Ada_QSortFilterProxyModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend bool __Qt4Ada_QSortFilterProxyModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend void __Qt4Ada_QSortFilterProxyModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSortFilterProxyModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSortFilterProxyModel_beginResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QSortFilterProxyModel_endInsertColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_endInsertRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_endMoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_endMoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_endRemoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_endRemoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_endResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_reset_0_wrapper(QObject*);
    friend void __Qt4Ada_QSortFilterProxyModel_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSortFilterProxyModel_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSortFilterProxyModel_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QSortFilterProxyModel_sender_0_wrapper(QObject*);
};

#endif // __QSORTFILTERPROXYMODELDIRECTOR_H__
