//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QSize>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTimerEvent>
#include <QWheelEvent>
#include <QVariant>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qspinboxdirector.h"
#include "qabstractspinboxdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QSpinBox_staticMetaObject =
        &QSpinBox::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QSpinBox_cleanText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::cleanText();
    }

    int __Qt4Ada_QSpinBox_maximum_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::maximum();
    }

    int __Qt4Ada_QSpinBox_minimum_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::minimum();
    }

    void __Qt4Ada_QSpinBox_prefix_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::prefix();
    }

    void __Qt4Ada_QSpinBox_setMaximum_0_wrapper(QObject* cpp_object, int max)
    {
        dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::setMaximum(max);
    }

    void __Qt4Ada_QSpinBox_setMinimum_0_wrapper(QObject* cpp_object, int min)
    {
        dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::setMinimum(min);
    }

    void __Qt4Ada_QSpinBox_setPrefix_0_wrapper(QObject* cpp_object, const QString* prefix)
    {
        dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::setPrefix(*prefix);
    }

    void __Qt4Ada_QSpinBox_setRange_0_wrapper(QObject* cpp_object, int min, int max)
    {
        dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::setRange(min, max);
    }

    void __Qt4Ada_QSpinBox_setSingleStep_0_wrapper(QObject* cpp_object, int val)
    {
        dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::setSingleStep(val);
    }

    void __Qt4Ada_QSpinBox_setSuffix_0_wrapper(QObject* cpp_object, const QString* suffix)
    {
        dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::setSuffix(*suffix);
    }

    int __Qt4Ada_QSpinBox_singleStep_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::singleStep();
    }

    void __Qt4Ada_QSpinBox_suffix_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::suffix();
    }

    int __Qt4Ada_QSpinBox_value_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::value();
    }

    void __Qt4Ada_QSpinBox_setValue_0_wrapper(QObject* cpp_object, int val)
    {
        dynamic_cast<QSpinBox*>(cpp_object)->QSpinBox::setValue(val);
    }

    void __Qt4Ada_QSpinBox_valueChanged_1_wrapper(QObject* cpp_object, int i)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QSpinBox::valueChanged(i);
    }

    void __Qt4Ada_QSpinBox_valueChanged_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QSpinBox::valueChanged(*text);
    }

    void __Qt4Ada_QSpinBox_textFromValue_0_wrapper(QObject* cpp_object, int val, QString* returns)
    {
        *returns = dynamic_cast<QSpinBoxDirector*>(cpp_object)->QSpinBox::textFromValue(val);
    }

    int __Qt4Ada_QSpinBox_valueFromText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        return dynamic_cast<QSpinBoxDirector*>(cpp_object)->QSpinBox::valueFromText(*text);
    }

    bool __Qt4Ada_QSpinBox_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QSpinBoxDirector*>(cpp_object)->QSpinBox::event(e);
    }

    void __Qt4Ada_QSpinBox_fixup_0_wrapper(QObject* cpp_object, QString* input)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QSpinBox::fixup(*input);
    }

    QValidator::State __Qt4Ada_QSpinBox_validate_0_wrapper(QObject* cpp_object, QString* input, int pos)
    {
        return dynamic_cast<QSpinBoxDirector*>(cpp_object)->QSpinBox::validate(*input, pos);
    }

    QObject* __Qt4Ada_QSpinBox_lineEdit_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::lineEdit());
    }

    void __Qt4Ada_QSpinBox_setLineEdit_0_wrapper(QObject* cpp_object, QObject* edit)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::setLineEdit(dynamic_cast<QLineEdit*>(edit));
    }

    void __Qt4Ada_QSpinBox_editingFinished_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::editingFinished();
    }

    void __Qt4Ada_QSpinBox_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::changeEvent(event);
    }

    void __Qt4Ada_QSpinBox_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QAbstractSpinBox::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QSpinBox_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QSpinBox_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QSpinBox_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QSpinBox_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QSpinBox_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QSpinBox_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QSpinBox_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QSpinBox_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QSpinBoxDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QSpinBox_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QSpinBox_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSpinBoxDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QSpinBox_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSpinBoxDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QSpinBox_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QSpinBox*>(cpp_this)->QSpinBox::qt_metacast(name);
    }

    int __Qt4Ada_QSpinBox_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QSpinBox*>(cpp_this)->QSpinBox::qt_metacall(_c, _id, _a);
    }

}

QString QSpinBoxDirector::textFromValue(int val) const
{
    QString *aux = __Qt4Ada_QSpinBox_textFromValue_0_dispatch(this->ada_object, val);
    QString returns = *aux;
    delete aux;
    return returns;
}

int QSpinBoxDirector::valueFromText(const QString& text) const
{
    return __Qt4Ada_QSpinBox_valueFromText_0_dispatch(this->ada_object, &text);
}

bool QSpinBoxDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QSpinBoxDirector::fixup(QString& input) const
{
    __Qt4Ada_QAbstractSpinBox_fixup_0_dispatch(this->ada_object, &input);
}

QValidator::State QSpinBoxDirector::validate(QString& input, int pos) const
{
    return __Qt4Ada_QAbstractSpinBox_validate_0_dispatch(this->ada_object, &input, pos);
}

void QSpinBoxDirector::stepBy(int steps)
{
    __Qt4Ada_QAbstractSpinBox_stepBy_0_dispatch(this->ada_object, steps);
}

QSize QSpinBoxDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QSpinBoxDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QSpinBoxDirector::clear()
{
    __Qt4Ada_QAbstractSpinBox_clear_0_dispatch(this->ada_object);
}

void QSpinBoxDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QSpinBoxDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QSpinBoxDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QSpinBoxDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QSpinBoxDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QSpinBoxDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QSpinBoxDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QSpinBoxDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QSpinBoxDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QSpinBoxDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QSpinBoxDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QSpinBoxDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QSpinBoxDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QSpinBoxDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C" {

    QObject* __Qt4Ada_new_QSpinBox(QObject* parent)
    {
        return dynamic_cast<QObject*>(new QSpinBox(dynamic_cast<QWidget*>(parent)));
    }

}
