//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QModelIndex>
#include <QMimeData>
#include <QStringList>
#include <QSize>
#include <QChildEvent>
#include <QTimerEvent>

#include "qstandarditemmodeldirector.h"
#include "qabstractitemmodeldirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QStandardItemModel_staticMetaObject =
        &QStandardItemModel::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    int __Qt4Ada_QStandardItemModel_columnCount_0_wrapper(QObject* cpp_object, const QModelIndex* parent)
    {
        return dynamic_cast<QStandardItemModel*>(cpp_object)->QStandardItemModel::columnCount(*parent);
    }

    bool __Qt4Ada_QStandardItemModel_hasChildren_0_wrapper(QObject* cpp_object, const QModelIndex* parent)
    {
        return dynamic_cast<QStandardItemModel*>(cpp_object)->QStandardItemModel::hasChildren(*parent);
    }

    void __Qt4Ada_QStandardItemModel_index_0_wrapper(QObject* cpp_object, int row, int column, const QModelIndex* parent, QModelIndex* returns)
    {
        *returns = dynamic_cast<QStandardItemModel*>(cpp_object)->QStandardItemModel::index(row, column, *parent);
    }

    bool __Qt4Ada_QStandardItemModel_insertColumns_0_wrapper(QObject* cpp_object, int column, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QStandardItemModel*>(cpp_object)->QStandardItemModel::insertColumns(column, count, *parent);
    }

    bool __Qt4Ada_QStandardItemModel_insertRows_0_wrapper(QObject* cpp_object, int row, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QStandardItemModel*>(cpp_object)->QStandardItemModel::insertRows(row, count, *parent);
    }

    void __Qt4Ada_QStandardItemModel_parent_1_wrapper(QObject* cpp_object, const QModelIndex* child, QModelIndex* returns)
    {
        *returns = dynamic_cast<QStandardItemModel*>(cpp_object)->QStandardItemModel::parent(*child);
    }

    bool __Qt4Ada_QStandardItemModel_removeColumns_0_wrapper(QObject* cpp_object, int column, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QStandardItemModel*>(cpp_object)->QStandardItemModel::removeColumns(column, count, *parent);
    }

    bool __Qt4Ada_QStandardItemModel_removeRows_0_wrapper(QObject* cpp_object, int row, int count, const QModelIndex* parent)
    {
        return dynamic_cast<QStandardItemModel*>(cpp_object)->QStandardItemModel::removeRows(row, count, *parent);
    }

    int __Qt4Ada_QStandardItemModel_rowCount_0_wrapper(QObject* cpp_object, const QModelIndex* parent)
    {
        return dynamic_cast<QStandardItemModel*>(cpp_object)->QStandardItemModel::rowCount(*parent);
    }

    void __Qt4Ada_QStandardItemModel_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::dataChanged(*topLeft, *bottomRight);
    }

    void __Qt4Ada_QStandardItemModel_headerDataChanged_0_wrapper(QObject* cpp_object, Qt::Orientation orientation, int first, int last)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::headerDataChanged(orientation, first, last);
    }

    void __Qt4Ada_QStandardItemModel_layoutAboutToBeChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::layoutAboutToBeChanged();
    }

    void __Qt4Ada_QStandardItemModel_layoutChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::layoutChanged();
    }

    void __Qt4Ada_QStandardItemModel_beginInsertColumns_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::beginInsertColumns(*parent, first, last);
    }

    void __Qt4Ada_QStandardItemModel_beginInsertRows_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::beginInsertRows(*parent, first, last);
    }

    bool __Qt4Ada_QStandardItemModel_beginMoveColumns_0_wrapper(QObject* cpp_object, const QModelIndex* sourceParent, int sourceFirst, int sourceLast, const QModelIndex* destinationParent, int destinationChild)
    {
        return dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::beginMoveColumns(*sourceParent, sourceFirst, sourceLast, *destinationParent, destinationChild);
    }

    bool __Qt4Ada_QStandardItemModel_beginMoveRows_0_wrapper(QObject* cpp_object, const QModelIndex* sourceParent, int sourceFirst, int sourceLast, const QModelIndex* destinationParent, int destinationChild)
    {
        return dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::beginMoveRows(*sourceParent, sourceFirst, sourceLast, *destinationParent, destinationChild);
    }

    void __Qt4Ada_QStandardItemModel_beginRemoveColumns_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::beginRemoveColumns(*parent, first, last);
    }

    void __Qt4Ada_QStandardItemModel_beginRemoveRows_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int first, int last)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::beginRemoveRows(*parent, first, last);
    }

    void __Qt4Ada_QStandardItemModel_beginResetModel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::beginResetModel();
    }

    void __Qt4Ada_QStandardItemModel_changePersistentIndex_0_wrapper(QObject* cpp_object, const QModelIndex* from, const QModelIndex* to)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::changePersistentIndex(*from, *to);
    }

    void __Qt4Ada_QStandardItemModel_endInsertColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::endInsertColumns();
    }

    void __Qt4Ada_QStandardItemModel_endInsertRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::endInsertRows();
    }

    void __Qt4Ada_QStandardItemModel_endMoveColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::endMoveColumns();
    }

    void __Qt4Ada_QStandardItemModel_endMoveRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::endMoveRows();
    }

    void __Qt4Ada_QStandardItemModel_endRemoveColumns_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::endRemoveColumns();
    }

    void __Qt4Ada_QStandardItemModel_endRemoveRows_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::endRemoveRows();
    }

    void __Qt4Ada_QStandardItemModel_endResetModel_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::endResetModel();
    }

    void __Qt4Ada_QStandardItemModel_reset_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QAbstractItemModel::reset();
    }

    void __Qt4Ada_QStandardItemModel_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QStandardItemModel_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QStandardItemModel_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QStandardItemModel_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QStandardItemModelDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QStandardItemModel_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QStandardItemModel*>(cpp_this)->QStandardItemModel::qt_metacast(name);
    }

    int __Qt4Ada_QStandardItemModel_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QStandardItemModel*>(cpp_this)->QStandardItemModel::qt_metacall(_c, _id, _a);
    }

}

int QStandardItemModelDirector::columnCount(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_columnCount_0_dispatch(this->ada_object, &parent);
}

bool QStandardItemModelDirector::hasChildren(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_hasChildren_0_dispatch(this->ada_object, &parent);
}

QModelIndex QStandardItemModelDirector::index(int row, int column, const QModelIndex& parent) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_index_0_dispatch(this->ada_object, row, column, &parent);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QStandardItemModelDirector::insertColumns(int column, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_insertColumns_0_dispatch(this->ada_object, column, count, &parent);
}

bool QStandardItemModelDirector::insertRows(int row, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_insertRows_0_dispatch(this->ada_object, row, count, &parent);
}

QModelIndex QStandardItemModelDirector::parent(const QModelIndex& child) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_parent_1_dispatch(this->ada_object, &child);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QStandardItemModelDirector::removeColumns(int column, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_removeColumns_0_dispatch(this->ada_object, column, count, &parent);
}

bool QStandardItemModelDirector::removeRows(int row, int count, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_removeRows_0_dispatch(this->ada_object, row, count, &parent);
}

int QStandardItemModelDirector::rowCount(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_rowCount_0_dispatch(this->ada_object, &parent);
}

QModelIndex QStandardItemModelDirector::buddy(const QModelIndex& index) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemModel_buddy_0_dispatch(this->ada_object, &index);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

bool QStandardItemModelDirector::canFetchMore(const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_canFetchMore_0_dispatch(this->ada_object, &parent);
}

bool QStandardItemModelDirector::dropMimeData(QMimeData* data, Qt::DropAction action, int row, int column, const QModelIndex& parent)
{
    return __Qt4Ada_QAbstractItemModel_dropMimeData_0_dispatch(this->ada_object, data, action, row, column, &parent);
}

void QStandardItemModelDirector::fetchMore(const QModelIndex& parent)
{
    __Qt4Ada_QAbstractItemModel_fetchMore_0_dispatch(this->ada_object, &parent);
}

bool QStandardItemModelDirector::hasIndex(int row, int column, const QModelIndex& parent) const
{
    return __Qt4Ada_QAbstractItemModel_hasIndex_0_dispatch(this->ada_object, row, column, &parent);
}

QMimeData* QStandardItemModelDirector::mimeData(const QModelIndexList& indexes) const
{
    return dynamic_cast<QMimeData*>(__Qt4Ada_QAbstractItemModel_mimeData_0_dispatch(this->ada_object, &indexes));
}

QStringList QStandardItemModelDirector::mimeTypes() const
{
    QStringList *aux = __Qt4Ada_QAbstractItemModel_mimeTypes_0_dispatch(this->ada_object);
    QStringList returns = *aux;
    delete aux;
    return returns;
}

QSize QStandardItemModelDirector::span(const QModelIndex& index) const
{
    QSize *aux = __Qt4Ada_QAbstractItemModel_span_0_dispatch(this->ada_object, &index);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QStandardItemModelDirector::revert()
{
    __Qt4Ada_QAbstractItemModel_revert_0_dispatch(this->ada_object);
}

bool QStandardItemModelDirector::submit()
{
    return __Qt4Ada_QAbstractItemModel_submit_0_dispatch(this->ada_object);
}

bool QStandardItemModelDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QStandardItemModelDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QStandardItemModelDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QStandardItemModelDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QStandardItemModelDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QStandardItemModelDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QStandardItemModelDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QStandardItemModelDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include "qabstractitemmodeldirector.h"

bool QStandardItemModelDirector::setData(const QModelIndex&index,const QVariant&value,int role)
{
   return __Qt4Ada_QAbstractItemModel_setData_dispatch (this->ada_object, &index, &value, role);
}

extern "C"
{

    QObject* __Qt4Ada_new_QStandardItemModel (QObject*parent)
    {
        return dynamic_cast<QObject*> (new QStandardItemModel (parent));
    }

    QObject* __Qt4Ada_new_QStandardItemModel_with_rows_and_coumns (int rows,int columns,QObject*parent)
    {
        return dynamic_cast<QObject*> (new QStandardItemModel (rows,columns,parent));
    }

    QModelIndex* __Qt4Ada_QStandardItemModel_index_wrapper(QObject*cpp_this,int row,int col,const QModelIndex*model)
    {
        return (new QModelIndex (dynamic_cast<QStandardItemModel*>(cpp_this)->QStandardItemModel::index (row,col,*model)));
    }

    bool __Qt4Ada_QStandardItemModel_setData_wrapper (QObject*cpp_this,const QModelIndex*index, const QVariant*val, int role)
    {
        return dynamic_cast<QStandardItemModel*>(cpp_this)->QStandardItemModel::setData(*index, *val, role);
    }

    QVariant* __Qt4Ada_QStandardItemModel_data_wrapper(QObject* cpp_this, const QModelIndex* index, int role)
    {
        return (new QVariant (dynamic_cast<QStandardItemModel*>(cpp_this)->QStandardItemModel::data(*index, role)));
    }

}
