//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QSTANDARDITEMMODELDIRECTOR_H__
#define __QSTANDARDITEMMODELDIRECTOR_H__

#include <QStandardItemModel>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QStandardItemModel_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern int __Qt4Ada_QStandardItemModel_columnCount_0_wrapper(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QStandardItemModel_hasChildren_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QStandardItemModel_index_0_wrapper(QObject*, int, int, const QModelIndex*, QModelIndex*);
    extern bool __Qt4Ada_QStandardItemModel_insertColumns_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QStandardItemModel_insertRows_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern void __Qt4Ada_QStandardItemModel_parent_1_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    extern bool __Qt4Ada_QStandardItemModel_removeColumns_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QStandardItemModel_removeRows_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern int __Qt4Ada_QStandardItemModel_rowCount_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QStandardItemModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QStandardItemModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    extern void __Qt4Ada_QStandardItemModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_layoutChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QStandardItemModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern bool __Qt4Ada_QStandardItemModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern bool __Qt4Ada_QStandardItemModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern void __Qt4Ada_QStandardItemModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QStandardItemModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QStandardItemModel_beginResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QStandardItemModel_endInsertColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_endInsertRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_endMoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_endMoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_endRemoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_endRemoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_endResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_reset_0_wrapper(QObject*);
    extern void __Qt4Ada_QStandardItemModel_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QStandardItemModel_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QStandardItemModel_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QStandardItemModel_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QStandardItemModel_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QStandardItemModel_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

//  Constructors

extern "C"
{
    extern QObject* __Qt4Ada_new_QStandardItemModel (QObject*);
    extern QObject* __Qt4Ada_new_QStandardItemModel_with_rows_and_coumns (int,int,QObject*);

    extern QModelIndex* __Qt4Ada_QStandardItemModel_index_wrapper(QObject*,int ,int ,const QModelIndex*);

    extern QVariant* __Qt4Ada_QStandardItemModel_data_virtual(QObject*, const QModelIndex*, int);
    extern bool __Qt4Ada_QStandardItemModel_setData_wrapper (QObject*cpp_this,const QModelIndex*index, const QVariant*val, int role);

}

class QStandardItemModelDirector : public QStandardItemModel
{
protected:
    void* ada_object;
    QStandardItemModelDirector();
    virtual bool setData(const QModelIndex&,const QVariant&,int );

    virtual int columnCount(const QModelIndex&) const;
    virtual bool hasChildren(const QModelIndex&) const;
    virtual QModelIndex index(int, int, const QModelIndex&) const;
    virtual bool insertColumns(int, int, const QModelIndex&);
    virtual bool insertRows(int, int, const QModelIndex&);
    virtual QModelIndex parent(const QModelIndex&) const;
    virtual bool removeColumns(int, int, const QModelIndex&);
    virtual bool removeRows(int, int, const QModelIndex&);
    virtual int rowCount(const QModelIndex&) const;
    virtual QModelIndex buddy(const QModelIndex&) const;
    virtual bool canFetchMore(const QModelIndex&) const;
    virtual bool dropMimeData(QMimeData*, Qt::DropAction, int, int, const QModelIndex&);
    virtual void fetchMore(const QModelIndex&);
    virtual bool hasIndex(int, int, const QModelIndex&) const;
    virtual QMimeData* mimeData(const QModelIndexList&) const;
    virtual QStringList mimeTypes() const;
    virtual QSize span(const QModelIndex&) const;
    virtual void revert();
    virtual bool submit();
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QStandardItemModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QStandardItemModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    friend void __Qt4Ada_QStandardItemModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_layoutChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QStandardItemModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend bool __Qt4Ada_QStandardItemModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend bool __Qt4Ada_QStandardItemModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend void __Qt4Ada_QStandardItemModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QStandardItemModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QStandardItemModel_beginResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QStandardItemModel_endInsertColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_endInsertRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_endMoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_endMoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_endRemoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_endRemoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_endResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_reset_0_wrapper(QObject*);
    friend void __Qt4Ada_QStandardItemModel_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QStandardItemModel_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QStandardItemModel_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QStandardItemModel_sender_0_wrapper(QObject*);
};

#endif // __QSTANDARDITEMMODELDIRECTOR_H__
