//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QTextDocument>
#include <QTextCharFormat>
#include <QChildEvent>
#include <QTimerEvent>

#include "qsyntaxhighlighterdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QSyntaxHighlighter_staticMetaObject =
        &QSyntaxHighlighter::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    QObject* __Qt4Ada_QSyntaxHighlighter_document_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QSyntaxHighlighter*>(cpp_object)->QSyntaxHighlighter::document());
    }

    void __Qt4Ada_QSyntaxHighlighter_setDocument_0_wrapper(QObject* cpp_object, QObject* doc)
    {
        dynamic_cast<QSyntaxHighlighter*>(cpp_object)->QSyntaxHighlighter::setDocument(dynamic_cast<QTextDocument*>(doc));
    }

    void __Qt4Ada_QSyntaxHighlighter_rehighlight_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QSyntaxHighlighter*>(cpp_object)->QSyntaxHighlighter::rehighlight();
    }

    int __Qt4Ada_QSyntaxHighlighter_currentBlockState_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSyntaxHighlighterDirector*>(cpp_object)->QSyntaxHighlighter::currentBlockState();
    }

    int __Qt4Ada_QSyntaxHighlighter_previousBlockState_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSyntaxHighlighterDirector*>(cpp_object)->QSyntaxHighlighter::previousBlockState();
    }

    void __Qt4Ada_QSyntaxHighlighter_setCurrentBlockState_0_wrapper(QObject* cpp_object, int newState)
    {
        dynamic_cast<QSyntaxHighlighterDirector*>(cpp_object)->QSyntaxHighlighter::setCurrentBlockState(newState);
    }

    void __Qt4Ada_QSyntaxHighlighter_setFormat_2_wrapper(QObject* cpp_object, int start, int count, const QColor* color)
    {
        dynamic_cast<QSyntaxHighlighterDirector*>(cpp_object)->QSyntaxHighlighter::setFormat(start, count, *color);
    }

    void __Qt4Ada_QSyntaxHighlighter_setFormat_1_wrapper(QObject* cpp_object, int start, int count, const QFont* font)
    {
        dynamic_cast<QSyntaxHighlighterDirector*>(cpp_object)->QSyntaxHighlighter::setFormat(start, count, *font);
    }

    void __Qt4Ada_QSyntaxHighlighter_setFormat_0_wrapper(QObject* cpp_object, int start, int count, const QTextFormat* format)
    {
        dynamic_cast<QSyntaxHighlighterDirector*>(cpp_object)->QSyntaxHighlighter::setFormat(start, count, static_cast<const QTextCharFormat&>(*format));
    }

    void __Qt4Ada_QSyntaxHighlighter_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSyntaxHighlighterDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QSyntaxHighlighter_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSyntaxHighlighterDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QSyntaxHighlighter_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSyntaxHighlighterDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QSyntaxHighlighter_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSyntaxHighlighterDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QSyntaxHighlighter_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QSyntaxHighlighter*>(cpp_this)->QSyntaxHighlighter::qt_metacast(name);
    }

    int __Qt4Ada_QSyntaxHighlighter_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QSyntaxHighlighter*>(cpp_this)->QSyntaxHighlighter::qt_metacall(_c, _id, _a);
    }

}

void QSyntaxHighlighterDirector::highlightBlock(const QString& text)
{
    __Qt4Ada_QSyntaxHighlighter_highlightBlock_0_dispatch(this->ada_object, &text);
}

bool QSyntaxHighlighterDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QSyntaxHighlighterDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QSyntaxHighlighterDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QSyntaxHighlighterDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QSyntaxHighlighterDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QSyntaxHighlighterDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QSyntaxHighlighterDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QSyntaxHighlighterDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QSyntaxHighlighterDirector::QSyntaxHighlighterDirector(void* o, QObject* parent) :
    QSyntaxHighlighter(parent),
    ada_object (o)
{
}

QSyntaxHighlighterDirector::QSyntaxHighlighterDirector(void* o, QTextDocument* parent) :
    QSyntaxHighlighter(parent),
    ada_object (o)
{
}

QSyntaxHighlighterDirector::QSyntaxHighlighterDirector(void* o, QTextEdit* parent) :
    QSyntaxHighlighter(parent),
    ada_object (o)
{
}

extern "C"
{

    QObject* __Qt4Ada_new_QSyntaxHighlighterDirector_QObjectP(void* ada_object, QObject*parent)
    {
       return dynamic_cast<QObject*>(new QSyntaxHighlighterDirector(ada_object, parent));
    }

    QObject* __Qt4Ada_new_QSyntaxHighlighterDirector_QTextDocumentP(void* ada_object, QObject*parent)
    {
       return dynamic_cast<QObject*>(new QSyntaxHighlighterDirector(ada_object, dynamic_cast<QTextDocument*>(parent)));
    }

    QObject* __Qt4Ada_new_QSyntaxHighlighterDirector_QTextEditP(void* ada_object,QObject*parent)
    {
       return dynamic_cast<QObject*>(new QSyntaxHighlighterDirector(ada_object, dynamic_cast<QTextEdit*>(parent)));
    }

}
