------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Graphics_Items;

with Qt_Ada.Internals.Graphics_Items.Abstract_Graphics_Shape_Item_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Graphics_Items.Abstract_Graphics_Shape_Item_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Abstract_Graphics_Shape_Items is

   procedure brush_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Brushes.Internals.QBrush);
   pragma Import (C, brush_0_wrapper,
                     "__Qt4Ada_QAbstractGraphicsShapeItem_brush_0_wrapper");

   procedure pen_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Pens.Internals.QPen);
   pragma Import (C, pen_0_wrapper,
                     "__Qt4Ada_QAbstractGraphicsShapeItem_pen_0_wrapper");

   procedure setBrush_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Brush : not null access constant Qt4.Brushes.Internals.QBrush);
   pragma Import (C, setBrush_0_wrapper,
                     "__Qt4Ada_QAbstractGraphicsShapeItem_setBrush_0_wrapper");

   procedure setPen_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Pen : not null access constant Qt4.Pens.Internals.QPen);
   pragma Import (C, setPen_0_wrapper,
                     "__Qt4Ada_QAbstractGraphicsShapeItem_setPen_0_wrapper");

   pragma Style_Checks ("N");

   -----------
   -- Brush --
   -----------

   function Brush
    (Self : not null access constant Q_Abstract_Graphics_Shape_Item'Class)
       return Qt4.Brushes.Q_Brush
   is
      Returns : Qt4.Brushes.Q_Brush;

   begin
      brush_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Brushes.Internals.QBrush_View (Returns));

      return Returns;
   end Brush;

   ---------
   -- Pen --
   ---------

   function Pen
    (Self : not null access constant Q_Abstract_Graphics_Shape_Item'Class)
       return Qt4.Pens.Q_Pen
   is
      Returns : Qt4.Pens.Q_Pen;

   begin
      pen_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Pens.Internals.QPen_View (Returns));

      return Returns;
   end Pen;

   ---------------
   -- Set_Brush --
   ---------------

   procedure Set_Brush
    (Self : not null access Q_Abstract_Graphics_Shape_Item'Class;
     Brush : Qt4.Brushes.Q_Brush)
   is
   begin
      setBrush_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Brushes.Internals.QBrush_View (Brush));
   end Set_Brush;

   -------------
   -- Set_Pen --
   -------------

   procedure Set_Pen
    (Self : not null access Q_Abstract_Graphics_Shape_Item'Class;
     Pen : Qt4.Pens.Q_Pen)
   is
   begin
      setPen_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Pens.Internals.QPen_View (Pen));
   end Set_Pen;

end Qt4.Abstract_Graphics_Shape_Items;
