------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Frames;
limited with Qt4.Scroll_Bars;
with Qt4.Sizes;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Abstract_Scroll_Areas is

   type Q_Abstract_Scroll_Area is limited interface
     and Qt4.Frames.Q_Frame;

   type Q_Abstract_Scroll_Area_Access is
     access all Q_Abstract_Scroll_Area'Class;
   for Q_Abstract_Scroll_Area_Access'Storage_Size use 0;

   type Q_Abstract_Scroll_Area_Pointer is tagged;

   function Corner_Widget
    (Self : not null access constant Q_Abstract_Scroll_Area'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Horizontal_Scroll_Bar
    (Self : not null access constant Q_Abstract_Scroll_Area'Class)
       return not null access Qt4.Scroll_Bars.Q_Scroll_Bar'Class;

   function Maximum_Viewport_Size
    (Self : not null access constant Q_Abstract_Scroll_Area'Class)
       return Qt4.Sizes.Q_Size;

   procedure Set_Corner_Widget
    (Self : not null access Q_Abstract_Scroll_Area'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Horizontal_Scroll_Bar
    (Self : not null access Q_Abstract_Scroll_Area'Class;
     Scrollbar : not null access Qt4.Scroll_Bars.Q_Scroll_Bar'Class);

   procedure Set_Vertical_Scroll_Bar
    (Self : not null access Q_Abstract_Scroll_Area'Class;
     Scrollbar : not null access Qt4.Scroll_Bars.Q_Scroll_Bar'Class);

   procedure Set_Viewport
    (Self : not null access Q_Abstract_Scroll_Area'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   function Viewport
    (Self : not null access constant Q_Abstract_Scroll_Area'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Vertical_Scroll_Bar
    (Self : not null access constant Q_Abstract_Scroll_Area'Class)
       return not null access Qt4.Scroll_Bars.Q_Scroll_Bar'Class;

   package Q_Abstract_Scroll_Area_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Abstract_Scroll_Area, Q_Abstract_Scroll_Area_Access);

   type Q_Abstract_Scroll_Area_Pointer is
     new Q_Abstract_Scroll_Area_Pointers.Q_Pointer with null record;

end Qt4.Abstract_Scroll_Areas;
