------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Abstract_Sliders is

   type Q_Abstract_Slider is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Abstract_Slider_Access is
     access all Q_Abstract_Slider'Class;
   for Q_Abstract_Slider_Access'Storage_Size use 0;

   type Q_Abstract_Slider_Pointer is tagged;

   function Has_Tracking
    (Self : not null access constant Q_Abstract_Slider'Class)
       return Standard.Boolean;

   function Inverted_Appearance
    (Self : not null access constant Q_Abstract_Slider'Class)
       return Standard.Boolean;

   function Inverted_Controls
    (Self : not null access constant Q_Abstract_Slider'Class)
       return Standard.Boolean;

   function Is_Slider_Down
    (Self : not null access constant Q_Abstract_Slider'Class)
       return Standard.Boolean;

   function Maximum
    (Self : not null access constant Q_Abstract_Slider'Class)
       return Qt4.Q_Integer;

   function Minimum
    (Self : not null access constant Q_Abstract_Slider'Class)
       return Qt4.Q_Integer;

   function Page_Step
    (Self : not null access constant Q_Abstract_Slider'Class)
       return Qt4.Q_Integer;

   procedure Set_Inverted_Appearance
    (Self : not null access Q_Abstract_Slider'Class;
     Value : Standard.Boolean);

   procedure Set_Inverted_Controls
    (Self : not null access Q_Abstract_Slider'Class;
     Value : Standard.Boolean);

   procedure Set_Maximum
    (Self : not null access Q_Abstract_Slider'Class;
     Value : Qt4.Q_Integer);

   procedure Set_Minimum
    (Self : not null access Q_Abstract_Slider'Class;
     Value : Qt4.Q_Integer);

   procedure Set_Page_Step
    (Self : not null access Q_Abstract_Slider'Class;
     Value : Qt4.Q_Integer);

   procedure Set_Range
    (Self : not null access Q_Abstract_Slider'Class;
     Min : Qt4.Q_Integer;
     Max : Qt4.Q_Integer);

   procedure Set_Single_Step
    (Self : not null access Q_Abstract_Slider'Class;
     Value : Qt4.Q_Integer);

   procedure Set_Slider_Down
    (Self : not null access Q_Abstract_Slider'Class;
     Value : Standard.Boolean);

   procedure Set_Slider_Position
    (Self : not null access Q_Abstract_Slider'Class;
     Value : Qt4.Q_Integer);

   procedure Set_Tracking
    (Self : not null access Q_Abstract_Slider'Class;
     Enable : Standard.Boolean);

   function Single_Step
    (Self : not null access constant Q_Abstract_Slider'Class)
       return Qt4.Q_Integer;

   function Slider_Position
    (Self : not null access constant Q_Abstract_Slider'Class)
       return Qt4.Q_Integer;

   function Value
    (Self : not null access constant Q_Abstract_Slider'Class)
       return Qt4.Q_Integer;

   procedure Set_Value
    (Self : not null access Q_Abstract_Slider'Class;
     Value : Qt4.Q_Integer);

   package Q_Abstract_Slider_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Abstract_Slider, Q_Abstract_Slider_Access);

   type Q_Abstract_Slider_Pointer is
     new Q_Abstract_Slider_Pointers.Q_Pointer with null record;

end Qt4.Abstract_Sliders;
