------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Child_Events;
limited with Qt4.Events;
with Qt4.Meta_Objects;
with Qt4.Objects.Directors;
with Qt4.Text_Char_Formats;
limited with Qt4.Timer_Events;

package Qt4.Abstract_Text_Document_Layouts.Directors is

   type Q_Abstract_Text_Document_Layout_Director is
     abstract new Qt4.Objects.Directors.Q_Object_Director
       and Q_Abstract_Text_Document_Layout with null record;

   overriding
   function Block_Bounding_Rect
    (Self : not null access constant Q_Abstract_Text_Document_Layout_Director;
     Block : Qt4.Text_Blocks.Q_Text_Block)
       return Qt4.Rect_Fs.Q_Rect_F
         is abstract;

   overriding
   function Document_Size
    (Self : not null access constant Q_Abstract_Text_Document_Layout_Director)
       return Qt4.Size_Fs.Q_Size_F
         is abstract;

   overriding
   function Frame_Bounding_Rect
    (Self : not null access constant Q_Abstract_Text_Document_Layout_Director;
     Frame : not null access Qt4.Text_Frames.Q_Text_Frame'Class)
       return Qt4.Rect_Fs.Q_Rect_F
         is abstract;

   overriding
   function Hit_Test
    (Self : not null access constant Q_Abstract_Text_Document_Layout_Director;
     Point : Qt4.Point_Fs.Q_Point_F;
     Accuracy : Qt4.Hit_Test_Accuracy)
       return Qt4.Q_Integer
         is abstract;

   overriding
   function Page_Count
    (Self : not null access constant Q_Abstract_Text_Document_Layout_Director)
       return Qt4.Q_Integer
         is abstract;

   not overriding
   procedure Emit_Document_Size_Changed
    (Self : not null access Q_Abstract_Text_Document_Layout_Director;
     New_Size : Qt4.Size_Fs.Q_Size_F);

   not overriding
   procedure Emit_Page_Count_Changed
    (Self : not null access Q_Abstract_Text_Document_Layout_Director;
     New_Pages : Qt4.Q_Integer);

   not overriding
   procedure Emit_Update
    (Self : not null access Q_Abstract_Text_Document_Layout_Director;
     Rect : Qt4.Rect_Fs.Q_Rect_F);

   not overriding
   procedure Emit_Update_Block
    (Self : not null access Q_Abstract_Text_Document_Layout_Director;
     Block : Qt4.Text_Blocks.Q_Text_Block);

   not overriding
   procedure Document_Changed
    (Self : not null access Q_Abstract_Text_Document_Layout_Director;
     From : Qt4.Q_Integer;
     Chars_Removed : Qt4.Q_Integer;
     Chars_Added : Qt4.Q_Integer)
       is abstract;

   not overriding
   function Format
    (Self : not null access Q_Abstract_Text_Document_Layout_Director;
     Position : Qt4.Q_Integer)
       return Qt4.Text_Char_Formats.Q_Text_Char_Format;

   overriding
   procedure Child_Event
    (Self : not null access Q_Abstract_Text_Document_Layout_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Abstract_Text_Document_Layout_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_Abstract_Text_Document_Layout_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Abstract_Text_Document_Layout_Director)
       return access Qt4.Objects.Q_Object'Class;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QAbstractTextDocumentLayout_staticMetaObject");

end Qt4.Abstract_Text_Document_Layouts.Directors;
