------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Text_Documents;
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Abstract_Text_Document_Layout_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Abstract_Text_Document_Layout_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Abstract_Text_Document_Layouts is

   procedure anchorAt_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Point_Fs.Internals.QPointF;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, anchorAt_0_wrapper,
                     "__Qt4Ada_QAbstractTextDocumentLayout_anchorAt_0_wrapper");

   function document_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, document_0_wrapper,
                     "__Qt4Ada_QAbstractTextDocumentLayout_document_0_wrapper");

   procedure registerHandler_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Object_Type : Qt4.Q_Integer;
     Component : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, registerHandler_0_wrapper,
                     "__Qt4Ada_QAbstractTextDocumentLayout_registerHandler_0_wrapper");

   pragma Style_Checks ("N");

   ---------------
   -- Anchor_At --
   ---------------

   function Anchor_At
    (Self : not null access constant Q_Abstract_Text_Document_Layout'Class;
     Pos : Qt4.Point_Fs.Q_Point_F)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      anchorAt_0_wrapper
       (Self.QObject_View,
        Qt4.Point_Fs.Internals.QPointF_View (Pos),
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Anchor_At;

   --------------
   -- Document --
   --------------

   function Document
    (Self : not null access constant Q_Abstract_Text_Document_Layout'Class)
       return not null access Qt4.Text_Documents.Q_Text_Document'Class
   is
   begin
      return
        Qt4.Text_Documents.Q_Text_Document'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (document_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Document;

   ----------------------
   -- Register_Handler --
   ----------------------

   procedure Register_Handler
    (Self : not null access Q_Abstract_Text_Document_Layout'Class;
     Object_Type : Qt4.Q_Integer;
     Component : not null access Qt4.Objects.Q_Object'Class)
   is
   begin
      registerHandler_0_wrapper
       (Self.QObject_View,
        Object_Type,
        Component.QObject_View);
   end Register_Handler;

end Qt4.Abstract_Text_Document_Layouts;
