------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Child_Events;
with Qt4.Events;
with Qt4.Objects;
with Qt4.Timer_Events;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Applications.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QApplication_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QApplication_qt_metacast_wrapper");

   function notify_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Receiver : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
       return Qt4.bool;
   pragma Import (C, notify_0_wrapper,
                     "__Qt4Ada_QApplication_notify_0_wrapper");

   function event_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     E : not null access Qt_Ada.Internals.Events.QEvent)
       return Qt4.bool;
   pragma Import (C, event_0_wrapper,
                     "__Qt4Ada_QApplication_event_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QApplication_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QApplication_customEvent_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QApplication_timerEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QApplication_sender_0_wrapper");

   procedure commitData
    (This    : not null access Qt_Ada.Internals.Objects.QObject;
     Manager : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import
    (C, commitData,
     "__Qt4Ada_QApplication_commitData_wrapper");

   procedure commitData_dispatch
    (Self    : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Manager : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Export
    (C, commitData_dispatch,
     "__Qt4Ada_QApplication_commitData_dispatch");
   pragma Warnings (Off, commitData_dispatch);

   function compressEvent
    (This          : not null access Qt_Ada.Internals.Objects.QObject;
     Event         : not null access Qt_Ada.Internals.Events.QEvent;
     Receiver      : not null access Qt_Ada.Internals.Objects.QObject;
     Posted_Events : not null access Qt4.Post_Event_Lists.Q_Post_Event_List)
       return bool;
   pragma Import
    (C, compressEvent,
     "__Qt4Ada_QApplication_compressEvent_wrapper");

   procedure saveState
    (This    : not null access Qt_Ada.Internals.Objects.QObject;
     Manager : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import
    (C, saveState,
     "__Qt4Ada_QApplication_saveState_wrapper");

   procedure saveState_dispatch
    (Self    : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Manager : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Export
    (C, saveState_dispatch,
     "__Qt4Ada_QApplication_saveState_dispatch");
   pragma Warnings (Off, saveState_dispatch);

   -----------------
   -- Commit_Data --
   -----------------

   procedure Commit_Data
    (Self    : not null access Q_Application_Director;
     Manager : not null access Qt4.Session_Managers.Q_Session_Manager'Class)
   is
   begin
      commitData (Self.QObject_View, Manager.QObject_View);
   end Commit_Data;

   -------------------------
   -- commitData_dispatch --
   -------------------------

   procedure commitData_dispatch
    (Self    : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Manager : not null access Qt_Ada.Internals.Objects.QObject)
   is
   begin
      Q_Application_Director (Self.all).Commit_Data
       (Qt4.Session_Managers.Q_Session_Manager'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object (Manager).all)'Access);
   end commitData_dispatch;

   --------------------
   -- Compress_Event --
   --------------------

   function Compress_Event
    (Self          : not null access Q_Application_Director;
     Event         : not null access Qt4.Events.Q_Event'Class;
     Receiver      : not null access Qt4.Objects.Q_Object'Class;
     Posted_Events : not null access Qt4.Post_Event_Lists.Q_Post_Event_List)
       return Boolean
   is
   begin
      return
        To_Boolean
         (compressEvent
           (Self.QObject_View,
            Event.QEvent_View,
            Receiver.QObject_View,
            Posted_Events));
   end Compress_Event;

   ----------------
   -- Save_State --
   ----------------

   procedure Save_State
    (Self    : not null access Q_Application_Director;
     Manager : not null access Qt4.Session_Managers.Q_Session_Manager'Class)
   is
   begin
      saveState (Self.QObject_View, Manager.QObject_View);
   end Save_State;

   ------------------------
   -- saveState_dispatch --
   ------------------------

   procedure saveState_dispatch
    (Self    : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Manager : not null access Qt_Ada.Internals.Objects.QObject)
   is
   begin
      Q_Application_Director'Class (Self.all).Save_State
       (Qt4.Session_Managers.Q_Session_Manager'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object (Manager).all)'Access);
   end saveState_dispatch;

   pragma Style_Checks ("N");

   ------------
   -- Notify --
   ------------

   overriding
   function Notify
    (Self : not null access Q_Application_Director;
     Receiver : not null access Qt4.Objects.Q_Object'Class;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (notify_0_wrapper
           (Q_Application_Director'Class (Self.all).QObject_View,
            Receiver.QObject_View,
            Event.QEvent_View));
   end Notify;

   -----------
   -- Event --
   -----------

   overriding
   function Event
    (Self : not null access Q_Application_Director;
     E : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (event_0_wrapper
           (Q_Application_Director'Class (Self.all).QObject_View,
            E.QEvent_View));
   end Event;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_Application_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_Application_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_Application_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_Application_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_Application_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_Application_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_Application_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_Application_Director'Class (Self.all).QObject_View));
   end Sender;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QApplication", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.Applications.Directors;
