------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Check_Box_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Check_Box_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Check_Boxes is

   function checkState_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Check_State;
   pragma Import (C, checkState_0_wrapper,
                     "__Qt4Ada_QCheckBox_checkState_0_wrapper");

   function isTristate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isTristate_0_wrapper,
                     "__Qt4Ada_QCheckBox_isTristate_0_wrapper");

   procedure setCheckState_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     State : Qt4.Check_State);
   pragma Import (C, setCheckState_0_wrapper,
                     "__Qt4Ada_QCheckBox_setCheckState_0_wrapper");

   procedure setTristate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     State : Qt4.bool);
   pragma Import (C, setTristate_0_wrapper,
                     "__Qt4Ada_QCheckBox_setTristate_0_wrapper");

   pragma Style_Checks ("N");

   -----------------
   -- Check_State --
   -----------------

   function Check_State
    (Self : not null access constant Q_Check_Box'Class)
       return Qt4.Check_State
   is
   begin
      return
        checkState_0_wrapper
         (Self.QObject_View);
   end Check_State;

   -----------------
   -- Is_Tristate --
   -----------------

   function Is_Tristate
    (Self : not null access constant Q_Check_Box'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isTristate_0_wrapper
           (Self.QObject_View));
   end Is_Tristate;

   ---------------------
   -- Set_Check_State --
   ---------------------

   procedure Set_Check_State
    (Self : not null access Q_Check_Box'Class;
     State : Qt4.Check_State)
   is
   begin
      setCheckState_0_wrapper
       (Self.QObject_View,
        State);
   end Set_Check_State;

   ------------------
   -- Set_Tristate --
   ------------------

   procedure Set_Tristate
    (Self : not null access Q_Check_Box'Class;
     State : Standard.Boolean
       := True)
   is
   begin
      setTristate_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (State));
   end Set_Tristate;

end Qt4.Check_Boxes;
