------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Date_Time_Edit_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Date_Time_Edit_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Date_Time_Edits is

   function calendarPopup_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, calendarPopup_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_calendarPopup_0_wrapper");

   procedure clearMaximumDate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearMaximumDate_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_clearMaximumDate_0_wrapper");

   procedure clearMaximumDateTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearMaximumDateTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_clearMaximumDateTime_0_wrapper");

   procedure clearMaximumTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearMaximumTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_clearMaximumTime_0_wrapper");

   procedure clearMinimumDate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearMinimumDate_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_clearMinimumDate_0_wrapper");

   procedure clearMinimumDateTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearMinimumDateTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_clearMinimumDateTime_0_wrapper");

   procedure clearMinimumTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearMinimumTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_clearMinimumTime_0_wrapper");

   function currentSectionIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, currentSectionIndex_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_currentSectionIndex_0_wrapper");

   procedure date_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Dates.Internals.QDate);
   pragma Import (C, date_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_date_0_wrapper");

   procedure dateTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Date_Times.Internals.QDateTime);
   pragma Import (C, dateTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_dateTime_0_wrapper");

   procedure displayFormat_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, displayFormat_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_displayFormat_0_wrapper");

   procedure maximumDate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Dates.Internals.QDate);
   pragma Import (C, maximumDate_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_maximumDate_0_wrapper");

   procedure maximumDateTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Date_Times.Internals.QDateTime);
   pragma Import (C, maximumDateTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_maximumDateTime_0_wrapper");

   procedure maximumTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Times.Internals.QTime);
   pragma Import (C, maximumTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_maximumTime_0_wrapper");

   procedure minimumDate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Dates.Internals.QDate);
   pragma Import (C, minimumDate_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_minimumDate_0_wrapper");

   procedure minimumDateTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Date_Times.Internals.QDateTime);
   pragma Import (C, minimumDateTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_minimumDateTime_0_wrapper");

   procedure minimumTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Times.Internals.QTime);
   pragma Import (C, minimumTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_minimumTime_0_wrapper");

   function sectionCount_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, sectionCount_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_sectionCount_0_wrapper");

   procedure setCalendarPopup_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Enable : Qt4.bool);
   pragma Import (C, setCalendarPopup_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setCalendarPopup_0_wrapper");

   procedure setCurrentSectionIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Index : Qt4.Q_Integer);
   pragma Import (C, setCurrentSectionIndex_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setCurrentSectionIndex_0_wrapper");

   procedure setDateRange_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mix : not null access constant Qt4.Dates.Internals.QDate;
     Max : not null access constant Qt4.Dates.Internals.QDate);
   pragma Import (C, setDateRange_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setDateRange_0_wrapper");

   procedure setDateTimeRange_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mix : not null access constant Qt4.Date_Times.Internals.QDateTime;
     Max : not null access constant Qt4.Date_Times.Internals.QDateTime);
   pragma Import (C, setDateTimeRange_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setDateTimeRange_0_wrapper");

   procedure setDisplayFormat_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Format : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setDisplayFormat_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setDisplayFormat_0_wrapper");

   procedure setMaximumDate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Max : not null access constant Qt4.Dates.Internals.QDate);
   pragma Import (C, setMaximumDate_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setMaximumDate_0_wrapper");

   procedure setMaximumDateTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Max : not null access constant Qt4.Date_Times.Internals.QDateTime);
   pragma Import (C, setMaximumDateTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setMaximumDateTime_0_wrapper");

   procedure setMaximumTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Max : not null access constant Qt4.Times.Internals.QTime);
   pragma Import (C, setMaximumTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setMaximumTime_0_wrapper");

   procedure setMinimumDate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Min : not null access constant Qt4.Dates.Internals.QDate);
   pragma Import (C, setMinimumDate_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setMinimumDate_0_wrapper");

   procedure setMinimumDateTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Min : not null access constant Qt4.Date_Times.Internals.QDateTime);
   pragma Import (C, setMinimumDateTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setMinimumDateTime_0_wrapper");

   procedure setMinimumTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Min : not null access constant Qt4.Times.Internals.QTime);
   pragma Import (C, setMinimumTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setMinimumTime_0_wrapper");

   procedure setTimeRange_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mix : not null access constant Qt4.Times.Internals.QTime;
     Max : not null access constant Qt4.Times.Internals.QTime);
   pragma Import (C, setTimeRange_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setTimeRange_0_wrapper");

   procedure setTimeSpec_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Spec : Qt4.Time_Spec);
   pragma Import (C, setTimeSpec_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setTimeSpec_0_wrapper");

   procedure time_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Times.Internals.QTime);
   pragma Import (C, time_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_time_0_wrapper");

   function timeSpec_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Time_Spec;
   pragma Import (C, timeSpec_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_timeSpec_0_wrapper");

   procedure setDate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Date : not null access constant Qt4.Dates.Internals.QDate);
   pragma Import (C, setDate_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setDate_0_wrapper");

   procedure setDateTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Date_Time : not null access constant Qt4.Date_Times.Internals.QDateTime);
   pragma Import (C, setDateTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setDateTime_0_wrapper");

   procedure setTime_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Time : not null access constant Qt4.Times.Internals.QTime);
   pragma Import (C, setTime_0_wrapper,
                     "__Qt4Ada_QDateTimeEdit_setTime_0_wrapper");

   pragma Style_Checks ("N");

   --------------------
   -- Calendar_Popup --
   --------------------

   function Calendar_Popup
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (calendarPopup_0_wrapper
           (Self.QObject_View));
   end Calendar_Popup;

   ------------------------
   -- Clear_Maximum_Date --
   ------------------------

   procedure Clear_Maximum_Date
    (Self : not null access Q_Date_Time_Edit'Class)
   is
   begin
      clearMaximumDate_0_wrapper
       (Self.QObject_View);
   end Clear_Maximum_Date;

   -----------------------------
   -- Clear_Maximum_Date_Time --
   -----------------------------

   procedure Clear_Maximum_Date_Time
    (Self : not null access Q_Date_Time_Edit'Class)
   is
   begin
      clearMaximumDateTime_0_wrapper
       (Self.QObject_View);
   end Clear_Maximum_Date_Time;

   ------------------------
   -- Clear_Maximum_Time --
   ------------------------

   procedure Clear_Maximum_Time
    (Self : not null access Q_Date_Time_Edit'Class)
   is
   begin
      clearMaximumTime_0_wrapper
       (Self.QObject_View);
   end Clear_Maximum_Time;

   ------------------------
   -- Clear_Minimum_Date --
   ------------------------

   procedure Clear_Minimum_Date
    (Self : not null access Q_Date_Time_Edit'Class)
   is
   begin
      clearMinimumDate_0_wrapper
       (Self.QObject_View);
   end Clear_Minimum_Date;

   -----------------------------
   -- Clear_Minimum_Date_Time --
   -----------------------------

   procedure Clear_Minimum_Date_Time
    (Self : not null access Q_Date_Time_Edit'Class)
   is
   begin
      clearMinimumDateTime_0_wrapper
       (Self.QObject_View);
   end Clear_Minimum_Date_Time;

   ------------------------
   -- Clear_Minimum_Time --
   ------------------------

   procedure Clear_Minimum_Time
    (Self : not null access Q_Date_Time_Edit'Class)
   is
   begin
      clearMinimumTime_0_wrapper
       (Self.QObject_View);
   end Clear_Minimum_Time;

   ---------------------------
   -- Current_Section_Index --
   ---------------------------

   function Current_Section_Index
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        currentSectionIndex_0_wrapper
         (Self.QObject_View);
   end Current_Section_Index;

   ----------
   -- Date --
   ----------

   function Date
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Dates.Q_Date
   is
      Returns : Qt4.Dates.Q_Date;

   begin
      date_0_wrapper
       (Self.QObject_View,
        Qt4.Dates.Internals.QDate_View (Returns));

      return Returns;
   end Date;

   ---------------
   -- Date_Time --
   ---------------

   function Date_Time
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Date_Times.Q_Date_Time
   is
      Returns : Qt4.Date_Times.Q_Date_Time;

   begin
      dateTime_0_wrapper
       (Self.QObject_View,
        Qt4.Date_Times.Internals.QDateTime_View (Returns));

      return Returns;
   end Date_Time;

   --------------------
   -- Display_Format --
   --------------------

   function Display_Format
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      displayFormat_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Display_Format;

   ------------------
   -- Maximum_Date --
   ------------------

   function Maximum_Date
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Dates.Q_Date
   is
      Returns : Qt4.Dates.Q_Date;

   begin
      maximumDate_0_wrapper
       (Self.QObject_View,
        Qt4.Dates.Internals.QDate_View (Returns));

      return Returns;
   end Maximum_Date;

   -----------------------
   -- Maximum_Date_Time --
   -----------------------

   function Maximum_Date_Time
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Date_Times.Q_Date_Time
   is
      Returns : Qt4.Date_Times.Q_Date_Time;

   begin
      maximumDateTime_0_wrapper
       (Self.QObject_View,
        Qt4.Date_Times.Internals.QDateTime_View (Returns));

      return Returns;
   end Maximum_Date_Time;

   ------------------
   -- Maximum_Time --
   ------------------

   function Maximum_Time
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Times.Q_Time
   is
      Returns : Qt4.Times.Q_Time;

   begin
      maximumTime_0_wrapper
       (Self.QObject_View,
        Qt4.Times.Internals.QTime_View (Returns));

      return Returns;
   end Maximum_Time;

   ------------------
   -- Minimum_Date --
   ------------------

   function Minimum_Date
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Dates.Q_Date
   is
      Returns : Qt4.Dates.Q_Date;

   begin
      minimumDate_0_wrapper
       (Self.QObject_View,
        Qt4.Dates.Internals.QDate_View (Returns));

      return Returns;
   end Minimum_Date;

   -----------------------
   -- Minimum_Date_Time --
   -----------------------

   function Minimum_Date_Time
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Date_Times.Q_Date_Time
   is
      Returns : Qt4.Date_Times.Q_Date_Time;

   begin
      minimumDateTime_0_wrapper
       (Self.QObject_View,
        Qt4.Date_Times.Internals.QDateTime_View (Returns));

      return Returns;
   end Minimum_Date_Time;

   ------------------
   -- Minimum_Time --
   ------------------

   function Minimum_Time
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Times.Q_Time
   is
      Returns : Qt4.Times.Q_Time;

   begin
      minimumTime_0_wrapper
       (Self.QObject_View,
        Qt4.Times.Internals.QTime_View (Returns));

      return Returns;
   end Minimum_Time;

   -------------------
   -- Section_Count --
   -------------------

   function Section_Count
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        sectionCount_0_wrapper
         (Self.QObject_View);
   end Section_Count;

   ------------------------
   -- Set_Calendar_Popup --
   ------------------------

   procedure Set_Calendar_Popup
    (Self : not null access Q_Date_Time_Edit'Class;
     Enable : Standard.Boolean)
   is
   begin
      setCalendarPopup_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Enable));
   end Set_Calendar_Popup;

   -------------------------------
   -- Set_Current_Section_Index --
   -------------------------------

   procedure Set_Current_Section_Index
    (Self : not null access Q_Date_Time_Edit'Class;
     Index : Qt4.Q_Integer)
   is
   begin
      setCurrentSectionIndex_0_wrapper
       (Self.QObject_View,
        Index);
   end Set_Current_Section_Index;

   --------------------
   -- Set_Date_Range --
   --------------------

   procedure Set_Date_Range
    (Self : not null access Q_Date_Time_Edit'Class;
     Mix : Qt4.Dates.Q_Date;
     Max : Qt4.Dates.Q_Date)
   is
   begin
      setDateRange_0_wrapper
       (Self.QObject_View,
        Qt4.Dates.Internals.QDate_View (Mix),
        Qt4.Dates.Internals.QDate_View (Max));
   end Set_Date_Range;

   -------------------------
   -- Set_Date_Time_Range --
   -------------------------

   procedure Set_Date_Time_Range
    (Self : not null access Q_Date_Time_Edit'Class;
     Mix : Qt4.Date_Times.Q_Date_Time;
     Max : Qt4.Date_Times.Q_Date_Time)
   is
   begin
      setDateTimeRange_0_wrapper
       (Self.QObject_View,
        Qt4.Date_Times.Internals.QDateTime_View (Mix),
        Qt4.Date_Times.Internals.QDateTime_View (Max));
   end Set_Date_Time_Range;

   ------------------------
   -- Set_Display_Format --
   ------------------------

   procedure Set_Display_Format
    (Self : not null access Q_Date_Time_Edit'Class;
     Format : Qt4.Strings.Q_String)
   is
   begin
      setDisplayFormat_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Format));
   end Set_Display_Format;

   ----------------------
   -- Set_Maximum_Date --
   ----------------------

   procedure Set_Maximum_Date
    (Self : not null access Q_Date_Time_Edit'Class;
     Max : Qt4.Dates.Q_Date)
   is
   begin
      setMaximumDate_0_wrapper
       (Self.QObject_View,
        Qt4.Dates.Internals.QDate_View (Max));
   end Set_Maximum_Date;

   ---------------------------
   -- Set_Maximum_Date_Time --
   ---------------------------

   procedure Set_Maximum_Date_Time
    (Self : not null access Q_Date_Time_Edit'Class;
     Max : Qt4.Date_Times.Q_Date_Time)
   is
   begin
      setMaximumDateTime_0_wrapper
       (Self.QObject_View,
        Qt4.Date_Times.Internals.QDateTime_View (Max));
   end Set_Maximum_Date_Time;

   ----------------------
   -- Set_Maximum_Time --
   ----------------------

   procedure Set_Maximum_Time
    (Self : not null access Q_Date_Time_Edit'Class;
     Max : Qt4.Times.Q_Time)
   is
   begin
      setMaximumTime_0_wrapper
       (Self.QObject_View,
        Qt4.Times.Internals.QTime_View (Max));
   end Set_Maximum_Time;

   ----------------------
   -- Set_Minimum_Date --
   ----------------------

   procedure Set_Minimum_Date
    (Self : not null access Q_Date_Time_Edit'Class;
     Min : Qt4.Dates.Q_Date)
   is
   begin
      setMinimumDate_0_wrapper
       (Self.QObject_View,
        Qt4.Dates.Internals.QDate_View (Min));
   end Set_Minimum_Date;

   ---------------------------
   -- Set_Minimum_Date_Time --
   ---------------------------

   procedure Set_Minimum_Date_Time
    (Self : not null access Q_Date_Time_Edit'Class;
     Min : Qt4.Date_Times.Q_Date_Time)
   is
   begin
      setMinimumDateTime_0_wrapper
       (Self.QObject_View,
        Qt4.Date_Times.Internals.QDateTime_View (Min));
   end Set_Minimum_Date_Time;

   ----------------------
   -- Set_Minimum_Time --
   ----------------------

   procedure Set_Minimum_Time
    (Self : not null access Q_Date_Time_Edit'Class;
     Min : Qt4.Times.Q_Time)
   is
   begin
      setMinimumTime_0_wrapper
       (Self.QObject_View,
        Qt4.Times.Internals.QTime_View (Min));
   end Set_Minimum_Time;

   --------------------
   -- Set_Time_Range --
   --------------------

   procedure Set_Time_Range
    (Self : not null access Q_Date_Time_Edit'Class;
     Mix : Qt4.Times.Q_Time;
     Max : Qt4.Times.Q_Time)
   is
   begin
      setTimeRange_0_wrapper
       (Self.QObject_View,
        Qt4.Times.Internals.QTime_View (Mix),
        Qt4.Times.Internals.QTime_View (Max));
   end Set_Time_Range;

   -------------------
   -- Set_Time_Spec --
   -------------------

   procedure Set_Time_Spec
    (Self : not null access Q_Date_Time_Edit'Class;
     Spec : Qt4.Time_Spec)
   is
   begin
      setTimeSpec_0_wrapper
       (Self.QObject_View,
        Spec);
   end Set_Time_Spec;

   ----------
   -- Time --
   ----------

   function Time
    (Self : not null access constant Q_Date_Time_Edit'Class)
       return Qt4.Times.Q_Time
   is
      Returns : Qt4.Times.Q_Time;

   begin
      time_0_wrapper
       (Self.QObject_View,
        Qt4.Times.Internals.QTime_View (Returns));

      return Returns;
   end Time;

   ---------------
   -- Time_Spec --
   ---------------

   function Time_Spec
    (Self : not null access Q_Date_Time_Edit'Class)
       return Qt4.Time_Spec
   is
   begin
      return
        timeSpec_0_wrapper
         (Self.QObject_View);
   end Time_Spec;

   --------------
   -- Set_Date --
   --------------

   procedure Set_Date
    (Self : not null access Q_Date_Time_Edit'Class;
     Date : Qt4.Dates.Q_Date)
   is
   begin
      setDate_0_wrapper
       (Self.QObject_View,
        Qt4.Dates.Internals.QDate_View (Date));
   end Set_Date;

   -------------------
   -- Set_Date_Time --
   -------------------

   procedure Set_Date_Time
    (Self : not null access Q_Date_Time_Edit'Class;
     Date_Time : Qt4.Date_Times.Q_Date_Time)
   is
   begin
      setDateTime_0_wrapper
       (Self.QObject_View,
        Qt4.Date_Times.Internals.QDateTime_View (Date_Time));
   end Set_Date_Time;

   --------------
   -- Set_Time --
   --------------

   procedure Set_Time
    (Self : not null access Q_Date_Time_Edit'Class;
     Time : Qt4.Times.Q_Time)
   is
   begin
      setTime_0_wrapper
       (Self.QObject_View,
        Qt4.Times.Internals.QTime_View (Time));
   end Set_Time;

end Qt4.Date_Time_Edits;
