------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Dialogs is

   type Q_Dialog is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Dialog_Access is
     access all Q_Dialog'Class;
   for Q_Dialog_Access'Storage_Size use 0;

   type Q_Dialog_Pointer is tagged;

   function Is_Size_Grip_Enabled
    (Self : not null access constant Q_Dialog'Class)
       return Standard.Boolean;

   function Result
    (Self : not null access constant Q_Dialog'Class)
       return Qt4.Q_Integer;

   procedure Set_Modal
    (Self : not null access Q_Dialog'Class;
     Modal : Standard.Boolean);

   procedure Set_Result
    (Self : not null access Q_Dialog'Class;
     Result : Qt4.Q_Integer);

   procedure Set_Size_Grip_Enabled
    (Self : not null access Q_Dialog'Class;
     Enable : Standard.Boolean);

   not overriding
   procedure Accept_Dialog
    (Self : not null access Q_Dialog)
       is abstract;

   not overriding
   procedure Done
    (Self : not null access Q_Dialog;
     Result : Qt4.Q_Integer)
       is abstract;

   function Exec
    (Self : not null access Q_Dialog'Class)
       return Qt4.Q_Integer;

   not overriding
   procedure Reject
    (Self : not null access Q_Dialog)
       is abstract;

   subtype Dialog_Code is Q_Integer;

   Accepted : constant Dialog_Code := 1;
   Rejected : constant Dialog_Code := 0;

   package Q_Dialog_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Dialog, Q_Dialog_Access);

   type Q_Dialog_Pointer is
     new Q_Dialog_Pointers.Q_Pointer with null record;

end Qt4.Dialogs;
