------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Child_Events;
limited with Qt4.Events;
with Qt4.Meta_Objects;
limited with Qt4.Objects;
with Qt4.Strings;
limited with Qt4.Timer_Events;
with Qt4.Validators.Directors;

package Qt4.Double_Validators.Directors is

   type Q_Double_Validator_Director is
     new Qt4.Validators.Directors.Q_Validator_Director
       and Q_Double_Validator with null record;

   overriding
   procedure Set_Range
    (Self : not null access Q_Double_Validator_Director;
     Bottom : Qt4.Q_Real;
     Top : Qt4.Q_Real;
     Decimals : Qt4.Q_Integer
       :=  0);

   overriding
   procedure Child_Event
    (Self : not null access Q_Double_Validator_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Double_Validator_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_Double_Validator_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Double_Validator_Director)
       return access Qt4.Objects.Q_Object'Class;

   overriding
   function Validate
    (Self  : not null access constant Q_Double_Validator_Director;
     Input : not null access Qt4.Strings.Q_String;
     Pos   : not null access Qt4.Q_Integer)
       return Qt4.Validators.Validator_State;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QDoubleValidator_staticMetaObject");

end Qt4.Double_Validators.Directors;
