------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Double_Validator_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Double_Validator_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Double_Validators is

   function bottom_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Real;
   pragma Import (C, bottom_0_wrapper,
                     "__Qt4Ada_QDoubleValidator_bottom_0_wrapper");

   function decimals_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, decimals_0_wrapper,
                     "__Qt4Ada_QDoubleValidator_decimals_0_wrapper");

   procedure setBottom_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Bottom : Qt4.Q_Real);
   pragma Import (C, setBottom_0_wrapper,
                     "__Qt4Ada_QDoubleValidator_setBottom_0_wrapper");

   procedure setDecimals_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Decimals : Qt4.Q_Integer);
   pragma Import (C, setDecimals_0_wrapper,
                     "__Qt4Ada_QDoubleValidator_setDecimals_0_wrapper");

   procedure setTop_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Top : Qt4.Q_Real);
   pragma Import (C, setTop_0_wrapper,
                     "__Qt4Ada_QDoubleValidator_setTop_0_wrapper");

   function top_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Real;
   pragma Import (C, top_0_wrapper,
                     "__Qt4Ada_QDoubleValidator_top_0_wrapper");

   pragma Style_Checks ("N");

   ------------
   -- Bottom --
   ------------

   function Bottom
    (Self : not null access constant Q_Double_Validator'Class)
       return Qt4.Q_Real
   is
   begin
      return
        bottom_0_wrapper
         (Self.QObject_View);
   end Bottom;

   --------------
   -- Decimals --
   --------------

   function Decimals
    (Self : not null access constant Q_Double_Validator'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        decimals_0_wrapper
         (Self.QObject_View);
   end Decimals;

   ----------------
   -- Set_Bottom --
   ----------------

   procedure Set_Bottom
    (Self : not null access Q_Double_Validator'Class;
     Bottom : Qt4.Q_Real)
   is
   begin
      setBottom_0_wrapper
       (Self.QObject_View,
        Bottom);
   end Set_Bottom;

   ------------------
   -- Set_Decimals --
   ------------------

   procedure Set_Decimals
    (Self : not null access Q_Double_Validator'Class;
     Decimals : Qt4.Q_Integer)
   is
   begin
      setDecimals_0_wrapper
       (Self.QObject_View,
        Decimals);
   end Set_Decimals;

   -------------
   -- Set_Top --
   -------------

   procedure Set_Top
    (Self : not null access Q_Double_Validator'Class;
     Top : Qt4.Q_Real)
   is
   begin
      setTop_0_wrapper
       (Self.QObject_View,
        Top);
   end Set_Top;

   ---------
   -- Top --
   ---------

   function Top
    (Self : not null access constant Q_Double_Validator'Class)
       return Qt4.Q_Real
   is
   begin
      return
        top_0_wrapper
         (Self.QObject_View);
   end Top;

end Qt4.Double_Validators;
