------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Validators;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Double_Validators is

   type Q_Double_Validator is limited interface
     and Qt4.Validators.Q_Validator;

   type Q_Double_Validator_Access is
     access all Q_Double_Validator'Class;
   for Q_Double_Validator_Access'Storage_Size use 0;

   type Q_Double_Validator_Pointer is tagged;

   function Bottom
    (Self : not null access constant Q_Double_Validator'Class)
       return Qt4.Q_Real;

   function Decimals
    (Self : not null access constant Q_Double_Validator'Class)
       return Qt4.Q_Integer;

   procedure Set_Bottom
    (Self : not null access Q_Double_Validator'Class;
     Bottom : Qt4.Q_Real);

   procedure Set_Decimals
    (Self : not null access Q_Double_Validator'Class;
     Decimals : Qt4.Q_Integer);

   not overriding
   procedure Set_Range
    (Self : not null access Q_Double_Validator;
     Bottom : Qt4.Q_Real;
     Top : Qt4.Q_Real;
     Decimals : Qt4.Q_Integer
       :=  0)
       is abstract;

   procedure Set_Top
    (Self : not null access Q_Double_Validator'Class;
     Top : Qt4.Q_Real);

   function Top
    (Self : not null access constant Q_Double_Validator'Class)
       return Qt4.Q_Real;

   package Q_Double_Validator_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Double_Validator, Q_Double_Validator_Access);

   type Q_Double_Validator_Pointer is
     new Q_Double_Validator_Pointers.Q_Pointer with null record;

end Qt4.Double_Validators;
