------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Graphics_Items;

with Qt_Ada.Internals.Graphics_Items.Graphics_Ellipse_Item_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Graphics_Items.Graphics_Ellipse_Item_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Graphics_Ellipse_Items is

   procedure rect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, rect_0_wrapper,
                     "__Qt4Ada_QGraphicsEllipseItem_rect_0_wrapper");

   procedure setRect_1_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rect : not null access constant Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, setRect_1_wrapper,
                     "__Qt4Ada_QGraphicsEllipseItem_setRect_1_wrapper");

   procedure setRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real);
   pragma Import (C, setRect_0_wrapper,
                     "__Qt4Ada_QGraphicsEllipseItem_setRect_0_wrapper");

   pragma Style_Checks ("N");

   ----------
   -- Rect --
   ----------

   function Rect
    (Self : not null access constant Q_Graphics_Ellipse_Item'Class)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      rect_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Rect;

   --------------
   -- Set_Rect --
   --------------

   procedure Set_Rect
    (Self : not null access Q_Graphics_Ellipse_Item'Class;
     Rect : Qt4.Rect_Fs.Q_Rect_F)
   is
   begin
      setRect_1_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Rect));
   end Set_Rect;

   --------------
   -- Set_Rect --
   --------------

   procedure Set_Rect
    (Self : not null access Q_Graphics_Ellipse_Item'Class;
     X : Qt4.Q_Real;
     Y : Qt4.Q_Real;
     W : Qt4.Q_Real;
     H : Qt4.Q_Real)
   is
   begin
      setRect_0_wrapper
       (Self.QGraphicsItem_View,
        X,
        Y,
        W,
        H);
   end Set_Rect;

end Qt4.Graphics_Ellipse_Items;
