------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Child_Events;
with Qt4.Events;
with Qt4.Focus_Events;
with Qt4.Graphics_Items.Directors;
with Qt4.Graphics_Scene_Context_Menu_Events;
with Qt4.Graphics_Scene_Drag_Drop_Events;
with Qt4.Graphics_Scene_Hover_Events;
with Qt4.Graphics_Scene_Mouse_Events;
with Qt4.Graphics_Scene_Wheel_Events;
with Qt4.Input_Method_Events;
with Qt4.Key_Events;
with Qt4.Timer_Events;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Graphics_Objects.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QGraphicsObject_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QGraphicsObject_qt_metacast_wrapper");

   procedure enabledChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, enabledChanged_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_enabledChanged_0_wrapper");

   procedure opacityChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, opacityChanged_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_opacityChanged_0_wrapper");

   procedure parentChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, parentChanged_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_parentChanged_0_wrapper");

   procedure rotationChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, rotationChanged_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_rotationChanged_0_wrapper");

   procedure scaleChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, scaleChanged_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_scaleChanged_0_wrapper");

   procedure visibleChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, visibleChanged_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_visibleChanged_0_wrapper");

   procedure xChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, xChanged_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_xChanged_0_wrapper");

   procedure yChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, yChanged_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_yChanged_0_wrapper");

   procedure zChanged_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, zChanged_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_zChanged_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_customEvent_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_timerEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_sender_0_wrapper");

   procedure advance_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Phase : Qt4.Q_Integer);
   pragma Import (C, advance_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_advance_0_wrapper");

   function collidesWithItem_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Other : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Mode : Qt4.Item_Selection_Mode)
       return Qt4.bool;
   pragma Import (C, collidesWithItem_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_collidesWithItem_0_wrapper");

   function collidesWithPath_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Path : not null access constant Qt4.Painter_Paths.Internals.QPainterPath;
     Mode : Qt4.Item_Selection_Mode)
       return Qt4.bool;
   pragma Import (C, collidesWithPath_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_collidesWithPath_0_wrapper");

   function contains_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Point : not null access constant Qt4.Point_Fs.Internals.QPointF)
       return Qt4.bool;
   pragma Import (C, contains_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_contains_0_wrapper");

   function isObscuredBy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isObscuredBy_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_isObscuredBy_0_wrapper");

   procedure opaqueArea_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, opaqueArea_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_opaqueArea_0_wrapper");

   procedure shape_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, shape_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_shape_0_wrapper");

   procedure contextMenuEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, contextMenuEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_contextMenuEvent_0_wrapper");

   procedure dragEnterEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragEnterEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_dragEnterEvent_0_wrapper");

   procedure dragLeaveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragLeaveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_dragLeaveEvent_0_wrapper");

   procedure dragMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragMoveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_dragMoveEvent_0_wrapper");

   procedure dropEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dropEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_dropEvent_0_wrapper");

   procedure focusInEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, focusInEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_focusInEvent_0_wrapper");

   procedure focusOutEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, focusOutEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_focusOutEvent_0_wrapper");

   procedure hoverEnterEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, hoverEnterEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_hoverEnterEvent_0_wrapper");

   procedure hoverMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, hoverMoveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_hoverMoveEvent_0_wrapper");

   procedure hoverLeaveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, hoverLeaveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_hoverLeaveEvent_0_wrapper");

   procedure inputMethodEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, inputMethodEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_inputMethodEvent_0_wrapper");

   procedure inputMethodQuery_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Query : Qt4.Input_Method_Query;
     Returns : not null access Qt4.Variants.Internals.QVariant);
   pragma Import (C, inputMethodQuery_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_inputMethodQuery_0_wrapper");

   procedure itemChange_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Change : Qt4.Graphics_Items.Graphics_Item_Graphics_Item_Change;
     Value : not null access constant Qt4.Variants.Internals.QVariant;
     Returns : not null access Qt4.Variants.Internals.QVariant);
   pragma Import (C, itemChange_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_itemChange_0_wrapper");

   procedure keyPressEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, keyPressEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_keyPressEvent_0_wrapper");

   procedure keyReleaseEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, keyReleaseEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_keyReleaseEvent_0_wrapper");

   procedure mouseDoubleClickEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseDoubleClickEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mouseDoubleClickEvent_0_wrapper");

   procedure mouseMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseMoveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mouseMoveEvent_0_wrapper");

   procedure mousePressEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mousePressEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mousePressEvent_0_wrapper");

   procedure mouseReleaseEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseReleaseEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_mouseReleaseEvent_0_wrapper");

   procedure prepareGeometryChange_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, prepareGeometryChange_0_wrapper,
                     "__Qt4Ada_QGraphicsObject_prepareGeometryChange_0_wrapper");

   function sceneEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
       return Qt4.bool;
   pragma Import (C, sceneEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_sceneEvent_0_wrapper");

   function sceneEventFilter_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Watched : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
       return Qt4.bool;
   pragma Import (C, sceneEventFilter_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_sceneEventFilter_0_wrapper");

   procedure wheelEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, wheelEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsItem_wheelEvent_0_wrapper");

   ------------------------
   -- QGraphicsItem_View --
   ------------------------

   function dynamic_cast_QGraphicsItem
    (Item : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt_Ada.Internals.Graphics_Items.QGraphicsItem_Access;
   pragma Import
    (C, dynamic_cast_QGraphicsItem,
     "__QtAda_dynamic_cast_QGraphicsItem_from_QObject");

   overriding
   function QGraphicsItem_View
    (Self : not null access constant Q_Graphics_Object_Director)
       return not null Qt_Ada.Internals.Graphics_Items.QGraphicsItem_Access
   is
   begin
      return dynamic_cast_QGraphicsItem (Self.QObject_View);
   end QGraphicsItem_View;

   pragma Style_Checks ("N");

   --------------------------
   -- Emit_Enabled_Changed --
   --------------------------

   not overriding
   procedure Emit_Enabled_Changed
    (Self : not null access Q_Graphics_Object_Director)
   is
   begin
      enabledChanged_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View);
   end Emit_Enabled_Changed;

   --------------------------
   -- Emit_Opacity_Changed --
   --------------------------

   not overriding
   procedure Emit_Opacity_Changed
    (Self : not null access Q_Graphics_Object_Director)
   is
   begin
      opacityChanged_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View);
   end Emit_Opacity_Changed;

   -------------------------
   -- Emit_Parent_Changed --
   -------------------------

   not overriding
   procedure Emit_Parent_Changed
    (Self : not null access Q_Graphics_Object_Director)
   is
   begin
      parentChanged_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View);
   end Emit_Parent_Changed;

   ---------------------------
   -- Emit_Rotation_Changed --
   ---------------------------

   not overriding
   procedure Emit_Rotation_Changed
    (Self : not null access Q_Graphics_Object_Director)
   is
   begin
      rotationChanged_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View);
   end Emit_Rotation_Changed;

   ------------------------
   -- Emit_Scale_Changed --
   ------------------------

   not overriding
   procedure Emit_Scale_Changed
    (Self : not null access Q_Graphics_Object_Director)
   is
   begin
      scaleChanged_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View);
   end Emit_Scale_Changed;

   --------------------------
   -- Emit_Visible_Changed --
   --------------------------

   not overriding
   procedure Emit_Visible_Changed
    (Self : not null access Q_Graphics_Object_Director)
   is
   begin
      visibleChanged_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View);
   end Emit_Visible_Changed;

   --------------------
   -- Emit_X_Changed --
   --------------------

   not overriding
   procedure Emit_X_Changed
    (Self : not null access Q_Graphics_Object_Director)
   is
   begin
      xChanged_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View);
   end Emit_X_Changed;

   --------------------
   -- Emit_Y_Changed --
   --------------------

   not overriding
   procedure Emit_Y_Changed
    (Self : not null access Q_Graphics_Object_Director)
   is
   begin
      yChanged_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View);
   end Emit_Y_Changed;

   --------------------
   -- Emit_Z_Changed --
   --------------------

   not overriding
   procedure Emit_Z_Changed
    (Self : not null access Q_Graphics_Object_Director)
   is
   begin
      zChanged_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View);
   end Emit_Z_Changed;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_Graphics_Object_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_Graphics_Object_Director'Class (Self.all).QObject_View));
   end Sender;

   -------------
   -- Advance --
   -------------

   overriding
   procedure Advance
    (Self : not null access Q_Graphics_Object_Director;
     Phase : Qt4.Q_Integer)
   is
   begin
      advance_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Phase);
   end Advance;

   ------------------------
   -- Collides_With_Item --
   ------------------------

   overriding
   function Collides_With_Item
    (Self : not null access constant Q_Graphics_Object_Director;
     Other : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Mode : Qt4.Item_Selection_Mode
       := Qt4.Intersects_Item_Shape)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (collidesWithItem_0_wrapper
           (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
            Other.QGraphicsItem_View,
            Mode));
   end Collides_With_Item;

   ------------------------
   -- Collides_With_Path --
   ------------------------

   overriding
   function Collides_With_Path
    (Self : not null access constant Q_Graphics_Object_Director;
     Path : Qt4.Painter_Paths.Q_Painter_Path;
     Mode : Qt4.Item_Selection_Mode
       := Qt4.Intersects_Item_Shape)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (collidesWithPath_0_wrapper
           (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
            Qt4.Painter_Paths.Internals.QPainterPath_View (Path),
            Mode));
   end Collides_With_Path;

   --------------
   -- Contains --
   --------------

   overriding
   function Contains
    (Self : not null access constant Q_Graphics_Object_Director;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (contains_0_wrapper
           (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
            Qt4.Point_Fs.Internals.QPointF_View (Point)));
   end Contains;

   --------------------
   -- Is_Obscured_By --
   --------------------

   overriding
   function Is_Obscured_By
    (Self : not null access constant Q_Graphics_Object_Director;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isObscuredBy_0_wrapper
           (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
            Item.QGraphicsItem_View));
   end Is_Obscured_By;

   -----------------
   -- Opaque_Area --
   -----------------

   overriding
   function Opaque_Area
    (Self : not null access constant Q_Graphics_Object_Director)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      opaqueArea_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Opaque_Area;

   -----------
   -- Shape --
   -----------

   overriding
   function Shape
    (Self : not null access constant Q_Graphics_Object_Director)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      shape_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Shape;

   ------------------------
   -- Context_Menu_Event --
   ------------------------

   not overriding
   procedure Context_Menu_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Context_Menu_Events.Q_Graphics_Scene_Context_Menu_Event'Class)
   is
   begin
      contextMenuEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Context_Menu_Event;

   ----------------------
   -- Drag_Enter_Event --
   ----------------------

   not overriding
   procedure Drag_Enter_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dragEnterEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Drag_Enter_Event;

   ----------------------
   -- Drag_Leave_Event --
   ----------------------

   not overriding
   procedure Drag_Leave_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dragLeaveEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Drag_Leave_Event;

   ---------------------
   -- Drag_Move_Event --
   ---------------------

   not overriding
   procedure Drag_Move_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dragMoveEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Drag_Move_Event;

   ----------------
   -- Drop_Event --
   ----------------

   not overriding
   procedure Drop_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dropEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Drop_Event;

   --------------------
   -- Focus_In_Event --
   --------------------

   not overriding
   procedure Focus_In_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class)
   is
   begin
      focusInEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Focus_In_Event;

   ---------------------
   -- Focus_Out_Event --
   ---------------------

   not overriding
   procedure Focus_Out_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class)
   is
   begin
      focusOutEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Focus_Out_Event;

   -----------------------
   -- Hover_Enter_Event --
   -----------------------

   not overriding
   procedure Hover_Enter_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class)
   is
   begin
      hoverEnterEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Hover_Enter_Event;

   ----------------------
   -- Hover_Move_Event --
   ----------------------

   not overriding
   procedure Hover_Move_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class)
   is
   begin
      hoverMoveEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Hover_Move_Event;

   -----------------------
   -- Hover_Leave_Event --
   -----------------------

   not overriding
   procedure Hover_Leave_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class)
   is
   begin
      hoverLeaveEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Hover_Leave_Event;

   ------------------------
   -- Input_Method_Event --
   ------------------------

   not overriding
   procedure Input_Method_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Input_Method_Events.Q_Input_Method_Event'Class)
   is
   begin
      inputMethodEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Input_Method_Event;

   ------------------------
   -- Input_Method_Query --
   ------------------------

   not overriding
   function Input_Method_Query
    (Self : not null access constant Q_Graphics_Object_Director;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      inputMethodQuery_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Query,
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Input_Method_Query;

   -----------------
   -- Item_Change --
   -----------------

   not overriding
   function Item_Change
    (Self : not null access Q_Graphics_Object_Director;
     Change : Qt4.Graphics_Items.Graphics_Item_Graphics_Item_Change;
     Value : Qt4.Variants.Q_Variant)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      itemChange_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Change,
        Qt4.Variants.Internals.QVariant_View (Value),
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Item_Change;

   ---------------------
   -- Key_Press_Event --
   ---------------------

   not overriding
   procedure Key_Press_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class)
   is
   begin
      keyPressEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Key_Press_Event;

   -----------------------
   -- Key_Release_Event --
   -----------------------

   not overriding
   procedure Key_Release_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class)
   is
   begin
      keyReleaseEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Key_Release_Event;

   ------------------------------
   -- Mouse_Double_Click_Event --
   ------------------------------

   not overriding
   procedure Mouse_Double_Click_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mouseDoubleClickEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Mouse_Double_Click_Event;

   ----------------------
   -- Mouse_Move_Event --
   ----------------------

   not overriding
   procedure Mouse_Move_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mouseMoveEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Mouse_Move_Event;

   -----------------------
   -- Mouse_Press_Event --
   -----------------------

   not overriding
   procedure Mouse_Press_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mousePressEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Mouse_Press_Event;

   -------------------------
   -- Mouse_Release_Event --
   -------------------------

   not overriding
   procedure Mouse_Release_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mouseReleaseEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Mouse_Release_Event;

   -----------------------------
   -- Prepare_Geometry_Change --
   -----------------------------

   not overriding
   procedure Prepare_Geometry_Change
    (Self : not null access Q_Graphics_Object_Director)
   is
   begin
      prepareGeometryChange_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View);
   end Prepare_Geometry_Change;

   -----------------
   -- Scene_Event --
   -----------------

   not overriding
   function Scene_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (sceneEvent_0_wrapper
           (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
            Event.QEvent_View));
   end Scene_Event;

   ------------------------
   -- Scene_Event_Filter --
   ------------------------

   not overriding
   function Scene_Event_Filter
    (Self : not null access Q_Graphics_Object_Director;
     Watched : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (sceneEventFilter_0_wrapper
           (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
            Watched.QGraphicsItem_View,
            Event.QEvent_View));
   end Scene_Event_Filter;

   -----------------
   -- Wheel_Event --
   -----------------

   not overriding
   procedure Wheel_Event
    (Self : not null access Q_Graphics_Object_Director;
     Event : not null access Qt4.Graphics_Scene_Wheel_Events.Q_Graphics_Scene_Wheel_Event'Class)
   is
   begin
      wheelEvent_0_wrapper
       (Q_Graphics_Object_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Wheel_Event;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QGraphicsObject", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.Graphics_Objects.Directors;
