------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009, 2010 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Events;
with Qt4.Focus_Events;
with Qt4.Graphics_Items.Directors;
with Qt4.Graphics_Scene_Context_Menu_Events;
with Qt4.Graphics_Scene_Drag_Drop_Events;
with Qt4.Graphics_Scene_Hover_Events;
with Qt4.Graphics_Scene_Mouse_Events;
with Qt4.Graphics_Scene_Wheel_Events;
with Qt4.Input_Method_Events;
with Qt4.Key_Events;
with Qt4.Style_Options;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Graphics_Items;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Graphics_Path_Items.Directors is

   procedure boundingRect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Rect_Fs.Internals.QRectF);
   pragma Import (C, boundingRect_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_boundingRect_0_wrapper");

   function contains_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Point : not null access constant Qt4.Point_Fs.Internals.QPointF)
       return Qt4.bool;
   pragma Import (C, contains_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_contains_0_wrapper");

   function isObscuredBy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Item : not null access constant Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.bool;
   pragma Import (C, isObscuredBy_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_isObscuredBy_0_wrapper");

   procedure opaqueArea_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, opaqueArea_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_opaqueArea_0_wrapper");

   procedure shape_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Painter_Paths.Internals.QPainterPath);
   pragma Import (C, shape_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_shape_0_wrapper");

   procedure contextMenuEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, contextMenuEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_contextMenuEvent_0_wrapper");

   procedure dragEnterEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragEnterEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_dragEnterEvent_0_wrapper");

   procedure dragLeaveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragLeaveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_dragLeaveEvent_0_wrapper");

   procedure dragMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragMoveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_dragMoveEvent_0_wrapper");

   procedure dropEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dropEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_dropEvent_0_wrapper");

   procedure focusInEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, focusInEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_focusInEvent_0_wrapper");

   procedure focusOutEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, focusOutEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_focusOutEvent_0_wrapper");

   procedure hoverEnterEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, hoverEnterEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_hoverEnterEvent_0_wrapper");

   procedure hoverMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, hoverMoveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_hoverMoveEvent_0_wrapper");

   procedure hoverLeaveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, hoverLeaveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_hoverLeaveEvent_0_wrapper");

   procedure inputMethodEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, inputMethodEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_inputMethodEvent_0_wrapper");

   procedure inputMethodQuery_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Query : Qt4.Input_Method_Query;
     Returns : not null access Qt4.Variants.Internals.QVariant);
   pragma Import (C, inputMethodQuery_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_inputMethodQuery_0_wrapper");

   procedure itemChange_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Change : Qt4.Graphics_Items.Graphics_Item_Graphics_Item_Change;
     Value : not null access constant Qt4.Variants.Internals.QVariant;
     Returns : not null access Qt4.Variants.Internals.QVariant);
   pragma Import (C, itemChange_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_itemChange_0_wrapper");

   procedure keyPressEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, keyPressEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_keyPressEvent_0_wrapper");

   procedure keyReleaseEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, keyReleaseEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_keyReleaseEvent_0_wrapper");

   procedure mouseDoubleClickEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseDoubleClickEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_mouseDoubleClickEvent_0_wrapper");

   procedure mouseMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseMoveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_mouseMoveEvent_0_wrapper");

   procedure mousePressEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mousePressEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_mousePressEvent_0_wrapper");

   procedure mouseReleaseEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseReleaseEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_mouseReleaseEvent_0_wrapper");

   procedure prepareGeometryChange_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem);
   pragma Import (C, prepareGeometryChange_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_prepareGeometryChange_0_wrapper");

   function sceneEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
       return Qt4.bool;
   pragma Import (C, sceneEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_sceneEvent_0_wrapper");

   function sceneEventFilter_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Watched : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
       return Qt4.bool;
   pragma Import (C, sceneEventFilter_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_sceneEventFilter_0_wrapper");

   procedure wheelEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, wheelEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsPathItem_wheelEvent_0_wrapper");

   procedure paint_wrapper
    (Self    : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Painter : not null access Qt4.Painters.Internals.QPainter;
     Option  : not null access Qt4.Style_Options.Thin.QStyleOption;
     Widget  : access          Qt_Ada.Internals.Objects.QObject);
   pragma Import
    (C, paint_wrapper, "__Qt4Ada_QGraphicsPathItem_paint_wrapper");

   -----------
   -- Paint --
   -----------

   procedure Paint
    (Self    : not null access Q_Graphics_Path_Item_Director;
     Painter : in out Qt4.Painters.Q_Painter'Class;
     Option  :
       Qt4.Style_Option_Graphics_Items.Q_Style_Option_Graphics_Item'Class;
     Widget  : access Qt4.Widgets.Q_Widget'Class := null)
   is
   begin
      paint_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Painters.Internals.QPainter_View (Painter),
        Qt4.Style_Options.Internals.QStyleOption_View (Option),
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
         (Widget));
   end Paint;

   pragma Style_Checks ("N");

   -------------------
   -- Bounding_Rect --
   -------------------

   overriding
   function Bounding_Rect
    (Self : not null access constant Q_Graphics_Path_Item_Director)
       return Qt4.Rect_Fs.Q_Rect_F
   is
      Returns : Qt4.Rect_Fs.Q_Rect_F;

   begin
      boundingRect_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Qt4.Rect_Fs.Internals.QRectF_View (Returns));

      return Returns;
   end Bounding_Rect;

   --------------
   -- Contains --
   --------------

   overriding
   function Contains
    (Self : not null access constant Q_Graphics_Path_Item_Director;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (contains_0_wrapper
           (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
            Qt4.Point_Fs.Internals.QPointF_View (Point)));
   end Contains;

   --------------------
   -- Is_Obscured_By --
   --------------------

   overriding
   function Is_Obscured_By
    (Self : not null access constant Q_Graphics_Path_Item_Director;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isObscuredBy_0_wrapper
           (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
            Item.QGraphicsItem_View));
   end Is_Obscured_By;

   -----------------
   -- Opaque_Area --
   -----------------

   overriding
   function Opaque_Area
    (Self : not null access constant Q_Graphics_Path_Item_Director)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      opaqueArea_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Opaque_Area;

   -----------
   -- Shape --
   -----------

   overriding
   function Shape
    (Self : not null access constant Q_Graphics_Path_Item_Director)
       return Qt4.Painter_Paths.Q_Painter_Path
   is
      Returns : Qt4.Painter_Paths.Q_Painter_Path;

   begin
      shape_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Qt4.Painter_Paths.Internals.QPainterPath_View (Returns));

      return Returns;
   end Shape;

   ------------------------
   -- Context_Menu_Event --
   ------------------------

   overriding
   procedure Context_Menu_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Context_Menu_Events.Q_Graphics_Scene_Context_Menu_Event'Class)
   is
   begin
      contextMenuEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Context_Menu_Event;

   ----------------------
   -- Drag_Enter_Event --
   ----------------------

   overriding
   procedure Drag_Enter_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dragEnterEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Drag_Enter_Event;

   ----------------------
   -- Drag_Leave_Event --
   ----------------------

   overriding
   procedure Drag_Leave_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dragLeaveEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Drag_Leave_Event;

   ---------------------
   -- Drag_Move_Event --
   ---------------------

   overriding
   procedure Drag_Move_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dragMoveEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Drag_Move_Event;

   ----------------
   -- Drop_Event --
   ----------------

   overriding
   procedure Drop_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dropEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Drop_Event;

   --------------------
   -- Focus_In_Event --
   --------------------

   overriding
   procedure Focus_In_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class)
   is
   begin
      focusInEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Focus_In_Event;

   ---------------------
   -- Focus_Out_Event --
   ---------------------

   overriding
   procedure Focus_Out_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class)
   is
   begin
      focusOutEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Focus_Out_Event;

   -----------------------
   -- Hover_Enter_Event --
   -----------------------

   overriding
   procedure Hover_Enter_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class)
   is
   begin
      hoverEnterEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Hover_Enter_Event;

   ----------------------
   -- Hover_Move_Event --
   ----------------------

   overriding
   procedure Hover_Move_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class)
   is
   begin
      hoverMoveEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Hover_Move_Event;

   -----------------------
   -- Hover_Leave_Event --
   -----------------------

   overriding
   procedure Hover_Leave_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Hover_Events.Q_Graphics_Scene_Hover_Event'Class)
   is
   begin
      hoverLeaveEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Hover_Leave_Event;

   ------------------------
   -- Input_Method_Event --
   ------------------------

   overriding
   procedure Input_Method_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Input_Method_Events.Q_Input_Method_Event'Class)
   is
   begin
      inputMethodEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Input_Method_Event;

   ------------------------
   -- Input_Method_Query --
   ------------------------

   overriding
   function Input_Method_Query
    (Self : not null access constant Q_Graphics_Path_Item_Director;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      inputMethodQuery_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Query,
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Input_Method_Query;

   -----------------
   -- Item_Change --
   -----------------

   overriding
   function Item_Change
    (Self : not null access Q_Graphics_Path_Item_Director;
     Change : Qt4.Graphics_Items.Graphics_Item_Graphics_Item_Change;
     Value : Qt4.Variants.Q_Variant)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      itemChange_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Change,
        Qt4.Variants.Internals.QVariant_View (Value),
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Item_Change;

   ---------------------
   -- Key_Press_Event --
   ---------------------

   overriding
   procedure Key_Press_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class)
   is
   begin
      keyPressEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Key_Press_Event;

   -----------------------
   -- Key_Release_Event --
   -----------------------

   overriding
   procedure Key_Release_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class)
   is
   begin
      keyReleaseEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Key_Release_Event;

   ------------------------------
   -- Mouse_Double_Click_Event --
   ------------------------------

   overriding
   procedure Mouse_Double_Click_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mouseDoubleClickEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Mouse_Double_Click_Event;

   ----------------------
   -- Mouse_Move_Event --
   ----------------------

   overriding
   procedure Mouse_Move_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mouseMoveEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Mouse_Move_Event;

   -----------------------
   -- Mouse_Press_Event --
   -----------------------

   overriding
   procedure Mouse_Press_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mousePressEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Mouse_Press_Event;

   -------------------------
   -- Mouse_Release_Event --
   -------------------------

   overriding
   procedure Mouse_Release_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mouseReleaseEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Mouse_Release_Event;

   -----------------------------
   -- Prepare_Geometry_Change --
   -----------------------------

   overriding
   procedure Prepare_Geometry_Change
    (Self : not null access Q_Graphics_Path_Item_Director)
   is
   begin
      prepareGeometryChange_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View);
   end Prepare_Geometry_Change;

   -----------------
   -- Scene_Event --
   -----------------

   overriding
   function Scene_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (sceneEvent_0_wrapper
           (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
            Event.QEvent_View));
   end Scene_Event;

   ------------------------
   -- Scene_Event_Filter --
   ------------------------

   overriding
   function Scene_Event_Filter
    (Self : not null access Q_Graphics_Path_Item_Director;
     Watched : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Event : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (sceneEventFilter_0_wrapper
           (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
            Watched.QGraphicsItem_View,
            Event.QEvent_View));
   end Scene_Event_Filter;

   -----------------
   -- Wheel_Event --
   -----------------

   overriding
   procedure Wheel_Event
    (Self : not null access Q_Graphics_Path_Item_Director;
     Event : not null access Qt4.Graphics_Scene_Wheel_Events.Q_Graphics_Scene_Wheel_Event'Class)
   is
   begin
      wheelEvent_0_wrapper
       (Q_Graphics_Path_Item_Director'Class (Self.all).QGraphicsItem_View,
        Event.QEvent_View);
   end Wheel_Event;

end Qt4.Graphics_Path_Items.Directors;
