------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Graphics_Items;

with Qt_Ada.Internals.Graphics_Items.Graphics_Polygon_Item_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Graphics_Items.Graphics_Polygon_Item_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Graphics_Polygon_Items is

   function fillRule_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem)
       return Qt4.Fill_Rule;
   pragma Import (C, fillRule_0_wrapper,
                     "__Qt4Ada_QGraphicsPolygonItem_fillRule_0_wrapper");

   procedure polygon_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, polygon_0_wrapper,
                     "__Qt4Ada_QGraphicsPolygonItem_polygon_0_wrapper");

   procedure setFillRule_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Rule : Qt4.Fill_Rule);
   pragma Import (C, setFillRule_0_wrapper,
                     "__Qt4Ada_QGraphicsPolygonItem_setFillRule_0_wrapper");

   procedure setPolygon_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Polygon : not null access constant Qt4.Polygon_Fs.Internals.QPolygonF);
   pragma Import (C, setPolygon_0_wrapper,
                     "__Qt4Ada_QGraphicsPolygonItem_setPolygon_0_wrapper");

   pragma Style_Checks ("N");

   ---------------
   -- Fill_Rule --
   ---------------

   function Fill_Rule
    (Self : not null access constant Q_Graphics_Polygon_Item'Class)
       return Qt4.Fill_Rule
   is
   begin
      return
        fillRule_0_wrapper
         (Self.QGraphicsItem_View);
   end Fill_Rule;

   -------------
   -- Polygon --
   -------------

   function Polygon
    (Self : not null access constant Q_Graphics_Polygon_Item'Class)
       return Qt4.Polygon_Fs.Q_Polygon_F
   is
      Returns : Qt4.Polygon_Fs.Q_Polygon_F;

   begin
      polygon_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Returns));

      return Returns;
   end Polygon;

   -------------------
   -- Set_Fill_Rule --
   -------------------

   procedure Set_Fill_Rule
    (Self : not null access Q_Graphics_Polygon_Item'Class;
     Rule : Qt4.Fill_Rule)
   is
   begin
      setFillRule_0_wrapper
       (Self.QGraphicsItem_View,
        Rule);
   end Set_Fill_Rule;

   -----------------
   -- Set_Polygon --
   -----------------

   procedure Set_Polygon
    (Self : not null access Q_Graphics_Polygon_Item'Class;
     Polygon : Qt4.Polygon_Fs.Q_Polygon_F)
   is
   begin
      setPolygon_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Polygon_Fs.Internals.QPolygonF_View (Polygon));
   end Set_Polygon;

end Qt4.Graphics_Polygon_Items;
