------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Graphics_Shape_Items;
with Qt4.Painters;
with Qt4.Polygon_Fs;
with Qt4.Style_Option_Graphics_Items;
with Qt4.Widgets;

package Qt4.Graphics_Polygon_Items is

   type Q_Graphics_Polygon_Item is limited interface
     and Qt4.Abstract_Graphics_Shape_Items.Q_Abstract_Graphics_Shape_Item;

   type Q_Graphics_Polygon_Item_Access is
     access all Q_Graphics_Polygon_Item'Class;
   for Q_Graphics_Polygon_Item_Access'Storage_Size use 0;

   function Fill_Rule
    (Self : not null access constant Q_Graphics_Polygon_Item'Class)
       return Qt4.Fill_Rule;

   function Polygon
    (Self : not null access constant Q_Graphics_Polygon_Item'Class)
       return Qt4.Polygon_Fs.Q_Polygon_F;

   procedure Set_Fill_Rule
    (Self : not null access Q_Graphics_Polygon_Item'Class;
     Rule : Qt4.Fill_Rule);

   procedure Set_Polygon
    (Self : not null access Q_Graphics_Polygon_Item'Class;
     Polygon : Qt4.Polygon_Fs.Q_Polygon_F);

end Qt4.Graphics_Polygon_Items;
