------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Child_Events;
with Qt4.Events;
with Qt4.Focus_Events;
with Qt4.Graphics_Scene_Context_Menu_Events;
with Qt4.Graphics_Scene_Drag_Drop_Events;
with Qt4.Graphics_Scene_Help_Events;
with Qt4.Graphics_Scene_Mouse_Events;
with Qt4.Graphics_Scene_Wheel_Events;
with Qt4.Input_Method_Events;
with Qt4.Key_Events;
with Qt4.Timer_Events;
with Qt_Ada.Internals.Events;
with Qt_Ada.Internals.Events.Registry;
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

package body Qt4.Graphics_Scenes.Directors is

   function qt_metacall_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Kind : Qt4.Meta_Objects.Call;
     Id   : Qt4.Q_Integer;
     Args : Qt4.Address_Pointer)
       return Qt4.Q_Integer;
   pragma Import (C, qt_metacall_wrapper,
                  "__Qt4Ada_QGraphicsScene_qt_metacall_wrapper");

   function qt_metacast_wrapper
    (Self  : not null access Qt_Ada.Internals.Objects.QObject;
     Class : Interfaces.C.char_array)
       return System.Address;
   pragma Import (C, qt_metacast_wrapper,
                  "__Qt4Ada_QGraphicsScene_qt_metacast_wrapper");

   function inputMethodQuery_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Query : Qt4.Input_Method_Query)
       return not null access Qt4.Variants.Internals.QVariant;
   pragma Export (C, inputMethodQuery_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_inputMethodQuery_0_dispatch");
   pragma Warnings (Off, inputMethodQuery_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure inputMethodQuery_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Query : Qt4.Input_Method_Query;
     Returns : not null access Qt4.Variants.Internals.QVariant);
   pragma Import (C, inputMethodQuery_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_inputMethodQuery_0_wrapper");

   function event_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     E : not null access Qt_Ada.Internals.Events.QEvent)
       return Qt4.bool;
   pragma Import (C, event_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_event_0_wrapper");

   procedure contextMenuEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, contextMenuEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_contextMenuEvent_0_dispatch");
   pragma Warnings (Off, contextMenuEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure contextMenuEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, contextMenuEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_contextMenuEvent_0_wrapper");

   procedure dragEnterEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, dragEnterEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_dragEnterEvent_0_dispatch");
   pragma Warnings (Off, dragEnterEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure dragEnterEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragEnterEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_dragEnterEvent_0_wrapper");

   procedure dragMoveEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, dragMoveEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_dragMoveEvent_0_dispatch");
   pragma Warnings (Off, dragMoveEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure dragMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragMoveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_dragMoveEvent_0_wrapper");

   procedure dragLeaveEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, dragLeaveEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_dragLeaveEvent_0_dispatch");
   pragma Warnings (Off, dragLeaveEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure dragLeaveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dragLeaveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_dragLeaveEvent_0_wrapper");

   procedure dropEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, dropEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_dropEvent_0_dispatch");
   pragma Warnings (Off, dropEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure dropEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, dropEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_dropEvent_0_wrapper");

   procedure focusInEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, focusInEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_focusInEvent_0_dispatch");
   pragma Warnings (Off, focusInEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure focusInEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, focusInEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_focusInEvent_0_wrapper");

   procedure focusOutEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, focusOutEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_focusOutEvent_0_dispatch");
   pragma Warnings (Off, focusOutEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure focusOutEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, focusOutEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_focusOutEvent_0_wrapper");

   procedure helpEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, helpEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_helpEvent_0_dispatch");
   pragma Warnings (Off, helpEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure helpEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, helpEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_helpEvent_0_wrapper");

   procedure keyPressEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, keyPressEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_keyPressEvent_0_dispatch");
   pragma Warnings (Off, keyPressEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure keyPressEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, keyPressEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_keyPressEvent_0_wrapper");

   procedure keyReleaseEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, keyReleaseEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_keyReleaseEvent_0_dispatch");
   pragma Warnings (Off, keyReleaseEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure keyReleaseEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, keyReleaseEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_keyReleaseEvent_0_wrapper");

   procedure mousePressEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, mousePressEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_mousePressEvent_0_dispatch");
   pragma Warnings (Off, mousePressEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure mousePressEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mousePressEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_mousePressEvent_0_wrapper");

   procedure mouseMoveEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, mouseMoveEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_mouseMoveEvent_0_dispatch");
   pragma Warnings (Off, mouseMoveEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure mouseMoveEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseMoveEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_mouseMoveEvent_0_wrapper");

   procedure mouseReleaseEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, mouseReleaseEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_mouseReleaseEvent_0_dispatch");
   pragma Warnings (Off, mouseReleaseEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure mouseReleaseEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseReleaseEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_mouseReleaseEvent_0_wrapper");

   procedure mouseDoubleClickEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, mouseDoubleClickEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_mouseDoubleClickEvent_0_dispatch");
   pragma Warnings (Off, mouseDoubleClickEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure mouseDoubleClickEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, mouseDoubleClickEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_mouseDoubleClickEvent_0_wrapper");

   procedure wheelEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, wheelEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_wheelEvent_0_dispatch");
   pragma Warnings (Off, wheelEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure wheelEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, wheelEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_wheelEvent_0_wrapper");

   procedure inputMethodEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Export (C, inputMethodEvent_0_dispatch,
                     "__Qt4Ada_QGraphicsScene_inputMethodEvent_0_dispatch");
   pragma Warnings (Off, inputMethodEvent_0_dispatch);
   --  GCC GNAT 4.3.0: suppress warning
   --  is a tagged type which does not correspond to any C type

   procedure inputMethodEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, inputMethodEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_inputMethodEvent_0_wrapper");

   procedure childEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, childEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_childEvent_0_wrapper");

   procedure customEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, customEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_customEvent_0_wrapper");

   procedure timerEvent_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Event : not null access Qt_Ada.Internals.Events.QEvent);
   pragma Import (C, timerEvent_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_timerEvent_0_wrapper");

   function sender_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, sender_0_wrapper,
                     "__Qt4Ada_QGraphicsScene_sender_0_wrapper");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> drawBackground_wrapper
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
--      procedure drawBackground_wrapper
--       (This : not null access Qt_Ada.Internals.Objects.QObject;
--        Painter : not null access Qt4.Painters.Impl.Thin.QPainter;
--        Rect : Qt4.RectFs.Impl.Thin.QRectF);
--      pragma Import
--       (C, drawBackground_wrapper,
--        "__Qt4Ada_QGraphicsScene_drawBackground_wrapper");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> drawForeground_wrapper
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
--      procedure drawForeground_wrapper
--       (This : not null access Qt_Ada.Internals.Objects.QObject;
--        Painter : not null access Qt4.Painters.Impl.Thin.QPainter;
--        Rect : Qt4.RectFs.Impl.Thin.QRectF);
--      pragma Import
--       (C, drawForeground_wrapper,
--        "__Qt4Ada_QGraphicsScene_drawForeground_wrapper");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> drawItems_wrapper
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
--      procedure drawItems_wrapper
--       (This      : not null access Qt_Ada.Internals.Objects.QObject;
--        Painter   : not null access Qt4.Painters.Impl.Thin.QPainter;
--        Num_Items : Q_Integer;
--      Items     : not null access Qt4.Graphics_Items.Impl.Thin.QGraphicsItem;
--        Options   : not null access Qt4.Style_Options.Impl.Thin.QStyleOption;
--        Widget    : not null access Qt_Ada.Internals.Objects.QObject);
--      pragma Import
--       (C, drawItems_wrapper,
--        "__Qt4Ada_QGraphicsScene_drawItems_wrapper");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> drawBackground_dispatch
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
--    procedure drawBackground_dispatch
--     (Self : not null access Q_Graphics_Scene'Class;
--      X : not null access Qt4.Painters.Impl.Thin.QPainter;
--      X : Qt4.RectFs.Impl.Thin.QRectF);
--    pragma Export
--     (C, drawBackground_dispatch,
--      "__Qt4Ada_QGraphicsScene_drawBackground_dispatch");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> drawForeground_dispatch
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
--    procedure drawForeground_dispatch
--     (Self : not null access Q_Graphics_Scene'Class;
--      X : not null access Qt4.Painters.Impl.Thin.QPainter;
--      X : Qt4.RectFs.Impl.Thin.QRectF);
--    pragma Export
--     (C, drawForeground_dispatch,
--      "__Qt4Ada_QGraphicsScene_drawForeground_dispatch");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> drawItems_dispatch
   --!    <Purpose>
   --!    <Exceptions>
   ---------------------------------------------------------------------------
--    procedure drawItems_dispatch
--     (Self : not null access Q_Graphics_Scene'Class;
--      X : not null access Qt4.Painters.Impl.Thin.QPainter;
--      X : Q_Integer;
--      X : not null access Qt4.Graphics_Items.Impl.Thin.QGraphicsItem;
--      X : Qt4.Style_Options.Impl.Thin.QStyleOption;
--      X : not null access Qt_Ada.Internals.Objects.QObject);
--    pragma Export
--     (C, drawItems_dispatch,
--      "__Qt4Ada_QGraphicsScene_drawItems_dispatch");

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> drawBackground_dispatch
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
--    procedure drawBackground_dispatch
--     (Self    : not null access Q_Graphics_Scene_Impl;
--      Painter : not null access Qt4.Painters.Q_Painter'Class;
--      Rect    : not null access Qt4.Rects_F.Q_Rect_F'Class)
--    is
--    begin
--       Self.Draw_Background;
--    end drawBackground_dispatch;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Draw_Background
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
--    procedure Draw_Background
--     (Self    : not null access Q_Graphics_Scene_Impl;
--      Painter : not null access Qt4.Painters.Q_Painter'Class;
--      Rect    : not null access Qt4.Rects_F.Q_Rect_F'Class)
--    is
--    begin
--       if Self.Is_Director then
--          Thin.drawBackground_wrapper (Self.Cpp_Object);
--
--       else
--          raise Program_Error;
--       end if;
--    end Draw_Background;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> drawForeground_dispatch
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
--    procedure drawForeground_dispatch
--     (Self    : not null access Q_Graphics_Scene_Impl;
--      Painter : not null access Qt4.Painters.Q_Painter'Class;
--      Rect    : not null access Qt4.Rects_F.Q_Rect_F'Class)
--    is
--    begin
--       Self.Draw_Foreground;
--    end drawForeground_dispatch;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Draw_Foreground
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
--    procedure Draw_Foreground
--     (Self    : not null access Q_Graphics_Scene_Impl;
--      Painter : not null access Qt4.Painters.Q_Painter'Class;
--      Rect    : not null access Qt4.Rects_F.Q_Rect_F'Class)
--    is
--    begin
--       if Self.Is_Director then
--          Thin.drawForeground_wrapper (Self.Cpp_Object);
--
--       else
--          raise Program_Error;
--       end if;
--    end Draw_Foreground;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> drawItems_dispatch
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
--    procedure drawItems_dispatch
--     (Self      : not null access Q_Graphics_Scene_Impl;
--      Painter   : not null access Qt4.Painters.Q_Painter'Class;
--      Num_Items : Q_Integer;
--      Items     : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;
--      Options   : not null access
--        Qt4.Style_Option_Graphics_Items.Q_Style_Option_Graphics_Item'Class;
--      Widget    : not null access Qt4.Widgets.Q_Widget'Class)
--    is
--    begin
--       Self.Draw_Items;
--    end drawItems_dispatch;

   ---------------------------------------------------------------------------
   --! <Subprogram>
   --!    <Unit> Draw_Items
   --!    <ImplementationNotes>
   ---------------------------------------------------------------------------
--    procedure Draw_Items
--     (Self      : not null access Q_Graphics_Scene_Impl;
--      Painter   : not null access Qt4.Painters.Q_Painter'Class;
--      Num_Items : Q_Integer;
--      Items     : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;
--      Options   : not null access
--        Qt4.Style_Option_Graphics_Items.Q_Style_Option_Graphics_Item'Class;
--      Widget    : not null access Qt4.Widgets.Q_Widget'Class)
--    is
--    begin
--       if Self.Is_Director then
--          Thin.drawItems_wrapper (Self.Cpp_Object);
--
--       else
--          raise Program_Error;
--       end if;
--    end Draw_Items;

   ------------------
   -- Constructors --
   ------------------

   package body Constructors is

      function new_QGraphicsSceneDirector
       (Object : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
        Parent : access Qt_Ada.Internals.Objects.QObject)
          return not null Qt_Ada.Internals.Objects.QObject_Access;
      pragma Import
       (C, new_QGraphicsSceneDirector, "__Qt4Ada_new_QGraphicsSceneDirector");
      pragma Warnings (Off, new_QGraphicsSceneDirector);

      ----------------
      -- Initialize --
      ----------------

      procedure Initialize
       (Self   : not null access Q_Graphics_Scene_Director'Class;
        Parent : access Qt4.Objects.Q_Object'Class := null)
      is
         Director : constant not null Qt_Ada.Internals.Objects.QObject_Access
           := new_QGraphicsSceneDirector
               (Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self),
                Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject
                 (Parent));

      begin
         Qt_Ada.Internals.Objects.Initialize (Self, Director);
      end Initialize;

   end Constructors;

   pragma Style_Checks ("N");

   ---------------------------------
   -- inputMethodQuery_0_dispatch --
   ---------------------------------

   function inputMethodQuery_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Query : Qt4.Input_Method_Query)
       return not null access Qt4.Variants.Internals.QVariant
   is
   begin
      return
        Qt4.Variants.Thin.copy_QVariant
         (Qt4.Variants.Internals.QVariant_View
           (Q_Graphics_Scene_Director'Class (Self.all).Input_Method_Query
             (Query)));
   end inputMethodQuery_0_dispatch;

   ------------------------
   -- Input_Method_Query --
   ------------------------

   overriding
   function Input_Method_Query
    (Self : not null access constant Q_Graphics_Scene_Director;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant
   is
      Returns : Qt4.Variants.Q_Variant;

   begin
      inputMethodQuery_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Query,
        Qt4.Variants.Internals.QVariant_View (Returns));

      return Returns;
   end Input_Method_Query;

   -----------
   -- Event --
   -----------

   overriding
   function Event
    (Self : not null access Q_Graphics_Scene_Director;
     E : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (event_0_wrapper
           (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
            E.QEvent_View));
   end Event;

   ---------------------------------
   -- contextMenuEvent_0_dispatch --
   ---------------------------------

   procedure contextMenuEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Context_Menu_Event
       (Qt4.Graphics_Scene_Context_Menu_Events.Q_Graphics_Scene_Context_Menu_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end contextMenuEvent_0_dispatch;

   ------------------------
   -- Context_Menu_Event --
   ------------------------

   not overriding
   procedure Context_Menu_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Context_Menu_Events.Q_Graphics_Scene_Context_Menu_Event'Class)
   is
   begin
      contextMenuEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Context_Menu_Event;

   -------------------------------
   -- dragEnterEvent_0_dispatch --
   -------------------------------

   procedure dragEnterEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Drag_Enter_Event
       (Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end dragEnterEvent_0_dispatch;

   ----------------------
   -- Drag_Enter_Event --
   ----------------------

   not overriding
   procedure Drag_Enter_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dragEnterEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drag_Enter_Event;

   ------------------------------
   -- dragMoveEvent_0_dispatch --
   ------------------------------

   procedure dragMoveEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Drag_Move_Event
       (Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end dragMoveEvent_0_dispatch;

   ---------------------
   -- Drag_Move_Event --
   ---------------------

   not overriding
   procedure Drag_Move_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dragMoveEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drag_Move_Event;

   -------------------------------
   -- dragLeaveEvent_0_dispatch --
   -------------------------------

   procedure dragLeaveEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Drag_Leave_Event
       (Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end dragLeaveEvent_0_dispatch;

   ----------------------
   -- Drag_Leave_Event --
   ----------------------

   not overriding
   procedure Drag_Leave_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dragLeaveEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drag_Leave_Event;

   --------------------------
   -- dropEvent_0_dispatch --
   --------------------------

   procedure dropEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Drop_Event
       (Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end dropEvent_0_dispatch;

   ----------------
   -- Drop_Event --
   ----------------

   not overriding
   procedure Drop_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class)
   is
   begin
      dropEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Drop_Event;

   -----------------------------
   -- focusInEvent_0_dispatch --
   -----------------------------

   procedure focusInEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Focus_In_Event
       (Qt4.Focus_Events.Q_Focus_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end focusInEvent_0_dispatch;

   --------------------
   -- Focus_In_Event --
   --------------------

   not overriding
   procedure Focus_In_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class)
   is
   begin
      focusInEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Focus_In_Event;

   ------------------------------
   -- focusOutEvent_0_dispatch --
   ------------------------------

   procedure focusOutEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Focus_Out_Event
       (Qt4.Focus_Events.Q_Focus_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end focusOutEvent_0_dispatch;

   ---------------------
   -- Focus_Out_Event --
   ---------------------

   not overriding
   procedure Focus_Out_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class)
   is
   begin
      focusOutEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Focus_Out_Event;

   --------------------------
   -- helpEvent_0_dispatch --
   --------------------------

   procedure helpEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Help_Event
       (Qt4.Graphics_Scene_Help_Events.Q_Graphics_Scene_Help_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end helpEvent_0_dispatch;

   ----------------
   -- Help_Event --
   ----------------

   not overriding
   procedure Help_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Help_Events.Q_Graphics_Scene_Help_Event'Class)
   is
   begin
      helpEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Help_Event;

   ------------------------------
   -- keyPressEvent_0_dispatch --
   ------------------------------

   procedure keyPressEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Key_Press_Event
       (Qt4.Key_Events.Q_Key_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end keyPressEvent_0_dispatch;

   ---------------------
   -- Key_Press_Event --
   ---------------------

   not overriding
   procedure Key_Press_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class)
   is
   begin
      keyPressEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Key_Press_Event;

   --------------------------------
   -- keyReleaseEvent_0_dispatch --
   --------------------------------

   procedure keyReleaseEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Key_Release_Event
       (Qt4.Key_Events.Q_Key_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end keyReleaseEvent_0_dispatch;

   -----------------------
   -- Key_Release_Event --
   -----------------------

   not overriding
   procedure Key_Release_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class)
   is
   begin
      keyReleaseEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Key_Release_Event;

   --------------------------------
   -- mousePressEvent_0_dispatch --
   --------------------------------

   procedure mousePressEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Mouse_Press_Event
       (Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end mousePressEvent_0_dispatch;

   -----------------------
   -- Mouse_Press_Event --
   -----------------------

   not overriding
   procedure Mouse_Press_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mousePressEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Press_Event;

   -------------------------------
   -- mouseMoveEvent_0_dispatch --
   -------------------------------

   procedure mouseMoveEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Mouse_Move_Event
       (Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end mouseMoveEvent_0_dispatch;

   ----------------------
   -- Mouse_Move_Event --
   ----------------------

   not overriding
   procedure Mouse_Move_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mouseMoveEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Move_Event;

   ----------------------------------
   -- mouseReleaseEvent_0_dispatch --
   ----------------------------------

   procedure mouseReleaseEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Mouse_Release_Event
       (Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end mouseReleaseEvent_0_dispatch;

   -------------------------
   -- Mouse_Release_Event --
   -------------------------

   not overriding
   procedure Mouse_Release_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mouseReleaseEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Release_Event;

   --------------------------------------
   -- mouseDoubleClickEvent_0_dispatch --
   --------------------------------------

   procedure mouseDoubleClickEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Mouse_Double_Click_Event
       (Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end mouseDoubleClickEvent_0_dispatch;

   ------------------------------
   -- Mouse_Double_Click_Event --
   ------------------------------

   not overriding
   procedure Mouse_Double_Click_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class)
   is
   begin
      mouseDoubleClickEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Mouse_Double_Click_Event;

   ---------------------------
   -- wheelEvent_0_dispatch --
   ---------------------------

   procedure wheelEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Wheel_Event
       (Qt4.Graphics_Scene_Wheel_Events.Q_Graphics_Scene_Wheel_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end wheelEvent_0_dispatch;

   -----------------
   -- Wheel_Event --
   -----------------

   not overriding
   procedure Wheel_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Wheel_Events.Q_Graphics_Scene_Wheel_Event'Class)
   is
   begin
      wheelEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Wheel_Event;

   ---------------------------------
   -- inputMethodEvent_0_dispatch --
   ---------------------------------

   procedure inputMethodEvent_0_dispatch
    (Self : not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;
     Event : not null access Qt_Ada.Internals.Events.QEvent)
   is
   begin
      Q_Graphics_Scene_Director'Class (Self.all).Input_Method_Event
       (Qt4.Input_Method_Events.Q_Input_Method_Event'Class (Qt_Ada.Internals.Events.Registry.Create_Wrapper (Event).all)'Access);
   end inputMethodEvent_0_dispatch;

   ------------------------
   -- Input_Method_Event --
   ------------------------

   not overriding
   procedure Input_Method_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Input_Method_Events.Q_Input_Method_Event'Class)
   is
   begin
      inputMethodEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Input_Method_Event;

   -----------------
   -- Child_Event --
   -----------------

   overriding
   procedure Child_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class)
   is
   begin
      childEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Child_Event;

   ------------------
   -- Custom_Event --
   ------------------

   overriding
   procedure Custom_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Events.Q_Event'Class)
   is
   begin
      customEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Custom_Event;

   -----------------
   -- Timer_Event --
   -----------------

   overriding
   procedure Timer_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class)
   is
   begin
      timerEvent_0_wrapper
       (Q_Graphics_Scene_Director'Class (Self.all).QObject_View,
        Event.QEvent_View);
   end Timer_Event;

   ------------
   -- Sender --
   ------------

   overriding
   function Sender
    (Self : not null access constant Q_Graphics_Scene_Director)
       return access Qt4.Objects.Q_Object'Class
   is
   begin
      return
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_Q_Object
         (sender_0_wrapper
           (Q_Graphics_Scene_Director'Class (Self.all).QObject_View));
   end Sender;

begin
   Qt_Ada.Internals.Object_Registry.Register_Director
    ("QGraphicsScene", qt_metacast_wrapper'Access, qt_metacall_wrapper'Access);

end Qt4.Graphics_Scenes.Directors;
