------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Child_Events;
limited with Qt4.Events;
limited with Qt4.Focus_Events;
limited with Qt4.Graphics_Scene_Context_Menu_Events;
limited with Qt4.Graphics_Scene_Drag_Drop_Events;
limited with Qt4.Graphics_Scene_Help_Events;
limited with Qt4.Graphics_Scene_Mouse_Events;
limited with Qt4.Graphics_Scene_Wheel_Events;
limited with Qt4.Input_Method_Events;
limited with Qt4.Key_Events;
with Qt4.Meta_Objects;
with Qt4.Objects.Directors;
limited with Qt4.Timer_Events;

package Qt4.Graphics_Scenes.Directors is

   type Q_Graphics_Scene_Director is
     new Qt4.Objects.Directors.Q_Object_Director
       and Q_Graphics_Scene with null record;

   overriding
   function Input_Method_Query
    (Self : not null access constant Q_Graphics_Scene_Director;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant;

   overriding
   function Event
    (Self : not null access Q_Graphics_Scene_Director;
     E : not null access Qt4.Events.Q_Event'Class)
       return Standard.Boolean;

   not overriding
   procedure Context_Menu_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Context_Menu_Events.Q_Graphics_Scene_Context_Menu_Event'Class);

   not overriding
   procedure Drag_Enter_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   not overriding
   procedure Drag_Move_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   not overriding
   procedure Drag_Leave_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   not overriding
   procedure Drop_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Drag_Drop_Events.Q_Graphics_Scene_Drag_Drop_Event'Class);

   not overriding
   procedure Focus_In_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class);

   not overriding
   procedure Focus_Out_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Focus_Events.Q_Focus_Event'Class);

   not overriding
   procedure Help_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Help_Events.Q_Graphics_Scene_Help_Event'Class);

   not overriding
   procedure Key_Press_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class);

   not overriding
   procedure Key_Release_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Key_Events.Q_Key_Event'Class);

   not overriding
   procedure Mouse_Press_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   not overriding
   procedure Mouse_Move_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   not overriding
   procedure Mouse_Release_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   not overriding
   procedure Mouse_Double_Click_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Mouse_Events.Q_Graphics_Scene_Mouse_Event'Class);

   not overriding
   procedure Wheel_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Graphics_Scene_Wheel_Events.Q_Graphics_Scene_Wheel_Event'Class);

   not overriding
   procedure Input_Method_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Input_Method_Events.Q_Input_Method_Event'Class);

   overriding
   procedure Child_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Child_Events.Q_Child_Event'Class);

   overriding
   procedure Custom_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Events.Q_Event'Class);

   overriding
   procedure Timer_Event
    (Self : not null access Q_Graphics_Scene_Director;
     Event : not null access Qt4.Timer_Events.Q_Timer_Event'Class);

   overriding
   function Sender
    (Self : not null access constant Q_Graphics_Scene_Director)
       return access Qt4.Objects.Q_Object'Class;

--    not overriding
--    procedure Draw_Background
--     (Self    : not null access Q_Graphics_Scene_Impl;
--      Painter : not null access Qt4.Painters.Q_Painter'Class;
--      Rect    : not null access Qt4.Rects_F.Q_Rect_F'Class);

--    not overriding
--    procedure Draw_Foreground
--     (Self    : not null access Q_Graphics_Scene_Impl;
--      Painter : not null access Qt4.Painters.Q_Painter'Class;
--      Rect    : not null access Qt4.Rects_F.Q_Rect_F'Class);

--    not overriding
--    procedure Draw_Items
--     (Self      : not null access Q_Graphics_Scene_Impl;
--      Painter   : not null access Qt4.Painters.Q_Painter'Class;
--      Num_Items : Q_Integer;
--      Items     : not null access Qt4.Graphics_Items.Q_Graphics_Item'Class;
--      Options   : not null access
--        Qt4.Style_Option_Graphics_Items.Q_Style_Option_Graphics_Item'Class;
--      Widget : not null access Qt4.Widgets.Q_Widget'Class);

   package Constructors is

      procedure Initialize
       (Self   : not null access Q_Graphics_Scene_Director'Class;
        Parent : access Qt4.Objects.Q_Object'Class := null);
      --  Creates C++ director and associate it with the specified object.

   end Constructors;

   Static_Meta_Object : access constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C, Static_Meta_Object,
                  "__Qt4Ada_QGraphicsScene_staticMetaObject");

end Qt4.Graphics_Scenes.Directors;
