------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Graphics_Items;

with Qt_Ada.Internals.Graphics_Items.Graphics_Simple_Text_Item_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Graphics_Items.Graphics_Simple_Text_Item_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Graphics_Simple_Text_Items is

   procedure font_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Fonts.Internals.QFont);
   pragma Import (C, font_0_wrapper,
                     "__Qt4Ada_QGraphicsSimpleTextItem_font_0_wrapper");

   procedure setFont_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Font : not null access constant Qt4.Fonts.Internals.QFont);
   pragma Import (C, setFont_0_wrapper,
                     "__Qt4Ada_QGraphicsSimpleTextItem_setFont_0_wrapper");

   procedure setText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setText_0_wrapper,
                     "__Qt4Ada_QGraphicsSimpleTextItem_setText_0_wrapper");

   procedure text_0_wrapper
    (Self : not null access Qt_Ada.Internals.Graphics_Items.QGraphicsItem;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, text_0_wrapper,
                     "__Qt4Ada_QGraphicsSimpleTextItem_text_0_wrapper");

   pragma Style_Checks ("N");

   ----------
   -- Font --
   ----------

   function Font
    (Self : not null access constant Q_Graphics_Simple_Text_Item'Class)
       return Qt4.Fonts.Q_Font
   is
      Returns : Qt4.Fonts.Q_Font;

   begin
      font_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Fonts.Internals.QFont_View (Returns));

      return Returns;
   end Font;

   --------------
   -- Set_Font --
   --------------

   procedure Set_Font
    (Self : not null access Q_Graphics_Simple_Text_Item'Class;
     Font : Qt4.Fonts.Q_Font)
   is
   begin
      setFont_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Fonts.Internals.QFont_View (Font));
   end Set_Font;

   --------------
   -- Set_Text --
   --------------

   procedure Set_Text
    (Self : not null access Q_Graphics_Simple_Text_Item'Class;
     Text : Qt4.Strings.Q_String)
   is
   begin
      setText_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Strings.Internals.QString_View (Text));
   end Set_Text;

   ----------
   -- Text --
   ----------

   function Text
    (Self : not null access constant Q_Graphics_Simple_Text_Item'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      text_0_wrapper
       (Self.QGraphicsItem_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Text;

end Qt4.Graphics_Simple_Text_Items;
