------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Item_Delegates;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Item_Delegates is

   type Q_Item_Delegate is limited interface
     and Qt4.Abstract_Item_Delegates.Q_Abstract_Item_Delegate;

   type Q_Item_Delegate_Access is
     access all Q_Item_Delegate'Class;
   for Q_Item_Delegate_Access'Storage_Size use 0;

   type Q_Item_Delegate_Pointer is tagged;

   function Has_Clipping
    (Self : not null access constant Q_Item_Delegate'Class)
       return Standard.Boolean;

   procedure Set_Clipping
    (Self : not null access Q_Item_Delegate'Class;
     Clip : Standard.Boolean);

   package Q_Item_Delegate_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Item_Delegate, Q_Item_Delegate_Access);

   type Q_Item_Delegate_Pointer is
     new Q_Item_Delegate_Pointers.Q_Pointer with null record;

end Qt4.Item_Delegates;
