------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Frames;
with Qt4.Pixmaps;
with Qt4.Strings;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Labels is

   type Q_Label is limited interface
     and Qt4.Frames.Q_Frame;

   type Q_Label_Access is
     access all Q_Label'Class;
   for Q_Label_Access'Storage_Size use 0;

   type Q_Label_Pointer is tagged;

   function Buddy
    (Self : not null access constant Q_Label'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   function Has_Scaled_Contents
    (Self : not null access constant Q_Label'Class)
       return Standard.Boolean;

   function Indent
    (Self : not null access constant Q_Label'Class)
       return Qt4.Q_Integer;

   function Margin
    (Self : not null access constant Q_Label'Class)
       return Qt4.Q_Integer;

   function Open_External_Links
    (Self : not null access constant Q_Label'Class)
       return Standard.Boolean;

   procedure Set_Buddy
    (Self : not null access Q_Label'Class;
     Buddy : not null access Qt4.Widgets.Q_Widget'Class);

   procedure Set_Indent
    (Self : not null access Q_Label'Class;
     Indent : Qt4.Q_Integer);

   procedure Set_Margin
    (Self : not null access Q_Label'Class;
     Margin : Qt4.Q_Integer);

   procedure Set_Open_External_Links
    (Self : not null access Q_Label'Class;
     Open : Standard.Boolean);

   procedure Set_Pixmap
    (Self : not null access Q_Label'Class;
     Pixmap : Qt4.Pixmaps.Q_Pixmap);

   procedure Set_Scaled_Contents
    (Self : not null access Q_Label'Class;
     Scaled : Standard.Boolean);

   procedure Set_Word_Wrap
    (Self : not null access Q_Label'Class;
     On : Standard.Boolean);

   function Text
    (Self : not null access constant Q_Label'Class)
       return Qt4.Strings.Q_String;

   function Word_Wrap
    (Self : not null access constant Q_Label'Class)
       return Standard.Boolean;

   procedure Clear
    (Self : not null access Q_Label'Class);

   procedure Set_Num
    (Self : not null access Q_Label'Class;
     Num : Qt4.Q_Integer);

   procedure Set_Text
    (Self : not null access Q_Label'Class;
     Text : Qt4.Strings.Q_String);

   procedure Set_Alignment
    (Self  : not null access Q_Label'Class;
     Value : Qt4.Alignment);

   procedure Set_Text_Interaction_Flags
    (Self  : not null access Q_Label'Class;
     Flags : Qt4.Text_Interaction_Flags);

   package Q_Label_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Label, Q_Label_Access);

   type Q_Label_Pointer is
     new Q_Label_Pointers.Q_Pointer with null record;

end Qt4.Labels;
