------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.List_Views;
with Qt4.String_Lists;
with Qt4.Strings;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.List_Widgets is

   type Q_List_Widget is limited interface
     and Qt4.List_Views.Q_List_View;

   type Q_List_Widget_Access is
     access all Q_List_Widget'Class;
   for Q_List_Widget_Access'Storage_Size use 0;

   type Q_List_Widget_Pointer is tagged;

   procedure Add_Item
    (Self : not null access Q_List_Widget'Class;
     Label : Qt4.Strings.Q_String);

   function Count
    (Self : not null access constant Q_List_Widget'Class)
       return Qt4.Q_Integer;

   function Current_Row
    (Self : not null access constant Q_List_Widget'Class)
       return Qt4.Q_Integer;

   procedure Insert_Item
    (Self : not null access Q_List_Widget'Class;
     Row : Qt4.Q_Integer;
     Label : Qt4.Strings.Q_String);

   function Is_Sorting_Enabled
    (Self : not null access constant Q_List_Widget'Class)
       return Standard.Boolean;

   procedure Set_Current_Row
    (Self : not null access Q_List_Widget'Class;
     Row : Qt4.Q_Integer);

   procedure Set_Sorting_Enabled
    (Self : not null access Q_List_Widget'Class;
     Enable : Standard.Boolean);

   procedure Clear
    (Self : not null access Q_List_Widget'Class);

   procedure Add_Items
    (Self   : not null access Q_List_Widget'Class;
     Labels : Qt4.String_Lists.Q_String_List'Class);

   package Q_List_Widget_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_List_Widget, Q_List_Widget_Access);

   type Q_List_Widget_Pointer is
     new Q_List_Widget_Pointers.Q_Pointer with null record;

end Qt4.List_Widgets;
