------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Plain_Text_Document_Layout_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Plain_Text_Document_Layout_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Plain_Text_Document_Layouts is

   function cursorWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, cursorWidth_0_wrapper,
                     "__Qt4Ada_QPlainTextDocumentLayout_cursorWidth_0_wrapper");

   procedure ensureBlockLayout_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Block : not null access constant Qt4.Text_Blocks.Thin.QTextBlock);
   pragma Import (C, ensureBlockLayout_0_wrapper,
                     "__Qt4Ada_QPlainTextDocumentLayout_ensureBlockLayout_0_wrapper");

   procedure requestUpdate_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, requestUpdate_0_wrapper,
                     "__Qt4Ada_QPlainTextDocumentLayout_requestUpdate_0_wrapper");

   procedure setCursorWidth_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Width : Qt4.Q_Integer);
   pragma Import (C, setCursorWidth_0_wrapper,
                     "__Qt4Ada_QPlainTextDocumentLayout_setCursorWidth_0_wrapper");

   pragma Style_Checks ("N");

   ------------------
   -- Cursor_Width --
   ------------------

   function Cursor_Width
    (Self : not null access constant Q_Plain_Text_Document_Layout'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        cursorWidth_0_wrapper
         (Self.QObject_View);
   end Cursor_Width;

   -------------------------
   -- Ensure_Block_Layout --
   -------------------------

   procedure Ensure_Block_Layout
    (Self : not null access constant Q_Plain_Text_Document_Layout'Class;
     Block : Qt4.Text_Blocks.Q_Text_Block)
   is
   begin
      ensureBlockLayout_0_wrapper
       (Self.QObject_View,
        Qt4.Text_Blocks.Internals.QTextBlock_View (Block));
   end Ensure_Block_Layout;

   --------------------
   -- Request_Update --
   --------------------

   procedure Request_Update
    (Self : not null access Q_Plain_Text_Document_Layout'Class)
   is
   begin
      requestUpdate_0_wrapper
       (Self.QObject_View);
   end Request_Update;

   ----------------------
   -- Set_Cursor_Width --
   ----------------------

   procedure Set_Cursor_Width
    (Self : not null access Q_Plain_Text_Document_Layout'Class;
     Width : Qt4.Q_Integer)
   is
   begin
      setCursorWidth_0_wrapper
       (Self.QObject_View,
        Width);
   end Set_Cursor_Width;

end Qt4.Plain_Text_Document_Layouts;
