------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3639 $ $Date: 2009-11-27 11:31:52 +0300 (Fri, 27 Nov 2009) $
------------------------------------------------------------------------------

package body Qt4.Rgbs is

   ---------------------------
   -- From_Unsigned_Integer --
   ---------------------------

   function From_Unsigned_Integer (Item : Qt4.Q_Unsigned_Integer)
     return Q_Rgb
   is
   begin
      return Q_Rgb (Item);
   end From_Unsigned_Integer;

   -------------------------
   -- To_Unsigned_Integer --
   -------------------------

   function To_Unsigned_Integer (Self : Q_Rgb) return Qt4.Q_Unsigned_Integer is
   begin
      return Qt4.Q_Unsigned_Integer (Self);
   end To_Unsigned_Integer;

end Qt4.Rgbs;
