------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Qt4.Meta_Objects;
with Qt4.Objects.Directors;
with Qt4.Session_Managers;

package Qt4.Session_Managers.Directors is

   pragma Elaborate_Body;
   --  XXX Remove later, after some operation will be implemented.

   type Q_Session_Manager_Director is
     new Qt4.Objects.Directors.Q_Object_Director
       and Qt4.Session_Managers.Q_Session_Manager with null record;

   Static_Meta_Object : aliased constant Qt4.Meta_Objects.Q_Meta_Object;
   pragma Import (C,
                  Static_Meta_Object,
                  "__Qt4Ada_QSessionManager_staticMetaObject");

--   not overriding
--   function Session_Id (Self : not null access Q_Session_Manager)
--     return Qt4.Strings.Q_String;

--   not overriding
--   function Session_Key (Self : not null access Q_Session_Manager)
--     return Qt4.Strings.Q_String;

   --  void *handle() const;

--    overriding
--  function Allows_Interaction (Self : not null access Q_Session_Manager_Impl)
--      return Boolean;
--
--    overriding
--    function Allows_Error_Interaction
--     (Self : not null access Q_Session_Manager_Impl)
--        return Boolean;
--
--    overriding
--    procedure Release (Self : not null access Q_Session_Manager_Impl);
--
--    overriding
--    procedure Cancel (Self : not null access Q_Session_Manager_Impl);
--
--    overriding
--    function Restart_Hint (Self : not null access Q_Session_Manager_Impl)
--      return Q_Restart_Hint;
--
--    overriding
--  procedure Set_Restart_Hint (Self  : not null access Q_Session_Manager_Impl;
--                                Value : Q_Restart_Hint);

--   not overriding
--   function Restart_Command (Self : not null access Q_Session_Manager)
--     return Qt4.String_Lists.Q_String_List;

--   not overriding
--   procedure Set_Restart_Command
--    (Self  : not null access Q_Session_Manager;
--     Value : Qt4.String_Lists.Q_String_List);

--   not overriding
--   function Discard_Command
--    (Self : not null access Q_Session_Manager)
--       return Qt4.String_Lists.Q_String_List;

--   not overriding
--   procedure Set_Discard_Command
--    (Self  : not null access Q_Session_Manager;
--     Value : Qt4.String_Lists.Q_String_List);

--   not overriding
--   procedure Set_Manager_Property
--    (Self  : not null access Q_Session_Manager;
--     Name  : Qt4.Strings.Q_String;
--     Value : Qt4.Strings.Q_String);

--   not overriding
--   procedure Set_Manager_Property
--    (Self  : not null access Q_Session_Manager;
--     Name  : Qt4.Strings.Q_String;
--     Value : Qt4.String_Lists.Q_String_List);

--    overriding
--    function Is_Phase_2
--     (Self : not null access Q_Session_Manager_Impl)
--        return Boolean;
--
--    overriding
--  procedure Request_Phase_2 (Self : not null access Q_Session_Manager_Impl);

end Qt4.Session_Managers.Directors;
