------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Key_Sequences;
with Qt4.Objects;
with Qt4.Strings;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Shortcuts is

   type Q_Shortcut is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Shortcut_Access is
     access all Q_Shortcut'Class;
   for Q_Shortcut_Access'Storage_Size use 0;

   type Q_Shortcut_Pointer is tagged;

   function Auto_Repeat
    (Self : not null access constant Q_Shortcut'Class)
       return Standard.Boolean;

   function Context
    (Self : not null access Q_Shortcut'Class)
       return Qt4.Shortcut_Context;

   function Id
    (Self : not null access constant Q_Shortcut'Class)
       return Qt4.Q_Integer;

   function Is_Enabled
    (Self : not null access constant Q_Shortcut'Class)
       return Standard.Boolean;

   function Key
    (Self : not null access constant Q_Shortcut'Class)
       return Qt4.Key_Sequences.Q_Key_Sequence;

   function Parent_Widget
    (Self : not null access constant Q_Shortcut'Class)
       return not null access Qt4.Widgets.Q_Widget'Class;

   procedure Set_Auto_Repeat
    (Self : not null access Q_Shortcut'Class;
     On : Standard.Boolean);

   procedure Set_Context
    (Self : not null access Q_Shortcut'Class;
     Context : Qt4.Shortcut_Context);

   procedure Set_Enabled
    (Self : not null access Q_Shortcut'Class;
     Enabled : Standard.Boolean);

   procedure Set_Key
    (Self : not null access Q_Shortcut'Class;
     Key : Qt4.Key_Sequences.Q_Key_Sequence);

   procedure Set_Whats_This
    (Self : not null access Q_Shortcut'Class;
     Text : Qt4.Strings.Q_String);

   function Whats_This
    (Self : not null access constant Q_Shortcut'Class)
       return Qt4.Strings.Q_String;

   package Q_Shortcut_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Shortcut, Q_Shortcut_Access);

   type Q_Shortcut_Pointer is
     new Q_Shortcut_Pointers.Q_Pointer with null record;

end Qt4.Shortcuts;
