------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Abstract_Spin_Boxes;
with Qt4.Strings;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Spin_Boxes is

   type Q_Spin_Box is limited interface
     and Qt4.Abstract_Spin_Boxes.Q_Abstract_Spin_Box;

   type Q_Spin_Box_Access is
     access all Q_Spin_Box'Class;
   for Q_Spin_Box_Access'Storage_Size use 0;

   type Q_Spin_Box_Pointer is tagged;

   function Clean_Text
    (Self : not null access constant Q_Spin_Box'Class)
       return Qt4.Strings.Q_String;

   function Maximum
    (Self : not null access constant Q_Spin_Box'Class)
       return Qt4.Q_Integer;

   function Minimum
    (Self : not null access constant Q_Spin_Box'Class)
       return Qt4.Q_Integer;

   function Prefix
    (Self : not null access constant Q_Spin_Box'Class)
       return Qt4.Strings.Q_String;

   procedure Set_Maximum
    (Self : not null access Q_Spin_Box'Class;
     Max : Qt4.Q_Integer);

   procedure Set_Minimum
    (Self : not null access Q_Spin_Box'Class;
     Min : Qt4.Q_Integer);

   procedure Set_Prefix
    (Self : not null access Q_Spin_Box'Class;
     Prefix : Qt4.Strings.Q_String);

   procedure Set_Range
    (Self : not null access Q_Spin_Box'Class;
     Min : Qt4.Q_Integer;
     Max : Qt4.Q_Integer);

   procedure Set_Single_Step
    (Self : not null access Q_Spin_Box'Class;
     Val : Qt4.Q_Integer);

   procedure Set_Suffix
    (Self : not null access Q_Spin_Box'Class;
     Suffix : Qt4.Strings.Q_String);

   function Single_Step
    (Self : not null access constant Q_Spin_Box'Class)
       return Qt4.Q_Integer;

   function Suffix
    (Self : not null access constant Q_Spin_Box'Class)
       return Qt4.Strings.Q_String;

   function Value
    (Self : not null access constant Q_Spin_Box'Class)
       return Qt4.Q_Integer;

   procedure Set_Value
    (Self : not null access Q_Spin_Box'Class;
     Val : Qt4.Q_Integer);

   package Q_Spin_Box_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Spin_Box, Q_Spin_Box_Access);

   type Q_Spin_Box_Pointer is
     new Q_Spin_Box_Pointers.Q_Pointer with null record;

end Qt4.Spin_Boxes;
