------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Splash_Screen_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Splash_Screen_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Splash_Screens is

   procedure finish_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     W : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, finish_0_wrapper,
                     "__Qt4Ada_QSplashScreen_finish_0_wrapper");

   procedure pixmap_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Pixmaps.Internals.QPixmap);
   pragma Import (C, pixmap_0_wrapper,
                     "__Qt4Ada_QSplashScreen_pixmap_0_wrapper");

   procedure repaint_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, repaint_0_wrapper,
                     "__Qt4Ada_QSplashScreen_repaint_0_wrapper");

   procedure setPixmap_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pixmap : not null access constant Qt4.Pixmaps.Internals.QPixmap);
   pragma Import (C, setPixmap_0_wrapper,
                     "__Qt4Ada_QSplashScreen_setPixmap_0_wrapper");

   procedure clearMessage_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clearMessage_0_wrapper,
                     "__Qt4Ada_QSplashScreen_clearMessage_0_wrapper");

   procedure QSplashScreen_showMessage_QStringCR_int_QColorCR
    (Self      : not null access Qt_Ada.Internals.Objects.QObject;
     Message   : not null Qt4.Strings.Internals.QString_Access;
     Alignment : Qt4.Alignment;
     Color     : not null Qt4.Colors.Internals.QColor_Access);
   pragma Import
    (C,
     QSplashScreen_showMessage_QStringCR_int_QColorCR,
     "__QtAda_QSplashScreen_showMessage_QStringCR_int_QColorCR");

   ------------------
   -- Show_Message --
   ------------------

   procedure Show_Message
    (Self      : not null access Q_Splash_Screen'Class;
     Message   : Qt4.Strings.Q_String'Class
       := Qt4.Strings.Create;
     Alignment : Qt4.Alignment
       := +Qt4.Align_Left;
     Color     : Qt4.Colors.Q_Color'Class
       := Qt4.Colors.Create (Qt4.Black))
   is
   begin
      QSplashScreen_showMessage_QStringCR_int_QColorCR
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Message),
        Alignment,
        Qt4.Colors.Internals.QColor_View (Color));
   end Show_Message;

   pragma Style_Checks ("N");

   ------------
   -- Finish --
   ------------

   procedure Finish
    (Self : not null access Q_Splash_Screen'Class;
     W : not null access Qt4.Widgets.Q_Widget'Class)
   is
   begin
      finish_0_wrapper
       (Self.QObject_View,
        W.QObject_View);
   end Finish;

   ------------
   -- Pixmap --
   ------------

   function Pixmap
    (Self : not null access constant Q_Splash_Screen'Class)
       return Qt4.Pixmaps.Q_Pixmap
   is
      Returns : Qt4.Pixmaps.Q_Pixmap;

   begin
      pixmap_0_wrapper
       (Self.QObject_View,
        Qt4.Pixmaps.Internals.QPixmap_View (Returns));

      return Returns;
   end Pixmap;

   -------------
   -- Repaint --
   -------------

   procedure Repaint
    (Self : not null access Q_Splash_Screen'Class)
   is
   begin
      repaint_0_wrapper
       (Self.QObject_View);
   end Repaint;

   ----------------
   -- Set_Pixmap --
   ----------------

   procedure Set_Pixmap
    (Self : not null access Q_Splash_Screen'Class;
     Pixmap : Qt4.Pixmaps.Q_Pixmap)
   is
   begin
      setPixmap_0_wrapper
       (Self.QObject_View,
        Qt4.Pixmaps.Internals.QPixmap_View (Pixmap));
   end Set_Pixmap;

   -------------------
   -- Clear_Message --
   -------------------

   procedure Clear_Message
    (Self : not null access Q_Splash_Screen'Class)
   is
   begin
      clearMessage_0_wrapper
       (Self.QObject_View);
   end Clear_Message;

end Qt4.Splash_Screens;
