------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Colors;
with Qt4.Pixmaps;
with Qt4.Strings;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Splash_Screens is

   type Q_Splash_Screen is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_Splash_Screen_Access is
     access all Q_Splash_Screen'Class;
   for Q_Splash_Screen_Access'Storage_Size use 0;

   type Q_Splash_Screen_Pointer is tagged;

   procedure Finish
    (Self : not null access Q_Splash_Screen'Class;
     W : not null access Qt4.Widgets.Q_Widget'Class);

   function Pixmap
    (Self : not null access constant Q_Splash_Screen'Class)
       return Qt4.Pixmaps.Q_Pixmap;

   procedure Repaint
    (Self : not null access Q_Splash_Screen'Class);

   procedure Set_Pixmap
    (Self : not null access Q_Splash_Screen'Class;
     Pixmap : Qt4.Pixmaps.Q_Pixmap);

   procedure Clear_Message
    (Self : not null access Q_Splash_Screen'Class);

   procedure Show_Message
    (Self      : not null access Q_Splash_Screen'Class;
     Message   : Qt4.Strings.Q_String'Class
       := Qt4.Strings.Create;
     Alignment : Qt4.Alignment
       := +Qt4.Align_Left;
     Color     : Qt4.Colors.Q_Color'Class
       := Qt4.Colors.Create (Qt4.Black));

   package Q_Splash_Screen_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Splash_Screen, Q_Splash_Screen_Access);

   type Q_Splash_Screen_Pointer is
     new Q_Splash_Screen_Pointers.Q_Pointer with null record;

end Qt4.Splash_Screens;
