------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2012 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Byte_Arrays;
with Qt4.Frames;
limited with Qt4.Splitter_Handles;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Splitters is

   type Q_Splitter is limited interface
     and Qt4.Frames.Q_Frame;

   type Q_Splitter_Access is
     access all Q_Splitter'Class;
   for Q_Splitter_Access'Storage_Size use 0;

   type Q_Splitter_Pointer is tagged;

   procedure Add_Widget
    (Self : not null access Q_Splitter'Class;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   function Children_Collapsible
    (Self : not null access constant Q_Splitter'Class)
       return Standard.Boolean;

   function Count
    (Self : not null access constant Q_Splitter'Class)
       return Qt4.Q_Integer;

   function Handle
    (Self : not null access constant Q_Splitter'Class;
     Index : Qt4.Q_Integer)
       return not null access Qt4.Splitter_Handles.Q_Splitter_Handle'Class;

   function Handle_Width
    (Self : not null access constant Q_Splitter'Class)
       return Qt4.Q_Integer;

   function Index_Of
    (Self : not null access constant Q_Splitter'Class;
     W : not null access Qt4.Widgets.Q_Widget'Class)
       return Qt4.Q_Integer;

   procedure Insert_Widget
    (Self : not null access Q_Splitter'Class;
     Index : Qt4.Q_Integer;
     Widget : not null access Qt4.Widgets.Q_Widget'Class);

   function Is_Collapsible
    (Self : not null access constant Q_Splitter'Class;
     Index : Qt4.Q_Integer)
       return Standard.Boolean;

   function Opaque_Resize
    (Self : not null access constant Q_Splitter'Class)
       return Standard.Boolean;

   procedure Refresh
    (Self : not null access Q_Splitter'Class);

   procedure Restore_State
    (Self : not null access Q_Splitter'Class;
     State : Qt4.Byte_Arrays.Q_Byte_Array);

   function Save_State
    (Self : not null access constant Q_Splitter'Class)
       return Qt4.Byte_Arrays.Q_Byte_Array;

   procedure Set_Children_Collapsible
    (Self : not null access Q_Splitter'Class;
     Collapse : Standard.Boolean);

   procedure Set_Collapsible
    (Self : not null access Q_Splitter'Class;
     Index : Qt4.Q_Integer;
     Collapse : Standard.Boolean);

   procedure Set_Handle_Width
    (Self : not null access Q_Splitter'Class;
     Width : Qt4.Q_Integer);

   procedure Set_Stretch_Factor
    (Self : not null access Q_Splitter'Class;
     Index : Qt4.Q_Integer;
     Stretch : Qt4.Q_Integer);

   function Widget
    (Self : not null access constant Q_Splitter'Class;
     Index : Qt4.Q_Integer)
       return not null access Qt4.Widgets.Q_Widget'Class;

   package Q_Splitter_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Splitter, Q_Splitter_Access);

   type Q_Splitter_Pointer is
     new Q_Splitter_Pointers.Q_Pointer with null record;

end Qt4.Splitters;
