------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Objects;
limited with Qt4.Text_Documents;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Syntax_Highlighters is

   type Q_Syntax_Highlighter is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Syntax_Highlighter_Access is
     access all Q_Syntax_Highlighter'Class;
   for Q_Syntax_Highlighter_Access'Storage_Size use 0;

   type Q_Syntax_Highlighter_Pointer is tagged;

   function Document
    (Self : not null access constant Q_Syntax_Highlighter'Class)
       return not null access Qt4.Text_Documents.Q_Text_Document'Class;

   procedure Set_Document
    (Self : not null access Q_Syntax_Highlighter'Class;
     Doc : not null access Qt4.Text_Documents.Q_Text_Document'Class);

   procedure Rehighlight
    (Self : not null access Q_Syntax_Highlighter'Class);

   package Q_Syntax_Highlighter_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Syntax_Highlighter, Q_Syntax_Highlighter_Access);

   type Q_Syntax_Highlighter_Pointer is
     new Q_Syntax_Highlighter_Pointers.Q_Pointer with null record;

end Qt4.Syntax_Highlighters;
