------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Text_Object_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Text_Object_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Text_Objects is

   function formatIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, formatIndex_0_wrapper,
                     "__Qt4Ada_QTextObject_formatIndex_0_wrapper");

   function objectIndex_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, objectIndex_0_wrapper,
                     "__Qt4Ada_QTextObject_objectIndex_0_wrapper");

   pragma Style_Checks ("N");

   ------------------
   -- Format_Index --
   ------------------

   function Format_Index
    (Self : not null access constant Q_Text_Object'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        formatIndex_0_wrapper
         (Self.QObject_View);
   end Format_Index;

   ------------------
   -- Object_Index --
   ------------------

   function Object_Index
    (Self : not null access constant Q_Text_Object'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        objectIndex_0_wrapper
         (Self.QObject_View);
   end Object_Index;

end Qt4.Text_Objects;
