------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.Wizard_Page_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Wizard_Page_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Wizard_Pages is

   procedure buttonText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Which : Qt4.Wizards.Wizard_Wizard_Button;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, buttonText_0_wrapper,
                     "__Qt4Ada_QWizardPage_buttonText_0_wrapper");

   function isCommitPage_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isCommitPage_0_wrapper,
                     "__Qt4Ada_QWizardPage_isCommitPage_0_wrapper");

   function isFinalPage_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isFinalPage_0_wrapper,
                     "__Qt4Ada_QWizardPage_isFinalPage_0_wrapper");

   procedure pixmap_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Which : Qt4.Wizards.Wizard_Wizard_Pixmap;
     Returns : not null access Qt4.Pixmaps.Internals.QPixmap);
   pragma Import (C, pixmap_0_wrapper,
                     "__Qt4Ada_QWizardPage_pixmap_0_wrapper");

   procedure setButtonText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Which : Qt4.Wizards.Wizard_Wizard_Button;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setButtonText_0_wrapper,
                     "__Qt4Ada_QWizardPage_setButtonText_0_wrapper");

   procedure setCommitPage_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Commit_Page : Qt4.bool);
   pragma Import (C, setCommitPage_0_wrapper,
                     "__Qt4Ada_QWizardPage_setCommitPage_0_wrapper");

   procedure setFinalPage_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Final_Page : Qt4.bool);
   pragma Import (C, setFinalPage_0_wrapper,
                     "__Qt4Ada_QWizardPage_setFinalPage_0_wrapper");

   procedure setPixmap_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Which : Qt4.Wizards.Wizard_Wizard_Pixmap;
     Pixmap : not null access constant Qt4.Pixmaps.Internals.QPixmap);
   pragma Import (C, setPixmap_0_wrapper,
                     "__Qt4Ada_QWizardPage_setPixmap_0_wrapper");

   procedure setSubTitle_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Sub_Title : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setSubTitle_0_wrapper,
                     "__Qt4Ada_QWizardPage_setSubTitle_0_wrapper");

   procedure setTitle_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Title : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setTitle_0_wrapper,
                     "__Qt4Ada_QWizardPage_setTitle_0_wrapper");

   procedure subTitle_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, subTitle_0_wrapper,
                     "__Qt4Ada_QWizardPage_subTitle_0_wrapper");

   procedure title_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, title_0_wrapper,
                     "__Qt4Ada_QWizardPage_title_0_wrapper");

   pragma Style_Checks ("N");

   -----------------
   -- Button_Text --
   -----------------

   function Button_Text
    (Self : not null access constant Q_Wizard_Page'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Button)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      buttonText_0_wrapper
       (Self.QObject_View,
        Which,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Button_Text;

   --------------------
   -- Is_Commit_Page --
   --------------------

   function Is_Commit_Page
    (Self : not null access constant Q_Wizard_Page'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isCommitPage_0_wrapper
           (Self.QObject_View));
   end Is_Commit_Page;

   -------------------
   -- Is_Final_Page --
   -------------------

   function Is_Final_Page
    (Self : not null access constant Q_Wizard_Page'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isFinalPage_0_wrapper
           (Self.QObject_View));
   end Is_Final_Page;

   ------------
   -- Pixmap --
   ------------

   function Pixmap
    (Self : not null access constant Q_Wizard_Page'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Pixmap)
       return Qt4.Pixmaps.Q_Pixmap
   is
      Returns : Qt4.Pixmaps.Q_Pixmap;

   begin
      pixmap_0_wrapper
       (Self.QObject_View,
        Which,
        Qt4.Pixmaps.Internals.QPixmap_View (Returns));

      return Returns;
   end Pixmap;

   ---------------------
   -- Set_Button_Text --
   ---------------------

   procedure Set_Button_Text
    (Self : not null access Q_Wizard_Page'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Button;
     Text : Qt4.Strings.Q_String)
   is
   begin
      setButtonText_0_wrapper
       (Self.QObject_View,
        Which,
        Qt4.Strings.Internals.QString_View (Text));
   end Set_Button_Text;

   ---------------------
   -- Set_Commit_Page --
   ---------------------

   procedure Set_Commit_Page
    (Self : not null access Q_Wizard_Page'Class;
     Commit_Page : Standard.Boolean)
   is
   begin
      setCommitPage_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Commit_Page));
   end Set_Commit_Page;

   --------------------
   -- Set_Final_Page --
   --------------------

   procedure Set_Final_Page
    (Self : not null access Q_Wizard_Page'Class;
     Final_Page : Standard.Boolean)
   is
   begin
      setFinalPage_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Final_Page));
   end Set_Final_Page;

   ----------------
   -- Set_Pixmap --
   ----------------

   procedure Set_Pixmap
    (Self : not null access Q_Wizard_Page'Class;
     Which : Qt4.Wizards.Wizard_Wizard_Pixmap;
     Pixmap : Qt4.Pixmaps.Q_Pixmap)
   is
   begin
      setPixmap_0_wrapper
       (Self.QObject_View,
        Which,
        Qt4.Pixmaps.Internals.QPixmap_View (Pixmap));
   end Set_Pixmap;

   -------------------
   -- Set_Sub_Title --
   -------------------

   procedure Set_Sub_Title
    (Self : not null access Q_Wizard_Page'Class;
     Sub_Title : Qt4.Strings.Q_String)
   is
   begin
      setSubTitle_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Sub_Title));
   end Set_Sub_Title;

   ---------------
   -- Set_Title --
   ---------------

   procedure Set_Title
    (Self : not null access Q_Wizard_Page'Class;
     Title : Qt4.Strings.Q_String)
   is
   begin
      setTitle_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Title));
   end Set_Title;

   ---------------
   -- Sub_Title --
   ---------------

   function Sub_Title
    (Self : not null access constant Q_Wizard_Page'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      subTitle_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Sub_Title;

   -----------
   -- Title --
   -----------

   function Title
    (Self : not null access constant Q_Wizard_Page'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      title_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Title;

end Qt4.Wizard_Pages;
