------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);

package body Qt_Ada.Internals.Objects.Dialog_Proxies is

   procedure accept_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
      pragma Import (C, accept_0_virtual,
                     "__Qt4Ada_QDialog_accept_0_virtual");

   procedure done_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Result : Qt4.Q_Integer);
      pragma Import (C, done_0_virtual,
                     "__Qt4Ada_QDialog_done_0_virtual");

   procedure reject_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
      pragma Import (C, reject_0_virtual,
                     "__Qt4Ada_QDialog_reject_0_virtual");

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;

   pragma Style_Checks ("N");

   -------------------
   -- Accept_Dialog --
   -------------------

   procedure Accept_Dialog
    (Self : not null access Q_Dialog_Proxy)
   is
   begin
      accept_0_virtual
       (Q_Dialog_Proxy'Class (Self.all).QObject_View);
   end Accept_Dialog;

   ----------
   -- Done --
   ----------

   procedure Done
    (Self : not null access Q_Dialog_Proxy;
     Result : Qt4.Q_Integer)
   is
   begin
      done_0_virtual
       (Q_Dialog_Proxy'Class (Self.all).QObject_View,
        Result);
   end Done;

   ------------
   -- Reject --
   ------------

   procedure Reject
    (Self : not null access Q_Dialog_Proxy)
   is
   begin
      reject_0_virtual
       (Q_Dialog_Proxy'Class (Self.all).QObject_View);
   end Reject;

   type Q_Dialog_Proxy_Access is
     access all Q_Dialog_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access
   is
      Self : constant not null Q_Dialog_Proxy_Access
        := new Q_Dialog_Proxy;

   begin
      Qt_Ada.Internals.Objects.Initialize (Self, Object);

      return Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Object_Registry.Register_Proxy
    ("QDialog", Create'Access);
end Qt_Ada.Internals.Objects.Dialog_Proxies;
