------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);

package body Qt_Ada.Internals.Objects.Item_Selection_Model_Proxies is

   procedure clear_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
      pragma Import (C, clear_0_virtual,
                     "__Qt4Ada_QItemSelectionModel_clear_0_virtual");

   procedure reset_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
      pragma Import (C, reset_0_virtual,
                     "__Qt4Ada_QItemSelectionModel_reset_0_virtual");

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;

   procedure select_virtual
    (Self      : not null access Qt_Ada.Internals.Objects.QObject;
     Selection : not null access Qt4.Item_Selections.Thin.QItemSelection;
     Command   : Qt4.Item_Selection_Models.Selection_Flags);
   pragma Import
    (C, select_virtual, "__Qt4Ada_QItemSelectionModel_select_virtual");

   procedure select_QModelIndexCR_virtual
    (Self    : not null access Qt_Ada.Internals.Objects.QObject;
     Index   : not null Qt4.Model_Indices.Internals.QModelIndex_Access;
     Command : Qt4.Item_Selection_Models.Selection_Flags);
   pragma Import
    (C, select_QModelIndexCR_virtual,
     "__Qt4Ada_QItemSelectionModel_select_QModelIndexCR_virtual");

   -----------------
   -- Select_Item --
   -----------------

   overriding
   procedure Select_Item
    (Self    : not null access Q_Item_Selection_Model_Proxy;
     Index   : Qt4.Model_Indices.Q_Model_Index;
     Command : Qt4.Item_Selection_Models.Selection_Flags)
   is
   begin
      select_QModelIndexCR_virtual
       (Self.QObject_View,
        Qt4.Model_Indices.Internals.QModelIndex_View (Index),
        Command);
   end Select_Item;

   -----------------
   -- Select_Item --
   -----------------

   overriding
   procedure Select_Item
    (Self      : not null access Q_Item_Selection_Model_Proxy;
     Selection : Qt4.Item_Selections.Q_Item_Selection;
     Command   : Qt4.Item_Selection_Models.Selection_Flags)
   is
   begin
      select_virtual
       (Self.QObject_View,
        Qt4.Item_Selections.Internals.QItemSelection_View (Selection),
        Command);
   end Select_Item;

   pragma Style_Checks ("N");

   -----------
   -- Clear --
   -----------

   procedure Clear
    (Self : not null access Q_Item_Selection_Model_Proxy)
   is
   begin
      clear_0_virtual
       (Q_Item_Selection_Model_Proxy'Class (Self.all).QObject_View);
   end Clear;

   -----------
   -- Reset --
   -----------

   procedure Reset
    (Self : not null access Q_Item_Selection_Model_Proxy)
   is
   begin
      reset_0_virtual
       (Q_Item_Selection_Model_Proxy'Class (Self.all).QObject_View);
   end Reset;

   type Q_Item_Selection_Model_Proxy_Access is
     access all Q_Item_Selection_Model_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access
   is
      Self : constant not null Q_Item_Selection_Model_Proxy_Access
        := new Q_Item_Selection_Model_Proxy;

   begin
      Qt_Ada.Internals.Objects.Initialize (Self, Object);

      return Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Object_Registry.Register_Proxy
    ("QItemSelectionModel", Create'Access);
end Qt_Ada.Internals.Objects.Item_Selection_Model_Proxies;
