------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Paint_Engines;
with Qt4.Sizes;
with Qt4.Variants;
with Qt4.Widgets;
with Qt_Ada.Internals.Objects.Object_Proxies;
with Qt_Ada.Internals.Paint_Devices;

package Qt_Ada.Internals.Objects.Widget_Proxies is

   pragma Elaborate_Body;

   type Q_Widget_Proxy is
     new Qt_Ada.Internals.Objects.Object_Proxies.Q_Object_Proxy
       and Qt4.Widgets.Q_Widget with null record;

   function Height_For_Width
    (Self : not null access constant Q_Widget_Proxy;
     W : Qt4.Q_Integer)
       return Qt4.Q_Integer;

   function Input_Method_Query
    (Self : not null access constant Q_Widget_Proxy;
     Query : Qt4.Input_Method_Query)
       return Qt4.Variants.Q_Variant;

   function Minimum_Size_Hint
    (Self : not null access constant Q_Widget_Proxy)
       return Qt4.Sizes.Q_Size;

   function Size_Hint
    (Self : not null access constant Q_Widget_Proxy)
       return Qt4.Sizes.Q_Size;

   procedure Set_Visible
    (Self : not null access Q_Widget_Proxy;
     Visible : Standard.Boolean);

   overriding
   function Paint_Engine
    (Self : not null access Q_Widget_Proxy)
       return not null access Qt4.Paint_Engines.Q_Paint_Engine;

   overriding function QPaintDevice_View
    (Self : not null access constant Q_Widget_Proxy)
       return not null Qt_Ada.Internals.Paint_Devices.QPaintDevice_Access;

end Qt_Ada.Internals.Objects.Widget_Proxies;
