//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QTABBARDIRECTOR_H__
#define __QTABBARDIRECTOR_H__

#include <QTabBar>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QTabBar_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QTabBar_tabInserted_0_dispatch(void*, int);
    extern void __Qt4Ada_QTabBar_tabLayoutChange_0_dispatch(void*);
    extern void __Qt4Ada_QTabBar_tabRemoved_0_dispatch(void*, int);
    extern QSize* __Qt4Ada_QTabBar_tabSizeHint_0_dispatch(void*, int);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern int __Qt4Ada_QTabBar_addTab_1_wrapper(QObject*, const QString*);
    extern int __Qt4Ada_QTabBar_addTab_0_wrapper(QObject*, const QIcon*, const QString*);
    extern int __Qt4Ada_QTabBar_count_0_wrapper(QObject*);
    extern int __Qt4Ada_QTabBar_currentIndex_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTabBar_drawBase_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabBar_iconSize_0_wrapper(QObject*, QSize*);
    extern int __Qt4Ada_QTabBar_insertTab_1_wrapper(QObject*, int, const QString*);
    extern int __Qt4Ada_QTabBar_insertTab_0_wrapper(QObject*, int, const QIcon*, const QString*);
    extern bool __Qt4Ada_QTabBar_isTabEnabled_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabBar_removeTab_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabBar_setDrawBase_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTabBar_setIconSize_0_wrapper(QObject*, const QSize*);
    extern void __Qt4Ada_QTabBar_setShape_0_wrapper(QObject*, QTabBar::Shape);
    extern void __Qt4Ada_QTabBar_setTabData_0_wrapper(QObject*, int, const QVariant*);
    extern void __Qt4Ada_QTabBar_setTabEnabled_0_wrapper(QObject*, int, bool);
    extern void __Qt4Ada_QTabBar_setTabIcon_0_wrapper(QObject*, int, const QIcon*);
    extern void __Qt4Ada_QTabBar_setTabText_0_wrapper(QObject*, int, const QString*);
    extern void __Qt4Ada_QTabBar_setTabTextColor_0_wrapper(QObject*, int, const QColor*);
    extern void __Qt4Ada_QTabBar_setTabToolTip_0_wrapper(QObject*, int, const QString*);
    extern void __Qt4Ada_QTabBar_setTabWhatsThis_0_wrapper(QObject*, int, const QString*);
    extern void __Qt4Ada_QTabBar_setUsesScrollButtons_0_wrapper(QObject*, bool);
    extern QTabBar::Shape __Qt4Ada_QTabBar_shape_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabBar_tabData_0_wrapper(QObject*, int, QVariant*);
    extern void __Qt4Ada_QTabBar_tabIcon_0_wrapper(QObject*, int, QIcon*);
    extern void __Qt4Ada_QTabBar_tabRect_0_wrapper(QObject*, int, QRect*);
    extern void __Qt4Ada_QTabBar_tabText_0_wrapper(QObject*, int, QString*);
    extern void __Qt4Ada_QTabBar_tabTextColor_0_wrapper(QObject*, int, QColor*);
    extern void __Qt4Ada_QTabBar_tabToolTip_0_wrapper(QObject*, int, QString*);
    extern void __Qt4Ada_QTabBar_tabWhatsThis_0_wrapper(QObject*, int, QString*);
    extern bool __Qt4Ada_QTabBar_usesScrollButtons_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabBar_setCurrentIndex_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabBar_sizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QTabBar_minimumSizeHint_0_wrapper(QObject*, QSize*);
    extern void __Qt4Ada_QTabBar_currentChanged_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabBar_tabInserted_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabBar_tabLayoutChange_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabBar_tabRemoved_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTabBar_tabSizeHint_0_wrapper(QObject*, int, QSize*);
    extern void __Qt4Ada_QTabBar_changeEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTabBar_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QTabBar_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTabBar_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTabBar_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTabBar_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTabBar_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabBar_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QTabBar_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QTabBar_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QTabBar_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTabBar_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QTabBar_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QTabBar_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QTabBar_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

class QTabBarDirector : public QTabBar
{
protected:
    void* ada_object;
    QTabBarDirector();

    virtual QSize sizeHint() const;
    virtual QSize minimumSizeHint() const;
    virtual void tabInserted(int);
    virtual void tabLayoutChange();
    virtual void tabRemoved(int);
    virtual QSize tabSizeHint(int) const;
    virtual void changeEvent(QEvent*);
    virtual bool event(QEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void showEvent(QShowEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QTabBar_currentChanged_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QTabBar_tabInserted_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QTabBar_tabLayoutChange_0_wrapper(QObject*);
    friend void __Qt4Ada_QTabBar_tabRemoved_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QTabBar_tabSizeHint_0_wrapper(QObject*, int, QSize*);
    friend void __Qt4Ada_QTabBar_changeEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTabBar_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QTabBar_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTabBar_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QTabBar_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTabBar_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTabBar_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QTabBar_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QTabBar_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QTabBar_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QTabBar_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTabBar_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QTabBar_sender_0_wrapper(QObject*);
};

#endif // __QTABBARDIRECTOR_H__
