//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QHeaderView>
#include <QModelIndex>
#include <QAbstractItemModel>
#include <QRect>
#include <QPaintEvent>
#include <QTimerEvent>
#include <QRegion>
#include <QItemSelectionModel>
#include <QVariant>
#include <QWidget>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QResizeEvent>
#include <QSize>
#include <QWheelEvent>
#include <QContextMenuEvent>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qtableviewdirector.h"
#include "qabstractitemviewdirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QTableView_staticMetaObject =
        &QTableView::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    int __Qt4Ada_QTableView_columnAt_0_wrapper(QObject* cpp_object, int x)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::columnAt(x);
    }

    int __Qt4Ada_QTableView_columnSpan_0_wrapper(QObject* cpp_object, int row, int column)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::columnSpan(row, column);
    }

    int __Qt4Ada_QTableView_columnViewportPosition_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::columnViewportPosition(column);
    }

    int __Qt4Ada_QTableView_columnWidth_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::columnWidth(column);
    }

    QObject* __Qt4Ada_QTableView_horizontalHeader_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QTableView*>(cpp_object)->QTableView::horizontalHeader());
    }

    bool __Qt4Ada_QTableView_isColumnHidden_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::isColumnHidden(column);
    }

    bool __Qt4Ada_QTableView_isCornerButtonEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::isCornerButtonEnabled();
    }

    bool __Qt4Ada_QTableView_isRowHidden_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::isRowHidden(row);
    }

    bool __Qt4Ada_QTableView_isSortingEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::isSortingEnabled();
    }

    int __Qt4Ada_QTableView_rowAt_0_wrapper(QObject* cpp_object, int y)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::rowAt(y);
    }

    int __Qt4Ada_QTableView_rowHeight_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::rowHeight(row);
    }

    int __Qt4Ada_QTableView_rowSpan_0_wrapper(QObject* cpp_object, int row, int column)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::rowSpan(row, column);
    }

    int __Qt4Ada_QTableView_rowViewportPosition_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::rowViewportPosition(row);
    }

    void __Qt4Ada_QTableView_setColumnHidden_0_wrapper(QObject* cpp_object, int column, bool hide)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setColumnHidden(column, hide);
    }

    void __Qt4Ada_QTableView_setColumnWidth_0_wrapper(QObject* cpp_object, int column, int width)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setColumnWidth(column, width);
    }

    void __Qt4Ada_QTableView_setCornerButtonEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setCornerButtonEnabled(enable);
    }

    void __Qt4Ada_QTableView_setHorizontalHeader_0_wrapper(QObject* cpp_object, QObject* header)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setHorizontalHeader(dynamic_cast<QHeaderView*>(header));
    }

    void __Qt4Ada_QTableView_setRowHeight_0_wrapper(QObject* cpp_object, int row, int height)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setRowHeight(row, height);
    }

    void __Qt4Ada_QTableView_setRowHidden_0_wrapper(QObject* cpp_object, int row, bool hide)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setRowHidden(row, hide);
    }

    void __Qt4Ada_QTableView_setSortingEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setSortingEnabled(enable);
    }

    void __Qt4Ada_QTableView_setSpan_0_wrapper(QObject* cpp_object, int row, int column, int rowSpan, int columnSpan)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setSpan(row, column, rowSpan, columnSpan);
    }

    void __Qt4Ada_QTableView_setVerticalHeader_0_wrapper(QObject* cpp_object, QObject* header)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setVerticalHeader(dynamic_cast<QHeaderView*>(header));
    }

    void __Qt4Ada_QTableView_setWordWrap_0_wrapper(QObject* cpp_object, bool on)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setWordWrap(on);
    }

    bool __Qt4Ada_QTableView_showGrid_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::showGrid();
    }

    QObject* __Qt4Ada_QTableView_verticalHeader_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QTableView*>(cpp_object)->QTableView::verticalHeader());
    }

    bool __Qt4Ada_QTableView_wordWrap_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableView*>(cpp_object)->QTableView::wordWrap();
    }

    void __Qt4Ada_QTableView_hideColumn_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::hideColumn(column);
    }

    void __Qt4Ada_QTableView_hideRow_0_wrapper(QObject* cpp_object, int row)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::hideRow(row);
    }

    void __Qt4Ada_QTableView_resizeColumnToContents_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::resizeColumnToContents(column);
    }

    void __Qt4Ada_QTableView_resizeColumnsToContents_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::resizeColumnsToContents();
    }

    void __Qt4Ada_QTableView_resizeRowToContents_0_wrapper(QObject* cpp_object, int row)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::resizeRowToContents(row);
    }

    void __Qt4Ada_QTableView_resizeRowsToContents_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::resizeRowsToContents();
    }

    void __Qt4Ada_QTableView_selectColumn_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::selectColumn(column);
    }

    void __Qt4Ada_QTableView_selectRow_0_wrapper(QObject* cpp_object, int row)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::selectRow(row);
    }

    void __Qt4Ada_QTableView_setShowGrid_0_wrapper(QObject* cpp_object, bool show)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setShowGrid(show);
    }

    void __Qt4Ada_QTableView_showColumn_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::showColumn(column);
    }

    void __Qt4Ada_QTableView_showRow_0_wrapper(QObject* cpp_object, int row)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::showRow(row);
    }

    void __Qt4Ada_QTableView_indexAt_0_wrapper(QObject* cpp_object, const QPoint* point, QModelIndex* returns)
    {
        *returns = dynamic_cast<QTableView*>(cpp_object)->QTableView::indexAt(*point);
    }

    void __Qt4Ada_QTableView_scrollTo_0_wrapper(QObject* cpp_object, const QModelIndex* index, QAbstractItemView::ScrollHint hint)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::scrollTo(*index, hint);
    }

    void __Qt4Ada_QTableView_setModel_0_wrapper(QObject* cpp_object, QObject* model)
    {
        dynamic_cast<QTableView*>(cpp_object)->QTableView::setModel(dynamic_cast<QAbstractItemModel*>(model));
    }

    void __Qt4Ada_QTableView_visualRect_0_wrapper(QObject* cpp_object, const QModelIndex* index, QRect* returns)
    {
        *returns = dynamic_cast<QTableView*>(cpp_object)->QTableView::visualRect(*index);
    }

    int __Qt4Ada_QTableView_horizontalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QTableView::horizontalOffset();
    }

    void __Qt4Ada_QTableView_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QTableView::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    bool __Qt4Ada_QTableView_isIndexHidden_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QTableView::isIndexHidden(*index);
    }

    void __Qt4Ada_QTableView_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QTableView::scrollContentsBy(dx, dy);
    }

    int __Qt4Ada_QTableView_sizeHintForColumn_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QTableView::sizeHintForColumn(column);
    }

    int __Qt4Ada_QTableView_sizeHintForRow_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QTableView::sizeHintForRow(row);
    }

    void __Qt4Ada_QTableView_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QTableView::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    int __Qt4Ada_QTableView_verticalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QTableView::verticalOffset();
    }

    void __Qt4Ada_QTableView_visualRegionForSelection_0_wrapper(QObject* cpp_object, const QItemSelection* selection, QRegion* returns)
    {
        *returns = dynamic_cast<QTableViewDirector*>(cpp_object)->QTableView::visualRegionForSelection(*selection);
    }

    void __Qt4Ada_QTableView_activated_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::activated(*index);
    }

    void __Qt4Ada_QTableView_clicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::clicked(*index);
    }

    void __Qt4Ada_QTableView_doubleClicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::doubleClicked(*index);
    }

    void __Qt4Ada_QTableView_entered_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::entered(*index);
    }

    void __Qt4Ada_QTableView_pressed_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::pressed(*index);
    }

    void __Qt4Ada_QTableView_viewportEntered_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::viewportEntered();
    }

    void __Qt4Ada_QTableView_dirtyRegionOffset_0_wrapper(QObject* cpp_object, QPoint* returns)
    {
        *returns = dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::dirtyRegionOffset();
    }

    void __Qt4Ada_QTableView_executeDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::executeDelayedItemsLayout();
    }

    void __Qt4Ada_QTableView_scheduleDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::scheduleDelayedItemsLayout();
    }

    void __Qt4Ada_QTableView_scrollDirtyRegion_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::scrollDirtyRegion(dx, dy);
    }

    void __Qt4Ada_QTableView_setDirtyRegion_0_wrapper(QObject* cpp_object, const QRegion* region)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::setDirtyRegion(*region);
    }

    void __Qt4Ada_QTableView_commitData_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::commitData(dynamic_cast<QWidget*>(editor));
    }

    void __Qt4Ada_QTableView_currentChanged_0_wrapper(QObject* cpp_object, const QModelIndex* current, const QModelIndex* previous)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::currentChanged(*current, *previous);
    }

    void __Qt4Ada_QTableView_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::dataChanged(*topLeft, *bottomRight);
    }

    void __Qt4Ada_QTableView_editorDestroyed_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::editorDestroyed(editor);
    }

    void __Qt4Ada_QTableView_rowsAboutToBeRemoved_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::rowsAboutToBeRemoved(*parent, start, stop);
    }

    void __Qt4Ada_QTableView_rowsInserted_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::rowsInserted(*parent, start, stop);
    }

    void __Qt4Ada_QTableView_selectionChanged_0_wrapper(QObject* cpp_object, const QItemSelection* selected, const QItemSelection* deselected)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::selectionChanged(*selected, *deselected);
    }

    void __Qt4Ada_QTableView_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QTableView_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QTableView_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QTableView_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    bool __Qt4Ada_QTableView_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::event(e);
    }

    void __Qt4Ada_QTableView_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QTableView_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::focusNextPrevChild(next);
    }

    void __Qt4Ada_QTableView_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QTableView_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QTableView_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTableView_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTableView_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTableView_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTableView_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTableView_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    bool __Qt4Ada_QTableView_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractItemView::viewportEvent(event);
    }

    void __Qt4Ada_QTableView_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QTableView_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QTableView_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractScrollArea::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QTableView_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QAbstractScrollArea::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QTableView_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QTableView_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QTableView_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QTableView_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QTableView_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QTableView_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QTableView_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QTableView_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QTableView_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTableView_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QTableView_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QTableView_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QTableView_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QTableView_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QTableView_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QTableView_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QTableView_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableViewDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QTableView_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableViewDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QTableView_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QTableView*>(cpp_this)->QTableView::qt_metacast(name);
    }

    int __Qt4Ada_QTableView_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QTableView*>(cpp_this)->QTableView::qt_metacall(_c, _id, _a);
    }

}

QModelIndex QTableViewDirector::indexAt(const QPoint& point) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemView_indexAt_0_dispatch(this->ada_object, &point);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

void QTableViewDirector::scrollTo(const QModelIndex& index, QAbstractItemView::ScrollHint hint)
{
    __Qt4Ada_QAbstractItemView_scrollTo_0_dispatch(this->ada_object, &index, hint);
}

void QTableViewDirector::setModel(QAbstractItemModel* model)
{
    __Qt4Ada_QAbstractItemView_setModel_0_dispatch(this->ada_object, model);
}

QRect QTableViewDirector::visualRect(const QModelIndex& index) const
{
    QRect *aux = __Qt4Ada_QAbstractItemView_visualRect_0_dispatch(this->ada_object, &index);
    QRect returns = *aux;
    delete aux;
    return returns;
}

int QTableViewDirector::horizontalOffset() const
{
    return __Qt4Ada_QAbstractItemView_horizontalOffset_0_dispatch(this->ada_object);
}

void QTableViewDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

bool QTableViewDirector::isIndexHidden(const QModelIndex& index) const
{
    return __Qt4Ada_QAbstractItemView_isIndexHidden_0_dispatch(this->ada_object, &index);
}

void QTableViewDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

int QTableViewDirector::sizeHintForColumn(int column) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_dispatch(this->ada_object, column);
}

int QTableViewDirector::sizeHintForRow(int row) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForRow_0_dispatch(this->ada_object, row);
}

void QTableViewDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

int QTableViewDirector::verticalOffset() const
{
    return __Qt4Ada_QAbstractItemView_verticalOffset_0_dispatch(this->ada_object);
}

QRegion QTableViewDirector::visualRegionForSelection(const QItemSelection& selection) const
{
    QRegion *aux = __Qt4Ada_QAbstractItemView_visualRegionForSelection_0_dispatch(this->ada_object, &selection);
    QRegion returns = *aux;
    delete aux;
    return returns;
}

void QTableViewDirector::keyboardSearch(const QString& search)
{
    __Qt4Ada_QAbstractItemView_keyboardSearch_0_dispatch(this->ada_object, &search);
}

void QTableViewDirector::setSelectionModel(QItemSelectionModel* selectionModel)
{
    __Qt4Ada_QAbstractItemView_setSelectionModel_0_dispatch(this->ada_object, selectionModel);
}

void QTableViewDirector::reset()
{
    __Qt4Ada_QAbstractItemView_reset_0_dispatch(this->ada_object);
}

void QTableViewDirector::selectAll()
{
    __Qt4Ada_QAbstractItemView_selectAll_0_dispatch(this->ada_object);
}

void QTableViewDirector::setRootIndex(const QModelIndex& index)
{
    __Qt4Ada_QAbstractItemView_setRootIndex_0_dispatch(this->ada_object, &index);
}

QVariant QTableViewDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QTableViewDirector::commitData(QWidget* editor)
{
    __Qt4Ada_QAbstractItemView_commitData_0_dispatch(this->ada_object, editor);
}

void QTableViewDirector::currentChanged(const QModelIndex& current, const QModelIndex& previous)
{
    __Qt4Ada_QAbstractItemView_currentChanged_0_dispatch(this->ada_object, &current, &previous);
}

void QTableViewDirector::dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight)
{
    __Qt4Ada_QAbstractItemView_dataChanged_0_dispatch(this->ada_object, &topLeft, &bottomRight);
}

void QTableViewDirector::editorDestroyed(QObject* editor)
{
    __Qt4Ada_QAbstractItemView_editorDestroyed_0_dispatch(this->ada_object, editor);
}

void QTableViewDirector::rowsAboutToBeRemoved(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_dispatch(this->ada_object, &parent, start, stop);
}

void QTableViewDirector::rowsInserted(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsInserted_0_dispatch(this->ada_object, &parent, start, stop);
}

void QTableViewDirector::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected)
{
    __Qt4Ada_QAbstractItemView_selectionChanged_0_dispatch(this->ada_object, &selected, &deselected);
}

void QTableViewDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

bool QTableViewDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QTableViewDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QTableViewDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QTableViewDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

bool QTableViewDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

QSize QTableViewDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QTableViewDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QTableViewDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QTableViewDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QTableViewDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QTableViewDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QTableViewDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QTableViewDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QTableViewDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QTableViewDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QTableViewDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QTableViewDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QTableViewDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QTableViewDirector::QTableViewDirector(void* o, QWidget* parent) :
    QTableView (parent),
    ada_object (o)
{
}

extern "C" {

    QObject* __Qt4Ada_new_QTableView (QObject* parent)
    {
        return static_cast<QObject*>(new QTableView (dynamic_cast <QWidget*> (parent)));
    }

    QObject* __Qt4Ada_new_QTableViewDirector(void* ada_object, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QTableViewDirector(ada_object, dynamic_cast<QWidget*>(parent)));
    }

    void __Qt4Ada_QTableView_moveCursor_wrapper (QObject*cpp_object, unsigned action, unsigned modifiers,QModelIndex*index)
   {
      *index = dynamic_cast <QTableViewDirector*>(cpp_object) -> moveCursor ((QTableViewDirector::CursorAction) action, (Qt::KeyboardModifiers) modifiers);
   }

    void __Qt4Ada_QTableView_setSelection_wrapper (QObject*cpp_object, QRect*rect, unsigned flags)
    {
       dynamic_cast<QTableViewDirector*>(cpp_object) -> setSelection (*rect,  (QItemSelectionModel::SelectionFlags)flags);
    }

}
