//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QTABLEVIEWDIRECTOR_H__
#define __QTABLEVIEWDIRECTOR_H__

#include <QTableView>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QTableView_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern int __Qt4Ada_QTableView_columnAt_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTableView_columnSpan_0_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QTableView_columnViewportPosition_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTableView_columnWidth_0_wrapper(QObject*, int);
    extern QObject* __Qt4Ada_QTableView_horizontalHeader_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTableView_isColumnHidden_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QTableView_isCornerButtonEnabled_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTableView_isRowHidden_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QTableView_isSortingEnabled_0_wrapper(QObject*);
    extern int __Qt4Ada_QTableView_rowAt_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTableView_rowHeight_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTableView_rowSpan_0_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QTableView_rowViewportPosition_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableView_setColumnHidden_0_wrapper(QObject*, int, bool);
    extern void __Qt4Ada_QTableView_setColumnWidth_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableView_setCornerButtonEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTableView_setHorizontalHeader_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTableView_setRowHeight_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableView_setRowHidden_0_wrapper(QObject*, int, bool);
    extern void __Qt4Ada_QTableView_setSortingEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTableView_setSpan_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QTableView_setVerticalHeader_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTableView_setWordWrap_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QTableView_showGrid_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QTableView_verticalHeader_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTableView_wordWrap_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableView_hideColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableView_hideRow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableView_resizeColumnToContents_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableView_resizeColumnsToContents_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableView_resizeRowToContents_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableView_resizeRowsToContents_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableView_selectColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableView_selectRow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableView_setShowGrid_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTableView_showColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableView_showRow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableView_indexAt_0_wrapper(QObject*, const QPoint*, QModelIndex*);
    extern void __Qt4Ada_QTableView_scrollTo_0_wrapper(QObject*, const QModelIndex*, QAbstractItemView::ScrollHint);
    extern void __Qt4Ada_QTableView_setModel_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTableView_visualRect_0_wrapper(QObject*, const QModelIndex*, QRect*);
    extern int __Qt4Ada_QTableView_horizontalOffset_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableView_paintEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTableView_isIndexHidden_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableView_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QTableView_sizeHintForColumn_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTableView_sizeHintForRow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableView_timerEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QTableView_verticalOffset_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableView_visualRegionForSelection_0_wrapper(QObject*, const QItemSelection*, QRegion*);
    extern void __Qt4Ada_QTableView_activated_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableView_clicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableView_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableView_entered_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableView_pressed_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableView_viewportEntered_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableView_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    extern void __Qt4Ada_QTableView_executeDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableView_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableView_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableView_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    extern void __Qt4Ada_QTableView_commitData_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTableView_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QTableView_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QTableView_editorDestroyed_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTableView_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QTableView_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QTableView_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    extern void __Qt4Ada_QTableView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_dropEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTableView_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTableView_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTableView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTableView_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTableView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QTableView_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QTableView_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTableView_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTableView_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableView_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableView_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QTableView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QTableView_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableView_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QTableView_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QTableView_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QTableView_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
extern "C" {

    // constructors

    extern QObject* __Qt4Ada_new_QTableView (QObject*);
    extern QObject* __Qt4Ada_new_QTableViewDirector (void*, QObject*);

    extern void __Qt4Ada_QTableView_moveCursor_wrapper (QObject*, unsigned, unsigned,QModelIndex*);
    extern void __Qt4Ada_QTableView_setSelection_wrapper (QObject*, QRect*, unsigned);

}

class QTableViewDirector : public QTableView
{
protected:
    void* ada_object;
public:
    QTableViewDirector (void*, QWidget*);

protected:
    friend void __Qt4Ada_QTableView_moveCursor_wrapper (QObject*, unsigned, unsigned,QModelIndex*);
    friend void __Qt4Ada_QTableView_setSelection_wrapper (QObject*, QRect*, unsigned);

    virtual QModelIndex indexAt(const QPoint&) const;
    virtual void scrollTo(const QModelIndex&, QAbstractItemView::ScrollHint);
    virtual void setModel(QAbstractItemModel*);
    virtual QRect visualRect(const QModelIndex&) const;
    virtual int horizontalOffset() const;
    virtual void paintEvent(QPaintEvent*);
    virtual bool isIndexHidden(const QModelIndex&) const;
    virtual void scrollContentsBy(int, int);
    virtual int sizeHintForColumn(int) const;
    virtual int sizeHintForRow(int) const;
    virtual void timerEvent(QTimerEvent*);
    virtual int verticalOffset() const;
    virtual QRegion visualRegionForSelection(const QItemSelection&) const;
    virtual void keyboardSearch(const QString&);
    virtual void setSelectionModel(QItemSelectionModel*);
    virtual void reset();
    virtual void selectAll();
    virtual void setRootIndex(const QModelIndex&);
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void commitData(QWidget*);
    virtual void currentChanged(const QModelIndex&, const QModelIndex&);
    virtual void dataChanged(const QModelIndex&, const QModelIndex&);
    virtual void editorDestroyed(QObject*);
    virtual void rowsAboutToBeRemoved(const QModelIndex&, int, int);
    virtual void rowsInserted(const QModelIndex&, int, int);
    virtual void selectionChanged(const QItemSelection&, const QItemSelection&);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual bool event(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual bool viewportEvent(QEvent*);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void wheelEvent(QWheelEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend int __Qt4Ada_QTableView_horizontalOffset_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableView_paintEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTableView_isIndexHidden_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableView_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend int __Qt4Ada_QTableView_sizeHintForColumn_0_wrapper(QObject*, int);
    friend int __Qt4Ada_QTableView_sizeHintForRow_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QTableView_timerEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QTableView_verticalOffset_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableView_visualRegionForSelection_0_wrapper(QObject*, const QItemSelection*, QRegion*);
    friend void __Qt4Ada_QTableView_activated_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableView_clicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableView_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableView_entered_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableView_pressed_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableView_viewportEntered_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableView_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    friend void __Qt4Ada_QTableView_executeDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableView_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableView_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QTableView_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    friend void __Qt4Ada_QTableView_commitData_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QTableView_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QTableView_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QTableView_editorDestroyed_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QTableView_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QTableView_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QTableView_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    friend void __Qt4Ada_QTableView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_dropEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTableView_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTableView_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTableView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTableView_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QTableView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend void __Qt4Ada_QTableView_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QTableView_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTableView_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QTableView_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableView_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableView_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QTableView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QTableView_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableView_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QTableView_sender_0_wrapper(QObject*);
};

#endif // __QTABLEVIEWDIRECTOR_H__
