//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QPaintEvent>
#include <QModelIndex>
#include <QAbstractItemModel>
#include <QRect>
#include <QTimerEvent>
#include <QRegion>
#include <QItemSelectionModel>
#include <QVariant>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QResizeEvent>
#include <QSize>
#include <QWheelEvent>
#include <QContextMenuEvent>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qtablewidgetdirector.h"
#include "qtableviewdirector.h"
#include "qabstractitemviewdirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QTableWidget_staticMetaObject =
        &QTableWidget::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    QObject* __Qt4Ada_QTableWidget_cellWidget_0_wrapper(QObject* cpp_object, int row, int column)
    {
        return static_cast<QObject*>(dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::cellWidget(row, column));
    }

    int __Qt4Ada_QTableWidget_columnCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::columnCount();
    }

    int __Qt4Ada_QTableWidget_currentColumn_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::currentColumn();
    }

    int __Qt4Ada_QTableWidget_currentRow_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::currentRow();
    }

    void __Qt4Ada_QTableWidget_removeCellWidget_0_wrapper(QObject* cpp_object, int row, int column)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::removeCellWidget(row, column);
    }

    int __Qt4Ada_QTableWidget_rowCount_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::rowCount();
    }

    void __Qt4Ada_QTableWidget_setCellWidget_0_wrapper(QObject* cpp_object, int row, int column, QObject* widget)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::setCellWidget(row, column, dynamic_cast<QWidget*>(widget));
    }

    void __Qt4Ada_QTableWidget_setColumnCount_0_wrapper(QObject* cpp_object, int columns)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::setColumnCount(columns);
    }

    void __Qt4Ada_QTableWidget_setCurrentCell_0_wrapper(QObject* cpp_object, int row, int column)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::setCurrentCell(row, column);
    }

    void __Qt4Ada_QTableWidget_setRowCount_0_wrapper(QObject* cpp_object, int rows)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::setRowCount(rows);
    }

    void __Qt4Ada_QTableWidget_sortItems_0_wrapper(QObject* cpp_object, int column, Qt::SortOrder order)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::sortItems(column, order);
    }

    void __Qt4Ada_QTableWidget_visualColumn_0_wrapper(QObject* cpp_object, int logicalColumn)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::visualColumn(logicalColumn);
    }

    void __Qt4Ada_QTableWidget_visualRow_0_wrapper(QObject* cpp_object, int logicalRow)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::visualRow(logicalRow);
    }

    void __Qt4Ada_QTableWidget_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::clear();
    }

    void __Qt4Ada_QTableWidget_clearContents_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::clearContents();
    }

    void __Qt4Ada_QTableWidget_insertColumn_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::insertColumn(column);
    }

    void __Qt4Ada_QTableWidget_insertRow_0_wrapper(QObject* cpp_object, int row)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::insertRow(row);
    }

    void __Qt4Ada_QTableWidget_removeColumn_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::removeColumn(column);
    }

    void __Qt4Ada_QTableWidget_removeRow_0_wrapper(QObject* cpp_object, int row)
    {
        dynamic_cast<QTableWidget*>(cpp_object)->QTableWidget::removeRow(row);
    }

    void __Qt4Ada_QTableWidget_cellActivated_0_wrapper(QObject* cpp_object, int row, int column)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableWidget::cellActivated(row, column);
    }

    void __Qt4Ada_QTableWidget_cellChanged_0_wrapper(QObject* cpp_object, int row, int column)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableWidget::cellChanged(row, column);
    }

    void __Qt4Ada_QTableWidget_cellClicked_0_wrapper(QObject* cpp_object, int row, int column)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableWidget::cellClicked(row, column);
    }

    void __Qt4Ada_QTableWidget_cellDoubleClicked_0_wrapper(QObject* cpp_object, int row, int column)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableWidget::cellDoubleClicked(row, column);
    }

    void __Qt4Ada_QTableWidget_cellEntered_0_wrapper(QObject* cpp_object, int row, int column)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableWidget::cellEntered(row, column);
    }

    void __Qt4Ada_QTableWidget_cellPressed_0_wrapper(QObject* cpp_object, int row, int column)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableWidget::cellPressed(row, column);
    }

    void __Qt4Ada_QTableWidget_currentCellChanged_0_wrapper(QObject* cpp_object, int currentRow, int currentColumn, int previousRow, int previousColumn)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableWidget::currentCellChanged(currentRow, currentColumn, previousRow, previousColumn);
    }

    void __Qt4Ada_QTableWidget_itemSelectionChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableWidget::itemSelectionChanged();
    }

    bool __Qt4Ada_QTableWidget_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableWidget::event(e);
    }

    void __Qt4Ada_QTableWidget_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    int __Qt4Ada_QTableWidget_horizontalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableView::horizontalOffset();
    }

    bool __Qt4Ada_QTableWidget_isIndexHidden_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableView::isIndexHidden(*index);
    }

    void __Qt4Ada_QTableWidget_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableView::scrollContentsBy(dx, dy);
    }

    int __Qt4Ada_QTableWidget_sizeHintForColumn_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableView::sizeHintForColumn(column);
    }

    int __Qt4Ada_QTableWidget_sizeHintForRow_0_wrapper(QObject* cpp_object, int row)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableView::sizeHintForRow(row);
    }

    void __Qt4Ada_QTableWidget_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableView::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    int __Qt4Ada_QTableWidget_verticalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableView::verticalOffset();
    }

    void __Qt4Ada_QTableWidget_visualRegionForSelection_0_wrapper(QObject* cpp_object, const QItemSelection* selection, QRegion* returns)
    {
        *returns = dynamic_cast<QTableWidgetDirector*>(cpp_object)->QTableView::visualRegionForSelection(*selection);
    }

    void __Qt4Ada_QTableWidget_activated_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::activated(*index);
    }

    void __Qt4Ada_QTableWidget_clicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::clicked(*index);
    }

    void __Qt4Ada_QTableWidget_doubleClicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::doubleClicked(*index);
    }

    void __Qt4Ada_QTableWidget_entered_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::entered(*index);
    }

    void __Qt4Ada_QTableWidget_pressed_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::pressed(*index);
    }

    void __Qt4Ada_QTableWidget_viewportEntered_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::viewportEntered();
    }

    void __Qt4Ada_QTableWidget_dirtyRegionOffset_0_wrapper(QObject* cpp_object, QPoint* returns)
    {
        *returns = dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::dirtyRegionOffset();
    }

    void __Qt4Ada_QTableWidget_executeDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::executeDelayedItemsLayout();
    }

    void __Qt4Ada_QTableWidget_scheduleDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::scheduleDelayedItemsLayout();
    }

    void __Qt4Ada_QTableWidget_scrollDirtyRegion_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::scrollDirtyRegion(dx, dy);
    }

    void __Qt4Ada_QTableWidget_setDirtyRegion_0_wrapper(QObject* cpp_object, const QRegion* region)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::setDirtyRegion(*region);
    }

    void __Qt4Ada_QTableWidget_commitData_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::commitData(dynamic_cast<QWidget*>(editor));
    }

    void __Qt4Ada_QTableWidget_currentChanged_0_wrapper(QObject* cpp_object, const QModelIndex* current, const QModelIndex* previous)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::currentChanged(*current, *previous);
    }

    void __Qt4Ada_QTableWidget_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::dataChanged(*topLeft, *bottomRight);
    }

    void __Qt4Ada_QTableWidget_editorDestroyed_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::editorDestroyed(editor);
    }

    void __Qt4Ada_QTableWidget_rowsAboutToBeRemoved_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::rowsAboutToBeRemoved(*parent, start, stop);
    }

    void __Qt4Ada_QTableWidget_rowsInserted_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::rowsInserted(*parent, start, stop);
    }

    void __Qt4Ada_QTableWidget_selectionChanged_0_wrapper(QObject* cpp_object, const QItemSelection* selected, const QItemSelection* deselected)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::selectionChanged(*selected, *deselected);
    }

    void __Qt4Ada_QTableWidget_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QTableWidget_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::focusNextPrevChild(next);
    }

    void __Qt4Ada_QTableWidget_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    bool __Qt4Ada_QTableWidget_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractItemView::viewportEvent(event);
    }

    void __Qt4Ada_QTableWidget_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QTableWidget_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QTableWidget_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractScrollArea::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QAbstractScrollArea::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QTableWidget_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QTableWidget_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QTableWidget_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QTableWidget_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QTableWidget_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QTableWidget_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QTableWidget_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QTableWidget_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QTableWidget_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QTableWidget_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTableWidgetDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QTableWidget_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTableWidgetDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QTableWidget_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QTableWidget*>(cpp_this)->QTableWidget::qt_metacast(name);
    }

    int __Qt4Ada_QTableWidget_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QTableWidget*>(cpp_this)->QTableWidget::qt_metacall(_c, _id, _a);
    }

}

bool QTableWidgetDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QTableWidgetDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

QModelIndex QTableWidgetDirector::indexAt(const QPoint& point) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemView_indexAt_0_dispatch(this->ada_object, &point);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

void QTableWidgetDirector::scrollTo(const QModelIndex& index, QAbstractItemView::ScrollHint hint)
{
    __Qt4Ada_QAbstractItemView_scrollTo_0_dispatch(this->ada_object, &index, hint);
}

void QTableWidgetDirector::setModel(QAbstractItemModel* model)
{
    __Qt4Ada_QAbstractItemView_setModel_0_dispatch(this->ada_object, model);
}

QRect QTableWidgetDirector::visualRect(const QModelIndex& index) const
{
    QRect *aux = __Qt4Ada_QAbstractItemView_visualRect_0_dispatch(this->ada_object, &index);
    QRect returns = *aux;
    delete aux;
    return returns;
}

int QTableWidgetDirector::horizontalOffset() const
{
    return __Qt4Ada_QAbstractItemView_horizontalOffset_0_dispatch(this->ada_object);
}

bool QTableWidgetDirector::isIndexHidden(const QModelIndex& index) const
{
    return __Qt4Ada_QAbstractItemView_isIndexHidden_0_dispatch(this->ada_object, &index);
}

void QTableWidgetDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

int QTableWidgetDirector::sizeHintForColumn(int column) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_dispatch(this->ada_object, column);
}

int QTableWidgetDirector::sizeHintForRow(int row) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForRow_0_dispatch(this->ada_object, row);
}

void QTableWidgetDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

int QTableWidgetDirector::verticalOffset() const
{
    return __Qt4Ada_QAbstractItemView_verticalOffset_0_dispatch(this->ada_object);
}

QRegion QTableWidgetDirector::visualRegionForSelection(const QItemSelection& selection) const
{
    QRegion *aux = __Qt4Ada_QAbstractItemView_visualRegionForSelection_0_dispatch(this->ada_object, &selection);
    QRegion returns = *aux;
    delete aux;
    return returns;
}

void QTableWidgetDirector::keyboardSearch(const QString& search)
{
    __Qt4Ada_QAbstractItemView_keyboardSearch_0_dispatch(this->ada_object, &search);
}

void QTableWidgetDirector::setSelectionModel(QItemSelectionModel* selectionModel)
{
    __Qt4Ada_QAbstractItemView_setSelectionModel_0_dispatch(this->ada_object, selectionModel);
}

void QTableWidgetDirector::reset()
{
    __Qt4Ada_QAbstractItemView_reset_0_dispatch(this->ada_object);
}

void QTableWidgetDirector::selectAll()
{
    __Qt4Ada_QAbstractItemView_selectAll_0_dispatch(this->ada_object);
}

void QTableWidgetDirector::setRootIndex(const QModelIndex& index)
{
    __Qt4Ada_QAbstractItemView_setRootIndex_0_dispatch(this->ada_object, &index);
}

QVariant QTableWidgetDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QTableWidgetDirector::commitData(QWidget* editor)
{
    __Qt4Ada_QAbstractItemView_commitData_0_dispatch(this->ada_object, editor);
}

void QTableWidgetDirector::currentChanged(const QModelIndex& current, const QModelIndex& previous)
{
    __Qt4Ada_QAbstractItemView_currentChanged_0_dispatch(this->ada_object, &current, &previous);
}

void QTableWidgetDirector::dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight)
{
    __Qt4Ada_QAbstractItemView_dataChanged_0_dispatch(this->ada_object, &topLeft, &bottomRight);
}

void QTableWidgetDirector::editorDestroyed(QObject* editor)
{
    __Qt4Ada_QAbstractItemView_editorDestroyed_0_dispatch(this->ada_object, editor);
}

void QTableWidgetDirector::rowsAboutToBeRemoved(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_dispatch(this->ada_object, &parent, start, stop);
}

void QTableWidgetDirector::rowsInserted(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsInserted_0_dispatch(this->ada_object, &parent, start, stop);
}

void QTableWidgetDirector::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected)
{
    __Qt4Ada_QAbstractItemView_selectionChanged_0_dispatch(this->ada_object, &selected, &deselected);
}

void QTableWidgetDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QTableWidgetDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QTableWidgetDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

bool QTableWidgetDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

QSize QTableWidgetDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QTableWidgetDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QTableWidgetDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QTableWidgetDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QTableWidgetDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QTableWidgetDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QTableWidgetDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QTableWidgetDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QTableWidgetDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QTableWidgetDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QTableWidgetDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QTableWidgetDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QTableWidgetDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
extern "C" {
    extern QObject* __Qt4Ada_new_QTableWidget (QObject* parent) 
    {
        return dynamic_cast<QObject*>(new QTableWidget (dynamic_cast<QWidget*>(parent))); 
    }
    extern QObject* __Qt4Ada_new_QTableWidget_int_int (int rows, int columns, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QTableWidget (rows, columns, dynamic_cast<QWidget*>(parent)));
    }
}
