//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QTABLEWIDGETDIRECTOR_H__
#define __QTABLEWIDGETDIRECTOR_H__

#include <QTableWidget>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QTableWidget_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern QObject* __Qt4Ada_QTableWidget_cellWidget_0_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QTableWidget_columnCount_0_wrapper(QObject*);
    extern int __Qt4Ada_QTableWidget_currentColumn_0_wrapper(QObject*);
    extern int __Qt4Ada_QTableWidget_currentRow_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableWidget_removeCellWidget_0_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QTableWidget_rowCount_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableWidget_setCellWidget_0_wrapper(QObject*, int, int, QObject*);
    extern void __Qt4Ada_QTableWidget_setColumnCount_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableWidget_setCurrentCell_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableWidget_setRowCount_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableWidget_sortItems_0_wrapper(QObject*, int, Qt::SortOrder);
    extern void __Qt4Ada_QTableWidget_visualColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableWidget_visualRow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableWidget_clear_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableWidget_clearContents_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableWidget_insertColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableWidget_insertRow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableWidget_removeColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableWidget_removeRow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableWidget_cellActivated_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableWidget_cellChanged_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableWidget_cellClicked_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableWidget_cellDoubleClicked_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableWidget_cellEntered_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableWidget_cellPressed_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableWidget_currentCellChanged_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QTableWidget_itemSelectionChanged_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTableWidget_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_paintEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QTableWidget_horizontalOffset_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTableWidget_isIndexHidden_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableWidget_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QTableWidget_sizeHintForColumn_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTableWidget_sizeHintForRow_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTableWidget_timerEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QTableWidget_verticalOffset_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableWidget_visualRegionForSelection_0_wrapper(QObject*, const QItemSelection*, QRegion*);
    extern void __Qt4Ada_QTableWidget_activated_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableWidget_clicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableWidget_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableWidget_entered_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableWidget_pressed_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTableWidget_viewportEntered_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableWidget_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    extern void __Qt4Ada_QTableWidget_executeDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableWidget_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableWidget_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTableWidget_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    extern void __Qt4Ada_QTableWidget_commitData_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTableWidget_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QTableWidget_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QTableWidget_editorDestroyed_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTableWidget_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QTableWidget_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QTableWidget_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    extern void __Qt4Ada_QTableWidget_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTableWidget_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTableWidget_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTableWidget_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTableWidget_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QTableWidget_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QTableWidget_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTableWidget_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTableWidget_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableWidget_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QTableWidget_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QTableWidget_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QTableWidget_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTableWidget_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QTableWidget_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QTableWidget_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QTableWidget_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
extern "C" {

// Constructors
    extern QObject* __Qt4Ada_new_QTableWidget (QObject*);
    extern QObject* __Qt4Ada_new_QTableWidget_int_int (int, int, QObject*);
}

class QTableWidgetDirector : public QTableWidget
{
protected:
    void* ada_object;
   QTableWidgetDirector();

    virtual bool event(QEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual QModelIndex indexAt(const QPoint&) const;
    virtual void scrollTo(const QModelIndex&, QAbstractItemView::ScrollHint);
    virtual void setModel(QAbstractItemModel*);
    virtual QRect visualRect(const QModelIndex&) const;
    virtual int horizontalOffset() const;
    virtual bool isIndexHidden(const QModelIndex&) const;
    virtual void scrollContentsBy(int, int);
    virtual int sizeHintForColumn(int) const;
    virtual int sizeHintForRow(int) const;
    virtual void timerEvent(QTimerEvent*);
    virtual int verticalOffset() const;
    virtual QRegion visualRegionForSelection(const QItemSelection&) const;
    virtual void keyboardSearch(const QString&);
    virtual void setSelectionModel(QItemSelectionModel*);
    virtual void reset();
    virtual void selectAll();
    virtual void setRootIndex(const QModelIndex&);
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void commitData(QWidget*);
    virtual void currentChanged(const QModelIndex&, const QModelIndex&);
    virtual void dataChanged(const QModelIndex&, const QModelIndex&);
    virtual void editorDestroyed(QObject*);
    virtual void rowsAboutToBeRemoved(const QModelIndex&, int, int);
    virtual void rowsInserted(const QModelIndex&, int, int);
    virtual void selectionChanged(const QItemSelection&, const QItemSelection&);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual bool viewportEvent(QEvent*);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void wheelEvent(QWheelEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QTableWidget_cellActivated_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QTableWidget_cellChanged_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QTableWidget_cellClicked_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QTableWidget_cellDoubleClicked_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QTableWidget_cellEntered_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QTableWidget_cellPressed_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QTableWidget_currentCellChanged_0_wrapper(QObject*, int, int, int, int);
    friend void __Qt4Ada_QTableWidget_itemSelectionChanged_0_wrapper(QObject*);
    friend bool __Qt4Ada_QTableWidget_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_paintEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QTableWidget_horizontalOffset_0_wrapper(QObject*);
    friend bool __Qt4Ada_QTableWidget_isIndexHidden_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableWidget_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend int __Qt4Ada_QTableWidget_sizeHintForColumn_0_wrapper(QObject*, int);
    friend int __Qt4Ada_QTableWidget_sizeHintForRow_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QTableWidget_timerEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QTableWidget_verticalOffset_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableWidget_visualRegionForSelection_0_wrapper(QObject*, const QItemSelection*, QRegion*);
    friend void __Qt4Ada_QTableWidget_activated_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableWidget_clicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableWidget_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableWidget_entered_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableWidget_pressed_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTableWidget_viewportEntered_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableWidget_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    friend void __Qt4Ada_QTableWidget_executeDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableWidget_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableWidget_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QTableWidget_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    friend void __Qt4Ada_QTableWidget_commitData_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QTableWidget_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QTableWidget_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QTableWidget_editorDestroyed_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QTableWidget_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QTableWidget_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QTableWidget_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    friend void __Qt4Ada_QTableWidget_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTableWidget_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTableWidget_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTableWidget_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QTableWidget_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend void __Qt4Ada_QTableWidget_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QTableWidget_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTableWidget_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QTableWidget_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableWidget_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QTableWidget_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QTableWidget_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QTableWidget_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTableWidget_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QTableWidget_sender_0_wrapper(QObject*);
};

#endif // __QTABLEWIDGETDIRECTOR_H__
