//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include "qtextblockformatwrapper.h"

extern "C"
{

    QTextFormat* __QtAda_inititialize_QTextBlockFormat(void* storage)
    {
        return new (storage) QTextBlockFormat();
    }

    QTextFormat* __QtAda_adjust_QTextBlockFormat(void* storage, const QTextFormat* from)
    {
        return new (storage) QTextBlockFormat(*static_cast<const QTextBlockFormat*>(from));
    }

    void __QtAda_finalize_QTextBlockFormat(QTextFormat *item)
    {
        static_cast<const QTextBlockFormat*>(item)->~QTextBlockFormat();
    }

    double __QtAda_QTextBlockFormat_bottomMargin_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextBlockFormat*>(self)->bottomMargin();
    }

    int __QtAda_QTextBlockFormat_indent_Q(const QTextFormat* self)
    {
        return static_cast<const QTextBlockFormat*>(self)->indent();
    }

    unsigned __QtAda_QTextBlockFormat_isValid_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextBlockFormat*>(self)->isValid();
    }

    double __QtAda_QTextBlockFormat_leftMargin_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextBlockFormat*>(self)->leftMargin();
    }

    unsigned __QtAda_QTextBlockFormat_nonBreakableLines_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextBlockFormat*>(self)->nonBreakableLines();
    }

    double __QtAda_QTextBlockFormat_rightMargin_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextBlockFormat*>(self)->rightMargin();
    }

    void __QtAda_QTextBlockFormat_setBottomMargin_qreal(QTextFormat* self, double margin)
    {
        static_cast<QTextBlockFormat*>(self)->setBottomMargin((qreal)margin);
    }

    void __QtAda_QTextBlockFormat_setIndent_int(QTextFormat* self, int indent)
    {
        static_cast<QTextBlockFormat*>(self)->setIndent(indent);
    }

    void __QtAda_QTextBlockFormat_setLeftMargin_qreal(QTextFormat* self, double margin)
    {
        static_cast<QTextBlockFormat*>(self)->setLeftMargin((qreal)margin);
    }

    void __QtAda_QTextBlockFormat_setNonBreakableLines_bool(QTextFormat* self, unsigned b)
    {
        static_cast<QTextBlockFormat*>(self)->setNonBreakableLines((bool)b);
    }

    void __QtAda_QTextBlockFormat_setRightMargin_qreal(QTextFormat* self, double margin)
    {
        static_cast<QTextBlockFormat*>(self)->setRightMargin((qreal)margin);
    }

    void __QtAda_QTextBlockFormat_setTextIndent_qreal(QTextFormat* self, double indent)
    {
        static_cast<QTextBlockFormat*>(self)->setTextIndent((qreal)indent);
    }

    void __QtAda_QTextBlockFormat_setTopMargin_qreal(QTextFormat* self, double margin)
    {
        static_cast<QTextBlockFormat*>(self)->setTopMargin((qreal)margin);
    }

    double __QtAda_QTextBlockFormat_textIndent_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextBlockFormat*>(self)->textIndent();
    }

    double __QtAda_QTextBlockFormat_topMargin_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextBlockFormat*>(self)->topMargin();
    }

};

