//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QBrush>
#include <QColor>
#include <QPen>
#include <QString>
#include <QTextBlockFormat>
#include <QTextCharFormat>
#include <QTextFrameFormat>
#include <QTextImageFormat>
#include <QTextLength>
#include <QTextListFormat>
#include <QTextTableCellFormat>
#include <QTextTableFormat>
#include <QVariant>
#include "qtextformatwrapper.h"

extern "C"
{

    QTextFormat* __QtAda_inititialize_QTextFormat(void* storage)
    {
        return new (storage) QTextFormat();
    }

    QTextFormat* __QtAda_adjust_QTextFormat(void* storage, const QTextFormat* from)
    {
        return new (storage) QTextFormat(*from);
    }

    void __QtAda_finalize_QTextFormat(QTextFormat *item)
    {
        item->~QTextFormat();
    }

    void __QtAda_QTextFormat_background_Q(QBrush* returns, const QTextFormat* self)
    {
        *returns = self->background();
    }

    unsigned __QtAda_QTextFormat_boolProperty_int_Q(const QTextFormat* self, int propertyId)
    {
        return (unsigned)self->boolProperty(propertyId);
    }

    void __QtAda_QTextFormat_brushProperty_int_Q(QBrush* returns, const QTextFormat* self, int propertyId)
    {
        *returns = self->brushProperty(propertyId);
    }

    void __QtAda_QTextFormat_clearBackground(QTextFormat* self)
    {
        self->clearBackground();
    }

    void __QtAda_QTextFormat_clearForeground(QTextFormat* self)
    {
        self->clearForeground();
    }

    void __QtAda_QTextFormat_clearProperty_int(QTextFormat* self, int propertyId)
    {
        self->clearProperty(propertyId);
    }

    void __QtAda_QTextFormat_colorProperty_int_Q(QColor* returns, const QTextFormat* self, int propertyId)
    {
        *returns = self->colorProperty(propertyId);
    }

    double __QtAda_QTextFormat_doubleProperty_int_Q(const QTextFormat* self, int propertyId)
    {
        return (double)self->doubleProperty(propertyId);
    }

    void __QtAda_QTextFormat_foreground_Q(QBrush* returns, const QTextFormat* self)
    {
        *returns = self->foreground();
    }

    int __QtAda_QTextFormat_intProperty_int_Q(const QTextFormat* self, int propertyId)
    {
        return self->intProperty(propertyId);
    }

    unsigned __QtAda_QTextFormat_isBlockFormat_Q(const QTextFormat* self)
    {
        return (unsigned)self->isBlockFormat();
    }

    unsigned __QtAda_QTextFormat_isCharFormat_Q(const QTextFormat* self)
    {
        return (unsigned)self->isCharFormat();
    }

    unsigned __QtAda_QTextFormat_isFrameFormat_Q(const QTextFormat* self)
    {
        return (unsigned)self->isFrameFormat();
    }

    unsigned __QtAda_QTextFormat_isImageFormat_Q(const QTextFormat* self)
    {
        return (unsigned)self->isImageFormat();
    }

    unsigned __QtAda_QTextFormat_isListFormat_Q(const QTextFormat* self)
    {
        return (unsigned)self->isListFormat();
    }

    unsigned __QtAda_QTextFormat_isTableCellFormat_Q(const QTextFormat* self)
    {
        return (unsigned)self->isTableCellFormat();
    }

    unsigned __QtAda_QTextFormat_isTableFormat_Q(const QTextFormat* self)
    {
        return (unsigned)self->isTableFormat();
    }

    unsigned __QtAda_QTextFormat_isValid_Q(const QTextFormat* self)
    {
        return (unsigned)self->isValid();
    }

    unsigned __QtAda_QTextFormat_layoutDirection_Q(const QTextFormat* self)
    {
        return (unsigned)self->layoutDirection();
    }

    void __QtAda_QTextFormat_lengthProperty_int_Q(QTextLength* returns, const QTextFormat* self, int propertyId)
    {
        *returns = self->lengthProperty(propertyId);
    }

    void __QtAda_QTextFormat_merge_QTextFormatCR(QTextFormat* self, const QTextFormat* other)
    {
        self->merge(*other);
    }

    int __QtAda_QTextFormat_objectIndex_Q(const QTextFormat* self)
    {
        return self->objectIndex();
    }

    int __QtAda_QTextFormat_objectType_Q(const QTextFormat* self)
    {
        return self->objectType();
    }

    void __QtAda_QTextFormat_penProperty_int_Q(QPen* returns, const QTextFormat* self, int propertyId)
    {
        *returns = self->penProperty(propertyId);
    }

    void __QtAda_QTextFormat_property_int_Q(QVariant* returns, const QTextFormat* self, int propertyId)
    {
        *returns = self->property(propertyId);
    }

    int __QtAda_QTextFormat_propertyCount_Q(const QTextFormat* self)
    {
        return self->propertyCount();
    }

    void __QtAda_QTextFormat_setBackground_QBrushCR(QTextFormat* self, const QBrush* brush)
    {
        self->setBackground(*brush);
    }

    void __QtAda_QTextFormat_setForeground_QBrushCR(QTextFormat* self, const QBrush* brush)
    {
        self->setForeground(*brush);
    }

    void __QtAda_QTextFormat_setLayoutDirection_LayoutDirection(QTextFormat* self, unsigned direction)
    {
        self->setLayoutDirection((Qt::LayoutDirection)direction);
    }

    void __QtAda_QTextFormat_setObjectIndex_int(QTextFormat* self, int object)
    {
        self->setObjectIndex(object);
    }

    void __QtAda_QTextFormat_setObjectType_int(QTextFormat* self, int type)
    {
        self->setObjectType(type);
    }

    void __QtAda_QTextFormat_setProperty_int_QVariantCR(QTextFormat* self, int propertyId, const QVariant* value)
    {
        self->setProperty(propertyId, *value);
    }

    void __QtAda_QTextFormat_stringProperty_int_Q(QString* returns, const QTextFormat* self, int propertyId)
    {
        *returns = self->stringProperty(propertyId);
    }

    void __QtAda_QTextFormat_toBlockFormat_Q(QTextFormat* returns, const QTextFormat* self)
    {
        *static_cast<QTextBlockFormat*>(returns) = self->toBlockFormat();
    }

    void __QtAda_QTextFormat_toCharFormat_Q(QTextFormat* returns, const QTextFormat* self)
    {
        *static_cast<QTextCharFormat*>(returns) = self->toCharFormat();
    }

    void __QtAda_QTextFormat_toFrameFormat_Q(QTextFormat* returns, const QTextFormat* self)
    {
        *static_cast<QTextFrameFormat*>(returns) = self->toFrameFormat();
    }

    void __QtAda_QTextFormat_toImageFormat_Q(QTextFormat* returns, const QTextFormat* self)
    {
        *static_cast<QTextImageFormat*>(returns) = self->toImageFormat();
    }

    void __QtAda_QTextFormat_toListFormat_Q(QTextFormat* returns, const QTextFormat* self)
    {
        *static_cast<QTextListFormat*>(returns) = self->toListFormat();
    }

    void __QtAda_QTextFormat_toTableCellFormat_Q(QTextFormat* returns, const QTextFormat* self)
    {
        *static_cast<QTextTableCellFormat*>(returns) = self->toTableCellFormat();
    }

    void __QtAda_QTextFormat_toTableFormat_Q(QTextFormat* returns, const QTextFormat* self)
    {
        *static_cast<QTextTableFormat*>(returns) = self->toTableFormat();
    }

    int __QtAda_QTextFormat_type_Q(const QTextFormat* self)
    {
        return self->type();
    }

    unsigned __QtAda_QTextFormat_eq_QTextFormatCR_Q(const QTextFormat* self, const QTextFormat* other)
    {
        return (unsigned)self->operator==(*other);
    }

};

