//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QTextFormat>

extern "C"
{
    extern QTextFormat* __QtAda_inititialize_QTextFormat(void*);
    extern QTextFormat* __QtAda_adjust_QTextFormat(void*, const QTextFormat*);
    extern void __QtAda_finalize_QTextFormat(QTextFormat*);

    extern void __QtAda_QTextFormat_background_Q(QBrush*, const QTextFormat*);
    extern unsigned __QtAda_QTextFormat_boolProperty_int_Q(const QTextFormat*, int);
    extern void __QtAda_QTextFormat_brushProperty_int_Q(QBrush*, const QTextFormat*, int);
    extern void __QtAda_QTextFormat_clearBackground(QTextFormat*);
    extern void __QtAda_QTextFormat_clearForeground(QTextFormat*);
    extern void __QtAda_QTextFormat_clearProperty_int(QTextFormat*, int);
    extern void __QtAda_QTextFormat_colorProperty_int_Q(QColor*, const QTextFormat*, int);
    extern double __QtAda_QTextFormat_doubleProperty_int_Q(const QTextFormat*, int);
    extern void __QtAda_QTextFormat_foreground_Q(QBrush*, const QTextFormat*);
    extern int __QtAda_QTextFormat_intProperty_int_Q(const QTextFormat*, int);
    extern unsigned __QtAda_QTextFormat_isBlockFormat_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextFormat_isCharFormat_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextFormat_isFrameFormat_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextFormat_isImageFormat_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextFormat_isListFormat_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextFormat_isTableCellFormat_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextFormat_isTableFormat_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextFormat_isValid_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextFormat_layoutDirection_Q(const QTextFormat*);
    extern void __QtAda_QTextFormat_lengthProperty_int_Q(QTextLength*, const QTextFormat*, int);
    extern void __QtAda_QTextFormat_merge_QTextFormatCR(QTextFormat*, const QTextFormat*);
    extern int __QtAda_QTextFormat_objectIndex_Q(const QTextFormat*);
    extern int __QtAda_QTextFormat_objectType_Q(const QTextFormat*);
    extern void __QtAda_QTextFormat_penProperty_int_Q(QPen*, const QTextFormat*, int);
    extern void __QtAda_QTextFormat_property_int_Q(QVariant*, const QTextFormat*, int);
    extern int __QtAda_QTextFormat_propertyCount_Q(const QTextFormat*);
    extern void __QtAda_QTextFormat_setBackground_QBrushCR(QTextFormat*, const QBrush*);
    extern void __QtAda_QTextFormat_setForeground_QBrushCR(QTextFormat*, const QBrush*);
    extern void __QtAda_QTextFormat_setLayoutDirection_LayoutDirection(QTextFormat*, unsigned);
    extern void __QtAda_QTextFormat_setObjectIndex_int(QTextFormat*, int);
    extern void __QtAda_QTextFormat_setObjectType_int(QTextFormat*, int);
    extern void __QtAda_QTextFormat_setProperty_int_QVariantCR(QTextFormat*, int, const QVariant*);
    extern void __QtAda_QTextFormat_stringProperty_int_Q(QString*, const QTextFormat*, int);
    extern void __QtAda_QTextFormat_toBlockFormat_Q(QTextFormat*, const QTextFormat*);
    extern void __QtAda_QTextFormat_toCharFormat_Q(QTextFormat*, const QTextFormat*);
    extern void __QtAda_QTextFormat_toFrameFormat_Q(QTextFormat*, const QTextFormat*);
    extern void __QtAda_QTextFormat_toImageFormat_Q(QTextFormat*, const QTextFormat*);
    extern void __QtAda_QTextFormat_toListFormat_Q(QTextFormat*, const QTextFormat*);
    extern void __QtAda_QTextFormat_toTableCellFormat_Q(QTextFormat*, const QTextFormat*);
    extern void __QtAda_QTextFormat_toTableFormat_Q(QTextFormat*, const QTextFormat*);
    extern int __QtAda_QTextFormat_type_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextFormat_eq_QTextFormatCR_Q(const QTextFormat*, const QTextFormat*);

};

