//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QTextFrameFormat>

extern "C"
{
    extern QTextFormat* __QtAda_inititialize_QTextFrameFormat(void*);
    extern QTextFormat* __QtAda_adjust_QTextFrameFormat(void*, const QTextFormat*);
    extern void __QtAda_finalize_QTextFrameFormat(QTextFormat*);

    extern double __QtAda_QTextFrameFormat_border_Q(const QTextFormat*);
    extern void __QtAda_QTextFrameFormat_borderBrush_Q(QBrush*, const QTextFormat*);
    extern unsigned __QtAda_QTextFrameFormat_borderStyle_Q(const QTextFormat*);
    extern double __QtAda_QTextFrameFormat_bottomMargin_Q(const QTextFormat*);
    extern void __QtAda_QTextFrameFormat_height_Q(QTextLength*, const QTextFormat*);
    extern unsigned __QtAda_QTextFrameFormat_isValid_Q(const QTextFormat*);
    extern double __QtAda_QTextFrameFormat_leftMargin_Q(const QTextFormat*);
    extern double __QtAda_QTextFrameFormat_margin_Q(const QTextFormat*);
    extern double __QtAda_QTextFrameFormat_padding_Q(const QTextFormat*);
    extern unsigned __QtAda_QTextFrameFormat_position_Q(const QTextFormat*);
    extern double __QtAda_QTextFrameFormat_rightMargin_Q(const QTextFormat*);
    extern void __QtAda_QTextFrameFormat_setBorder_qreal(QTextFormat*, double);
    extern void __QtAda_QTextFrameFormat_setBorderBrush_QBrushCR(QTextFormat*, const QBrush*);
    extern void __QtAda_QTextFrameFormat_setBorderStyle_BorderStyle(QTextFormat*, unsigned);
    extern void __QtAda_QTextFrameFormat_setBottomMargin_qreal(QTextFormat*, double);
    extern void __QtAda_QTextFrameFormat_setHeight_QTextLengthCR(QTextFormat*, const QTextLength*);
    extern void __QtAda_QTextFrameFormat_setHeight_qreal(QTextFormat*, double);
    extern void __QtAda_QTextFrameFormat_setLeftMargin_qreal(QTextFormat*, double);
    extern void __QtAda_QTextFrameFormat_setMargin_qreal(QTextFormat*, double);
    extern void __QtAda_QTextFrameFormat_setPadding_qreal(QTextFormat*, double);
    extern void __QtAda_QTextFrameFormat_setPosition_Position(QTextFormat*, unsigned);
    extern void __QtAda_QTextFrameFormat_setRightMargin_qreal(QTextFormat*, double);
    extern void __QtAda_QTextFrameFormat_setTopMargin_qreal(QTextFormat*, double);
    extern void __QtAda_QTextFrameFormat_setWidth_QTextLengthCR(QTextFormat*, const QTextLength*);
    extern void __QtAda_QTextFrameFormat_setWidth_qreal(QTextFormat*, double);
    extern double __QtAda_QTextFrameFormat_topMargin_Q(const QTextFormat*);
    extern void __QtAda_QTextFrameFormat_width_Q(QTextLength*, const QTextFormat*);

};

