//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include "qtextimageformatwrapper.h"

extern "C"
{

    QTextFormat* __QtAda_inititialize_QTextImageFormat(void* storage)
    {
        return new (storage) QTextImageFormat();
    }

    QTextFormat* __QtAda_adjust_QTextImageFormat(void* storage, const QTextFormat* from)
    {
        return new (storage) QTextImageFormat(*static_cast<const QTextImageFormat*>(from));
    }

    void __QtAda_finalize_QTextImageFormat(QTextFormat *item)
    {
        static_cast<const QTextImageFormat*>(item)->~QTextImageFormat();
    }

    double __QtAda_QTextImageFormat_height_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextImageFormat*>(self)->height();
    }

    unsigned __QtAda_QTextImageFormat_isValid_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextImageFormat*>(self)->isValid();
    }

    void __QtAda_QTextImageFormat_name_Q(QString* returns, const QTextFormat* self)
    {
        *returns = static_cast<const QTextImageFormat*>(self)->name();
    }

    void __QtAda_QTextImageFormat_setHeight_qreal(QTextFormat* self, double height)
    {
        static_cast<QTextImageFormat*>(self)->setHeight((qreal)height);
    }

    void __QtAda_QTextImageFormat_setName_QStringCR(QTextFormat* self, const QString* height)
    {
        static_cast<QTextImageFormat*>(self)->setName(*height);
    }

    void __QtAda_QTextImageFormat_setWidth_qreal(QTextFormat* self, double width)
    {
        static_cast<QTextImageFormat*>(self)->setWidth((qreal)width);
    }

    double __QtAda_QTextImageFormat_width_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextImageFormat*>(self)->width();
    }

};

