//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include "qtextlengthwrapper.h"

extern "C"
{

    QTextLength* __QtAda_inititialize_QTextLength(void* storage)
    {
        return new (storage) QTextLength();
    }

    QTextLength* __QtAda_inititialize_QTextLength_Type_qreal(void* storage, unsigned type, double value)
    {
        return new (storage) QTextLength((QTextLength::Type)type, (qreal)value);
    }

    QTextLength* __QtAda_adjust_QTextLength(void* storage, const QTextLength* from)
    {
        return new (storage) QTextLength(*from);
    }

    void __QtAda_finalize_QTextLength(QTextLength *item)
    {
        item->~QTextLength();
    }

    double __QtAda_QTextLength_rawValue_Q(const QTextLength* self)
    {
        return (double)self->rawValue();
    }

    unsigned __QtAda_QTextLength_type_Q(const QTextLength* self)
    {
        return (unsigned)self->type();
    }

    double __QtAda_QTextLength_value_qreal_Q(const QTextLength* self, double maximumLength)
    {
        return (double)self->value((qreal)maximumLength);
    }

    unsigned __QtAda_QTextLength_eq_QTextLengthCR_Q(const QTextLength* self, const QTextLength* other)
    {
        return (unsigned)self->operator==(*other);
    }

};

