//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include "qtexttableformatwrapper.h"

extern "C"
{

    QTextFormat* __QtAda_inititialize_QTextTableFormat(void* storage)
    {
        return new (storage) QTextTableFormat();
    }

    QTextFormat* __QtAda_adjust_QTextTableFormat(void* storage, const QTextFormat* from)
    {
        return new (storage) QTextTableFormat(*static_cast<const QTextTableFormat*>(from));
    }

    void __QtAda_finalize_QTextTableFormat(QTextFormat *item)
    {
        static_cast<const QTextTableFormat*>(item)->~QTextTableFormat();
    }

    double __QtAda_QTextTableFormat_cellPadding_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextTableFormat*>(self)->cellPadding();
    }

    double __QtAda_QTextTableFormat_cellSpacing_Q(const QTextFormat* self)
    {
        return (double)static_cast<const QTextTableFormat*>(self)->cellSpacing();
    }

    void __QtAda_QTextTableFormat_clearColumnWidthConstraints(QTextFormat* self)
    {
        static_cast<QTextTableFormat*>(self)->clearColumnWidthConstraints();
    }

    int __QtAda_QTextTableFormat_columns_Q(const QTextFormat* self)
    {
        return static_cast<const QTextTableFormat*>(self)->columns();
    }

    int __QtAda_QTextTableFormat_headerRowCount_Q(const QTextFormat* self)
    {
        return static_cast<const QTextTableFormat*>(self)->headerRowCount();
    }

    unsigned __QtAda_QTextTableFormat_isValid_Q(const QTextFormat* self)
    {
        return (unsigned)static_cast<const QTextTableFormat*>(self)->isValid();
    }

    void __Qt4Ada_QTextTableFormat_setAlignment_wrapper(QTextFormat* self, unsigned alignment)
    {
         static_cast<QTextTableFormat*>(self)->setAlignment((Qt::Alignment)alignment);
    }

    void __QtAda_QTextTableFormat_setCellPadding_qreal(QTextFormat* self, double padding)
    {
        static_cast<QTextTableFormat*>(self)->setCellPadding((qreal)padding);
    }

    void __QtAda_QTextTableFormat_setCellSpacing_qreal(QTextFormat* self, double spacing)
    {
        static_cast<QTextTableFormat*>(self)->setCellSpacing((qreal)spacing);
    }

    void __QtAda_QTextTableFormat_setColumns_int(QTextFormat* self, int columns)
    {
        static_cast<QTextTableFormat*>(self)->setColumns(columns);
    }

    void __QtAda_QTextTableFormat_setHeaderRowCount_int(QTextFormat* self, int count)
    {
        static_cast<QTextTableFormat*>(self)->setHeaderRowCount(count);
    }

};

