//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QSize>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTimerEvent>
#include <QWheelEvent>
#include <QVariant>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qtimeeditdirector.h"
#include "qdatetimeeditdirector.h"
#include "qabstractspinboxdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QTimeEdit_staticMetaObject =
        &QTimeEdit::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QTimeEdit_dateChanged_0_wrapper(QObject* cpp_object, const QDate* date)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QDateTimeEdit::dateChanged(*date);
    }

    void __Qt4Ada_QTimeEdit_dateTimeChanged_0_wrapper(QObject* cpp_object, const QDateTime* dateTime)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QDateTimeEdit::dateTimeChanged(*dateTime);
    }

    void __Qt4Ada_QTimeEdit_timeChanged_0_wrapper(QObject* cpp_object, const QTime* time)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QDateTimeEdit::timeChanged(*time);
    }

    QObject* __Qt4Ada_QTimeEdit_lineEdit_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::lineEdit());
    }

    void __Qt4Ada_QTimeEdit_setLineEdit_0_wrapper(QObject* cpp_object, QObject* edit)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::setLineEdit(dynamic_cast<QLineEdit*>(edit));
    }

    void __Qt4Ada_QTimeEdit_editingFinished_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::editingFinished();
    }

    void __Qt4Ada_QTimeEdit_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::changeEvent(event);
    }

    void __Qt4Ada_QTimeEdit_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QAbstractSpinBox::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QTimeEdit_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QTimeEdit_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QTimeEdit_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QTimeEdit_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QTimeEdit_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QTimeEdit_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QTimeEdit_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QTimeEdit_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QTimeEditDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QTimeEdit_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QTimeEdit_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTimeEditDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QTimeEdit_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTimeEditDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QTimeEdit_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QTimeEdit*>(cpp_this)->QTimeEdit::qt_metacast(name);
    }

    int __Qt4Ada_QTimeEdit_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QTimeEdit*>(cpp_this)->QTimeEdit::qt_metacall(_c, _id, _a);
    }

}

bool QTimeEditDirector::event(QEvent* event)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::fixup(QString& input) const
{
    __Qt4Ada_QAbstractSpinBox_fixup_0_dispatch(this->ada_object, &input);
}

void QTimeEditDirector::stepBy(int steps)
{
    __Qt4Ada_QAbstractSpinBox_stepBy_0_dispatch(this->ada_object, steps);
}

QValidator::State QTimeEditDirector::validate(QString& input, int pos) const
{
    return __Qt4Ada_QAbstractSpinBox_validate_0_dispatch(this->ada_object, &input, pos);
}

QSize QTimeEditDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QTimeEditDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QTimeEditDirector::clear()
{
    __Qt4Ada_QAbstractSpinBox_clear_0_dispatch(this->ada_object);
}

void QTimeEditDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QTimeEditDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QTimeEditDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QTimeEditDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QTimeEditDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QTimeEditDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QTimeEditDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QTimeEditDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QTimeEditDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QTimeEditDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QTimeEditDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QTimeEditDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QTimeEditDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QTimeEditDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
