//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QAction>
#include <QWidget>
#include <QSize>
#include <QActionEvent>
#include <QChildEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QVariant>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QTimerEvent>

#include "qtoolbardirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QToolBar_staticMetaObject =
        &QToolBar::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    QObject* __Qt4Ada_QToolBar_actionAt_1_wrapper(QObject* cpp_object, const QPoint* p)
    {
        return static_cast<QObject*>(dynamic_cast<QToolBar*>(cpp_object)->QToolBar::actionAt(*p));
    }

    QObject* __Qt4Ada_QToolBar_actionAt_0_wrapper(QObject* cpp_object, int x, int y)
    {
        return static_cast<QObject*>(dynamic_cast<QToolBar*>(cpp_object)->QToolBar::actionAt(x, y));
    }

    QObject* __Qt4Ada_QToolBar_addAction_2_wrapper(QObject* cpp_object, const QString* text)
    {
        return static_cast<QObject*>(dynamic_cast<QToolBar*>(cpp_object)->QToolBar::addAction(*text));
    }

    QObject* __Qt4Ada_QToolBar_addAction_1_wrapper(QObject* cpp_object, const QIcon* icon, const QString* text)
    {
        return static_cast<QObject*>(dynamic_cast<QToolBar*>(cpp_object)->QToolBar::addAction(*icon, *text));
    }

    QObject* __Qt4Ada_QToolBar_addSeparator_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QToolBar*>(cpp_object)->QToolBar::addSeparator());
    }

    QObject* __Qt4Ada_QToolBar_addWidget_0_wrapper(QObject* cpp_object, QObject* before)
    {
        return static_cast<QObject*>(dynamic_cast<QToolBar*>(cpp_object)->QToolBar::addWidget(dynamic_cast<QWidget*>(before)));
    }

    void __Qt4Ada_QToolBar_clear_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QToolBar*>(cpp_object)->QToolBar::clear();
    }

    void __Qt4Ada_QToolBar_iconSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QToolBar*>(cpp_object)->QToolBar::iconSize();
    }

    QObject* __Qt4Ada_QToolBar_insertSeparator_0_wrapper(QObject* cpp_object, QObject* before)
    {
        return static_cast<QObject*>(dynamic_cast<QToolBar*>(cpp_object)->QToolBar::insertSeparator(dynamic_cast<QAction*>(before)));
    }

    QObject* __Qt4Ada_QToolBar_insertWidget_0_wrapper(QObject* cpp_object, QObject* before, QObject* widget)
    {
        return static_cast<QObject*>(dynamic_cast<QToolBar*>(cpp_object)->QToolBar::insertWidget(dynamic_cast<QAction*>(before), dynamic_cast<QWidget*>(widget)));
    }

    bool __Qt4Ada_QToolBar_isMovable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolBar*>(cpp_object)->QToolBar::isMovable();
    }

    void __Qt4Ada_QToolBar_setMovable_0_wrapper(QObject* cpp_object, bool movable)
    {
        dynamic_cast<QToolBar*>(cpp_object)->QToolBar::setMovable(movable);
    }

    QObject* __Qt4Ada_QToolBar_toggleViewAction_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QToolBar*>(cpp_object)->QToolBar::toggleViewAction());
    }

    QObject* __Qt4Ada_QToolBar_widgetForAction_0_wrapper(QObject* cpp_object, QObject* action)
    {
        return static_cast<QObject*>(dynamic_cast<QToolBar*>(cpp_object)->QToolBar::widgetForAction(dynamic_cast<QAction*>(action)));
    }

    void __Qt4Ada_QToolBar_setIconSize_0_wrapper(QObject* cpp_object, const QSize* iconSize)
    {
        dynamic_cast<QToolBar*>(cpp_object)->QToolBar::setIconSize(*iconSize);
    }

    void __Qt4Ada_QToolBar_actionTriggered_0_wrapper(QObject* cpp_object, QObject* action)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QToolBar::actionTriggered(dynamic_cast<QAction*>(action));
    }

    void __Qt4Ada_QToolBar_iconSizeChanged_0_wrapper(QObject* cpp_object, const QSize* iconSize)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QToolBar::iconSizeChanged(*iconSize);
    }

    void __Qt4Ada_QToolBar_movableChanged_0_wrapper(QObject* cpp_object, bool movable)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QToolBar::movableChanged(movable);
    }

    void __Qt4Ada_QToolBar_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QToolBar::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QToolBar_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QToolBar::changeEvent(event);
    }

    void __Qt4Ada_QToolBar_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QToolBar::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    bool __Qt4Ada_QToolBar_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QToolBarDirector*>(cpp_object)->QToolBar::event(e);
    }

    void __Qt4Ada_QToolBar_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QToolBar::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QToolBar_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QToolBar::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QToolBar_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QToolBar_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QToolBar_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QToolBar_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QToolBar_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QToolBar_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QToolBar_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QToolBar_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QToolBar_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QToolBar_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QToolBar_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QToolBar_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QToolBar_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QToolBar_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QToolBar_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QToolBar_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QToolBar_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QToolBar_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QToolBar_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QToolBar_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QToolBar_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QToolBar_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QToolBar_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QToolBar_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QToolBar_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QToolBar_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QToolBar_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QToolBar_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QToolBarDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QToolBar_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QToolBar_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolBarDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QToolBar_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolBarDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QToolBar_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QToolBar*>(cpp_this)->QToolBar::qt_metacast(name);
    }

    int __Qt4Ada_QToolBar_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QToolBar*>(cpp_this)->QToolBar::qt_metacall(_c, _id, _a);
    }

}

void QToolBarDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

bool QToolBarDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QToolBarDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

int QToolBarDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QToolBarDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QToolBarDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QToolBarDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QToolBarDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QToolBarDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QToolBarDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QToolBarDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QToolBarDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QToolBarDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QToolBarDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QToolBarDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QToolBarDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QToolBarDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QToolBarDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{

    QObject* __QtAda_new_QToolBar_QStringCR_QWidgetP(const QString* title, QObject* parent)
    {
        return new QToolBar(*title, dynamic_cast<QWidget*>(parent));
    }

    QObject* __QtAda_new_QToolBar_QWidgetP(QObject* parent)
    {
        return new QToolBar(dynamic_cast<QWidget*>(parent));
    }

}
