//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008, 2009 Vadim Godunko <vgodunko@gmail.com>                //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QAction>
#include <QMenu>
#include <QSize>
#include <QActionEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QTimerEvent>
#include <QFocusEvent>
#include <QKeyEvent>
#include <QVariant>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMoveEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>

#include "qtoolbuttondirector.h"
#include "qabstractbuttondirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QToolButton_staticMetaObject =
        &QToolButton::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    Qt::ArrowType __Qt4Ada_QToolButton_arrowType_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolButton*>(cpp_object)->QToolButton::arrowType();
    }

    bool __Qt4Ada_QToolButton_autoRaise_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolButton*>(cpp_object)->QToolButton::autoRaise();
    }

    QObject* __Qt4Ada_QToolButton_defaultAction_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QToolButton*>(cpp_object)->QToolButton::defaultAction());
    }

    QObject* __Qt4Ada_QToolButton_menu_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QToolButton*>(cpp_object)->QToolButton::menu());
    }

    QToolButton::ToolButtonPopupMode __Qt4Ada_QToolButton_popupMode_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolButton*>(cpp_object)->QToolButton::popupMode();
    }

    void __Qt4Ada_QToolButton_setArrowType_0_wrapper(QObject* cpp_object, Qt::ArrowType the_type)
    {
        dynamic_cast<QToolButton*>(cpp_object)->QToolButton::setArrowType(the_type);
    }

    void __Qt4Ada_QToolButton_setAutoRaise_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QToolButton*>(cpp_object)->QToolButton::setAutoRaise(enable);
    }

    void __Qt4Ada_QToolButton_setMenu_0_wrapper(QObject* cpp_object, QObject* menu)
    {
        dynamic_cast<QToolButton*>(cpp_object)->QToolButton::setMenu(dynamic_cast<QMenu*>(menu));
    }

    void __Qt4Ada_QToolButton_setPopupMode_0_wrapper(QObject* cpp_object, QToolButton::ToolButtonPopupMode mode)
    {
        dynamic_cast<QToolButton*>(cpp_object)->QToolButton::setPopupMode(mode);
    }

    Qt::ToolButtonStyle __Qt4Ada_QToolButton_toolButtonStyle_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolButton*>(cpp_object)->QToolButton::toolButtonStyle();
    }

    void __Qt4Ada_QToolButton_setDefaultAction_0_wrapper(QObject* cpp_object, QObject* action)
    {
        dynamic_cast<QToolButton*>(cpp_object)->QToolButton::setDefaultAction(dynamic_cast<QAction*>(action));
    }

    void __Qt4Ada_QToolButton_setToolButtonStyle_0_wrapper(QObject* cpp_object, Qt::ToolButtonStyle style)
    {
        dynamic_cast<QToolButton*>(cpp_object)->QToolButton::setToolButtonStyle(style);
    }

    void __Qt4Ada_QToolButton_showMenu_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QToolButton*>(cpp_object)->QToolButton::showMenu();
    }

    void __Qt4Ada_QToolButton_triggered_0_wrapper(QObject* cpp_object, QObject* action)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::triggered(dynamic_cast<QAction*>(action));
    }

    void __Qt4Ada_QToolButton_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QToolButton*>(cpp_object)->QToolButton::minimumSizeHint();
    }

    void __Qt4Ada_QToolButton_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QToolButton*>(cpp_object)->QToolButton::sizeHint();
    }

    void __Qt4Ada_QToolButton_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QToolButton_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::changeEvent(event);
    }

    void __Qt4Ada_QToolButton_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::enterEvent(event);
    }

    bool __Qt4Ada_QToolButton_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::event(e);
    }

    bool __Qt4Ada_QToolButton_hitButton_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        return dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::hitButton(*pos);
    }

    void __Qt4Ada_QToolButton_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::leaveEvent(event);
    }

    void __Qt4Ada_QToolButton_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QToolButton_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QToolButton_nextCheckState_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::nextCheckState();
    }

    void __Qt4Ada_QToolButton_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QToolButton_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QToolButton::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    void __Qt4Ada_QToolButton_checkStateSet_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QAbstractButton::checkStateSet();
    }

    void __Qt4Ada_QToolButton_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QAbstractButton::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QToolButton_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QAbstractButton::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QToolButton_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QAbstractButton::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QToolButton_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QAbstractButton::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QToolButton_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QAbstractButton::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QToolButton_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QToolButton_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QToolButton_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QToolButton_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QToolButton_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QToolButton_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QToolButton_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    bool __Qt4Ada_QToolButton_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QToolButton_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    bool __Qt4Ada_QToolButton_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QToolButton_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QToolButton_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QToolButton_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QToolButton_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QToolButton_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QToolButton_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QToolButton_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QToolButton_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QToolButton_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QToolButton_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QToolButtonDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QToolButton_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QToolButton_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QToolButtonDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QToolButton_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QToolButtonDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QToolButton_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QToolButton*>(cpp_this)->QToolButton::qt_metacast(name);
    }

    int __Qt4Ada_QToolButton_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QToolButton*>(cpp_this)->QToolButton::qt_metacall(_c, _id, _a);
    }

}

QSize QToolButtonDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QToolButtonDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QToolButtonDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QToolButtonDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QToolButtonDirector::hitButton(const QPoint& pos) const
{
    return __Qt4Ada_QAbstractButton_hitButton_0_dispatch(this->ada_object, &pos);
}

void QToolButtonDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::nextCheckState()
{
    __Qt4Ada_QAbstractButton_nextCheckState_0_dispatch(this->ada_object);
}

void QToolButtonDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::checkStateSet()
{
    __Qt4Ada_QAbstractButton_checkStateSet_0_dispatch(this->ada_object);
}

void QToolButtonDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

int QToolButtonDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QToolButtonDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QToolButtonDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QToolButtonDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

bool QToolButtonDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QToolButtonDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QToolButtonDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QToolButtonDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QToolButtonDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QToolButtonDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QToolButtonDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QToolButtonDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QToolButtonDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
QToolButtonDirector::QToolButtonDirector(void* self, QWidget* parent) :
    QToolButton(parent),
    ada_object(self)
{
}

extern "C" {

    QObject* __Qt4Ada_new_QToolButton (QObject* parent)
    {
        return dynamic_cast<QObject*>(new QToolButton (dynamic_cast <QWidget*> (parent)));
    }

    QObject* __QtAda_new_QToolButtonDirector_QWidgetP(void* self, QObject* parent)
    {
        return static_cast<QObject*>(new QToolButtonDirector(self, dynamic_cast<QWidget*>(parent)));
    }

}
