//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2007 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QTransform>

extern "C"
{
    extern QTransform* __QtAda_inititialize_QTransform(void*);
    extern QTransform* __QtAda_inititialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal(void*, double, double, double, double, double, double, double, double, double);
    extern QTransform* __QtAda_inititialize_QTransform_qreal_qreal_qreal_qreal_qreal_qreal(void*, double, double, double, double, double, double);
    extern QTransform* __QtAda_inititialize_QTransform_QMatrixCR(void*, const QMatrix*);
    extern QTransform* __QtAda_adjust_QTransform(void*, const QTransform*);
    extern void __QtAda_finalize_QTransform(QTransform*);

    extern double __QtAda_QTransform_m11_Q(const QTransform*);
    extern double __QtAda_QTransform_m12_Q(const QTransform*);
    extern double __QtAda_QTransform_m13_Q(const QTransform*);
    extern double __QtAda_QTransform_m21_Q(const QTransform*);
    extern double __QtAda_QTransform_m22_Q(const QTransform*);
    extern double __QtAda_QTransform_m23_Q(const QTransform*);
    extern double __QtAda_QTransform_m31_Q(const QTransform*);
    extern double __QtAda_QTransform_m32_Q(const QTransform*);
    extern double __QtAda_QTransform_m33_Q(const QTransform*);
    extern void __QtAda_QTransform_adjoint_Q(QTransform*, const QTransform*);
    extern double __QtAda_QTransform_det_Q(const QTransform*);
    extern double __QtAda_QTransform_determinant_Q(const QTransform*);
    extern double __QtAda_QTransform_dx_Q(const QTransform*);
    extern double __QtAda_QTransform_dy_Q(const QTransform*);
    extern void __QtAda_QTransform_inverted_Q(QTransform*, const QTransform*);
    extern unsigned __QtAda_QTransform_isAffine_Q(const QTransform*);
    extern unsigned __QtAda_QTransform_isIdentity_Q(const QTransform*);
    extern unsigned __QtAda_QTransform_isInvertible_Q(const QTransform*);
    extern unsigned __QtAda_QTransform_isRotating_Q(const QTransform*);
    extern unsigned __QtAda_QTransform_isScaling_Q(const QTransform*);
    extern unsigned __QtAda_QTransform_isTranslating_Q(const QTransform*);
    extern void __QtAda_QTransform_map_qreal_qreal_qrealP_qrealP_Q(const QTransform*, double, double, double*, double*);
    extern void __QtAda_QTransform_map_int_int_intP_intP_Q(const QTransform*, int, int, int*, int*);
    extern void __QtAda_QTransform_map_QPointCR_Q(QPoint*, const QTransform*, const QPoint*);
    extern void __QtAda_QTransform_map_QPointFCR_Q(QPointF*, const QTransform*, const QPointF*);
    extern void __QtAda_QTransform_map_QLineCR_Q(QLine*, const QTransform*, const QLine*);
    extern void __QtAda_QTransform_map_QLineFCR_Q(QLineF*, const QTransform*, const QLineF*);
    extern void __QtAda_QTransform_map_QPolygonCR_Q(QPolygon*, const QTransform*, const QPolygon*);
    extern void __QtAda_QTransform_map_QPolygonFCR_Q(QPolygonF*, const QTransform*, const QPolygonF*);
    extern void __QtAda_QTransform_map_QRegionCR_Q(QRegion*, const QTransform*, const QRegion*);
    extern void __QtAda_QTransform_map_QPainterPathCR_Q(QPainterPath*, const QTransform*, const QPainterPath*);
    extern void __QtAda_QTransform_mapRect_QRectCR_Q(QRect*, const QTransform*, const QRect*);
    extern void __QtAda_QTransform_mapRect_QRectFCR_Q(QRectF*, const QTransform*, const QRectF*);
    extern void __QtAda_QTransform_mapToPolygon_QRectCR_Q(QPolygon*, const QTransform*, const QRect*);
    extern void __QtAda_QTransform_reset(QTransform*);
    extern void __QtAda_QTransform_rotate_qreal_Axis(QTransform*, double, unsigned);
    extern void __QtAda_QTransform_rotateRadians_qreal_Axis(QTransform*, double, unsigned);
    extern void __QtAda_QTransform_scale_qreal_qreal(QTransform*, double, double);
    extern void __QtAda_QTransform_setMatrix_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal_qreal(QTransform*, double, double, double, double, double, double, double, double, double);
    extern void __QtAda_QTransform_shear_qreal_qreal(QTransform*, double, double);
    extern void __QtAda_QTransform_toAffine_Q(QMatrix*, const QTransform*);
    extern void __QtAda_QTransform_translate_qreal_qreal(QTransform*, double, double);
    extern void __QtAda_QTransform_transposed_Q(QTransform*, const QTransform*);
    extern unsigned __QtAda_QTransform_eq_QTransformCR_Q(const QTransform*, const QTransform*);
    extern void __QtAda_QTransform_multiplication_QTransformCR_Q(QTransform*, const QTransform*, const QTransform*);
    extern void __QtAda_multiplication_QPointCR_QTransformCR(QPoint*, const QPoint*, const QTransform*);
    extern void __QtAda_multiplication_QPointFCR_QTransformCR(QPointF*, const QPointF*, const QTransform*);
    extern void __QtAda_multiplication_QLineCR_QTransformCR(QLine*, const QLine*, const QTransform*);
    extern void __QtAda_multiplication_QLineFCR_QTransformCR(QLineF*, const QLineF*, const QTransform*);
    extern void __QtAda_multiplication_QPolygonCR_QTransformCR(QPolygon*, const QPolygon*, const QTransform*);
    extern void __QtAda_multiplication_QPolygonFCR_QTransformCR(QPolygonF*, const QPolygonF*, const QTransform*);
    extern void __QtAda_multiplication_QRegionCR_QTransformCR(QRegion*, const QRegion*, const QTransform*);
    extern void __QtAda_multiplication_QPainterPathCR_QTransformCR(QPainterPath*, const QPainterPath*, const QTransform*);
    extern void __QtAda_multiplication_QTransformCR_qreal(QTransform*, const QTransform*, double);
    extern void __QtAda_division_QTransformCR_qreal(QTransform*, const QTransform*, double);
    extern void __QtAda_plus_QTransformCR_qreal(QTransform*, const QTransform*, double);
    extern void __QtAda_minus_QTransformCR_qreal(QTransform*, const QTransform*, double);

};

