//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QModelIndex>
#include <QAbstractItemModel>
#include <QRect>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QPaintEvent>
#include <QDragMoveEvent>
#include <QTimerEvent>
#include <QRegion>
#include <QItemSelectionModel>
#include <QVariant>
#include <QWidget>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QInputMethodEvent>
#include <QResizeEvent>
#include <QSize>
#include <QWheelEvent>
#include <QContextMenuEvent>
#include <QActionEvent>
#include <QCloseEvent>
#include <QHideEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QChildEvent>

#include "qtreeviewdirector.h"
#include "qabstractitemviewdirector.h"
#include "qabstractscrollareadirector.h"
#include "qframedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QTreeView_staticMetaObject =
        &QTreeView::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QTreeView_allColumnsShowFocus_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::allColumnsShowFocus();
    }

    int __Qt4Ada_QTreeView_columnAt_0_wrapper(QObject* cpp_object, int x)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::columnAt(x);
    }

    int __Qt4Ada_QTreeView_columnViewportPosition_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::columnViewportPosition(column);
    }

    int __Qt4Ada_QTreeView_columnWidth_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::columnWidth(column);
    }

    int __Qt4Ada_QTreeView_indentation_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::indentation();
    }

    void __Qt4Ada_QTreeView_indexAbove_0_wrapper(QObject* cpp_object, const QModelIndex* index, QModelIndex* returns)
    {
        *returns = dynamic_cast<QTreeView*>(cpp_object)->QTreeView::indexAbove(*index);
    }

    void __Qt4Ada_QTreeView_indexBelow_0_wrapper(QObject* cpp_object, const QModelIndex* index, QModelIndex* returns)
    {
        *returns = dynamic_cast<QTreeView*>(cpp_object)->QTreeView::indexBelow(*index);
    }

    bool __Qt4Ada_QTreeView_isAnimated_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::isAnimated();
    }

    bool __Qt4Ada_QTreeView_isColumnHidden_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::isColumnHidden(column);
    }

    bool __Qt4Ada_QTreeView_isExpanded_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::isExpanded(*index);
    }

    bool __Qt4Ada_QTreeView_isRowHidden_0_wrapper(QObject* cpp_object, int row, const QModelIndex* index)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::isRowHidden(row, *index);
    }

    bool __Qt4Ada_QTreeView_isSortingEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::isSortingEnabled();
    }

    bool __Qt4Ada_QTreeView_itemsExpandable_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::itemsExpandable();
    }

    bool __Qt4Ada_QTreeView_rootIsDecorated_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::rootIsDecorated();
    }

    void __Qt4Ada_QTreeView_setAllColumnsShowFocus_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setAllColumnsShowFocus(enable);
    }

    void __Qt4Ada_QTreeView_setAnimated_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setAnimated(enable);
    }

    void __Qt4Ada_QTreeView_setColumnHidden_0_wrapper(QObject* cpp_object, int column, bool hide)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setColumnHidden(column, hide);
    }

    void __Qt4Ada_QTreeView_setColumnWidth_0_wrapper(QObject* cpp_object, int column, int width)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setColumnWidth(column, width);
    }

    void __Qt4Ada_QTreeView_setExpanded_0_wrapper(QObject* cpp_object, const QModelIndex* index, bool expand)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setExpanded(*index, expand);
    }

    void __Qt4Ada_QTreeView_setFirstColumnSpanned_0_wrapper(QObject* cpp_object, int row, const QModelIndex* parent, bool span)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setFirstColumnSpanned(row, *parent, span);
    }

    void __Qt4Ada_QTreeView_setIndentation_0_wrapper(QObject* cpp_object, int i)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setIndentation(i);
    }

    void __Qt4Ada_QTreeView_setItemsExpandable_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setItemsExpandable(enable);
    }

    void __Qt4Ada_QTreeView_setRootIsDecorated_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setRootIsDecorated(enable);
    }

    void __Qt4Ada_QTreeView_setRowHidden_0_wrapper(QObject* cpp_object, int row, const QModelIndex* index, bool hide)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setRowHidden(row, *index, hide);
    }

    void __Qt4Ada_QTreeView_setSortingEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setSortingEnabled(enable);
    }

    void __Qt4Ada_QTreeView_setUniformRowHeights_0_wrapper(QObject* cpp_object, bool uniform)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setUniformRowHeights(uniform);
    }

    bool __Qt4Ada_QTreeView_uniformRowHeights_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeView*>(cpp_object)->QTreeView::uniformRowHeights();
    }

    void __Qt4Ada_QTreeView_collapse_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::collapse(*index);
    }

    void __Qt4Ada_QTreeView_collapseAll_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::collapseAll();
    }

    void __Qt4Ada_QTreeView_expand_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::expand(*index);
    }

    void __Qt4Ada_QTreeView_expandAll_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::expandAll();
    }

    void __Qt4Ada_QTreeView_hideColumn_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::hideColumn(column);
    }

    void __Qt4Ada_QTreeView_resizeColumnToContents_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::resizeColumnToContents(column);
    }

    void __Qt4Ada_QTreeView_selectAll_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::selectAll();
    }

    void __Qt4Ada_QTreeView_showColumn_0_wrapper(QObject* cpp_object, int column)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::showColumn(column);
    }

    void __Qt4Ada_QTreeView_indexAt_0_wrapper(QObject* cpp_object, const QPoint* point, QModelIndex* returns)
    {
        *returns = dynamic_cast<QTreeView*>(cpp_object)->QTreeView::indexAt(*point);
    }

    void __Qt4Ada_QTreeView_scrollTo_0_wrapper(QObject* cpp_object, const QModelIndex* index, QAbstractItemView::ScrollHint hint)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::scrollTo(*index, hint);
    }

    void __Qt4Ada_QTreeView_setModel_0_wrapper(QObject* cpp_object, QObject* model)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setModel(dynamic_cast<QAbstractItemModel*>(model));
    }

    void __Qt4Ada_QTreeView_setRootIndex_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::setRootIndex(*index);
    }

    void __Qt4Ada_QTreeView_visualRect_0_wrapper(QObject* cpp_object, const QModelIndex* index, QRect* returns)
    {
        *returns = dynamic_cast<QTreeView*>(cpp_object)->QTreeView::visualRect(*index);
    }

    void __Qt4Ada_QTreeView_dataChanged_0_wrapper(QObject* cpp_object, const QModelIndex* topLeft, const QModelIndex* bottomRight)
    {
        dynamic_cast<QTreeView*>(cpp_object)->QTreeView::dataChanged(*topLeft, *bottomRight);
    }

    int __Qt4Ada_QTreeView_horizontalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::horizontalOffset();
    }

    void __Qt4Ada_QTreeView_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    bool __Qt4Ada_QTreeView_isIndexHidden_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::isIndexHidden(*index);
    }

    void __Qt4Ada_QTreeView_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTreeView_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTreeView_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTreeView_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QTreeView_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    bool __Qt4Ada_QTreeView_viewportEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::viewportEvent(event);
    }

    void __Qt4Ada_QTreeView_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QTreeView_rowsAboutToBeRemoved_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::rowsAboutToBeRemoved(*parent, start, stop);
    }

    void __Qt4Ada_QTreeView_rowsInserted_0_wrapper(QObject* cpp_object, const QModelIndex* parent, int start, int stop)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::rowsInserted(*parent, start, stop);
    }

    void __Qt4Ada_QTreeView_scrollContentsBy_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::scrollContentsBy(dx, dy);
    }

    int __Qt4Ada_QTreeView_sizeHintForColumn_0_wrapper(QObject* cpp_object, int column)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::sizeHintForColumn(column);
    }

    void __Qt4Ada_QTreeView_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    int __Qt4Ada_QTreeView_verticalOffset_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::verticalOffset();
    }

    void __Qt4Ada_QTreeView_visualRegionForSelection_0_wrapper(QObject* cpp_object, const QItemSelection* selection, QRegion* returns)
    {
        *returns = dynamic_cast<QTreeViewDirector*>(cpp_object)->QTreeView::visualRegionForSelection(*selection);
    }

    void __Qt4Ada_QTreeView_activated_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::activated(*index);
    }

    void __Qt4Ada_QTreeView_clicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::clicked(*index);
    }

    void __Qt4Ada_QTreeView_doubleClicked_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::doubleClicked(*index);
    }

    void __Qt4Ada_QTreeView_entered_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::entered(*index);
    }

    void __Qt4Ada_QTreeView_pressed_0_wrapper(QObject* cpp_object, const QModelIndex* index)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::pressed(*index);
    }

    void __Qt4Ada_QTreeView_viewportEntered_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::viewportEntered();
    }

    void __Qt4Ada_QTreeView_dirtyRegionOffset_0_wrapper(QObject* cpp_object, QPoint* returns)
    {
        *returns = dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::dirtyRegionOffset();
    }

    void __Qt4Ada_QTreeView_executeDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::executeDelayedItemsLayout();
    }

    void __Qt4Ada_QTreeView_scheduleDelayedItemsLayout_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::scheduleDelayedItemsLayout();
    }

    void __Qt4Ada_QTreeView_scrollDirtyRegion_0_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::scrollDirtyRegion(dx, dy);
    }

    void __Qt4Ada_QTreeView_setDirtyRegion_0_wrapper(QObject* cpp_object, const QRegion* region)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::setDirtyRegion(*region);
    }

    void __Qt4Ada_QTreeView_commitData_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::commitData(dynamic_cast<QWidget*>(editor));
    }

    void __Qt4Ada_QTreeView_currentChanged_0_wrapper(QObject* cpp_object, const QModelIndex* current, const QModelIndex* previous)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::currentChanged(*current, *previous);
    }

    void __Qt4Ada_QTreeView_editorDestroyed_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::editorDestroyed(editor);
    }

    void __Qt4Ada_QTreeView_selectionChanged_0_wrapper(QObject* cpp_object, const QItemSelection* selected, const QItemSelection* deselected)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::selectionChanged(*selected, *deselected);
    }

    void __Qt4Ada_QTreeView_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QTreeView_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QTreeView_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    bool __Qt4Ada_QTreeView_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::event(e);
    }

    void __Qt4Ada_QTreeView_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QTreeView_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::focusNextPrevChild(next);
    }

    void __Qt4Ada_QTreeView_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    void __Qt4Ada_QTreeView_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QTreeView_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractItemView::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QTreeView_setupViewport_0_wrapper(QObject* cpp_object, QObject* viewport)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractScrollArea::setupViewport(dynamic_cast<QWidget*>(viewport));
    }

    void __Qt4Ada_QTreeView_setViewportMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractScrollArea::setViewportMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QTreeView_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractScrollArea::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    void __Qt4Ada_QTreeView_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QAbstractScrollArea::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QTreeView_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QFrame::changeEvent(event);
    }

    void __Qt4Ada_QTreeView_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QTreeView_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QTreeView_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QTreeView_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QTreeView_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QTreeView_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QTreeView_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QTreeView_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QTreeView_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QTreeView_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QTreeView_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QTreeView_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QTreeView_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    int __Qt4Ada_QTreeView_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QTreeView_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QTreeView_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QTreeViewDirector*>(cpp_object)->QObject::customEvent(event);
    }

    QObject* __Qt4Ada_QTreeView_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QTreeViewDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QTreeView_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QTreeView*>(cpp_this)->QTreeView::qt_metacast(name);
    }

    int __Qt4Ada_QTreeView_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QTreeView*>(cpp_this)->QTreeView::qt_metacall(_c, _id, _a);
    }

}

void QTreeViewDirector::selectAll()
{
    __Qt4Ada_QAbstractItemView_selectAll_0_dispatch(this->ada_object);
}

QModelIndex QTreeViewDirector::indexAt(const QPoint& point) const
{
    QModelIndex *aux = __Qt4Ada_QAbstractItemView_indexAt_0_dispatch(this->ada_object, &point);
    QModelIndex returns = *aux;
    delete aux;
    return returns;
}

void QTreeViewDirector::scrollTo(const QModelIndex& index, QAbstractItemView::ScrollHint hint)
{
    __Qt4Ada_QAbstractItemView_scrollTo_0_dispatch(this->ada_object, &index, hint);
}

void QTreeViewDirector::setModel(QAbstractItemModel* model)
{
    __Qt4Ada_QAbstractItemView_setModel_0_dispatch(this->ada_object, model);
}

void QTreeViewDirector::setRootIndex(const QModelIndex& index)
{
    __Qt4Ada_QAbstractItemView_setRootIndex_0_dispatch(this->ada_object, &index);
}

QRect QTreeViewDirector::visualRect(const QModelIndex& index) const
{
    QRect *aux = __Qt4Ada_QAbstractItemView_visualRect_0_dispatch(this->ada_object, &index);
    QRect returns = *aux;
    delete aux;
    return returns;
}

void QTreeViewDirector::dataChanged(const QModelIndex& topLeft, const QModelIndex& bottomRight)
{
    __Qt4Ada_QAbstractItemView_dataChanged_0_dispatch(this->ada_object, &topLeft, &bottomRight);
}

int QTreeViewDirector::horizontalOffset() const
{
    return __Qt4Ada_QAbstractItemView_horizontalOffset_0_dispatch(this->ada_object);
}

void QTreeViewDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

bool QTreeViewDirector::isIndexHidden(const QModelIndex& index) const
{
    return __Qt4Ada_QAbstractItemView_isIndexHidden_0_dispatch(this->ada_object, &index);
}

void QTreeViewDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

bool QTreeViewDirector::viewportEvent(QEvent* event)
{
    return __Qt4Ada_QAbstractScrollArea_viewportEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::rowsAboutToBeRemoved(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsAboutToBeRemoved_0_dispatch(this->ada_object, &parent, start, stop);
}

void QTreeViewDirector::rowsInserted(const QModelIndex& parent, int start, int stop)
{
    __Qt4Ada_QAbstractItemView_rowsInserted_0_dispatch(this->ada_object, &parent, start, stop);
}

void QTreeViewDirector::scrollContentsBy(int dx, int dy)
{
    __Qt4Ada_QAbstractScrollArea_scrollContentsBy_0_dispatch(this->ada_object, dx, dy);
}

int QTreeViewDirector::sizeHintForColumn(int column) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForColumn_0_dispatch(this->ada_object, column);
}

void QTreeViewDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

int QTreeViewDirector::verticalOffset() const
{
    return __Qt4Ada_QAbstractItemView_verticalOffset_0_dispatch(this->ada_object);
}

QRegion QTreeViewDirector::visualRegionForSelection(const QItemSelection& selection) const
{
    QRegion *aux = __Qt4Ada_QAbstractItemView_visualRegionForSelection_0_dispatch(this->ada_object, &selection);
    QRegion returns = *aux;
    delete aux;
    return returns;
}

void QTreeViewDirector::keyboardSearch(const QString& search)
{
    __Qt4Ada_QAbstractItemView_keyboardSearch_0_dispatch(this->ada_object, &search);
}

void QTreeViewDirector::setSelectionModel(QItemSelectionModel* selectionModel)
{
    __Qt4Ada_QAbstractItemView_setSelectionModel_0_dispatch(this->ada_object, selectionModel);
}

int QTreeViewDirector::sizeHintForRow(int row) const
{
    return __Qt4Ada_QAbstractItemView_sizeHintForRow_0_dispatch(this->ada_object, row);
}

void QTreeViewDirector::reset()
{
    __Qt4Ada_QAbstractItemView_reset_0_dispatch(this->ada_object);
}

QVariant QTreeViewDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QTreeViewDirector::commitData(QWidget* editor)
{
    __Qt4Ada_QAbstractItemView_commitData_0_dispatch(this->ada_object, editor);
}

void QTreeViewDirector::currentChanged(const QModelIndex& current, const QModelIndex& previous)
{
    __Qt4Ada_QAbstractItemView_currentChanged_0_dispatch(this->ada_object, &current, &previous);
}

void QTreeViewDirector::editorDestroyed(QObject* editor)
{
    __Qt4Ada_QAbstractItemView_editorDestroyed_0_dispatch(this->ada_object, editor);
}

void QTreeViewDirector::selectionChanged(const QItemSelection& selected, const QItemSelection& deselected)
{
    __Qt4Ada_QAbstractItemView_selectionChanged_0_dispatch(this->ada_object, &selected, &deselected);
}

void QTreeViewDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

bool QTreeViewDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QTreeViewDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QTreeViewDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QTreeViewDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

QSize QTreeViewDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QTreeViewDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QTreeViewDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

int QTreeViewDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

void QTreeViewDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QTreeViewDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

int QTreeViewDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QTreeViewDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QTreeViewDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QTreeViewDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QTreeViewDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QTreeViewDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QTreeViewDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QTreeViewDirector::QTreeViewDirector(void* o, QWidget* parent) :
    QTreeView(parent),
    ada_object(o)
{
}

extern "C" {

    QObject *__Qt4Ada_new_QTreeView (QObject *parent)
    {
        return dynamic_cast<QObject *>(new QTreeView (dynamic_cast <QWidget*> (parent)));
    }

    QObject* __Qt4Ada_new_QTreeViewDirector (void* ada_object, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QTreeViewDirector(ada_object,dynamic_cast<QWidget*>(parent)));
    }

    void __Qt4Ada_QTreeView_moveCursor_wrapper (QObject*cpp_object, unsigned action, unsigned modifiers,QModelIndex*index)
   {
      *index = dynamic_cast <QTreeViewDirector*>(cpp_object) -> moveCursor ((QTreeViewDirector::CursorAction) action, (Qt::KeyboardModifiers) modifiers);
   }

    void __Qt4Ada_QTreeView_setSelection_wrapper (QObject*cpp_object, QRect*rect, unsigned flags)
    {
       dynamic_cast<QTreeViewDirector*>(cpp_object) -> setSelection (*rect,  (QItemSelectionModel::SelectionFlags)flags);
    }

    void __Qt4Ada_QTreeView_visualRegionForSelection_wrapper (QObject*cpp_object, QItemSelection*item, QRegion*returns)
   {
      *returns = dynamic_cast<QTreeViewDirector*>(cpp_object) -> visualRegionForSelection (*item);
   }

}
