//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QTREEVIEWDIRECTOR_H__
#define __QTREEVIEWDIRECTOR_H__

#include <QTreeView>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QTreeView_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern bool __Qt4Ada_QTreeView_allColumnsShowFocus_0_wrapper(QObject*);
    extern int __Qt4Ada_QTreeView_columnAt_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTreeView_columnViewportPosition_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTreeView_columnWidth_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QTreeView_indentation_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_indexAbove_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    extern void __Qt4Ada_QTreeView_indexBelow_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    extern bool __Qt4Ada_QTreeView_isAnimated_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTreeView_isColumnHidden_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QTreeView_isExpanded_0_wrapper(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QTreeView_isRowHidden_0_wrapper(QObject*, int, const QModelIndex*);
    extern bool __Qt4Ada_QTreeView_isSortingEnabled_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTreeView_itemsExpandable_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTreeView_rootIsDecorated_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_setAllColumnsShowFocus_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTreeView_setAnimated_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTreeView_setColumnHidden_0_wrapper(QObject*, int, bool);
    extern void __Qt4Ada_QTreeView_setColumnWidth_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTreeView_setExpanded_0_wrapper(QObject*, const QModelIndex*, bool);
    extern void __Qt4Ada_QTreeView_setFirstColumnSpanned_0_wrapper(QObject*, int, const QModelIndex*, bool);
    extern void __Qt4Ada_QTreeView_setIndentation_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTreeView_setItemsExpandable_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTreeView_setRootIsDecorated_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTreeView_setRowHidden_0_wrapper(QObject*, int, const QModelIndex*, bool);
    extern void __Qt4Ada_QTreeView_setSortingEnabled_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTreeView_setUniformRowHeights_0_wrapper(QObject*, bool);
    extern bool __Qt4Ada_QTreeView_uniformRowHeights_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_collapse_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTreeView_collapseAll_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_expand_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTreeView_expandAll_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_hideColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTreeView_resizeColumnToContents_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTreeView_selectAll_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_showColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTreeView_indexAt_0_wrapper(QObject*, const QPoint*, QModelIndex*);
    extern void __Qt4Ada_QTreeView_scrollTo_0_wrapper(QObject*, const QModelIndex*, QAbstractItemView::ScrollHint);
    extern void __Qt4Ada_QTreeView_setModel_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTreeView_setRootIndex_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTreeView_visualRect_0_wrapper(QObject*, const QModelIndex*, QRect*);
    extern void __Qt4Ada_QTreeView_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern int __Qt4Ada_QTreeView_horizontalOffset_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTreeView_isIndexHidden_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTreeView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_paintEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTreeView_viewportEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QTreeView_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QTreeView_scrollContentsBy_0_wrapper(QObject*, int, int);
    extern int __Qt4Ada_QTreeView_sizeHintForColumn_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QTreeView_timerEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QTreeView_verticalOffset_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_visualRegionForSelection_0_wrapper(QObject*, const QItemSelection*, QRegion*);
    extern void __Qt4Ada_QTreeView_activated_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTreeView_clicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTreeView_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTreeView_entered_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTreeView_pressed_0_wrapper(QObject*, const QModelIndex*);
    extern void __Qt4Ada_QTreeView_viewportEntered_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    extern void __Qt4Ada_QTreeView_executeDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    extern void __Qt4Ada_QTreeView_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    extern void __Qt4Ada_QTreeView_commitData_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTreeView_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QTreeView_editorDestroyed_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTreeView_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    extern void __Qt4Ada_QTreeView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_dropEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTreeView_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTreeView_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QTreeView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_setupViewport_0_wrapper(QObject*, QObject*);
    extern void __Qt4Ada_QTreeView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    extern void __Qt4Ada_QTreeView_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QTreeView_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_enterEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QTreeView_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QTreeView_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QTreeView_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QTreeView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QTreeView_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QTreeView_customEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QTreeView_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QTreeView_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QTreeView_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}
extern "C" {

   // constructors

   extern QObject* __Qt4Ada_new_QTreeView(QObject*);
   extern QObject* __Qt4Ada_new_QTreeViewDirector(void*, QObject*);

   extern void __Qt4Ada_QTreeView_moveCursor_wrapper (QObject*, unsigned, unsigned,QModelIndex*);

   extern void __Qt4Ada_QTreeView_setSelection_wrapper (QObject*, QRect*, unsigned);
   extern void __Qt4Ada_QTreeView_visualRegionForSelection_wrapper (QObject*, QItemSelection*, QRegion*);

}

class QTreeViewDirector : public QTreeView
{
protected:
    void* ada_object;
    QTreeViewDirector(void*, QWidget*);

    friend void __Qt4Ada_QTreeView_moveCursor_wrapper (QObject*, unsigned, unsigned,QModelIndex*);
    friend void __Qt4Ada_QTreeView_setSelection_wrapper (QObject*, QRect*, unsigned);
    friend void __Qt4Ada_QTreeView_visualRegionForSelection_wrapper (QObject*, QItemSelection*, QRegion*);
    friend QObject* __Qt4Ada_new_QTreeViewDirector(void*, QObject*);

    virtual void selectAll();
    virtual QModelIndex indexAt(const QPoint&) const;
    virtual void scrollTo(const QModelIndex&, QAbstractItemView::ScrollHint);
    virtual void setModel(QAbstractItemModel*);
    virtual void setRootIndex(const QModelIndex&);
    virtual QRect visualRect(const QModelIndex&) const;
    virtual void dataChanged(const QModelIndex&, const QModelIndex&);
    virtual int horizontalOffset() const;
    virtual void keyPressEvent(QKeyEvent*);
    virtual bool isIndexHidden(const QModelIndex&) const;
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual bool viewportEvent(QEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void rowsAboutToBeRemoved(const QModelIndex&, int, int);
    virtual void rowsInserted(const QModelIndex&, int, int);
    virtual void scrollContentsBy(int, int);
    virtual int sizeHintForColumn(int) const;
    virtual void timerEvent(QTimerEvent*);
    virtual int verticalOffset() const;
    virtual QRegion visualRegionForSelection(const QItemSelection&) const;
    virtual void keyboardSearch(const QString&);
    virtual void setSelectionModel(QItemSelectionModel*);
    virtual int sizeHintForRow(int) const;
    virtual void reset();
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void commitData(QWidget*);
    virtual void currentChanged(const QModelIndex&, const QModelIndex&);
    virtual void editorDestroyed(QObject*);
    virtual void selectionChanged(const QItemSelection&, const QItemSelection&);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual bool event(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;
    virtual void wheelEvent(QWheelEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual void changeEvent(QEvent*);
    virtual int heightForWidth(int) const;
    virtual void setVisible(bool);
    virtual void actionEvent(QActionEvent*);
    virtual void closeEvent(QCloseEvent*);
    virtual void enterEvent(QEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void showEvent(QShowEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend int __Qt4Ada_QTreeView_horizontalOffset_0_wrapper(QObject*);
    friend void __Qt4Ada_QTreeView_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTreeView_isIndexHidden_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTreeView_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_paintEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTreeView_viewportEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_rowsAboutToBeRemoved_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QTreeView_rowsInserted_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QTreeView_scrollContentsBy_0_wrapper(QObject*, int, int);
    friend int __Qt4Ada_QTreeView_sizeHintForColumn_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QTreeView_timerEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QTreeView_verticalOffset_0_wrapper(QObject*);
    friend void __Qt4Ada_QTreeView_visualRegionForSelection_0_wrapper(QObject*, const QItemSelection*, QRegion*);
    friend void __Qt4Ada_QTreeView_activated_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTreeView_clicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTreeView_doubleClicked_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTreeView_entered_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTreeView_pressed_0_wrapper(QObject*, const QModelIndex*);
    friend void __Qt4Ada_QTreeView_viewportEntered_0_wrapper(QObject*);
    friend void __Qt4Ada_QTreeView_dirtyRegionOffset_0_wrapper(QObject*, QPoint*);
    friend void __Qt4Ada_QTreeView_executeDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QTreeView_scheduleDelayedItemsLayout_0_wrapper(QObject*);
    friend void __Qt4Ada_QTreeView_scrollDirtyRegion_0_wrapper(QObject*, int, int);
    friend void __Qt4Ada_QTreeView_setDirtyRegion_0_wrapper(QObject*, const QRegion*);
    friend void __Qt4Ada_QTreeView_commitData_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QTreeView_currentChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QTreeView_editorDestroyed_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QTreeView_selectionChanged_0_wrapper(QObject*, const QItemSelection*, const QItemSelection*);
    friend void __Qt4Ada_QTreeView_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_dropEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTreeView_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTreeView_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QTreeView_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_setupViewport_0_wrapper(QObject*, QObject*);
    friend void __Qt4Ada_QTreeView_setViewportMargins_0_wrapper(QObject*, int, int, int, int);
    friend void __Qt4Ada_QTreeView_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QTreeView_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_enterEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QTreeView_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QTreeView_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QTreeView_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QTreeView_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QTreeView_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QTreeView_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QTreeView_customEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QTreeView_sender_0_wrapper(QObject*);
};

#endif // __QTREEVIEWDIRECTOR_H__
