//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QAction>
#include <QSize>
#include <QRect>
#include <QRegion>
#include <QCursor>
#include <QFont>
#include <QFontInfo>
#include <QFontMetrics>
#include <QVariant>
#include <QLayout>
#include <QPoint>
#include <QPalette>
#include <QByteArray>
#include <QStyle>
#include <QSizePolicy>
#include <QIcon>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QWidget_staticMetaObject =
        &QWidget::staticMetaObject;
}

extern "C"
{

    int __Qt4Ada_QWidget_heightForWidth_0_virtual(QObject* cpp_object, int w)
    {
        return dynamic_cast<QWidget*>(cpp_object)->heightForWidth(w);
    }

    void __Qt4Ada_QWidget_inputMethodQuery_0_virtual(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->inputMethodQuery(query);
    }

    void __Qt4Ada_QWidget_minimumSizeHint_0_virtual(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->minimumSizeHint();
    }

    void __Qt4Ada_QWidget_sizeHint_0_virtual(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->sizeHint();
    }

    void __Qt4Ada_QWidget_setVisible_0_virtual(QObject* cpp_object, bool visible)
    {
        dynamic_cast<QWidget*>(cpp_object)->setVisible(visible);
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    bool __Qt4Ada_QWidget_acceptDrops_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::acceptDrops();
    }

    void __Qt4Ada_QWidget_accessibleDescription_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::accessibleDescription();
    }

    void __Qt4Ada_QWidget_accessibleName_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::accessibleName();
    }

    void __Qt4Ada_QWidget_activateWindow_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::activateWindow();
    }

    void __Qt4Ada_QWidget_addAction_0_wrapper(QObject* cpp_object, QObject* action)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::addAction(dynamic_cast<QAction*>(action));
    }

    void __Qt4Ada_QWidget_adjustSize_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::adjustSize();
    }

    bool __Qt4Ada_QWidget_autoFillBackground_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::autoFillBackground();
    }

    void __Qt4Ada_QWidget_baseSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::baseSize();
    }

    void __Qt4Ada_QWidget_childAt_1_wrapper(QObject* cpp_object, int x, int y)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::childAt(x, y);
    }

    void __Qt4Ada_QWidget_childAt_0_wrapper(QObject* cpp_object, const QPoint* p)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::childAt(*p);
    }

    void __Qt4Ada_QWidget_childrenRect_0_wrapper(QObject* cpp_object, QRect* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::childrenRect();
    }

    void __Qt4Ada_QWidget_childrenRegion_0_wrapper(QObject* cpp_object, QRegion* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::childrenRegion();
    }

    void __Qt4Ada_QWidget_clearFocus_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::clearFocus();
    }

    void __Qt4Ada_QWidget_clearMask_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::clearMask();
    }

    void __Qt4Ada_QWidget_contentsRect_0_wrapper(QObject* cpp_object, QRect* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::contentsRect();
    }

    Qt::ContextMenuPolicy __Qt4Ada_QWidget_contextMenuPolicy_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::contextMenuPolicy();
    }

    void __Qt4Ada_QWidget_cursor_0_wrapper(QObject* cpp_object, QCursor* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::cursor();
    }

    WId __Qt4Ada_QWidget_effectiveWinId_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::effectiveWinId();
    }

    void __Qt4Ada_QWidget_ensurePolished_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::ensurePolished();
    }

    Qt::FocusPolicy __Qt4Ada_QWidget_focusPolicy_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::focusPolicy();
    }

    QObject* __Qt4Ada_QWidget_focusProxy_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QWidget*>(cpp_object)->QWidget::focusProxy());
    }

    QObject* __Qt4Ada_QWidget_focusWidget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QWidget*>(cpp_object)->QWidget::focusWidget());
    }

    void __Qt4Ada_QWidget_font_0_wrapper(QObject* cpp_object, QFont* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::font();
    }

    QFontInfo* __Qt4Ada_QWidget_fontInfo_0_wrapper(QObject* cpp_object, void* storage)
    {
        return new (storage) QFontInfo(dynamic_cast<QWidget*>(cpp_object)->QWidget::fontInfo());
    }

    QFontMetrics* __Qt4Ada_QWidget_fontMetrics_0_wrapper(QObject* cpp_object, void* storage)
    {
        return new (storage) QFontMetrics(dynamic_cast<QWidget*>(cpp_object)->QWidget::fontMetrics());
    }

    void __Qt4Ada_QWidget_frameGeometry_0_wrapper(QObject* cpp_object, QRect* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::frameGeometry();
    }

    void __Qt4Ada_QWidget_frameSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::frameSize();
    }

    void __Qt4Ada_QWidget_grabKeyboard_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::grabKeyboard();
    }

    void __Qt4Ada_QWidget_grabMouse_1_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::grabMouse();
    }

    void __Qt4Ada_QWidget_grabMouse_0_wrapper(QObject* cpp_object, const QCursor* cursor)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::grabMouse(*cursor);
    }

    bool __Qt4Ada_QWidget_hasFocus_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::hasFocus();
    }

    bool __Qt4Ada_QWidget_hasMouseTracking_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::hasMouseTracking();
    }

    int __Qt4Ada_QWidget_height_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::height();
    }

    int __Qt4Ada_QWidget_heightForWidth_0_wrapper(QObject* cpp_object, int w)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::heightForWidth(w);
    }

    void __Qt4Ada_QWidget_inputMethodQuery_0_wrapper(QObject* cpp_object, Qt::InputMethodQuery query, QVariant* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::inputMethodQuery(query);
    }

    void __Qt4Ada_QWidget_insertAction_0_wrapper(QObject* cpp_object, QObject* before, QObject* action)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::insertAction(dynamic_cast<QAction*>(before), dynamic_cast<QAction*>(action));
    }

    bool __Qt4Ada_QWidget_isActiveWindow_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isActiveWindow();
    }

    bool __Qt4Ada_QWidget_isAncestorOf_0_wrapper(QObject* cpp_object, const QObject* child)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isAncestorOf(dynamic_cast<const QWidget*>(child));
    }

    bool __Qt4Ada_QWidget_isEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isEnabled();
    }

    bool __Qt4Ada_QWidget_isEnabledTo_0_wrapper(QObject* cpp_object, QObject* ancestor)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isEnabledTo(dynamic_cast<QWidget*>(ancestor));
    }

    bool __Qt4Ada_QWidget_isFullScreen_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isFullScreen();
    }

    bool __Qt4Ada_QWidget_isHidden_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isHidden();
    }

    bool __Qt4Ada_QWidget_isMaximized_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isMaximized();
    }

    bool __Qt4Ada_QWidget_isMinimized_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isMinimized();
    }

    bool __Qt4Ada_QWidget_isModal_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isModal();
    }

    bool __Qt4Ada_QWidget_isVisible_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isVisible();
    }

    bool __Qt4Ada_QWidget_isVisibleTo_0_wrapper(QObject* cpp_object, QObject* ancestor)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isVisibleTo(dynamic_cast<QWidget*>(ancestor));
    }

    bool __Qt4Ada_QWidget_isWindow_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isWindow();
    }

    bool __Qt4Ada_QWidget_isWindowModified_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::isWindowModified();
    }

    QObject* __Qt4Ada_QWidget_layout_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QWidget*>(cpp_object)->QWidget::layout());
    }

    void __Qt4Ada_QWidget_mapFrom_0_wrapper(QObject* cpp_object, QObject* parent, const QPoint* pos, QPoint* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::mapFrom(dynamic_cast<QWidget*>(parent), *pos);
    }

    void __Qt4Ada_QWidget_mapFromGlobal_0_wrapper(QObject* cpp_object, const QPoint* pos, QPoint* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::mapFromGlobal(*pos);
    }

    void __Qt4Ada_QWidget_mapFromParent_0_wrapper(QObject* cpp_object, const QPoint* pos, QPoint* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::mapFromParent(*pos);
    }

    void __Qt4Ada_QWidget_mapTo_0_wrapper(QObject* cpp_object, QObject* parent, const QPoint* pos, QPoint* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::mapTo(dynamic_cast<QWidget*>(parent), *pos);
    }

    void __Qt4Ada_QWidget_mapToGlobal_0_wrapper(QObject* cpp_object, const QPoint* pos, QPoint* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::mapToGlobal(*pos);
    }

    void __Qt4Ada_QWidget_mapToParent_0_wrapper(QObject* cpp_object, const QPoint* pos, QPoint* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::mapToParent(*pos);
    }

    void __Qt4Ada_QWidget_mask_0_wrapper(QObject* cpp_object, QRegion* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::mask();
    }

    int __Qt4Ada_QWidget_maximumHeight_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::maximumHeight();
    }

    void __Qt4Ada_QWidget_maximumSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::maximumSize();
    }

    int __Qt4Ada_QWidget_maximumWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::maximumWidth();
    }

    int __Qt4Ada_QWidget_minimumHeight_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::minimumHeight();
    }

    void __Qt4Ada_QWidget_minimumSize_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::minimumSize();
    }

    void __Qt4Ada_QWidget_minimumSizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::minimumSizeHint();
    }

    int __Qt4Ada_QWidget_minimumWidth_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::minimumWidth();
    }

    void __Qt4Ada_QWidget_move_1_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::move(*pos);
    }

    void __Qt4Ada_QWidget_move_0_wrapper(QObject* cpp_object, int x, int y)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::move(x, y);
    }

    QObject* __Qt4Ada_QWidget_nextInFocusChain_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QWidget*>(cpp_object)->QWidget::nextInFocusChain());
    }

    void __Qt4Ada_QWidget_normalGeometry_0_wrapper(QObject* cpp_object, QRect* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::normalGeometry();
    }

    void __Qt4Ada_QWidget_palette_0_wrapper(QObject* cpp_object, QPalette* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::palette();
    }

    QObject* __Qt4Ada_QWidget_parentWidget_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QWidget*>(cpp_object)->QWidget::parentWidget());
    }

    void __Qt4Ada_QWidget_pos_0_wrapper(QObject* cpp_object, QPoint* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::pos();
    }

    void __Qt4Ada_QWidget_rect_0_wrapper(QObject* cpp_object, QRect* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::rect();
    }

    void __Qt4Ada_QWidget_releaseKeyboard_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::releaseKeyboard();
    }

    void __Qt4Ada_QWidget_releaseMouse_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::releaseMouse();
    }

    void __Qt4Ada_QWidget_removeAction_0_wrapper(QObject* cpp_object, QObject* action)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::removeAction(dynamic_cast<QAction*>(action));
    }

    void __Qt4Ada_QWidget_repaint_3_wrapper(QObject* cpp_object, int x, int y, int w, int h)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::repaint(x, y, w, h);
    }

    void __Qt4Ada_QWidget_repaint_2_wrapper(QObject* cpp_object, const QRect* r)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::repaint(*r);
    }

    void __Qt4Ada_QWidget_repaint_1_wrapper(QObject* cpp_object, const QRegion* rng)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::repaint(*rng);
    }

    void __Qt4Ada_QWidget_resize_1_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::resize(*size);
    }

    void __Qt4Ada_QWidget_resize_0_wrapper(QObject* cpp_object, int w, int h)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::resize(w, h);
    }

    void __Qt4Ada_QWidget_restoreGeometry_0_wrapper(QObject* cpp_object, const QByteArray* geometry)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::restoreGeometry(*geometry);
    }

    void __Qt4Ada_QWidget_saveGeometry_0_wrapper(QObject* cpp_object, QByteArray* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::saveGeometry();
    }

    void __Qt4Ada_QWidget_scroll_1_wrapper(QObject* cpp_object, int dx, int dy)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::scroll(dx, dy);
    }

    void __Qt4Ada_QWidget_scroll_0_wrapper(QObject* cpp_object, int dx, int dy, const QRect* r)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::scroll(dx, dy, *r);
    }

    void __Qt4Ada_QWidget_setAcceptDrops_0_wrapper(QObject* cpp_object, bool on)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setAcceptDrops(on);
    }

    void __Qt4Ada_QWidget_setAccessibleDescription_0_wrapper(QObject* cpp_object, const QString* description)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setAccessibleDescription(*description);
    }

    void __Qt4Ada_QWidget_setAccessibleName_0_wrapper(QObject* cpp_object, const QString* name)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setAccessibleName(*name);
    }

    void __Qt4Ada_QWidget_setAttribute_0_wrapper(QObject* cpp_object, Qt::WidgetAttribute attribute, bool on)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setAttribute(attribute, on);
    }

    void __Qt4Ada_QWidget_setAutoFillBackground_0_wrapper(QObject* cpp_object, bool on)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setAutoFillBackground(on);
    }

    void __Qt4Ada_QWidget_setBaseSize_1_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setBaseSize(*size);
    }

    void __Qt4Ada_QWidget_setBaseSize_0_wrapper(QObject* cpp_object, int basew, int baseh)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setBaseSize(basew, baseh);
    }

    void __Qt4Ada_QWidget_setContentsMargins_0_wrapper(QObject* cpp_object, int left, int top, int right, int bottom)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setContentsMargins(left, top, right, bottom);
    }

    void __Qt4Ada_QWidget_setContextMenuPolicy_0_wrapper(QObject* cpp_object, Qt::ContextMenuPolicy policy)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setContextMenuPolicy(policy);
    }

    void __Qt4Ada_QWidget_setCursor_0_wrapper(QObject* cpp_object, const QCursor* cursor)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setCursor(*cursor);
    }

    void __Qt4Ada_QWidget_setFixedHeight_0_wrapper(QObject* cpp_object, int h)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setFixedHeight(h);
    }

    void __Qt4Ada_QWidget_setFixedSize_1_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setFixedSize(*size);
    }

    void __Qt4Ada_QWidget_setFixedSize_0_wrapper(QObject* cpp_object, int w, int h)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setFixedSize(w, h);
    }

    void __Qt4Ada_QWidget_setFixedWidth_0_wrapper(QObject* cpp_object, int h)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setFixedWidth(h);
    }

    void __Qt4Ada_QWidget_setFocus_1_wrapper(QObject* cpp_object, Qt::FocusReason reason)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setFocus(reason);
    }

    void __Qt4Ada_QWidget_setFocusPolicy_0_wrapper(QObject* cpp_object, Qt::FocusPolicy policy)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setFocusPolicy(policy);
    }

    void __Qt4Ada_QWidget_setFocusProxy_0_wrapper(QObject* cpp_object, QObject* w)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setFocusProxy(dynamic_cast<QWidget*>(w));
    }

    void __Qt4Ada_QWidget_setFont_0_wrapper(QObject* cpp_object, const QFont* font)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setFont(*font);
    }

    void __Qt4Ada_QWidget_setGeometry_1_wrapper(QObject* cpp_object, const QRect* r)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setGeometry(*r);
    }

    void __Qt4Ada_QWidget_setGeometry_0_wrapper(QObject* cpp_object, int x, int y, int w, int h)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setGeometry(x, y, w, h);
    }

    void __Qt4Ada_QWidget_setLayout_0_wrapper(QObject* cpp_object, QObject* layout)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setLayout(dynamic_cast<QLayout*>(layout));
    }

    void __Qt4Ada_QWidget_setMask_0_wrapper(QObject* cpp_object, const QRegion* region)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setMask(*region);
    }

    void __Qt4Ada_QWidget_setMaximumHeight_0_wrapper(QObject* cpp_object, int maxh)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setMaximumHeight(maxh);
    }

    void __Qt4Ada_QWidget_setMaximumSize_1_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setMaximumSize(*size);
    }

    void __Qt4Ada_QWidget_setMaximumSize_0_wrapper(QObject* cpp_object, int maxw, int maxh)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setMaximumSize(maxw, maxh);
    }

    void __Qt4Ada_QWidget_setMaximumWidth_0_wrapper(QObject* cpp_object, int maxw)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setMaximumWidth(maxw);
    }

    void __Qt4Ada_QWidget_setMinimumHeight_0_wrapper(QObject* cpp_object, int minh)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setMinimumHeight(minh);
    }

    void __Qt4Ada_QWidget_setMinimumSize_1_wrapper(QObject* cpp_object, const QSize* size)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setMinimumSize(*size);
    }

    void __Qt4Ada_QWidget_setMinimumSize_0_wrapper(QObject* cpp_object, int minw, int minh)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setMinimumSize(minw, minh);
    }

    void __Qt4Ada_QWidget_setMinimumWidth_0_wrapper(QObject* cpp_object, int minw)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setMinimumWidth(minw);
    }

    void __Qt4Ada_QWidget_setMouseTracking_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setMouseTracking(enable);
    }

    void __Qt4Ada_QWidget_setPalette_0_wrapper(QObject* cpp_object, const QPalette* palette)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setPalette(*palette);
    }

    void __Qt4Ada_QWidget_setParent_1_wrapper(QObject* cpp_object, QObject* parent)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setParent(dynamic_cast<QWidget*>(parent));
    }

    void __Qt4Ada_QWidget_setSizeIncrement_1_wrapper(QObject* cpp_object, const QSize* inc)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setSizeIncrement(*inc);
    }

    void __Qt4Ada_QWidget_setSizeIncrement_0_wrapper(QObject* cpp_object, int w, int h)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setSizeIncrement(w, h);
    }

    void __Qt4Ada_QWidget_setStatusTip_0_wrapper(QObject* cpp_object, const QString* tip)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setStatusTip(*tip);
    }

    void __Qt4Ada_QWidget_setStyle_0_wrapper(QObject* cpp_object, QObject* style)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setStyle(dynamic_cast<QStyle*>(style));
    }

    void __Qt4Ada_QWidget_setToolTip_0_wrapper(QObject* cpp_object, const QString* tip)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setToolTip(*tip);
    }

    void __Qt4Ada_QWidget_setUpdatesEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setUpdatesEnabled(enable);
    }

    void __Qt4Ada_QWidget_setWhatsThis_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setWhatsThis(*text);
    }

    void __Qt4Ada_QWidget_setWindowIcon_0_wrapper(QObject* cpp_object, const QIcon* icon)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setWindowIcon(*icon);
    }

    void __Qt4Ada_QWidget_setWindowIconText_0_wrapper(QObject* cpp_object, const QString* text)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setWindowIconText(*text);
    }

    void __Qt4Ada_QWidget_setWindowRole_0_wrapper(QObject* cpp_object, const QString* role)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setWindowRole(*role);
    }

    void __Qt4Ada_QWidget_size_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::size();
    }

    void __Qt4Ada_QWidget_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::sizeHint();
    }

    void __Qt4Ada_QWidget_sizeIncrement_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::sizeIncrement();
    }

    void __Qt4Ada_QWidget_sizePolicy_0_wrapper(QObject* cpp_object, QSizePolicy* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::sizePolicy();
    }

    void __Qt4Ada_QWidget_stackUnder_0_wrapper(QObject* cpp_object, QObject* w)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::stackUnder(dynamic_cast<QWidget*>(w));
    }

    void __Qt4Ada_QWidget_statusTip_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::statusTip();
    }

    QObject* __Qt4Ada_QWidget_style_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QWidget*>(cpp_object)->QWidget::style());
    }

    void __Qt4Ada_QWidget_styleSheet_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::styleSheet();
    }

    bool __Qt4Ada_QWidget_testAttribute_0_wrapper(QObject* cpp_object, Qt::WidgetAttribute attribute)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::testAttribute(attribute);
    }

    void __Qt4Ada_QWidget_toolTip_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::toolTip();
    }

    bool __Qt4Ada_QWidget_underMouse_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::underMouse();
    }

    void __Qt4Ada_QWidget_unsetCursor_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::unsetCursor();
    }

    void __Qt4Ada_QWidget_unsetLayoutDirection_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::unsetLayoutDirection();
    }

    void __Qt4Ada_QWidget_update_3_wrapper(QObject* cpp_object, int x, int y, int w, int h)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::update(x, y, w, h);
    }

    void __Qt4Ada_QWidget_update_2_wrapper(QObject* cpp_object, const QRect* r)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::update(*r);
    }

    void __Qt4Ada_QWidget_update_1_wrapper(QObject* cpp_object, const QRegion* rng)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::update(*rng);
    }

    void __Qt4Ada_QWidget_updateGeometry_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::updateGeometry();
    }

    bool __Qt4Ada_QWidget_updatesEnabled_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::updatesEnabled();
    }

    void __Qt4Ada_QWidget_visibleRegion_0_wrapper(QObject* cpp_object, QRegion* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::visibleRegion();
    }

    void __Qt4Ada_QWidget_whatsThis_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::whatsThis();
    }

    int __Qt4Ada_QWidget_width_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::width();
    }

    WId __Qt4Ada_QWidget_winId_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::winId();
    }

    QObject* __Qt4Ada_QWidget_window_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QWidget*>(cpp_object)->QWidget::window());
    }

    void __Qt4Ada_QWidget_windowIcon_0_wrapper(QObject* cpp_object, QIcon* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::windowIcon();
    }

    void __Qt4Ada_QWidget_windowIconText_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::windowIconText();
    }

    void __Qt4Ada_QWidget_windowRole_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::windowRole();
    }

    void __Qt4Ada_QWidget_windowTitle_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWidget*>(cpp_object)->QWidget::windowTitle();
    }

    int __Qt4Ada_QWidget_x_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::x();
    }

    int __Qt4Ada_QWidget_y_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::y();
    }

    bool __Qt4Ada_QWidget_close_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidget*>(cpp_object)->QWidget::close();
    }

    void __Qt4Ada_QWidget_hide_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::hide();
    }

    void __Qt4Ada_QWidget_lower_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::lower();
    }

    void __Qt4Ada_QWidget_raise_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::raise();
    }

    void __Qt4Ada_QWidget_repaint_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::repaint();
    }

    void __Qt4Ada_QWidget_setDisabled_0_wrapper(QObject* cpp_object, bool disable)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setDisabled(disable);
    }

    void __Qt4Ada_QWidget_setEnabled_0_wrapper(QObject* cpp_object, bool enable)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setEnabled(enable);
    }

    void __Qt4Ada_QWidget_setFocus_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setFocus();
    }

    void __Qt4Ada_QWidget_setHidden_0_wrapper(QObject* cpp_object, bool hidden)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setHidden(hidden);
    }

    void __Qt4Ada_QWidget_setStyleSheet_0_wrapper(QObject* cpp_object, const QString* styleSheet)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setStyleSheet(*styleSheet);
    }

    void __Qt4Ada_QWidget_setVisible_0_wrapper(QObject* cpp_object, bool visible)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setVisible(visible);
    }

    void __Qt4Ada_QWidget_setWindowModified_0_wrapper(QObject* cpp_object, bool value)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setWindowModified(value);
    }

    void __Qt4Ada_QWidget_setWindowTitle_0_wrapper(QObject* cpp_object, const QString* title)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::setWindowTitle(*title);
    }

    void __Qt4Ada_QWidget_show_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::show();
    }

    void __Qt4Ada_QWidget_showFullScreen_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::showFullScreen();
    }

    void __Qt4Ada_QWidget_showMaximized_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::showMaximized();
    }

    void __Qt4Ada_QWidget_showMinimized_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::showMinimized();
    }

    void __Qt4Ada_QWidget_showNormal_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::showNormal();
    }

    void __Qt4Ada_QWidget_update_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidget*>(cpp_object)->QWidget::update();
    }

    void __Qt4Ada_QWidget_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QWidget_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QWidget_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QWidget_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QWidget_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QWidget_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QWidget_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QWidget_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QWidget_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QWidget_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QWidget_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::event(e);
    }

    void __Qt4Ada_QWidget_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QWidget_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QWidget_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QWidget_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QWidget_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QWidget_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QWidget_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QWidget_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QWidget_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QWidget_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QWidget_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWidget_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWidget_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWidget_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWidget_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QWidget_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QWidget_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QWidget_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QWidget_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QWidget_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QWidget_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QWidget_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QWidgetDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QWidget_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QWidget_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QWidget_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWidgetDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QWidget_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWidgetDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QWidget_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QWidget*>(cpp_this)->QWidget::qt_metacast(name);
    }

    int __Qt4Ada_QWidget_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QWidget*>(cpp_this)->QWidget::qt_metacall(_c, _id, _a);
    }

}

int QWidgetDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QWidgetDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QWidgetDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QWidgetDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QWidgetDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QWidgetDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QWidgetDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QWidgetDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QWidgetDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QWidgetDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QWidgetDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QWidgetDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QWidgetDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QWidgetDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QWidgetDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QWidgetDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QWidgetDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
#include <QLayout>

QWidgetDirector::QWidgetDirector(void* o, QWidget*parent, Qt::WindowFlags flags) :
    QWidget (parent, flags),
    ada_object (o)
{
}

// QPaintEngine*QWidgetDirector::paintEngine()
// {
//     return __Qt4Ada_QWidget_paintEngine_dispatch(this->ada_object);
// }

void QWidgetDirector::connectNotify(const char*_p1)
{
    __Qt4Ada_QObject_connectNotify_dispatch(this->ada_object,_p1);
}

void QWidgetDirector::disconnectNotify(const char*_p1)
{
    __Qt4Ada_QObject_disconnectNotify_dispatch(this->ada_object,_p1);
}

extern "C" {

    QPaintDevice* __QtAda_QWidget_QPaintDevice_View(QObject*o)
    {
        return dynamic_cast<QPaintDevice*>(o);
    }

    QPaintEngine*__Qt4Ada_QWidget_paintEngine_wrapper(QObject*cpp_this)
    {
        return (dynamic_cast<QWidget*>(cpp_this))->QWidget::paintEngine();
    }

    QObject *__Qt4Ada_new_QWidget (QObject *parent, unsigned f)
    {
        return dynamic_cast<QObject *>(new QWidget (dynamic_cast <QWidget*> (parent), (Qt::WindowType)f));
    }

    QObject* __Qt4Ada_new_QWidgetDirector (void* ada_object, QObject *parent, unsigned f)
    {
        return dynamic_cast<QObject*>(new QWidgetDirector(ada_object,dynamic_cast<QWidget*>(parent), (Qt::WindowType)f));
    }

    void __Qt4Ada_QWidget_setSizePolicy_wrapper (QObject*     cpp_this,
                                                 QSizePolicy* value)
    {
        dynamic_cast<QWidget*>(cpp_this)->setSizePolicy(*value);
    }

    void __Qt4Ada_QWidget_setTabOrder_wrapper(QObject* first, QObject* second)
    {
        QWidget::setTabOrder(dynamic_cast<QWidget*>(first), dynamic_cast<QWidget*>(second));
    }

    void __Qt4Ada_QWidget_setWindowFlags_wrapper (QObject* cpp_ths, int flags)
    {
        dynamic_cast<QWidget*>(cpp_ths)->setWindowFlags (static_cast<Qt::WindowFlags> (flags));
    }

    QWidget* __QtAda_dynamic_cast_QWidget_from_QObject(QObject* object)
    {
        return dynamic_cast<QWidget*>(object);
    }

    QObject* __QtAda_dynamic_cast_QObject_from_QWidget(QWidget* object)
    {
        return dynamic_cast<QObject*>(object);
    }

}
