//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWizardPage>
#include <QAbstractButton>
#include <QString>
#include <QVariant>
#include <QPixmap>
#include <QSize>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QKeyEvent>
#include <QShowEvent>
#include <QActionEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qwizarddirector.h"
#include "qdialogdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QWizard_staticMetaObject =
        &QWizard::staticMetaObject;
}

extern "C"
{

    int __Qt4Ada_QWizard_nextId_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QWizard*>(cpp_object)->nextId();
    }

    bool __Qt4Ada_QWizard_validateCurrentPage_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QWizard*>(cpp_object)->validateCurrentPage();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    int __Qt4Ada_QWizard_addPage_0_wrapper(QObject* cpp_object, QObject* page)
    {
        return dynamic_cast<QWizard*>(cpp_object)->QWizard::addPage(dynamic_cast<QWizardPage*>(page));
    }

    QObject* __Qt4Ada_QWizard_button_0_wrapper(QObject* cpp_object, QWizard::WizardButton page)
    {
        return static_cast<QObject*>(dynamic_cast<QWizard*>(cpp_object)->QWizard::button(page));
    }

    void __Qt4Ada_QWizard_buttonText_0_wrapper(QObject* cpp_object, QWizard::WizardButton which, QString* returns)
    {
        *returns = dynamic_cast<QWizard*>(cpp_object)->QWizard::buttonText(which);
    }

    int __Qt4Ada_QWizard_currentId_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizard*>(cpp_object)->QWizard::currentId();
    }

    QObject* __Qt4Ada_QWizard_currentPage_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QWizard*>(cpp_object)->QWizard::currentPage());
    }

    void __Qt4Ada_QWizard_field_0_wrapper(QObject* cpp_object, const QString* name, QVariant* returns)
    {
        *returns = dynamic_cast<QWizard*>(cpp_object)->QWizard::field(*name);
    }

    bool __Qt4Ada_QWizard_hasVisitedPage_0_wrapper(QObject* cpp_object, int id)
    {
        return dynamic_cast<QWizard*>(cpp_object)->QWizard::hasVisitedPage(id);
    }

    int __Qt4Ada_QWizard_nextId_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizard*>(cpp_object)->QWizard::nextId();
    }

    QObject* __Qt4Ada_QWizard_page_0_wrapper(QObject* cpp_object, int id)
    {
        return static_cast<QObject*>(dynamic_cast<QWizard*>(cpp_object)->QWizard::page(id));
    }

    void __Qt4Ada_QWizard_pixmap_0_wrapper(QObject* cpp_object, QWizard::WizardPixmap id, QPixmap* returns)
    {
        *returns = dynamic_cast<QWizard*>(cpp_object)->QWizard::pixmap(id);
    }

    void __Qt4Ada_QWizard_setButton_0_wrapper(QObject* cpp_object, QWizard::WizardButton which, QObject* button)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setButton(which, dynamic_cast<QAbstractButton*>(button));
    }

    void __Qt4Ada_QWizard_setButtonText_0_wrapper(QObject* cpp_object, QWizard::WizardButton which, const QString* text)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setButtonText(which, *text);
    }

    void __Qt4Ada_QWizard_setField_0_wrapper(QObject* cpp_object, const QString* name, const QVariant* value)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setField(*name, *value);
    }

    void __Qt4Ada_QWizard_setOption_0_wrapper(QObject* cpp_object, QWizard::WizardOption which, bool on)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setOption(which, on);
    }

    void __Qt4Ada_QWizard_setPage_0_wrapper(QObject* cpp_object, int id, QObject* page)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setPage(id, dynamic_cast<QWizardPage*>(page));
    }

    void __Qt4Ada_QWizard_setPixmap_0_wrapper(QObject* cpp_object, QWizard::WizardPixmap which, const QPixmap* pixmap)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setPixmap(which, *pixmap);
    }

    void __Qt4Ada_QWizard_setStartId_0_wrapper(QObject* cpp_object, int id)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setStartId(id);
    }

    void __Qt4Ada_QWizard_setSubTitleFormat_0_wrapper(QObject* cpp_object, Qt::TextFormat format)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setSubTitleFormat(format);
    }

    void __Qt4Ada_QWizard_setTitleFormat_0_wrapper(QObject* cpp_object, Qt::TextFormat format)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setTitleFormat(format);
    }

    void __Qt4Ada_QWizard_setWizardStyle_0_wrapper(QObject* cpp_object, QWizard::WizardStyle style)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setWizardStyle(style);
    }

    int __Qt4Ada_QWizard_startId_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizard*>(cpp_object)->QWizard::startId();
    }

    Qt::TextFormat __Qt4Ada_QWizard_subTitleFormat_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizard*>(cpp_object)->QWizard::subTitleFormat();
    }

    bool __Qt4Ada_QWizard_testOption_0_wrapper(QObject* cpp_object, QWizard::WizardOption option)
    {
        return dynamic_cast<QWizard*>(cpp_object)->QWizard::testOption(option);
    }

    Qt::TextFormat __Qt4Ada_QWizard_titleFormat_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizard*>(cpp_object)->QWizard::titleFormat();
    }

    bool __Qt4Ada_QWizard_validateCurrentPage_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizard*>(cpp_object)->QWizard::validateCurrentPage();
    }

    QWizard::WizardStyle __Qt4Ada_QWizard_wizardStyle_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizard*>(cpp_object)->QWizard::wizardStyle();
    }

    void __Qt4Ada_QWizard_back_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::back();
    }

    void __Qt4Ada_QWizard_next_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::next();
    }

    void __Qt4Ada_QWizard_restart_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::restart();
    }

    void __Qt4Ada_QWizard_currentIdChanged_0_wrapper(QObject* cpp_object, int id)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWizard::currentIdChanged(id);
    }

    void __Qt4Ada_QWizard_customButtonClicked_0_wrapper(QObject* cpp_object, int which)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWizard::customButtonClicked(which);
    }

    void __Qt4Ada_QWizard_helpRequested_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWizard::helpRequested();
    }

    void __Qt4Ada_QWizard_cleanupPage_0_wrapper(QObject* cpp_object, int id)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWizard::cleanupPage(id);
    }

    void __Qt4Ada_QWizard_initializePage_0_wrapper(QObject* cpp_object, int id)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWizard::initializePage(id);
    }

    void __Qt4Ada_QWizard_setVisible_0_wrapper(QObject* cpp_object, bool visible)
    {
        dynamic_cast<QWizard*>(cpp_object)->QWizard::setVisible(visible);
    }

    void __Qt4Ada_QWizard_sizeHint_0_wrapper(QObject* cpp_object, QSize* returns)
    {
        *returns = dynamic_cast<QWizard*>(cpp_object)->QWizard::sizeHint();
    }

    bool __Qt4Ada_QWizard_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QWizardDirector*>(cpp_object)->QWizard::event(e);
    }

    void __Qt4Ada_QWizard_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWizard::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QWizard_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWizard::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QWizard_done_0_wrapper(QObject* cpp_object, int result)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWizard::done(result);
    }

    void __Qt4Ada_QWizard_accepted_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QDialog::accepted();
    }

    void __Qt4Ada_QWizard_finished_0_wrapper(QObject* cpp_object, int result)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QDialog::finished(result);
    }

    void __Qt4Ada_QWizard_rejected_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QDialog::rejected();
    }

    void __Qt4Ada_QWizard_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QDialog::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QWizard_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QDialog::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    bool __Qt4Ada_QWizard_eventFilter_0_wrapper(QObject* cpp_object, QObject* watched, QEvent* event)
    {
        return dynamic_cast<QWizardDirector*>(cpp_object)->QDialog::eventFilter(watched, event);
    }

    void __Qt4Ada_QWizard_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QDialog::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QWizard_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QDialog::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QWizard_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QWizard_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QWizard_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QWizard_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QWizard_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QWizard_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QWizard_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QWizard_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QWizard_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QWizard_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QWizard_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QWizard_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QWizard_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QWizard_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QWizard_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QWizard_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QWizard_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QWizard_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWizard_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWizard_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWizard_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWizard_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QWizard_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QWizard_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QWizard_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QWizard_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QWizardDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QWizard_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QWizard_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QWizard_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QWizard_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QWizard_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QWizard*>(cpp_this)->QWizard::qt_metacast(name);
    }

    int __Qt4Ada_QWizard_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QWizard*>(cpp_this)->QWizard::qt_metacall(_c, _id, _a);
    }

}

int QWizardDirector::nextId() const
{
    return __Qt4Ada_QWizard_nextId_0_dispatch(this->ada_object);
}

bool QWizardDirector::validateCurrentPage()
{
    return __Qt4Ada_QWizard_validateCurrentPage_0_dispatch(this->ada_object);
}

void QWizardDirector::cleanupPage(int id)
{
    __Qt4Ada_QWizard_cleanupPage_0_dispatch(this->ada_object, id);
}

void QWizardDirector::initializePage(int id)
{
    __Qt4Ada_QWizard_initializePage_0_dispatch(this->ada_object, id);
}

void QWizardDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

QSize QWizardDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

bool QWizardDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QWizardDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::done(int result)
{
    __Qt4Ada_QDialog_done_0_dispatch(this->ada_object, result);
}

void QWizardDirector::accept()
{
    __Qt4Ada_QDialog_accept_0_dispatch(this->ada_object);
}

void QWizardDirector::reject()
{
    __Qt4Ada_QDialog_reject_0_dispatch(this->ada_object);
}

QSize QWizardDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QWizardDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

bool QWizardDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QWizardDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

int QWizardDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QWizardDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

void QWizardDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QWizardDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QWizardDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QWizardDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

void QWizardDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QWizardDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QWizardDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QWizardDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QWizardDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QWizardDirector::QWizardDirector(void* o, QWidget* parent, Qt::WindowFlags flags) :
    QWizard (parent, flags),
    ada_object (o)
{
}

extern "C" {

    QObject* __Qt4Ada_new_QWizard(QObject* parent, unsigned f)
    {
        return dynamic_cast<QObject*>(new QWizard(dynamic_cast<QWidget*>(parent), (Qt::WindowType)f));
    }

    QObject* __Qt4Ada_new_QWizardDirector(void* ada_object, QObject* parent, unsigned f)
    {
        return dynamic_cast<QObject*>(new QWizardDirector(ada_object, dynamic_cast<QWidget*>(parent), (Qt::WindowType)f));
    }

}
