//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QWIZARDDIRECTOR_H__
#define __QWIZARDDIRECTOR_H__

#include <QWizard>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QWizard_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern int __Qt4Ada_QWizard_nextId_0_dispatch(void*);
    extern bool __Qt4Ada_QWizard_validateCurrentPage_0_dispatch(void*);
    extern void __Qt4Ada_QWizard_cleanupPage_0_dispatch(void*, int);
    extern void __Qt4Ada_QWizard_initializePage_0_dispatch(void*, int);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern int __Qt4Ada_QWizard_nextId_0_virtual(QObject*);
    extern bool __Qt4Ada_QWizard_validateCurrentPage_0_virtual(QObject*);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern int __Qt4Ada_QWizard_addPage_0_wrapper(QObject*, QObject*);
    extern QObject* __Qt4Ada_QWizard_button_0_wrapper(QObject*, QWizard::WizardButton);
    extern void __Qt4Ada_QWizard_buttonText_0_wrapper(QObject*, QWizard::WizardButton, QString*);
    extern int __Qt4Ada_QWizard_currentId_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QWizard_currentPage_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizard_field_0_wrapper(QObject*, const QString*, QVariant*);
    extern bool __Qt4Ada_QWizard_hasVisitedPage_0_wrapper(QObject*, int);
    extern int __Qt4Ada_QWizard_nextId_0_wrapper(QObject*);
    extern QObject* __Qt4Ada_QWizard_page_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWizard_pixmap_0_wrapper(QObject*, QWizard::WizardPixmap, QPixmap*);
    extern void __Qt4Ada_QWizard_setButton_0_wrapper(QObject*, QWizard::WizardButton, QObject*);
    extern void __Qt4Ada_QWizard_setButtonText_0_wrapper(QObject*, QWizard::WizardButton, const QString*);
    extern void __Qt4Ada_QWizard_setField_0_wrapper(QObject*, const QString*, const QVariant*);
    extern void __Qt4Ada_QWizard_setOption_0_wrapper(QObject*, QWizard::WizardOption, bool);
    extern void __Qt4Ada_QWizard_setPage_0_wrapper(QObject*, int, QObject*);
    extern void __Qt4Ada_QWizard_setPixmap_0_wrapper(QObject*, QWizard::WizardPixmap, const QPixmap*);
    extern void __Qt4Ada_QWizard_setStartId_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWizard_setSubTitleFormat_0_wrapper(QObject*, Qt::TextFormat);
    extern void __Qt4Ada_QWizard_setTitleFormat_0_wrapper(QObject*, Qt::TextFormat);
    extern void __Qt4Ada_QWizard_setWizardStyle_0_wrapper(QObject*, QWizard::WizardStyle);
    extern int __Qt4Ada_QWizard_startId_0_wrapper(QObject*);
    extern Qt::TextFormat __Qt4Ada_QWizard_subTitleFormat_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWizard_testOption_0_wrapper(QObject*, QWizard::WizardOption);
    extern Qt::TextFormat __Qt4Ada_QWizard_titleFormat_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWizard_validateCurrentPage_0_wrapper(QObject*);
    extern QWizard::WizardStyle __Qt4Ada_QWizard_wizardStyle_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizard_back_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizard_next_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizard_restart_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizard_currentIdChanged_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWizard_customButtonClicked_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWizard_helpRequested_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizard_cleanupPage_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWizard_initializePage_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWizard_setVisible_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWizard_sizeHint_0_wrapper(QObject*, QSize*);
    extern bool __Qt4Ada_QWizard_event_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_paintEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_resizeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_done_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWizard_accepted_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizard_finished_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QWizard_rejected_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizard_closeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QWizard_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_keyPressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_showEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    extern void __Qt4Ada_QWizard_actionEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_changeEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_dropEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_enterEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_focusInEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QWizard_focusNextChild_0_wrapper(QObject*);
    extern bool __Qt4Ada_QWizard_focusNextPrevChild_0_wrapper(QObject*, bool);
    extern void __Qt4Ada_QWizard_focusOutEvent_0_wrapper(QObject*, QEvent*);
    extern bool __Qt4Ada_QWizard_focusPreviousChild_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizard_hideEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_leaveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_mousePressEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_moveEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_resetInputContext_0_wrapper(QObject*);
    extern void __Qt4Ada_QWizard_tabletEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_wheelEvent_0_wrapper(QObject*, QEvent*);
    extern int __Qt4Ada_QWizard_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    extern void __Qt4Ada_QWizard_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QWizard_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QWizard_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QWizard_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QWizard_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject* __Qt4Ada_new_QWizard(QObject*, unsigned);
    extern QObject* __Qt4Ada_new_QWizardDirector(void*, QObject*, unsigned);

}

class QWizardDirector : public QWizard
{
protected:
    void* ada_object;
public:
    QWizardDirector(void*, QWidget*, Qt::WindowFlags);

    virtual int nextId() const;
    virtual bool validateCurrentPage();
    virtual void cleanupPage(int);
    virtual void initializePage(int);
    virtual void setVisible(bool);
    virtual QSize sizeHint() const;
    virtual bool event(QEvent*);
    virtual void paintEvent(QPaintEvent*);
    virtual void resizeEvent(QResizeEvent*);
    virtual void done(int);
    virtual void accept();
    virtual void reject();
    virtual QSize minimumSizeHint() const;
    virtual void closeEvent(QCloseEvent*);
    virtual void contextMenuEvent(QContextMenuEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void keyPressEvent(QKeyEvent*);
    virtual void showEvent(QShowEvent*);
    virtual int heightForWidth(int) const;
    virtual QVariant inputMethodQuery(Qt::InputMethodQuery) const;
    virtual void actionEvent(QActionEvent*);
    virtual void changeEvent(QEvent*);
    virtual void dragEnterEvent(QDragEnterEvent*);
    virtual void dragLeaveEvent(QDragLeaveEvent*);
    virtual void dragMoveEvent(QDragMoveEvent*);
    virtual void dropEvent(QDropEvent*);
    virtual void enterEvent(QEvent*);
    virtual void focusInEvent(QFocusEvent*);
    virtual bool focusNextPrevChild(bool);
    virtual void focusOutEvent(QFocusEvent*);
    virtual void hideEvent(QHideEvent*);
    virtual void inputMethodEvent(QInputMethodEvent*);
    virtual void keyReleaseEvent(QKeyEvent*);
    virtual void leaveEvent(QEvent*);
    virtual void mouseDoubleClickEvent(QMouseEvent*);
    virtual void mouseMoveEvent(QMouseEvent*);
    virtual void mousePressEvent(QMouseEvent*);
    virtual void mouseReleaseEvent(QMouseEvent*);
    virtual void moveEvent(QMoveEvent*);
    virtual void tabletEvent(QTabletEvent*);
    virtual void wheelEvent(QWheelEvent*);
    virtual int metric(QPaintDevice::PaintDeviceMetric) const;
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QWizard_currentIdChanged_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QWizard_customButtonClicked_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QWizard_helpRequested_0_wrapper(QObject*);
    friend void __Qt4Ada_QWizard_cleanupPage_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QWizard_initializePage_0_wrapper(QObject*, int);
    friend bool __Qt4Ada_QWizard_event_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_paintEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_resizeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_done_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QWizard_accepted_0_wrapper(QObject*);
    friend void __Qt4Ada_QWizard_finished_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QWizard_rejected_0_wrapper(QObject*);
    friend void __Qt4Ada_QWizard_closeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_contextMenuEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QWizard_eventFilter_0_wrapper(QObject*, QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_keyPressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_showEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_customContextMenuRequested_0_wrapper(QObject*, const QPoint*);
    friend void __Qt4Ada_QWizard_actionEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_changeEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_dragEnterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_dragLeaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_dragMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_dropEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_enterEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_focusInEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QWizard_focusNextChild_0_wrapper(QObject*);
    friend bool __Qt4Ada_QWizard_focusNextPrevChild_0_wrapper(QObject*, bool);
    friend void __Qt4Ada_QWizard_focusOutEvent_0_wrapper(QObject*, QEvent*);
    friend bool __Qt4Ada_QWizard_focusPreviousChild_0_wrapper(QObject*);
    friend void __Qt4Ada_QWizard_hideEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_inputMethodEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_keyReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_leaveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_mouseDoubleClickEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_mouseMoveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_mousePressEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_mouseReleaseEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_moveEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_resetInputContext_0_wrapper(QObject*);
    friend void __Qt4Ada_QWizard_tabletEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_wheelEvent_0_wrapper(QObject*, QEvent*);
    friend int __Qt4Ada_QWizard_metric_0_wrapper(QObject*, QPaintDevice::PaintDeviceMetric);
    friend void __Qt4Ada_QWizard_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QWizard_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QWizard_sender_0_wrapper(QObject*);
};

#endif // __QWIZARDDIRECTOR_H__
