//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QString>
#include <QPixmap>
#include <QVariant>
#include <QWizard>
#include <QSize>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QPaintEvent>
#include <QResizeEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qwizardpagedirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QWizardPage_staticMetaObject =
        &QWizardPage::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QWizardPage_cleanupPage_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QWizardPage*>(cpp_object)->cleanupPage();
    }

    void __Qt4Ada_QWizardPage_initializePage_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QWizardPage*>(cpp_object)->initializePage();
    }

    bool __Qt4Ada_QWizardPage_isComplete_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPage*>(cpp_object)->isComplete();
    }

    int __Qt4Ada_QWizardPage_nextId_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPage*>(cpp_object)->nextId();
    }

    bool __Qt4Ada_QWizardPage_validatePage_0_virtual(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPage*>(cpp_object)->validatePage();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QWizardPage_buttonText_0_wrapper(QObject* cpp_object, QWizard::WizardButton which, QString* returns)
    {
        *returns = dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::buttonText(which);
    }

    void __Qt4Ada_QWizardPage_cleanupPage_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::cleanupPage();
    }

    void __Qt4Ada_QWizardPage_initializePage_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::initializePage();
    }

    bool __Qt4Ada_QWizardPage_isCommitPage_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::isCommitPage();
    }

    bool __Qt4Ada_QWizardPage_isComplete_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::isComplete();
    }

    bool __Qt4Ada_QWizardPage_isFinalPage_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::isFinalPage();
    }

    int __Qt4Ada_QWizardPage_nextId_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::nextId();
    }

    void __Qt4Ada_QWizardPage_pixmap_0_wrapper(QObject* cpp_object, QWizard::WizardPixmap which, QPixmap* returns)
    {
        *returns = dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::pixmap(which);
    }

    void __Qt4Ada_QWizardPage_setButtonText_0_wrapper(QObject* cpp_object, QWizard::WizardButton which, const QString* text)
    {
        dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::setButtonText(which, *text);
    }

    void __Qt4Ada_QWizardPage_setCommitPage_0_wrapper(QObject* cpp_object, bool commitPage)
    {
        dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::setCommitPage(commitPage);
    }

    void __Qt4Ada_QWizardPage_setFinalPage_0_wrapper(QObject* cpp_object, bool finalPage)
    {
        dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::setFinalPage(finalPage);
    }

    void __Qt4Ada_QWizardPage_setPixmap_0_wrapper(QObject* cpp_object, QWizard::WizardPixmap which, const QPixmap* pixmap)
    {
        dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::setPixmap(which, *pixmap);
    }

    void __Qt4Ada_QWizardPage_setSubTitle_0_wrapper(QObject* cpp_object, const QString* subTitle)
    {
        dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::setSubTitle(*subTitle);
    }

    void __Qt4Ada_QWizardPage_setTitle_0_wrapper(QObject* cpp_object, const QString* title)
    {
        dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::setTitle(*title);
    }

    void __Qt4Ada_QWizardPage_subTitle_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::subTitle();
    }

    void __Qt4Ada_QWizardPage_title_0_wrapper(QObject* cpp_object, QString* returns)
    {
        *returns = dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::title();
    }

    bool __Qt4Ada_QWizardPage_validatePage_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPage*>(cpp_object)->QWizardPage::validatePage();
    }

    void __Qt4Ada_QWizardPage_completeChanged_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWizardPage::completeChanged();
    }

    void __Qt4Ada_QWizardPage_field_0_wrapper(QObject* cpp_object, const QString* name, QVariant* returns)
    {
        *returns = dynamic_cast<QWizardPageDirector*>(cpp_object)->QWizardPage::field(*name);
    }

    void __Qt4Ada_QWizardPage_setField_0_wrapper(QObject* cpp_object, const QString* name, const QVariant* value)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWizardPage::setField(*name, *value);
    }

    QObject* __Qt4Ada_QWizardPage_wizard_0_wrapper(QObject* cpp_object)
    {
        return static_cast<QObject*>(dynamic_cast<QWizardPageDirector*>(cpp_object)->QWizardPage::wizard());
    }

    void __Qt4Ada_QWizardPage_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QWizardPage_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QWizardPage_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    bool __Qt4Ada_QWizardPage_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::event(e);
    }

    void __Qt4Ada_QWizardPage_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QWizardPage_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QWizardPage_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QWizardPage_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QWizardPage_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QWizardPage_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QWizardPage_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QWizardPage_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QWizardPage_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QWizardPageDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QWizardPage_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QWizardPage_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QWizardPage_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QWizardPageDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QWizardPage_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QWizardPageDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QWizardPage_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QWizardPage*>(cpp_this)->QWizardPage::qt_metacast(name);
    }

    int __Qt4Ada_QWizardPage_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QWizardPage*>(cpp_this)->QWizardPage::qt_metacall(_c, _id, _a);
    }

}

void QWizardPageDirector::cleanupPage()
{
    __Qt4Ada_QWizardPage_cleanupPage_0_dispatch(this->ada_object);
}

void QWizardPageDirector::initializePage()
{
    __Qt4Ada_QWizardPage_initializePage_0_dispatch(this->ada_object);
}

bool QWizardPageDirector::isComplete() const
{
    return __Qt4Ada_QWizardPage_isComplete_0_dispatch(this->ada_object);
}

int QWizardPageDirector::nextId() const
{
    return __Qt4Ada_QWizardPage_nextId_0_dispatch(this->ada_object);
}

bool QWizardPageDirector::validatePage()
{
    return __Qt4Ada_QWizardPage_validatePage_0_dispatch(this->ada_object);
}

int QWizardPageDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QWizardPageDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QWizardPageDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QWizardPageDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QWizardPageDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QWizardPageDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

bool QWizardPageDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QWizardPageDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QWizardPageDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QWizardPageDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QWizardPageDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QWizardPageDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QWizardPageDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QWizardPageDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QWizardPageDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QWizardPageDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QWizardPageDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QWizardPageDirector::QWizardPageDirector(void* o, QWidget* parent) :
    QWizardPage (parent),
    ada_object (o)
{
}

extern "C" {

    QObject* __Qt4Ada_new_QWizardPage(QObject* parent)
    {
        return dynamic_cast<QObject*>(new QWizardPage(dynamic_cast<QWidget*>(parent)));
    }

    QObject* __Qt4Ada_new_QWizardPageDirector(void* ada_object, QObject* parent)
    {
        return dynamic_cast<QObject*>(new QWizardPageDirector(ada_object, dynamic_cast<QWidget*>(parent)));
    }

}
