//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QPaintEvent>
#include <QResizeEvent>
#include <QVariant>
#include <QSize>
#include <QActionEvent>
#include <QCloseEvent>
#include <QContextMenuEvent>
#include <QDragEnterEvent>
#include <QDragLeaveEvent>
#include <QDragMoveEvent>
#include <QDropEvent>
#include <QFocusEvent>
#include <QHideEvent>
#include <QInputMethodEvent>
#include <QKeyEvent>
#include <QMouseEvent>
#include <QMoveEvent>
#include <QShowEvent>
#include <QTabletEvent>
#include <QWheelEvent>
#include <QChildEvent>
#include <QTimerEvent>

#include "qglwidgetdirector.h"
#include "qwidgetdirector.h"
#include "qobjectdirector.h"
#include "qpaintdevicedirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QGLWidget_staticMetaObject =
        &QGLWidget::staticMetaObject;
}

extern "C"
{

    void __Qt4Ada_QGLWidget_updateGL_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QGLWidget*>(cpp_object)->updateGL();
    }

    void __Qt4Ada_QGLWidget_updateOverlayGL_0_virtual(QObject* cpp_object)
    {
        dynamic_cast<QGLWidget*>(cpp_object)->updateOverlayGL();
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QGLWidget_qglClearColor_0_wrapper(QObject* cpp_object, const QColor* c)
    {
        dynamic_cast<QGLWidget*>(cpp_object)->QGLWidget::qglClearColor(*c);
    }

    void __Qt4Ada_QGLWidget_qglColor_0_wrapper(QObject* cpp_object, const QColor* c)
    {
        dynamic_cast<QGLWidget*>(cpp_object)->QGLWidget::qglColor(*c);
    }

    void __Qt4Ada_QGLWidget_updateGL_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGLWidget*>(cpp_object)->QGLWidget::updateGL();
    }

    void __Qt4Ada_QGLWidget_updateOverlayGL_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGLWidget*>(cpp_object)->QGLWidget::updateOverlayGL();
    }

    bool __Qt4Ada_QGLWidget_autoBufferSwap_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::autoBufferSwap();
    }

    void __Qt4Ada_QGLWidget_glDraw_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::glDraw();
    }

    void __Qt4Ada_QGLWidget_glInit_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::glInit();
    }

    void __Qt4Ada_QGLWidget_initializeGL_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::initializeGL();
    }

    void __Qt4Ada_QGLWidget_initializeOverlayGL_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::initializeOverlayGL();
    }

    void __Qt4Ada_QGLWidget_paintGL_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::paintGL();
    }

    void __Qt4Ada_QGLWidget_paintOverlayGL_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::paintOverlayGL();
    }

    void __Qt4Ada_QGLWidget_resizeGL_0_wrapper(QObject* cpp_object, int width, int height)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::resizeGL(width, height);
    }

    void __Qt4Ada_QGLWidget_resizeOverlayGL_0_wrapper(QObject* cpp_object, int width, int height)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::resizeOverlayGL(width, height);
    }

    void __Qt4Ada_QGLWidget_setAutoBufferSwap_0_wrapper(QObject* cpp_object, bool on)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::setAutoBufferSwap(on);
    }

    bool __Qt4Ada_QGLWidget_event_0_wrapper(QObject* cpp_object, QEvent* e)
    {
        return dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::event(e);
    }

    void __Qt4Ada_QGLWidget_paintEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::paintEvent(dynamic_cast<QPaintEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_resizeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QGLWidget::resizeEvent(dynamic_cast<QResizeEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_customContextMenuRequested_0_wrapper(QObject* cpp_object, const QPoint* pos)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::customContextMenuRequested(*pos);
    }

    void __Qt4Ada_QGLWidget_actionEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::actionEvent(dynamic_cast<QActionEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_changeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::changeEvent(event);
    }

    void __Qt4Ada_QGLWidget_closeEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::closeEvent(dynamic_cast<QCloseEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_contextMenuEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::contextMenuEvent(dynamic_cast<QContextMenuEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_dragEnterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::dragEnterEvent(dynamic_cast<QDragEnterEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_dragLeaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::dragLeaveEvent(dynamic_cast<QDragLeaveEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_dragMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::dragMoveEvent(dynamic_cast<QDragMoveEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_dropEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::dropEvent(dynamic_cast<QDropEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_enterEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::enterEvent(event);
    }

    void __Qt4Ada_QGLWidget_focusInEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::focusInEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QGLWidget_focusNextChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::focusNextChild();
    }

    bool __Qt4Ada_QGLWidget_focusNextPrevChild_0_wrapper(QObject* cpp_object, bool next)
    {
        return dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::focusNextPrevChild(next);
    }

    void __Qt4Ada_QGLWidget_focusOutEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::focusOutEvent(dynamic_cast<QFocusEvent*>(event));
    }

    bool __Qt4Ada_QGLWidget_focusPreviousChild_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::focusPreviousChild();
    }

    void __Qt4Ada_QGLWidget_hideEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::hideEvent(dynamic_cast<QHideEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_inputMethodEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::inputMethodEvent(dynamic_cast<QInputMethodEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_keyPressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::keyPressEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_keyReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::keyReleaseEvent(dynamic_cast<QKeyEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_leaveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::leaveEvent(event);
    }

    void __Qt4Ada_QGLWidget_mouseDoubleClickEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::mouseDoubleClickEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_mouseMoveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::mouseMoveEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_mousePressEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::mousePressEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_mouseReleaseEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::mouseReleaseEvent(dynamic_cast<QMouseEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_moveEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::moveEvent(dynamic_cast<QMoveEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_resetInputContext_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::resetInputContext();
    }

    void __Qt4Ada_QGLWidget_showEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::showEvent(dynamic_cast<QShowEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_tabletEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::tabletEvent(dynamic_cast<QTabletEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_wheelEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::wheelEvent(dynamic_cast<QWheelEvent*>(event));
    }

    int __Qt4Ada_QGLWidget_metric_0_wrapper(QObject* cpp_object, QPaintDevice::PaintDeviceMetric metric)
    {
        return dynamic_cast<QGLWidgetDirector*>(cpp_object)->QWidget::metric(metric);
    }

    void __Qt4Ada_QGLWidget_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QGLWidget_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QGLWidget_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QGLWidgetDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QGLWidget_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QGLWidgetDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QGLWidget_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QGLWidget*>(cpp_this)->QGLWidget::qt_metacast(name);
    }

    int __Qt4Ada_QGLWidget_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QGLWidget*>(cpp_this)->QGLWidget::qt_metacall(_c, _id, _a);
    }

}

void QGLWidgetDirector::updateGL()
{
    __Qt4Ada_QGLWidget_updateGL_0_dispatch(this->ada_object);
}

void QGLWidgetDirector::updateOverlayGL()
{
    __Qt4Ada_QGLWidget_updateOverlayGL_0_dispatch(this->ada_object);
}

bool QGLWidgetDirector::autoBufferSwap() const
{
    return __Qt4Ada_QGLWidget_autoBufferSwap_0_dispatch(this->ada_object);
}

void QGLWidgetDirector::glDraw()
{
    __Qt4Ada_QGLWidget_glDraw_0_dispatch(this->ada_object);
}

void QGLWidgetDirector::glInit()
{
    __Qt4Ada_QGLWidget_glInit_0_dispatch(this->ada_object);
}

void QGLWidgetDirector::initializeGL()
{
    __Qt4Ada_QGLWidget_initializeGL_0_dispatch(this->ada_object);
}

void QGLWidgetDirector::initializeOverlayGL()
{
    __Qt4Ada_QGLWidget_initializeOverlayGL_0_dispatch(this->ada_object);
}

void QGLWidgetDirector::paintGL()
{
    __Qt4Ada_QGLWidget_paintGL_0_dispatch(this->ada_object);
}

void QGLWidgetDirector::paintOverlayGL()
{
    __Qt4Ada_QGLWidget_paintOverlayGL_0_dispatch(this->ada_object);
}

void QGLWidgetDirector::resizeGL(int width, int height)
{
    __Qt4Ada_QGLWidget_resizeGL_0_dispatch(this->ada_object, width, height);
}

void QGLWidgetDirector::resizeOverlayGL(int width, int height)
{
    __Qt4Ada_QGLWidget_resizeOverlayGL_0_dispatch(this->ada_object, width, height);
}

void QGLWidgetDirector::setAutoBufferSwap(bool on)
{
    __Qt4Ada_QGLWidget_setAutoBufferSwap_0_dispatch(this->ada_object, on);
}

bool QGLWidgetDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

void QGLWidgetDirector::paintEvent(QPaintEvent* event)
{
    __Qt4Ada_QWidget_paintEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::resizeEvent(QResizeEvent* event)
{
    __Qt4Ada_QWidget_resizeEvent_0_dispatch(this->ada_object, event);
}

int QGLWidgetDirector::heightForWidth(int w) const
{
    return __Qt4Ada_QWidget_heightForWidth_0_dispatch(this->ada_object, w);
}

QVariant QGLWidgetDirector::inputMethodQuery(Qt::InputMethodQuery query) const
{
    QVariant *aux = __Qt4Ada_QWidget_inputMethodQuery_0_dispatch(this->ada_object, query);
    QVariant returns = *aux;
    delete aux;
    return returns;
}

QSize QGLWidgetDirector::minimumSizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_minimumSizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

QSize QGLWidgetDirector::sizeHint() const
{
    QSize *aux = __Qt4Ada_QWidget_sizeHint_0_dispatch(this->ada_object);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QGLWidgetDirector::setVisible(bool visible)
{
    __Qt4Ada_QWidget_setVisible_0_dispatch(this->ada_object, visible);
}

void QGLWidgetDirector::actionEvent(QActionEvent* event)
{
    __Qt4Ada_QWidget_actionEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::changeEvent(QEvent* event)
{
    __Qt4Ada_QWidget_changeEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::closeEvent(QCloseEvent* event)
{
    __Qt4Ada_QWidget_closeEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::contextMenuEvent(QContextMenuEvent* event)
{
    __Qt4Ada_QWidget_contextMenuEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::dragEnterEvent(QDragEnterEvent* event)
{
    __Qt4Ada_QWidget_dragEnterEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::dragLeaveEvent(QDragLeaveEvent* event)
{
    __Qt4Ada_QWidget_dragLeaveEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::dragMoveEvent(QDragMoveEvent* event)
{
    __Qt4Ada_QWidget_dragMoveEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::dropEvent(QDropEvent* event)
{
    __Qt4Ada_QWidget_dropEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::enterEvent(QEvent* event)
{
    __Qt4Ada_QWidget_enterEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::focusInEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusInEvent_0_dispatch(this->ada_object, event);
}

bool QGLWidgetDirector::focusNextPrevChild(bool next)
{
    return __Qt4Ada_QWidget_focusNextPrevChild_0_dispatch(this->ada_object, next);
}

void QGLWidgetDirector::focusOutEvent(QFocusEvent* event)
{
    __Qt4Ada_QWidget_focusOutEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::hideEvent(QHideEvent* event)
{
    __Qt4Ada_QWidget_hideEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::inputMethodEvent(QInputMethodEvent* event)
{
    __Qt4Ada_QWidget_inputMethodEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::keyPressEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyPressEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::keyReleaseEvent(QKeyEvent* event)
{
    __Qt4Ada_QWidget_keyReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::leaveEvent(QEvent* event)
{
    __Qt4Ada_QWidget_leaveEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::mouseDoubleClickEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseDoubleClickEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::mouseMoveEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseMoveEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::mousePressEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mousePressEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::mouseReleaseEvent(QMouseEvent* event)
{
    __Qt4Ada_QWidget_mouseReleaseEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::moveEvent(QMoveEvent* event)
{
    __Qt4Ada_QWidget_moveEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::showEvent(QShowEvent* event)
{
    __Qt4Ada_QWidget_showEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::tabletEvent(QTabletEvent* event)
{
    __Qt4Ada_QWidget_tabletEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::wheelEvent(QWheelEvent* event)
{
    __Qt4Ada_QWidget_wheelEvent_0_dispatch(this->ada_object, event);
}

int QGLWidgetDirector::metric(QPaintDevice::PaintDeviceMetric metric) const
{
    return __Qt4Ada_QWidget_metric_0_dispatch(this->ada_object, metric);
}

bool QGLWidgetDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QGLWidgetDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QGLWidgetDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QGLWidgetDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QGLWidgetDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QGLWidgetDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

QGLWidgetDirector::QGLWidgetDirector(void* o, QWidget* parent, QGLWidget* shareWidget, Qt::WindowFlags flags) :
    QGLWidget (parent, shareWidget, flags),
    ada_object (o)
{
}

extern "C"
{

    QObject* __Qt4Ada_new_QGLWidgetDirector(void* ada_object, QObject* parent, QObject* shareWidget, unsigned f)
    {
        return dynamic_cast<QObject*>(new QGLWidgetDirector(ada_object, dynamic_cast<QWidget*>(parent), dynamic_cast<QGLWidget*>(shareWidget), (Qt::WindowType)f));
    }

}
