------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Objects;

with Qt_Ada.Internals.Objects.GL_Widget_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.GL_Widget_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.GL_Widgets is

   procedure qglClearColor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     C : not null access constant Qt4.Colors.Internals.QColor);
   pragma Import (C, qglClearColor_0_wrapper,
                     "__Qt4Ada_QGLWidget_qglClearColor_0_wrapper");

   procedure qglColor_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     C : not null access constant Qt4.Colors.Internals.QColor);
   pragma Import (C, qglColor_0_wrapper,
                     "__Qt4Ada_QGLWidget_qglColor_0_wrapper");

   pragma Style_Checks ("N");

   ---------------------
   -- Qgl_Clear_Color --
   ---------------------

   procedure Qgl_Clear_Color
    (Self : not null access constant Q_GL_Widget'Class;
     C : Qt4.Colors.Q_Color)
   is
   begin
      qglClearColor_0_wrapper
       (Self.QObject_View,
        Qt4.Colors.Internals.QColor_View (C));
   end Qgl_Clear_Color;

   ---------------
   -- Qgl_Color --
   ---------------

   procedure Qgl_Color
    (Self : not null access constant Q_GL_Widget'Class;
     C : Qt4.Colors.Q_Color)
   is
   begin
      qglColor_0_wrapper
       (Self.QObject_View,
        Qt4.Colors.Internals.QColor_View (C));
   end Qgl_Color;

end Qt4.GL_Widgets;
