------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Colors;
with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.GL_Widgets is

   type Q_GL_Widget is limited interface
     and Qt4.Widgets.Q_Widget;

   type Q_GL_Widget_Access is
     access all Q_GL_Widget'Class;
   for Q_GL_Widget_Access'Storage_Size use 0;

   type Q_GL_Widget_Pointer is tagged;

   procedure Qgl_Clear_Color
    (Self : not null access constant Q_GL_Widget'Class;
     C : Qt4.Colors.Q_Color);

   procedure Qgl_Color
    (Self : not null access constant Q_GL_Widget'Class;
     C : Qt4.Colors.Q_Color);

   not overriding
   procedure Update_GL
    (Self : not null access Q_GL_Widget)
       is abstract;

   not overriding
   procedure Update_Overlay_GL
    (Self : not null access Q_GL_Widget)
       is abstract;

   package Q_GL_Widget_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_GL_Widget, Q_GL_Widget_Access);

   type Q_GL_Widget_Pointer is
     new Q_GL_Widget_Pointers.Q_Pointer with null record;

end Qt4.GL_Widgets;
