//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include <QVariant>
#include "qsqlfieldwrapper.h"

extern "C"
{

    QSqlField* __QtAda_inititialize_QSqlField(void* storage)
    {
        return new (storage) QSqlField();
    }

    QSqlField* __QtAda_inititialize_QSqlField_QStringCR_Type(void* storage, const QString* fieldName, unsigned the_type)
    {
        return new (storage) QSqlField(*fieldName, (QVariant::Type)the_type);
    }

    QSqlField* __QtAda_adjust_QSqlField(void* storage, const QSqlField* from)
    {
        return new (storage) QSqlField(*from);
    }

    void __QtAda_finalize_QSqlField(QSqlField *item)
    {
        item->~QSqlField();
    }

    void __QtAda_QSqlField_clear(QSqlField* self)
    {
        self->clear();
    }

    void __QtAda_QSqlField_defaultValue_Q(QVariant* returns, const QSqlField* self)
    {
        *returns = self->defaultValue();
    }

    unsigned __QtAda_QSqlField_isAutoValue_Q(const QSqlField* self)
    {
        return (unsigned)self->isAutoValue();
    }

    unsigned __QtAda_QSqlField_isGenerated_Q(const QSqlField* self)
    {
        return (unsigned)self->isGenerated();
    }

    unsigned __QtAda_QSqlField_isNull_Q(const QSqlField* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QSqlField_isReadOnly_Q(const QSqlField* self)
    {
        return (unsigned)self->isReadOnly();
    }

    unsigned __QtAda_QSqlField_isValid_Q(const QSqlField* self)
    {
        return (unsigned)self->isValid();
    }

    int __QtAda_QSqlField_length_Q(const QSqlField* self)
    {
        return self->length();
    }

    void __QtAda_QSqlField_name_Q(QString* returns, const QSqlField* self)
    {
        *returns = self->name();
    }

    int __QtAda_QSqlField_precision_Q(const QSqlField* self)
    {
        return self->precision();
    }

    int __QtAda_QSqlField_requiredStatus_Q(const QSqlField* self)
    {
        return (int)self->requiredStatus();
    }

    void __QtAda_QSqlField_setAutoValue_bool(QSqlField* self, unsigned autoVal)
    {
        self->setAutoValue((bool)autoVal);
    }

    void __QtAda_QSqlField_setDefaultValue_QVariantCR(QSqlField* self, const QVariant* value)
    {
        self->setDefaultValue(*value);
    }

    void __QtAda_QSqlField_setGenerated_bool(QSqlField* self, unsigned gen)
    {
        self->setGenerated((bool)gen);
    }

    void __QtAda_QSqlField_setLength_int(QSqlField* self, int fieldLength)
    {
        self->setLength(fieldLength);
    }

    void __QtAda_QSqlField_setName_QStringCR(QSqlField* self, const QString* name)
    {
        self->setName(*name);
    }

    void __QtAda_QSqlField_setPrecision_int(QSqlField* self, int precision)
    {
        self->setPrecision(precision);
    }

    void __QtAda_QSqlField_setReadOnly_bool(QSqlField* self, unsigned readOnly)
    {
        self->setReadOnly((bool)readOnly);
    }

    void __QtAda_QSqlField_setRequired_bool(QSqlField* self, unsigned required)
    {
        self->setRequired((bool)required);
    }

    void __QtAda_QSqlField_setRequiredStatus_RequiredStatus(QSqlField* self, int status)
    {
        self->setRequiredStatus((QSqlField::RequiredStatus)status);
    }

    void __QtAda_QSqlField_setType_Type(QSqlField* self, unsigned the_type)
    {
        self->setType((QVariant::Type)the_type);
    }

    void __QtAda_QSqlField_setValue_QVariantCR(QSqlField* self, const QVariant* value)
    {
        self->setValue(*value);
    }

    unsigned __QtAda_QSqlField_type_Q(const QSqlField* self)
    {
        return (unsigned)self->type();
    }

    void __QtAda_QSqlField_value_Q(QVariant* returns, const QSqlField* self)
    {
        *returns = self->value();
    }

    unsigned __QtAda_QSqlField_eq_QSqlFieldCR_Q(const QSqlField* self, const QSqlField* other)
    {
        return (unsigned)self->operator==(*other);
    }

};

