//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include "qsqlindexwrapper.h"

extern "C"
{

    QSqlRecord* __QtAda_inititialize_QSqlIndex(void* storage)
    {
        return new (storage) QSqlIndex();
    }

    QSqlRecord* __QtAda_inititialize_QSqlIndex_QStringCR_QStringCR(void* storage, const QString* cursorName, const QString* name)
    {
        return new (storage) QSqlIndex(*cursorName, *name);
    }

    QSqlRecord* __QtAda_adjust_QSqlIndex(void* storage, const QSqlRecord* from)
    {
        return new (storage) QSqlIndex(*static_cast<const QSqlIndex*>(from));
    }

    void __QtAda_finalize_QSqlIndex(QSqlRecord *item)
    {
        static_cast<const QSqlIndex*>(item)->~QSqlIndex();
    }

    void __QtAda_QSqlIndex_append_QSqlFieldCR(QSqlRecord* self, const QSqlField* field)
    {
        static_cast<QSqlIndex*>(self)->append(*field);
    }

    void __QtAda_QSqlIndex_append_QSqlFieldCR_bool(QSqlRecord* self, const QSqlField* field, unsigned desc)
    {
        static_cast<QSqlIndex*>(self)->append(*field, (bool)desc);
    }

    void __QtAda_QSqlIndex_cursorName_Q(QString* returns, const QSqlRecord* self)
    {
        *returns = static_cast<const QSqlIndex*>(self)->cursorName();
    }

    unsigned __QtAda_QSqlIndex_isDescending_int_Q(const QSqlRecord* self, int index)
    {
        return (unsigned)static_cast<const QSqlIndex*>(self)->isDescending(index);
    }

    void __QtAda_QSqlIndex_name_Q(QString* returns, const QSqlRecord* self)
    {
        *returns = static_cast<const QSqlIndex*>(self)->name();
    }

    void __QtAda_QSqlIndex_setCursorName_QStringCR(QSqlRecord* self, const QString* cursorName)
    {
        static_cast<QSqlIndex*>(self)->setCursorName(*cursorName);
    }

    void __QtAda_QSqlIndex_setDescending_int_bool(QSqlRecord* self, int index, unsigned desc)
    {
        static_cast<QSqlIndex*>(self)->setDescending(index, (bool)desc);
    }

    void __QtAda_QSqlIndex_setName_QStringCR(QSqlRecord* self, const QString* name)
    {
        static_cast<QSqlIndex*>(self)->setName(*name);
    }

};

