//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QSqlError>
#include <QSqlRecord>
#include <QString>
#include <QVariant>
#include "qsqlquerywrapper.h"

extern "C"
{

    QSqlQuery* __QtAda_inititialize_QSqlQuery(void* storage)
    {
        return new (storage) QSqlQuery();
    }

    QSqlQuery* __QtAda_inititialize_QSqlQuery_QStringCR_QSqlDatabaseCR(void* storage, const QString* query, const QSqlDatabase* db)
    {
        return new (storage) QSqlQuery(*query, *db);
    }

    QSqlQuery* __QtAda_inititialize_QSqlQuery_QSqlDatabaseCR(void* storage, const QSqlDatabase* db)
    {
        return new (storage) QSqlQuery(*db);
    }

    QSqlQuery* __QtAda_adjust_QSqlQuery(void* storage, const QSqlQuery* from)
    {
        return new (storage) QSqlQuery(*from);
    }

    void __QtAda_finalize_QSqlQuery(QSqlQuery *item)
    {
        item->~QSqlQuery();
    }

    void __QtAda_QSqlQuery_addBindValue_QVariantCR_ParamTypeFlag(QSqlQuery* self, const QVariant* val, unsigned the_type)
    {
        self->addBindValue(*val, (QSql::ParamTypeFlag)the_type);
    }

    int __QtAda_QSqlQuery_at_Q(const QSqlQuery* self)
    {
        return self->at();
    }

    void __QtAda_QSqlQuery_bindValue_QStringCR_QVariantCR_ParamTypeFlag(QSqlQuery* self, const QString* placeholder, const QVariant* val, unsigned the_type)
    {
        self->bindValue(*placeholder, *val, (QSql::ParamTypeFlag)the_type);
    }

    void __QtAda_QSqlQuery_bindValue_int_QVariantCR_ParamTypeFlag(QSqlQuery* self, int pos, const QVariant* val, unsigned the_type)
    {
        self->bindValue(pos, *val, (QSql::ParamTypeFlag)the_type);
    }

    void __QtAda_QSqlQuery_boundValue_QStringCR_Q(QVariant* returns, const QSqlQuery* self, const QString* placeholder)
    {
        *returns = self->boundValue(*placeholder);
    }

    void __QtAda_QSqlQuery_boundValue_int_Q(QVariant* returns, const QSqlQuery* self, int pos)
    {
        *returns = self->boundValue(pos);
    }

    void __QtAda_QSqlQuery_clear(QSqlQuery* self)
    {
        self->clear();
    }

    unsigned __QtAda_QSqlQuery_exec_QStringCR(QSqlQuery* self, const QString* query)
    {
        return (unsigned)self->exec(*query);
    }

    unsigned __QtAda_QSqlQuery_exec(QSqlQuery* self)
    {
        return (unsigned)self->exec();
    }

    unsigned __QtAda_QSqlQuery_execBatch_BatchExecutionMode(QSqlQuery* self, unsigned mode)
    {
        return (unsigned)self->execBatch((QSqlQuery::BatchExecutionMode)mode);
    }

    void __QtAda_QSqlQuery_executedQuery_Q(QString* returns, const QSqlQuery* self)
    {
        *returns = self->executedQuery();
    }

    void __QtAda_QSqlQuery_finish(QSqlQuery* self)
    {
        self->finish();
    }

    unsigned __QtAda_QSqlQuery_first(QSqlQuery* self)
    {
        return (unsigned)self->first();
    }

    unsigned __QtAda_QSqlQuery_isActive_Q(const QSqlQuery* self)
    {
        return (unsigned)self->isActive();
    }

    unsigned __QtAda_QSqlQuery_isForwardOnly_Q(const QSqlQuery* self)
    {
        return (unsigned)self->isForwardOnly();
    }

    unsigned __QtAda_QSqlQuery_isNull_int_Q(const QSqlQuery* self, int field)
    {
        return (unsigned)self->isNull(field);
    }

    unsigned __QtAda_QSqlQuery_isSelect_Q(const QSqlQuery* self)
    {
        return (unsigned)self->isSelect();
    }

    unsigned __QtAda_QSqlQuery_isValid_Q(const QSqlQuery* self)
    {
        return (unsigned)self->isValid();
    }

    unsigned __QtAda_QSqlQuery_last(QSqlQuery* self)
    {
        return (unsigned)self->last();
    }

    void __QtAda_QSqlQuery_lastError_Q(QSqlError* returns, const QSqlQuery* self)
    {
        *returns = self->lastError();
    }

    void __QtAda_QSqlQuery_lastInsertId_Q(QVariant* returns, const QSqlQuery* self)
    {
        *returns = self->lastInsertId();
    }

    void __QtAda_QSqlQuery_lastQuery_Q(QString* returns, const QSqlQuery* self)
    {
        *returns = self->lastQuery();
    }

    unsigned __QtAda_QSqlQuery_next(QSqlQuery* self)
    {
        return (unsigned)self->next();
    }

    unsigned __QtAda_QSqlQuery_nextResult(QSqlQuery* self)
    {
        return (unsigned)self->nextResult();
    }

    int __QtAda_QSqlQuery_numRowsAffected_Q(const QSqlQuery* self)
    {
        return self->numRowsAffected();
    }

    unsigned __QtAda_QSqlQuery_numericalPrecisionPolicy_Q(const QSqlQuery* self)
    {
        return (unsigned)self->numericalPrecisionPolicy();
    }

    unsigned __QtAda_QSqlQuery_prepare_QStringCR(QSqlQuery* self, const QString* query)
    {
        return (unsigned)self->prepare(*query);
    }

    unsigned __QtAda_QSqlQuery_previous(QSqlQuery* self)
    {
        return (unsigned)self->previous();
    }

    void __QtAda_QSqlQuery_record_Q(QSqlRecord* returns, const QSqlQuery* self)
    {
        *returns = self->record();
    }

    unsigned __QtAda_QSqlQuery_seek_int_bool(QSqlQuery* self, int index, unsigned relative)
    {
        return (unsigned)self->seek(index, (bool)relative);
    }

    void __QtAda_QSqlQuery_setForwardOnly_bool(QSqlQuery* self, unsigned forward)
    {
        self->setForwardOnly((bool)forward);
    }

    void __QtAda_QSqlQuery_setNumericalPrecisionPolicy_NumericalPrecisionPolicy(QSqlQuery* self, unsigned precisionPolicy)
    {
        self->setNumericalPrecisionPolicy((QSql::NumericalPrecisionPolicy)precisionPolicy);
    }

    int __QtAda_QSqlQuery_size(QSqlQuery* self)
    {
        return self->size();
    }

    void __QtAda_QSqlQuery_value_int(QVariant* returns, QSqlQuery* self, int index)
    {
        *returns = self->value(index);
    }

};

