//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2009-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QSqlField>
#include <QString>
#include <QVariant>
#include "qsqlrecordwrapper.h"

extern "C"
{

    QSqlRecord* __QtAda_inititialize_QSqlRecord(void* storage)
    {
        return new (storage) QSqlRecord();
    }

    QSqlRecord* __QtAda_adjust_QSqlRecord(void* storage, const QSqlRecord* from)
    {
        return new (storage) QSqlRecord(*from);
    }

    void __QtAda_finalize_QSqlRecord(QSqlRecord *item)
    {
        item->~QSqlRecord();
    }

    void __QtAda_QSqlRecord_append_QSqlFieldCR(QSqlRecord* self, const QSqlField* field)
    {
        self->append(*field);
    }

    void __QtAda_QSqlRecord_clear(QSqlRecord* self)
    {
        self->clear();
    }

    void __QtAda_QSqlRecord_clearValues(QSqlRecord* self)
    {
        self->clearValues();
    }

    unsigned __QtAda_QSqlRecord_contains_QStringCR_Q(const QSqlRecord* self, const QString* name)
    {
        return (unsigned)self->contains(*name);
    }

    int __QtAda_QSqlRecord_count_Q(const QSqlRecord* self)
    {
        return self->count();
    }

    void __QtAda_QSqlRecord_field_int_Q(QSqlField* returns, const QSqlRecord* self, int index)
    {
        *returns = self->field(index);
    }

    void __QtAda_QSqlRecord_field_QStringCR_Q(QSqlField* returns, const QSqlRecord* self, const QString* name)
    {
        *returns = self->field(*name);
    }

    void __QtAda_QSqlRecord_fieldName_int_Q(QString* returns, const QSqlRecord* self, int index)
    {
        *returns = self->fieldName(index);
    }

    int __QtAda_QSqlRecord_indexOf_QStringCR_Q(const QSqlRecord* self, const QString* name)
    {
        return self->indexOf(*name);
    }

    void __QtAda_QSqlRecord_insert_int_QSqlFieldCR(QSqlRecord* self, int pos, const QSqlField* field)
    {
        self->insert(pos, *field);
    }

    unsigned __QtAda_QSqlRecord_isEmpty_Q(const QSqlRecord* self)
    {
        return (unsigned)self->isEmpty();
    }

    unsigned __QtAda_QSqlRecord_isGenerated_QStringCR_Q(const QSqlRecord* self, const QString* name)
    {
        return (unsigned)self->isGenerated(*name);
    }

    unsigned __QtAda_QSqlRecord_isGenerated_int_Q(const QSqlRecord* self, int index)
    {
        return (unsigned)self->isGenerated(index);
    }

    unsigned __QtAda_QSqlRecord_isNull_QStringCR_Q(const QSqlRecord* self, const QString* name)
    {
        return (unsigned)self->isNull(*name);
    }

    unsigned __QtAda_QSqlRecord_isNull_int_Q(const QSqlRecord* self, int index)
    {
        return (unsigned)self->isNull(index);
    }

    void __QtAda_QSqlRecord_remove_int(QSqlRecord* self, int pos)
    {
        self->remove(pos);
    }

    void __QtAda_QSqlRecord_replace_int_QSqlFieldCR(QSqlRecord* self, int pos, const QSqlField* field)
    {
        self->replace(pos, *field);
    }

    void __QtAda_QSqlRecord_setGenerated_QStringCR_bool(QSqlRecord* self, const QString* name, unsigned generated)
    {
        self->setGenerated(*name, (bool)generated);
    }

    void __QtAda_QSqlRecord_setGenerated_int_bool(QSqlRecord* self, int index, unsigned generated)
    {
        self->setGenerated(index, (bool)generated);
    }

    void __QtAda_QSqlRecord_setNull_QStringCR(QSqlRecord* self, const QString* name)
    {
        self->setNull(*name);
    }

    void __QtAda_QSqlRecord_setNull_int(QSqlRecord* self, int index)
    {
        self->setNull(index);
    }

    void __QtAda_QSqlRecord_setValue_QStringCR_QVariantCR(QSqlRecord* self, const QString* name, const QVariant* value)
    {
        self->setValue(*name, *value);
    }

    void __QtAda_QSqlRecord_setValue_int_QVariantCR(QSqlRecord* self, int index, const QVariant* value)
    {
        self->setValue(index, *value);
    }

    void __QtAda_QSqlRecord_value_QStringCR_Q(QVariant* returns, const QSqlRecord* self, const QString* name)
    {
        *returns = self->value(*name);
    }

    void __QtAda_QSqlRecord_value_int_Q(QVariant* returns, const QSqlRecord* self, int index)
    {
        *returns = self->value(index);
    }

    unsigned __QtAda_QSqlRecord_eq_QSqlRecordCR_Q(const QSqlRecord* self, const QSqlRecord* other)
    {
        return (unsigned)self->operator==(*other);
    }

};

