//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QWidget>
#include <QStyleOptionViewItem>
#include <QAbstractItemModel>
#include <QSize>
#include <QChildEvent>
#include <QTimerEvent>

#include "qsqlrelationaldelegatedirector.h"
#include "qitemdelegatedirector.h"
#include "qabstractitemdelegatedirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QSqlRelationalDelegate_staticMetaObject =
        &QSqlRelationalDelegate::staticMetaObject;
}

extern "C"
{

}

//  Functions for static call of C++ functions.

extern "C"
{

    QObject* __Qt4Ada_QSqlRelationalDelegate_createEditor_0_wrapper(QObject* cpp_object, QObject* parent, const QStyleOption* option, const QModelIndex* index)
    {
        return static_cast<QObject*>(dynamic_cast<QSqlRelationalDelegate*>(cpp_object)->QSqlRelationalDelegate::createEditor(dynamic_cast<QWidget*>(parent), static_cast<const QStyleOptionViewItem&>(*option), *index));
    }

    void __Qt4Ada_QSqlRelationalDelegate_setEditorData_0_wrapper(QObject* cpp_object, QObject* editor, const QModelIndex* index)
    {
        dynamic_cast<QSqlRelationalDelegate*>(cpp_object)->QSqlRelationalDelegate::setEditorData(dynamic_cast<QWidget*>(editor), *index);
    }

    void __Qt4Ada_QSqlRelationalDelegate_setModelData_0_wrapper(QObject* cpp_object, QObject* editor, QObject* model, const QModelIndex* index)
    {
        dynamic_cast<QSqlRelationalDelegate*>(cpp_object)->QSqlRelationalDelegate::setModelData(dynamic_cast<QWidget*>(editor), dynamic_cast<QAbstractItemModel*>(model), *index);
    }

    void __Qt4Ada_QSqlRelationalDelegate_commitData_0_wrapper(QObject* cpp_object, QObject* editor)
    {
        dynamic_cast<QSqlRelationalDelegateDirector*>(cpp_object)->QAbstractItemDelegate::commitData(dynamic_cast<QWidget*>(editor));
    }

    void __Qt4Ada_QSqlRelationalDelegate_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSqlRelationalDelegateDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QSqlRelationalDelegate_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSqlRelationalDelegateDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QSqlRelationalDelegate_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QSqlRelationalDelegateDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QSqlRelationalDelegate_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QSqlRelationalDelegateDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QSqlRelationalDelegate_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QSqlRelationalDelegate*>(cpp_this)->QSqlRelationalDelegate::qt_metacast(name);
    }

    int __Qt4Ada_QSqlRelationalDelegate_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QSqlRelationalDelegate*>(cpp_this)->QSqlRelationalDelegate::qt_metacall(_c, _id, _a);
    }

}

QWidget* QSqlRelationalDelegateDirector::createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
    return dynamic_cast<QWidget*>(__Qt4Ada_QAbstractItemDelegate_createEditor_0_dispatch(this->ada_object, parent, &option, &index));
}

void QSqlRelationalDelegateDirector::setEditorData(QWidget* editor, const QModelIndex& index) const
{
    __Qt4Ada_QAbstractItemDelegate_setEditorData_0_dispatch(this->ada_object, editor, &index);
}

void QSqlRelationalDelegateDirector::setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const
{
    __Qt4Ada_QAbstractItemDelegate_setModelData_0_dispatch(this->ada_object, editor, model, &index);
}

QSize QSqlRelationalDelegateDirector::sizeHint(const QStyleOptionViewItem& option, const QModelIndex& index) const
{
    QSize *aux = __Qt4Ada_QAbstractItemDelegate_sizeHint_0_dispatch(this->ada_object, &option, &index);
    QSize returns = *aux;
    delete aux;
    return returns;
}

void QSqlRelationalDelegateDirector::updateEditorGeometry(QWidget* editor, const QStyleOptionViewItem& option, const QModelIndex& index) const
{
    __Qt4Ada_QAbstractItemDelegate_updateEditorGeometry_0_dispatch(this->ada_object, editor, &option, &index);
}

bool QSqlRelationalDelegateDirector::editorEvent(QEvent* event, QAbstractItemModel* model, const QStyleOptionViewItem& option, const QModelIndex& index)
{
    return __Qt4Ada_QAbstractItemDelegate_editorEvent_0_dispatch(this->ada_object, event, model, &option, &index);
}

bool QSqlRelationalDelegateDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QSqlRelationalDelegateDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QSqlRelationalDelegateDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QSqlRelationalDelegateDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QSqlRelationalDelegateDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QSqlRelationalDelegateDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QSqlRelationalDelegateDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QSqlRelationalDelegateDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}
extern "C" {

    QObject* __Qt4Ada_new_QSqlRelationalDelegate (QObject* parent)
    {
        return dynamic_cast<QObject *>(new QSqlRelationalDelegate (parent));
    }
}
