//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#ifndef __QSQLTABLEMODELDIRECTOR_H__
#define __QSQLTABLEMODELDIRECTOR_H__

#include <QSqlTableModel>

extern "C"
{
    extern const QMetaObject* __Qt4Ada_QSqlTableModel_staticMetaObject;
}

//  Functions for dispatching call of Ada subprograms.

extern "C"
{
    extern void __Qt4Ada_QSqlTableModel_revertRow_0_dispatch(void*, int);
    extern bool __Qt4Ada_QSqlTableModel_select_0_dispatch(void*);
    extern void __Qt4Ada_QSqlTableModel_setEditStrategy_0_dispatch(void*, QSqlTableModel::EditStrategy);
    extern void __Qt4Ada_QSqlTableModel_setFilter_0_dispatch(void*, const QString*);
    extern void __Qt4Ada_QSqlTableModel_setSort_0_dispatch(void*, int, Qt::SortOrder);
    extern void __Qt4Ada_QSqlTableModel_setTable_0_dispatch(void*, const QString*);
    extern void __Qt4Ada_QSqlTableModel_sort_0_dispatch(void*, int, Qt::SortOrder);
    extern bool __Qt4Ada_QSqlTableModel_deleteRowFromTable_0_dispatch(void*, int);
    extern QString* __Qt4Ada_QSqlTableModel_orderByClause_0_dispatch(void*);
    extern QString* __Qt4Ada_QSqlTableModel_selectStatement_0_dispatch(void*);
}

//  Functions for virtual call of C++ virtual functions.

extern "C"
{
    extern void __Qt4Ada_QSqlTableModel_revertRow_0_virtual(QObject*, int);
    extern bool __Qt4Ada_QSqlTableModel_select_0_virtual(QObject*);
    extern void __Qt4Ada_QSqlTableModel_setEditStrategy_0_virtual(QObject*, QSqlTableModel::EditStrategy);
    extern void __Qt4Ada_QSqlTableModel_setFilter_0_virtual(QObject*, const QString*);
    extern void __Qt4Ada_QSqlTableModel_setSort_0_virtual(QObject*, int, Qt::SortOrder);
    extern void __Qt4Ada_QSqlTableModel_setTable_0_virtual(QObject*, const QString*);
    extern void __Qt4Ada_QSqlTableModel_sort_0_virtual(QObject*, int, Qt::SortOrder);
}

//  Functions for static call of C++ functions.

extern "C"
{
    extern void __Qt4Ada_QSqlTableModel_database_0_wrapper(QObject*, QSqlDatabase*);
    extern QSqlTableModel::EditStrategy __Qt4Ada_QSqlTableModel_editStrategy_0_wrapper(QObject*);
    extern int __Qt4Ada_QSqlTableModel_fieldIndex_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QSqlTableModel_filter_0_wrapper(QObject*, QString*);
    extern bool __Qt4Ada_QSqlTableModel_insertRecord_0_wrapper(QObject*, int, const QSqlRecord*);
    extern bool __Qt4Ada_QSqlTableModel_insertRows_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QSqlTableModel_isDirty_0_wrapper(QObject*, const QModelIndex*);
    extern bool __Qt4Ada_QSqlTableModel_removeColumns_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern bool __Qt4Ada_QSqlTableModel_removeRows_0_wrapper(QObject*, int, int, const QModelIndex*);
    extern void __Qt4Ada_QSqlTableModel_revertRow_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QSqlTableModel_select_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_setEditStrategy_0_wrapper(QObject*, QSqlTableModel::EditStrategy);
    extern void __Qt4Ada_QSqlTableModel_setFilter_0_wrapper(QObject*, const QString*);
    extern bool __Qt4Ada_QSqlTableModel_setRecord_0_wrapper(QObject*, int, const QSqlRecord*);
    extern void __Qt4Ada_QSqlTableModel_setSort_0_wrapper(QObject*, int, Qt::SortOrder);
    extern void __Qt4Ada_QSqlTableModel_setTable_0_wrapper(QObject*, const QString*);
    extern void __Qt4Ada_QSqlTableModel_sort_0_wrapper(QObject*, int, Qt::SortOrder);
    extern void __Qt4Ada_QSqlTableModel_tableName_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QSqlTableModel_revert_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_revertAll_0_wrapper(QObject*);
    extern bool __Qt4Ada_QSqlTableModel_submit_0_wrapper(QObject*);
    extern bool __Qt4Ada_QSqlTableModel_submitAll_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_beforeDelete_0_wrapper(QObject*, int);
    extern bool __Qt4Ada_QSqlTableModel_deleteRowFromTable_0_wrapper(QObject*, int);
    extern void __Qt4Ada_QSqlTableModel_indexInQuery_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    extern void __Qt4Ada_QSqlTableModel_orderByClause_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QSqlTableModel_selectStatement_0_wrapper(QObject*, QString*);
    extern void __Qt4Ada_QSqlTableModel_queryChange_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QSqlTableModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    extern void __Qt4Ada_QSqlTableModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_layoutChanged_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSqlTableModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern bool __Qt4Ada_QSqlTableModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern bool __Qt4Ada_QSqlTableModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    extern void __Qt4Ada_QSqlTableModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSqlTableModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    extern void __Qt4Ada_QSqlTableModel_beginResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    extern void __Qt4Ada_QSqlTableModel_endInsertColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_endInsertRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_endMoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_endMoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_endRemoveColumns_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_endRemoveRows_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_endResetModel_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_reset_0_wrapper(QObject*);
    extern void __Qt4Ada_QSqlTableModel_childEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSqlTableModel_customEvent_0_wrapper(QObject*, QEvent*);
    extern void __Qt4Ada_QSqlTableModel_timerEvent_0_wrapper(QObject*, QEvent*);
    extern QObject* __Qt4Ada_QSqlTableModel_sender_0_wrapper(QObject*);

    extern void* __Qt4Ada_QSqlTableModel_qt_metacast_wrapper(QObject*, const char*);
    extern int __Qt4Ada_QSqlTableModel_qt_metacall_wrapper(QObject*, QMetaObject::Call, int, void**);
}

extern "C" {

    extern QObject* __Qt4Ada_new_QSqlTableModel (QObject*, QSqlDatabase*);
    extern QObject* __Qt4Ada_new_QSqlTableModelDirector(void*, QObject*, QSqlDatabase*);

}

class QSqlTableModelDirector : public QSqlTableModel
{
protected:
    void* ada_object;
    QSqlTableModelDirector(void*, QObject*, QSqlDatabase*);

    friend QObject* __Qt4Ada_new_QSqlTableModelDirector(void*, QObject*, QSqlDatabase*);

    virtual bool insertRows(int, int, const QModelIndex&);
    virtual bool removeColumns(int, int, const QModelIndex&);
    virtual bool removeRows(int, int, const QModelIndex&);
    virtual void revertRow(int);
    virtual bool select();
    virtual void setEditStrategy(QSqlTableModel::EditStrategy);
    virtual void setFilter(const QString&);
    virtual void setSort(int, Qt::SortOrder);
    virtual void setTable(const QString&);
    virtual void sort(int, Qt::SortOrder);
    virtual void revert();
    virtual bool submit();
    virtual bool deleteRowFromTable(int);
    virtual QString orderByClause() const;
    virtual QString selectStatement() const;
    virtual bool canFetchMore(const QModelIndex&) const;
    virtual void clear();
    virtual QVariant data(const QModelIndex&, int) const;
    virtual void fetchMore(const QModelIndex&);
    virtual QVariant headerData(int, Qt::Orientation, int) const;
    virtual bool insertColumns(int, int, const QModelIndex&);
    virtual int rowCount(const QModelIndex&) const;
    virtual int columnCount(const QModelIndex&) const;
    virtual bool setHeaderData(int, Qt::Orientation, const QVariant&, int);
    virtual void queryChange();
    virtual QModelIndex index(int, int, const QModelIndex&) const;
    virtual QModelIndex parent(const QModelIndex&) const;
    virtual QModelIndex buddy(const QModelIndex&) const;
    virtual bool dropMimeData(QMimeData*, Qt::DropAction, int, int, const QModelIndex&);
    virtual bool hasChildren(const QModelIndex&) const;
    virtual bool hasIndex(int, int, const QModelIndex&) const;
    virtual QMimeData* mimeData(const QModelIndexList&) const;
    virtual QStringList mimeTypes() const;
    virtual QSize span(const QModelIndex&) const;
    virtual bool event(QEvent*);
    virtual bool eventFilter(QObject*, QEvent*);
    virtual void childEvent(QChildEvent*);
    virtual void customEvent(QEvent*);
    virtual void timerEvent(QTimerEvent*);

    //  Inherited from QObject, defined by Q_OBJECT macro
    virtual const QMetaObject* metaObject() const;
    virtual void* qt_metacast(const char*);
    virtual int qt_metacall(QMetaObject::Call, int, void**);

    //  Wrappers for protected functions is a class' friends.
    friend void __Qt4Ada_QSqlTableModel_beforeDelete_0_wrapper(QObject*, int);
    friend bool __Qt4Ada_QSqlTableModel_deleteRowFromTable_0_wrapper(QObject*, int);
    friend void __Qt4Ada_QSqlTableModel_indexInQuery_0_wrapper(QObject*, const QModelIndex*, QModelIndex*);
    friend void __Qt4Ada_QSqlTableModel_orderByClause_0_wrapper(QObject*, QString*);
    friend void __Qt4Ada_QSqlTableModel_selectStatement_0_wrapper(QObject*, QString*);
    friend void __Qt4Ada_QSqlTableModel_queryChange_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_dataChanged_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QSqlTableModel_headerDataChanged_0_wrapper(QObject*, Qt::Orientation, int, int);
    friend void __Qt4Ada_QSqlTableModel_layoutAboutToBeChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_layoutChanged_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_beginInsertColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSqlTableModel_beginInsertRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend bool __Qt4Ada_QSqlTableModel_beginMoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend bool __Qt4Ada_QSqlTableModel_beginMoveRows_0_wrapper(QObject*, const QModelIndex*, int, int, const QModelIndex*, int);
    friend void __Qt4Ada_QSqlTableModel_beginRemoveColumns_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSqlTableModel_beginRemoveRows_0_wrapper(QObject*, const QModelIndex*, int, int);
    friend void __Qt4Ada_QSqlTableModel_beginResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_changePersistentIndex_0_wrapper(QObject*, const QModelIndex*, const QModelIndex*);
    friend void __Qt4Ada_QSqlTableModel_endInsertColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_endInsertRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_endMoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_endMoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_endRemoveColumns_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_endRemoveRows_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_endResetModel_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_reset_0_wrapper(QObject*);
    friend void __Qt4Ada_QSqlTableModel_childEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSqlTableModel_customEvent_0_wrapper(QObject*, QEvent*);
    friend void __Qt4Ada_QSqlTableModel_timerEvent_0_wrapper(QObject*, QEvent*);
    friend QObject* __Qt4Ada_QSqlTableModel_sender_0_wrapper(QObject*);
};

#endif // __QSQLTABLEMODELDIRECTOR_H__
