------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Strings;

package Qt4.Sql_Records.Sql_Indices is

   type Q_Sql_Index is new Qt4.Sql_Records.Q_Sql_Record with private;

   function Create
    (Cursor_Name : Qt4.Strings.Q_String'Class
       := Qt4.Strings.Create;
     Name : Qt4.Strings.Q_String'Class
       := Qt4.Strings.Create)
       return Q_Sql_Index;

   procedure Append
    (Self : in out Q_Sql_Index'Class;
     Field : Qt4.Sql_Fields.Q_Sql_Field'Class);

   procedure Append
    (Self : in out Q_Sql_Index'Class;
     Field : Qt4.Sql_Fields.Q_Sql_Field'Class;
     Desc : Boolean);

   function Cursor_Name
    (Self : Q_Sql_Index'Class)
       return Qt4.Strings.Q_String;

   function Is_Descending
    (Self : Q_Sql_Index'Class;
     Index : Qt4.Q_Integer)
       return Boolean;

   function Name
    (Self : Q_Sql_Index'Class)
       return Qt4.Strings.Q_String;

   procedure Set_Cursor_Name
    (Self : in out Q_Sql_Index'Class;
     Cursor_Name : Qt4.Strings.Q_String'Class);

   procedure Set_Descending
    (Self : in out Q_Sql_Index'Class;
     Index : Qt4.Q_Integer;
     Desc : Boolean);

   procedure Set_Name
    (Self : in out Q_Sql_Index'Class;
     Name : Qt4.Strings.Q_String'Class);

   package Internals is

      function Create_Wrapper
       (Item : Qt4.Sql_Records.Internals.QSqlRecord_Access)
          return Q_Sql_Index;

   end Internals;

private

   type Q_Sql_Index is new Qt4.Sql_Records.Q_Sql_Record with null record;

   overriding
   procedure Adjust (Self : in out Q_Sql_Index);

   overriding
   procedure Finalize (Self : in out Q_Sql_Index);

   overriding
   procedure Initialize (Self : in out Q_Sql_Index);

end Qt4.Sql_Records.Sql_Indices;
