------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt_Ada.Internals.Object_Registry;
pragma Elaborate (Qt_Ada.Internals.Object_Registry);

package body Qt_Ada.Internals.Objects.Sql_Relational_Table_Model_Proxies is

   procedure setRelation_0_virtual
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Column : Qt4.Q_Integer;
     Relation : not null access constant Qt4.Sql_Relations.Thin.QSqlRelation);
      pragma Import (C, setRelation_0_virtual,
                     "__Qt4Ada_QSqlRelationalTableModel_setRelation_0_virtual");

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access;

   pragma Style_Checks ("N");

   ------------------
   -- Set_Relation --
   ------------------

   procedure Set_Relation
    (Self : not null access Q_Sql_Relational_Table_Model_Proxy;
     Column : Qt4.Q_Integer;
     Relation : Qt4.Sql_Relations.Q_Sql_Relation)
   is
   begin
      setRelation_0_virtual
       (Q_Sql_Relational_Table_Model_Proxy'Class (Self.all).QObject_View,
        Column,
        Qt4.Sql_Relations.Internals.QSqlRelation_View (Relation));
   end Set_Relation;

   type Q_Sql_Relational_Table_Model_Proxy_Access is
     access all Q_Sql_Relational_Table_Model_Proxy'Class;

   ------------
   -- Create --
   ------------

   function Create
    (Object : not null Qt_Ada.Internals.Objects.QObject_Access)
       return not null Qt_Ada.Internals.Objects.Q_Object_Base_Access
   is
      Self : constant not null Q_Sql_Relational_Table_Model_Proxy_Access
        := new Q_Sql_Relational_Table_Model_Proxy;

   begin
      Qt_Ada.Internals.Objects.Initialize (Self, Object);

      return Qt_Ada.Internals.Objects.Q_Object_Base_Access (Self);
   end Create;

begin
   Qt_Ada.Internals.Object_Registry.Register_Proxy
    ("QSqlRelationalTableModel", Create'Access);
end Qt_Ada.Internals.Objects.Sql_Relational_Table_Model_Proxies;
