------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 2903 $ $Date: 2008-10-08 11:42:39 +0400 (Wed, 08 Oct 2008) $
------------------------------------------------------------------------------

package Amoc.Version is

   function Qt_Ada_Version return Wide_String;
   --  Returns Qt_Ada's version number.

   function Qt_Ada_Edition return Wide_String;
   --  Returns Qt_Ada's edition name.

   function Qt_Ada_Changeset_Number return Wide_String;
   --  Returns Qt_Ada's changeset number.

   type Platform is (Unix, Windows, MacOSX);

   function Qt_Ada_Platform return Platform;
   --  Returns Qt_Ada's platform.

end Amoc.Version;
