------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
limited with Qt4.Actions;
limited with Qt4.IO_Devices;
limited with Qt4.Layouts;
with Qt4.Objects;
with Qt4.Strings;
limited with Qt4.Widgets;
with Qt_Ada.Generic_Object_Pointers;

package Qt4.Ui_Loaders is

   type Q_Ui_Loader is limited interface
     and Qt4.Objects.Q_Object;

   type Q_Ui_Loader_Access is
     access all Q_Ui_Loader'Class;
   for Q_Ui_Loader_Access'Storage_Size use 0;

   type Q_Ui_Loader_Pointer is tagged;

   procedure Add_Plugin_Path
    (Self : not null access Q_Ui_Loader'Class;
     Path : Qt4.Strings.Q_String);

   procedure Clear_Plugin_Paths
    (Self : not null access Q_Ui_Loader'Class);

   not overriding
   function Create_Action
    (Self : not null access Q_Ui_Loader;
     Parent : access Qt4.Objects.Q_Object'Class;
     Name : Qt4.Strings.Q_String
       := Qt4.Strings.Create)
       return not null access Qt4.Actions.Q_Action'Class
         is abstract;

   not overriding
   function Create_Layout
    (Self : not null access Q_Ui_Loader;
     Class_Name : Qt4.Strings.Q_String;
     Parent : access Qt4.Objects.Q_Object'Class;
     Name : Qt4.Strings.Q_String
       := Qt4.Strings.Create)
       return not null access Qt4.Layouts.Q_Layout'Class
         is abstract;

   not overriding
   function Create_Widget
    (Self : not null access Q_Ui_Loader;
     Class_Name : Qt4.Strings.Q_String;
     Parent : access Qt4.Widgets.Q_Widget'Class;
     Name : Qt4.Strings.Q_String
       := Qt4.Strings.Create)
       return not null access Qt4.Widgets.Q_Widget'Class
         is abstract;

   function Load
    (Self : not null access Q_Ui_Loader'Class;
     Device : not null access Qt4.IO_Devices.Q_IO_Device'Class;
     Parent_Widget : access Qt4.Widgets.Q_Widget'Class)
       return access Qt4.Widgets.Q_Widget'Class;

   package Q_Ui_Loader_Pointers is
     new Qt_Ada.Generic_Object_Pointers (Q_Ui_Loader, Q_Ui_Loader_Access);

   type Q_Ui_Loader_Pointer is
     new Q_Ui_Loader_Pointers.Q_Pointer with null record;

end Qt4.Ui_Loaders;
