------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Actions;
with Qt4.Layouts;
with Qt4.Objects;
with Qt4.Strings;
with Qt4.Ui_Loaders;
with Qt4.Widgets;
with Qt_Ada.Internals.Objects.Object_Proxies;

package Qt_Ada.Internals.Objects.Ui_Loader_Proxies is

   pragma Elaborate_Body;

   type Q_Ui_Loader_Proxy is
     new Qt_Ada.Internals.Objects.Object_Proxies.Q_Object_Proxy
       and Qt4.Ui_Loaders.Q_Ui_Loader with null record;

   function Create_Action
    (Self : not null access Q_Ui_Loader_Proxy;
     Parent : access Qt4.Objects.Q_Object'Class;
     Name : Qt4.Strings.Q_String)
       return not null access Qt4.Actions.Q_Action'Class;

   function Create_Layout
    (Self : not null access Q_Ui_Loader_Proxy;
     Class_Name : Qt4.Strings.Q_String;
     Parent : access Qt4.Objects.Q_Object'Class;
     Name : Qt4.Strings.Q_String)
       return not null access Qt4.Layouts.Q_Layout'Class;

   function Create_Widget
    (Self : not null access Q_Ui_Loader_Proxy;
     Class_Name : Qt4.Strings.Q_String;
     Parent : access Qt4.Widgets.Q_Widget'Class;
     Name : Qt4.Strings.Q_String)
       return not null access Qt4.Widgets.Q_Widget'Class;

end Qt_Ada.Internals.Objects.Ui_Loader_Proxies;
