//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if other files  instantiate  generics from this //
// unit, or you link  this unit with other files  to produce an executable, //
// this  unit  does not  by itself cause  the resulting  executable  to  be //
// covered  by the  GNU  General  Public  License.  This exception does not //
// however invalidate  any other reasons why  the executable file  might be //
// covered by the  GNU Public License.                                      //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//

#include <QAction>
#include <QLayout>
#include <QWidget>
#include <QIODevice>
#include <QChildEvent>
#include <QTimerEvent>

#include "quiloaderdirector.h"
#include "qobjectdirector.h"

extern "C"
{
    const QMetaObject* __Qt4Ada_QUiLoader_staticMetaObject =
        &QUiLoader::staticMetaObject;
}

extern "C"
{

    QObject* __Qt4Ada_QUiLoader_createAction_0_virtual(QObject* cpp_object, QObject* parent, const QString* name)
    {
        return static_cast<QObject*>(dynamic_cast<QUiLoader*>(cpp_object)->createAction(parent, *name));
    }

    QObject* __Qt4Ada_QUiLoader_createLayout_0_virtual(QObject* cpp_object, const QString* className, QObject* parent, const QString* name)
    {
        return static_cast<QObject*>(dynamic_cast<QUiLoader*>(cpp_object)->createLayout(*className, parent, *name));
    }

    QObject* __Qt4Ada_QUiLoader_createWidget_0_virtual(QObject* cpp_object, const QString* className, QObject* parent, const QString* name)
    {
        return static_cast<QObject*>(dynamic_cast<QUiLoader*>(cpp_object)->createWidget(*className, dynamic_cast<QWidget*>(parent), *name));
    }

}

//  Functions for static call of C++ functions.

extern "C"
{

    void __Qt4Ada_QUiLoader_addPluginPath_0_wrapper(QObject* cpp_object, const QString* path)
    {
        dynamic_cast<QUiLoader*>(cpp_object)->QUiLoader::addPluginPath(*path);
    }

    void __Qt4Ada_QUiLoader_clearPluginPaths_0_wrapper(QObject* cpp_object)
    {
        dynamic_cast<QUiLoader*>(cpp_object)->QUiLoader::clearPluginPaths();
    }

    QObject* __Qt4Ada_QUiLoader_createAction_0_wrapper(QObject* cpp_object, QObject* parent, const QString* name)
    {
        return static_cast<QObject*>(dynamic_cast<QUiLoader*>(cpp_object)->QUiLoader::createAction(parent, *name));
    }

    QObject* __Qt4Ada_QUiLoader_createLayout_0_wrapper(QObject* cpp_object, const QString* className, QObject* parent, const QString* name)
    {
        return static_cast<QObject*>(dynamic_cast<QUiLoader*>(cpp_object)->QUiLoader::createLayout(*className, parent, *name));
    }

    QObject* __Qt4Ada_QUiLoader_createWidget_0_wrapper(QObject* cpp_object, const QString* className, QObject* parent, const QString* name)
    {
        return static_cast<QObject*>(dynamic_cast<QUiLoader*>(cpp_object)->QUiLoader::createWidget(*className, dynamic_cast<QWidget*>(parent), *name));
    }

    QObject* __Qt4Ada_QUiLoader_load_0_wrapper(QObject* cpp_object, QObject* device, QObject* parentWidget)
    {
        return static_cast<QObject*>(dynamic_cast<QUiLoader*>(cpp_object)->QUiLoader::load(dynamic_cast<QIODevice*>(device), dynamic_cast<QWidget*>(parentWidget)));
    }

    void __Qt4Ada_QUiLoader_childEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QUiLoaderDirector*>(cpp_object)->QObject::childEvent(dynamic_cast<QChildEvent*>(event));
    }

    void __Qt4Ada_QUiLoader_customEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QUiLoaderDirector*>(cpp_object)->QObject::customEvent(event);
    }

    void __Qt4Ada_QUiLoader_timerEvent_0_wrapper(QObject* cpp_object, QEvent* event)
    {
        dynamic_cast<QUiLoaderDirector*>(cpp_object)->QObject::timerEvent(dynamic_cast<QTimerEvent*>(event));
    }

    QObject* __Qt4Ada_QUiLoader_sender_0_wrapper(QObject* cpp_object)
    {
        return dynamic_cast<QUiLoaderDirector*>(cpp_object)->QObject::sender();
    }

    void* __Qt4Ada_QUiLoader_qt_metacast_wrapper(QObject* cpp_this, const char* name)
    {
        return dynamic_cast<QUiLoader*>(cpp_this)->QUiLoader::qt_metacast(name);
    }

    int __Qt4Ada_QUiLoader_qt_metacall_wrapper(QObject* cpp_this, QMetaObject::Call _c, int _id, void** _a)
    {
        return dynamic_cast<QUiLoader*>(cpp_this)->QUiLoader::qt_metacall(_c, _id, _a);
    }

}

QAction* QUiLoaderDirector::createAction(QObject* parent, const QString& name)
{
    return dynamic_cast<QAction*>(__Qt4Ada_QUiLoader_createAction_0_dispatch(this->ada_object, parent, &name));
}

QLayout* QUiLoaderDirector::createLayout(const QString& className, QObject* parent, const QString& name)
{
    return dynamic_cast<QLayout*>(__Qt4Ada_QUiLoader_createLayout_0_dispatch(this->ada_object, &className, parent, &name));
}

QWidget* QUiLoaderDirector::createWidget(const QString& className, QWidget* parent, const QString& name)
{
    return dynamic_cast<QWidget*>(__Qt4Ada_QUiLoader_createWidget_0_dispatch(this->ada_object, &className, parent, &name));
}

bool QUiLoaderDirector::event(QEvent* e)
{
    return __Qt4Ada_QObject_event_0_dispatch(this->ada_object, e);
}

bool QUiLoaderDirector::eventFilter(QObject* watched, QEvent* event)
{
    return __Qt4Ada_QObject_eventFilter_0_dispatch(this->ada_object, watched, event);
}

void QUiLoaderDirector::childEvent(QChildEvent* event)
{
    __Qt4Ada_QObject_childEvent_0_dispatch(this->ada_object, event);
}

void QUiLoaderDirector::customEvent(QEvent* event)
{
    __Qt4Ada_QObject_customEvent_0_dispatch(this->ada_object, event);
}

void QUiLoaderDirector::timerEvent(QTimerEvent* event)
{
    __Qt4Ada_QObject_timerEvent_0_dispatch(this->ada_object, event);
}

const QMetaObject* QUiLoaderDirector::metaObject() const
{
    return __Qt4Ada_QObject_metaObject_dispatch(this->ada_object);
}

void* QUiLoaderDirector::qt_metacast(const char *name)
{
    return __Qt4Ada_QObject_qt_metacast_dispatch(this->ada_object, name);
}

int QUiLoaderDirector::qt_metacall(QMetaObject::Call _c, int _id, void** _a)
{
    return __Qt4Ada_QObject_qt_metacall_dispatch(this->ada_object, _c, _id, _a);
}

extern "C"
{

    QObject* __Qt4Ada_new_QUiLoader(QObject* parent)
    {
        return dynamic_cast<QObject*>(new QUiLoader(parent));
    }

}
