//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QString>
#include "qdomcharacterdatawrapper.h"

extern "C"
{

    QDomNode* __QtAda_inititialize_QDomCharacterData(void* storage)
    {
        return new (storage) QDomCharacterData();
    }

    QDomNode* __QtAda_adjust_QDomCharacterData(void* storage, const QDomNode* from)
    {
        return new (storage) QDomCharacterData(*static_cast<const QDomCharacterData*>(from));
    }

    void __QtAda_finalize_QDomCharacterData(QDomNode *item)
    {
        static_cast<const QDomCharacterData*>(item)->~QDomCharacterData();
    }

    void __QtAda_QDomCharacterData_appendData_QStringCR(QDomNode* self, const QString* arg)
    {
        static_cast<QDomCharacterData*>(self)->appendData(*arg);
    }

    void __QtAda_QDomCharacterData_data_Q(QString* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomCharacterData*>(self)->data();
    }

    void __QtAda_QDomCharacterData_deleteData_ulong_ulong(QDomNode* self, ulong offset, ulong count)
    {
        static_cast<QDomCharacterData*>(self)->deleteData(offset, count);
    }

    void __QtAda_QDomCharacterData_insertData_ulong_QStringCR(QDomNode* self, ulong offset, const QString* arg)
    {
        static_cast<QDomCharacterData*>(self)->insertData(offset, *arg);
    }

    uint __QtAda_QDomCharacterData_length_Q(const QDomNode* self)
    {
        return static_cast<const QDomCharacterData*>(self)->length();
    }

    unsigned __QtAda_QDomCharacterData_nodeType_Q(const QDomNode* self)
    {
        return (unsigned)static_cast<const QDomCharacterData*>(self)->nodeType();
    }

    void __QtAda_QDomCharacterData_replaceData_ulong_ulong_QStringCR(QDomNode* self, ulong offset, ulong count, const QString* arg)
    {
        static_cast<QDomCharacterData*>(self)->replaceData(offset, count, *arg);
    }

    void __QtAda_QDomCharacterData_setData_QStringCR(QDomNode* self, const QString* arg)
    {
        static_cast<QDomCharacterData*>(self)->setData(*arg);
    }

};

