//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QDomNamedNodeMap>
#include <QString>
#include "qdomdocumenttypewrapper.h"

extern "C"
{

    QDomNode* __QtAda_inititialize_QDomDocumentType(void* storage)
    {
        return new (storage) QDomDocumentType();
    }

    QDomNode* __QtAda_adjust_QDomDocumentType(void* storage, const QDomNode* from)
    {
        return new (storage) QDomDocumentType(*static_cast<const QDomDocumentType*>(from));
    }

    void __QtAda_finalize_QDomDocumentType(QDomNode *item)
    {
        static_cast<const QDomDocumentType*>(item)->~QDomDocumentType();
    }

    void __QtAda_QDomDocumentType_entities_Q(QDomNamedNodeMap* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomDocumentType*>(self)->entities();
    }

    void __QtAda_QDomDocumentType_internalSubset_Q(QString* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomDocumentType*>(self)->internalSubset();
    }

    void __QtAda_QDomDocumentType_name_Q(QString* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomDocumentType*>(self)->name();
    }

    unsigned __QtAda_QDomDocumentType_nodeType_Q(const QDomNode* self)
    {
        return (unsigned)static_cast<const QDomDocumentType*>(self)->nodeType();
    }

    void __QtAda_QDomDocumentType_notations_Q(QDomNamedNodeMap* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomDocumentType*>(self)->notations();
    }

    void __QtAda_QDomDocumentType_publicId_Q(QString* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomDocumentType*>(self)->publicId();
    }

    void __QtAda_QDomDocumentType_systemId_Q(QString* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomDocumentType*>(self)->systemId();
    }

};

