//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QDomNamedNodeMap>
#include <QDomNodeList>
#include <QString>
#include "qdomelementwrapper.h"

extern "C"
{

    QDomNode* __QtAda_inititialize_QDomElement(void* storage)
    {
        return new (storage) QDomElement();
    }

    QDomNode* __QtAda_adjust_QDomElement(void* storage, const QDomNode* from)
    {
        return new (storage) QDomElement(*static_cast<const QDomElement*>(from));
    }

    void __QtAda_finalize_QDomElement(QDomNode *item)
    {
        static_cast<const QDomElement*>(item)->~QDomElement();
    }

    void __QtAda_QDomElement_attribute_QStringCR_QStringCR_Q(QString* returns, const QDomNode* self, const QString* name, const QString* defValue)
    {
        *returns = static_cast<const QDomElement*>(self)->attribute(*name, *defValue);
    }

    void __QtAda_QDomElement_attributeNS_QStringCR_QStringCR_QStringCR_Q(QString* returns, const QDomNode* self, const QString* nsURI, const QString* localName, const QString* defValue)
    {
        *returns = static_cast<const QDomElement*>(self)->attributeNS(*nsURI, *localName, *defValue);
    }

    void __QtAda_QDomElement_attributes_Q(QDomNamedNodeMap* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomElement*>(self)->attributes();
    }

    void __QtAda_QDomElement_elementsByTagName_QStringCR_Q(QDomNodeList* returns, const QDomNode* self, const QString* tagname)
    {
        *returns = static_cast<const QDomElement*>(self)->elementsByTagName(*tagname);
    }

    void __QtAda_QDomElement_elementsByTagNameNS_QStringCR_QStringCR_Q(QDomNodeList* returns, const QDomNode* self, const QString* nsURI, const QString* localName)
    {
        *returns = static_cast<const QDomElement*>(self)->elementsByTagNameNS(*nsURI, *localName);
    }

    unsigned __QtAda_QDomElement_hasAttribute_QStringCR_Q(const QDomNode* self, const QString* name)
    {
        return (unsigned)static_cast<const QDomElement*>(self)->hasAttribute(*name);
    }

    unsigned __QtAda_QDomElement_hasAttributeNS_QStringCR_QStringCR_Q(const QDomNode* self, const QString* nsURI, const QString* localName)
    {
        return (unsigned)static_cast<const QDomElement*>(self)->hasAttributeNS(*nsURI, *localName);
    }

    unsigned __QtAda_QDomElement_nodeType_Q(const QDomNode* self)
    {
        return (unsigned)static_cast<const QDomElement*>(self)->nodeType();
    }

    void __QtAda_QDomElement_removeAttribute_QStringCR(QDomNode* self, const QString* name)
    {
        static_cast<QDomElement*>(self)->removeAttribute(*name);
    }

    void __QtAda_QDomElement_removeAttributeNS_QStringCR_QStringCR(QDomNode* self, const QString* nsURI, const QString* localName)
    {
        static_cast<QDomElement*>(self)->removeAttributeNS(*nsURI, *localName);
    }

    void __QtAda_QDomElement_setAttribute_QStringCR_QStringCR(QDomNode* self, const QString* name, const QString* value)
    {
        static_cast<QDomElement*>(self)->setAttribute(*name, *value);
    }

    void __QtAda_QDomElement_setAttributeNS_QStringCR_QStringCR_QStringCR(QDomNode* self, const QString* nsURI, const QString* qName, const QString* value)
    {
        static_cast<QDomElement*>(self)->setAttributeNS(*nsURI, *qName, *value);
    }

    void __QtAda_QDomElement_setAttributeNode_QDomAttrCR(QDomNode* self, const QDomNode* newAttr)
    {
        static_cast<QDomElement*>(self)->setAttributeNode(*static_cast<const QDomAttr*>(newAttr));
    }

    void __QtAda_QDomElement_setAttributeNodeNS_QDomAttrCR(QDomNode* self, const QDomNode* newAttr)
    {
        static_cast<QDomElement*>(self)->setAttributeNodeNS(*static_cast<const QDomAttr*>(newAttr));
    }

    void __QtAda_QDomElement_setTagName_QStringCR(QDomNode* self, const QString* name)
    {
        static_cast<QDomElement*>(self)->setTagName(*name);
    }

    void __QtAda_QDomElement_tagName_Q(QString* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomElement*>(self)->tagName();
    }

    void __QtAda_QDomElement_text_Q(QString* returns, const QDomNode* self)
    {
        *returns = static_cast<const QDomElement*>(self)->text();
    }

};

