//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008-2011 Vadim Godunko <vgodunko@gmail.com>                 //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <new>
#include <QDomDocument>
#include <QDomDocumentType>
#include <QString>
#include "qdomimplementationwrapper.h"

extern "C"
{

    QDomImplementation* __QtAda_inititialize_QDomImplementation(void* storage)
    {
        return new (storage) QDomImplementation();
    }

    QDomImplementation* __QtAda_adjust_QDomImplementation(void* storage, const QDomImplementation* from)
    {
        return new (storage) QDomImplementation(*from);
    }

    void __QtAda_finalize_QDomImplementation(QDomImplementation *item)
    {
        item->~QDomImplementation();
    }

    void __QtAda_QDomImplementation_createDocument_QStringCR_QStringCR_QDomDocumentTypeCR(QDomNode* returns, QDomImplementation* self, const QString* nsURI, const QString* qName, const QDomNode* doctype)
    {
        *static_cast<QDomDocument*>(returns) = self->createDocument(*nsURI, *qName, *static_cast<const QDomDocumentType*>(doctype));
    }

    void __QtAda_QDomImplementation_createDocumentType_QStringCR_QStringCR_QStringCR(QDomNode* returns, QDomImplementation* self, const QString* qName, const QString* publicId, const QString* systemId)
    {
        *static_cast<QDomDocumentType*>(returns) = self->createDocumentType(*qName, *publicId, *systemId);
    }

    unsigned __QtAda_QDomImplementation_hasFeature_QStringCR_QStringCR_Q(const QDomImplementation* self, const QString* feature, const QString* version)
    {
        return (unsigned)self->hasFeature(*feature, *version);
    }

    unsigned __QtAda_QDomImplementation_isNull(QDomImplementation* self)
    {
        return (unsigned)self->isNull();
    }

    unsigned __QtAda_QDomImplementation_eq_QDomImplementationCR_Q(const QDomImplementation* self, const QDomImplementation* x)
    {
        return (unsigned)self->operator==(*x);
    }

    unsigned __QtAda_QDomImplementation_invalidDataPolicy_S()
    {
        return (unsigned)QDomImplementation::invalidDataPolicy();
    }

    void __QtAda_QDomImplementation_setInvalidDataPolicy_InvalidDataPolicy_S(unsigned policy)
    {
        QDomImplementation::setInvalidDataPolicy((QDomImplementation::InvalidDataPolicy)policy);
    }

};

