//--------------------------------------------------------------------------//
//                                                                          //
//                An Ada2005 binding to the Qt C++ framework                //
//                                                                          //
//--------------------------------------------------------------------------//
//                                                                          //
// Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      //
//                                                                          //
// QtAda is free software;  you can  redistribute it and/or modify it under //
// terms of the  GNU General Public License as published  by the Free Soft- //
// ware  Foundation;  either version 2,  or (at your option) any later ver- //
// sion. QtAda is distributed in the hope that it will be useful, but WITH- //
// OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY //
// or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License //
// for  more details.  You should have  received  a copy of the GNU General //
// Public License distributed with QtAda;  see file COPYING.  If not, write //
// to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, //
// Boston, MA 02110-1301, USA.                                              //
//                                                                          //
// As a special exception,  if  other files  instantiate  templates  or use //
// macros or inline functions from this file,  or you compile this file and //
// link it with other files to produce an executable, this file does not by //
// itself cause  the resulting executable to be covered by  the GNU General //
// Public License.  This exception  does not however  invalidate any  other //
// reasons  why  the executable file  might be covered  by  the GNU General //
// Public License.                                                          //
//                                                                          //
//--------------------------------------------------------------------------//
//    This file has been generated automatically. Please don't edit it.     //
//--------------------------------------------------------------------------//
#include <QDomNode>

extern "C"
{
    extern QDomNode* __QtAda_inititialize_QDomNode(void*);
    extern QDomNode* __QtAda_adjust_QDomNode(void*, const QDomNode*);
    extern void __QtAda_finalize_QDomNode(QDomNode*);

    extern void __QtAda_QDomNode_appendChild_QDomNodeCR(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_attributes_Q(QDomNamedNodeMap*, const QDomNode*);
    extern void __QtAda_QDomNode_childNodes_Q(QDomNodeList*, const QDomNode*);
    extern void __QtAda_QDomNode_clear(QDomNode*);
    extern void __QtAda_QDomNode_cloneNode_bool_Q(QDomNode*, const QDomNode*, unsigned);
    extern int __QtAda_QDomNode_columnNumber_Q(const QDomNode*);
    extern void __QtAda_QDomNode_firstChild_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_firstChildElement_QStringCR_Q(QDomNode*, const QDomNode*, const QString*);
    extern unsigned __QtAda_QDomNode_hasAttributes_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_hasChildNodes_Q(const QDomNode*);
    extern void __QtAda_QDomNode_insertAfter_QDomNodeCR_QDomNodeCR(QDomNode*, const QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_insertBefore_QDomNodeCR_QDomNodeCR(QDomNode*, const QDomNode*, const QDomNode*);
    extern unsigned __QtAda_QDomNode_isAttr_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isCDATASection_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isCharacterData_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isComment_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isDocument_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isDocumentFragment_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isDocumentType_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isElement_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isEntity_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isEntityReference_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isNotation_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isNull_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isProcessingInstruction_Q(const QDomNode*);
    extern unsigned __QtAda_QDomNode_isSupported_QStringCR_QStringCR_Q(const QDomNode*, const QString*, const QString*);
    extern unsigned __QtAda_QDomNode_isText_Q(const QDomNode*);
    extern void __QtAda_QDomNode_lastChild_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_lastChildElement_QStringCR_Q(QDomNode*, const QDomNode*, const QString*);
    extern int __QtAda_QDomNode_lineNumber_Q(const QDomNode*);
    extern void __QtAda_QDomNode_localName_Q(QString*, const QDomNode*);
    extern void __QtAda_QDomNode_namedItem_QStringCR_Q(QDomNode*, const QDomNode*, const QString*);
    extern void __QtAda_QDomNode_namespaceURI_Q(QString*, const QDomNode*);
    extern void __QtAda_QDomNode_nextSibling_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_nextSiblingElement_QStringCR_Q(QDomNode*, const QDomNode*, const QString*);
    extern void __QtAda_QDomNode_nodeName_Q(QString*, const QDomNode*);
    extern unsigned __QtAda_QDomNode_nodeType_Q(const QDomNode*);
    extern void __QtAda_QDomNode_nodeValue_Q(QString*, const QDomNode*);
    extern void __QtAda_QDomNode_normalize(QDomNode*);
    extern void __QtAda_QDomNode_ownerDocument_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_parentNode_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_prefix_Q(QString*, const QDomNode*);
    extern void __QtAda_QDomNode_previousSibling_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_previousSiblingElement_QStringCR_Q(QDomNode*, const QDomNode*, const QString*);
    extern void __QtAda_QDomNode_removeChild_QDomNodeCR(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_replaceChild_QDomNodeCR_QDomNodeCR(QDomNode*, const QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_setNodeValue_QStringCR(QDomNode*, const QString*);
    extern void __QtAda_QDomNode_setPrefix_QStringCR(QDomNode*, const QString*);
    extern void __QtAda_QDomNode_toAttr_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toCDATASection_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toCharacterData_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toComment_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toDocument_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toDocumentFragment_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toDocumentType_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toElement_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toEntity_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toEntityReference_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toNotation_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toProcessingInstruction_Q(QDomNode*, const QDomNode*);
    extern void __QtAda_QDomNode_toText_Q(QDomNode*, const QDomNode*);
    extern unsigned __QtAda_QDomNode_eq_QDomNodeCR_Q(const QDomNode*, const QDomNode*);

};

